/*******************************************************************************
* Copyright (C) 2001-2025 Altera Corporation
*
* This code and the related documents are Altera copyrighted materials and
* your use of them is governed by the express license under which they were
* provided to you ("License"). Unless the License provides otherwise, you may
* not use, modify, copy, publish, distribute, disclose, or transmit this
* code or the related documents without Altera's prior written permission.
* 
* This code and the related documents are provided as is, with no express
* or implied warranties other than those that are expressly stated in the
* License.
* 
*******************************************************************************/


// bts_xcvr is the module specified by the QSF setting TOP_LEVEL_ENTITY
// QUARTUS_TLG generates a module called bts_xcvr__tiles specified by the QSF setting SECONDARY_TOP_LEVEL_ENTITY
// Both bts_xcvr and bts_xcvr__tiles are instantiated in the user simulation
// testbench but not necessarily at the same level of hierarchy
// The testbench filelist can set a +define+TOP_LEVEL_ENTITY_INSTANCE_PATH
// to indicate the fully qualified instance name of the bts_xcvr relative to the
// hierarchy node common to both bts_xcvr and bts_xcvr__tiles.
//
// In the simplest case, the following is true
// * Both bts_xcvr and bts_xcvr__tiles are instantiated in the same testbench module
// * The instance name of bts_xcvr is bts_xcvr
// For the above the defaults are sufficient and so the +define+TOP_LEVEL_ENTITY_INSTANCE_PATH
// is not required.
//
// A more complicated situation is as follows:
//
// top_testbench
// |
// + -- foo
//      |
//      + -- xxx
//      |    |
//      |    |
//      |    + -- x_bts_xcvr (Instance of bts_xcvr)
//      |
//      + -- bar
//           |
//           + -- bts_xcvr__tiles
//
// For the above we need
// +define+TOP_LEVEL_ENTITY_INSTANCE_PATH+foo.xxx.x_bts_xcvr
`ifndef TOP_LEVEL_ENTITY_INSTANCE_PATH
`define QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH bts_xcvr
`else
`define QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH `TOP_LEVEL_ENTITY_INSTANCE_PATH
`endif
// altera message_off 16788
module bts_xcvr__tiles();
f_tile_soft_reset_ctlr_ip_v1 #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.init_fname("bts_xcvr__tiles__z1577a_x0_y166_n0.mif")
) z1577a_x0_y166_n0__reset_controller();
wire z1577a_x0_y166_n0__avmm2_0__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector;
wire z1577a_x0_y166_n0__reset_controller__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(0),
	.num_ip_on_intfc_00(2)
) z1577a_x0_y166_n0__avmm2_0(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_0__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[0]}));
wire z1577a_x0_y166_n0__avmm2_1__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(1),
	.num_ip_on_intfc_00(2)
) z1577a_x0_y166_n0__avmm2_1(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_1__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[1]}));
wire z1577a_x0_y166_n0__avmm2_10__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_10__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_10__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(10),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_10(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_10__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[10]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_0,
		qtlg_wire_1,
		qtlg_wire_2,
		qtlg_wire_3,
		qtlg_wire_4,
		qtlg_wire_5,
		qtlg_wire_6,
		qtlg_wire_7}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_8}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_9,
		qtlg_wire_10,
		qtlg_wire_11,
		qtlg_wire_12,
		qtlg_wire_13}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_14}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_15}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_16}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_17}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_18,
		qtlg_wire_19,
		qtlg_wire_20,
		qtlg_wire_21,
		qtlg_wire_22,
		qtlg_wire_23,
		qtlg_wire_24,
		qtlg_wire_25}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_26}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_27}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_11__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_11__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_11__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(11),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_11(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_11__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[11]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_28,
		qtlg_wire_29,
		qtlg_wire_30,
		qtlg_wire_31,
		qtlg_wire_32,
		qtlg_wire_33,
		qtlg_wire_34,
		qtlg_wire_35}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_36}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_37,
		qtlg_wire_38,
		qtlg_wire_39,
		qtlg_wire_40,
		qtlg_wire_41}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_42}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_43}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_44}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_45}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_46,
		qtlg_wire_47,
		qtlg_wire_48,
		qtlg_wire_49,
		qtlg_wire_50,
		qtlg_wire_51,
		qtlg_wire_52,
		qtlg_wire_53}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_54}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_55}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_12__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_12__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_12__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(12),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_12(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_12__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[12]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_56,
		qtlg_wire_57,
		qtlg_wire_58,
		qtlg_wire_59,
		qtlg_wire_60,
		qtlg_wire_61,
		qtlg_wire_62,
		qtlg_wire_63}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_64}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_65,
		qtlg_wire_66,
		qtlg_wire_67,
		qtlg_wire_68,
		qtlg_wire_69}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_70}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_71}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_72}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_73}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_74,
		qtlg_wire_75,
		qtlg_wire_76,
		qtlg_wire_77,
		qtlg_wire_78,
		qtlg_wire_79,
		qtlg_wire_80,
		qtlg_wire_81}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_82}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_83}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_13__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_13__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_13__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(13),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_13(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_13__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[13]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_84,
		qtlg_wire_85,
		qtlg_wire_86,
		qtlg_wire_87,
		qtlg_wire_88,
		qtlg_wire_89,
		qtlg_wire_90,
		qtlg_wire_91}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_92}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_93,
		qtlg_wire_94,
		qtlg_wire_95,
		qtlg_wire_96,
		qtlg_wire_97}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_98}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_99}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_100}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_101}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_102,
		qtlg_wire_103,
		qtlg_wire_104,
		qtlg_wire_105,
		qtlg_wire_106,
		qtlg_wire_107,
		qtlg_wire_108,
		qtlg_wire_109}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_110}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_111}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_14__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_14__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_14__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(14),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_14(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_14__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[14]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_112,
		qtlg_wire_113,
		qtlg_wire_114,
		qtlg_wire_115,
		qtlg_wire_116,
		qtlg_wire_117,
		qtlg_wire_118,
		qtlg_wire_119}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_120}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_121,
		qtlg_wire_122,
		qtlg_wire_123,
		qtlg_wire_124,
		qtlg_wire_125}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_126}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_127}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_128}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_129}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_130,
		qtlg_wire_131,
		qtlg_wire_132,
		qtlg_wire_133,
		qtlg_wire_134,
		qtlg_wire_135,
		qtlg_wire_136,
		qtlg_wire_137}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_138}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_139}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_15__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_15__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_15__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(15),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_15(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_15__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[15]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_140,
		qtlg_wire_141,
		qtlg_wire_142,
		qtlg_wire_143,
		qtlg_wire_144,
		qtlg_wire_145,
		qtlg_wire_146,
		qtlg_wire_147}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_148}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_149,
		qtlg_wire_150,
		qtlg_wire_151,
		qtlg_wire_152,
		qtlg_wire_153}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_154}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_155}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_156}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_157}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_158,
		qtlg_wire_159,
		qtlg_wire_160,
		qtlg_wire_161,
		qtlg_wire_162,
		qtlg_wire_163,
		qtlg_wire_164,
		qtlg_wire_165}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_166}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_167}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_16__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_16__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_16__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(16),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_16(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_16__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[16]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_168,
		qtlg_wire_169,
		qtlg_wire_170,
		qtlg_wire_171,
		qtlg_wire_172,
		qtlg_wire_173,
		qtlg_wire_174,
		qtlg_wire_175}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_176}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_177,
		qtlg_wire_178,
		qtlg_wire_179,
		qtlg_wire_180,
		qtlg_wire_181}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_182}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_183}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_184}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_185}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_186,
		qtlg_wire_187,
		qtlg_wire_188,
		qtlg_wire_189,
		qtlg_wire_190,
		qtlg_wire_191,
		qtlg_wire_192,
		qtlg_wire_193}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_194}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_195}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_17__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_17__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_17__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(17),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_17(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_17__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[17]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_196,
		qtlg_wire_197,
		qtlg_wire_198,
		qtlg_wire_199,
		qtlg_wire_200,
		qtlg_wire_201,
		qtlg_wire_202,
		qtlg_wire_203}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_204}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_205,
		qtlg_wire_206,
		qtlg_wire_207,
		qtlg_wire_208,
		qtlg_wire_209}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_210}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_211}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_212}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_213}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_214,
		qtlg_wire_215,
		qtlg_wire_216,
		qtlg_wire_217,
		qtlg_wire_218,
		qtlg_wire_219,
		qtlg_wire_220,
		qtlg_wire_221}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_222}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_223}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_18__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_18__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_18__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(18),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_18(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_18__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[18]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_224,
		qtlg_wire_225,
		qtlg_wire_226,
		qtlg_wire_227,
		qtlg_wire_228,
		qtlg_wire_229,
		qtlg_wire_230,
		qtlg_wire_231}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_232}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_233,
		qtlg_wire_234,
		qtlg_wire_235,
		qtlg_wire_236,
		qtlg_wire_237}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_238}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_239}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_240}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_241}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_242,
		qtlg_wire_243,
		qtlg_wire_244,
		qtlg_wire_245,
		qtlg_wire_246,
		qtlg_wire_247,
		qtlg_wire_248,
		qtlg_wire_249}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_250}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_251}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_19__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_19__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_19__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(19),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_19(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_19__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[19]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_252,
		qtlg_wire_253,
		qtlg_wire_254,
		qtlg_wire_255,
		qtlg_wire_256,
		qtlg_wire_257,
		qtlg_wire_258,
		qtlg_wire_259}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_260}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_261,
		qtlg_wire_262,
		qtlg_wire_263,
		qtlg_wire_264,
		qtlg_wire_265}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_266}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_267}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_268}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_269}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_270,
		qtlg_wire_271,
		qtlg_wire_272,
		qtlg_wire_273,
		qtlg_wire_274,
		qtlg_wire_275,
		qtlg_wire_276,
		qtlg_wire_277}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_278}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_279}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_2__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(2),
	.num_ip_on_intfc_00(2)
) z1577a_x0_y166_n0__avmm2_2(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_2__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[2]}));
wire z1577a_x0_y166_n0__avmm2_20__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(20),
	.num_ip_on_intfc_00(1)
) z1577a_x0_y166_n0__avmm2_20(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_20__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[20]));
wire z1577a_x0_y166_n0__avmm2_21__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(21),
	.num_ip_on_intfc_00(1)
) z1577a_x0_y166_n0__avmm2_21(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_21__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[21]));
wire z1577a_x0_y166_n0__avmm2_22__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(22),
	.num_ip_on_intfc_00(1)
) z1577a_x0_y166_n0__avmm2_22(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_22__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[22]));
wire z1577a_x0_y166_n0__avmm2_23__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(23),
	.num_ip_on_intfc_00(1)
) z1577a_x0_y166_n0__avmm2_23(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_23__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pll_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[23]));
wire z1577a_x0_y166_n0__avmm2_3__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(3),
	.num_ip_on_intfc_00(2)
) z1577a_x0_y166_n0__avmm2_3(
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_3__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[3]}));
wire z1577a_x0_y166_n0__avmm2_4__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_4__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_4__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(4),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_4(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_4__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[4]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_280,
		qtlg_wire_281,
		qtlg_wire_282,
		qtlg_wire_283,
		qtlg_wire_284,
		qtlg_wire_285,
		qtlg_wire_286,
		qtlg_wire_287}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_288}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_289,
		qtlg_wire_290,
		qtlg_wire_291,
		qtlg_wire_292,
		qtlg_wire_293}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_294}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_295}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_296}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_297}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_298,
		qtlg_wire_299,
		qtlg_wire_300,
		qtlg_wire_301,
		qtlg_wire_302,
		qtlg_wire_303,
		qtlg_wire_304,
		qtlg_wire_305}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_306}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_307}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_5__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_5__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_5__pld_pll_cal_done_real;
wire bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(5),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_5(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_5__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[5]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_308,
		qtlg_wire_309,
		qtlg_wire_310,
		qtlg_wire_311,
		qtlg_wire_312,
		qtlg_wire_313,
		qtlg_wire_314,
		qtlg_wire_315}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_316}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_317,
		qtlg_wire_318,
		qtlg_wire_319,
		qtlg_wire_320,
		qtlg_wire_321}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_322}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_323}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_324}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_325}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_326,
		qtlg_wire_327,
		qtlg_wire_328,
		qtlg_wire_329,
		qtlg_wire_330,
		qtlg_wire_331,
		qtlg_wire_332,
		qtlg_wire_333}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_334}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_335}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_6__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_6__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_6__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(6),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_6(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_6__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[6]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_336,
		qtlg_wire_337,
		qtlg_wire_338,
		qtlg_wire_339,
		qtlg_wire_340,
		qtlg_wire_341,
		qtlg_wire_342,
		qtlg_wire_343}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_344}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_345,
		qtlg_wire_346,
		qtlg_wire_347,
		qtlg_wire_348,
		qtlg_wire_349}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_350}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_351}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_352}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_353}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_354,
		qtlg_wire_355,
		qtlg_wire_356,
		qtlg_wire_357,
		qtlg_wire_358,
		qtlg_wire_359,
		qtlg_wire_360,
		qtlg_wire_361}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_362}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_363}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_7__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_7__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_7__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(7),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_7(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_7__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[7]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_364,
		qtlg_wire_365,
		qtlg_wire_366,
		qtlg_wire_367,
		qtlg_wire_368,
		qtlg_wire_369,
		qtlg_wire_370,
		qtlg_wire_371}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_372}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_373,
		qtlg_wire_374,
		qtlg_wire_375,
		qtlg_wire_376,
		qtlg_wire_377}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_378}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_379}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_380}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_381}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_382,
		qtlg_wire_383,
		qtlg_wire_384,
		qtlg_wire_385,
		qtlg_wire_386,
		qtlg_wire_387,
		qtlg_wire_388,
		qtlg_wire_389}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_390}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_391}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_8__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_8__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_8__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(8),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_8(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_8__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[8]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_392,
		qtlg_wire_393,
		qtlg_wire_394,
		qtlg_wire_395,
		qtlg_wire_396,
		qtlg_wire_397,
		qtlg_wire_398,
		qtlg_wire_399}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_400}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_401,
		qtlg_wire_402,
		qtlg_wire_403,
		qtlg_wire_404,
		qtlg_wire_405}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_406}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_407}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_408}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_409}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_410,
		qtlg_wire_411,
		qtlg_wire_412,
		qtlg_wire_413,
		qtlg_wire_414,
		qtlg_wire_415,
		qtlg_wire_416,
		qtlg_wire_417}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_418}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_419}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire z1577a_x0_y166_n0__avmm2_9__hip_avmm_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real;
wire z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdatavalid_real;
wire [20:0] z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real;
wire [4:0] z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_9__hip_avmm_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real;
wire z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedone_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_busy_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_clk_rowclk_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_cmdfifo_wr_full_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_cmdfifo_wr_pfull_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_read_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdatavalid_real;
wire [8:0] z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_request_real;
wire [5:0] z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_out_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_avmm2_write_real;
wire [7:0] z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real;
wire z1577a_x0_y166_n0__avmm2_9__pld_pll_cal_done_real;
intfc_m_hdpldadapt_avmm2_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(9),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2)
) z1577a_x0_y166_n0__avmm2_9(
	.hip_avmm_read_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_read_real),
	.hip_avmm_readdata_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real),
	.hip_avmm_readdatavalid_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdatavalid_real),
	.hip_avmm_reg_addr_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real),
	.hip_avmm_reserved_out_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real),
	.hip_avmm_write_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_write_real),
	.hip_avmm_writedata_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real),
	.hip_avmm_writedone_real(z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedone_real),
	.pld_avmm2_busy_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_busy_real),
	.pld_avmm2_clk_rowclk_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_clk_rowclk_real),
	.pld_avmm2_cmdfifo_wr_full_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_cmdfifo_wr_full_real),
	.pld_avmm2_cmdfifo_wr_pfull_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_cmdfifo_wr_pfull_real),
	.pld_avmm2_read_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_read_real),
	.pld_avmm2_readdata_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real),
	.pld_avmm2_readdatavalid_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdatavalid_real),
	.pld_avmm2_reg_addr_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real),
	.pld_avmm2_request_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_request_real),
	.pld_avmm2_reserved_in_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real),
	.pld_avmm2_reserved_out_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_out_real),
	.pld_avmm2_write_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_write_real),
	.pld_avmm2_writedata_real(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real),
	.pld_pll_cal_done_real(z1577a_x0_y166_n0__avmm2_9__pld_pll_cal_done_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_00_pld_pll_cal_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_txstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_avmm2__pld_pll_cal_done_real[9]}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_hip_avmm_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_read[0],
		1'bz}),
	.s_intfc_01_hip_avmm_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdata[0],
		qtlg_wire_420,
		qtlg_wire_421,
		qtlg_wire_422,
		qtlg_wire_423,
		qtlg_wire_424,
		qtlg_wire_425,
		qtlg_wire_426,
		qtlg_wire_427}),
	.s_intfc_01_hip_avmm_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_readdatavalid[0],
		qtlg_wire_428}),
	.s_intfc_01_hip_avmm_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_reserved_out[0],
		qtlg_wire_429,
		qtlg_wire_430,
		qtlg_wire_431,
		qtlg_wire_432,
		qtlg_wire_433}),
	.s_intfc_01_hip_avmm_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_write[0],
		1'bz}),
	.s_intfc_01_hip_avmm_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_hip_avmm_writedone_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_avmm_writedone[0],
		qtlg_wire_434}),
	.s_intfc_01_pld_avmm2_busy_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_busy[0],
		qtlg_wire_435}),
	.s_intfc_01_pld_avmm2_clk_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_clk_rowclk[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_full[0],
		qtlg_wire_436}),
	.s_intfc_01_pld_avmm2_cmdfifo_wr_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_cmdfifo_wr_pfull[0],
		qtlg_wire_437}),
	.s_intfc_01_pld_avmm2_read_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_read[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_readdata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdata[0],
		qtlg_wire_438,
		qtlg_wire_439,
		qtlg_wire_440,
		qtlg_wire_441,
		qtlg_wire_442,
		qtlg_wire_443,
		qtlg_wire_444,
		qtlg_wire_445}),
	.s_intfc_01_pld_avmm2_readdatavalid_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_readdatavalid[0],
		qtlg_wire_446}),
	.s_intfc_01_pld_avmm2_reg_addr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reg_addr[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_request_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_request[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_avmm2_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_reserved_out[0],
		qtlg_wire_447}),
	.s_intfc_01_pld_avmm2_write_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_write[0],
		1'bz}),
	.s_intfc_01_pld_avmm2_writedata_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_avmm2_writedata[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}));
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real;
wire [23:0] z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(0),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[0]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[0]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[0]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_448,
		qtlg_wire_449,
		qtlg_wire_450,
		qtlg_wire_451,
		qtlg_wire_452,
		qtlg_wire_453,
		qtlg_wire_454,
		qtlg_wire_455,
		qtlg_wire_456,
		qtlg_wire_457,
		qtlg_wire_458,
		qtlg_wire_459,
		qtlg_wire_460,
		qtlg_wire_461,
		qtlg_wire_462,
		qtlg_wire_463,
		qtlg_wire_464,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][2],
		qtlg_wire_465,
		qtlg_wire_466}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_467,
		qtlg_wire_468,
		qtlg_wire_469,
		qtlg_wire_470,
		qtlg_wire_471,
		qtlg_wire_472,
		qtlg_wire_473,
		qtlg_wire_474,
		qtlg_wire_475,
		qtlg_wire_476,
		qtlg_wire_477,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][3],
		qtlg_wire_478,
		qtlg_wire_479,
		qtlg_wire_480}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_481,
		qtlg_wire_482,
		qtlg_wire_483,
		qtlg_wire_484,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][15],
		qtlg_wire_485,
		qtlg_wire_486,
		qtlg_wire_487,
		qtlg_wire_488,
		qtlg_wire_489,
		qtlg_wire_490,
		qtlg_wire_491,
		qtlg_wire_492,
		qtlg_wire_493,
		qtlg_wire_494,
		qtlg_wire_495,
		qtlg_wire_496,
		qtlg_wire_497,
		qtlg_wire_498,
		qtlg_wire_499}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_500,
		qtlg_wire_501,
		qtlg_wire_502,
		qtlg_wire_503,
		qtlg_wire_504,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][9],
		qtlg_wire_505,
		qtlg_wire_506,
		qtlg_wire_507,
		qtlg_wire_508,
		qtlg_wire_509,
		qtlg_wire_510,
		qtlg_wire_511,
		qtlg_wire_512,
		qtlg_wire_513}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[0]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][16],
		qtlg_wire_514,
		qtlg_wire_515,
		qtlg_wire_516,
		qtlg_wire_517,
		qtlg_wire_518,
		qtlg_wire_519,
		qtlg_wire_520,
		qtlg_wire_521,
		qtlg_wire_522,
		qtlg_wire_523,
		qtlg_wire_524,
		qtlg_wire_525,
		qtlg_wire_526,
		qtlg_wire_527,
		qtlg_wire_528,
		qtlg_wire_529}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[0][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[0]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_530}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[0]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_531}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_532,
		qtlg_wire_533,
		qtlg_wire_534,
		qtlg_wire_535,
		qtlg_wire_536,
		qtlg_wire_537,
		qtlg_wire_538,
		qtlg_wire_539,
		qtlg_wire_540,
		qtlg_wire_541,
		qtlg_wire_542,
		qtlg_wire_543,
		qtlg_wire_544,
		qtlg_wire_545,
		qtlg_wire_546,
		qtlg_wire_547,
		qtlg_wire_548,
		qtlg_wire_549,
		qtlg_wire_550,
		qtlg_wire_551,
		qtlg_wire_552,
		qtlg_wire_553,
		qtlg_wire_554,
		qtlg_wire_555,
		qtlg_wire_556,
		qtlg_wire_557,
		qtlg_wire_558,
		qtlg_wire_559,
		qtlg_wire_560,
		qtlg_wire_561,
		qtlg_wire_562,
		qtlg_wire_563,
		qtlg_wire_564,
		qtlg_wire_565,
		qtlg_wire_566,
		qtlg_wire_567,
		qtlg_wire_568,
		qtlg_wire_569,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[0][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[0]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[0][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[0][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[0][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[0][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[0]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[0]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[0]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[0]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[0]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[0][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[0]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[0]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[1]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[1]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[1]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_570,
		qtlg_wire_571,
		qtlg_wire_572,
		qtlg_wire_573,
		qtlg_wire_574,
		qtlg_wire_575,
		qtlg_wire_576,
		qtlg_wire_577,
		qtlg_wire_578,
		qtlg_wire_579,
		qtlg_wire_580,
		qtlg_wire_581,
		qtlg_wire_582,
		qtlg_wire_583,
		qtlg_wire_584,
		qtlg_wire_585,
		qtlg_wire_586,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][2],
		qtlg_wire_587,
		qtlg_wire_588}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_589,
		qtlg_wire_590,
		qtlg_wire_591,
		qtlg_wire_592,
		qtlg_wire_593,
		qtlg_wire_594,
		qtlg_wire_595,
		qtlg_wire_596,
		qtlg_wire_597,
		qtlg_wire_598,
		qtlg_wire_599,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][3],
		qtlg_wire_600,
		qtlg_wire_601,
		qtlg_wire_602}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_603,
		qtlg_wire_604,
		qtlg_wire_605,
		qtlg_wire_606,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][15],
		qtlg_wire_607,
		qtlg_wire_608,
		qtlg_wire_609,
		qtlg_wire_610,
		qtlg_wire_611,
		qtlg_wire_612,
		qtlg_wire_613,
		qtlg_wire_614,
		qtlg_wire_615,
		qtlg_wire_616,
		qtlg_wire_617,
		qtlg_wire_618,
		qtlg_wire_619,
		qtlg_wire_620,
		qtlg_wire_621}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_622,
		qtlg_wire_623,
		qtlg_wire_624,
		qtlg_wire_625,
		qtlg_wire_626,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][9],
		qtlg_wire_627,
		qtlg_wire_628,
		qtlg_wire_629,
		qtlg_wire_630,
		qtlg_wire_631,
		qtlg_wire_632,
		qtlg_wire_633,
		qtlg_wire_634,
		qtlg_wire_635}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[1]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][16],
		qtlg_wire_636,
		qtlg_wire_637,
		qtlg_wire_638,
		qtlg_wire_639,
		qtlg_wire_640,
		qtlg_wire_641,
		qtlg_wire_642,
		qtlg_wire_643,
		qtlg_wire_644,
		qtlg_wire_645,
		qtlg_wire_646,
		qtlg_wire_647,
		qtlg_wire_648,
		qtlg_wire_649,
		qtlg_wire_650,
		qtlg_wire_651}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[1][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[1]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_652}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[1]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_653}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_654,
		qtlg_wire_655,
		qtlg_wire_656,
		qtlg_wire_657,
		qtlg_wire_658,
		qtlg_wire_659,
		qtlg_wire_660,
		qtlg_wire_661,
		qtlg_wire_662,
		qtlg_wire_663,
		qtlg_wire_664,
		qtlg_wire_665,
		qtlg_wire_666,
		qtlg_wire_667,
		qtlg_wire_668,
		qtlg_wire_669,
		qtlg_wire_670,
		qtlg_wire_671,
		qtlg_wire_672,
		qtlg_wire_673,
		qtlg_wire_674,
		qtlg_wire_675,
		qtlg_wire_676,
		qtlg_wire_677,
		qtlg_wire_678,
		qtlg_wire_679,
		qtlg_wire_680,
		qtlg_wire_681,
		qtlg_wire_682,
		qtlg_wire_683,
		qtlg_wire_684,
		qtlg_wire_685,
		qtlg_wire_686,
		qtlg_wire_687,
		qtlg_wire_688,
		qtlg_wire_689,
		qtlg_wire_690,
		qtlg_wire_691,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[1][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[1]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[1][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[1][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[1][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[1][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[1]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[1]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[1]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[1]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[1]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[1][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[1]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[1]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(10),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_692}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_693}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[10]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[10]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[10]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_694,
		qtlg_wire_695,
		qtlg_wire_696,
		qtlg_wire_697,
		qtlg_wire_698,
		qtlg_wire_699,
		qtlg_wire_700,
		qtlg_wire_701,
		qtlg_wire_702,
		qtlg_wire_703,
		qtlg_wire_704,
		qtlg_wire_705,
		qtlg_wire_706,
		qtlg_wire_707,
		qtlg_wire_708,
		qtlg_wire_709,
		qtlg_wire_710,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][2],
		qtlg_wire_711,
		qtlg_wire_712}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_713,
		qtlg_wire_714,
		qtlg_wire_715,
		qtlg_wire_716,
		qtlg_wire_717,
		qtlg_wire_718,
		qtlg_wire_719,
		qtlg_wire_720,
		qtlg_wire_721,
		qtlg_wire_722,
		qtlg_wire_723,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][3],
		qtlg_wire_724,
		qtlg_wire_725,
		qtlg_wire_726}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_727,
		qtlg_wire_728,
		qtlg_wire_729,
		qtlg_wire_730,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][15],
		qtlg_wire_731,
		qtlg_wire_732,
		qtlg_wire_733,
		qtlg_wire_734,
		qtlg_wire_735,
		qtlg_wire_736,
		qtlg_wire_737,
		qtlg_wire_738,
		qtlg_wire_739,
		qtlg_wire_740,
		qtlg_wire_741,
		qtlg_wire_742,
		qtlg_wire_743,
		qtlg_wire_744,
		qtlg_wire_745}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_746,
		qtlg_wire_747,
		qtlg_wire_748,
		qtlg_wire_749,
		qtlg_wire_750,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][9],
		qtlg_wire_751,
		qtlg_wire_752,
		qtlg_wire_753,
		qtlg_wire_754,
		qtlg_wire_755,
		qtlg_wire_756,
		qtlg_wire_757,
		qtlg_wire_758,
		qtlg_wire_759}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[10]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][16],
		qtlg_wire_760,
		qtlg_wire_761,
		qtlg_wire_762,
		qtlg_wire_763,
		qtlg_wire_764,
		qtlg_wire_765,
		qtlg_wire_766,
		qtlg_wire_767,
		qtlg_wire_768,
		qtlg_wire_769,
		qtlg_wire_770,
		qtlg_wire_771,
		qtlg_wire_772,
		qtlg_wire_773,
		qtlg_wire_774,
		qtlg_wire_775}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[10][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[10]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_776,
		qtlg_wire_777}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_778,
		qtlg_wire_779}),
	.s_intfc_15_pld_8g_signal_detect_out_real({qtlg_wire_780,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_781}),
	.s_intfc_15_pld_ltr_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[10]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({qtlg_wire_782,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_783}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_784,
		qtlg_wire_785,
		qtlg_wire_786,
		qtlg_wire_787,
		qtlg_wire_788,
		qtlg_wire_789,
		qtlg_wire_790,
		qtlg_wire_791,
		qtlg_wire_792,
		qtlg_wire_793,
		qtlg_wire_794,
		qtlg_wire_795,
		qtlg_wire_796,
		qtlg_wire_797,
		qtlg_wire_798,
		qtlg_wire_799,
		qtlg_wire_800,
		qtlg_wire_801,
		qtlg_wire_802,
		qtlg_wire_803,
		qtlg_wire_804,
		qtlg_wire_805,
		qtlg_wire_806,
		qtlg_wire_807,
		qtlg_wire_808,
		qtlg_wire_809,
		qtlg_wire_810,
		qtlg_wire_811,
		qtlg_wire_812,
		qtlg_wire_813,
		qtlg_wire_814,
		qtlg_wire_815,
		qtlg_wire_816,
		qtlg_wire_817,
		qtlg_wire_818,
		qtlg_wire_819,
		qtlg_wire_820,
		qtlg_wire_821,
		qtlg_wire_822,
		qtlg_wire_823,
		qtlg_wire_824,
		qtlg_wire_825,
		qtlg_wire_826,
		qtlg_wire_827,
		qtlg_wire_828,
		qtlg_wire_829,
		qtlg_wire_830,
		qtlg_wire_831,
		qtlg_wire_832,
		qtlg_wire_833,
		qtlg_wire_834,
		qtlg_wire_835,
		qtlg_wire_836,
		qtlg_wire_837,
		qtlg_wire_838,
		qtlg_wire_839,
		qtlg_wire_840,
		qtlg_wire_841,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[10][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_842,
		qtlg_wire_843}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_844}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_845}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_846}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_847,
		qtlg_wire_848,
		qtlg_wire_849,
		qtlg_wire_850}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_851}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[10]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[10][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[10][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[10][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[10][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[10]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_852,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[10]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_853,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[10]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_854,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[10]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_855}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_856}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_857}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_858}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[10]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[10][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_859,
		qtlg_wire_860,
		qtlg_wire_861,
		qtlg_wire_862,
		qtlg_wire_863}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_864}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_865}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[10]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_866,
		qtlg_wire_867,
		qtlg_wire_868,
		qtlg_wire_869,
		qtlg_wire_870,
		qtlg_wire_871,
		qtlg_wire_872,
		qtlg_wire_873,
		qtlg_wire_874,
		qtlg_wire_875,
		qtlg_wire_876,
		qtlg_wire_877,
		qtlg_wire_878,
		qtlg_wire_879,
		qtlg_wire_880,
		qtlg_wire_881,
		qtlg_wire_882,
		qtlg_wire_883,
		qtlg_wire_884,
		qtlg_wire_885,
		qtlg_wire_886,
		qtlg_wire_887,
		qtlg_wire_888,
		qtlg_wire_889,
		qtlg_wire_890,
		qtlg_wire_891,
		qtlg_wire_892,
		qtlg_wire_893,
		qtlg_wire_894,
		qtlg_wire_895,
		qtlg_wire_896,
		qtlg_wire_897,
		qtlg_wire_898,
		qtlg_wire_899,
		qtlg_wire_900,
		qtlg_wire_901,
		qtlg_wire_902,
		qtlg_wire_903,
		qtlg_wire_904,
		qtlg_wire_905,
		qtlg_wire_906,
		qtlg_wire_907,
		qtlg_wire_908,
		qtlg_wire_909,
		qtlg_wire_910,
		qtlg_wire_911,
		qtlg_wire_912,
		qtlg_wire_913,
		qtlg_wire_914,
		qtlg_wire_915,
		qtlg_wire_916,
		qtlg_wire_917,
		qtlg_wire_918,
		qtlg_wire_919,
		qtlg_wire_920,
		qtlg_wire_921,
		qtlg_wire_922,
		qtlg_wire_923,
		qtlg_wire_924,
		qtlg_wire_925,
		qtlg_wire_926,
		qtlg_wire_927,
		qtlg_wire_928,
		qtlg_wire_929,
		qtlg_wire_930,
		qtlg_wire_931,
		qtlg_wire_932,
		qtlg_wire_933,
		qtlg_wire_934,
		qtlg_wire_935,
		qtlg_wire_936,
		qtlg_wire_937,
		qtlg_wire_938,
		qtlg_wire_939,
		qtlg_wire_940,
		qtlg_wire_941,
		qtlg_wire_942,
		qtlg_wire_943,
		qtlg_wire_944,
		qtlg_wire_945}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_946}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_947}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_948}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_949}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_950,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[10]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_951}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_952}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_953}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_954}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(11),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_955}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_956}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[11]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[11]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[11]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_957,
		qtlg_wire_958,
		qtlg_wire_959,
		qtlg_wire_960,
		qtlg_wire_961,
		qtlg_wire_962,
		qtlg_wire_963,
		qtlg_wire_964,
		qtlg_wire_965,
		qtlg_wire_966,
		qtlg_wire_967,
		qtlg_wire_968,
		qtlg_wire_969,
		qtlg_wire_970,
		qtlg_wire_971,
		qtlg_wire_972,
		qtlg_wire_973,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][2],
		qtlg_wire_974,
		qtlg_wire_975}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_976,
		qtlg_wire_977,
		qtlg_wire_978,
		qtlg_wire_979,
		qtlg_wire_980,
		qtlg_wire_981,
		qtlg_wire_982,
		qtlg_wire_983,
		qtlg_wire_984,
		qtlg_wire_985,
		qtlg_wire_986,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][3],
		qtlg_wire_987,
		qtlg_wire_988,
		qtlg_wire_989}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_990,
		qtlg_wire_991,
		qtlg_wire_992,
		qtlg_wire_993,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][15],
		qtlg_wire_994,
		qtlg_wire_995,
		qtlg_wire_996,
		qtlg_wire_997,
		qtlg_wire_998,
		qtlg_wire_999,
		qtlg_wire_1000,
		qtlg_wire_1001,
		qtlg_wire_1002,
		qtlg_wire_1003,
		qtlg_wire_1004,
		qtlg_wire_1005,
		qtlg_wire_1006,
		qtlg_wire_1007,
		qtlg_wire_1008}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_1009,
		qtlg_wire_1010,
		qtlg_wire_1011,
		qtlg_wire_1012,
		qtlg_wire_1013,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][9],
		qtlg_wire_1014,
		qtlg_wire_1015,
		qtlg_wire_1016,
		qtlg_wire_1017,
		qtlg_wire_1018,
		qtlg_wire_1019,
		qtlg_wire_1020,
		qtlg_wire_1021,
		qtlg_wire_1022}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[11]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][16],
		qtlg_wire_1023,
		qtlg_wire_1024,
		qtlg_wire_1025,
		qtlg_wire_1026,
		qtlg_wire_1027,
		qtlg_wire_1028,
		qtlg_wire_1029,
		qtlg_wire_1030,
		qtlg_wire_1031,
		qtlg_wire_1032,
		qtlg_wire_1033,
		qtlg_wire_1034,
		qtlg_wire_1035,
		qtlg_wire_1036,
		qtlg_wire_1037,
		qtlg_wire_1038}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[11][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[11]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_1039,
		qtlg_wire_1040}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_1041,
		qtlg_wire_1042}),
	.s_intfc_15_pld_8g_signal_detect_out_real({qtlg_wire_1043,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_1044}),
	.s_intfc_15_pld_ltr_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[11]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({qtlg_wire_1045,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_1046}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_1047,
		qtlg_wire_1048,
		qtlg_wire_1049,
		qtlg_wire_1050,
		qtlg_wire_1051,
		qtlg_wire_1052,
		qtlg_wire_1053,
		qtlg_wire_1054,
		qtlg_wire_1055,
		qtlg_wire_1056,
		qtlg_wire_1057,
		qtlg_wire_1058,
		qtlg_wire_1059,
		qtlg_wire_1060,
		qtlg_wire_1061,
		qtlg_wire_1062,
		qtlg_wire_1063,
		qtlg_wire_1064,
		qtlg_wire_1065,
		qtlg_wire_1066,
		qtlg_wire_1067,
		qtlg_wire_1068,
		qtlg_wire_1069,
		qtlg_wire_1070,
		qtlg_wire_1071,
		qtlg_wire_1072,
		qtlg_wire_1073,
		qtlg_wire_1074,
		qtlg_wire_1075,
		qtlg_wire_1076,
		qtlg_wire_1077,
		qtlg_wire_1078,
		qtlg_wire_1079,
		qtlg_wire_1080,
		qtlg_wire_1081,
		qtlg_wire_1082,
		qtlg_wire_1083,
		qtlg_wire_1084,
		qtlg_wire_1085,
		qtlg_wire_1086,
		qtlg_wire_1087,
		qtlg_wire_1088,
		qtlg_wire_1089,
		qtlg_wire_1090,
		qtlg_wire_1091,
		qtlg_wire_1092,
		qtlg_wire_1093,
		qtlg_wire_1094,
		qtlg_wire_1095,
		qtlg_wire_1096,
		qtlg_wire_1097,
		qtlg_wire_1098,
		qtlg_wire_1099,
		qtlg_wire_1100,
		qtlg_wire_1101,
		qtlg_wire_1102,
		qtlg_wire_1103,
		qtlg_wire_1104,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[11][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_1105,
		qtlg_wire_1106}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_1107}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_1108}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_1109}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_1110,
		qtlg_wire_1111,
		qtlg_wire_1112,
		qtlg_wire_1113}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_1114}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[11]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[11][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[11][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[11][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[11][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[11]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_1115,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[11]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_1116,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[11]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_1117,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[11]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_1118}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_1119}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_1120}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_1121}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[11]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[11][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_1122,
		qtlg_wire_1123,
		qtlg_wire_1124,
		qtlg_wire_1125,
		qtlg_wire_1126}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_1127}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_1128}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[11]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_1129,
		qtlg_wire_1130,
		qtlg_wire_1131,
		qtlg_wire_1132,
		qtlg_wire_1133,
		qtlg_wire_1134,
		qtlg_wire_1135,
		qtlg_wire_1136,
		qtlg_wire_1137,
		qtlg_wire_1138,
		qtlg_wire_1139,
		qtlg_wire_1140,
		qtlg_wire_1141,
		qtlg_wire_1142,
		qtlg_wire_1143,
		qtlg_wire_1144,
		qtlg_wire_1145,
		qtlg_wire_1146,
		qtlg_wire_1147,
		qtlg_wire_1148,
		qtlg_wire_1149,
		qtlg_wire_1150,
		qtlg_wire_1151,
		qtlg_wire_1152,
		qtlg_wire_1153,
		qtlg_wire_1154,
		qtlg_wire_1155,
		qtlg_wire_1156,
		qtlg_wire_1157,
		qtlg_wire_1158,
		qtlg_wire_1159,
		qtlg_wire_1160,
		qtlg_wire_1161,
		qtlg_wire_1162,
		qtlg_wire_1163,
		qtlg_wire_1164,
		qtlg_wire_1165,
		qtlg_wire_1166,
		qtlg_wire_1167,
		qtlg_wire_1168,
		qtlg_wire_1169,
		qtlg_wire_1170,
		qtlg_wire_1171,
		qtlg_wire_1172,
		qtlg_wire_1173,
		qtlg_wire_1174,
		qtlg_wire_1175,
		qtlg_wire_1176,
		qtlg_wire_1177,
		qtlg_wire_1178,
		qtlg_wire_1179,
		qtlg_wire_1180,
		qtlg_wire_1181,
		qtlg_wire_1182,
		qtlg_wire_1183,
		qtlg_wire_1184,
		qtlg_wire_1185,
		qtlg_wire_1186,
		qtlg_wire_1187,
		qtlg_wire_1188,
		qtlg_wire_1189,
		qtlg_wire_1190,
		qtlg_wire_1191,
		qtlg_wire_1192,
		qtlg_wire_1193,
		qtlg_wire_1194,
		qtlg_wire_1195,
		qtlg_wire_1196,
		qtlg_wire_1197,
		qtlg_wire_1198,
		qtlg_wire_1199,
		qtlg_wire_1200,
		qtlg_wire_1201,
		qtlg_wire_1202,
		qtlg_wire_1203,
		qtlg_wire_1204,
		qtlg_wire_1205,
		qtlg_wire_1206,
		qtlg_wire_1207,
		qtlg_wire_1208}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_1209}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_1210}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_1211}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_1212}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_1213,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[11]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_1214}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_1215}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_1216}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_1217}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(12),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_1218}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_1219}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[12]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[12]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[12]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_1220,
		qtlg_wire_1221,
		qtlg_wire_1222,
		qtlg_wire_1223,
		qtlg_wire_1224,
		qtlg_wire_1225,
		qtlg_wire_1226,
		qtlg_wire_1227,
		qtlg_wire_1228,
		qtlg_wire_1229,
		qtlg_wire_1230,
		qtlg_wire_1231,
		qtlg_wire_1232,
		qtlg_wire_1233,
		qtlg_wire_1234,
		qtlg_wire_1235,
		qtlg_wire_1236,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][2],
		qtlg_wire_1237,
		qtlg_wire_1238}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_1239,
		qtlg_wire_1240,
		qtlg_wire_1241,
		qtlg_wire_1242,
		qtlg_wire_1243,
		qtlg_wire_1244,
		qtlg_wire_1245,
		qtlg_wire_1246,
		qtlg_wire_1247,
		qtlg_wire_1248,
		qtlg_wire_1249,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][3],
		qtlg_wire_1250,
		qtlg_wire_1251,
		qtlg_wire_1252}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_1253,
		qtlg_wire_1254,
		qtlg_wire_1255,
		qtlg_wire_1256,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][15],
		qtlg_wire_1257,
		qtlg_wire_1258,
		qtlg_wire_1259,
		qtlg_wire_1260,
		qtlg_wire_1261,
		qtlg_wire_1262,
		qtlg_wire_1263,
		qtlg_wire_1264,
		qtlg_wire_1265,
		qtlg_wire_1266,
		qtlg_wire_1267,
		qtlg_wire_1268,
		qtlg_wire_1269,
		qtlg_wire_1270,
		qtlg_wire_1271}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_1272,
		qtlg_wire_1273,
		qtlg_wire_1274,
		qtlg_wire_1275,
		qtlg_wire_1276,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][9],
		qtlg_wire_1277,
		qtlg_wire_1278,
		qtlg_wire_1279,
		qtlg_wire_1280,
		qtlg_wire_1281,
		qtlg_wire_1282,
		qtlg_wire_1283,
		qtlg_wire_1284,
		qtlg_wire_1285}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[12]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][16],
		qtlg_wire_1286,
		qtlg_wire_1287,
		qtlg_wire_1288,
		qtlg_wire_1289,
		qtlg_wire_1290,
		qtlg_wire_1291,
		qtlg_wire_1292,
		qtlg_wire_1293,
		qtlg_wire_1294,
		qtlg_wire_1295,
		qtlg_wire_1296,
		qtlg_wire_1297,
		qtlg_wire_1298,
		qtlg_wire_1299,
		qtlg_wire_1300,
		qtlg_wire_1301}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[12][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[12]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_1302,
		qtlg_wire_1303}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_1304,
		qtlg_wire_1305}),
	.s_intfc_15_pld_8g_signal_detect_out_real({qtlg_wire_1306,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_1307}),
	.s_intfc_15_pld_ltr_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[12]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({qtlg_wire_1308,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_1309}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_1310,
		qtlg_wire_1311,
		qtlg_wire_1312,
		qtlg_wire_1313,
		qtlg_wire_1314,
		qtlg_wire_1315,
		qtlg_wire_1316,
		qtlg_wire_1317,
		qtlg_wire_1318,
		qtlg_wire_1319,
		qtlg_wire_1320,
		qtlg_wire_1321,
		qtlg_wire_1322,
		qtlg_wire_1323,
		qtlg_wire_1324,
		qtlg_wire_1325,
		qtlg_wire_1326,
		qtlg_wire_1327,
		qtlg_wire_1328,
		qtlg_wire_1329,
		qtlg_wire_1330,
		qtlg_wire_1331,
		qtlg_wire_1332,
		qtlg_wire_1333,
		qtlg_wire_1334,
		qtlg_wire_1335,
		qtlg_wire_1336,
		qtlg_wire_1337,
		qtlg_wire_1338,
		qtlg_wire_1339,
		qtlg_wire_1340,
		qtlg_wire_1341,
		qtlg_wire_1342,
		qtlg_wire_1343,
		qtlg_wire_1344,
		qtlg_wire_1345,
		qtlg_wire_1346,
		qtlg_wire_1347,
		qtlg_wire_1348,
		qtlg_wire_1349,
		qtlg_wire_1350,
		qtlg_wire_1351,
		qtlg_wire_1352,
		qtlg_wire_1353,
		qtlg_wire_1354,
		qtlg_wire_1355,
		qtlg_wire_1356,
		qtlg_wire_1357,
		qtlg_wire_1358,
		qtlg_wire_1359,
		qtlg_wire_1360,
		qtlg_wire_1361,
		qtlg_wire_1362,
		qtlg_wire_1363,
		qtlg_wire_1364,
		qtlg_wire_1365,
		qtlg_wire_1366,
		qtlg_wire_1367,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[12][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_1368,
		qtlg_wire_1369}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_1370}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_1371}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_1372}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_1373,
		qtlg_wire_1374,
		qtlg_wire_1375,
		qtlg_wire_1376}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_1377}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[12]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[12][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[12][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[12][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[12][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[12]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_1378,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[12]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_1379,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[12]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_1380,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[12]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_1381}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_1382}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_1383}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_1384}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[12]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[12][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_1385,
		qtlg_wire_1386,
		qtlg_wire_1387,
		qtlg_wire_1388,
		qtlg_wire_1389}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_1390}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_1391}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[12]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_1392,
		qtlg_wire_1393,
		qtlg_wire_1394,
		qtlg_wire_1395,
		qtlg_wire_1396,
		qtlg_wire_1397,
		qtlg_wire_1398,
		qtlg_wire_1399,
		qtlg_wire_1400,
		qtlg_wire_1401,
		qtlg_wire_1402,
		qtlg_wire_1403,
		qtlg_wire_1404,
		qtlg_wire_1405,
		qtlg_wire_1406,
		qtlg_wire_1407,
		qtlg_wire_1408,
		qtlg_wire_1409,
		qtlg_wire_1410,
		qtlg_wire_1411,
		qtlg_wire_1412,
		qtlg_wire_1413,
		qtlg_wire_1414,
		qtlg_wire_1415,
		qtlg_wire_1416,
		qtlg_wire_1417,
		qtlg_wire_1418,
		qtlg_wire_1419,
		qtlg_wire_1420,
		qtlg_wire_1421,
		qtlg_wire_1422,
		qtlg_wire_1423,
		qtlg_wire_1424,
		qtlg_wire_1425,
		qtlg_wire_1426,
		qtlg_wire_1427,
		qtlg_wire_1428,
		qtlg_wire_1429,
		qtlg_wire_1430,
		qtlg_wire_1431,
		qtlg_wire_1432,
		qtlg_wire_1433,
		qtlg_wire_1434,
		qtlg_wire_1435,
		qtlg_wire_1436,
		qtlg_wire_1437,
		qtlg_wire_1438,
		qtlg_wire_1439,
		qtlg_wire_1440,
		qtlg_wire_1441,
		qtlg_wire_1442,
		qtlg_wire_1443,
		qtlg_wire_1444,
		qtlg_wire_1445,
		qtlg_wire_1446,
		qtlg_wire_1447,
		qtlg_wire_1448,
		qtlg_wire_1449,
		qtlg_wire_1450,
		qtlg_wire_1451,
		qtlg_wire_1452,
		qtlg_wire_1453,
		qtlg_wire_1454,
		qtlg_wire_1455,
		qtlg_wire_1456,
		qtlg_wire_1457,
		qtlg_wire_1458,
		qtlg_wire_1459,
		qtlg_wire_1460,
		qtlg_wire_1461,
		qtlg_wire_1462,
		qtlg_wire_1463,
		qtlg_wire_1464,
		qtlg_wire_1465,
		qtlg_wire_1466,
		qtlg_wire_1467,
		qtlg_wire_1468,
		qtlg_wire_1469,
		qtlg_wire_1470,
		qtlg_wire_1471}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_1472}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_1473}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_1474}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_1475}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_1476,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[12]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_1477}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_1478}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_1479}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_1480}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(13),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_1481}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_1482}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[13]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[13]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[13]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_1483,
		qtlg_wire_1484,
		qtlg_wire_1485,
		qtlg_wire_1486,
		qtlg_wire_1487,
		qtlg_wire_1488,
		qtlg_wire_1489,
		qtlg_wire_1490,
		qtlg_wire_1491,
		qtlg_wire_1492,
		qtlg_wire_1493,
		qtlg_wire_1494,
		qtlg_wire_1495,
		qtlg_wire_1496,
		qtlg_wire_1497,
		qtlg_wire_1498,
		qtlg_wire_1499,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][2],
		qtlg_wire_1500,
		qtlg_wire_1501}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_1502,
		qtlg_wire_1503,
		qtlg_wire_1504,
		qtlg_wire_1505,
		qtlg_wire_1506,
		qtlg_wire_1507,
		qtlg_wire_1508,
		qtlg_wire_1509,
		qtlg_wire_1510,
		qtlg_wire_1511,
		qtlg_wire_1512,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][3],
		qtlg_wire_1513,
		qtlg_wire_1514,
		qtlg_wire_1515}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_1516,
		qtlg_wire_1517,
		qtlg_wire_1518,
		qtlg_wire_1519,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][15],
		qtlg_wire_1520,
		qtlg_wire_1521,
		qtlg_wire_1522,
		qtlg_wire_1523,
		qtlg_wire_1524,
		qtlg_wire_1525,
		qtlg_wire_1526,
		qtlg_wire_1527,
		qtlg_wire_1528,
		qtlg_wire_1529,
		qtlg_wire_1530,
		qtlg_wire_1531,
		qtlg_wire_1532,
		qtlg_wire_1533,
		qtlg_wire_1534}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_1535,
		qtlg_wire_1536,
		qtlg_wire_1537,
		qtlg_wire_1538,
		qtlg_wire_1539,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][9],
		qtlg_wire_1540,
		qtlg_wire_1541,
		qtlg_wire_1542,
		qtlg_wire_1543,
		qtlg_wire_1544,
		qtlg_wire_1545,
		qtlg_wire_1546,
		qtlg_wire_1547,
		qtlg_wire_1548}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[13]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][16],
		qtlg_wire_1549,
		qtlg_wire_1550,
		qtlg_wire_1551,
		qtlg_wire_1552,
		qtlg_wire_1553,
		qtlg_wire_1554,
		qtlg_wire_1555,
		qtlg_wire_1556,
		qtlg_wire_1557,
		qtlg_wire_1558,
		qtlg_wire_1559,
		qtlg_wire_1560,
		qtlg_wire_1561,
		qtlg_wire_1562,
		qtlg_wire_1563,
		qtlg_wire_1564}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[13][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[13]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_1565,
		qtlg_wire_1566}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_1567,
		qtlg_wire_1568}),
	.s_intfc_15_pld_8g_signal_detect_out_real({qtlg_wire_1569,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_1570}),
	.s_intfc_15_pld_ltr_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[13]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({qtlg_wire_1571,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_1572}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_1573,
		qtlg_wire_1574,
		qtlg_wire_1575,
		qtlg_wire_1576,
		qtlg_wire_1577,
		qtlg_wire_1578,
		qtlg_wire_1579,
		qtlg_wire_1580,
		qtlg_wire_1581,
		qtlg_wire_1582,
		qtlg_wire_1583,
		qtlg_wire_1584,
		qtlg_wire_1585,
		qtlg_wire_1586,
		qtlg_wire_1587,
		qtlg_wire_1588,
		qtlg_wire_1589,
		qtlg_wire_1590,
		qtlg_wire_1591,
		qtlg_wire_1592,
		qtlg_wire_1593,
		qtlg_wire_1594,
		qtlg_wire_1595,
		qtlg_wire_1596,
		qtlg_wire_1597,
		qtlg_wire_1598,
		qtlg_wire_1599,
		qtlg_wire_1600,
		qtlg_wire_1601,
		qtlg_wire_1602,
		qtlg_wire_1603,
		qtlg_wire_1604,
		qtlg_wire_1605,
		qtlg_wire_1606,
		qtlg_wire_1607,
		qtlg_wire_1608,
		qtlg_wire_1609,
		qtlg_wire_1610,
		qtlg_wire_1611,
		qtlg_wire_1612,
		qtlg_wire_1613,
		qtlg_wire_1614,
		qtlg_wire_1615,
		qtlg_wire_1616,
		qtlg_wire_1617,
		qtlg_wire_1618,
		qtlg_wire_1619,
		qtlg_wire_1620,
		qtlg_wire_1621,
		qtlg_wire_1622,
		qtlg_wire_1623,
		qtlg_wire_1624,
		qtlg_wire_1625,
		qtlg_wire_1626,
		qtlg_wire_1627,
		qtlg_wire_1628,
		qtlg_wire_1629,
		qtlg_wire_1630,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[13][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_1631,
		qtlg_wire_1632}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_1633}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_1634}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_1635}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_1636,
		qtlg_wire_1637,
		qtlg_wire_1638,
		qtlg_wire_1639}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_1640}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[13]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[13][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[13][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[13][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[13][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[13]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_1641,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[13]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_1642,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[13]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_1643,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[13]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_1644}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_1645}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_1646}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_1647}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[13]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[13][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_1648,
		qtlg_wire_1649,
		qtlg_wire_1650,
		qtlg_wire_1651,
		qtlg_wire_1652}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_1653}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_1654}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[13]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_1655,
		qtlg_wire_1656,
		qtlg_wire_1657,
		qtlg_wire_1658,
		qtlg_wire_1659,
		qtlg_wire_1660,
		qtlg_wire_1661,
		qtlg_wire_1662,
		qtlg_wire_1663,
		qtlg_wire_1664,
		qtlg_wire_1665,
		qtlg_wire_1666,
		qtlg_wire_1667,
		qtlg_wire_1668,
		qtlg_wire_1669,
		qtlg_wire_1670,
		qtlg_wire_1671,
		qtlg_wire_1672,
		qtlg_wire_1673,
		qtlg_wire_1674,
		qtlg_wire_1675,
		qtlg_wire_1676,
		qtlg_wire_1677,
		qtlg_wire_1678,
		qtlg_wire_1679,
		qtlg_wire_1680,
		qtlg_wire_1681,
		qtlg_wire_1682,
		qtlg_wire_1683,
		qtlg_wire_1684,
		qtlg_wire_1685,
		qtlg_wire_1686,
		qtlg_wire_1687,
		qtlg_wire_1688,
		qtlg_wire_1689,
		qtlg_wire_1690,
		qtlg_wire_1691,
		qtlg_wire_1692,
		qtlg_wire_1693,
		qtlg_wire_1694,
		qtlg_wire_1695,
		qtlg_wire_1696,
		qtlg_wire_1697,
		qtlg_wire_1698,
		qtlg_wire_1699,
		qtlg_wire_1700,
		qtlg_wire_1701,
		qtlg_wire_1702,
		qtlg_wire_1703,
		qtlg_wire_1704,
		qtlg_wire_1705,
		qtlg_wire_1706,
		qtlg_wire_1707,
		qtlg_wire_1708,
		qtlg_wire_1709,
		qtlg_wire_1710,
		qtlg_wire_1711,
		qtlg_wire_1712,
		qtlg_wire_1713,
		qtlg_wire_1714,
		qtlg_wire_1715,
		qtlg_wire_1716,
		qtlg_wire_1717,
		qtlg_wire_1718,
		qtlg_wire_1719,
		qtlg_wire_1720,
		qtlg_wire_1721,
		qtlg_wire_1722,
		qtlg_wire_1723,
		qtlg_wire_1724,
		qtlg_wire_1725,
		qtlg_wire_1726,
		qtlg_wire_1727,
		qtlg_wire_1728,
		qtlg_wire_1729,
		qtlg_wire_1730,
		qtlg_wire_1731,
		qtlg_wire_1732,
		qtlg_wire_1733,
		qtlg_wire_1734}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_1735}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_1736}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_1737}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_1738}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_1739,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[13]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_1740}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_1741}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_1742}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_1743}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(14),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_1744}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_1745}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[14]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[14]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[14]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_1746,
		qtlg_wire_1747,
		qtlg_wire_1748,
		qtlg_wire_1749,
		qtlg_wire_1750,
		qtlg_wire_1751,
		qtlg_wire_1752,
		qtlg_wire_1753,
		qtlg_wire_1754,
		qtlg_wire_1755,
		qtlg_wire_1756,
		qtlg_wire_1757,
		qtlg_wire_1758,
		qtlg_wire_1759,
		qtlg_wire_1760,
		qtlg_wire_1761,
		qtlg_wire_1762,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][2],
		qtlg_wire_1763,
		qtlg_wire_1764}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_1765,
		qtlg_wire_1766,
		qtlg_wire_1767,
		qtlg_wire_1768,
		qtlg_wire_1769,
		qtlg_wire_1770,
		qtlg_wire_1771,
		qtlg_wire_1772,
		qtlg_wire_1773,
		qtlg_wire_1774,
		qtlg_wire_1775,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][3],
		qtlg_wire_1776,
		qtlg_wire_1777,
		qtlg_wire_1778}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_1779,
		qtlg_wire_1780,
		qtlg_wire_1781,
		qtlg_wire_1782,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][15],
		qtlg_wire_1783,
		qtlg_wire_1784,
		qtlg_wire_1785,
		qtlg_wire_1786,
		qtlg_wire_1787,
		qtlg_wire_1788,
		qtlg_wire_1789,
		qtlg_wire_1790,
		qtlg_wire_1791,
		qtlg_wire_1792,
		qtlg_wire_1793,
		qtlg_wire_1794,
		qtlg_wire_1795,
		qtlg_wire_1796,
		qtlg_wire_1797}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_1798,
		qtlg_wire_1799,
		qtlg_wire_1800,
		qtlg_wire_1801,
		qtlg_wire_1802,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][9],
		qtlg_wire_1803,
		qtlg_wire_1804,
		qtlg_wire_1805,
		qtlg_wire_1806,
		qtlg_wire_1807,
		qtlg_wire_1808,
		qtlg_wire_1809,
		qtlg_wire_1810,
		qtlg_wire_1811}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[14]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][16],
		qtlg_wire_1812,
		qtlg_wire_1813,
		qtlg_wire_1814,
		qtlg_wire_1815,
		qtlg_wire_1816,
		qtlg_wire_1817,
		qtlg_wire_1818,
		qtlg_wire_1819,
		qtlg_wire_1820,
		qtlg_wire_1821,
		qtlg_wire_1822,
		qtlg_wire_1823,
		qtlg_wire_1824,
		qtlg_wire_1825,
		qtlg_wire_1826,
		qtlg_wire_1827}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[14][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[14]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_1828,
		qtlg_wire_1829}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_1830,
		qtlg_wire_1831}),
	.s_intfc_15_pld_8g_signal_detect_out_real({qtlg_wire_1832,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_1833}),
	.s_intfc_15_pld_ltr_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[14]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({qtlg_wire_1834,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_1835}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_1836,
		qtlg_wire_1837,
		qtlg_wire_1838,
		qtlg_wire_1839,
		qtlg_wire_1840,
		qtlg_wire_1841,
		qtlg_wire_1842,
		qtlg_wire_1843,
		qtlg_wire_1844,
		qtlg_wire_1845,
		qtlg_wire_1846,
		qtlg_wire_1847,
		qtlg_wire_1848,
		qtlg_wire_1849,
		qtlg_wire_1850,
		qtlg_wire_1851,
		qtlg_wire_1852,
		qtlg_wire_1853,
		qtlg_wire_1854,
		qtlg_wire_1855,
		qtlg_wire_1856,
		qtlg_wire_1857,
		qtlg_wire_1858,
		qtlg_wire_1859,
		qtlg_wire_1860,
		qtlg_wire_1861,
		qtlg_wire_1862,
		qtlg_wire_1863,
		qtlg_wire_1864,
		qtlg_wire_1865,
		qtlg_wire_1866,
		qtlg_wire_1867,
		qtlg_wire_1868,
		qtlg_wire_1869,
		qtlg_wire_1870,
		qtlg_wire_1871,
		qtlg_wire_1872,
		qtlg_wire_1873,
		qtlg_wire_1874,
		qtlg_wire_1875,
		qtlg_wire_1876,
		qtlg_wire_1877,
		qtlg_wire_1878,
		qtlg_wire_1879,
		qtlg_wire_1880,
		qtlg_wire_1881,
		qtlg_wire_1882,
		qtlg_wire_1883,
		qtlg_wire_1884,
		qtlg_wire_1885,
		qtlg_wire_1886,
		qtlg_wire_1887,
		qtlg_wire_1888,
		qtlg_wire_1889,
		qtlg_wire_1890,
		qtlg_wire_1891,
		qtlg_wire_1892,
		qtlg_wire_1893,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[14][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_1894,
		qtlg_wire_1895}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_1896}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_1897}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_1898}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_1899,
		qtlg_wire_1900,
		qtlg_wire_1901,
		qtlg_wire_1902}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_1903}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[14]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[14][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[14][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[14][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[14][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[14]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_1904,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[14]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_1905,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[14]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_1906,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[14]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_1907}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_1908}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_1909}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_1910}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[14]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[14][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_1911,
		qtlg_wire_1912,
		qtlg_wire_1913,
		qtlg_wire_1914,
		qtlg_wire_1915}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_1916}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_1917}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[14]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_1918,
		qtlg_wire_1919,
		qtlg_wire_1920,
		qtlg_wire_1921,
		qtlg_wire_1922,
		qtlg_wire_1923,
		qtlg_wire_1924,
		qtlg_wire_1925,
		qtlg_wire_1926,
		qtlg_wire_1927,
		qtlg_wire_1928,
		qtlg_wire_1929,
		qtlg_wire_1930,
		qtlg_wire_1931,
		qtlg_wire_1932,
		qtlg_wire_1933,
		qtlg_wire_1934,
		qtlg_wire_1935,
		qtlg_wire_1936,
		qtlg_wire_1937,
		qtlg_wire_1938,
		qtlg_wire_1939,
		qtlg_wire_1940,
		qtlg_wire_1941,
		qtlg_wire_1942,
		qtlg_wire_1943,
		qtlg_wire_1944,
		qtlg_wire_1945,
		qtlg_wire_1946,
		qtlg_wire_1947,
		qtlg_wire_1948,
		qtlg_wire_1949,
		qtlg_wire_1950,
		qtlg_wire_1951,
		qtlg_wire_1952,
		qtlg_wire_1953,
		qtlg_wire_1954,
		qtlg_wire_1955,
		qtlg_wire_1956,
		qtlg_wire_1957,
		qtlg_wire_1958,
		qtlg_wire_1959,
		qtlg_wire_1960,
		qtlg_wire_1961,
		qtlg_wire_1962,
		qtlg_wire_1963,
		qtlg_wire_1964,
		qtlg_wire_1965,
		qtlg_wire_1966,
		qtlg_wire_1967,
		qtlg_wire_1968,
		qtlg_wire_1969,
		qtlg_wire_1970,
		qtlg_wire_1971,
		qtlg_wire_1972,
		qtlg_wire_1973,
		qtlg_wire_1974,
		qtlg_wire_1975,
		qtlg_wire_1976,
		qtlg_wire_1977,
		qtlg_wire_1978,
		qtlg_wire_1979,
		qtlg_wire_1980,
		qtlg_wire_1981,
		qtlg_wire_1982,
		qtlg_wire_1983,
		qtlg_wire_1984,
		qtlg_wire_1985,
		qtlg_wire_1986,
		qtlg_wire_1987,
		qtlg_wire_1988,
		qtlg_wire_1989,
		qtlg_wire_1990,
		qtlg_wire_1991,
		qtlg_wire_1992,
		qtlg_wire_1993,
		qtlg_wire_1994,
		qtlg_wire_1995,
		qtlg_wire_1996,
		qtlg_wire_1997}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_1998}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_1999}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_2000}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_2001}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_2002,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[14]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_2003}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_2004}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_2005}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_2006}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(15),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_2007}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_2008}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[15]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[15]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[15]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_2009,
		qtlg_wire_2010,
		qtlg_wire_2011,
		qtlg_wire_2012,
		qtlg_wire_2013,
		qtlg_wire_2014,
		qtlg_wire_2015,
		qtlg_wire_2016,
		qtlg_wire_2017,
		qtlg_wire_2018,
		qtlg_wire_2019,
		qtlg_wire_2020,
		qtlg_wire_2021,
		qtlg_wire_2022,
		qtlg_wire_2023,
		qtlg_wire_2024,
		qtlg_wire_2025,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][2],
		qtlg_wire_2026,
		qtlg_wire_2027}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_2028,
		qtlg_wire_2029,
		qtlg_wire_2030,
		qtlg_wire_2031,
		qtlg_wire_2032,
		qtlg_wire_2033,
		qtlg_wire_2034,
		qtlg_wire_2035,
		qtlg_wire_2036,
		qtlg_wire_2037,
		qtlg_wire_2038,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][3],
		qtlg_wire_2039,
		qtlg_wire_2040,
		qtlg_wire_2041}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_2042,
		qtlg_wire_2043,
		qtlg_wire_2044,
		qtlg_wire_2045,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][15],
		qtlg_wire_2046,
		qtlg_wire_2047,
		qtlg_wire_2048,
		qtlg_wire_2049,
		qtlg_wire_2050,
		qtlg_wire_2051,
		qtlg_wire_2052,
		qtlg_wire_2053,
		qtlg_wire_2054,
		qtlg_wire_2055,
		qtlg_wire_2056,
		qtlg_wire_2057,
		qtlg_wire_2058,
		qtlg_wire_2059,
		qtlg_wire_2060}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_2061,
		qtlg_wire_2062,
		qtlg_wire_2063,
		qtlg_wire_2064,
		qtlg_wire_2065,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][9],
		qtlg_wire_2066,
		qtlg_wire_2067,
		qtlg_wire_2068,
		qtlg_wire_2069,
		qtlg_wire_2070,
		qtlg_wire_2071,
		qtlg_wire_2072,
		qtlg_wire_2073,
		qtlg_wire_2074}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[15]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][16],
		qtlg_wire_2075,
		qtlg_wire_2076,
		qtlg_wire_2077,
		qtlg_wire_2078,
		qtlg_wire_2079,
		qtlg_wire_2080,
		qtlg_wire_2081,
		qtlg_wire_2082,
		qtlg_wire_2083,
		qtlg_wire_2084,
		qtlg_wire_2085,
		qtlg_wire_2086,
		qtlg_wire_2087,
		qtlg_wire_2088,
		qtlg_wire_2089,
		qtlg_wire_2090}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[15][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[15]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_2091,
		qtlg_wire_2092}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_2093,
		qtlg_wire_2094}),
	.s_intfc_15_pld_8g_signal_detect_out_real({qtlg_wire_2095,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_2096}),
	.s_intfc_15_pld_ltr_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[15]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({qtlg_wire_2097,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_2098}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_2099,
		qtlg_wire_2100,
		qtlg_wire_2101,
		qtlg_wire_2102,
		qtlg_wire_2103,
		qtlg_wire_2104,
		qtlg_wire_2105,
		qtlg_wire_2106,
		qtlg_wire_2107,
		qtlg_wire_2108,
		qtlg_wire_2109,
		qtlg_wire_2110,
		qtlg_wire_2111,
		qtlg_wire_2112,
		qtlg_wire_2113,
		qtlg_wire_2114,
		qtlg_wire_2115,
		qtlg_wire_2116,
		qtlg_wire_2117,
		qtlg_wire_2118,
		qtlg_wire_2119,
		qtlg_wire_2120,
		qtlg_wire_2121,
		qtlg_wire_2122,
		qtlg_wire_2123,
		qtlg_wire_2124,
		qtlg_wire_2125,
		qtlg_wire_2126,
		qtlg_wire_2127,
		qtlg_wire_2128,
		qtlg_wire_2129,
		qtlg_wire_2130,
		qtlg_wire_2131,
		qtlg_wire_2132,
		qtlg_wire_2133,
		qtlg_wire_2134,
		qtlg_wire_2135,
		qtlg_wire_2136,
		qtlg_wire_2137,
		qtlg_wire_2138,
		qtlg_wire_2139,
		qtlg_wire_2140,
		qtlg_wire_2141,
		qtlg_wire_2142,
		qtlg_wire_2143,
		qtlg_wire_2144,
		qtlg_wire_2145,
		qtlg_wire_2146,
		qtlg_wire_2147,
		qtlg_wire_2148,
		qtlg_wire_2149,
		qtlg_wire_2150,
		qtlg_wire_2151,
		qtlg_wire_2152,
		qtlg_wire_2153,
		qtlg_wire_2154,
		qtlg_wire_2155,
		qtlg_wire_2156,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[15][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_2157,
		qtlg_wire_2158}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_2159}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_2160}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_2161}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_2162,
		qtlg_wire_2163,
		qtlg_wire_2164,
		qtlg_wire_2165}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_2166}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[15]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[15][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[15][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[15][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[15][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[15]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_2167,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[15]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_2168,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[15]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_2169,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[15]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_2170}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_2171}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_2172}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_2173}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[15]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[15][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_2174,
		qtlg_wire_2175,
		qtlg_wire_2176,
		qtlg_wire_2177,
		qtlg_wire_2178}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_2179}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_2180}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[15]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_2181,
		qtlg_wire_2182,
		qtlg_wire_2183,
		qtlg_wire_2184,
		qtlg_wire_2185,
		qtlg_wire_2186,
		qtlg_wire_2187,
		qtlg_wire_2188,
		qtlg_wire_2189,
		qtlg_wire_2190,
		qtlg_wire_2191,
		qtlg_wire_2192,
		qtlg_wire_2193,
		qtlg_wire_2194,
		qtlg_wire_2195,
		qtlg_wire_2196,
		qtlg_wire_2197,
		qtlg_wire_2198,
		qtlg_wire_2199,
		qtlg_wire_2200,
		qtlg_wire_2201,
		qtlg_wire_2202,
		qtlg_wire_2203,
		qtlg_wire_2204,
		qtlg_wire_2205,
		qtlg_wire_2206,
		qtlg_wire_2207,
		qtlg_wire_2208,
		qtlg_wire_2209,
		qtlg_wire_2210,
		qtlg_wire_2211,
		qtlg_wire_2212,
		qtlg_wire_2213,
		qtlg_wire_2214,
		qtlg_wire_2215,
		qtlg_wire_2216,
		qtlg_wire_2217,
		qtlg_wire_2218,
		qtlg_wire_2219,
		qtlg_wire_2220,
		qtlg_wire_2221,
		qtlg_wire_2222,
		qtlg_wire_2223,
		qtlg_wire_2224,
		qtlg_wire_2225,
		qtlg_wire_2226,
		qtlg_wire_2227,
		qtlg_wire_2228,
		qtlg_wire_2229,
		qtlg_wire_2230,
		qtlg_wire_2231,
		qtlg_wire_2232,
		qtlg_wire_2233,
		qtlg_wire_2234,
		qtlg_wire_2235,
		qtlg_wire_2236,
		qtlg_wire_2237,
		qtlg_wire_2238,
		qtlg_wire_2239,
		qtlg_wire_2240,
		qtlg_wire_2241,
		qtlg_wire_2242,
		qtlg_wire_2243,
		qtlg_wire_2244,
		qtlg_wire_2245,
		qtlg_wire_2246,
		qtlg_wire_2247,
		qtlg_wire_2248,
		qtlg_wire_2249,
		qtlg_wire_2250,
		qtlg_wire_2251,
		qtlg_wire_2252,
		qtlg_wire_2253,
		qtlg_wire_2254,
		qtlg_wire_2255,
		qtlg_wire_2256,
		qtlg_wire_2257,
		qtlg_wire_2258,
		qtlg_wire_2259,
		qtlg_wire_2260}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_2261}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_2262}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_2263}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_2264}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_2265,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[15]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_2266}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_2267}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_2268}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_2269}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real;
wire bts_xcvr__q_sys_u0__systemclk_f_0__systemclk_f_0__one_hot_selector;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(16),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_2270}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_2271}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[16]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[16]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[16]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_2272,
		qtlg_wire_2273,
		qtlg_wire_2274,
		qtlg_wire_2275,
		qtlg_wire_2276,
		qtlg_wire_2277,
		qtlg_wire_2278,
		qtlg_wire_2279,
		qtlg_wire_2280,
		qtlg_wire_2281,
		qtlg_wire_2282,
		qtlg_wire_2283,
		qtlg_wire_2284,
		qtlg_wire_2285,
		qtlg_wire_2286,
		qtlg_wire_2287,
		qtlg_wire_2288,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][2],
		qtlg_wire_2289,
		qtlg_wire_2290}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_2291,
		qtlg_wire_2292,
		qtlg_wire_2293,
		qtlg_wire_2294,
		qtlg_wire_2295,
		qtlg_wire_2296,
		qtlg_wire_2297,
		qtlg_wire_2298,
		qtlg_wire_2299,
		qtlg_wire_2300,
		qtlg_wire_2301,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][3],
		qtlg_wire_2302,
		qtlg_wire_2303,
		qtlg_wire_2304}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_2305,
		qtlg_wire_2306,
		qtlg_wire_2307,
		qtlg_wire_2308,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][15],
		qtlg_wire_2309,
		qtlg_wire_2310,
		qtlg_wire_2311,
		qtlg_wire_2312,
		qtlg_wire_2313,
		qtlg_wire_2314,
		qtlg_wire_2315,
		qtlg_wire_2316,
		qtlg_wire_2317,
		qtlg_wire_2318,
		qtlg_wire_2319,
		qtlg_wire_2320,
		qtlg_wire_2321,
		qtlg_wire_2322,
		qtlg_wire_2323}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_2324,
		qtlg_wire_2325,
		qtlg_wire_2326,
		qtlg_wire_2327,
		qtlg_wire_2328,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][9],
		qtlg_wire_2329,
		qtlg_wire_2330,
		qtlg_wire_2331,
		qtlg_wire_2332,
		qtlg_wire_2333,
		qtlg_wire_2334,
		qtlg_wire_2335,
		qtlg_wire_2336,
		qtlg_wire_2337}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[16]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real({bts_xcvr__q_sys_u0__systemclk_f_0__systemclk_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_10_pld_test_data_real({qtlg_wire_2338,
		qtlg_wire_2339,
		qtlg_wire_2340,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.systemclk_f_0.systemclk_f_0.out_systempll_synthlock_0,
		qtlg_wire_2341,
		qtlg_wire_2342,
		qtlg_wire_2343,
		qtlg_wire_2344,
		qtlg_wire_2345,
		qtlg_wire_2346,
		qtlg_wire_2347,
		qtlg_wire_2348,
		qtlg_wire_2349,
		qtlg_wire_2350,
		qtlg_wire_2351,
		qtlg_wire_2352,
		qtlg_wire_2353,
		qtlg_wire_2354,
		qtlg_wire_2355,
		qtlg_wire_2356,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][16],
		qtlg_wire_2357,
		qtlg_wire_2358,
		qtlg_wire_2359,
		qtlg_wire_2360,
		qtlg_wire_2361,
		qtlg_wire_2362,
		qtlg_wire_2363,
		qtlg_wire_2364,
		qtlg_wire_2365,
		qtlg_wire_2366,
		qtlg_wire_2367,
		qtlg_wire_2368,
		qtlg_wire_2369,
		qtlg_wire_2370,
		qtlg_wire_2371,
		qtlg_wire_2372}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[16][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[16]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_2373}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_2374}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[16]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_2375,
		qtlg_wire_2376,
		qtlg_wire_2377,
		qtlg_wire_2378,
		qtlg_wire_2379,
		qtlg_wire_2380,
		qtlg_wire_2381,
		qtlg_wire_2382,
		qtlg_wire_2383,
		qtlg_wire_2384,
		qtlg_wire_2385,
		qtlg_wire_2386,
		qtlg_wire_2387,
		qtlg_wire_2388,
		qtlg_wire_2389,
		qtlg_wire_2390,
		qtlg_wire_2391,
		qtlg_wire_2392,
		qtlg_wire_2393,
		qtlg_wire_2394,
		qtlg_wire_2395,
		qtlg_wire_2396,
		qtlg_wire_2397,
		qtlg_wire_2398,
		qtlg_wire_2399,
		qtlg_wire_2400,
		qtlg_wire_2401,
		qtlg_wire_2402,
		qtlg_wire_2403,
		qtlg_wire_2404,
		qtlg_wire_2405,
		qtlg_wire_2406,
		qtlg_wire_2407,
		qtlg_wire_2408,
		qtlg_wire_2409,
		qtlg_wire_2410,
		qtlg_wire_2411,
		qtlg_wire_2412,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[16][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_2413,
		qtlg_wire_2414}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_2415}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_2416}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_2417}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_2418,
		qtlg_wire_2419,
		qtlg_wire_2420,
		qtlg_wire_2421}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_2422}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[16]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[16][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[16][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[16][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[16][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[16]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_2423,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[16]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_2424,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[16]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_2425,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[16]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_2426}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_2427}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_2428}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_2429}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[16]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[16][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_2430,
		qtlg_wire_2431,
		qtlg_wire_2432,
		qtlg_wire_2433,
		qtlg_wire_2434}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_2435}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_2436}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[16]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_2437,
		qtlg_wire_2438,
		qtlg_wire_2439,
		qtlg_wire_2440,
		qtlg_wire_2441,
		qtlg_wire_2442,
		qtlg_wire_2443,
		qtlg_wire_2444,
		qtlg_wire_2445,
		qtlg_wire_2446,
		qtlg_wire_2447,
		qtlg_wire_2448,
		qtlg_wire_2449,
		qtlg_wire_2450,
		qtlg_wire_2451,
		qtlg_wire_2452,
		qtlg_wire_2453,
		qtlg_wire_2454,
		qtlg_wire_2455,
		qtlg_wire_2456,
		qtlg_wire_2457,
		qtlg_wire_2458,
		qtlg_wire_2459,
		qtlg_wire_2460,
		qtlg_wire_2461,
		qtlg_wire_2462,
		qtlg_wire_2463,
		qtlg_wire_2464,
		qtlg_wire_2465,
		qtlg_wire_2466,
		qtlg_wire_2467,
		qtlg_wire_2468,
		qtlg_wire_2469,
		qtlg_wire_2470,
		qtlg_wire_2471,
		qtlg_wire_2472,
		qtlg_wire_2473,
		qtlg_wire_2474,
		qtlg_wire_2475,
		qtlg_wire_2476,
		qtlg_wire_2477,
		qtlg_wire_2478,
		qtlg_wire_2479,
		qtlg_wire_2480,
		qtlg_wire_2481,
		qtlg_wire_2482,
		qtlg_wire_2483,
		qtlg_wire_2484,
		qtlg_wire_2485,
		qtlg_wire_2486,
		qtlg_wire_2487,
		qtlg_wire_2488,
		qtlg_wire_2489,
		qtlg_wire_2490,
		qtlg_wire_2491,
		qtlg_wire_2492,
		qtlg_wire_2493,
		qtlg_wire_2494,
		qtlg_wire_2495,
		qtlg_wire_2496,
		qtlg_wire_2497,
		qtlg_wire_2498,
		qtlg_wire_2499,
		qtlg_wire_2500,
		qtlg_wire_2501,
		qtlg_wire_2502,
		qtlg_wire_2503,
		qtlg_wire_2504,
		qtlg_wire_2505,
		qtlg_wire_2506,
		qtlg_wire_2507,
		qtlg_wire_2508,
		qtlg_wire_2509,
		qtlg_wire_2510,
		qtlg_wire_2511,
		qtlg_wire_2512,
		qtlg_wire_2513,
		qtlg_wire_2514,
		qtlg_wire_2515,
		qtlg_wire_2516}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_2517}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_2518}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_2519}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_2520}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_2521,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[16]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_2522}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_2523}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_2524}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_2525}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(17),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_2526}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_2527}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[17]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[17]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[17]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_2528,
		qtlg_wire_2529,
		qtlg_wire_2530,
		qtlg_wire_2531,
		qtlg_wire_2532,
		qtlg_wire_2533,
		qtlg_wire_2534,
		qtlg_wire_2535,
		qtlg_wire_2536,
		qtlg_wire_2537,
		qtlg_wire_2538,
		qtlg_wire_2539,
		qtlg_wire_2540,
		qtlg_wire_2541,
		qtlg_wire_2542,
		qtlg_wire_2543,
		qtlg_wire_2544,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][2],
		qtlg_wire_2545,
		qtlg_wire_2546}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_2547,
		qtlg_wire_2548,
		qtlg_wire_2549,
		qtlg_wire_2550,
		qtlg_wire_2551,
		qtlg_wire_2552,
		qtlg_wire_2553,
		qtlg_wire_2554,
		qtlg_wire_2555,
		qtlg_wire_2556,
		qtlg_wire_2557,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][3],
		qtlg_wire_2558,
		qtlg_wire_2559,
		qtlg_wire_2560}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_2561,
		qtlg_wire_2562,
		qtlg_wire_2563,
		qtlg_wire_2564,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][15],
		qtlg_wire_2565,
		qtlg_wire_2566,
		qtlg_wire_2567,
		qtlg_wire_2568,
		qtlg_wire_2569,
		qtlg_wire_2570,
		qtlg_wire_2571,
		qtlg_wire_2572,
		qtlg_wire_2573,
		qtlg_wire_2574,
		qtlg_wire_2575,
		qtlg_wire_2576,
		qtlg_wire_2577,
		qtlg_wire_2578,
		qtlg_wire_2579}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_2580,
		qtlg_wire_2581,
		qtlg_wire_2582,
		qtlg_wire_2583,
		qtlg_wire_2584,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][9],
		qtlg_wire_2585,
		qtlg_wire_2586,
		qtlg_wire_2587,
		qtlg_wire_2588,
		qtlg_wire_2589,
		qtlg_wire_2590,
		qtlg_wire_2591,
		qtlg_wire_2592,
		qtlg_wire_2593}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[17]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][16],
		qtlg_wire_2594,
		qtlg_wire_2595,
		qtlg_wire_2596,
		qtlg_wire_2597,
		qtlg_wire_2598,
		qtlg_wire_2599,
		qtlg_wire_2600,
		qtlg_wire_2601,
		qtlg_wire_2602,
		qtlg_wire_2603,
		qtlg_wire_2604,
		qtlg_wire_2605,
		qtlg_wire_2606,
		qtlg_wire_2607,
		qtlg_wire_2608,
		qtlg_wire_2609}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[17][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[17]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_2610}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_2611}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[17]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_2612,
		qtlg_wire_2613,
		qtlg_wire_2614,
		qtlg_wire_2615,
		qtlg_wire_2616,
		qtlg_wire_2617,
		qtlg_wire_2618,
		qtlg_wire_2619,
		qtlg_wire_2620,
		qtlg_wire_2621,
		qtlg_wire_2622,
		qtlg_wire_2623,
		qtlg_wire_2624,
		qtlg_wire_2625,
		qtlg_wire_2626,
		qtlg_wire_2627,
		qtlg_wire_2628,
		qtlg_wire_2629,
		qtlg_wire_2630,
		qtlg_wire_2631,
		qtlg_wire_2632,
		qtlg_wire_2633,
		qtlg_wire_2634,
		qtlg_wire_2635,
		qtlg_wire_2636,
		qtlg_wire_2637,
		qtlg_wire_2638,
		qtlg_wire_2639,
		qtlg_wire_2640,
		qtlg_wire_2641,
		qtlg_wire_2642,
		qtlg_wire_2643,
		qtlg_wire_2644,
		qtlg_wire_2645,
		qtlg_wire_2646,
		qtlg_wire_2647,
		qtlg_wire_2648,
		qtlg_wire_2649,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[17][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_2650,
		qtlg_wire_2651}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_2652}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_2653}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_2654}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_2655,
		qtlg_wire_2656,
		qtlg_wire_2657,
		qtlg_wire_2658}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_2659}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[17]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[17][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[17][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[17][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[17][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[17]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_2660,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[17]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_2661,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[17]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_2662,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[17]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_2663}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_2664}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_2665}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_2666}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[17]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[17][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_2667,
		qtlg_wire_2668,
		qtlg_wire_2669,
		qtlg_wire_2670,
		qtlg_wire_2671}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_2672}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_2673}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[17]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_2674,
		qtlg_wire_2675,
		qtlg_wire_2676,
		qtlg_wire_2677,
		qtlg_wire_2678,
		qtlg_wire_2679,
		qtlg_wire_2680,
		qtlg_wire_2681,
		qtlg_wire_2682,
		qtlg_wire_2683,
		qtlg_wire_2684,
		qtlg_wire_2685,
		qtlg_wire_2686,
		qtlg_wire_2687,
		qtlg_wire_2688,
		qtlg_wire_2689,
		qtlg_wire_2690,
		qtlg_wire_2691,
		qtlg_wire_2692,
		qtlg_wire_2693,
		qtlg_wire_2694,
		qtlg_wire_2695,
		qtlg_wire_2696,
		qtlg_wire_2697,
		qtlg_wire_2698,
		qtlg_wire_2699,
		qtlg_wire_2700,
		qtlg_wire_2701,
		qtlg_wire_2702,
		qtlg_wire_2703,
		qtlg_wire_2704,
		qtlg_wire_2705,
		qtlg_wire_2706,
		qtlg_wire_2707,
		qtlg_wire_2708,
		qtlg_wire_2709,
		qtlg_wire_2710,
		qtlg_wire_2711,
		qtlg_wire_2712,
		qtlg_wire_2713,
		qtlg_wire_2714,
		qtlg_wire_2715,
		qtlg_wire_2716,
		qtlg_wire_2717,
		qtlg_wire_2718,
		qtlg_wire_2719,
		qtlg_wire_2720,
		qtlg_wire_2721,
		qtlg_wire_2722,
		qtlg_wire_2723,
		qtlg_wire_2724,
		qtlg_wire_2725,
		qtlg_wire_2726,
		qtlg_wire_2727,
		qtlg_wire_2728,
		qtlg_wire_2729,
		qtlg_wire_2730,
		qtlg_wire_2731,
		qtlg_wire_2732,
		qtlg_wire_2733,
		qtlg_wire_2734,
		qtlg_wire_2735,
		qtlg_wire_2736,
		qtlg_wire_2737,
		qtlg_wire_2738,
		qtlg_wire_2739,
		qtlg_wire_2740,
		qtlg_wire_2741,
		qtlg_wire_2742,
		qtlg_wire_2743,
		qtlg_wire_2744,
		qtlg_wire_2745,
		qtlg_wire_2746,
		qtlg_wire_2747,
		qtlg_wire_2748,
		qtlg_wire_2749,
		qtlg_wire_2750,
		qtlg_wire_2751,
		qtlg_wire_2752,
		qtlg_wire_2753}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_2754}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_2755}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_2756}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_2757}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_2758,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[17]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_2759}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_2760}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_2761}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_2762}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(18),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_2763}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_2764}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[18]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[18]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[18]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_2765,
		qtlg_wire_2766,
		qtlg_wire_2767,
		qtlg_wire_2768,
		qtlg_wire_2769,
		qtlg_wire_2770,
		qtlg_wire_2771,
		qtlg_wire_2772,
		qtlg_wire_2773,
		qtlg_wire_2774,
		qtlg_wire_2775,
		qtlg_wire_2776,
		qtlg_wire_2777,
		qtlg_wire_2778,
		qtlg_wire_2779,
		qtlg_wire_2780,
		qtlg_wire_2781,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][2],
		qtlg_wire_2782,
		qtlg_wire_2783}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_2784,
		qtlg_wire_2785,
		qtlg_wire_2786,
		qtlg_wire_2787,
		qtlg_wire_2788,
		qtlg_wire_2789,
		qtlg_wire_2790,
		qtlg_wire_2791,
		qtlg_wire_2792,
		qtlg_wire_2793,
		qtlg_wire_2794,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][3],
		qtlg_wire_2795,
		qtlg_wire_2796,
		qtlg_wire_2797}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_2798,
		qtlg_wire_2799,
		qtlg_wire_2800,
		qtlg_wire_2801,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][15],
		qtlg_wire_2802,
		qtlg_wire_2803,
		qtlg_wire_2804,
		qtlg_wire_2805,
		qtlg_wire_2806,
		qtlg_wire_2807,
		qtlg_wire_2808,
		qtlg_wire_2809,
		qtlg_wire_2810,
		qtlg_wire_2811,
		qtlg_wire_2812,
		qtlg_wire_2813,
		qtlg_wire_2814,
		qtlg_wire_2815,
		qtlg_wire_2816}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_2817,
		qtlg_wire_2818,
		qtlg_wire_2819,
		qtlg_wire_2820,
		qtlg_wire_2821,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][9],
		qtlg_wire_2822,
		qtlg_wire_2823,
		qtlg_wire_2824,
		qtlg_wire_2825,
		qtlg_wire_2826,
		qtlg_wire_2827,
		qtlg_wire_2828,
		qtlg_wire_2829,
		qtlg_wire_2830}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[18]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][16],
		qtlg_wire_2831,
		qtlg_wire_2832,
		qtlg_wire_2833,
		qtlg_wire_2834,
		qtlg_wire_2835,
		qtlg_wire_2836,
		qtlg_wire_2837,
		qtlg_wire_2838,
		qtlg_wire_2839,
		qtlg_wire_2840,
		qtlg_wire_2841,
		qtlg_wire_2842,
		qtlg_wire_2843,
		qtlg_wire_2844,
		qtlg_wire_2845,
		qtlg_wire_2846}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[18][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[18]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_2847}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_2848}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[18]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_2849,
		qtlg_wire_2850,
		qtlg_wire_2851,
		qtlg_wire_2852,
		qtlg_wire_2853,
		qtlg_wire_2854,
		qtlg_wire_2855,
		qtlg_wire_2856,
		qtlg_wire_2857,
		qtlg_wire_2858,
		qtlg_wire_2859,
		qtlg_wire_2860,
		qtlg_wire_2861,
		qtlg_wire_2862,
		qtlg_wire_2863,
		qtlg_wire_2864,
		qtlg_wire_2865,
		qtlg_wire_2866,
		qtlg_wire_2867,
		qtlg_wire_2868,
		qtlg_wire_2869,
		qtlg_wire_2870,
		qtlg_wire_2871,
		qtlg_wire_2872,
		qtlg_wire_2873,
		qtlg_wire_2874,
		qtlg_wire_2875,
		qtlg_wire_2876,
		qtlg_wire_2877,
		qtlg_wire_2878,
		qtlg_wire_2879,
		qtlg_wire_2880,
		qtlg_wire_2881,
		qtlg_wire_2882,
		qtlg_wire_2883,
		qtlg_wire_2884,
		qtlg_wire_2885,
		qtlg_wire_2886,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[18][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_2887,
		qtlg_wire_2888}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_2889}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_2890}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_2891}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_2892,
		qtlg_wire_2893,
		qtlg_wire_2894,
		qtlg_wire_2895}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_2896}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[18]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[18][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[18][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[18][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[18][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[18]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_2897,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[18]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_2898,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[18]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_2899,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[18]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_2900}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_2901}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_2902}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_2903}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[18]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[18][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_2904,
		qtlg_wire_2905,
		qtlg_wire_2906,
		qtlg_wire_2907,
		qtlg_wire_2908}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_2909}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_2910}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[18]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_2911,
		qtlg_wire_2912,
		qtlg_wire_2913,
		qtlg_wire_2914,
		qtlg_wire_2915,
		qtlg_wire_2916,
		qtlg_wire_2917,
		qtlg_wire_2918,
		qtlg_wire_2919,
		qtlg_wire_2920,
		qtlg_wire_2921,
		qtlg_wire_2922,
		qtlg_wire_2923,
		qtlg_wire_2924,
		qtlg_wire_2925,
		qtlg_wire_2926,
		qtlg_wire_2927,
		qtlg_wire_2928,
		qtlg_wire_2929,
		qtlg_wire_2930,
		qtlg_wire_2931,
		qtlg_wire_2932,
		qtlg_wire_2933,
		qtlg_wire_2934,
		qtlg_wire_2935,
		qtlg_wire_2936,
		qtlg_wire_2937,
		qtlg_wire_2938,
		qtlg_wire_2939,
		qtlg_wire_2940,
		qtlg_wire_2941,
		qtlg_wire_2942,
		qtlg_wire_2943,
		qtlg_wire_2944,
		qtlg_wire_2945,
		qtlg_wire_2946,
		qtlg_wire_2947,
		qtlg_wire_2948,
		qtlg_wire_2949,
		qtlg_wire_2950,
		qtlg_wire_2951,
		qtlg_wire_2952,
		qtlg_wire_2953,
		qtlg_wire_2954,
		qtlg_wire_2955,
		qtlg_wire_2956,
		qtlg_wire_2957,
		qtlg_wire_2958,
		qtlg_wire_2959,
		qtlg_wire_2960,
		qtlg_wire_2961,
		qtlg_wire_2962,
		qtlg_wire_2963,
		qtlg_wire_2964,
		qtlg_wire_2965,
		qtlg_wire_2966,
		qtlg_wire_2967,
		qtlg_wire_2968,
		qtlg_wire_2969,
		qtlg_wire_2970,
		qtlg_wire_2971,
		qtlg_wire_2972,
		qtlg_wire_2973,
		qtlg_wire_2974,
		qtlg_wire_2975,
		qtlg_wire_2976,
		qtlg_wire_2977,
		qtlg_wire_2978,
		qtlg_wire_2979,
		qtlg_wire_2980,
		qtlg_wire_2981,
		qtlg_wire_2982,
		qtlg_wire_2983,
		qtlg_wire_2984,
		qtlg_wire_2985,
		qtlg_wire_2986,
		qtlg_wire_2987,
		qtlg_wire_2988,
		qtlg_wire_2989,
		qtlg_wire_2990}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_2991}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_2992}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_2993}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_2994}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_2995,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[18]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_2996}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_2997}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_2998}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_2999}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(19),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_3000}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_3001}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[19]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[19]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[19]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_3002,
		qtlg_wire_3003,
		qtlg_wire_3004,
		qtlg_wire_3005,
		qtlg_wire_3006,
		qtlg_wire_3007,
		qtlg_wire_3008,
		qtlg_wire_3009,
		qtlg_wire_3010,
		qtlg_wire_3011,
		qtlg_wire_3012,
		qtlg_wire_3013,
		qtlg_wire_3014,
		qtlg_wire_3015,
		qtlg_wire_3016,
		qtlg_wire_3017,
		qtlg_wire_3018,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][2],
		qtlg_wire_3019,
		qtlg_wire_3020}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_3021,
		qtlg_wire_3022,
		qtlg_wire_3023,
		qtlg_wire_3024,
		qtlg_wire_3025,
		qtlg_wire_3026,
		qtlg_wire_3027,
		qtlg_wire_3028,
		qtlg_wire_3029,
		qtlg_wire_3030,
		qtlg_wire_3031,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][3],
		qtlg_wire_3032,
		qtlg_wire_3033,
		qtlg_wire_3034}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_3035,
		qtlg_wire_3036,
		qtlg_wire_3037,
		qtlg_wire_3038,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][15],
		qtlg_wire_3039,
		qtlg_wire_3040,
		qtlg_wire_3041,
		qtlg_wire_3042,
		qtlg_wire_3043,
		qtlg_wire_3044,
		qtlg_wire_3045,
		qtlg_wire_3046,
		qtlg_wire_3047,
		qtlg_wire_3048,
		qtlg_wire_3049,
		qtlg_wire_3050,
		qtlg_wire_3051,
		qtlg_wire_3052,
		qtlg_wire_3053}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_3054,
		qtlg_wire_3055,
		qtlg_wire_3056,
		qtlg_wire_3057,
		qtlg_wire_3058,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][9],
		qtlg_wire_3059,
		qtlg_wire_3060,
		qtlg_wire_3061,
		qtlg_wire_3062,
		qtlg_wire_3063,
		qtlg_wire_3064,
		qtlg_wire_3065,
		qtlg_wire_3066,
		qtlg_wire_3067}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[19]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][16],
		qtlg_wire_3068,
		qtlg_wire_3069,
		qtlg_wire_3070,
		qtlg_wire_3071,
		qtlg_wire_3072,
		qtlg_wire_3073,
		qtlg_wire_3074,
		qtlg_wire_3075,
		qtlg_wire_3076,
		qtlg_wire_3077,
		qtlg_wire_3078,
		qtlg_wire_3079,
		qtlg_wire_3080,
		qtlg_wire_3081,
		qtlg_wire_3082,
		qtlg_wire_3083}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[19][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[19]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_3084}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_3085}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[19]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_3086,
		qtlg_wire_3087,
		qtlg_wire_3088,
		qtlg_wire_3089,
		qtlg_wire_3090,
		qtlg_wire_3091,
		qtlg_wire_3092,
		qtlg_wire_3093,
		qtlg_wire_3094,
		qtlg_wire_3095,
		qtlg_wire_3096,
		qtlg_wire_3097,
		qtlg_wire_3098,
		qtlg_wire_3099,
		qtlg_wire_3100,
		qtlg_wire_3101,
		qtlg_wire_3102,
		qtlg_wire_3103,
		qtlg_wire_3104,
		qtlg_wire_3105,
		qtlg_wire_3106,
		qtlg_wire_3107,
		qtlg_wire_3108,
		qtlg_wire_3109,
		qtlg_wire_3110,
		qtlg_wire_3111,
		qtlg_wire_3112,
		qtlg_wire_3113,
		qtlg_wire_3114,
		qtlg_wire_3115,
		qtlg_wire_3116,
		qtlg_wire_3117,
		qtlg_wire_3118,
		qtlg_wire_3119,
		qtlg_wire_3120,
		qtlg_wire_3121,
		qtlg_wire_3122,
		qtlg_wire_3123,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[19][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_3124,
		qtlg_wire_3125}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_3126}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_3127}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_3128}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_3129,
		qtlg_wire_3130,
		qtlg_wire_3131,
		qtlg_wire_3132}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_3133}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[19]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[19][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[19][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[19][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[19][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[19]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_3134,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[19]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_3135,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[19]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_3136,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[19]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_3137}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_3138}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_3139}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_3140}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[19]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[19][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_3141,
		qtlg_wire_3142,
		qtlg_wire_3143,
		qtlg_wire_3144,
		qtlg_wire_3145}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_3146}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_3147}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[19]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_3148,
		qtlg_wire_3149,
		qtlg_wire_3150,
		qtlg_wire_3151,
		qtlg_wire_3152,
		qtlg_wire_3153,
		qtlg_wire_3154,
		qtlg_wire_3155,
		qtlg_wire_3156,
		qtlg_wire_3157,
		qtlg_wire_3158,
		qtlg_wire_3159,
		qtlg_wire_3160,
		qtlg_wire_3161,
		qtlg_wire_3162,
		qtlg_wire_3163,
		qtlg_wire_3164,
		qtlg_wire_3165,
		qtlg_wire_3166,
		qtlg_wire_3167,
		qtlg_wire_3168,
		qtlg_wire_3169,
		qtlg_wire_3170,
		qtlg_wire_3171,
		qtlg_wire_3172,
		qtlg_wire_3173,
		qtlg_wire_3174,
		qtlg_wire_3175,
		qtlg_wire_3176,
		qtlg_wire_3177,
		qtlg_wire_3178,
		qtlg_wire_3179,
		qtlg_wire_3180,
		qtlg_wire_3181,
		qtlg_wire_3182,
		qtlg_wire_3183,
		qtlg_wire_3184,
		qtlg_wire_3185,
		qtlg_wire_3186,
		qtlg_wire_3187,
		qtlg_wire_3188,
		qtlg_wire_3189,
		qtlg_wire_3190,
		qtlg_wire_3191,
		qtlg_wire_3192,
		qtlg_wire_3193,
		qtlg_wire_3194,
		qtlg_wire_3195,
		qtlg_wire_3196,
		qtlg_wire_3197,
		qtlg_wire_3198,
		qtlg_wire_3199,
		qtlg_wire_3200,
		qtlg_wire_3201,
		qtlg_wire_3202,
		qtlg_wire_3203,
		qtlg_wire_3204,
		qtlg_wire_3205,
		qtlg_wire_3206,
		qtlg_wire_3207,
		qtlg_wire_3208,
		qtlg_wire_3209,
		qtlg_wire_3210,
		qtlg_wire_3211,
		qtlg_wire_3212,
		qtlg_wire_3213,
		qtlg_wire_3214,
		qtlg_wire_3215,
		qtlg_wire_3216,
		qtlg_wire_3217,
		qtlg_wire_3218,
		qtlg_wire_3219,
		qtlg_wire_3220,
		qtlg_wire_3221,
		qtlg_wire_3222,
		qtlg_wire_3223,
		qtlg_wire_3224,
		qtlg_wire_3225,
		qtlg_wire_3226,
		qtlg_wire_3227}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_3228}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_3229}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_3230}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_3231}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_3232,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[19]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_3233}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_3234}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_3235}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_3236}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[2]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[2]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[2]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_3237,
		qtlg_wire_3238,
		qtlg_wire_3239,
		qtlg_wire_3240,
		qtlg_wire_3241,
		qtlg_wire_3242,
		qtlg_wire_3243,
		qtlg_wire_3244,
		qtlg_wire_3245,
		qtlg_wire_3246,
		qtlg_wire_3247,
		qtlg_wire_3248,
		qtlg_wire_3249,
		qtlg_wire_3250,
		qtlg_wire_3251,
		qtlg_wire_3252,
		qtlg_wire_3253,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][2],
		qtlg_wire_3254,
		qtlg_wire_3255}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_3256,
		qtlg_wire_3257,
		qtlg_wire_3258,
		qtlg_wire_3259,
		qtlg_wire_3260,
		qtlg_wire_3261,
		qtlg_wire_3262,
		qtlg_wire_3263,
		qtlg_wire_3264,
		qtlg_wire_3265,
		qtlg_wire_3266,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][3],
		qtlg_wire_3267,
		qtlg_wire_3268,
		qtlg_wire_3269}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_3270,
		qtlg_wire_3271,
		qtlg_wire_3272,
		qtlg_wire_3273,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][15],
		qtlg_wire_3274,
		qtlg_wire_3275,
		qtlg_wire_3276,
		qtlg_wire_3277,
		qtlg_wire_3278,
		qtlg_wire_3279,
		qtlg_wire_3280,
		qtlg_wire_3281,
		qtlg_wire_3282,
		qtlg_wire_3283,
		qtlg_wire_3284,
		qtlg_wire_3285,
		qtlg_wire_3286,
		qtlg_wire_3287,
		qtlg_wire_3288}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_3289,
		qtlg_wire_3290,
		qtlg_wire_3291,
		qtlg_wire_3292,
		qtlg_wire_3293,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][9],
		qtlg_wire_3294,
		qtlg_wire_3295,
		qtlg_wire_3296,
		qtlg_wire_3297,
		qtlg_wire_3298,
		qtlg_wire_3299,
		qtlg_wire_3300,
		qtlg_wire_3301,
		qtlg_wire_3302}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[2]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][16],
		qtlg_wire_3303,
		qtlg_wire_3304,
		qtlg_wire_3305,
		qtlg_wire_3306,
		qtlg_wire_3307,
		qtlg_wire_3308,
		qtlg_wire_3309,
		qtlg_wire_3310,
		qtlg_wire_3311,
		qtlg_wire_3312,
		qtlg_wire_3313,
		qtlg_wire_3314,
		qtlg_wire_3315,
		qtlg_wire_3316,
		qtlg_wire_3317,
		qtlg_wire_3318}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[2][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[2]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_3319}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[2]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_3320}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_3321,
		qtlg_wire_3322,
		qtlg_wire_3323,
		qtlg_wire_3324,
		qtlg_wire_3325,
		qtlg_wire_3326,
		qtlg_wire_3327,
		qtlg_wire_3328,
		qtlg_wire_3329,
		qtlg_wire_3330,
		qtlg_wire_3331,
		qtlg_wire_3332,
		qtlg_wire_3333,
		qtlg_wire_3334,
		qtlg_wire_3335,
		qtlg_wire_3336,
		qtlg_wire_3337,
		qtlg_wire_3338,
		qtlg_wire_3339,
		qtlg_wire_3340,
		qtlg_wire_3341,
		qtlg_wire_3342,
		qtlg_wire_3343,
		qtlg_wire_3344,
		qtlg_wire_3345,
		qtlg_wire_3346,
		qtlg_wire_3347,
		qtlg_wire_3348,
		qtlg_wire_3349,
		qtlg_wire_3350,
		qtlg_wire_3351,
		qtlg_wire_3352,
		qtlg_wire_3353,
		qtlg_wire_3354,
		qtlg_wire_3355,
		qtlg_wire_3356,
		qtlg_wire_3357,
		qtlg_wire_3358,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[2][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[2]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[2][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[2][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[2][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[2][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[2]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[2]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[2]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[2]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[2]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[2][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[2]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[2]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(20),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_3359}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_3360}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[20]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[20]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[20]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_3361,
		qtlg_wire_3362,
		qtlg_wire_3363,
		qtlg_wire_3364,
		qtlg_wire_3365,
		qtlg_wire_3366,
		qtlg_wire_3367,
		qtlg_wire_3368,
		qtlg_wire_3369,
		qtlg_wire_3370,
		qtlg_wire_3371,
		qtlg_wire_3372,
		qtlg_wire_3373,
		qtlg_wire_3374,
		qtlg_wire_3375,
		qtlg_wire_3376,
		qtlg_wire_3377,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][2],
		qtlg_wire_3378,
		qtlg_wire_3379}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_3380,
		qtlg_wire_3381,
		qtlg_wire_3382,
		qtlg_wire_3383,
		qtlg_wire_3384,
		qtlg_wire_3385,
		qtlg_wire_3386,
		qtlg_wire_3387,
		qtlg_wire_3388,
		qtlg_wire_3389,
		qtlg_wire_3390,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][3],
		qtlg_wire_3391,
		qtlg_wire_3392,
		qtlg_wire_3393}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_3394,
		qtlg_wire_3395,
		qtlg_wire_3396,
		qtlg_wire_3397,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][15],
		qtlg_wire_3398,
		qtlg_wire_3399,
		qtlg_wire_3400,
		qtlg_wire_3401,
		qtlg_wire_3402,
		qtlg_wire_3403,
		qtlg_wire_3404,
		qtlg_wire_3405,
		qtlg_wire_3406,
		qtlg_wire_3407,
		qtlg_wire_3408,
		qtlg_wire_3409,
		qtlg_wire_3410,
		qtlg_wire_3411,
		qtlg_wire_3412}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_3413,
		qtlg_wire_3414,
		qtlg_wire_3415,
		qtlg_wire_3416,
		qtlg_wire_3417,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][9],
		qtlg_wire_3418,
		qtlg_wire_3419,
		qtlg_wire_3420,
		qtlg_wire_3421,
		qtlg_wire_3422,
		qtlg_wire_3423,
		qtlg_wire_3424,
		qtlg_wire_3425,
		qtlg_wire_3426}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[20]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][16],
		qtlg_wire_3427,
		qtlg_wire_3428,
		qtlg_wire_3429,
		qtlg_wire_3430,
		qtlg_wire_3431,
		qtlg_wire_3432,
		qtlg_wire_3433,
		qtlg_wire_3434,
		qtlg_wire_3435,
		qtlg_wire_3436,
		qtlg_wire_3437,
		qtlg_wire_3438,
		qtlg_wire_3439,
		qtlg_wire_3440,
		qtlg_wire_3441,
		qtlg_wire_3442}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[20][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[20]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_3443}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_3444}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[20]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_3445,
		qtlg_wire_3446,
		qtlg_wire_3447,
		qtlg_wire_3448,
		qtlg_wire_3449,
		qtlg_wire_3450,
		qtlg_wire_3451,
		qtlg_wire_3452,
		qtlg_wire_3453,
		qtlg_wire_3454,
		qtlg_wire_3455,
		qtlg_wire_3456,
		qtlg_wire_3457,
		qtlg_wire_3458,
		qtlg_wire_3459,
		qtlg_wire_3460,
		qtlg_wire_3461,
		qtlg_wire_3462,
		qtlg_wire_3463,
		qtlg_wire_3464,
		qtlg_wire_3465,
		qtlg_wire_3466,
		qtlg_wire_3467,
		qtlg_wire_3468,
		qtlg_wire_3469,
		qtlg_wire_3470,
		qtlg_wire_3471,
		qtlg_wire_3472,
		qtlg_wire_3473,
		qtlg_wire_3474,
		qtlg_wire_3475,
		qtlg_wire_3476,
		qtlg_wire_3477,
		qtlg_wire_3478,
		qtlg_wire_3479,
		qtlg_wire_3480,
		qtlg_wire_3481,
		qtlg_wire_3482,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[20][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_3483,
		qtlg_wire_3484}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_3485}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_3486}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_3487}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_3488,
		qtlg_wire_3489,
		qtlg_wire_3490,
		qtlg_wire_3491}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_3492}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[20]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[20][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[20][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[20][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[20][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[20]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_3493,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[20]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_3494,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[20]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_3495,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[20]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_3496}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_3497}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_3498}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_3499}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[20]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[20][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_3500,
		qtlg_wire_3501,
		qtlg_wire_3502,
		qtlg_wire_3503,
		qtlg_wire_3504}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_3505}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_3506}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[20]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_3507,
		qtlg_wire_3508,
		qtlg_wire_3509,
		qtlg_wire_3510,
		qtlg_wire_3511,
		qtlg_wire_3512,
		qtlg_wire_3513,
		qtlg_wire_3514,
		qtlg_wire_3515,
		qtlg_wire_3516,
		qtlg_wire_3517,
		qtlg_wire_3518,
		qtlg_wire_3519,
		qtlg_wire_3520,
		qtlg_wire_3521,
		qtlg_wire_3522,
		qtlg_wire_3523,
		qtlg_wire_3524,
		qtlg_wire_3525,
		qtlg_wire_3526,
		qtlg_wire_3527,
		qtlg_wire_3528,
		qtlg_wire_3529,
		qtlg_wire_3530,
		qtlg_wire_3531,
		qtlg_wire_3532,
		qtlg_wire_3533,
		qtlg_wire_3534,
		qtlg_wire_3535,
		qtlg_wire_3536,
		qtlg_wire_3537,
		qtlg_wire_3538,
		qtlg_wire_3539,
		qtlg_wire_3540,
		qtlg_wire_3541,
		qtlg_wire_3542,
		qtlg_wire_3543,
		qtlg_wire_3544,
		qtlg_wire_3545,
		qtlg_wire_3546,
		qtlg_wire_3547,
		qtlg_wire_3548,
		qtlg_wire_3549,
		qtlg_wire_3550,
		qtlg_wire_3551,
		qtlg_wire_3552,
		qtlg_wire_3553,
		qtlg_wire_3554,
		qtlg_wire_3555,
		qtlg_wire_3556,
		qtlg_wire_3557,
		qtlg_wire_3558,
		qtlg_wire_3559,
		qtlg_wire_3560,
		qtlg_wire_3561,
		qtlg_wire_3562,
		qtlg_wire_3563,
		qtlg_wire_3564,
		qtlg_wire_3565,
		qtlg_wire_3566,
		qtlg_wire_3567,
		qtlg_wire_3568,
		qtlg_wire_3569,
		qtlg_wire_3570,
		qtlg_wire_3571,
		qtlg_wire_3572,
		qtlg_wire_3573,
		qtlg_wire_3574,
		qtlg_wire_3575,
		qtlg_wire_3576,
		qtlg_wire_3577,
		qtlg_wire_3578,
		qtlg_wire_3579,
		qtlg_wire_3580,
		qtlg_wire_3581,
		qtlg_wire_3582,
		qtlg_wire_3583,
		qtlg_wire_3584,
		qtlg_wire_3585,
		qtlg_wire_3586}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_3587}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_3588}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_3589}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_3590}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_3591,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[20]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_3592}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_3593}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_3594}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_3595}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(21),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_3596}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_3597}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[21]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[21]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[21]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_3598,
		qtlg_wire_3599,
		qtlg_wire_3600,
		qtlg_wire_3601,
		qtlg_wire_3602,
		qtlg_wire_3603,
		qtlg_wire_3604,
		qtlg_wire_3605,
		qtlg_wire_3606,
		qtlg_wire_3607,
		qtlg_wire_3608,
		qtlg_wire_3609,
		qtlg_wire_3610,
		qtlg_wire_3611,
		qtlg_wire_3612,
		qtlg_wire_3613,
		qtlg_wire_3614,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][2],
		qtlg_wire_3615,
		qtlg_wire_3616}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_3617,
		qtlg_wire_3618,
		qtlg_wire_3619,
		qtlg_wire_3620,
		qtlg_wire_3621,
		qtlg_wire_3622,
		qtlg_wire_3623,
		qtlg_wire_3624,
		qtlg_wire_3625,
		qtlg_wire_3626,
		qtlg_wire_3627,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][3],
		qtlg_wire_3628,
		qtlg_wire_3629,
		qtlg_wire_3630}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_3631,
		qtlg_wire_3632,
		qtlg_wire_3633,
		qtlg_wire_3634,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][15],
		qtlg_wire_3635,
		qtlg_wire_3636,
		qtlg_wire_3637,
		qtlg_wire_3638,
		qtlg_wire_3639,
		qtlg_wire_3640,
		qtlg_wire_3641,
		qtlg_wire_3642,
		qtlg_wire_3643,
		qtlg_wire_3644,
		qtlg_wire_3645,
		qtlg_wire_3646,
		qtlg_wire_3647,
		qtlg_wire_3648,
		qtlg_wire_3649}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_3650,
		qtlg_wire_3651,
		qtlg_wire_3652,
		qtlg_wire_3653,
		qtlg_wire_3654,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][9],
		qtlg_wire_3655,
		qtlg_wire_3656,
		qtlg_wire_3657,
		qtlg_wire_3658,
		qtlg_wire_3659,
		qtlg_wire_3660,
		qtlg_wire_3661,
		qtlg_wire_3662,
		qtlg_wire_3663}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[21]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][16],
		qtlg_wire_3664,
		qtlg_wire_3665,
		qtlg_wire_3666,
		qtlg_wire_3667,
		qtlg_wire_3668,
		qtlg_wire_3669,
		qtlg_wire_3670,
		qtlg_wire_3671,
		qtlg_wire_3672,
		qtlg_wire_3673,
		qtlg_wire_3674,
		qtlg_wire_3675,
		qtlg_wire_3676,
		qtlg_wire_3677,
		qtlg_wire_3678,
		qtlg_wire_3679}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[21][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[21]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_3680}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_3681}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[21]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_3682,
		qtlg_wire_3683,
		qtlg_wire_3684,
		qtlg_wire_3685,
		qtlg_wire_3686,
		qtlg_wire_3687,
		qtlg_wire_3688,
		qtlg_wire_3689,
		qtlg_wire_3690,
		qtlg_wire_3691,
		qtlg_wire_3692,
		qtlg_wire_3693,
		qtlg_wire_3694,
		qtlg_wire_3695,
		qtlg_wire_3696,
		qtlg_wire_3697,
		qtlg_wire_3698,
		qtlg_wire_3699,
		qtlg_wire_3700,
		qtlg_wire_3701,
		qtlg_wire_3702,
		qtlg_wire_3703,
		qtlg_wire_3704,
		qtlg_wire_3705,
		qtlg_wire_3706,
		qtlg_wire_3707,
		qtlg_wire_3708,
		qtlg_wire_3709,
		qtlg_wire_3710,
		qtlg_wire_3711,
		qtlg_wire_3712,
		qtlg_wire_3713,
		qtlg_wire_3714,
		qtlg_wire_3715,
		qtlg_wire_3716,
		qtlg_wire_3717,
		qtlg_wire_3718,
		qtlg_wire_3719,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[21][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_3720,
		qtlg_wire_3721}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_3722}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_3723}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_3724}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_3725,
		qtlg_wire_3726,
		qtlg_wire_3727,
		qtlg_wire_3728}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_3729}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[21]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[21][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[21][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[21][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[21][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[21]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_3730,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[21]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_3731,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[21]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_3732,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[21]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_3733}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_3734}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_3735}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_3736}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[21]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[21][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_3737,
		qtlg_wire_3738,
		qtlg_wire_3739,
		qtlg_wire_3740,
		qtlg_wire_3741}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_3742}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_3743}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[21]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_3744,
		qtlg_wire_3745,
		qtlg_wire_3746,
		qtlg_wire_3747,
		qtlg_wire_3748,
		qtlg_wire_3749,
		qtlg_wire_3750,
		qtlg_wire_3751,
		qtlg_wire_3752,
		qtlg_wire_3753,
		qtlg_wire_3754,
		qtlg_wire_3755,
		qtlg_wire_3756,
		qtlg_wire_3757,
		qtlg_wire_3758,
		qtlg_wire_3759,
		qtlg_wire_3760,
		qtlg_wire_3761,
		qtlg_wire_3762,
		qtlg_wire_3763,
		qtlg_wire_3764,
		qtlg_wire_3765,
		qtlg_wire_3766,
		qtlg_wire_3767,
		qtlg_wire_3768,
		qtlg_wire_3769,
		qtlg_wire_3770,
		qtlg_wire_3771,
		qtlg_wire_3772,
		qtlg_wire_3773,
		qtlg_wire_3774,
		qtlg_wire_3775,
		qtlg_wire_3776,
		qtlg_wire_3777,
		qtlg_wire_3778,
		qtlg_wire_3779,
		qtlg_wire_3780,
		qtlg_wire_3781,
		qtlg_wire_3782,
		qtlg_wire_3783,
		qtlg_wire_3784,
		qtlg_wire_3785,
		qtlg_wire_3786,
		qtlg_wire_3787,
		qtlg_wire_3788,
		qtlg_wire_3789,
		qtlg_wire_3790,
		qtlg_wire_3791,
		qtlg_wire_3792,
		qtlg_wire_3793,
		qtlg_wire_3794,
		qtlg_wire_3795,
		qtlg_wire_3796,
		qtlg_wire_3797,
		qtlg_wire_3798,
		qtlg_wire_3799,
		qtlg_wire_3800,
		qtlg_wire_3801,
		qtlg_wire_3802,
		qtlg_wire_3803,
		qtlg_wire_3804,
		qtlg_wire_3805,
		qtlg_wire_3806,
		qtlg_wire_3807,
		qtlg_wire_3808,
		qtlg_wire_3809,
		qtlg_wire_3810,
		qtlg_wire_3811,
		qtlg_wire_3812,
		qtlg_wire_3813,
		qtlg_wire_3814,
		qtlg_wire_3815,
		qtlg_wire_3816,
		qtlg_wire_3817,
		qtlg_wire_3818,
		qtlg_wire_3819,
		qtlg_wire_3820,
		qtlg_wire_3821,
		qtlg_wire_3822,
		qtlg_wire_3823}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_3824}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_3825}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_3826}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_3827}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_3828,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[21]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_3829}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_3830}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_3831}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_3832}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(22),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_3833}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_3834}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[22]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[22]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[22]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_3835,
		qtlg_wire_3836,
		qtlg_wire_3837,
		qtlg_wire_3838,
		qtlg_wire_3839,
		qtlg_wire_3840,
		qtlg_wire_3841,
		qtlg_wire_3842,
		qtlg_wire_3843,
		qtlg_wire_3844,
		qtlg_wire_3845,
		qtlg_wire_3846,
		qtlg_wire_3847,
		qtlg_wire_3848,
		qtlg_wire_3849,
		qtlg_wire_3850,
		qtlg_wire_3851,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][2],
		qtlg_wire_3852,
		qtlg_wire_3853}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_3854,
		qtlg_wire_3855,
		qtlg_wire_3856,
		qtlg_wire_3857,
		qtlg_wire_3858,
		qtlg_wire_3859,
		qtlg_wire_3860,
		qtlg_wire_3861,
		qtlg_wire_3862,
		qtlg_wire_3863,
		qtlg_wire_3864,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][3],
		qtlg_wire_3865,
		qtlg_wire_3866,
		qtlg_wire_3867}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_3868,
		qtlg_wire_3869,
		qtlg_wire_3870,
		qtlg_wire_3871,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][15],
		qtlg_wire_3872,
		qtlg_wire_3873,
		qtlg_wire_3874,
		qtlg_wire_3875,
		qtlg_wire_3876,
		qtlg_wire_3877,
		qtlg_wire_3878,
		qtlg_wire_3879,
		qtlg_wire_3880,
		qtlg_wire_3881,
		qtlg_wire_3882,
		qtlg_wire_3883,
		qtlg_wire_3884,
		qtlg_wire_3885,
		qtlg_wire_3886}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_3887,
		qtlg_wire_3888,
		qtlg_wire_3889,
		qtlg_wire_3890,
		qtlg_wire_3891,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][9],
		qtlg_wire_3892,
		qtlg_wire_3893,
		qtlg_wire_3894,
		qtlg_wire_3895,
		qtlg_wire_3896,
		qtlg_wire_3897,
		qtlg_wire_3898,
		qtlg_wire_3899,
		qtlg_wire_3900}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[22]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][16],
		qtlg_wire_3901,
		qtlg_wire_3902,
		qtlg_wire_3903,
		qtlg_wire_3904,
		qtlg_wire_3905,
		qtlg_wire_3906,
		qtlg_wire_3907,
		qtlg_wire_3908,
		qtlg_wire_3909,
		qtlg_wire_3910,
		qtlg_wire_3911,
		qtlg_wire_3912,
		qtlg_wire_3913,
		qtlg_wire_3914,
		qtlg_wire_3915,
		qtlg_wire_3916}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[22][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[22]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_3917}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_3918}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[22]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_3919,
		qtlg_wire_3920,
		qtlg_wire_3921,
		qtlg_wire_3922,
		qtlg_wire_3923,
		qtlg_wire_3924,
		qtlg_wire_3925,
		qtlg_wire_3926,
		qtlg_wire_3927,
		qtlg_wire_3928,
		qtlg_wire_3929,
		qtlg_wire_3930,
		qtlg_wire_3931,
		qtlg_wire_3932,
		qtlg_wire_3933,
		qtlg_wire_3934,
		qtlg_wire_3935,
		qtlg_wire_3936,
		qtlg_wire_3937,
		qtlg_wire_3938,
		qtlg_wire_3939,
		qtlg_wire_3940,
		qtlg_wire_3941,
		qtlg_wire_3942,
		qtlg_wire_3943,
		qtlg_wire_3944,
		qtlg_wire_3945,
		qtlg_wire_3946,
		qtlg_wire_3947,
		qtlg_wire_3948,
		qtlg_wire_3949,
		qtlg_wire_3950,
		qtlg_wire_3951,
		qtlg_wire_3952,
		qtlg_wire_3953,
		qtlg_wire_3954,
		qtlg_wire_3955,
		qtlg_wire_3956,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[22][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_3957,
		qtlg_wire_3958}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_3959}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_3960}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_3961}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_3962,
		qtlg_wire_3963,
		qtlg_wire_3964,
		qtlg_wire_3965}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_3966}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[22]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[22][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[22][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[22][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[22][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[22]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_3967,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[22]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_3968,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[22]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_3969,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[22]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_3970}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_3971}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_3972}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_3973}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[22]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[22][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_3974,
		qtlg_wire_3975,
		qtlg_wire_3976,
		qtlg_wire_3977,
		qtlg_wire_3978}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_3979}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_3980}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[22]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_3981,
		qtlg_wire_3982,
		qtlg_wire_3983,
		qtlg_wire_3984,
		qtlg_wire_3985,
		qtlg_wire_3986,
		qtlg_wire_3987,
		qtlg_wire_3988,
		qtlg_wire_3989,
		qtlg_wire_3990,
		qtlg_wire_3991,
		qtlg_wire_3992,
		qtlg_wire_3993,
		qtlg_wire_3994,
		qtlg_wire_3995,
		qtlg_wire_3996,
		qtlg_wire_3997,
		qtlg_wire_3998,
		qtlg_wire_3999,
		qtlg_wire_4000,
		qtlg_wire_4001,
		qtlg_wire_4002,
		qtlg_wire_4003,
		qtlg_wire_4004,
		qtlg_wire_4005,
		qtlg_wire_4006,
		qtlg_wire_4007,
		qtlg_wire_4008,
		qtlg_wire_4009,
		qtlg_wire_4010,
		qtlg_wire_4011,
		qtlg_wire_4012,
		qtlg_wire_4013,
		qtlg_wire_4014,
		qtlg_wire_4015,
		qtlg_wire_4016,
		qtlg_wire_4017,
		qtlg_wire_4018,
		qtlg_wire_4019,
		qtlg_wire_4020,
		qtlg_wire_4021,
		qtlg_wire_4022,
		qtlg_wire_4023,
		qtlg_wire_4024,
		qtlg_wire_4025,
		qtlg_wire_4026,
		qtlg_wire_4027,
		qtlg_wire_4028,
		qtlg_wire_4029,
		qtlg_wire_4030,
		qtlg_wire_4031,
		qtlg_wire_4032,
		qtlg_wire_4033,
		qtlg_wire_4034,
		qtlg_wire_4035,
		qtlg_wire_4036,
		qtlg_wire_4037,
		qtlg_wire_4038,
		qtlg_wire_4039,
		qtlg_wire_4040,
		qtlg_wire_4041,
		qtlg_wire_4042,
		qtlg_wire_4043,
		qtlg_wire_4044,
		qtlg_wire_4045,
		qtlg_wire_4046,
		qtlg_wire_4047,
		qtlg_wire_4048,
		qtlg_wire_4049,
		qtlg_wire_4050,
		qtlg_wire_4051,
		qtlg_wire_4052,
		qtlg_wire_4053,
		qtlg_wire_4054,
		qtlg_wire_4055,
		qtlg_wire_4056,
		qtlg_wire_4057,
		qtlg_wire_4058,
		qtlg_wire_4059,
		qtlg_wire_4060}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_4061}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_4062}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_4063}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_4064}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_4065,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[22]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_4066}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_4067}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_4068}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_4069}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_rxelecidle_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(23),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(1),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_rxelecidle_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_switch_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_4070}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_4071}),
	.intfc_02_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_02_pld_8g_rxelecidle_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[23]),
	.s_intfc_02_pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[23]),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[23]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4072,
		qtlg_wire_4073,
		qtlg_wire_4074,
		qtlg_wire_4075,
		qtlg_wire_4076,
		qtlg_wire_4077,
		qtlg_wire_4078,
		qtlg_wire_4079,
		qtlg_wire_4080,
		qtlg_wire_4081,
		qtlg_wire_4082,
		qtlg_wire_4083,
		qtlg_wire_4084,
		qtlg_wire_4085,
		qtlg_wire_4086,
		qtlg_wire_4087,
		qtlg_wire_4088,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][2],
		qtlg_wire_4089,
		qtlg_wire_4090}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4091,
		qtlg_wire_4092,
		qtlg_wire_4093,
		qtlg_wire_4094,
		qtlg_wire_4095,
		qtlg_wire_4096,
		qtlg_wire_4097,
		qtlg_wire_4098,
		qtlg_wire_4099,
		qtlg_wire_4100,
		qtlg_wire_4101,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][3],
		qtlg_wire_4102,
		qtlg_wire_4103,
		qtlg_wire_4104}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4105,
		qtlg_wire_4106,
		qtlg_wire_4107,
		qtlg_wire_4108,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][15],
		qtlg_wire_4109,
		qtlg_wire_4110,
		qtlg_wire_4111,
		qtlg_wire_4112,
		qtlg_wire_4113,
		qtlg_wire_4114,
		qtlg_wire_4115,
		qtlg_wire_4116,
		qtlg_wire_4117,
		qtlg_wire_4118,
		qtlg_wire_4119,
		qtlg_wire_4120,
		qtlg_wire_4121,
		qtlg_wire_4122,
		qtlg_wire_4123}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4124,
		qtlg_wire_4125,
		qtlg_wire_4126,
		qtlg_wire_4127,
		qtlg_wire_4128,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][9],
		qtlg_wire_4129,
		qtlg_wire_4130,
		qtlg_wire_4131,
		qtlg_wire_4132,
		qtlg_wire_4133,
		qtlg_wire_4134,
		qtlg_wire_4135,
		qtlg_wire_4136,
		qtlg_wire_4137}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[23]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][16],
		qtlg_wire_4138,
		qtlg_wire_4139,
		qtlg_wire_4140,
		qtlg_wire_4141,
		qtlg_wire_4142,
		qtlg_wire_4143,
		qtlg_wire_4144,
		qtlg_wire_4145,
		qtlg_wire_4146,
		qtlg_wire_4147,
		qtlg_wire_4148,
		qtlg_wire_4149,
		qtlg_wire_4150,
		qtlg_wire_4151,
		qtlg_wire_4152,
		qtlg_wire_4153}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[23][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[23]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_4154}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_4155}),
	.s_intfc_15_pld_ltr_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[23]}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_4156,
		qtlg_wire_4157,
		qtlg_wire_4158,
		qtlg_wire_4159,
		qtlg_wire_4160,
		qtlg_wire_4161,
		qtlg_wire_4162,
		qtlg_wire_4163,
		qtlg_wire_4164,
		qtlg_wire_4165,
		qtlg_wire_4166,
		qtlg_wire_4167,
		qtlg_wire_4168,
		qtlg_wire_4169,
		qtlg_wire_4170,
		qtlg_wire_4171,
		qtlg_wire_4172,
		qtlg_wire_4173,
		qtlg_wire_4174,
		qtlg_wire_4175,
		qtlg_wire_4176,
		qtlg_wire_4177,
		qtlg_wire_4178,
		qtlg_wire_4179,
		qtlg_wire_4180,
		qtlg_wire_4181,
		qtlg_wire_4182,
		qtlg_wire_4183,
		qtlg_wire_4184,
		qtlg_wire_4185,
		qtlg_wire_4186,
		qtlg_wire_4187,
		qtlg_wire_4188,
		qtlg_wire_4189,
		qtlg_wire_4190,
		qtlg_wire_4191,
		qtlg_wire_4192,
		qtlg_wire_4193,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[23][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_4194,
		qtlg_wire_4195}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_4196}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_4197}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_4198}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_4199,
		qtlg_wire_4200,
		qtlg_wire_4201,
		qtlg_wire_4202}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_4203}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[23]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[23][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[23][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[23][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[23][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[23]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_4204,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[23]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_4205,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[23]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_4206,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[23]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_4207}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_4208}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_4209}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_4210}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[23]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[23][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_4211,
		qtlg_wire_4212,
		qtlg_wire_4213,
		qtlg_wire_4214,
		qtlg_wire_4215}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_4216}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_4217}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[23]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_4218,
		qtlg_wire_4219,
		qtlg_wire_4220,
		qtlg_wire_4221,
		qtlg_wire_4222,
		qtlg_wire_4223,
		qtlg_wire_4224,
		qtlg_wire_4225,
		qtlg_wire_4226,
		qtlg_wire_4227,
		qtlg_wire_4228,
		qtlg_wire_4229,
		qtlg_wire_4230,
		qtlg_wire_4231,
		qtlg_wire_4232,
		qtlg_wire_4233,
		qtlg_wire_4234,
		qtlg_wire_4235,
		qtlg_wire_4236,
		qtlg_wire_4237,
		qtlg_wire_4238,
		qtlg_wire_4239,
		qtlg_wire_4240,
		qtlg_wire_4241,
		qtlg_wire_4242,
		qtlg_wire_4243,
		qtlg_wire_4244,
		qtlg_wire_4245,
		qtlg_wire_4246,
		qtlg_wire_4247,
		qtlg_wire_4248,
		qtlg_wire_4249,
		qtlg_wire_4250,
		qtlg_wire_4251,
		qtlg_wire_4252,
		qtlg_wire_4253,
		qtlg_wire_4254,
		qtlg_wire_4255,
		qtlg_wire_4256,
		qtlg_wire_4257,
		qtlg_wire_4258,
		qtlg_wire_4259,
		qtlg_wire_4260,
		qtlg_wire_4261,
		qtlg_wire_4262,
		qtlg_wire_4263,
		qtlg_wire_4264,
		qtlg_wire_4265,
		qtlg_wire_4266,
		qtlg_wire_4267,
		qtlg_wire_4268,
		qtlg_wire_4269,
		qtlg_wire_4270,
		qtlg_wire_4271,
		qtlg_wire_4272,
		qtlg_wire_4273,
		qtlg_wire_4274,
		qtlg_wire_4275,
		qtlg_wire_4276,
		qtlg_wire_4277,
		qtlg_wire_4278,
		qtlg_wire_4279,
		qtlg_wire_4280,
		qtlg_wire_4281,
		qtlg_wire_4282,
		qtlg_wire_4283,
		qtlg_wire_4284,
		qtlg_wire_4285,
		qtlg_wire_4286,
		qtlg_wire_4287,
		qtlg_wire_4288,
		qtlg_wire_4289,
		qtlg_wire_4290,
		qtlg_wire_4291,
		qtlg_wire_4292,
		qtlg_wire_4293,
		qtlg_wire_4294,
		qtlg_wire_4295,
		qtlg_wire_4296,
		qtlg_wire_4297}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_4298}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_4299}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_4300}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_4301}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_4302,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[23]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_4303}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_4304}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_4305}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_4306}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(3),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[3]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[3]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[3]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4307,
		qtlg_wire_4308,
		qtlg_wire_4309,
		qtlg_wire_4310,
		qtlg_wire_4311,
		qtlg_wire_4312,
		qtlg_wire_4313,
		qtlg_wire_4314,
		qtlg_wire_4315,
		qtlg_wire_4316,
		qtlg_wire_4317,
		qtlg_wire_4318,
		qtlg_wire_4319,
		qtlg_wire_4320,
		qtlg_wire_4321,
		qtlg_wire_4322,
		qtlg_wire_4323,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][2],
		qtlg_wire_4324,
		qtlg_wire_4325}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4326,
		qtlg_wire_4327,
		qtlg_wire_4328,
		qtlg_wire_4329,
		qtlg_wire_4330,
		qtlg_wire_4331,
		qtlg_wire_4332,
		qtlg_wire_4333,
		qtlg_wire_4334,
		qtlg_wire_4335,
		qtlg_wire_4336,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][3],
		qtlg_wire_4337,
		qtlg_wire_4338,
		qtlg_wire_4339}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4340,
		qtlg_wire_4341,
		qtlg_wire_4342,
		qtlg_wire_4343,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][15],
		qtlg_wire_4344,
		qtlg_wire_4345,
		qtlg_wire_4346,
		qtlg_wire_4347,
		qtlg_wire_4348,
		qtlg_wire_4349,
		qtlg_wire_4350,
		qtlg_wire_4351,
		qtlg_wire_4352,
		qtlg_wire_4353,
		qtlg_wire_4354,
		qtlg_wire_4355,
		qtlg_wire_4356,
		qtlg_wire_4357,
		qtlg_wire_4358}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4359,
		qtlg_wire_4360,
		qtlg_wire_4361,
		qtlg_wire_4362,
		qtlg_wire_4363,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][9],
		qtlg_wire_4364,
		qtlg_wire_4365,
		qtlg_wire_4366,
		qtlg_wire_4367,
		qtlg_wire_4368,
		qtlg_wire_4369,
		qtlg_wire_4370,
		qtlg_wire_4371,
		qtlg_wire_4372}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[3]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][16],
		qtlg_wire_4373,
		qtlg_wire_4374,
		qtlg_wire_4375,
		qtlg_wire_4376,
		qtlg_wire_4377,
		qtlg_wire_4378,
		qtlg_wire_4379,
		qtlg_wire_4380,
		qtlg_wire_4381,
		qtlg_wire_4382,
		qtlg_wire_4383,
		qtlg_wire_4384,
		qtlg_wire_4385,
		qtlg_wire_4386,
		qtlg_wire_4387,
		qtlg_wire_4388}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[3][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[3]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_4389}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[3]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_4390}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_4391,
		qtlg_wire_4392,
		qtlg_wire_4393,
		qtlg_wire_4394,
		qtlg_wire_4395,
		qtlg_wire_4396,
		qtlg_wire_4397,
		qtlg_wire_4398,
		qtlg_wire_4399,
		qtlg_wire_4400,
		qtlg_wire_4401,
		qtlg_wire_4402,
		qtlg_wire_4403,
		qtlg_wire_4404,
		qtlg_wire_4405,
		qtlg_wire_4406,
		qtlg_wire_4407,
		qtlg_wire_4408,
		qtlg_wire_4409,
		qtlg_wire_4410,
		qtlg_wire_4411,
		qtlg_wire_4412,
		qtlg_wire_4413,
		qtlg_wire_4414,
		qtlg_wire_4415,
		qtlg_wire_4416,
		qtlg_wire_4417,
		qtlg_wire_4418,
		qtlg_wire_4419,
		qtlg_wire_4420,
		qtlg_wire_4421,
		qtlg_wire_4422,
		qtlg_wire_4423,
		qtlg_wire_4424,
		qtlg_wire_4425,
		qtlg_wire_4426,
		qtlg_wire_4427,
		qtlg_wire_4428,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[3][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[3]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[3][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[3][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[3][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[3][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[3]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[3]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[3]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[3]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[3]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[3][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[3]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[3]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(4),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[4]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[4]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[4]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4429,
		qtlg_wire_4430,
		qtlg_wire_4431,
		qtlg_wire_4432,
		qtlg_wire_4433,
		qtlg_wire_4434,
		qtlg_wire_4435,
		qtlg_wire_4436,
		qtlg_wire_4437,
		qtlg_wire_4438,
		qtlg_wire_4439,
		qtlg_wire_4440,
		qtlg_wire_4441,
		qtlg_wire_4442,
		qtlg_wire_4443,
		qtlg_wire_4444,
		qtlg_wire_4445,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][2],
		qtlg_wire_4446,
		qtlg_wire_4447}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4448,
		qtlg_wire_4449,
		qtlg_wire_4450,
		qtlg_wire_4451,
		qtlg_wire_4452,
		qtlg_wire_4453,
		qtlg_wire_4454,
		qtlg_wire_4455,
		qtlg_wire_4456,
		qtlg_wire_4457,
		qtlg_wire_4458,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][3],
		qtlg_wire_4459,
		qtlg_wire_4460,
		qtlg_wire_4461}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4462,
		qtlg_wire_4463,
		qtlg_wire_4464,
		qtlg_wire_4465,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][15],
		qtlg_wire_4466,
		qtlg_wire_4467,
		qtlg_wire_4468,
		qtlg_wire_4469,
		qtlg_wire_4470,
		qtlg_wire_4471,
		qtlg_wire_4472,
		qtlg_wire_4473,
		qtlg_wire_4474,
		qtlg_wire_4475,
		qtlg_wire_4476,
		qtlg_wire_4477,
		qtlg_wire_4478,
		qtlg_wire_4479,
		qtlg_wire_4480}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4481,
		qtlg_wire_4482,
		qtlg_wire_4483,
		qtlg_wire_4484,
		qtlg_wire_4485,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][9],
		qtlg_wire_4486,
		qtlg_wire_4487,
		qtlg_wire_4488,
		qtlg_wire_4489,
		qtlg_wire_4490,
		qtlg_wire_4491,
		qtlg_wire_4492,
		qtlg_wire_4493,
		qtlg_wire_4494}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[4]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][16],
		qtlg_wire_4495,
		qtlg_wire_4496,
		qtlg_wire_4497,
		qtlg_wire_4498,
		qtlg_wire_4499,
		qtlg_wire_4500,
		qtlg_wire_4501,
		qtlg_wire_4502,
		qtlg_wire_4503,
		qtlg_wire_4504,
		qtlg_wire_4505,
		qtlg_wire_4506,
		qtlg_wire_4507,
		qtlg_wire_4508,
		qtlg_wire_4509,
		qtlg_wire_4510}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[4][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[4]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_4511}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[4]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_4512}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_4513,
		qtlg_wire_4514,
		qtlg_wire_4515,
		qtlg_wire_4516,
		qtlg_wire_4517,
		qtlg_wire_4518,
		qtlg_wire_4519,
		qtlg_wire_4520,
		qtlg_wire_4521,
		qtlg_wire_4522,
		qtlg_wire_4523,
		qtlg_wire_4524,
		qtlg_wire_4525,
		qtlg_wire_4526,
		qtlg_wire_4527,
		qtlg_wire_4528,
		qtlg_wire_4529,
		qtlg_wire_4530,
		qtlg_wire_4531,
		qtlg_wire_4532,
		qtlg_wire_4533,
		qtlg_wire_4534,
		qtlg_wire_4535,
		qtlg_wire_4536,
		qtlg_wire_4537,
		qtlg_wire_4538,
		qtlg_wire_4539,
		qtlg_wire_4540,
		qtlg_wire_4541,
		qtlg_wire_4542,
		qtlg_wire_4543,
		qtlg_wire_4544,
		qtlg_wire_4545,
		qtlg_wire_4546,
		qtlg_wire_4547,
		qtlg_wire_4548,
		qtlg_wire_4549,
		qtlg_wire_4550,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[4][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[4]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[4][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[4][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[4][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[4][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[4]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[4]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[4]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[4]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[4]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[4][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[4]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[4]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(5),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[5]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[5]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[5]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4551,
		qtlg_wire_4552,
		qtlg_wire_4553,
		qtlg_wire_4554,
		qtlg_wire_4555,
		qtlg_wire_4556,
		qtlg_wire_4557,
		qtlg_wire_4558,
		qtlg_wire_4559,
		qtlg_wire_4560,
		qtlg_wire_4561,
		qtlg_wire_4562,
		qtlg_wire_4563,
		qtlg_wire_4564,
		qtlg_wire_4565,
		qtlg_wire_4566,
		qtlg_wire_4567,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][2],
		qtlg_wire_4568,
		qtlg_wire_4569}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4570,
		qtlg_wire_4571,
		qtlg_wire_4572,
		qtlg_wire_4573,
		qtlg_wire_4574,
		qtlg_wire_4575,
		qtlg_wire_4576,
		qtlg_wire_4577,
		qtlg_wire_4578,
		qtlg_wire_4579,
		qtlg_wire_4580,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][3],
		qtlg_wire_4581,
		qtlg_wire_4582,
		qtlg_wire_4583}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4584,
		qtlg_wire_4585,
		qtlg_wire_4586,
		qtlg_wire_4587,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][15],
		qtlg_wire_4588,
		qtlg_wire_4589,
		qtlg_wire_4590,
		qtlg_wire_4591,
		qtlg_wire_4592,
		qtlg_wire_4593,
		qtlg_wire_4594,
		qtlg_wire_4595,
		qtlg_wire_4596,
		qtlg_wire_4597,
		qtlg_wire_4598,
		qtlg_wire_4599,
		qtlg_wire_4600,
		qtlg_wire_4601,
		qtlg_wire_4602}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4603,
		qtlg_wire_4604,
		qtlg_wire_4605,
		qtlg_wire_4606,
		qtlg_wire_4607,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][9],
		qtlg_wire_4608,
		qtlg_wire_4609,
		qtlg_wire_4610,
		qtlg_wire_4611,
		qtlg_wire_4612,
		qtlg_wire_4613,
		qtlg_wire_4614,
		qtlg_wire_4615,
		qtlg_wire_4616}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[5]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][16],
		qtlg_wire_4617,
		qtlg_wire_4618,
		qtlg_wire_4619,
		qtlg_wire_4620,
		qtlg_wire_4621,
		qtlg_wire_4622,
		qtlg_wire_4623,
		qtlg_wire_4624,
		qtlg_wire_4625,
		qtlg_wire_4626,
		qtlg_wire_4627,
		qtlg_wire_4628,
		qtlg_wire_4629,
		qtlg_wire_4630,
		qtlg_wire_4631,
		qtlg_wire_4632}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[5][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[5]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_4633}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[5]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_4634}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_4635,
		qtlg_wire_4636,
		qtlg_wire_4637,
		qtlg_wire_4638,
		qtlg_wire_4639,
		qtlg_wire_4640,
		qtlg_wire_4641,
		qtlg_wire_4642,
		qtlg_wire_4643,
		qtlg_wire_4644,
		qtlg_wire_4645,
		qtlg_wire_4646,
		qtlg_wire_4647,
		qtlg_wire_4648,
		qtlg_wire_4649,
		qtlg_wire_4650,
		qtlg_wire_4651,
		qtlg_wire_4652,
		qtlg_wire_4653,
		qtlg_wire_4654,
		qtlg_wire_4655,
		qtlg_wire_4656,
		qtlg_wire_4657,
		qtlg_wire_4658,
		qtlg_wire_4659,
		qtlg_wire_4660,
		qtlg_wire_4661,
		qtlg_wire_4662,
		qtlg_wire_4663,
		qtlg_wire_4664,
		qtlg_wire_4665,
		qtlg_wire_4666,
		qtlg_wire_4667,
		qtlg_wire_4668,
		qtlg_wire_4669,
		qtlg_wire_4670,
		qtlg_wire_4671,
		qtlg_wire_4672,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[5][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[5]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[5][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[5][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[5][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[5][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[5]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[5]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[5]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[5]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[5]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[5][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[5]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[5]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(6),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[6]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[6]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[6]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4673,
		qtlg_wire_4674,
		qtlg_wire_4675,
		qtlg_wire_4676,
		qtlg_wire_4677,
		qtlg_wire_4678,
		qtlg_wire_4679,
		qtlg_wire_4680,
		qtlg_wire_4681,
		qtlg_wire_4682,
		qtlg_wire_4683,
		qtlg_wire_4684,
		qtlg_wire_4685,
		qtlg_wire_4686,
		qtlg_wire_4687,
		qtlg_wire_4688,
		qtlg_wire_4689,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][2],
		qtlg_wire_4690,
		qtlg_wire_4691}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4692,
		qtlg_wire_4693,
		qtlg_wire_4694,
		qtlg_wire_4695,
		qtlg_wire_4696,
		qtlg_wire_4697,
		qtlg_wire_4698,
		qtlg_wire_4699,
		qtlg_wire_4700,
		qtlg_wire_4701,
		qtlg_wire_4702,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][3],
		qtlg_wire_4703,
		qtlg_wire_4704,
		qtlg_wire_4705}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4706,
		qtlg_wire_4707,
		qtlg_wire_4708,
		qtlg_wire_4709,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][15],
		qtlg_wire_4710,
		qtlg_wire_4711,
		qtlg_wire_4712,
		qtlg_wire_4713,
		qtlg_wire_4714,
		qtlg_wire_4715,
		qtlg_wire_4716,
		qtlg_wire_4717,
		qtlg_wire_4718,
		qtlg_wire_4719,
		qtlg_wire_4720,
		qtlg_wire_4721,
		qtlg_wire_4722,
		qtlg_wire_4723,
		qtlg_wire_4724}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4725,
		qtlg_wire_4726,
		qtlg_wire_4727,
		qtlg_wire_4728,
		qtlg_wire_4729,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][9],
		qtlg_wire_4730,
		qtlg_wire_4731,
		qtlg_wire_4732,
		qtlg_wire_4733,
		qtlg_wire_4734,
		qtlg_wire_4735,
		qtlg_wire_4736,
		qtlg_wire_4737,
		qtlg_wire_4738}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[6]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][16],
		qtlg_wire_4739,
		qtlg_wire_4740,
		qtlg_wire_4741,
		qtlg_wire_4742,
		qtlg_wire_4743,
		qtlg_wire_4744,
		qtlg_wire_4745,
		qtlg_wire_4746,
		qtlg_wire_4747,
		qtlg_wire_4748,
		qtlg_wire_4749,
		qtlg_wire_4750,
		qtlg_wire_4751,
		qtlg_wire_4752,
		qtlg_wire_4753,
		qtlg_wire_4754}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[6][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[6]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_4755}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[6]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_4756}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_4757,
		qtlg_wire_4758,
		qtlg_wire_4759,
		qtlg_wire_4760,
		qtlg_wire_4761,
		qtlg_wire_4762,
		qtlg_wire_4763,
		qtlg_wire_4764,
		qtlg_wire_4765,
		qtlg_wire_4766,
		qtlg_wire_4767,
		qtlg_wire_4768,
		qtlg_wire_4769,
		qtlg_wire_4770,
		qtlg_wire_4771,
		qtlg_wire_4772,
		qtlg_wire_4773,
		qtlg_wire_4774,
		qtlg_wire_4775,
		qtlg_wire_4776,
		qtlg_wire_4777,
		qtlg_wire_4778,
		qtlg_wire_4779,
		qtlg_wire_4780,
		qtlg_wire_4781,
		qtlg_wire_4782,
		qtlg_wire_4783,
		qtlg_wire_4784,
		qtlg_wire_4785,
		qtlg_wire_4786,
		qtlg_wire_4787,
		qtlg_wire_4788,
		qtlg_wire_4789,
		qtlg_wire_4790,
		qtlg_wire_4791,
		qtlg_wire_4792,
		qtlg_wire_4793,
		qtlg_wire_4794,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[6][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[6]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[6][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[6][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[6][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[6][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[6]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[6]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[6]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[6]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[6]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[6][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[6]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[6]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_adapt_start_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_rx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_rx_fifo_ready_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(7),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(1),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1),
	.num_ip_on_intfc_15(2),
	.num_ip_on_intfc_17(1)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_ltr_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_adapt_start_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pfdmode_lock_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_rxpma_rstb_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_rx_dll_lock_req_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_rx_fifo_ready_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[7]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[7]}),
	.intfc_03_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_03_pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[7]),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4795,
		qtlg_wire_4796,
		qtlg_wire_4797,
		qtlg_wire_4798,
		qtlg_wire_4799,
		qtlg_wire_4800,
		qtlg_wire_4801,
		qtlg_wire_4802,
		qtlg_wire_4803,
		qtlg_wire_4804,
		qtlg_wire_4805,
		qtlg_wire_4806,
		qtlg_wire_4807,
		qtlg_wire_4808,
		qtlg_wire_4809,
		qtlg_wire_4810,
		qtlg_wire_4811,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][2],
		qtlg_wire_4812,
		qtlg_wire_4813}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4814,
		qtlg_wire_4815,
		qtlg_wire_4816,
		qtlg_wire_4817,
		qtlg_wire_4818,
		qtlg_wire_4819,
		qtlg_wire_4820,
		qtlg_wire_4821,
		qtlg_wire_4822,
		qtlg_wire_4823,
		qtlg_wire_4824,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][3],
		qtlg_wire_4825,
		qtlg_wire_4826,
		qtlg_wire_4827}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4828,
		qtlg_wire_4829,
		qtlg_wire_4830,
		qtlg_wire_4831,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][15],
		qtlg_wire_4832,
		qtlg_wire_4833,
		qtlg_wire_4834,
		qtlg_wire_4835,
		qtlg_wire_4836,
		qtlg_wire_4837,
		qtlg_wire_4838,
		qtlg_wire_4839,
		qtlg_wire_4840,
		qtlg_wire_4841,
		qtlg_wire_4842,
		qtlg_wire_4843,
		qtlg_wire_4844,
		qtlg_wire_4845,
		qtlg_wire_4846}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4847,
		qtlg_wire_4848,
		qtlg_wire_4849,
		qtlg_wire_4850,
		qtlg_wire_4851,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][9],
		qtlg_wire_4852,
		qtlg_wire_4853,
		qtlg_wire_4854,
		qtlg_wire_4855,
		qtlg_wire_4856,
		qtlg_wire_4857,
		qtlg_wire_4858,
		qtlg_wire_4859,
		qtlg_wire_4860}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[7]),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][16],
		qtlg_wire_4861,
		qtlg_wire_4862,
		qtlg_wire_4863,
		qtlg_wire_4864,
		qtlg_wire_4865,
		qtlg_wire_4866,
		qtlg_wire_4867,
		qtlg_wire_4868,
		qtlg_wire_4869,
		qtlg_wire_4870,
		qtlg_wire_4871,
		qtlg_wire_4872,
		qtlg_wire_4873,
		qtlg_wire_4874,
		qtlg_wire_4875,
		qtlg_wire_4876}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[7][0]}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_pld_pma_adapt_start_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[7]),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_4877}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[7]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_4878}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_4879,
		qtlg_wire_4880,
		qtlg_wire_4881,
		qtlg_wire_4882,
		qtlg_wire_4883,
		qtlg_wire_4884,
		qtlg_wire_4885,
		qtlg_wire_4886,
		qtlg_wire_4887,
		qtlg_wire_4888,
		qtlg_wire_4889,
		qtlg_wire_4890,
		qtlg_wire_4891,
		qtlg_wire_4892,
		qtlg_wire_4893,
		qtlg_wire_4894,
		qtlg_wire_4895,
		qtlg_wire_4896,
		qtlg_wire_4897,
		qtlg_wire_4898,
		qtlg_wire_4899,
		qtlg_wire_4900,
		qtlg_wire_4901,
		qtlg_wire_4902,
		qtlg_wire_4903,
		qtlg_wire_4904,
		qtlg_wire_4905,
		qtlg_wire_4906,
		qtlg_wire_4907,
		qtlg_wire_4908,
		qtlg_wire_4909,
		qtlg_wire_4910,
		qtlg_wire_4911,
		qtlg_wire_4912,
		qtlg_wire_4913,
		qtlg_wire_4914,
		qtlg_wire_4915,
		qtlg_wire_4916,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[7][0]}),
	.intfc_17_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_17_pld_8g_full_rmf_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[7]),
	.s_intfc_17_pld_8g_wa_boundary_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[7][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[7][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[7][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[7][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[7]),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[7]),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[7]),
	.s_intfc_17_pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[7]),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[7]),
	.s_intfc_17_pld_pma_pcie_switch_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[7][0]}),
	.s_intfc_17_pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[7]),
	.s_intfc_17_pld_rx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[7]));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(8),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_4917}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_4918}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[8]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[8]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[8]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_4919,
		qtlg_wire_4920,
		qtlg_wire_4921,
		qtlg_wire_4922,
		qtlg_wire_4923,
		qtlg_wire_4924,
		qtlg_wire_4925,
		qtlg_wire_4926,
		qtlg_wire_4927,
		qtlg_wire_4928,
		qtlg_wire_4929,
		qtlg_wire_4930,
		qtlg_wire_4931,
		qtlg_wire_4932,
		qtlg_wire_4933,
		qtlg_wire_4934,
		qtlg_wire_4935,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][2],
		qtlg_wire_4936,
		qtlg_wire_4937}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_4938,
		qtlg_wire_4939,
		qtlg_wire_4940,
		qtlg_wire_4941,
		qtlg_wire_4942,
		qtlg_wire_4943,
		qtlg_wire_4944,
		qtlg_wire_4945,
		qtlg_wire_4946,
		qtlg_wire_4947,
		qtlg_wire_4948,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][3],
		qtlg_wire_4949,
		qtlg_wire_4950,
		qtlg_wire_4951}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_4952,
		qtlg_wire_4953,
		qtlg_wire_4954,
		qtlg_wire_4955,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][15],
		qtlg_wire_4956,
		qtlg_wire_4957,
		qtlg_wire_4958,
		qtlg_wire_4959,
		qtlg_wire_4960,
		qtlg_wire_4961,
		qtlg_wire_4962,
		qtlg_wire_4963,
		qtlg_wire_4964,
		qtlg_wire_4965,
		qtlg_wire_4966,
		qtlg_wire_4967,
		qtlg_wire_4968,
		qtlg_wire_4969,
		qtlg_wire_4970}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_4971,
		qtlg_wire_4972,
		qtlg_wire_4973,
		qtlg_wire_4974,
		qtlg_wire_4975,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][9],
		qtlg_wire_4976,
		qtlg_wire_4977,
		qtlg_wire_4978,
		qtlg_wire_4979,
		qtlg_wire_4980,
		qtlg_wire_4981,
		qtlg_wire_4982,
		qtlg_wire_4983,
		qtlg_wire_4984}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[8]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][16],
		qtlg_wire_4985,
		qtlg_wire_4986,
		qtlg_wire_4987,
		qtlg_wire_4988,
		qtlg_wire_4989,
		qtlg_wire_4990,
		qtlg_wire_4991,
		qtlg_wire_4992,
		qtlg_wire_4993,
		qtlg_wire_4994,
		qtlg_wire_4995,
		qtlg_wire_4996,
		qtlg_wire_4997,
		qtlg_wire_4998,
		qtlg_wire_4999,
		qtlg_wire_5000}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[8][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[8]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({qtlg_wire_5001,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_5002}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({qtlg_wire_5003,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_5004}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_5005,
		qtlg_wire_5006}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[8]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_5007,
		qtlg_wire_5008}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_5009,
		qtlg_wire_5010,
		qtlg_wire_5011,
		qtlg_wire_5012,
		qtlg_wire_5013,
		qtlg_wire_5014,
		qtlg_wire_5015,
		qtlg_wire_5016,
		qtlg_wire_5017,
		qtlg_wire_5018,
		qtlg_wire_5019,
		qtlg_wire_5020,
		qtlg_wire_5021,
		qtlg_wire_5022,
		qtlg_wire_5023,
		qtlg_wire_5024,
		qtlg_wire_5025,
		qtlg_wire_5026,
		qtlg_wire_5027,
		qtlg_wire_5028,
		qtlg_wire_5029,
		qtlg_wire_5030,
		qtlg_wire_5031,
		qtlg_wire_5032,
		qtlg_wire_5033,
		qtlg_wire_5034,
		qtlg_wire_5035,
		qtlg_wire_5036,
		qtlg_wire_5037,
		qtlg_wire_5038,
		qtlg_wire_5039,
		qtlg_wire_5040,
		qtlg_wire_5041,
		qtlg_wire_5042,
		qtlg_wire_5043,
		qtlg_wire_5044,
		qtlg_wire_5045,
		qtlg_wire_5046,
		qtlg_wire_5047,
		qtlg_wire_5048,
		qtlg_wire_5049,
		qtlg_wire_5050,
		qtlg_wire_5051,
		qtlg_wire_5052,
		qtlg_wire_5053,
		qtlg_wire_5054,
		qtlg_wire_5055,
		qtlg_wire_5056,
		qtlg_wire_5057,
		qtlg_wire_5058,
		qtlg_wire_5059,
		qtlg_wire_5060,
		qtlg_wire_5061,
		qtlg_wire_5062,
		qtlg_wire_5063,
		qtlg_wire_5064,
		qtlg_wire_5065,
		qtlg_wire_5066,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[8][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_5067,
		qtlg_wire_5068}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_5069}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_5070}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_5071}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_5072,
		qtlg_wire_5073,
		qtlg_wire_5074,
		qtlg_wire_5075}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_5076}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[8]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[8][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[8][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[8][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[8][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[8]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_5077,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[8]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_5078,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[8]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_5079,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[8]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_5080}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_5081}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_5082}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_5083}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[8]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[8][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_5084,
		qtlg_wire_5085,
		qtlg_wire_5086,
		qtlg_wire_5087,
		qtlg_wire_5088}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_5089}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_5090}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[8]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_5091,
		qtlg_wire_5092,
		qtlg_wire_5093,
		qtlg_wire_5094,
		qtlg_wire_5095,
		qtlg_wire_5096,
		qtlg_wire_5097,
		qtlg_wire_5098,
		qtlg_wire_5099,
		qtlg_wire_5100,
		qtlg_wire_5101,
		qtlg_wire_5102,
		qtlg_wire_5103,
		qtlg_wire_5104,
		qtlg_wire_5105,
		qtlg_wire_5106,
		qtlg_wire_5107,
		qtlg_wire_5108,
		qtlg_wire_5109,
		qtlg_wire_5110,
		qtlg_wire_5111,
		qtlg_wire_5112,
		qtlg_wire_5113,
		qtlg_wire_5114,
		qtlg_wire_5115,
		qtlg_wire_5116,
		qtlg_wire_5117,
		qtlg_wire_5118,
		qtlg_wire_5119,
		qtlg_wire_5120,
		qtlg_wire_5121,
		qtlg_wire_5122,
		qtlg_wire_5123,
		qtlg_wire_5124,
		qtlg_wire_5125,
		qtlg_wire_5126,
		qtlg_wire_5127,
		qtlg_wire_5128,
		qtlg_wire_5129,
		qtlg_wire_5130,
		qtlg_wire_5131,
		qtlg_wire_5132,
		qtlg_wire_5133,
		qtlg_wire_5134,
		qtlg_wire_5135,
		qtlg_wire_5136,
		qtlg_wire_5137,
		qtlg_wire_5138,
		qtlg_wire_5139,
		qtlg_wire_5140,
		qtlg_wire_5141,
		qtlg_wire_5142,
		qtlg_wire_5143,
		qtlg_wire_5144,
		qtlg_wire_5145,
		qtlg_wire_5146,
		qtlg_wire_5147,
		qtlg_wire_5148,
		qtlg_wire_5149,
		qtlg_wire_5150,
		qtlg_wire_5151,
		qtlg_wire_5152,
		qtlg_wire_5153,
		qtlg_wire_5154,
		qtlg_wire_5155,
		qtlg_wire_5156,
		qtlg_wire_5157,
		qtlg_wire_5158,
		qtlg_wire_5159,
		qtlg_wire_5160,
		qtlg_wire_5161,
		qtlg_wire_5162,
		qtlg_wire_5163,
		qtlg_wire_5164,
		qtlg_wire_5165,
		qtlg_wire_5166,
		qtlg_wire_5167,
		qtlg_wire_5168,
		qtlg_wire_5169,
		qtlg_wire_5170}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_5171}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_5172}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_5173}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_5174}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_5175,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[8]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_5176}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_5177}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_5178}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_5179}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_blk_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_clr_errblk_cnt_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_diag_data_status_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_frame_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_crc32_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_frame_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_hi_ber_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_a1a2_k1k2_flag_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_bitloc_rev_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_byte_rev_en_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_eidleinfersel_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_empty_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_encdt_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_full_rmf_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_rxelecidle_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_signal_detect_out_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_adapter_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_aib_fabric_rx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_aib_hssi_rx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_hssi_rx_transfer_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_ltr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_adapt_start_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_early_eios_real;
wire [5:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_internal_clk1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_internal_clk2_hioint_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_sw_done_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_switch_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pfdmode_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_ppm_lock_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rs_lpbk_b_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rx_found_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rxpll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rxpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_signal_ok_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pmaif_rxclkslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_polinv_rx_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_rd_en_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_err_clr_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_err_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_sclk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_sclk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_syncsm_en_real;
wire [19:0] z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real;
intfc_m_hdpldadapt_rx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(9),
	.num_ip_on_intfc_00(2),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(1),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(1),
	.num_ip_on_intfc_08(1),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_10(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(2),
	.num_ip_on_intfc_15(3),
	.num_ip_on_intfc_17(2)
) z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.pld_10g_krfec_rx_blk_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_blk_lock_real),
	.pld_10g_krfec_rx_clr_errblk_cnt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.pld_10g_krfec_rx_diag_data_status_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_diag_data_status_real),
	.pld_10g_krfec_rx_frame_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_frame_real),
	.pld_10g_rx_crc32_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_crc32_err_real),
	.pld_10g_rx_frame_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_frame_lock_real),
	.pld_10g_rx_hi_ber_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_hi_ber_real),
	.pld_8g_a1a2_k1k2_flag_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_a1a2_k1k2_flag_real),
	.pld_8g_bitloc_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_bitloc_rev_en_real),
	.pld_8g_byte_rev_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_byte_rev_en_real),
	.pld_8g_eidleinfersel_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_eidleinfersel_real),
	.pld_8g_empty_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_empty_rmf_real),
	.pld_8g_encdt_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_encdt_real),
	.pld_8g_full_rmf_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_full_rmf_real),
	.pld_8g_rxelecidle_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_rxelecidle_real),
	.pld_8g_signal_detect_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_signal_detect_out_real),
	.pld_8g_wa_boundary_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real),
	.pld_adapter_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_adapter_rx_pld_rst_n_real),
	.pld_aib_fabric_rx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_aib_fabric_rx_dll_lock_real),
	.pld_aib_hssi_rx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_aib_hssi_rx_dcd_cal_done_real),
	.pld_hssi_rx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_hssi_rx_transfer_en_real),
	.pld_ltr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_ltr_real),
	.pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out1_dcm_real),
	.pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out1_hioint_real),
	.pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out2_dcm_real),
	.pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out2_hioint_real),
	.pld_pcs_rx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_pld_rst_n_real),
	.pld_pma_adapt_start_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_adapt_start_real),
	.pld_pma_early_eios_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_early_eios_real),
	.pld_pma_eye_monitor_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real),
	.pld_pma_internal_clk1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_internal_clk1_hioint_real),
	.pld_pma_internal_clk2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_internal_clk2_hioint_real),
	.pld_pma_pcie_sw_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_sw_done_real),
	.pld_pma_pcie_switch_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_switch_real),
	.pld_pma_pfdmode_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pfdmode_lock_real),
	.pld_pma_ppm_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_ppm_lock_real),
	.pld_pma_reserved_in_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real),
	.pld_pma_reserved_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real),
	.pld_pma_rs_lpbk_b_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rs_lpbk_b_real),
	.pld_pma_rx_found_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rx_found_real),
	.pld_pma_rxpll_lock_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rxpll_lock_real),
	.pld_pma_rxpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rxpma_rstb_real),
	.pld_pma_signal_ok_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_signal_ok_real),
	.pld_pmaif_rxclkslip_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pmaif_rxclkslip_real),
	.pld_polinv_rx_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_polinv_rx_real),
	.pld_rx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk1_dcm_real),
	.pld_rx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk1_rowclk_real),
	.pld_rx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk2_rowclk_real),
	.pld_rx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_dll_lock_req_real),
	.pld_rx_fabric_data_out_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real),
	.pld_rx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_empty_real),
	.pld_rx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_full_real),
	.pld_rx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_pempty_real),
	.pld_rx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_pfull_real),
	.pld_rx_fabric_fifo_rd_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_rd_en_real),
	.pld_rx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fifo_ready_real),
	.pld_rx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_hssi_fifo_empty_real),
	.pld_rx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_hssi_fifo_full_real),
	.pld_rx_prbs_done_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_done_real),
	.pld_rx_prbs_err_clr_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_err_clr_real),
	.pld_rx_prbs_err_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_err_real),
	.pld_sclk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_sclk1_rowclk_real),
	.pld_sclk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_sclk2_rowclk_real),
	.pld_syncsm_en_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_syncsm_en_real),
	.pld_test_data_real(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real),
	.intfc_00_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_00_pld_pma_internal_clk1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk1_hioint[0],
		qtlg_wire_5180}),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_pma_internal_clk2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_internal_clk2_hioint[0],
		qtlg_wire_5181}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_pld_8g_rxelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlockstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_rxelecidle_real[9]}),
	.s_intfc_02_pld_pma_rxpll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxcdrlock2data_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpll_lock_real[9]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_03_pld_pma_rxpma_rstb_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_rxpma_rstb_real[9]}),
	.s_intfc_03_pld_sclk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk1_rowclk[0],
		1'bz}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_pld_test_data_real({qtlg_wire_5182,
		qtlg_wire_5183,
		qtlg_wire_5184,
		qtlg_wire_5185,
		qtlg_wire_5186,
		qtlg_wire_5187,
		qtlg_wire_5188,
		qtlg_wire_5189,
		qtlg_wire_5190,
		qtlg_wire_5191,
		qtlg_wire_5192,
		qtlg_wire_5193,
		qtlg_wire_5194,
		qtlg_wire_5195,
		qtlg_wire_5196,
		qtlg_wire_5197,
		qtlg_wire_5198,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][2],
		qtlg_wire_5199,
		qtlg_wire_5200}),
	.intfc_05_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_05_pld_test_data_real({qtlg_wire_5201,
		qtlg_wire_5202,
		qtlg_wire_5203,
		qtlg_wire_5204,
		qtlg_wire_5205,
		qtlg_wire_5206,
		qtlg_wire_5207,
		qtlg_wire_5208,
		qtlg_wire_5209,
		qtlg_wire_5210,
		qtlg_wire_5211,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][8],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][3],
		qtlg_wire_5212,
		qtlg_wire_5213,
		qtlg_wire_5214}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_06_pld_pma_early_eios_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_early_eios[0],
		1'bz}),
	.s_intfc_06_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_reserved_out_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_07_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_07_pld_test_data_real({qtlg_wire_5215,
		qtlg_wire_5216,
		qtlg_wire_5217,
		qtlg_wire_5218,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][15],
		qtlg_wire_5219,
		qtlg_wire_5220,
		qtlg_wire_5221,
		qtlg_wire_5222,
		qtlg_wire_5223,
		qtlg_wire_5224,
		qtlg_wire_5225,
		qtlg_wire_5226,
		qtlg_wire_5227,
		qtlg_wire_5228,
		qtlg_wire_5229,
		qtlg_wire_5230,
		qtlg_wire_5231,
		qtlg_wire_5232,
		qtlg_wire_5233}),
	.intfc_08_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_08_pld_test_data_real({qtlg_wire_5234,
		qtlg_wire_5235,
		qtlg_wire_5236,
		qtlg_wire_5237,
		qtlg_wire_5238,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][9],
		qtlg_wire_5239,
		qtlg_wire_5240,
		qtlg_wire_5241,
		qtlg_wire_5242,
		qtlg_wire_5243,
		qtlg_wire_5244,
		qtlg_wire_5245,
		qtlg_wire_5246,
		qtlg_wire_5247}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_pld_10g_krfec_rx_clr_errblk_cnt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_clr_errblk_cnt[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_10g_krfec_rx_clr_errblk_cnt_real[9]}),
	.s_intfc_09_pld_8g_bitloc_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_bitloc_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_byte_rev_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_byte_rev_en[0],
		1'bz}),
	.s_intfc_09_pld_8g_eidleinfersel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_eidleinfersel[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_8g_encdt_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_encdt[0],
		1'bz}),
	.s_intfc_09_pld_pma_eye_monitor_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_reserved_out_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_10_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_10_pld_test_data_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][16],
		qtlg_wire_5248,
		qtlg_wire_5249,
		qtlg_wire_5250,
		qtlg_wire_5251,
		qtlg_wire_5252,
		qtlg_wire_5253,
		qtlg_wire_5254,
		qtlg_wire_5255,
		qtlg_wire_5256,
		qtlg_wire_5257,
		qtlg_wire_5258,
		qtlg_wire_5259,
		qtlg_wire_5260,
		qtlg_wire_5261,
		qtlg_wire_5262,
		qtlg_wire_5263}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_11_pld_pma_eye_monitor_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_pma_reserved_out_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_11_pld_polinv_rx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_rx[0],
		1'bz}),
	.s_intfc_11_pld_rx_prbs_err_clr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err_clr[0],
		1'bz}),
	.s_intfc_11_pld_syncsm_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_syncsm_en[0],
		1'bz}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_pld_pma_pcie_sw_done_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_sw_done_real[9][0]}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_pld_pma_adapt_start_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_adapt_start[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_adapt_start_real[9]}),
	.s_intfc_14_pld_pma_eye_monitor_real({1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_eye_monitor[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_pma_reserved_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_out[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_15_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_15_pld_10g_krfec_rx_blk_lock_real({qtlg_wire_5264,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_blk_lock[0],
		qtlg_wire_5265}),
	.s_intfc_15_pld_10g_rx_crc32_err_real({qtlg_wire_5266,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_crc32_err[0],
		qtlg_wire_5267}),
	.s_intfc_15_pld_8g_signal_detect_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxsignaldetect_lfps_lx_a[0],
		qtlg_wire_5268,
		qtlg_wire_5269}),
	.s_intfc_15_pld_ltr_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.flux_top__iflux_ingress_direct__231[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_ltr_real[9]}),
	.s_intfc_15_pld_pma_pfdmode_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_rxsignaldetect_lx_a[0],
		qtlg_wire_5270,
		qtlg_wire_5271}),
	.s_intfc_15_pld_test_data_real({qtlg_wire_5272,
		qtlg_wire_5273,
		qtlg_wire_5274,
		qtlg_wire_5275,
		qtlg_wire_5276,
		qtlg_wire_5277,
		qtlg_wire_5278,
		qtlg_wire_5279,
		qtlg_wire_5280,
		qtlg_wire_5281,
		qtlg_wire_5282,
		qtlg_wire_5283,
		qtlg_wire_5284,
		qtlg_wire_5285,
		qtlg_wire_5286,
		qtlg_wire_5287,
		qtlg_wire_5288,
		qtlg_wire_5289,
		qtlg_wire_5290,
		qtlg_wire_5291,
		qtlg_wire_5292,
		qtlg_wire_5293,
		qtlg_wire_5294,
		qtlg_wire_5295,
		qtlg_wire_5296,
		qtlg_wire_5297,
		qtlg_wire_5298,
		qtlg_wire_5299,
		qtlg_wire_5300,
		qtlg_wire_5301,
		qtlg_wire_5302,
		qtlg_wire_5303,
		qtlg_wire_5304,
		qtlg_wire_5305,
		qtlg_wire_5306,
		qtlg_wire_5307,
		qtlg_wire_5308,
		qtlg_wire_5309,
		qtlg_wire_5310,
		qtlg_wire_5311,
		qtlg_wire_5312,
		qtlg_wire_5313,
		qtlg_wire_5314,
		qtlg_wire_5315,
		qtlg_wire_5316,
		qtlg_wire_5317,
		qtlg_wire_5318,
		qtlg_wire_5319,
		qtlg_wire_5320,
		qtlg_wire_5321,
		qtlg_wire_5322,
		qtlg_wire_5323,
		qtlg_wire_5324,
		qtlg_wire_5325,
		qtlg_wire_5326,
		qtlg_wire_5327,
		qtlg_wire_5328,
		qtlg_wire_5329,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_test_data_real[9][0]}),
	.intfc_17_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_17_pld_10g_krfec_rx_diag_data_status_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_diag_data_status[0],
		qtlg_wire_5330,
		qtlg_wire_5331}),
	.s_intfc_17_pld_10g_krfec_rx_frame_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_krfec_rx_frame[0],
		qtlg_wire_5332}),
	.s_intfc_17_pld_10g_rx_frame_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_frame_lock[0],
		qtlg_wire_5333}),
	.s_intfc_17_pld_10g_rx_hi_ber_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_rx_hi_ber[0],
		qtlg_wire_5334}),
	.s_intfc_17_pld_8g_a1a2_k1k2_flag_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_a1a2_k1k2_flag[0],
		qtlg_wire_5335,
		qtlg_wire_5336,
		qtlg_wire_5337,
		qtlg_wire_5338}),
	.s_intfc_17_pld_8g_empty_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_empty_rmf[0],
		qtlg_wire_5339}),
	.s_intfc_17_pld_8g_full_rmf_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_full_rmf[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_full_rmf_real[9]}),
	.s_intfc_17_pld_8g_wa_boundary_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_wa_boundary[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[9][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[9][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[9][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_8g_wa_boundary_real[9][0]}),
	.s_intfc_17_pld_adapter_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_adapter_rx_pld_rst_n_real[9]}),
	.s_intfc_17_pld_aib_fabric_rx_dll_lock_real({qtlg_wire_5340,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_fabric_rx_dll_lock_real[9]}),
	.s_intfc_17_pld_aib_hssi_rx_dcd_cal_done_real({qtlg_wire_5341,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_aib_hssi_rx_dcd_cal_done_real[9]}),
	.s_intfc_17_pld_hssi_rx_transfer_en_real({qtlg_wire_5342,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_hssi_rx_transfer_en_real[9]}),
	.s_intfc_17_pld_pcs_rx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_dcm[0],
		qtlg_wire_5343}),
	.s_intfc_17_pld_pcs_rx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out1_hioint[0],
		qtlg_wire_5344}),
	.s_intfc_17_pld_pcs_rx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_dcm[0],
		qtlg_wire_5345}),
	.s_intfc_17_pld_pcs_rx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_rx_clk_out2_hioint[0],
		qtlg_wire_5346}),
	.s_intfc_17_pld_pcs_rx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pcs_rx_pld_rst_n_real[9]}),
	.s_intfc_17_pld_pma_pcie_switch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_pcie_switch[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_pma_pcie_switch_real[9][0]}),
	.s_intfc_17_pld_pma_ppm_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_ppm_lock[0],
		1'bz}),
	.s_intfc_17_pld_pma_reserved_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_reserved_in[0],
		qtlg_wire_5347,
		qtlg_wire_5348,
		qtlg_wire_5349,
		qtlg_wire_5350,
		qtlg_wire_5351}),
	.s_intfc_17_pld_pma_rs_lpbk_b_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rs_lpbk_b[0],
		1'bz}),
	.s_intfc_17_pld_pma_rx_found_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_rx_found[0],
		qtlg_wire_5352}),
	.s_intfc_17_pld_pma_signal_ok_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_signal_ok[0],
		qtlg_wire_5353}),
	.s_intfc_17_pld_pmaif_rxclkslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_rxclkslip[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_dcm[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_17_pld_rx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_dll_lock_req_real[9]}),
	.s_intfc_17_pld_rx_fabric_data_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_from_aib[0],
		qtlg_wire_5354,
		qtlg_wire_5355,
		qtlg_wire_5356,
		qtlg_wire_5357,
		qtlg_wire_5358,
		qtlg_wire_5359,
		qtlg_wire_5360,
		qtlg_wire_5361,
		qtlg_wire_5362,
		qtlg_wire_5363,
		qtlg_wire_5364,
		qtlg_wire_5365,
		qtlg_wire_5366,
		qtlg_wire_5367,
		qtlg_wire_5368,
		qtlg_wire_5369,
		qtlg_wire_5370,
		qtlg_wire_5371,
		qtlg_wire_5372,
		qtlg_wire_5373,
		qtlg_wire_5374,
		qtlg_wire_5375,
		qtlg_wire_5376,
		qtlg_wire_5377,
		qtlg_wire_5378,
		qtlg_wire_5379,
		qtlg_wire_5380,
		qtlg_wire_5381,
		qtlg_wire_5382,
		qtlg_wire_5383,
		qtlg_wire_5384,
		qtlg_wire_5385,
		qtlg_wire_5386,
		qtlg_wire_5387,
		qtlg_wire_5388,
		qtlg_wire_5389,
		qtlg_wire_5390,
		qtlg_wire_5391,
		qtlg_wire_5392,
		qtlg_wire_5393,
		qtlg_wire_5394,
		qtlg_wire_5395,
		qtlg_wire_5396,
		qtlg_wire_5397,
		qtlg_wire_5398,
		qtlg_wire_5399,
		qtlg_wire_5400,
		qtlg_wire_5401,
		qtlg_wire_5402,
		qtlg_wire_5403,
		qtlg_wire_5404,
		qtlg_wire_5405,
		qtlg_wire_5406,
		qtlg_wire_5407,
		qtlg_wire_5408,
		qtlg_wire_5409,
		qtlg_wire_5410,
		qtlg_wire_5411,
		qtlg_wire_5412,
		qtlg_wire_5413,
		qtlg_wire_5414,
		qtlg_wire_5415,
		qtlg_wire_5416,
		qtlg_wire_5417,
		qtlg_wire_5418,
		qtlg_wire_5419,
		qtlg_wire_5420,
		qtlg_wire_5421,
		qtlg_wire_5422,
		qtlg_wire_5423,
		qtlg_wire_5424,
		qtlg_wire_5425,
		qtlg_wire_5426,
		qtlg_wire_5427,
		qtlg_wire_5428,
		qtlg_wire_5429,
		qtlg_wire_5430,
		qtlg_wire_5431,
		qtlg_wire_5432,
		qtlg_wire_5433}),
	.s_intfc_17_pld_rx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_empty[0],
		qtlg_wire_5434}),
	.s_intfc_17_pld_rx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_full[0],
		qtlg_wire_5435}),
	.s_intfc_17_pld_rx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pempty[0],
		qtlg_wire_5436}),
	.s_intfc_17_pld_rx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_pfull[0],
		qtlg_wire_5437}),
	.s_intfc_17_pld_rx_fabric_fifo_rd_en_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_fifo_rd_en[0],
		1'bz}),
	.s_intfc_17_pld_rx_fifo_ready_real({qtlg_wire_5438,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_rx__pld_rx_fifo_ready_real[9]}),
	.s_intfc_17_pld_rx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_empty[0],
		qtlg_wire_5439}),
	.s_intfc_17_pld_rx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_hssi_fifo_full[0],
		qtlg_wire_5440}),
	.s_intfc_17_pld_rx_prbs_done_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_done[0],
		qtlg_wire_5441}),
	.s_intfc_17_pld_rx_prbs_err_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_rx_prbs_err[0],
		qtlg_wire_5442}),
	.s_intfc_17_pld_sclk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_sclk2_rowclk[0],
		1'bz}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(0),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[0]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[0]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[0]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[0]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[0]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[0]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[0][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[0][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[0][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[0][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[0][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[0]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[0]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[0]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[0]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[0][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[0][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[0]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[0]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[0]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[0]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(1),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[1]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[1]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[1]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[1]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[1]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[1]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[1][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[1][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[1][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[1][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[1][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[1]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[1]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[1]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[1]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[1][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[1][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[1]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[1]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[1]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[1]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(10),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[10]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[10]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[10]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5443,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[10]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[10]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[10]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5444}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[10][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[10][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[10][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5445,
		qtlg_wire_5446,
		qtlg_wire_5447,
		qtlg_wire_5448}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[10][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[10][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[10]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5449,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[10]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[10]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5450,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[10]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[10][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[10][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[10]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5451}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5452}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5453}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5454}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5455}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[10]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[10]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5456}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5457}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5458}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5459}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5460,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[10]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5461}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5462}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(11),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[11]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[11]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[11]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5463,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[11]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[11]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[11]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5464}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[11][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[11][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[11][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5465,
		qtlg_wire_5466,
		qtlg_wire_5467,
		qtlg_wire_5468}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[11][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[11][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[11]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5469,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[11]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[11]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5470,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[11]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[11][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[11][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[11]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5471}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5472}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5473}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5474}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5475}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[11]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[11]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5476}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5477}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5478}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5479}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5480,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[11]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5481}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5482}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(12),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[12]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[12]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[12]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5483,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[12]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[12]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[12]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5484}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[12][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[12][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[12][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5485,
		qtlg_wire_5486,
		qtlg_wire_5487,
		qtlg_wire_5488}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[12][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[12][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[12]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5489,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[12]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[12]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5490,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[12]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[12][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[12][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[12]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5491}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5492}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5493}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5494}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5495}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[12]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[12]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5496}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5497}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5498}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5499}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5500,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[12]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5501}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5502}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(13),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[13]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[13]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[13]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5503,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[13]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[13]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[13]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5504}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[13][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[13][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[13][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5505,
		qtlg_wire_5506,
		qtlg_wire_5507,
		qtlg_wire_5508}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[13][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[13][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[13]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5509,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[13]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[13]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5510,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[13]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[13][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[13][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[13]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5511}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5512}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5513}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5514}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5515}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[13]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[13]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5516}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5517}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5518}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5519}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5520,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[13]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5521}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5522}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(14),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[14]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[14]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[14]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5523,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[14]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[14]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[14]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5524}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[14][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[14][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[14][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5525,
		qtlg_wire_5526,
		qtlg_wire_5527,
		qtlg_wire_5528}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[14][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[14][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[14]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5529,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[14]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[14]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5530,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[14]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[14][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[14][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[14]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5531}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5532}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5533}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5534}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5535}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[14]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[14]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5536}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5537}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5538}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5539}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5540,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[14]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5541}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5542}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(15),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[15]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[15]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[15]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5543,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[15]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[15]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[15]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5544}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[15][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[15][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[15][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5545,
		qtlg_wire_5546,
		qtlg_wire_5547,
		qtlg_wire_5548}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[15][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[15][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[15]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5549,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[15]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[15]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5550,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[15]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[15][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[15][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[15]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5551}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5552}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5553}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5554}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5555}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[15]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[15]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5556}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5557}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5558}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5559}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5560,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[15]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5561}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5562}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(16),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[16]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[16]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[16]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5563,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[16]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[16]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[16]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5564}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[16][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[16][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[16][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5565,
		qtlg_wire_5566,
		qtlg_wire_5567,
		qtlg_wire_5568}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[16][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[16][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[16]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5569,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[16]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[16]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5570,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[16]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[16][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[16][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[16]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5571}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5572}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5573}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5574}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5575}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[16]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[16]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5576}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5577}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5578}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5579}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5580,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[16]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5581}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5582}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(17),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[17]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[17]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[17]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5583,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[17]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[17]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[17]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5584}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[17][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[17][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[17][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5585,
		qtlg_wire_5586,
		qtlg_wire_5587,
		qtlg_wire_5588}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[17][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[17][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[17]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5589,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[17]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[17]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5590,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[17]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[17][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[17][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[17]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5591}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5592}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5593}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5594}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5595}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[17]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[17]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5596}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5597}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5598}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5599}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5600,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[17]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5601}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5602}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(18),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[18]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[18]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[18]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5603,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[18]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[18]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[18]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5604}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[18][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[18][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[18][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5605,
		qtlg_wire_5606,
		qtlg_wire_5607,
		qtlg_wire_5608}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[18][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[18][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[18]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5609,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[18]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[18]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5610,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[18]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[18][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[18][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[18]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5611}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5612}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5613}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5614}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5615}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[18]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[18]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5616}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5617}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5618}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5619}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5620,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[18]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5621}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5622}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(19),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[19]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[19]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[19]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5623,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[19]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[19]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[19]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5624}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[19][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[19][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[19][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5625,
		qtlg_wire_5626,
		qtlg_wire_5627,
		qtlg_wire_5628}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[19][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[19][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[19]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5629,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[19]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[19]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5630,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[19]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[19][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[19][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[19]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5631}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5632}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5633}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5634}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5635}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[19]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[19]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5636}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5637}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5638}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5639}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5640,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[19]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5641}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5642}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(2),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[2]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[2]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[2]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[2]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[2]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[2]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[2][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[2][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[2][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[2][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[2][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[2]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[2]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[2]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[2]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[2][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[2][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[2]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[2]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[2]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[2]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(20),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[20]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[20]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[20]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5643,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[20]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[20]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[20]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5644}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[20][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[20][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[20][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5645,
		qtlg_wire_5646,
		qtlg_wire_5647,
		qtlg_wire_5648}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[20][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[20][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[20]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5649,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[20]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[20]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5650,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[20]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[20][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[20][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[20]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5651}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5652}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5653}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5654}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5655}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[20]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[20]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5656}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5657}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5658}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5659}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5660,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[20]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5661}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5662}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(21),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[21]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[21]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[21]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5663,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[21]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[21]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[21]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5664}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[21][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[21][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[21][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5665,
		qtlg_wire_5666,
		qtlg_wire_5667,
		qtlg_wire_5668}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[21][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[21][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[21]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5669,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[21]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[21]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5670,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[21]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[21][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[21][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[21]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5671}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5672}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5673}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5674}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5675}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[21]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[21]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5676}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5677}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5678}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5679}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5680,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[21]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5681}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5682}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(22),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[22]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[22]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[22]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5683,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[22]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[22]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[22]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5684}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[22][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[22][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[22][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5685,
		qtlg_wire_5686,
		qtlg_wire_5687,
		qtlg_wire_5688}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[22][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[22][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[22]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5689,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[22]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[22]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5690,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[22]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[22][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[22][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[22]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5691}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5692}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5693}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5694}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5695}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[22]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[22]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5696}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5697}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5698}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5699}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5700,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[22]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5701}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5702}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_clk0bad_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(23),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(1),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[23]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[23]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[23]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({qtlg_wire_5703,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[23]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[23]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[23]),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5704}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[23][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[23][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[23][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5705,
		qtlg_wire_5706,
		qtlg_wire_5707,
		qtlg_wire_5708}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[23][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[23][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[23]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5709,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[23]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[23]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5710,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[23]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[23][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[23][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[23]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5711}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5712}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5713}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5714}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5715}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[23]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[23]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5716}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5717}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5718}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5719}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5720,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[23]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5721}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5722}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(3),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[3]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[3]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[3]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[3]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[3]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[3]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[3][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[3][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[3][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[3][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[3][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[3]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[3]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[3]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[3]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[3][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[3][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[3]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[3]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[3]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[3]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(4),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[4]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[4]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[4]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[4]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[4]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[4]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[4][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[4][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[4][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[4][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[4][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[4]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[4]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[4]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[4]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[4][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[4][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[4]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[4]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[4]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[4]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(5),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[5]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[5]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[5]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[5]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[5]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[5]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[5][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[5][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[5][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[5][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[5][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[5]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[5]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[5]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[5]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[5][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[5][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[5]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[5]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[5]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[5]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(6),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[6]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[6]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[6]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[6]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[6]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[6]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[6][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[6][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[6][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[6][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[6][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[6]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[6]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[6]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[6]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[6][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[6][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[6]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[6]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[6]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[6]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_fsr_in_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_lc_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_tx_dll_lock_req_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_tx_fifo_ready_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(7),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_02(2),
	.num_ip_on_intfc_04(1),
	.num_ip_on_intfc_05(2),
	.num_ip_on_intfc_06(2),
	.num_ip_on_intfc_09(1),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_13(1),
	.num_ip_on_intfc_14(1)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_fsr_in_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_out_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_tx_bitslip_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_txpma_rstb_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_tx_dll_lock_req_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_tx_fifo_ready_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[7]),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][0]}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[7]}),
	.intfc_04_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[7]),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[7]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[7]}),
	.intfc_09_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][3],
		1'bz,
		1'bz,
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[7]}),
	.intfc_13_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_14_hip_aib_fsr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[7][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[7][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[7][0]}),
	.s_intfc_14_hip_aib_ssr_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[7][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[7][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[7]),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[7]),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[7]),
	.s_intfc_14_pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[7]),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[7][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[7][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[7]),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[7]),
	.s_intfc_14_pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[7]),
	.s_intfc_14_pld_tx_fifo_ready_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[7]));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(8),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[8]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[8]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[8]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		qtlg_wire_5723,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[8]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[8]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[8]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5724}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[8][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[8][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[8][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5725,
		qtlg_wire_5726,
		qtlg_wire_5727,
		qtlg_wire_5728}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[8][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[8][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[8]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5729,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[8]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[8]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5730,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[8]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[8][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[8][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[8]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5731}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5732}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5733}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5734}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5735}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[8]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[8]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5736}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5737}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5738}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5739}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5740,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[8]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5741}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5742}));
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_in_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_out_real;
wire [39:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real;
wire [7:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real;
wire [6:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real;
wire [4:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_adapter_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_aib_fabric_tx_dcd_cal_done_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_aib_hssi_tx_dll_lock_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fabric_tx_transfer_en_real;
wire [1:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_out_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_krfec_tx_alignment_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out1_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out2_hioint_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_pld_rst_n_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_csr_test_dis_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_clk0bad_real;
wire [3:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_cnt_sel_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_extswitch_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_lc_csr_test_dis_real;
wire [2:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_num_phase_shifts_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_pfden_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_up_dn_lc_lf_rstn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_nrpi_freeze_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_bitslip_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_qpi_pulldn_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_qpi_pullup_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_txpma_rstb_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pmaif_mask_tx_pll_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_polinv_tx_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk1_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk1_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk2_dcm_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk2_rowclk_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_dll_lock_req_real;
wire [79:0] z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_pempty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_pfull_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fifo_ready_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_hssi_fifo_empty_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_hssi_fifo_full_real;
wire z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_txelecidle_real;
intfc_m_hdpldadapt_tx_mux #(
	.topology("UX16E400GPTP_XX_DISABLED_XX_DISABLED"),
	.maib_id(9),
	.num_ip_on_intfc_00(1),
	.num_ip_on_intfc_01(2),
	.num_ip_on_intfc_02(3),
	.num_ip_on_intfc_03(2),
	.num_ip_on_intfc_04(2),
	.num_ip_on_intfc_05(3),
	.num_ip_on_intfc_06(3),
	.num_ip_on_intfc_07(2),
	.num_ip_on_intfc_09(2),
	.num_ip_on_intfc_11(2),
	.num_ip_on_intfc_12(2),
	.num_ip_on_intfc_13(2),
	.num_ip_on_intfc_14(2)
) z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9(
	.io_pld_pcs_rx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_dcm_real),
	.io_pld_pcs_rx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out1_hioint_real),
	.io_pld_pcs_rx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_dcm_real),
	.io_pld_pcs_rx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_rx_clk_out2_hioint_real),
	.io_pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_dcm_real),
	.io_pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out1_hioint_real),
	.io_pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_dcm_real),
	.io_pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0_io_pld_pcs_tx_clk_out2_hioint_real),
	.hip_aib_fsr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_in_real),
	.hip_aib_fsr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_out_real),
	.hip_aib_ssr_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real),
	.hip_aib_ssr_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real),
	.pld_10g_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real),
	.pld_8g_tx_boundary_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real),
	.pld_adapter_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_adapter_tx_pld_rst_n_real),
	.pld_aib_fabric_tx_dcd_cal_done_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_aib_fabric_tx_dcd_cal_done_real),
	.pld_aib_hssi_tx_dll_lock_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_aib_hssi_tx_dll_lock_real),
	.pld_fabric_tx_transfer_en_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fabric_tx_transfer_en_real),
	.pld_fpll_shared_direct_async_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_real),
	.pld_fpll_shared_direct_async_in_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_rowclk_real),
	.pld_fpll_shared_direct_async_out_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_out_real),
	.pld_krfec_tx_alignment_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_krfec_tx_alignment_real),
	.pld_pcs_tx_clk_out1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out1_dcm_real),
	.pld_pcs_tx_clk_out1_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out1_hioint_real),
	.pld_pcs_tx_clk_out2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out2_dcm_real),
	.pld_pcs_tx_clk_out2_hioint_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out2_hioint_real),
	.pld_pcs_tx_pld_rst_n_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_pld_rst_n_real),
	.pld_pma_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_csr_test_dis_real),
	.pld_pma_fpll_clk0bad_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_clk0bad_real),
	.pld_pma_fpll_cnt_sel_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_cnt_sel_real),
	.pld_pma_fpll_extswitch_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_extswitch_real),
	.pld_pma_fpll_lc_csr_test_dis_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_lc_csr_test_dis_real),
	.pld_pma_fpll_num_phase_shifts_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_num_phase_shifts_real),
	.pld_pma_fpll_pfden_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_pfden_real),
	.pld_pma_fpll_up_dn_lc_lf_rstn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.pld_pma_nrpi_freeze_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_nrpi_freeze_real),
	.pld_pma_tx_bitslip_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_bitslip_real),
	.pld_pma_tx_qpi_pulldn_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_qpi_pulldn_real),
	.pld_pma_tx_qpi_pullup_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_qpi_pullup_real),
	.pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_txpma_rstb_real),
	.pld_pmaif_mask_tx_pll_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pmaif_mask_tx_pll_real),
	.pld_polinv_tx_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_polinv_tx_real),
	.pld_tx_clk1_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk1_dcm_real),
	.pld_tx_clk1_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk1_rowclk_real),
	.pld_tx_clk2_dcm_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk2_dcm_real),
	.pld_tx_clk2_rowclk_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk2_rowclk_real),
	.pld_tx_dll_lock_req_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_dll_lock_req_real),
	.pld_tx_fabric_data_in_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real),
	.pld_tx_fabric_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_empty_real),
	.pld_tx_fabric_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_full_real),
	.pld_tx_fabric_fifo_pempty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_pempty_real),
	.pld_tx_fabric_fifo_pfull_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_pfull_real),
	.pld_tx_fifo_ready_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fifo_ready_real),
	.pld_tx_hssi_fifo_empty_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_hssi_fifo_empty_real),
	.pld_tx_hssi_fifo_full_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_hssi_fifo_full_real),
	.pld_txelecidle_real(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_txelecidle_real),
	.intfc_00_one_hot_selector_real(z1577a_x0_y166_n0__reset_controller__one_hot_selector),
	.s_intfc_00_pld_pma_txpma_rstb_real(z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_txpma_rstb_real[9]),
	.intfc_01_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_01_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_rx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pulldn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pulldn[0],
		1'bz}),
	.s_intfc_01_pld_pma_tx_qpi_pullup_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_qpi_pullup[0],
		1'bz}),
	.intfc_02_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_02_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[4],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][4],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][0]}),
	.s_intfc_02_pld_8g_tx_boundary_sel_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_8g_tx_boundary_sel[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_02_pld_pma_fpll_lc_csr_test_dis_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_txbeacon_lx_a[0],
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_lc_csr_test_dis_real[9]}),
	.intfc_03_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_03_pld_10g_tx_bitslip_real({1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_10g_tx_bitslip_tx[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_04_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_04_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[5],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[1],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][5],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][1],
		1'bz}),
	.s_intfc_04_pld_pma_nrpi_freeze_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_nrpi_freeze[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_nrpi_freeze_real[9]}),
	.intfc_05_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_05_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_05_pld_pma_fpll_clk0bad_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.octl_pcs_rxstatus_lx_a[0],
		qtlg_wire_5743,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_fpll_clk0bad_real[9]}),
	.intfc_06_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_06_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[6],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[2],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][6],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][2],
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_csr_test_dis_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_csr_test_dis[0],
		1'bz}),
	.s_intfc_06_pld_pma_fpll_cnt_sel_real({1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2data_lx_a[0],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.ictl_pcs_rxovrcdrlock2dataen_lx_a[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_06_pld_pma_tx_bitslip_real({1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_tx_bitslip[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pma_tx_bitslip_real[9]}),
	.intfc_07_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_07_pld_10g_tx_bitslip_real({1'bz,
		1'bz,
		1'bz,
		1'b0,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_07_pld_polinv_tx_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_polinv_tx[0],
		1'bz}),
	.intfc_09_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_09_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[7],
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[3],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][7],
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][3],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_extswitch_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_extswitch[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_num_phase_shifts_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_num_phase_shifts[0],
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_09_pld_pma_fpll_pfden_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_pfden[0],
		1'bz}),
	.s_intfc_09_pld_pma_fpll_up_dn_lc_lf_rstn_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pma_fpll_up_dn_lc_lf_rstn[0],
		1'bz}),
	.intfc_11_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_11_pld_fpll_shared_direct_async_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.oct_pcs_all_synthlockstatus[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_out_real[9]}),
	.intfc_12_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,1'b0}),
	.s_intfc_12_pld_pmaif_mask_tx_pll_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pmaif_mask_tx_pll[0],
		qtlg_wire_5744}),
	.s_intfc_12_pld_txelecidle_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_txelecidle[0],
		1'bz}),
	.intfc_13_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_13_hip_aib_ssr_in_real({1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][15],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][14],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][13],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][12],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][11],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][10],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][9],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][8],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.intfc_14_one_hot_selector_real({bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector,z1577a_x0_y166_n0__reset_controller__one_hot_selector}),
	.s_intfc_14_hip_aib_fsr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_in[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[9][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[9][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_fsr_in_real[9][0]}),
	.s_intfc_14_hip_aib_fsr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_fsr_out[0],
		qtlg_wire_5745,
		qtlg_wire_5746,
		qtlg_wire_5747,
		qtlg_wire_5748}),
	.s_intfc_14_hip_aib_ssr_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_in[16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][39],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][38],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][37],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][36],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][35],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][34],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][33],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][32],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][31],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][30],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][29],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][28],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][27],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][26],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][25],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][24],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][23],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][22],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][21],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][20],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][19],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][18],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][17],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_in_real[9][16],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_hip_aib_ssr_out_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.hip_aib_ssr_out[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][7],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][6],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][5],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][4],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][3],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][2],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__hip_aib_ssr_out_real[9][0]}),
	.s_intfc_14_pld_adapter_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_adapter_tx_pld_rst_n_real[9]}),
	.s_intfc_14_pld_aib_fabric_tx_dcd_cal_done_real({qtlg_wire_5749,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_fabric_tx_dcd_cal_done_real[9]}),
	.s_intfc_14_pld_aib_hssi_tx_dll_lock_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_dll_lock[0],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_aib_hssi_tx_dll_lock_real[9]}),
	.s_intfc_14_pld_fabric_tx_transfer_en_real({qtlg_wire_5750,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fabric_tx_transfer_en_real[9]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_real({1'bz,
		1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[9][1],
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_real[9][0]}),
	.s_intfc_14_pld_fpll_shared_direct_async_in_rowclk_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_fpll_shared_direct_async_in_rowclk_real[9]}),
	.s_intfc_14_pld_krfec_tx_alignment_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_krfec_tx_alignment[0],
		qtlg_wire_5751}),
	.s_intfc_14_pld_pcs_tx_clk_out1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_dcm[0],
		qtlg_wire_5752}),
	.s_intfc_14_pld_pcs_tx_clk_out1_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out1_hioint[0],
		qtlg_wire_5753}),
	.s_intfc_14_pld_pcs_tx_clk_out2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_dcm[0],
		qtlg_wire_5754}),
	.s_intfc_14_pld_pcs_tx_clk_out2_hioint_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_pcs_tx_clk_out2_hioint[0],
		qtlg_wire_5755}),
	.s_intfc_14_pld_pcs_tx_pld_rst_n_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_pcs_tx_pld_rst_n_real[9]}),
	.s_intfc_14_pld_tx_clk1_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk1_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk1_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_dcm_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_dcm[0],
		1'bz}),
	.s_intfc_14_pld_tx_clk2_rowclk_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_clk2_rowclk[0],
		1'bz}),
	.s_intfc_14_pld_tx_dll_lock_req_real({1'bz,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_dll_lock_req_real[9]}),
	.s_intfc_14_pld_tx_fabric_data_in_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[79],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[78],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[77],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[76],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[75],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[74],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[73],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[72],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[71],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[70],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[69],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[68],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[67],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[66],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[65],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[64],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[63],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[62],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[61],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[60],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[59],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[58],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[57],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[56],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[55],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[54],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[53],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[52],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[51],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[50],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[49],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[48],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[47],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[46],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[45],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[44],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[43],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[42],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[41],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[40],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[39],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[38],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[37],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[36],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[35],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[34],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[33],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[32],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[31],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[30],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[29],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[28],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[27],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[26],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[25],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[24],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[23],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[22],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[21],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[20],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[19],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[18],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[17],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[16],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[15],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[14],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[13],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[12],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[11],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[10],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[9],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[8],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[7],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[6],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[5],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[4],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[3],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[2],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[1],
		`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.sync_data_to_aib[0],
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz,
		1'bz}),
	.s_intfc_14_pld_tx_fabric_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_empty[0],
		qtlg_wire_5756}),
	.s_intfc_14_pld_tx_fabric_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_full[0],
		qtlg_wire_5757}),
	.s_intfc_14_pld_tx_fabric_fifo_pempty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pempty[0],
		qtlg_wire_5758}),
	.s_intfc_14_pld_tx_fabric_fifo_pfull_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_fifo_pfull[0],
		qtlg_wire_5759}),
	.s_intfc_14_pld_tx_fifo_ready_real({qtlg_wire_5760,
		z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_hip_v1.x_bb_m_hdpldadapt_tx__pld_tx_fifo_ready_real[9]}),
	.s_intfc_14_pld_tx_hssi_fifo_empty_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_empty[0],
		qtlg_wire_5761}),
	.s_intfc_14_pld_tx_hssi_fifo_full_real({`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.pld_tx_hssi_fifo_full[0],
		qtlg_wire_5762}));
assign z1577a_x0_y166_n0__reset_controller__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_0__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_1__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_10__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_11__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_12__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_13__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_14__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_15__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_2__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_3__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_4__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_5__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_6__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_7__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_8__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__ftile_xcvr_test_9__directphy_f_0__directphy_f_0__one_hot_selector = 1'b1;
assign bts_xcvr__q_sys_u0__systemclk_f_0__systemclk_f_0__one_hot_selector = 1'b1;
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[4];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[4];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[4];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[4];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[4];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[5];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[5];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[5];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[5];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[5];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[14];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[14];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[14];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[14];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[14];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[15];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[15];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[15];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[15];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[15];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[16];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[16];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[16];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[16];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[16];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[17];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[17];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[17];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[17];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[17];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[18];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[18];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[18];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[18];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[18];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[19];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[19];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[19];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[19];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[19];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[6];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[6];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[6];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[6];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[6];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[7];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[7];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[7];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[7];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[7];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[8];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[8];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[8];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[8];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[8];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[9];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[9];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[9];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[9];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[9];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[10];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[10];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[10];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[10];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[10];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[11];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[11];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[11];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[11];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[11];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[12];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[12];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[12];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[12];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[12];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_alarm[13];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_current_state[13];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_start[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_start[13];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_alarm[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_alarm[13];
assign `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_current_state[0] = z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_current_state[13];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[10] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[11] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[12] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[13] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[14] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[15] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[16] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[17] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[18] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[19] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[4] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[5] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[6] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[7] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[8] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_clear_alarm[9] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[10] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[11] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[12] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[13] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[14] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[15] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[16] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[17] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[18] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[19] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[4] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[5] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[6] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[7] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[8] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.rx_lane_desired_state[9] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.rx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[10] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[11] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[12] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[13] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[14] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[15] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[16] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[17] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[18] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[19] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[4] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[5] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[6] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[7] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[8] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_am_gen_2x_ack[9] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_am_gen_2x_ack[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[10] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[11] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[12] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[13] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[14] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[15] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[16] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[17] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[18] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[19] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[4] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[5] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[6] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[7] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[8] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.sip_rx_ignore_lock2data[9] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.sip_rx_ignore_lock2data[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[10] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[11] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[12] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[13] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[14] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[15] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[16] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[17] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[18] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[19] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[4] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[5] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[6] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[7] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[8] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_clear_alarm[9] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_clear_alarm[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[10] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[11] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[12] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[13] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[14] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[15] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[16] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[17] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[18] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[19] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[4] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[5] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[6] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[7] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[8] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
assign z1577a_x0_y166_n0__reset_controller.x_f_tile_soft_reset_ctlr_sip_v1.tx_lane_desired_state[9] = `QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_sip_inst.tx_lane_desired_state[0];
wire z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u22_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u23_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u24_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u25_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u2_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u2_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u2_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u3_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u3_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u3_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u4_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u4_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u4_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u5_2_hdpldadapt_pld_avmm2_reserved_out_2_;
wire z1577a_x0_y166_n0__x0_x0_u5_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u5_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
wire z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_3_;
wire z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_2_;
wire z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_1_;
wire z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_0_;
wire z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_;
wire z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_;
ftile_ag_v0 z1577a_x0_y166_n0(
	.refclk_p_q1_ch0_uxclkrx(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.systemclk_f_0.systemclk_f_0.in_refclk_fgt_2),
	.rx_n_q0_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q0_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q0_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q0_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q1_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q1_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q1_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q1_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q2_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q2_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q2_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q2_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q3_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q3_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q3_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_n_q3_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data_n[0]),
	.rx_p_q0_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q0_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q0_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q0_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q1_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q1_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q1_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q1_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q2_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q2_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q2_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q2_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q3_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q3_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q3_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.rx_p_q3_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.rx_serial_data[0]),
	.tx_n_q0_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q0_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q0_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q0_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q1_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q1_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q1_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q1_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q2_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q2_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q2_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q2_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q3_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q3_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q3_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_n_q3_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data_n[0]),
	.tx_p_q0_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_0.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q0_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_1.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q0_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_2.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q0_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_3.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q1_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_4.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q1_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_5.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q1_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_6.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q1_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_7.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q2_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_8.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q2_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_9.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q2_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_10.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q2_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_11.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q3_ch0_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_12.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q3_ch1_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_13.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q3_ch2_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_14.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.tx_p_q3_ch3_ux(`QUARTUS_TLG__TOP_LEVEL_ENTITY_INSTANCE_PATH.q_sys_u0.ftile_xcvr_test_15.directphy_f_0.directphy_f_0.dphy_hip_inst.tx_serial_data[0]),
	.x0_x0_u10_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_in_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_fsr_out_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_in_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__hip_aib_ssr_out_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_8__hip_avmm_read_real),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdata_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_8__hip_avmm_readdatavalid_real),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_8__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_8__hip_avmm_write_real),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedata_real[0] }),
	.x0_x0_u10_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_8__hip_avmm_writedone_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_krfec_rx_frame_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_crc32_err_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_frame_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_10g_rx_hi_ber_real),
	.x0_x0_u10_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_bitloc_rev_en_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_byte_rev_en_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_empty_rmf_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_encdt_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_full_rmf_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_rxelecidle_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_signal_detect_out_real),
	.x0_x0_u10_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u10_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u10_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u10_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u10_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_busy_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_clk_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_read_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdata_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_readdatavalid_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_request_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_8__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fifo_ready_real }),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_8__pld_avmm2_write_real),
	.x0_x0_u10_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_8__pld_avmm2_writedata_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fabric_tx_transfer_en_real),
	.x0_x0_u10_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u10_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_hssi_rx_transfer_en_real),
	.x0_x0_u10_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_krfec_tx_alignment_real),
	.x0_x0_u10_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_ltr_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u10_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u10_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_8__pld_pll_cal_done_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_adapt_start_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_csr_test_dis_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_early_eios_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_clk0bad_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u10_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_extswitch_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_pfden_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_nrpi_freeze_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_pfdmode_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_ppm_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_in_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_reserved_out_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rs_lpbk_b_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rx_found_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rxpll_lock_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_rxpma_rstb_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pma_signal_ok_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_bitslip_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u10_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pma_txpma_rstb_real),
	.x0_x0_u10_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u10_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_pmaif_rxclkslip_real),
	.x0_x0_u10_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_polinv_rx_real),
	.x0_x0_u10_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_polinv_tx_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk1_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk1_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_clk2_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_dll_lock_req_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_full_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_hssi_fifo_full_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_done_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_err_real),
	.x0_x0_u10_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_rx_prbs_err_clr_real),
	.x0_x0_u10_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_sclk1_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_sclk2_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_syncsm_en_real),
	.x0_x0_u10_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_8__pld_test_data_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk1_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk1_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk2_dcm_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_clk2_rowclk_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_dll_lock_req_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u10_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_full_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u10_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_tx_hssi_fifo_full_real),
	.x0_x0_u10_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_8__pld_txelecidle_real),
	.x0_x0_u11_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_in_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_fsr_out_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_in_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__hip_aib_ssr_out_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_9__hip_avmm_read_real),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdata_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_9__hip_avmm_readdatavalid_real),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_9__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_9__hip_avmm_write_real),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedata_real[0] }),
	.x0_x0_u11_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_9__hip_avmm_writedone_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_krfec_rx_frame_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_crc32_err_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_frame_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_10g_rx_hi_ber_real),
	.x0_x0_u11_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_bitloc_rev_en_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_byte_rev_en_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_empty_rmf_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_encdt_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_full_rmf_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_rxelecidle_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_signal_detect_out_real),
	.x0_x0_u11_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u11_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u11_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u11_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u11_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_busy_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_clk_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_read_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdata_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_readdatavalid_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_request_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_9__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fifo_ready_real }),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_9__pld_avmm2_write_real),
	.x0_x0_u11_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_9__pld_avmm2_writedata_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fabric_tx_transfer_en_real),
	.x0_x0_u11_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u11_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_hssi_rx_transfer_en_real),
	.x0_x0_u11_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_krfec_tx_alignment_real),
	.x0_x0_u11_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_ltr_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u11_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u11_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_9__pld_pll_cal_done_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_adapt_start_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_csr_test_dis_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_early_eios_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_clk0bad_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u11_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_extswitch_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_pfden_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_nrpi_freeze_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_pfdmode_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_ppm_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_in_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_reserved_out_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rs_lpbk_b_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rx_found_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rxpll_lock_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_rxpma_rstb_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pma_signal_ok_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_bitslip_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u11_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pma_txpma_rstb_real),
	.x0_x0_u11_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u11_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_pmaif_rxclkslip_real),
	.x0_x0_u11_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_polinv_rx_real),
	.x0_x0_u11_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_polinv_tx_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk1_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk1_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_clk2_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_dll_lock_req_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_full_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_hssi_fifo_full_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_done_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_err_real),
	.x0_x0_u11_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_rx_prbs_err_clr_real),
	.x0_x0_u11_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_sclk1_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_sclk2_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_syncsm_en_real),
	.x0_x0_u11_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_9__pld_test_data_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk1_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk1_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk2_dcm_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_clk2_rowclk_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_dll_lock_req_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u11_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_full_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u11_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_tx_hssi_fifo_full_real),
	.x0_x0_u11_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_9__pld_txelecidle_real),
	.x0_x0_u12_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_in_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_fsr_out_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_in_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__hip_aib_ssr_out_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_10__hip_avmm_read_real),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdata_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_10__hip_avmm_readdatavalid_real),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_10__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_10__hip_avmm_write_real),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedata_real[0] }),
	.x0_x0_u12_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_10__hip_avmm_writedone_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_krfec_rx_frame_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_crc32_err_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_frame_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_10g_rx_hi_ber_real),
	.x0_x0_u12_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_bitloc_rev_en_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_byte_rev_en_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_empty_rmf_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_encdt_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_full_rmf_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_rxelecidle_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_signal_detect_out_real),
	.x0_x0_u12_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u12_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u12_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u12_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u12_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_busy_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_clk_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_read_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdata_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_readdatavalid_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_request_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_10__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fifo_ready_real }),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_10__pld_avmm2_write_real),
	.x0_x0_u12_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_10__pld_avmm2_writedata_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fabric_tx_transfer_en_real),
	.x0_x0_u12_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u12_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_hssi_rx_transfer_en_real),
	.x0_x0_u12_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_krfec_tx_alignment_real),
	.x0_x0_u12_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_ltr_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u12_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u12_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_10__pld_pll_cal_done_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_adapt_start_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_csr_test_dis_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_early_eios_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_clk0bad_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u12_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_extswitch_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_pfden_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_nrpi_freeze_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_pfdmode_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_ppm_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_in_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_reserved_out_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rs_lpbk_b_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rx_found_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rxpll_lock_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_rxpma_rstb_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pma_signal_ok_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_bitslip_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u12_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pma_txpma_rstb_real),
	.x0_x0_u12_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u12_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_pmaif_rxclkslip_real),
	.x0_x0_u12_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_polinv_rx_real),
	.x0_x0_u12_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_polinv_tx_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk1_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk1_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_clk2_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_dll_lock_req_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_full_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_hssi_fifo_full_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_done_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_err_real),
	.x0_x0_u12_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_rx_prbs_err_clr_real),
	.x0_x0_u12_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_sclk1_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_sclk2_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_syncsm_en_real),
	.x0_x0_u12_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_10__pld_test_data_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk1_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk1_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk2_dcm_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_clk2_rowclk_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_dll_lock_req_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u12_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_full_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u12_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_tx_hssi_fifo_full_real),
	.x0_x0_u12_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_10__pld_txelecidle_real),
	.x0_x0_u13_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_in_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_fsr_out_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_in_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__hip_aib_ssr_out_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_11__hip_avmm_read_real),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdata_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_11__hip_avmm_readdatavalid_real),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_11__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_11__hip_avmm_write_real),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedata_real[0] }),
	.x0_x0_u13_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_11__hip_avmm_writedone_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_krfec_rx_frame_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_crc32_err_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_frame_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_10g_rx_hi_ber_real),
	.x0_x0_u13_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_bitloc_rev_en_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_byte_rev_en_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_empty_rmf_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_encdt_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_full_rmf_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_rxelecidle_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_signal_detect_out_real),
	.x0_x0_u13_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u13_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u13_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u13_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u13_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_busy_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_clk_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_read_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdata_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_readdatavalid_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_request_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_11__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fifo_ready_real }),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_11__pld_avmm2_write_real),
	.x0_x0_u13_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_11__pld_avmm2_writedata_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fabric_tx_transfer_en_real),
	.x0_x0_u13_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u13_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_hssi_rx_transfer_en_real),
	.x0_x0_u13_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_krfec_tx_alignment_real),
	.x0_x0_u13_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_ltr_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u13_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u13_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_11__pld_pll_cal_done_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_adapt_start_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_csr_test_dis_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_early_eios_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_clk0bad_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u13_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_extswitch_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_pfden_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_nrpi_freeze_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_pfdmode_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_ppm_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_in_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_reserved_out_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rs_lpbk_b_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rx_found_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rxpll_lock_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_rxpma_rstb_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pma_signal_ok_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_bitslip_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u13_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pma_txpma_rstb_real),
	.x0_x0_u13_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u13_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_pmaif_rxclkslip_real),
	.x0_x0_u13_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_polinv_rx_real),
	.x0_x0_u13_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_polinv_tx_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk1_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk1_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_clk2_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_dll_lock_req_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_full_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_hssi_fifo_full_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_done_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_err_real),
	.x0_x0_u13_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_rx_prbs_err_clr_real),
	.x0_x0_u13_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_sclk1_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_sclk2_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_syncsm_en_real),
	.x0_x0_u13_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_11__pld_test_data_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk1_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk1_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk2_dcm_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_clk2_rowclk_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_dll_lock_req_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u13_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_full_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u13_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_tx_hssi_fifo_full_real),
	.x0_x0_u13_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_11__pld_txelecidle_real),
	.x0_x0_u14_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_in_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_fsr_out_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_in_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__hip_aib_ssr_out_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_12__hip_avmm_read_real),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdata_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_12__hip_avmm_readdatavalid_real),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_12__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_12__hip_avmm_write_real),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedata_real[0] }),
	.x0_x0_u14_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_12__hip_avmm_writedone_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_krfec_rx_frame_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_crc32_err_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_frame_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_10g_rx_hi_ber_real),
	.x0_x0_u14_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_bitloc_rev_en_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_byte_rev_en_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_empty_rmf_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_encdt_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_full_rmf_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_rxelecidle_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_signal_detect_out_real),
	.x0_x0_u14_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u14_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u14_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u14_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u14_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_busy_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_clk_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_read_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdata_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_readdatavalid_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_request_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_12__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fifo_ready_real }),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_12__pld_avmm2_write_real),
	.x0_x0_u14_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_12__pld_avmm2_writedata_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fabric_tx_transfer_en_real),
	.x0_x0_u14_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u14_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_hssi_rx_transfer_en_real),
	.x0_x0_u14_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_krfec_tx_alignment_real),
	.x0_x0_u14_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_ltr_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u14_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u14_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_12__pld_pll_cal_done_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_adapt_start_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_csr_test_dis_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_early_eios_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_clk0bad_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u14_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_extswitch_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_pfden_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_nrpi_freeze_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_pfdmode_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_ppm_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_in_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_reserved_out_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rs_lpbk_b_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rx_found_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rxpll_lock_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_rxpma_rstb_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pma_signal_ok_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_bitslip_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u14_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pma_txpma_rstb_real),
	.x0_x0_u14_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u14_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_pmaif_rxclkslip_real),
	.x0_x0_u14_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_polinv_rx_real),
	.x0_x0_u14_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_polinv_tx_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk1_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk1_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_clk2_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_dll_lock_req_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_full_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_hssi_fifo_full_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_done_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_err_real),
	.x0_x0_u14_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_rx_prbs_err_clr_real),
	.x0_x0_u14_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_sclk1_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_sclk2_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_syncsm_en_real),
	.x0_x0_u14_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_12__pld_test_data_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk1_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk1_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk2_dcm_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_clk2_rowclk_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_dll_lock_req_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u14_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_full_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u14_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_tx_hssi_fifo_full_real),
	.x0_x0_u14_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_12__pld_txelecidle_real),
	.x0_x0_u15_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_in_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_fsr_out_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_in_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__hip_aib_ssr_out_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_13__hip_avmm_read_real),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdata_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_13__hip_avmm_readdatavalid_real),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_13__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_13__hip_avmm_write_real),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedata_real[0] }),
	.x0_x0_u15_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_13__hip_avmm_writedone_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_krfec_rx_frame_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_crc32_err_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_frame_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_10g_rx_hi_ber_real),
	.x0_x0_u15_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_bitloc_rev_en_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_byte_rev_en_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_empty_rmf_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_encdt_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_full_rmf_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_rxelecidle_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_signal_detect_out_real),
	.x0_x0_u15_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u15_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u15_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u15_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u15_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_busy_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_clk_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_read_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdata_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_readdatavalid_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_request_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_13__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fifo_ready_real }),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_13__pld_avmm2_write_real),
	.x0_x0_u15_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_13__pld_avmm2_writedata_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fabric_tx_transfer_en_real),
	.x0_x0_u15_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u15_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_hssi_rx_transfer_en_real),
	.x0_x0_u15_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_krfec_tx_alignment_real),
	.x0_x0_u15_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_ltr_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u15_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u15_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_13__pld_pll_cal_done_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_adapt_start_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_csr_test_dis_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_early_eios_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_clk0bad_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u15_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_extswitch_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_pfden_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_nrpi_freeze_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_pfdmode_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_ppm_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_in_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_reserved_out_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rs_lpbk_b_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rx_found_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rxpll_lock_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_rxpma_rstb_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pma_signal_ok_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_bitslip_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u15_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pma_txpma_rstb_real),
	.x0_x0_u15_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u15_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_pmaif_rxclkslip_real),
	.x0_x0_u15_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_polinv_rx_real),
	.x0_x0_u15_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_polinv_tx_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk1_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk1_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_clk2_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_dll_lock_req_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_full_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_hssi_fifo_full_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_done_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_err_real),
	.x0_x0_u15_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_rx_prbs_err_clr_real),
	.x0_x0_u15_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_sclk1_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_sclk2_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_syncsm_en_real),
	.x0_x0_u15_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_13__pld_test_data_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk1_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk1_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk2_dcm_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_clk2_rowclk_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_dll_lock_req_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u15_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_full_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u15_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_tx_hssi_fifo_full_real),
	.x0_x0_u15_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_13__pld_txelecidle_real),
	.x0_x0_u16_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_in_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_fsr_out_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_in_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__hip_aib_ssr_out_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_14__hip_avmm_read_real),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdata_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_14__hip_avmm_readdatavalid_real),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_14__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_14__hip_avmm_write_real),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedata_real[0] }),
	.x0_x0_u16_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_14__hip_avmm_writedone_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_krfec_rx_frame_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_crc32_err_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_frame_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_10g_rx_hi_ber_real),
	.x0_x0_u16_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_bitloc_rev_en_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_byte_rev_en_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_empty_rmf_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_encdt_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_full_rmf_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_rxelecidle_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_signal_detect_out_real),
	.x0_x0_u16_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u16_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u16_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u16_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u16_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_busy_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_clk_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_read_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdata_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_readdatavalid_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_request_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_14__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fifo_ready_real }),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_14__pld_avmm2_write_real),
	.x0_x0_u16_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_14__pld_avmm2_writedata_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fabric_tx_transfer_en_real),
	.x0_x0_u16_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u16_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_hssi_rx_transfer_en_real),
	.x0_x0_u16_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_krfec_tx_alignment_real),
	.x0_x0_u16_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_ltr_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u16_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u16_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_14__pld_pll_cal_done_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_adapt_start_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_csr_test_dis_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_early_eios_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_clk0bad_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u16_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_extswitch_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_pfden_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_nrpi_freeze_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_pfdmode_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_ppm_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_in_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_reserved_out_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rs_lpbk_b_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rx_found_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rxpll_lock_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_rxpma_rstb_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pma_signal_ok_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_bitslip_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u16_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pma_txpma_rstb_real),
	.x0_x0_u16_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u16_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_pmaif_rxclkslip_real),
	.x0_x0_u16_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_polinv_rx_real),
	.x0_x0_u16_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_polinv_tx_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk1_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk1_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_clk2_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_dll_lock_req_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_full_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_hssi_fifo_full_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_done_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_err_real),
	.x0_x0_u16_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_rx_prbs_err_clr_real),
	.x0_x0_u16_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_sclk1_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_sclk2_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_syncsm_en_real),
	.x0_x0_u16_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_14__pld_test_data_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk1_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk1_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk2_dcm_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_clk2_rowclk_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_dll_lock_req_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u16_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_full_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u16_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_tx_hssi_fifo_full_real),
	.x0_x0_u16_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_14__pld_txelecidle_real),
	.x0_x0_u17_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_in_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_fsr_out_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_in_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__hip_aib_ssr_out_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_15__hip_avmm_read_real),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdata_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_15__hip_avmm_readdatavalid_real),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_15__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_15__hip_avmm_write_real),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedata_real[0] }),
	.x0_x0_u17_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_15__hip_avmm_writedone_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_krfec_rx_frame_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_crc32_err_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_frame_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_10g_rx_hi_ber_real),
	.x0_x0_u17_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_bitloc_rev_en_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_byte_rev_en_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_empty_rmf_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_encdt_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_full_rmf_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_rxelecidle_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_signal_detect_out_real),
	.x0_x0_u17_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u17_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u17_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u17_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u17_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_busy_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_clk_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_read_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdata_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_readdatavalid_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_request_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_15__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fifo_ready_real }),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_15__pld_avmm2_write_real),
	.x0_x0_u17_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_15__pld_avmm2_writedata_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fabric_tx_transfer_en_real),
	.x0_x0_u17_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u17_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_hssi_rx_transfer_en_real),
	.x0_x0_u17_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_krfec_tx_alignment_real),
	.x0_x0_u17_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_ltr_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u17_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u17_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_15__pld_pll_cal_done_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_adapt_start_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_csr_test_dis_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_early_eios_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_clk0bad_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u17_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_extswitch_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_pfden_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_nrpi_freeze_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_pfdmode_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_ppm_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_in_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_reserved_out_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rs_lpbk_b_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rx_found_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rxpll_lock_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_rxpma_rstb_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pma_signal_ok_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_bitslip_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u17_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pma_txpma_rstb_real),
	.x0_x0_u17_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u17_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_pmaif_rxclkslip_real),
	.x0_x0_u17_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_polinv_rx_real),
	.x0_x0_u17_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_polinv_tx_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk1_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk1_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_clk2_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_dll_lock_req_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_full_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_hssi_fifo_full_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_done_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_err_real),
	.x0_x0_u17_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_rx_prbs_err_clr_real),
	.x0_x0_u17_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_sclk1_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_sclk2_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_syncsm_en_real),
	.x0_x0_u17_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_15__pld_test_data_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk1_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk1_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk2_dcm_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_clk2_rowclk_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_dll_lock_req_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u17_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_full_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u17_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_tx_hssi_fifo_full_real),
	.x0_x0_u17_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_15__pld_txelecidle_real),
	.x0_x0_u18_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_in_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_fsr_out_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_in_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__hip_aib_ssr_out_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_16__hip_avmm_read_real),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdata_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_16__hip_avmm_readdatavalid_real),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_16__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_16__hip_avmm_write_real),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedata_real[0] }),
	.x0_x0_u18_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_16__hip_avmm_writedone_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_krfec_rx_frame_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_crc32_err_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_frame_lock_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_10g_rx_hi_ber_real),
	.x0_x0_u18_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_bitloc_rev_en_real),
	.x0_x0_u18_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_byte_rev_en_real),
	.x0_x0_u18_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_empty_rmf_real),
	.x0_x0_u18_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_encdt_real),
	.x0_x0_u18_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_full_rmf_real),
	.x0_x0_u18_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_rxelecidle_real),
	.x0_x0_u18_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u18_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u18_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u18_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u18_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u18_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_busy_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_clk_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_read_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdata_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_readdatavalid_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_request_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_16__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fifo_ready_real }),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_16__pld_avmm2_write_real),
	.x0_x0_u18_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_16__pld_avmm2_writedata_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fabric_tx_transfer_en_real),
	.x0_x0_u18_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u18_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_hssi_rx_transfer_en_real),
	.x0_x0_u18_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_krfec_tx_alignment_real),
	.x0_x0_u18_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_ltr_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u18_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u18_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_16__pld_pll_cal_done_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_adapt_start_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_csr_test_dis_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_early_eios_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_clk0bad_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_extswitch_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_pfden_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_nrpi_freeze_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_ppm_lock_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_in_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_reserved_out_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rs_lpbk_b_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rx_found_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rxpll_lock_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_rxpma_rstb_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pma_signal_ok_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_bitslip_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u18_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pma_txpma_rstb_real),
	.x0_x0_u18_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u18_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_pmaif_rxclkslip_real),
	.x0_x0_u18_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_polinv_rx_real),
	.x0_x0_u18_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_polinv_tx_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk1_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk1_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_clk2_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_dll_lock_req_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_full_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_hssi_fifo_full_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_done_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_err_real),
	.x0_x0_u18_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_rx_prbs_err_clr_real),
	.x0_x0_u18_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_sclk1_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_sclk2_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_syncsm_en_real),
	.x0_x0_u18_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_16__pld_test_data_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk1_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk1_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk2_dcm_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_clk2_rowclk_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_dll_lock_req_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u18_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_full_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u18_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_tx_hssi_fifo_full_real),
	.x0_x0_u18_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_16__pld_txelecidle_real),
	.x0_x0_u19_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_in_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_fsr_out_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_in_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__hip_aib_ssr_out_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_17__hip_avmm_read_real),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdata_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_17__hip_avmm_readdatavalid_real),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_17__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_17__hip_avmm_write_real),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedata_real[0] }),
	.x0_x0_u19_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_17__hip_avmm_writedone_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_krfec_rx_frame_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_crc32_err_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_frame_lock_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_10g_rx_hi_ber_real),
	.x0_x0_u19_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_bitloc_rev_en_real),
	.x0_x0_u19_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_byte_rev_en_real),
	.x0_x0_u19_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_empty_rmf_real),
	.x0_x0_u19_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_encdt_real),
	.x0_x0_u19_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_full_rmf_real),
	.x0_x0_u19_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_rxelecidle_real),
	.x0_x0_u19_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u19_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u19_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u19_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u19_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u19_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_busy_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_clk_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_read_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdata_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_readdatavalid_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_request_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_17__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fifo_ready_real }),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_17__pld_avmm2_write_real),
	.x0_x0_u19_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_17__pld_avmm2_writedata_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fabric_tx_transfer_en_real),
	.x0_x0_u19_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u19_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_hssi_rx_transfer_en_real),
	.x0_x0_u19_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_krfec_tx_alignment_real),
	.x0_x0_u19_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_ltr_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u19_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u19_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_17__pld_pll_cal_done_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_adapt_start_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_csr_test_dis_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_early_eios_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_clk0bad_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_extswitch_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_pfden_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_nrpi_freeze_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_ppm_lock_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_in_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_reserved_out_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rs_lpbk_b_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rx_found_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rxpll_lock_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_rxpma_rstb_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pma_signal_ok_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_bitslip_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u19_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pma_txpma_rstb_real),
	.x0_x0_u19_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u19_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_pmaif_rxclkslip_real),
	.x0_x0_u19_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_polinv_rx_real),
	.x0_x0_u19_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_polinv_tx_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk1_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk1_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_clk2_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_dll_lock_req_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_full_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_hssi_fifo_full_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_done_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_err_real),
	.x0_x0_u19_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_rx_prbs_err_clr_real),
	.x0_x0_u19_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_sclk1_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_sclk2_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_syncsm_en_real),
	.x0_x0_u19_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_17__pld_test_data_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk1_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk1_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk2_dcm_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_clk2_rowclk_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_dll_lock_req_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u19_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_full_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u19_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_tx_hssi_fifo_full_real),
	.x0_x0_u19_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_17__pld_txelecidle_real),
	.x0_x0_u20_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_in_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_fsr_out_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_in_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__hip_aib_ssr_out_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_18__hip_avmm_read_real),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdata_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_18__hip_avmm_readdatavalid_real),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_18__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_18__hip_avmm_write_real),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedata_real[0] }),
	.x0_x0_u20_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_18__hip_avmm_writedone_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_krfec_rx_frame_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_crc32_err_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_frame_lock_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_10g_rx_hi_ber_real),
	.x0_x0_u20_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_bitloc_rev_en_real),
	.x0_x0_u20_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_byte_rev_en_real),
	.x0_x0_u20_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_empty_rmf_real),
	.x0_x0_u20_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_encdt_real),
	.x0_x0_u20_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_full_rmf_real),
	.x0_x0_u20_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_rxelecidle_real),
	.x0_x0_u20_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u20_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u20_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u20_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u20_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u20_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_busy_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_clk_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_read_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdata_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_readdatavalid_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_request_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_18__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fifo_ready_real }),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_18__pld_avmm2_write_real),
	.x0_x0_u20_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_18__pld_avmm2_writedata_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fabric_tx_transfer_en_real),
	.x0_x0_u20_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u20_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_hssi_rx_transfer_en_real),
	.x0_x0_u20_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_krfec_tx_alignment_real),
	.x0_x0_u20_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_ltr_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u20_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u20_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_18__pld_pll_cal_done_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_adapt_start_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_csr_test_dis_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_early_eios_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_clk0bad_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_extswitch_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_pfden_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_nrpi_freeze_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_ppm_lock_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_in_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_reserved_out_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rs_lpbk_b_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rx_found_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rxpll_lock_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_rxpma_rstb_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pma_signal_ok_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_bitslip_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u20_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pma_txpma_rstb_real),
	.x0_x0_u20_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u20_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_pmaif_rxclkslip_real),
	.x0_x0_u20_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_polinv_rx_real),
	.x0_x0_u20_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_polinv_tx_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk1_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk1_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_clk2_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_dll_lock_req_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_full_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_hssi_fifo_full_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_done_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_err_real),
	.x0_x0_u20_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_rx_prbs_err_clr_real),
	.x0_x0_u20_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_sclk1_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_sclk2_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_syncsm_en_real),
	.x0_x0_u20_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_18__pld_test_data_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk1_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk1_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk2_dcm_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_clk2_rowclk_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_dll_lock_req_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u20_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_full_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u20_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_tx_hssi_fifo_full_real),
	.x0_x0_u20_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_18__pld_txelecidle_real),
	.x0_x0_u21_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_in_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_fsr_out_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_in_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__hip_aib_ssr_out_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_19__hip_avmm_read_real),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdata_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_19__hip_avmm_readdatavalid_real),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_19__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_19__hip_avmm_write_real),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedata_real[0] }),
	.x0_x0_u21_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_19__hip_avmm_writedone_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_krfec_rx_frame_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_crc32_err_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_frame_lock_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_10g_rx_hi_ber_real),
	.x0_x0_u21_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_bitloc_rev_en_real),
	.x0_x0_u21_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_byte_rev_en_real),
	.x0_x0_u21_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_empty_rmf_real),
	.x0_x0_u21_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_encdt_real),
	.x0_x0_u21_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_full_rmf_real),
	.x0_x0_u21_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_rxelecidle_real),
	.x0_x0_u21_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u21_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u21_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u21_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u21_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u21_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_busy_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_clk_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_read_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdata_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_readdatavalid_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_request_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_19__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fifo_ready_real }),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_19__pld_avmm2_write_real),
	.x0_x0_u21_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_19__pld_avmm2_writedata_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fabric_tx_transfer_en_real),
	.x0_x0_u21_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u21_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_hssi_rx_transfer_en_real),
	.x0_x0_u21_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_krfec_tx_alignment_real),
	.x0_x0_u21_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_ltr_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u21_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u21_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_19__pld_pll_cal_done_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_adapt_start_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_csr_test_dis_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_early_eios_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_clk0bad_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_extswitch_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_pfden_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_nrpi_freeze_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_ppm_lock_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_in_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_reserved_out_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rs_lpbk_b_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rx_found_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rxpll_lock_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_rxpma_rstb_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pma_signal_ok_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_bitslip_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u21_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pma_txpma_rstb_real),
	.x0_x0_u21_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u21_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_pmaif_rxclkslip_real),
	.x0_x0_u21_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_polinv_rx_real),
	.x0_x0_u21_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_polinv_tx_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk1_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk1_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_clk2_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_dll_lock_req_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_full_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_hssi_fifo_full_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_done_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_err_real),
	.x0_x0_u21_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_rx_prbs_err_clr_real),
	.x0_x0_u21_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_sclk1_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_sclk2_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_syncsm_en_real),
	.x0_x0_u21_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_19__pld_test_data_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk1_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk1_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk2_dcm_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_clk2_rowclk_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_dll_lock_req_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u21_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_full_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u21_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_tx_hssi_fifo_full_real),
	.x0_x0_u21_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_19__pld_txelecidle_real),
	.x0_x0_u22_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_in_real[0] }),
	.x0_x0_u22_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_fsr_out_real[0] }),
	.x0_x0_u22_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_in_real[0] }),
	.x0_x0_u22_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__hip_aib_ssr_out_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u22_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u22_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_krfec_rx_frame_real),
	.x0_x0_u22_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_crc32_err_real),
	.x0_x0_u22_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_frame_lock_real),
	.x0_x0_u22_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_10g_rx_hi_ber_real),
	.x0_x0_u22_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_bitloc_rev_en_real),
	.x0_x0_u22_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_byte_rev_en_real),
	.x0_x0_u22_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_empty_rmf_real),
	.x0_x0_u22_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_encdt_real),
	.x0_x0_u22_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_full_rmf_real),
	.x0_x0_u22_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_rxelecidle_real),
	.x0_x0_u22_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u22_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u22_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u22_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u22_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u22_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u22_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u22_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fifo_ready_real }),
	.x0_x0_u22_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fabric_tx_transfer_en_real),
	.x0_x0_u22_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u22_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_hssi_rx_transfer_en_real),
	.x0_x0_u22_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_krfec_tx_alignment_real),
	.x0_x0_u22_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_ltr_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u22_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u22_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_20__pld_pll_cal_done_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_adapt_start_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_csr_test_dis_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_early_eios_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_clk0bad_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_extswitch_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_pfden_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_nrpi_freeze_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_ppm_lock_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_in_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_reserved_out_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rs_lpbk_b_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rx_found_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rxpll_lock_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_rxpma_rstb_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pma_signal_ok_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_bitslip_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u22_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pma_txpma_rstb_real),
	.x0_x0_u22_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u22_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_pmaif_rxclkslip_real),
	.x0_x0_u22_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_polinv_rx_real),
	.x0_x0_u22_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_polinv_tx_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk1_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk1_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_clk2_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_dll_lock_req_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_full_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_hssi_fifo_full_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_done_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_err_real),
	.x0_x0_u22_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_rx_prbs_err_clr_real),
	.x0_x0_u22_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_sclk1_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_sclk2_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_syncsm_en_real),
	.x0_x0_u22_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_20__pld_test_data_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk1_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk1_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk2_dcm_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_clk2_rowclk_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_dll_lock_req_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u22_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_full_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u22_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_tx_hssi_fifo_full_real),
	.x0_x0_u22_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_20__pld_txelecidle_real),
	.x0_x0_u23_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_in_real[0] }),
	.x0_x0_u23_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_fsr_out_real[0] }),
	.x0_x0_u23_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_in_real[0] }),
	.x0_x0_u23_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__hip_aib_ssr_out_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u23_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u23_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_krfec_rx_frame_real),
	.x0_x0_u23_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_crc32_err_real),
	.x0_x0_u23_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_frame_lock_real),
	.x0_x0_u23_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_10g_rx_hi_ber_real),
	.x0_x0_u23_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_bitloc_rev_en_real),
	.x0_x0_u23_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_byte_rev_en_real),
	.x0_x0_u23_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_empty_rmf_real),
	.x0_x0_u23_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_encdt_real),
	.x0_x0_u23_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_full_rmf_real),
	.x0_x0_u23_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_rxelecidle_real),
	.x0_x0_u23_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u23_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u23_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u23_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u23_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u23_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u23_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u23_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fifo_ready_real }),
	.x0_x0_u23_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fabric_tx_transfer_en_real),
	.x0_x0_u23_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u23_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_hssi_rx_transfer_en_real),
	.x0_x0_u23_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_krfec_tx_alignment_real),
	.x0_x0_u23_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_ltr_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u23_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u23_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_21__pld_pll_cal_done_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_adapt_start_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_csr_test_dis_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_early_eios_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_clk0bad_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_extswitch_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_pfden_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_nrpi_freeze_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_ppm_lock_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_in_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_reserved_out_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rs_lpbk_b_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rx_found_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rxpll_lock_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_rxpma_rstb_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pma_signal_ok_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_bitslip_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u23_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pma_txpma_rstb_real),
	.x0_x0_u23_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u23_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_pmaif_rxclkslip_real),
	.x0_x0_u23_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_polinv_rx_real),
	.x0_x0_u23_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_polinv_tx_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk1_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk1_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_clk2_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_dll_lock_req_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_full_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_hssi_fifo_full_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_done_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_err_real),
	.x0_x0_u23_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_rx_prbs_err_clr_real),
	.x0_x0_u23_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_sclk1_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_sclk2_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_syncsm_en_real),
	.x0_x0_u23_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_21__pld_test_data_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk1_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk1_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk2_dcm_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_clk2_rowclk_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_dll_lock_req_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u23_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_full_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u23_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_tx_hssi_fifo_full_real),
	.x0_x0_u23_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_21__pld_txelecidle_real),
	.x0_x0_u24_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_in_real[0] }),
	.x0_x0_u24_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_fsr_out_real[0] }),
	.x0_x0_u24_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_in_real[0] }),
	.x0_x0_u24_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__hip_aib_ssr_out_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u24_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u24_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_krfec_rx_frame_real),
	.x0_x0_u24_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_crc32_err_real),
	.x0_x0_u24_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_frame_lock_real),
	.x0_x0_u24_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_10g_rx_hi_ber_real),
	.x0_x0_u24_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_bitloc_rev_en_real),
	.x0_x0_u24_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_byte_rev_en_real),
	.x0_x0_u24_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_empty_rmf_real),
	.x0_x0_u24_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_encdt_real),
	.x0_x0_u24_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_full_rmf_real),
	.x0_x0_u24_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_rxelecidle_real),
	.x0_x0_u24_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u24_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u24_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u24_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u24_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u24_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u24_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u24_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fifo_ready_real }),
	.x0_x0_u24_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fabric_tx_transfer_en_real),
	.x0_x0_u24_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u24_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_hssi_rx_transfer_en_real),
	.x0_x0_u24_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_krfec_tx_alignment_real),
	.x0_x0_u24_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_ltr_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u24_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u24_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_22__pld_pll_cal_done_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_adapt_start_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_csr_test_dis_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_early_eios_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_clk0bad_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_extswitch_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_pfden_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_nrpi_freeze_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_ppm_lock_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_in_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_reserved_out_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rs_lpbk_b_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rx_found_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rxpll_lock_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_rxpma_rstb_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pma_signal_ok_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_bitslip_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u24_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pma_txpma_rstb_real),
	.x0_x0_u24_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u24_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_pmaif_rxclkslip_real),
	.x0_x0_u24_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_polinv_rx_real),
	.x0_x0_u24_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_polinv_tx_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk1_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk1_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_clk2_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_dll_lock_req_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_full_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_hssi_fifo_full_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_done_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_err_real),
	.x0_x0_u24_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_rx_prbs_err_clr_real),
	.x0_x0_u24_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_sclk1_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_sclk2_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_syncsm_en_real),
	.x0_x0_u24_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_22__pld_test_data_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk1_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk1_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk2_dcm_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_clk2_rowclk_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_dll_lock_req_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u24_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_full_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u24_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_tx_hssi_fifo_full_real),
	.x0_x0_u24_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_22__pld_txelecidle_real),
	.x0_x0_u25_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_in_real[0] }),
	.x0_x0_u25_2_hdpldadapt_hip_aib_fsr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_fsr_out_real[0] }),
	.x0_x0_u25_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_in_real[0] }),
	.x0_x0_u25_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__hip_aib_ssr_out_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_10g_krfec_rx_blk_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_blk_lock_real),
	.x0_x0_u25_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u25_2_hdpldadapt_pld_10g_krfec_rx_diag_data_status({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_diag_data_status_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_diag_data_status_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_10g_krfec_rx_frame(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_krfec_rx_frame_real),
	.x0_x0_u25_2_hdpldadapt_pld_10g_rx_crc32_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_crc32_err_real),
	.x0_x0_u25_2_hdpldadapt_pld_10g_rx_frame_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_frame_lock_real),
	.x0_x0_u25_2_hdpldadapt_pld_10g_rx_hi_ber(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_10g_rx_hi_ber_real),
	.x0_x0_u25_2_hdpldadapt_pld_10g_tx_bitslip({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_10g_tx_bitslip_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_8g_a1a2_k1k2_flag({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_a1a2_k1k2_flag_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_a1a2_k1k2_flag_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_a1a2_k1k2_flag_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_a1a2_k1k2_flag_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_8g_bitloc_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_bitloc_rev_en_real),
	.x0_x0_u25_2_hdpldadapt_pld_8g_byte_rev_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_byte_rev_en_real),
	.x0_x0_u25_2_hdpldadapt_pld_8g_eidleinfersel({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_eidleinfersel_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_eidleinfersel_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_eidleinfersel_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_8g_empty_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_empty_rmf_real),
	.x0_x0_u25_2_hdpldadapt_pld_8g_encdt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_encdt_real),
	.x0_x0_u25_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_full_rmf_real),
	.x0_x0_u25_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_rxelecidle_real),
	.x0_x0_u25_2_hdpldadapt_pld_8g_tx_boundary_sel({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_8g_tx_boundary_sel_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u25_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u25_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u25_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u25_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u25_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u25_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u25_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fifo_ready_real }),
	.x0_x0_u25_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fabric_tx_transfer_en_real),
	.x0_x0_u25_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u25_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_hssi_rx_transfer_en_real),
	.x0_x0_u25_2_hdpldadapt_pld_krfec_tx_alignment(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_krfec_tx_alignment_real),
	.x0_x0_u25_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_ltr_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_rx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out1_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_rx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out1_hioint_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_rx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out2_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_rx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_clk_out2_hioint_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_tx_clk_out1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out1_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_tx_clk_out1_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out1_hioint_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_tx_clk_out2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out2_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_tx_clk_out2_hioint(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_clk_out2_hioint_real),
	.x0_x0_u25_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u25_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_23__pld_pll_cal_done_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_adapt_start_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_csr_test_dis_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_early_eios(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_early_eios_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_eye_monitor({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_eye_monitor_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_clk0bad_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_fpll_extswitch(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_extswitch_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_fpll_num_phase_shifts({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_num_phase_shifts_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_num_phase_shifts_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_num_phase_shifts_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_pma_fpll_pfden(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_pfden_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_fpll_up_dn_lc_lf_rstn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_fpll_up_dn_lc_lf_rstn_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_internal_clk1_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_internal_clk1_hioint_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_internal_clk2_hioint(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_internal_clk2_hioint_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_nrpi_freeze_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_pma_ppm_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_ppm_lock_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_reserved_in({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_in_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_pma_reserved_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_reserved_out_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_pma_rs_lpbk_b(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rs_lpbk_b_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_rx_found(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rx_found_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rxpll_lock_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_rxpma_rstb_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_signal_ok(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pma_signal_ok_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_bitslip_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_tx_qpi_pulldn(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_qpi_pulldn_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_tx_qpi_pullup(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_tx_qpi_pullup_real),
	.x0_x0_u25_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pma_txpma_rstb_real),
	.x0_x0_u25_2_hdpldadapt_pld_pmaif_mask_tx_pll(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_pmaif_mask_tx_pll_real),
	.x0_x0_u25_2_hdpldadapt_pld_pmaif_rxclkslip(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_pmaif_rxclkslip_real),
	.x0_x0_u25_2_hdpldadapt_pld_polinv_rx(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_polinv_rx_real),
	.x0_x0_u25_2_hdpldadapt_pld_polinv_tx(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_polinv_tx_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk1_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk1_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_clk2_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_dll_lock_req_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_fabric_data_out({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[79], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[78], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[77], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[76], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[75], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[74], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[73], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[72], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[71], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[70], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[69], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[68], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[67], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[66], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[65], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[64], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[63], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[62], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[61], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[60], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[59], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[58], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[57], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[56], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[55], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[54], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[53], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[52], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[51], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[50], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[49], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[48], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[47], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[46], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[45], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[44], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[43], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[42], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[41], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[40], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[39], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[38], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[37], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[36], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[35], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[34], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[33], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[32], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[31], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[30], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[29], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[28], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[27], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[26], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[25], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[24], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[23], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[22], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[21], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[20], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_data_out_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_rx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_empty_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_full_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_pempty_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_pfull_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_fabric_fifo_rd_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_fabric_fifo_rd_en_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_hssi_fifo_empty_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_hssi_fifo_full_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_prbs_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_done_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_prbs_err(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_err_real),
	.x0_x0_u25_2_hdpldadapt_pld_rx_prbs_err_clr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_rx_prbs_err_clr_real),
	.x0_x0_u25_2_hdpldadapt_pld_sclk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_sclk1_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_sclk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_sclk2_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_syncsm_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_syncsm_en_real),
	.x0_x0_u25_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_23__pld_test_data_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_tx_clk1_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk1_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_clk1_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk1_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_clk2_dcm(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk2_dcm_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_clk2_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_clk2_rowclk_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_dll_lock_req_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_fabric_data_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[79], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[78], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[77], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[76], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[75], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[74], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[73], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[72], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[71], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[70], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[69], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[68], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[67], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[66], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[65], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[64], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[63], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[62], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[61], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[60], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[59], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[58], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[57], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[56], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[55], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[54], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[53], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[52], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[51], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[50], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[49], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[48], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[47], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[46], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[45], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[44], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[43], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[42], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[41], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[40], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_data_in_real[0] }),
	.x0_x0_u25_2_hdpldadapt_pld_tx_fabric_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_empty_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_fabric_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_full_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_fabric_fifo_pempty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_pempty_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_fabric_fifo_pfull(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_fabric_fifo_pfull_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_hssi_fifo_empty(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_hssi_fifo_empty_real),
	.x0_x0_u25_2_hdpldadapt_pld_tx_hssi_fifo_full(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_tx_hssi_fifo_full_real),
	.x0_x0_u25_2_hdpldadapt_pld_txelecidle(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_23__pld_txelecidle_real),
	.x0_x0_u2_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_fsr_in_real[0] }),
	.x0_x0_u2_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_in_real[0] }),
	.x0_x0_u2_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__hip_aib_ssr_out_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u2_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_full_rmf_real),
	.x0_x0_u2_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_rxelecidle_real),
	.x0_x0_u2_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_signal_detect_out_real),
	.x0_x0_u2_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u2_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u2_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u2_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u2_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u2_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u2_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u2_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_tx_fifo_ready_real }),
	.x0_x0_u2_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fabric_tx_transfer_en_real),
	.x0_x0_u2_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u2_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u2_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_hssi_rx_transfer_en_real),
	.x0_x0_u2_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_ltr_real),
	.x0_x0_u2_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u2_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u2_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_0__pld_pll_cal_done_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_adapt_start_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_clk0bad_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u2_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u2_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_nrpi_freeze_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_pfdmode_lock_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_rxpll_lock_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_pma_rxpma_rstb_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_tx_bitslip_real),
	.x0_x0_u2_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_pma_txpma_rstb_real),
	.x0_x0_u2_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_rx_dll_lock_req_real),
	.x0_x0_u2_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_0__pld_test_data_real[0] }),
	.x0_x0_u2_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_0__pld_tx_dll_lock_req_real),
	.x0_x0_u3_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_fsr_in_real[0] }),
	.x0_x0_u3_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_in_real[0] }),
	.x0_x0_u3_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__hip_aib_ssr_out_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u3_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_full_rmf_real),
	.x0_x0_u3_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_rxelecidle_real),
	.x0_x0_u3_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_signal_detect_out_real),
	.x0_x0_u3_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u3_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u3_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u3_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u3_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u3_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u3_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u3_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_tx_fifo_ready_real }),
	.x0_x0_u3_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fabric_tx_transfer_en_real),
	.x0_x0_u3_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u3_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u3_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_hssi_rx_transfer_en_real),
	.x0_x0_u3_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_ltr_real),
	.x0_x0_u3_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u3_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u3_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_1__pld_pll_cal_done_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_adapt_start_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_clk0bad_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u3_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u3_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_nrpi_freeze_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_pfdmode_lock_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_rxpll_lock_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_pma_rxpma_rstb_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_tx_bitslip_real),
	.x0_x0_u3_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_pma_txpma_rstb_real),
	.x0_x0_u3_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_rx_dll_lock_req_real),
	.x0_x0_u3_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_1__pld_test_data_real[0] }),
	.x0_x0_u3_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_1__pld_tx_dll_lock_req_real),
	.x0_x0_u4_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_fsr_in_real[0] }),
	.x0_x0_u4_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_in_real[0] }),
	.x0_x0_u4_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__hip_aib_ssr_out_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u4_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_full_rmf_real),
	.x0_x0_u4_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_rxelecidle_real),
	.x0_x0_u4_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_signal_detect_out_real),
	.x0_x0_u4_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u4_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u4_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u4_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u4_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u4_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u4_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u4_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_tx_fifo_ready_real }),
	.x0_x0_u4_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fabric_tx_transfer_en_real),
	.x0_x0_u4_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u4_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u4_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_hssi_rx_transfer_en_real),
	.x0_x0_u4_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_ltr_real),
	.x0_x0_u4_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u4_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u4_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_2__pld_pll_cal_done_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_adapt_start_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_clk0bad_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u4_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u4_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_nrpi_freeze_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_pfdmode_lock_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_rxpll_lock_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_pma_rxpma_rstb_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_tx_bitslip_real),
	.x0_x0_u4_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_pma_txpma_rstb_real),
	.x0_x0_u4_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_rx_dll_lock_req_real),
	.x0_x0_u4_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_2__pld_test_data_real[0] }),
	.x0_x0_u4_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_2__pld_tx_dll_lock_req_real),
	.x0_x0_u5_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_fsr_in_real[0] }),
	.x0_x0_u5_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_in_real[0] }),
	.x0_x0_u5_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__hip_aib_ssr_out_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u5_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_full_rmf_real),
	.x0_x0_u5_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_rxelecidle_real),
	.x0_x0_u5_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_signal_detect_out_real),
	.x0_x0_u5_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u5_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u5_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u5_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u5_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u5_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u5_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__x0_x0_u5_2_hdpldadapt_pld_avmm2_reserved_out_2_, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_tx_fifo_ready_real }),
	.x0_x0_u5_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fabric_tx_transfer_en_real),
	.x0_x0_u5_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u5_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u5_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_hssi_rx_transfer_en_real),
	.x0_x0_u5_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_ltr_real),
	.x0_x0_u5_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u5_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u5_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_3__pld_pll_cal_done_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_adapt_start_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_clk0bad_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u5_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u5_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_nrpi_freeze_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_pfdmode_lock_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_rxpll_lock_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_pma_rxpma_rstb_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_tx_bitslip_real),
	.x0_x0_u5_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_pma_txpma_rstb_real),
	.x0_x0_u5_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_rx_dll_lock_req_real),
	.x0_x0_u5_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_3__pld_test_data_real[0] }),
	.x0_x0_u5_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_3__pld_tx_dll_lock_req_real),
	.x0_x0_u6_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_fsr_in_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_in_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__hip_aib_ssr_out_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_4__hip_avmm_read_real),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdata_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_4__hip_avmm_readdatavalid_real),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_4__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_4__hip_avmm_write_real),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedata_real[0] }),
	.x0_x0_u6_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_4__hip_avmm_writedone_real),
	.x0_x0_u6_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u6_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_full_rmf_real),
	.x0_x0_u6_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_rxelecidle_real),
	.x0_x0_u6_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_signal_detect_out_real),
	.x0_x0_u6_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u6_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u6_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u6_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u6_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u6_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_busy_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_clk_rowclk_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_read_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdata_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_readdatavalid_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_request_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_4__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_tx_fifo_ready_real }),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_4__pld_avmm2_write_real),
	.x0_x0_u6_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_4__pld_avmm2_writedata_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fabric_tx_transfer_en_real),
	.x0_x0_u6_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u6_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u6_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_hssi_rx_transfer_en_real),
	.x0_x0_u6_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_ltr_real),
	.x0_x0_u6_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u6_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u6_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_4__pld_pll_cal_done_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_adapt_start_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_clk0bad_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u6_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_nrpi_freeze_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_pfdmode_lock_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_rxpll_lock_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_pma_rxpma_rstb_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_tx_bitslip_real),
	.x0_x0_u6_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_pma_txpma_rstb_real),
	.x0_x0_u6_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_rx_dll_lock_req_real),
	.x0_x0_u6_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_4__pld_test_data_real[0] }),
	.x0_x0_u6_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_4__pld_tx_dll_lock_req_real),
	.x0_x0_u7_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_fsr_in_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_in_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__hip_aib_ssr_out_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_5__hip_avmm_read_real),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdata_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_5__hip_avmm_readdatavalid_real),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_5__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_5__hip_avmm_write_real),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedata_real[0] }),
	.x0_x0_u7_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_5__hip_avmm_writedone_real),
	.x0_x0_u7_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u7_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_full_rmf_real),
	.x0_x0_u7_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_rxelecidle_real),
	.x0_x0_u7_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_signal_detect_out_real),
	.x0_x0_u7_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u7_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u7_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u7_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u7_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u7_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_busy_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_clk_rowclk_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_read_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdata_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_readdatavalid_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_request_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_5__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_tx_fifo_ready_real }),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_5__pld_avmm2_write_real),
	.x0_x0_u7_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_5__pld_avmm2_writedata_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fabric_tx_transfer_en_real),
	.x0_x0_u7_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u7_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u7_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_hssi_rx_transfer_en_real),
	.x0_x0_u7_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_ltr_real),
	.x0_x0_u7_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u7_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u7_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_5__pld_pll_cal_done_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_adapt_start_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_clk0bad_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u7_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_nrpi_freeze_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_pfdmode_lock_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_rxpll_lock_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_pma_rxpma_rstb_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_tx_bitslip_real),
	.x0_x0_u7_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_pma_txpma_rstb_real),
	.x0_x0_u7_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_rx_dll_lock_req_real),
	.x0_x0_u7_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_5__pld_test_data_real[0] }),
	.x0_x0_u7_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_5__pld_tx_dll_lock_req_real),
	.x0_x0_u8_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_fsr_in_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_in_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__hip_aib_ssr_out_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_6__hip_avmm_read_real),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdata_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_6__hip_avmm_readdatavalid_real),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_6__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_6__hip_avmm_write_real),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedata_real[0] }),
	.x0_x0_u8_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_6__hip_avmm_writedone_real),
	.x0_x0_u8_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u8_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_full_rmf_real),
	.x0_x0_u8_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_rxelecidle_real),
	.x0_x0_u8_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_signal_detect_out_real),
	.x0_x0_u8_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u8_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u8_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u8_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u8_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u8_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_busy_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_clk_rowclk_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_read_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdata_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_readdatavalid_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_request_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_6__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_tx_fifo_ready_real }),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_6__pld_avmm2_write_real),
	.x0_x0_u8_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_6__pld_avmm2_writedata_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fabric_tx_transfer_en_real),
	.x0_x0_u8_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u8_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u8_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_hssi_rx_transfer_en_real),
	.x0_x0_u8_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_ltr_real),
	.x0_x0_u8_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u8_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u8_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_6__pld_pll_cal_done_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_adapt_start_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_clk0bad_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u8_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_nrpi_freeze_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_pfdmode_lock_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_rxpll_lock_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_pma_rxpma_rstb_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_tx_bitslip_real),
	.x0_x0_u8_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_pma_txpma_rstb_real),
	.x0_x0_u8_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_rx_dll_lock_req_real),
	.x0_x0_u8_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_6__pld_test_data_real[0] }),
	.x0_x0_u8_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_6__pld_tx_dll_lock_req_real),
	.x0_x0_u9_2_hdpldadapt_hip_aib_fsr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_fsr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_fsr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_fsr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_fsr_in_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_aib_ssr_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[39], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[38], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[37], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[36], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[35], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[34], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[33], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[32], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[31], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[30], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[29], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[28], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[27], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[26], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[25], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[24], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[23], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[22], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[21], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[20], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[19], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[18], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[17], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[16], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[15], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[14], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[13], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[12], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[11], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[10], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[9], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[8], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_in_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_aib_ssr_out({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[7], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[6], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[5], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[4], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[3], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[2], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__hip_aib_ssr_out_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_read(z1577a_x0_y166_n0__avmm2_7__hip_avmm_read_real),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_readdata({ z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[7], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[6], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[5], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[4], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[3], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[2], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[1], z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdata_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_readdatavalid(z1577a_x0_y166_n0__avmm2_7__hip_avmm_readdatavalid_real),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_reg_addr({ z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[20], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[19], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[18], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[17], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[16], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[15], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[14], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[13], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[12], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[11], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[10], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[9], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reg_addr_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_reserved_out({ z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real[4], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real[3], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real[2], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real[1], z1577a_x0_y166_n0__avmm2_7__hip_avmm_reserved_out_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_write(z1577a_x0_y166_n0__avmm2_7__hip_avmm_write_real),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_writedata({ z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[7], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[6], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[5], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[4], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[3], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[2], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[1], z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedata_real[0] }),
	.x0_x0_u9_2_hdpldadapt_hip_avmm_writedone(z1577a_x0_y166_n0__avmm2_7__hip_avmm_writedone_real),
	.x0_x0_u9_2_hdpldadapt_pld_10g_krfec_rx_clr_errblk_cnt(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_10g_krfec_rx_clr_errblk_cnt_real),
	.x0_x0_u9_2_hdpldadapt_pld_8g_full_rmf(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_full_rmf_real),
	.x0_x0_u9_2_hdpldadapt_pld_8g_rxelecidle(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_rxelecidle_real),
	.x0_x0_u9_2_hdpldadapt_pld_8g_signal_detect_out(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_signal_detect_out_real),
	.x0_x0_u9_2_hdpldadapt_pld_8g_wa_boundary({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_8g_wa_boundary_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_adapter_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_adapter_rx_pld_rst_n_real),
	.x0_x0_u9_2_hdpldadapt_pld_adapter_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_adapter_tx_pld_rst_n_real),
	.x0_x0_u9_2_hdpldadapt_pld_aib_fabric_rx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_aib_fabric_rx_dll_lock_real),
	.x0_x0_u9_2_hdpldadapt_pld_aib_fabric_tx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_aib_fabric_tx_dcd_cal_done_real),
	.x0_x0_u9_2_hdpldadapt_pld_aib_hssi_rx_dcd_cal_done(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_aib_hssi_rx_dcd_cal_done_real),
	.x0_x0_u9_2_hdpldadapt_pld_aib_hssi_tx_dll_lock(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_aib_hssi_tx_dll_lock_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_busy(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_busy_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_clk_rowclk(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_clk_rowclk_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_cmdfifo_wr_full(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_cmdfifo_wr_full_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_cmdfifo_wr_pfull(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_cmdfifo_wr_pfull_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_read(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_read_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_readdata({ z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[7], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[6], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[5], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[4], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[3], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[2], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[1], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdata_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_readdatavalid(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_readdatavalid_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_reg_addr({ z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[8], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[7], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[6], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[5], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[4], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[3], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[2], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[1], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reg_addr_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_request(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_request_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in({ z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real[5], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real[4], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real[3], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real[2], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real[1], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_in_real[0], z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_3_, z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_2_, z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_1_, z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_in_0_ }),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_reserved_out({ z1577a_x0_y166_n0__avmm2_7__pld_avmm2_reserved_out_real, z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_rx_fifo_ready_real, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_tx_fifo_ready_real }),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_write(z1577a_x0_y166_n0__avmm2_7__pld_avmm2_write_real),
	.x0_x0_u9_2_hdpldadapt_pld_avmm2_writedata({ z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[7], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[6], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[5], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[4], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[3], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[2], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[1], z1577a_x0_y166_n0__avmm2_7__pld_avmm2_writedata_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_fabric_tx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fabric_tx_transfer_en_real),
	.x0_x0_u9_2_hdpldadapt_pld_fpll_shared_direct_async_in({ z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_fpll_shared_direct_async_in_rowclk(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_in_rowclk_real),
	.x0_x0_u9_2_hdpldadapt_pld_fpll_shared_direct_async_out(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_fpll_shared_direct_async_out_real),
	.x0_x0_u9_2_hdpldadapt_pld_hssi_rx_transfer_en(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_hssi_rx_transfer_en_real),
	.x0_x0_u9_2_hdpldadapt_pld_ltr(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_ltr_real),
	.x0_x0_u9_2_hdpldadapt_pld_pcs_rx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pcs_rx_pld_rst_n_real),
	.x0_x0_u9_2_hdpldadapt_pld_pcs_tx_pld_rst_n(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pcs_tx_pld_rst_n_real),
	.x0_x0_u9_2_hdpldadapt_pld_pll_cal_done(z1577a_x0_y166_n0__avmm2_7__pld_pll_cal_done_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_adapt_start(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_adapt_start_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_fpll_clk0bad(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_clk0bad_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_fpll_cnt_sel({ z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_pma_fpll_cnt_sel_3_, z1577a_x0_y166_n0__x0_x0_u9_2_hdpldadapt_pld_pma_fpll_cnt_sel_2_, z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_cnt_sel_real[1], z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_cnt_sel_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_pma_fpll_lc_csr_test_dis(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_fpll_lc_csr_test_dis_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_nrpi_freeze(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_nrpi_freeze_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_pcie_sw_done({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_sw_done_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_sw_done_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_pma_pcie_switch({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_switch_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pcie_switch_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_pma_pfdmode_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_pfdmode_lock_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_rxpll_lock(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_rxpll_lock_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_rxpma_rstb(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_pma_rxpma_rstb_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_tx_bitslip(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_tx_bitslip_real),
	.x0_x0_u9_2_hdpldadapt_pld_pma_txpma_rstb(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_pma_txpma_rstb_real),
	.x0_x0_u9_2_hdpldadapt_pld_rx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_rx_dll_lock_req_real),
	.x0_x0_u9_2_hdpldadapt_pld_test_data({ z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[19], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[18], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[17], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[16], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[15], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[14], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[13], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[12], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[11], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[10], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[9], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[8], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[7], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[6], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[5], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[4], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[3], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[2], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[1], z1577a_x0_y166_n0__hdpldadapt_rx_chnl_7__pld_test_data_real[0] }),
	.x0_x0_u9_2_hdpldadapt_pld_tx_dll_lock_req(z1577a_x0_y166_n0__hdpldadapt_tx_chnl_7__pld_tx_dll_lock_req_real));
`ifndef USE_DV_PATTERN
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_0_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_10_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_11_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_12_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_13_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_14_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_15_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_16_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_17_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_18_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_19_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_1_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_20_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_21_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_22_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_23_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_2_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_3_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_4_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_5_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_6_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_7_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_8_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_nfhssi_calibratio_feature_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_read_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm1_9_pldadapt_uc_blocking_enable = "enable";
defparam z1577a_x0_y166_n0.avmm2_0_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_0_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_0_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_0_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_0_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_0_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_10_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_10_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_10_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_10_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_10_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_10_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_11_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_11_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_11_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_11_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_11_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_11_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_12_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_12_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_12_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_12_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_12_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_12_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_13_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_13_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_13_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_13_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_13_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_13_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_14_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_14_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_14_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_14_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_14_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_14_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_15_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_15_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_15_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_15_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_15_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_15_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_16_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_16_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_16_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_16_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_16_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_16_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_17_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_17_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_17_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_17_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_17_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_17_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_18_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_18_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_18_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_18_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_18_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_18_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_19_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_19_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_19_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_19_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_19_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_19_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_1_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_1_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_1_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_1_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_1_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_1_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_20_pldadapt_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_20_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_20_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_20_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_20_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_20_pldadapt_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_21_pldadapt_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_21_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_21_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_21_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_21_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_21_pldadapt_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_22_pldadapt_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_22_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_22_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_22_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_22_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_22_pldadapt_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_23_pldadapt_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_23_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_23_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_23_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_23_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_23_pldadapt_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.avmm2_2_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_2_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_2_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_2_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_2_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_2_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_3_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_3_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_3_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_3_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_3_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_3_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_4_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_4_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_4_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_4_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_4_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_4_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_5_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_5_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_5_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_5_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_5_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_5_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_6_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_6_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_6_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_6_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_6_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_6_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_7_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_7_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_7_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_7_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_7_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_7_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_8_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_8_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_8_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_8_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_8_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_8_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_9_pldadapt_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.avmm2_9_pldadapt_avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.avmm2_9_pldadapt_avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.avmm2_9_pldadapt_gate_dis = "disable";
defparam z1577a_x0_y166_n0.avmm2_9_pldadapt_hip_mode = "user_chnl";
defparam z1577a_x0_y166_n0.avmm2_9_pldadapt_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfifo_mode = "rxgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfifo_pempty = 4;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfifo_pfull = 20;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_0_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_10_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_11_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_12_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_13_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_14_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_15_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_16_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_17_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_18_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_19_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfifo_mode = "rxgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfifo_pempty = 4;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfifo_pfull = 20;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_1_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_20_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_21_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_22_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_23_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfifo_mode = "rxgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfifo_pempty = 4;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfifo_pfull = 20;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_2_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfifo_mode = "rxgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfifo_pempty = 4;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfifo_pfull = 20;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_3_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfifo_mode = "rxgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfifo_pempty = 4;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfifo_pfull = 20;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_4_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfifo_mode = "rxgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfifo_pempty = 4;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfifo_pfull = 20;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_5_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_6_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_pld_rx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_pld_rx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_powermode_freq_hz_pld_rx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_7_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_8_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_aib_clk1_sel = "aib_clk1_pld_pcs_rx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_rx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_asn_bypass_pma_pcie_sw_done = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_asn_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_asn_wait_for_dll_reset_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_asn_wait_for_fifo_flush_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_asn_wait_for_pma_pcie_sw_done_cnt = 64;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_dv_mode = "dv_mode_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_double_read = "fifo_double_read_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_rd_clk_ins_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_rd_clk_sel = "fifo_rd_clk_pld_rx_clk1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_wr_clk_del_sm_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fifo_wr_clk_sel = "fifo_wr_clk_rx_transfer_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_gb_rx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_gb_rx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_aib_fabric_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_aib_fabric_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_pld_rx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_pld_rx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_internal_clk1_sel1 = "pma_clks_or_txfiford_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_internal_clk1_sel2 = "pma_clks_clk1_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_internal_clk2_sel1 = "pma_clks_or_rxfifowr_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_internal_clk2_sel2 = "pma_clks_clk2_mux2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pipe_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_pma_hclk_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_powermode_freq_hz_pld_rx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_fastbond_wren = "wren_ds_del_us_del";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_fifo_write_ctrl = "blklock_ignore";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_pld_8g_eidleinfersel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_pld_pma_eye_monitor_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_pld_pma_pcie_switch_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_pld_pma_reser_out_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_prbs_flags_sr_enable = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_true_b2b = "b2b";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfifo_empty = "empty_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfifo_mode = "rxphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfiford_post_ct_sel = "rxfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_rxfifowr_post_ct_sel = "rxfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_sclk_sel = "sclk1_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_txfiford_post_ct_sel = "txfiford_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_txfifowr_post_ct_sel = "txfifowr_sclk_post_ct";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_word_align = "wa_en";
defparam z1577a_x0_y166_n0.hdpldadapt_rx_chnl_9_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_txfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_txfifo_mode = "txgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_txfifo_pfull = 18;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_0_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_10_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_11_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_12_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_13_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_14_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_15_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_16_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_17_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_18_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_19_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_txfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_txfifo_mode = "txgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_txfifo_pfull = 18;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_1_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_20_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_21_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_22_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_23_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_txfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_txfifo_mode = "txgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_txfifo_pfull = 18;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_2_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_txfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_txfifo_mode = "txgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_txfifo_pfull = 18;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_3_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_txfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_txfifo_mode = "txgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_txfifo_pfull = 18;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_4_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_mode = "generic_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_stop_rd = "n_rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_fifo_power_mode = "full_width_full_depth";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_txfifo_full = "full_non_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_txfifo_mode = "txgeneric_basic";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_txfifo_pfull = 18;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_5_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_6_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_tx_clk1_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_tx_clk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_tx_clk2_dcm_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_pld_tx_clk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_powermode_freq_hz_pld_tx_clk1_dcm = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_7_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_8_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_aib_clk1_sel = "aib_clk1_pld_pcs_tx_clk_out";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_aib_clk2_sel = "aib_clk2_pld_pma_clkdiv_tx_user";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_bonding_dft_en = "dft_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_bonding_dft_val = "dft_0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_chnl_bonding = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_comp_cnt = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_compin_sel = "compin_master";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_ctrl_plane_bonding = "individual";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_ds_bypass_pipeln = "ds_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_ds_last_chnl = "ds_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_ds_master = "ds_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_duplex_mode = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_dv_bond = "dv_bond_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_dv_gen = "dv_gen_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_mode = "phase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_rd_clk_frm_gen_scg_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_rd_clk_sel = "fifo_rd_pma_aib_tx_clk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fpll_shared_direct_async_in_sel = "fpll_shared_direct_async_in_rowclk";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_frmgen_burst = "frmgen_burst_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_frmgen_bypass = "frmgen_bypass_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_frmgen_mfrm_length = 2048;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_frmgen_pipeln = "frmgen_pipeln_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_frmgen_pyld_ins = "frmgen_pyld_ins_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_frmgen_wordslip = "frmgen_wordslip_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_gb_tx_idwidth = "idwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_gb_tx_odwidth = "odwidth_32";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_aib_fabric_pld_pma_hclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_aib_fabric_pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_aib_fabric_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_csr_clk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_avmm1_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_avmm2_clk_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_sclk1_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_sclk2_rowclk_hz = 0;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_tx_clk1_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_tx_clk1_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_tx_clk2_dcm_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_pld_tx_clk2_rowclk_hz = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hdpldadapt_speed_grade = "dash_2";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hip_mode = "disable_hip";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_indv = "indv_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_is_paired_with = "z1577a";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_loopback_mode = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_low_latency_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pipe_mode = "disable_pipe";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pld_clk1_delay_en = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pld_clk1_delay_sel = "delay_path3";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pld_clk1_inv_en = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pld_clk1_sel = "pld_clk1_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pld_clk2_sel = "pld_clk2_dcm";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_pma_aib_tx_clk_expected_setting = "not_used";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_powermode_freq_hz_aib_fabric_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_powermode_freq_hz_pld_tx_clk1_dcm = 390625000;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_sh_err = "sh_err_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_stretch_num_stages = "two_stage";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_datapath_tb_sel = "tx_fifo_tb1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_fastbond_rden = "rden_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_fastbond_wren = "wren_ds_fast_us_fast";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_fifo_power_mode = "full_width_ps_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_hip_aib_ssr_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_pld_10g_tx_bitslip_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_pld_8g_tx_boundary_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_pld_pma_fpll_cnt_sel_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_pld_pma_fpll_num_phase_shifts_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_tx_usertest_sel = "disable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_txfifo_full = "full_pc_dw";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_txfifo_mode = "txphase_comp";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_txfifo_pfull = 10;
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_us_bypass_pipeln = "us_bypass_pipeln_dis";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_us_last_chnl = "us_last_chnl";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_us_master = "us_master_en";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_word_align_enable = "enable";
defparam z1577a_x0_y166_n0.hdpldadapt_tx_chnl_9_word_mark = "wm_en";
defparam z1577a_x0_y166_n0.silicon_rev = "10nm8agdra";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_op_mode = "rx_dll_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_0_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_10_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_11_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_12_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_13_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_14_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_15_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_16_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_17_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_18_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_19_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_op_mode = "rx_dll_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_1_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_20_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_21_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_22_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_23_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_op_mode = "rx_dll_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_2_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_op_mode = "rx_dll_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_3_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_op_mode = "rx_dll_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_4_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_op_mode = "rx_dll_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_5_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_6_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_7_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_8_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_ber_margining_ctrl = "aib_ber_margining_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_hps_ctrl_en = "aib_dllstr_align_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_inctrl_gr3 = "aib_inctrl3_setting3";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outndrv_r12 = "aib_ndrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outndrv_r78 = "aib_ndrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outpdrv_r12 = "aib_pdrv12_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_outpdrv_r78 = "aib_pdrv78_setting2";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_aib_red_shift_en = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_op_mode = "rx_dll_enable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xrxdatapath_rx_9_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_byp = "aib_tx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_en = "aib_tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_op_mode = "tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_0_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_10_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_11_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_12_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_13_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_14_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_15_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_16_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_17_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_18_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_19_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_byp = "aib_tx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_en = "aib_tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_op_mode = "tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_1_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_20_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_21_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_22_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_23_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_byp = "aib_tx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_en = "aib_tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_op_mode = "tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_2_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_byp = "aib_tx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_en = "aib_tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_op_mode = "tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_3_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_byp = "aib_tx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_en = "aib_tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_op_mode = "tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_4_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_byp = "aib_tx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_en = "aib_tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_op_mode = "tx_dcc_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_5_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_6_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_7_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_8_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_datasel_gr3 = "aib_datasel3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outndrv_r34 = "aib_ndrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outndrv_r56 = "aib_ndrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outpdrv_r34 = "aib_pdrv34_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_outpdrv_r56 = "aib_pdrv56_setting2";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_pout_shiften = "aib_red_pout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_clkdiv = "aib_tx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_byp = "aib_tx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_byp_iocsr_unused = "aib_tx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_cont_cal = "aib_tx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_cont_cal_iocsr_unused = "aib_tx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_dft = "aib_tx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_dft_sel = "aib_tx_dcc_dft_mode0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_dll_dft_sel = "aib_tx_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_dll_entest = "aib_tx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_dy_ctl_static = "aib_tx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_dy_ctlsel = "aib_tx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_en = "aib_tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_en_iocsr_unused = "aib_tx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_manual_dn = "aib_tx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_manual_up = "aib_tx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_rst_prgmnvrt = "aib_tx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_core_dn_prgmnvrt = "aib_tx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_core_up_prgmnvrt = "aib_tx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_core_updnen = "aib_tx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_dftmuxsel = "aib_tx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_dly_pst = "aib_tx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_en = "aib_tx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_hps_ctrl_en = "aib_tx_dcc_hps_ctrl_en_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_lockreq_muxsel = "aib_tx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_new_dll = "aib_tx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_st_rst = "aib_tx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_dcc_test_clk_pll_en_n = "aib_tx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_halfcode = "aib_tx_halfcode_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_aib_tx_selflock = "aib_tx_selflock_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_op_mode = "tx_dcc_enable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_redundancy_en = "disable";
defparam z1577a_x0_y166_n0.xtxdatapath_tx_9_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_barak_es_limit = "barak_es_limit_r1";
defparam z1577a_x0_y166_n0.z1577a_force_sup_mode_to_usermode_for_all = "each_ss_chooses";
defparam z1577a_x0_y166_n0.z1577a_is_active = "false";
defparam z1577a_x0_y166_n0.z1577a_is_cvp_capable = "false";
defparam z1577a_x0_y166_n0.z1577a_is_cvp_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_is_present = "false";
defparam z1577a_x0_y166_n0.z1577a_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_speed_grade = "speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_topology = "ux16e400gptp_xx_disabled_xx_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g_div2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g_div4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_tx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g_div2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g_div4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_tx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "feedthru_clks_or_txfifowr_post_ct_or_txfiford_pre_or_post_ct_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "pma_clks_or_rxfiford_post_ct_or_rxfifowr_pre_or_post_ct_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "feedthru_clks_or_txfifowr_post_ct_or_txfiford_pre_or_post_ct_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "pma_clks_or_rxfiford_post_ct_or_rxfifowr_pre_or_post_ct_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "feedthru_clks_or_txfifowr_post_ct_or_txfiford_pre_or_post_ct_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "pma_clks_or_rxfiford_post_ct_or_rxfifowr_pre_or_post_ct_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "feedthru_clks_or_txfifowr_post_ct_or_txfiford_pre_or_post_ct_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "pma_clks_or_rxfiford_post_ct_or_rxfifowr_pre_or_post_ct_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g_div2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g_div4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_tx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g_div2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g_div4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_tx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g_div2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g_div4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_tx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g_div2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g_div4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_tx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_tx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_tx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_cntr_inc_value = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_cntr_rst_b = "cntr_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_ch_sel = "gp0_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_cntr_data_sel = "gp0_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_testbus_sel = "gp0_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_ch_sel = "gp1_ch_sel_prev";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_cntr_data_sel = "gp1_sel_data";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_testbus_sel = "gp1_tx_fifo_0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_rst_b = "mux_reset_assert";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__sr_test_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel = "feedthru_clk1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel0 = "txfifowr_from_aib_mux_clk1_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel1 = "feedthru_clks_or_txfiford_pre_or_post_ct_mux_clk1_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel2 = "pma_clks_or_txfiford_pre_ct_mux_clk1_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk1_sel3 = "pma_clks_clk1_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel = "feedthru_clk0_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel0 = "rxfiford_to_aib_mux_clk2_mux0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel1 = "pma_clks_or_rxfifowr_pre_or_post_ct_mux_clk2_mux1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel2 = "pma_clks_or_rxfifowr_pre_ct_mux_clk2_mux2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__internal_clk2_sel3 = "pma_clks_clk2_mux3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_10g_krfec_rx_diag_data_status_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_datapath_tb_sel = "pcs_chnl_tb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_a1a2_k1k2_flag_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pld_8g_wa_boundary_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_pcie_sw_done_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_reser_in_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pld_pma_testbus_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pld_test_data_polling_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_user_clk_rst_sel = "rx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_user_clk_sel = "rx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfiford_post_ct_sel = "rxfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfiford_to_aib_sel = "rxfiford_sclk_to_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifowr_post_ct_sel = "rxfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifowr_pre_ct_sel = "rxfifowr_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__txfiford_post_ct_sel = "txfiford_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__txfiford_pre_ct_sel = "txfiford_pre_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__txfifowr_from_aib_sel = "txfifowr_sclk_from_aib";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__txfifowr_post_ct_sel = "txfifowr_post_ct";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hrdrst_user_ctl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__phcomp_rd_del = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_datapath_tb_sel = "wa";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_latency_src_xcvrif = "latency_pls_e400e200";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_user_clk_rst_sel = "tx_user_clk_hard_rst";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_user_clk_sel = "tx_user_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_usertest_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_hssi_rx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_hssi_tx_transfer_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_rx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_tx_user_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__op_mode = "rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dfd_dll_dcc_en = "disable_dfd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__dft_hssitestip_dll_dcc_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__op_mode = "tx_dll_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__barak_es_limit = "barak_es_limit_r1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_an_mode = "bk0_an_mode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_bti_protected = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_fec_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_loopback_mode = "bk0_lpbk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_pam4_rxgrey_code = "bk0_pam4_rxgrey_is_b4";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_invert_p_and_n = "bk0_rx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_precode_en = "bk0_rx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_bond_size = "bk0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_ffe_output_swizzle = "bk0_txffe_output_swizzle_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_invert_p_and_n = "bk0_tx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_precode_en = "bk0_tx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_protocol = "bk0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_post_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_post_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_post_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_pre_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txout_tristate_en = "bk0_txout_tristate_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txrx_line_encoding_type = "bk0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txrx_xcvr_speed_bucket = "bk0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_an_mode = "bk1_an_mode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_bti_protected = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_fec_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_loopback_mode = "bk1_lpbk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_pam4_rxgrey_code = "bk1_pam4_rxgrey_is_b4";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_invert_p_and_n = "bk1_rx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_precode_en = "bk1_rx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_bond_size = "bk1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_ffe_output_swizzle = "bk1_txffe_output_swizzle_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_invert_p_and_n = "bk1_tx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_precode_en = "bk1_tx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_protocol = "bk1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_post_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_post_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_post_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_pre_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txout_tristate_en = "bk1_txout_tristate_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txrx_line_encoding_type = "bk1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txrx_xcvr_speed_bucket = "bk1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_an_mode = "bk2_an_mode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_bti_protected = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_fec_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_loopback_mode = "bk2_lpbk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_pam4_rxgrey_code = "bk2_pam4_rxgrey_is_b4";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_invert_p_and_n = "bk2_rx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_precode_en = "bk2_rx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_bond_size = "bk2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_ffe_output_swizzle = "bk2_txffe_output_swizzle_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_invert_p_and_n = "bk2_tx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_precode_en = "bk2_tx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_protocol = "bk2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_post_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_post_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_post_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_pre_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txout_tristate_en = "bk2_txout_tristate_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txrx_line_encoding_type = "bk2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txrx_xcvr_speed_bucket = "bk2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_an_mode = "bk3_an_mode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_bti_protected = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_fec_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_loopback_mode = "bk3_lpbk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_pam4_rxgrey_code = "bk3_pam4_rxgrey_is_b4";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_invert_p_and_n = "bk3_rx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_precode_en = "bk3_rx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_bond_size = "bk3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_ffe_output_swizzle = "bk3_txffe_output_swizzle_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_invert_p_and_n = "bk3_tx_invert_pn_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_precode_en = "bk3_tx_precode_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_protocol = "bk3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_post_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_post_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_post_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_pre_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txout_tristate_en = "bk3_txout_tristate_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txrx_line_encoding_type = "bk3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txrx_xcvr_speed_bucket = "bk3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_2nd_cbpll_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_gray = "bk_bitprog_nogray";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_invert = "bk_bitprog_noinvert";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_lane_mode = "bk_bitprog_lane_mode0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_lane_sel = "bk_bitprog_sel_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_opcode = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_pllrate_sel = "bk_bitprog_pllrate_12g";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_prbssel_berthld_ppmsrc_pattype_netsel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_swl = "bk_bitprog_swl_none";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_tx_fail_thld = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_tx_preset_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_tx_test_length = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_update_cfg = "bk_bitprog_noupdate_cfg";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_car_tx_clk_src_sel = "bk_car_tx_clk_src_sel_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_clk_en_plla_cmos_refclk_out = "clken_cmos_plla_refclko_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_clk_en_pllb_cmos_refclk_out = "clken_cmos_pllb_refclko_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_kvcc_vreg_offset_en_val = "bk_common_pll_a_cfg_kvcc_vreg_offset_en_val_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_vregcomp_average_cnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_kvcc_vreg_offset_en_val = "bk_common_pll_b_cfg_kvcc_vreg_offset_en_val_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_vregcomp_average_cnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_refclk_source_pll_a = "gnd_to_plla_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_refclk_source_pll_b = "gnd_to_pllb_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_dl_enable_lane0 = "bk0_detlat_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_dl_enable_lane1 = "bk1_detlat_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_dl_enable_lane2 = "bk2_detlat_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_dl_enable_lane3 = "bk3_detlat_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_en_rxdat_profile_ln0 = "bk0_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_en_rxdat_profile_ln1 = "bk1_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_en_rxdat_profile_ln2 = "bk2_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_en_rxdat_profile_ln3 = "bk3_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_fast_clk_sel = "bk_fast_clk_sel_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_pcs3334_ratio = "lane0_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_rx_pcs3334_ratio = "lane0_rx_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_refclk_source_lane_pll = "bk_lane0_ref_to_gnd";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_limit_lsb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_limit_msb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_mask_0_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_mask_32_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_mask_64_95 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_mask_96_127 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_prbs_common_en = "bk_lane0_rx_prbs_common_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_prbs_mode = "lane0_rx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_user_clk1_en = "bk0_rx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_user_clk1_sel = "bk0_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_user_clk2_en = "bk0_rx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_user_clk2_sel = "bk0_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_prbs_en = "bk_lane0_tx_prbs_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_prbs_mode = "lane0_tx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_swizzle_mode = "lane0_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_user_clk1_en = "bk0_tx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_user_clk1_sel = "bk0_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_user_clk2_en = "bk0_tx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_user_clk2_sel = "bk0_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_pcs3334_ratio = "lane1_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_rx_pcs3334_ratio = "lane1_rx_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_refclk_source_lane_pll = "bk_lane1_ref_to_gnd";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_limit_lsb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_limit_msb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_mask_0_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_mask_32_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_mask_64_95 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_mask_96_127 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_prbs_common_en = "bk_lane1_rx_prbs_common_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_prbs_mode = "lane1_rx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_user_clk1_en = "bk1_rx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_user_clk1_sel = "bk1_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_user_clk2_en = "bk1_rx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_user_clk2_sel = "bk1_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_prbs_en = "bk_lane1_tx_prbs_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_prbs_mode = "lane1_tx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_swizzle_mode = "lane1_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_user_clk1_en = "bk1_tx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_user_clk1_sel = "bk1_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_user_clk2_en = "bk1_tx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_user_clk2_sel = "bk1_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_pcs3334_ratio = "lane2_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_rx_pcs3334_ratio = "lane2_rx_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_refclk_source_lane_pll = "bk_lane2_ref_to_gnd";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_limit_lsb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_limit_msb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_mask_0_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_mask_32_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_mask_64_95 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_mask_96_127 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_prbs_common_en = "bk_lane2_rx_prbs_common_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_prbs_mode = "lane2_rx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_user_clk1_en = "bk2_rx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_user_clk1_sel = "bk2_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_user_clk2_en = "bk2_rx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_user_clk2_sel = "bk2_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_prbs_en = "bk_lane2_tx_prbs_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_prbs_mode = "lane2_tx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_swizzle_mode = "lane2_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_user_clk1_en = "bk2_tx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_user_clk1_sel = "bk2_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_user_clk2_en = "bk2_tx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_user_clk2_sel = "bk2_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_pcs3334_ratio = "lane3_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_rx_pcs3334_ratio = "lane3_rx_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_refclk_source_lane_pll = "bk_lane3_ref_to_gnd";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_limit_lsb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_limit_msb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_mask_0_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_mask_32_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_mask_64_95 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_mask_96_127 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_prbs_common_en = "bk_lane3_rx_prbs_common_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_prbs_mode = "lane3_rx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_user_clk1_en = "bk3_rx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_user_clk1_sel = "bk3_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_user_clk2_en = "bk3_rx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_user_clk2_sel = "bk3_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_prbs_en = "bk_lane3_tx_prbs_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_prbs_mode = "lane3_tx_prbs_7";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_swizzle_mode = "lane3_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_user_clk1_en = "bk3_tx_usrclk1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_user_clk1_sel = "bk3_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_user_clk2_en = "bk3_tx_usrclk2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_user_clk2_sel = "bk3_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lnx_txovf_rxbdstb_inten = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lnx_txudf_pldrstb_inten = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_bdst_rcon_en_ln0 = "bk0_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_bdst_rcon_en_ln1 = "bk1_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_bdst_rcon_en_ln2 = "bk2_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_bdst_rcon_en_ln3 = "bk3_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_lat_bit_for_async_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_lat_bit_for_async_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_lat_bit_for_async_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_lat_bit_for_async_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_ppmd_rcon_en_ln0 = "bk0_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_ppmd_rcon_en_ln1 = "bk1_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_ppmd_rcon_en_ln2 = "bk2_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rx_ppmd_rcon_en_ln3 = "bk3_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_cntr_pma_lane0 = "bk0_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_cntr_pma_lane1 = "bk1_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_cntr_pma_lane2 = "bk2_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_cntr_pma_lane3 = "bk3_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_rollover_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_rollover_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_rollover_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxbit_rollover_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_high_ln0 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_high_ln1 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_high_ln2 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_high_ln3 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_low_ln0 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_low_ln1 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_low_ln2 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_rxdat_1cnt_thld_low_ln3 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_sel_tx_user_data_ln0 = "bk0_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_sel_tx_user_data_ln1 = "bk1_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_sel_tx_user_data_ln2 = "bk2_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_sel_tx_user_data_ln3 = "bk3_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq0_enable = "seq0_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq10_enable = "seq10_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq11_enable = "seq11_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq12_enable = "seq12_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq13_enable = "seq13_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq14_enable = "seq14_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq15_enable = "seq15_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq16_enable = "seq16_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq17_enable = "seq17_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq18_enable = "seq18_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq19_enable = "seq19_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq1_enable = "seq1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq20_enable = "seq20_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq21_enable = "seq21_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq22_enable = "seq22_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq23_enable = "seq23_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq24_enable = "seq24_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq25_enable = "seq25_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq26_enable = "seq26_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq27_enable = "seq27_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq28_enable = "seq28_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq29_enable = "seq29_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq2_enable = "seq2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq30_enable = "seq30_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq31_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq31_enable = "seq31_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq31_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq31_rdwrb = "seq31_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq32_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq32_enable = "seq32_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq32_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq32_rdwrb = "seq32_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq33_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq33_enable = "seq33_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq33_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq33_rdwrb = "seq33_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq34_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq34_enable = "seq34_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq34_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq34_rdwrb = "seq34_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq35_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq35_enable = "seq35_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq35_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq35_rdwrb = "seq35_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq36_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq36_enable = "seq36_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq36_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq36_rdwrb = "seq36_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq37_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq37_enable = "seq37_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq37_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq37_rdwrb = "seq37_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq38_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq38_enable = "seq38_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq38_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq38_rdwrb = "seq38_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq39_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq39_enable = "seq39_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq39_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq39_rdwrb = "seq39_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq3_enable = "seq3_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq40_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq40_enable = "seq40_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq40_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq40_rdwrb = "seq40_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq41_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq41_enable = "seq41_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq41_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq41_rdwrb = "seq41_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq42_enable = "seq42_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq43_enable = "seq43_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq44_enable = "seq44_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq45_enable = "seq45_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq46_enable = "seq46_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq4_enable = "seq4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq55_enable = "seq55_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq56_enable = "seq56_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq57_enable = "seq57_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq58_enable = "seq58_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq59_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq59_enable = "seq59_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq59_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq59_rdwrb = "seq59_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq5_enable = "seq5_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq60_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq60_enable = "seq60_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq60_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq60_rdwrb = "seq60_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq61_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq61_enable = "seq61_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq61_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq61_rdwrb = "seq61_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq62_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq62_enable = "seq62_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq62_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq62_rdwrb = "seq62_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq63_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq63_enable = "seq63_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq63_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq63_rdwrb = "seq63_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq6_enable = "seq6_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq7_enable = "seq7_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq8_enable = "seq8_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_seq9_enable = "seq9_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_speed_grade = "bk_speed_grade_none";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_lnx_ovf_inten_dirsignal = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_lnx_rxbadst_inten_dirsignal = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_lnx_udf_inten_dirsignal = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln0_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln0_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln0_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln0_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln1_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln1_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln1_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln1_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln2_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln2_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln2_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln2_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln3_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln3_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln3_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tx_usr_data_ln3_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__channel_type = "chnl_simulation";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__package_type = "highend";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__refclk1_freq = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__refclk2_freq = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__rx_termination = "rxterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__speed_grade = "speed_grade_56g";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__tx_termination = "txterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pempty_thld_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pempty_thld_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pempty_thld_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pempty_thld_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pfull_thld_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pfull_thld_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pfull_thld_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_pfull_thld_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_en_attr = "dts_ctrl_f_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mailbox_out_outgoing_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_cvp_attr = "pcie_cvp_attr_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_hw_decode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_use_pin_perstn_attr = "pcie_does_not_use_pinperst_attr";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c0_bypass_control = "pll_0_c0_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c0_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c0_output_enable = "pll_0_c0_output_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c1_bypass_control = "pll_0_c1_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c1_counter = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c1_output_enable = "pll_0_c1_output_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c2_bypass_control = "pll_0_c2_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c2_counter = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c2_output_enable = "pll_0_c2_output_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c3_bypass_control = "pll_0_c3_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c3_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c3_output_enable = "pll_0_c3_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_calib_f_hscount = 96;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_calib_f_mscount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_ethernet_preset = "pll_0_ethernet_freq_other";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_out_c0_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_out_c1_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_out_c2_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_pfd_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_vco_hz = 32'hE8D4A510;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_fractional_enable = "pll_0_fractional_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_m_counter = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_pcie_preset = "pll_0_pcie_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_powerdown_mode = "pll_0_pwrdn_false";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_primary_use = "pll_0_ethernet";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_refclk_calibration_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_refclk_mux_select = "pll_0_ref_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c0_bypass_control = "pll_1_c0_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c0_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c0_output_enable = "pll_1_c0_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c1_bypass_control = "pll_1_c1_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c1_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c1_output_enable = "pll_1_c1_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c2_bypass_control = "pll_1_c2_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c2_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c2_output_enable = "pll_1_c2_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c3_bypass_control = "pll_1_c3_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c3_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c3_output_enable = "pll_1_c3_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_calib_f_hscount = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_calib_f_mscount = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_ethernet_preset = "pll_1_ethernet_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_out_c0_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_out_c1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_out_c2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_fractional_enable = "pll_1_fractional_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_pcie_preset = "pll_1_pcie_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_powerdown_mode = "pll_1_pwrdn_true";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_primary_use = "pll_1_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_refclk_calibration_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_refclk_mux_select = "pll_1_refclk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c0_bypass_control = "pll_2_c0_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c0_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c0_output_enable = "pll_2_c0_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c1_bypass_control = "pll_2_c1_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c1_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c1_output_enable = "pll_2_c1_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c2_bypass_control = "pll_2_c2_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c2_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c2_output_enable = "pll_2_c2_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c3_bypass_control = "pll_2_c3_bypass_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c3_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c3_output_enable = "pll_2_c3_output_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_calib_f_hscount = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_calib_f_mscount = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_ethernet_preset = "pll_2_ethernet_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_out_c0_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_out_c1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_out_c2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_fractional_enable = "pll_2_fractional_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_pcie_preset = "pll_2_pcie_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_powerdown_mode = "pll_2_pwrdn_true";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_primary_use = "pll_2_unused";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_refclk_calibration_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_refclk_mux_select = "pll_2_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_aref_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_extended_attr = "pll_ctrl_0_f_extended_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_aref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_extended_attr = "pll_ctrl_1_f_extended_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_aref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_extended_attr = "pll_ctrl_2_f_extended_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_ctrl_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_ctrl_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_ctrl_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_dfd_power_off_attr = "primary_dfd_power_off_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_ext_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__sup_mode = "advanced_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__topology = "ux16e400gptp_xx_disabled_xx_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__dft_aux_en = "disable_dft";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__dft_dll_osc_dftsel = "disable_dll_osc_dftsel";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__dft_osc_dftcounter = "disable_osc_dftcounter";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__redundancy_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_aib2_rx_st_clk_en = "e200g_100g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_aib2_tx_st_clk_en = "e200g_100g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_aib3_rx_st_clk_en = "e200g_100g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_aib3_tx_st_clk_en = "e200g_100g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_aibif_data_valid = "e200g_100g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_duplex_mode = "e200g_100g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_fec_clk_src = "e200g_100g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_fec_error = "e200g_100g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_fec_mode = "e200g_100g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_fec_spec = "e200g_100g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_lpbk_mode = "e200g_100g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_pcs_ber_mon_mode = "e200g_100g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_ptp_mode = "e200g_100g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_aib_if_fifo_mode = "e200g_100g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_excvr_gb_ratio_mode = "e200g_100g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_excvr_if_fifo_mode = "e200g_100g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_fec_enable = "e200g_100g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_master_bond_chnl = "e200g_100g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_pcs_mode = "e200g_100g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_primary_use = "e200g_100g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_rx_xcvr_width = "e200g_100g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_speed_map = "e200g_100g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_sup_mode = "e200g_100g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_sys_clk_src = "e200g_100g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_aib_if_fifo_mode = "e200g_100g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_excvr_gb_ratio_mode = "e200g_100g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_excvr_if_fifo_mode = "e200g_100g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_fec_enable = "e200g_100g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_master_bond_chnl = "e200g_100g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_pcs_mode = "e200g_100g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_primary_use = "e200g_100g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_tx_xcvr_width = "e200g_100g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_xcvr_mode = "e200g_100g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_xcvr_type = "e200g_100g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_aib2_rx_st_clk_en = "e200g_100g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_aib2_tx_st_clk_en = "e200g_100g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_aib3_rx_st_clk_en = "e200g_100g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_aib3_tx_st_clk_en = "e200g_100g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_aibif_data_valid = "e200g_100g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_duplex_mode = "e200g_100g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_fec_clk_src = "e200g_100g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_fec_error = "e200g_100g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_fec_mode = "e200g_100g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_fec_spec = "e200g_100g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_lpbk_mode = "e200g_100g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_pcs_ber_mon_mode = "e200g_100g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_ptp_mode = "e200g_100g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_aib_if_fifo_mode = "e200g_100g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_excvr_gb_ratio_mode = "e200g_100g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_excvr_if_fifo_mode = "e200g_100g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_fec_enable = "e200g_100g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_master_bond_chnl = "e200g_100g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_pcs_mode = "e200g_100g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_primary_use = "e200g_100g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_rx_xcvr_width = "e200g_100g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_speed_map = "e200g_100g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_sup_mode = "e200g_100g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_sys_clk_src = "e200g_100g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_aib_if_fifo_mode = "e200g_100g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_excvr_gb_ratio_mode = "e200g_100g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_excvr_if_fifo_mode = "e200g_100g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_fec_enable = "e200g_100g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_master_bond_chnl = "e200g_100g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_pcs_mode = "e200g_100g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_primary_use = "e200g_100g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_tx_xcvr_width = "e200g_100g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_xcvr_mode = "e200g_100g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_xcvr_type = "e200g_100g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_aib2_rx_st_clk_en = "e200g_150g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_aib2_tx_st_clk_en = "e200g_150g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_aib3_rx_st_clk_en = "e200g_150g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_aib3_tx_st_clk_en = "e200g_150g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_aibif_data_valid = "e200g_150g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_duplex_mode = "e200g_150g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_fec_mode = "e200g_150g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_fec_spec = "e200g_150g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_lpbk_mode = "e200g_150g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_pcs_ber_mon_mode = "e200g_150g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_ptp_mode = "e200g_150g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_aib_if_fifo_mode = "e200g_150g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_excvr_gb_ratio_mode = "e200g_150g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_excvr_if_fifo_mode = "e200g_150g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_fec_enable = "e200g_150g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_master_bond_chnl = "e200g_150g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_pcs_mode = "e200g_150g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_primary_use = "e200g_150g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_rx_xcvr_width = "e200g_150g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_speed_map = "e200g_150g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_sup_mode = "e200g_150g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_sys_clk_src = "e200g_150g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_aib_if_fifo_mode = "e200g_150g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_excvr_gb_ratio_mode = "e200g_150g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_excvr_if_fifo_mode = "e200g_150g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_fec_enable = "e200g_150g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_master_bond_chnl = "e200g_150g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_pcs_mode = "e200g_150g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_primary_use = "e200g_150g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_tx_xcvr_width = "e200g_150g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_xcvr_mode = "e200g_150g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_xcvr_type = "e200g_150g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_aib2_rx_st_clk_en = "e200g_150g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_aib2_tx_st_clk_en = "e200g_150g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_aib3_rx_st_clk_en = "e200g_150g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_aib3_tx_st_clk_en = "e200g_150g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_aibif_data_valid = "e200g_150g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_duplex_mode = "e200g_150g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_fec_mode = "e200g_150g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_fec_spec = "e200g_150g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_lpbk_mode = "e200g_150g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_pcs_ber_mon_mode = "e200g_150g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_ptp_mode = "e200g_150g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_aib_if_fifo_mode = "e200g_150g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_excvr_gb_ratio_mode = "e200g_150g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_excvr_if_fifo_mode = "e200g_150g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_fec_enable = "e200g_150g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_master_bond_chnl = "e200g_150g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_pcs_mode = "e200g_150g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_primary_use = "e200g_150g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_rx_xcvr_width = "e200g_150g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_speed_map = "e200g_150g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_sup_mode = "e200g_150g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_sys_clk_src = "e200g_150g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_aib_if_fifo_mode = "e200g_150g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_excvr_gb_ratio_mode = "e200g_150g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_excvr_if_fifo_mode = "e200g_150g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_fec_enable = "e200g_150g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_master_bond_chnl = "e200g_150g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_pcs_mode = "e200g_150g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_primary_use = "e200g_150g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_tx_xcvr_width = "e200g_150g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_xcvr_mode = "e200g_150g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_xcvr_type = "e200g_150g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_aib2_rx_st_clk_en = "e200g_200g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_aib2_tx_st_clk_en = "e200g_200g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_aib3_rx_st_clk_en = "e200g_200g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_aib3_tx_st_clk_en = "e200g_200g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_aibif_data_valid = "e200g_200g_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_duplex_mode = "e200g_200g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_fec_clk_src = "e200g_200g_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_fec_error = "e200g_200g_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_fec_mode = "e200g_200g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_fec_spec = "e200g_200g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_lpbk_mode = "e200g_200g_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_pcs_ber_mon_mode = "e200g_200g_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_ptp_mode = "e200g_200g_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_aib_if_fifo_mode = "e200g_200g_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_excvr_gb_ratio_mode = "e200g_200g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_excvr_if_fifo_mode = "e200g_200g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_fec_enable = "e200g_200g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_master_bond_chnl = "e200g_200g_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_pcs_mode = "e200g_200g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_primary_use = "e200g_200g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_rx_xcvr_width = "e200g_200g_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_speed_map = "e200g_200g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_sup_mode = "e200g_200g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_sys_clk_src = "e200g_200g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_aib_if_fifo_mode = "e200g_200g_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_excvr_gb_ratio_mode = "e200g_200g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_excvr_if_fifo_mode = "e200g_200g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_fec_enable = "e200g_200g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_master_bond_chnl = "e200g_200g_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_pcs_mode = "e200g_200g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_primary_use = "e200g_200g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_tx_xcvr_width = "e200g_200g_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_xcvr_mode = "e200g_200g_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_xcvr_type = "e200g_200g_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_aib2_rx_st_clk_en = "e200g_25g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_aib2_tx_st_clk_en = "e200g_25g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_aib3_rx_st_clk_en = "e200g_25g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_aib3_tx_st_clk_en = "e200g_25g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_aibif_data_valid = "e200g_25g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_duplex_mode = "e200g_25g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_fec_clk_src = "e200g_25g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_fec_error = "e200g_25g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_fec_mode = "e200g_25g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_fec_spec = "e200g_25g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_lpbk_mode = "e200g_25g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_pcs_ber_mon_mode = "e200g_25g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_ptp_mode = "e200g_25g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_aib_if_fifo_mode = "e200g_25g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_excvr_gb_ratio_mode = "e200g_25g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_excvr_if_fifo_mode = "e200g_25g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_fec_enable = "e200g_25g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_master_bond_chnl = "e200g_25g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_pcs_mode = "e200g_25g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_primary_use = "e200g_25g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_rx_xcvr_width = "e200g_25g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_speed_map = "e200g_25g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_sup_mode = "e200g_25g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_sys_clk_src = "e200g_25g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_aib_if_fifo_mode = "e200g_25g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_excvr_gb_ratio_mode = "e200g_25g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_excvr_if_fifo_mode = "e200g_25g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_fec_enable = "e200g_25g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_master_bond_chnl = "e200g_25g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_pcs_mode = "e200g_25g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_primary_use = "e200g_25g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_tx_xcvr_width = "e200g_25g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_xcvr_mode = "e200g_25g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_xcvr_type = "e200g_25g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_aib2_rx_st_clk_en = "e200g_25g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_aib2_tx_st_clk_en = "e200g_25g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_aib3_rx_st_clk_en = "e200g_25g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_aib3_tx_st_clk_en = "e200g_25g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_aibif_data_valid = "e200g_25g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_duplex_mode = "e200g_25g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_fec_clk_src = "e200g_25g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_fec_error = "e200g_25g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_fec_mode = "e200g_25g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_fec_spec = "e200g_25g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_lpbk_mode = "e200g_25g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_pcs_ber_mon_mode = "e200g_25g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_ptp_mode = "e200g_25g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_aib_if_fifo_mode = "e200g_25g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_excvr_gb_ratio_mode = "e200g_25g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_excvr_if_fifo_mode = "e200g_25g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_fec_enable = "e200g_25g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_master_bond_chnl = "e200g_25g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_pcs_mode = "e200g_25g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_primary_use = "e200g_25g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_rx_xcvr_width = "e200g_25g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_speed_map = "e200g_25g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_sup_mode = "e200g_25g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_sys_clk_src = "e200g_25g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_aib_if_fifo_mode = "e200g_25g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_excvr_gb_ratio_mode = "e200g_25g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_excvr_if_fifo_mode = "e200g_25g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_fec_enable = "e200g_25g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_master_bond_chnl = "e200g_25g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_pcs_mode = "e200g_25g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_primary_use = "e200g_25g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_tx_xcvr_width = "e200g_25g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_xcvr_mode = "e200g_25g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_xcvr_type = "e200g_25g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_aib2_rx_st_clk_en = "e200g_25g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_aib2_tx_st_clk_en = "e200g_25g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_aib3_rx_st_clk_en = "e200g_25g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_aib3_tx_st_clk_en = "e200g_25g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_aibif_data_valid = "e200g_25g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_duplex_mode = "e200g_25g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_fec_clk_src = "e200g_25g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_fec_error = "e200g_25g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_fec_mode = "e200g_25g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_fec_spec = "e200g_25g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_lpbk_mode = "e200g_25g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_pcs_ber_mon_mode = "e200g_25g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_ptp_mode = "e200g_25g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_aib_if_fifo_mode = "e200g_25g_2_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_excvr_gb_ratio_mode = "e200g_25g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_excvr_if_fifo_mode = "e200g_25g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_fec_enable = "e200g_25g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_master_bond_chnl = "e200g_25g_2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_pcs_mode = "e200g_25g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_primary_use = "e200g_25g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_rx_xcvr_width = "e200g_25g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_speed_map = "e200g_25g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_sup_mode = "e200g_25g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_sys_clk_src = "e200g_25g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_aib_if_fifo_mode = "e200g_25g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_excvr_gb_ratio_mode = "e200g_25g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_excvr_if_fifo_mode = "e200g_25g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_fec_enable = "e200g_25g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_master_bond_chnl = "e200g_25g_2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_pcs_mode = "e200g_25g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_primary_use = "e200g_25g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_tx_xcvr_width = "e200g_25g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_xcvr_mode = "e200g_25g_2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_xcvr_type = "e200g_25g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_aib2_rx_st_clk_en = "e200g_25g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_aib2_tx_st_clk_en = "e200g_25g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_aib3_rx_st_clk_en = "e200g_25g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_aib3_tx_st_clk_en = "e200g_25g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_aibif_data_valid = "e200g_25g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_duplex_mode = "e200g_25g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_fec_clk_src = "e200g_25g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_fec_error = "e200g_25g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_fec_mode = "e200g_25g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_fec_spec = "e200g_25g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_lpbk_mode = "e200g_25g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_pcs_ber_mon_mode = "e200g_25g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_ptp_mode = "e200g_25g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_aib_if_fifo_mode = "e200g_25g_3_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_excvr_gb_ratio_mode = "e200g_25g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_excvr_if_fifo_mode = "e200g_25g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_fec_enable = "e200g_25g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_master_bond_chnl = "e200g_25g_3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_pcs_mode = "e200g_25g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_primary_use = "e200g_25g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_rx_xcvr_width = "e200g_25g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_speed_map = "e200g_25g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_sup_mode = "e200g_25g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_sys_clk_src = "e200g_25g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_aib_if_fifo_mode = "e200g_25g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_excvr_gb_ratio_mode = "e200g_25g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_excvr_if_fifo_mode = "e200g_25g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_fec_enable = "e200g_25g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_master_bond_chnl = "e200g_25g_3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_pcs_mode = "e200g_25g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_primary_use = "e200g_25g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_tx_xcvr_width = "e200g_25g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_xcvr_mode = "e200g_25g_3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_xcvr_type = "e200g_25g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_aib2_rx_st_clk_en = "e200g_25g_4_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_aib2_tx_st_clk_en = "e200g_25g_4_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_aib3_rx_st_clk_en = "e200g_25g_4_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_aib3_tx_st_clk_en = "e200g_25g_4_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_aibif_data_valid = "e200g_25g_4_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_duplex_mode = "e200g_25g_4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_fec_clk_src = "e200g_25g_4_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_fec_error = "e200g_25g_4_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_fec_mode = "e200g_25g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_fec_spec = "e200g_25g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_lpbk_mode = "e200g_25g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_pcs_ber_mon_mode = "e200g_25g_4_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_ptp_mode = "e200g_25g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_aib_if_fifo_mode = "e200g_25g_4_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_excvr_gb_ratio_mode = "e200g_25g_4_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_excvr_if_fifo_mode = "e200g_25g_4_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_fec_enable = "e200g_25g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_master_bond_chnl = "e200g_25g_4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_pcs_mode = "e200g_25g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_primary_use = "e200g_25g_4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_rx_xcvr_width = "e200g_25g_4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_speed_map = "e200g_25g_4_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_sup_mode = "e200g_25g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_sys_clk_src = "e200g_25g_4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_aib_if_fifo_mode = "e200g_25g_4_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_excvr_gb_ratio_mode = "e200g_25g_4_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_excvr_if_fifo_mode = "e200g_25g_4_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_fec_enable = "e200g_25g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_master_bond_chnl = "e200g_25g_4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_pcs_mode = "e200g_25g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_primary_use = "e200g_25g_4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_tx_xcvr_width = "e200g_25g_4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_xcvr_mode = "e200g_25g_4_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_xcvr_type = "e200g_25g_4_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_aib2_rx_st_clk_en = "e200g_25g_5_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_aib2_tx_st_clk_en = "e200g_25g_5_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_aib3_rx_st_clk_en = "e200g_25g_5_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_aib3_tx_st_clk_en = "e200g_25g_5_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_aibif_data_valid = "e200g_25g_5_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_duplex_mode = "e200g_25g_5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_fec_clk_src = "e200g_25g_5_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_fec_error = "e200g_25g_5_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_fec_mode = "e200g_25g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_fec_spec = "e200g_25g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_lpbk_mode = "e200g_25g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_pcs_ber_mon_mode = "e200g_25g_5_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_ptp_mode = "e200g_25g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_aib_if_fifo_mode = "e200g_25g_5_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_excvr_gb_ratio_mode = "e200g_25g_5_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_excvr_if_fifo_mode = "e200g_25g_5_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_fec_enable = "e200g_25g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_master_bond_chnl = "e200g_25g_5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_pcs_mode = "e200g_25g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_primary_use = "e200g_25g_5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_rx_xcvr_width = "e200g_25g_5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_speed_map = "e200g_25g_5_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_sup_mode = "e200g_25g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_sys_clk_src = "e200g_25g_5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_aib_if_fifo_mode = "e200g_25g_5_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_excvr_gb_ratio_mode = "e200g_25g_5_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_excvr_if_fifo_mode = "e200g_25g_5_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_fec_enable = "e200g_25g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_master_bond_chnl = "e200g_25g_5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_pcs_mode = "e200g_25g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_primary_use = "e200g_25g_5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_tx_xcvr_width = "e200g_25g_5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_xcvr_mode = "e200g_25g_5_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_xcvr_type = "e200g_25g_5_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_aib2_rx_st_clk_en = "e200g_25g_6_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_aib2_tx_st_clk_en = "e200g_25g_6_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_aib3_rx_st_clk_en = "e200g_25g_6_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_aib3_tx_st_clk_en = "e200g_25g_6_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_aibif_data_valid = "e200g_25g_6_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_duplex_mode = "e200g_25g_6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_fec_clk_src = "e200g_25g_6_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_fec_error = "e200g_25g_6_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_fec_mode = "e200g_25g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_fec_spec = "e200g_25g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_lpbk_mode = "e200g_25g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_pcs_ber_mon_mode = "e200g_25g_6_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_ptp_mode = "e200g_25g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_aib_if_fifo_mode = "e200g_25g_6_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_excvr_gb_ratio_mode = "e200g_25g_6_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_excvr_if_fifo_mode = "e200g_25g_6_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_fec_enable = "e200g_25g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_master_bond_chnl = "e200g_25g_6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_pcs_mode = "e200g_25g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_primary_use = "e200g_25g_6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_rx_xcvr_width = "e200g_25g_6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_speed_map = "e200g_25g_6_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_sup_mode = "e200g_25g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_sys_clk_src = "e200g_25g_6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_aib_if_fifo_mode = "e200g_25g_6_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_excvr_gb_ratio_mode = "e200g_25g_6_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_excvr_if_fifo_mode = "e200g_25g_6_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_fec_enable = "e200g_25g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_master_bond_chnl = "e200g_25g_6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_pcs_mode = "e200g_25g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_primary_use = "e200g_25g_6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_tx_xcvr_width = "e200g_25g_6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_xcvr_mode = "e200g_25g_6_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_xcvr_type = "e200g_25g_6_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_aib2_rx_st_clk_en = "e200g_25g_7_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_aib2_tx_st_clk_en = "e200g_25g_7_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_aib3_rx_st_clk_en = "e200g_25g_7_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_aib3_tx_st_clk_en = "e200g_25g_7_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_aibif_data_valid = "e200g_25g_7_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_duplex_mode = "e200g_25g_7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_fec_clk_src = "e200g_25g_7_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_fec_error = "e200g_25g_7_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_fec_mode = "e200g_25g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_fec_spec = "e200g_25g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_lpbk_mode = "e200g_25g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_pcs_ber_mon_mode = "e200g_25g_7_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_ptp_mode = "e200g_25g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_aib_if_fifo_mode = "e200g_25g_7_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_excvr_gb_ratio_mode = "e200g_25g_7_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_excvr_if_fifo_mode = "e200g_25g_7_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_fec_enable = "e200g_25g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_master_bond_chnl = "e200g_25g_7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_pcs_mode = "e200g_25g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_primary_use = "e200g_25g_7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_rx_xcvr_width = "e200g_25g_7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_speed_map = "e200g_25g_7_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_sup_mode = "e200g_25g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_sys_clk_src = "e200g_25g_7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_aib_if_fifo_mode = "e200g_25g_7_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_excvr_gb_ratio_mode = "e200g_25g_7_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_excvr_if_fifo_mode = "e200g_25g_7_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_fec_enable = "e200g_25g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_master_bond_chnl = "e200g_25g_7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_pcs_mode = "e200g_25g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_primary_use = "e200g_25g_7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_tx_xcvr_width = "e200g_25g_7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_xcvr_mode = "e200g_25g_7_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_xcvr_type = "e200g_25g_7_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_aib2_rx_st_clk_en = "e200g_50g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_aib2_tx_st_clk_en = "e200g_50g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_aib3_rx_st_clk_en = "e200g_50g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_aib3_tx_st_clk_en = "e200g_50g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_aibif_data_valid = "e200g_50g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_duplex_mode = "e200g_50g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_fec_clk_src = "e200g_50g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_fec_error = "e200g_50g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_fec_mode = "e200g_50g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_fec_spec = "e200g_50g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_lpbk_mode = "e200g_50g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_pcs_ber_mon_mode = "e200g_50g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_ptp_mode = "e200g_50g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_aib_if_fifo_mode = "e200g_50g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_excvr_gb_ratio_mode = "e200g_50g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_excvr_if_fifo_mode = "e200g_50g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_fec_enable = "e200g_50g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_master_bond_chnl = "e200g_50g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_pcs_mode = "e200g_50g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_primary_use = "e200g_50g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_rx_xcvr_width = "e200g_50g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_speed_map = "e200g_50g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_sup_mode = "e200g_50g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_sys_clk_src = "e200g_50g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_aib_if_fifo_mode = "e200g_50g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_excvr_gb_ratio_mode = "e200g_50g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_excvr_if_fifo_mode = "e200g_50g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_fec_enable = "e200g_50g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_master_bond_chnl = "e200g_50g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_pcs_mode = "e200g_50g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_primary_use = "e200g_50g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_tx_xcvr_width = "e200g_50g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_xcvr_mode = "e200g_50g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_xcvr_type = "e200g_50g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_aib2_rx_st_clk_en = "e200g_50g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_aib2_tx_st_clk_en = "e200g_50g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_aib3_rx_st_clk_en = "e200g_50g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_aib3_tx_st_clk_en = "e200g_50g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_aibif_data_valid = "e200g_50g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_duplex_mode = "e200g_50g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_fec_clk_src = "e200g_50g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_fec_error = "e200g_50g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_fec_mode = "e200g_50g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_fec_spec = "e200g_50g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_lpbk_mode = "e200g_50g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_pcs_ber_mon_mode = "e200g_50g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_ptp_mode = "e200g_50g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_aib_if_fifo_mode = "e200g_50g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_excvr_gb_ratio_mode = "e200g_50g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_excvr_if_fifo_mode = "e200g_50g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_fec_enable = "e200g_50g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_master_bond_chnl = "e200g_50g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_pcs_mode = "e200g_50g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_primary_use = "e200g_50g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_rx_xcvr_width = "e200g_50g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_speed_map = "e200g_50g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_sup_mode = "e200g_50g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_sys_clk_src = "e200g_50g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_aib_if_fifo_mode = "e200g_50g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_excvr_gb_ratio_mode = "e200g_50g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_excvr_if_fifo_mode = "e200g_50g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_fec_enable = "e200g_50g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_master_bond_chnl = "e200g_50g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_pcs_mode = "e200g_50g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_primary_use = "e200g_50g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_tx_xcvr_width = "e200g_50g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_xcvr_mode = "e200g_50g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_xcvr_type = "e200g_50g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_aib2_rx_st_clk_en = "e200g_50g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_aib2_tx_st_clk_en = "e200g_50g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_aib3_rx_st_clk_en = "e200g_50g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_aib3_tx_st_clk_en = "e200g_50g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_aibif_data_valid = "e200g_50g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_duplex_mode = "e200g_50g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_fec_clk_src = "e200g_50g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_fec_error = "e200g_50g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_fec_mode = "e200g_50g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_fec_spec = "e200g_50g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_lpbk_mode = "e200g_50g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_pcs_ber_mon_mode = "e200g_50g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_ptp_mode = "e200g_50g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_aib_if_fifo_mode = "e200g_50g_2_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_excvr_gb_ratio_mode = "e200g_50g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_excvr_if_fifo_mode = "e200g_50g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_fec_enable = "e200g_50g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_master_bond_chnl = "e200g_50g_2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_pcs_mode = "e200g_50g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_primary_use = "e200g_50g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_rx_xcvr_width = "e200g_50g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_speed_map = "e200g_50g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_sup_mode = "e200g_50g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_sys_clk_src = "e200g_50g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_aib_if_fifo_mode = "e200g_50g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_excvr_gb_ratio_mode = "e200g_50g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_excvr_if_fifo_mode = "e200g_50g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_fec_enable = "e200g_50g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_master_bond_chnl = "e200g_50g_2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_pcs_mode = "e200g_50g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_primary_use = "e200g_50g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_tx_xcvr_width = "e200g_50g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_xcvr_mode = "e200g_50g_2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_xcvr_type = "e200g_50g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_aib2_rx_st_clk_en = "e200g_50g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_aib2_tx_st_clk_en = "e200g_50g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_aib3_rx_st_clk_en = "e200g_50g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_aib3_tx_st_clk_en = "e200g_50g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_aibif_data_valid = "e200g_50g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_duplex_mode = "e200g_50g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_fec_clk_src = "e200g_50g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_fec_error = "e200g_50g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_fec_mode = "e200g_50g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_fec_spec = "e200g_50g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_lpbk_mode = "e200g_50g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_pcs_ber_mon_mode = "e200g_50g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_ptp_mode = "e200g_50g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_aib_if_fifo_mode = "e200g_50g_3_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_excvr_gb_ratio_mode = "e200g_50g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_excvr_if_fifo_mode = "e200g_50g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_fec_enable = "e200g_50g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_master_bond_chnl = "e200g_50g_3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_pcs_mode = "e200g_50g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_primary_use = "e200g_50g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_rx_xcvr_width = "e200g_50g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_speed_map = "e200g_50g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_sup_mode = "e200g_50g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_sys_clk_src = "e200g_50g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_aib_if_fifo_mode = "e200g_50g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_excvr_gb_ratio_mode = "e200g_50g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_excvr_if_fifo_mode = "e200g_50g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_fec_enable = "e200g_50g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_master_bond_chnl = "e200g_50g_3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_pcs_mode = "e200g_50g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_primary_use = "e200g_50g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_tx_xcvr_width = "e200g_50g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_xcvr_mode = "e200g_50g_3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_xcvr_type = "e200g_50g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_duplex_mode = "e200g_ux0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_rx_protocol = "e200g_ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_rx_xcvr_width = "e200g_ux0_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_speed_bucket = "e200g_ux0_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_sys_clk_src = "e200g_ux0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_tx_protocol = "e200g_ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_tx_xcvr_width = "e200g_ux0_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_txrx_line_encoding_type = "e200g_ux0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_xcvr_mode = "e200g_ux0_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_duplex_mode = "e200g_ux1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_rx_protocol = "e200g_ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_rx_xcvr_width = "e200g_ux1_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_speed_bucket = "e200g_ux1_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_sys_clk_src = "e200g_ux1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_tx_protocol = "e200g_ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_tx_xcvr_width = "e200g_ux1_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_txrx_line_encoding_type = "e200g_ux1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_xcvr_mode = "e200g_ux1_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_duplex_mode = "e200g_ux2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_rx_protocol = "e200g_ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_rx_xcvr_width = "e200g_ux2_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_speed_bucket = "e200g_ux2_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_sys_clk_src = "e200g_ux2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_tx_protocol = "e200g_ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_tx_xcvr_width = "e200g_ux2_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_txrx_line_encoding_type = "e200g_ux2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_xcvr_mode = "e200g_ux2_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_duplex_mode = "e200g_ux3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_rx_protocol = "e200g_ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_rx_xcvr_width = "e200g_ux3_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_speed_bucket = "e200g_ux3_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_sys_clk_src = "e200g_ux3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_tx_protocol = "e200g_ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_tx_xcvr_width = "e200g_ux3_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_txrx_line_encoding_type = "e200g_ux3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_xcvr_mode = "e200g_ux3_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_duplex_mode = "e200g_ux4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_rx_protocol = "e200g_ux4_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_rx_xcvr_width = "e200g_ux4_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_speed_bucket = "e200g_ux4_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_sys_clk_src = "e200g_ux4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_tx_protocol = "e200g_ux4_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_tx_xcvr_width = "e200g_ux4_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_txrx_line_encoding_type = "e200g_ux4_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_xcvr_mode = "e200g_ux4_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_duplex_mode = "e200g_ux5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_rx_protocol = "e200g_ux5_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_rx_xcvr_width = "e200g_ux5_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_speed_bucket = "e200g_ux5_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_sys_clk_src = "e200g_ux5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_tx_protocol = "e200g_ux5_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_tx_xcvr_width = "e200g_ux5_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_txrx_line_encoding_type = "e200g_ux5_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_xcvr_mode = "e200g_ux5_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_duplex_mode = "e200g_ux6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_rx_protocol = "e200g_ux6_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_rx_xcvr_width = "e200g_ux6_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_speed_bucket = "e200g_ux6_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_sys_clk_src = "e200g_ux6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_tx_protocol = "e200g_ux6_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_tx_xcvr_width = "e200g_ux6_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_txrx_line_encoding_type = "e200g_ux6_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_xcvr_mode = "e200g_ux6_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_duplex_mode = "e200g_ux7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_rx_protocol = "e200g_ux7_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_rx_xcvr_width = "e200g_ux7_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_speed_bucket = "e200g_ux7_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_sys_clk_src = "e200g_ux7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_tx_protocol = "e200g_ux7_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_tx_xcvr_width = "e200g_ux7_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_txrx_line_encoding_type = "e200g_ux7_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_xcvr_mode = "e200g_ux7_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_duplex_mode = "e200g_xcvr_speed_map_25e2x0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_rx_protocol = "e200g_xcvr_speed_map_25e2x0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_speed_bucket = "e200g_xcvr_speed_map_25e2x0_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_sys_clk_src = "e200g_xcvr_speed_map_25e2x0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_tx_protocol = "e200g_xcvr_speed_map_25e2x0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x0_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_xcvr_mode = "e200g_xcvr_speed_map_25e2x0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_duplex_mode = "e200g_xcvr_speed_map_25e2x10_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x10_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_rx_protocol = "e200g_xcvr_speed_map_25e2x10_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x10_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_speed_bucket = "e200g_xcvr_speed_map_25e2x10_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_sys_clk_src = "e200g_xcvr_speed_map_25e2x10_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x10_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_tx_protocol = "e200g_xcvr_speed_map_25e2x10_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x10_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x10_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x10_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x10_xcvr_mode = "e200g_xcvr_speed_map_25e2x10_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_duplex_mode = "e200g_xcvr_speed_map_25e2x11_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x11_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_rx_protocol = "e200g_xcvr_speed_map_25e2x11_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x11_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_speed_bucket = "e200g_xcvr_speed_map_25e2x11_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_sys_clk_src = "e200g_xcvr_speed_map_25e2x11_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x11_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_tx_protocol = "e200g_xcvr_speed_map_25e2x11_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x11_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x11_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x11_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x11_xcvr_mode = "e200g_xcvr_speed_map_25e2x11_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_duplex_mode = "e200g_xcvr_speed_map_25e2x12_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x12_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_rx_protocol = "e200g_xcvr_speed_map_25e2x12_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x12_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_speed_bucket = "e200g_xcvr_speed_map_25e2x12_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_sys_clk_src = "e200g_xcvr_speed_map_25e2x12_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x12_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_tx_protocol = "e200g_xcvr_speed_map_25e2x12_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x12_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x12_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x12_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x12_xcvr_mode = "e200g_xcvr_speed_map_25e2x12_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_duplex_mode = "e200g_xcvr_speed_map_25e2x13_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x13_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_rx_protocol = "e200g_xcvr_speed_map_25e2x13_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x13_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_speed_bucket = "e200g_xcvr_speed_map_25e2x13_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_sys_clk_src = "e200g_xcvr_speed_map_25e2x13_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x13_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_tx_protocol = "e200g_xcvr_speed_map_25e2x13_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x13_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x13_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x13_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x13_xcvr_mode = "e200g_xcvr_speed_map_25e2x13_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_duplex_mode = "e200g_xcvr_speed_map_25e2x14_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x14_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_rx_protocol = "e200g_xcvr_speed_map_25e2x14_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x14_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_speed_bucket = "e200g_xcvr_speed_map_25e2x14_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_sys_clk_src = "e200g_xcvr_speed_map_25e2x14_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x14_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_tx_protocol = "e200g_xcvr_speed_map_25e2x14_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x14_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x14_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x14_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x14_xcvr_mode = "e200g_xcvr_speed_map_25e2x14_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_duplex_mode = "e200g_xcvr_speed_map_25e2x15_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x15_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_rx_protocol = "e200g_xcvr_speed_map_25e2x15_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x15_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_speed_bucket = "e200g_xcvr_speed_map_25e2x15_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_sys_clk_src = "e200g_xcvr_speed_map_25e2x15_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x15_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_tx_protocol = "e200g_xcvr_speed_map_25e2x15_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x15_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x15_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x15_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x15_xcvr_mode = "e200g_xcvr_speed_map_25e2x15_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_duplex_mode = "e200g_xcvr_speed_map_25e2x1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_rx_protocol = "e200g_xcvr_speed_map_25e2x1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_speed_bucket = "e200g_xcvr_speed_map_25e2x1_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_sys_clk_src = "e200g_xcvr_speed_map_25e2x1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_tx_protocol = "e200g_xcvr_speed_map_25e2x1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x1_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_xcvr_mode = "e200g_xcvr_speed_map_25e2x1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_duplex_mode = "e200g_xcvr_speed_map_25e2x2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_rx_protocol = "e200g_xcvr_speed_map_25e2x2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_speed_bucket = "e200g_xcvr_speed_map_25e2x2_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_sys_clk_src = "e200g_xcvr_speed_map_25e2x2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_tx_protocol = "e200g_xcvr_speed_map_25e2x2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x2_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_xcvr_mode = "e200g_xcvr_speed_map_25e2x2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_duplex_mode = "e200g_xcvr_speed_map_25e2x3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_rx_protocol = "e200g_xcvr_speed_map_25e2x3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_speed_bucket = "e200g_xcvr_speed_map_25e2x3_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_sys_clk_src = "e200g_xcvr_speed_map_25e2x3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_tx_protocol = "e200g_xcvr_speed_map_25e2x3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x3_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_xcvr_mode = "e200g_xcvr_speed_map_25e2x3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_duplex_mode = "e200g_xcvr_speed_map_25e2x4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_rx_protocol = "e200g_xcvr_speed_map_25e2x4_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_speed_bucket = "e200g_xcvr_speed_map_25e2x4_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_sys_clk_src = "e200g_xcvr_speed_map_25e2x4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_tx_protocol = "e200g_xcvr_speed_map_25e2x4_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x4_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x4_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_xcvr_mode = "e200g_xcvr_speed_map_25e2x4_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_duplex_mode = "e200g_xcvr_speed_map_25e2x5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_rx_protocol = "e200g_xcvr_speed_map_25e2x5_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_speed_bucket = "e200g_xcvr_speed_map_25e2x5_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_sys_clk_src = "e200g_xcvr_speed_map_25e2x5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_tx_protocol = "e200g_xcvr_speed_map_25e2x5_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x5_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x5_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_xcvr_mode = "e200g_xcvr_speed_map_25e2x5_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_duplex_mode = "e200g_xcvr_speed_map_25e2x6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_rx_protocol = "e200g_xcvr_speed_map_25e2x6_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_speed_bucket = "e200g_xcvr_speed_map_25e2x6_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_sys_clk_src = "e200g_xcvr_speed_map_25e2x6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_tx_protocol = "e200g_xcvr_speed_map_25e2x6_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x6_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x6_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_xcvr_mode = "e200g_xcvr_speed_map_25e2x6_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_duplex_mode = "e200g_xcvr_speed_map_25e2x7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_rx_protocol = "e200g_xcvr_speed_map_25e2x7_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_speed_bucket = "e200g_xcvr_speed_map_25e2x7_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_sys_clk_src = "e200g_xcvr_speed_map_25e2x7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_tx_protocol = "e200g_xcvr_speed_map_25e2x7_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x7_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x7_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_xcvr_mode = "e200g_xcvr_speed_map_25e2x7_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_duplex_mode = "e200g_xcvr_speed_map_25e2x8_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x8_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_rx_protocol = "e200g_xcvr_speed_map_25e2x8_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x8_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_speed_bucket = "e200g_xcvr_speed_map_25e2x8_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_sys_clk_src = "e200g_xcvr_speed_map_25e2x8_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x8_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_tx_protocol = "e200g_xcvr_speed_map_25e2x8_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x8_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x8_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x8_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x8_xcvr_mode = "e200g_xcvr_speed_map_25e2x8_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_duplex_mode = "e200g_xcvr_speed_map_25e2x9_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_rx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x9_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_rx_protocol = "e200g_xcvr_speed_map_25e2x9_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_rx_xcvr_width = "e200g_xcvr_speed_map_25e2x9_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_speed_bucket = "e200g_xcvr_speed_map_25e2x9_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_sys_clk_src = "e200g_xcvr_speed_map_25e2x9_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_tx_master_bond_chnl = "e200g_xcvr_speed_map_25e2x9_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_tx_protocol = "e200g_xcvr_speed_map_25e2x9_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_tx_xcvr_width = "e200g_xcvr_speed_map_25e2x9_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_txrx_channel_operation = "e200g_xcvr_speed_map_25e2x9_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_txrx_line_encoding_type = "e200g_xcvr_speed_map_25e2x9_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x9_xcvr_mode = "e200g_xcvr_speed_map_25e2x9_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_duplex_mode = "e200g_xcvr_speed_map_56e2x0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_rx_protocol = "e200g_xcvr_speed_map_56e2x0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_speed_bucket = "e200g_xcvr_speed_map_56e2x0_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_sys_clk_src = "e200g_xcvr_speed_map_56e2x0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_tx_protocol = "e200g_xcvr_speed_map_56e2x0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x0_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_xcvr_mode = "e200g_xcvr_speed_map_56e2x0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_duplex_mode = "e200g_xcvr_speed_map_56e2x1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_rx_protocol = "e200g_xcvr_speed_map_56e2x1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_speed_bucket = "e200g_xcvr_speed_map_56e2x1_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_sys_clk_src = "e200g_xcvr_speed_map_56e2x1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_tx_protocol = "e200g_xcvr_speed_map_56e2x1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x1_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_xcvr_mode = "e200g_xcvr_speed_map_56e2x1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_duplex_mode = "e200g_xcvr_speed_map_56e2x2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_rx_protocol = "e200g_xcvr_speed_map_56e2x2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_speed_bucket = "e200g_xcvr_speed_map_56e2x2_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_sys_clk_src = "e200g_xcvr_speed_map_56e2x2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_tx_protocol = "e200g_xcvr_speed_map_56e2x2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x2_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_xcvr_mode = "e200g_xcvr_speed_map_56e2x2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_duplex_mode = "e200g_xcvr_speed_map_56e2x3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_rx_protocol = "e200g_xcvr_speed_map_56e2x3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_speed_bucket = "e200g_xcvr_speed_map_56e2x3_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_sys_clk_src = "e200g_xcvr_speed_map_56e2x3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_tx_protocol = "e200g_xcvr_speed_map_56e2x3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x3_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_xcvr_mode = "e200g_xcvr_speed_map_56e2x3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_duplex_mode = "e200g_xcvr_speed_map_56e2x4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_rx_protocol = "e200g_xcvr_speed_map_56e2x4_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_speed_bucket = "e200g_xcvr_speed_map_56e2x4_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_sys_clk_src = "e200g_xcvr_speed_map_56e2x4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_tx_protocol = "e200g_xcvr_speed_map_56e2x4_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x4_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x4_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x4_xcvr_mode = "e200g_xcvr_speed_map_56e2x4_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_duplex_mode = "e200g_xcvr_speed_map_56e2x5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_rx_protocol = "e200g_xcvr_speed_map_56e2x5_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_speed_bucket = "e200g_xcvr_speed_map_56e2x5_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_sys_clk_src = "e200g_xcvr_speed_map_56e2x5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_tx_protocol = "e200g_xcvr_speed_map_56e2x5_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x5_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x5_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x5_xcvr_mode = "e200g_xcvr_speed_map_56e2x5_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_duplex_mode = "e200g_xcvr_speed_map_56e2x6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_rx_protocol = "e200g_xcvr_speed_map_56e2x6_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_speed_bucket = "e200g_xcvr_speed_map_56e2x6_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_sys_clk_src = "e200g_xcvr_speed_map_56e2x6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_tx_protocol = "e200g_xcvr_speed_map_56e2x6_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x6_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x6_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x6_xcvr_mode = "e200g_xcvr_speed_map_56e2x6_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_duplex_mode = "e200g_xcvr_speed_map_56e2x7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_rx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_rx_protocol = "e200g_xcvr_speed_map_56e2x7_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_rx_xcvr_width = "e200g_xcvr_speed_map_56e2x7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_speed_bucket = "e200g_xcvr_speed_map_56e2x7_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_sys_clk_src = "e200g_xcvr_speed_map_56e2x7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_tx_master_bond_chnl = "e200g_xcvr_speed_map_56e2x7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_tx_protocol = "e200g_xcvr_speed_map_56e2x7_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_tx_xcvr_width = "e200g_xcvr_speed_map_56e2x7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_txrx_channel_operation = "e200g_xcvr_speed_map_56e2x7_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_txrx_line_encoding_type = "e200g_xcvr_speed_map_56e2x7_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x7_xcvr_mode = "e200g_xcvr_speed_map_56e2x7_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux0 = "map_ux0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux1 = "map_ux1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux2 = "map_ux2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux3 = "map_ux3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux4 = "map_ux4_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux5 = "map_ux5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux6 = "map_ux6_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__map_ux7 = "map_ux7_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__topo_supports_barak = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__topo_supports_pcie = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__topo_supports_ptp = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__topology = "ux16e400gptp_xx_disabled_xx_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 7;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 56;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st4_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st4_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st5_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st5_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st6_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st6_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st7_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st7_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st4_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st4_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st5_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st5_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st6_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st6_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st7_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st7_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_aib2_rx_st_clk_en = "e400g_100g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_aib2_tx_st_clk_en = "e400g_100g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_aib3_rx_st_clk_en = "e400g_100g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_aib3_tx_st_clk_en = "e400g_100g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_aibif_data_valid = "e400g_100g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_duplex_mode = "e400g_100g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_fec_clk_src = "e400g_100g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_fec_error = "e400g_100g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_fec_mode = "e400g_100g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_fec_spec = "e400g_100g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_lpbk_mode = "e400g_100g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_flow_control = "e400g_100g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_flow_control_holdoff_mode = "e400g_100g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_link_fault_mode = "e400g_100g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_mode = "e400g_100g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_ptp_phy_lane_num = "e400g_100g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_ipg_size = "e400g_100g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_ptp_phy_lane_num = "e400g_100g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_pcs_ber_mon_mode = "e400g_100g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_ptp_mode = "e400g_100g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_aib_if_fifo_mode = "e400g_100g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_excvr_gb_ratio_mode = "e400g_100g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_excvr_if_fifo_mode = "e400g_100g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_fec_enable = "e400g_100g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_master_bond_chnl = "e400g_100g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_pcs_mode = "e400g_100g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_primary_use = "e400g_100g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_rx_xcvr_width = "e400g_100g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_speed_map = "e400g_100g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_sup_mode = "e400g_100g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_sys_clk_src = "e400g_100g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_aib_if_fifo_mode = "e400g_100g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_excvr_gb_ratio_mode = "e400g_100g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_excvr_if_fifo_mode = "e400g_100g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_fec_enable = "e400g_100g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_master_bond_chnl = "e400g_100g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_pcs_mode = "e400g_100g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_primary_use = "e400g_100g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_tx_xcvr_width = "e400g_100g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_xcvr_mode = "e400g_100g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_xcvr_type = "e400g_100g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_aib2_rx_st_clk_en = "e400g_100g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_aib2_tx_st_clk_en = "e400g_100g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_aib3_rx_st_clk_en = "e400g_100g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_aib3_tx_st_clk_en = "e400g_100g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_aibif_data_valid = "e400g_100g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_duplex_mode = "e400g_100g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_fec_clk_src = "e400g_100g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_fec_error = "e400g_100g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_fec_mode = "e400g_100g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_fec_spec = "e400g_100g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_lpbk_mode = "e400g_100g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_flow_control = "e400g_100g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_flow_control_holdoff_mode = "e400g_100g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_link_fault_mode = "e400g_100g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_mode = "e400g_100g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_ptp_phy_lane_num = "e400g_100g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_ipg_size = "e400g_100g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_ptp_phy_lane_num = "e400g_100g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_pcs_ber_mon_mode = "e400g_100g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_ptp_mode = "e400g_100g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_aib_if_fifo_mode = "e400g_100g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_excvr_gb_ratio_mode = "e400g_100g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_excvr_if_fifo_mode = "e400g_100g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_fec_enable = "e400g_100g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_master_bond_chnl = "e400g_100g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_pcs_mode = "e400g_100g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_primary_use = "e400g_100g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_rx_xcvr_width = "e400g_100g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_speed_map = "e400g_100g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_sup_mode = "e400g_100g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_sys_clk_src = "e400g_100g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_aib_if_fifo_mode = "e400g_100g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_excvr_gb_ratio_mode = "e400g_100g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_excvr_if_fifo_mode = "e400g_100g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_fec_enable = "e400g_100g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_master_bond_chnl = "e400g_100g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_pcs_mode = "e400g_100g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_primary_use = "e400g_100g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_tx_xcvr_width = "e400g_100g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_xcvr_mode = "e400g_100g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_xcvr_type = "e400g_100g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_aib2_rx_st_clk_en = "e400g_100g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_aib2_tx_st_clk_en = "e400g_100g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_aib3_rx_st_clk_en = "e400g_100g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_aib3_tx_st_clk_en = "e400g_100g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_aibif_data_valid = "e400g_100g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_duplex_mode = "e400g_100g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_fec_clk_src = "e400g_100g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_fec_error = "e400g_100g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_fec_mode = "e400g_100g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_fec_spec = "e400g_100g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_lpbk_mode = "e400g_100g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_flow_control = "e400g_100g_2_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_flow_control_holdoff_mode = "e400g_100g_2_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_link_fault_mode = "e400g_100g_2_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_mode = "e400g_100g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_ptp_phy_lane_num = "e400g_100g_2_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_ipg_size = "e400g_100g_2_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_ptp_phy_lane_num = "e400g_100g_2_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_pcs_ber_mon_mode = "e400g_100g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_ptp_mode = "e400g_100g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_aib_if_fifo_mode = "e400g_100g_2_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_excvr_gb_ratio_mode = "e400g_100g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_excvr_if_fifo_mode = "e400g_100g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_fec_enable = "e400g_100g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_master_bond_chnl = "e400g_100g_2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_pcs_mode = "e400g_100g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_primary_use = "e400g_100g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_rx_xcvr_width = "e400g_100g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_speed_map = "e400g_100g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_sup_mode = "e400g_100g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_sys_clk_src = "e400g_100g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_aib_if_fifo_mode = "e400g_100g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_excvr_gb_ratio_mode = "e400g_100g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_excvr_if_fifo_mode = "e400g_100g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_fec_enable = "e400g_100g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_master_bond_chnl = "e400g_100g_2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_pcs_mode = "e400g_100g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_primary_use = "e400g_100g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_tx_xcvr_width = "e400g_100g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_xcvr_mode = "e400g_100g_2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_xcvr_type = "e400g_100g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_aib2_rx_st_clk_en = "e400g_100g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_aib2_tx_st_clk_en = "e400g_100g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_aib3_rx_st_clk_en = "e400g_100g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_aib3_tx_st_clk_en = "e400g_100g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_aibif_data_valid = "e400g_100g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_duplex_mode = "e400g_100g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_fec_clk_src = "e400g_100g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_fec_error = "e400g_100g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_fec_mode = "e400g_100g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_fec_spec = "e400g_100g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_lpbk_mode = "e400g_100g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_flow_control = "e400g_100g_3_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_flow_control_holdoff_mode = "e400g_100g_3_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_link_fault_mode = "e400g_100g_3_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_mode = "e400g_100g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_ptp_phy_lane_num = "e400g_100g_3_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_ipg_size = "e400g_100g_3_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_ptp_phy_lane_num = "e400g_100g_3_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_pcs_ber_mon_mode = "e400g_100g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_ptp_mode = "e400g_100g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_aib_if_fifo_mode = "e400g_100g_3_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_excvr_gb_ratio_mode = "e400g_100g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_excvr_if_fifo_mode = "e400g_100g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_fec_enable = "e400g_100g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_master_bond_chnl = "e400g_100g_3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_pcs_mode = "e400g_100g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_primary_use = "e400g_100g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_rx_xcvr_width = "e400g_100g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_speed_map = "e400g_100g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_sup_mode = "e400g_100g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_sys_clk_src = "e400g_100g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_aib_if_fifo_mode = "e400g_100g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_excvr_gb_ratio_mode = "e400g_100g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_excvr_if_fifo_mode = "e400g_100g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_fec_enable = "e400g_100g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_master_bond_chnl = "e400g_100g_3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_pcs_mode = "e400g_100g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_primary_use = "e400g_100g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_tx_xcvr_width = "e400g_100g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_xcvr_mode = "e400g_100g_3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_xcvr_type = "e400g_100g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_aib2_rx_st_clk_en = "e400g_150g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_aib2_tx_st_clk_en = "e400g_150g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_aib3_rx_st_clk_en = "e400g_150g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_aib3_tx_st_clk_en = "e400g_150g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_aibif_data_valid = "e400g_150g_0_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_duplex_mode = "e400g_150g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_fec_mode = "e400g_150g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_fec_spec = "e400g_150g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_lpbk_mode = "e400g_150g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_mac_mode = "e400g_150g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_pcs_ber_mon_mode = "e400g_150g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_ptp_mode = "e400g_150g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_aib_if_fifo_mode = "e400g_150g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_excvr_gb_ratio_mode = "e400g_150g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_excvr_if_fifo_mode = "e400g_150g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_fec_enable = "e400g_150g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_master_bond_chnl = "e400g_150g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_pcs_mode = "e400g_150g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_primary_use = "e400g_150g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_rx_xcvr_width = "e400g_150g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_speed_map = "e400g_150g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_sup_mode = "e400g_150g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_sys_clk_src = "e400g_150g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_aib_if_fifo_mode = "e400g_150g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_excvr_gb_ratio_mode = "e400g_150g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_excvr_if_fifo_mode = "e400g_150g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_fec_enable = "e400g_150g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_master_bond_chnl = "e400g_150g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_pcs_mode = "e400g_150g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_primary_use = "e400g_150g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_tx_xcvr_width = "e400g_150g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_xcvr_mode = "e400g_150g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_xcvr_type = "e400g_150g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_aib2_rx_st_clk_en = "e400g_150g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_aib2_tx_st_clk_en = "e400g_150g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_aib3_rx_st_clk_en = "e400g_150g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_aib3_tx_st_clk_en = "e400g_150g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_aibif_data_valid = "e400g_150g_1_aibif_data_valid_40g_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_duplex_mode = "e400g_150g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_fec_mode = "e400g_150g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_fec_spec = "e400g_150g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_lpbk_mode = "e400g_150g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_mac_mode = "e400g_150g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_pcs_ber_mon_mode = "e400g_150g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_ptp_mode = "e400g_150g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_aib_if_fifo_mode = "e400g_150g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_excvr_gb_ratio_mode = "e400g_150g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_excvr_if_fifo_mode = "e400g_150g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_fec_enable = "e400g_150g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_master_bond_chnl = "e400g_150g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_pcs_mode = "e400g_150g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_primary_use = "e400g_150g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_rx_xcvr_width = "e400g_150g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_speed_map = "e400g_150g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_sup_mode = "e400g_150g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_sys_clk_src = "e400g_150g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_aib_if_fifo_mode = "e400g_150g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_excvr_gb_ratio_mode = "e400g_150g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_excvr_if_fifo_mode = "e400g_150g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_fec_enable = "e400g_150g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_master_bond_chnl = "e400g_150g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_pcs_mode = "e400g_150g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_primary_use = "e400g_150g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_tx_xcvr_width = "e400g_150g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_xcvr_mode = "e400g_150g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_xcvr_type = "e400g_150g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_aib2_rx_st_clk_en = "e400g_150g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_aib2_tx_st_clk_en = "e400g_150g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_aib3_rx_st_clk_en = "e400g_150g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_aib3_tx_st_clk_en = "e400g_150g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_aibif_data_valid = "e400g_150g_2_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_duplex_mode = "e400g_150g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_fec_mode = "e400g_150g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_fec_spec = "e400g_150g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_lpbk_mode = "e400g_150g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_mac_mode = "e400g_150g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_pcs_ber_mon_mode = "e400g_150g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_ptp_mode = "e400g_150g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_aib_if_fifo_mode = "e400g_150g_2_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_excvr_gb_ratio_mode = "e400g_150g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_excvr_if_fifo_mode = "e400g_150g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_fec_enable = "e400g_150g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_master_bond_chnl = "e400g_150g_2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_pcs_mode = "e400g_150g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_primary_use = "e400g_150g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_rx_xcvr_width = "e400g_150g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_speed_map = "e400g_150g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_sup_mode = "e400g_150g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_sys_clk_src = "e400g_150g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_aib_if_fifo_mode = "e400g_150g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_excvr_gb_ratio_mode = "e400g_150g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_excvr_if_fifo_mode = "e400g_150g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_fec_enable = "e400g_150g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_master_bond_chnl = "e400g_150g_2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_pcs_mode = "e400g_150g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_primary_use = "e400g_150g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_tx_xcvr_width = "e400g_150g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_xcvr_mode = "e400g_150g_2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_xcvr_type = "e400g_150g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_aib2_rx_st_clk_en = "e400g_150g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_aib2_tx_st_clk_en = "e400g_150g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_aib3_rx_st_clk_en = "e400g_150g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_aib3_tx_st_clk_en = "e400g_150g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_aibif_data_valid = "e400g_150g_3_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_duplex_mode = "e400g_150g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_fec_mode = "e400g_150g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_fec_spec = "e400g_150g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_lpbk_mode = "e400g_150g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_mac_mode = "e400g_150g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_pcs_ber_mon_mode = "e400g_150g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_ptp_mode = "e400g_150g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_aib_if_fifo_mode = "e400g_150g_3_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_excvr_gb_ratio_mode = "e400g_150g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_excvr_if_fifo_mode = "e400g_150g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_fec_enable = "e400g_150g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_master_bond_chnl = "e400g_150g_3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_pcs_mode = "e400g_150g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_primary_use = "e400g_150g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_rx_xcvr_width = "e400g_150g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_speed_map = "e400g_150g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_sup_mode = "e400g_150g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_sys_clk_src = "e400g_150g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_aib_if_fifo_mode = "e400g_150g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_excvr_gb_ratio_mode = "e400g_150g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_excvr_if_fifo_mode = "e400g_150g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_fec_enable = "e400g_150g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_master_bond_chnl = "e400g_150g_3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_pcs_mode = "e400g_150g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_primary_use = "e400g_150g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_tx_xcvr_width = "e400g_150g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_xcvr_mode = "e400g_150g_3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_xcvr_type = "e400g_150g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_aib2_rx_st_clk_en = "e400g_200g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_aib2_tx_st_clk_en = "e400g_200g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_aib3_rx_st_clk_en = "e400g_200g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_aib3_tx_st_clk_en = "e400g_200g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_aibif_data_valid = "e400g_200g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_duplex_mode = "e400g_200g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_fec_clk_src = "e400g_200g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_fec_error = "e400g_200g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_fec_mode = "e400g_200g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_fec_spec = "e400g_200g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_lpbk_mode = "e400g_200g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_flow_control = "e400g_200g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_flow_control_holdoff_mode = "e400g_200g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_link_fault_mode = "e400g_200g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_mode = "e400g_200g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_ptp_phy_lane_num = "e400g_200g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_ipg_size = "e400g_200g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_ptp_phy_lane_num = "e400g_200g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_pcs_ber_mon_mode = "e400g_200g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_ptp_mode = "e400g_200g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_aib_if_fifo_mode = "e400g_200g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_excvr_gb_ratio_mode = "e400g_200g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_excvr_if_fifo_mode = "e400g_200g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_fec_enable = "e400g_200g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_master_bond_chnl = "e400g_200g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_pcs_mode = "e400g_200g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_primary_use = "e400g_200g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_rx_xcvr_width = "e400g_200g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_speed_map = "e400g_200g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_sup_mode = "e400g_200g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_sys_clk_src = "e400g_200g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_aib_if_fifo_mode = "e400g_200g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_excvr_gb_ratio_mode = "e400g_200g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_excvr_if_fifo_mode = "e400g_200g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_fec_enable = "e400g_200g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_master_bond_chnl = "e400g_200g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_pcs_mode = "e400g_200g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_primary_use = "e400g_200g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_tx_xcvr_width = "e400g_200g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_xcvr_mode = "e400g_200g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_xcvr_type = "e400g_200g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_aib2_rx_st_clk_en = "e400g_200g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_aib2_tx_st_clk_en = "e400g_200g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_aib3_rx_st_clk_en = "e400g_200g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_aib3_tx_st_clk_en = "e400g_200g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_aibif_data_valid = "e400g_200g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_duplex_mode = "e400g_200g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_fec_clk_src = "e400g_200g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_fec_error = "e400g_200g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_fec_mode = "e400g_200g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_fec_spec = "e400g_200g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_lpbk_mode = "e400g_200g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_flow_control = "e400g_200g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_flow_control_holdoff_mode = "e400g_200g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_link_fault_mode = "e400g_200g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_mode = "e400g_200g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_ptp_phy_lane_num = "e400g_200g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_ipg_size = "e400g_200g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_ptp_phy_lane_num = "e400g_200g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_pcs_ber_mon_mode = "e400g_200g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_ptp_mode = "e400g_200g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_aib_if_fifo_mode = "e400g_200g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_excvr_gb_ratio_mode = "e400g_200g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_excvr_if_fifo_mode = "e400g_200g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_fec_enable = "e400g_200g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_master_bond_chnl = "e400g_200g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_pcs_mode = "e400g_200g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_primary_use = "e400g_200g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_rx_xcvr_width = "e400g_200g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_speed_map = "e400g_200g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_sup_mode = "e400g_200g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_sys_clk_src = "e400g_200g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_aib_if_fifo_mode = "e400g_200g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_excvr_gb_ratio_mode = "e400g_200g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_excvr_if_fifo_mode = "e400g_200g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_fec_enable = "e400g_200g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_master_bond_chnl = "e400g_200g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_pcs_mode = "e400g_200g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_primary_use = "e400g_200g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_tx_xcvr_width = "e400g_200g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_xcvr_mode = "e400g_200g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_xcvr_type = "e400g_200g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_aib2_rx_st_clk_en = "e400g_25g_0_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_aib2_tx_st_clk_en = "e400g_25g_0_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_aib3_rx_st_clk_en = "e400g_25g_0_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_aib3_tx_st_clk_en = "e400g_25g_0_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_aibif_data_valid = "e400g_25g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_duplex_mode = "e400g_25g_0_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_fec_clk_src = "e400g_25g_0_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_fec_error = "e400g_25g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_fec_mode = "e400g_25g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_fec_spec = "e400g_25g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_lpbk_mode = "e400g_25g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_flow_control = "e400g_25g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_flow_control_holdoff_mode = "e400g_25g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_link_fault_mode = "e400g_25g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_mode = "e400g_25g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_ptp_phy_lane_num = "e400g_25g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_ipg_size = "e400g_25g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_ptp_phy_lane_num = "e400g_25g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_pcs_ber_mon_mode = "e400g_25g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_ptp_mode = "e400g_25g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_aib_if_fifo_mode = "e400g_25g_0_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_excvr_gb_ratio_mode = "e400g_25g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_excvr_if_fifo_mode = "e400g_25g_0_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_fec_enable = "e400g_25g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_master_bond_chnl = "e400g_25g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_pcs_mode = "e400g_25g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_primary_use = "e400g_25g_0_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_rx_xcvr_width = "e400g_25g_0_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_speed_map = "e400g_25g_0_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_sup_mode = "e400g_25g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_sys_clk_src = "e400g_25g_0_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_aib_if_fifo_mode = "e400g_25g_0_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_excvr_gb_ratio_mode = "e400g_25g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_excvr_if_fifo_mode = "e400g_25g_0_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_fec_enable = "e400g_25g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_master_bond_chnl = "e400g_25g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_pcs_mode = "e400g_25g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_primary_use = "e400g_25g_0_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_tx_xcvr_width = "e400g_25g_0_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_xcvr_mode = "e400g_25g_0_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_xcvr_type = "e400g_25g_0_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_aib2_rx_st_clk_en = "e400g_25g_10_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_aib2_tx_st_clk_en = "e400g_25g_10_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_aib3_rx_st_clk_en = "e400g_25g_10_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_aib3_tx_st_clk_en = "e400g_25g_10_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_aibif_data_valid = "e400g_25g_10_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_duplex_mode = "e400g_25g_10_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_fec_clk_src = "e400g_25g_10_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_fec_error = "e400g_25g_10_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_fec_mode = "e400g_25g_10_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_fec_spec = "e400g_25g_10_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_lpbk_mode = "e400g_25g_10_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_flow_control = "e400g_25g_10_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_flow_control_holdoff_mode = "e400g_25g_10_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_link_fault_mode = "e400g_25g_10_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_mode = "e400g_25g_10_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_ptp_phy_lane_num = "e400g_25g_10_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_ipg_size = "e400g_25g_10_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_ptp_phy_lane_num = "e400g_25g_10_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_pcs_ber_mon_mode = "e400g_25g_10_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_pcs_pcs_ber_mon_mode = "e400g_25g_10_pcs_pcs_ber_mon_mode_10g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_ptp_mode = "e400g_25g_10_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_aib_if_fifo_mode = "e400g_25g_10_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_excvr_gb_ratio_mode = "e400g_25g_10_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_excvr_if_fifo_mode = "e400g_25g_10_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_fec_enable = "e400g_25g_10_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_master_bond_chnl = "e400g_25g_10_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_pcs_mode = "e400g_25g_10_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_primary_use = "e400g_25g_10_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_rx_xcvr_width = "e400g_25g_10_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_speed_map = "e400g_25g_10_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_sup_mode = "e400g_25g_10_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_sys_clk_src = "e400g_25g_10_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_aib_if_fifo_mode = "e400g_25g_10_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_excvr_gb_ratio_mode = "e400g_25g_10_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_excvr_if_fifo_mode = "e400g_25g_10_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_fec_enable = "e400g_25g_10_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_master_bond_chnl = "e400g_25g_10_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_pcs_mode = "e400g_25g_10_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_primary_use = "e400g_25g_10_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_tx_xcvr_width = "e400g_25g_10_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_xcvr_mode = "e400g_25g_10_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_xcvr_type = "e400g_25g_10_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_aib2_rx_st_clk_en = "e400g_25g_11_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_aib2_tx_st_clk_en = "e400g_25g_11_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_aib3_rx_st_clk_en = "e400g_25g_11_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_aib3_tx_st_clk_en = "e400g_25g_11_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_aibif_data_valid = "e400g_25g_11_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_duplex_mode = "e400g_25g_11_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_fec_clk_src = "e400g_25g_11_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_fec_error = "e400g_25g_11_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_fec_mode = "e400g_25g_11_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_fec_spec = "e400g_25g_11_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_lpbk_mode = "e400g_25g_11_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_flow_control = "e400g_25g_11_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_flow_control_holdoff_mode = "e400g_25g_11_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_link_fault_mode = "e400g_25g_11_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_mode = "e400g_25g_11_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_ptp_phy_lane_num = "e400g_25g_11_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_ipg_size = "e400g_25g_11_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_ptp_phy_lane_num = "e400g_25g_11_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_pcs_ber_mon_mode = "e400g_25g_11_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_ptp_mode = "e400g_25g_11_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_aib_if_fifo_mode = "e400g_25g_11_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_excvr_gb_ratio_mode = "e400g_25g_11_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_excvr_if_fifo_mode = "e400g_25g_11_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_fec_enable = "e400g_25g_11_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_master_bond_chnl = "e400g_25g_11_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_pcs_mode = "e400g_25g_11_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_primary_use = "e400g_25g_11_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_rx_xcvr_width = "e400g_25g_11_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_speed_map = "e400g_25g_11_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_sup_mode = "e400g_25g_11_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_sys_clk_src = "e400g_25g_11_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_aib_if_fifo_mode = "e400g_25g_11_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_excvr_gb_ratio_mode = "e400g_25g_11_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_excvr_if_fifo_mode = "e400g_25g_11_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_fec_enable = "e400g_25g_11_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_master_bond_chnl = "e400g_25g_11_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_pcs_mode = "e400g_25g_11_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_primary_use = "e400g_25g_11_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_tx_xcvr_width = "e400g_25g_11_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_xcvr_mode = "e400g_25g_11_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_xcvr_type = "e400g_25g_11_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_aib2_rx_st_clk_en = "e400g_25g_12_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_aib2_tx_st_clk_en = "e400g_25g_12_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_aib3_rx_st_clk_en = "e400g_25g_12_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_aib3_tx_st_clk_en = "e400g_25g_12_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_aibif_data_valid = "e400g_25g_12_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_duplex_mode = "e400g_25g_12_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_fec_clk_src = "e400g_25g_12_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_fec_error = "e400g_25g_12_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_fec_mode = "e400g_25g_12_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_fec_spec = "e400g_25g_12_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_lpbk_mode = "e400g_25g_12_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_flow_control = "e400g_25g_12_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_flow_control_holdoff_mode = "e400g_25g_12_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_link_fault_mode = "e400g_25g_12_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_mode = "e400g_25g_12_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_ptp_phy_lane_num = "e400g_25g_12_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_ipg_size = "e400g_25g_12_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_ptp_phy_lane_num = "e400g_25g_12_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_pcs_ber_mon_mode = "e400g_25g_12_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_ptp_mode = "e400g_25g_12_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_aib_if_fifo_mode = "e400g_25g_12_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_excvr_gb_ratio_mode = "e400g_25g_12_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_excvr_if_fifo_mode = "e400g_25g_12_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_fec_enable = "e400g_25g_12_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_master_bond_chnl = "e400g_25g_12_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_pcs_mode = "e400g_25g_12_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_primary_use = "e400g_25g_12_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_rx_xcvr_width = "e400g_25g_12_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_speed_map = "e400g_25g_12_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_sup_mode = "e400g_25g_12_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_sys_clk_src = "e400g_25g_12_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_aib_if_fifo_mode = "e400g_25g_12_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_excvr_gb_ratio_mode = "e400g_25g_12_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_excvr_if_fifo_mode = "e400g_25g_12_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_fec_enable = "e400g_25g_12_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_master_bond_chnl = "e400g_25g_12_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_pcs_mode = "e400g_25g_12_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_primary_use = "e400g_25g_12_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_tx_xcvr_width = "e400g_25g_12_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_xcvr_mode = "e400g_25g_12_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_xcvr_type = "e400g_25g_12_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_aib2_rx_st_clk_en = "e400g_25g_13_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_aib2_tx_st_clk_en = "e400g_25g_13_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_aib3_rx_st_clk_en = "e400g_25g_13_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_aib3_tx_st_clk_en = "e400g_25g_13_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_aibif_data_valid = "e400g_25g_13_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_duplex_mode = "e400g_25g_13_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_fec_clk_src = "e400g_25g_13_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_fec_error = "e400g_25g_13_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_fec_mode = "e400g_25g_13_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_fec_spec = "e400g_25g_13_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_lpbk_mode = "e400g_25g_13_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_flow_control = "e400g_25g_13_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_flow_control_holdoff_mode = "e400g_25g_13_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_link_fault_mode = "e400g_25g_13_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_mode = "e400g_25g_13_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_ptp_phy_lane_num = "e400g_25g_13_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_ipg_size = "e400g_25g_13_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_ptp_phy_lane_num = "e400g_25g_13_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_pcs_ber_mon_mode = "e400g_25g_13_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_ptp_mode = "e400g_25g_13_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_aib_if_fifo_mode = "e400g_25g_13_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_excvr_gb_ratio_mode = "e400g_25g_13_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_excvr_if_fifo_mode = "e400g_25g_13_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_fec_enable = "e400g_25g_13_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_master_bond_chnl = "e400g_25g_13_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_pcs_mode = "e400g_25g_13_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_primary_use = "e400g_25g_13_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_rx_xcvr_width = "e400g_25g_13_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_speed_map = "e400g_25g_13_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_sup_mode = "e400g_25g_13_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_sys_clk_src = "e400g_25g_13_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_aib_if_fifo_mode = "e400g_25g_13_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_excvr_gb_ratio_mode = "e400g_25g_13_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_excvr_if_fifo_mode = "e400g_25g_13_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_fec_enable = "e400g_25g_13_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_master_bond_chnl = "e400g_25g_13_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_pcs_mode = "e400g_25g_13_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_primary_use = "e400g_25g_13_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_tx_xcvr_width = "e400g_25g_13_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_xcvr_mode = "e400g_25g_13_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_xcvr_type = "e400g_25g_13_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_aib2_rx_st_clk_en = "e400g_25g_14_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_aib2_tx_st_clk_en = "e400g_25g_14_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_aib3_rx_st_clk_en = "e400g_25g_14_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_aib3_tx_st_clk_en = "e400g_25g_14_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_aibif_data_valid = "e400g_25g_14_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_duplex_mode = "e400g_25g_14_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_fec_clk_src = "e400g_25g_14_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_fec_error = "e400g_25g_14_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_fec_mode = "e400g_25g_14_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_fec_spec = "e400g_25g_14_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_lpbk_mode = "e400g_25g_14_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_flow_control = "e400g_25g_14_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_flow_control_holdoff_mode = "e400g_25g_14_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_link_fault_mode = "e400g_25g_14_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_mode = "e400g_25g_14_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_ptp_phy_lane_num = "e400g_25g_14_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_ipg_size = "e400g_25g_14_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_ptp_phy_lane_num = "e400g_25g_14_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_pcs_ber_mon_mode = "e400g_25g_14_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_ptp_mode = "e400g_25g_14_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_aib_if_fifo_mode = "e400g_25g_14_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_excvr_gb_ratio_mode = "e400g_25g_14_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_excvr_if_fifo_mode = "e400g_25g_14_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_fec_enable = "e400g_25g_14_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_master_bond_chnl = "e400g_25g_14_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_pcs_mode = "e400g_25g_14_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_primary_use = "e400g_25g_14_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_rx_xcvr_width = "e400g_25g_14_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_speed_map = "e400g_25g_14_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_sup_mode = "e400g_25g_14_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_sys_clk_src = "e400g_25g_14_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_aib_if_fifo_mode = "e400g_25g_14_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_excvr_gb_ratio_mode = "e400g_25g_14_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_excvr_if_fifo_mode = "e400g_25g_14_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_fec_enable = "e400g_25g_14_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_master_bond_chnl = "e400g_25g_14_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_pcs_mode = "e400g_25g_14_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_primary_use = "e400g_25g_14_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_tx_xcvr_width = "e400g_25g_14_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_xcvr_mode = "e400g_25g_14_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_xcvr_type = "e400g_25g_14_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_aib2_rx_st_clk_en = "e400g_25g_15_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_aib2_tx_st_clk_en = "e400g_25g_15_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_aib3_rx_st_clk_en = "e400g_25g_15_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_aib3_tx_st_clk_en = "e400g_25g_15_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_aibif_data_valid = "e400g_25g_15_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_duplex_mode = "e400g_25g_15_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_fec_clk_src = "e400g_25g_15_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_fec_error = "e400g_25g_15_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_fec_mode = "e400g_25g_15_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_fec_spec = "e400g_25g_15_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_lpbk_mode = "e400g_25g_15_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_flow_control = "e400g_25g_15_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_flow_control_holdoff_mode = "e400g_25g_15_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_link_fault_mode = "e400g_25g_15_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_mode = "e400g_25g_15_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_ptp_phy_lane_num = "e400g_25g_15_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_ipg_size = "e400g_25g_15_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_ptp_phy_lane_num = "e400g_25g_15_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_pcs_ber_mon_mode = "e400g_25g_15_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_ptp_mode = "e400g_25g_15_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_aib_if_fifo_mode = "e400g_25g_15_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_excvr_gb_ratio_mode = "e400g_25g_15_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_excvr_if_fifo_mode = "e400g_25g_15_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_fec_enable = "e400g_25g_15_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_master_bond_chnl = "e400g_25g_15_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_pcs_mode = "e400g_25g_15_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_primary_use = "e400g_25g_15_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_rx_xcvr_width = "e400g_25g_15_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_speed_map = "e400g_25g_15_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_sup_mode = "e400g_25g_15_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_sys_clk_src = "e400g_25g_15_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_aib_if_fifo_mode = "e400g_25g_15_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_excvr_gb_ratio_mode = "e400g_25g_15_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_excvr_if_fifo_mode = "e400g_25g_15_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_fec_enable = "e400g_25g_15_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_master_bond_chnl = "e400g_25g_15_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_pcs_mode = "e400g_25g_15_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_primary_use = "e400g_25g_15_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_tx_xcvr_width = "e400g_25g_15_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_xcvr_mode = "e400g_25g_15_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_xcvr_type = "e400g_25g_15_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_aib2_rx_st_clk_en = "e400g_25g_1_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_aib2_tx_st_clk_en = "e400g_25g_1_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_aib3_rx_st_clk_en = "e400g_25g_1_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_aib3_tx_st_clk_en = "e400g_25g_1_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_aibif_data_valid = "e400g_25g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_duplex_mode = "e400g_25g_1_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_fec_clk_src = "e400g_25g_1_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_fec_error = "e400g_25g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_fec_mode = "e400g_25g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_fec_spec = "e400g_25g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_lpbk_mode = "e400g_25g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_flow_control = "e400g_25g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_flow_control_holdoff_mode = "e400g_25g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_link_fault_mode = "e400g_25g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_mode = "e400g_25g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_ptp_phy_lane_num = "e400g_25g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_ipg_size = "e400g_25g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_ptp_phy_lane_num = "e400g_25g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_pcs_ber_mon_mode = "e400g_25g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_ptp_mode = "e400g_25g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_aib_if_fifo_mode = "e400g_25g_1_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_excvr_gb_ratio_mode = "e400g_25g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_excvr_if_fifo_mode = "e400g_25g_1_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_fec_enable = "e400g_25g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_master_bond_chnl = "e400g_25g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_pcs_mode = "e400g_25g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_primary_use = "e400g_25g_1_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_rx_xcvr_width = "e400g_25g_1_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_speed_map = "e400g_25g_1_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_sup_mode = "e400g_25g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_sys_clk_src = "e400g_25g_1_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_aib_if_fifo_mode = "e400g_25g_1_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_excvr_gb_ratio_mode = "e400g_25g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_excvr_if_fifo_mode = "e400g_25g_1_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_fec_enable = "e400g_25g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_master_bond_chnl = "e400g_25g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_pcs_mode = "e400g_25g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_primary_use = "e400g_25g_1_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_tx_xcvr_width = "e400g_25g_1_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_xcvr_mode = "e400g_25g_1_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_xcvr_type = "e400g_25g_1_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_aib2_rx_st_clk_en = "e400g_25g_2_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_aib2_tx_st_clk_en = "e400g_25g_2_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_aib3_rx_st_clk_en = "e400g_25g_2_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_aib3_tx_st_clk_en = "e400g_25g_2_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_aibif_data_valid = "e400g_25g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_duplex_mode = "e400g_25g_2_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_fec_clk_src = "e400g_25g_2_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_fec_error = "e400g_25g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_fec_mode = "e400g_25g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_fec_spec = "e400g_25g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_lpbk_mode = "e400g_25g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_flow_control = "e400g_25g_2_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_flow_control_holdoff_mode = "e400g_25g_2_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_link_fault_mode = "e400g_25g_2_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_mode = "e400g_25g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_ptp_phy_lane_num = "e400g_25g_2_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_ipg_size = "e400g_25g_2_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_ptp_phy_lane_num = "e400g_25g_2_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_pcs_ber_mon_mode = "e400g_25g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_ptp_mode = "e400g_25g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_aib_if_fifo_mode = "e400g_25g_2_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_excvr_gb_ratio_mode = "e400g_25g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_excvr_if_fifo_mode = "e400g_25g_2_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_fec_enable = "e400g_25g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_master_bond_chnl = "e400g_25g_2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_pcs_mode = "e400g_25g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_primary_use = "e400g_25g_2_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_rx_xcvr_width = "e400g_25g_2_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_speed_map = "e400g_25g_2_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_sup_mode = "e400g_25g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_sys_clk_src = "e400g_25g_2_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_aib_if_fifo_mode = "e400g_25g_2_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_excvr_gb_ratio_mode = "e400g_25g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_excvr_if_fifo_mode = "e400g_25g_2_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_fec_enable = "e400g_25g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_master_bond_chnl = "e400g_25g_2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_pcs_mode = "e400g_25g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_primary_use = "e400g_25g_2_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_tx_xcvr_width = "e400g_25g_2_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_xcvr_mode = "e400g_25g_2_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_xcvr_type = "e400g_25g_2_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_aib2_rx_st_clk_en = "e400g_25g_3_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_aib2_tx_st_clk_en = "e400g_25g_3_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_aib3_rx_st_clk_en = "e400g_25g_3_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_aib3_tx_st_clk_en = "e400g_25g_3_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_aibif_data_valid = "e400g_25g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_duplex_mode = "e400g_25g_3_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_fec_clk_src = "e400g_25g_3_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_fec_error = "e400g_25g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_fec_mode = "e400g_25g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_fec_spec = "e400g_25g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_lpbk_mode = "e400g_25g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_flow_control = "e400g_25g_3_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_flow_control_holdoff_mode = "e400g_25g_3_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_link_fault_mode = "e400g_25g_3_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_mode = "e400g_25g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_ptp_phy_lane_num = "e400g_25g_3_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_ipg_size = "e400g_25g_3_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_ptp_phy_lane_num = "e400g_25g_3_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_pcs_ber_mon_mode = "e400g_25g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_ptp_mode = "e400g_25g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_aib_if_fifo_mode = "e400g_25g_3_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_excvr_gb_ratio_mode = "e400g_25g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_excvr_if_fifo_mode = "e400g_25g_3_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_fec_enable = "e400g_25g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_master_bond_chnl = "e400g_25g_3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_pcs_mode = "e400g_25g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_primary_use = "e400g_25g_3_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_rx_xcvr_width = "e400g_25g_3_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_speed_map = "e400g_25g_3_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_sup_mode = "e400g_25g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_sys_clk_src = "e400g_25g_3_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_aib_if_fifo_mode = "e400g_25g_3_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_excvr_gb_ratio_mode = "e400g_25g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_excvr_if_fifo_mode = "e400g_25g_3_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_fec_enable = "e400g_25g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_master_bond_chnl = "e400g_25g_3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_pcs_mode = "e400g_25g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_primary_use = "e400g_25g_3_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_tx_xcvr_width = "e400g_25g_3_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_xcvr_mode = "e400g_25g_3_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_xcvr_type = "e400g_25g_3_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_aib2_rx_st_clk_en = "e400g_25g_4_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_aib2_tx_st_clk_en = "e400g_25g_4_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_aib3_rx_st_clk_en = "e400g_25g_4_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_aib3_tx_st_clk_en = "e400g_25g_4_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_aibif_data_valid = "e400g_25g_4_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_duplex_mode = "e400g_25g_4_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_fec_clk_src = "e400g_25g_4_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_fec_error = "e400g_25g_4_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_fec_mode = "e400g_25g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_fec_spec = "e400g_25g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_lpbk_mode = "e400g_25g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_flow_control = "e400g_25g_4_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_flow_control_holdoff_mode = "e400g_25g_4_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_link_fault_mode = "e400g_25g_4_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_mode = "e400g_25g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_ptp_phy_lane_num = "e400g_25g_4_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_ipg_size = "e400g_25g_4_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_ptp_phy_lane_num = "e400g_25g_4_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_pcs_ber_mon_mode = "e400g_25g_4_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_ptp_mode = "e400g_25g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_aib_if_fifo_mode = "e400g_25g_4_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_excvr_gb_ratio_mode = "e400g_25g_4_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_excvr_if_fifo_mode = "e400g_25g_4_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_fec_enable = "e400g_25g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_master_bond_chnl = "e400g_25g_4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_pcs_mode = "e400g_25g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_primary_use = "e400g_25g_4_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_rx_xcvr_width = "e400g_25g_4_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_speed_map = "e400g_25g_4_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_sup_mode = "e400g_25g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_sys_clk_src = "e400g_25g_4_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_aib_if_fifo_mode = "e400g_25g_4_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_excvr_gb_ratio_mode = "e400g_25g_4_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_excvr_if_fifo_mode = "e400g_25g_4_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_fec_enable = "e400g_25g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_master_bond_chnl = "e400g_25g_4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_pcs_mode = "e400g_25g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_primary_use = "e400g_25g_4_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_tx_xcvr_width = "e400g_25g_4_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_xcvr_mode = "e400g_25g_4_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_xcvr_type = "e400g_25g_4_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_aib2_rx_st_clk_en = "e400g_25g_5_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_aib2_tx_st_clk_en = "e400g_25g_5_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_aib3_rx_st_clk_en = "e400g_25g_5_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_aib3_tx_st_clk_en = "e400g_25g_5_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_aibif_data_valid = "e400g_25g_5_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_duplex_mode = "e400g_25g_5_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_fec_clk_src = "e400g_25g_5_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_fec_error = "e400g_25g_5_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_fec_mode = "e400g_25g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_fec_spec = "e400g_25g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_lpbk_mode = "e400g_25g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_flow_control = "e400g_25g_5_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_flow_control_holdoff_mode = "e400g_25g_5_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_link_fault_mode = "e400g_25g_5_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_mode = "e400g_25g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_ptp_phy_lane_num = "e400g_25g_5_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_ipg_size = "e400g_25g_5_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_ptp_phy_lane_num = "e400g_25g_5_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_pcs_ber_mon_mode = "e400g_25g_5_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_ptp_mode = "e400g_25g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_aib_if_fifo_mode = "e400g_25g_5_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_excvr_gb_ratio_mode = "e400g_25g_5_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_excvr_if_fifo_mode = "e400g_25g_5_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_fec_enable = "e400g_25g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_master_bond_chnl = "e400g_25g_5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_pcs_mode = "e400g_25g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_primary_use = "e400g_25g_5_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_rx_xcvr_width = "e400g_25g_5_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_speed_map = "e400g_25g_5_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_sup_mode = "e400g_25g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_sys_clk_src = "e400g_25g_5_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_aib_if_fifo_mode = "e400g_25g_5_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_excvr_gb_ratio_mode = "e400g_25g_5_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_excvr_if_fifo_mode = "e400g_25g_5_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_fec_enable = "e400g_25g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_master_bond_chnl = "e400g_25g_5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_pcs_mode = "e400g_25g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_primary_use = "e400g_25g_5_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_tx_xcvr_width = "e400g_25g_5_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_xcvr_mode = "e400g_25g_5_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_xcvr_type = "e400g_25g_5_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_aib2_rx_st_clk_en = "e400g_25g_6_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_aib2_tx_st_clk_en = "e400g_25g_6_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_aib3_rx_st_clk_en = "e400g_25g_6_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_aib3_tx_st_clk_en = "e400g_25g_6_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_aibif_data_valid = "e400g_25g_6_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_duplex_mode = "e400g_25g_6_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_fec_clk_src = "e400g_25g_6_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_fec_error = "e400g_25g_6_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_fec_mode = "e400g_25g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_fec_spec = "e400g_25g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_lpbk_mode = "e400g_25g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_flow_control = "e400g_25g_6_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_flow_control_holdoff_mode = "e400g_25g_6_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_link_fault_mode = "e400g_25g_6_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_mode = "e400g_25g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_ptp_phy_lane_num = "e400g_25g_6_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_ipg_size = "e400g_25g_6_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_ptp_phy_lane_num = "e400g_25g_6_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_pcs_ber_mon_mode = "e400g_25g_6_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_ptp_mode = "e400g_25g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_aib_if_fifo_mode = "e400g_25g_6_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_excvr_gb_ratio_mode = "e400g_25g_6_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_excvr_if_fifo_mode = "e400g_25g_6_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_fec_enable = "e400g_25g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_master_bond_chnl = "e400g_25g_6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_pcs_mode = "e400g_25g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_primary_use = "e400g_25g_6_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_rx_xcvr_width = "e400g_25g_6_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_speed_map = "e400g_25g_6_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_sup_mode = "e400g_25g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_sys_clk_src = "e400g_25g_6_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_aib_if_fifo_mode = "e400g_25g_6_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_excvr_gb_ratio_mode = "e400g_25g_6_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_excvr_if_fifo_mode = "e400g_25g_6_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_fec_enable = "e400g_25g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_master_bond_chnl = "e400g_25g_6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_pcs_mode = "e400g_25g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_primary_use = "e400g_25g_6_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_tx_xcvr_width = "e400g_25g_6_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_xcvr_mode = "e400g_25g_6_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_xcvr_type = "e400g_25g_6_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_aib2_rx_st_clk_en = "e400g_25g_7_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_aib2_tx_st_clk_en = "e400g_25g_7_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_aib3_rx_st_clk_en = "e400g_25g_7_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_aib3_tx_st_clk_en = "e400g_25g_7_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_aibif_data_valid = "e400g_25g_7_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_duplex_mode = "e400g_25g_7_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_fec_clk_src = "e400g_25g_7_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_fec_error = "e400g_25g_7_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_fec_mode = "e400g_25g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_fec_spec = "e400g_25g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_lpbk_mode = "e400g_25g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_flow_control = "e400g_25g_7_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_flow_control_holdoff_mode = "e400g_25g_7_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_link_fault_mode = "e400g_25g_7_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_mode = "e400g_25g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_ptp_phy_lane_num = "e400g_25g_7_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_ipg_size = "e400g_25g_7_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_ptp_phy_lane_num = "e400g_25g_7_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_pcs_ber_mon_mode = "e400g_25g_7_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_ptp_mode = "e400g_25g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_aib_if_fifo_mode = "e400g_25g_7_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_excvr_gb_ratio_mode = "e400g_25g_7_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_excvr_if_fifo_mode = "e400g_25g_7_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_fec_enable = "e400g_25g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_master_bond_chnl = "e400g_25g_7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_pcs_mode = "e400g_25g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_primary_use = "e400g_25g_7_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_rx_xcvr_width = "e400g_25g_7_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_speed_map = "e400g_25g_7_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_sup_mode = "e400g_25g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_sys_clk_src = "e400g_25g_7_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_aib_if_fifo_mode = "e400g_25g_7_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_excvr_gb_ratio_mode = "e400g_25g_7_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_excvr_if_fifo_mode = "e400g_25g_7_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_fec_enable = "e400g_25g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_master_bond_chnl = "e400g_25g_7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_pcs_mode = "e400g_25g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_primary_use = "e400g_25g_7_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_tx_xcvr_width = "e400g_25g_7_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_xcvr_mode = "e400g_25g_7_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_xcvr_type = "e400g_25g_7_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_aib2_rx_st_clk_en = "e400g_25g_8_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_aib2_tx_st_clk_en = "e400g_25g_8_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_aib3_rx_st_clk_en = "e400g_25g_8_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_aib3_tx_st_clk_en = "e400g_25g_8_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_aibif_data_valid = "e400g_25g_8_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_duplex_mode = "e400g_25g_8_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_fec_clk_src = "e400g_25g_8_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_fec_error = "e400g_25g_8_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_fec_mode = "e400g_25g_8_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_fec_spec = "e400g_25g_8_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_lpbk_mode = "e400g_25g_8_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_flow_control = "e400g_25g_8_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_flow_control_holdoff_mode = "e400g_25g_8_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_link_fault_mode = "e400g_25g_8_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_mode = "e400g_25g_8_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_ptp_phy_lane_num = "e400g_25g_8_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_ipg_size = "e400g_25g_8_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_ptp_phy_lane_num = "e400g_25g_8_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_pcs_ber_mon_mode = "e400g_25g_8_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_ptp_mode = "e400g_25g_8_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_aib_if_fifo_mode = "e400g_25g_8_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_excvr_gb_ratio_mode = "e400g_25g_8_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_excvr_if_fifo_mode = "e400g_25g_8_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_fec_enable = "e400g_25g_8_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_master_bond_chnl = "e400g_25g_8_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_pcs_mode = "e400g_25g_8_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_primary_use = "e400g_25g_8_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_rx_xcvr_width = "e400g_25g_8_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_speed_map = "e400g_25g_8_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_sup_mode = "e400g_25g_8_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_sys_clk_src = "e400g_25g_8_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_aib_if_fifo_mode = "e400g_25g_8_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_excvr_gb_ratio_mode = "e400g_25g_8_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_excvr_if_fifo_mode = "e400g_25g_8_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_fec_enable = "e400g_25g_8_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_master_bond_chnl = "e400g_25g_8_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_pcs_mode = "e400g_25g_8_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_primary_use = "e400g_25g_8_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_tx_xcvr_width = "e400g_25g_8_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_xcvr_mode = "e400g_25g_8_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_xcvr_type = "e400g_25g_8_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_aib2_rx_st_clk_en = "e400g_25g_9_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_aib2_tx_st_clk_en = "e400g_25g_9_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_aib3_rx_st_clk_en = "e400g_25g_9_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_aib3_tx_st_clk_en = "e400g_25g_9_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_aibif_data_valid = "e400g_25g_9_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_duplex_mode = "e400g_25g_9_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_fec_clk_src = "e400g_25g_9_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_fec_error = "e400g_25g_9_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_fec_mode = "e400g_25g_9_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_fec_spec = "e400g_25g_9_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_lpbk_mode = "e400g_25g_9_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_flow_control = "e400g_25g_9_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_flow_control_holdoff_mode = "e400g_25g_9_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_link_fault_mode = "e400g_25g_9_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_mode = "e400g_25g_9_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_ptp_phy_lane_num = "e400g_25g_9_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_ipg_size = "e400g_25g_9_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_ptp_phy_lane_num = "e400g_25g_9_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_pcs_ber_mon_mode = "e400g_25g_9_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_ptp_mode = "e400g_25g_9_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_q_dl_cfg_rxbit_rollover_attr = 182856;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_aib_if_fifo_mode = "e400g_25g_9_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_excvr_gb_ratio_mode = "e400g_25g_9_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_excvr_if_fifo_mode = "e400g_25g_9_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_fec_enable = "e400g_25g_9_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_master_bond_chnl = "e400g_25g_9_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_pcs_mode = "e400g_25g_9_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_primary_use = "e400g_25g_9_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_word_clk_hz = 37'h1864852D86;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_rx_xcvr_width = "e400g_25g_9_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_speed_map = "e400g_25g_9_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_sup_mode = "e400g_25g_9_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_sys_clk_src = "e400g_25g_9_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_aib_if_fifo_mode = "e400g_25g_9_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_excvr_gb_ratio_mode = "e400g_25g_9_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_excvr_if_fifo_mode = "e400g_25g_9_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_fec_enable = "e400g_25g_9_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_master_bond_chnl = "e400g_25g_9_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_pcs_mode = "e400g_25g_9_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_primary_use = "e400g_25g_9_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_word_clk_hz = 37'h1FA1FF921A;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_tx_xcvr_width = "e400g_25g_9_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_xcvr_mode = "e400g_25g_9_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_xcvr_type = "e400g_25g_9_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_aib2_rx_st_clk_en = "e400g_300g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_aib2_tx_st_clk_en = "e400g_300g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_aib3_rx_st_clk_en = "e400g_300g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_aib3_tx_st_clk_en = "e400g_300g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_aibif_data_valid = "e400g_300g_0_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_duplex_mode = "e400g_300g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_fec_mode = "e400g_300g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_fec_spec = "e400g_300g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_lpbk_mode = "e400g_300g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_mac_mode = "e400g_300g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_pcs_ber_mon_mode = "e400g_300g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_ptp_mode = "e400g_300g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_aib_if_fifo_mode = "e400g_300g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_excvr_gb_ratio_mode = "e400g_300g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_excvr_if_fifo_mode = "e400g_300g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_fec_enable = "e400g_300g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_master_bond_chnl = "e400g_300g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_pcs_mode = "e400g_300g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_primary_use = "e400g_300g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_rx_xcvr_width = "e400g_300g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_speed_map = "e400g_300g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_sup_mode = "e400g_300g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_sys_clk_src = "e400g_300g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_aib_if_fifo_mode = "e400g_300g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_excvr_gb_ratio_mode = "e400g_300g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_excvr_if_fifo_mode = "e400g_300g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_fec_enable = "e400g_300g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_master_bond_chnl = "e400g_300g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_pcs_mode = "e400g_300g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_primary_use = "e400g_300g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_tx_xcvr_width = "e400g_300g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_xcvr_mode = "e400g_300g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_xcvr_type = "e400g_300g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_aib2_rx_st_clk_en = "e400g_300g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_aib2_tx_st_clk_en = "e400g_300g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_aib3_rx_st_clk_en = "e400g_300g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_aib3_tx_st_clk_en = "e400g_300g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_aibif_data_valid = "e400g_300g_1_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_duplex_mode = "e400g_300g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_fec_mode = "e400g_300g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_fec_spec = "e400g_300g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_lpbk_mode = "e400g_300g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_mac_mode = "e400g_300g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_pcs_ber_mon_mode = "e400g_300g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_ptp_mode = "e400g_300g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_aib_if_fifo_mode = "e400g_300g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_excvr_gb_ratio_mode = "e400g_300g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_excvr_if_fifo_mode = "e400g_300g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_fec_enable = "e400g_300g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_master_bond_chnl = "e400g_300g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_pcs_mode = "e400g_300g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_primary_use = "e400g_300g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_rx_xcvr_width = "e400g_300g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_speed_map = "e400g_300g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_sup_mode = "e400g_300g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_sys_clk_src = "e400g_300g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_aib_if_fifo_mode = "e400g_300g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_excvr_gb_ratio_mode = "e400g_300g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_excvr_if_fifo_mode = "e400g_300g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_fec_enable = "e400g_300g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_master_bond_chnl = "e400g_300g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_pcs_mode = "e400g_300g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_primary_use = "e400g_300g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_tx_xcvr_width = "e400g_300g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_xcvr_mode = "e400g_300g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_xcvr_type = "e400g_300g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_aib2_rx_st_clk_en = "e400g_400g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_aib2_tx_st_clk_en = "e400g_400g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_aib3_rx_st_clk_en = "e400g_400g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_aib3_tx_st_clk_en = "e400g_400g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_aibif_data_valid = "e400g_400g_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_duplex_mode = "e400g_400g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_fec_clk_src = "e400g_400g_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_fec_error = "e400g_400g_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_fec_mode = "e400g_400g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_fec_spec = "e400g_400g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_lpbk_mode = "e400g_400g_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_flow_control = "e400g_400g_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_flow_control_holdoff_mode = "e400g_400g_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_link_fault_mode = "e400g_400g_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_mode = "e400g_400g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_ptp_phy_lane_num = "e400g_400g_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_ipg_size = "e400g_400g_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_ptp_phy_lane_num = "e400g_400g_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_pcs_ber_mon_mode = "e400g_400g_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_ptp_mode = "e400g_400g_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_aib_if_fifo_mode = "e400g_400g_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_excvr_gb_ratio_mode = "e400g_400g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_excvr_if_fifo_mode = "e400g_400g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_fec_enable = "e400g_400g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_master_bond_chnl = "e400g_400g_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_pcs_mode = "e400g_400g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_primary_use = "e400g_400g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_rx_xcvr_width = "e400g_400g_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_speed_map = "e400g_400g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_sup_mode = "e400g_400g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_sys_clk_src = "e400g_400g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_aib_if_fifo_mode = "e400g_400g_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_excvr_gb_ratio_mode = "e400g_400g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_excvr_if_fifo_mode = "e400g_400g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_fec_enable = "e400g_400g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_master_bond_chnl = "e400g_400g_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_pcs_mode = "e400g_400g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_primary_use = "e400g_400g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_tx_xcvr_width = "e400g_400g_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_xcvr_mode = "e400g_400g_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_xcvr_type = "e400g_400g_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_aib2_rx_st_clk_en = "e400g_50g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_aib2_tx_st_clk_en = "e400g_50g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_aib3_rx_st_clk_en = "e400g_50g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_aib3_tx_st_clk_en = "e400g_50g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_aibif_data_valid = "e400g_50g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_duplex_mode = "e400g_50g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_fec_clk_src = "e400g_50g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_fec_error = "e400g_50g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_fec_mode = "e400g_50g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_fec_spec = "e400g_50g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_lpbk_mode = "e400g_50g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_flow_control = "e400g_50g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_flow_control_holdoff_mode = "e400g_50g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_link_fault_mode = "e400g_50g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_mode = "e400g_50g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_ptp_phy_lane_num = "e400g_50g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_ipg_size = "e400g_50g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_ptp_phy_lane_num = "e400g_50g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_pcs_ber_mon_mode = "e400g_50g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_ptp_mode = "e400g_50g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_aib_if_fifo_mode = "e400g_50g_0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_excvr_gb_ratio_mode = "e400g_50g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_excvr_if_fifo_mode = "e400g_50g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_fec_enable = "e400g_50g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_master_bond_chnl = "e400g_50g_0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_pcs_mode = "e400g_50g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_primary_use = "e400g_50g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_rx_xcvr_width = "e400g_50g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_speed_map = "e400g_50g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_sup_mode = "e400g_50g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_sys_clk_src = "e400g_50g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_aib_if_fifo_mode = "e400g_50g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_excvr_gb_ratio_mode = "e400g_50g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_excvr_if_fifo_mode = "e400g_50g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_fec_enable = "e400g_50g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_master_bond_chnl = "e400g_50g_0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_pcs_mode = "e400g_50g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_primary_use = "e400g_50g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_tx_xcvr_width = "e400g_50g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_xcvr_mode = "e400g_50g_0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_xcvr_type = "e400g_50g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_aib2_rx_st_clk_en = "e400g_50g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_aib2_tx_st_clk_en = "e400g_50g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_aib3_rx_st_clk_en = "e400g_50g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_aib3_tx_st_clk_en = "e400g_50g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_aibif_data_valid = "e400g_50g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_duplex_mode = "e400g_50g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_fec_clk_src = "e400g_50g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_fec_error = "e400g_50g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_fec_mode = "e400g_50g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_fec_spec = "e400g_50g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_lpbk_mode = "e400g_50g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_flow_control = "e400g_50g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_flow_control_holdoff_mode = "e400g_50g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_link_fault_mode = "e400g_50g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_mode = "e400g_50g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_ptp_phy_lane_num = "e400g_50g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_ipg_size = "e400g_50g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_ptp_phy_lane_num = "e400g_50g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_pcs_ber_mon_mode = "e400g_50g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_ptp_mode = "e400g_50g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_aib_if_fifo_mode = "e400g_50g_1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_excvr_gb_ratio_mode = "e400g_50g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_excvr_if_fifo_mode = "e400g_50g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_fec_enable = "e400g_50g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_master_bond_chnl = "e400g_50g_1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_pcs_mode = "e400g_50g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_primary_use = "e400g_50g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_rx_xcvr_width = "e400g_50g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_speed_map = "e400g_50g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_sup_mode = "e400g_50g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_sys_clk_src = "e400g_50g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_aib_if_fifo_mode = "e400g_50g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_excvr_gb_ratio_mode = "e400g_50g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_excvr_if_fifo_mode = "e400g_50g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_fec_enable = "e400g_50g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_master_bond_chnl = "e400g_50g_1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_pcs_mode = "e400g_50g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_primary_use = "e400g_50g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_tx_xcvr_width = "e400g_50g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_xcvr_mode = "e400g_50g_1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_xcvr_type = "e400g_50g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_aib2_rx_st_clk_en = "e400g_50g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_aib2_tx_st_clk_en = "e400g_50g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_aib3_rx_st_clk_en = "e400g_50g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_aib3_tx_st_clk_en = "e400g_50g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_aibif_data_valid = "e400g_50g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_duplex_mode = "e400g_50g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_fec_clk_src = "e400g_50g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_fec_error = "e400g_50g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_fec_mode = "e400g_50g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_fec_spec = "e400g_50g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_lpbk_mode = "e400g_50g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_flow_control = "e400g_50g_2_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_flow_control_holdoff_mode = "e400g_50g_2_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_link_fault_mode = "e400g_50g_2_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_mode = "e400g_50g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_ptp_phy_lane_num = "e400g_50g_2_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_ipg_size = "e400g_50g_2_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_ptp_phy_lane_num = "e400g_50g_2_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_pcs_ber_mon_mode = "e400g_50g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_ptp_mode = "e400g_50g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_aib_if_fifo_mode = "e400g_50g_2_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_excvr_gb_ratio_mode = "e400g_50g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_excvr_if_fifo_mode = "e400g_50g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_fec_enable = "e400g_50g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_master_bond_chnl = "e400g_50g_2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_pcs_mode = "e400g_50g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_primary_use = "e400g_50g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_rx_xcvr_width = "e400g_50g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_speed_map = "e400g_50g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_sup_mode = "e400g_50g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_sys_clk_src = "e400g_50g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_aib_if_fifo_mode = "e400g_50g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_excvr_gb_ratio_mode = "e400g_50g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_excvr_if_fifo_mode = "e400g_50g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_fec_enable = "e400g_50g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_master_bond_chnl = "e400g_50g_2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_pcs_mode = "e400g_50g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_primary_use = "e400g_50g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_tx_xcvr_width = "e400g_50g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_xcvr_mode = "e400g_50g_2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_xcvr_type = "e400g_50g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_aib2_rx_st_clk_en = "e400g_50g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_aib2_tx_st_clk_en = "e400g_50g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_aib3_rx_st_clk_en = "e400g_50g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_aib3_tx_st_clk_en = "e400g_50g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_aibif_data_valid = "e400g_50g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_duplex_mode = "e400g_50g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_fec_clk_src = "e400g_50g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_fec_error = "e400g_50g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_fec_mode = "e400g_50g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_fec_spec = "e400g_50g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_lpbk_mode = "e400g_50g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_flow_control = "e400g_50g_3_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_flow_control_holdoff_mode = "e400g_50g_3_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_link_fault_mode = "e400g_50g_3_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_mode = "e400g_50g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_ptp_phy_lane_num = "e400g_50g_3_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_ipg_size = "e400g_50g_3_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_ptp_phy_lane_num = "e400g_50g_3_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_pcs_ber_mon_mode = "e400g_50g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_ptp_mode = "e400g_50g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_aib_if_fifo_mode = "e400g_50g_3_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_excvr_gb_ratio_mode = "e400g_50g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_excvr_if_fifo_mode = "e400g_50g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_fec_enable = "e400g_50g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_master_bond_chnl = "e400g_50g_3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_pcs_mode = "e400g_50g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_primary_use = "e400g_50g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_rx_xcvr_width = "e400g_50g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_speed_map = "e400g_50g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_sup_mode = "e400g_50g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_sys_clk_src = "e400g_50g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_aib_if_fifo_mode = "e400g_50g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_excvr_gb_ratio_mode = "e400g_50g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_excvr_if_fifo_mode = "e400g_50g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_fec_enable = "e400g_50g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_master_bond_chnl = "e400g_50g_3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_pcs_mode = "e400g_50g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_primary_use = "e400g_50g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_tx_xcvr_width = "e400g_50g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_xcvr_mode = "e400g_50g_3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_xcvr_type = "e400g_50g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_aib2_rx_st_clk_en = "e400g_50g_4_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_aib2_tx_st_clk_en = "e400g_50g_4_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_aib3_rx_st_clk_en = "e400g_50g_4_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_aib3_tx_st_clk_en = "e400g_50g_4_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_aibif_data_valid = "e400g_50g_4_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_duplex_mode = "e400g_50g_4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_fec_clk_src = "e400g_50g_4_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_fec_error = "e400g_50g_4_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_fec_mode = "e400g_50g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_fec_spec = "e400g_50g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_lpbk_mode = "e400g_50g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_flow_control = "e400g_50g_4_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_flow_control_holdoff_mode = "e400g_50g_4_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_link_fault_mode = "e400g_50g_4_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_mode = "e400g_50g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_ptp_phy_lane_num = "e400g_50g_4_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_ipg_size = "e400g_50g_4_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_ptp_phy_lane_num = "e400g_50g_4_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_pcs_ber_mon_mode = "e400g_50g_4_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_ptp_mode = "e400g_50g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_aib_if_fifo_mode = "e400g_50g_4_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_excvr_gb_ratio_mode = "e400g_50g_4_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_excvr_if_fifo_mode = "e400g_50g_4_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_fec_enable = "e400g_50g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_master_bond_chnl = "e400g_50g_4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_pcs_mode = "e400g_50g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_primary_use = "e400g_50g_4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_rx_xcvr_width = "e400g_50g_4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_speed_map = "e400g_50g_4_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_sup_mode = "e400g_50g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_sys_clk_src = "e400g_50g_4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_aib_if_fifo_mode = "e400g_50g_4_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_excvr_gb_ratio_mode = "e400g_50g_4_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_excvr_if_fifo_mode = "e400g_50g_4_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_fec_enable = "e400g_50g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_master_bond_chnl = "e400g_50g_4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_pcs_mode = "e400g_50g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_primary_use = "e400g_50g_4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_tx_xcvr_width = "e400g_50g_4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_xcvr_mode = "e400g_50g_4_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_xcvr_type = "e400g_50g_4_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_aib2_rx_st_clk_en = "e400g_50g_5_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_aib2_tx_st_clk_en = "e400g_50g_5_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_aib3_rx_st_clk_en = "e400g_50g_5_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_aib3_tx_st_clk_en = "e400g_50g_5_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_aibif_data_valid = "e400g_50g_5_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_duplex_mode = "e400g_50g_5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_fec_clk_src = "e400g_50g_5_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_fec_error = "e400g_50g_5_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_fec_mode = "e400g_50g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_fec_spec = "e400g_50g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_lpbk_mode = "e400g_50g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_flow_control = "e400g_50g_5_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_flow_control_holdoff_mode = "e400g_50g_5_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_link_fault_mode = "e400g_50g_5_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_mode = "e400g_50g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_ptp_phy_lane_num = "e400g_50g_5_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_ipg_size = "e400g_50g_5_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_ptp_phy_lane_num = "e400g_50g_5_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_pcs_ber_mon_mode = "e400g_50g_5_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_ptp_mode = "e400g_50g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_aib_if_fifo_mode = "e400g_50g_5_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_excvr_gb_ratio_mode = "e400g_50g_5_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_excvr_if_fifo_mode = "e400g_50g_5_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_fec_enable = "e400g_50g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_master_bond_chnl = "e400g_50g_5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_pcs_mode = "e400g_50g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_primary_use = "e400g_50g_5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_rx_xcvr_width = "e400g_50g_5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_speed_map = "e400g_50g_5_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_sup_mode = "e400g_50g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_sys_clk_src = "e400g_50g_5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_aib_if_fifo_mode = "e400g_50g_5_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_excvr_gb_ratio_mode = "e400g_50g_5_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_excvr_if_fifo_mode = "e400g_50g_5_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_fec_enable = "e400g_50g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_master_bond_chnl = "e400g_50g_5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_pcs_mode = "e400g_50g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_primary_use = "e400g_50g_5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_tx_xcvr_width = "e400g_50g_5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_xcvr_mode = "e400g_50g_5_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_xcvr_type = "e400g_50g_5_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_aib2_rx_st_clk_en = "e400g_50g_6_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_aib2_tx_st_clk_en = "e400g_50g_6_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_aib3_rx_st_clk_en = "e400g_50g_6_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_aib3_tx_st_clk_en = "e400g_50g_6_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_aibif_data_valid = "e400g_50g_6_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_duplex_mode = "e400g_50g_6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_fec_clk_src = "e400g_50g_6_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_fec_error = "e400g_50g_6_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_fec_mode = "e400g_50g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_fec_spec = "e400g_50g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_lpbk_mode = "e400g_50g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_flow_control = "e400g_50g_6_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_flow_control_holdoff_mode = "e400g_50g_6_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_link_fault_mode = "e400g_50g_6_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_mode = "e400g_50g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_ptp_phy_lane_num = "e400g_50g_6_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_ipg_size = "e400g_50g_6_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_ptp_phy_lane_num = "e400g_50g_6_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_pcs_ber_mon_mode = "e400g_50g_6_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_ptp_mode = "e400g_50g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_aib_if_fifo_mode = "e400g_50g_6_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_excvr_gb_ratio_mode = "e400g_50g_6_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_excvr_if_fifo_mode = "e400g_50g_6_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_fec_enable = "e400g_50g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_master_bond_chnl = "e400g_50g_6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_pcs_mode = "e400g_50g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_primary_use = "e400g_50g_6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_rx_xcvr_width = "e400g_50g_6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_speed_map = "e400g_50g_6_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_sup_mode = "e400g_50g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_sys_clk_src = "e400g_50g_6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_aib_if_fifo_mode = "e400g_50g_6_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_excvr_gb_ratio_mode = "e400g_50g_6_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_excvr_if_fifo_mode = "e400g_50g_6_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_fec_enable = "e400g_50g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_master_bond_chnl = "e400g_50g_6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_pcs_mode = "e400g_50g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_primary_use = "e400g_50g_6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_tx_xcvr_width = "e400g_50g_6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_xcvr_mode = "e400g_50g_6_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_xcvr_type = "e400g_50g_6_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_aib2_rx_st_clk_en = "e400g_50g_7_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_aib2_tx_st_clk_en = "e400g_50g_7_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_aib3_rx_st_clk_en = "e400g_50g_7_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_aib3_tx_st_clk_en = "e400g_50g_7_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_aibif_data_valid = "e400g_50g_7_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_duplex_mode = "e400g_50g_7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_fec_clk_src = "e400g_50g_7_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_fec_error = "e400g_50g_7_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_fec_mode = "e400g_50g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_fec_spec = "e400g_50g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_lpbk_mode = "e400g_50g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_flow_control = "e400g_50g_7_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_flow_control_holdoff_mode = "e400g_50g_7_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_link_fault_mode = "e400g_50g_7_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_mode = "e400g_50g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_ptp_phy_lane_num = "e400g_50g_7_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_ipg_size = "e400g_50g_7_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_ptp_phy_lane_num = "e400g_50g_7_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_pcs_ber_mon_mode = "e400g_50g_7_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_ptp_mode = "e400g_50g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_aib_if_fifo_mode = "e400g_50g_7_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_excvr_gb_ratio_mode = "e400g_50g_7_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_excvr_if_fifo_mode = "e400g_50g_7_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_fec_enable = "e400g_50g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_master_bond_chnl = "e400g_50g_7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_pcs_mode = "e400g_50g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_primary_use = "e400g_50g_7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_rx_xcvr_width = "e400g_50g_7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_speed_map = "e400g_50g_7_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_sup_mode = "e400g_50g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_sys_clk_src = "e400g_50g_7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_aib_if_fifo_mode = "e400g_50g_7_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_excvr_gb_ratio_mode = "e400g_50g_7_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_excvr_if_fifo_mode = "e400g_50g_7_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_fec_enable = "e400g_50g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_master_bond_chnl = "e400g_50g_7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_pcs_mode = "e400g_50g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_primary_use = "e400g_50g_7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_tx_xcvr_width = "e400g_50g_7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_xcvr_mode = "e400g_50g_7_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_xcvr_type = "e400g_50g_7_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_duplex_mode = "e400g_bk0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_rx_protocol = "e400g_bk0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_rx_xcvr_width = "e400g_bk0_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_sys_clk_src = "e400g_bk0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_tx_protocol = "e400g_bk0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_tx_xcvr_width = "e400g_bk0_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_txrx_channel_operation = "e400g_bk0_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_txrx_line_encoding_type = "e400g_bk0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_duplex_mode = "e400g_bk1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_rx_protocol = "e400g_bk1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_rx_xcvr_width = "e400g_bk1_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_sys_clk_src = "e400g_bk1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_tx_protocol = "e400g_bk1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_tx_xcvr_width = "e400g_bk1_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_txrx_channel_operation = "e400g_bk1_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_txrx_line_encoding_type = "e400g_bk1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_duplex_mode = "e400g_bk2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_rx_protocol = "e400g_bk2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_rx_xcvr_width = "e400g_bk2_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_sys_clk_src = "e400g_bk2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_tx_protocol = "e400g_bk2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_tx_xcvr_width = "e400g_bk2_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_txrx_channel_operation = "e400g_bk2_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_txrx_line_encoding_type = "e400g_bk2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_duplex_mode = "e400g_bk3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_rx_protocol = "e400g_bk3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_rx_xcvr_width = "e400g_bk3_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_sys_clk_src = "e400g_bk3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_tx_protocol = "e400g_bk3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_tx_xcvr_width = "e400g_bk3_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_txrx_channel_operation = "e400g_bk3_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_txrx_line_encoding_type = "e400g_bk3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ptp0_aib2_div2_clk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ptp1_aib2_div2_clk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_duplex_mode = "e400g_ux0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_rx_protocol = "e400g_ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_rx_xcvr_width = "e400g_ux0_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_speed_bucket = "e400g_ux0_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_sys_clk_src = "e400g_ux0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_tx_protocol = "e400g_ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_tx_xcvr_width = "e400g_ux0_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_txrx_line_encoding_type = "e400g_ux0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_xcvr_mode = "e400g_ux0_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_duplex_mode = "e400g_ux10_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_rx_protocol = "e400g_ux10_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_rx_xcvr_width = "e400g_ux10_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_speed_bucket = "e400g_ux10_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_sys_clk_src = "e400g_ux10_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_tx_protocol = "e400g_ux10_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_tx_xcvr_width = "e400g_ux10_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_txrx_line_encoding_type = "e400g_ux10_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_xcvr_mode = "e400g_ux10_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_duplex_mode = "e400g_ux11_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_rx_protocol = "e400g_ux11_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_rx_xcvr_width = "e400g_ux11_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_speed_bucket = "e400g_ux11_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_sys_clk_src = "e400g_ux11_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_tx_protocol = "e400g_ux11_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_tx_xcvr_width = "e400g_ux11_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_txrx_line_encoding_type = "e400g_ux11_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_xcvr_mode = "e400g_ux11_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_duplex_mode = "e400g_ux12_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_rx_protocol = "e400g_ux12_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_rx_xcvr_width = "e400g_ux12_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_speed_bucket = "e400g_ux12_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_sys_clk_src = "e400g_ux12_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_tx_protocol = "e400g_ux12_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_tx_xcvr_width = "e400g_ux12_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_txrx_line_encoding_type = "e400g_ux12_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_xcvr_mode = "e400g_ux12_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_duplex_mode = "e400g_ux13_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_rx_protocol = "e400g_ux13_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_rx_xcvr_width = "e400g_ux13_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_speed_bucket = "e400g_ux13_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_sys_clk_src = "e400g_ux13_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_tx_protocol = "e400g_ux13_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_tx_xcvr_width = "e400g_ux13_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_txrx_line_encoding_type = "e400g_ux13_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_xcvr_mode = "e400g_ux13_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_duplex_mode = "e400g_ux14_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_rx_protocol = "e400g_ux14_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_rx_xcvr_width = "e400g_ux14_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_speed_bucket = "e400g_ux14_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_sys_clk_src = "e400g_ux14_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_tx_protocol = "e400g_ux14_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_tx_xcvr_width = "e400g_ux14_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_txrx_line_encoding_type = "e400g_ux14_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_xcvr_mode = "e400g_ux14_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_duplex_mode = "e400g_ux15_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_rx_protocol = "e400g_ux15_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_rx_xcvr_width = "e400g_ux15_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_speed_bucket = "e400g_ux15_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_sys_clk_src = "e400g_ux15_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_tx_protocol = "e400g_ux15_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_tx_xcvr_width = "e400g_ux15_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_txrx_line_encoding_type = "e400g_ux15_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_xcvr_mode = "e400g_ux15_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_duplex_mode = "e400g_ux1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_rx_protocol = "e400g_ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_rx_xcvr_width = "e400g_ux1_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_speed_bucket = "e400g_ux1_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_sys_clk_src = "e400g_ux1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_tx_protocol = "e400g_ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_tx_xcvr_width = "e400g_ux1_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_txrx_line_encoding_type = "e400g_ux1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_xcvr_mode = "e400g_ux1_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_duplex_mode = "e400g_ux2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_rx_protocol = "e400g_ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_rx_xcvr_width = "e400g_ux2_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_speed_bucket = "e400g_ux2_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_sys_clk_src = "e400g_ux2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_tx_protocol = "e400g_ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_tx_xcvr_width = "e400g_ux2_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_txrx_line_encoding_type = "e400g_ux2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_xcvr_mode = "e400g_ux2_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_duplex_mode = "e400g_ux3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_rx_protocol = "e400g_ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_rx_xcvr_width = "e400g_ux3_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_speed_bucket = "e400g_ux3_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_sys_clk_src = "e400g_ux3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_tx_protocol = "e400g_ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_tx_xcvr_width = "e400g_ux3_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_txrx_line_encoding_type = "e400g_ux3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_xcvr_mode = "e400g_ux3_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_duplex_mode = "e400g_ux4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_rx_protocol = "e400g_ux4_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_rx_xcvr_width = "e400g_ux4_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_speed_bucket = "e400g_ux4_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_sys_clk_src = "e400g_ux4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_tx_protocol = "e400g_ux4_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_tx_xcvr_width = "e400g_ux4_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_txrx_line_encoding_type = "e400g_ux4_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_xcvr_mode = "e400g_ux4_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_duplex_mode = "e400g_ux5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_rx_protocol = "e400g_ux5_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_rx_xcvr_width = "e400g_ux5_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_speed_bucket = "e400g_ux5_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_sys_clk_src = "e400g_ux5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_tx_protocol = "e400g_ux5_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_tx_xcvr_width = "e400g_ux5_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_txrx_line_encoding_type = "e400g_ux5_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_xcvr_mode = "e400g_ux5_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_duplex_mode = "e400g_ux6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_rx_protocol = "e400g_ux6_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_rx_xcvr_width = "e400g_ux6_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_speed_bucket = "e400g_ux6_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_sys_clk_src = "e400g_ux6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_tx_protocol = "e400g_ux6_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_tx_xcvr_width = "e400g_ux6_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_txrx_line_encoding_type = "e400g_ux6_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_xcvr_mode = "e400g_ux6_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_duplex_mode = "e400g_ux7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_rx_protocol = "e400g_ux7_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_rx_xcvr_width = "e400g_ux7_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_speed_bucket = "e400g_ux7_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_sys_clk_src = "e400g_ux7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_tx_protocol = "e400g_ux7_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_tx_xcvr_width = "e400g_ux7_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_txrx_line_encoding_type = "e400g_ux7_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_xcvr_mode = "e400g_ux7_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_duplex_mode = "e400g_ux8_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_rx_protocol = "e400g_ux8_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_rx_xcvr_width = "e400g_ux8_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_speed_bucket = "e400g_ux8_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_sys_clk_src = "e400g_ux8_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_tx_protocol = "e400g_ux8_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_tx_xcvr_width = "e400g_ux8_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_txrx_line_encoding_type = "e400g_ux8_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_xcvr_mode = "e400g_ux8_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_duplex_mode = "e400g_ux9_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_rx_protocol = "e400g_ux9_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_rx_xcvr_width = "e400g_ux9_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_speed_bucket = "e400g_ux9_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_sys_clk_src = "e400g_ux9_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_tx_protocol = "e400g_ux9_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_tx_xcvr_width = "e400g_ux9_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_txrx_line_encoding_type = "e400g_ux9_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_xcvr_mode = "e400g_ux9_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_duplex_mode = "e400g_xcvr_speed_map_112e4x0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_rx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_rx_protocol = "e400g_xcvr_speed_map_112e4x0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_rx_xcvr_width = "e400g_xcvr_speed_map_112e4x0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_speed_bucket = "e400g_xcvr_speed_map_112e4x0_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_sys_clk_src = "e400g_xcvr_speed_map_112e4x0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_tx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_tx_protocol = "e400g_xcvr_speed_map_112e4x0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_tx_xcvr_width = "e400g_xcvr_speed_map_112e4x0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_txrx_channel_operation = "e400g_xcvr_speed_map_112e4x0_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_txrx_line_encoding_type = "e400g_xcvr_speed_map_112e4x0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_xcvr_mode = "e400g_xcvr_speed_map_112e4x0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_duplex_mode = "e400g_xcvr_speed_map_112e4x1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_rx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_rx_protocol = "e400g_xcvr_speed_map_112e4x1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_rx_xcvr_width = "e400g_xcvr_speed_map_112e4x1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_speed_bucket = "e400g_xcvr_speed_map_112e4x1_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_sys_clk_src = "e400g_xcvr_speed_map_112e4x1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_tx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_tx_protocol = "e400g_xcvr_speed_map_112e4x1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_tx_xcvr_width = "e400g_xcvr_speed_map_112e4x1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_txrx_channel_operation = "e400g_xcvr_speed_map_112e4x1_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_txrx_line_encoding_type = "e400g_xcvr_speed_map_112e4x1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_xcvr_mode = "e400g_xcvr_speed_map_112e4x1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_duplex_mode = "e400g_xcvr_speed_map_112e4x2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_rx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_rx_protocol = "e400g_xcvr_speed_map_112e4x2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_rx_xcvr_width = "e400g_xcvr_speed_map_112e4x2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_speed_bucket = "e400g_xcvr_speed_map_112e4x2_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_sys_clk_src = "e400g_xcvr_speed_map_112e4x2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_tx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_tx_protocol = "e400g_xcvr_speed_map_112e4x2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_tx_xcvr_width = "e400g_xcvr_speed_map_112e4x2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_txrx_channel_operation = "e400g_xcvr_speed_map_112e4x2_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_txrx_line_encoding_type = "e400g_xcvr_speed_map_112e4x2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_xcvr_mode = "e400g_xcvr_speed_map_112e4x2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_duplex_mode = "e400g_xcvr_speed_map_112e4x3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_rx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_rx_protocol = "e400g_xcvr_speed_map_112e4x3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_rx_xcvr_width = "e400g_xcvr_speed_map_112e4x3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_speed_bucket = "e400g_xcvr_speed_map_112e4x3_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_sys_clk_src = "e400g_xcvr_speed_map_112e4x3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_tx_master_bond_chnl = "e400g_xcvr_speed_map_112e4x3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_tx_protocol = "e400g_xcvr_speed_map_112e4x3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_tx_xcvr_width = "e400g_xcvr_speed_map_112e4x3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_txrx_channel_operation = "e400g_xcvr_speed_map_112e4x3_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_txrx_line_encoding_type = "e400g_xcvr_speed_map_112e4x3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_xcvr_mode = "e400g_xcvr_speed_map_112e4x3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_duplex_mode = "e400g_xcvr_speed_map_25e4x0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_rx_protocol = "e400g_xcvr_speed_map_25e4x0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_speed_bucket = "e400g_xcvr_speed_map_25e4x0_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_sys_clk_src = "e400g_xcvr_speed_map_25e4x0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_tx_protocol = "e400g_xcvr_speed_map_25e4x0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x0_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_xcvr_mode = "e400g_xcvr_speed_map_25e4x0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_duplex_mode = "e400g_xcvr_speed_map_25e4x10_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x10_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_rx_protocol = "e400g_xcvr_speed_map_25e4x10_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x10_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_speed_bucket = "e400g_xcvr_speed_map_25e4x10_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_sys_clk_src = "e400g_xcvr_speed_map_25e4x10_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x10_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_tx_protocol = "e400g_xcvr_speed_map_25e4x10_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x10_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x10_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x10_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_xcvr_mode = "e400g_xcvr_speed_map_25e4x10_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_duplex_mode = "e400g_xcvr_speed_map_25e4x11_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x11_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_rx_protocol = "e400g_xcvr_speed_map_25e4x11_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x11_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_speed_bucket = "e400g_xcvr_speed_map_25e4x11_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_sys_clk_src = "e400g_xcvr_speed_map_25e4x11_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x11_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_tx_protocol = "e400g_xcvr_speed_map_25e4x11_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x11_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x11_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x11_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_xcvr_mode = "e400g_xcvr_speed_map_25e4x11_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_duplex_mode = "e400g_xcvr_speed_map_25e4x12_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x12_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_rx_protocol = "e400g_xcvr_speed_map_25e4x12_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x12_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_speed_bucket = "e400g_xcvr_speed_map_25e4x12_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_sys_clk_src = "e400g_xcvr_speed_map_25e4x12_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x12_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_tx_protocol = "e400g_xcvr_speed_map_25e4x12_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x12_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x12_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x12_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_xcvr_mode = "e400g_xcvr_speed_map_25e4x12_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_duplex_mode = "e400g_xcvr_speed_map_25e4x13_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x13_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_rx_protocol = "e400g_xcvr_speed_map_25e4x13_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x13_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_speed_bucket = "e400g_xcvr_speed_map_25e4x13_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_sys_clk_src = "e400g_xcvr_speed_map_25e4x13_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x13_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_tx_protocol = "e400g_xcvr_speed_map_25e4x13_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x13_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x13_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x13_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_xcvr_mode = "e400g_xcvr_speed_map_25e4x13_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_duplex_mode = "e400g_xcvr_speed_map_25e4x14_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x14_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_rx_protocol = "e400g_xcvr_speed_map_25e4x14_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x14_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_speed_bucket = "e400g_xcvr_speed_map_25e4x14_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_sys_clk_src = "e400g_xcvr_speed_map_25e4x14_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x14_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_tx_protocol = "e400g_xcvr_speed_map_25e4x14_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x14_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x14_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x14_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_xcvr_mode = "e400g_xcvr_speed_map_25e4x14_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_duplex_mode = "e400g_xcvr_speed_map_25e4x15_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x15_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_rx_protocol = "e400g_xcvr_speed_map_25e4x15_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x15_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_speed_bucket = "e400g_xcvr_speed_map_25e4x15_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_sys_clk_src = "e400g_xcvr_speed_map_25e4x15_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x15_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_tx_protocol = "e400g_xcvr_speed_map_25e4x15_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x15_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x15_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x15_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_xcvr_mode = "e400g_xcvr_speed_map_25e4x15_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_duplex_mode = "e400g_xcvr_speed_map_25e4x1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_rx_protocol = "e400g_xcvr_speed_map_25e4x1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_speed_bucket = "e400g_xcvr_speed_map_25e4x1_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_sys_clk_src = "e400g_xcvr_speed_map_25e4x1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_tx_protocol = "e400g_xcvr_speed_map_25e4x1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x1_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_xcvr_mode = "e400g_xcvr_speed_map_25e4x1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_duplex_mode = "e400g_xcvr_speed_map_25e4x2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_rx_protocol = "e400g_xcvr_speed_map_25e4x2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_speed_bucket = "e400g_xcvr_speed_map_25e4x2_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_sys_clk_src = "e400g_xcvr_speed_map_25e4x2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_tx_protocol = "e400g_xcvr_speed_map_25e4x2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x2_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_xcvr_mode = "e400g_xcvr_speed_map_25e4x2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_duplex_mode = "e400g_xcvr_speed_map_25e4x3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_rx_protocol = "e400g_xcvr_speed_map_25e4x3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_speed_bucket = "e400g_xcvr_speed_map_25e4x3_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_sys_clk_src = "e400g_xcvr_speed_map_25e4x3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_tx_protocol = "e400g_xcvr_speed_map_25e4x3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x3_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_xcvr_mode = "e400g_xcvr_speed_map_25e4x3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_duplex_mode = "e400g_xcvr_speed_map_25e4x4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_rx_protocol = "e400g_xcvr_speed_map_25e4x4_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_speed_bucket = "e400g_xcvr_speed_map_25e4x4_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_sys_clk_src = "e400g_xcvr_speed_map_25e4x4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_tx_protocol = "e400g_xcvr_speed_map_25e4x4_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x4_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x4_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_xcvr_mode = "e400g_xcvr_speed_map_25e4x4_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_duplex_mode = "e400g_xcvr_speed_map_25e4x5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_rx_protocol = "e400g_xcvr_speed_map_25e4x5_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_speed_bucket = "e400g_xcvr_speed_map_25e4x5_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_sys_clk_src = "e400g_xcvr_speed_map_25e4x5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_tx_protocol = "e400g_xcvr_speed_map_25e4x5_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x5_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x5_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_xcvr_mode = "e400g_xcvr_speed_map_25e4x5_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_duplex_mode = "e400g_xcvr_speed_map_25e4x6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_rx_protocol = "e400g_xcvr_speed_map_25e4x6_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_speed_bucket = "e400g_xcvr_speed_map_25e4x6_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_sys_clk_src = "e400g_xcvr_speed_map_25e4x6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_tx_protocol = "e400g_xcvr_speed_map_25e4x6_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x6_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x6_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_xcvr_mode = "e400g_xcvr_speed_map_25e4x6_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_duplex_mode = "e400g_xcvr_speed_map_25e4x7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_rx_protocol = "e400g_xcvr_speed_map_25e4x7_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_speed_bucket = "e400g_xcvr_speed_map_25e4x7_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_sys_clk_src = "e400g_xcvr_speed_map_25e4x7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_tx_protocol = "e400g_xcvr_speed_map_25e4x7_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x7_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x7_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_xcvr_mode = "e400g_xcvr_speed_map_25e4x7_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_duplex_mode = "e400g_xcvr_speed_map_25e4x8_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x8_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_rx_protocol = "e400g_xcvr_speed_map_25e4x8_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x8_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_speed_bucket = "e400g_xcvr_speed_map_25e4x8_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_sys_clk_src = "e400g_xcvr_speed_map_25e4x8_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x8_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_tx_protocol = "e400g_xcvr_speed_map_25e4x8_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x8_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x8_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x8_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_xcvr_mode = "e400g_xcvr_speed_map_25e4x8_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_duplex_mode = "e400g_xcvr_speed_map_25e4x9_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_rx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x9_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_rx_protocol = "e400g_xcvr_speed_map_25e4x9_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_rx_xcvr_width = "e400g_xcvr_speed_map_25e4x9_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_speed_bucket = "e400g_xcvr_speed_map_25e4x9_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_sys_clk_src = "e400g_xcvr_speed_map_25e4x9_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_tx_master_bond_chnl = "e400g_xcvr_speed_map_25e4x9_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_tx_protocol = "e400g_xcvr_speed_map_25e4x9_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_tx_xcvr_width = "e400g_xcvr_speed_map_25e4x9_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_txrx_channel_operation = "e400g_xcvr_speed_map_25e4x9_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_txrx_line_encoding_type = "e400g_xcvr_speed_map_25e4x9_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_xcvr_mode = "e400g_xcvr_speed_map_25e4x9_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_duplex_mode = "e400g_xcvr_speed_map_56e4x0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_rx_protocol = "e400g_xcvr_speed_map_56e4x0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_speed_bucket = "e400g_xcvr_speed_map_56e4x0_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_sys_clk_src = "e400g_xcvr_speed_map_56e4x0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_tx_protocol = "e400g_xcvr_speed_map_56e4x0_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x0_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x0_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_xcvr_mode = "e400g_xcvr_speed_map_56e4x0_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_duplex_mode = "e400g_xcvr_speed_map_56e4x1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_rx_protocol = "e400g_xcvr_speed_map_56e4x1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_speed_bucket = "e400g_xcvr_speed_map_56e4x1_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_sys_clk_src = "e400g_xcvr_speed_map_56e4x1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_tx_protocol = "e400g_xcvr_speed_map_56e4x1_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x1_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x1_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_xcvr_mode = "e400g_xcvr_speed_map_56e4x1_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_duplex_mode = "e400g_xcvr_speed_map_56e4x2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_rx_protocol = "e400g_xcvr_speed_map_56e4x2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_speed_bucket = "e400g_xcvr_speed_map_56e4x2_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_sys_clk_src = "e400g_xcvr_speed_map_56e4x2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_tx_protocol = "e400g_xcvr_speed_map_56e4x2_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x2_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x2_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_xcvr_mode = "e400g_xcvr_speed_map_56e4x2_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_duplex_mode = "e400g_xcvr_speed_map_56e4x3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_rx_protocol = "e400g_xcvr_speed_map_56e4x3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_speed_bucket = "e400g_xcvr_speed_map_56e4x3_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_sys_clk_src = "e400g_xcvr_speed_map_56e4x3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_tx_protocol = "e400g_xcvr_speed_map_56e4x3_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x3_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x3_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_xcvr_mode = "e400g_xcvr_speed_map_56e4x3_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_duplex_mode = "e400g_xcvr_speed_map_56e4x4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_rx_protocol = "e400g_xcvr_speed_map_56e4x4_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_speed_bucket = "e400g_xcvr_speed_map_56e4x4_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_sys_clk_src = "e400g_xcvr_speed_map_56e4x4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_tx_protocol = "e400g_xcvr_speed_map_56e4x4_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x4_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x4_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_xcvr_mode = "e400g_xcvr_speed_map_56e4x4_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_duplex_mode = "e400g_xcvr_speed_map_56e4x5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_rx_protocol = "e400g_xcvr_speed_map_56e4x5_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_speed_bucket = "e400g_xcvr_speed_map_56e4x5_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_sys_clk_src = "e400g_xcvr_speed_map_56e4x5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_tx_protocol = "e400g_xcvr_speed_map_56e4x5_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x5_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x5_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_xcvr_mode = "e400g_xcvr_speed_map_56e4x5_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_duplex_mode = "e400g_xcvr_speed_map_56e4x6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_rx_protocol = "e400g_xcvr_speed_map_56e4x6_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_speed_bucket = "e400g_xcvr_speed_map_56e4x6_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_sys_clk_src = "e400g_xcvr_speed_map_56e4x6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_tx_protocol = "e400g_xcvr_speed_map_56e4x6_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x6_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x6_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_xcvr_mode = "e400g_xcvr_speed_map_56e4x6_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_duplex_mode = "e400g_xcvr_speed_map_56e4x7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_rx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_rx_protocol = "e400g_xcvr_speed_map_56e4x7_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_rx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_rx_xcvr_width = "e400g_xcvr_speed_map_56e4x7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_speed_bucket = "e400g_xcvr_speed_map_56e4x7_speed_bucket_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_sys_clk_src = "e400g_xcvr_speed_map_56e4x7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_tx_master_bond_chnl = "e400g_xcvr_speed_map_56e4x7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_tx_protocol = "e400g_xcvr_speed_map_56e4x7_tx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_tx_word_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_tx_xcvr_width = "e400g_xcvr_speed_map_56e4x7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_txrx_channel_operation = "e400g_xcvr_speed_map_56e4x7_txrx_channel_operation_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_txrx_line_encoding_type = "e400g_xcvr_speed_map_56e4x7_txrx_line_encoding_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_xcvr_mode = "e400g_xcvr_speed_map_56e4x7_xcvr_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_bk0 = "map_bk0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_bk1 = "map_bk1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_bk2 = "map_bk2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_bk3 = "map_bk3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux0 = "map_ux0_enable_25e4x15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux1 = "map_ux1_enable_25e4x14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux10 = "map_ux10_enable_25e4x5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux11 = "map_ux11_enable_25e4x4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux12 = "map_ux12_enable_25e4x3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux13 = "map_ux13_enable_25e4x2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux14 = "map_ux14_enable_25e4x1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux15 = "map_ux15_enable_25e4x0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux2 = "map_ux2_enable_25e4x13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux3 = "map_ux3_enable_25e4x12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux4 = "map_ux4_enable_25e4x11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux5 = "map_ux5_enable_25e4x10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux6 = "map_ux6_enable_25e4x9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux7 = "map_ux7_enable_25e4x8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux8 = "map_ux8_enable_25e4x7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__map_ux9 = "map_ux9_enable_25e4x6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sup_mode = "individual_31_control";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__topo_supports_barak = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__topo_supports_pcie = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__topo_supports_ptp = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__topology = "ux16e400gptp_xx_disabled_xx_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__error_correction_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__error_indicator_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel2 = "eth_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_rx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_sfrz_tx_bond_sel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel4 = "tx_aib_st";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_force_signal_ok = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pempty = 5;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_signal_ok_sel = "xcvrif_signal_ok_sync";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pempty = 8;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_pfull = 48;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_phcomp_rd_delay = "phcomp_rd_del2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_aibif_data_valid = "e400g_150g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__dfd_mux_sel = "dfd_pre";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__dfd_node_sel = "dfd_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__dsk_wait_count = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__ehip_mode_tx = "ehip_tx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__testbus_ip_sel = "testbus_ehip";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__testbus_rx_tx_sel = "testbus_tx";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_fifo_lat_pulse_sel = "lphy_lat";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_am_period = "no_tx_am_period";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__dfd_enable = "dfd_is_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_gen_capable = "gen3";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__topology = "disabled_system";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ippwrmod_freq = "clk1g";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_bad_dllp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_bad_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_corrected_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dl_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_fc_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_mlf_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_ptm_auto_update_signal = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_rcvr_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_rcvr_overflow_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_replay_number_rollover_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_replay_timer_timeout_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_surprise_down_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_uncor_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__clrhip_not_rst_sticky = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_data_compressed = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_data_encrypted = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_irq_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_jtag0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_user_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_tablesize_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_bir_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixpba_offset_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_bir_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixtable_offset_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_subsysid_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablelocation_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_sttablesize_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__gpio_irq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__irq_misc_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__nonsriov_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pcie_parity_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_adv_err_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_acs_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_auto_lane_flip_ctrl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar0_type = "pf0_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar2_type = "pf0_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar3_mem_io = "pf0_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar4_type = "pf0_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_config_phy_tx_change = "pf0_full_swing";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsi = "pf0_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_rx_preset_hint9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dsp_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eq_eieos_cnt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eq_phase_2_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eq_phase_2_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eq_redo = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eq_redo_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_fast_link_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_eval_2ms_disable = "pf0_continue";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_eval_2ms_disable_atg4 = "pf0_continue_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_phase23_exit_mode = "pf0_next_rec_speed";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_phase23_exit_mode_atg4 = "pf0_next_rec_speed_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_pset_req_vec = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_pset_req_vec_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_equalization_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_equalization_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_lower_rate_eq_redo_enable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_lower_rate_eq_redo_enable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_int_pin = "pf0_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_loopback_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_no_soft_rst = "pf0_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_multiple_msg_cap = "pf0_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_attention_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_attention_indicator_button = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_crs_sw_visibility = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_electromech_interlock = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_flr_cap = "pf0_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_hot_plug_capable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_hot_plug_surprise = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_mrl_sensor = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_no_cmd_cpl_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_phy_slot_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_power_controller = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_power_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_sel_deemphasis = "pf0_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_power_limit_scale = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_power_limit_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_slot_imp = "pf0_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pipe_loopback = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rp_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rp_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rxeq_ph01_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rxeq_ph01_en_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rxeq_rgrdless_rxts = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rxeq_rgrdless_rxts_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sel_deemphasis = "pf0_minus_6db_ctl";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar0_type = "pf0_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar2_type = "pf0_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar4_type = "pf0_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_offset_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf0_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_st_table_loc_1 = "pf0_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf0_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint1 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint10 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint11 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint12 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint13 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint14 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint15 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint2 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint4 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint5 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint6 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint7 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint8 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_rx_preset_hint9 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset10 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset11 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset12 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset13 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset14 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset15 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset5 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset7 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset8 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_tx_preset9 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar0_type = "pf1_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar2_type = "pf1_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar4_type = "pf1_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dsi = "pf1_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_int_pin = "pf1_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_no_soft_rst = "pf1_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_multiple_msg_cap = "pf1_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_flr_cap = "pf1_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar0_type = "pf1_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar2_type = "pf1_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar4_type = "pf1_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf1_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_st_table_loc_1 = "pf1_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf1_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar0_type = "pf2_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar2_type = "pf2_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar4_type = "pf2_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dsi = "pf2_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_int_pin = "pf2_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_no_soft_rst = "pf2_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_multiple_msg_cap = "pf2_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_flr_cap = "pf2_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar0_type = "pf2_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar2_type = "pf2_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar4_type = "pf2_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf2_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_st_table_loc_1 = "pf2_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf2_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar0_type = "pf3_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar2_type = "pf3_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar4_type = "pf3_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dsi = "pf3_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_int_pin = "pf3_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_no_soft_rst = "pf3_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_multiple_msg_cap = "pf3_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_flr_cap = "pf3_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar0_type = "pf3_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar2_type = "pf3_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar4_type = "pf3_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf3_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_st_table_loc_1 = "pf3_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf3_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar0_type = "pf4_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar2_type = "pf4_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar4_type = "pf4_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dsi = "pf4_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_int_pin = "pf4_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_no_soft_rst = "pf4_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_multiple_msg_cap = "pf4_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_flr_cap = "pf4_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar0_type = "pf4_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar2_type = "pf4_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar4_type = "pf4_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf4_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_st_table_loc_1 = "pf4_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf4_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar0_type = "pf5_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar2_type = "pf5_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar4_type = "pf5_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dsi = "pf5_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_int_pin = "pf5_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_no_soft_rst = "pf5_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_multiple_msg_cap = "pf5_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_flr_cap = "pf5_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar0_type = "pf5_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar2_type = "pf5_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar4_type = "pf5_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf5_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_st_table_loc_1 = "pf5_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf5_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar0_type = "pf6_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar2_type = "pf6_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar4_type = "pf6_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dsi = "pf6_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_int_pin = "pf6_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_no_soft_rst = "pf6_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_multiple_msg_cap = "pf6_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_flr_cap = "pf6_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar0_type = "pf6_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar2_type = "pf6_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar4_type = "pf6_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf6_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_st_table_loc_1 = "pf6_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf6_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar0_type = "pf7_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar2_type = "pf7_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar4_type = "pf7_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dsi = "pf7_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_int_pin = "pf7_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_no_soft_rst = "pf7_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_multiple_msg_cap = "pf7_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_flr_cap = "pf7_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar0_type = "pf7_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar2_type = "pf7_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar4_type = "pf7_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf7_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_st_table_loc_1 = "pf7_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf7_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pld_aib_loopback_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pld_crs_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__powermode_freq_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__rx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__rxbuf_limit_bypass = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__shadow_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__sris_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__test_in_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__vf_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_drop_vendor0_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_drop_vendor1_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_ep_native = "native";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_link_rate = "gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_link_width = "x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_maxpayload_size = "max_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_num_of_lanes = "num_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_dlink_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_io_decode = "io32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_ltr_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_prefetch_decode = "pref64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_phase23_txpreset = "preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_phase23_txpreset_atg4 = "gen4_preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pldclk_rate = "slow";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_ptm_autoupdate = "autoupdate_10ms";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_rp_ep_mode = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__vsec_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__vsec_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_bad_dllp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_bad_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_corrected_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dl_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_ecrc_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_fc_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_mlf_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_rcvr_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_rcvr_overflow_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_replay_number_rollover_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_replay_timer_timeout_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_surprise_down_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_uncor_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__clrhip_not_rst_sticky = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_data_compressed = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_data_encrypted = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_irq_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_jtag0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_jtag1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_jtag2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_jtag3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_user_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__gpio_irq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__irq_misc_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pcie_parity_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_adv_err_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_acs_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_auto_lane_flip_ctrl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar0_type = "pf0_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar2_type = "pf0_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar3_mem_io = "pf0_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar4_type = "pf0_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_config_phy_tx_change = "pf0_full_swing";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsi = "pf0_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_rx_preset_hint9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dsp_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eq_eieos_cnt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eq_phase_2_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eq_phase_2_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eq_redo = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eq_redo_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_fast_link_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_eval_2ms_disable = "pf0_continue";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_eval_2ms_disable_atg4 = "pf0_continue_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_phase23_exit_mode = "pf0_next_rec_speed";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_phase23_exit_mode_atg4 = "pf0_next_rec_speed_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_pset_req_vec = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_pset_req_vec_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_equalization_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_equalization_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_lower_rate_eq_redo_enable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_lower_rate_eq_redo_enable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_int_pin = "pf0_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_loopback_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_no_soft_rst = "pf0_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_multiple_msg_cap = "pf0_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_attention_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_attention_indicator_button = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_crs_sw_visibility = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_electromech_interlock = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_ext_tag_supp = "pf0_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_flr_cap = "pf0_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_hot_plug_capable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_hot_plug_surprise = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_mrl_sensor = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_no_cmd_cpl_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_phy_slot_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_power_controller = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_power_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_sel_deemphasis = "pf0_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_power_limit_scale = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_power_limit_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_slot_imp = "pf0_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pipe_loopback = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rp_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rp_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rxeq_ph01_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rxeq_ph01_en_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rxeq_rgrdless_rxts = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rxeq_rgrdless_rxts_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sel_deemphasis = "pf0_minus_6db_ctl";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar0_type = "pf0_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar2_type = "pf0_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar4_type = "pf0_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_offset_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf0_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_st_table_loc_1 = "pf0_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf0_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint1 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint10 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint11 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint12 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint13 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint14 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint15 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint2 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint4 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint5 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint6 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint7 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint8 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_rx_preset_hint9 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset10 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset11 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset12 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset13 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset14 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset15 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset5 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset7 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset8 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_tx_preset9 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pld_aib_loopback_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pld_crs_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__powermode_freq_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__rx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__rxbuf_limit_bypass = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__shadow_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__sris_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__test_in_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__vf_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_drop_vendor0_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_drop_vendor1_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_ep_native = "native";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_link_rate = "gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_maxpayload_size = "max_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_num_of_lanes = "num_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_dlink_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_io_decode = "io32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_ltr_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_pl16g_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_prefetch_decode = "pref64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_phase23_txpreset = "preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_phase23_txpreset_atg4 = "gen4_preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pldclk_rate = "slow";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_rp_ep_mode = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__vsec_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__vsec_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_bad_dllp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_bad_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_corrected_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dl_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_ecrc_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_fc_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_mlf_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_rcvr_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_rcvr_overflow_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_replay_number_rollover_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_replay_timer_timeout_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_surprise_down_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_uncor_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__clrhip_not_rst_sticky = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_data_compressed = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_data_encrypted = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_irq_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_jtag0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_jtag1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_jtag2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_jtag3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_user_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__gpio_irq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__irq_misc_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pcie_parity_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_adv_err_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_acs_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_auto_lane_flip_ctrl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar0_type = "pf0_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar2_type = "pf0_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar3_mem_io = "pf0_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar4_type = "pf0_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_config_phy_tx_change = "pf0_full_swing";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsi = "pf0_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_rx_preset_hint9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dsp_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eq_eieos_cnt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eq_phase_2_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eq_phase_2_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eq_redo = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eq_redo_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_fast_link_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_eval_2ms_disable = "pf0_continue";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_eval_2ms_disable_atg4 = "pf0_continue_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_phase23_exit_mode = "pf0_next_rec_speed";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_phase23_exit_mode_atg4 = "pf0_next_rec_speed_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_pset_req_vec = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_pset_req_vec_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_equalization_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_equalization_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_lower_rate_eq_redo_enable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_lower_rate_eq_redo_enable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_int_pin = "pf0_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_loopback_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_no_soft_rst = "pf0_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_multiple_msg_cap = "pf0_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_attention_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_attention_indicator_button = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_crs_sw_visibility = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_electromech_interlock = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_ext_tag_supp = "pf0_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_flr_cap = "pf0_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_hot_plug_capable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_hot_plug_surprise = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_mrl_sensor = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_no_cmd_cpl_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_phy_slot_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_power_controller = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_power_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_sel_deemphasis = "pf0_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_power_limit_scale = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_power_limit_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_slot_imp = "pf0_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pipe_loopback = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rp_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rp_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rxeq_ph01_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rxeq_ph01_en_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rxeq_rgrdless_rxts = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rxeq_rgrdless_rxts_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sel_deemphasis = "pf0_minus_6db_ctl";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar0_type = "pf0_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar2_type = "pf0_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar4_type = "pf0_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_offset_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf0_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_st_table_loc_1 = "pf0_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf0_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint1 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint10 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint11 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint12 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint13 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint14 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint15 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint2 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint4 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint5 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint6 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint7 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint8 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_rx_preset_hint9 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset10 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset11 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset12 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset13 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset14 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset15 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset5 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset7 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset8 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_tx_preset9 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pld_aib_loopback_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pld_crs_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__powermode_freq_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__rx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__rxbuf_limit_bypass = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__shadow_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__sris_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__test_in_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__vf_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_drop_vendor0_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_drop_vendor1_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_ep_native = "native";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_link_rate = "gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_maxpayload_size = "max_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_num_of_lanes = "num_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_dlink_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_io_decode = "io32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_ltr_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_pl16g_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_prefetch_decode = "pref64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_phase23_txpreset = "preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_phase23_txpreset_atg4 = "gen4_preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pldclk_rate = "slow";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_rp_ep_mode = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__vsec_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__vsec_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_bad_dllp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_bad_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_corrected_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dl_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_ecrc_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_fc_protocol_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_mlf_tlp_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_ptm_auto_update_signal = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_rcvr_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_rcvr_overflow_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_replay_number_rollover_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_replay_timer_timeout_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_surprise_down_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_uncor_internal_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__clrhip_not_rst_sticky = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_data_compressed = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_data_encrypted = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_irq_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_jtag0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_jtag1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_jtag2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_jtag3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_user_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_tablesize_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_bir_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixpba_offset_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_bir_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixtable_offset_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_subsysid_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablelocation_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_sttablesize_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__gpio_irq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__irq_misc_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__nonsriov_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pcie_parity_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_adv_err_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_acs_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_auto_lane_flip_ctrl_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar0_type = "pf0_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar2_type = "pf0_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar3_mem_io = "pf0_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar4_type = "pf0_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_config_phy_tx_change = "pf0_full_swing";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsi = "pf0_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_rx_preset_hint9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dsp_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eq_eieos_cnt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eq_phase_2_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eq_phase_2_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eq_redo = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eq_redo_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_fast_link_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_eval_2ms_disable = "pf0_continue";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_eval_2ms_disable_atg4 = "pf0_continue_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_phase23_exit_mode = "pf0_next_rec_speed";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_phase23_exit_mode_atg4 = "pf0_next_rec_speed_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_pset_req_vec = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_pset_req_vec_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_equalization_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_equalization_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_lower_rate_eq_redo_enable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_lower_rate_eq_redo_enable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_int_pin = "pf0_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_loopback_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_no_soft_rst = "pf0_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_multiple_msg_cap = "pf0_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_attention_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_attention_indicator_button = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_crs_sw_visibility = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_electromech_interlock = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_ext_tag_supp = "pf0_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_flr_cap = "pf0_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_hot_plug_capable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_hot_plug_surprise = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_mrl_sensor = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_no_cmd_cpl_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_phy_slot_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_power_controller = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_power_indicator = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_sel_deemphasis = "pf0_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_power_limit_scale = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_power_limit_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_slot_imp = "pf0_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pipe_loopback = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rp_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rp_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rxeq_ph01_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rxeq_ph01_en_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rxeq_rgrdless_rxts = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rxeq_rgrdless_rxts_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sel_deemphasis = "pf0_minus_6db_ctl";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar0_type = "pf0_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar2_type = "pf0_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar4_type = "pf0_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_offset_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf0_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_st_table_loc_1 = "pf0_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf0_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_16g_tx_preset9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint1 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint10 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint11 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint12 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint13 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint14 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint15 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint2 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint4 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint5 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint6 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint7 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint8 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_rx_preset_hint9 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset10 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset11 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset12 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset13 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset14 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset15 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset5 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset7 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset8 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_tx_preset9 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar0_type = "pf1_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar2_type = "pf1_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar4_type = "pf1_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dsi = "pf1_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_int_pin = "pf1_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_no_soft_rst = "pf1_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_multiple_msg_cap = "pf1_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_ext_tag_supp = "pf1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_flr_cap = "pf1_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar0_type = "pf1_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar2_type = "pf1_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar4_type = "pf1_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf1_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_st_table_loc_1 = "pf1_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf1_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar0_type = "pf2_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar2_type = "pf2_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar4_type = "pf2_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dsi = "pf2_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_int_pin = "pf2_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_no_soft_rst = "pf2_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_multiple_msg_cap = "pf2_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_ext_tag_supp = "pf2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_flr_cap = "pf2_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar0_type = "pf2_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar2_type = "pf2_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar4_type = "pf2_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf2_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_st_table_loc_1 = "pf2_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf2_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar0_type = "pf3_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar2_type = "pf3_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar4_type = "pf3_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dsi = "pf3_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_int_pin = "pf3_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_no_soft_rst = "pf3_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_multiple_msg_cap = "pf3_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_ext_tag_supp = "pf3_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_flr_cap = "pf3_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar0_type = "pf3_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar2_type = "pf3_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar4_type = "pf3_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf3_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_st_table_loc_1 = "pf3_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf3_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar0_type = "pf4_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar2_type = "pf4_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar4_type = "pf4_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dsi = "pf4_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_int_pin = "pf4_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_no_soft_rst = "pf4_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_multiple_msg_cap = "pf4_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_ext_tag_supp = "pf4_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_flr_cap = "pf4_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar0_type = "pf4_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar2_type = "pf4_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar4_type = "pf4_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf4_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_st_table_loc_1 = "pf4_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf4_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar0_type = "pf5_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar2_type = "pf5_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar4_type = "pf5_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dsi = "pf5_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_int_pin = "pf5_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_no_soft_rst = "pf5_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_multiple_msg_cap = "pf5_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_ext_tag_supp = "pf5_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_flr_cap = "pf5_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar0_type = "pf5_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar2_type = "pf5_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar4_type = "pf5_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf5_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_st_table_loc_1 = "pf5_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf5_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar0_type = "pf6_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar2_type = "pf6_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar4_type = "pf6_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dsi = "pf6_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_int_pin = "pf6_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_no_soft_rst = "pf6_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_multiple_msg_cap = "pf6_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_ext_tag_supp = "pf6_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_flr_cap = "pf6_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar0_type = "pf6_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar2_type = "pf6_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar4_type = "pf6_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf6_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_st_table_loc_1 = "pf6_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf6_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_at_block = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_direct_translated_p2p = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_egress_ctrl_size = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_p2p_cpl_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_p2p_egress_control = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_p2p_req_redirect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_src_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_usp_forwarding = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_aux_curr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar0_type = "pf7_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar2_type = "pf7_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar4_type = "pf7_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_base_class_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_cardbus_cis_pointer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dsi = "pf7_not_required";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_int_pin = "pf7_no_int";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_invalidate_q_depth = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_no_soft_rst = "pf7_internally_reset";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_page_aligned_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_execute_permission_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_max_pasid_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_privileged_mode_supported = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_64_bit_addr_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_ext_data_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_ext_data_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_multiple_msg_cap = "pf7_msi_vec_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_bir = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_pba = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_pba_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_table_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar0_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar1_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar2_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar3_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar4_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar5_mask_31_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_ep_l0s_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_ep_l1_accpt_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_ext_tag_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_ext_tag_supp = "pf7_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_flr_cap = "pf7_not_capable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_l0s_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_l1_exit_latency_commclk_dis = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_port_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_slot_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pme_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_program_interface = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_revision_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_rom_bar_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_rom_bar_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_rom_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_shadow_sriov_vf_stride_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_ser_num_reg_1_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_ser_num_reg_2_dw = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_sup_page_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar0_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar0_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar0_type = "pf7_sriov_vf_bar0_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar1_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar1_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar2_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar2_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar2_type = "pf7_sriov_vf_bar2_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar3_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar3_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar4_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar4_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar4_type = "pf7_sriov_vf_bar4_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar5_mask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar5_prefetch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_device_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_offset_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_offset_position_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_stride_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_subclass_code = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_subsys_dev_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_subsys_vendor_id = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_int_vec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_int_vec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_st_table_loc_0_vfcomm_cs2 = "pf7_not_in_tph_struct_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_st_table_loc_1 = "pf7_not_in_msix_table";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_st_table_loc_1_vfcomm_cs2 = "pf7_not_in_msix_table_vf";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_st_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_st_table_size_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_device_spec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_device_spec_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pld_aib_loopback_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pld_crs_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__powermode_freq_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__rx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__rxbuf_limit_bypass = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__shadow_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__sris_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__test_in_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_lane_flip_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__vf_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_drop_vendor0_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_drop_vendor1_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_ep_native = "native";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_link_rate = "gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_link_width = "x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_maxpayload_size = "max_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_num_of_lanes = "num_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_dlink_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_io_decode = "io32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_ltr_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_prefetch_decode = "pref64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_bar1_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_bar3_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_bar5_mask_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_exvf_acs_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_exvf_ats_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_exvf_msix_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_exvf_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_exvf_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_msi_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_msix_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_pasid_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_prs_ext_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_ras_des_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sn_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_vf_bar0_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_vf_bar2_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_vf_bar4_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_tph_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_user_vsec_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_user_vsec_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_virtio_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_vsecras_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_phase23_txpreset = "preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_phase23_txpreset_atg4 = "gen4_preset0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pldclk_rate = "slow";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_ptm_autoupdate = "autoupdate_10ms";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_rp_ep_mode = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__vsec_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__vsec_select = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__ecc_ctrl_bypass_ecc_all_aib_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__ecc_ctrl_clr_stat_n_attr = "ecc_ctrl_clr_stat_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__ecc_ctrl_ecc_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_port_x16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_port_x4_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_port_x4_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_port_x8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_rate_x16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_rate_x4_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_rate_x4_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_rate_x8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__powermode_ac = "misc_off";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_ctrl_k_hrc_arb_disable_attr = "r_hrc_arb_ctrl_k_hrc_arb_disable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_ctrl_k_hrc_arb_num_active_ip_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_ctrl_k_hrc_arb_timeslot_interval_attr = 243;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_sel_k_hrc_arb_sel_ip0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_sel_k_hrc_arb_sel_ip1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_sel_k_hrc_arb_sel_ip2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_sel_k_hrc_arb_sel_ip3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x16_bypass_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x16_platform_rst_req_attr = "r_hrc_bp_ctrl_x16_platform_rst_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x16_rst_cold_n_attr = "r_hrc_bp_ctrl_x16_rst_cold_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x16_rst_n_attr = "r_hrc_bp_ctrl_x16_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x16_rst_perst_n_attr = "r_hrc_bp_ctrl_x16_rst_perst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x16_rst_pldclrhip_n_attr = "r_hrc_bp_ctrl_x16_rst_pldclrhip_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_0_bypass_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_0_platform_rst_req_attr = "r_hrc_bp_ctrl_x4_0_platform_rst_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_0_rst_cold_n_attr = "r_hrc_bp_ctrl_x4_0_rst_cold_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_0_rst_n_attr = "r_hrc_bp_ctrl_x4_0_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_0_rst_perst_n_attr = "r_hrc_bp_ctrl_x4_0_rst_perst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_0_rst_pldclrhip_n_attr = "r_hrc_bp_ctrl_x4_0_rst_pldclrhip_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_1_bypass_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_1_platform_rst_req_attr = "r_hrc_bp_ctrl_x4_1_platform_rst_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_1_rst_cold_n_attr = "r_hrc_bp_ctrl_x4_1_rst_cold_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_1_rst_n_attr = "r_hrc_bp_ctrl_x4_1_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_1_rst_perst_n_attr = "r_hrc_bp_ctrl_x4_1_rst_perst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x4_1_rst_pldclrhip_n_attr = "r_hrc_bp_ctrl_x4_1_rst_pldclrhip_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x8_bypass_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x8_platform_rst_req_attr = "r_hrc_bp_ctrl_x8_platform_rst_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x8_rst_cold_n_attr = "r_hrc_bp_ctrl_x8_rst_cold_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x8_rst_n_attr = "r_hrc_bp_ctrl_x8_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x8_rst_perst_n_attr = "r_hrc_bp_ctrl_x8_rst_perst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_ctrl_x8_rst_pldclrhip_n_attr = "r_hrc_bp_ctrl_x8_rst_pldclrhip_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_pcs_ctrl_pipeb_a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bp_pcs_ctrl_por_b_a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_phy_rst_ctrl_k_hrc_cold_reset_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_phy_rst_ctrl_k_hrc_phy_warm_rst_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_phy_rst_time_k_hrc_phy_lane_rst_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_phy_rst_time_k_hrc_phy_post_phy_rst_quiet_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_phy_time_ctrl_k_hrc_phy_post_creg_quiet_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_phy_time_ctrl_k_hrc_phy_post_lane_rst_quiet_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_core_rst_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_dis_phystat_chk_4_partial_rst_attr = "r_hrc_rst_ctrl_k_hrc_dis_phystat_chk_4_partial_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_link_req_is_full_rst_attr = "r_hrc_rst_ctrl_k_hrc_link_req_is_full_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_link_req_is_partial_rst_attr = "r_hrc_rst_ctrl_k_hrc_link_req_is_partial_rst_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_pin_perst_is_full_rst_attr = "r_hrc_rst_ctrl_k_hrc_pin_perst_is_full_rst_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_time_ctrl_k_hrc_post_core_rst_quiet_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_time_ctrl_k_hrc_warm_rst_timeout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_stagger_ctrl_k_hrc_lane_stagger_disable_attr = "r_hrc_stagger_ctrl_k_hrc_lane_stagger_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_stagger_ctrl_k_hrc_lane_stagger_interval_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_stagger_ctrl_k_hrc_phy_stagger_disable_attr = "r_hrc_stagger_ctrl_k_hrc_phy_stagger_disable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_stagger_ctrl_k_hrc_phy_stagger_interval_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw16_perstn_overwrite_attr = "r_hrc_top_ctrl_k_hrc_dw16_perstn_overwrite_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw40_perstn_overwrite_attr = "r_hrc_top_ctrl_k_hrc_dw40_perstn_overwrite_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw41_perstn_overwrite_attr = "r_hrc_top_ctrl_k_hrc_dw41_perstn_overwrite_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw8_perstn_overwrite_attr = "r_hrc_top_ctrl_k_hrc_dw8_perstn_overwrite_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_extended_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_ip_ena_vec_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_spare_attr = "sctrl_spare_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_pcie_rate = "pcie_gen4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_ptm = "disabled";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_x16_perst_sel = "cmn_hard_x16";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_x40_perst_sel = "cmn_hard_x40";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_x41_perst_sel = "cmn_hard_x41";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_x8_perst_sel = "cmn_hard_x8";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_jtag_tck_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_srisenable_attr = "pctrl_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_port_type = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_powerdown_mode = "power_down";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_sim_mode = "disable_vsim_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_sris_enable = "disable_sris";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_tlp_bypass_en = "disable_tlbp";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_top_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__top_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmn_rx_cdr_refclk_mux_select = "ux0_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_over_sample = "ux0_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_over_sample = "ux0_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmn_rx_cdr_refclk_mux_select = "ux1_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_over_sample = "ux1_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_over_sample = "ux1_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmn_rx_cdr_refclk_mux_select = "ux2_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_over_sample = "ux2_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_over_sample = "ux2_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmn_rx_cdr_refclk_mux_select = "ux3_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_over_sample = "ux3_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_over_sample = "ux3_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__global_refclk_3_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_rx_ux0 = "ux0_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_rx_ux1 = "ux1_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_rx_ux2 = "ux2_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_rx_ux3 = "ux3_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_tx_ux0 = "ux0_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_tx_ux1 = "ux1_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_tx_ux2 = "ux2_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_tx_ux3 = "ux3_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__regional_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__top_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__top_refclk_reconfig_span = "top_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__top_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_top_refclk_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__top_syspll_refclk_output_enable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmn_rx_cdr_refclk_mux_select = "ux0_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_over_sample = "ux0_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_over_sample = "ux0_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmn_rx_cdr_refclk_mux_select = "ux1_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_over_sample = "ux1_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_over_sample = "ux1_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmn_rx_cdr_refclk_mux_select = "ux2_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_over_sample = "ux2_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_over_sample = "ux2_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmn_rx_cdr_refclk_mux_select = "ux3_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_over_sample = "ux3_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_over_sample = "ux3_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_1_right_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__global_refclk_3_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_rx_ux0 = "ux0_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_rx_ux1 = "ux1_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_rx_ux2 = "ux2_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_rx_ux3 = "ux3_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_tx_ux0 = "ux0_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_tx_ux1 = "ux1_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_tx_ux2 = "ux2_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_tx_ux3 = "ux3_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__regional_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__top_f_fastest_reconfig_refclk_hz = 800000001;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__top_refclk_reconfig_span = "top_refclk_reconfig_span_one_right";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__top_syspll_refclk_output_enable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_top_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__top_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmn_rx_cdr_refclk_mux_select = "ux0_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_over_sample = "ux0_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_over_sample = "ux0_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmn_rx_cdr_refclk_mux_select = "ux1_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_over_sample = "ux1_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_over_sample = "ux1_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmn_rx_cdr_refclk_mux_select = "ux2_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_over_sample = "ux2_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_over_sample = "ux2_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmn_rx_cdr_refclk_mux_select = "ux3_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_over_sample = "ux3_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_over_sample = "ux3_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__global_refclk_3_right_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_rx_ux0 = "ux0_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_rx_ux1 = "ux1_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_rx_ux2 = "ux2_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_rx_ux3 = "ux3_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_tx_ux0 = "ux0_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_tx_ux1 = "ux1_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_tx_ux2 = "ux2_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_tx_ux3 = "ux3_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__regional_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__top_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__top_refclk_reconfig_span = "top_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__top_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_top_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__bot_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__top_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmn_rx_cdr_refclk_mux_select = "ux0_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_over_sample = "ux0_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_over_sample = "ux0_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmn_rx_cdr_refclk_mux_select = "ux1_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_over_sample = "ux1_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_over_sample = "ux1_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmn_rx_cdr_refclk_mux_select = "ux2_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_over_sample = "ux2_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_over_sample = "ux2_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmn_rx_cdr_refclk_mux_select = "ux3_cmn_rx_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_over_sample = "ux3_rx_over_sample_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_over_sample = "ux3_tx_over_sample_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__global_refclk_3_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_rx_ux0 = "ux0_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_rx_ux1 = "ux1_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_rx_ux2 = "ux2_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_rx_ux3 = "ux3_powermode_ac_mode_rx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_tx_ux0 = "ux0_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_tx_ux1 = "ux1_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_tx_ux2 = "ux2_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_tx_ux3 = "ux3_powermode_ac_mode_tx_nrz_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__regional_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__top_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__top_refclk_reconfig_span = "top_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__top_syspll_refclk_output_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_refclk_select = "ux0_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_core_pll = "ux0_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_dpma_refclk_source = "ux0_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ethernet_source = "ux0_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_flux_mode = "ux0_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_loopback_mode = "ux0_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_master_sup_mode = "ux0_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_adapt_mode = "ux0_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_bond_size = "ux0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_master_bond_chnl = "ux0_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_onchip_termination = "ux0_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_term_mode_select = "ux0_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_tuning_hint = "ux0_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_width = "ux0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_standalone_core_clk_mux = "ux0_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sup_mode = "ux0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_bond_size = "ux0_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_master_bond_chnl = "ux0_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_pll = "ux0_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_pll_bw_sel = "ux0_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_pll_refclk_mux_select = "ux0_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_pll_refclk_select = "ux0_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_tuning_hint = "ux0_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_width = "ux0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txrx_channel_operation = "ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txrx_line_encoding_type = "ux0_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_txrx_xcvr_speed_bucket = "ux0_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_refclk_select = "ux1_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_core_pll = "ux1_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_dpma_refclk_source = "ux1_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ethernet_source = "ux1_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_flux_mode = "ux1_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_loopback_mode = "ux1_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_master_sup_mode = "ux1_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_adapt_mode = "ux1_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_bond_size = "ux1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_master_bond_chnl = "ux1_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_onchip_termination = "ux1_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_term_mode_select = "ux1_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_tuning_hint = "ux1_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_width = "ux1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_standalone_core_clk_mux = "ux1_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sup_mode = "ux1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_bond_size = "ux1_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_master_bond_chnl = "ux1_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_pll = "ux1_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_pll_bw_sel = "ux1_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_pll_refclk_mux_select = "ux1_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_pll_refclk_select = "ux1_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_tuning_hint = "ux1_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_width = "ux1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txrx_channel_operation = "ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txrx_line_encoding_type = "ux1_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_txrx_xcvr_speed_bucket = "ux1_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_refclk_select = "ux2_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_core_pll = "ux2_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_dpma_refclk_source = "ux2_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ethernet_source = "ux2_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_loopback_mode = "ux2_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_master_sup_mode = "ux2_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_adapt_mode = "ux2_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_bond_size = "ux2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_master_bond_chnl = "ux2_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_onchip_termination = "ux2_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_term_mode_select = "ux2_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_tuning_hint = "ux2_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_width = "ux2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_standalone_core_clk_mux = "ux2_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sup_mode = "ux2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_bond_size = "ux2_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_master_bond_chnl = "ux2_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_pll = "ux2_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_pll_bw_sel = "ux2_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_pll_refclk_mux_select = "ux2_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_pll_refclk_select = "ux2_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_tuning_hint = "ux2_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_width = "ux2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txrx_channel_operation = "ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txrx_line_encoding_type = "ux2_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_txrx_xcvr_speed_bucket = "ux2_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_clkdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_refclk_select = "ux3_cdr_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_core_pll = "ux3_core_pll_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_dpma_refclk_source = "ux3_dpma_refclk_source_external";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_engineered_link_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_prbs_gen_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_bond_size = "ux3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_master_bond_chnl = "ux3_rx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_term_mode_select = "ux3_rx_term_mode_select_floating";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_width = "ux3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_squelch_detect = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_pam4_graycode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_pam4_precode_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_pll = "ux3_tx_pll_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_pll_bw_sel = "ux3_tx_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_pll_refclk_mux_select = "ux3_tx_pll_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_pll_refclk_select = "ux3_tx_pll_refclk_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_spread_spectrum_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txrx_channel_operation = "ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txrx_line_encoding_type = "ux3_txrx_line_encoding_type_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_txrx_xcvr_speed_bucket = "ux3_txrx_xcvr_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_speed_grade = "ux_speed_grade_dash1";
`ifndef ALTERA_RESERVED_QIS
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "disable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "disable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_bti";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__e400g_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_0__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_10__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_11__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_12__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_13__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_14__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_15__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_16__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_17__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_18__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_19__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "disable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "disable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_bti";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__e400g_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_1__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__internal_clk1_source = "internal_clk1_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__internal_clk2_source = "internal_clk2_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "pwr_down";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "powerdown_ac_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "powerdown_dc_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_20__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__internal_clk1_source = "internal_clk1_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__internal_clk2_source = "internal_clk2_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "pwr_down";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "powerdown_ac_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "powerdown_dc_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_21__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__internal_clk1_source = "internal_clk1_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__internal_clk2_source = "internal_clk2_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "pwr_down";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "powerdown_ac_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "powerdown_dc_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_22__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__internal_clk1_source = "internal_clk1_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__internal_clk2_source = "internal_clk2_xcvr_refclk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "pwr_down";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "powerdown_ac_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "powerdown_dc_avmm2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_23__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "disable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "disable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_bti";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__e400g_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_2__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "disable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "disable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_bti";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__e400g_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_3__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "disable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "disable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_bti";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__e400g_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_4__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "disable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "disable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_bti";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__e400g_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__pma_aib_tx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_low_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_5__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_6__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_7__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_8__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__async_direct_sel0 = "direct_sel0_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__async_direct_sel1 = "direct_sel1_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__async_direct_sel2 = "direct_sel2_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__async_direct_sel3 = "direct_sel3_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_free_run_div_clk = "avmm1_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_read = "avmm1_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_rdfifo_stop_write = "avmm1_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm1_write_resp_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_dcg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_avmm_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_free_run_div_clk = "avmm2_out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_global_usr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_empty = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_full = 56;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_read = "avmm2_rdfifo_n_rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm2_rdfifo_stop_write = "avmm2_rdfifo_n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm_hrdrst_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__avmm_testbus_sel = "avmm1_transfer_testbus";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp0_rsvd = "gp0_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__dfd_mux_gp1_rsvd = "gp1_rsvd";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__hwcfg_adpt_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__hwcfg_aib_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__hwcfg_mode = "block_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__sr_prot_map_mode = "map_sr_prot_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__sr_xcvr_map_mode = "map_sr_xcvr_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_avmm__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__adapter_lpbk_mode = "loopback_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__aib_lpbk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__async_direct_hip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__clock_del_measure_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__datapath_mapping_mode = "map_rx_e400g_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_double_write = "fifo_double_write_en";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_rd_clk_sel = "fifo_rd_e400g_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_width = "fifo_double_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fifo_wr_clk_sel = "fifo_wr_pcie_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fsr_pld_10g_rx_crc32_err_rst_val = "reset_to_zero_crc32";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fsr_pld_8g_sigdet_out_rst_val = "reset_to_zero_sigdet";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltd_b_rst_val = "reset_to_one_ltdb";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fsr_pld_ltr_rst_val = "reset_to_zero_ltr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__fsr_pld_rx_fifo_align_clr_rst_val = "reset_to_zero_alignclr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__hrdrst_rst_sm_dis = "enable_rx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__loopback_mode = "loopback_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__msb_pipeline_byp = "msb_pipe_byp_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__pld_pcs_rx_clk_out_sel = "pld_pcs_rx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__pma_aib_rx_clk_expected_setting = "unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__pma_coreclkin_sel = "pma_coreclkin_pld_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_parity_sel = "func_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pcs_testbus_sel = "direct_tr_tb_bit0_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_pcspma_testbus_sel = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_rmfflag_stretch_num_stages = "rmfflag_two_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rx_usertest_sel = "direct_tr_usertest3_sel";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifo_mode = "rxbypass_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__rxfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_rxchnl__word_mark = "wm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_hip_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_osc_clk_div_sel = "non_div";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_parity_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_reserved_in_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sr_reserved_out_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_sr__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__datapath_mapping_mode = "map_tx_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__duplex_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__dv_gating = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_double_read = "fifo_double_read_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_mode = "bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_rd_clk_sel = "fifo_rd_pcie_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_width = "fifo_single_width";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__free_run_div_clk = "out_of_reset_sync";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit0_rst_val = "reset_to_one_hfsrin0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit1_rst_val = "reset_to_one_hfsrin1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit2_rst_val = "reset_to_one_hfsrin2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_in_bit3_rst_val = "reset_to_zero_hfsrin3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit0_rst_val = "reset_to_one_hfsrout0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit1_rst_val = "reset_to_one_hfsrout1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit2_rst_val = "reset_to_zero_hfsrout2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_hip_fsr_out_bit3_rst_val = "reset_to_zero_hfsrout3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_mask_tx_pll_rst_val = "reset_to_zero_maskpll";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__fsr_pld_txelecidle_rst_val = "reset_to_zero_txelec";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__func_mode = "gdradpt_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hip_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hrdrst_align_bypass = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hrdrst_dcd_cal_done_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hrdrst_dll_lock_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hrdrst_rst_sm_dis = "enable_tx_rst_sm";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__hrdrst_rx_osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__osc_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__pld_pcs_tx_clk_out_sel = "pld_pcs_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__pma_aib_tx_clk_sel = "pma_aib_tx_clk_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__stretch_num_stages = "seven_stage";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_fifo_power_mode = "half_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_fifo_read_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_fifo_write_latency_adjust = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_latency_pls_sel = "latency_pls_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_osc_clock_setting = "osc_clk_div_by1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_rev_lpbk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e200g_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_e400g_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_transfer_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__tx_transfer_div2_clk_pcie_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__txfifo_full = "full_dw";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__txfifo_pfull = 5;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__adapt_txchnl__word_align_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_hssi_rx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_hssi_tx_sr_clk_in_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__aib_hssi_tx_sr_clk_out_hz = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__bti_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__direct_sel0 = "direct_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_aib1_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e200g_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__e400g_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__global_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__internal_clk1_source = "internal_clk1_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__internal_clk2_source = "internal_clk2_dl_return_path";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pcie_pld_2x_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pcie_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pcie_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pcie_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pld_pcs_rx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pld_pcs_tx_clk_out_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__pma_aib_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_ac_avmm1 = "ac_avmm1_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_ac_avmm2 = "ac_avmm2_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_ac_rx_datapath = "ac_rx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_ac_sr = "ac_sr_on";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_ac_tx_datapath = "ac_tx_datapath_fifo_bypass";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_freq_hz_aib_rx_sr_clk_in = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_freq_hz_aib_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_freq_hz_aib_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__gdr_aibadapter__sr_prot_mode = "sr_prot_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr0 = "aib_inctrl0_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_inctrl_gr2 = "aib_inctrl2_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__aib_red_avm1_shiften = "aib_red_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__op_mode = "avmm1_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_ac = "avmm1_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_dc = "avmm1_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__powermode_freq_hz_aib_hssi_avmm1_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_datasel = "aib_datasel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_inctrl = "aib_inctrl_setting4";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outctrl = "aib_outen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__op_mode = "avmm2_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_ac = "avmm2_osc_div1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_dc = "avmm2_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__powermode_freq_hz_aib_hssi_avmm2_clk = 900000000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xavmm2__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr1 = "aib_datasel1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_datasel_gr2 = "aib_datasel2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr0 = "aib_ddr0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_ddrctrl_gr1 = "aib_ddr1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinasyncen = "aib_inasyncen_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_iinclken = "aib_inclken_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outctrl_gr3 = "aib_outen3_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_clkdiv = "aib_rx_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp = "aib_rx_dcc_byp_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_byp_iocsr_unused = "aib_rx_dcc_byp_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal = "aib_rx_dcc_cal_cont";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_cont_cal_iocsr_unused = "aib_rx_dcc_cal_single_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft = "aib_rx_dcc_dft_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dft_sel = "aib_rx_dcc_dft_mode1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dll_entest = "aib_rx_dcc_dll_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctl_static = "aib_rx_dcc_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_dy_ctlsel = "aib_rx_dcc_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en = "aib_rx_dcc_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_en_iocsr_unused = "aib_rx_dcc_disable_iocsr_unused";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_dn = "aib_rx_dcc_manual_dn0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_manual_up = "aib_rx_dcc_manual_up0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_pi_slw = "aib_rx_dcc_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_rst_prgmnvrt = "aib_rx_dcc_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_dn_prgmnvrt = "aib_rx_dcc_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_up_prgmnvrt = "aib_rx_dcc_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_core_updnen = "aib_rx_dcc_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dftmuxsel = "aib_rx_dcc_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_dly_pst = "aib_rx_dcc_st_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_en = "aib_rx_dcc_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_lockreq_muxsel = "aib_rx_dcc_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll = "aib_rx_dcc_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_new_dll2 = "aib_rx_dcc_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_st_rst = "aib_rx_dcc_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_dcc_test_clk_pll_en_n = "aib_rx_dcc_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_halfcode = "aib_rx_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__aib_rx_selflock = "aib_rx_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_ac = "rxdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_dc = "rxdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__powermode_freq_hz_aib_hssi_rx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xrxdatapath_rx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr0 = "aib_datasel0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr1 = "aib_datasel1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_datasel_gr2 = "aib_datasel2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_clkdiv = "aib_dllstr_align_clkdiv_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dcc_dll_dft_sel = "aib_dllstr_align_dcc_dll_dft_sel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dft_ch_muxsel = "aib_dllstr_align_dft_ch_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dly_pst = "aib_dllstr_align_dly_pst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctl_static = "aib_dllstr_align_dy_ctl_static_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_dy_ctlsel = "aib_dllstr_align_dy_ctlsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_entest = "aib_dllstr_align_test_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_halfcode = "aib_dllstr_align_halfcode_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_pi_slw = "aib_dllstr_align_pi_slw_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_selflock = "aib_dllstr_align_selflock_enable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_dn_prgmnvrt = "aib_dllstr_align_st_core_dn_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_up_prgmnvrt = "aib_dllstr_align_st_core_up_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_core_updnen = "aib_dllstr_align_st_core_updnen_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_dftmuxsel = "aib_dllstr_align_st_dftmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_en = "aib_dllstr_align_st_en_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_lockreq_muxsel = "aib_dllstr_align_st_lockreq_muxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll = "aib_dllstr_align_new_dll_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_new_dll2 = "aib_dllstr_align_new_dll2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst = "aib_dllstr_align_st_rst_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_st_rst_prgmnvrt = "aib_dllstr_align_st_rst_prgmnvrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_dllstr_align_test_clk_pll_en_n = "aib_dllstr_align_test_clk_pll_en_n_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr0 = "aib_inctrl0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr1 = "aib_inctrl1_setting3";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr2 = "aib_inctrl2_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_inctrl_gr3 = "aib_inctrl3_setting2";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr0 = "aib_outen0_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr1 = "aib_outen1_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outctrl_gr2 = "aib_outen2_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r12 = "aib_ndrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r34 = "aib_ndrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r56 = "aib_ndrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outndrv_r78 = "aib_ndrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r12 = "aib_pdrv12_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r34 = "aib_pdrv34_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r56 = "aib_pdrv56_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_outpdrv_r78 = "aib_pdrv78_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkn_shiften = "aib_red_dirclkn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dirclkp_shiften = "aib_red_dirclkp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_drx_shiften = "aib_red_drx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_dtx_shiften = "aib_red_dtx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_pinp_shiften = "aib_red_pinp_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_rx_shiften = "aib_red_rx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_tx_shiften = "aib_red_tx_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkout_shiften = "aib_red_txferclkout_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__aib_red_txferclkoutn_shiften = "aib_red_txferclkoutn_shift_disable";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_ac = "txdatapath_high_speed_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_dc = "txdatapath_powerup";
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__powermode_freq_hz_aib_hssi_tx_transfer_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_aibadapt_wrap_9__xgdr_aibchl_top_wrp__xgdr_aibchl_top__xtxdatapath_tx__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_bond_size = "bk0_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_master_bond_chnl = "bk0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_protocol = "bk0_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_swizzle_mode = "lane0_rx_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_termination = "bk0_rxterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_which_lane_to_copy = "bk0_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_width = "bk0_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_rxterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_i_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_master_bond_chnl = "bk0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_rdfifo_master_bond_chnl = "bk0_tx_rdfifo_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_termination = "bk0_txterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_which_lane_to_copy = "bk0_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_width = "bk0_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_tx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txeq_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk0_txterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_bond_size = "bk1_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_master_bond_chnl = "bk1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_protocol = "bk1_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_swizzle_mode = "lane1_rx_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_termination = "bk1_rxterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_which_lane_to_copy = "bk1_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_width = "bk1_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_rxterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_i_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_master_bond_chnl = "bk1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_rdfifo_master_bond_chnl = "bk1_tx_rdfifo_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_termination = "bk1_txterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_which_lane_to_copy = "bk1_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_width = "bk1_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_tx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txeq_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk1_txterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_bond_size = "bk2_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_master_bond_chnl = "bk2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_protocol = "bk2_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_swizzle_mode = "lane2_rx_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_termination = "bk2_rxterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_which_lane_to_copy = "bk2_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_width = "bk2_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_rxterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_i_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_master_bond_chnl = "bk2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_rdfifo_master_bond_chnl = "bk2_tx_rdfifo_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_termination = "bk2_txterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_which_lane_to_copy = "bk2_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_width = "bk2_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_tx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txeq_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk2_txterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_bond_size = "bk3_rx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_line_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_master_bond_chnl = "bk3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_protocol = "bk3_rx_protocol_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_swizzle_mode = "lane3_rx_swizzle_mode_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_termination = "bk3_rxterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_which_lane_to_copy = "bk3_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_width = "bk3_rx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_rxterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_bond_size_sd = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_i_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_line_rate_actual = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_master_bond_chnl = "bk3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_o_clk_e4_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_rdfifo_master_bond_chnl = "bk3_tx_rdfifo_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_termination = "bk3_txterm_offset_p0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_which_lane_to_copy = "bk3_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_width = "bk3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_tx_width_sd = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txeq_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk3_txterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_aonclk_mstclk_sel = "sel_refclka_for_aon";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_lane_mode_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_lane_sel_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_pllrate_sel_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_reg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bitprog_swl_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln0_feature_on = "bk0_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln0_force_on = "bk0_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln1_feature_on = "bk1_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln1_force_on = "bk1_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln2_feature_on = "bk2_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln2_force_on = "bk2_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln3_feature_on = "bk3_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_rclk_ln3_force_on = "bk3_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln0_feature_on = "bk0_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln0_force_on = "bk0_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln1_feature_on = "bk1_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln1_force_on = "bk1_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln2_feature_on = "bk2_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln2_force_on = "bk2_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln3_feature_on = "bk3_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_bticlk_tclk_ln3_force_on = "bk3_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_max_pfd_pll_a_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_max_pfd_pll_b_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_max_ref_pll_a_hz = 200000000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_max_ref_pll_b_hz = 34'h200000000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_max_vco_pll_a_hz = 34'h360447100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_max_vco_pll_b_hz = 34'h360447100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_min_pfd_pll_a_hz = 25000000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_min_pfd_pll_b_hz = 25000000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_min_ref_pll_a_hz = 25000000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_min_ref_pll_b_hz = 25000000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_min_vco_pll_a_hz = 34'h2CB417800;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_min_vco_pll_b_hz = 34'h2CB417800;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_ref_pll_a_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_f_ref_pll_b_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_bypass_refclk = "bk_common_pll_a_bypass_refclk_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_clkouten_cb = "bk_common_pll_a_cfg_clkouten_cb_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_clkouten_lane = "bk_common_pll_a_cfg_clkouten_lane_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_filter_boostfade_fine_en = "bk_common_pll_a_cfg_filter_boostfade_fine_en_enable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_force_kvcc_done = "bk_common_pll_a_cfg_force_kvcc_done_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_kvcc_code_ovrd = "bk_common_pll_a_cfg_kvcc_code_ovrd_enable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_kvcc_code_val = 95;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_kvcc_settle_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_kvcc_vreg_offset_en_ovrd = "bk_common_pll_a_cfg_kvcc_vreg_offset_en_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_kvcccalib_vreg_offset = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_obsmux0_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_obsmux1_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_pcs3334div_en = "bk_common_pll_a_cfg_pcs3334div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_pcs40div_en = "bk_common_pll_a_cfg_pcs40div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_ref156div_rat0p5 = "bk_common_pll_a_cfg_ref156div_rat0p5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_ref156div_ratio = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_refclk100div_en = "bk_common_pll_a_cfg_refclk100div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_refclk156div_en = "bk_common_pll_a_cfg_refclk156div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_refclk_cnt_limit = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_refclk_cycles_per_1us_maxcnt = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_tdcrefclkcnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_cfg_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_fbdiv_strobe_h = "bk_common_pll_a_fbdiv_strobe_h_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_feedfwrdgain = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_fraction_div = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_m_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_pcs3334_ratio = "pll_a_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_tdc_fine_res = "bk_common_pll_a_tdc_fine_res_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_a_tdctargetcnt = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_bypass_refclk = "bk_common_pll_b_bypass_refclk_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_clkouten_cb = "bk_common_pll_b_cfg_clkouten_cb_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_clkouten_lane = "bk_common_pll_b_cfg_clkouten_lane_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_filter_boostfade_fine_en = "bk_common_pll_b_cfg_filter_boostfade_fine_en_enable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_force_kvcc_done = "bk_common_pll_b_cfg_force_kvcc_done_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_kvcc_code_ovrd = "bk_common_pll_b_cfg_kvcc_code_ovrd_enable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_kvcc_code_val = 95;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_kvcc_settle_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_kvcc_vreg_offset_en_ovrd = "bk_common_pll_b_cfg_kvcc_vreg_offset_en_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_kvcccalib_vreg_offset = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_obsmux0_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_obsmux1_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_pcs3334div_en = "bk_common_pll_b_cfg_pcs3334div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_pcs40div_en = "bk_common_pll_b_cfg_pcs40div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_ref156div_rat0p5 = "bk_common_pll_b_cfg_ref156div_rat0p5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_ref156div_ratio = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_refclk100div_en = "bk_common_pll_b_cfg_refclk100div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_refclk156div_en = "bk_common_pll_b_cfg_refclk156div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_refclk_cnt_limit = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_refclk_cycles_per_1us_maxcnt = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_tdcrefclkcnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_cfg_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_fbdiv_strobe_h = "bk_common_pll_b_fbdiv_strobe_h_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_feedfwrdgain = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_fraction_div = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_m_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_pcs3334_ratio = "pll_b_div_33_by_2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_tdc_fine_res = "bk_common_pll_b_tdc_fine_res_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_b_tdctargetcnt = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_freq_a_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_freq_a_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_freq_b_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pll_freq_b_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_plla_cfg_propotional_constant = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_plla_fractional_mode = "bk_common_plla_fractional_mode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pllb_cfg_propotional_constant = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_pllb_fractional_mode = "bk_common_pllb_fractional_mode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_vco_freq_pll_a_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_common_vco_freq_pll_b_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_cpu_lane0_en = "bk_cpu_lane0_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_cpu_lane1_en = "bk_cpu_lane1_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_cpu_lane2_en = "bk_cpu_lane2_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_cpu_lane3_en = "bk_cpu_lane3_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_cpu_runstall_en = "bk_cpu_runstall_en_enable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_ber_clear = "bk_lane0_ber_clear_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_ber_start = "bk_lane0_ber_start_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_ber_stop = "bk_lane0_ber_stop_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_max_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_max_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_max_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_min_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_min_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_min_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_f_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_grey_sum_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_lane_pll_pfd_freq_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_bypass_refclk = "bk_lane0_pll_bypass_refclk_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_clkouten_cb = "bk_lane0_pll_cfg_clkouten_cb_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_clkouten_lane = "bk_lane0_pll_cfg_clkouten_lane_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_filter_boostfade_fine_en = "bk_lane0_pll_cfg_filter_boostfade_fine_en_enable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_fine_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_force_kvcc_done = "bk_lane0_pll_cfg_force_kvcc_done_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_kvcc_code_ovrd = "bk_lane0_pll_cfg_kvcc_code_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_kvcc_code_val = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_kvcc_settle_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_kvcc_vreg_offset_en_ovrd = "bk_lane0_pll_cfg_kvcc_vreg_offset_en_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_kvcc_vreg_offset_en_val = "bk_lane0_pll_cfg_kvcc_vreg_offset_en_val_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_kvcccalib_vreg_offset = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_obsmux0_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_obsmux1_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_pcs3334div_en = "bk_lane0_pll_cfg_pcs3334div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_pcs40div_en = "bk_lane0_pll_cfg_pcs40div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_propotional_constant = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_ref156div_rat0p5 = "bk_lane0_pll_cfg_ref156div_rat0p5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_ref156div_ratio = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_refclk100div_en = "bk_lane0_pll_cfg_refclk100div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_refclk156div_en = "bk_lane0_pll_cfg_refclk156div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_refclk_cnt_limit = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_refclk_cycles_per_1us_maxcnt = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_tdcrefclkcnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_cfg_vregcomp_average_cnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_fbdiv_strobe_h = "bk_lane0_pll_fbdiv_strobe_h_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_feedfwrdgain = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_fraction_div = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_fractional_mode = "bk_lane0_pll_fractional_mode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_m_counter = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_tdc_fine_res = "bk_lane0_pll_tdc_fine_res_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_pll_tdctargetcnt = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_ber_cnt_en = "bk_lane0_rx_ber_cnt_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_rx_prbs_data_sel = "lane0_prbs_data_source0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_bus_take = "bk_lane0_tx_bus_take_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_tx_prbs_init = "bk_lane0_tx_prbs_init_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_vco_freq_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane0_xcvr_lane_mode = "bk_lane0_no_mode";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_ber_clear = "bk_lane1_ber_clear_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_ber_start = "bk_lane1_ber_start_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_ber_stop = "bk_lane1_ber_stop_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_max_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_max_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_max_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_min_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_min_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_min_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_f_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_grey_sum_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_lane_pll_pfd_freq_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_bypass_refclk = "bk_lane1_pll_bypass_refclk_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_clkouten_cb = "bk_lane1_pll_cfg_clkouten_cb_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_clkouten_lane = "bk_lane1_pll_cfg_clkouten_lane_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_filter_boostfade_fine_en = "bk_lane1_pll_cfg_filter_boostfade_fine_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_fine_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_force_kvcc_done = "bk_lane1_pll_cfg_force_kvcc_done_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_kvcc_code_ovrd = "bk_lane1_pll_cfg_kvcc_code_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_kvcc_code_val = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_kvcc_settle_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_kvcc_vreg_offset_en_ovrd = "bk_lane1_pll_cfg_kvcc_vreg_offset_en_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_kvcc_vreg_offset_en_val = "bk_lane1_pll_cfg_kvcc_vreg_offset_en_val_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_kvcccalib_vreg_offset = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_obsmux0_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_obsmux1_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_pcs3334div_en = "bk_lane1_pll_cfg_pcs3334div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_pcs40div_en = "bk_lane1_pll_cfg_pcs40div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_propotional_constant = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_ref156div_rat0p5 = "bk_lane1_pll_cfg_ref156div_rat0p5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_ref156div_ratio = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_refclk100div_en = "bk_lane1_pll_cfg_refclk100div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_refclk156div_en = "bk_lane1_pll_cfg_refclk156div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_refclk_cnt_limit = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_refclk_cycles_per_1us_maxcnt = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_tdcrefclkcnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_cfg_vregcomp_average_cnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_fbdiv_strobe_h = "bk_lane1_pll_fbdiv_strobe_h_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_feedfwrdgain = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_fraction_div = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_fractional_mode = "bk_lane1_pll_fractional_mode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_m_counter = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_tdc_fine_res = "bk_lane1_pll_tdc_fine_res_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_pll_tdctargetcnt = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_ber_cnt_en = "bk_lane1_rx_ber_cnt_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_rx_prbs_data_sel = "lane1_prbs_data_source0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_bus_take = "bk_lane1_tx_bus_take_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_tx_prbs_init = "bk_lane1_tx_prbs_init_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_vco_freq_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane1_xcvr_lane_mode = "bk_lane1_no_mode";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_ber_clear = "bk_lane2_ber_clear_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_ber_start = "bk_lane2_ber_start_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_ber_stop = "bk_lane2_ber_stop_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_max_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_max_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_max_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_min_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_min_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_min_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_f_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_grey_sum_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_lane_pll_pfd_freq_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_bypass_refclk = "bk_lane2_pll_bypass_refclk_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_clkouten_cb = "bk_lane2_pll_cfg_clkouten_cb_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_clkouten_lane = "bk_lane2_pll_cfg_clkouten_lane_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_filter_boostfade_fine_en = "bk_lane2_pll_cfg_filter_boostfade_fine_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_fine_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_force_kvcc_done = "bk_lane2_pll_cfg_force_kvcc_done_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_kvcc_code_ovrd = "bk_lane2_pll_cfg_kvcc_code_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_kvcc_code_val = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_kvcc_settle_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_kvcc_vreg_offset_en_ovrd = "bk_lane2_pll_cfg_kvcc_vreg_offset_en_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_kvcc_vreg_offset_en_val = "bk_lane2_pll_cfg_kvcc_vreg_offset_en_val_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_kvcccalib_vreg_offset = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_obsmux0_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_obsmux1_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_pcs3334div_en = "bk_lane2_pll_cfg_pcs3334div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_pcs40div_en = "bk_lane2_pll_cfg_pcs40div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_propotional_constant = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_ref156div_rat0p5 = "bk_lane2_pll_cfg_ref156div_rat0p5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_ref156div_ratio = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_refclk100div_en = "bk_lane2_pll_cfg_refclk100div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_refclk156div_en = "bk_lane2_pll_cfg_refclk156div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_refclk_cnt_limit = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_refclk_cycles_per_1us_maxcnt = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_tdcrefclkcnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_cfg_vregcomp_average_cnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_fbdiv_strobe_h = "bk_lane2_pll_fbdiv_strobe_h_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_feedfwrdgain = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_fraction_div = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_fractional_mode = "bk_lane2_pll_fractional_mode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_m_counter = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_tdc_fine_res = "bk_lane2_pll_tdc_fine_res_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_pll_tdctargetcnt = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_ber_cnt_en = "bk_lane2_rx_ber_cnt_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_rx_prbs_data_sel = "lane2_prbs_data_source0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_bus_take = "bk_lane2_tx_bus_take_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_tx_prbs_init = "bk_lane2_tx_prbs_init_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_vco_freq_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane2_xcvr_lane_mode = "bk_lane2_no_mode";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_ber_clear = "bk_lane3_ber_clear_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_ber_start = "bk_lane3_ber_start_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_ber_stop = "bk_lane3_ber_stop_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_max_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_max_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_max_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_min_pfd_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_min_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_min_vco_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_f_ref_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_grey_sum_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_lane_pll_pfd_freq_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_bypass_refclk = "bk_lane3_pll_bypass_refclk_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_clkouten_cb = "bk_lane3_pll_cfg_clkouten_cb_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_clkouten_lane = "bk_lane3_pll_cfg_clkouten_lane_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_filter_boostfade_fine_en = "bk_lane3_pll_cfg_filter_boostfade_fine_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_fine_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_force_kvcc_done = "bk_lane3_pll_cfg_force_kvcc_done_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_kvcc_code_ovrd = "bk_lane3_pll_cfg_kvcc_code_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_kvcc_code_val = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_kvcc_settle_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_kvcc_vreg_offset_en_ovrd = "bk_lane3_pll_cfg_kvcc_vreg_offset_en_ovrd_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_kvcc_vreg_offset_en_val = "bk_lane3_pll_cfg_kvcc_vreg_offset_en_val_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_kvcccalib_vreg_offset = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_obsmux0_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_obsmux1_del = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_pcs3334div_en = "bk_lane3_pll_cfg_pcs3334div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_pcs40div_en = "bk_lane3_pll_cfg_pcs40div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_propotional_constant = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_ref156div_rat0p5 = "bk_lane3_pll_cfg_ref156div_rat0p5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_ref156div_ratio = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_refclk100div_en = "bk_lane3_pll_cfg_refclk100div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_refclk156div_en = "bk_lane3_pll_cfg_refclk156div_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_refclk_cnt_limit = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_refclk_cycles_per_1us_maxcnt = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_tdcrefclkcnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_cfg_vregcomp_average_cnt = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_fbdiv_strobe_h = "bk_lane3_pll_fbdiv_strobe_h_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_feedfwrdgain = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_fraction_div = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_fractional_mode = "bk_lane3_pll_fractional_mode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_m_counter = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_tdc_fine_res = "bk_lane3_pll_tdc_fine_res_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_pll_tdctargetcnt = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_ber_cnt_en = "bk_lane3_rx_ber_cnt_en_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_rx_prbs_data_sel = "lane3_prbs_data_source0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_bus_take = "bk_lane3_tx_bus_take_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_tx_prbs_init = "bk_lane3_tx_prbs_init_disable";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_vco_freq_lane_pll_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_lane3_xcvr_lane_mode = "bk_lane3_no_mode";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__bk_tb_reg9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_bkwrap_l0 = "ac_bkwrap_off_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_bkwrap_l1 = "ac_bkwrap_off_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_bkwrap_l2 = "ac_bkwrap_off_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_bkwrap_l3 = "ac_bkwrap_off_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_csr = "ac_xcvr_csr_off";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_serdes_l0 = "ac_serdes_off_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_serdes_l1 = "ac_serdes_off_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_serdes_l2 = "ac_serdes_off_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_serdes_l3 = "ac_serdes_off_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_xtensa_l0 = "ac_xtensa_off_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_xtensa_l1 = "ac_xtensa_off_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_xtensa_l2 = "ac_xtensa_off_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_ac_xtensa_l3 = "ac_xtensa_off_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_bkwrap_l0 = "powerdown_dc_bkwrap_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_bkwrap_l1 = "powerdown_dc_bkwrap_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_bkwrap_l2 = "powerdown_dc_bkwrap_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_bkwrap_l3 = "powerdown_dc_bkwrap_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_csr = "powerdown_dc_xcvr_csr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_dts = "powerdown_dc_dts";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_serdes_l0 = "powerdown_dc_serdes_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_serdes_l1 = "powerdown_dc_serdes_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_serdes_l2 = "powerdown_dc_serdes_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_serdes_l3 = "powerdown_dc_serdes_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_dc_xtensa = "powerdown_dc_xtensa";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l0_par = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l0_ui = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l1_par = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l1_ui = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l2_par = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l2_ui = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l3_par = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_serdes_l3_ui = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__powermode_freq_hz_xtensa = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__rxterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__txterm_sd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_aonclk_mstclk_sel = "sel_refclka_for_aon";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_bdst_rcon_en_ln0 = "bk0_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_bdst_rcon_en_ln1 = "bk1_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_bdst_rcon_en_ln2 = "bk2_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_bdst_rcon_en_ln3 = "bk3_rx_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_ln_swl = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_mute_ln0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_mute_ln1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_mute_ln2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_mute_ln3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_ppmd_rcon_en_ln0 = "bk0_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_ppmd_rcon_en_ln1 = "bk1_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_ppmd_rcon_en_ln2 = "bk2_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_rx_ppmd_rcon_en_ln3 = "bk3_rx_ppmd_badst_rcon_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_barak_tx_ln_swl = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bond_n_ch_l0 = "tx_bond_size_1_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bond_n_ch_l1 = "tx_bond_size_1_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bond_n_ch_l2 = "tx_bond_size_1_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bond_n_ch_l3 = "tx_bond_size_1_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bti_prot_enable = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln0_feature_on = "bk0_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln0_force_on = "bk0_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln1_feature_on = "bk1_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln1_force_on = "bk1_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln2_feature_on = "bk2_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln2_force_on = "bk2_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln3_feature_on = "bk3_bticlk_rclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_rclk_ln3_force_on = "bk3_bticlk_rclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln0_feature_on = "bk0_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln0_force_on = "bk0_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln1_feature_on = "bk1_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln1_force_on = "bk1_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln2_feature_on = "bk2_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln2_force_on = "bk2_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln3_feature_on = "bk3_bticlk_tclk_featur_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_bticlk_tclk_ln3_force_on = "bk3_bticlk_tclk_frc_on";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_dfd_clk = "bk_dfd_clk_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_plla_cmos_refclk_out = "clken_cmos_plla_refclko_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_pllb_cmos_refclk_out = "clken_cmos_pllb_refclko_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_clk_lane0 = "barak_txrx_clken_cfg_clk_en_rx_clk_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_clk_lane1 = "barak_txrx_clken_cfg_clk_en_rx_clk_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_clk_lane2 = "barak_txrx_clken_cfg_clk_en_rx_clk_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_clk_lane3 = "barak_txrx_clken_cfg_clk_en_rx_clk_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk1_lane0 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk1_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk1_lane1 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk1_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk1_lane2 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk1_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk1_lane3 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk1_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk2_lane0 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk2_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk2_lane1 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk2_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk2_lane2 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk2_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_rx_usr_clk2_lane3 = "barak_txrx_clken_cfg_clk_en_rx_usr_clk2_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_sclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_sys_aon_clk = "sys_aon_clk_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clki_lane0 = "barak_txrx_clken_cfg_clk_en_tx_clki_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clki_lane1 = "barak_txrx_clken_cfg_clk_en_tx_clki_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clki_lane2 = "barak_txrx_clken_cfg_clk_en_tx_clki_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clki_lane3 = "barak_txrx_clken_cfg_clk_en_tx_clki_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clko_lane0 = "barak_txrx_clken_cfg_clk_en_tx_clko_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clko_lane1 = "barak_txrx_clken_cfg_clk_en_tx_clko_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clko_lane2 = "barak_txrx_clken_cfg_clk_en_tx_clko_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_clko_lane3 = "barak_txrx_clken_cfg_clk_en_tx_clko_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk1_lane0 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk1_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk1_lane1 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk1_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk1_lane2 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk1_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk1_lane3 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk1_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk2_lane0 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk2_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk2_lane1 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk2_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk2_lane2 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk2_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_clk_en_tx_usr_clk2_lane3 = "barak_txrx_clken_cfg_clk_en_tx_usr_clk2_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_dfd_apb_rdata_sel = "dfd_apb_rdata_28_29";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_dfd_extrig_muxsel = "dfd_etmux_sel_by2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_dfd_muxsel = "dfd_dmux_sel_signature";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_dfd_rsvd_muxsel = "dfd_rsvmux_sel_by2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_pldrst2srds = "dis_pldrst_2_srds";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_rxdat_profile_ln0 = "bk0_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_rxdat_profile_ln1 = "bk1_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_rxdat_profile_ln2 = "bk2_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_rxdat_profile_ln3 = "bk3_rxdat_prof_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_tx_deskew_l0 = "tx_bond_lane0_000";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_tx_deskew_l1 = "tx_bond_lane1_000";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_tx_deskew_l2 = "tx_bond_lane2_000";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_en_tx_deskew_l3 = "tx_bond_lane3_000";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_fuse_valid = "barak_fuse_valid_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane0_rx_user_clk1_sel = "bk0_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane0_rx_user_clk2_sel = "bk0_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane0_tx_user_clk1_sel = "bk0_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane0_tx_user_clk2_sel = "bk0_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane1_rx_user_clk1_sel = "bk1_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane1_rx_user_clk2_sel = "bk1_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane1_tx_user_clk1_sel = "bk1_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane1_tx_user_clk2_sel = "bk1_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane2_rx_user_clk1_sel = "bk2_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane2_rx_user_clk2_sel = "bk2_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane2_tx_user_clk1_sel = "bk2_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane2_tx_user_clk2_sel = "bk2_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane3_rx_user_clk1_sel = "bk3_rx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane3_rx_user_clk2_sel = "bk3_rx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane3_tx_user_clk1_sel = "bk3_tx_usrclk1sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lane3_tx_user_clk2_sel = "bk3_tx_usrclk2sel_div3334";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_latpls_bw_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_latpls_bw_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_latpls_bw_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_latpls_bw_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lnx_txovf_rxbdstb_inten = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_lnx_txudf_pldrstb_inten = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbin_msg_l0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbin_msg_l1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbin_msg_l2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbin_msg_l3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbout_msg_l0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbout_msg_l1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbout_msg_l2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_mbout_msg_l3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_new_msg_l0 = "barak_mbout_no_newmsg_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_new_msg_l1 = "barak_mbout_no_newmsg_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_new_msg_l2 = "barak_mbout_no_newmsg_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_new_msg_l3 = "barak_mbout_no_newmsg_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_nomode_cmd_ch0 = 7423;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_nomode_cmd_ch1 = 7423;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_nomode_cmd_ch2 = 7423;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_nomode_cmd_ch3 = 7423;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_phcomp_rd_delay_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_phcomp_rd_delay_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_phcomp_rd_delay_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_phcomp_rd_delay_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rd_empty_lanex = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_reconverge_cmd_ch0 = 23807;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_reconverge_cmd_ch1 = 23807;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_reconverge_cmd_ch2 = 23807;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_reconverge_cmd_ch3 = 23807;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_restart_seq_sm = "restart_seq_sm_false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rst_dfd_extrig_cntr = "bk_dfd_xtrgcntr_rst_false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rst_dfd_signature_cntr = "bk_dfd_sigcntr_rst_false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rst_rxbit_cntr_lane0 = "bk0_rxbit_cntr_rst_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rst_rxbit_cntr_lane1 = "bk1_rxbit_cntr_rst_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rst_rxbit_cntr_lane2 = "bk2_rxbit_cntr_rst_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rst_rxbit_cntr_lane3 = "bk3_rxbit_cntr_rst_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rstb_dfd_logic = "rst_dfd_logic";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rx_fifo_lat_en_lanex = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rx_lat_bit_for_async_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rx_lat_bit_for_async_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rx_lat_bit_for_async_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rx_lat_bit_for_async_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rx_pipeline_brk_lanex = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_cntr_pma_lane0 = "bk0_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_cntr_pma_lane1 = "bk1_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_cntr_pma_lane2 = "bk2_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_cntr_pma_lane3 = "bk3_rxbit_cntr_pmadir_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_rollover_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_rollover_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_rollover_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxbit_rollover_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_high_ln0 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_high_ln1 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_high_ln2 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_high_ln3 = 550000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_low_ln0 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_low_ln1 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_low_ln2 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_1cnt_thld_low_ln3 = 450000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_bw_ln0 = "bk0_rxd_prof_bw_128";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_bw_ln1 = "bk1_rxd_prof_bw_128";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_bw_ln2 = "bk2_rxd_prof_bw_128";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_rxdat_bw_ln3 = "bk3_rxd_prof_bw_128";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_bti_clk_sel_refclk = "bti_clk_en";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_rxbit_adder_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_rxbit_adder_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_rxbit_adder_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_rxbit_adder_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_tx_user_data_ln0 = "bk0_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_tx_user_data_ln1 = "bk1_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_tx_user_data_ln2 = "bk2_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sel_tx_user_data_ln3 = "bk3_tx_usrdata_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_send_msg_l0 = "barak_mbin_nomsg_2_send_l0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_send_msg_l1 = "barak_mbin_nomsg_2_send_l1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_send_msg_l2 = "barak_mbin_nomsg_2_send_l2";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_send_msg_l3 = "barak_mbin_nomsg_2_send_l3";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq0_addr = 401492;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq0_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq10_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq11_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq12_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq13_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq14_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq15_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq16_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq17_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq18_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq19_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq1_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq20_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq21_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq22_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq23_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq24_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq25_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq26_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq27_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq28_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq29_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq2_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq30_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq31_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq31_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq32_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq32_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq33_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq33_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq34_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq34_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq35_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq35_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq36_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq36_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq37_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq37_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq38_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq38_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq39_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq39_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq3_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq40_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq40_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq41_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq41_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq42_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq43_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq44_rdata_unmask = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq45_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq46_rdata_unmask = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq47_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq48_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq49_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq4_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq50_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq51_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq52_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq53_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq53_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq54_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq54_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq55_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq56_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq57_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq58_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq59_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq59_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq5_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq60_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq60_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq61_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq61_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq62_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq62_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq63_data = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq63_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq6_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq7_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq8_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_seq9_rdata_unmask = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sft_rst_rx_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_sft_rst_tx_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_skip_rdseq_pulse = "skip_read_seq_false";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_spare_reg0_resv = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_spare_reg1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx2rx_bypass_brk_lane0 = "bk0_tx2rx_srds_byp_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx2rx_bypass_brk_lane1 = "bk1_tx2rx_srds_byp_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx2rx_bypass_brk_lane2 = "bk2_tx2rx_srds_byp_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx2rx_bypass_brk_lane3 = "bk3_tx2rx_srds_byp_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_clk_sel2_lane0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_clk_sel2_lane1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_clk_sel2_lane2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_clk_sel2_lane3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_lnx_ovf_inten_dirsignal = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_lnx_rxbadst_inten_dirsignal = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_lnx_udf_inten_dirsignal = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_min_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_pipeline_brk_lanex = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln0_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln0_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln0_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln0_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln1_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln1_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln1_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln1_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln2_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln2_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln2_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln2_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln3_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln3_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln3_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_tx_usr_data_ln3_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_unfreeze_hard_rst = "unfreeze_hardrst_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_unfreeze_rst_rxdl = "unfreeze_rst_rxdl_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__cfg_unfreeze_rst_txdl = "unfreeze_rst_txdl_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_cbplls_refsel_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_cmn_plla_refclk_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_cmn_plla_refclk_sel_ovr = "serdes_shim_common_reg_11_cfg_cmn_plla_ref_clk_sel_ovrd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_cmn_pllb_refclk_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_cmn_pllb_refclk_sel_ovr = "serdes_shim_common_reg_11_cfg_cmn_pllb_ref_clk_sel_ovrd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_enable = "seq0_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq0_rdwrb = "seq0_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq10_enable = "seq10_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq10_ln3_pll_refclk_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq10_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq10_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq10_rdwrb = "seq10_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_enable = "seq11_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_ln0_rx_gry_lut = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_ln0_rx_inv = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_ln0_rx_pre = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_ln0_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_ln0_tx2rx_lpbk_en = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq11_rdwrb = "seq11_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_enable = "seq12_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_ln1_rx_gry_lut = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_ln1_rx_inv = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_ln1_rx_pre = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_ln1_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_ln1_tx2rx_lpbk_en = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq12_rdwrb = "seq12_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_enable = "seq13_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_ln2_rx_gry_lut = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_ln2_rx_inv = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_ln2_rx_pre = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_ln2_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_ln2_tx2rx_lpbk_en = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq13_rdwrb = "seq13_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_enable = "seq14_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_ln3_rx_gry_lut = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_ln3_rx_inv = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_ln3_rx_pre = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_ln3_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_ln3_tx2rx_lpbk_en = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq14_rdwrb = "seq14_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_enable = "seq15_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_rdwrb = "seq15_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_tx_ln0_ffe_coeff_p2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_tx_ln0_ffe_coeff_p3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_tx_ln0_ffe_coeff_p4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq15_tx_ln0_ffe_coeff_p5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq16_enable = "seq16_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq16_rdwrb = "seq16_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq16_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq16_tx_ln0_ffe_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_enable = "seq17_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_rdwrb = "seq17_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_coeff_load = "serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_mode32ui = "serdes_lane_ana_tx_lane0_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq17_tx_ln0_ffe_output_swizzle = "serdes_lane_ana_tx_lane0_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_enable = "seq18_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_rdwrb = "seq18_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_tx_ln1_ffe_coeff_p2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_tx_ln1_ffe_coeff_p3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_tx_ln1_ffe_coeff_p4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq18_tx_ln1_ffe_coeff_p5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq19_enable = "seq19_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq19_rdwrb = "seq19_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq19_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq19_tx_ln1_ffe_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq1_cmn_plla_fbdiv_frac = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq1_cmn_plla_fbdiv_fracen = "serdes_shim_ana_pll_pll_a_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq1_cmn_plla_fbdiv_intgr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq1_enable = "seq1_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq1_rdwrb = "seq1_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_enable = "seq20_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_rdwrb = "seq20_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_coeff_load = "serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_mode32ui = "serdes_lane_ana_tx_lane1_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq20_tx_ln1_ffe_output_swizzle = "serdes_lane_ana_tx_lane1_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_enable = "seq21_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_rdwrb = "seq21_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_tx_ln2_ffe_coeff_p2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_tx_ln2_ffe_coeff_p3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_tx_ln2_ffe_coeff_p4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq21_tx_ln2_ffe_coeff_p5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq22_enable = "seq22_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq22_rdwrb = "seq22_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq22_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq22_tx_ln2_ffe_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_enable = "seq23_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_rdwrb = "seq23_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_coeff_load = "serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_mode32ui = "serdes_lane_ana_tx_lane2_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq23_tx_ln2_ffe_output_swizzle = "serdes_lane_ana_tx_lane2_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_enable = "seq24_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_rdwrb = "seq24_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_tx_ln3_ffe_coeff_p2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_tx_ln3_ffe_coeff_p3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_tx_ln3_ffe_coeff_p4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq24_tx_ln3_ffe_coeff_p5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq25_enable = "seq25_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq25_rdwrb = "seq25_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq25_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq25_tx_ln3_ffe_cmod = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_enable = "seq26_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_rdwrb = "seq26_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_coeff_load = "serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_mode32ui = "serdes_lane_ana_tx_lane3_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq26_tx_ln3_ffe_output_swizzle = "serdes_lane_ana_tx_lane3_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_enable = "seq27_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_rdwrb = "seq27_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_coeff_load = "dyn_serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_mode32ui = "dyn_serdes_lane_ana_tx_lane0_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq27_tx_ln0_ffe_output_swizzle = "dyn_serdes_lane_ana_tx_lane0_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_enable = "seq28_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_rdwrb = "seq28_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_coeff_load = "dyn_serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_mode32ui = "dyn_serdes_lane_ana_tx_lane1_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq28_tx_ln1_ffe_output_swizzle = "dyn_serdes_lane_ana_tx_lane1_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_enable = "seq29_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_rdwrb = "seq29_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_coeff_load = "dyn_serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_mode32ui = "dyn_serdes_lane_ana_tx_lane2_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq29_tx_ln2_ffe_output_swizzle = "dyn_serdes_lane_ana_tx_lane2_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq2_cmn_pllb_fbdiv_frac = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq2_cmn_pllb_fbdiv_fracen = "serdes_shim_ana_pll_pll_b_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq2_cmn_pllb_fbdiv_intgr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq2_enable = "seq2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq2_rdwrb = "seq2_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_enable = "seq30_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_rdwrb = "seq30_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_coeff_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_coeff_load = "dyn_serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_coeff_m1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_coeff_m2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_coeff_p1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_mode32ui = "dyn_serdes_lane_ana_tx_lane3_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq30_tx_ln3_ffe_output_swizzle = "dyn_serdes_lane_ana_tx_lane3_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq31_enable = "seq31_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq31_rdwrb = "seq31_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq32_enable = "seq32_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq32_rdwrb = "seq32_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq33_enable = "seq33_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq33_rdwrb = "seq33_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq34_enable = "seq34_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq34_rdwrb = "seq34_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq35_enable = "seq35_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq35_rdwrb = "seq35_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq36_enable = "seq36_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq36_rdwrb = "seq36_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq37_enable = "seq37_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq37_rdwrb = "seq37_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq38_enable = "seq38_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq38_rdwrb = "seq38_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq39_enable = "seq39_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq39_rdwrb = "seq39_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq3_enable = "seq3_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq3_ln0_pll_fbdiv_frac = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq3_ln0_pll_fbdiv_fracen = "serdes_lane_ana_pll_lane0_reg_1_o_fracnen_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq3_ln0_pll_fbdiv_intgr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq3_rdwrb = "seq3_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq40_enable = "seq40_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq40_rdwrb = "seq40_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq41_enable = "seq41_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq41_rdwrb = "seq41_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq42_cbplla_en = "serdes_shim_common_reg_13_icom_plla_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq42_cbplla_rstb = "serdes_shim_common_reg_13_icom_plla_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq42_enable = "seq42_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq42_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq42_rdwrb = "seq42_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq43_cbpllb_en = "serdes_shim_common_reg_14_icom_pllb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq43_cbpllb_rstb = "serdes_shim_common_reg_14_icom_pllb_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq43_enable = "seq43_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq43_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq43_rdwrb = "seq43_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq44_cbplls_status = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq44_enable = "seq44_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq44_rdwrb = "seq44_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq45_enable = "seq45_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq45_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq45_rdwrb = "seq45_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq45_runstall = "serdes_shim_wrap_car_reg_12_cfg_run_stall_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq46_bkrdy_status = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq46_enable = "seq46_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq46_rdwrb = "seq46_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq47_enable = "seq47_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq47_lnx_fktfl_en = "lnx_fktfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq47_lnx_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq47_lnx_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq47_lnx_tfl_en = "lnx_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq47_rdwrb = "seq47_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq48_enable = "seq48_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq48_lnxp1_fktfl_en = "lnxp1_fktfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq48_lnxp1_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq48_lnxp1_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq48_lnxp1_tfl_en = "lnxp1_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq48_rdwrb = "seq48_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq49_enable = "seq49_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq49_lnxp2_fktfl_en = "lnxp2_fktfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq49_lnxp2_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq49_lnxp2_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq49_lnxp2_tfl_en = "lnxp2_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq49_rdwrb = "seq49_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq4_enable = "seq4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq4_ln1_pll_fbdiv_frac = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq4_ln1_pll_fbdiv_fracen = "serdes_lane_ana_pll_lane1_reg_1_o_fracnen_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq4_ln1_pll_fbdiv_intgr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq4_rdwrb = "seq4_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq50_enable = "seq50_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq50_lnxp3_fktfl_en = "lnxp3_fktfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq50_lnxp3_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq50_lnxp3_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq50_lnxp3_tfl_en = "lnxp3_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq50_rdwrb = "seq50_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq51_enable = "seq51_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq51_lnxp4_fktfl_en = "lnxp4_fktfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq51_lnxp4_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq51_lnxp4_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq51_lnxp4_tfl_en = "lnxp4_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq51_rdwrb = "seq51_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq52_enable = "seq52_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq52_lnxp5_fktfl_en = "lnxp5_fktfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq52_lnxp5_mode = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq52_lnxp5_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq52_lnxp5_tfl_en = "lnxp5_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq52_rdwrb = "seq52_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq53_enable = "seq53_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq53_rdwrb = "seq53_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq54_enable = "seq54_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq54_rdwrb = "seq54_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_enable = "seq55_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_ln0_rx2tx_lpbk_en = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_ln0_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_ln0_tx_bus_take_dft = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_ln0_tx_gry_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_ln0_tx_inv = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_ln0_tx_pre = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_lsb_static_field = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq55_rdwrb = "seq55_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_enable = "seq56_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_ln1_rx2tx_lpbk_en = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_ln1_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_ln1_tx_bus_take_dft = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_ln1_tx_gry_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_ln1_tx_inv = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_ln1_tx_pre = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_lsb_static_field = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq56_rdwrb = "seq56_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_enable = "seq57_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_ln2_rx2tx_lpbk_en = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_ln2_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_ln2_tx_bus_take_dft = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_ln2_tx_gry_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_ln2_tx_inv = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_ln2_tx_pre = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_lsb_static_field = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq57_rdwrb = "seq57_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_enable = "seq58_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_ln3_rx2tx_lpbk_en = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_ln3_swl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_ln3_tx_bus_take_dft = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_ln3_tx_gry_lut = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_ln3_tx_inv = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_ln3_tx_pre = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_lsb_static_field = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq58_rdwrb = "seq58_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq59_enable = "seq59_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq59_rdwrb = "seq59_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq5_enable = "seq5_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq5_ln2_pll_fbdiv_frac = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq5_ln2_pll_fbdiv_fracen = "serdes_lane_ana_pll_lane2_reg_1_o_fracnen_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq5_ln2_pll_fbdiv_intgr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq5_rdwrb = "seq5_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq60_enable = "seq60_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq60_rdwrb = "seq60_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq61_enable = "seq61_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq61_rdwrb = "seq61_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq62_enable = "seq62_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq62_rdwrb = "seq62_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq63_enable = "seq63_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq63_rdwrb = "seq63_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq6_enable = "seq6_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq6_ln3_pll_fbdiv_frac = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq6_ln3_pll_fbdiv_fracen = "serdes_lane_ana_pll_lane3_reg_1_o_fracnen_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq6_ln3_pll_fbdiv_intgr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq6_rdwrb = "seq6_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq7_enable = "seq7_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq7_ln0_pll_refclk_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq7_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq7_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq7_rdwrb = "seq7_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq8_enable = "seq8_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq8_ln1_pll_refclk_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq8_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq8_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq8_rdwrb = "seq8_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq9_enable = "seq9_dis";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq9_ln2_pll_refclk_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq9_lsb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq9_msb_static_field = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_gdr_barak_quad_cfg_ctrl__u_gdr_barak_quad_avmm_cfgcsr__seq9_rdwrb = "seq9_wr";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_10_oct2sar2_sar18_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_10_oct2sar2_sar18_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_10_oct2sar3_sar26_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_10_oct2sar3_sar26_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_11_oct2sar4_sar34_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_11_oct2sar4_sar34_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_11_oct2sar5_sar42_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_11_oct2sar5_sar42_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_12_oct2sar6_sar50_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_12_oct2sar6_sar50_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_12_oct2sar7_sar58_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_12_oct2sar7_sar58_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_13_oct3sar0_sar3_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_13_oct3sar0_sar3_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_13_oct3sar1_sar11_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_13_oct3sar1_sar11_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_14_oct3sar2_sar19_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_14_oct3sar2_sar19_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_14_oct3sar3_sar27_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_14_oct3sar3_sar27_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_15_oct3sar4_sar35_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_15_oct3sar4_sar35_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_15_oct3sar5_sar43_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_15_oct3sar5_sar43_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_16_oct3sar6_sar51_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_16_oct3sar6_sar51_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_16_oct3sar7_sar59_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_16_oct3sar7_sar59_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_17_oct4sar0_sar4_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_17_oct4sar0_sar4_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_17_oct4sar1_sar12_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_17_oct4sar1_sar12_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_18_oct4sar2_sar20_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_18_oct4sar2_sar20_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_18_oct4sar3_sar28_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_18_oct4sar3_sar28_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_19_oct4sar4_sar36_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_19_oct4sar4_sar36_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_19_oct4sar5_sar44_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_19_oct4sar5_sar44_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_1_oct0sar0_sar0_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_1_oct0sar0_sar0_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_1_oct0sar1_sar8_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_1_oct0sar1_sar8_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_20_oct4sar6_sar52_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_20_oct4sar6_sar52_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_20_oct4sar7_sar60_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_20_oct4sar7_sar60_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_21_oct5sar0_sar5_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_21_oct5sar0_sar5_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_21_oct5sar1_sar13_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_21_oct5sar1_sar13_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_22_oct5sar2_sar21_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_22_oct5sar2_sar21_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_22_oct5sar3_sar29_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_22_oct5sar3_sar29_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_23_oct5sar4_sar37_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_23_oct5sar4_sar37_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_23_oct5sar5_sar45_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_23_oct5sar5_sar45_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_24_oct5sar6_sar53_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_24_oct5sar6_sar53_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_24_oct5sar7_sar61_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_24_oct5sar7_sar61_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_25_oct6sar0_sar6_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_25_oct6sar0_sar6_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_25_oct6sar1_sar14_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_25_oct6sar1_sar14_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_26_oct6sar2_sar22_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_26_oct6sar2_sar22_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_26_oct6sar3_sar30_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_26_oct6sar3_sar30_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_27_oct6sar4_sar38_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_27_oct6sar4_sar38_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_27_oct6sar5_sar46_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_27_oct6sar5_sar46_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_28_oct6sar6_sar54_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_28_oct6sar6_sar54_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_28_oct6sar7_sar62_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_28_oct6sar7_sar62_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_29_oct7sar0_sar7_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_29_oct7sar0_sar7_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_29_oct7sar1_sar15_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_29_oct7sar1_sar15_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_2_oct0sar2_sar16_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_2_oct0sar2_sar16_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_2_oct0sar3_sar24_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_2_oct0sar3_sar24_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_30_oct7sar2_sar23_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_30_oct7sar2_sar23_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_30_oct7sar3_sar31_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_30_oct7sar3_sar31_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_31_oct7sar4_sar39_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_31_oct7sar4_sar39_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_31_oct7sar5_sar47_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_31_oct7sar5_sar47_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_32_oct7sar6_sar55_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_32_oct7sar6_sar55_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_32_oct7sar7_sar63_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_32_oct7sar7_sar63_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar2_sar16_en_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar2_sar16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar2_sar16_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar2_sar16_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar2_sar16_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar3_sar24_en_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar3_sar24_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar3_sar24_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar3_sar24_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar3_sar24_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar4_sar32_en_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar4_sar32_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar4_sar32_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar4_sar32_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar4_sar32_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar5_sar40_en_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar5_sar40_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar5_sar40_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_33_oct0sar5_sar40_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_33_oct0sar5_sar40_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar0_sar0_en_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar0_sar0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar0_sar0_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar0_sar0_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar0_sar0_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar1_sar8_en_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar1_sar8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar1_sar8_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar1_sar8_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar1_sar8_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar6_sar48_en_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar6_sar48_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar6_sar48_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar6_sar48_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar6_sar48_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar7_sar56_en_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar7_sar56_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar7_sar56_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_34_oct0sar7_sar56_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_34_oct0sar7_sar56_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_glb_div33_en_fw_attr = "serdes_lane_ana_adc_lane0_reg_35_glb_div33_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar2_sar17_en_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar2_sar17_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar2_sar17_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar2_sar17_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar2_sar17_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar3_sar25_en_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar3_sar25_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar3_sar25_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar3_sar25_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar3_sar25_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar4_sar33_en_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar4_sar33_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar4_sar33_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar4_sar33_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar4_sar33_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar5_sar41_en_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar5_sar41_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar5_sar41_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_35_oct1sar5_sar41_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_35_oct1sar5_sar41_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar0_sar1_en_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar0_sar1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar0_sar1_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar0_sar1_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar0_sar1_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar1_sar9_en_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar1_sar9_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar1_sar9_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar1_sar9_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar1_sar9_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar6_sar49_en_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar6_sar49_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar6_sar49_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar6_sar49_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar6_sar49_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar7_sar57_en_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar7_sar57_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar7_sar57_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_36_oct1sar7_sar57_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_36_oct1sar7_sar57_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar2_sar18_en_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar2_sar18_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar2_sar18_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar2_sar18_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar2_sar18_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar3_sar26_en_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar3_sar26_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar3_sar26_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar3_sar26_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar3_sar26_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar4_sar34_en_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar4_sar34_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar4_sar34_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar4_sar34_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar4_sar34_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar5_sar42_en_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar5_sar42_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar5_sar42_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_37_oct2sar5_sar42_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_37_oct2sar5_sar42_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar0_sar2_en_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar0_sar2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar0_sar2_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar0_sar2_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar0_sar2_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar1_sar10_en_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar1_sar10_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar1_sar10_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar1_sar10_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar1_sar10_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar6_sar50_en_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar6_sar50_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar6_sar50_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar6_sar50_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar6_sar50_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar7_sar58_en_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar7_sar58_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar7_sar58_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_38_oct2sar7_sar58_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_38_oct2sar7_sar58_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar2_sar19_en_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar2_sar19_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar2_sar19_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar2_sar19_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar2_sar19_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar3_sar27_en_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar3_sar27_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar3_sar27_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar3_sar27_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar3_sar27_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar4_sar35_en_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar4_sar35_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar4_sar35_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar4_sar35_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar4_sar35_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar5_sar43_en_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar5_sar43_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar5_sar43_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_39_oct3sar5_sar43_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_39_oct3sar5_sar43_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_3_oct0sar4_sar32_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_3_oct0sar4_sar32_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_3_oct0sar5_sar40_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_3_oct0sar5_sar40_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar0_sar3_en_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar0_sar3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar0_sar3_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar0_sar3_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar0_sar3_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar1_sar11_en_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar1_sar11_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar1_sar11_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar1_sar11_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar1_sar11_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar6_sar51_en_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar6_sar51_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar6_sar51_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar6_sar51_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar6_sar51_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar7_sar59_en_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar7_sar59_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar7_sar59_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_40_oct3sar7_sar59_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_40_oct3sar7_sar59_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar2_sar20_en_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar2_sar20_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar2_sar20_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar2_sar20_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar2_sar20_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar3_sar28_en_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar3_sar28_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar3_sar28_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar3_sar28_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar3_sar28_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar4_sar36_en_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar4_sar36_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar4_sar36_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar4_sar36_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar4_sar36_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar5_sar44_en_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar5_sar44_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar5_sar44_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_41_oct4sar5_sar44_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_41_oct4sar5_sar44_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar0_sar4_en_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar0_sar4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar0_sar4_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar0_sar4_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar0_sar4_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar1_sar12_en_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar1_sar12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar1_sar12_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar1_sar12_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar1_sar12_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar6_sar52_en_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar6_sar52_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar6_sar52_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar6_sar52_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar6_sar52_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar7_sar60_en_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar7_sar60_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar7_sar60_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_42_oct4sar7_sar60_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_42_oct4sar7_sar60_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar2_sar21_en_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar2_sar21_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar2_sar21_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar2_sar21_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar2_sar21_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar3_sar29_en_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar3_sar29_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar3_sar29_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar3_sar29_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar3_sar29_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar4_sar37_en_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar4_sar37_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar4_sar37_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar4_sar37_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar4_sar37_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar5_sar45_en_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar5_sar45_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar5_sar45_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_43_oct5sar5_sar45_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_43_oct5sar5_sar45_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_glb_div10_en_fw_attr = "serdes_lane_ana_adc_lane0_reg_44_glb_div10_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_glb_div33_frac0p25_fw_attr = "serdes_lane_ana_adc_lane0_reg_44_glb_div33_frac0p25_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_glb_div33_frac0p5_fw_attr = "serdes_lane_ana_adc_lane0_reg_44_glb_div33_frac0p5_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_glb_div33_ratio_fw_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar0_sar5_en_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar0_sar5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar0_sar5_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar0_sar5_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar0_sar5_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar1_sar13_en_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar1_sar13_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar1_sar13_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar1_sar13_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar1_sar13_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar6_sar53_en_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar6_sar53_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar6_sar53_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar6_sar53_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar6_sar53_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar7_sar61_en_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar7_sar61_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar7_sar61_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_44_oct5sar7_sar61_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_44_oct5sar7_sar61_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar2_sar22_en_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar2_sar22_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar2_sar22_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar2_sar22_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar2_sar22_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar3_sar30_en_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar3_sar30_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar3_sar30_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar3_sar30_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar3_sar30_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar4_sar38_en_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar4_sar38_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar4_sar38_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar4_sar38_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar4_sar38_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar5_sar46_en_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar5_sar46_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar5_sar46_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_45_oct6sar5_sar46_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_45_oct6sar5_sar46_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar0_sar6_en_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar0_sar6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar0_sar6_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar0_sar6_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar0_sar6_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar1_sar14_en_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar1_sar14_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar1_sar14_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar1_sar14_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar1_sar14_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar6_sar54_en_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar6_sar54_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar6_sar54_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar6_sar54_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar6_sar54_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar7_sar62_en_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar7_sar62_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar7_sar62_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_46_oct6sar7_sar62_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_46_oct6sar7_sar62_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar2_sar23_en_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar2_sar23_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar2_sar23_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar2_sar23_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar2_sar23_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar3_sar31_en_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar3_sar31_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar3_sar31_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar3_sar31_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar3_sar31_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar4_sar39_en_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar4_sar39_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar4_sar39_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar4_sar39_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar4_sar39_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar5_sar47_en_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar5_sar47_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar5_sar47_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_47_oct7sar5_sar47_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_47_oct7sar5_sar47_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar0_sar7_en_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar0_sar7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar0_sar7_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar0_sar7_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar0_sar7_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar1_sar15_en_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar1_sar15_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar1_sar15_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar1_sar15_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar1_sar15_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar6_sar55_en_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar6_sar55_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar6_sar55_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar6_sar55_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar6_sar55_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar7_sar63_en_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar7_sar63_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar7_sar63_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_48_oct7sar7_sar63_shrg_init_val_attr = "serdes_lane_ana_adc_lane0_reg_48_oct7sar7_sar63_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_dac_clear_dis_attr = "serdes_lane_ana_adc_lane0_reg_49_dac_clear_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_dac_clear_force_dfx_attr = "serdes_lane_ana_adc_lane0_reg_49_dac_clear_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_dac_reset_force_dfx_attr = "serdes_lane_ana_adc_lane0_reg_49_dac_reset_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_i_sar_finish_disable_fw_attr = "serdes_lane_ana_adc_lane0_reg_49_i_sar_finish_disable_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_osc_speed_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_refgen_cm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_refgen_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_rstb_attr = "serdes_lane_ana_adc_lane0_reg_49_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_sar_array_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_th2_bypass_attr = "serdes_lane_ana_adc_lane0_reg_49_th2_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_49_th_boost_select_attr = "serdes_lane_ana_adc_lane0_reg_49_th_boost_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_4_oct0sar6_sar48_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_4_oct0sar6_sar48_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_4_oct0sar7_sar56_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_4_oct0sar7_sar56_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_50_shrg_align_clk2cdrrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_50_shrg_align_clk2lgcrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_50_shrg_align_clkrst_val_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_51_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_51_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_51_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_51_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_51_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_o_en_attr = "serdes_lane_ana_adc_lane0_reg_51_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_51_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_52_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_52_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_52_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_52_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_52_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_o_en_attr = "serdes_lane_ana_adc_lane0_reg_52_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_52_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_53_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_53_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_53_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_53_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_53_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_o_en_attr = "serdes_lane_ana_adc_lane0_reg_53_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_53_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_54_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_54_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_54_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_54_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_54_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_o_en_attr = "serdes_lane_ana_adc_lane0_reg_54_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_54_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_55_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_55_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_55_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_55_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_55_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_o_en_attr = "serdes_lane_ana_adc_lane0_reg_55_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_55_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_56_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_56_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_56_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_56_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_56_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_o_en_attr = "serdes_lane_ana_adc_lane0_reg_56_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_56_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_57_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_57_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_57_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_57_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_57_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_o_en_attr = "serdes_lane_ana_adc_lane0_reg_57_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_57_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_current_base_dis_attr = "serdes_lane_ana_adc_lane0_reg_58_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane0_reg_58_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane0_reg_58_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane0_reg_58_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane0_reg_58_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_o_en_attr = "serdes_lane_ana_adc_lane0_reg_58_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_58_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_i_psf_cur_trim_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_i_psf_cur_trim_spare_attr = "serdes_lane_ana_adc_lane0_reg_59_i_psf_cur_trim_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_bias_current_mon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_bias_current_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_cm_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_dcmon_spare1_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_dcmon_spare1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_dcmon_spare2_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_dcmon_spare2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_dcmon_spare3_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_dcmon_spare3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_dfx_int_out_mon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_dfx_int_out_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_integrator_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_integrator_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_pbias_cas_mon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_pbias_cas_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_psf_vref_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_psf_vref_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th0_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th0_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th1_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th1_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th2_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th2_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th3_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th3_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th4_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th4_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th5_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th5_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th6_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th6_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th7_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_59_th7_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_59_th_sw_bypass_attr = "serdes_lane_ana_adc_lane0_reg_59_th_sw_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_5_oct1sar0_sar1_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_5_oct1sar0_sar1_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_5_oct1sar1_sar9_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_5_oct1sar1_sar9_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th0_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th1_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th2_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th3_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th4_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th5_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th6_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_60_th7_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th0_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th1_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th2_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th3_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th4_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th5_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th6_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_61_th7_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_dfx_en_mon_attr = "serdes_lane_ana_adc_lane0_reg_62_dfx_en_mon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_dfx_en_slc_attr = "serdes_lane_ana_adc_lane0_reg_62_dfx_en_slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th0_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th1_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th2_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th3_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th4_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th5_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th6_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th7_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_62_th_bias_en_attr = "serdes_lane_ana_adc_lane0_reg_62_th_bias_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_63_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_63_sar_dfx_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_64_ch4_pi_code_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_64_ch5_pi_code_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_64_ch6_pi_code_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_64_ch7_pi_code_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_65_ch0_pi_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_65_ch1_pi_code_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_65_ch2_pi_code_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_65_ch3_pi_code_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_c2c_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch0_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch0_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch0_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch0_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch1_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch1_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch1_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch1_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch2_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch2_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch2_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch2_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch3_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch3_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch3_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch3_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch4_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch4_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch4_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch4_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch5_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch5_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch5_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch5_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch6_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch6_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch6_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch6_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch7_pi_en_attr = "serdes_lane_ana_adc_lane0_reg_66_ch7_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_66_ch7_pi_transp_in_attr = "serdes_lane_ana_adc_lane0_reg_66_ch7_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_67_dispolarity_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_67_i_clkmux_ungate_req_reg_attr = "serdes_lane_ana_adc_lane0_reg_67_i_clkmux_ungate_req_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_67_i_clkmux_ungate_rst_reg_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_67_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_67_td_degen_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_clk2td_ch_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_pdo_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_68_pdo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_spare_attr = "serdes_lane_ana_adc_lane0_reg_68_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_td_en_pd_attr = "serdes_lane_ana_adc_lane0_reg_68_td_en_pd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_td_i_ctrl_2ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_td_i_ctrl_4ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_td_i_sel_count_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_68_td_rstb_attr = "serdes_lane_ana_adc_lane0_reg_68_td_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_dcmon_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_input_cs_trimming_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_nc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_nsf_enable_attr = "serdes_lane_ana_adc_lane0_reg_69_nsf_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_nsf_even_en_attr = "serdes_lane_ana_adc_lane0_reg_69_nsf_even_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_69_nsf_odd_en_attr = "serdes_lane_ana_adc_lane0_reg_69_nsf_odd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_6_oct1sar2_sar17_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_6_oct1sar2_sar17_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_6_oct1sar3_sar25_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_6_oct1sar3_sar25_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_70_i_clkmux_hsmonsel_local_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_70_i_clkmux_hsmonsel_next_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_70_i_clkmux_hsmonseln_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_70_i_clkmux_hsmonselp_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_70_ph_out_seln_attr = "serdes_lane_ana_adc_lane0_reg_70_ph_out_seln_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_clk_gen_dcmon_n_en_attr = "serdes_lane_ana_adc_lane0_reg_71_clk_gen_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_clk_gen_dcmon_p_en_attr = "serdes_lane_ana_adc_lane0_reg_71_clk_gen_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_comp_n_en_attr = "serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_comp_p_en_attr = "serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_dcmon_n_en_attr = "serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_dcmon_p_en_attr = "serdes_lane_ana_adc_lane0_reg_71_clkgen_and_sar_l_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_i_sararray_vref_n_attr = "serdes_lane_ana_adc_lane0_reg_71_i_sararray_vref_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_i_sararray_vref_p_attr = "serdes_lane_ana_adc_lane0_reg_71_i_sararray_vref_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_comp_n_en_attr = "serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_comp_p_en_attr = "serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_dcmon_n_en_attr = "serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_dcmon_p_en_attr = "serdes_lane_ana_adc_lane0_reg_71_nsf_th_clkmux_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_oct3_dfx_en_l_attr = "serdes_lane_ana_adc_lane0_reg_71_oct3_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_oct3_dfx_en_r_attr = "serdes_lane_ana_adc_lane0_reg_71_oct3_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_oct7_dfx_en_l_attr = "serdes_lane_ana_adc_lane0_reg_71_oct7_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_oct7_dfx_en_r_attr = "serdes_lane_ana_adc_lane0_reg_71_oct7_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_71_spare_dfx_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_72_dcmon2slc_attr = "serdes_lane_ana_adc_lane0_reg_72_dcmon2slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_72_dcmon_en_attr = "serdes_lane_ana_adc_lane0_reg_72_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_72_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_72_ph_out_selp_attr = "serdes_lane_ana_adc_lane0_reg_72_ph_out_selp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_72_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_clkgen_comp_en_attr = "serdes_lane_ana_adc_lane0_reg_73_clkgen_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct0_dfx_en_l_attr = "serdes_lane_ana_adc_lane0_reg_73_oct0_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct0_dfx_en_r_attr = "serdes_lane_ana_adc_lane0_reg_73_oct0_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct2_dfx_en_l_attr = "serdes_lane_ana_adc_lane0_reg_73_oct2_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct2_dfx_en_r_attr = "serdes_lane_ana_adc_lane0_reg_73_oct2_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct4_dfx_en_l_attr = "serdes_lane_ana_adc_lane0_reg_73_oct4_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct4_dfx_en_r_attr = "serdes_lane_ana_adc_lane0_reg_73_oct4_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_oct6_dfx_en_l_attr = "serdes_lane_ana_adc_lane0_reg_73_oct6_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_sar_r_comp_n_en_attr = "serdes_lane_ana_adc_lane0_reg_73_sar_r_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_sar_r_comp_p_en_attr = "serdes_lane_ana_adc_lane0_reg_73_sar_r_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_sar_r_dcmon_n_en_attr = "serdes_lane_ana_adc_lane0_reg_73_sar_r_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_sar_r_dcmon_p_en_attr = "serdes_lane_ana_adc_lane0_reg_73_sar_r_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_73_spare_dfx_right_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_74_fall_sel3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_74_fall_sel5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_74_fall_sel7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_74_spare1_reg13_attr = "serdes_lane_ana_adc_lane0_reg_74_spare1_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_74_spare2_reg13_attr = "serdes_lane_ana_adc_lane0_reg_74_spare2_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_74_spare3_reg13_attr = "serdes_lane_ana_adc_lane0_reg_74_spare3_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_75_rise_sel0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_75_rise_sel1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_75_rise_sel2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_75_rise_sel3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_76_spare_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_77_dfx_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_77_spare1_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_77_spare2_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_78_dfx_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_78_spare_reg03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_79_rise_sel4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_79_rise_sel5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_79_rise_sel6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_79_rise_sel7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_7_oct1sar4_sar33_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_7_oct1sar4_sar33_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_7_oct1sar5_sar41_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_7_oct1sar5_sar41_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_c2c_en_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_counter_en_attr = "serdes_lane_ana_adc_lane0_reg_80_counter_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_dcd_en_attr = "serdes_lane_ana_adc_lane0_reg_80_dcd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_dcd_sel_attr = "serdes_lane_ana_adc_lane0_reg_80_dcd_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_dfx_en_attr = "serdes_lane_ana_adc_lane0_reg_80_dfx_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_en_dfx_attr = "serdes_lane_ana_adc_lane0_reg_80_en_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_80_spare5_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_buffer_bias0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_buffer_bias_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_en_attr = "serdes_lane_ana_adc_lane0_reg_81_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_sel_c2c_cascode_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_sel_c2c_dc_coarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_sel_c2c_global_i_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_81_spare_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_82_bw_sel0_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_82_i_a2f_en_attr = "serdes_lane_ana_adc_lane0_reg_82_i_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_82_i_dfx_a2f_boost_en_attr = "serdes_lane_ana_adc_lane0_reg_82_i_dfx_a2f_boost_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_82_idfx_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_82_sel_cgm_en_attr = "serdes_lane_ana_adc_lane0_reg_82_sel_cgm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_82_spare_reg07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_83_bw_sel1_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_83_res_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_83_spare_reg08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_84_bw_sel2_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_84_clk_2ui_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_84_spare_reg09_attr = "serdes_lane_ana_adc_lane0_reg_84_spare_reg09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_85_bw_sel3_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_85_spare_reg10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_86_fall_sel0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_86_fall_sel1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_86_spare1_reg11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_86_spare2_reg11_attr = "serdes_lane_ana_adc_lane0_reg_86_spare2_reg11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_87_fall_sel2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_87_fall_sel4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_87_fall_sel6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_87_spare1_reg12_attr = "serdes_lane_ana_adc_lane0_reg_87_spare1_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_87_spare2_reg12_attr = "serdes_lane_ana_adc_lane0_reg_87_spare2_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_87_spare3_reg12_attr = "serdes_lane_ana_adc_lane0_reg_87_spare3_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_8_oct1sar6_sar49_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_8_oct1sar6_sar49_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_8_oct1sar7_sar57_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_8_oct1sar7_sar57_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_9_oct2sar0_sar2_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_9_oct2sar0_sar2_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_9_oct2sar1_sar10_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane0_reg_9_oct2sar1_sar10_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_10_oct2sar2_sar18_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_10_oct2sar2_sar18_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_10_oct2sar3_sar26_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_10_oct2sar3_sar26_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_11_oct2sar4_sar34_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_11_oct2sar4_sar34_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_11_oct2sar5_sar42_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_11_oct2sar5_sar42_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_12_oct2sar6_sar50_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_12_oct2sar6_sar50_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_12_oct2sar7_sar58_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_12_oct2sar7_sar58_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_13_oct3sar0_sar3_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_13_oct3sar0_sar3_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_13_oct3sar1_sar11_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_13_oct3sar1_sar11_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_14_oct3sar2_sar19_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_14_oct3sar2_sar19_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_14_oct3sar3_sar27_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_14_oct3sar3_sar27_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_15_oct3sar4_sar35_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_15_oct3sar4_sar35_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_15_oct3sar5_sar43_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_15_oct3sar5_sar43_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_16_oct3sar6_sar51_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_16_oct3sar6_sar51_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_16_oct3sar7_sar59_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_16_oct3sar7_sar59_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_17_oct4sar0_sar4_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_17_oct4sar0_sar4_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_17_oct4sar1_sar12_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_17_oct4sar1_sar12_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_18_oct4sar2_sar20_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_18_oct4sar2_sar20_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_18_oct4sar3_sar28_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_18_oct4sar3_sar28_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_19_oct4sar4_sar36_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_19_oct4sar4_sar36_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_19_oct4sar5_sar44_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_19_oct4sar5_sar44_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_1_oct0sar0_sar0_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_1_oct0sar0_sar0_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_1_oct0sar1_sar8_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_1_oct0sar1_sar8_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_20_oct4sar6_sar52_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_20_oct4sar6_sar52_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_20_oct4sar7_sar60_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_20_oct4sar7_sar60_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_21_oct5sar0_sar5_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_21_oct5sar0_sar5_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_21_oct5sar1_sar13_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_21_oct5sar1_sar13_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_22_oct5sar2_sar21_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_22_oct5sar2_sar21_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_22_oct5sar3_sar29_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_22_oct5sar3_sar29_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_23_oct5sar4_sar37_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_23_oct5sar4_sar37_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_23_oct5sar5_sar45_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_23_oct5sar5_sar45_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_24_oct5sar6_sar53_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_24_oct5sar6_sar53_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_24_oct5sar7_sar61_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_24_oct5sar7_sar61_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_25_oct6sar0_sar6_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_25_oct6sar0_sar6_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_25_oct6sar1_sar14_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_25_oct6sar1_sar14_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_26_oct6sar2_sar22_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_26_oct6sar2_sar22_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_26_oct6sar3_sar30_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_26_oct6sar3_sar30_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_27_oct6sar4_sar38_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_27_oct6sar4_sar38_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_27_oct6sar5_sar46_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_27_oct6sar5_sar46_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_28_oct6sar6_sar54_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_28_oct6sar6_sar54_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_28_oct6sar7_sar62_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_28_oct6sar7_sar62_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_29_oct7sar0_sar7_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_29_oct7sar0_sar7_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_29_oct7sar1_sar15_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_29_oct7sar1_sar15_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_2_oct0sar2_sar16_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_2_oct0sar2_sar16_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_2_oct0sar3_sar24_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_2_oct0sar3_sar24_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_30_oct7sar2_sar23_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_30_oct7sar2_sar23_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_30_oct7sar3_sar31_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_30_oct7sar3_sar31_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_31_oct7sar4_sar39_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_31_oct7sar4_sar39_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_31_oct7sar5_sar47_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_31_oct7sar5_sar47_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_32_oct7sar6_sar55_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_32_oct7sar6_sar55_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_32_oct7sar7_sar63_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_32_oct7sar7_sar63_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar2_sar16_en_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar2_sar16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar2_sar16_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar2_sar16_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar2_sar16_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar3_sar24_en_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar3_sar24_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar3_sar24_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar3_sar24_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar3_sar24_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar4_sar32_en_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar4_sar32_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar4_sar32_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar4_sar32_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar4_sar32_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar5_sar40_en_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar5_sar40_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar5_sar40_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_33_oct0sar5_sar40_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_33_oct0sar5_sar40_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar0_sar0_en_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar0_sar0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar0_sar0_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar0_sar0_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar0_sar0_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar1_sar8_en_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar1_sar8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar1_sar8_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar1_sar8_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar1_sar8_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar6_sar48_en_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar6_sar48_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar6_sar48_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar6_sar48_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar6_sar48_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar7_sar56_en_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar7_sar56_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar7_sar56_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_34_oct0sar7_sar56_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_34_oct0sar7_sar56_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_glb_div33_en_fw_attr = "serdes_lane_ana_adc_lane1_reg_35_glb_div33_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar2_sar17_en_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar2_sar17_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar2_sar17_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar2_sar17_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar2_sar17_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar3_sar25_en_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar3_sar25_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar3_sar25_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar3_sar25_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar3_sar25_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar4_sar33_en_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar4_sar33_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar4_sar33_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar4_sar33_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar4_sar33_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar5_sar41_en_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar5_sar41_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar5_sar41_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_35_oct1sar5_sar41_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_35_oct1sar5_sar41_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar0_sar1_en_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar0_sar1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar0_sar1_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar0_sar1_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar0_sar1_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar1_sar9_en_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar1_sar9_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar1_sar9_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar1_sar9_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar1_sar9_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar6_sar49_en_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar6_sar49_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar6_sar49_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar6_sar49_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar6_sar49_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar7_sar57_en_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar7_sar57_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar7_sar57_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_36_oct1sar7_sar57_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_36_oct1sar7_sar57_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar2_sar18_en_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar2_sar18_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar2_sar18_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar2_sar18_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar2_sar18_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar3_sar26_en_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar3_sar26_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar3_sar26_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar3_sar26_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar3_sar26_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar4_sar34_en_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar4_sar34_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar4_sar34_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar4_sar34_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar4_sar34_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar5_sar42_en_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar5_sar42_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar5_sar42_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_37_oct2sar5_sar42_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_37_oct2sar5_sar42_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar0_sar2_en_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar0_sar2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar0_sar2_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar0_sar2_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar0_sar2_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar1_sar10_en_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar1_sar10_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar1_sar10_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar1_sar10_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar1_sar10_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar6_sar50_en_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar6_sar50_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar6_sar50_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar6_sar50_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar6_sar50_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar7_sar58_en_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar7_sar58_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar7_sar58_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_38_oct2sar7_sar58_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_38_oct2sar7_sar58_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar2_sar19_en_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar2_sar19_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar2_sar19_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar2_sar19_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar2_sar19_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar3_sar27_en_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar3_sar27_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar3_sar27_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar3_sar27_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar3_sar27_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar4_sar35_en_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar4_sar35_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar4_sar35_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar4_sar35_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar4_sar35_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar5_sar43_en_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar5_sar43_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar5_sar43_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_39_oct3sar5_sar43_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_39_oct3sar5_sar43_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_3_oct0sar4_sar32_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_3_oct0sar4_sar32_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_3_oct0sar5_sar40_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_3_oct0sar5_sar40_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar0_sar3_en_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar0_sar3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar0_sar3_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar0_sar3_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar0_sar3_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar1_sar11_en_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar1_sar11_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar1_sar11_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar1_sar11_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar1_sar11_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar6_sar51_en_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar6_sar51_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar6_sar51_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar6_sar51_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar6_sar51_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar7_sar59_en_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar7_sar59_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar7_sar59_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_40_oct3sar7_sar59_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_40_oct3sar7_sar59_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar2_sar20_en_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar2_sar20_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar2_sar20_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar2_sar20_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar2_sar20_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar3_sar28_en_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar3_sar28_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar3_sar28_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar3_sar28_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar3_sar28_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar4_sar36_en_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar4_sar36_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar4_sar36_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar4_sar36_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar4_sar36_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar5_sar44_en_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar5_sar44_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar5_sar44_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_41_oct4sar5_sar44_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_41_oct4sar5_sar44_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar0_sar4_en_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar0_sar4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar0_sar4_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar0_sar4_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar0_sar4_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar1_sar12_en_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar1_sar12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar1_sar12_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar1_sar12_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar1_sar12_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar6_sar52_en_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar6_sar52_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar6_sar52_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar6_sar52_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar6_sar52_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar7_sar60_en_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar7_sar60_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar7_sar60_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_42_oct4sar7_sar60_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_42_oct4sar7_sar60_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar2_sar21_en_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar2_sar21_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar2_sar21_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar2_sar21_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar2_sar21_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar3_sar29_en_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar3_sar29_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar3_sar29_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar3_sar29_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar3_sar29_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar4_sar37_en_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar4_sar37_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar4_sar37_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar4_sar37_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar4_sar37_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar5_sar45_en_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar5_sar45_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar5_sar45_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_43_oct5sar5_sar45_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_43_oct5sar5_sar45_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_glb_div10_en_fw_attr = "serdes_lane_ana_adc_lane1_reg_44_glb_div10_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_glb_div33_frac0p25_fw_attr = "serdes_lane_ana_adc_lane1_reg_44_glb_div33_frac0p25_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_glb_div33_frac0p5_fw_attr = "serdes_lane_ana_adc_lane1_reg_44_glb_div33_frac0p5_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_glb_div33_ratio_fw_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar0_sar5_en_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar0_sar5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar0_sar5_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar0_sar5_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar0_sar5_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar1_sar13_en_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar1_sar13_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar1_sar13_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar1_sar13_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar1_sar13_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar6_sar53_en_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar6_sar53_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar6_sar53_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar6_sar53_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar6_sar53_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar7_sar61_en_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar7_sar61_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar7_sar61_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_44_oct5sar7_sar61_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_44_oct5sar7_sar61_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar2_sar22_en_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar2_sar22_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar2_sar22_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar2_sar22_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar2_sar22_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar3_sar30_en_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar3_sar30_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar3_sar30_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar3_sar30_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar3_sar30_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar4_sar38_en_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar4_sar38_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar4_sar38_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar4_sar38_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar4_sar38_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar5_sar46_en_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar5_sar46_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar5_sar46_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_45_oct6sar5_sar46_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_45_oct6sar5_sar46_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar0_sar6_en_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar0_sar6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar0_sar6_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar0_sar6_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar0_sar6_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar1_sar14_en_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar1_sar14_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar1_sar14_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar1_sar14_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar1_sar14_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar6_sar54_en_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar6_sar54_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar6_sar54_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar6_sar54_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar6_sar54_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar7_sar62_en_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar7_sar62_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar7_sar62_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_46_oct6sar7_sar62_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_46_oct6sar7_sar62_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar2_sar23_en_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar2_sar23_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar2_sar23_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar2_sar23_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar2_sar23_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar3_sar31_en_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar3_sar31_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar3_sar31_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar3_sar31_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar3_sar31_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar4_sar39_en_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar4_sar39_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar4_sar39_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar4_sar39_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar4_sar39_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar5_sar47_en_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar5_sar47_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar5_sar47_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_47_oct7sar5_sar47_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_47_oct7sar5_sar47_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar0_sar7_en_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar0_sar7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar0_sar7_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar0_sar7_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar0_sar7_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar1_sar15_en_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar1_sar15_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar1_sar15_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar1_sar15_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar1_sar15_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar6_sar55_en_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar6_sar55_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar6_sar55_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar6_sar55_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar6_sar55_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar7_sar63_en_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar7_sar63_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar7_sar63_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_48_oct7sar7_sar63_shrg_init_val_attr = "serdes_lane_ana_adc_lane1_reg_48_oct7sar7_sar63_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_dac_clear_dis_attr = "serdes_lane_ana_adc_lane1_reg_49_dac_clear_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_dac_clear_force_dfx_attr = "serdes_lane_ana_adc_lane1_reg_49_dac_clear_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_dac_reset_force_dfx_attr = "serdes_lane_ana_adc_lane1_reg_49_dac_reset_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_i_sar_finish_disable_fw_attr = "serdes_lane_ana_adc_lane1_reg_49_i_sar_finish_disable_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_osc_speed_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_refgen_cm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_refgen_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_rstb_attr = "serdes_lane_ana_adc_lane1_reg_49_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_sar_array_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_th2_bypass_attr = "serdes_lane_ana_adc_lane1_reg_49_th2_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_49_th_boost_select_attr = "serdes_lane_ana_adc_lane1_reg_49_th_boost_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_4_oct0sar6_sar48_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_4_oct0sar6_sar48_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_4_oct0sar7_sar56_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_4_oct0sar7_sar56_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_50_shrg_align_clk2cdrrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_50_shrg_align_clk2lgcrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_50_shrg_align_clkrst_val_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_51_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_51_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_51_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_51_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_51_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_o_en_attr = "serdes_lane_ana_adc_lane1_reg_51_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_51_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_52_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_52_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_52_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_52_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_52_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_o_en_attr = "serdes_lane_ana_adc_lane1_reg_52_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_52_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_53_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_53_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_53_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_53_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_53_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_o_en_attr = "serdes_lane_ana_adc_lane1_reg_53_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_53_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_54_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_54_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_54_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_54_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_54_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_o_en_attr = "serdes_lane_ana_adc_lane1_reg_54_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_54_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_55_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_55_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_55_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_55_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_55_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_o_en_attr = "serdes_lane_ana_adc_lane1_reg_55_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_55_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_56_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_56_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_56_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_56_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_56_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_o_en_attr = "serdes_lane_ana_adc_lane1_reg_56_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_56_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_57_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_57_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_57_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_57_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_57_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_o_en_attr = "serdes_lane_ana_adc_lane1_reg_57_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_57_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_current_base_dis_attr = "serdes_lane_ana_adc_lane1_reg_58_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane1_reg_58_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane1_reg_58_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane1_reg_58_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane1_reg_58_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_o_en_attr = "serdes_lane_ana_adc_lane1_reg_58_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_58_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_i_psf_cur_trim_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_i_psf_cur_trim_spare_attr = "serdes_lane_ana_adc_lane1_reg_59_i_psf_cur_trim_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_bias_current_mon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_bias_current_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_cm_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_dcmon_spare1_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_dcmon_spare1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_dcmon_spare2_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_dcmon_spare2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_dcmon_spare3_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_dcmon_spare3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_dfx_int_out_mon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_dfx_int_out_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_integrator_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_integrator_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_pbias_cas_mon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_pbias_cas_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_psf_vref_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_psf_vref_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th0_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th0_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th1_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th1_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th2_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th2_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th3_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th3_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th4_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th4_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th5_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th5_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th6_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th6_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th7_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_59_th7_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_59_th_sw_bypass_attr = "serdes_lane_ana_adc_lane1_reg_59_th_sw_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_5_oct1sar0_sar1_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_5_oct1sar0_sar1_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_5_oct1sar1_sar9_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_5_oct1sar1_sar9_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th0_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th1_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th2_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th3_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th4_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th5_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th6_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_60_th7_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th0_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th1_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th2_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th3_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th4_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th5_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th6_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_61_th7_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_dfx_en_mon_attr = "serdes_lane_ana_adc_lane1_reg_62_dfx_en_mon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_dfx_en_slc_attr = "serdes_lane_ana_adc_lane1_reg_62_dfx_en_slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th0_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th1_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th2_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th3_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th4_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th5_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th6_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th7_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_62_th_bias_en_attr = "serdes_lane_ana_adc_lane1_reg_62_th_bias_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_63_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_63_sar_dfx_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_64_ch4_pi_code_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_64_ch5_pi_code_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_64_ch6_pi_code_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_64_ch7_pi_code_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_65_ch0_pi_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_65_ch1_pi_code_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_65_ch2_pi_code_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_65_ch3_pi_code_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_c2c_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch0_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch0_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch0_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch0_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch1_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch1_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch1_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch1_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch2_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch2_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch2_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch2_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch3_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch3_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch3_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch3_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch4_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch4_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch4_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch4_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch5_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch5_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch5_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch5_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch6_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch6_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch6_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch6_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch7_pi_en_attr = "serdes_lane_ana_adc_lane1_reg_66_ch7_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_66_ch7_pi_transp_in_attr = "serdes_lane_ana_adc_lane1_reg_66_ch7_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_67_dispolarity_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_67_i_clkmux_ungate_req_reg_attr = "serdes_lane_ana_adc_lane1_reg_67_i_clkmux_ungate_req_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_67_i_clkmux_ungate_rst_reg_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_67_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_67_td_degen_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_clk2td_ch_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_pdo_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_68_pdo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_spare_attr = "serdes_lane_ana_adc_lane1_reg_68_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_td_en_pd_attr = "serdes_lane_ana_adc_lane1_reg_68_td_en_pd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_td_i_ctrl_2ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_td_i_ctrl_4ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_td_i_sel_count_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_68_td_rstb_attr = "serdes_lane_ana_adc_lane1_reg_68_td_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_dcmon_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_input_cs_trimming_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_nc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_nsf_enable_attr = "serdes_lane_ana_adc_lane1_reg_69_nsf_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_nsf_even_en_attr = "serdes_lane_ana_adc_lane1_reg_69_nsf_even_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_69_nsf_odd_en_attr = "serdes_lane_ana_adc_lane1_reg_69_nsf_odd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_6_oct1sar2_sar17_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_6_oct1sar2_sar17_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_6_oct1sar3_sar25_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_6_oct1sar3_sar25_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_70_i_clkmux_hsmonsel_local_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_70_i_clkmux_hsmonsel_next_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_70_i_clkmux_hsmonseln_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_70_i_clkmux_hsmonselp_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_70_ph_out_seln_attr = "serdes_lane_ana_adc_lane1_reg_70_ph_out_seln_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_clk_gen_dcmon_n_en_attr = "serdes_lane_ana_adc_lane1_reg_71_clk_gen_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_clk_gen_dcmon_p_en_attr = "serdes_lane_ana_adc_lane1_reg_71_clk_gen_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_comp_n_en_attr = "serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_comp_p_en_attr = "serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_dcmon_n_en_attr = "serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_dcmon_p_en_attr = "serdes_lane_ana_adc_lane1_reg_71_clkgen_and_sar_l_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_i_sararray_vref_n_attr = "serdes_lane_ana_adc_lane1_reg_71_i_sararray_vref_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_i_sararray_vref_p_attr = "serdes_lane_ana_adc_lane1_reg_71_i_sararray_vref_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_comp_n_en_attr = "serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_comp_p_en_attr = "serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_dcmon_n_en_attr = "serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_dcmon_p_en_attr = "serdes_lane_ana_adc_lane1_reg_71_nsf_th_clkmux_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_oct3_dfx_en_l_attr = "serdes_lane_ana_adc_lane1_reg_71_oct3_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_oct3_dfx_en_r_attr = "serdes_lane_ana_adc_lane1_reg_71_oct3_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_oct7_dfx_en_l_attr = "serdes_lane_ana_adc_lane1_reg_71_oct7_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_oct7_dfx_en_r_attr = "serdes_lane_ana_adc_lane1_reg_71_oct7_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_71_spare_dfx_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_72_dcmon2slc_attr = "serdes_lane_ana_adc_lane1_reg_72_dcmon2slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_72_dcmon_en_attr = "serdes_lane_ana_adc_lane1_reg_72_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_72_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_72_ph_out_selp_attr = "serdes_lane_ana_adc_lane1_reg_72_ph_out_selp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_72_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_clkgen_comp_en_attr = "serdes_lane_ana_adc_lane1_reg_73_clkgen_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct0_dfx_en_l_attr = "serdes_lane_ana_adc_lane1_reg_73_oct0_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct0_dfx_en_r_attr = "serdes_lane_ana_adc_lane1_reg_73_oct0_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct2_dfx_en_l_attr = "serdes_lane_ana_adc_lane1_reg_73_oct2_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct2_dfx_en_r_attr = "serdes_lane_ana_adc_lane1_reg_73_oct2_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct4_dfx_en_l_attr = "serdes_lane_ana_adc_lane1_reg_73_oct4_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct4_dfx_en_r_attr = "serdes_lane_ana_adc_lane1_reg_73_oct4_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_oct6_dfx_en_l_attr = "serdes_lane_ana_adc_lane1_reg_73_oct6_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_sar_r_comp_n_en_attr = "serdes_lane_ana_adc_lane1_reg_73_sar_r_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_sar_r_comp_p_en_attr = "serdes_lane_ana_adc_lane1_reg_73_sar_r_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_sar_r_dcmon_n_en_attr = "serdes_lane_ana_adc_lane1_reg_73_sar_r_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_sar_r_dcmon_p_en_attr = "serdes_lane_ana_adc_lane1_reg_73_sar_r_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_73_spare_dfx_right_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_74_fall_sel3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_74_fall_sel5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_74_fall_sel7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_74_spare1_reg13_attr = "serdes_lane_ana_adc_lane1_reg_74_spare1_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_74_spare2_reg13_attr = "serdes_lane_ana_adc_lane1_reg_74_spare2_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_74_spare3_reg13_attr = "serdes_lane_ana_adc_lane1_reg_74_spare3_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_75_rise_sel0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_75_rise_sel1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_75_rise_sel2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_75_rise_sel3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_76_spare_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_77_dfx_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_77_spare1_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_77_spare2_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_78_dfx_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_78_spare_reg03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_79_rise_sel4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_79_rise_sel5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_79_rise_sel6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_79_rise_sel7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_7_oct1sar4_sar33_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_7_oct1sar4_sar33_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_7_oct1sar5_sar41_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_7_oct1sar5_sar41_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_c2c_en_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_counter_en_attr = "serdes_lane_ana_adc_lane1_reg_80_counter_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_dcd_en_attr = "serdes_lane_ana_adc_lane1_reg_80_dcd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_dcd_sel_attr = "serdes_lane_ana_adc_lane1_reg_80_dcd_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_dfx_en_attr = "serdes_lane_ana_adc_lane1_reg_80_dfx_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_en_dfx_attr = "serdes_lane_ana_adc_lane1_reg_80_en_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_80_spare5_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_buffer_bias0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_buffer_bias_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_en_attr = "serdes_lane_ana_adc_lane1_reg_81_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_sel_c2c_cascode_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_sel_c2c_dc_coarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_sel_c2c_global_i_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_81_spare_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_82_bw_sel0_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_82_i_a2f_en_attr = "serdes_lane_ana_adc_lane1_reg_82_i_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_82_i_dfx_a2f_boost_en_attr = "serdes_lane_ana_adc_lane1_reg_82_i_dfx_a2f_boost_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_82_idfx_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_82_sel_cgm_en_attr = "serdes_lane_ana_adc_lane1_reg_82_sel_cgm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_82_spare_reg07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_83_bw_sel1_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_83_res_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_83_spare_reg08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_84_bw_sel2_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_84_clk_2ui_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_84_spare_reg09_attr = "serdes_lane_ana_adc_lane1_reg_84_spare_reg09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_85_bw_sel3_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_85_spare_reg10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_86_fall_sel0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_86_fall_sel1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_86_spare1_reg11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_86_spare2_reg11_attr = "serdes_lane_ana_adc_lane1_reg_86_spare2_reg11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_87_fall_sel2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_87_fall_sel4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_87_fall_sel6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_87_spare1_reg12_attr = "serdes_lane_ana_adc_lane1_reg_87_spare1_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_87_spare2_reg12_attr = "serdes_lane_ana_adc_lane1_reg_87_spare2_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_87_spare3_reg12_attr = "serdes_lane_ana_adc_lane1_reg_87_spare3_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_8_oct1sar6_sar49_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_8_oct1sar6_sar49_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_8_oct1sar7_sar57_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_8_oct1sar7_sar57_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_9_oct2sar0_sar2_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_9_oct2sar0_sar2_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_9_oct2sar1_sar10_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane1_reg_9_oct2sar1_sar10_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_10_oct2sar2_sar18_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_10_oct2sar2_sar18_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_10_oct2sar3_sar26_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_10_oct2sar3_sar26_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_11_oct2sar4_sar34_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_11_oct2sar4_sar34_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_11_oct2sar5_sar42_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_11_oct2sar5_sar42_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_12_oct2sar6_sar50_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_12_oct2sar6_sar50_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_12_oct2sar7_sar58_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_12_oct2sar7_sar58_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_13_oct3sar0_sar3_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_13_oct3sar0_sar3_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_13_oct3sar1_sar11_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_13_oct3sar1_sar11_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_14_oct3sar2_sar19_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_14_oct3sar2_sar19_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_14_oct3sar3_sar27_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_14_oct3sar3_sar27_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_15_oct3sar4_sar35_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_15_oct3sar4_sar35_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_15_oct3sar5_sar43_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_15_oct3sar5_sar43_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_16_oct3sar6_sar51_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_16_oct3sar6_sar51_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_16_oct3sar7_sar59_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_16_oct3sar7_sar59_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_17_oct4sar0_sar4_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_17_oct4sar0_sar4_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_17_oct4sar1_sar12_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_17_oct4sar1_sar12_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_18_oct4sar2_sar20_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_18_oct4sar2_sar20_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_18_oct4sar3_sar28_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_18_oct4sar3_sar28_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_19_oct4sar4_sar36_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_19_oct4sar4_sar36_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_19_oct4sar5_sar44_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_19_oct4sar5_sar44_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_1_oct0sar0_sar0_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_1_oct0sar0_sar0_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_1_oct0sar1_sar8_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_1_oct0sar1_sar8_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_20_oct4sar6_sar52_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_20_oct4sar6_sar52_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_20_oct4sar7_sar60_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_20_oct4sar7_sar60_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_21_oct5sar0_sar5_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_21_oct5sar0_sar5_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_21_oct5sar1_sar13_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_21_oct5sar1_sar13_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_22_oct5sar2_sar21_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_22_oct5sar2_sar21_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_22_oct5sar3_sar29_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_22_oct5sar3_sar29_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_23_oct5sar4_sar37_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_23_oct5sar4_sar37_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_23_oct5sar5_sar45_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_23_oct5sar5_sar45_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_24_oct5sar6_sar53_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_24_oct5sar6_sar53_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_24_oct5sar7_sar61_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_24_oct5sar7_sar61_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_25_oct6sar0_sar6_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_25_oct6sar0_sar6_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_25_oct6sar1_sar14_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_25_oct6sar1_sar14_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_26_oct6sar2_sar22_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_26_oct6sar2_sar22_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_26_oct6sar3_sar30_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_26_oct6sar3_sar30_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_27_oct6sar4_sar38_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_27_oct6sar4_sar38_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_27_oct6sar5_sar46_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_27_oct6sar5_sar46_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_28_oct6sar6_sar54_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_28_oct6sar6_sar54_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_28_oct6sar7_sar62_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_28_oct6sar7_sar62_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_29_oct7sar0_sar7_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_29_oct7sar0_sar7_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_29_oct7sar1_sar15_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_29_oct7sar1_sar15_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_2_oct0sar2_sar16_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_2_oct0sar2_sar16_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_2_oct0sar3_sar24_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_2_oct0sar3_sar24_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_30_oct7sar2_sar23_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_30_oct7sar2_sar23_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_30_oct7sar3_sar31_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_30_oct7sar3_sar31_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_31_oct7sar4_sar39_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_31_oct7sar4_sar39_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_31_oct7sar5_sar47_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_31_oct7sar5_sar47_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_32_oct7sar6_sar55_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_32_oct7sar6_sar55_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_32_oct7sar7_sar63_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_32_oct7sar7_sar63_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar2_sar16_en_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar2_sar16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar2_sar16_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar2_sar16_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar2_sar16_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar3_sar24_en_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar3_sar24_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar3_sar24_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar3_sar24_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar3_sar24_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar4_sar32_en_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar4_sar32_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar4_sar32_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar4_sar32_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar4_sar32_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar5_sar40_en_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar5_sar40_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar5_sar40_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_33_oct0sar5_sar40_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_33_oct0sar5_sar40_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar0_sar0_en_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar0_sar0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar0_sar0_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar0_sar0_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar0_sar0_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar1_sar8_en_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar1_sar8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar1_sar8_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar1_sar8_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar1_sar8_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar6_sar48_en_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar6_sar48_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar6_sar48_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar6_sar48_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar6_sar48_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar7_sar56_en_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar7_sar56_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar7_sar56_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_34_oct0sar7_sar56_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_34_oct0sar7_sar56_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_glb_div33_en_fw_attr = "serdes_lane_ana_adc_lane2_reg_35_glb_div33_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar2_sar17_en_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar2_sar17_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar2_sar17_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar2_sar17_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar2_sar17_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar3_sar25_en_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar3_sar25_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar3_sar25_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar3_sar25_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar3_sar25_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar4_sar33_en_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar4_sar33_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar4_sar33_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar4_sar33_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar4_sar33_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar5_sar41_en_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar5_sar41_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar5_sar41_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_35_oct1sar5_sar41_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_35_oct1sar5_sar41_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar0_sar1_en_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar0_sar1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar0_sar1_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar0_sar1_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar0_sar1_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar1_sar9_en_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar1_sar9_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar1_sar9_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar1_sar9_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar1_sar9_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar6_sar49_en_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar6_sar49_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar6_sar49_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar6_sar49_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar6_sar49_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar7_sar57_en_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar7_sar57_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar7_sar57_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_36_oct1sar7_sar57_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_36_oct1sar7_sar57_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar2_sar18_en_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar2_sar18_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar2_sar18_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar2_sar18_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar2_sar18_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar3_sar26_en_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar3_sar26_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar3_sar26_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar3_sar26_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar3_sar26_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar4_sar34_en_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar4_sar34_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar4_sar34_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar4_sar34_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar4_sar34_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar5_sar42_en_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar5_sar42_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar5_sar42_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_37_oct2sar5_sar42_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_37_oct2sar5_sar42_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar0_sar2_en_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar0_sar2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar0_sar2_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar0_sar2_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar0_sar2_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar1_sar10_en_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar1_sar10_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar1_sar10_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar1_sar10_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar1_sar10_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar6_sar50_en_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar6_sar50_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar6_sar50_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar6_sar50_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar6_sar50_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar7_sar58_en_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar7_sar58_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar7_sar58_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_38_oct2sar7_sar58_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_38_oct2sar7_sar58_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar2_sar19_en_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar2_sar19_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar2_sar19_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar2_sar19_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar2_sar19_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar3_sar27_en_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar3_sar27_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar3_sar27_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar3_sar27_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar3_sar27_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar4_sar35_en_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar4_sar35_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar4_sar35_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar4_sar35_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar4_sar35_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar5_sar43_en_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar5_sar43_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar5_sar43_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_39_oct3sar5_sar43_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_39_oct3sar5_sar43_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_3_oct0sar4_sar32_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_3_oct0sar4_sar32_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_3_oct0sar5_sar40_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_3_oct0sar5_sar40_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar0_sar3_en_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar0_sar3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar0_sar3_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar0_sar3_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar0_sar3_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar1_sar11_en_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar1_sar11_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar1_sar11_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar1_sar11_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar1_sar11_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar6_sar51_en_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar6_sar51_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar6_sar51_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar6_sar51_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar6_sar51_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar7_sar59_en_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar7_sar59_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar7_sar59_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_40_oct3sar7_sar59_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_40_oct3sar7_sar59_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar2_sar20_en_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar2_sar20_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar2_sar20_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar2_sar20_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar2_sar20_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar3_sar28_en_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar3_sar28_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar3_sar28_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar3_sar28_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar3_sar28_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar4_sar36_en_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar4_sar36_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar4_sar36_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar4_sar36_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar4_sar36_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar5_sar44_en_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar5_sar44_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar5_sar44_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_41_oct4sar5_sar44_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_41_oct4sar5_sar44_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar0_sar4_en_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar0_sar4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar0_sar4_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar0_sar4_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar0_sar4_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar1_sar12_en_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar1_sar12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar1_sar12_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar1_sar12_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar1_sar12_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar6_sar52_en_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar6_sar52_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar6_sar52_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar6_sar52_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar6_sar52_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar7_sar60_en_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar7_sar60_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar7_sar60_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_42_oct4sar7_sar60_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_42_oct4sar7_sar60_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar2_sar21_en_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar2_sar21_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar2_sar21_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar2_sar21_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar2_sar21_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar3_sar29_en_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar3_sar29_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar3_sar29_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar3_sar29_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar3_sar29_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar4_sar37_en_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar4_sar37_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar4_sar37_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar4_sar37_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar4_sar37_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar5_sar45_en_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar5_sar45_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar5_sar45_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_43_oct5sar5_sar45_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_43_oct5sar5_sar45_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_glb_div10_en_fw_attr = "serdes_lane_ana_adc_lane2_reg_44_glb_div10_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_glb_div33_frac0p25_fw_attr = "serdes_lane_ana_adc_lane2_reg_44_glb_div33_frac0p25_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_glb_div33_frac0p5_fw_attr = "serdes_lane_ana_adc_lane2_reg_44_glb_div33_frac0p5_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_glb_div33_ratio_fw_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar0_sar5_en_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar0_sar5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar0_sar5_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar0_sar5_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar0_sar5_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar1_sar13_en_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar1_sar13_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar1_sar13_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar1_sar13_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar1_sar13_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar6_sar53_en_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar6_sar53_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar6_sar53_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar6_sar53_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar6_sar53_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar7_sar61_en_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar7_sar61_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar7_sar61_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_44_oct5sar7_sar61_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_44_oct5sar7_sar61_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar2_sar22_en_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar2_sar22_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar2_sar22_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar2_sar22_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar2_sar22_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar3_sar30_en_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar3_sar30_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar3_sar30_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar3_sar30_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar3_sar30_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar4_sar38_en_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar4_sar38_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar4_sar38_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar4_sar38_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar4_sar38_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar5_sar46_en_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar5_sar46_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar5_sar46_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_45_oct6sar5_sar46_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_45_oct6sar5_sar46_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar0_sar6_en_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar0_sar6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar0_sar6_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar0_sar6_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar0_sar6_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar1_sar14_en_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar1_sar14_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar1_sar14_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar1_sar14_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar1_sar14_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar6_sar54_en_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar6_sar54_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar6_sar54_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar6_sar54_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar6_sar54_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar7_sar62_en_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar7_sar62_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar7_sar62_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_46_oct6sar7_sar62_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_46_oct6sar7_sar62_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar2_sar23_en_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar2_sar23_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar2_sar23_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar2_sar23_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar2_sar23_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar3_sar31_en_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar3_sar31_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar3_sar31_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar3_sar31_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar3_sar31_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar4_sar39_en_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar4_sar39_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar4_sar39_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar4_sar39_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar4_sar39_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar5_sar47_en_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar5_sar47_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar5_sar47_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_47_oct7sar5_sar47_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_47_oct7sar5_sar47_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar0_sar7_en_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar0_sar7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar0_sar7_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar0_sar7_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar0_sar7_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar1_sar15_en_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar1_sar15_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar1_sar15_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar1_sar15_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar1_sar15_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar6_sar55_en_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar6_sar55_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar6_sar55_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar6_sar55_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar6_sar55_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar7_sar63_en_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar7_sar63_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar7_sar63_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_48_oct7sar7_sar63_shrg_init_val_attr = "serdes_lane_ana_adc_lane2_reg_48_oct7sar7_sar63_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_dac_clear_dis_attr = "serdes_lane_ana_adc_lane2_reg_49_dac_clear_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_dac_clear_force_dfx_attr = "serdes_lane_ana_adc_lane2_reg_49_dac_clear_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_dac_reset_force_dfx_attr = "serdes_lane_ana_adc_lane2_reg_49_dac_reset_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_i_sar_finish_disable_fw_attr = "serdes_lane_ana_adc_lane2_reg_49_i_sar_finish_disable_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_osc_speed_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_refgen_cm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_refgen_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_rstb_attr = "serdes_lane_ana_adc_lane2_reg_49_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_sar_array_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_th2_bypass_attr = "serdes_lane_ana_adc_lane2_reg_49_th2_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_49_th_boost_select_attr = "serdes_lane_ana_adc_lane2_reg_49_th_boost_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_4_oct0sar6_sar48_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_4_oct0sar6_sar48_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_4_oct0sar7_sar56_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_4_oct0sar7_sar56_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_50_shrg_align_clk2cdrrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_50_shrg_align_clk2lgcrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_50_shrg_align_clkrst_val_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_51_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_51_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_51_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_51_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_51_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_o_en_attr = "serdes_lane_ana_adc_lane2_reg_51_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_51_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_52_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_52_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_52_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_52_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_52_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_o_en_attr = "serdes_lane_ana_adc_lane2_reg_52_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_52_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_53_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_53_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_53_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_53_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_53_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_o_en_attr = "serdes_lane_ana_adc_lane2_reg_53_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_53_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_54_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_54_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_54_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_54_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_54_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_o_en_attr = "serdes_lane_ana_adc_lane2_reg_54_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_54_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_55_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_55_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_55_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_55_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_55_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_o_en_attr = "serdes_lane_ana_adc_lane2_reg_55_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_55_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_56_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_56_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_56_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_56_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_56_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_o_en_attr = "serdes_lane_ana_adc_lane2_reg_56_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_56_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_57_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_57_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_57_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_57_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_57_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_o_en_attr = "serdes_lane_ana_adc_lane2_reg_57_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_57_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_current_base_dis_attr = "serdes_lane_ana_adc_lane2_reg_58_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane2_reg_58_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane2_reg_58_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane2_reg_58_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane2_reg_58_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_o_en_attr = "serdes_lane_ana_adc_lane2_reg_58_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_58_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_i_psf_cur_trim_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_i_psf_cur_trim_spare_attr = "serdes_lane_ana_adc_lane2_reg_59_i_psf_cur_trim_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_bias_current_mon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_bias_current_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_cm_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_dcmon_spare1_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_dcmon_spare1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_dcmon_spare2_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_dcmon_spare2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_dcmon_spare3_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_dcmon_spare3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_dfx_int_out_mon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_dfx_int_out_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_integrator_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_integrator_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_pbias_cas_mon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_pbias_cas_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_psf_vref_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_psf_vref_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th0_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th0_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th1_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th1_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th2_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th2_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th3_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th3_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th4_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th4_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th5_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th5_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th6_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th6_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th7_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_59_th7_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_59_th_sw_bypass_attr = "serdes_lane_ana_adc_lane2_reg_59_th_sw_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_5_oct1sar0_sar1_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_5_oct1sar0_sar1_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_5_oct1sar1_sar9_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_5_oct1sar1_sar9_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th0_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th1_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th2_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th3_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th4_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th5_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th6_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_60_th7_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th0_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th1_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th2_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th3_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th4_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th5_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th6_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_61_th7_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_dfx_en_mon_attr = "serdes_lane_ana_adc_lane2_reg_62_dfx_en_mon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_dfx_en_slc_attr = "serdes_lane_ana_adc_lane2_reg_62_dfx_en_slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th0_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th1_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th2_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th3_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th4_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th5_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th6_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th7_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_62_th_bias_en_attr = "serdes_lane_ana_adc_lane2_reg_62_th_bias_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_63_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_63_sar_dfx_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_64_ch4_pi_code_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_64_ch5_pi_code_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_64_ch6_pi_code_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_64_ch7_pi_code_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_65_ch0_pi_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_65_ch1_pi_code_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_65_ch2_pi_code_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_65_ch3_pi_code_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_c2c_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch0_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch0_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch0_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch0_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch1_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch1_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch1_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch1_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch2_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch2_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch2_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch2_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch3_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch3_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch3_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch3_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch4_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch4_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch4_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch4_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch5_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch5_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch5_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch5_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch6_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch6_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch6_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch6_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch7_pi_en_attr = "serdes_lane_ana_adc_lane2_reg_66_ch7_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_66_ch7_pi_transp_in_attr = "serdes_lane_ana_adc_lane2_reg_66_ch7_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_67_dispolarity_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_67_i_clkmux_ungate_req_reg_attr = "serdes_lane_ana_adc_lane2_reg_67_i_clkmux_ungate_req_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_67_i_clkmux_ungate_rst_reg_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_67_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_67_td_degen_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_clk2td_ch_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_pdo_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_68_pdo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_spare_attr = "serdes_lane_ana_adc_lane2_reg_68_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_td_en_pd_attr = "serdes_lane_ana_adc_lane2_reg_68_td_en_pd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_td_i_ctrl_2ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_td_i_ctrl_4ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_td_i_sel_count_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_68_td_rstb_attr = "serdes_lane_ana_adc_lane2_reg_68_td_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_dcmon_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_input_cs_trimming_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_nc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_nsf_enable_attr = "serdes_lane_ana_adc_lane2_reg_69_nsf_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_nsf_even_en_attr = "serdes_lane_ana_adc_lane2_reg_69_nsf_even_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_69_nsf_odd_en_attr = "serdes_lane_ana_adc_lane2_reg_69_nsf_odd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_6_oct1sar2_sar17_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_6_oct1sar2_sar17_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_6_oct1sar3_sar25_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_6_oct1sar3_sar25_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_70_i_clkmux_hsmonsel_local_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_70_i_clkmux_hsmonsel_next_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_70_i_clkmux_hsmonseln_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_70_i_clkmux_hsmonselp_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_70_ph_out_seln_attr = "serdes_lane_ana_adc_lane2_reg_70_ph_out_seln_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_clk_gen_dcmon_n_en_attr = "serdes_lane_ana_adc_lane2_reg_71_clk_gen_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_clk_gen_dcmon_p_en_attr = "serdes_lane_ana_adc_lane2_reg_71_clk_gen_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_comp_n_en_attr = "serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_comp_p_en_attr = "serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_dcmon_n_en_attr = "serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_dcmon_p_en_attr = "serdes_lane_ana_adc_lane2_reg_71_clkgen_and_sar_l_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_i_sararray_vref_n_attr = "serdes_lane_ana_adc_lane2_reg_71_i_sararray_vref_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_i_sararray_vref_p_attr = "serdes_lane_ana_adc_lane2_reg_71_i_sararray_vref_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_comp_n_en_attr = "serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_comp_p_en_attr = "serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_dcmon_n_en_attr = "serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_dcmon_p_en_attr = "serdes_lane_ana_adc_lane2_reg_71_nsf_th_clkmux_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_oct3_dfx_en_l_attr = "serdes_lane_ana_adc_lane2_reg_71_oct3_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_oct3_dfx_en_r_attr = "serdes_lane_ana_adc_lane2_reg_71_oct3_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_oct7_dfx_en_l_attr = "serdes_lane_ana_adc_lane2_reg_71_oct7_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_oct7_dfx_en_r_attr = "serdes_lane_ana_adc_lane2_reg_71_oct7_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_71_spare_dfx_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_72_dcmon2slc_attr = "serdes_lane_ana_adc_lane2_reg_72_dcmon2slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_72_dcmon_en_attr = "serdes_lane_ana_adc_lane2_reg_72_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_72_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_72_ph_out_selp_attr = "serdes_lane_ana_adc_lane2_reg_72_ph_out_selp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_72_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_clkgen_comp_en_attr = "serdes_lane_ana_adc_lane2_reg_73_clkgen_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct0_dfx_en_l_attr = "serdes_lane_ana_adc_lane2_reg_73_oct0_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct0_dfx_en_r_attr = "serdes_lane_ana_adc_lane2_reg_73_oct0_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct2_dfx_en_l_attr = "serdes_lane_ana_adc_lane2_reg_73_oct2_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct2_dfx_en_r_attr = "serdes_lane_ana_adc_lane2_reg_73_oct2_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct4_dfx_en_l_attr = "serdes_lane_ana_adc_lane2_reg_73_oct4_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct4_dfx_en_r_attr = "serdes_lane_ana_adc_lane2_reg_73_oct4_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_oct6_dfx_en_l_attr = "serdes_lane_ana_adc_lane2_reg_73_oct6_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_sar_r_comp_n_en_attr = "serdes_lane_ana_adc_lane2_reg_73_sar_r_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_sar_r_comp_p_en_attr = "serdes_lane_ana_adc_lane2_reg_73_sar_r_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_sar_r_dcmon_n_en_attr = "serdes_lane_ana_adc_lane2_reg_73_sar_r_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_sar_r_dcmon_p_en_attr = "serdes_lane_ana_adc_lane2_reg_73_sar_r_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_73_spare_dfx_right_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_74_fall_sel3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_74_fall_sel5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_74_fall_sel7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_74_spare1_reg13_attr = "serdes_lane_ana_adc_lane2_reg_74_spare1_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_74_spare2_reg13_attr = "serdes_lane_ana_adc_lane2_reg_74_spare2_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_74_spare3_reg13_attr = "serdes_lane_ana_adc_lane2_reg_74_spare3_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_75_rise_sel0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_75_rise_sel1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_75_rise_sel2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_75_rise_sel3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_76_spare_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_77_dfx_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_77_spare1_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_77_spare2_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_78_dfx_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_78_spare_reg03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_79_rise_sel4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_79_rise_sel5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_79_rise_sel6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_79_rise_sel7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_7_oct1sar4_sar33_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_7_oct1sar4_sar33_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_7_oct1sar5_sar41_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_7_oct1sar5_sar41_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_c2c_en_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_counter_en_attr = "serdes_lane_ana_adc_lane2_reg_80_counter_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_dcd_en_attr = "serdes_lane_ana_adc_lane2_reg_80_dcd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_dcd_sel_attr = "serdes_lane_ana_adc_lane2_reg_80_dcd_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_dfx_en_attr = "serdes_lane_ana_adc_lane2_reg_80_dfx_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_en_dfx_attr = "serdes_lane_ana_adc_lane2_reg_80_en_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_80_spare5_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_buffer_bias0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_buffer_bias_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_en_attr = "serdes_lane_ana_adc_lane2_reg_81_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_sel_c2c_cascode_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_sel_c2c_dc_coarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_sel_c2c_global_i_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_81_spare_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_82_bw_sel0_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_82_i_a2f_en_attr = "serdes_lane_ana_adc_lane2_reg_82_i_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_82_i_dfx_a2f_boost_en_attr = "serdes_lane_ana_adc_lane2_reg_82_i_dfx_a2f_boost_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_82_idfx_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_82_sel_cgm_en_attr = "serdes_lane_ana_adc_lane2_reg_82_sel_cgm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_82_spare_reg07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_83_bw_sel1_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_83_res_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_83_spare_reg08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_84_bw_sel2_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_84_clk_2ui_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_84_spare_reg09_attr = "serdes_lane_ana_adc_lane2_reg_84_spare_reg09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_85_bw_sel3_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_85_spare_reg10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_86_fall_sel0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_86_fall_sel1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_86_spare1_reg11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_86_spare2_reg11_attr = "serdes_lane_ana_adc_lane2_reg_86_spare2_reg11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_87_fall_sel2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_87_fall_sel4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_87_fall_sel6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_87_spare1_reg12_attr = "serdes_lane_ana_adc_lane2_reg_87_spare1_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_87_spare2_reg12_attr = "serdes_lane_ana_adc_lane2_reg_87_spare2_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_87_spare3_reg12_attr = "serdes_lane_ana_adc_lane2_reg_87_spare3_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_8_oct1sar6_sar49_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_8_oct1sar6_sar49_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_8_oct1sar7_sar57_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_8_oct1sar7_sar57_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_9_oct2sar0_sar2_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_9_oct2sar0_sar2_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_9_oct2sar1_sar10_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane2_reg_9_oct2sar1_sar10_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_10_oct2sar2_sar18_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_10_oct2sar2_sar18_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_10_oct2sar3_sar26_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_10_oct2sar3_sar26_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_11_oct2sar4_sar34_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_11_oct2sar4_sar34_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_11_oct2sar5_sar42_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_11_oct2sar5_sar42_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_12_oct2sar6_sar50_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_12_oct2sar6_sar50_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_12_oct2sar7_sar58_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_12_oct2sar7_sar58_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_13_oct3sar0_sar3_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_13_oct3sar0_sar3_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_13_oct3sar1_sar11_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_13_oct3sar1_sar11_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_14_oct3sar2_sar19_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_14_oct3sar2_sar19_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_14_oct3sar3_sar27_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_14_oct3sar3_sar27_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_15_oct3sar4_sar35_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_15_oct3sar4_sar35_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_15_oct3sar5_sar43_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_15_oct3sar5_sar43_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_16_oct3sar6_sar51_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_16_oct3sar6_sar51_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_16_oct3sar7_sar59_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_16_oct3sar7_sar59_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_17_oct4sar0_sar4_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_17_oct4sar0_sar4_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_17_oct4sar1_sar12_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_17_oct4sar1_sar12_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_18_oct4sar2_sar20_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_18_oct4sar2_sar20_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_18_oct4sar3_sar28_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_18_oct4sar3_sar28_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_19_oct4sar4_sar36_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_19_oct4sar4_sar36_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_19_oct4sar5_sar44_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_19_oct4sar5_sar44_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_1_oct0sar0_sar0_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_1_oct0sar0_sar0_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_1_oct0sar1_sar8_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_1_oct0sar1_sar8_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_20_oct4sar6_sar52_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_20_oct4sar6_sar52_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_20_oct4sar7_sar60_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_20_oct4sar7_sar60_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_21_oct5sar0_sar5_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_21_oct5sar0_sar5_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_21_oct5sar1_sar13_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_21_oct5sar1_sar13_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_22_oct5sar2_sar21_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_22_oct5sar2_sar21_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_22_oct5sar3_sar29_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_22_oct5sar3_sar29_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_23_oct5sar4_sar37_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_23_oct5sar4_sar37_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_23_oct5sar5_sar45_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_23_oct5sar5_sar45_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_24_oct5sar6_sar53_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_24_oct5sar6_sar53_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_24_oct5sar7_sar61_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_24_oct5sar7_sar61_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_25_oct6sar0_sar6_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_25_oct6sar0_sar6_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_25_oct6sar1_sar14_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_25_oct6sar1_sar14_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_26_oct6sar2_sar22_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_26_oct6sar2_sar22_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_26_oct6sar3_sar30_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_26_oct6sar3_sar30_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_27_oct6sar4_sar38_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_27_oct6sar4_sar38_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_27_oct6sar5_sar46_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_27_oct6sar5_sar46_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_28_oct6sar6_sar54_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_28_oct6sar6_sar54_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_28_oct6sar7_sar62_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_28_oct6sar7_sar62_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_29_oct7sar0_sar7_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_29_oct7sar0_sar7_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_29_oct7sar1_sar15_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_29_oct7sar1_sar15_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_2_oct0sar2_sar16_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_2_oct0sar2_sar16_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_2_oct0sar3_sar24_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_2_oct0sar3_sar24_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_30_oct7sar2_sar23_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_30_oct7sar2_sar23_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_30_oct7sar3_sar31_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_30_oct7sar3_sar31_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_31_oct7sar4_sar39_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_31_oct7sar4_sar39_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_31_oct7sar5_sar47_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_31_oct7sar5_sar47_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_32_oct7sar6_sar55_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_32_oct7sar6_sar55_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_32_oct7sar7_sar63_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_32_oct7sar7_sar63_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar2_sar16_en_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar2_sar16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar2_sar16_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar2_sar16_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar2_sar16_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar3_sar24_en_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar3_sar24_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar3_sar24_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar3_sar24_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar3_sar24_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar4_sar32_en_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar4_sar32_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar4_sar32_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar4_sar32_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar4_sar32_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar5_sar40_en_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar5_sar40_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar5_sar40_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_33_oct0sar5_sar40_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_33_oct0sar5_sar40_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar0_sar0_en_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar0_sar0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar0_sar0_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar0_sar0_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar0_sar0_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar1_sar8_en_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar1_sar8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar1_sar8_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar1_sar8_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar1_sar8_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar6_sar48_en_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar6_sar48_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar6_sar48_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar6_sar48_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar6_sar48_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar7_sar56_en_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar7_sar56_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar7_sar56_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_34_oct0sar7_sar56_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_34_oct0sar7_sar56_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_glb_div33_en_fw_attr = "serdes_lane_ana_adc_lane3_reg_35_glb_div33_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar2_sar17_en_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar2_sar17_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar2_sar17_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar2_sar17_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar2_sar17_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar3_sar25_en_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar3_sar25_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar3_sar25_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar3_sar25_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar3_sar25_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar4_sar33_en_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar4_sar33_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar4_sar33_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar4_sar33_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar4_sar33_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar5_sar41_en_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar5_sar41_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar5_sar41_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_35_oct1sar5_sar41_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_35_oct1sar5_sar41_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar0_sar1_en_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar0_sar1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar0_sar1_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar0_sar1_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar0_sar1_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar1_sar9_en_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar1_sar9_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar1_sar9_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar1_sar9_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar1_sar9_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar6_sar49_en_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar6_sar49_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar6_sar49_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar6_sar49_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar6_sar49_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar7_sar57_en_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar7_sar57_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar7_sar57_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_36_oct1sar7_sar57_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_36_oct1sar7_sar57_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar2_sar18_en_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar2_sar18_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar2_sar18_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar2_sar18_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar2_sar18_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar3_sar26_en_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar3_sar26_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar3_sar26_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar3_sar26_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar3_sar26_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar4_sar34_en_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar4_sar34_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar4_sar34_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar4_sar34_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar4_sar34_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar5_sar42_en_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar5_sar42_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar5_sar42_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_37_oct2sar5_sar42_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_37_oct2sar5_sar42_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar0_sar2_en_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar0_sar2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar0_sar2_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar0_sar2_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar0_sar2_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar1_sar10_en_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar1_sar10_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar1_sar10_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar1_sar10_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar1_sar10_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar6_sar50_en_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar6_sar50_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar6_sar50_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar6_sar50_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar6_sar50_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar7_sar58_en_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar7_sar58_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar7_sar58_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_38_oct2sar7_sar58_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_38_oct2sar7_sar58_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar2_sar19_en_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar2_sar19_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar2_sar19_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar2_sar19_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar2_sar19_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar3_sar27_en_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar3_sar27_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar3_sar27_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar3_sar27_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar3_sar27_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar4_sar35_en_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar4_sar35_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar4_sar35_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar4_sar35_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar4_sar35_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar5_sar43_en_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar5_sar43_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar5_sar43_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_39_oct3sar5_sar43_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_39_oct3sar5_sar43_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_3_oct0sar4_sar32_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_3_oct0sar4_sar32_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_3_oct0sar5_sar40_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_3_oct0sar5_sar40_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar0_sar3_en_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar0_sar3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar0_sar3_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar0_sar3_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar0_sar3_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar1_sar11_en_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar1_sar11_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar1_sar11_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar1_sar11_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar1_sar11_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar6_sar51_en_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar6_sar51_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar6_sar51_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar6_sar51_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar6_sar51_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar7_sar59_en_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar7_sar59_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar7_sar59_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_40_oct3sar7_sar59_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_40_oct3sar7_sar59_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar2_sar20_en_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar2_sar20_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar2_sar20_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar2_sar20_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar2_sar20_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar3_sar28_en_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar3_sar28_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar3_sar28_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar3_sar28_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar3_sar28_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar4_sar36_en_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar4_sar36_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar4_sar36_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar4_sar36_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar4_sar36_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar5_sar44_en_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar5_sar44_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar5_sar44_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_41_oct4sar5_sar44_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_41_oct4sar5_sar44_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar0_sar4_en_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar0_sar4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar0_sar4_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar0_sar4_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar0_sar4_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar1_sar12_en_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar1_sar12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar1_sar12_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar1_sar12_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar1_sar12_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar6_sar52_en_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar6_sar52_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar6_sar52_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar6_sar52_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar6_sar52_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar7_sar60_en_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar7_sar60_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar7_sar60_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_42_oct4sar7_sar60_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_42_oct4sar7_sar60_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar2_sar21_en_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar2_sar21_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar2_sar21_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar2_sar21_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar2_sar21_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar3_sar29_en_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar3_sar29_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar3_sar29_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar3_sar29_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar3_sar29_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar4_sar37_en_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar4_sar37_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar4_sar37_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar4_sar37_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar4_sar37_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar5_sar45_en_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar5_sar45_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar5_sar45_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_43_oct5sar5_sar45_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_43_oct5sar5_sar45_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_glb_div10_en_fw_attr = "serdes_lane_ana_adc_lane3_reg_44_glb_div10_en_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_glb_div33_frac0p25_fw_attr = "serdes_lane_ana_adc_lane3_reg_44_glb_div33_frac0p25_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_glb_div33_frac0p5_fw_attr = "serdes_lane_ana_adc_lane3_reg_44_glb_div33_frac0p5_fw_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_glb_div33_ratio_fw_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar0_sar5_en_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar0_sar5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar0_sar5_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar0_sar5_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar0_sar5_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar1_sar13_en_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar1_sar13_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar1_sar13_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar1_sar13_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar1_sar13_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar6_sar53_en_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar6_sar53_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar6_sar53_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar6_sar53_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar6_sar53_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar7_sar61_en_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar7_sar61_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar7_sar61_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_44_oct5sar7_sar61_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_44_oct5sar7_sar61_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar2_sar22_en_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar2_sar22_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar2_sar22_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar2_sar22_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar2_sar22_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar3_sar30_en_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar3_sar30_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar3_sar30_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar3_sar30_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar3_sar30_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar4_sar38_en_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar4_sar38_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar4_sar38_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar4_sar38_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar4_sar38_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar5_sar46_en_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar5_sar46_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar5_sar46_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_45_oct6sar5_sar46_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_45_oct6sar5_sar46_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar0_sar6_en_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar0_sar6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar0_sar6_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar0_sar6_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar0_sar6_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar1_sar14_en_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar1_sar14_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar1_sar14_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar1_sar14_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar1_sar14_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar6_sar54_en_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar6_sar54_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar6_sar54_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar6_sar54_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar6_sar54_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar7_sar62_en_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar7_sar62_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar7_sar62_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_46_oct6sar7_sar62_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_46_oct6sar7_sar62_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar2_sar23_en_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar2_sar23_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar2_sar23_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar2_sar23_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar2_sar23_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar3_sar31_en_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar3_sar31_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar3_sar31_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar3_sar31_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar3_sar31_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar4_sar39_en_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar4_sar39_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar4_sar39_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar4_sar39_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar4_sar39_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar5_sar47_en_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar5_sar47_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar5_sar47_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_47_oct7sar5_sar47_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_47_oct7sar5_sar47_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar0_sar7_en_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar0_sar7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar0_sar7_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar0_sar7_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar0_sar7_shrg_init_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar1_sar15_en_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar1_sar15_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar1_sar15_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar1_sar15_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar1_sar15_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar6_sar55_en_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar6_sar55_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar6_sar55_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar6_sar55_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar6_sar55_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar7_sar63_en_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar7_sar63_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar7_sar63_gain_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_48_oct7sar7_sar63_shrg_init_val_attr = "serdes_lane_ana_adc_lane3_reg_48_oct7sar7_sar63_shrg_init_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_dac_clear_dis_attr = "serdes_lane_ana_adc_lane3_reg_49_dac_clear_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_dac_clear_force_dfx_attr = "serdes_lane_ana_adc_lane3_reg_49_dac_clear_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_dac_reset_force_dfx_attr = "serdes_lane_ana_adc_lane3_reg_49_dac_reset_force_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_i_sar_finish_disable_fw_attr = "serdes_lane_ana_adc_lane3_reg_49_i_sar_finish_disable_fw_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_osc_speed_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_refgen_cm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_refgen_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_rstb_attr = "serdes_lane_ana_adc_lane3_reg_49_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_sar_array_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_th2_bypass_attr = "serdes_lane_ana_adc_lane3_reg_49_th2_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_49_th_boost_select_attr = "serdes_lane_ana_adc_lane3_reg_49_th_boost_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_4_oct0sar6_sar48_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_4_oct0sar6_sar48_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_4_oct0sar7_sar56_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_4_oct0sar7_sar56_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_50_shrg_align_clk2cdrrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_50_shrg_align_clk2lgcrst_val_attr = 225;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_50_shrg_align_clkrst_val_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_51_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_51_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_51_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_51_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_51_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_o_en_attr = "serdes_lane_ana_adc_lane3_reg_51_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_51_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_52_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_52_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_52_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_52_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_52_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_o_en_attr = "serdes_lane_ana_adc_lane3_reg_52_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_52_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_53_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_53_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_53_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_53_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_53_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_o_en_attr = "serdes_lane_ana_adc_lane3_reg_53_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_53_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_54_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_54_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_54_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_54_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_54_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_o_en_attr = "serdes_lane_ana_adc_lane3_reg_54_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_54_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_55_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_55_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_55_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_55_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_55_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_o_en_attr = "serdes_lane_ana_adc_lane3_reg_55_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_55_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_56_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_56_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_56_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_56_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_56_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_o_en_attr = "serdes_lane_ana_adc_lane3_reg_56_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_56_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_57_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_57_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_57_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_57_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_57_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_o_en_attr = "serdes_lane_ana_adc_lane3_reg_57_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_57_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_current_control_15pc_ctl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_current_control_15pc_ctl2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_current_control_3_ctl2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_current_control_7_ctl1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_25pc_ctl_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_current_base_dis_attr = "serdes_lane_ana_adc_lane3_reg_58_o_current_base_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_dcmon_vbpn_en_attr = "serdes_lane_ana_adc_lane3_reg_58_o_dcmon_vbpn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_dcmon_vref0_en_attr = "serdes_lane_ana_adc_lane3_reg_58_o_dcmon_vref0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_dcmon_vref_en_attr = "serdes_lane_ana_adc_lane3_reg_58_o_dcmon_vref_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_dcmonp_vref_inp_attr = "serdes_lane_ana_adc_lane3_reg_58_o_dcmonp_vref_inp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_o_en_attr = "serdes_lane_ana_adc_lane3_reg_58_o_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_58_res_ref_ladder_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_i_psf_cur_trim_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_i_psf_cur_trim_spare_attr = "serdes_lane_ana_adc_lane3_reg_59_i_psf_cur_trim_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_bias_current_mon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_bias_current_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_cm_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_dcmon_spare1_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_dcmon_spare1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_dcmon_spare2_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_dcmon_spare2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_dcmon_spare3_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_dcmon_spare3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_dfx_int_out_mon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_dfx_int_out_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_integrator_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_integrator_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_pbias_cas_mon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_pbias_cas_mon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_psf_vref_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_psf_vref_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th0_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th0_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th1_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th1_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th2_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th2_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th3_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th3_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th4_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th4_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th5_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th5_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th6_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th6_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th7_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_59_th7_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_59_th_sw_bypass_attr = "serdes_lane_ana_adc_lane3_reg_59_th_sw_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_5_oct1sar0_sar1_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_5_oct1sar0_sar1_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_5_oct1sar1_sar9_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_5_oct1sar1_sar9_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th0_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th1_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th2_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th3_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th4_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th5_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th6_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_60_th7_cur_trim_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th0_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th1_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th2_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th3_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th4_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th5_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th6_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_61_th7_psf_ofc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_dfx_en_mon_attr = "serdes_lane_ana_adc_lane3_reg_62_dfx_en_mon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_dfx_en_slc_attr = "serdes_lane_ana_adc_lane3_reg_62_dfx_en_slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th0_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th0_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th1_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th2_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th3_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th3_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th4_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th5_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th5_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th6_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th6_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th7_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th7_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_62_th_bias_en_attr = "serdes_lane_ana_adc_lane3_reg_62_th_bias_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_63_bonus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_63_sar_dfx_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_64_ch4_pi_code_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_64_ch5_pi_code_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_64_ch6_pi_code_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_64_ch7_pi_code_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_65_ch0_pi_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_65_ch1_pi_code_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_65_ch2_pi_code_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_65_ch3_pi_code_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_c2c_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch0_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch0_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch0_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch0_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch1_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch1_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch1_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch1_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch2_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch2_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch2_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch2_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch3_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch3_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch3_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch3_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch4_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch4_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch4_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch4_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch5_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch5_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch5_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch5_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch6_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch6_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch6_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch6_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch7_pi_en_attr = "serdes_lane_ana_adc_lane3_reg_66_ch7_pi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_66_ch7_pi_transp_in_attr = "serdes_lane_ana_adc_lane3_reg_66_ch7_pi_transp_in_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_67_dispolarity_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_67_i_clkmux_ungate_req_reg_attr = "serdes_lane_ana_adc_lane3_reg_67_i_clkmux_ungate_req_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_67_i_clkmux_ungate_rst_reg_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_67_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_67_td_degen_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_clk2td_ch_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_pdo_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_68_pdo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_spare_attr = "serdes_lane_ana_adc_lane3_reg_68_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_td_en_pd_attr = "serdes_lane_ana_adc_lane3_reg_68_td_en_pd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_td_i_ctrl_2ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_td_i_ctrl_4ui_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_td_i_sel_count_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_68_td_rstb_attr = "serdes_lane_ana_adc_lane3_reg_68_td_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_dcmon_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_input_cs_trimming_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_nc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_nsf_enable_attr = "serdes_lane_ana_adc_lane3_reg_69_nsf_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_nsf_even_en_attr = "serdes_lane_ana_adc_lane3_reg_69_nsf_even_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_69_nsf_odd_en_attr = "serdes_lane_ana_adc_lane3_reg_69_nsf_odd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_6_oct1sar2_sar17_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_6_oct1sar2_sar17_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_6_oct1sar3_sar25_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_6_oct1sar3_sar25_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_70_i_clkmux_hsmonsel_local_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_70_i_clkmux_hsmonsel_next_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_70_i_clkmux_hsmonseln_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_70_i_clkmux_hsmonselp_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_70_ph_out_seln_attr = "serdes_lane_ana_adc_lane3_reg_70_ph_out_seln_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_clk_gen_dcmon_n_en_attr = "serdes_lane_ana_adc_lane3_reg_71_clk_gen_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_clk_gen_dcmon_p_en_attr = "serdes_lane_ana_adc_lane3_reg_71_clk_gen_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_comp_n_en_attr = "serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_comp_p_en_attr = "serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_dcmon_n_en_attr = "serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_dcmon_p_en_attr = "serdes_lane_ana_adc_lane3_reg_71_clkgen_and_sar_l_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_i_sararray_vref_n_attr = "serdes_lane_ana_adc_lane3_reg_71_i_sararray_vref_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_i_sararray_vref_p_attr = "serdes_lane_ana_adc_lane3_reg_71_i_sararray_vref_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_comp_n_en_attr = "serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_comp_p_en_attr = "serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_dcmon_n_en_attr = "serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_dcmon_p_en_attr = "serdes_lane_ana_adc_lane3_reg_71_nsf_th_clkmux_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_oct3_dfx_en_l_attr = "serdes_lane_ana_adc_lane3_reg_71_oct3_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_oct3_dfx_en_r_attr = "serdes_lane_ana_adc_lane3_reg_71_oct3_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_oct7_dfx_en_l_attr = "serdes_lane_ana_adc_lane3_reg_71_oct7_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_oct7_dfx_en_r_attr = "serdes_lane_ana_adc_lane3_reg_71_oct7_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_71_spare_dfx_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_72_dcmon2slc_attr = "serdes_lane_ana_adc_lane3_reg_72_dcmon2slc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_72_dcmon_en_attr = "serdes_lane_ana_adc_lane3_reg_72_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_72_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_72_ph_out_selp_attr = "serdes_lane_ana_adc_lane3_reg_72_ph_out_selp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_72_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_clkgen_comp_en_attr = "serdes_lane_ana_adc_lane3_reg_73_clkgen_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_o_sar_dft_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct0_dfx_en_l_attr = "serdes_lane_ana_adc_lane3_reg_73_oct0_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct0_dfx_en_r_attr = "serdes_lane_ana_adc_lane3_reg_73_oct0_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct2_dfx_en_l_attr = "serdes_lane_ana_adc_lane3_reg_73_oct2_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct2_dfx_en_r_attr = "serdes_lane_ana_adc_lane3_reg_73_oct2_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct4_dfx_en_l_attr = "serdes_lane_ana_adc_lane3_reg_73_oct4_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct4_dfx_en_r_attr = "serdes_lane_ana_adc_lane3_reg_73_oct4_dfx_en_r_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_oct6_dfx_en_l_attr = "serdes_lane_ana_adc_lane3_reg_73_oct6_dfx_en_l_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_sar_r_comp_n_en_attr = "serdes_lane_ana_adc_lane3_reg_73_sar_r_comp_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_sar_r_comp_p_en_attr = "serdes_lane_ana_adc_lane3_reg_73_sar_r_comp_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_sar_r_dcmon_n_en_attr = "serdes_lane_ana_adc_lane3_reg_73_sar_r_dcmon_n_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_sar_r_dcmon_p_en_attr = "serdes_lane_ana_adc_lane3_reg_73_sar_r_dcmon_p_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_73_spare_dfx_right_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_74_fall_sel3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_74_fall_sel5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_74_fall_sel7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_74_spare1_reg13_attr = "serdes_lane_ana_adc_lane3_reg_74_spare1_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_74_spare2_reg13_attr = "serdes_lane_ana_adc_lane3_reg_74_spare2_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_74_spare3_reg13_attr = "serdes_lane_ana_adc_lane3_reg_74_spare3_reg13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_75_rise_sel0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_75_rise_sel1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_75_rise_sel2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_75_rise_sel3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_76_spare_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_77_dfx_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_77_spare1_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_77_spare2_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_78_dfx_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_78_spare_reg03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_79_rise_sel4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_79_rise_sel5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_79_rise_sel6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_79_rise_sel7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_7_oct1sar4_sar33_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_7_oct1sar4_sar33_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_7_oct1sar5_sar41_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_7_oct1sar5_sar41_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_c2c_en_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_counter_en_attr = "serdes_lane_ana_adc_lane3_reg_80_counter_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_dcd_en_attr = "serdes_lane_ana_adc_lane3_reg_80_dcd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_dcd_sel_attr = "serdes_lane_ana_adc_lane3_reg_80_dcd_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_dfx_en_attr = "serdes_lane_ana_adc_lane3_reg_80_dfx_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_en_dfx_attr = "serdes_lane_ana_adc_lane3_reg_80_en_dfx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_80_spare5_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_buffer_bias0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_buffer_bias_dfx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_en_attr = "serdes_lane_ana_adc_lane3_reg_81_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_sel_c2c_cascode_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_sel_c2c_dc_coarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_sel_c2c_global_i_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_81_spare_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_82_bw_sel0_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_82_i_a2f_en_attr = "serdes_lane_ana_adc_lane3_reg_82_i_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_82_i_dfx_a2f_boost_en_attr = "serdes_lane_ana_adc_lane3_reg_82_i_dfx_a2f_boost_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_82_idfx_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_82_sel_cgm_en_attr = "serdes_lane_ana_adc_lane3_reg_82_sel_cgm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_82_spare_reg07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_83_bw_sel1_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_83_res_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_83_spare_reg08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_84_bw_sel2_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_84_clk_2ui_sel_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_84_spare_reg09_attr = "serdes_lane_ana_adc_lane3_reg_84_spare_reg09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_85_bw_sel3_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_85_spare_reg10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_86_fall_sel0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_86_fall_sel1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_86_spare1_reg11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_86_spare2_reg11_attr = "serdes_lane_ana_adc_lane3_reg_86_spare2_reg11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_87_fall_sel2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_87_fall_sel4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_87_fall_sel6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_87_spare1_reg12_attr = "serdes_lane_ana_adc_lane3_reg_87_spare1_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_87_spare2_reg12_attr = "serdes_lane_ana_adc_lane3_reg_87_spare2_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_87_spare3_reg12_attr = "serdes_lane_ana_adc_lane3_reg_87_spare3_reg12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_8_oct1sar6_sar49_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_8_oct1sar6_sar49_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_8_oct1sar7_sar57_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_8_oct1sar7_sar57_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_9_oct2sar0_sar2_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_9_oct2sar0_sar2_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_9_oct2sar1_sar10_slc1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_adc_lane3_reg_9_oct2sar1_sar10_slc2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_10_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_11_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_12_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_13_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_13_cfg_plllock_state_sel_attr = "serdes_lane_ana_pll_lane0_reg_13_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_13_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_dcocoarse_ovrden_attr = "serdes_lane_ana_pll_lane0_reg_18_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_18_cfg_full_range_afc_sel_attr = "serdes_lane_ana_pll_lane0_reg_18_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_boost_dtr_const_zeta_attr = "serdes_lane_ana_pll_lane0_reg_19_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_boost_fine_const_zeta_attr = "serdes_lane_ana_pll_lane0_reg_19_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_filter_boostfade_dtr_en_attr = "serdes_lane_ana_pll_lane0_reg_19_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_filter_boostfade_fine_en_attr = "serdes_lane_ana_pll_lane0_reg_19_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_19_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_1_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_1_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_1_o_fracnen_h_attr = "serdes_lane_ana_pll_lane0_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_earlylock_sel_attr = "serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_final_code_sel_attr = "serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_20_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_dcosettle_mode_attr = "serdes_lane_ana_pll_lane0_reg_21_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_dtr_ovrden_attr = "serdes_lane_ana_pll_lane0_reg_21_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_skip_second_afc_calib_attr = "serdes_lane_ana_pll_lane0_reg_21_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_stay_fll_attr = "serdes_lane_ana_pll_lane0_reg_21_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_stay_pll_attr = "serdes_lane_ana_pll_lane0_reg_21_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_21_cfg_tdcbbpd_en_attr = "serdes_lane_ana_pll_lane0_reg_21_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_ssc_track_en_attr = "serdes_lane_ana_pll_lane0_reg_22_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_22_cfg_temp_track_en_attr = "serdes_lane_ana_pll_lane0_reg_22_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_cb56_lane32div_en_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_clkouten_cb_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_clkouten_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_clkouten_lane_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_fbdiv_rat0p5_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_pcs3334_divsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_pcs3334div_en_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_pcs40div_en_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_pll_bypass_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_refclk100div_en_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_refclk100div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_refclk156div_en_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_refclk156div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_sddiv_en_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_sddiv_ratio_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_23_cfg_sddtr_clk_sel_attr = "serdes_lane_ana_pll_lane0_reg_23_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_a2f_en_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_en_peak_sense_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_en_peak_sense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_force_vreglpfbyp_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_obsmux0_del_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_obsmux1_del_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_pll_refclkreg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_ref156div_rat0p5_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_ss_comp_out_sel_attr = "serdes_lane_ana_pll_lane0_reg_24_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_24_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_ramp_dir_ovr_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_ramp_enable_ovr_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_ramp_toggle_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dpso_bypass_mode_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_dtr_modulation_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_fbdiv_clkgate_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_fine_modulation_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_fine_modulation_sel_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_tdcpe_modulation_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_25_cfg_vreg_dac_modulation_en_attr = "serdes_lane_ana_pll_lane0_reg_25_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_26_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_26_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_fw_force_vreg_cal_done_attr = "serdes_lane_ana_pll_lane0_reg_27_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_fw_vreg_accum_ovrd_attr = "serdes_lane_ana_pll_lane0_reg_27_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_inv_vpeak_comb_fb_attr = "serdes_lane_ana_pll_lane0_reg_27_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_inv_vreg_comb_fb_attr = "serdes_lane_ana_pll_lane0_reg_27_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_27_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_28_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_28_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_dft_freq_meas_enable_attr = "serdes_lane_ana_pll_lane0_reg_29_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_29_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_2_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_2_cfg_fracn_sd_step_en_attr = "serdes_lane_ana_pll_lane0_reg_2_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_2_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_30_cfg_force_kvcc_done_attr = "serdes_lane_ana_pll_lane0_reg_30_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_code_ovrd_attr = "serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_vreg_offset_en_val_attr = "serdes_lane_ana_pll_lane0_reg_30_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_31_cfg_spare_dig2ana_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_3_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_3_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_3_o_tdc_fine_res_attr = "serdes_lane_ana_pll_lane0_reg_3_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_3_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_cfg_sigma_delta2_sel_attr = "serdes_lane_ana_pll_lane0_reg_4_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_dcoditheren_h_attr = "serdes_lane_ana_pll_lane0_reg_4_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_fbdiv_strobe_h_attr = "serdes_lane_ana_pll_lane0_reg_4_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_feedfwrdcal_en_h_attr = "serdes_lane_ana_pll_lane0_reg_4_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_feedfwrdcal_pause_h_attr = "serdes_lane_ana_pll_lane0_reg_4_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_4_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_5_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_5_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_6_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_6_o_bbinlock_h_attr = "serdes_lane_ana_pll_lane0_reg_6_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_6_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_6_o_tdcdc_en_h_attr = "serdes_lane_ana_pll_lane0_reg_6_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_6_o_tdcovccorr_en_h_attr = "serdes_lane_ana_pll_lane0_reg_6_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_6_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_7_o_dfx_tdc_disable_attr = "serdes_lane_ana_pll_lane0_reg_7_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_7_o_pll_reg_resetb_attr = "serdes_lane_ana_pll_lane0_reg_7_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_7_o_pll_reg_resetb_mode_ctrl_attr = "serdes_lane_ana_pll_lane0_reg_7_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_7_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_7_o_plllc_regen_h_attr = "serdes_lane_ana_pll_lane0_reg_7_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_8_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_8_o_dcocoarse_ovrd_h_attr = "serdes_lane_ana_pll_lane0_reg_8_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_8_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_8_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_cfg_dft_cnt_restart_attr = "serdes_lane_ana_pll_lane0_reg_9_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_cfg_force_tdcdone_at_afcdone_attr = "serdes_lane_ana_pll_lane0_reg_9_cfg_force_tdcdone_at_afcdone_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_o_tdccalexten_h_attr = "serdes_lane_ana_pll_lane0_reg_9_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_o_tdcroen_h_attr = "serdes_lane_ana_pll_lane0_reg_9_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane0_reg_9_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_10_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_11_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_12_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_13_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_13_cfg_plllock_state_sel_attr = "serdes_lane_ana_pll_lane1_reg_13_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_13_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_dcocoarse_ovrden_attr = "serdes_lane_ana_pll_lane1_reg_18_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_18_cfg_full_range_afc_sel_attr = "serdes_lane_ana_pll_lane1_reg_18_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_boost_dtr_const_zeta_attr = "serdes_lane_ana_pll_lane1_reg_19_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_boost_fine_const_zeta_attr = "serdes_lane_ana_pll_lane1_reg_19_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_filter_boostfade_dtr_en_attr = "serdes_lane_ana_pll_lane1_reg_19_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_filter_boostfade_fine_en_attr = "serdes_lane_ana_pll_lane1_reg_19_cfg_filter_boostfade_fine_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_19_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_1_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_1_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_1_o_fracnen_h_attr = "serdes_lane_ana_pll_lane1_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_earlylock_sel_attr = "serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_final_code_sel_attr = "serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_20_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_dcosettle_mode_attr = "serdes_lane_ana_pll_lane1_reg_21_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_dtr_ovrden_attr = "serdes_lane_ana_pll_lane1_reg_21_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_skip_second_afc_calib_attr = "serdes_lane_ana_pll_lane1_reg_21_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_stay_fll_attr = "serdes_lane_ana_pll_lane1_reg_21_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_stay_pll_attr = "serdes_lane_ana_pll_lane1_reg_21_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_21_cfg_tdcbbpd_en_attr = "serdes_lane_ana_pll_lane1_reg_21_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_ssc_track_en_attr = "serdes_lane_ana_pll_lane1_reg_22_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_22_cfg_temp_track_en_attr = "serdes_lane_ana_pll_lane1_reg_22_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_cb56_lane32div_en_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_clkouten_cb_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_clkouten_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_clkouten_lane_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_fbdiv_rat0p5_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_pcs3334_divsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_pcs3334div_en_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_pcs40div_en_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_pll_bypass_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_refclk100div_en_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_refclk100div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_refclk156div_en_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_refclk156div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_sddiv_en_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_sddiv_ratio_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_23_cfg_sddtr_clk_sel_attr = "serdes_lane_ana_pll_lane1_reg_23_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_a2f_en_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_en_peak_sense_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_en_peak_sense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_force_vreglpfbyp_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_obsmux0_del_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_obsmux1_del_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_pll_refclkreg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_ref156div_rat0p5_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_ss_comp_out_sel_attr = "serdes_lane_ana_pll_lane1_reg_24_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_24_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_ramp_dir_ovr_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_ramp_enable_ovr_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_ramp_toggle_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dpso_bypass_mode_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_dtr_modulation_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_fbdiv_clkgate_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_fine_modulation_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_fine_modulation_sel_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_tdcpe_modulation_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_25_cfg_vreg_dac_modulation_en_attr = "serdes_lane_ana_pll_lane1_reg_25_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_26_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_26_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_fw_force_vreg_cal_done_attr = "serdes_lane_ana_pll_lane1_reg_27_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_fw_vreg_accum_ovrd_attr = "serdes_lane_ana_pll_lane1_reg_27_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_inv_vpeak_comb_fb_attr = "serdes_lane_ana_pll_lane1_reg_27_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_inv_vreg_comb_fb_attr = "serdes_lane_ana_pll_lane1_reg_27_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_27_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_28_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_28_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_dft_freq_meas_enable_attr = "serdes_lane_ana_pll_lane1_reg_29_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_29_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_2_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_2_cfg_fracn_sd_step_en_attr = "serdes_lane_ana_pll_lane1_reg_2_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_2_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_30_cfg_force_kvcc_done_attr = "serdes_lane_ana_pll_lane1_reg_30_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_code_ovrd_attr = "serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_vreg_offset_en_val_attr = "serdes_lane_ana_pll_lane1_reg_30_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_31_cfg_spare_dig2ana_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_3_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_3_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_3_o_tdc_fine_res_attr = "serdes_lane_ana_pll_lane1_reg_3_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_3_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_cfg_sigma_delta2_sel_attr = "serdes_lane_ana_pll_lane1_reg_4_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_dcoditheren_h_attr = "serdes_lane_ana_pll_lane1_reg_4_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_fbdiv_strobe_h_attr = "serdes_lane_ana_pll_lane1_reg_4_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_feedfwrdcal_en_h_attr = "serdes_lane_ana_pll_lane1_reg_4_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_feedfwrdcal_pause_h_attr = "serdes_lane_ana_pll_lane1_reg_4_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_4_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_5_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_5_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_6_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_6_o_bbinlock_h_attr = "serdes_lane_ana_pll_lane1_reg_6_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_6_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_6_o_tdcdc_en_h_attr = "serdes_lane_ana_pll_lane1_reg_6_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_6_o_tdcovccorr_en_h_attr = "serdes_lane_ana_pll_lane1_reg_6_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_6_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_7_o_dfx_tdc_disable_attr = "serdes_lane_ana_pll_lane1_reg_7_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_7_o_pll_reg_resetb_attr = "serdes_lane_ana_pll_lane1_reg_7_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_7_o_pll_reg_resetb_mode_ctrl_attr = "serdes_lane_ana_pll_lane1_reg_7_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_7_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_7_o_plllc_regen_h_attr = "serdes_lane_ana_pll_lane1_reg_7_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_8_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_8_o_dcocoarse_ovrd_h_attr = "serdes_lane_ana_pll_lane1_reg_8_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_8_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_8_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_cfg_dft_cnt_restart_attr = "serdes_lane_ana_pll_lane1_reg_9_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_cfg_force_tdcdone_at_afcdone_attr = "serdes_lane_ana_pll_lane1_reg_9_cfg_force_tdcdone_at_afcdone_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_o_tdccalexten_h_attr = "serdes_lane_ana_pll_lane1_reg_9_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_o_tdcroen_h_attr = "serdes_lane_ana_pll_lane1_reg_9_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane1_reg_9_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_10_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_11_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_12_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_13_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_13_cfg_plllock_state_sel_attr = "serdes_lane_ana_pll_lane2_reg_13_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_13_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_dcocoarse_ovrden_attr = "serdes_lane_ana_pll_lane2_reg_18_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_18_cfg_full_range_afc_sel_attr = "serdes_lane_ana_pll_lane2_reg_18_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_boost_dtr_const_zeta_attr = "serdes_lane_ana_pll_lane2_reg_19_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_boost_fine_const_zeta_attr = "serdes_lane_ana_pll_lane2_reg_19_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_filter_boostfade_dtr_en_attr = "serdes_lane_ana_pll_lane2_reg_19_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_filter_boostfade_fine_en_attr = "serdes_lane_ana_pll_lane2_reg_19_cfg_filter_boostfade_fine_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_19_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_1_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_1_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_1_o_fracnen_h_attr = "serdes_lane_ana_pll_lane2_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_earlylock_sel_attr = "serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_final_code_sel_attr = "serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_20_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_dcosettle_mode_attr = "serdes_lane_ana_pll_lane2_reg_21_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_dtr_ovrden_attr = "serdes_lane_ana_pll_lane2_reg_21_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_skip_second_afc_calib_attr = "serdes_lane_ana_pll_lane2_reg_21_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_stay_fll_attr = "serdes_lane_ana_pll_lane2_reg_21_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_stay_pll_attr = "serdes_lane_ana_pll_lane2_reg_21_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_21_cfg_tdcbbpd_en_attr = "serdes_lane_ana_pll_lane2_reg_21_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_ssc_track_en_attr = "serdes_lane_ana_pll_lane2_reg_22_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_22_cfg_temp_track_en_attr = "serdes_lane_ana_pll_lane2_reg_22_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_cb56_lane32div_en_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_clkouten_cb_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_clkouten_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_clkouten_lane_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_fbdiv_rat0p5_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_pcs3334_divsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_pcs3334div_en_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_pcs40div_en_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_pll_bypass_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_refclk100div_en_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_refclk100div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_refclk156div_en_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_refclk156div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_sddiv_en_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_sddiv_ratio_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_23_cfg_sddtr_clk_sel_attr = "serdes_lane_ana_pll_lane2_reg_23_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_a2f_en_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_en_peak_sense_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_en_peak_sense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_force_vreglpfbyp_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_obsmux0_del_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_obsmux1_del_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_pll_refclkreg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_ref156div_rat0p5_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_ss_comp_out_sel_attr = "serdes_lane_ana_pll_lane2_reg_24_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_24_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_ramp_dir_ovr_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_ramp_enable_ovr_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_ramp_toggle_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dpso_bypass_mode_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_dtr_modulation_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_fbdiv_clkgate_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_fine_modulation_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_fine_modulation_sel_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_tdcpe_modulation_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_25_cfg_vreg_dac_modulation_en_attr = "serdes_lane_ana_pll_lane2_reg_25_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_26_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_26_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_fw_force_vreg_cal_done_attr = "serdes_lane_ana_pll_lane2_reg_27_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_fw_vreg_accum_ovrd_attr = "serdes_lane_ana_pll_lane2_reg_27_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_inv_vpeak_comb_fb_attr = "serdes_lane_ana_pll_lane2_reg_27_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_inv_vreg_comb_fb_attr = "serdes_lane_ana_pll_lane2_reg_27_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_27_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_28_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_28_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_dft_freq_meas_enable_attr = "serdes_lane_ana_pll_lane2_reg_29_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_29_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_2_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_2_cfg_fracn_sd_step_en_attr = "serdes_lane_ana_pll_lane2_reg_2_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_2_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_30_cfg_force_kvcc_done_attr = "serdes_lane_ana_pll_lane2_reg_30_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_code_ovrd_attr = "serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_vreg_offset_en_val_attr = "serdes_lane_ana_pll_lane2_reg_30_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_31_cfg_spare_dig2ana_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_3_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_3_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_3_o_tdc_fine_res_attr = "serdes_lane_ana_pll_lane2_reg_3_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_3_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_cfg_sigma_delta2_sel_attr = "serdes_lane_ana_pll_lane2_reg_4_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_dcoditheren_h_attr = "serdes_lane_ana_pll_lane2_reg_4_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_fbdiv_strobe_h_attr = "serdes_lane_ana_pll_lane2_reg_4_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_feedfwrdcal_en_h_attr = "serdes_lane_ana_pll_lane2_reg_4_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_feedfwrdcal_pause_h_attr = "serdes_lane_ana_pll_lane2_reg_4_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_4_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_5_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_5_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_6_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_6_o_bbinlock_h_attr = "serdes_lane_ana_pll_lane2_reg_6_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_6_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_6_o_tdcdc_en_h_attr = "serdes_lane_ana_pll_lane2_reg_6_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_6_o_tdcovccorr_en_h_attr = "serdes_lane_ana_pll_lane2_reg_6_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_6_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_7_o_dfx_tdc_disable_attr = "serdes_lane_ana_pll_lane2_reg_7_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_7_o_pll_reg_resetb_attr = "serdes_lane_ana_pll_lane2_reg_7_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_7_o_pll_reg_resetb_mode_ctrl_attr = "serdes_lane_ana_pll_lane2_reg_7_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_7_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_7_o_plllc_regen_h_attr = "serdes_lane_ana_pll_lane2_reg_7_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_8_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_8_o_dcocoarse_ovrd_h_attr = "serdes_lane_ana_pll_lane2_reg_8_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_8_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_8_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_cfg_dft_cnt_restart_attr = "serdes_lane_ana_pll_lane2_reg_9_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_cfg_force_tdcdone_at_afcdone_attr = "serdes_lane_ana_pll_lane2_reg_9_cfg_force_tdcdone_at_afcdone_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_o_tdccalexten_h_attr = "serdes_lane_ana_pll_lane2_reg_9_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_o_tdcroen_h_attr = "serdes_lane_ana_pll_lane2_reg_9_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane2_reg_9_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_10_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_11_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_12_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_13_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_13_cfg_plllock_state_sel_attr = "serdes_lane_ana_pll_lane3_reg_13_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_13_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_dcocoarse_ovrden_attr = "serdes_lane_ana_pll_lane3_reg_18_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_18_cfg_full_range_afc_sel_attr = "serdes_lane_ana_pll_lane3_reg_18_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_boost_dtr_const_zeta_attr = "serdes_lane_ana_pll_lane3_reg_19_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_boost_fine_const_zeta_attr = "serdes_lane_ana_pll_lane3_reg_19_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_filter_boostfade_dtr_en_attr = "serdes_lane_ana_pll_lane3_reg_19_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_filter_boostfade_fine_en_attr = "serdes_lane_ana_pll_lane3_reg_19_cfg_filter_boostfade_fine_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_19_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_1_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_1_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_1_o_fracnen_h_attr = "serdes_lane_ana_pll_lane3_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_earlylock_sel_attr = "serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_final_code_sel_attr = "serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_20_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_dcosettle_mode_attr = "serdes_lane_ana_pll_lane3_reg_21_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_dtr_ovrden_attr = "serdes_lane_ana_pll_lane3_reg_21_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_skip_second_afc_calib_attr = "serdes_lane_ana_pll_lane3_reg_21_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_stay_fll_attr = "serdes_lane_ana_pll_lane3_reg_21_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_stay_pll_attr = "serdes_lane_ana_pll_lane3_reg_21_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_21_cfg_tdcbbpd_en_attr = "serdes_lane_ana_pll_lane3_reg_21_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_ssc_track_en_attr = "serdes_lane_ana_pll_lane3_reg_22_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_22_cfg_temp_track_en_attr = "serdes_lane_ana_pll_lane3_reg_22_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_cb56_lane32div_en_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_clkouten_cb_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_clkouten_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_clkouten_lane_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_fbdiv_rat0p5_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_pcs3334_divsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_pcs3334div_en_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_pcs40div_en_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_pll_bypass_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_refclk100div_en_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_refclk100div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_refclk156div_en_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_refclk156div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_sddiv_en_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_sddiv_ratio_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_23_cfg_sddtr_clk_sel_attr = "serdes_lane_ana_pll_lane3_reg_23_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_a2f_en_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_en_peak_sense_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_en_peak_sense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_force_vreglpfbyp_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_obsmux0_del_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_obsmux1_del_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_pll_refclkreg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_ref156div_rat0p5_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_ss_comp_out_sel_attr = "serdes_lane_ana_pll_lane3_reg_24_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_24_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_ramp_dir_ovr_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_ramp_enable_ovr_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_ramp_toggle_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dpso_bypass_mode_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_dtr_modulation_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_fbdiv_clkgate_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_fine_modulation_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_fine_modulation_sel_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_tdcpe_modulation_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_25_cfg_vreg_dac_modulation_en_attr = "serdes_lane_ana_pll_lane3_reg_25_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_26_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_26_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_fw_force_vreg_cal_done_attr = "serdes_lane_ana_pll_lane3_reg_27_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_fw_vreg_accum_ovrd_attr = "serdes_lane_ana_pll_lane3_reg_27_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_inv_vpeak_comb_fb_attr = "serdes_lane_ana_pll_lane3_reg_27_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_inv_vreg_comb_fb_attr = "serdes_lane_ana_pll_lane3_reg_27_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_27_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_28_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_28_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_dft_freq_meas_enable_attr = "serdes_lane_ana_pll_lane3_reg_29_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_29_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_2_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_2_cfg_fracn_sd_step_en_attr = "serdes_lane_ana_pll_lane3_reg_2_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_2_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_30_cfg_force_kvcc_done_attr = "serdes_lane_ana_pll_lane3_reg_30_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_code_ovrd_attr = "serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_vreg_offset_en_val_attr = "serdes_lane_ana_pll_lane3_reg_30_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_31_cfg_spare_dig2ana_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_3_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_3_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_3_o_tdc_fine_res_attr = "serdes_lane_ana_pll_lane3_reg_3_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_3_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_cfg_sigma_delta2_sel_attr = "serdes_lane_ana_pll_lane3_reg_4_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_dcoditheren_h_attr = "serdes_lane_ana_pll_lane3_reg_4_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_fbdiv_strobe_h_attr = "serdes_lane_ana_pll_lane3_reg_4_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_feedfwrdcal_en_h_attr = "serdes_lane_ana_pll_lane3_reg_4_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_feedfwrdcal_pause_h_attr = "serdes_lane_ana_pll_lane3_reg_4_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_4_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_5_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_5_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_6_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_6_o_bbinlock_h_attr = "serdes_lane_ana_pll_lane3_reg_6_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_6_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_6_o_tdcdc_en_h_attr = "serdes_lane_ana_pll_lane3_reg_6_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_6_o_tdcovccorr_en_h_attr = "serdes_lane_ana_pll_lane3_reg_6_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_6_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_7_o_dfx_tdc_disable_attr = "serdes_lane_ana_pll_lane3_reg_7_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_7_o_pll_reg_resetb_attr = "serdes_lane_ana_pll_lane3_reg_7_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_7_o_pll_reg_resetb_mode_ctrl_attr = "serdes_lane_ana_pll_lane3_reg_7_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_7_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_7_o_plllc_regen_h_attr = "serdes_lane_ana_pll_lane3_reg_7_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_8_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_8_o_dcocoarse_ovrd_h_attr = "serdes_lane_ana_pll_lane3_reg_8_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_8_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_8_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_cfg_dft_cnt_restart_attr = "serdes_lane_ana_pll_lane3_reg_9_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_cfg_force_tdcdone_at_afcdone_attr = "serdes_lane_ana_pll_lane3_reg_9_cfg_force_tdcdone_at_afcdone_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_o_tdccalexten_h_attr = "serdes_lane_ana_pll_lane3_reg_9_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_o_tdcroen_h_attr = "serdes_lane_ana_pll_lane3_reg_9_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_pll_lane3_reg_9_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_10_afe_spare_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_11_afe_spare_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_afe_st1_config_1_reg_spare_attr = "serdes_lane_ana_rx1_lane0_reg_12_afe_st1_config_1_reg_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_st1_en_vcmbf_attr = "serdes_lane_ana_rx1_lane0_reg_12_st1_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_st1_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_st1_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_st1_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_st1_vcmnshift_attr = "serdes_lane_ana_rx1_lane0_reg_12_st1_vcmnshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_12_st3_bpktrm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_afe_st2_config_reg_sp_attr = "serdes_lane_ana_rx1_lane0_reg_13_afe_st2_config_reg_sp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_st2_bctune_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_st2_en_vcmbf_attr = "serdes_lane_ana_rx1_lane0_reg_13_st2_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_st2_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_st2_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_st2_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_13_st2_vcmshift_attr = "serdes_lane_ana_rx1_lane0_reg_13_st2_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_14_afe_st3_config_reg_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_14_st3_brload_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_14_st3_en_vcmbf_attr = "serdes_lane_ana_rx1_lane0_reg_14_st3_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_14_st3_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_14_st3_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_14_st3_vcmshift_attr = "serdes_lane_ana_rx1_lane0_reg_14_st3_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_15_ioutp_abs_100u_31_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_15_ioutp_abs_100u_32_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_15_ioutp_abs_100u_33_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_15_ioutp_abs_100u_34_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_15_ioutp_abs_100u_35_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_15_ioutp_abs_100u_36_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_16_ioutp_abs_100u_37_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_16_ioutp_abs_100u_38_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_16_ioutp_abs_100u_39_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_16_ioutp_abs_100u_40_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_16_ioutp_abs_100u_41_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_16_ioutp_abs_100u_42_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_17_ioutp_abs_100u_43_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_17_ioutp_abs_100u_44_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_17_ioutp_abs_100u_45_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_17_ioutp_abs_100u_46_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_17_ioutp_abs_100u_47_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_17_ioutp_abs_100u_48_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon1_en_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_100ua_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_50ua_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_v_n_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_v_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_v_p_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon1_minus_v_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon2_en_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon2_minus_100ua_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon2_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_dcmon2_minus_50ua_attr = "serdes_lane_ana_rx1_lane0_reg_18_dcmon2_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_ioutp_abs_100u_49_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_ioutp_abs_100u_50_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_vref_n_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_18_vref_p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_19_ioutn_abs_50u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_19_ioutn_abs_50u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_19_ioutn_abs_50u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_19_ioutn_abs_50u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_19_ioutn_abs_50u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_19_ioutn_abs_50u_d_n_master_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_1_afe_bias_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_1_bias_en400_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_20_ioutn_abs_50u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_20_ioutn_abs_50u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_20_ioutn_abs_50u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_20_ioutn_abs_50u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_20_ioutn_abs_50u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_20_ioutn_abs_50u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_21_ioutn_abs_50u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_21_ioutn_abs_50u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_21_ioutn_abs_50u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_21_ioutn_abs_50u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_21_ioutn_abs_50u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_21_ioutn_abs_50u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_22_ioutn_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_22_ioutn_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_22_ioutn_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_22_ioutn_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_22_ioutn_abs_50u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_22_ioutn_abs_50u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_23_ioutn_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_23_ioutn_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_23_ioutn_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_23_ioutn_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_23_ioutn_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_23_ioutn_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_24_ioutn_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_24_ioutn_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_24_ioutn_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_24_ioutn_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_24_ioutn_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_24_ioutn_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_25_ioutn_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_25_ioutn_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_25_ioutn_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_25_ioutn_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_25_ioutn_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_25_ioutn_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_26_ioutn_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_26_ioutn_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_26_ioutn_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_26_ioutn_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_26_ioutn_abs_100u_pchref_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_26_ioutn_abs_100u_tx1to100_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_27_ioutn_abs_200u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_27_ioutn_abs_200u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_27_ioutn_abs_200u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_27_ioutn_abs_200u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_27_ioutn_abs_200u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_27_ioutp_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_28_ioutp_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_28_ioutp_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_28_ioutp_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_28_ioutp_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_28_ioutp_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_28_ioutp_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_29_ioutp_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_29_ioutp_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_29_ioutp_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_29_ioutp_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_29_ioutp_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_29_ioutp_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_en_acmp_attr = "serdes_lane_ana_rx1_lane0_reg_2_en_acmp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_en_amon_attr = "serdes_lane_ana_rx1_lane0_reg_2_en_amon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_inp_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_rgen_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_rtrm_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_st1_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_st2_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_2_st3_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_30_ioutp_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_30_ioutp_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_30_ioutp_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_30_ioutp_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_30_ioutp_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_30_ioutp_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_31_ioutp_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_31_ioutp_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_31_ioutp_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_31_ioutp_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_31_ioutp_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_31_ioutp_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_32_ioutp_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_32_ioutp_abs_100u_26_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_32_ioutp_abs_100u_27_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_32_ioutp_abs_100u_28_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_32_ioutp_abs_100u_29_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_32_ioutp_abs_100u_30_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_3_afe_odac_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_3_odac1_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_3_odac2_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_3_odac3_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_3_odac_en_attr = "serdes_lane_ana_rx1_lane0_reg_3_odac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_3_odac_range_attr = "serdes_lane_ana_rx1_lane0_reg_3_odac_range_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_4_afe_odac_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_4_odac1_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_4_odac1_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_4_odac2_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_4_odac2_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_4_odac3_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_5_afe_refgen_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_5_rgen_bitrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_5_rgen_bitrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_5_rgen_bvtrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_5_rgen_bvtrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_6_afe_refgen_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_6_rgen_bsel1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_6_rgen_bsel2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_6_rgen_bsel3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_6_rgen_bseli_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_afe_bivcm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_st1_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_st1_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_st2_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_st2_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_st3_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_7_st3_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_afe_inp_rtrm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_afe_slicer_in_attr = "serdes_lane_ana_rx1_lane0_reg_8_afe_slicer_in_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_in_bypass_attr = "serdes_lane_ana_rx1_lane0_reg_8_in_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_inp_trmc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_inp_trmp0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_inp_trmp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_inp_trmp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_rtrm_btune_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_8_rtrm_vcm_swt_attr = "serdes_lane_ana_rx1_lane0_reg_8_rtrm_vcm_swt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane0_reg_9_afe_spare_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_10_afe_spare_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_11_afe_spare_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_afe_st1_config_1_reg_spare_attr = "serdes_lane_ana_rx1_lane1_reg_12_afe_st1_config_1_reg_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_st1_en_vcmbf_attr = "serdes_lane_ana_rx1_lane1_reg_12_st1_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_st1_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_st1_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_st1_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_st1_vcmnshift_attr = "serdes_lane_ana_rx1_lane1_reg_12_st1_vcmnshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_12_st3_bpktrm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_afe_st2_config_reg_sp_attr = "serdes_lane_ana_rx1_lane1_reg_13_afe_st2_config_reg_sp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_st2_bctune_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_st2_en_vcmbf_attr = "serdes_lane_ana_rx1_lane1_reg_13_st2_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_st2_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_st2_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_st2_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_13_st2_vcmshift_attr = "serdes_lane_ana_rx1_lane1_reg_13_st2_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_14_afe_st3_config_reg_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_14_st3_brload_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_14_st3_en_vcmbf_attr = "serdes_lane_ana_rx1_lane1_reg_14_st3_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_14_st3_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_14_st3_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_14_st3_vcmshift_attr = "serdes_lane_ana_rx1_lane1_reg_14_st3_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_15_ioutp_abs_100u_31_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_15_ioutp_abs_100u_32_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_15_ioutp_abs_100u_33_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_15_ioutp_abs_100u_34_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_15_ioutp_abs_100u_35_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_15_ioutp_abs_100u_36_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_16_ioutp_abs_100u_37_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_16_ioutp_abs_100u_38_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_16_ioutp_abs_100u_39_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_16_ioutp_abs_100u_40_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_16_ioutp_abs_100u_41_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_16_ioutp_abs_100u_42_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_17_ioutp_abs_100u_43_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_17_ioutp_abs_100u_44_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_17_ioutp_abs_100u_45_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_17_ioutp_abs_100u_46_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_17_ioutp_abs_100u_47_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_17_ioutp_abs_100u_48_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon1_en_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_100ua_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_50ua_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_v_n_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_v_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_v_p_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon1_minus_v_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon2_en_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon2_minus_100ua_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon2_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_dcmon2_minus_50ua_attr = "serdes_lane_ana_rx1_lane1_reg_18_dcmon2_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_ioutp_abs_100u_49_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_ioutp_abs_100u_50_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_vref_n_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_18_vref_p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_19_ioutn_abs_50u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_19_ioutn_abs_50u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_19_ioutn_abs_50u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_19_ioutn_abs_50u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_19_ioutn_abs_50u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_19_ioutn_abs_50u_d_n_master_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_1_afe_bias_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_1_bias_en400_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_20_ioutn_abs_50u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_20_ioutn_abs_50u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_20_ioutn_abs_50u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_20_ioutn_abs_50u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_20_ioutn_abs_50u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_20_ioutn_abs_50u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_21_ioutn_abs_50u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_21_ioutn_abs_50u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_21_ioutn_abs_50u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_21_ioutn_abs_50u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_21_ioutn_abs_50u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_21_ioutn_abs_50u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_22_ioutn_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_22_ioutn_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_22_ioutn_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_22_ioutn_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_22_ioutn_abs_50u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_22_ioutn_abs_50u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_23_ioutn_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_23_ioutn_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_23_ioutn_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_23_ioutn_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_23_ioutn_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_23_ioutn_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_24_ioutn_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_24_ioutn_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_24_ioutn_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_24_ioutn_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_24_ioutn_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_24_ioutn_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_25_ioutn_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_25_ioutn_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_25_ioutn_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_25_ioutn_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_25_ioutn_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_25_ioutn_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_26_ioutn_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_26_ioutn_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_26_ioutn_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_26_ioutn_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_26_ioutn_abs_100u_pchref_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_26_ioutn_abs_100u_tx1to100_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_27_ioutn_abs_200u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_27_ioutn_abs_200u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_27_ioutn_abs_200u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_27_ioutn_abs_200u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_27_ioutn_abs_200u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_27_ioutp_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_28_ioutp_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_28_ioutp_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_28_ioutp_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_28_ioutp_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_28_ioutp_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_28_ioutp_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_29_ioutp_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_29_ioutp_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_29_ioutp_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_29_ioutp_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_29_ioutp_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_29_ioutp_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_en_acmp_attr = "serdes_lane_ana_rx1_lane1_reg_2_en_acmp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_en_amon_attr = "serdes_lane_ana_rx1_lane1_reg_2_en_amon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_inp_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_rgen_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_rtrm_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_st1_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_st2_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_2_st3_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_30_ioutp_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_30_ioutp_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_30_ioutp_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_30_ioutp_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_30_ioutp_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_30_ioutp_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_31_ioutp_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_31_ioutp_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_31_ioutp_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_31_ioutp_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_31_ioutp_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_31_ioutp_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_32_ioutp_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_32_ioutp_abs_100u_26_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_32_ioutp_abs_100u_27_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_32_ioutp_abs_100u_28_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_32_ioutp_abs_100u_29_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_32_ioutp_abs_100u_30_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_3_afe_odac_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_3_odac1_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_3_odac2_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_3_odac3_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_3_odac_en_attr = "serdes_lane_ana_rx1_lane1_reg_3_odac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_3_odac_range_attr = "serdes_lane_ana_rx1_lane1_reg_3_odac_range_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_4_afe_odac_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_4_odac1_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_4_odac1_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_4_odac2_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_4_odac2_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_4_odac3_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_5_afe_refgen_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_5_rgen_bitrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_5_rgen_bitrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_5_rgen_bvtrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_5_rgen_bvtrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_6_afe_refgen_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_6_rgen_bsel1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_6_rgen_bsel2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_6_rgen_bsel3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_6_rgen_bseli_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_afe_bivcm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_st1_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_st1_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_st2_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_st2_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_st3_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_7_st3_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_afe_inp_rtrm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_afe_slicer_in_attr = "serdes_lane_ana_rx1_lane1_reg_8_afe_slicer_in_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_in_bypass_attr = "serdes_lane_ana_rx1_lane1_reg_8_in_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_inp_trmc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_inp_trmp0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_inp_trmp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_inp_trmp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_rtrm_btune_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_8_rtrm_vcm_swt_attr = "serdes_lane_ana_rx1_lane1_reg_8_rtrm_vcm_swt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane1_reg_9_afe_spare_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_10_afe_spare_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_11_afe_spare_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_afe_st1_config_1_reg_spare_attr = "serdes_lane_ana_rx1_lane2_reg_12_afe_st1_config_1_reg_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_st1_en_vcmbf_attr = "serdes_lane_ana_rx1_lane2_reg_12_st1_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_st1_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_st1_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_st1_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_st1_vcmnshift_attr = "serdes_lane_ana_rx1_lane2_reg_12_st1_vcmnshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_12_st3_bpktrm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_afe_st2_config_reg_sp_attr = "serdes_lane_ana_rx1_lane2_reg_13_afe_st2_config_reg_sp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_st2_bctune_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_st2_en_vcmbf_attr = "serdes_lane_ana_rx1_lane2_reg_13_st2_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_st2_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_st2_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_st2_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_13_st2_vcmshift_attr = "serdes_lane_ana_rx1_lane2_reg_13_st2_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_14_afe_st3_config_reg_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_14_st3_brload_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_14_st3_en_vcmbf_attr = "serdes_lane_ana_rx1_lane2_reg_14_st3_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_14_st3_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_14_st3_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_14_st3_vcmshift_attr = "serdes_lane_ana_rx1_lane2_reg_14_st3_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_15_ioutp_abs_100u_31_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_15_ioutp_abs_100u_32_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_15_ioutp_abs_100u_33_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_15_ioutp_abs_100u_34_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_15_ioutp_abs_100u_35_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_15_ioutp_abs_100u_36_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_16_ioutp_abs_100u_37_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_16_ioutp_abs_100u_38_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_16_ioutp_abs_100u_39_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_16_ioutp_abs_100u_40_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_16_ioutp_abs_100u_41_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_16_ioutp_abs_100u_42_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_17_ioutp_abs_100u_43_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_17_ioutp_abs_100u_44_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_17_ioutp_abs_100u_45_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_17_ioutp_abs_100u_46_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_17_ioutp_abs_100u_47_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_17_ioutp_abs_100u_48_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon1_en_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_100ua_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_50ua_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_v_n_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_v_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_v_p_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon1_minus_v_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon2_en_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon2_minus_100ua_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon2_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_dcmon2_minus_50ua_attr = "serdes_lane_ana_rx1_lane2_reg_18_dcmon2_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_ioutp_abs_100u_49_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_ioutp_abs_100u_50_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_vref_n_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_18_vref_p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_19_ioutn_abs_50u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_19_ioutn_abs_50u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_19_ioutn_abs_50u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_19_ioutn_abs_50u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_19_ioutn_abs_50u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_19_ioutn_abs_50u_d_n_master_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_1_afe_bias_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_1_bias_en400_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_20_ioutn_abs_50u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_20_ioutn_abs_50u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_20_ioutn_abs_50u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_20_ioutn_abs_50u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_20_ioutn_abs_50u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_20_ioutn_abs_50u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_21_ioutn_abs_50u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_21_ioutn_abs_50u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_21_ioutn_abs_50u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_21_ioutn_abs_50u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_21_ioutn_abs_50u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_21_ioutn_abs_50u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_22_ioutn_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_22_ioutn_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_22_ioutn_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_22_ioutn_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_22_ioutn_abs_50u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_22_ioutn_abs_50u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_23_ioutn_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_23_ioutn_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_23_ioutn_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_23_ioutn_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_23_ioutn_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_23_ioutn_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_24_ioutn_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_24_ioutn_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_24_ioutn_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_24_ioutn_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_24_ioutn_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_24_ioutn_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_25_ioutn_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_25_ioutn_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_25_ioutn_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_25_ioutn_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_25_ioutn_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_25_ioutn_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_26_ioutn_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_26_ioutn_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_26_ioutn_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_26_ioutn_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_26_ioutn_abs_100u_pchref_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_26_ioutn_abs_100u_tx1to100_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_27_ioutn_abs_200u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_27_ioutn_abs_200u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_27_ioutn_abs_200u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_27_ioutn_abs_200u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_27_ioutn_abs_200u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_27_ioutp_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_28_ioutp_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_28_ioutp_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_28_ioutp_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_28_ioutp_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_28_ioutp_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_28_ioutp_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_29_ioutp_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_29_ioutp_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_29_ioutp_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_29_ioutp_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_29_ioutp_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_29_ioutp_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_en_acmp_attr = "serdes_lane_ana_rx1_lane2_reg_2_en_acmp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_en_amon_attr = "serdes_lane_ana_rx1_lane2_reg_2_en_amon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_inp_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_rgen_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_rtrm_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_st1_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_st2_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_2_st3_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_30_ioutp_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_30_ioutp_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_30_ioutp_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_30_ioutp_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_30_ioutp_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_30_ioutp_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_31_ioutp_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_31_ioutp_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_31_ioutp_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_31_ioutp_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_31_ioutp_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_31_ioutp_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_32_ioutp_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_32_ioutp_abs_100u_26_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_32_ioutp_abs_100u_27_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_32_ioutp_abs_100u_28_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_32_ioutp_abs_100u_29_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_32_ioutp_abs_100u_30_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_3_afe_odac_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_3_odac1_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_3_odac2_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_3_odac3_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_3_odac_en_attr = "serdes_lane_ana_rx1_lane2_reg_3_odac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_3_odac_range_attr = "serdes_lane_ana_rx1_lane2_reg_3_odac_range_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_4_afe_odac_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_4_odac1_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_4_odac1_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_4_odac2_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_4_odac2_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_4_odac3_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_5_afe_refgen_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_5_rgen_bitrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_5_rgen_bitrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_5_rgen_bvtrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_5_rgen_bvtrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_6_afe_refgen_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_6_rgen_bsel1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_6_rgen_bsel2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_6_rgen_bsel3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_6_rgen_bseli_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_afe_bivcm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_st1_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_st1_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_st2_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_st2_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_st3_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_7_st3_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_afe_inp_rtrm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_afe_slicer_in_attr = "serdes_lane_ana_rx1_lane2_reg_8_afe_slicer_in_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_in_bypass_attr = "serdes_lane_ana_rx1_lane2_reg_8_in_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_inp_trmc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_inp_trmp0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_inp_trmp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_inp_trmp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_rtrm_btune_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_8_rtrm_vcm_swt_attr = "serdes_lane_ana_rx1_lane2_reg_8_rtrm_vcm_swt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane2_reg_9_afe_spare_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_10_afe_spare_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_11_afe_spare_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_afe_st1_config_1_reg_spare_attr = "serdes_lane_ana_rx1_lane3_reg_12_afe_st1_config_1_reg_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_st1_en_vcmbf_attr = "serdes_lane_ana_rx1_lane3_reg_12_st1_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_st1_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_st1_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_st1_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_st1_vcmnshift_attr = "serdes_lane_ana_rx1_lane3_reg_12_st1_vcmnshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_12_st3_bpktrm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_afe_st2_config_reg_sp_attr = "serdes_lane_ana_rx1_lane3_reg_13_afe_st2_config_reg_sp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_st2_bctune_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_st2_en_vcmbf_attr = "serdes_lane_ana_rx1_lane3_reg_13_st2_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_st2_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_st2_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_st2_grload_attr = 34;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_13_st2_vcmshift_attr = "serdes_lane_ana_rx1_lane3_reg_13_st2_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_14_afe_st3_config_reg_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_14_st3_brload_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_14_st3_en_vcmbf_attr = "serdes_lane_ana_rx1_lane3_reg_14_st3_en_vcmbf_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_14_st3_ggain_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_14_st3_ggain_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_14_st3_vcmshift_attr = "serdes_lane_ana_rx1_lane3_reg_14_st3_vcmshift_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_15_ioutp_abs_100u_31_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_15_ioutp_abs_100u_32_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_15_ioutp_abs_100u_33_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_15_ioutp_abs_100u_34_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_15_ioutp_abs_100u_35_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_15_ioutp_abs_100u_36_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_16_ioutp_abs_100u_37_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_16_ioutp_abs_100u_38_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_16_ioutp_abs_100u_39_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_16_ioutp_abs_100u_40_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_16_ioutp_abs_100u_41_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_16_ioutp_abs_100u_42_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_17_ioutp_abs_100u_43_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_17_ioutp_abs_100u_44_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_17_ioutp_abs_100u_45_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_17_ioutp_abs_100u_46_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_17_ioutp_abs_100u_47_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_17_ioutp_abs_100u_48_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon1_en_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_100ua_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_50ua_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_v_n_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_v_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_v_p_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon1_minus_v_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon2_en_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon2_minus_100ua_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon2_minus_100ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_dcmon2_minus_50ua_attr = "serdes_lane_ana_rx1_lane3_reg_18_dcmon2_minus_50ua_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_ioutp_abs_100u_49_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_ioutp_abs_100u_50_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_vref_n_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_18_vref_p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_19_ioutn_abs_50u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_19_ioutn_abs_50u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_19_ioutn_abs_50u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_19_ioutn_abs_50u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_19_ioutn_abs_50u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_19_ioutn_abs_50u_d_n_master_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_1_afe_bias_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_1_bias_en400_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_20_ioutn_abs_50u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_20_ioutn_abs_50u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_20_ioutn_abs_50u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_20_ioutn_abs_50u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_20_ioutn_abs_50u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_20_ioutn_abs_50u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_21_ioutn_abs_50u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_21_ioutn_abs_50u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_21_ioutn_abs_50u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_21_ioutn_abs_50u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_21_ioutn_abs_50u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_21_ioutn_abs_50u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_22_ioutn_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_22_ioutn_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_22_ioutn_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_22_ioutn_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_22_ioutn_abs_50u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_22_ioutn_abs_50u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_23_ioutn_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_23_ioutn_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_23_ioutn_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_23_ioutn_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_23_ioutn_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_23_ioutn_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_24_ioutn_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_24_ioutn_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_24_ioutn_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_24_ioutn_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_24_ioutn_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_24_ioutn_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_25_ioutn_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_25_ioutn_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_25_ioutn_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_25_ioutn_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_25_ioutn_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_25_ioutn_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_26_ioutn_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_26_ioutn_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_26_ioutn_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_26_ioutn_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_26_ioutn_abs_100u_pchref_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_26_ioutn_abs_100u_tx1to100_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_27_ioutn_abs_200u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_27_ioutn_abs_200u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_27_ioutn_abs_200u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_27_ioutn_abs_200u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_27_ioutn_abs_200u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_27_ioutp_abs_100u_0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_28_ioutp_abs_100u_1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_28_ioutp_abs_100u_2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_28_ioutp_abs_100u_3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_28_ioutp_abs_100u_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_28_ioutp_abs_100u_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_28_ioutp_abs_100u_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_29_ioutp_abs_100u_10_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_29_ioutp_abs_100u_11_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_29_ioutp_abs_100u_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_29_ioutp_abs_100u_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_29_ioutp_abs_100u_8_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_29_ioutp_abs_100u_9_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_en_acmp_attr = "serdes_lane_ana_rx1_lane3_reg_2_en_acmp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_en_amon_attr = "serdes_lane_ana_rx1_lane3_reg_2_en_amon_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_inp_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_rgen_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_rtrm_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_st1_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_st2_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_2_st3_monen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_30_ioutp_abs_100u_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_30_ioutp_abs_100u_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_30_ioutp_abs_100u_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_30_ioutp_abs_100u_16_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_30_ioutp_abs_100u_17_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_30_ioutp_abs_100u_18_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_31_ioutp_abs_100u_19_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_31_ioutp_abs_100u_20_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_31_ioutp_abs_100u_21_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_31_ioutp_abs_100u_22_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_31_ioutp_abs_100u_23_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_31_ioutp_abs_100u_24_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_32_ioutp_abs_100u_25_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_32_ioutp_abs_100u_26_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_32_ioutp_abs_100u_27_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_32_ioutp_abs_100u_28_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_32_ioutp_abs_100u_29_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_32_ioutp_abs_100u_30_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_3_afe_odac_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_3_odac1_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_3_odac2_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_3_odac3_gmsb_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_3_odac_en_attr = "serdes_lane_ana_rx1_lane3_reg_3_odac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_3_odac_range_attr = "serdes_lane_ana_rx1_lane3_reg_3_odac_range_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_4_afe_odac_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_4_odac1_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_4_odac1_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_4_odac2_gdmc_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_4_odac2_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_4_odac3_glsb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_5_afe_refgen_0_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_5_rgen_bitrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_5_rgen_bitrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_5_rgen_bvtrm0p5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_5_rgen_bvtrm1p0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_6_afe_refgen_1_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_6_rgen_bsel1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_6_rgen_bsel2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_6_rgen_bsel3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_6_rgen_bseli_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_afe_bivcm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_st1_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_st1_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_st2_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_st2_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_st3_bivcm_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_7_st3_bivcm_p_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_afe_inp_rtrm_reg_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_afe_slicer_in_attr = "serdes_lane_ana_rx1_lane3_reg_8_afe_slicer_in_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_in_bypass_attr = "serdes_lane_ana_rx1_lane3_reg_8_in_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_inp_trmc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_inp_trmp0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_inp_trmp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_inp_trmp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_rtrm_btune_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_8_rtrm_vcm_swt_attr = "serdes_lane_ana_rx1_lane3_reg_8_rtrm_vcm_swt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx1_lane3_reg_9_afe_spare_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_1_vref_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_cmp_en_attr = "serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_cmp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_ldo_0p8_en_attr = "serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_ldo_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_ldo_0p9_en_attr = "serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_ldo_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_sampler_en_attr = "serdes_lane_ana_rx2_lane0_reg_1_vref_dcmon_sampler_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_1_vref_sampler_sel_attr = 603;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_2_vref_ldo_0p8_sel_attr = 902;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_2_vref_ldo_0p9_sel_attr = 972;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_2_vref_ldo_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_comp_en_attr = "serdes_lane_ana_rx2_lane0_reg_3_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_ofstn_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_ofstn_sgn_attr = "serdes_lane_ana_rx2_lane0_reg_3_ofstn_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_ofstp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_ofstp_sgn_attr = "serdes_lane_ana_rx2_lane0_reg_3_ofstp_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_pre_cmp_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_pre_cmp_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_3_rx_comparator_spare_nc_attr = "serdes_lane_ana_rx2_lane0_reg_3_rx_comparator_spare_nc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_4_rx_comparator_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_5_dco_cal_sp_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_5_dco_ibuf_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_5_dco_vb2comp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_5_dco_vb_gate_trim_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_6_dco_config_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_6_dco_cs_rtrim_attr = 38;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_6_dco_cs_vbn2_trim_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_6_dco_cs_vbp2_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_6_dco_vcpi_trim_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_7_dco_dcmon1_en_attr = "serdes_lane_ana_rx2_lane0_reg_7_dco_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_7_dco_dcmon1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_7_dco_dcmon2_en_attr = "serdes_lane_ana_rx2_lane0_reg_7_dco_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_7_dco_dcmon2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane0_reg_7_dco_tst_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_1_vref_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_cmp_en_attr = "serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_cmp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_ldo_0p8_en_attr = "serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_ldo_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_ldo_0p9_en_attr = "serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_ldo_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_sampler_en_attr = "serdes_lane_ana_rx2_lane1_reg_1_vref_dcmon_sampler_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_1_vref_sampler_sel_attr = 603;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_2_vref_ldo_0p8_sel_attr = 902;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_2_vref_ldo_0p9_sel_attr = 972;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_2_vref_ldo_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_comp_en_attr = "serdes_lane_ana_rx2_lane1_reg_3_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_ofstn_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_ofstn_sgn_attr = "serdes_lane_ana_rx2_lane1_reg_3_ofstn_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_ofstp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_ofstp_sgn_attr = "serdes_lane_ana_rx2_lane1_reg_3_ofstp_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_pre_cmp_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_pre_cmp_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_3_rx_comparator_spare_nc_attr = "serdes_lane_ana_rx2_lane1_reg_3_rx_comparator_spare_nc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_4_rx_comparator_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_5_dco_cal_sp_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_5_dco_ibuf_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_5_dco_vb2comp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_5_dco_vb_gate_trim_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_6_dco_config_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_6_dco_cs_rtrim_attr = 38;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_6_dco_cs_vbn2_trim_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_6_dco_cs_vbp2_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_6_dco_vcpi_trim_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_7_dco_dcmon1_en_attr = "serdes_lane_ana_rx2_lane1_reg_7_dco_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_7_dco_dcmon1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_7_dco_dcmon2_en_attr = "serdes_lane_ana_rx2_lane1_reg_7_dco_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_7_dco_dcmon2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane1_reg_7_dco_tst_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_1_vref_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_cmp_en_attr = "serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_cmp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_ldo_0p8_en_attr = "serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_ldo_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_ldo_0p9_en_attr = "serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_ldo_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_sampler_en_attr = "serdes_lane_ana_rx2_lane2_reg_1_vref_dcmon_sampler_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_1_vref_sampler_sel_attr = 603;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_2_vref_ldo_0p8_sel_attr = 902;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_2_vref_ldo_0p9_sel_attr = 972;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_2_vref_ldo_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_comp_en_attr = "serdes_lane_ana_rx2_lane2_reg_3_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_ofstn_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_ofstn_sgn_attr = "serdes_lane_ana_rx2_lane2_reg_3_ofstn_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_ofstp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_ofstp_sgn_attr = "serdes_lane_ana_rx2_lane2_reg_3_ofstp_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_pre_cmp_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_pre_cmp_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_3_rx_comparator_spare_nc_attr = "serdes_lane_ana_rx2_lane2_reg_3_rx_comparator_spare_nc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_4_rx_comparator_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_5_dco_cal_sp_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_5_dco_ibuf_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_5_dco_vb2comp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_5_dco_vb_gate_trim_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_6_dco_config_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_6_dco_cs_rtrim_attr = 38;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_6_dco_cs_vbn2_trim_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_6_dco_cs_vbp2_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_6_dco_vcpi_trim_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_7_dco_dcmon1_en_attr = "serdes_lane_ana_rx2_lane2_reg_7_dco_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_7_dco_dcmon1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_7_dco_dcmon2_en_attr = "serdes_lane_ana_rx2_lane2_reg_7_dco_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_7_dco_dcmon2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane2_reg_7_dco_tst_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_1_vref_cmp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_cmp_en_attr = "serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_cmp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_ldo_0p8_en_attr = "serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_ldo_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_ldo_0p9_en_attr = "serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_ldo_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_sampler_en_attr = "serdes_lane_ana_rx2_lane3_reg_1_vref_dcmon_sampler_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_1_vref_sampler_sel_attr = 603;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_2_vref_ldo_0p8_sel_attr = 902;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_2_vref_ldo_0p9_sel_attr = 972;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_2_vref_ldo_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_comp_en_attr = "serdes_lane_ana_rx2_lane3_reg_3_comp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_ofstn_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_ofstn_sgn_attr = "serdes_lane_ana_rx2_lane3_reg_3_ofstn_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_ofstp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_ofstp_sgn_attr = "serdes_lane_ana_rx2_lane3_reg_3_ofstp_sgn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_pre_cmp_seln_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_pre_cmp_selp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_3_rx_comparator_spare_nc_attr = "serdes_lane_ana_rx2_lane3_reg_3_rx_comparator_spare_nc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_4_rx_comparator_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_5_dco_cal_sp_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_5_dco_ibuf_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_5_dco_vb2comp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_5_dco_vb_gate_trim_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_6_dco_config_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_6_dco_cs_rtrim_attr = 38;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_6_dco_cs_vbn2_trim_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_6_dco_cs_vbp2_trim_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_6_dco_vcpi_trim_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_7_dco_dcmon1_en_attr = "serdes_lane_ana_rx2_lane3_reg_7_dco_dcmon1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_7_dco_dcmon1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_7_dco_dcmon2_en_attr = "serdes_lane_ana_rx2_lane3_reg_7_dco_dcmon2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_7_dco_dcmon2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_rx2_lane3_reg_7_dco_tst_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_amon_pulldown_en_attr = "serdes_lane_ana_tx_lane0_reg_10_csr_txclk_amon_pulldown_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_amoni_sel_attr = "serdes_lane_ana_tx_lane0_reg_10_csr_txclk_amoni_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_amonv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_clk_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_incr_i_attr = "serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_incr_q_attr = "serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_range_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_coarse_dcc_range_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_dcc_i_amon_en_attr = "serdes_lane_ana_tx_lane0_reg_10_csr_txclk_dcc_i_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_10_csr_txclk_dcc_q_amon_en_attr = "serdes_lane_ana_tx_lane0_reg_10_csr_txclk_dcc_q_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_dcc_crs_vrefn_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_dcc_crs_vrefp_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_incr_i_attr = "serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_incr_q_attr = "serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_range_i_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_fine_dcc_range_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_ibias_ctrl_dcc_dacn_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_11_csr_txclk_ibias_ctrl_dcc_dacp_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_ibias_ctrl_dcc_dacn_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_ibias_ctrl_dcc_dacp_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_qec_corsctrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_qec_corsctrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_qec_crs_dll_q_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_12_csr_txclk_qec_crs_dll_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_13_csr_txclk_qec_crs_i_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_13_csr_txclk_qec_crs_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_13_csr_txclk_qec_finectrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_13_csr_txclk_qec_finectrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_bypass_0p8_en_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_bypass_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_bypass_0p9_en_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_bypass_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_cmp_out_en_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_cmp_out_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_cmp_out_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_dcmon_en_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_enable_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_leaker_en_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_leaker_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_leaker_tune_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_14_csr_ldo_pwrdn_en_attr = "serdes_lane_ana_tx_lane0_reg_14_csr_ldo_pwrdn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_15_csr_drv_pd_cs_nmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_15_csr_drv_rterm_enb_attr = "serdes_lane_ana_tx_lane0_reg_15_csr_drv_rterm_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_15_csr_loadgen_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_15_csr_pisoclk_flip_attr = "serdes_lane_ana_tx_lane0_reg_15_csr_pisoclk_flip_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_15_csr_tx_rterm_ctl_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_16_csr_drv_cs_com_enb_attr = "serdes_lane_ana_tx_lane0_reg_16_csr_drv_cs_com_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_16_csr_drv_tx_cmp_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_16_csr_drv_tx_cmp_rd_select_attr = "serdes_lane_ana_tx_lane0_reg_16_csr_drv_tx_cmp_rd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_16_csr_drv_tx_mode64b0_32b1_attr = "serdes_lane_ana_tx_lane0_reg_16_csr_drv_tx_mode64b0_32b1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_17_reg2hwa_cfg_avg_eng_start_attr = "serdes_lane_ana_tx_lane0_reg_17_reg2hwa_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_18_reg2hwa_cfg_avg_eng_limit_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_1_csr_lgc_reset_bar_attr = "serdes_lane_ana_tx_lane0_reg_1_csr_lgc_reset_bar_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_lanedig_o_ldo_stable_attr = "serdes_lane_ana_tx_lane0_reg_22_csr_lanedig_o_ldo_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_lanedig_o_tx_caldone_attr = "serdes_lane_ana_tx_lane0_reg_22_csr_lanedig_o_tx_caldone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_lanedig_o_txclk_ready_attr = "serdes_lane_ana_tx_lane0_reg_22_csr_lanedig_o_txclk_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_probe0_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_probe0_txvisa_en_attr = "serdes_lane_ana_tx_lane0_reg_22_csr_probe0_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_probe1_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_22_csr_probe1_txvisa_en_attr = "serdes_lane_ana_tx_lane0_reg_22_csr_probe1_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_23_cmp_mirror_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_2_o_spare_a_rw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_3_o_spare_b_rw_attr = 16383;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_5_cmp_addr_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_5_cmp_addr_mask_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_5_cmp_mirror_rd_select_attr = "serdes_lane_ana_tx_lane0_reg_5_cmp_mirror_rd_select_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_6_csr_txclk_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_6_csr_txclk_dfx2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_6_csr_txclk_dfx_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_6_csr_txclk_dfx_lm1_en_attr = "serdes_lane_ana_tx_lane0_reg_6_csr_txclk_dfx_lm1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_6_csr_txclk_dfx_lm_lp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_6_csr_txffe_pll_dpso_sel_attr = "serdes_lane_ana_tx_lane0_reg_6_csr_txffe_pll_dpso_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_load_attr = "serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_m1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_m2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_coeff_p1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_mode32ui_attr = "serdes_lane_ana_tx_lane0_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_7_csr_txffe_output_swizzle_attr = "serdes_lane_ana_tx_lane0_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_8_csr_txffe_coeff_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_8_csr_txffe_coeff_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_8_csr_txffe_coeff_p4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_8_csr_txffe_coeff_p5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane0_reg_9_csr_txffe_cmod_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_amon_pulldown_en_attr = "serdes_lane_ana_tx_lane1_reg_10_csr_txclk_amon_pulldown_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_amoni_sel_attr = "serdes_lane_ana_tx_lane1_reg_10_csr_txclk_amoni_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_amonv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_clk_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_incr_i_attr = "serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_incr_q_attr = "serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_range_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_coarse_dcc_range_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_dcc_i_amon_en_attr = "serdes_lane_ana_tx_lane1_reg_10_csr_txclk_dcc_i_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_10_csr_txclk_dcc_q_amon_en_attr = "serdes_lane_ana_tx_lane1_reg_10_csr_txclk_dcc_q_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_dcc_crs_vrefn_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_dcc_crs_vrefp_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_incr_i_attr = "serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_incr_q_attr = "serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_range_i_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_fine_dcc_range_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_ibias_ctrl_dcc_dacn_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_11_csr_txclk_ibias_ctrl_dcc_dacp_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_ibias_ctrl_dcc_dacn_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_ibias_ctrl_dcc_dacp_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_qec_corsctrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_qec_corsctrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_qec_crs_dll_q_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_12_csr_txclk_qec_crs_dll_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_13_csr_txclk_qec_crs_i_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_13_csr_txclk_qec_crs_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_13_csr_txclk_qec_finectrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_13_csr_txclk_qec_finectrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_bypass_0p8_en_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_bypass_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_bypass_0p9_en_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_bypass_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_cmp_out_en_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_cmp_out_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_cmp_out_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_dcmon_en_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_enable_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_leaker_en_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_leaker_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_leaker_tune_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_14_csr_ldo_pwrdn_en_attr = "serdes_lane_ana_tx_lane1_reg_14_csr_ldo_pwrdn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_15_csr_drv_pd_cs_nmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_15_csr_drv_rterm_enb_attr = "serdes_lane_ana_tx_lane1_reg_15_csr_drv_rterm_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_15_csr_loadgen_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_15_csr_pisoclk_flip_attr = "serdes_lane_ana_tx_lane1_reg_15_csr_pisoclk_flip_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_15_csr_tx_rterm_ctl_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_16_csr_drv_cs_com_enb_attr = "serdes_lane_ana_tx_lane1_reg_16_csr_drv_cs_com_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_16_csr_drv_tx_cmp_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_16_csr_drv_tx_cmp_rd_select_attr = "serdes_lane_ana_tx_lane1_reg_16_csr_drv_tx_cmp_rd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_16_csr_drv_tx_mode64b0_32b1_attr = "serdes_lane_ana_tx_lane1_reg_16_csr_drv_tx_mode64b0_32b1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_17_reg2hwa_cfg_avg_eng_start_attr = "serdes_lane_ana_tx_lane1_reg_17_reg2hwa_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_18_reg2hwa_cfg_avg_eng_limit_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_1_csr_lgc_reset_bar_attr = "serdes_lane_ana_tx_lane1_reg_1_csr_lgc_reset_bar_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_lanedig_o_ldo_stable_attr = "serdes_lane_ana_tx_lane1_reg_22_csr_lanedig_o_ldo_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_lanedig_o_tx_caldone_attr = "serdes_lane_ana_tx_lane1_reg_22_csr_lanedig_o_tx_caldone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_lanedig_o_txclk_ready_attr = "serdes_lane_ana_tx_lane1_reg_22_csr_lanedig_o_txclk_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_probe0_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_probe0_txvisa_en_attr = "serdes_lane_ana_tx_lane1_reg_22_csr_probe0_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_probe1_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_22_csr_probe1_txvisa_en_attr = "serdes_lane_ana_tx_lane1_reg_22_csr_probe1_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_23_cmp_mirror_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_2_o_spare_a_rw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_3_o_spare_b_rw_attr = 16383;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_5_cmp_addr_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_5_cmp_addr_mask_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_5_cmp_mirror_rd_select_attr = "serdes_lane_ana_tx_lane1_reg_5_cmp_mirror_rd_select_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_6_csr_txclk_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_6_csr_txclk_dfx2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_6_csr_txclk_dfx_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_6_csr_txclk_dfx_lm1_en_attr = "serdes_lane_ana_tx_lane1_reg_6_csr_txclk_dfx_lm1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_6_csr_txclk_dfx_lm_lp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_6_csr_txffe_pll_dpso_sel_attr = "serdes_lane_ana_tx_lane1_reg_6_csr_txffe_pll_dpso_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_load_attr = "serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_m1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_m2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_coeff_p1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_mode32ui_attr = "serdes_lane_ana_tx_lane1_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_7_csr_txffe_output_swizzle_attr = "serdes_lane_ana_tx_lane1_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_8_csr_txffe_coeff_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_8_csr_txffe_coeff_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_8_csr_txffe_coeff_p4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_8_csr_txffe_coeff_p5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane1_reg_9_csr_txffe_cmod_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_amon_pulldown_en_attr = "serdes_lane_ana_tx_lane2_reg_10_csr_txclk_amon_pulldown_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_amoni_sel_attr = "serdes_lane_ana_tx_lane2_reg_10_csr_txclk_amoni_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_amonv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_clk_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_incr_i_attr = "serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_incr_q_attr = "serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_range_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_coarse_dcc_range_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_dcc_i_amon_en_attr = "serdes_lane_ana_tx_lane2_reg_10_csr_txclk_dcc_i_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_10_csr_txclk_dcc_q_amon_en_attr = "serdes_lane_ana_tx_lane2_reg_10_csr_txclk_dcc_q_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_dcc_crs_vrefn_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_dcc_crs_vrefp_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_incr_i_attr = "serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_incr_q_attr = "serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_range_i_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_fine_dcc_range_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_ibias_ctrl_dcc_dacn_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_11_csr_txclk_ibias_ctrl_dcc_dacp_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_ibias_ctrl_dcc_dacn_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_ibias_ctrl_dcc_dacp_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_qec_corsctrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_qec_corsctrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_qec_crs_dll_q_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_12_csr_txclk_qec_crs_dll_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_13_csr_txclk_qec_crs_i_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_13_csr_txclk_qec_crs_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_13_csr_txclk_qec_finectrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_13_csr_txclk_qec_finectrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_bypass_0p8_en_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_bypass_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_bypass_0p9_en_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_bypass_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_cmp_out_en_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_cmp_out_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_cmp_out_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_dcmon_en_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_enable_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_leaker_en_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_leaker_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_leaker_tune_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_14_csr_ldo_pwrdn_en_attr = "serdes_lane_ana_tx_lane2_reg_14_csr_ldo_pwrdn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_15_csr_drv_pd_cs_nmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_15_csr_drv_rterm_enb_attr = "serdes_lane_ana_tx_lane2_reg_15_csr_drv_rterm_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_15_csr_loadgen_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_15_csr_pisoclk_flip_attr = "serdes_lane_ana_tx_lane2_reg_15_csr_pisoclk_flip_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_15_csr_tx_rterm_ctl_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_16_csr_drv_cs_com_enb_attr = "serdes_lane_ana_tx_lane2_reg_16_csr_drv_cs_com_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_16_csr_drv_tx_cmp_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_16_csr_drv_tx_cmp_rd_select_attr = "serdes_lane_ana_tx_lane2_reg_16_csr_drv_tx_cmp_rd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_16_csr_drv_tx_mode64b0_32b1_attr = "serdes_lane_ana_tx_lane2_reg_16_csr_drv_tx_mode64b0_32b1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_17_reg2hwa_cfg_avg_eng_start_attr = "serdes_lane_ana_tx_lane2_reg_17_reg2hwa_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_18_reg2hwa_cfg_avg_eng_limit_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_1_csr_lgc_reset_bar_attr = "serdes_lane_ana_tx_lane2_reg_1_csr_lgc_reset_bar_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_lanedig_o_ldo_stable_attr = "serdes_lane_ana_tx_lane2_reg_22_csr_lanedig_o_ldo_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_lanedig_o_tx_caldone_attr = "serdes_lane_ana_tx_lane2_reg_22_csr_lanedig_o_tx_caldone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_lanedig_o_txclk_ready_attr = "serdes_lane_ana_tx_lane2_reg_22_csr_lanedig_o_txclk_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_probe0_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_probe0_txvisa_en_attr = "serdes_lane_ana_tx_lane2_reg_22_csr_probe0_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_probe1_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_22_csr_probe1_txvisa_en_attr = "serdes_lane_ana_tx_lane2_reg_22_csr_probe1_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_23_cmp_mirror_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_2_o_spare_a_rw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_3_o_spare_b_rw_attr = 16383;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_5_cmp_addr_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_5_cmp_addr_mask_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_5_cmp_mirror_rd_select_attr = "serdes_lane_ana_tx_lane2_reg_5_cmp_mirror_rd_select_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_6_csr_txclk_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_6_csr_txclk_dfx2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_6_csr_txclk_dfx_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_6_csr_txclk_dfx_lm1_en_attr = "serdes_lane_ana_tx_lane2_reg_6_csr_txclk_dfx_lm1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_6_csr_txclk_dfx_lm_lp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_6_csr_txffe_pll_dpso_sel_attr = "serdes_lane_ana_tx_lane2_reg_6_csr_txffe_pll_dpso_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_load_attr = "serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_m1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_m2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_coeff_p1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_mode32ui_attr = "serdes_lane_ana_tx_lane2_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_7_csr_txffe_output_swizzle_attr = "serdes_lane_ana_tx_lane2_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_8_csr_txffe_coeff_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_8_csr_txffe_coeff_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_8_csr_txffe_coeff_p4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_8_csr_txffe_coeff_p5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane2_reg_9_csr_txffe_cmod_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_amon_pulldown_en_attr = "serdes_lane_ana_tx_lane3_reg_10_csr_txclk_amon_pulldown_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_amoni_sel_attr = "serdes_lane_ana_tx_lane3_reg_10_csr_txclk_amoni_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_amonv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_clk_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_incr_i_attr = "serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_incr_q_attr = "serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_range_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_coarse_dcc_range_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_dcc_i_amon_en_attr = "serdes_lane_ana_tx_lane3_reg_10_csr_txclk_dcc_i_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_10_csr_txclk_dcc_q_amon_en_attr = "serdes_lane_ana_tx_lane3_reg_10_csr_txclk_dcc_q_amon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_dcc_crs_vrefn_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_dcc_crs_vrefp_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_ctr_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_ctr_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_incr_i_attr = "serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_incr_i_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_incr_q_attr = "serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_incr_q_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_range_i_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_fine_dcc_range_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_ibias_ctrl_dcc_dacn_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_11_csr_txclk_ibias_ctrl_dcc_dacp_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_ibias_ctrl_dcc_dacn_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_ibias_ctrl_dcc_dacp_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_qec_corsctrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_qec_corsctrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_qec_crs_dll_q_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_12_csr_txclk_qec_crs_dll_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_13_csr_txclk_qec_crs_i_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_13_csr_txclk_qec_crs_q_inv_cntrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_13_csr_txclk_qec_finectrl_i_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_13_csr_txclk_qec_finectrl_q_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_bypass_0p8_en_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_bypass_0p8_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_bypass_0p9_en_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_bypass_0p9_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_cmp_out_en_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_cmp_out_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_cmp_out_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_dcmon_en_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_enable_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_leaker_en_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_leaker_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_leaker_tune_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_14_csr_ldo_pwrdn_en_attr = "serdes_lane_ana_tx_lane3_reg_14_csr_ldo_pwrdn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_15_csr_drv_pd_cs_nmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_15_csr_drv_rterm_enb_attr = "serdes_lane_ana_tx_lane3_reg_15_csr_drv_rterm_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_15_csr_loadgen_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_15_csr_pisoclk_flip_attr = "serdes_lane_ana_tx_lane3_reg_15_csr_pisoclk_flip_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_15_csr_tx_rterm_ctl_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_16_csr_drv_cs_com_enb_attr = "serdes_lane_ana_tx_lane3_reg_16_csr_drv_cs_com_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_16_csr_drv_tx_cmp_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_16_csr_drv_tx_cmp_rd_select_attr = "serdes_lane_ana_tx_lane3_reg_16_csr_drv_tx_cmp_rd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_16_csr_drv_tx_mode64b0_32b1_attr = "serdes_lane_ana_tx_lane3_reg_16_csr_drv_tx_mode64b0_32b1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_17_reg2hwa_cfg_avg_eng_start_attr = "serdes_lane_ana_tx_lane3_reg_17_reg2hwa_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_18_reg2hwa_cfg_avg_eng_limit_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_1_csr_lgc_reset_bar_attr = "serdes_lane_ana_tx_lane3_reg_1_csr_lgc_reset_bar_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_lanedig_o_ldo_stable_attr = "serdes_lane_ana_tx_lane3_reg_22_csr_lanedig_o_ldo_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_lanedig_o_tx_caldone_attr = "serdes_lane_ana_tx_lane3_reg_22_csr_lanedig_o_tx_caldone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_lanedig_o_txclk_ready_attr = "serdes_lane_ana_tx_lane3_reg_22_csr_lanedig_o_txclk_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_probe0_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_probe0_txvisa_en_attr = "serdes_lane_ana_tx_lane3_reg_22_csr_probe0_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_probe1_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_22_csr_probe1_txvisa_en_attr = "serdes_lane_ana_tx_lane3_reg_22_csr_probe1_txvisa_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_23_cmp_mirror_reg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_2_o_spare_a_rw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_3_o_spare_b_rw_attr = 16383;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_5_cmp_addr_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_5_cmp_addr_mask_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_5_cmp_mirror_rd_select_attr = "serdes_lane_ana_tx_lane3_reg_5_cmp_mirror_rd_select_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_6_csr_txclk_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_6_csr_txclk_dfx2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_6_csr_txclk_dfx_dfx1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_6_csr_txclk_dfx_lm1_en_attr = "serdes_lane_ana_tx_lane3_reg_6_csr_txclk_dfx_lm1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_6_csr_txclk_dfx_lm_lp_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_6_csr_txffe_pll_dpso_sel_attr = "serdes_lane_ana_tx_lane3_reg_6_csr_txffe_pll_dpso_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_load_attr = "serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_load_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_m1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_m2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_coeff_p1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_mode32ui_attr = "serdes_lane_ana_tx_lane3_reg_7_csr_txffe_mode32ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_7_csr_txffe_output_swizzle_attr = "serdes_lane_ana_tx_lane3_reg_7_csr_txffe_output_swizzle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_8_csr_txffe_coeff_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_8_csr_txffe_coeff_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_8_csr_txffe_coeff_p4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_8_csr_txffe_coeff_p5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_ana_tx_lane3_reg_9_csr_txffe_cmod_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dft_rx_clken_attr = "serdes_lane_car_lane0_reg_1_car_dft_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dft_tx_clken_attr = "serdes_lane_car_lane0_reg_1_car_dft_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dsp_64ui_clken_attr = "serdes_lane_car_lane0_reg_1_car_dsp_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dsp_64ui_dfe_byps_clken_attr = "serdes_lane_car_lane0_reg_1_car_dsp_64ui_dfe_byps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dsp_64ui_dfe_clken_attr = "serdes_lane_car_lane0_reg_1_car_dsp_64ui_dfe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dsp_64ui_ffe_clken_attr = "serdes_lane_car_lane0_reg_1_car_dsp_64ui_ffe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dsp_64ui_first_samp_clken_attr = "serdes_lane_car_lane0_reg_1_car_dsp_64ui_first_samp_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_dsp_64ui_tap64_clken_attr = "serdes_lane_car_lane0_reg_1_car_dsp_64ui_tap64_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_ppm_all_tech_clken_attr = "serdes_lane_car_lane0_reg_1_car_ppm_all_tech_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_car_ref_ppm_clken_attr = "serdes_lane_car_lane0_reg_1_car_ref_ppm_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_clkmux_dig_clk_en_attr = "serdes_lane_car_lane0_reg_1_clkmux_dig_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_cdr_64ui_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_cdr_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_gain_per_sar_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_gain_per_sar_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_lms_eng_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_ops_gps_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_ops_gps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_sec_lms_eng_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_sec_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_snr_meter_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_snr_meter_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_dsp_vga_adapt_clken_attr = "serdes_lane_car_lane0_reg_1_dsp_vga_adapt_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_pcs_srds_tx_clken_attr = "serdes_lane_car_lane0_reg_1_pcs_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_rx_clk_fifo_clken_attr = "serdes_lane_car_lane0_reg_1_rx_clk_fifo_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_1_tx_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane0_reg_1_tx_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_ana_datapth_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_ana_datapth_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_brk_lane_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_brk_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dft_rx_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dft_rx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dft_tx_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dft_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dsp_64ui_dfe_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dsp_64ui_dfe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dsp_64ui_ffe_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dsp_64ui_ffe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dsp_64ui_first_samp_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dsp_64ui_first_samp_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_dsp_64ui_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_dsp_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_ppm_all_tech_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_ppm_all_tech_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_ref_ppm_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_ref_ppm_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_car_tx_64ui_swrstb_attr = "serdes_lane_car_lane0_reg_2_car_tx_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_dsp_cdr_64ui_swrstb_attr = "serdes_lane_car_lane0_reg_2_dsp_cdr_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_lane_swrstb_attr = "serdes_lane_car_lane0_reg_2_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_orx_srds_swrstb_attr = "serdes_lane_car_lane0_reg_2_orx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_otx_srds_swrstb_attr = "serdes_lane_car_lane0_reg_2_otx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_2_pcs_srds_tx_swrstb_attr = "serdes_lane_car_lane0_reg_2_pcs_srds_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_apb_dsp_clk_sel_attr = "serdes_lane_car_lane0_reg_3_apb_dsp_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_apb_rx_divn_en_attr = "serdes_lane_car_lane0_reg_3_apb_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_apb_rx_divn_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_cdr_pfd_rx_divn_en_attr = "serdes_lane_car_lane0_reg_3_cdr_pfd_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_cdr_pfd_rx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_cdr_pfd_tx_divn_en_attr = "serdes_lane_car_lane0_reg_3_cdr_pfd_tx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_cdr_pfd_tx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_3_ppm_clk_sel_attr = "serdes_lane_car_lane0_reg_3_ppm_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_4_cdr_as_pll_ref_divn_en_attr = "serdes_lane_car_lane0_reg_4_cdr_as_pll_ref_divn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_4_cdr_as_pll_ref_divn_val_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_6_obrk_rx_direct_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_7_obrk_rxsrds_rdy_attr = "serdes_lane_car_lane0_reg_7_obrk_rxsrds_rdy_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_load_preset_attr = "serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_8_car_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_9_car_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane0_reg_9_car_reg2probe_en_attr = "serdes_lane_car_lane0_reg_9_car_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dft_rx_clken_attr = "serdes_lane_car_lane1_reg_1_car_dft_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dft_tx_clken_attr = "serdes_lane_car_lane1_reg_1_car_dft_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dsp_64ui_clken_attr = "serdes_lane_car_lane1_reg_1_car_dsp_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dsp_64ui_dfe_byps_clken_attr = "serdes_lane_car_lane1_reg_1_car_dsp_64ui_dfe_byps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dsp_64ui_dfe_clken_attr = "serdes_lane_car_lane1_reg_1_car_dsp_64ui_dfe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dsp_64ui_ffe_clken_attr = "serdes_lane_car_lane1_reg_1_car_dsp_64ui_ffe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dsp_64ui_first_samp_clken_attr = "serdes_lane_car_lane1_reg_1_car_dsp_64ui_first_samp_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_dsp_64ui_tap64_clken_attr = "serdes_lane_car_lane1_reg_1_car_dsp_64ui_tap64_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_ppm_all_tech_clken_attr = "serdes_lane_car_lane1_reg_1_car_ppm_all_tech_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_car_ref_ppm_clken_attr = "serdes_lane_car_lane1_reg_1_car_ref_ppm_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_clkmux_dig_clk_en_attr = "serdes_lane_car_lane1_reg_1_clkmux_dig_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_cdr_64ui_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_cdr_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_gain_per_sar_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_gain_per_sar_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_lms_eng_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_ops_gps_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_ops_gps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_sec_lms_eng_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_sec_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_snr_meter_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_snr_meter_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_dsp_vga_adapt_clken_attr = "serdes_lane_car_lane1_reg_1_dsp_vga_adapt_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_pcs_srds_tx_clken_attr = "serdes_lane_car_lane1_reg_1_pcs_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_rx_clk_fifo_clken_attr = "serdes_lane_car_lane1_reg_1_rx_clk_fifo_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_1_tx_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane1_reg_1_tx_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_ana_datapth_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_ana_datapth_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_brk_lane_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_brk_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dft_rx_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dft_rx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dft_tx_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dft_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dsp_64ui_dfe_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dsp_64ui_dfe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dsp_64ui_ffe_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dsp_64ui_ffe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dsp_64ui_first_samp_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dsp_64ui_first_samp_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_dsp_64ui_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_dsp_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_ppm_all_tech_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_ppm_all_tech_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_ref_ppm_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_ref_ppm_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_car_tx_64ui_swrstb_attr = "serdes_lane_car_lane1_reg_2_car_tx_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_dsp_cdr_64ui_swrstb_attr = "serdes_lane_car_lane1_reg_2_dsp_cdr_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_lane_swrstb_attr = "serdes_lane_car_lane1_reg_2_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_orx_srds_swrstb_attr = "serdes_lane_car_lane1_reg_2_orx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_otx_srds_swrstb_attr = "serdes_lane_car_lane1_reg_2_otx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_2_pcs_srds_tx_swrstb_attr = "serdes_lane_car_lane1_reg_2_pcs_srds_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_apb_dsp_clk_sel_attr = "serdes_lane_car_lane1_reg_3_apb_dsp_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_apb_rx_divn_en_attr = "serdes_lane_car_lane1_reg_3_apb_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_apb_rx_divn_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_cdr_pfd_rx_divn_en_attr = "serdes_lane_car_lane1_reg_3_cdr_pfd_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_cdr_pfd_rx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_cdr_pfd_tx_divn_en_attr = "serdes_lane_car_lane1_reg_3_cdr_pfd_tx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_cdr_pfd_tx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_3_ppm_clk_sel_attr = "serdes_lane_car_lane1_reg_3_ppm_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_4_cdr_as_pll_ref_divn_en_attr = "serdes_lane_car_lane1_reg_4_cdr_as_pll_ref_divn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_4_cdr_as_pll_ref_divn_val_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_6_obrk_rx_direct_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_7_obrk_rxsrds_rdy_attr = "serdes_lane_car_lane1_reg_7_obrk_rxsrds_rdy_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_load_preset_attr = "serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_8_car_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_9_car_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane1_reg_9_car_reg2probe_en_attr = "serdes_lane_car_lane1_reg_9_car_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dft_rx_clken_attr = "serdes_lane_car_lane2_reg_1_car_dft_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dft_tx_clken_attr = "serdes_lane_car_lane2_reg_1_car_dft_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dsp_64ui_clken_attr = "serdes_lane_car_lane2_reg_1_car_dsp_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dsp_64ui_dfe_byps_clken_attr = "serdes_lane_car_lane2_reg_1_car_dsp_64ui_dfe_byps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dsp_64ui_dfe_clken_attr = "serdes_lane_car_lane2_reg_1_car_dsp_64ui_dfe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dsp_64ui_ffe_clken_attr = "serdes_lane_car_lane2_reg_1_car_dsp_64ui_ffe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dsp_64ui_first_samp_clken_attr = "serdes_lane_car_lane2_reg_1_car_dsp_64ui_first_samp_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_dsp_64ui_tap64_clken_attr = "serdes_lane_car_lane2_reg_1_car_dsp_64ui_tap64_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_ppm_all_tech_clken_attr = "serdes_lane_car_lane2_reg_1_car_ppm_all_tech_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_car_ref_ppm_clken_attr = "serdes_lane_car_lane2_reg_1_car_ref_ppm_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_clkmux_dig_clk_en_attr = "serdes_lane_car_lane2_reg_1_clkmux_dig_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_cdr_64ui_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_cdr_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_gain_per_sar_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_gain_per_sar_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_lms_eng_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_ops_gps_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_ops_gps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_sec_lms_eng_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_sec_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_snr_meter_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_snr_meter_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_dsp_vga_adapt_clken_attr = "serdes_lane_car_lane2_reg_1_dsp_vga_adapt_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_pcs_srds_tx_clken_attr = "serdes_lane_car_lane2_reg_1_pcs_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_rx_clk_fifo_clken_attr = "serdes_lane_car_lane2_reg_1_rx_clk_fifo_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_1_tx_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane2_reg_1_tx_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_ana_datapth_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_ana_datapth_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_brk_lane_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_brk_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dft_rx_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dft_rx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dft_tx_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dft_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dsp_64ui_dfe_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dsp_64ui_dfe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dsp_64ui_ffe_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dsp_64ui_ffe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dsp_64ui_first_samp_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dsp_64ui_first_samp_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_dsp_64ui_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_dsp_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_ppm_all_tech_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_ppm_all_tech_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_ref_ppm_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_ref_ppm_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_car_tx_64ui_swrstb_attr = "serdes_lane_car_lane2_reg_2_car_tx_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_dsp_cdr_64ui_swrstb_attr = "serdes_lane_car_lane2_reg_2_dsp_cdr_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_lane_swrstb_attr = "serdes_lane_car_lane2_reg_2_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_orx_srds_swrstb_attr = "serdes_lane_car_lane2_reg_2_orx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_otx_srds_swrstb_attr = "serdes_lane_car_lane2_reg_2_otx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_2_pcs_srds_tx_swrstb_attr = "serdes_lane_car_lane2_reg_2_pcs_srds_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_apb_dsp_clk_sel_attr = "serdes_lane_car_lane2_reg_3_apb_dsp_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_apb_rx_divn_en_attr = "serdes_lane_car_lane2_reg_3_apb_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_apb_rx_divn_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_cdr_pfd_rx_divn_en_attr = "serdes_lane_car_lane2_reg_3_cdr_pfd_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_cdr_pfd_rx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_cdr_pfd_tx_divn_en_attr = "serdes_lane_car_lane2_reg_3_cdr_pfd_tx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_cdr_pfd_tx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_3_ppm_clk_sel_attr = "serdes_lane_car_lane2_reg_3_ppm_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_4_cdr_as_pll_ref_divn_en_attr = "serdes_lane_car_lane2_reg_4_cdr_as_pll_ref_divn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_4_cdr_as_pll_ref_divn_val_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_6_obrk_rx_direct_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_7_obrk_rxsrds_rdy_attr = "serdes_lane_car_lane2_reg_7_obrk_rxsrds_rdy_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_load_preset_attr = "serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_8_car_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_9_car_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane2_reg_9_car_reg2probe_en_attr = "serdes_lane_car_lane2_reg_9_car_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dft_rx_clken_attr = "serdes_lane_car_lane3_reg_1_car_dft_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dft_tx_clken_attr = "serdes_lane_car_lane3_reg_1_car_dft_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dsp_64ui_clken_attr = "serdes_lane_car_lane3_reg_1_car_dsp_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dsp_64ui_dfe_byps_clken_attr = "serdes_lane_car_lane3_reg_1_car_dsp_64ui_dfe_byps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dsp_64ui_dfe_clken_attr = "serdes_lane_car_lane3_reg_1_car_dsp_64ui_dfe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dsp_64ui_ffe_clken_attr = "serdes_lane_car_lane3_reg_1_car_dsp_64ui_ffe_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dsp_64ui_first_samp_clken_attr = "serdes_lane_car_lane3_reg_1_car_dsp_64ui_first_samp_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_dsp_64ui_tap64_clken_attr = "serdes_lane_car_lane3_reg_1_car_dsp_64ui_tap64_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_ppm_all_tech_clken_attr = "serdes_lane_car_lane3_reg_1_car_ppm_all_tech_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_car_ref_ppm_clken_attr = "serdes_lane_car_lane3_reg_1_car_ref_ppm_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_clkmux_dig_clk_en_attr = "serdes_lane_car_lane3_reg_1_clkmux_dig_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_cdr_64ui_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_cdr_64ui_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_gain_per_sar_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_gain_per_sar_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_lms_eng_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_ops_gps_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_ops_gps_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_sec_lms_eng_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_sec_lms_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_snr_meter_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_snr_meter_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_dsp_vga_adapt_clken_attr = "serdes_lane_car_lane3_reg_1_dsp_vga_adapt_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_pcs_srds_tx_clken_attr = "serdes_lane_car_lane3_reg_1_pcs_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_rx_clk_fifo_clken_attr = "serdes_lane_car_lane3_reg_1_rx_clk_fifo_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_1_tx_64ui_cdr_pfd_clken_attr = "serdes_lane_car_lane3_reg_1_tx_64ui_cdr_pfd_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_ana_datapth_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_ana_datapth_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_brk_lane_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_brk_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dft_rx_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dft_rx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dft_tx_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dft_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dsp_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dsp_64ui_dfe_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dsp_64ui_dfe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dsp_64ui_ffe_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dsp_64ui_ffe_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dsp_64ui_first_samp_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dsp_64ui_first_samp_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_dsp_64ui_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_dsp_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_ppm_all_tech_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_ppm_all_tech_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_ref_ppm_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_ref_ppm_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_tx_64ui_cdr_pfd_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_car_tx_64ui_swrstb_attr = "serdes_lane_car_lane3_reg_2_car_tx_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_dsp_cdr_64ui_swrstb_attr = "serdes_lane_car_lane3_reg_2_dsp_cdr_64ui_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_lane_swrstb_attr = "serdes_lane_car_lane3_reg_2_lane_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_orx_srds_swrstb_attr = "serdes_lane_car_lane3_reg_2_orx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_otx_srds_swrstb_attr = "serdes_lane_car_lane3_reg_2_otx_srds_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_2_pcs_srds_tx_swrstb_attr = "serdes_lane_car_lane3_reg_2_pcs_srds_tx_swrstb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_apb_dsp_clk_sel_attr = "serdes_lane_car_lane3_reg_3_apb_dsp_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_apb_rx_divn_en_attr = "serdes_lane_car_lane3_reg_3_apb_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_apb_rx_divn_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_cdr_pfd_rx_divn_en_attr = "serdes_lane_car_lane3_reg_3_cdr_pfd_rx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_cdr_pfd_rx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_cdr_pfd_tx_divn_en_attr = "serdes_lane_car_lane3_reg_3_cdr_pfd_tx_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_cdr_pfd_tx_divn_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_3_ppm_clk_sel_attr = "serdes_lane_car_lane3_reg_3_ppm_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_4_cdr_as_pll_ref_divn_en_attr = "serdes_lane_car_lane3_reg_4_cdr_as_pll_ref_divn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_4_cdr_as_pll_ref_divn_val_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_6_obrk_rx_direct_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_7_obrk_rxsrds_rdy_attr = "serdes_lane_car_lane3_reg_7_obrk_rxsrds_rdy_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_load_preset_attr = "serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_8_car_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_9_car_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_car_lane3_reg_9_car_reg2probe_en_attr = "serdes_lane_car_lane3_reg_9_car_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_10_cdr_prop_thr_load_attr = "serdes_lane_cdr_new_lane0_reg_10_cdr_prop_thr_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_10_cdr_sar_inv_dp_cb_attr = "serdes_lane_cdr_new_lane0_reg_10_cdr_sar_inv_dp_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_10_csr_ki_force_en_attr = "serdes_lane_cdr_new_lane0_reg_10_csr_ki_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_10_csr_ki_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_10_ki_data_mode_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_10_ki_fine_cal_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_11_cdr_inv_accum_integ_attr = "serdes_lane_cdr_new_lane0_reg_11_cdr_inv_accum_integ_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_11_cfg_cdr_accum_init_attr = 349525;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_11_cfg_cdr_accum_init_en_attr = "serdes_lane_cdr_new_lane0_reg_11_cfg_cdr_accum_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_12_dco_integ_force_en_attr = "serdes_lane_cdr_new_lane0_reg_12_dco_integ_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_12_dco_integ_force_val_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_12_dco_prop_force_en_attr = "serdes_lane_cdr_new_lane0_reg_12_dco_prop_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_12_dco_prop_force_val_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_13_cfg_pde_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_14_cfg_pde_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_15_c2_c1_lms_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_15_c3_c0_lms_init_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_16_cfg_cdr_coeff_cm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_16_cfg_cdr_coeff_cm2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_16_cfg_cdr_coeff_cp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_16_cfg_cdr_coeff_cp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_16_cfg_cdr_coeff_update_sc_attr = "serdes_lane_cdr_new_lane0_reg_16_cfg_cdr_coeff_update_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_17_coeff_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane0_reg_17_coeff_lms_up1_dn0_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_17_lms_stable_clr_attr = "serdes_lane_cdr_new_lane0_reg_17_lms_stable_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_17_lms_stable_dist_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_17_lms_stable_nochange_thr_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_17_lms_stable_ref_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_18_cfg_cvar_trim_dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_18_slow_trim_dac_sel_max_th_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_18_slow_trim_dac_sel_min_th_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_cdr_sel_slow_trim_max_th_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_cdr_sel_slow_trim_min_th_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_cfg_slow_trim_dcosettle_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_cfg_slow_trim_dcoupdate_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_cfg_slow_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane0_reg_19_cfg_slow_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_cfg_slow_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_slow_trim_coarse_direction_inv_attr = "serdes_lane_cdr_new_lane0_reg_19_slow_trim_coarse_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_19_slow_trim_dac_sel_direction_inv_attr = "serdes_lane_cdr_new_lane0_reg_19_slow_trim_dac_sel_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_agc_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane0_reg_1_agc_lms_up1_dn0_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_agc_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_agc_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_idig_dco_dis_force_en_attr = "serdes_lane_cdr_new_lane0_reg_1_cdr_idig_dco_dis_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_idig_dco_dis_force_val_attr = "serdes_lane_cdr_new_lane0_reg_1_cdr_idig_dco_dis_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_lms_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_pam2_en_from_constellation_attr = "serdes_lane_cdr_new_lane0_reg_1_cdr_pam2_en_from_constellation_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_pam2_enable_from_reg_attr = "serdes_lane_cdr_new_lane0_reg_1_cdr_pam2_enable_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdr_pd_ext_lvl_dis_attr = "serdes_lane_cdr_new_lane0_reg_1_cdr_pd_ext_lvl_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cdren_int_attr = "serdes_lane_cdr_new_lane0_reg_1_cdren_int_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cfg_cdr_lock2ref_attr = "serdes_lane_cdr_new_lane0_reg_1_cfg_cdr_lock2ref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_cfg_lms_symmetric_en_attr = "serdes_lane_cdr_new_lane0_reg_1_cfg_lms_symmetric_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_csr_cdr_snap_data_attr = "serdes_lane_cdr_new_lane0_reg_1_csr_cdr_snap_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_lms_init_strobe_sc_attr = "serdes_lane_cdr_new_lane0_reg_1_lms_init_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_oversample_mode_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_oversample_mode_force_en_attr = "serdes_lane_cdr_new_lane0_reg_1_oversample_mode_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_ppm_test_en_by_fsm_attr = "serdes_lane_cdr_new_lane0_reg_1_ppm_test_en_by_fsm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_ppm_test_en_from_reg_attr = "serdes_lane_cdr_new_lane0_reg_1_ppm_test_en_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_1_slow_trim_en_attr = "serdes_lane_cdr_new_lane0_reg_1_slow_trim_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_cdr_ber_ph_fifo_en_attr = "serdes_lane_cdr_new_lane0_reg_20_cdr_ber_ph_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_cdr_dft_clk_enable_attr = "serdes_lane_cdr_new_lane0_reg_20_cdr_dft_clk_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_cdr_dft_clk_rst_n_attr = "serdes_lane_cdr_new_lane0_reg_20_cdr_dft_clk_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_csr_cdr_vote_fifo_en_attr = "serdes_lane_cdr_new_lane0_reg_20_csr_cdr_vote_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_dft_toggle_vcpi_integ_en_attr = "serdes_lane_cdr_new_lane0_reg_20_dft_toggle_vcpi_integ_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_integ_sd_bit_en_attr = "serdes_lane_cdr_new_lane0_reg_20_integ_sd_bit_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_slow_trim_force_mode_attr = "serdes_lane_cdr_new_lane0_reg_20_slow_trim_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_slow_trim_strobe_force_val_attr = "serdes_lane_cdr_new_lane0_reg_20_slow_trim_strobe_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_20_slow_trim_up1_dn0_force_val_attr = "serdes_lane_cdr_new_lane0_reg_20_slow_trim_up1_dn0_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_21_cfg_cdr_jit_force_en_attr = "serdes_lane_cdr_new_lane0_reg_21_cfg_cdr_jit_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_21_cfg_cdr_jit_force_mode_attr = "serdes_lane_cdr_new_lane0_reg_21_cfg_cdr_jit_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_21_cfg_dft_jtr_gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_21_cfg_dft_jtr_inj_en_attr = "serdes_lane_cdr_new_lane0_reg_21_cfg_dft_jtr_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_21_csr_jtr_dis_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_21_csr_jtr_en_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_22_clkgen_skew_strobe_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_22_clkgen_skew_strobe_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_22_clkgen_skew_updn_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_22_clkgen_skew_updn_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_23_s1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_23_s2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_23_s3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_24_s1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_24_s2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_24_s3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_25_s1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_25_s2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_25_s3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_26_s1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_26_s2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_26_s3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_27_s1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_27_s2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_27_s3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_28_s1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_28_s2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_28_s3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_29_s1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_29_s2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_29_s3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_2_cfg_dcodivcnt_target_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_2_dco_coarse_init_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_2_dco_coarse_max_val_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_30_s1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_30_s2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_30_s3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_31_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_32_c0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_32_c1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_32_c2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_32_c3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_33_c0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_33_c1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_33_c2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_33_c3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_34_c0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_34_c1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_34_c2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_34_c3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_35_c0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_35_c1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_35_c2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_35_c3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_36_c0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_36_c1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_36_c2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_36_c3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_37_c0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_37_c1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_37_c2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_37_c3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_38_c0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_38_c1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_38_c2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_38_c3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_39_c0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_39_c1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_39_c2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_39_c3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_3_cfg_time2dcocnt_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_3_cfg_time2dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_40_constellation_braodcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_41_cntln_slicer_reg_strobe_sc_attr = "serdes_lane_cdr_new_lane0_reg_41_cntln_slicer_reg_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_42_cdr_clock_reset_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_42_cfg_cdr_div_te_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_42_cfg_cdr_pfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr = "serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_43_cdr_new_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_44_cdr_new_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_44_cdr_new_reg2probe_en_attr = "serdes_lane_cdr_new_lane0_reg_44_cdr_new_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_cfg_calib_reset_bit_attr = "serdes_lane_cdr_new_lane0_reg_4_cfg_calib_reset_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_cfg_coarse_step_final_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_cfg_coarse_step_init_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_dsp_dco_itail_trim_final_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_dsp_dco_itail_trim_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_icfg_calib_switch_up_down_attr = "serdes_lane_cdr_new_lane0_reg_4_icfg_calib_switch_up_down_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_4_icfg_coarse_out_inv_attr = "serdes_lane_cdr_new_lane0_reg_4_icfg_coarse_out_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_cfg_cdr_state_ovrd_en_attr = "serdes_lane_cdr_new_lane0_reg_5_cfg_cdr_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_cfg_cdr_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_cfg_dcocoarse_ovrd_attr = "serdes_lane_cdr_new_lane0_reg_5_cfg_dcocoarse_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_cfg_dcocoarse_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_coarse_ppm_lock_th_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_skip_coarse_calib_attr = "serdes_lane_cdr_new_lane0_reg_5_skip_coarse_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_5_skip_fine_calib_attr = "serdes_lane_cdr_new_lane0_reg_5_skip_fine_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_6_bb_pfd_sample_negedge_attr = "serdes_lane_cdr_new_lane0_reg_6_bb_pfd_sample_negedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_6_cdr_pfd_en_force_en_attr = "serdes_lane_cdr_new_lane0_reg_6_cdr_pfd_en_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_6_cdr_pfd_en_force_val_attr = "serdes_lane_cdr_new_lane0_reg_6_cdr_pfd_en_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_6_cfg_cdr_bb_pfd_step_attr = 207;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_6_cfg_time2tune_fine_cal_attr = 400;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_7_cfg_analog_dco_cvar_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_7_cfg_cvar_trim_dcoupdate_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_7_cfg_cvar_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane0_reg_7_cfg_cvar_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_7_cfg_cvar_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_7_dco_cvar_force_mode_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_8_cdr_coarse_dac_sel_init_en_attr = "serdes_lane_cdr_new_lane0_reg_8_cdr_coarse_dac_sel_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_8_csr_coarse_dac_sel_init_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane0_reg_9_cdr_prop_thrs_attr = 63409921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_10_cdr_prop_thr_load_attr = "serdes_lane_cdr_new_lane1_reg_10_cdr_prop_thr_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_10_cdr_sar_inv_dp_cb_attr = "serdes_lane_cdr_new_lane1_reg_10_cdr_sar_inv_dp_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_10_csr_ki_force_en_attr = "serdes_lane_cdr_new_lane1_reg_10_csr_ki_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_10_csr_ki_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_10_ki_data_mode_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_10_ki_fine_cal_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_11_cdr_inv_accum_integ_attr = "serdes_lane_cdr_new_lane1_reg_11_cdr_inv_accum_integ_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_11_cfg_cdr_accum_init_attr = 349525;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_11_cfg_cdr_accum_init_en_attr = "serdes_lane_cdr_new_lane1_reg_11_cfg_cdr_accum_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_12_dco_integ_force_en_attr = "serdes_lane_cdr_new_lane1_reg_12_dco_integ_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_12_dco_integ_force_val_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_12_dco_prop_force_en_attr = "serdes_lane_cdr_new_lane1_reg_12_dco_prop_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_12_dco_prop_force_val_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_13_cfg_pde_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_14_cfg_pde_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_15_c2_c1_lms_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_15_c3_c0_lms_init_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_16_cfg_cdr_coeff_cm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_16_cfg_cdr_coeff_cm2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_16_cfg_cdr_coeff_cp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_16_cfg_cdr_coeff_cp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_16_cfg_cdr_coeff_update_sc_attr = "serdes_lane_cdr_new_lane1_reg_16_cfg_cdr_coeff_update_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_17_coeff_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane1_reg_17_coeff_lms_up1_dn0_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_17_lms_stable_clr_attr = "serdes_lane_cdr_new_lane1_reg_17_lms_stable_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_17_lms_stable_dist_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_17_lms_stable_nochange_thr_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_17_lms_stable_ref_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_18_cfg_cvar_trim_dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_18_slow_trim_dac_sel_max_th_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_18_slow_trim_dac_sel_min_th_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_cdr_sel_slow_trim_max_th_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_cdr_sel_slow_trim_min_th_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_cfg_slow_trim_dcosettle_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_cfg_slow_trim_dcoupdate_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_cfg_slow_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane1_reg_19_cfg_slow_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_cfg_slow_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_slow_trim_coarse_direction_inv_attr = "serdes_lane_cdr_new_lane1_reg_19_slow_trim_coarse_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_19_slow_trim_dac_sel_direction_inv_attr = "serdes_lane_cdr_new_lane1_reg_19_slow_trim_dac_sel_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_agc_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane1_reg_1_agc_lms_up1_dn0_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_agc_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_agc_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_idig_dco_dis_force_en_attr = "serdes_lane_cdr_new_lane1_reg_1_cdr_idig_dco_dis_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_idig_dco_dis_force_val_attr = "serdes_lane_cdr_new_lane1_reg_1_cdr_idig_dco_dis_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_lms_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_pam2_en_from_constellation_attr = "serdes_lane_cdr_new_lane1_reg_1_cdr_pam2_en_from_constellation_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_pam2_enable_from_reg_attr = "serdes_lane_cdr_new_lane1_reg_1_cdr_pam2_enable_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdr_pd_ext_lvl_dis_attr = "serdes_lane_cdr_new_lane1_reg_1_cdr_pd_ext_lvl_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cdren_int_attr = "serdes_lane_cdr_new_lane1_reg_1_cdren_int_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cfg_cdr_lock2ref_attr = "serdes_lane_cdr_new_lane1_reg_1_cfg_cdr_lock2ref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_cfg_lms_symmetric_en_attr = "serdes_lane_cdr_new_lane1_reg_1_cfg_lms_symmetric_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_csr_cdr_snap_data_attr = "serdes_lane_cdr_new_lane1_reg_1_csr_cdr_snap_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_lms_init_strobe_sc_attr = "serdes_lane_cdr_new_lane1_reg_1_lms_init_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_oversample_mode_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_oversample_mode_force_en_attr = "serdes_lane_cdr_new_lane1_reg_1_oversample_mode_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_ppm_test_en_by_fsm_attr = "serdes_lane_cdr_new_lane1_reg_1_ppm_test_en_by_fsm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_ppm_test_en_from_reg_attr = "serdes_lane_cdr_new_lane1_reg_1_ppm_test_en_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_1_slow_trim_en_attr = "serdes_lane_cdr_new_lane1_reg_1_slow_trim_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_cdr_ber_ph_fifo_en_attr = "serdes_lane_cdr_new_lane1_reg_20_cdr_ber_ph_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_cdr_dft_clk_enable_attr = "serdes_lane_cdr_new_lane1_reg_20_cdr_dft_clk_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_cdr_dft_clk_rst_n_attr = "serdes_lane_cdr_new_lane1_reg_20_cdr_dft_clk_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_csr_cdr_vote_fifo_en_attr = "serdes_lane_cdr_new_lane1_reg_20_csr_cdr_vote_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_dft_toggle_vcpi_integ_en_attr = "serdes_lane_cdr_new_lane1_reg_20_dft_toggle_vcpi_integ_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_integ_sd_bit_en_attr = "serdes_lane_cdr_new_lane1_reg_20_integ_sd_bit_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_slow_trim_force_mode_attr = "serdes_lane_cdr_new_lane1_reg_20_slow_trim_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_slow_trim_strobe_force_val_attr = "serdes_lane_cdr_new_lane1_reg_20_slow_trim_strobe_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_20_slow_trim_up1_dn0_force_val_attr = "serdes_lane_cdr_new_lane1_reg_20_slow_trim_up1_dn0_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_21_cfg_cdr_jit_force_en_attr = "serdes_lane_cdr_new_lane1_reg_21_cfg_cdr_jit_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_21_cfg_cdr_jit_force_mode_attr = "serdes_lane_cdr_new_lane1_reg_21_cfg_cdr_jit_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_21_cfg_dft_jtr_gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_21_cfg_dft_jtr_inj_en_attr = "serdes_lane_cdr_new_lane1_reg_21_cfg_dft_jtr_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_21_csr_jtr_dis_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_21_csr_jtr_en_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_22_clkgen_skew_strobe_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_22_clkgen_skew_strobe_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_22_clkgen_skew_updn_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_22_clkgen_skew_updn_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_23_s1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_23_s2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_23_s3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_24_s1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_24_s2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_24_s3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_25_s1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_25_s2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_25_s3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_26_s1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_26_s2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_26_s3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_27_s1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_27_s2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_27_s3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_28_s1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_28_s2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_28_s3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_29_s1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_29_s2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_29_s3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_2_cfg_dcodivcnt_target_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_2_dco_coarse_init_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_2_dco_coarse_max_val_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_30_s1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_30_s2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_30_s3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_31_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_32_c0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_32_c1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_32_c2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_32_c3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_33_c0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_33_c1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_33_c2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_33_c3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_34_c0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_34_c1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_34_c2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_34_c3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_35_c0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_35_c1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_35_c2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_35_c3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_36_c0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_36_c1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_36_c2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_36_c3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_37_c0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_37_c1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_37_c2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_37_c3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_38_c0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_38_c1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_38_c2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_38_c3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_39_c0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_39_c1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_39_c2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_39_c3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_3_cfg_time2dcocnt_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_3_cfg_time2dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_40_constellation_braodcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_41_cntln_slicer_reg_strobe_sc_attr = "serdes_lane_cdr_new_lane1_reg_41_cntln_slicer_reg_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_42_cdr_clock_reset_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_42_cfg_cdr_div_te_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_42_cfg_cdr_pfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr = "serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_43_cdr_new_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_44_cdr_new_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_44_cdr_new_reg2probe_en_attr = "serdes_lane_cdr_new_lane1_reg_44_cdr_new_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_cfg_calib_reset_bit_attr = "serdes_lane_cdr_new_lane1_reg_4_cfg_calib_reset_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_cfg_coarse_step_final_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_cfg_coarse_step_init_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_dsp_dco_itail_trim_final_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_dsp_dco_itail_trim_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_icfg_calib_switch_up_down_attr = "serdes_lane_cdr_new_lane1_reg_4_icfg_calib_switch_up_down_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_4_icfg_coarse_out_inv_attr = "serdes_lane_cdr_new_lane1_reg_4_icfg_coarse_out_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_cfg_cdr_state_ovrd_en_attr = "serdes_lane_cdr_new_lane1_reg_5_cfg_cdr_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_cfg_cdr_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_cfg_dcocoarse_ovrd_attr = "serdes_lane_cdr_new_lane1_reg_5_cfg_dcocoarse_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_cfg_dcocoarse_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_coarse_ppm_lock_th_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_skip_coarse_calib_attr = "serdes_lane_cdr_new_lane1_reg_5_skip_coarse_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_5_skip_fine_calib_attr = "serdes_lane_cdr_new_lane1_reg_5_skip_fine_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_6_bb_pfd_sample_negedge_attr = "serdes_lane_cdr_new_lane1_reg_6_bb_pfd_sample_negedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_6_cdr_pfd_en_force_en_attr = "serdes_lane_cdr_new_lane1_reg_6_cdr_pfd_en_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_6_cdr_pfd_en_force_val_attr = "serdes_lane_cdr_new_lane1_reg_6_cdr_pfd_en_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_6_cfg_cdr_bb_pfd_step_attr = 207;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_6_cfg_time2tune_fine_cal_attr = 400;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_7_cfg_analog_dco_cvar_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_7_cfg_cvar_trim_dcoupdate_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_7_cfg_cvar_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane1_reg_7_cfg_cvar_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_7_cfg_cvar_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_7_dco_cvar_force_mode_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_8_cdr_coarse_dac_sel_init_en_attr = "serdes_lane_cdr_new_lane1_reg_8_cdr_coarse_dac_sel_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_8_csr_coarse_dac_sel_init_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane1_reg_9_cdr_prop_thrs_attr = 63409921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_10_cdr_prop_thr_load_attr = "serdes_lane_cdr_new_lane2_reg_10_cdr_prop_thr_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_10_cdr_sar_inv_dp_cb_attr = "serdes_lane_cdr_new_lane2_reg_10_cdr_sar_inv_dp_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_10_csr_ki_force_en_attr = "serdes_lane_cdr_new_lane2_reg_10_csr_ki_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_10_csr_ki_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_10_ki_data_mode_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_10_ki_fine_cal_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_11_cdr_inv_accum_integ_attr = "serdes_lane_cdr_new_lane2_reg_11_cdr_inv_accum_integ_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_11_cfg_cdr_accum_init_attr = 349525;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_11_cfg_cdr_accum_init_en_attr = "serdes_lane_cdr_new_lane2_reg_11_cfg_cdr_accum_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_12_dco_integ_force_en_attr = "serdes_lane_cdr_new_lane2_reg_12_dco_integ_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_12_dco_integ_force_val_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_12_dco_prop_force_en_attr = "serdes_lane_cdr_new_lane2_reg_12_dco_prop_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_12_dco_prop_force_val_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_13_cfg_pde_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_14_cfg_pde_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_15_c2_c1_lms_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_15_c3_c0_lms_init_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_16_cfg_cdr_coeff_cm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_16_cfg_cdr_coeff_cm2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_16_cfg_cdr_coeff_cp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_16_cfg_cdr_coeff_cp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_16_cfg_cdr_coeff_update_sc_attr = "serdes_lane_cdr_new_lane2_reg_16_cfg_cdr_coeff_update_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_17_coeff_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane2_reg_17_coeff_lms_up1_dn0_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_17_lms_stable_clr_attr = "serdes_lane_cdr_new_lane2_reg_17_lms_stable_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_17_lms_stable_dist_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_17_lms_stable_nochange_thr_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_17_lms_stable_ref_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_18_cfg_cvar_trim_dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_18_slow_trim_dac_sel_max_th_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_18_slow_trim_dac_sel_min_th_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_cdr_sel_slow_trim_max_th_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_cdr_sel_slow_trim_min_th_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_cfg_slow_trim_dcosettle_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_cfg_slow_trim_dcoupdate_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_cfg_slow_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane2_reg_19_cfg_slow_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_cfg_slow_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_slow_trim_coarse_direction_inv_attr = "serdes_lane_cdr_new_lane2_reg_19_slow_trim_coarse_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_19_slow_trim_dac_sel_direction_inv_attr = "serdes_lane_cdr_new_lane2_reg_19_slow_trim_dac_sel_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_agc_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane2_reg_1_agc_lms_up1_dn0_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_agc_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_agc_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_idig_dco_dis_force_en_attr = "serdes_lane_cdr_new_lane2_reg_1_cdr_idig_dco_dis_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_idig_dco_dis_force_val_attr = "serdes_lane_cdr_new_lane2_reg_1_cdr_idig_dco_dis_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_lms_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_pam2_en_from_constellation_attr = "serdes_lane_cdr_new_lane2_reg_1_cdr_pam2_en_from_constellation_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_pam2_enable_from_reg_attr = "serdes_lane_cdr_new_lane2_reg_1_cdr_pam2_enable_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdr_pd_ext_lvl_dis_attr = "serdes_lane_cdr_new_lane2_reg_1_cdr_pd_ext_lvl_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cdren_int_attr = "serdes_lane_cdr_new_lane2_reg_1_cdren_int_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cfg_cdr_lock2ref_attr = "serdes_lane_cdr_new_lane2_reg_1_cfg_cdr_lock2ref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_cfg_lms_symmetric_en_attr = "serdes_lane_cdr_new_lane2_reg_1_cfg_lms_symmetric_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_csr_cdr_snap_data_attr = "serdes_lane_cdr_new_lane2_reg_1_csr_cdr_snap_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_lms_init_strobe_sc_attr = "serdes_lane_cdr_new_lane2_reg_1_lms_init_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_oversample_mode_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_oversample_mode_force_en_attr = "serdes_lane_cdr_new_lane2_reg_1_oversample_mode_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_ppm_test_en_by_fsm_attr = "serdes_lane_cdr_new_lane2_reg_1_ppm_test_en_by_fsm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_ppm_test_en_from_reg_attr = "serdes_lane_cdr_new_lane2_reg_1_ppm_test_en_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_1_slow_trim_en_attr = "serdes_lane_cdr_new_lane2_reg_1_slow_trim_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_cdr_ber_ph_fifo_en_attr = "serdes_lane_cdr_new_lane2_reg_20_cdr_ber_ph_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_cdr_dft_clk_enable_attr = "serdes_lane_cdr_new_lane2_reg_20_cdr_dft_clk_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_cdr_dft_clk_rst_n_attr = "serdes_lane_cdr_new_lane2_reg_20_cdr_dft_clk_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_csr_cdr_vote_fifo_en_attr = "serdes_lane_cdr_new_lane2_reg_20_csr_cdr_vote_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_dft_toggle_vcpi_integ_en_attr = "serdes_lane_cdr_new_lane2_reg_20_dft_toggle_vcpi_integ_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_integ_sd_bit_en_attr = "serdes_lane_cdr_new_lane2_reg_20_integ_sd_bit_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_slow_trim_force_mode_attr = "serdes_lane_cdr_new_lane2_reg_20_slow_trim_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_slow_trim_strobe_force_val_attr = "serdes_lane_cdr_new_lane2_reg_20_slow_trim_strobe_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_20_slow_trim_up1_dn0_force_val_attr = "serdes_lane_cdr_new_lane2_reg_20_slow_trim_up1_dn0_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_21_cfg_cdr_jit_force_en_attr = "serdes_lane_cdr_new_lane2_reg_21_cfg_cdr_jit_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_21_cfg_cdr_jit_force_mode_attr = "serdes_lane_cdr_new_lane2_reg_21_cfg_cdr_jit_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_21_cfg_dft_jtr_gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_21_cfg_dft_jtr_inj_en_attr = "serdes_lane_cdr_new_lane2_reg_21_cfg_dft_jtr_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_21_csr_jtr_dis_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_21_csr_jtr_en_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_22_clkgen_skew_strobe_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_22_clkgen_skew_strobe_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_22_clkgen_skew_updn_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_22_clkgen_skew_updn_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_23_s1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_23_s2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_23_s3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_24_s1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_24_s2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_24_s3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_25_s1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_25_s2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_25_s3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_26_s1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_26_s2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_26_s3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_27_s1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_27_s2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_27_s3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_28_s1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_28_s2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_28_s3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_29_s1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_29_s2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_29_s3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_2_cfg_dcodivcnt_target_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_2_dco_coarse_init_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_2_dco_coarse_max_val_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_30_s1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_30_s2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_30_s3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_31_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_32_c0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_32_c1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_32_c2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_32_c3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_33_c0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_33_c1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_33_c2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_33_c3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_34_c0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_34_c1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_34_c2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_34_c3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_35_c0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_35_c1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_35_c2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_35_c3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_36_c0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_36_c1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_36_c2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_36_c3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_37_c0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_37_c1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_37_c2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_37_c3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_38_c0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_38_c1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_38_c2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_38_c3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_39_c0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_39_c1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_39_c2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_39_c3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_3_cfg_time2dcocnt_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_3_cfg_time2dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_40_constellation_braodcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_41_cntln_slicer_reg_strobe_sc_attr = "serdes_lane_cdr_new_lane2_reg_41_cntln_slicer_reg_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_42_cdr_clock_reset_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_42_cfg_cdr_div_te_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_42_cfg_cdr_pfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr = "serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_43_cdr_new_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_44_cdr_new_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_44_cdr_new_reg2probe_en_attr = "serdes_lane_cdr_new_lane2_reg_44_cdr_new_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_cfg_calib_reset_bit_attr = "serdes_lane_cdr_new_lane2_reg_4_cfg_calib_reset_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_cfg_coarse_step_final_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_cfg_coarse_step_init_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_dsp_dco_itail_trim_final_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_dsp_dco_itail_trim_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_icfg_calib_switch_up_down_attr = "serdes_lane_cdr_new_lane2_reg_4_icfg_calib_switch_up_down_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_4_icfg_coarse_out_inv_attr = "serdes_lane_cdr_new_lane2_reg_4_icfg_coarse_out_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_cfg_cdr_state_ovrd_en_attr = "serdes_lane_cdr_new_lane2_reg_5_cfg_cdr_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_cfg_cdr_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_cfg_dcocoarse_ovrd_attr = "serdes_lane_cdr_new_lane2_reg_5_cfg_dcocoarse_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_cfg_dcocoarse_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_coarse_ppm_lock_th_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_skip_coarse_calib_attr = "serdes_lane_cdr_new_lane2_reg_5_skip_coarse_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_5_skip_fine_calib_attr = "serdes_lane_cdr_new_lane2_reg_5_skip_fine_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_6_bb_pfd_sample_negedge_attr = "serdes_lane_cdr_new_lane2_reg_6_bb_pfd_sample_negedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_6_cdr_pfd_en_force_en_attr = "serdes_lane_cdr_new_lane2_reg_6_cdr_pfd_en_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_6_cdr_pfd_en_force_val_attr = "serdes_lane_cdr_new_lane2_reg_6_cdr_pfd_en_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_6_cfg_cdr_bb_pfd_step_attr = 207;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_6_cfg_time2tune_fine_cal_attr = 400;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_7_cfg_analog_dco_cvar_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_7_cfg_cvar_trim_dcoupdate_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_7_cfg_cvar_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane2_reg_7_cfg_cvar_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_7_cfg_cvar_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_7_dco_cvar_force_mode_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_8_cdr_coarse_dac_sel_init_en_attr = "serdes_lane_cdr_new_lane2_reg_8_cdr_coarse_dac_sel_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_8_csr_coarse_dac_sel_init_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane2_reg_9_cdr_prop_thrs_attr = 63409921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_10_cdr_prop_thr_load_attr = "serdes_lane_cdr_new_lane3_reg_10_cdr_prop_thr_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_10_cdr_sar_inv_dp_cb_attr = "serdes_lane_cdr_new_lane3_reg_10_cdr_sar_inv_dp_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_10_csr_ki_force_en_attr = "serdes_lane_cdr_new_lane3_reg_10_csr_ki_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_10_csr_ki_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_10_ki_data_mode_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_10_ki_fine_cal_val_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_11_cdr_inv_accum_integ_attr = "serdes_lane_cdr_new_lane3_reg_11_cdr_inv_accum_integ_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_11_cfg_cdr_accum_init_attr = 349525;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_11_cfg_cdr_accum_init_en_attr = "serdes_lane_cdr_new_lane3_reg_11_cfg_cdr_accum_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_12_dco_integ_force_en_attr = "serdes_lane_cdr_new_lane3_reg_12_dco_integ_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_12_dco_integ_force_val_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_12_dco_prop_force_en_attr = "serdes_lane_cdr_new_lane3_reg_12_dco_prop_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_12_dco_prop_force_val_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_13_cfg_pde_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_14_cfg_pde_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_15_c2_c1_lms_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_15_c3_c0_lms_init_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_16_cfg_cdr_coeff_cm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_16_cfg_cdr_coeff_cm2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_16_cfg_cdr_coeff_cp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_16_cfg_cdr_coeff_cp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_16_cfg_cdr_coeff_update_sc_attr = "serdes_lane_cdr_new_lane3_reg_16_cfg_cdr_coeff_update_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_17_coeff_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane3_reg_17_coeff_lms_up1_dn0_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_17_lms_stable_clr_attr = "serdes_lane_cdr_new_lane3_reg_17_lms_stable_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_17_lms_stable_dist_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_17_lms_stable_nochange_thr_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_17_lms_stable_ref_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_18_cfg_cvar_trim_dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_18_slow_trim_dac_sel_max_th_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_18_slow_trim_dac_sel_min_th_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_cdr_sel_slow_trim_max_th_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_cdr_sel_slow_trim_min_th_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_cfg_slow_trim_dcosettle_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_cfg_slow_trim_dcoupdate_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_cfg_slow_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane3_reg_19_cfg_slow_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_cfg_slow_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_slow_trim_coarse_direction_inv_attr = "serdes_lane_cdr_new_lane3_reg_19_slow_trim_coarse_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_19_slow_trim_dac_sel_direction_inv_attr = "serdes_lane_cdr_new_lane3_reg_19_slow_trim_dac_sel_direction_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_agc_lms_up1_dn0_inv_attr = "serdes_lane_cdr_new_lane3_reg_1_agc_lms_up1_dn0_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_agc_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_agc_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_idig_dco_dis_force_en_attr = "serdes_lane_cdr_new_lane3_reg_1_cdr_idig_dco_dis_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_idig_dco_dis_force_val_attr = "serdes_lane_cdr_new_lane3_reg_1_cdr_idig_dco_dis_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_lms_speed_th_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_pam2_en_from_constellation_attr = "serdes_lane_cdr_new_lane3_reg_1_cdr_pam2_en_from_constellation_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_pam2_enable_from_reg_attr = "serdes_lane_cdr_new_lane3_reg_1_cdr_pam2_enable_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdr_pd_ext_lvl_dis_attr = "serdes_lane_cdr_new_lane3_reg_1_cdr_pd_ext_lvl_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cdren_int_attr = "serdes_lane_cdr_new_lane3_reg_1_cdren_int_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cfg_cdr_lock2ref_attr = "serdes_lane_cdr_new_lane3_reg_1_cfg_cdr_lock2ref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_cfg_lms_symmetric_en_attr = "serdes_lane_cdr_new_lane3_reg_1_cfg_lms_symmetric_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_csr_cdr_snap_data_attr = "serdes_lane_cdr_new_lane3_reg_1_csr_cdr_snap_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_lms_init_strobe_sc_attr = "serdes_lane_cdr_new_lane3_reg_1_lms_init_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_oversample_mode_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_oversample_mode_force_en_attr = "serdes_lane_cdr_new_lane3_reg_1_oversample_mode_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_ppm_test_en_by_fsm_attr = "serdes_lane_cdr_new_lane3_reg_1_ppm_test_en_by_fsm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_ppm_test_en_from_reg_attr = "serdes_lane_cdr_new_lane3_reg_1_ppm_test_en_from_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_1_slow_trim_en_attr = "serdes_lane_cdr_new_lane3_reg_1_slow_trim_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_cdr_ber_ph_fifo_en_attr = "serdes_lane_cdr_new_lane3_reg_20_cdr_ber_ph_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_cdr_dft_clk_enable_attr = "serdes_lane_cdr_new_lane3_reg_20_cdr_dft_clk_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_cdr_dft_clk_rst_n_attr = "serdes_lane_cdr_new_lane3_reg_20_cdr_dft_clk_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_csr_cdr_vote_fifo_en_attr = "serdes_lane_cdr_new_lane3_reg_20_csr_cdr_vote_fifo_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_dft_toggle_vcpi_integ_en_attr = "serdes_lane_cdr_new_lane3_reg_20_dft_toggle_vcpi_integ_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_integ_sd_bit_en_attr = "serdes_lane_cdr_new_lane3_reg_20_integ_sd_bit_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_slow_trim_force_mode_attr = "serdes_lane_cdr_new_lane3_reg_20_slow_trim_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_slow_trim_strobe_force_val_attr = "serdes_lane_cdr_new_lane3_reg_20_slow_trim_strobe_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_20_slow_trim_up1_dn0_force_val_attr = "serdes_lane_cdr_new_lane3_reg_20_slow_trim_up1_dn0_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_21_cfg_cdr_jit_force_en_attr = "serdes_lane_cdr_new_lane3_reg_21_cfg_cdr_jit_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_21_cfg_cdr_jit_force_mode_attr = "serdes_lane_cdr_new_lane3_reg_21_cfg_cdr_jit_force_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_21_cfg_dft_jtr_gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_21_cfg_dft_jtr_inj_en_attr = "serdes_lane_cdr_new_lane3_reg_21_cfg_dft_jtr_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_21_csr_jtr_dis_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_21_csr_jtr_en_cnt_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_22_clkgen_skew_strobe_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_22_clkgen_skew_strobe_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_22_clkgen_skew_updn_force_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_22_clkgen_skew_updn_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_23_s1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_23_s2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_23_s3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_24_s1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_24_s2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_24_s3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_25_s1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_25_s2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_25_s3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_26_s1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_26_s2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_26_s3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_27_s1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_27_s2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_27_s3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_28_s1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_28_s2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_28_s3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_29_s1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_29_s2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_29_s3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_2_cfg_dcodivcnt_target_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_2_dco_coarse_init_attr = 28;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_2_dco_coarse_max_val_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_30_s1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_30_s2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_30_s3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_31_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_32_c0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_32_c1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_32_c2_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_32_c3_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_33_c0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_33_c1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_33_c2_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_33_c3_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_34_c0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_34_c1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_34_c2_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_34_c3_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_35_c0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_35_c1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_35_c2_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_35_c3_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_36_c0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_36_c1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_36_c2_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_36_c3_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_37_c0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_37_c1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_37_c2_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_37_c3_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_38_c0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_38_c1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_38_c2_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_38_c3_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_39_c0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_39_c1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_39_c2_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_39_c3_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_3_cfg_time2dcocnt_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_3_cfg_time2dcosettle_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_40_constellation_braodcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_41_cntln_slicer_reg_strobe_sc_attr = "serdes_lane_cdr_new_lane3_reg_41_cntln_slicer_reg_strobe_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_42_cdr_clock_reset_force_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_42_cfg_cdr_div_te_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_42_cfg_cdr_pfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr = "serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_43_cdr_new_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_44_cdr_new_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_44_cdr_new_reg2probe_en_attr = "serdes_lane_cdr_new_lane3_reg_44_cdr_new_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_cfg_calib_reset_bit_attr = "serdes_lane_cdr_new_lane3_reg_4_cfg_calib_reset_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_cfg_coarse_step_final_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_cfg_coarse_step_init_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_dsp_dco_itail_trim_final_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_dsp_dco_itail_trim_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_icfg_calib_switch_up_down_attr = "serdes_lane_cdr_new_lane3_reg_4_icfg_calib_switch_up_down_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_4_icfg_coarse_out_inv_attr = "serdes_lane_cdr_new_lane3_reg_4_icfg_coarse_out_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_cfg_cdr_state_ovrd_en_attr = "serdes_lane_cdr_new_lane3_reg_5_cfg_cdr_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_cfg_cdr_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_cfg_dcocoarse_ovrd_attr = "serdes_lane_cdr_new_lane3_reg_5_cfg_dcocoarse_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_cfg_dcocoarse_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_coarse_ppm_lock_th_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_skip_coarse_calib_attr = "serdes_lane_cdr_new_lane3_reg_5_skip_coarse_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_5_skip_fine_calib_attr = "serdes_lane_cdr_new_lane3_reg_5_skip_fine_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_6_bb_pfd_sample_negedge_attr = "serdes_lane_cdr_new_lane3_reg_6_bb_pfd_sample_negedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_6_cdr_pfd_en_force_en_attr = "serdes_lane_cdr_new_lane3_reg_6_cdr_pfd_en_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_6_cdr_pfd_en_force_val_attr = "serdes_lane_cdr_new_lane3_reg_6_cdr_pfd_en_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_6_cfg_cdr_bb_pfd_step_attr = 207;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_6_cfg_time2tune_fine_cal_attr = 400;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_7_cfg_analog_dco_cvar_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_7_cfg_cvar_trim_dcoupdate_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_7_cfg_cvar_trim_state_ovrd_en_attr = "serdes_lane_cdr_new_lane3_reg_7_cfg_cvar_trim_state_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_7_cfg_cvar_trim_state_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_7_dco_cvar_force_mode_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_8_cdr_coarse_dac_sel_init_en_attr = "serdes_lane_cdr_new_lane3_reg_8_cdr_coarse_dac_sel_init_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_8_csr_coarse_dac_sel_init_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_cdr_new_lane3_reg_9_cdr_prop_thrs_attr = 63409921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_100_cfg_lane_tx_prbs_ssprq_cnt0_attr = 10924;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_100_cfg_lane_tx_prbs_ssprq_cnt1_attr = 10922;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_101_cfg_lane_tx_prbs_ssprq_cnt2_attr = 10923;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_101_cfg_lane_tx_prbs_ssprq_cnt3_attr = 10921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state11_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state8_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state6_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state8_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_103_cfg_lane_tx_prbs_ssprq_seed_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr = "serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_104_cfg_lane_tx_prbs_ssprq_max_state_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr = "serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr = "serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr = "serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr = "serdes_lane_dft_ctrl_lane0_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_107_dft_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_108_dft_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_108_dft_ctrl_reg2probe_en_attr = "serdes_lane_dft_ctrl_lane0_reg_108_dft_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_cond_hist_en_attr = "serdes_lane_dft_ctrl_lane0_reg_109_cfg_cond_hist_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_cond_hist_ui_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_delayed_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr = "serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_ui_data_sel_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_hist_selected_ui_level_sample_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_109_cfg_ui_sel_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_10_cfg_hist_ui_sel_cnt_end_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_10_cfg_hist_ui_sel_cnt_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_10_cfg_hist_ui_sel_cnt_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_110_cfg_hist_tigger_voltage_lvl_high_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_110_cfg_hist_tigger_voltage_lvl_low_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_11_cfg_128ui_rolling_cnt_limit_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_12_cfg_128ui_rolling_cnt_en_attr = "serdes_lane_dft_ctrl_lane0_reg_12_cfg_128ui_rolling_cnt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_12_cfg_128ui_samp_now_attr = "serdes_lane_dft_ctrl_lane0_reg_12_cfg_128ui_samp_now_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_12_cfg_128ui_to_fifo_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_12_cfg_128ui_to_fifo_stage_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_13_cfg_128ui_to_fifo_cnt_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_175_cfg_hist_event_cnt_lim_lsb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_176_cfg_hist_event_cnt_lim_msb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_1_cfg_dft_sar_valid_low_stick_attr = "serdes_lane_dft_ctrl_lane0_reg_1_cfg_dft_sar_valid_low_stick_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_1_cfg_dft_sar_valid_sticky_clr_attr = "serdes_lane_dft_ctrl_lane0_reg_1_cfg_dft_sar_valid_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_1_cfg_sar_sat_full_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_1_cfg_sar_sat_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_1_cfg_sar_val_window_sar_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_1_cfg_val_window_attr = 2047;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_45_cfg_pat_detect_align_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_45_cfg_pat_detect_unalign_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_align_done_sticky_en_attr = "serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_align_done_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_compare_on_attr = "serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_compare_on_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_cyc_for_align_search_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_en_attr = "serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_pat_comp_place_in_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_46_cfg_pat_detect_pat_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_47_cfg_pat_detect_start_detect_attr = "serdes_lane_dft_ctrl_lane0_reg_47_cfg_pat_detect_start_detect_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_48_cfg_pat_detect_exp_pat0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_49_cfg_pat_detect_exp_pat1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_50_cfg_pat_detect_exp_pat2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_51_cfg_pat_detect_exp_pat3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_53_cfg_pat_detect_comp_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_54_cfg_pat_detect_comp_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_55_cfg_pat_detect_probe_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_ber_count_force_cnt_attr = "serdes_lane_dft_ctrl_lane0_reg_56_cfg_ber_count_force_cnt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_ber_hist_error_counter_clr_attr = "serdes_lane_dft_ctrl_lane0_reg_56_cfg_ber_hist_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_ber_hist_error_counter_en_attr = "serdes_lane_dft_ctrl_lane0_reg_56_cfg_ber_hist_error_counter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_ber_count_en_attr = "serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_ber_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_ber_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_rx_force_lock_attr = "serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_rx_force_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_rx_lock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_rx_lock_sticky_en_attr = "serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_rx_lock_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_56_cfg_dft_rx_unlock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_57_cfg_dft_ber_clear_c_attr = "serdes_lane_dft_ctrl_lane0_reg_57_cfg_dft_ber_clear_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_57_cfg_dft_ber_start_c_attr = "serdes_lane_dft_ctrl_lane0_reg_57_cfg_dft_ber_start_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_57_cfg_dft_ber_stop_c_attr = "serdes_lane_dft_ctrl_lane0_reg_57_cfg_dft_ber_stop_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_58_cfg_dft_ber_error_mask_0_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_59_cfg_dft_ber_error_mask_32_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_60_cfg_ber_symb_cnt_limit_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_61_cfg_ber_symb_cnt_limit_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_77_cfg_dft_rx_prbs_common_en_attr = "serdes_lane_dft_ctrl_lane0_reg_77_cfg_dft_rx_prbs_common_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_77_cfg_dft_rx_prbs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_77_cfg_rx_dft_data_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_78_cfg_lane_tx_prbs_en_attr = "serdes_lane_dft_ctrl_lane0_reg_78_cfg_lane_tx_prbs_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_78_cfg_lane_tx_prbs_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_78_cfg_lane_tx_prbs_seed_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_78_cfg_lane_tx_prbs_ssprq_en_attr = "serdes_lane_dft_ctrl_lane0_reg_78_cfg_lane_tx_prbs_ssprq_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_79_cfg_lane_tx_prbs_seed_low_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_80_cfg_lane_tx_prbs_init_attr = "serdes_lane_dft_ctrl_lane0_reg_80_cfg_lane_tx_prbs_init_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_81_cfg_prbs_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_82_cfg_prbs_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_83_cfg_tx_pat_en_attr = "serdes_lane_dft_ctrl_lane0_reg_83_cfg_tx_pat_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_83_cfg_tx_pat_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_83_cfg_tx_pat_sp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_84_cfg_tx_pat_load_line_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_85_cfg_tx_pat_load_pulse_attr = "serdes_lane_dft_ctrl_lane0_reg_85_cfg_tx_pat_load_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_86_cfg_clear_ppm_counters_sc_attr = "serdes_lane_dft_ctrl_lane0_reg_86_cfg_clear_ppm_counters_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_86_cfg_ppm_raw_conter_restart_sc_attr = "serdes_lane_dft_ctrl_lane0_reg_86_cfg_ppm_raw_conter_restart_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_86_cfg_stop_ppm_meters_attr = "serdes_lane_dft_ctrl_lane0_reg_86_cfg_stop_ppm_meters_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_87_cfg_ppm_counter_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_91_cfg_dft_ber_error_mask_64_95_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_92_cfg_dft_ber_error_mask_96_127_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_93_cfg_bi_chk_en_attr = "serdes_lane_dft_ctrl_lane0_reg_93_cfg_bi_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_93_cfg_bi_symbol_count_stop_attr = "serdes_lane_dft_ctrl_lane0_reg_93_cfg_bi_symbol_count_stop_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_93_cfg_bi_toggle_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_96_cfg_lane_tx_prbs_ssprq_seed0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_97_cfg_lane_tx_prbs_ssprq_seed1_attr = 872497143;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_98_cfg_lane_tx_prbs_ssprq_seed2_attr = 214748364;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_99_cfg_lane_tx_prbs_ssprq_seed3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_adc_consider_valid_bit_attr = "serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_adc_consider_valid_bit_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_enable_attr = "serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_free_running_event_cnt_attr = "serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_free_running_event_cnt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_prbs_seed_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_reset_attr = "serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_source_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr = "serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_ui_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane0_reg_9_cfg_hist_ui_sel_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_100_cfg_lane_tx_prbs_ssprq_cnt0_attr = 10924;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_100_cfg_lane_tx_prbs_ssprq_cnt1_attr = 10922;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_101_cfg_lane_tx_prbs_ssprq_cnt2_attr = 10923;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_101_cfg_lane_tx_prbs_ssprq_cnt3_attr = 10921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state11_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state8_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state6_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state8_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_103_cfg_lane_tx_prbs_ssprq_seed_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr = "serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_104_cfg_lane_tx_prbs_ssprq_max_state_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr = "serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr = "serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr = "serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr = "serdes_lane_dft_ctrl_lane1_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_107_dft_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_108_dft_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_108_dft_ctrl_reg2probe_en_attr = "serdes_lane_dft_ctrl_lane1_reg_108_dft_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_cond_hist_en_attr = "serdes_lane_dft_ctrl_lane1_reg_109_cfg_cond_hist_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_cond_hist_ui_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_delayed_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr = "serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_ui_data_sel_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_hist_selected_ui_level_sample_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_109_cfg_ui_sel_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_10_cfg_hist_ui_sel_cnt_end_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_10_cfg_hist_ui_sel_cnt_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_10_cfg_hist_ui_sel_cnt_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_110_cfg_hist_tigger_voltage_lvl_high_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_110_cfg_hist_tigger_voltage_lvl_low_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_11_cfg_128ui_rolling_cnt_limit_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_12_cfg_128ui_rolling_cnt_en_attr = "serdes_lane_dft_ctrl_lane1_reg_12_cfg_128ui_rolling_cnt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_12_cfg_128ui_samp_now_attr = "serdes_lane_dft_ctrl_lane1_reg_12_cfg_128ui_samp_now_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_12_cfg_128ui_to_fifo_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_12_cfg_128ui_to_fifo_stage_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_13_cfg_128ui_to_fifo_cnt_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_175_cfg_hist_event_cnt_lim_lsb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_176_cfg_hist_event_cnt_lim_msb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_1_cfg_dft_sar_valid_low_stick_attr = "serdes_lane_dft_ctrl_lane1_reg_1_cfg_dft_sar_valid_low_stick_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_1_cfg_dft_sar_valid_sticky_clr_attr = "serdes_lane_dft_ctrl_lane1_reg_1_cfg_dft_sar_valid_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_1_cfg_sar_sat_full_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_1_cfg_sar_sat_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_1_cfg_sar_val_window_sar_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_1_cfg_val_window_attr = 2047;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_45_cfg_pat_detect_align_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_45_cfg_pat_detect_unalign_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_align_done_sticky_en_attr = "serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_align_done_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_compare_on_attr = "serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_compare_on_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_cyc_for_align_search_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_en_attr = "serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_pat_comp_place_in_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_46_cfg_pat_detect_pat_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_47_cfg_pat_detect_start_detect_attr = "serdes_lane_dft_ctrl_lane1_reg_47_cfg_pat_detect_start_detect_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_48_cfg_pat_detect_exp_pat0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_49_cfg_pat_detect_exp_pat1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_50_cfg_pat_detect_exp_pat2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_51_cfg_pat_detect_exp_pat3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_53_cfg_pat_detect_comp_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_54_cfg_pat_detect_comp_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_55_cfg_pat_detect_probe_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_ber_count_force_cnt_attr = "serdes_lane_dft_ctrl_lane1_reg_56_cfg_ber_count_force_cnt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_ber_hist_error_counter_clr_attr = "serdes_lane_dft_ctrl_lane1_reg_56_cfg_ber_hist_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_ber_hist_error_counter_en_attr = "serdes_lane_dft_ctrl_lane1_reg_56_cfg_ber_hist_error_counter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_ber_count_en_attr = "serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_ber_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_ber_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_rx_force_lock_attr = "serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_rx_force_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_rx_lock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_rx_lock_sticky_en_attr = "serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_rx_lock_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_56_cfg_dft_rx_unlock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_57_cfg_dft_ber_clear_c_attr = "serdes_lane_dft_ctrl_lane1_reg_57_cfg_dft_ber_clear_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_57_cfg_dft_ber_start_c_attr = "serdes_lane_dft_ctrl_lane1_reg_57_cfg_dft_ber_start_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_57_cfg_dft_ber_stop_c_attr = "serdes_lane_dft_ctrl_lane1_reg_57_cfg_dft_ber_stop_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_58_cfg_dft_ber_error_mask_0_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_59_cfg_dft_ber_error_mask_32_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_60_cfg_ber_symb_cnt_limit_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_61_cfg_ber_symb_cnt_limit_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_77_cfg_dft_rx_prbs_common_en_attr = "serdes_lane_dft_ctrl_lane1_reg_77_cfg_dft_rx_prbs_common_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_77_cfg_dft_rx_prbs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_77_cfg_rx_dft_data_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_78_cfg_lane_tx_prbs_en_attr = "serdes_lane_dft_ctrl_lane1_reg_78_cfg_lane_tx_prbs_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_78_cfg_lane_tx_prbs_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_78_cfg_lane_tx_prbs_seed_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_78_cfg_lane_tx_prbs_ssprq_en_attr = "serdes_lane_dft_ctrl_lane1_reg_78_cfg_lane_tx_prbs_ssprq_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_79_cfg_lane_tx_prbs_seed_low_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_80_cfg_lane_tx_prbs_init_attr = "serdes_lane_dft_ctrl_lane1_reg_80_cfg_lane_tx_prbs_init_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_81_cfg_prbs_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_82_cfg_prbs_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_83_cfg_tx_pat_en_attr = "serdes_lane_dft_ctrl_lane1_reg_83_cfg_tx_pat_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_83_cfg_tx_pat_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_83_cfg_tx_pat_sp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_84_cfg_tx_pat_load_line_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_85_cfg_tx_pat_load_pulse_attr = "serdes_lane_dft_ctrl_lane1_reg_85_cfg_tx_pat_load_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_86_cfg_clear_ppm_counters_sc_attr = "serdes_lane_dft_ctrl_lane1_reg_86_cfg_clear_ppm_counters_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_86_cfg_ppm_raw_conter_restart_sc_attr = "serdes_lane_dft_ctrl_lane1_reg_86_cfg_ppm_raw_conter_restart_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_86_cfg_stop_ppm_meters_attr = "serdes_lane_dft_ctrl_lane1_reg_86_cfg_stop_ppm_meters_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_87_cfg_ppm_counter_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_91_cfg_dft_ber_error_mask_64_95_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_92_cfg_dft_ber_error_mask_96_127_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_93_cfg_bi_chk_en_attr = "serdes_lane_dft_ctrl_lane1_reg_93_cfg_bi_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_93_cfg_bi_symbol_count_stop_attr = "serdes_lane_dft_ctrl_lane1_reg_93_cfg_bi_symbol_count_stop_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_93_cfg_bi_toggle_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_96_cfg_lane_tx_prbs_ssprq_seed0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_97_cfg_lane_tx_prbs_ssprq_seed1_attr = 872497143;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_98_cfg_lane_tx_prbs_ssprq_seed2_attr = 214748364;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_99_cfg_lane_tx_prbs_ssprq_seed3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_adc_consider_valid_bit_attr = "serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_adc_consider_valid_bit_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_enable_attr = "serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_free_running_event_cnt_attr = "serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_free_running_event_cnt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_prbs_seed_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_reset_attr = "serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_source_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr = "serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_ui_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane1_reg_9_cfg_hist_ui_sel_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_100_cfg_lane_tx_prbs_ssprq_cnt0_attr = 10924;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_100_cfg_lane_tx_prbs_ssprq_cnt1_attr = 10922;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_101_cfg_lane_tx_prbs_ssprq_cnt2_attr = 10923;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_101_cfg_lane_tx_prbs_ssprq_cnt3_attr = 10921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state11_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state8_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state6_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state8_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_103_cfg_lane_tx_prbs_ssprq_seed_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr = "serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_104_cfg_lane_tx_prbs_ssprq_max_state_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr = "serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr = "serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr = "serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr = "serdes_lane_dft_ctrl_lane2_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_107_dft_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_108_dft_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_108_dft_ctrl_reg2probe_en_attr = "serdes_lane_dft_ctrl_lane2_reg_108_dft_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_cond_hist_en_attr = "serdes_lane_dft_ctrl_lane2_reg_109_cfg_cond_hist_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_cond_hist_ui_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_delayed_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr = "serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_ui_data_sel_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_hist_selected_ui_level_sample_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_109_cfg_ui_sel_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_10_cfg_hist_ui_sel_cnt_end_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_10_cfg_hist_ui_sel_cnt_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_10_cfg_hist_ui_sel_cnt_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_110_cfg_hist_tigger_voltage_lvl_high_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_110_cfg_hist_tigger_voltage_lvl_low_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_11_cfg_128ui_rolling_cnt_limit_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_12_cfg_128ui_rolling_cnt_en_attr = "serdes_lane_dft_ctrl_lane2_reg_12_cfg_128ui_rolling_cnt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_12_cfg_128ui_samp_now_attr = "serdes_lane_dft_ctrl_lane2_reg_12_cfg_128ui_samp_now_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_12_cfg_128ui_to_fifo_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_12_cfg_128ui_to_fifo_stage_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_13_cfg_128ui_to_fifo_cnt_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_175_cfg_hist_event_cnt_lim_lsb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_176_cfg_hist_event_cnt_lim_msb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_1_cfg_dft_sar_valid_low_stick_attr = "serdes_lane_dft_ctrl_lane2_reg_1_cfg_dft_sar_valid_low_stick_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_1_cfg_dft_sar_valid_sticky_clr_attr = "serdes_lane_dft_ctrl_lane2_reg_1_cfg_dft_sar_valid_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_1_cfg_sar_sat_full_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_1_cfg_sar_sat_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_1_cfg_sar_val_window_sar_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_1_cfg_val_window_attr = 2047;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_45_cfg_pat_detect_align_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_45_cfg_pat_detect_unalign_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_align_done_sticky_en_attr = "serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_align_done_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_compare_on_attr = "serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_compare_on_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_cyc_for_align_search_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_en_attr = "serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_pat_comp_place_in_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_46_cfg_pat_detect_pat_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_47_cfg_pat_detect_start_detect_attr = "serdes_lane_dft_ctrl_lane2_reg_47_cfg_pat_detect_start_detect_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_48_cfg_pat_detect_exp_pat0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_49_cfg_pat_detect_exp_pat1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_50_cfg_pat_detect_exp_pat2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_51_cfg_pat_detect_exp_pat3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_53_cfg_pat_detect_comp_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_54_cfg_pat_detect_comp_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_55_cfg_pat_detect_probe_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_ber_count_force_cnt_attr = "serdes_lane_dft_ctrl_lane2_reg_56_cfg_ber_count_force_cnt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_ber_hist_error_counter_clr_attr = "serdes_lane_dft_ctrl_lane2_reg_56_cfg_ber_hist_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_ber_hist_error_counter_en_attr = "serdes_lane_dft_ctrl_lane2_reg_56_cfg_ber_hist_error_counter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_ber_count_en_attr = "serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_ber_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_ber_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_rx_force_lock_attr = "serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_rx_force_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_rx_lock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_rx_lock_sticky_en_attr = "serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_rx_lock_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_56_cfg_dft_rx_unlock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_57_cfg_dft_ber_clear_c_attr = "serdes_lane_dft_ctrl_lane2_reg_57_cfg_dft_ber_clear_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_57_cfg_dft_ber_start_c_attr = "serdes_lane_dft_ctrl_lane2_reg_57_cfg_dft_ber_start_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_57_cfg_dft_ber_stop_c_attr = "serdes_lane_dft_ctrl_lane2_reg_57_cfg_dft_ber_stop_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_58_cfg_dft_ber_error_mask_0_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_59_cfg_dft_ber_error_mask_32_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_60_cfg_ber_symb_cnt_limit_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_61_cfg_ber_symb_cnt_limit_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_77_cfg_dft_rx_prbs_common_en_attr = "serdes_lane_dft_ctrl_lane2_reg_77_cfg_dft_rx_prbs_common_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_77_cfg_dft_rx_prbs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_77_cfg_rx_dft_data_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_78_cfg_lane_tx_prbs_en_attr = "serdes_lane_dft_ctrl_lane2_reg_78_cfg_lane_tx_prbs_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_78_cfg_lane_tx_prbs_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_78_cfg_lane_tx_prbs_seed_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_78_cfg_lane_tx_prbs_ssprq_en_attr = "serdes_lane_dft_ctrl_lane2_reg_78_cfg_lane_tx_prbs_ssprq_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_79_cfg_lane_tx_prbs_seed_low_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_80_cfg_lane_tx_prbs_init_attr = "serdes_lane_dft_ctrl_lane2_reg_80_cfg_lane_tx_prbs_init_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_81_cfg_prbs_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_82_cfg_prbs_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_83_cfg_tx_pat_en_attr = "serdes_lane_dft_ctrl_lane2_reg_83_cfg_tx_pat_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_83_cfg_tx_pat_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_83_cfg_tx_pat_sp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_84_cfg_tx_pat_load_line_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_85_cfg_tx_pat_load_pulse_attr = "serdes_lane_dft_ctrl_lane2_reg_85_cfg_tx_pat_load_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_86_cfg_clear_ppm_counters_sc_attr = "serdes_lane_dft_ctrl_lane2_reg_86_cfg_clear_ppm_counters_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_86_cfg_ppm_raw_conter_restart_sc_attr = "serdes_lane_dft_ctrl_lane2_reg_86_cfg_ppm_raw_conter_restart_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_86_cfg_stop_ppm_meters_attr = "serdes_lane_dft_ctrl_lane2_reg_86_cfg_stop_ppm_meters_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_87_cfg_ppm_counter_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_91_cfg_dft_ber_error_mask_64_95_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_92_cfg_dft_ber_error_mask_96_127_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_93_cfg_bi_chk_en_attr = "serdes_lane_dft_ctrl_lane2_reg_93_cfg_bi_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_93_cfg_bi_symbol_count_stop_attr = "serdes_lane_dft_ctrl_lane2_reg_93_cfg_bi_symbol_count_stop_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_93_cfg_bi_toggle_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_96_cfg_lane_tx_prbs_ssprq_seed0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_97_cfg_lane_tx_prbs_ssprq_seed1_attr = 872497143;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_98_cfg_lane_tx_prbs_ssprq_seed2_attr = 214748364;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_99_cfg_lane_tx_prbs_ssprq_seed3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_adc_consider_valid_bit_attr = "serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_adc_consider_valid_bit_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_enable_attr = "serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_free_running_event_cnt_attr = "serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_free_running_event_cnt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_prbs_seed_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_reset_attr = "serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_source_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr = "serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_ui_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane2_reg_9_cfg_hist_ui_sel_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_100_cfg_lane_tx_prbs_ssprq_cnt0_attr = 10924;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_100_cfg_lane_tx_prbs_ssprq_cnt1_attr = 10922;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_101_cfg_lane_tx_prbs_ssprq_cnt2_attr = 10923;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_101_cfg_lane_tx_prbs_ssprq_cnt3_attr = 10921;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state11_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state8_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_102_cfg_lane_tx_prbs_ssprq_cnt_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state10_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state6_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state8_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_103_cfg_lane_tx_prbs_ssprq_seed_state9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state8_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_last_state9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state11_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state5_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr = "serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_inv_state9_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_104_cfg_lane_tx_prbs_ssprq_max_state_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr = "serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr = "serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr = "serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr = "serdes_lane_dft_ctrl_lane3_reg_105_cfg_lane_tx_prbs_ssprq_inv_last_state15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_107_dft_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_108_dft_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_108_dft_ctrl_reg2probe_en_attr = "serdes_lane_dft_ctrl_lane3_reg_108_dft_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_cond_hist_en_attr = "serdes_lane_dft_ctrl_lane3_reg_109_cfg_cond_hist_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_cond_hist_ui_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_delayed_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_delayed_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr = "serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_dfe_data_cond_ignore_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_dfe_data_cond_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr = "serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_ui_data_sel_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_ui_data_sel_force_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_hist_selected_ui_level_sample_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_109_cfg_ui_sel_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_10_cfg_hist_ui_sel_cnt_end_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_10_cfg_hist_ui_sel_cnt_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_10_cfg_hist_ui_sel_cnt_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_110_cfg_hist_tigger_voltage_lvl_high_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_110_cfg_hist_tigger_voltage_lvl_low_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_11_cfg_128ui_rolling_cnt_limit_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_12_cfg_128ui_rolling_cnt_en_attr = "serdes_lane_dft_ctrl_lane3_reg_12_cfg_128ui_rolling_cnt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_12_cfg_128ui_samp_now_attr = "serdes_lane_dft_ctrl_lane3_reg_12_cfg_128ui_samp_now_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_12_cfg_128ui_to_fifo_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_12_cfg_128ui_to_fifo_stage_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_13_cfg_128ui_to_fifo_cnt_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_175_cfg_hist_event_cnt_lim_lsb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_176_cfg_hist_event_cnt_lim_msb_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_1_cfg_dft_sar_valid_low_stick_attr = "serdes_lane_dft_ctrl_lane3_reg_1_cfg_dft_sar_valid_low_stick_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_1_cfg_dft_sar_valid_sticky_clr_attr = "serdes_lane_dft_ctrl_lane3_reg_1_cfg_dft_sar_valid_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_1_cfg_sar_sat_full_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_1_cfg_sar_sat_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_1_cfg_sar_val_window_sar_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_1_cfg_val_window_attr = 2047;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_45_cfg_pat_detect_align_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_45_cfg_pat_detect_unalign_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_align_done_sticky_en_attr = "serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_align_done_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_compare_on_attr = "serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_compare_on_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_cyc_for_align_search_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_en_attr = "serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_pat_comp_place_in_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_46_cfg_pat_detect_pat_period_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_47_cfg_pat_detect_start_detect_attr = "serdes_lane_dft_ctrl_lane3_reg_47_cfg_pat_detect_start_detect_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_48_cfg_pat_detect_exp_pat0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_49_cfg_pat_detect_exp_pat1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_50_cfg_pat_detect_exp_pat2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_51_cfg_pat_detect_exp_pat3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_53_cfg_pat_detect_comp_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_54_cfg_pat_detect_comp_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_55_cfg_pat_detect_probe_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_ber_count_force_cnt_attr = "serdes_lane_dft_ctrl_lane3_reg_56_cfg_ber_count_force_cnt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_ber_hist_error_counter_clr_attr = "serdes_lane_dft_ctrl_lane3_reg_56_cfg_ber_hist_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_ber_hist_error_counter_en_attr = "serdes_lane_dft_ctrl_lane3_reg_56_cfg_ber_hist_error_counter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_ber_count_en_attr = "serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_ber_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_ber_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_rx_force_lock_attr = "serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_rx_force_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_rx_lock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_rx_lock_sticky_en_attr = "serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_rx_lock_sticky_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_56_cfg_dft_rx_unlock_dly_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_57_cfg_dft_ber_clear_c_attr = "serdes_lane_dft_ctrl_lane3_reg_57_cfg_dft_ber_clear_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_57_cfg_dft_ber_start_c_attr = "serdes_lane_dft_ctrl_lane3_reg_57_cfg_dft_ber_start_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_57_cfg_dft_ber_stop_c_attr = "serdes_lane_dft_ctrl_lane3_reg_57_cfg_dft_ber_stop_c_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_58_cfg_dft_ber_error_mask_0_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_59_cfg_dft_ber_error_mask_32_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_60_cfg_ber_symb_cnt_limit_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_61_cfg_ber_symb_cnt_limit_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_77_cfg_dft_rx_prbs_common_en_attr = "serdes_lane_dft_ctrl_lane3_reg_77_cfg_dft_rx_prbs_common_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_77_cfg_dft_rx_prbs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_77_cfg_rx_dft_data_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_78_cfg_lane_tx_prbs_en_attr = "serdes_lane_dft_ctrl_lane3_reg_78_cfg_lane_tx_prbs_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_78_cfg_lane_tx_prbs_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_78_cfg_lane_tx_prbs_seed_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_78_cfg_lane_tx_prbs_ssprq_en_attr = "serdes_lane_dft_ctrl_lane3_reg_78_cfg_lane_tx_prbs_ssprq_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_79_cfg_lane_tx_prbs_seed_low_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_80_cfg_lane_tx_prbs_init_attr = "serdes_lane_dft_ctrl_lane3_reg_80_cfg_lane_tx_prbs_init_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_81_cfg_prbs_mask_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_82_cfg_prbs_mask_msb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_83_cfg_tx_pat_en_attr = "serdes_lane_dft_ctrl_lane3_reg_83_cfg_tx_pat_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_83_cfg_tx_pat_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_83_cfg_tx_pat_sp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_84_cfg_tx_pat_load_line_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_85_cfg_tx_pat_load_pulse_attr = "serdes_lane_dft_ctrl_lane3_reg_85_cfg_tx_pat_load_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_86_cfg_clear_ppm_counters_sc_attr = "serdes_lane_dft_ctrl_lane3_reg_86_cfg_clear_ppm_counters_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_86_cfg_ppm_raw_conter_restart_sc_attr = "serdes_lane_dft_ctrl_lane3_reg_86_cfg_ppm_raw_conter_restart_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_86_cfg_stop_ppm_meters_attr = "serdes_lane_dft_ctrl_lane3_reg_86_cfg_stop_ppm_meters_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_87_cfg_ppm_counter_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_91_cfg_dft_ber_error_mask_64_95_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_92_cfg_dft_ber_error_mask_96_127_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_93_cfg_bi_chk_en_attr = "serdes_lane_dft_ctrl_lane3_reg_93_cfg_bi_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_93_cfg_bi_symbol_count_stop_attr = "serdes_lane_dft_ctrl_lane3_reg_93_cfg_bi_symbol_count_stop_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_93_cfg_bi_toggle_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_96_cfg_lane_tx_prbs_ssprq_seed0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_97_cfg_lane_tx_prbs_ssprq_seed1_attr = 872497143;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_98_cfg_lane_tx_prbs_ssprq_seed2_attr = 214748364;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_99_cfg_lane_tx_prbs_ssprq_seed3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_adc_consider_valid_bit_attr = "serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_adc_consider_valid_bit_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_enable_attr = "serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_free_running_event_cnt_attr = "serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_free_running_event_cnt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_prbs_seed_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_reset_attr = "serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_source_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_start_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_stop_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr = "serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_stop_event_cnt_at_bin_max_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_ui_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dft_ctrl_lane3_reg_9_cfg_hist_ui_sel_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_10_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_11_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_12_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_13_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_15_dfe_adapt_all_taps_en_attr = "serdes_lane_dsp_adapt_lane0_reg_15_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_17_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_18_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_19_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_bit_swz_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_d_swz_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_d_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_en_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_inner_d_swz_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_inner_m_swz_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_latch_dis_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_dsp_m_swz_attr = "serdes_lane_dsp_adapt_lane0_reg_20_dsp_m_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_fine_attr = "serdes_lane_dsp_adapt_lane0_reg_20_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_ofc_sar_lsb_inv_attr = "serdes_lane_dsp_adapt_lane0_reg_20_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_ofc_sar_lsb_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_pam_4_en_attr = "serdes_lane_dsp_adapt_lane0_reg_20_pam_4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_20_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_21_ehm_event_sign_attr = "serdes_lane_dsp_adapt_lane0_reg_21_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_21_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_21_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_21_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_22_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_22_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_22_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_22_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_22_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_agc_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_0_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_10_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_11_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_12_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_13_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_14_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_15_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_1_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_2_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_3_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_4_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_5_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_6_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_7_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_8_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_9_attr = "serdes_lane_dsp_adapt_lane0_reg_23_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_gain_sar_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_ofc_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_ofc_lsb_sar_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_ofc_sar_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_power_save_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_res_isi_mes_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_vga_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_23_x3_en_attr = "serdes_lane_dsp_adapt_lane0_reg_23_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_24_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_25_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_26_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_27_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_28_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_29_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_2_agc_coarse_det_en_attr = "serdes_lane_dsp_adapt_lane0_reg_2_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_2_agc_d_sign_attr = "serdes_lane_dsp_adapt_lane0_reg_2_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_30_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_31_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_d_dly_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_swap_bot_en_attr = "serdes_lane_dsp_adapt_lane0_reg_32_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_32_swap_top_en_attr = "serdes_lane_dsp_adapt_lane0_reg_32_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_33_cfg_ofc_sar_adc_decode_en_attr = "serdes_lane_dsp_adapt_lane0_reg_33_cfg_ofc_sar_adc_decode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_33_coarse_det_pol_attr = "serdes_lane_dsp_adapt_lane0_reg_33_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_33_joint_dfe_en_attr = "serdes_lane_dsp_adapt_lane0_reg_33_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_33_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane0_reg_34_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_0_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_10_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_11_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_12_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_13_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_14_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_15_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_16_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_17_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_18_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_1_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_2_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_3_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_4_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_5_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_6_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_7_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_8_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_9_attr = "serdes_lane_dsp_adapt_lane0_reg_34_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_vga_sticky_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_34_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_34_x3_sticky_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_34_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_agc_acc_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_35_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_0_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_10_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_11_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_12_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_13_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_14_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_15_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_1_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_2_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_3_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_4_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_5_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_6_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_7_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_8_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_9_attr = "serdes_lane_dsp_adapt_lane0_reg_35_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_ehm_acc_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_35_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_ofc_acc_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_35_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_vga_acc_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_35_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_35_x3_acc_clr_attr = "serdes_lane_dsp_adapt_lane0_reg_35_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_36_ofc_d_sign_attr = "serdes_lane_dsp_adapt_lane0_reg_36_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_36_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_36_ofc_event_sign_attr = "serdes_lane_dsp_adapt_lane0_reg_36_ofc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_37_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_38_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_38_agc_event_sign_attr = "serdes_lane_dsp_adapt_lane0_reg_38_agc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_39_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_39_dfe_event_sign_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_3_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_3_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_40_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_41_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_42_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_42_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_45_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_46_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_47_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_48_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_49_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_4_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_50_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_51_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_51_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_51_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_51_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_51_vga_zero_pull_en_attr = "serdes_lane_dsp_adapt_lane0_reg_51_vga_zero_pull_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_51_vga_zero_pull_factor_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_52_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_53_vga_stable_attr = "serdes_lane_dsp_adapt_lane0_reg_53_vga_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_54_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_54_dfe_common_th_en_attr = "serdes_lane_dsp_adapt_lane0_reg_54_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_55_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_55_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_55_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_55_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_55_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_56_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_56_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_56_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_57_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_58_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_58_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_58_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_58_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_58_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_59_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_59_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_59_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_5_dfe_d_sign_attr = "serdes_lane_dsp_adapt_lane0_reg_5_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_5_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane0_reg_60_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gps_tap32_sel_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_61_gps_tap64_sel_attr = "serdes_lane_dsp_adapt_lane0_reg_61_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_62_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_62_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_62_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_62_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_62_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_63_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_63_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_63_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_acc_clr_en_attr = "serdes_lane_dsp_adapt_lane0_reg_64_acc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_acc_clr_rst_attr = "serdes_lane_dsp_adapt_lane0_reg_64_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_agc_clr_en_attr = "serdes_lane_dsp_adapt_lane0_reg_64_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_dfe1_clr_en_attr = "serdes_lane_dsp_adapt_lane0_reg_64_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_dfe2_16_clr_en_attr = "serdes_lane_dsp_adapt_lane0_reg_64_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_ofc_clr_en_attr = "serdes_lane_dsp_adapt_lane0_reg_64_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_vga_clr_en_attr = "serdes_lane_dsp_adapt_lane0_reg_64_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_64_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_65_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_66_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_67_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_67_snr_meter_en_attr = "serdes_lane_dsp_adapt_lane0_reg_67_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_67_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_69_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_6_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_6_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_70_dsp_adapt_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_71_dsp_adapt_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_71_dsp_adapt_reg2probe_en_attr = "serdes_lane_dsp_adapt_lane0_reg_71_dsp_adapt_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_74_sec_lms0_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_75_sec_lms1_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_76_sec_lms2_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_77_sec_lms3_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_78_sec_lms0_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_79_sec_lms1_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_7_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_80_sec_lms2_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_81_sec_lms3_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_82_sec_lms_clr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_82_sec_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_82_sec_lms_ofc_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_83_sec_lms0_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_83_sec_lms1_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_83_sec_lms2_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_83_sec_lms3_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_84_sec_lms_acc_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_84_sec_lms_acc_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_8_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_9_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane0_reg_9_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_10_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_11_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_12_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_13_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_15_dfe_adapt_all_taps_en_attr = "serdes_lane_dsp_adapt_lane1_reg_15_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_17_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_18_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_19_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_bit_swz_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_d_swz_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_d_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_en_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_inner_d_swz_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_inner_m_swz_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_latch_dis_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_dsp_m_swz_attr = "serdes_lane_dsp_adapt_lane1_reg_20_dsp_m_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_fine_attr = "serdes_lane_dsp_adapt_lane1_reg_20_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_ofc_sar_lsb_inv_attr = "serdes_lane_dsp_adapt_lane1_reg_20_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_ofc_sar_lsb_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_pam_4_en_attr = "serdes_lane_dsp_adapt_lane1_reg_20_pam_4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_20_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_21_ehm_event_sign_attr = "serdes_lane_dsp_adapt_lane1_reg_21_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_21_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_21_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_21_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_22_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_22_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_22_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_22_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_22_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_agc_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_0_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_10_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_11_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_12_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_13_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_14_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_15_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_1_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_2_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_3_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_4_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_5_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_6_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_7_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_8_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_9_attr = "serdes_lane_dsp_adapt_lane1_reg_23_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_gain_sar_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_ofc_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_ofc_lsb_sar_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_ofc_sar_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_power_save_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_res_isi_mes_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_vga_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_23_x3_en_attr = "serdes_lane_dsp_adapt_lane1_reg_23_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_24_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_25_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_26_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_27_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_28_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_29_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_2_agc_coarse_det_en_attr = "serdes_lane_dsp_adapt_lane1_reg_2_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_2_agc_d_sign_attr = "serdes_lane_dsp_adapt_lane1_reg_2_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_30_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_31_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_d_dly_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_swap_bot_en_attr = "serdes_lane_dsp_adapt_lane1_reg_32_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_32_swap_top_en_attr = "serdes_lane_dsp_adapt_lane1_reg_32_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_33_cfg_ofc_sar_adc_decode_en_attr = "serdes_lane_dsp_adapt_lane1_reg_33_cfg_ofc_sar_adc_decode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_33_coarse_det_pol_attr = "serdes_lane_dsp_adapt_lane1_reg_33_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_33_joint_dfe_en_attr = "serdes_lane_dsp_adapt_lane1_reg_33_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_33_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane1_reg_34_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_0_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_10_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_11_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_12_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_13_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_14_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_15_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_16_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_17_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_18_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_1_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_2_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_3_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_4_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_5_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_6_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_7_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_8_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_9_attr = "serdes_lane_dsp_adapt_lane1_reg_34_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_vga_sticky_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_34_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_34_x3_sticky_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_34_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_agc_acc_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_35_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_0_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_10_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_11_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_12_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_13_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_14_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_15_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_1_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_2_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_3_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_4_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_5_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_6_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_7_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_8_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_9_attr = "serdes_lane_dsp_adapt_lane1_reg_35_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_ehm_acc_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_35_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_ofc_acc_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_35_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_vga_acc_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_35_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_35_x3_acc_clr_attr = "serdes_lane_dsp_adapt_lane1_reg_35_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_36_ofc_d_sign_attr = "serdes_lane_dsp_adapt_lane1_reg_36_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_36_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_36_ofc_event_sign_attr = "serdes_lane_dsp_adapt_lane1_reg_36_ofc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_37_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_38_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_38_agc_event_sign_attr = "serdes_lane_dsp_adapt_lane1_reg_38_agc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_39_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_39_dfe_event_sign_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_3_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_3_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_40_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_41_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_42_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_42_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_45_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_46_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_47_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_48_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_49_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_4_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_50_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_51_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_51_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_51_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_51_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_51_vga_zero_pull_en_attr = "serdes_lane_dsp_adapt_lane1_reg_51_vga_zero_pull_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_51_vga_zero_pull_factor_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_52_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_53_vga_stable_attr = "serdes_lane_dsp_adapt_lane1_reg_53_vga_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_54_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_54_dfe_common_th_en_attr = "serdes_lane_dsp_adapt_lane1_reg_54_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_55_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_55_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_55_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_55_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_55_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_56_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_56_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_56_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_57_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_58_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_58_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_58_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_58_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_58_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_59_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_59_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_59_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_5_dfe_d_sign_attr = "serdes_lane_dsp_adapt_lane1_reg_5_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_5_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane1_reg_60_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gps_tap32_sel_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_61_gps_tap64_sel_attr = "serdes_lane_dsp_adapt_lane1_reg_61_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_62_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_62_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_62_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_62_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_62_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_63_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_63_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_63_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_acc_clr_en_attr = "serdes_lane_dsp_adapt_lane1_reg_64_acc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_acc_clr_rst_attr = "serdes_lane_dsp_adapt_lane1_reg_64_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_agc_clr_en_attr = "serdes_lane_dsp_adapt_lane1_reg_64_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_dfe1_clr_en_attr = "serdes_lane_dsp_adapt_lane1_reg_64_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_dfe2_16_clr_en_attr = "serdes_lane_dsp_adapt_lane1_reg_64_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_ofc_clr_en_attr = "serdes_lane_dsp_adapt_lane1_reg_64_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_vga_clr_en_attr = "serdes_lane_dsp_adapt_lane1_reg_64_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_64_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_65_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_66_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_67_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_67_snr_meter_en_attr = "serdes_lane_dsp_adapt_lane1_reg_67_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_67_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_69_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_6_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_6_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_70_dsp_adapt_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_71_dsp_adapt_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_71_dsp_adapt_reg2probe_en_attr = "serdes_lane_dsp_adapt_lane1_reg_71_dsp_adapt_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_74_sec_lms0_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_75_sec_lms1_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_76_sec_lms2_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_77_sec_lms3_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_78_sec_lms0_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_79_sec_lms1_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_7_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_80_sec_lms2_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_81_sec_lms3_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_82_sec_lms_clr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_82_sec_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_82_sec_lms_ofc_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_83_sec_lms0_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_83_sec_lms1_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_83_sec_lms2_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_83_sec_lms3_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_84_sec_lms_acc_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_84_sec_lms_acc_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_8_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_9_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane1_reg_9_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_10_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_11_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_12_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_13_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_15_dfe_adapt_all_taps_en_attr = "serdes_lane_dsp_adapt_lane2_reg_15_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_17_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_18_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_19_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_bit_swz_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_d_swz_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_d_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_en_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_inner_d_swz_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_inner_m_swz_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_latch_dis_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_dsp_m_swz_attr = "serdes_lane_dsp_adapt_lane2_reg_20_dsp_m_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_fine_attr = "serdes_lane_dsp_adapt_lane2_reg_20_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_ofc_sar_lsb_inv_attr = "serdes_lane_dsp_adapt_lane2_reg_20_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_ofc_sar_lsb_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_pam_4_en_attr = "serdes_lane_dsp_adapt_lane2_reg_20_pam_4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_20_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_21_ehm_event_sign_attr = "serdes_lane_dsp_adapt_lane2_reg_21_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_21_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_21_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_21_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_22_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_22_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_22_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_22_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_22_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_agc_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_0_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_10_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_11_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_12_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_13_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_14_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_15_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_1_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_2_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_3_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_4_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_5_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_6_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_7_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_8_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_9_attr = "serdes_lane_dsp_adapt_lane2_reg_23_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_gain_sar_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_ofc_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_ofc_lsb_sar_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_ofc_sar_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_power_save_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_res_isi_mes_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_vga_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_23_x3_en_attr = "serdes_lane_dsp_adapt_lane2_reg_23_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_24_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_25_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_26_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_27_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_28_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_29_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_2_agc_coarse_det_en_attr = "serdes_lane_dsp_adapt_lane2_reg_2_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_2_agc_d_sign_attr = "serdes_lane_dsp_adapt_lane2_reg_2_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_30_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_31_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_d_dly_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_swap_bot_en_attr = "serdes_lane_dsp_adapt_lane2_reg_32_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_32_swap_top_en_attr = "serdes_lane_dsp_adapt_lane2_reg_32_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_33_cfg_ofc_sar_adc_decode_en_attr = "serdes_lane_dsp_adapt_lane2_reg_33_cfg_ofc_sar_adc_decode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_33_coarse_det_pol_attr = "serdes_lane_dsp_adapt_lane2_reg_33_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_33_joint_dfe_en_attr = "serdes_lane_dsp_adapt_lane2_reg_33_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_33_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane2_reg_34_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_0_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_10_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_11_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_12_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_13_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_14_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_15_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_16_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_17_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_18_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_1_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_2_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_3_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_4_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_5_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_6_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_7_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_8_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_9_attr = "serdes_lane_dsp_adapt_lane2_reg_34_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_vga_sticky_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_34_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_34_x3_sticky_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_34_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_agc_acc_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_35_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_0_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_10_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_11_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_12_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_13_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_14_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_15_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_1_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_2_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_3_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_4_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_5_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_6_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_7_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_8_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_9_attr = "serdes_lane_dsp_adapt_lane2_reg_35_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_ehm_acc_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_35_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_ofc_acc_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_35_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_vga_acc_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_35_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_35_x3_acc_clr_attr = "serdes_lane_dsp_adapt_lane2_reg_35_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_36_ofc_d_sign_attr = "serdes_lane_dsp_adapt_lane2_reg_36_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_36_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_36_ofc_event_sign_attr = "serdes_lane_dsp_adapt_lane2_reg_36_ofc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_37_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_38_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_38_agc_event_sign_attr = "serdes_lane_dsp_adapt_lane2_reg_38_agc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_39_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_39_dfe_event_sign_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_3_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_3_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_40_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_41_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_42_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_42_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_45_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_46_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_47_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_48_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_49_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_4_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_50_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_51_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_51_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_51_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_51_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_51_vga_zero_pull_en_attr = "serdes_lane_dsp_adapt_lane2_reg_51_vga_zero_pull_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_51_vga_zero_pull_factor_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_52_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_53_vga_stable_attr = "serdes_lane_dsp_adapt_lane2_reg_53_vga_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_54_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_54_dfe_common_th_en_attr = "serdes_lane_dsp_adapt_lane2_reg_54_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_55_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_55_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_55_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_55_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_55_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_56_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_56_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_56_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_57_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_58_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_58_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_58_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_58_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_58_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_59_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_59_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_59_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_5_dfe_d_sign_attr = "serdes_lane_dsp_adapt_lane2_reg_5_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_5_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane2_reg_60_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gps_tap32_sel_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_61_gps_tap64_sel_attr = "serdes_lane_dsp_adapt_lane2_reg_61_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_62_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_62_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_62_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_62_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_62_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_63_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_63_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_63_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_acc_clr_en_attr = "serdes_lane_dsp_adapt_lane2_reg_64_acc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_acc_clr_rst_attr = "serdes_lane_dsp_adapt_lane2_reg_64_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_agc_clr_en_attr = "serdes_lane_dsp_adapt_lane2_reg_64_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_dfe1_clr_en_attr = "serdes_lane_dsp_adapt_lane2_reg_64_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_dfe2_16_clr_en_attr = "serdes_lane_dsp_adapt_lane2_reg_64_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_ofc_clr_en_attr = "serdes_lane_dsp_adapt_lane2_reg_64_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_vga_clr_en_attr = "serdes_lane_dsp_adapt_lane2_reg_64_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_64_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_65_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_66_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_67_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_67_snr_meter_en_attr = "serdes_lane_dsp_adapt_lane2_reg_67_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_67_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_69_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_6_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_6_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_70_dsp_adapt_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_71_dsp_adapt_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_71_dsp_adapt_reg2probe_en_attr = "serdes_lane_dsp_adapt_lane2_reg_71_dsp_adapt_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_74_sec_lms0_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_75_sec_lms1_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_76_sec_lms2_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_77_sec_lms3_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_78_sec_lms0_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_79_sec_lms1_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_7_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_80_sec_lms2_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_81_sec_lms3_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_82_sec_lms_clr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_82_sec_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_82_sec_lms_ofc_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_83_sec_lms0_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_83_sec_lms1_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_83_sec_lms2_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_83_sec_lms3_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_84_sec_lms_acc_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_84_sec_lms_acc_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_8_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_9_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane2_reg_9_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_10_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_11_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_12_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_13_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_15_dfe_adapt_all_taps_en_attr = "serdes_lane_dsp_adapt_lane3_reg_15_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_17_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_18_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_19_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_bit_swz_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_d_swz_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_d_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_en_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_inner_d_swz_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_inner_m_swz_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_latch_dis_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_dsp_m_swz_attr = "serdes_lane_dsp_adapt_lane3_reg_20_dsp_m_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_fine_attr = "serdes_lane_dsp_adapt_lane3_reg_20_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_ofc_sar_lsb_inv_attr = "serdes_lane_dsp_adapt_lane3_reg_20_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_ofc_sar_lsb_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_pam_4_en_attr = "serdes_lane_dsp_adapt_lane3_reg_20_pam_4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_20_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_21_ehm_event_sign_attr = "serdes_lane_dsp_adapt_lane3_reg_21_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_21_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_21_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_21_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_22_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_22_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_22_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_22_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_22_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_agc_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_0_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_10_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_11_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_12_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_13_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_14_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_15_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_1_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_2_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_3_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_4_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_5_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_6_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_7_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_8_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_9_attr = "serdes_lane_dsp_adapt_lane3_reg_23_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_gain_sar_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_ofc_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_ofc_lsb_sar_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_ofc_sar_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_power_save_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_res_isi_mes_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_vga_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_23_x3_en_attr = "serdes_lane_dsp_adapt_lane3_reg_23_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_24_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_25_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_26_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_27_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_28_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_29_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_2_agc_coarse_det_en_attr = "serdes_lane_dsp_adapt_lane3_reg_2_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_2_agc_d_sign_attr = "serdes_lane_dsp_adapt_lane3_reg_2_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_30_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_31_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_d_dly_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_swap_bot_en_attr = "serdes_lane_dsp_adapt_lane3_reg_32_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_32_swap_top_en_attr = "serdes_lane_dsp_adapt_lane3_reg_32_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_33_cfg_ofc_sar_adc_decode_en_attr = "serdes_lane_dsp_adapt_lane3_reg_33_cfg_ofc_sar_adc_decode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_33_coarse_det_pol_attr = "serdes_lane_dsp_adapt_lane3_reg_33_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_33_joint_dfe_en_attr = "serdes_lane_dsp_adapt_lane3_reg_33_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_33_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane3_reg_34_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_0_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_10_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_11_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_12_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_13_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_14_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_15_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_16_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_17_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_18_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_1_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_2_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_3_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_4_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_5_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_6_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_7_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_8_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_9_attr = "serdes_lane_dsp_adapt_lane3_reg_34_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_vga_sticky_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_34_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_34_x3_sticky_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_34_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_agc_acc_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_35_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_0_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_10_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_11_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_12_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_13_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_14_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_15_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_1_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_2_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_3_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_4_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_5_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_6_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_7_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_8_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_9_attr = "serdes_lane_dsp_adapt_lane3_reg_35_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_ehm_acc_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_35_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_ofc_acc_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_35_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_vga_acc_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_35_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_35_x3_acc_clr_attr = "serdes_lane_dsp_adapt_lane3_reg_35_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_36_ofc_d_sign_attr = "serdes_lane_dsp_adapt_lane3_reg_36_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_36_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_36_ofc_event_sign_attr = "serdes_lane_dsp_adapt_lane3_reg_36_ofc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_37_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_38_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_38_agc_event_sign_attr = "serdes_lane_dsp_adapt_lane3_reg_38_agc_event_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_39_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_39_dfe_event_sign_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_3_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_3_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_40_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_41_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_42_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_42_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_45_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_46_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_47_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_48_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_49_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_4_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_50_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_51_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_51_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_51_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_51_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_51_vga_zero_pull_en_attr = "serdes_lane_dsp_adapt_lane3_reg_51_vga_zero_pull_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_51_vga_zero_pull_factor_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_52_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_53_vga_stable_attr = "serdes_lane_dsp_adapt_lane3_reg_53_vga_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_54_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_54_dfe_common_th_en_attr = "serdes_lane_dsp_adapt_lane3_reg_54_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_55_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_55_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_55_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_55_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_55_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_56_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_56_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_56_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_57_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_58_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_58_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_58_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_58_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_58_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_59_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_59_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_59_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_5_dfe_d_sign_attr = "serdes_lane_dsp_adapt_lane3_reg_5_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_5_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr1_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr2_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr3_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr4_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr5_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr6_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr7_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr8_attr = "serdes_lane_dsp_adapt_lane3_reg_60_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr1_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr2_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr3_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr4_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr5_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr6_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr7_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr8_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gps_tap32_sel_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_61_gps_tap64_sel_attr = "serdes_lane_dsp_adapt_lane3_reg_61_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_62_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_62_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_62_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_62_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_62_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_63_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_63_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_63_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_acc_clr_en_attr = "serdes_lane_dsp_adapt_lane3_reg_64_acc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_acc_clr_rst_attr = "serdes_lane_dsp_adapt_lane3_reg_64_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_agc_clr_en_attr = "serdes_lane_dsp_adapt_lane3_reg_64_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_dfe1_clr_en_attr = "serdes_lane_dsp_adapt_lane3_reg_64_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_dfe2_16_clr_en_attr = "serdes_lane_dsp_adapt_lane3_reg_64_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_ofc_clr_en_attr = "serdes_lane_dsp_adapt_lane3_reg_64_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_vga_clr_en_attr = "serdes_lane_dsp_adapt_lane3_reg_64_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_64_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_65_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_66_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_67_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_67_snr_meter_en_attr = "serdes_lane_dsp_adapt_lane3_reg_67_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_67_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_69_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_6_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_6_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_70_dsp_adapt_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_71_dsp_adapt_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_71_dsp_adapt_reg2probe_en_attr = "serdes_lane_dsp_adapt_lane3_reg_71_dsp_adapt_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_74_sec_lms0_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_75_sec_lms1_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_76_sec_lms2_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_77_sec_lms3_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_78_sec_lms0_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_79_sec_lms1_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_7_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_80_sec_lms2_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_81_sec_lms3_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_82_sec_lms_clr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_82_sec_lms_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_82_sec_lms_ofc_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_83_sec_lms0_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_83_sec_lms1_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_83_sec_lms2_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_83_sec_lms3_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_84_sec_lms_acc_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_84_sec_lms_acc_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_8_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_9_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_adapt_lane3_reg_9_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_10_dfe_err_slicer_p_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_11_dfe_err_slicer_n_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_12_dfe_err_slice_level_p1_set0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_12_dfe_err_slice_level_p3_set0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_13_dfe_err_slice_level_m1_set0_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_13_dfe_err_slice_level_m3_set0_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_14_dfe_err_slice_level_p1_set1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_14_dfe_err_slice_level_p3_set1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_15_dfe_err_slice_level_m1_set1_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_15_dfe_err_slice_level_m3_set1_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_16_dfe_err_slice_level_p1_set2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_16_dfe_err_slice_level_p3_set2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_17_dfe_err_slice_level_m1_set2_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_17_dfe_err_slice_level_m3_set2_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_18_dfe_err_slice_level_p1_set3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_18_dfe_err_slice_level_p3_set3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_19_dfe_err_slice_level_m1_set3_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_19_dfe_err_slice_level_m3_set3_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_1_dfe_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_20_dfe_err_slice_level_p1_set4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_20_dfe_err_slice_level_p3_set4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_21_dfe_err_slice_level_m1_set4_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_21_dfe_err_slice_level_m3_set4_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_22_dfe_err_slice_level_p1_set5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_22_dfe_err_slice_level_p3_set5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_23_dfe_err_slice_level_m1_set5_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_23_dfe_err_slice_level_m3_set5_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_24_dfe_err_slice_level_p1_set6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_24_dfe_err_slice_level_p3_set6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_25_dfe_err_slice_level_m1_set6_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_25_dfe_err_slice_level_m3_set6_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_26_dfe_err_slice_level_p1_set7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_26_dfe_err_slice_level_p3_set7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_27_dfe_err_slice_level_m1_set7_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_27_dfe_err_slice_level_m3_set7_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_28_brk_dfe_cb_not_sat_in_dfe_attr = "serdes_lane_dsp_dfe1_lane0_reg_28_brk_dfe_cb_not_sat_in_dfe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_28_cfg_cb_inv_n_err_attr = "serdes_lane_dsp_dfe1_lane0_reg_28_cfg_cb_inv_n_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_28_cfg_cb_inv_p_err_attr = "serdes_lane_dsp_dfe1_lane0_reg_28_cfg_cb_inv_p_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_28_cfg_dfe_bypass_en_attr = "serdes_lane_dsp_dfe1_lane0_reg_28_cfg_dfe_bypass_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_28_cfg_pre_slice_en_attr = "serdes_lane_dsp_dfe1_lane0_reg_28_cfg_pre_slice_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_29_dfe_coeff_post1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_2_dfe_slice_level_0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_2_dfe_slice_level_m1_set0_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_2_dfe_slice_level_p1_set0_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_30_dfe_coeff_post1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_31_dfe_coeff_post1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_32_dfe_coeff_post1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_33_dfe_coeff_post1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_34_dfe_coeff_post1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_35_dfe_coeff_post1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_36_dfe_coeff_post1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_37_dfe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_38_dsp_dfe1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_39_dsp_dfe1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_39_dsp_dfe1_reg2probe_en_attr = "serdes_lane_dsp_dfe1_lane0_reg_39_dsp_dfe1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_3_dfe_slice_level_0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_3_dfe_slice_level_m1_set1_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_3_dfe_slice_level_p1_set1_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_4_dfe_slice_level_0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_4_dfe_slice_level_m1_set2_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_4_dfe_slice_level_p1_set2_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_5_dfe_slice_level_0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_5_dfe_slice_level_m1_set3_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_5_dfe_slice_level_p1_set3_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_6_dfe_slice_level_0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_6_dfe_slice_level_m1_set4_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_6_dfe_slice_level_p1_set4_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_7_dfe_slice_level_0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_7_dfe_slice_level_m1_set5_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_7_dfe_slice_level_p1_set5_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_8_dfe_slice_level_0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_8_dfe_slice_level_m1_set6_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_8_dfe_slice_level_p1_set6_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_9_dfe_slice_level_0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_9_dfe_slice_level_m1_set7_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane0_reg_9_dfe_slice_level_p1_set7_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_10_dfe_err_slicer_p_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_11_dfe_err_slicer_n_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_12_dfe_err_slice_level_p1_set0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_12_dfe_err_slice_level_p3_set0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_13_dfe_err_slice_level_m1_set0_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_13_dfe_err_slice_level_m3_set0_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_14_dfe_err_slice_level_p1_set1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_14_dfe_err_slice_level_p3_set1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_15_dfe_err_slice_level_m1_set1_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_15_dfe_err_slice_level_m3_set1_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_16_dfe_err_slice_level_p1_set2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_16_dfe_err_slice_level_p3_set2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_17_dfe_err_slice_level_m1_set2_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_17_dfe_err_slice_level_m3_set2_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_18_dfe_err_slice_level_p1_set3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_18_dfe_err_slice_level_p3_set3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_19_dfe_err_slice_level_m1_set3_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_19_dfe_err_slice_level_m3_set3_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_1_dfe_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_20_dfe_err_slice_level_p1_set4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_20_dfe_err_slice_level_p3_set4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_21_dfe_err_slice_level_m1_set4_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_21_dfe_err_slice_level_m3_set4_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_22_dfe_err_slice_level_p1_set5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_22_dfe_err_slice_level_p3_set5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_23_dfe_err_slice_level_m1_set5_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_23_dfe_err_slice_level_m3_set5_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_24_dfe_err_slice_level_p1_set6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_24_dfe_err_slice_level_p3_set6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_25_dfe_err_slice_level_m1_set6_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_25_dfe_err_slice_level_m3_set6_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_26_dfe_err_slice_level_p1_set7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_26_dfe_err_slice_level_p3_set7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_27_dfe_err_slice_level_m1_set7_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_27_dfe_err_slice_level_m3_set7_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_28_brk_dfe_cb_not_sat_in_dfe_attr = "serdes_lane_dsp_dfe1_lane1_reg_28_brk_dfe_cb_not_sat_in_dfe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_28_cfg_cb_inv_n_err_attr = "serdes_lane_dsp_dfe1_lane1_reg_28_cfg_cb_inv_n_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_28_cfg_cb_inv_p_err_attr = "serdes_lane_dsp_dfe1_lane1_reg_28_cfg_cb_inv_p_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_28_cfg_dfe_bypass_en_attr = "serdes_lane_dsp_dfe1_lane1_reg_28_cfg_dfe_bypass_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_28_cfg_pre_slice_en_attr = "serdes_lane_dsp_dfe1_lane1_reg_28_cfg_pre_slice_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_29_dfe_coeff_post1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_2_dfe_slice_level_0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_2_dfe_slice_level_m1_set0_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_2_dfe_slice_level_p1_set0_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_30_dfe_coeff_post1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_31_dfe_coeff_post1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_32_dfe_coeff_post1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_33_dfe_coeff_post1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_34_dfe_coeff_post1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_35_dfe_coeff_post1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_36_dfe_coeff_post1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_37_dfe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_38_dsp_dfe1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_39_dsp_dfe1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_39_dsp_dfe1_reg2probe_en_attr = "serdes_lane_dsp_dfe1_lane1_reg_39_dsp_dfe1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_3_dfe_slice_level_0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_3_dfe_slice_level_m1_set1_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_3_dfe_slice_level_p1_set1_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_4_dfe_slice_level_0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_4_dfe_slice_level_m1_set2_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_4_dfe_slice_level_p1_set2_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_5_dfe_slice_level_0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_5_dfe_slice_level_m1_set3_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_5_dfe_slice_level_p1_set3_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_6_dfe_slice_level_0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_6_dfe_slice_level_m1_set4_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_6_dfe_slice_level_p1_set4_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_7_dfe_slice_level_0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_7_dfe_slice_level_m1_set5_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_7_dfe_slice_level_p1_set5_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_8_dfe_slice_level_0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_8_dfe_slice_level_m1_set6_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_8_dfe_slice_level_p1_set6_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_9_dfe_slice_level_0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_9_dfe_slice_level_m1_set7_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane1_reg_9_dfe_slice_level_p1_set7_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_10_dfe_err_slicer_p_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_11_dfe_err_slicer_n_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_12_dfe_err_slice_level_p1_set0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_12_dfe_err_slice_level_p3_set0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_13_dfe_err_slice_level_m1_set0_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_13_dfe_err_slice_level_m3_set0_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_14_dfe_err_slice_level_p1_set1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_14_dfe_err_slice_level_p3_set1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_15_dfe_err_slice_level_m1_set1_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_15_dfe_err_slice_level_m3_set1_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_16_dfe_err_slice_level_p1_set2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_16_dfe_err_slice_level_p3_set2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_17_dfe_err_slice_level_m1_set2_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_17_dfe_err_slice_level_m3_set2_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_18_dfe_err_slice_level_p1_set3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_18_dfe_err_slice_level_p3_set3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_19_dfe_err_slice_level_m1_set3_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_19_dfe_err_slice_level_m3_set3_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_1_dfe_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_20_dfe_err_slice_level_p1_set4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_20_dfe_err_slice_level_p3_set4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_21_dfe_err_slice_level_m1_set4_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_21_dfe_err_slice_level_m3_set4_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_22_dfe_err_slice_level_p1_set5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_22_dfe_err_slice_level_p3_set5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_23_dfe_err_slice_level_m1_set5_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_23_dfe_err_slice_level_m3_set5_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_24_dfe_err_slice_level_p1_set6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_24_dfe_err_slice_level_p3_set6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_25_dfe_err_slice_level_m1_set6_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_25_dfe_err_slice_level_m3_set6_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_26_dfe_err_slice_level_p1_set7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_26_dfe_err_slice_level_p3_set7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_27_dfe_err_slice_level_m1_set7_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_27_dfe_err_slice_level_m3_set7_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_28_brk_dfe_cb_not_sat_in_dfe_attr = "serdes_lane_dsp_dfe1_lane2_reg_28_brk_dfe_cb_not_sat_in_dfe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_28_cfg_cb_inv_n_err_attr = "serdes_lane_dsp_dfe1_lane2_reg_28_cfg_cb_inv_n_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_28_cfg_cb_inv_p_err_attr = "serdes_lane_dsp_dfe1_lane2_reg_28_cfg_cb_inv_p_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_28_cfg_dfe_bypass_en_attr = "serdes_lane_dsp_dfe1_lane2_reg_28_cfg_dfe_bypass_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_28_cfg_pre_slice_en_attr = "serdes_lane_dsp_dfe1_lane2_reg_28_cfg_pre_slice_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_29_dfe_coeff_post1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_2_dfe_slice_level_0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_2_dfe_slice_level_m1_set0_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_2_dfe_slice_level_p1_set0_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_30_dfe_coeff_post1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_31_dfe_coeff_post1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_32_dfe_coeff_post1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_33_dfe_coeff_post1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_34_dfe_coeff_post1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_35_dfe_coeff_post1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_36_dfe_coeff_post1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_37_dfe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_38_dsp_dfe1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_39_dsp_dfe1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_39_dsp_dfe1_reg2probe_en_attr = "serdes_lane_dsp_dfe1_lane2_reg_39_dsp_dfe1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_3_dfe_slice_level_0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_3_dfe_slice_level_m1_set1_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_3_dfe_slice_level_p1_set1_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_4_dfe_slice_level_0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_4_dfe_slice_level_m1_set2_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_4_dfe_slice_level_p1_set2_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_5_dfe_slice_level_0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_5_dfe_slice_level_m1_set3_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_5_dfe_slice_level_p1_set3_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_6_dfe_slice_level_0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_6_dfe_slice_level_m1_set4_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_6_dfe_slice_level_p1_set4_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_7_dfe_slice_level_0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_7_dfe_slice_level_m1_set5_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_7_dfe_slice_level_p1_set5_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_8_dfe_slice_level_0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_8_dfe_slice_level_m1_set6_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_8_dfe_slice_level_p1_set6_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_9_dfe_slice_level_0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_9_dfe_slice_level_m1_set7_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane2_reg_9_dfe_slice_level_p1_set7_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_10_dfe_err_slicer_p_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_11_dfe_err_slicer_n_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_12_dfe_err_slice_level_p1_set0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_12_dfe_err_slice_level_p3_set0_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_13_dfe_err_slice_level_m1_set0_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_13_dfe_err_slice_level_m3_set0_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_14_dfe_err_slice_level_p1_set1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_14_dfe_err_slice_level_p3_set1_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_15_dfe_err_slice_level_m1_set1_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_15_dfe_err_slice_level_m3_set1_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_16_dfe_err_slice_level_p1_set2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_16_dfe_err_slice_level_p3_set2_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_17_dfe_err_slice_level_m1_set2_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_17_dfe_err_slice_level_m3_set2_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_18_dfe_err_slice_level_p1_set3_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_18_dfe_err_slice_level_p3_set3_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_19_dfe_err_slice_level_m1_set3_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_19_dfe_err_slice_level_m3_set3_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_1_dfe_slicer_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_20_dfe_err_slice_level_p1_set4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_20_dfe_err_slice_level_p3_set4_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_21_dfe_err_slice_level_m1_set4_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_21_dfe_err_slice_level_m3_set4_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_22_dfe_err_slice_level_p1_set5_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_22_dfe_err_slice_level_p3_set5_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_23_dfe_err_slice_level_m1_set5_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_23_dfe_err_slice_level_m3_set5_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_24_dfe_err_slice_level_p1_set6_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_24_dfe_err_slice_level_p3_set6_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_25_dfe_err_slice_level_m1_set6_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_25_dfe_err_slice_level_m3_set6_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_26_dfe_err_slice_level_p1_set7_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_26_dfe_err_slice_level_p3_set7_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_27_dfe_err_slice_level_m1_set7_attr = 480;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_27_dfe_err_slice_level_m3_set7_attr = 416;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_28_brk_dfe_cb_not_sat_in_dfe_attr = "serdes_lane_dsp_dfe1_lane3_reg_28_brk_dfe_cb_not_sat_in_dfe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_28_cfg_cb_inv_n_err_attr = "serdes_lane_dsp_dfe1_lane3_reg_28_cfg_cb_inv_n_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_28_cfg_cb_inv_p_err_attr = "serdes_lane_dsp_dfe1_lane3_reg_28_cfg_cb_inv_p_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_28_cfg_dfe_bypass_en_attr = "serdes_lane_dsp_dfe1_lane3_reg_28_cfg_dfe_bypass_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_28_cfg_pre_slice_en_attr = "serdes_lane_dsp_dfe1_lane3_reg_28_cfg_pre_slice_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_29_dfe_coeff_post1_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_2_dfe_slice_level_0_set0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_2_dfe_slice_level_m1_set0_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_2_dfe_slice_level_p1_set0_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_30_dfe_coeff_post1_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_31_dfe_coeff_post1_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_32_dfe_coeff_post1_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_33_dfe_coeff_post1_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_34_dfe_coeff_post1_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_35_dfe_coeff_post1_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_36_dfe_coeff_post1_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_37_dfe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_38_dsp_dfe1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_39_dsp_dfe1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_39_dsp_dfe1_reg2probe_en_attr = "serdes_lane_dsp_dfe1_lane3_reg_39_dsp_dfe1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_3_dfe_slice_level_0_set1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_3_dfe_slice_level_m1_set1_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_3_dfe_slice_level_p1_set1_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_4_dfe_slice_level_0_set2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_4_dfe_slice_level_m1_set2_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_4_dfe_slice_level_p1_set2_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_5_dfe_slice_level_0_set3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_5_dfe_slice_level_m1_set3_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_5_dfe_slice_level_p1_set3_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_6_dfe_slice_level_0_set4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_6_dfe_slice_level_m1_set4_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_6_dfe_slice_level_p1_set4_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_7_dfe_slice_level_0_set5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_7_dfe_slice_level_m1_set5_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_7_dfe_slice_level_p1_set5_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_8_dfe_slice_level_0_set6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_8_dfe_slice_level_m1_set6_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_8_dfe_slice_level_p1_set6_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_9_dfe_slice_level_0_set7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_9_dfe_slice_level_m1_set7_attr = 342;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_dfe1_lane3_reg_9_dfe_slice_level_p1_set7_attr = 170;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_10_ffe_coeff_set1_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_10_ffe_coeff_set1_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_10_ffe_coeff_set1_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_10_ffe_coeff_set1_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_11_ffe_coeff_set1_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_11_ffe_coeff_set1_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_11_ffe_coeff_set1_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_11_ffe_coeff_set1_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_12_ffe_coeff_set1_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_12_ffe_coeff_set1_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_12_ffe_coeff_set1_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_12_ffe_coeff_set1_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_13_ffe_coeff_set1_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_13_ffe_coeff_set1_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_13_ffe_coeff_set1_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_13_ffe_coeff_set1_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_14_ffe_coeff_set2_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_14_ffe_coeff_set2_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_14_ffe_coeff_set2_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_14_ffe_coeff_set2_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_15_ffe_coeff_set2_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_15_ffe_coeff_set2_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_15_ffe_coeff_set2_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_15_ffe_coeff_set2_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_16_ffe_coeff_set2_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_16_ffe_coeff_set2_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_16_ffe_coeff_set2_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_16_ffe_coeff_set2_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_17_ffe_coeff_set2_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_17_ffe_coeff_set2_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_17_ffe_coeff_set2_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_17_ffe_coeff_set2_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_18_ffe_coeff_set3_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_18_ffe_coeff_set3_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_18_ffe_coeff_set3_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_18_ffe_coeff_set3_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_19_ffe_coeff_set3_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_19_ffe_coeff_set3_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_19_ffe_coeff_set3_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_19_ffe_coeff_set3_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr = "serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr = "serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_en_dft_lut_data_out_attr = "serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_en_dft_lut_data_out_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_no_pre_ffe_attr = "serdes_lane_dsp_ffe_1_lane0_reg_1_cfg_no_pre_ffe_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_1_float_tap_position_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_20_ffe_coeff_set3_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_20_ffe_coeff_set3_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_20_ffe_coeff_set3_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_20_ffe_coeff_set3_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_21_ffe_coeff_set3_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_21_ffe_coeff_set3_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_21_ffe_coeff_set3_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_21_ffe_coeff_set3_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_22_ffe_coeff_set4_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_22_ffe_coeff_set4_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_22_ffe_coeff_set4_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_22_ffe_coeff_set4_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_23_ffe_coeff_set4_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_23_ffe_coeff_set4_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_23_ffe_coeff_set4_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_23_ffe_coeff_set4_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_24_ffe_coeff_set4_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_24_ffe_coeff_set4_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_24_ffe_coeff_set4_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_24_ffe_coeff_set4_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_25_ffe_coeff_set4_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_25_ffe_coeff_set4_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_25_ffe_coeff_set4_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_25_ffe_coeff_set4_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_26_ffe_coeff_set5_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_26_ffe_coeff_set5_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_26_ffe_coeff_set5_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_26_ffe_coeff_set5_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_27_ffe_coeff_set5_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_27_ffe_coeff_set5_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_27_ffe_coeff_set5_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_27_ffe_coeff_set5_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_28_ffe_coeff_set5_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_28_ffe_coeff_set5_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_28_ffe_coeff_set5_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_28_ffe_coeff_set5_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_29_ffe_coeff_set5_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_29_ffe_coeff_set5_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_29_ffe_coeff_set5_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_29_ffe_coeff_set5_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_2_ffe_coeff_broadcast_group_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_30_ffe_coeff_set6_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_30_ffe_coeff_set6_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_30_ffe_coeff_set6_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_30_ffe_coeff_set6_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_31_ffe_coeff_set6_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_31_ffe_coeff_set6_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_31_ffe_coeff_set6_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_31_ffe_coeff_set6_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_32_ffe_coeff_set6_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_32_ffe_coeff_set6_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_32_ffe_coeff_set6_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_32_ffe_coeff_set6_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_33_ffe_coeff_set6_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_33_ffe_coeff_set6_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_33_ffe_coeff_set6_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_33_ffe_coeff_set6_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_34_ffe_coeff_set7_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_34_ffe_coeff_set7_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_34_ffe_coeff_set7_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_34_ffe_coeff_set7_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_35_ffe_coeff_set7_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_35_ffe_coeff_set7_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_35_ffe_coeff_set7_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_35_ffe_coeff_set7_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_36_ffe_coeff_set7_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_36_ffe_coeff_set7_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_36_ffe_coeff_set7_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_36_ffe_coeff_set7_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_37_ffe_coeff_set7_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_37_ffe_coeff_set7_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_37_ffe_coeff_set7_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_37_ffe_coeff_set7_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_38_ffe_tap64_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_39_ffe_coeff_tap64_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_39_ffe_coeff_tap64_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_39_ffe_coeff_tap64_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_39_ffe_coeff_tap64_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_3_ffe_coeff_broadcast_group_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_40_ffe_coeff_tap64_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_40_ffe_coeff_tap64_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_40_ffe_coeff_tap64_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_40_ffe_coeff_tap64_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_41_ffe_coeff_tap64_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_41_ffe_coeff_tap64_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_41_ffe_coeff_tap64_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_41_ffe_coeff_tap64_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_42_ffe_coeff_tap64_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_42_ffe_coeff_tap64_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_42_ffe_coeff_tap64_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_42_ffe_coeff_tap64_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_43_ffe_coeff_tap64_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_43_ffe_coeff_tap64_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_43_ffe_coeff_tap64_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_43_ffe_coeff_tap64_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_44_ffe_coeff_tap64_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_44_ffe_coeff_tap64_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_44_ffe_coeff_tap64_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_44_ffe_coeff_tap64_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_45_ffe_coeff_tap64_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_45_ffe_coeff_tap64_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_45_ffe_coeff_tap64_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_45_ffe_coeff_tap64_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_46_ffe_coeff_tap64_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_46_ffe_coeff_tap64_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_46_ffe_coeff_tap64_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_46_ffe_coeff_tap64_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_47_ffe_coeff_tap64_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_47_ffe_coeff_tap64_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_47_ffe_coeff_tap64_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_47_ffe_coeff_tap64_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_48_ffe_coeff_tap64_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_48_ffe_coeff_tap64_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_48_ffe_coeff_tap64_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_48_ffe_coeff_tap64_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_49_ffe_coeff_tap64_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_49_ffe_coeff_tap64_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_49_ffe_coeff_tap64_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_49_ffe_coeff_tap64_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_4_ffe_coeff_broadcast_group_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_50_ffe_coeff_tap64_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_50_ffe_coeff_tap64_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_50_ffe_coeff_tap64_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_50_ffe_coeff_tap64_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_51_ffe_coeff_tap64_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_51_ffe_coeff_tap64_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_51_ffe_coeff_tap64_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_51_ffe_coeff_tap64_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_52_ffe_coeff_tap64_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_52_ffe_coeff_tap64_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_52_ffe_coeff_tap64_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_52_ffe_coeff_tap64_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_53_ffe_coeff_tap64_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_53_ffe_coeff_tap64_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_53_ffe_coeff_tap64_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_53_ffe_coeff_tap64_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_54_ffe_coeff_tap64_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_54_ffe_coeff_tap64_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_54_ffe_coeff_tap64_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_54_ffe_coeff_tap64_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_55_ffe_gain_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_56_ffe_coeff_gain_0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_56_ffe_coeff_gain_1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_56_ffe_coeff_gain_2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_56_ffe_coeff_gain_3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_57_ffe_coeff_gain_4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_57_ffe_coeff_gain_5_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_57_ffe_coeff_gain_6_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_57_ffe_coeff_gain_7_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_58_ffe_coeff_gain_10_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_58_ffe_coeff_gain_11_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_58_ffe_coeff_gain_8_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_58_ffe_coeff_gain_9_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_59_ffe_coeff_gain_12_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_59_ffe_coeff_gain_13_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_59_ffe_coeff_gain_14_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_59_ffe_coeff_gain_15_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_5_ffe_coeff_broadcast_group_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_60_ffe_coeff_gain_16_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_60_ffe_coeff_gain_17_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_60_ffe_coeff_gain_18_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_60_ffe_coeff_gain_19_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_61_ffe_coeff_gain_20_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_61_ffe_coeff_gain_21_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_61_ffe_coeff_gain_22_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_61_ffe_coeff_gain_23_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_62_ffe_coeff_gain_24_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_62_ffe_coeff_gain_25_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_62_ffe_coeff_gain_26_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_62_ffe_coeff_gain_27_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_63_ffe_coeff_gain_28_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_63_ffe_coeff_gain_29_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_63_ffe_coeff_gain_30_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_63_ffe_coeff_gain_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_64_ffe_coeff_gain_32_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_64_ffe_coeff_gain_33_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_64_ffe_coeff_gain_34_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_64_ffe_coeff_gain_35_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_65_ffe_coeff_gain_36_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_65_ffe_coeff_gain_37_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_65_ffe_coeff_gain_38_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_65_ffe_coeff_gain_39_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_66_ffe_coeff_gain_40_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_66_ffe_coeff_gain_41_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_66_ffe_coeff_gain_42_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_66_ffe_coeff_gain_43_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_67_ffe_coeff_gain_44_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_67_ffe_coeff_gain_45_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_67_ffe_coeff_gain_46_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_67_ffe_coeff_gain_47_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_68_ffe_coeff_gain_48_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_68_ffe_coeff_gain_49_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_68_ffe_coeff_gain_50_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_68_ffe_coeff_gain_51_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_69_ffe_coeff_gain_52_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_69_ffe_coeff_gain_53_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_69_ffe_coeff_gain_54_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_69_ffe_coeff_gain_55_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_6_ffe_coeff_set0_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_6_ffe_coeff_set0_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_6_ffe_coeff_set0_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_6_ffe_coeff_set0_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_70_ffe_coeff_gain_56_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_70_ffe_coeff_gain_57_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_70_ffe_coeff_gain_58_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_70_ffe_coeff_gain_59_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_71_ffe_coeff_gain_60_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_71_ffe_coeff_gain_61_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_71_ffe_coeff_gain_62_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_71_ffe_coeff_gain_63_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_72_dsp_ffe_1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_73_dsp_ffe_1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_73_dsp_ffe_1_reg2probe_en_attr = "serdes_lane_dsp_ffe_1_lane0_reg_73_dsp_ffe_1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_74_float_ffe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_75_float_ffe_set0_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_75_float_ffe_set0_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_75_float_ffe_set0_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_75_float_ffe_set0_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_76_float_ffe_set1_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_76_float_ffe_set1_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_76_float_ffe_set1_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_76_float_ffe_set1_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_77_float_ffe_set2_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_77_float_ffe_set2_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_77_float_ffe_set2_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_77_float_ffe_set2_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_78_float_ffe_set3_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_78_float_ffe_set3_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_78_float_ffe_set3_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_78_float_ffe_set3_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_79_float_ffe_set4_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_79_float_ffe_set4_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_79_float_ffe_set4_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_79_float_ffe_set4_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_7_ffe_coeff_set0_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_7_ffe_coeff_set0_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_7_ffe_coeff_set0_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_7_ffe_coeff_set0_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_80_float_ffe_set5_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_80_float_ffe_set5_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_80_float_ffe_set5_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_80_float_ffe_set5_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_81_float_ffe_set6_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_81_float_ffe_set6_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_81_float_ffe_set6_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_81_float_ffe_set6_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_82_float_ffe_set7_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_82_float_ffe_set7_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_82_float_ffe_set7_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_82_float_ffe_set7_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_8_ffe_coeff_set0_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_8_ffe_coeff_set0_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_8_ffe_coeff_set0_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_8_ffe_coeff_set0_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_9_ffe_coeff_set0_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_9_ffe_coeff_set0_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_9_ffe_coeff_set0_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane0_reg_9_ffe_coeff_set0_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_10_ffe_coeff_set1_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_10_ffe_coeff_set1_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_10_ffe_coeff_set1_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_10_ffe_coeff_set1_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_11_ffe_coeff_set1_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_11_ffe_coeff_set1_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_11_ffe_coeff_set1_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_11_ffe_coeff_set1_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_12_ffe_coeff_set1_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_12_ffe_coeff_set1_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_12_ffe_coeff_set1_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_12_ffe_coeff_set1_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_13_ffe_coeff_set1_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_13_ffe_coeff_set1_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_13_ffe_coeff_set1_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_13_ffe_coeff_set1_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_14_ffe_coeff_set2_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_14_ffe_coeff_set2_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_14_ffe_coeff_set2_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_14_ffe_coeff_set2_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_15_ffe_coeff_set2_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_15_ffe_coeff_set2_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_15_ffe_coeff_set2_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_15_ffe_coeff_set2_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_16_ffe_coeff_set2_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_16_ffe_coeff_set2_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_16_ffe_coeff_set2_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_16_ffe_coeff_set2_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_17_ffe_coeff_set2_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_17_ffe_coeff_set2_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_17_ffe_coeff_set2_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_17_ffe_coeff_set2_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_18_ffe_coeff_set3_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_18_ffe_coeff_set3_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_18_ffe_coeff_set3_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_18_ffe_coeff_set3_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_19_ffe_coeff_set3_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_19_ffe_coeff_set3_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_19_ffe_coeff_set3_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_19_ffe_coeff_set3_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr = "serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr = "serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_en_dft_lut_data_out_attr = "serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_en_dft_lut_data_out_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_no_pre_ffe_attr = "serdes_lane_dsp_ffe_1_lane1_reg_1_cfg_no_pre_ffe_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_1_float_tap_position_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_20_ffe_coeff_set3_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_20_ffe_coeff_set3_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_20_ffe_coeff_set3_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_20_ffe_coeff_set3_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_21_ffe_coeff_set3_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_21_ffe_coeff_set3_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_21_ffe_coeff_set3_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_21_ffe_coeff_set3_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_22_ffe_coeff_set4_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_22_ffe_coeff_set4_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_22_ffe_coeff_set4_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_22_ffe_coeff_set4_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_23_ffe_coeff_set4_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_23_ffe_coeff_set4_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_23_ffe_coeff_set4_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_23_ffe_coeff_set4_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_24_ffe_coeff_set4_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_24_ffe_coeff_set4_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_24_ffe_coeff_set4_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_24_ffe_coeff_set4_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_25_ffe_coeff_set4_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_25_ffe_coeff_set4_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_25_ffe_coeff_set4_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_25_ffe_coeff_set4_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_26_ffe_coeff_set5_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_26_ffe_coeff_set5_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_26_ffe_coeff_set5_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_26_ffe_coeff_set5_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_27_ffe_coeff_set5_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_27_ffe_coeff_set5_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_27_ffe_coeff_set5_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_27_ffe_coeff_set5_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_28_ffe_coeff_set5_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_28_ffe_coeff_set5_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_28_ffe_coeff_set5_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_28_ffe_coeff_set5_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_29_ffe_coeff_set5_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_29_ffe_coeff_set5_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_29_ffe_coeff_set5_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_29_ffe_coeff_set5_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_2_ffe_coeff_broadcast_group_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_30_ffe_coeff_set6_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_30_ffe_coeff_set6_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_30_ffe_coeff_set6_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_30_ffe_coeff_set6_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_31_ffe_coeff_set6_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_31_ffe_coeff_set6_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_31_ffe_coeff_set6_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_31_ffe_coeff_set6_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_32_ffe_coeff_set6_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_32_ffe_coeff_set6_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_32_ffe_coeff_set6_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_32_ffe_coeff_set6_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_33_ffe_coeff_set6_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_33_ffe_coeff_set6_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_33_ffe_coeff_set6_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_33_ffe_coeff_set6_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_34_ffe_coeff_set7_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_34_ffe_coeff_set7_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_34_ffe_coeff_set7_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_34_ffe_coeff_set7_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_35_ffe_coeff_set7_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_35_ffe_coeff_set7_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_35_ffe_coeff_set7_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_35_ffe_coeff_set7_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_36_ffe_coeff_set7_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_36_ffe_coeff_set7_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_36_ffe_coeff_set7_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_36_ffe_coeff_set7_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_37_ffe_coeff_set7_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_37_ffe_coeff_set7_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_37_ffe_coeff_set7_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_37_ffe_coeff_set7_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_38_ffe_tap64_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_39_ffe_coeff_tap64_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_39_ffe_coeff_tap64_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_39_ffe_coeff_tap64_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_39_ffe_coeff_tap64_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_3_ffe_coeff_broadcast_group_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_40_ffe_coeff_tap64_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_40_ffe_coeff_tap64_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_40_ffe_coeff_tap64_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_40_ffe_coeff_tap64_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_41_ffe_coeff_tap64_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_41_ffe_coeff_tap64_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_41_ffe_coeff_tap64_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_41_ffe_coeff_tap64_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_42_ffe_coeff_tap64_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_42_ffe_coeff_tap64_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_42_ffe_coeff_tap64_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_42_ffe_coeff_tap64_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_43_ffe_coeff_tap64_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_43_ffe_coeff_tap64_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_43_ffe_coeff_tap64_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_43_ffe_coeff_tap64_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_44_ffe_coeff_tap64_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_44_ffe_coeff_tap64_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_44_ffe_coeff_tap64_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_44_ffe_coeff_tap64_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_45_ffe_coeff_tap64_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_45_ffe_coeff_tap64_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_45_ffe_coeff_tap64_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_45_ffe_coeff_tap64_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_46_ffe_coeff_tap64_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_46_ffe_coeff_tap64_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_46_ffe_coeff_tap64_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_46_ffe_coeff_tap64_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_47_ffe_coeff_tap64_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_47_ffe_coeff_tap64_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_47_ffe_coeff_tap64_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_47_ffe_coeff_tap64_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_48_ffe_coeff_tap64_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_48_ffe_coeff_tap64_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_48_ffe_coeff_tap64_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_48_ffe_coeff_tap64_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_49_ffe_coeff_tap64_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_49_ffe_coeff_tap64_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_49_ffe_coeff_tap64_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_49_ffe_coeff_tap64_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_4_ffe_coeff_broadcast_group_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_50_ffe_coeff_tap64_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_50_ffe_coeff_tap64_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_50_ffe_coeff_tap64_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_50_ffe_coeff_tap64_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_51_ffe_coeff_tap64_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_51_ffe_coeff_tap64_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_51_ffe_coeff_tap64_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_51_ffe_coeff_tap64_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_52_ffe_coeff_tap64_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_52_ffe_coeff_tap64_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_52_ffe_coeff_tap64_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_52_ffe_coeff_tap64_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_53_ffe_coeff_tap64_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_53_ffe_coeff_tap64_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_53_ffe_coeff_tap64_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_53_ffe_coeff_tap64_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_54_ffe_coeff_tap64_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_54_ffe_coeff_tap64_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_54_ffe_coeff_tap64_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_54_ffe_coeff_tap64_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_55_ffe_gain_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_56_ffe_coeff_gain_0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_56_ffe_coeff_gain_1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_56_ffe_coeff_gain_2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_56_ffe_coeff_gain_3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_57_ffe_coeff_gain_4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_57_ffe_coeff_gain_5_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_57_ffe_coeff_gain_6_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_57_ffe_coeff_gain_7_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_58_ffe_coeff_gain_10_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_58_ffe_coeff_gain_11_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_58_ffe_coeff_gain_8_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_58_ffe_coeff_gain_9_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_59_ffe_coeff_gain_12_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_59_ffe_coeff_gain_13_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_59_ffe_coeff_gain_14_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_59_ffe_coeff_gain_15_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_5_ffe_coeff_broadcast_group_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_60_ffe_coeff_gain_16_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_60_ffe_coeff_gain_17_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_60_ffe_coeff_gain_18_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_60_ffe_coeff_gain_19_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_61_ffe_coeff_gain_20_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_61_ffe_coeff_gain_21_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_61_ffe_coeff_gain_22_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_61_ffe_coeff_gain_23_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_62_ffe_coeff_gain_24_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_62_ffe_coeff_gain_25_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_62_ffe_coeff_gain_26_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_62_ffe_coeff_gain_27_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_63_ffe_coeff_gain_28_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_63_ffe_coeff_gain_29_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_63_ffe_coeff_gain_30_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_63_ffe_coeff_gain_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_64_ffe_coeff_gain_32_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_64_ffe_coeff_gain_33_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_64_ffe_coeff_gain_34_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_64_ffe_coeff_gain_35_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_65_ffe_coeff_gain_36_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_65_ffe_coeff_gain_37_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_65_ffe_coeff_gain_38_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_65_ffe_coeff_gain_39_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_66_ffe_coeff_gain_40_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_66_ffe_coeff_gain_41_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_66_ffe_coeff_gain_42_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_66_ffe_coeff_gain_43_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_67_ffe_coeff_gain_44_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_67_ffe_coeff_gain_45_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_67_ffe_coeff_gain_46_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_67_ffe_coeff_gain_47_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_68_ffe_coeff_gain_48_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_68_ffe_coeff_gain_49_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_68_ffe_coeff_gain_50_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_68_ffe_coeff_gain_51_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_69_ffe_coeff_gain_52_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_69_ffe_coeff_gain_53_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_69_ffe_coeff_gain_54_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_69_ffe_coeff_gain_55_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_6_ffe_coeff_set0_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_6_ffe_coeff_set0_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_6_ffe_coeff_set0_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_6_ffe_coeff_set0_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_70_ffe_coeff_gain_56_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_70_ffe_coeff_gain_57_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_70_ffe_coeff_gain_58_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_70_ffe_coeff_gain_59_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_71_ffe_coeff_gain_60_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_71_ffe_coeff_gain_61_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_71_ffe_coeff_gain_62_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_71_ffe_coeff_gain_63_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_72_dsp_ffe_1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_73_dsp_ffe_1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_73_dsp_ffe_1_reg2probe_en_attr = "serdes_lane_dsp_ffe_1_lane1_reg_73_dsp_ffe_1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_74_float_ffe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_75_float_ffe_set0_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_75_float_ffe_set0_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_75_float_ffe_set0_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_75_float_ffe_set0_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_76_float_ffe_set1_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_76_float_ffe_set1_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_76_float_ffe_set1_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_76_float_ffe_set1_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_77_float_ffe_set2_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_77_float_ffe_set2_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_77_float_ffe_set2_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_77_float_ffe_set2_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_78_float_ffe_set3_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_78_float_ffe_set3_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_78_float_ffe_set3_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_78_float_ffe_set3_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_79_float_ffe_set4_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_79_float_ffe_set4_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_79_float_ffe_set4_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_79_float_ffe_set4_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_7_ffe_coeff_set0_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_7_ffe_coeff_set0_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_7_ffe_coeff_set0_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_7_ffe_coeff_set0_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_80_float_ffe_set5_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_80_float_ffe_set5_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_80_float_ffe_set5_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_80_float_ffe_set5_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_81_float_ffe_set6_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_81_float_ffe_set6_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_81_float_ffe_set6_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_81_float_ffe_set6_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_82_float_ffe_set7_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_82_float_ffe_set7_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_82_float_ffe_set7_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_82_float_ffe_set7_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_8_ffe_coeff_set0_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_8_ffe_coeff_set0_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_8_ffe_coeff_set0_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_8_ffe_coeff_set0_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_9_ffe_coeff_set0_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_9_ffe_coeff_set0_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_9_ffe_coeff_set0_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane1_reg_9_ffe_coeff_set0_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_10_ffe_coeff_set1_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_10_ffe_coeff_set1_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_10_ffe_coeff_set1_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_10_ffe_coeff_set1_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_11_ffe_coeff_set1_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_11_ffe_coeff_set1_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_11_ffe_coeff_set1_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_11_ffe_coeff_set1_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_12_ffe_coeff_set1_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_12_ffe_coeff_set1_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_12_ffe_coeff_set1_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_12_ffe_coeff_set1_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_13_ffe_coeff_set1_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_13_ffe_coeff_set1_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_13_ffe_coeff_set1_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_13_ffe_coeff_set1_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_14_ffe_coeff_set2_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_14_ffe_coeff_set2_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_14_ffe_coeff_set2_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_14_ffe_coeff_set2_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_15_ffe_coeff_set2_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_15_ffe_coeff_set2_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_15_ffe_coeff_set2_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_15_ffe_coeff_set2_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_16_ffe_coeff_set2_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_16_ffe_coeff_set2_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_16_ffe_coeff_set2_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_16_ffe_coeff_set2_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_17_ffe_coeff_set2_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_17_ffe_coeff_set2_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_17_ffe_coeff_set2_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_17_ffe_coeff_set2_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_18_ffe_coeff_set3_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_18_ffe_coeff_set3_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_18_ffe_coeff_set3_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_18_ffe_coeff_set3_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_19_ffe_coeff_set3_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_19_ffe_coeff_set3_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_19_ffe_coeff_set3_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_19_ffe_coeff_set3_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr = "serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr = "serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_en_dft_lut_data_out_attr = "serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_en_dft_lut_data_out_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_no_pre_ffe_attr = "serdes_lane_dsp_ffe_1_lane2_reg_1_cfg_no_pre_ffe_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_1_float_tap_position_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_20_ffe_coeff_set3_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_20_ffe_coeff_set3_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_20_ffe_coeff_set3_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_20_ffe_coeff_set3_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_21_ffe_coeff_set3_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_21_ffe_coeff_set3_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_21_ffe_coeff_set3_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_21_ffe_coeff_set3_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_22_ffe_coeff_set4_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_22_ffe_coeff_set4_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_22_ffe_coeff_set4_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_22_ffe_coeff_set4_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_23_ffe_coeff_set4_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_23_ffe_coeff_set4_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_23_ffe_coeff_set4_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_23_ffe_coeff_set4_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_24_ffe_coeff_set4_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_24_ffe_coeff_set4_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_24_ffe_coeff_set4_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_24_ffe_coeff_set4_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_25_ffe_coeff_set4_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_25_ffe_coeff_set4_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_25_ffe_coeff_set4_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_25_ffe_coeff_set4_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_26_ffe_coeff_set5_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_26_ffe_coeff_set5_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_26_ffe_coeff_set5_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_26_ffe_coeff_set5_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_27_ffe_coeff_set5_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_27_ffe_coeff_set5_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_27_ffe_coeff_set5_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_27_ffe_coeff_set5_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_28_ffe_coeff_set5_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_28_ffe_coeff_set5_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_28_ffe_coeff_set5_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_28_ffe_coeff_set5_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_29_ffe_coeff_set5_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_29_ffe_coeff_set5_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_29_ffe_coeff_set5_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_29_ffe_coeff_set5_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_2_ffe_coeff_broadcast_group_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_30_ffe_coeff_set6_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_30_ffe_coeff_set6_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_30_ffe_coeff_set6_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_30_ffe_coeff_set6_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_31_ffe_coeff_set6_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_31_ffe_coeff_set6_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_31_ffe_coeff_set6_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_31_ffe_coeff_set6_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_32_ffe_coeff_set6_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_32_ffe_coeff_set6_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_32_ffe_coeff_set6_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_32_ffe_coeff_set6_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_33_ffe_coeff_set6_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_33_ffe_coeff_set6_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_33_ffe_coeff_set6_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_33_ffe_coeff_set6_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_34_ffe_coeff_set7_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_34_ffe_coeff_set7_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_34_ffe_coeff_set7_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_34_ffe_coeff_set7_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_35_ffe_coeff_set7_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_35_ffe_coeff_set7_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_35_ffe_coeff_set7_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_35_ffe_coeff_set7_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_36_ffe_coeff_set7_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_36_ffe_coeff_set7_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_36_ffe_coeff_set7_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_36_ffe_coeff_set7_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_37_ffe_coeff_set7_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_37_ffe_coeff_set7_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_37_ffe_coeff_set7_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_37_ffe_coeff_set7_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_38_ffe_tap64_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_39_ffe_coeff_tap64_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_39_ffe_coeff_tap64_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_39_ffe_coeff_tap64_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_39_ffe_coeff_tap64_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_3_ffe_coeff_broadcast_group_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_40_ffe_coeff_tap64_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_40_ffe_coeff_tap64_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_40_ffe_coeff_tap64_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_40_ffe_coeff_tap64_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_41_ffe_coeff_tap64_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_41_ffe_coeff_tap64_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_41_ffe_coeff_tap64_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_41_ffe_coeff_tap64_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_42_ffe_coeff_tap64_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_42_ffe_coeff_tap64_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_42_ffe_coeff_tap64_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_42_ffe_coeff_tap64_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_43_ffe_coeff_tap64_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_43_ffe_coeff_tap64_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_43_ffe_coeff_tap64_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_43_ffe_coeff_tap64_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_44_ffe_coeff_tap64_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_44_ffe_coeff_tap64_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_44_ffe_coeff_tap64_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_44_ffe_coeff_tap64_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_45_ffe_coeff_tap64_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_45_ffe_coeff_tap64_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_45_ffe_coeff_tap64_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_45_ffe_coeff_tap64_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_46_ffe_coeff_tap64_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_46_ffe_coeff_tap64_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_46_ffe_coeff_tap64_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_46_ffe_coeff_tap64_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_47_ffe_coeff_tap64_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_47_ffe_coeff_tap64_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_47_ffe_coeff_tap64_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_47_ffe_coeff_tap64_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_48_ffe_coeff_tap64_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_48_ffe_coeff_tap64_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_48_ffe_coeff_tap64_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_48_ffe_coeff_tap64_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_49_ffe_coeff_tap64_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_49_ffe_coeff_tap64_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_49_ffe_coeff_tap64_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_49_ffe_coeff_tap64_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_4_ffe_coeff_broadcast_group_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_50_ffe_coeff_tap64_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_50_ffe_coeff_tap64_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_50_ffe_coeff_tap64_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_50_ffe_coeff_tap64_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_51_ffe_coeff_tap64_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_51_ffe_coeff_tap64_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_51_ffe_coeff_tap64_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_51_ffe_coeff_tap64_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_52_ffe_coeff_tap64_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_52_ffe_coeff_tap64_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_52_ffe_coeff_tap64_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_52_ffe_coeff_tap64_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_53_ffe_coeff_tap64_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_53_ffe_coeff_tap64_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_53_ffe_coeff_tap64_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_53_ffe_coeff_tap64_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_54_ffe_coeff_tap64_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_54_ffe_coeff_tap64_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_54_ffe_coeff_tap64_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_54_ffe_coeff_tap64_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_55_ffe_gain_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_56_ffe_coeff_gain_0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_56_ffe_coeff_gain_1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_56_ffe_coeff_gain_2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_56_ffe_coeff_gain_3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_57_ffe_coeff_gain_4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_57_ffe_coeff_gain_5_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_57_ffe_coeff_gain_6_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_57_ffe_coeff_gain_7_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_58_ffe_coeff_gain_10_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_58_ffe_coeff_gain_11_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_58_ffe_coeff_gain_8_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_58_ffe_coeff_gain_9_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_59_ffe_coeff_gain_12_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_59_ffe_coeff_gain_13_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_59_ffe_coeff_gain_14_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_59_ffe_coeff_gain_15_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_5_ffe_coeff_broadcast_group_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_60_ffe_coeff_gain_16_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_60_ffe_coeff_gain_17_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_60_ffe_coeff_gain_18_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_60_ffe_coeff_gain_19_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_61_ffe_coeff_gain_20_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_61_ffe_coeff_gain_21_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_61_ffe_coeff_gain_22_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_61_ffe_coeff_gain_23_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_62_ffe_coeff_gain_24_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_62_ffe_coeff_gain_25_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_62_ffe_coeff_gain_26_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_62_ffe_coeff_gain_27_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_63_ffe_coeff_gain_28_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_63_ffe_coeff_gain_29_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_63_ffe_coeff_gain_30_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_63_ffe_coeff_gain_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_64_ffe_coeff_gain_32_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_64_ffe_coeff_gain_33_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_64_ffe_coeff_gain_34_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_64_ffe_coeff_gain_35_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_65_ffe_coeff_gain_36_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_65_ffe_coeff_gain_37_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_65_ffe_coeff_gain_38_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_65_ffe_coeff_gain_39_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_66_ffe_coeff_gain_40_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_66_ffe_coeff_gain_41_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_66_ffe_coeff_gain_42_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_66_ffe_coeff_gain_43_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_67_ffe_coeff_gain_44_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_67_ffe_coeff_gain_45_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_67_ffe_coeff_gain_46_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_67_ffe_coeff_gain_47_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_68_ffe_coeff_gain_48_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_68_ffe_coeff_gain_49_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_68_ffe_coeff_gain_50_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_68_ffe_coeff_gain_51_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_69_ffe_coeff_gain_52_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_69_ffe_coeff_gain_53_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_69_ffe_coeff_gain_54_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_69_ffe_coeff_gain_55_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_6_ffe_coeff_set0_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_6_ffe_coeff_set0_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_6_ffe_coeff_set0_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_6_ffe_coeff_set0_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_70_ffe_coeff_gain_56_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_70_ffe_coeff_gain_57_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_70_ffe_coeff_gain_58_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_70_ffe_coeff_gain_59_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_71_ffe_coeff_gain_60_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_71_ffe_coeff_gain_61_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_71_ffe_coeff_gain_62_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_71_ffe_coeff_gain_63_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_72_dsp_ffe_1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_73_dsp_ffe_1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_73_dsp_ffe_1_reg2probe_en_attr = "serdes_lane_dsp_ffe_1_lane2_reg_73_dsp_ffe_1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_74_float_ffe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_75_float_ffe_set0_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_75_float_ffe_set0_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_75_float_ffe_set0_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_75_float_ffe_set0_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_76_float_ffe_set1_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_76_float_ffe_set1_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_76_float_ffe_set1_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_76_float_ffe_set1_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_77_float_ffe_set2_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_77_float_ffe_set2_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_77_float_ffe_set2_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_77_float_ffe_set2_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_78_float_ffe_set3_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_78_float_ffe_set3_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_78_float_ffe_set3_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_78_float_ffe_set3_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_79_float_ffe_set4_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_79_float_ffe_set4_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_79_float_ffe_set4_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_79_float_ffe_set4_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_7_ffe_coeff_set0_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_7_ffe_coeff_set0_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_7_ffe_coeff_set0_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_7_ffe_coeff_set0_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_80_float_ffe_set5_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_80_float_ffe_set5_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_80_float_ffe_set5_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_80_float_ffe_set5_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_81_float_ffe_set6_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_81_float_ffe_set6_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_81_float_ffe_set6_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_81_float_ffe_set6_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_82_float_ffe_set7_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_82_float_ffe_set7_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_82_float_ffe_set7_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_82_float_ffe_set7_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_8_ffe_coeff_set0_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_8_ffe_coeff_set0_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_8_ffe_coeff_set0_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_8_ffe_coeff_set0_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_9_ffe_coeff_set0_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_9_ffe_coeff_set0_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_9_ffe_coeff_set0_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane2_reg_9_ffe_coeff_set0_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_10_ffe_coeff_set1_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_10_ffe_coeff_set1_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_10_ffe_coeff_set1_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_10_ffe_coeff_set1_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_11_ffe_coeff_set1_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_11_ffe_coeff_set1_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_11_ffe_coeff_set1_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_11_ffe_coeff_set1_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_12_ffe_coeff_set1_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_12_ffe_coeff_set1_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_12_ffe_coeff_set1_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_12_ffe_coeff_set1_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_13_ffe_coeff_set1_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_13_ffe_coeff_set1_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_13_ffe_coeff_set1_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_13_ffe_coeff_set1_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_14_ffe_coeff_set2_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_14_ffe_coeff_set2_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_14_ffe_coeff_set2_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_14_ffe_coeff_set2_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_15_ffe_coeff_set2_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_15_ffe_coeff_set2_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_15_ffe_coeff_set2_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_15_ffe_coeff_set2_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_16_ffe_coeff_set2_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_16_ffe_coeff_set2_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_16_ffe_coeff_set2_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_16_ffe_coeff_set2_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_17_ffe_coeff_set2_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_17_ffe_coeff_set2_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_17_ffe_coeff_set2_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_17_ffe_coeff_set2_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_18_ffe_coeff_set3_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_18_ffe_coeff_set3_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_18_ffe_coeff_set3_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_18_ffe_coeff_set3_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_19_ffe_coeff_set3_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_19_ffe_coeff_set3_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_19_ffe_coeff_set3_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_19_ffe_coeff_set3_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr = "serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_brk_ffe_no_sat_in_ffe_2nd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr = "serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_brk_ffe_pre_no_sat_in_tap64_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_en_dft_lut_data_out_attr = "serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_en_dft_lut_data_out_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_no_pre_ffe_attr = "serdes_lane_dsp_ffe_1_lane3_reg_1_cfg_no_pre_ffe_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_1_float_tap_position_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_20_ffe_coeff_set3_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_20_ffe_coeff_set3_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_20_ffe_coeff_set3_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_20_ffe_coeff_set3_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_21_ffe_coeff_set3_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_21_ffe_coeff_set3_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_21_ffe_coeff_set3_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_21_ffe_coeff_set3_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_22_ffe_coeff_set4_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_22_ffe_coeff_set4_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_22_ffe_coeff_set4_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_22_ffe_coeff_set4_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_23_ffe_coeff_set4_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_23_ffe_coeff_set4_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_23_ffe_coeff_set4_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_23_ffe_coeff_set4_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_24_ffe_coeff_set4_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_24_ffe_coeff_set4_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_24_ffe_coeff_set4_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_24_ffe_coeff_set4_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_25_ffe_coeff_set4_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_25_ffe_coeff_set4_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_25_ffe_coeff_set4_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_25_ffe_coeff_set4_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_26_ffe_coeff_set5_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_26_ffe_coeff_set5_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_26_ffe_coeff_set5_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_26_ffe_coeff_set5_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_27_ffe_coeff_set5_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_27_ffe_coeff_set5_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_27_ffe_coeff_set5_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_27_ffe_coeff_set5_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_28_ffe_coeff_set5_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_28_ffe_coeff_set5_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_28_ffe_coeff_set5_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_28_ffe_coeff_set5_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_29_ffe_coeff_set5_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_29_ffe_coeff_set5_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_29_ffe_coeff_set5_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_29_ffe_coeff_set5_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_2_ffe_coeff_broadcast_group_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_30_ffe_coeff_set6_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_30_ffe_coeff_set6_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_30_ffe_coeff_set6_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_30_ffe_coeff_set6_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_31_ffe_coeff_set6_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_31_ffe_coeff_set6_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_31_ffe_coeff_set6_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_31_ffe_coeff_set6_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_32_ffe_coeff_set6_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_32_ffe_coeff_set6_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_32_ffe_coeff_set6_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_32_ffe_coeff_set6_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_33_ffe_coeff_set6_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_33_ffe_coeff_set6_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_33_ffe_coeff_set6_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_33_ffe_coeff_set6_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_34_ffe_coeff_set7_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_34_ffe_coeff_set7_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_34_ffe_coeff_set7_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_34_ffe_coeff_set7_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_35_ffe_coeff_set7_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_35_ffe_coeff_set7_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_35_ffe_coeff_set7_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_35_ffe_coeff_set7_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_36_ffe_coeff_set7_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_36_ffe_coeff_set7_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_36_ffe_coeff_set7_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_36_ffe_coeff_set7_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_37_ffe_coeff_set7_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_37_ffe_coeff_set7_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_37_ffe_coeff_set7_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_37_ffe_coeff_set7_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_38_ffe_tap64_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_39_ffe_coeff_tap64_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_39_ffe_coeff_tap64_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_39_ffe_coeff_tap64_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_39_ffe_coeff_tap64_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_3_ffe_coeff_broadcast_group_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_40_ffe_coeff_tap64_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_40_ffe_coeff_tap64_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_40_ffe_coeff_tap64_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_40_ffe_coeff_tap64_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_41_ffe_coeff_tap64_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_41_ffe_coeff_tap64_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_41_ffe_coeff_tap64_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_41_ffe_coeff_tap64_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_42_ffe_coeff_tap64_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_42_ffe_coeff_tap64_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_42_ffe_coeff_tap64_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_42_ffe_coeff_tap64_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_43_ffe_coeff_tap64_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_43_ffe_coeff_tap64_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_43_ffe_coeff_tap64_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_43_ffe_coeff_tap64_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_44_ffe_coeff_tap64_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_44_ffe_coeff_tap64_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_44_ffe_coeff_tap64_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_44_ffe_coeff_tap64_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_45_ffe_coeff_tap64_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_45_ffe_coeff_tap64_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_45_ffe_coeff_tap64_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_45_ffe_coeff_tap64_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_46_ffe_coeff_tap64_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_46_ffe_coeff_tap64_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_46_ffe_coeff_tap64_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_46_ffe_coeff_tap64_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_47_ffe_coeff_tap64_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_47_ffe_coeff_tap64_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_47_ffe_coeff_tap64_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_47_ffe_coeff_tap64_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_48_ffe_coeff_tap64_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_48_ffe_coeff_tap64_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_48_ffe_coeff_tap64_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_48_ffe_coeff_tap64_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_49_ffe_coeff_tap64_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_49_ffe_coeff_tap64_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_49_ffe_coeff_tap64_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_49_ffe_coeff_tap64_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_4_ffe_coeff_broadcast_group_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_50_ffe_coeff_tap64_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_50_ffe_coeff_tap64_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_50_ffe_coeff_tap64_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_50_ffe_coeff_tap64_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_51_ffe_coeff_tap64_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_51_ffe_coeff_tap64_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_51_ffe_coeff_tap64_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_51_ffe_coeff_tap64_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_52_ffe_coeff_tap64_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_52_ffe_coeff_tap64_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_52_ffe_coeff_tap64_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_52_ffe_coeff_tap64_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_53_ffe_coeff_tap64_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_53_ffe_coeff_tap64_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_53_ffe_coeff_tap64_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_53_ffe_coeff_tap64_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_54_ffe_coeff_tap64_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_54_ffe_coeff_tap64_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_54_ffe_coeff_tap64_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_54_ffe_coeff_tap64_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_55_ffe_gain_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_56_ffe_coeff_gain_0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_56_ffe_coeff_gain_1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_56_ffe_coeff_gain_2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_56_ffe_coeff_gain_3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_57_ffe_coeff_gain_4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_57_ffe_coeff_gain_5_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_57_ffe_coeff_gain_6_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_57_ffe_coeff_gain_7_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_58_ffe_coeff_gain_10_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_58_ffe_coeff_gain_11_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_58_ffe_coeff_gain_8_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_58_ffe_coeff_gain_9_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_59_ffe_coeff_gain_12_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_59_ffe_coeff_gain_13_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_59_ffe_coeff_gain_14_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_59_ffe_coeff_gain_15_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_5_ffe_coeff_broadcast_group_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_60_ffe_coeff_gain_16_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_60_ffe_coeff_gain_17_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_60_ffe_coeff_gain_18_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_60_ffe_coeff_gain_19_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_61_ffe_coeff_gain_20_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_61_ffe_coeff_gain_21_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_61_ffe_coeff_gain_22_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_61_ffe_coeff_gain_23_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_62_ffe_coeff_gain_24_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_62_ffe_coeff_gain_25_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_62_ffe_coeff_gain_26_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_62_ffe_coeff_gain_27_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_63_ffe_coeff_gain_28_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_63_ffe_coeff_gain_29_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_63_ffe_coeff_gain_30_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_63_ffe_coeff_gain_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_64_ffe_coeff_gain_32_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_64_ffe_coeff_gain_33_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_64_ffe_coeff_gain_34_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_64_ffe_coeff_gain_35_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_65_ffe_coeff_gain_36_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_65_ffe_coeff_gain_37_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_65_ffe_coeff_gain_38_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_65_ffe_coeff_gain_39_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_66_ffe_coeff_gain_40_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_66_ffe_coeff_gain_41_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_66_ffe_coeff_gain_42_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_66_ffe_coeff_gain_43_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_67_ffe_coeff_gain_44_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_67_ffe_coeff_gain_45_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_67_ffe_coeff_gain_46_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_67_ffe_coeff_gain_47_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_68_ffe_coeff_gain_48_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_68_ffe_coeff_gain_49_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_68_ffe_coeff_gain_50_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_68_ffe_coeff_gain_51_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_69_ffe_coeff_gain_52_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_69_ffe_coeff_gain_53_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_69_ffe_coeff_gain_54_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_69_ffe_coeff_gain_55_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_6_ffe_coeff_set0_coeff_post1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_6_ffe_coeff_set0_coeff_post2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_6_ffe_coeff_set0_coeff_post3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_6_ffe_coeff_set0_coeff_post4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_70_ffe_coeff_gain_56_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_70_ffe_coeff_gain_57_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_70_ffe_coeff_gain_58_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_70_ffe_coeff_gain_59_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_71_ffe_coeff_gain_60_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_71_ffe_coeff_gain_61_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_71_ffe_coeff_gain_62_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_71_ffe_coeff_gain_63_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr = "serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_72_dsp_ffe_1_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_73_dsp_ffe_1_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_73_dsp_ffe_1_reg2probe_en_attr = "serdes_lane_dsp_ffe_1_lane3_reg_73_dsp_ffe_1_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_74_float_ffe_coeff_broadcast_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_75_float_ffe_set0_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_75_float_ffe_set0_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_75_float_ffe_set0_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_75_float_ffe_set0_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_76_float_ffe_set1_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_76_float_ffe_set1_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_76_float_ffe_set1_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_76_float_ffe_set1_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_77_float_ffe_set2_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_77_float_ffe_set2_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_77_float_ffe_set2_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_77_float_ffe_set2_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_78_float_ffe_set3_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_78_float_ffe_set3_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_78_float_ffe_set3_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_78_float_ffe_set3_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_79_float_ffe_set4_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_79_float_ffe_set4_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_79_float_ffe_set4_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_79_float_ffe_set4_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_7_ffe_coeff_set0_coeff_post5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_7_ffe_coeff_set0_coeff_post6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_7_ffe_coeff_set0_coeff_post7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_7_ffe_coeff_set0_coeff_post8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_80_float_ffe_set5_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_80_float_ffe_set5_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_80_float_ffe_set5_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_80_float_ffe_set5_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_81_float_ffe_set6_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_81_float_ffe_set6_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_81_float_ffe_set6_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_81_float_ffe_set6_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_82_float_ffe_set7_coeff_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_82_float_ffe_set7_coeff_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_82_float_ffe_set7_coeff_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_82_float_ffe_set7_coeff_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_8_ffe_coeff_set0_coeff_post10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_8_ffe_coeff_set0_coeff_post11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_8_ffe_coeff_set0_coeff_post12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_8_ffe_coeff_set0_coeff_post9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_9_ffe_coeff_set0_coeff_post13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_9_ffe_coeff_set0_coeff_pre1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_9_ffe_coeff_set0_coeff_pre2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_dsp_ffe_1_lane3_reg_9_ffe_coeff_set0_coeff_pre3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_10_idig_pll_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_12_idig_pll_en_h_attr = "serdes_lane_lane_ctrl_lane0_reg_12_idig_pll_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_12_idig_pll_resetb_attr = "serdes_lane_lane_ctrl_lane0_reg_12_idig_pll_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_14_cfg_avg_eng_bit_in_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_14_cfg_avg_eng_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_14_cfg_avg_eng_probe_bit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_14_cfg_avg_eng_start_attr = "serdes_lane_lane_ctrl_lane0_reg_14_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_15_cfg_avg_eng_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_18_cfg_force_apb2strb_bridge_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_18_cfg_force_apb2strb_bridge_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_18_cfg_force_apb2strb_bridge_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_inv_attr = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_precode_enable_attr = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_1_cfg_use_cdr_data_as_data_attr = "serdes_lane_lane_ctrl_lane0_reg_1_cfg_use_cdr_data_as_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane0_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_23_cfg_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane0_reg_23_cfg_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_23_cfg_stbl_time_aftr_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_23_cfg_stbl_time_bfr_strb_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_23_cfg_strb_pulse_width_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_24_adc_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_24_cfg_lane_mode_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_24_fake_training_attr = "serdes_lane_lane_ctrl_lane0_reg_24_fake_training_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_24_rx_reconverge_attr = "serdes_lane_lane_ctrl_lane0_reg_24_rx_reconverge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_24_tfl_enable_attr = "serdes_lane_lane_ctrl_lane0_reg_24_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_25_dp_rx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_25_dp_tx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_25_rx_adc_active_sar_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_25_rx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_25_tx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_26_idig_adc_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_26_idig_clkmux_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_26_idig_lane_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_28_lane_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_29_lane_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_29_lane_ctrl_reg2probe_en_attr = "serdes_lane_lane_ctrl_lane0_reg_29_lane_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_bus_take_dft_attr = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_inv_attr = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_lane_enable_attr = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_lane_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_precode_enable_attr = "serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_2_cfg_tx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_30_metrics_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_31_metrics_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_32_fw_calib_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_32_fw_dsp_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_32_fw_tfl_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_33_fw_fsm_state1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_33_fw_fsm_state2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_33_fw_fsm_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_34_lane_cal_error_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_34_lane_cal_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_3_cfg_tx_err_inj_en_attr = "serdes_lane_lane_ctrl_lane0_reg_3_cfg_tx_err_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_3_cfg_tx_err_inj_mask_cfg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_3_cfg_tx_err_inj_mask_rotate_attr = "serdes_lane_lane_ctrl_lane0_reg_3_cfg_tx_err_inj_mask_rotate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_3_cfg_tx_err_inj_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_4_cfg_tx_err_inj_trig_attr = "serdes_lane_lane_ctrl_lane0_reg_4_cfg_tx_err_inj_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_5_cfg_tx_err_inj_mask_load_attr = "serdes_lane_lane_ctrl_lane0_reg_5_cfg_tx_err_inj_mask_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_6_idig_tx_dig_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_6_tx_piso_reset_attr = "serdes_lane_lane_ctrl_lane0_reg_6_tx_piso_reset_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_7_idig_lclbias_pd_attr = "serdes_lane_lane_ctrl_lane0_reg_7_idig_lclbias_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_7_idig_pll_dfx_bi_en_attr = "serdes_lane_lane_ctrl_lane0_reg_7_idig_pll_dfx_bi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_7_idig_txpath_first_mux_control_attr = "serdes_lane_lane_ctrl_lane0_reg_7_idig_txpath_first_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_7_idig_txpath_second_mux_control_attr = "serdes_lane_lane_ctrl_lane0_reg_7_idig_txpath_second_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane0_reg_7_link_up_cntr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_10_idig_pll_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_12_idig_pll_en_h_attr = "serdes_lane_lane_ctrl_lane1_reg_12_idig_pll_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_12_idig_pll_resetb_attr = "serdes_lane_lane_ctrl_lane1_reg_12_idig_pll_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_14_cfg_avg_eng_bit_in_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_14_cfg_avg_eng_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_14_cfg_avg_eng_probe_bit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_14_cfg_avg_eng_start_attr = "serdes_lane_lane_ctrl_lane1_reg_14_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_15_cfg_avg_eng_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_18_cfg_force_apb2strb_bridge_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_18_cfg_force_apb2strb_bridge_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_18_cfg_force_apb2strb_bridge_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_inv_attr = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_precode_enable_attr = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_1_cfg_use_cdr_data_as_data_attr = "serdes_lane_lane_ctrl_lane1_reg_1_cfg_use_cdr_data_as_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane1_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_23_cfg_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane1_reg_23_cfg_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_23_cfg_stbl_time_aftr_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_23_cfg_stbl_time_bfr_strb_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_23_cfg_strb_pulse_width_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_24_adc_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_24_cfg_lane_mode_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_24_fake_training_attr = "serdes_lane_lane_ctrl_lane1_reg_24_fake_training_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_24_rx_reconverge_attr = "serdes_lane_lane_ctrl_lane1_reg_24_rx_reconverge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_24_tfl_enable_attr = "serdes_lane_lane_ctrl_lane1_reg_24_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_25_dp_rx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_25_dp_tx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_25_rx_adc_active_sar_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_25_rx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_25_tx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_26_idig_adc_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_26_idig_clkmux_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_26_idig_lane_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_28_lane_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_29_lane_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_29_lane_ctrl_reg2probe_en_attr = "serdes_lane_lane_ctrl_lane1_reg_29_lane_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_bus_take_dft_attr = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_inv_attr = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_lane_enable_attr = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_lane_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_precode_enable_attr = "serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_2_cfg_tx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_30_metrics_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_31_metrics_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_32_fw_calib_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_32_fw_dsp_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_32_fw_tfl_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_33_fw_fsm_state1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_33_fw_fsm_state2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_33_fw_fsm_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_34_lane_cal_error_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_34_lane_cal_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_3_cfg_tx_err_inj_en_attr = "serdes_lane_lane_ctrl_lane1_reg_3_cfg_tx_err_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_3_cfg_tx_err_inj_mask_cfg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_3_cfg_tx_err_inj_mask_rotate_attr = "serdes_lane_lane_ctrl_lane1_reg_3_cfg_tx_err_inj_mask_rotate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_3_cfg_tx_err_inj_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_4_cfg_tx_err_inj_trig_attr = "serdes_lane_lane_ctrl_lane1_reg_4_cfg_tx_err_inj_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_5_cfg_tx_err_inj_mask_load_attr = "serdes_lane_lane_ctrl_lane1_reg_5_cfg_tx_err_inj_mask_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_6_idig_tx_dig_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_6_tx_piso_reset_attr = "serdes_lane_lane_ctrl_lane1_reg_6_tx_piso_reset_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_7_idig_lclbias_pd_attr = "serdes_lane_lane_ctrl_lane1_reg_7_idig_lclbias_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_7_idig_pll_dfx_bi_en_attr = "serdes_lane_lane_ctrl_lane1_reg_7_idig_pll_dfx_bi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_7_idig_txpath_first_mux_control_attr = "serdes_lane_lane_ctrl_lane1_reg_7_idig_txpath_first_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_7_idig_txpath_second_mux_control_attr = "serdes_lane_lane_ctrl_lane1_reg_7_idig_txpath_second_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane1_reg_7_link_up_cntr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_10_idig_pll_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_12_idig_pll_en_h_attr = "serdes_lane_lane_ctrl_lane2_reg_12_idig_pll_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_12_idig_pll_resetb_attr = "serdes_lane_lane_ctrl_lane2_reg_12_idig_pll_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_14_cfg_avg_eng_bit_in_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_14_cfg_avg_eng_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_14_cfg_avg_eng_probe_bit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_14_cfg_avg_eng_start_attr = "serdes_lane_lane_ctrl_lane2_reg_14_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_15_cfg_avg_eng_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_18_cfg_force_apb2strb_bridge_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_18_cfg_force_apb2strb_bridge_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_18_cfg_force_apb2strb_bridge_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_inv_attr = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_precode_enable_attr = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_1_cfg_use_cdr_data_as_data_attr = "serdes_lane_lane_ctrl_lane2_reg_1_cfg_use_cdr_data_as_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane2_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_23_cfg_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane2_reg_23_cfg_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_23_cfg_stbl_time_aftr_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_23_cfg_stbl_time_bfr_strb_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_23_cfg_strb_pulse_width_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_24_adc_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_24_cfg_lane_mode_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_24_fake_training_attr = "serdes_lane_lane_ctrl_lane2_reg_24_fake_training_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_24_rx_reconverge_attr = "serdes_lane_lane_ctrl_lane2_reg_24_rx_reconverge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_24_tfl_enable_attr = "serdes_lane_lane_ctrl_lane2_reg_24_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_25_dp_rx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_25_dp_tx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_25_rx_adc_active_sar_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_25_rx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_25_tx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_26_idig_adc_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_26_idig_clkmux_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_26_idig_lane_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_28_lane_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_29_lane_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_29_lane_ctrl_reg2probe_en_attr = "serdes_lane_lane_ctrl_lane2_reg_29_lane_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_bus_take_dft_attr = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_inv_attr = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_lane_enable_attr = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_lane_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_precode_enable_attr = "serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_2_cfg_tx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_30_metrics_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_31_metrics_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_32_fw_calib_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_32_fw_dsp_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_32_fw_tfl_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_33_fw_fsm_state1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_33_fw_fsm_state2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_33_fw_fsm_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_34_lane_cal_error_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_34_lane_cal_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_3_cfg_tx_err_inj_en_attr = "serdes_lane_lane_ctrl_lane2_reg_3_cfg_tx_err_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_3_cfg_tx_err_inj_mask_cfg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_3_cfg_tx_err_inj_mask_rotate_attr = "serdes_lane_lane_ctrl_lane2_reg_3_cfg_tx_err_inj_mask_rotate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_3_cfg_tx_err_inj_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_4_cfg_tx_err_inj_trig_attr = "serdes_lane_lane_ctrl_lane2_reg_4_cfg_tx_err_inj_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_5_cfg_tx_err_inj_mask_load_attr = "serdes_lane_lane_ctrl_lane2_reg_5_cfg_tx_err_inj_mask_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_6_idig_tx_dig_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_6_tx_piso_reset_attr = "serdes_lane_lane_ctrl_lane2_reg_6_tx_piso_reset_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_7_idig_lclbias_pd_attr = "serdes_lane_lane_ctrl_lane2_reg_7_idig_lclbias_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_7_idig_pll_dfx_bi_en_attr = "serdes_lane_lane_ctrl_lane2_reg_7_idig_pll_dfx_bi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_7_idig_txpath_first_mux_control_attr = "serdes_lane_lane_ctrl_lane2_reg_7_idig_txpath_first_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_7_idig_txpath_second_mux_control_attr = "serdes_lane_lane_ctrl_lane2_reg_7_idig_txpath_second_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane2_reg_7_link_up_cntr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_10_idig_pll_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_12_idig_pll_en_h_attr = "serdes_lane_lane_ctrl_lane3_reg_12_idig_pll_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_12_idig_pll_resetb_attr = "serdes_lane_lane_ctrl_lane3_reg_12_idig_pll_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_14_cfg_avg_eng_bit_in_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_14_cfg_avg_eng_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_14_cfg_avg_eng_probe_bit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_14_cfg_avg_eng_start_attr = "serdes_lane_lane_ctrl_lane3_reg_14_cfg_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_15_cfg_avg_eng_limit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_18_cfg_force_apb2strb_bridge_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_18_cfg_force_apb2strb_bridge_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_18_cfg_force_apb2strb_bridge_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_19_cfg_force_cdr_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_19_cfg_force_cdr_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_lane_dig_tx2rx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_inv_attr = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_precode_enable_attr = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_unused_sar_inv_data_path_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_rx_unused_sar_inv_vga_adapt_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_1_cfg_use_cdr_data_as_data_attr = "serdes_lane_lane_ctrl_lane3_reg_1_cfg_use_cdr_data_as_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_20_cfg_force_dfe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_20_cfg_force_dfe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_21_cfg_force_ffe_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_21_cfg_force_ffe_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_22_cfg_force_adapt_apb2apb_bridge_src_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr = "serdes_lane_lane_ctrl_lane3_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_22_cfg_force_adapt_apb2apb_bridge_trgt_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_23_cfg_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane3_reg_23_cfg_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_23_cfg_stbl_time_aftr_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_23_cfg_stbl_time_bfr_strb_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_23_cfg_strb_pulse_width_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_24_adc_nob_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_24_cfg_lane_mode_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_24_fake_training_attr = "serdes_lane_lane_ctrl_lane3_reg_24_fake_training_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_24_rx_reconverge_attr = "serdes_lane_lane_ctrl_lane3_reg_24_rx_reconverge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_24_tfl_enable_attr = "serdes_lane_lane_ctrl_lane3_reg_24_tfl_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_25_dp_rx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_25_dp_tx_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_25_rx_adc_active_sar_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_25_rx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_25_tx_pam_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_26_idig_adc_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_26_idig_clkmux_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_26_idig_lane_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr = "serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr = "serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr = "serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr = "serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_28_lane_ctrl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_29_lane_ctrl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_29_lane_ctrl_reg2probe_en_attr = "serdes_lane_lane_ctrl_lane3_reg_29_lane_ctrl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_lane_dig_rx2tx_loopback_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_bus_take_dft_attr = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_bus_take_dft_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_grey_sym_lut_attr = 228;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_inv_attr = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_lane_enable_attr = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_lane_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_precode_enable_attr = "serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_precode_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_probe_bus_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_2_cfg_tx_swizzle_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_30_metrics_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_31_metrics_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_32_fw_calib_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_32_fw_dsp_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_32_fw_tfl_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_33_fw_fsm_state1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_33_fw_fsm_state2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_33_fw_fsm_state3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_34_lane_cal_error_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_34_lane_cal_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_3_cfg_tx_err_inj_en_attr = "serdes_lane_lane_ctrl_lane3_reg_3_cfg_tx_err_inj_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_3_cfg_tx_err_inj_mask_cfg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_3_cfg_tx_err_inj_mask_rotate_attr = "serdes_lane_lane_ctrl_lane3_reg_3_cfg_tx_err_inj_mask_rotate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_3_cfg_tx_err_inj_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_4_cfg_tx_err_inj_trig_attr = "serdes_lane_lane_ctrl_lane3_reg_4_cfg_tx_err_inj_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_5_cfg_tx_err_inj_mask_load_attr = "serdes_lane_lane_ctrl_lane3_reg_5_cfg_tx_err_inj_mask_load_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_6_idig_tx_dig_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_6_tx_piso_reset_attr = "serdes_lane_lane_ctrl_lane3_reg_6_tx_piso_reset_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_7_idig_lclbias_pd_attr = "serdes_lane_lane_ctrl_lane3_reg_7_idig_lclbias_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_7_idig_pll_dfx_bi_en_attr = "serdes_lane_lane_ctrl_lane3_reg_7_idig_pll_dfx_bi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_7_idig_txpath_first_mux_control_attr = "serdes_lane_lane_ctrl_lane3_reg_7_idig_txpath_first_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_7_idig_txpath_second_mux_control_attr = "serdes_lane_lane_ctrl_lane3_reg_7_idig_txpath_second_mux_control_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_lane_lane_ctrl_lane3_reg_7_link_up_cntr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_10_cfg_an_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_11_cfg_an_rx_lcw_re_attr = "serdes_shim_an_lane0_reg_11_cfg_an_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_11_cfg_an_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_11_cfg_an_tx_lcw_we_attr = "serdes_shim_an_lane0_reg_11_cfg_an_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_18_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_19_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_1_an_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_1_an_reg2probe_en_attr = "serdes_shim_an_lane0_reg_1_an_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_20_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_21_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_22_debug_fw_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_23_debug_fw_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_24_debug_fw_reg7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_25_debug_fw_reg8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_26_debug_fw_reg9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_27_direct_control_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_27_direct_control_bus_en_attr = "serdes_shim_an_lane0_reg_27_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_load_preset_attr = "serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_2_an_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_lane0_reg_3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_an_rx_enable_m_attr = "serdes_shim_an_lane0_reg_3_cfg_an_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_an_tx_enable_m_attr = "serdes_shim_an_lane0_reg_3_cfg_an_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_dig_cdr_disable_attr = "serdes_shim_an_lane0_reg_3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_edge_too_long_disable_attr = "serdes_shim_an_lane0_reg_3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_edge_too_short_disable_attr = "serdes_shim_an_lane0_reg_3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_page_max_timer_disable_attr = "serdes_shim_an_lane0_reg_3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_3_cfg_page_min_timer_disable_attr = "serdes_shim_an_lane0_reg_3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_4_pcs_lock_attr = "serdes_shim_an_lane0_reg_4_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_pcs_rx_bypass_sample_attr = "serdes_shim_an_lane0_reg_5_pcs_rx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_pcs_tx_bypass_sample_attr = "serdes_shim_an_lane0_reg_5_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_rx_pma_en_attr = "serdes_shim_an_lane0_reg_5_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_sc_rx_80b_swz_attr = "serdes_shim_an_lane0_reg_5_sc_rx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_sc_tx_80b_swz_attr = "serdes_shim_an_lane0_reg_5_sc_tx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_transmit_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_5_tx_pma_en_attr = "serdes_shim_an_lane0_reg_5_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_6_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_7_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_8_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane0_reg_9_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_10_cfg_an_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_11_cfg_an_rx_lcw_re_attr = "serdes_shim_an_lane1_reg_11_cfg_an_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_11_cfg_an_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_11_cfg_an_tx_lcw_we_attr = "serdes_shim_an_lane1_reg_11_cfg_an_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_18_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_19_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_1_an_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_1_an_reg2probe_en_attr = "serdes_shim_an_lane1_reg_1_an_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_20_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_21_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_22_debug_fw_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_23_debug_fw_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_24_debug_fw_reg7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_25_debug_fw_reg8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_26_debug_fw_reg9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_27_direct_control_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_27_direct_control_bus_en_attr = "serdes_shim_an_lane1_reg_27_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_load_preset_attr = "serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_2_an_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_lane1_reg_3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_an_rx_enable_m_attr = "serdes_shim_an_lane1_reg_3_cfg_an_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_an_tx_enable_m_attr = "serdes_shim_an_lane1_reg_3_cfg_an_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_dig_cdr_disable_attr = "serdes_shim_an_lane1_reg_3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_edge_too_long_disable_attr = "serdes_shim_an_lane1_reg_3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_edge_too_short_disable_attr = "serdes_shim_an_lane1_reg_3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_page_max_timer_disable_attr = "serdes_shim_an_lane1_reg_3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_3_cfg_page_min_timer_disable_attr = "serdes_shim_an_lane1_reg_3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_4_pcs_lock_attr = "serdes_shim_an_lane1_reg_4_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_pcs_rx_bypass_sample_attr = "serdes_shim_an_lane1_reg_5_pcs_rx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_pcs_tx_bypass_sample_attr = "serdes_shim_an_lane1_reg_5_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_rx_pma_en_attr = "serdes_shim_an_lane1_reg_5_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_sc_rx_80b_swz_attr = "serdes_shim_an_lane1_reg_5_sc_rx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_sc_tx_80b_swz_attr = "serdes_shim_an_lane1_reg_5_sc_tx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_transmit_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_5_tx_pma_en_attr = "serdes_shim_an_lane1_reg_5_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_6_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_7_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_8_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane1_reg_9_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_10_cfg_an_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_11_cfg_an_rx_lcw_re_attr = "serdes_shim_an_lane2_reg_11_cfg_an_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_11_cfg_an_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_11_cfg_an_tx_lcw_we_attr = "serdes_shim_an_lane2_reg_11_cfg_an_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_18_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_19_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_1_an_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_1_an_reg2probe_en_attr = "serdes_shim_an_lane2_reg_1_an_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_20_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_21_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_22_debug_fw_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_23_debug_fw_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_24_debug_fw_reg7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_25_debug_fw_reg8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_26_debug_fw_reg9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_27_direct_control_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_27_direct_control_bus_en_attr = "serdes_shim_an_lane2_reg_27_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_load_preset_attr = "serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_2_an_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_lane2_reg_3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_an_rx_enable_m_attr = "serdes_shim_an_lane2_reg_3_cfg_an_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_an_tx_enable_m_attr = "serdes_shim_an_lane2_reg_3_cfg_an_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_dig_cdr_disable_attr = "serdes_shim_an_lane2_reg_3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_edge_too_long_disable_attr = "serdes_shim_an_lane2_reg_3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_edge_too_short_disable_attr = "serdes_shim_an_lane2_reg_3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_page_max_timer_disable_attr = "serdes_shim_an_lane2_reg_3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_3_cfg_page_min_timer_disable_attr = "serdes_shim_an_lane2_reg_3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_4_pcs_lock_attr = "serdes_shim_an_lane2_reg_4_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_pcs_rx_bypass_sample_attr = "serdes_shim_an_lane2_reg_5_pcs_rx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_pcs_tx_bypass_sample_attr = "serdes_shim_an_lane2_reg_5_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_rx_pma_en_attr = "serdes_shim_an_lane2_reg_5_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_sc_rx_80b_swz_attr = "serdes_shim_an_lane2_reg_5_sc_rx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_sc_tx_80b_swz_attr = "serdes_shim_an_lane2_reg_5_sc_tx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_transmit_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_5_tx_pma_en_attr = "serdes_shim_an_lane2_reg_5_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_6_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_7_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_8_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane2_reg_9_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_10_cfg_an_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_11_cfg_an_rx_lcw_re_attr = "serdes_shim_an_lane3_reg_11_cfg_an_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_11_cfg_an_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_11_cfg_an_tx_lcw_we_attr = "serdes_shim_an_lane3_reg_11_cfg_an_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_18_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_19_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_1_an_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_1_an_reg2probe_en_attr = "serdes_shim_an_lane3_reg_1_an_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_20_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_21_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_22_debug_fw_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_23_debug_fw_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_24_debug_fw_reg7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_25_debug_fw_reg8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_26_debug_fw_reg9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_27_direct_control_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_27_direct_control_bus_en_attr = "serdes_shim_an_lane3_reg_27_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_load_preset_attr = "serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_2_an_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_lane3_reg_3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_an_rx_enable_m_attr = "serdes_shim_an_lane3_reg_3_cfg_an_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_an_tx_enable_m_attr = "serdes_shim_an_lane3_reg_3_cfg_an_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_dig_cdr_disable_attr = "serdes_shim_an_lane3_reg_3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_edge_too_long_disable_attr = "serdes_shim_an_lane3_reg_3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_edge_too_short_disable_attr = "serdes_shim_an_lane3_reg_3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_page_max_timer_disable_attr = "serdes_shim_an_lane3_reg_3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_3_cfg_page_min_timer_disable_attr = "serdes_shim_an_lane3_reg_3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_4_pcs_lock_attr = "serdes_shim_an_lane3_reg_4_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_pcs_rx_bypass_sample_attr = "serdes_shim_an_lane3_reg_5_pcs_rx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_pcs_tx_bypass_sample_attr = "serdes_shim_an_lane3_reg_5_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_rx_pma_en_attr = "serdes_shim_an_lane3_reg_5_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_sc_rx_80b_swz_attr = "serdes_shim_an_lane3_reg_5_sc_rx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_sc_tx_80b_swz_attr = "serdes_shim_an_lane3_reg_5_sc_tx_80b_swz_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_transmit_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_5_tx_pma_en_attr = "serdes_shim_an_lane3_reg_5_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_6_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_7_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_8_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_an_lane3_reg_9_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_10_mb_lcb_enb_attr = "serdes_shim_ana_common_reg_10_mb_lcb_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_10_mb_lcbamp_enb_attr = "serdes_shim_ana_common_reg_10_mb_lcbamp_enb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_10_mb_reg7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_10_mb_rs_trim_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_10_mb_vacu600_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_10_mb_vreflocal_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_11_mb_compsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_11_mb_reg8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_11_mb_vref_dco_clb_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_11_mb_vref_rx_clb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_11_mb_vref_tx_clb_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_11_mb_vrefen_attr = "serdes_shim_ana_common_reg_11_mb_vrefen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_12_mb_dcmonctr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_12_mb_reg9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_12_mb_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_cmn_dcmon_adcafe_l_en_attr = "serdes_shim_ana_common_reg_13_cmn_dcmon_adcafe_l_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_cmn_dcmon_adcafe_r_en_attr = "serdes_shim_ana_common_reg_13_cmn_dcmon_adcafe_r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_cmn_dcmon_afe_l_en_attr = "serdes_shim_ana_common_reg_13_cmn_dcmon_afe_l_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_cmn_dcmon_afe_r_en_attr = "serdes_shim_ana_common_reg_13_cmn_dcmon_afe_r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_cmn_ref_clks_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_family_clk_tie_low_en_attr = "serdes_shim_ana_common_reg_13_family_clk_tie_low_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_refclk1_term_cm_en_attr = "serdes_shim_ana_common_reg_13_refclk1_term_cm_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_refclk1_term_en_attr = "serdes_shim_ana_common_reg_13_refclk1_term_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_refclk2_term_cm_en_attr = "serdes_shim_ana_common_reg_13_refclk2_term_cm_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_13_refclk2_term_en_attr = "serdes_shim_ana_common_reg_13_refclk2_term_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_cmn_dcmon_obs_sp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_dcmon_adc_l_en_attr = "serdes_shim_ana_common_reg_1_dcmon_adc_l_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_dcmon_adc_r_en_attr = "serdes_shim_ana_common_reg_1_dcmon_adc_r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_dcmon_en_attr = "serdes_shim_ana_common_reg_1_dcmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_dcmon_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_bgtrim_mode_attr = "serdes_shim_ana_common_reg_1_delta_sigma_bgtrim_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_chop_en_attr = "serdes_shim_ana_common_reg_1_delta_sigma_chop_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_clkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_cont_mode_attr = "serdes_shim_ana_common_reg_1_delta_sigma_cont_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_en_attr = "serdes_shim_ana_common_reg_1_delta_sigma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_freeze_attr = "serdes_shim_ana_common_reg_1_delta_sigma_freeze_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_mux_en_attr = "serdes_shim_ana_common_reg_1_delta_sigma_mux_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_rst_b_attr = "serdes_shim_ana_common_reg_1_delta_sigma_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_1_delta_sigma_sel_p_attr = "serdes_shim_ana_common_reg_1_delta_sigma_sel_p_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_3_mb_cmp_en_attr = "serdes_shim_ana_common_reg_3_mb_cmp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_3_mb_cmp_ofc_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_3_mb_cmp_ofc_n_sign_attr = "serdes_shim_ana_common_reg_3_mb_cmp_ofc_n_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_3_mb_cmp_ofc_p_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_3_mb_cmp_ofc_p_sign_attr = "serdes_shim_ana_common_reg_3_mb_cmp_ofc_p_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_3_mb_reg0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_dco_clbswen_attr = "serdes_shim_ana_common_reg_4_mb_dco_clbswen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_pre_cmp_n_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_pre_cmp_p_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_rx_st3_clbswen_attr = "serdes_shim_ana_common_reg_4_mb_rx_st3_clbswen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_rx_term_clbswen_attr = "serdes_shim_ana_common_reg_4_mb_rx_term_clbswen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_4_mb_tx_term_clbswen_attr = "serdes_shim_ana_common_reg_4_mb_tx_term_clbswen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_5_mb_dco_bintrim_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_5_mb_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_5_txterm_trim_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_6_mb_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_6_mb_rx_rterm_btrim_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_6_mb_rx_st3_trim_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_6_mb_vg750sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_7_mb_lcb_trim_plla_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_7_mb_lcb_trim_pllb_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_7_mb_lcb_trim_rclk1_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_7_mb_lcb_trim_rclk2_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_7_mb_lcb_trim_spare1_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_7_mb_lcb_trim_spare2_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_8_mb_lcb_trim_comp_50u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_8_mb_lcb_trim_dcmon_50u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_8_mb_lcb_trim_master_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_8_mb_lcb_trim_spare1_50u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_8_mb_lcb_trim_spare2_50u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_8_mb_reg5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_9_mb_lcb_trim_spare3_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_9_mb_lcb_trim_spare3_50u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_9_mb_lcb_trim_spare4_100u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_9_mb_lcb_trim_spare4_50u_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_common_reg_9_mb_reg6_attr = 136;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_10_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_11_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_12_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_13_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_13_cfg_plllock_state_sel_attr = "serdes_shim_ana_pll_pll_a_reg_13_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_13_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_dcocoarse_ovrden_attr = "serdes_shim_ana_pll_pll_a_reg_18_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_18_cfg_full_range_afc_sel_attr = "serdes_shim_ana_pll_pll_a_reg_18_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_boost_dtr_const_zeta_attr = "serdes_shim_ana_pll_pll_a_reg_19_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_boost_fine_const_zeta_attr = "serdes_shim_ana_pll_pll_a_reg_19_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_filter_boostfade_dtr_en_attr = "serdes_shim_ana_pll_pll_a_reg_19_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_filter_boostfade_fine_en_attr = "serdes_shim_ana_pll_pll_a_reg_19_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_19_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_1_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_1_o_fbdiv_intgr_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_1_o_fracnen_h_attr = "serdes_shim_ana_pll_pll_a_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_earlylock_sel_attr = "serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_final_code_sel_attr = "serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_fine_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_fine_prop_coeff_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_20_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_dcosettle_mode_attr = "serdes_shim_ana_pll_pll_a_reg_21_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_dtr_ovrden_attr = "serdes_shim_ana_pll_pll_a_reg_21_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_skip_second_afc_calib_attr = "serdes_shim_ana_pll_pll_a_reg_21_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_stay_fll_attr = "serdes_shim_ana_pll_pll_a_reg_21_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_stay_pll_attr = "serdes_shim_ana_pll_pll_a_reg_21_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_21_cfg_tdcbbpd_en_attr = "serdes_shim_ana_pll_pll_a_reg_21_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_ssc_track_en_attr = "serdes_shim_ana_pll_pll_a_reg_22_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_22_cfg_temp_track_en_attr = "serdes_shim_ana_pll_pll_a_reg_22_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_cb56_lane32div_en_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_clkouten_cb_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_clkouten_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_clkouten_lane_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_fbdiv_rat0p5_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_pcs3334_divsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_pcs3334div_en_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_pcs40div_en_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_pll_bypass_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_refclk100div_en_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_refclk100div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_refclk156div_en_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_refclk156div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_sddiv_en_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_sddiv_ratio_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_23_cfg_sddtr_clk_sel_attr = "serdes_shim_ana_pll_pll_a_reg_23_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_a2f_en_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_en_peak_sense_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_en_peak_sense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_force_vreglpfbyp_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_obsmux0_del_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_obsmux1_del_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_ref156div_rat0p5_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_ss_comp_out_sel_attr = "serdes_shim_ana_pll_pll_a_reg_24_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_24_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_ramp_dir_ovr_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_ramp_enable_ovr_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_ramp_toggle_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dpso_bypass_mode_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_dtr_modulation_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_fbdiv_clkgate_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_fine_modulation_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_fine_modulation_sel_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_tdcpe_modulation_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_25_cfg_vreg_dac_modulation_en_attr = "serdes_shim_ana_pll_pll_a_reg_25_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_26_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_26_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_fw_force_vreg_cal_done_attr = "serdes_shim_ana_pll_pll_a_reg_27_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_fw_vreg_accum_ovrd_attr = "serdes_shim_ana_pll_pll_a_reg_27_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_inv_vpeak_comb_fb_attr = "serdes_shim_ana_pll_pll_a_reg_27_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_inv_vreg_comb_fb_attr = "serdes_shim_ana_pll_pll_a_reg_27_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_27_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_28_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_28_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_dft_freq_meas_enable_attr = "serdes_shim_ana_pll_pll_a_reg_29_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_29_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_2_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_2_cfg_fracn_sd_step_en_attr = "serdes_shim_ana_pll_pll_a_reg_2_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_2_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_30_cfg_force_kvcc_done_attr = "serdes_shim_ana_pll_pll_a_reg_30_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_code_ovrd_attr = "serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_code_ovrd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_code_val_attr = 95;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_vreg_offset_en_val_attr = "serdes_shim_ana_pll_pll_a_reg_30_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_31_cfg_spare_dig2ana_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_3_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_3_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_3_o_tdc_fine_res_attr = "serdes_shim_ana_pll_pll_a_reg_3_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_3_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_cfg_sigma_delta2_sel_attr = "serdes_shim_ana_pll_pll_a_reg_4_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_dcoditheren_h_attr = "serdes_shim_ana_pll_pll_a_reg_4_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_fbdiv_strobe_h_attr = "serdes_shim_ana_pll_pll_a_reg_4_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_feedfwrdcal_en_h_attr = "serdes_shim_ana_pll_pll_a_reg_4_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_feedfwrdcal_pause_h_attr = "serdes_shim_ana_pll_pll_a_reg_4_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_4_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_5_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_5_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_6_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_6_o_bbinlock_h_attr = "serdes_shim_ana_pll_pll_a_reg_6_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_6_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_6_o_tdcdc_en_h_attr = "serdes_shim_ana_pll_pll_a_reg_6_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_6_o_tdcovccorr_en_h_attr = "serdes_shim_ana_pll_pll_a_reg_6_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_6_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_7_o_dfx_tdc_disable_attr = "serdes_shim_ana_pll_pll_a_reg_7_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_7_o_pll_reg_resetb_attr = "serdes_shim_ana_pll_pll_a_reg_7_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_7_o_pll_reg_resetb_mode_ctrl_attr = "serdes_shim_ana_pll_pll_a_reg_7_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_7_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_7_o_plllc_regen_h_attr = "serdes_shim_ana_pll_pll_a_reg_7_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_8_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_8_o_dcocoarse_ovrd_h_attr = "serdes_shim_ana_pll_pll_a_reg_8_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_8_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_8_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_cfg_dft_cnt_restart_attr = "serdes_shim_ana_pll_pll_a_reg_9_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_cfg_force_tdcdone_at_afcdone_attr = "serdes_shim_ana_pll_pll_a_reg_9_cfg_force_tdcdone_at_afcdone_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_o_tdccalexten_h_attr = "serdes_shim_ana_pll_pll_a_reg_9_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_o_tdcroen_h_attr = "serdes_shim_ana_pll_pll_a_reg_9_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_a_reg_9_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_10_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_11_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_12_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_13_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_13_cfg_plllock_state_sel_attr = "serdes_shim_ana_pll_pll_b_reg_13_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_13_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_dcocoarse_ovrden_attr = "serdes_shim_ana_pll_pll_b_reg_18_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_18_cfg_full_range_afc_sel_attr = "serdes_shim_ana_pll_pll_b_reg_18_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_boost_dtr_const_zeta_attr = "serdes_shim_ana_pll_pll_b_reg_19_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_boost_fine_const_zeta_attr = "serdes_shim_ana_pll_pll_b_reg_19_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_filter_boostfade_dtr_en_attr = "serdes_shim_ana_pll_pll_b_reg_19_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_filter_boostfade_fine_en_attr = "serdes_shim_ana_pll_pll_b_reg_19_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_19_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_1_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_1_o_fbdiv_intgr_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_1_o_fracnen_h_attr = "serdes_shim_ana_pll_pll_b_reg_1_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_earlylock_sel_attr = "serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_final_code_sel_attr = "serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_fine_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_fine_prop_coeff_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_20_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_dcosettle_mode_attr = "serdes_shim_ana_pll_pll_b_reg_21_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_dtr_ovrden_attr = "serdes_shim_ana_pll_pll_b_reg_21_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_skip_second_afc_calib_attr = "serdes_shim_ana_pll_pll_b_reg_21_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_stay_fll_attr = "serdes_shim_ana_pll_pll_b_reg_21_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_stay_pll_attr = "serdes_shim_ana_pll_pll_b_reg_21_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_21_cfg_tdcbbpd_en_attr = "serdes_shim_ana_pll_pll_b_reg_21_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_ssc_track_en_attr = "serdes_shim_ana_pll_pll_b_reg_22_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_22_cfg_temp_track_en_attr = "serdes_shim_ana_pll_pll_b_reg_22_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_cb56_lane32div_en_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_clkouten_cb_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_clkouten_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_clkouten_lane_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_fbdiv_rat0p5_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_pcs3334_divsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_pcs3334div_en_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_pcs40div_en_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_pll_bypass_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_refclk100div_en_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_refclk100div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_refclk156div_en_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_refclk156div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_sddiv_en_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_sddiv_ratio_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_23_cfg_sddtr_clk_sel_attr = "serdes_shim_ana_pll_pll_b_reg_23_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_a2f_en_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_en_peak_sense_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_en_peak_sense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_force_vreglpfbyp_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_obsmux0_del_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_obsmux1_del_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_ref156div_rat0p5_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_ss_comp_out_sel_attr = "serdes_shim_ana_pll_pll_b_reg_24_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_24_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_ramp_dir_ovr_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_ramp_enable_ovr_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_ramp_toggle_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dpso_bypass_mode_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_dtr_modulation_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_fbdiv_clkgate_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_fine_modulation_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_fine_modulation_sel_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_tdcpe_modulation_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_25_cfg_vreg_dac_modulation_en_attr = "serdes_shim_ana_pll_pll_b_reg_25_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_26_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_26_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_fw_force_vreg_cal_done_attr = "serdes_shim_ana_pll_pll_b_reg_27_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_fw_vreg_accum_ovrd_attr = "serdes_shim_ana_pll_pll_b_reg_27_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_inv_vpeak_comb_fb_attr = "serdes_shim_ana_pll_pll_b_reg_27_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_inv_vreg_comb_fb_attr = "serdes_shim_ana_pll_pll_b_reg_27_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_27_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_28_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_28_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_dft_freq_meas_enable_attr = "serdes_shim_ana_pll_pll_b_reg_29_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_29_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_2_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_2_cfg_fracn_sd_step_en_attr = "serdes_shim_ana_pll_pll_b_reg_2_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_2_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_30_cfg_force_kvcc_done_attr = "serdes_shim_ana_pll_pll_b_reg_30_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_code_ovrd_attr = "serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_code_ovrd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_code_val_attr = 95;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_vreg_offset_en_val_attr = "serdes_shim_ana_pll_pll_b_reg_30_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_31_cfg_spare_dig2ana_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_3_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_3_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_3_o_tdc_fine_res_attr = "serdes_shim_ana_pll_pll_b_reg_3_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_3_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_cfg_sigma_delta2_sel_attr = "serdes_shim_ana_pll_pll_b_reg_4_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_dcoditheren_h_attr = "serdes_shim_ana_pll_pll_b_reg_4_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_fbdiv_strobe_h_attr = "serdes_shim_ana_pll_pll_b_reg_4_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_feedfwrdcal_en_h_attr = "serdes_shim_ana_pll_pll_b_reg_4_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_feedfwrdcal_pause_h_attr = "serdes_shim_ana_pll_pll_b_reg_4_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_4_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_5_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_5_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_6_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_6_o_bbinlock_h_attr = "serdes_shim_ana_pll_pll_b_reg_6_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_6_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_6_o_tdcdc_en_h_attr = "serdes_shim_ana_pll_pll_b_reg_6_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_6_o_tdcovccorr_en_h_attr = "serdes_shim_ana_pll_pll_b_reg_6_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_6_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_7_o_dfx_tdc_disable_attr = "serdes_shim_ana_pll_pll_b_reg_7_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_7_o_pll_reg_resetb_attr = "serdes_shim_ana_pll_pll_b_reg_7_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_7_o_pll_reg_resetb_mode_ctrl_attr = "serdes_shim_ana_pll_pll_b_reg_7_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_7_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_7_o_plllc_regen_h_attr = "serdes_shim_ana_pll_pll_b_reg_7_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_8_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_8_o_dcocoarse_ovrd_h_attr = "serdes_shim_ana_pll_pll_b_reg_8_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_8_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_8_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_cfg_dft_cnt_restart_attr = "serdes_shim_ana_pll_pll_b_reg_9_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_cfg_force_tdcdone_at_afcdone_attr = "serdes_shim_ana_pll_pll_b_reg_9_cfg_force_tdcdone_at_afcdone_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_o_tdccalexten_h_attr = "serdes_shim_ana_pll_pll_b_reg_9_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_o_tdcroen_h_attr = "serdes_shim_ana_pll_pll_b_reg_9_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_ana_pll_pll_b_reg_9_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_10_common_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_10_common_reg2probe_en_attr = "serdes_shim_common_reg_10_common_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_11_cfg_cmn_plla_ref_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_11_cfg_cmn_plla_ref_clk_sel_ovrd_attr = "serdes_shim_common_reg_11_cfg_cmn_plla_ref_clk_sel_ovrd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_11_cfg_cmn_pllb_ref_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_11_cfg_cmn_pllb_ref_clk_sel_ovrd_attr = "serdes_shim_common_reg_11_cfg_cmn_pllb_ref_clk_sel_ovrd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_13_icom_plla_dfx_bi_en_attr = "serdes_shim_common_reg_13_icom_plla_dfx_bi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_13_icom_plla_en_attr = "serdes_shim_common_reg_13_icom_plla_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_13_icom_plla_resetb_attr = "serdes_shim_common_reg_13_icom_plla_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_14_icom_pllb_dfx_bi_en_attr = "serdes_shim_common_reg_14_icom_pllb_dfx_bi_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_14_icom_pllb_en_attr = "serdes_shim_common_reg_14_icom_pllb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_14_icom_pllb_resetb_attr = "serdes_shim_common_reg_14_icom_pllb_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_15_cfg_acc_ctrl_field_mask_write_en_attr = "serdes_shim_common_reg_15_cfg_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_15_cfg_force_apb2strb_bridge_state_en_attr = "serdes_shim_common_reg_15_cfg_force_apb2strb_bridge_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_15_cfg_force_apb2strb_bridge_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_15_cfg_stbl_time_aftr_strb_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_15_cfg_stbl_time_bfr_strb_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_15_cfg_strb_pulse_width_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_17_apb_bridge_wd_limit_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_17_fabric_wd_counter_max_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_1_icom_refclk1_en_attr = "serdes_shim_common_reg_1_icom_refclk1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_1_icom_refclk2_en_attr = "serdes_shim_common_reg_1_icom_refclk2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_2_common_avg_eng_bit_in_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_2_common_avg_eng_count_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_2_common_avg_eng_probe_bit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_2_common_avg_eng_start_attr = "serdes_shim_common_reg_2_common_avg_eng_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_3_eth_probe_out_int_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_4_common_avg_eng_limit_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_7_icom_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_common_reg_9_common_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_common_reg_9_common_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_load_preset_attr = "serdes_shim_common_reg_9_common_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_common_reg_9_common_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_common_reg_9_common_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_common_reg_9_common_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_common_reg_9_common_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_clkbyp_dram2_attr = "serdes_shim_cpu_pm_reg_100_fuse_clkbyp_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_mce_dram2_attr = "serdes_shim_cpu_pm_reg_100_fuse_mce_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_ra_dram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_rmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_wa_dram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_wmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_100_fuse_wpulse_dram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_clkbyp_dram3_attr = "serdes_shim_cpu_pm_reg_101_fuse_clkbyp_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_mce_dram3_attr = "serdes_shim_cpu_pm_reg_101_fuse_mce_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_ra_dram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_rmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_wa_dram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_wmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_101_fuse_wpulse_dram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_clkbyp_trace_attr = "serdes_shim_cpu_pm_reg_102_fuse_clkbyp_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_mce_trace_attr = "serdes_shim_cpu_pm_reg_102_fuse_mce_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_ra_trace_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_rmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_wa_trace_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_wmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_102_fuse_wpulse_trace_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_103_fuse_clkbyp_fifo_attr = "serdes_shim_cpu_pm_reg_103_fuse_clkbyp_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_103_fuse_mce_fifo_attr = "serdes_shim_cpu_pm_reg_103_fuse_mce_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_103_fuse_rmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_103_fuse_wa_fifo_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_103_fuse_wmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_103_fuse_wpulse_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_105_sil_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_106_comm_cal_error_code_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_106_comm_cal_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_107_bitprog_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_108_bitprog_res_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_109_bitprog_status_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_10_lane3_auto_halt_release_attr = "serdes_shim_cpu_pm_reg_10_lane3_auto_halt_release_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_10_lane3_fsm_reset_attr = "serdes_shim_cpu_pm_reg_10_lane3_fsm_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_10_lane3_halt_on_state_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_10_lane3_jump_attr = "serdes_shim_cpu_pm_reg_10_lane3_jump_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_10_lane3_jump_from_halt_to_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_10_lane3_release_halt_attr = "serdes_shim_cpu_pm_reg_10_lane3_release_halt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_110_bitlog_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_111_bitlog_res_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_112_fw_common_calib_fsm_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_112_fw_common_fsm_state1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_112_fw_common_fsm_state2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_extracted_model_attr = "serdes_shim_cpu_pm_reg_11_extracted_model_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_rxtop_en_lane0_attr = "serdes_shim_cpu_pm_reg_11_rxtop_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_rxtop_en_lane1_attr = "serdes_shim_cpu_pm_reg_11_rxtop_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_rxtop_en_lane2_attr = "serdes_shim_cpu_pm_reg_11_rxtop_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_rxtop_en_lane3_attr = "serdes_shim_cpu_pm_reg_11_rxtop_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_speed_up_lane0_attr = "serdes_shim_cpu_pm_reg_11_speed_up_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_speed_up_lane1_attr = "serdes_shim_cpu_pm_reg_11_speed_up_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_speed_up_lane2_attr = "serdes_shim_cpu_pm_reg_11_speed_up_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_speed_up_lane3_attr = "serdes_shim_cpu_pm_reg_11_speed_up_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_txtop_en_lane0_attr = "serdes_shim_cpu_pm_reg_11_txtop_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_txtop_en_lane1_attr = "serdes_shim_cpu_pm_reg_11_txtop_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_txtop_en_lane2_attr = "serdes_shim_cpu_pm_reg_11_txtop_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_11_txtop_en_lane3_attr = "serdes_shim_cpu_pm_reg_11_txtop_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_16_fw_control_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_17_cpu_gen_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_18_cpu_ocdhaltonreset_attr = "serdes_shim_cpu_pm_reg_18_cpu_ocdhaltonreset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_18_cpu_prid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_18_cpu_ra_addr_by_fw_lane_cntxt_en_attr = "serdes_shim_cpu_pm_reg_18_cpu_ra_addr_by_fw_lane_cntxt_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_18_cpu_statvectorsel_attr = "serdes_shim_cpu_pm_reg_18_cpu_statvectorsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_atresetn_attr = "serdes_shim_cpu_pm_reg_19_cpu_atresetn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_breakin_attr = "serdes_shim_cpu_pm_reg_19_cpu_breakin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_breakoutack_attr = "serdes_shim_cpu_pm_reg_19_cpu_breakoutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_crosstriggerin_attr = "serdes_shim_cpu_pm_reg_19_cpu_crosstriggerin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_crosstriggeroutack_attr = "serdes_shim_cpu_pm_reg_19_cpu_crosstriggeroutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_pdebugenable_attr = "serdes_shim_cpu_pm_reg_19_cpu_pdebugenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_19_cpu_tmodeclkgateoverride_reserved_attr = "serdes_shim_cpu_pm_reg_19_cpu_tmodeclkgateoverride_reserved_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_comm_dco_calib_en_attr = "serdes_shim_cpu_pm_reg_1_comm_dco_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_comm_rcomp_calib_en_attr = "serdes_shim_cpu_pm_reg_1_comm_rcomp_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_comm_stg3_calib_en_attr = "serdes_shim_cpu_pm_reg_1_comm_stg3_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_comm_tcomp_calib_en_attr = "serdes_shim_cpu_pm_reg_1_comm_tcomp_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_lane0_en_attr = "serdes_shim_cpu_pm_reg_1_lane0_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_lane1_en_attr = "serdes_shim_cpu_pm_reg_1_lane1_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_lane2_en_attr = "serdes_shim_cpu_pm_reg_1_lane2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_lane3_en_attr = "serdes_shim_cpu_pm_reg_1_lane3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_main_manual_mode_en_attr = "serdes_shim_cpu_pm_reg_1_main_manual_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_1_main_periodic_state_en_attr = "serdes_shim_cpu_pm_reg_1_main_periodic_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_20_cpu_fifo_pattern_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_20_cpu_fifo_pattern_match_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_21_lane_select_128ui_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_21_samples_to_read_128ui_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_21_write_enable_128ui_attr = "serdes_shim_cpu_pm_reg_21_write_enable_128ui_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_22_tb_reg0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_23_tb_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_24_tb_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_25_tb_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_26_tb_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_27_tb_reg5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_28_tb_reg6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_29_tb_reg7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_adc_slc_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_adc_slc_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_clkgen_duty_cycle_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_clkgen_duty_cycle_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_clkgen_phase_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_clkgen_phase_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_clkgen_phase_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_clkgen_phase_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_clkmux_phase_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_clkmux_phase_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_concon_adapt_dis_attr = "serdes_shim_cpu_pm_reg_2_lane0_concon_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dco_pi_step_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dco_pi_step_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dco_vbuff_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dco_vbuff_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dco_vgate_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dco_vgate_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dsp_comm_dfe_n_ffe_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dsp_comm_dfe_n_ffe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dsp_ehm_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dsp_ehm_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dsp_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dsp_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dsp_g_per_sar_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dsp_g_per_sar_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dsp_tap64_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dsp_tap64_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_dsp_vref_per_oct_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_dsp_vref_per_oct_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_manual_mode_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_manual_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_reduced_th_attr = "serdes_shim_cpu_pm_reg_2_lane0_reduced_th_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_rsrv_1_attr = "serdes_shim_cpu_pm_reg_2_lane0_rsrv_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_rsrv_2_attr = "serdes_shim_cpu_pm_reg_2_lane0_rsrv_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_st1_common_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_st1_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_st1_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_st1_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_st2_common_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_st2_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_st2_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_st2_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_st3_common_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_st3_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_st3_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_st3_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_stand_alone_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_stand_alone_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_tx_dcc_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_tx_dcc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_tx_ldo_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_tx_ldo_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_tx_qec_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_tx_qec_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_tx_qec_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_tx_qec_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_vga_adapt_dis_attr = "serdes_shim_cpu_pm_reg_2_lane0_vga_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_2_lane0_vga_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_2_lane0_vga_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_30_tb_reg8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_31_tb_reg9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_32_fw_version_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_33_link_mng_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_33_link_mng_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_34_phy_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_34_phy_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_35_phy_owner_cpi_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_36_cpu_fifo_push_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_37_serdes_wrap_visactrl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_38_serdes_wrap_visactrl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_39_serdes_wrap_visactrl2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_adc_slc_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_adc_slc_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_clkgen_duty_cycle_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_clkgen_duty_cycle_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_clkgen_phase_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_clkgen_phase_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_clkgen_phase_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_clkgen_phase_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_clkmux_phase_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_clkmux_phase_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_concon_adapt_dis_attr = "serdes_shim_cpu_pm_reg_3_lane1_concon_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dco_pi_step_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dco_pi_step_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dco_vbuff_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dco_vbuff_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dco_vgate_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dco_vgate_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dsp_comm_dfe_n_ffe_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dsp_comm_dfe_n_ffe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dsp_ehm_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dsp_ehm_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dsp_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dsp_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dsp_g_per_sar_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dsp_g_per_sar_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dsp_tap64_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dsp_tap64_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_dsp_vref_per_oct_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_dsp_vref_per_oct_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_manual_mode_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_manual_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_reduced_th_attr = "serdes_shim_cpu_pm_reg_3_lane1_reduced_th_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_rsrv_1_attr = "serdes_shim_cpu_pm_reg_3_lane1_rsrv_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_rsrv_2_attr = "serdes_shim_cpu_pm_reg_3_lane1_rsrv_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_st1_common_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_st1_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_st1_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_st1_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_st2_common_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_st2_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_st2_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_st2_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_st3_common_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_st3_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_st3_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_st3_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_stand_alone_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_stand_alone_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_tx_dcc_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_tx_dcc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_tx_ldo_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_tx_ldo_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_tx_qec_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_tx_qec_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_tx_qec_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_tx_qec_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_vga_adapt_dis_attr = "serdes_shim_cpu_pm_reg_3_lane1_vga_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_3_lane1_vga_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_3_lane1_vga_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_40_serdes_wrap_visactrl3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_41_serdes_wrap_visactrl4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_42_serdes_wrap_visactrl5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_43_serdes_wrap_visactrl6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_44_serdes_wrap_visactrl7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_45_serdes_wrap_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_46_lanes_m0_visactrl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_47_lanes_m0_visactrl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_48_lanes_m0_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_49_lanes_m1_visactrl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_adc_slc_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_adc_slc_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_clkgen_duty_cycle_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_clkgen_duty_cycle_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_clkgen_phase_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_clkgen_phase_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_clkgen_phase_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_clkgen_phase_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_clkmux_phase_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_clkmux_phase_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_concon_adapt_dis_attr = "serdes_shim_cpu_pm_reg_4_lane2_concon_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dco_pi_step_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dco_pi_step_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dco_vbuff_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dco_vbuff_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dco_vgate_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dco_vgate_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dsp_comm_dfe_n_ffe_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dsp_comm_dfe_n_ffe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dsp_ehm_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dsp_ehm_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dsp_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dsp_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dsp_g_per_sar_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dsp_g_per_sar_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dsp_tap64_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dsp_tap64_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_dsp_vref_per_oct_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_dsp_vref_per_oct_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_manual_mode_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_manual_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_reduced_th_attr = "serdes_shim_cpu_pm_reg_4_lane2_reduced_th_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_rsrv_1_attr = "serdes_shim_cpu_pm_reg_4_lane2_rsrv_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_rsrv_2_attr = "serdes_shim_cpu_pm_reg_4_lane2_rsrv_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_st1_common_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_st1_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_st1_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_st1_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_st2_common_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_st2_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_st2_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_st2_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_st3_common_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_st3_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_st3_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_st3_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_stand_alone_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_stand_alone_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_tx_dcc_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_tx_dcc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_tx_ldo_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_tx_ldo_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_tx_qec_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_tx_qec_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_tx_qec_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_tx_qec_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_vga_adapt_dis_attr = "serdes_shim_cpu_pm_reg_4_lane2_vga_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_4_lane2_vga_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_4_lane2_vga_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_50_lanes_m1_visactrl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_51_lanes_m1_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_52_lanes_m2_visactrl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_53_lanes_m2_visactrl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_54_lanes_m2_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_55_lanes_m3_visactrl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_56_lanes_m3_visactrl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_57_lanes_m3_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_adc_slc_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_adc_slc_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_clkgen_duty_cycle_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_clkgen_duty_cycle_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_clkgen_phase_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_clkgen_phase_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_clkgen_phase_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_clkgen_phase_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_clkmux_phase_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_clkmux_phase_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_concon_adapt_dis_attr = "serdes_shim_cpu_pm_reg_5_lane3_concon_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dco_pi_step_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dco_pi_step_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dco_vbuff_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dco_vbuff_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dco_vgate_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dco_vgate_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dsp_comm_dfe_n_ffe_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dsp_comm_dfe_n_ffe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dsp_ehm_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dsp_ehm_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dsp_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dsp_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dsp_g_per_sar_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dsp_g_per_sar_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dsp_tap64_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dsp_tap64_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_dsp_vref_per_oct_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_dsp_vref_per_oct_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_manual_mode_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_manual_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_reduced_th_attr = "serdes_shim_cpu_pm_reg_5_lane3_reduced_th_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_rsrv_1_attr = "serdes_shim_cpu_pm_reg_5_lane3_rsrv_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_rsrv_2_attr = "serdes_shim_cpu_pm_reg_5_lane3_rsrv_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_st1_common_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_st1_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_st1_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_st1_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_st2_common_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_st2_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_st2_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_st2_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_st3_common_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_st3_common_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_st3_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_st3_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_stand_alone_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_stand_alone_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_tx_dcc_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_tx_dcc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_tx_ldo_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_tx_ldo_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_tx_qec_coarse_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_tx_qec_coarse_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_tx_qec_fine_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_tx_qec_fine_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_vga_adapt_dis_attr = "serdes_shim_cpu_pm_reg_5_lane3_vga_adapt_dis_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_5_lane3_vga_ofc_calib_en_attr = "serdes_shim_cpu_pm_reg_5_lane3_vga_ofc_calib_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_load_preset_attr = "serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_64_cpu_pm_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_65_cpu_pm_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_65_cpu_pm_reg2probe_en_attr = "serdes_shim_cpu_pm_reg_65_cpu_pm_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_common_attr = "serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_common_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane0_attr = "serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane1_attr = "serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane2_attr = "serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane3_attr = "serdes_shim_cpu_pm_reg_66_uc_timer_start_sc_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_67_uc_timer_limit_common_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_68_uc_timer_limit_lane0_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_69_uc_timer_limit_lane1_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_6_main_auto_halt_release_attr = "serdes_shim_cpu_pm_reg_6_main_auto_halt_release_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_6_main_fsm_reset_attr = "serdes_shim_cpu_pm_reg_6_main_fsm_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_6_main_halt_on_state_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_6_main_jump_attr = "serdes_shim_cpu_pm_reg_6_main_jump_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_6_main_jump_from_halt_to_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_6_main_release_halt_attr = "serdes_shim_cpu_pm_reg_6_main_release_halt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_70_uc_timer_limit_lane2_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_71_uc_timer_limit_lane3_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_72_uc_fsm_state_timer_en_attr = "serdes_shim_cpu_pm_reg_72_uc_fsm_state_timer_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_72_uc_fsm_state_timer_th_attr = 2000;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_75_temerature_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_7_lane0_auto_halt_release_attr = "serdes_shim_cpu_pm_reg_7_lane0_auto_halt_release_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_7_lane0_fsm_reset_attr = "serdes_shim_cpu_pm_reg_7_lane0_fsm_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_7_lane0_halt_on_state_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_7_lane0_jump_attr = "serdes_shim_cpu_pm_reg_7_lane0_jump_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_7_lane0_jump_from_halt_to_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_7_lane0_release_halt_attr = "serdes_shim_cpu_pm_reg_7_lane0_release_halt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_8_lane1_auto_halt_release_attr = "serdes_shim_cpu_pm_reg_8_lane1_auto_halt_release_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_8_lane1_fsm_reset_attr = "serdes_shim_cpu_pm_reg_8_lane1_fsm_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_8_lane1_halt_on_state_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_8_lane1_jump_attr = "serdes_shim_cpu_pm_reg_8_lane1_jump_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_8_lane1_jump_from_halt_to_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_8_lane1_release_halt_attr = "serdes_shim_cpu_pm_reg_8_lane1_release_halt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_clkbyp_iram0_attr = "serdes_shim_cpu_pm_reg_90_fuse_clkbyp_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_mce_iram0_attr = "serdes_shim_cpu_pm_reg_90_fuse_mce_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_ra_iram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_rmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_wa_iram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_wmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_90_fuse_wpulse_iram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_clkbyp_iram1_attr = "serdes_shim_cpu_pm_reg_91_fuse_clkbyp_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_mce_iram1_attr = "serdes_shim_cpu_pm_reg_91_fuse_mce_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_ra_iram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_rmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_wa_iram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_wmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_91_fuse_wpulse_iram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_clkbyp_iram2_attr = "serdes_shim_cpu_pm_reg_92_fuse_clkbyp_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_mce_iram2_attr = "serdes_shim_cpu_pm_reg_92_fuse_mce_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_ra_iram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_rmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_wa_iram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_wmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_92_fuse_wpulse_iram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_clkbyp_iram3_attr = "serdes_shim_cpu_pm_reg_93_fuse_clkbyp_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_mce_iram3_attr = "serdes_shim_cpu_pm_reg_93_fuse_mce_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_ra_iram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_rmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_wa_iram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_wmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_93_fuse_wpulse_iram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_clkbyp_iram4_attr = "serdes_shim_cpu_pm_reg_94_fuse_clkbyp_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_mce_iram4_attr = "serdes_shim_cpu_pm_reg_94_fuse_mce_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_ra_iram4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_rmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_wa_iram4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_wmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_94_fuse_wpulse_iram4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_clkbyp_iram5_attr = "serdes_shim_cpu_pm_reg_95_fuse_clkbyp_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_mce_iram5_attr = "serdes_shim_cpu_pm_reg_95_fuse_mce_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_ra_iram5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_rmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_wa_iram5_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_wmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_95_fuse_wpulse_iram5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_clkbyp_iram6_attr = "serdes_shim_cpu_pm_reg_96_fuse_clkbyp_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_mce_iram6_attr = "serdes_shim_cpu_pm_reg_96_fuse_mce_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_ra_iram6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_rmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_wa_iram6_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_wmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_96_fuse_wpulse_iram6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_clkbyp_iram7_attr = "serdes_shim_cpu_pm_reg_97_fuse_clkbyp_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_mce_iram7_attr = "serdes_shim_cpu_pm_reg_97_fuse_mce_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_ra_iram7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_rmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_wa_iram7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_wmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_97_fuse_wpulse_iram7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_clkbyp_dram0_attr = "serdes_shim_cpu_pm_reg_98_fuse_clkbyp_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_mce_dram0_attr = "serdes_shim_cpu_pm_reg_98_fuse_mce_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_ra_dram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_rmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_wa_dram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_wmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_98_fuse_wpulse_dram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_clkbyp_dram1_attr = "serdes_shim_cpu_pm_reg_99_fuse_clkbyp_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_mce_dram1_attr = "serdes_shim_cpu_pm_reg_99_fuse_mce_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_ra_dram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_rmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_wa_dram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_wmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_99_fuse_wpulse_dram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_9_lane2_auto_halt_release_attr = "serdes_shim_cpu_pm_reg_9_lane2_auto_halt_release_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_9_lane2_fsm_reset_attr = "serdes_shim_cpu_pm_reg_9_lane2_fsm_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_9_lane2_halt_on_state_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_9_lane2_jump_attr = "serdes_shim_cpu_pm_reg_9_lane2_jump_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_9_lane2_jump_from_halt_to_state_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_cpu_pm_reg_9_lane2_release_halt_attr = "serdes_shim_cpu_pm_reg_9_lane2_release_halt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_10_cfg_phymon_addr14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_10_cfg_phymon_addr15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_11_cfg_phymon_addr16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_11_cfg_phymon_addr17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_12_cfg_phymon_addr18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_12_cfg_phymon_addr19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_13_cfg_phymon_addr20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_13_cfg_phymon_addr21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_14_cfg_phymon_addr22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_14_cfg_phymon_addr23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_15_cfg_phymon_addr24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_15_cfg_phymon_addr25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_16_cfg_phymon_addr26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_16_cfg_phymon_addr27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_17_cfg_phymon_addr28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_17_cfg_phymon_addr29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_18_cfg_phymon_addr30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_18_cfg_phymon_addr31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_19_cfg_phymon_marker_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_1_cfg_blk_probe_samp_en_attr = "serdes_shim_lane_wrap_reg_1_cfg_blk_probe_samp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_1_cfg_core_probe_samp_en_attr = "serdes_shim_lane_wrap_reg_1_cfg_core_probe_samp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_1_cfg_probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_1_cfg_probe_id_out_sel_attr = "serdes_shim_lane_wrap_reg_1_cfg_probe_id_out_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_1_cfg_top_clk_data_prb_sel_attr = "serdes_shim_lane_wrap_reg_1_cfg_top_clk_data_prb_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_20_cfg_phymon_last_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_20_cfg_phymon_marker_cyc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_20_cfg_phymon_marker_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_20_cfg_phymon_marker_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_20_cfg_phymon_marker_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_20_cfg_phymon_self_probe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_load_preset_attr = "serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_21_lane_wrap_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_22_lane_wrap_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_22_lane_wrap_reg2probe_en_attr = "serdes_shim_lane_wrap_reg_22_lane_wrap_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane0_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane1_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane2_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane3_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_lane0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_lane1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_lane2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb32to80_start_rd_ptr_force_lane3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane0_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane1_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane2_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane3_attr = "serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_lane0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_lane1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_lane2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_23_cfg_an_gb80to32_start_rd_ptr_force_lane3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_25_irq_en_attr = 16709565;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_26_irq_clr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_27_irq_inv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_29_ecsr_ahb_bridge_clear_error_attr = "serdes_shim_lane_wrap_reg_29_ecsr_ahb_bridge_clear_error_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_29_ecsr_ahb_bridge_to_limit_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_burst_mode_attr = "serdes_shim_lane_wrap_reg_2_cfg_phymon_burst_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_man_cnt_attr = "serdes_shim_lane_wrap_reg_2_cfg_phymon_man_cnt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_man_mode_attr = "serdes_shim_lane_wrap_reg_2_cfg_phymon_man_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_samp_n_hold_attr = "serdes_shim_lane_wrap_reg_2_cfg_phymon_samp_n_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_start_attr = "serdes_shim_lane_wrap_reg_2_cfg_phymon_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_stop_attr = "serdes_shim_lane_wrap_reg_2_cfg_phymon_stop_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_phymon_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_polar_en_attr = "serdes_shim_lane_wrap_reg_2_cfg_polar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_2_cfg_polar_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_31_brk_int_out_by_reg_attr = "serdes_shim_lane_wrap_reg_31_brk_int_out_by_reg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_3_cfg_phymon_addr0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_3_cfg_phymon_addr1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_4_cfg_phymon_addr2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_4_cfg_phymon_addr3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_5_cfg_phymon_addr4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_5_cfg_phymon_addr5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_6_cfg_phymon_addr6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_6_cfg_phymon_addr7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_7_cfg_phymon_addr8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_7_cfg_phymon_addr9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_8_cfg_phymon_addr10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_8_cfg_phymon_addr11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_9_cfg_phymon_addr12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_lane_wrap_reg_9_cfg_phymon_addr13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_10_cfg_tfl_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_12_cfg_tfl_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_13_cfg_tfl_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_lane0_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_load_preset_attr = "serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_1_tfl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_29_cfg_tfl_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_29_cfg_tfl_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_2_tfl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_2_tfl_reg2probe_en_attr = "serdes_shim_tfl_lane0_reg_2_tfl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_36_cfg_tfl_gb_128_80_en_attr = "serdes_shim_tfl_lane0_reg_36_cfg_tfl_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_36_cfg_tfl_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_frame_boundary_early_attr = "serdes_shim_tfl_lane0_reg_3_cfg_tfl_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_lane0_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_lane0_reg_3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_lane0_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_send_data_attr = "serdes_shim_tfl_lane0_reg_3_cfg_tfl_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_lane0_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tfl_tx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_3_cfg_tx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_4_cfg_tfl_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_4_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_lane0_reg_4_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_4_cfg_tfl_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_4_cfg_tfl_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_5_cfg_tfl_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_lane0_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_5_cfg_tfl_cl136_precoder_out_swz_attr = "serdes_shim_tfl_lane0_reg_5_cfg_tfl_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_5_cfg_tfl_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_5_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_lane0_reg_5_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_6_cfg_tfl_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_7_cfg_tfl_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_lane0_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_7_cfg_tfl_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_7_cfg_tfl_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_7_cfg_tfl_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_9_cfg_rx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_9_cfg_rx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_9_cfg_tfl_rx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_9_cfg_tfl_rx_sync_pulse_attr = "serdes_shim_tfl_lane0_reg_9_cfg_tfl_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane0_reg_9_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_10_cfg_tfl_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_12_cfg_tfl_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_13_cfg_tfl_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_lane1_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_load_preset_attr = "serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_1_tfl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_29_cfg_tfl_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_29_cfg_tfl_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_2_tfl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_2_tfl_reg2probe_en_attr = "serdes_shim_tfl_lane1_reg_2_tfl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_36_cfg_tfl_gb_128_80_en_attr = "serdes_shim_tfl_lane1_reg_36_cfg_tfl_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_36_cfg_tfl_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_frame_boundary_early_attr = "serdes_shim_tfl_lane1_reg_3_cfg_tfl_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_lane1_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_lane1_reg_3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_lane1_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_send_data_attr = "serdes_shim_tfl_lane1_reg_3_cfg_tfl_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_lane1_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tfl_tx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_3_cfg_tx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_4_cfg_tfl_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_4_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_lane1_reg_4_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_4_cfg_tfl_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_4_cfg_tfl_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_5_cfg_tfl_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_lane1_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_5_cfg_tfl_cl136_precoder_out_swz_attr = "serdes_shim_tfl_lane1_reg_5_cfg_tfl_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_5_cfg_tfl_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_5_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_lane1_reg_5_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_6_cfg_tfl_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_7_cfg_tfl_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_lane1_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_7_cfg_tfl_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_7_cfg_tfl_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_7_cfg_tfl_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_9_cfg_rx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_9_cfg_rx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_9_cfg_tfl_rx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_9_cfg_tfl_rx_sync_pulse_attr = "serdes_shim_tfl_lane1_reg_9_cfg_tfl_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane1_reg_9_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_10_cfg_tfl_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_12_cfg_tfl_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_13_cfg_tfl_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_lane2_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_load_preset_attr = "serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_1_tfl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_29_cfg_tfl_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_29_cfg_tfl_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_2_tfl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_2_tfl_reg2probe_en_attr = "serdes_shim_tfl_lane2_reg_2_tfl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_36_cfg_tfl_gb_128_80_en_attr = "serdes_shim_tfl_lane2_reg_36_cfg_tfl_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_36_cfg_tfl_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_frame_boundary_early_attr = "serdes_shim_tfl_lane2_reg_3_cfg_tfl_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_lane2_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_lane2_reg_3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_lane2_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_send_data_attr = "serdes_shim_tfl_lane2_reg_3_cfg_tfl_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_lane2_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tfl_tx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_3_cfg_tx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_4_cfg_tfl_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_4_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_lane2_reg_4_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_4_cfg_tfl_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_4_cfg_tfl_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_5_cfg_tfl_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_lane2_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_5_cfg_tfl_cl136_precoder_out_swz_attr = "serdes_shim_tfl_lane2_reg_5_cfg_tfl_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_5_cfg_tfl_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_5_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_lane2_reg_5_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_6_cfg_tfl_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_7_cfg_tfl_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_lane2_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_7_cfg_tfl_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_7_cfg_tfl_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_7_cfg_tfl_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_9_cfg_rx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_9_cfg_rx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_9_cfg_tfl_rx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_9_cfg_tfl_rx_sync_pulse_attr = "serdes_shim_tfl_lane2_reg_9_cfg_tfl_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane2_reg_9_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_10_cfg_tfl_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_11_cfg_tfl_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_12_cfg_tfl_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_13_cfg_tfl_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_14_cfg_tfl_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_lane3_reg_17_cfg_tfl_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_load_preset_attr = "serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_1_tfl_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_29_cfg_tfl_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_29_cfg_tfl_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_2_tfl_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_2_tfl_reg2probe_en_attr = "serdes_shim_tfl_lane3_reg_2_tfl_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_36_cfg_tfl_gb_128_80_en_attr = "serdes_shim_tfl_lane3_reg_36_cfg_tfl_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_36_cfg_tfl_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_frame_boundary_early_attr = "serdes_shim_tfl_lane3_reg_3_cfg_tfl_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_lane3_reg_3_cfg_tfl_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_lane3_reg_3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_lane3_reg_3_cfg_tfl_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_send_data_attr = "serdes_shim_tfl_lane3_reg_3_cfg_tfl_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_lane3_reg_3_cfg_tfl_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tfl_tx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_3_cfg_tx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_4_cfg_tfl_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_4_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_lane3_reg_4_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_4_cfg_tfl_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_4_cfg_tfl_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_5_cfg_tfl_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_lane3_reg_5_cfg_tfl_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_5_cfg_tfl_cl136_precoder_out_swz_attr = "serdes_shim_tfl_lane3_reg_5_cfg_tfl_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_5_cfg_tfl_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_5_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_lane3_reg_5_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_6_cfg_tfl_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_7_cfg_tfl_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_lane3_reg_7_cfg_tfl_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_7_cfg_tfl_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_7_cfg_tfl_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_7_cfg_tfl_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_9_cfg_rx_grey_sym_lut_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_9_cfg_rx_swizzle_mode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_9_cfg_tfl_rx_samp_cnt_max_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_9_cfg_tfl_rx_sync_pulse_attr = "serdes_shim_tfl_lane3_reg_9_cfg_tfl_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_tfl_lane3_reg_9_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_10_wrap_car_reg2probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_10_wrap_car_reg2probe_en_attr = "serdes_shim_wrap_car_reg_10_wrap_car_reg2probe_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_11_obrk_barak_ready_attr = "serdes_shim_wrap_car_reg_11_obrk_barak_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_12_cfg_run_stall_attr = "serdes_shim_wrap_car_reg_12_cfg_run_stall_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_12_cfg_run_stall_force_en_attr = "serdes_shim_wrap_car_reg_12_cfg_run_stall_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_12_cfg_run_stall_force_val_attr = "serdes_shim_wrap_car_reg_12_cfg_run_stall_force_val_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_apb_clk_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_car_tx_clk_src_sel_attr = "serdes_shim_wrap_car_reg_1_car_tx_clk_src_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_cpu_clk_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_fast_clk_sel_attr = "serdes_shim_wrap_car_reg_1_fast_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_fifo_w_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_ok_to_switch_fast_clk_attr = "serdes_shim_wrap_car_reg_1_ok_to_switch_fast_clk_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_1_rx_fifo_clk_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_apb_pclk_en_lane0_attr = "serdes_shim_wrap_car_reg_2_apb_pclk_en_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_apb_pclk_en_lane1_attr = "serdes_shim_wrap_car_reg_2_apb_pclk_en_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_apb_pclk_en_lane2_attr = "serdes_shim_wrap_car_reg_2_apb_pclk_en_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_apb_pclk_en_lane3_attr = "serdes_shim_wrap_car_reg_2_apb_pclk_en_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_ck_apb_pclken_attr = "serdes_shim_wrap_car_reg_2_ck_apb_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_fifo_w_clken_attr = "serdes_shim_wrap_car_reg_2_fifo_w_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_hw_assist_avg_eng_clken_attr = "serdes_shim_wrap_car_reg_2_hw_assist_avg_eng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_probe_clk_en_attr = "serdes_shim_wrap_car_reg_2_probe_clk_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_8k_div2_clken_attr = "serdes_shim_wrap_car_reg_2_rx_8k_div2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_fifo_clk_divn_en_attr = "serdes_shim_wrap_car_reg_2_rx_fifo_clk_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane0_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane1_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane2_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane3_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_clk_en_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane0_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane1_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane2_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane3_attr = "serdes_shim_wrap_car_reg_2_rx_pcs_reset_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane0_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane1_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane2_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane3_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_clk_en_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane0_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane1_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane2_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane3_attr = "serdes_shim_wrap_car_reg_2_tx_pcs_reset_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_3_apb_presetn_swrst_attr = "serdes_shim_wrap_car_reg_3_apb_presetn_swrst_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_3_hw_assist_avg_eng_swrst_attr = "serdes_shim_wrap_car_reg_3_hw_assist_avg_eng_swrst_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_3_rx_fifo_r_swrst_attr = "serdes_shim_wrap_car_reg_3_rx_fifo_r_swrst_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_3_rx_fifo_w_swrst_attr = "serdes_shim_wrap_car_reg_3_rx_fifo_w_swrst_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_4_cfg_car_div_te_attr = "serdes_shim_wrap_car_reg_4_cfg_car_div_te_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_4_ecsr_period_clk_stabilizing_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_4_ecsr_restart_detection_attr = "serdes_shim_wrap_car_reg_4_ecsr_restart_detection_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_4_non_posted_write_en_attr = "serdes_shim_wrap_car_reg_4_non_posted_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_access_ind_extend_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_broadcast_mode_attr = "serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_broadcast_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_clear_on_read_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_field_mask_write_en_attr = "serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_field_mask_write_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_load_preset_attr = "serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_load_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_man_clear_on_read_attr = "serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_man_clear_on_read_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_man_self_clear_attr = "serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_man_self_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_read_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_self_clear_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_soft_reset_n_attr = "serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_soft_reset_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_7_wrap_car_sec_acc_ctrl_write_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane0_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane1_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane2_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane3_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_clk_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_sel_lane0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_sel_lane1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_sel_lane2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_clk_sel_lane3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane0_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane1_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane2_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane3_attr = "serdes_shim_wrap_car_reg_8_rx_tfl_reset_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane0_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane1_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane2_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane3_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_clk_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_sel_lane0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_sel_lane1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_sel_lane2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_clk_sel_lane3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane0_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane1_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane2_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane3_attr = "serdes_shim_wrap_car_reg_8_tx_tfl_reset_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane0_attr = "serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane1_attr = "serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane2_attr = "serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane3_attr = "serdes_shim_wrap_car_reg_9_rx_an_clk_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_reset_lane0_attr = "serdes_shim_wrap_car_reg_9_rx_an_reset_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_reset_lane1_attr = "serdes_shim_wrap_car_reg_9_rx_an_reset_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_reset_lane2_attr = "serdes_shim_wrap_car_reg_9_rx_an_reset_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_rx_an_reset_lane3_attr = "serdes_shim_wrap_car_reg_9_rx_an_reset_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane0_attr = "serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane1_attr = "serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane2_attr = "serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane3_attr = "serdes_shim_wrap_car_reg_9_tx_an_clk_en_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_reset_lane0_attr = "serdes_shim_wrap_car_reg_9_tx_an_reset_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_reset_lane1_attr = "serdes_shim_wrap_car_reg_9_tx_an_reset_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_reset_lane2_attr = "serdes_shim_wrap_car_reg_9_tx_an_reset_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_barak_quad__u_ip758brktop__serdes_shim_wrap_car_reg_9_tx_an_reset_lane3_attr = "serdes_shim_wrap_car_reg_9_tx_an_reset_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__avmm_clk_attr_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__barak_pri_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__barak_sec_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__cfgavmm_timeout_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__cnoc_clk_attr_hz = 250000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_0_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_0_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_0_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_0_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_1_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_1_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_1_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_1_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_2_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_2_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_2_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_2_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_3_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_3_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_3_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit0_ctrl_3_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_0_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_0_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_0_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_0_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_1_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_1_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_1_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_1_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_2_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_2_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_2_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_2_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_3_be0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_3_be1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_3_be2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_bit1_ctrl_3_be3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_0_ip_data_be0_attr = "dfd_0_be0_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_0_ip_data_be1_attr = "dfd_0_be1_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_0_ip_data_be2_attr = "dfd_0_be2_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_0_ip_data_be3_attr = "dfd_0_be3_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_1_ip_data_be0_attr = "dfd_1_be0_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_1_ip_data_be1_attr = "dfd_1_be1_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_1_ip_data_be2_attr = "dfd_1_be2_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_1_ip_data_be3_attr = "dfd_1_be3_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_2_ip_data_be0_attr = "dfd_2_be0_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_2_ip_data_be1_attr = "dfd_2_be1_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_2_ip_data_be2_attr = "dfd_2_be2_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_2_ip_data_be3_attr = "dfd_2_be3_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_3_ip_data_be0_attr = "dfd_3_be0_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_3_ip_data_be1_attr = "dfd_3_be1_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_3_ip_data_be2_attr = "dfd_3_be2_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_data_mux_ctrl_3_ip_data_be3_attr = "dfd_3_be3_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask0_ctrl_0_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask0_ctrl_1_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask0_ctrl_2_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask0_ctrl_3_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask1_ctrl_0_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask1_ctrl_1_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask1_ctrl_2_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_mask1_ctrl_3_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_memctrl_0_mem_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_memctrl_1_mem_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_memctrl_2_mem_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_memctrl_3_mem_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_capture_disabled_attr = "dfd_primary_ctrl_0_capture_disabled_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_extrig_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_ipdata_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_no_cprmemdata_attr = "dfd_primary_ctrl_0_no_cprmemdata_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_no_trigger_attr = "dfd_primary_ctrl_0_no_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_odfd_flushmem_start_attr = "dfd_primary_ctrl_0_odfd_flushmem_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_perfmon_cnt_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_pretrigger_mode_attr = "dfd_primary_ctrl_0_pretrigger_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_primwr2_attr = "dfd_primary_ctrl_0_primwr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_read_trace_done_attr = "dfd_primary_ctrl_0_read_trace_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_rstc_attr = "dfd_primary_ctrl_0_rstc_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_start_capture_attr = "dfd_primary_ctrl_0_start_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_0_swread_attr = "dfd_primary_ctrl_0_swread_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_capture_disabled_attr = "dfd_primary_ctrl_1_capture_disabled_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_extrig_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_ipdata_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_no_cprmemdata_attr = "dfd_primary_ctrl_1_no_cprmemdata_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_no_trigger_attr = "dfd_primary_ctrl_1_no_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_odfd_flushmem_start_attr = "dfd_primary_ctrl_1_odfd_flushmem_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_perfmon_cnt_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_pretrigger_mode_attr = "dfd_primary_ctrl_1_pretrigger_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_primwr2_attr = "dfd_primary_ctrl_1_primwr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_read_trace_done_attr = "dfd_primary_ctrl_1_read_trace_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_rstc_attr = "dfd_primary_ctrl_1_rstc_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_start_capture_attr = "dfd_primary_ctrl_1_start_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_1_swread_attr = "dfd_primary_ctrl_1_swread_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_capture_disabled_attr = "dfd_primary_ctrl_2_capture_disabled_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_extrig_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_ipdata_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_no_cprmemdata_attr = "dfd_primary_ctrl_2_no_cprmemdata_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_no_trigger_attr = "dfd_primary_ctrl_2_no_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_odfd_flushmem_start_attr = "dfd_primary_ctrl_2_odfd_flushmem_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_perfmon_cnt_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_pretrigger_mode_attr = "dfd_primary_ctrl_2_pretrigger_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_primwr2_attr = "dfd_primary_ctrl_2_primwr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_read_trace_done_attr = "dfd_primary_ctrl_2_read_trace_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_rstc_attr = "dfd_primary_ctrl_2_rstc_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_start_capture_attr = "dfd_primary_ctrl_2_start_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_2_swread_attr = "dfd_primary_ctrl_2_swread_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_capture_disabled_attr = "dfd_primary_ctrl_3_capture_disabled_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_extrig_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_ipdata_sync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_no_cprmemdata_attr = "dfd_primary_ctrl_3_no_cprmemdata_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_no_trigger_attr = "dfd_primary_ctrl_3_no_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_odfd_flushmem_start_attr = "dfd_primary_ctrl_3_odfd_flushmem_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_perfmon_cnt_set_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_pretrigger_mode_attr = "dfd_primary_ctrl_3_pretrigger_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_primwr2_attr = "dfd_primary_ctrl_3_primwr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_read_trace_done_attr = "dfd_primary_ctrl_3_read_trace_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_rstc_attr = "dfd_primary_ctrl_3_rstc_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_start_capture_attr = "dfd_primary_ctrl_3_start_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_primary_ctrl_3_swread_attr = "dfd_primary_ctrl_3_swread_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_0_pre_trigger_window_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_0_sm_trig_ena_attr = "dfd_secondary_ctrl_0_sm_trig_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_1_pre_trigger_window_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_1_sm_trig_ena_attr = "dfd_secondary_ctrl_1_sm_trig_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_2_pre_trigger_window_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_2_sm_trig_ena_attr = "dfd_secondary_ctrl_2_sm_trig_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_3_pre_trigger_window_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_secondary_ctrl_3_sm_trig_ena_attr = "dfd_secondary_ctrl_3_sm_trig_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_sm_mask_ctrl_0_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_sm_mask_ctrl_1_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_sm_mask_ctrl_2_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_sm_mask_ctrl_3_mv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_andor_triggers_attr = "dfd_trig_ctrl_0_andor_triggers_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_delay_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_depth_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_extrig0_edge_attr = "dfd_trig_ctrl_0_extrig0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_extrig0_ena_attr = "dfd_trig_ctrl_0_extrig0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_extrig1_edge_attr = "dfd_trig_ctrl_0_extrig1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_extrig1_ena_attr = "dfd_trig_ctrl_0_extrig1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_inv_triggers_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_mask0_edge_attr = "dfd_trig_ctrl_0_mask0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_mask0_ena_attr = "dfd_trig_ctrl_0_mask0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_mask0_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_mask1_edge_attr = "dfd_trig_ctrl_0_mask1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_mask1_ena_attr = "dfd_trig_ctrl_0_mask1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_mask1_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_odfd_flushmem_auto_attr = "dfd_trig_ctrl_0_odfd_flushmem_auto_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_odfd_flushmem_extrig_attr = "dfd_trig_ctrl_0_odfd_flushmem_extrig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_0_use_windows_capture_attr = "dfd_trig_ctrl_0_use_windows_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_andor_triggers_attr = "dfd_trig_ctrl_1_andor_triggers_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_delay_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_depth_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_extrig0_edge_attr = "dfd_trig_ctrl_1_extrig0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_extrig0_ena_attr = "dfd_trig_ctrl_1_extrig0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_extrig1_edge_attr = "dfd_trig_ctrl_1_extrig1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_extrig1_ena_attr = "dfd_trig_ctrl_1_extrig1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_inv_triggers_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_mask0_edge_attr = "dfd_trig_ctrl_1_mask0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_mask0_ena_attr = "dfd_trig_ctrl_1_mask0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_mask0_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_mask1_edge_attr = "dfd_trig_ctrl_1_mask1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_mask1_ena_attr = "dfd_trig_ctrl_1_mask1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_mask1_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_odfd_flushmem_auto_attr = "dfd_trig_ctrl_1_odfd_flushmem_auto_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_odfd_flushmem_extrig_attr = "dfd_trig_ctrl_1_odfd_flushmem_extrig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_1_use_windows_capture_attr = "dfd_trig_ctrl_1_use_windows_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_andor_triggers_attr = "dfd_trig_ctrl_2_andor_triggers_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_delay_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_depth_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_extrig0_edge_attr = "dfd_trig_ctrl_2_extrig0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_extrig0_ena_attr = "dfd_trig_ctrl_2_extrig0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_extrig1_edge_attr = "dfd_trig_ctrl_2_extrig1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_extrig1_ena_attr = "dfd_trig_ctrl_2_extrig1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_inv_triggers_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_mask0_edge_attr = "dfd_trig_ctrl_2_mask0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_mask0_ena_attr = "dfd_trig_ctrl_2_mask0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_mask0_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_mask1_edge_attr = "dfd_trig_ctrl_2_mask1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_mask1_ena_attr = "dfd_trig_ctrl_2_mask1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_mask1_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_odfd_flushmem_auto_attr = "dfd_trig_ctrl_2_odfd_flushmem_auto_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_odfd_flushmem_extrig_attr = "dfd_trig_ctrl_2_odfd_flushmem_extrig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_2_use_windows_capture_attr = "dfd_trig_ctrl_2_use_windows_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_andor_triggers_attr = "dfd_trig_ctrl_3_andor_triggers_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_delay_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_depth_capture_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_extrig0_edge_attr = "dfd_trig_ctrl_3_extrig0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_extrig0_ena_attr = "dfd_trig_ctrl_3_extrig0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_extrig1_edge_attr = "dfd_trig_ctrl_3_extrig1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_extrig1_ena_attr = "dfd_trig_ctrl_3_extrig1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_inv_triggers_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_mask0_edge_attr = "dfd_trig_ctrl_3_mask0_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_mask0_ena_attr = "dfd_trig_ctrl_3_mask0_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_mask0_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_mask1_edge_attr = "dfd_trig_ctrl_3_mask1_edge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_mask1_ena_attr = "dfd_trig_ctrl_3_mask1_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_mask1_trigger_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_odfd_flushmem_auto_attr = "dfd_trig_ctrl_3_odfd_flushmem_auto_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_odfd_flushmem_extrig_attr = "dfd_trig_ctrl_3_odfd_flushmem_extrig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_ctrl_3_use_windows_capture_attr = "dfd_trig_ctrl_3_use_windows_capture_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_0_clk_sel_attr = "dfd_0_clk_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_0_extrig_sel0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_0_extrig_sel1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_0_odfd_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_0_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_1_clk_sel_attr = "dfd_1_clk_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_1_extrig_sel0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_1_extrig_sel1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_1_odfd_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_1_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_2_clk_sel_attr = "dfd_2_clk_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_2_extrig_sel0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_2_extrig_sel1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_2_odfd_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_2_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_3_clk_sel_attr = "dfd_3_clk_aib_daisychain_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_3_extrig_sel0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_3_extrig_sel1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_3_odfd_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dfd_trig_mux_ctrl_3_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_ext_ctrl_attr = "dts_ctrl_ext_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_aclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_alert_thresh_attr = 155;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_biasenable_attr = "dts_ctrl_f_biasenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_biasratiosel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_burst_attr = "dts_ctrl_f_burst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_currratiosel_attr = "dts_ctrl_f_currratiosel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_dclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_remotesensor_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_remotesensor_valid_attr = "dts_ctrl_f_remotesensor_valid_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_rst_n_attr = "dts_ctrl_f_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_standalone_en_attr = "dts_ctrl_f_standalone_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ctrl_f_trip_thresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ld_calib_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ld_calib_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_ld_calib_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_1_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_1_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_1_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_2_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_2_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_2_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_3_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_3_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_3_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_4_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_4_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_4_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_5_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_5_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_5_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_6_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_6_f_caloffset_attr = 1906;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_rd_calib_6_f_calslope_attr = 2244;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_status_f_calconfigsel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__dts_status_f_calgamma_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_iaddr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_ichipsel_attr = "efuse_ctrl_ichipsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_ifavor_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_ipgmctl_attr = "efuse_ctrl_ipgmctl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_ipgmen_attr = "efuse_ctrl_ipgmen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_isense_attr = "efuse_ctrl_isense_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_ctrl_isenselv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__efuse_wr_data_wr_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__gdr_ctrl_dfd_bsync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__gdr_ctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__gdr_ctrl_dfd_dfd_clk_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__gdr_ctrl_dfd_dfd_rst_n_attr = "gdr_ctrl_dfd_dfd_rst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__gdr_ctrl_dfd_primary_attr = "gdr_ctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__gdr_ctrl_dfd_seondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__local_avmm_enable_attr = "local_avmm_disable_attr";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__memory_ctrl_f_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__memory_ctrl_f_pll_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__memory_ctrl_f_req = "memreq_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__memory_ctrl_f_wdata = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__memory_ctrl_f_wr = "memwr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_m_1p_rmce_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_m_1p_wmce_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_m_1p_wpulse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_m_2p_rmce_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_m_2p_wmce_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_m_2p_wpulse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_mce_attr = "mmem_mce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_ra_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__mmem_wa_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_cvp_enable_attr = "pcie_cvp_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_cvp_inprogress_attr = "pcie_cvp_inprogress_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_cvp_request_attr = "pcie_cvp_request_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_hrc_pin_perst_n_attr = "pcie_hrc_pin_perst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_hrc_pld_clrpll_n_attr = "pcie_hrc_pld_clrpll_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_hrc_pld_perst_n_attr = "pcie_hrc_pld_perst_n_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_perstn_debounced_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_pll_lock_pldclk_attr = "pcie_pll_lock_pldclk_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pcie_ssm_perst_overide_attr = "pcie_ssm_perst_overide_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c0_clkmute = "pll_0_c0_clkmute_unmute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c1_clkmute = "pll_0_c1_clkmute_unmute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c2_clkmute = "pll_0_c2_clkmute_unmute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_c3_clkmute = "pll_0_c3_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_max_pfd_hz = 400000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_max_ref_hz = 380000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_max_vco_hz = 33'h18C5EF280;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_min_pfd_hz = 20000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_min_ref_hz = 100000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_min_vco_hz = 32'hD09DC300;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_out_c3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref2_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref5_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref6_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref7_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_f_ref_gpio_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_fastref_enable = "pll_0_fastref_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_mod_counter = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_pll_sync = "pll_0_pll_sync_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_refclk_period_nsec = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_rst = "pll_0_reset";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_spare_attribute_0 = "pll_0_value0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_spare_attribute_1 = "pll_0_value4";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_0_sup_mode = "pll_0_advanced_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c0_clkmute = "pll_1_c0_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c1_clkmute = "pll_1_c1_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c2_clkmute = "pll_1_c2_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_c3_clkmute = "pll_1_c3_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_max_pfd_hz = 400000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_max_ref_hz = 380000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_max_vco_hz = 33'h18C5EF280;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_min_pfd_hz = 20000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_min_ref_hz = 100000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_min_vco_hz = 32'hD09DC300;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_out_c3_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref2_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref5_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref6_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref7_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_f_ref_gpio_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_fastref_enable = "pll_1_fastref_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_mod_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_pll_sync = "pll_1_pll_sync_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_refclk_period_nsec = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_rst = "pll_1_reset";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_spare_attribute_0 = "pll_1_value0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_spare_attribute_1 = "pll_1_value4";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_1_sup_mode = "pll_1_advanced_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c0_clkmute = "pll_2_c0_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c1_clkmute = "pll_2_c1_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c2_clkmute = "pll_2_c2_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_c3_clkmute = "pll_2_c3_clkmute_mute";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_max_pfd_hz = 400000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_max_ref_hz = 380000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_max_vco_hz = 33'h18C5EF280;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_min_pfd_hz = 20000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_min_ref_hz = 100000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_min_vco_hz = 32'hD09DC300;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_out_c3_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref2_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref5_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref6_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref7_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_f_ref_gpio_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_fastref_enable = "pll_2_fastref_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_mod_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_pll_sync = "pll_2_pll_sync_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_refclk_period_nsec = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_rst = "pll_2_reset";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_spare_attribute_0 = "pll_2_value0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_spare_attribute_1 = "pll_2_value4";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_2_sup_mode = "pll_2_advanced_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_calib_0_f_hscount_attr = 96;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_calib_0_f_mscount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_calib_1_f_hscount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_calib_1_f_mscount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_calib_2_f_hscount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_calib_2_f_mscount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_cal_clr_a_attr = "pll_ctrl_0_f_cal_clr_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_disconnect_a_attr = "pll_ctrl_0_f_disconnect_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_disconnect_keepalive_attr = "pll_ctrl_0_f_disconnect_keepalive_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_dref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_fastrefen_attr = "pll_ctrl_0_f_fastrefen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_freqgen_hop_dir_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_freqgen_hop_req_attr = "pll_ctrl_0_f_freqgen_hop_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_freqgen_ssc_req_attr = "pll_ctrl_0_f_freqgen_ssc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_keepalive_attr = "pll_ctrl_0_f_keepalive_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_mod_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_refclk_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_rst_n_attr = "pll_ctrl_0_f_rst_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_spare_attr = "pll_ctrl_0_f_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_0_f_sync_attr = "pll_ctrl_0_f_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_cal_clr_a_attr = "pll_ctrl_1_f_cal_clr_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_disconnect_a_attr = "pll_ctrl_1_f_disconnect_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_disconnect_keepalive_attr = "pll_ctrl_1_f_disconnect_keepalive_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_dref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_fastrefen_attr = "pll_ctrl_1_f_fastrefen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_freqgen_hop_dir_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_freqgen_hop_req_attr = "pll_ctrl_1_f_freqgen_hop_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_freqgen_ssc_req_attr = "pll_ctrl_1_f_freqgen_ssc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_keepalive_attr = "pll_ctrl_1_f_keepalive_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_mod_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_refclk_sel_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_rst_n_attr = "pll_ctrl_1_f_rst_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_spare_attr = "pll_ctrl_1_f_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_1_f_sync_attr = "pll_ctrl_1_f_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_cal_clr_a_attr = "pll_ctrl_2_f_cal_clr_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_disconnect_a_attr = "pll_ctrl_2_f_disconnect_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_disconnect_keepalive_attr = "pll_ctrl_2_f_disconnect_keepalive_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_dref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_fastrefen_attr = "pll_ctrl_2_f_fastrefen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_freqgen_hop_dir_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_freqgen_hop_req_attr = "pll_ctrl_2_f_freqgen_hop_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_freqgen_ssc_req_attr = "pll_ctrl_2_f_freqgen_ssc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_keepalive_attr = "pll_ctrl_2_f_keepalive_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_mod_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_refclk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_rst_n_attr = "pll_ctrl_2_f_rst_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_spare_attr = "pll_ctrl_2_f_spare_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ctrl_2_f_sync_attr = "pll_ctrl_2_f_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref2_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref5_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref6_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref7_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_f_ref_gpio_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_fdiv_ctrl_0_f_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_fdiv_ctrl_1_f_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_fdiv_ctrl_2_f_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mdiv_ctrl_0_f_ctrl_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mdiv_ctrl_1_f_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mdiv_ctrl_2_f_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mem_ctrl_f_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mem_ctrl_f_pll_num_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mem_ctrl_f_req_attr = "pll_mem_ctrl_f_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mem_ctrl_f_wdata_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_mem_ctrl_f_wr_attr = "pll_mem_ctrl_f_wr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_0_f_cntr_end_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_0_f_ref_cntr_rstb_attr = "pll_ref_clk_chk_0_f_ref_cntr_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_0_f_ref_cntr_start_attr = "pll_ref_clk_chk_0_f_ref_cntr_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_1_f_cntr_end_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_1_f_ref_cntr_rstb_attr = "pll_ref_clk_chk_1_f_ref_cntr_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_1_f_ref_cntr_start_attr = "pll_ref_clk_chk_1_f_ref_cntr_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_2_f_cntr_end_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_2_f_ref_cntr_rstb_attr = "pll_ref_clk_chk_2_f_ref_cntr_rstb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_ref_clk_chk_2_f_ref_cntr_start_attr = "pll_ref_clk_chk_2_f_ref_cntr_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_ctrl_0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_ctrl_1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_slice_bypass_en_0_attr = "pll_slice0_1_div_ctrl_0_f_slice_bypass_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_slice_bypass_en_1_attr = "pll_slice0_1_div_ctrl_0_f_slice_bypass_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_slice_ckmute_en_0_attr = "pll_slice0_1_div_ctrl_0_f_slice_ckmute_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_slice_ckmute_en_1_attr = "pll_slice0_1_div_ctrl_0_f_slice_ckmute_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_slice_en_0_attr = "pll_slice0_1_div_ctrl_0_f_slice_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_0_f_slice_en_1_attr = "pll_slice0_1_div_ctrl_0_f_slice_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_ctrl_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_ctrl_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_slice_bypass_en_0_attr = "pll_slice0_1_div_ctrl_1_f_slice_bypass_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_slice_bypass_en_1_attr = "pll_slice0_1_div_ctrl_1_f_slice_bypass_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_slice_ckmute_en_0_attr = "pll_slice0_1_div_ctrl_1_f_slice_ckmute_en_0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_slice_ckmute_en_1_attr = "pll_slice0_1_div_ctrl_1_f_slice_ckmute_en_1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_slice_en_0_attr = "pll_slice0_1_div_ctrl_1_f_slice_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_1_f_slice_en_1_attr = "pll_slice0_1_div_ctrl_1_f_slice_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_ctrl_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_ctrl_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_slice_bypass_en_0_attr = "pll_slice0_1_div_ctrl_2_f_slice_bypass_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_slice_bypass_en_1_attr = "pll_slice0_1_div_ctrl_2_f_slice_bypass_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_slice_ckmute_en_0_attr = "pll_slice0_1_div_ctrl_2_f_slice_ckmute_en_0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_slice_ckmute_en_1_attr = "pll_slice0_1_div_ctrl_2_f_slice_ckmute_en_1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_slice_en_0_attr = "pll_slice0_1_div_ctrl_2_f_slice_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice0_1_div_ctrl_2_f_slice_en_1_attr = "pll_slice0_1_div_ctrl_2_f_slice_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_ctrl_0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_slice_bypass_en_0_attr = "pll_slice2_3_div_ctrl_0_f_slice_bypass_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_slice_bypass_en_1_attr = "pll_slice2_3_div_ctrl_0_f_slice_bypass_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_slice_ckmute_en_0_attr = "pll_slice2_3_div_ctrl_0_f_slice_ckmute_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_slice_ckmute_en_1_attr = "pll_slice2_3_div_ctrl_0_f_slice_ckmute_en_1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_slice_en_0_attr = "pll_slice2_3_div_ctrl_0_f_slice_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_0_f_slice_en_1_attr = "pll_slice2_3_div_ctrl_0_f_slice_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_ctrl_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_slice_bypass_en_0_attr = "pll_slice2_3_div_ctrl_1_f_slice_bypass_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_slice_bypass_en_1_attr = "pll_slice2_3_div_ctrl_1_f_slice_bypass_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_slice_ckmute_en_0_attr = "pll_slice2_3_div_ctrl_1_f_slice_ckmute_en_0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_slice_ckmute_en_1_attr = "pll_slice2_3_div_ctrl_1_f_slice_ckmute_en_1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_slice_en_0_attr = "pll_slice2_3_div_ctrl_1_f_slice_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_1_f_slice_en_1_attr = "pll_slice2_3_div_ctrl_1_f_slice_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_ctrl_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_slice_bypass_en_0_attr = "pll_slice2_3_div_ctrl_2_f_slice_bypass_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_slice_bypass_en_1_attr = "pll_slice2_3_div_ctrl_2_f_slice_bypass_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_slice_ckmute_en_0_attr = "pll_slice2_3_div_ctrl_2_f_slice_ckmute_en_0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_slice_ckmute_en_1_attr = "pll_slice2_3_div_ctrl_2_f_slice_ckmute_en_1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_slice_en_0_attr = "pll_slice2_3_div_ctrl_2_f_slice_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__pll_slice2_3_div_ctrl_2_f_slice_en_1_attr = "pll_slice2_3_div_ctrl_2_f_slice_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_ac_dfd = "dfd_power_up";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_ac_misc = "misc_power_up";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_ac_pll0 = "pll0_power_up";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_ac_pll1 = "pll1_power_dn";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_ac_pll2 = "pll2_power_dn";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_avmm_clk_attr = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_cnoc_clk_attr = 250000000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_0_f_out_c0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_0_f_out_c1 = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_0_f_out_c2 = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_0_f_ref = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_0_f_vco = 32'hE8D4A510;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_1_f_out_c0 = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_1_f_out_c1 = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_1_f_out_c2 = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_1_f_ref = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_1_f_vco = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_2_f_out_c0 = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_2_f_out_c1 = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_2_f_out_c2 = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_2_f_ref = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__powermode_freq_hz_pll_2_f_vco = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_arb_read_pipe_attr = "primary_arb_read_pipe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_arb_waitreq_pipe_attr = "primary_arb_waitreq_pipe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_arb_write_pipe_attr = "primary_arb_write_pipe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_atb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_cfgavmm_to_ena_attr = "primary_cfgavmm_to_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_cfgavmm_to_rst_attr = "primary_cfgavmm_to_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_ext_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_filt_avmm_orphean_dis_attr = "primary_filt_avmm_orphean_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_global_avmm_user_access_en_attr = "primary_global_avmm_user_access_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_master_topologies_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__primary_reset_wcounter_attr = "primary_reset_wcounter_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__secondary_f_byte0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__secondary_f_byte1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__secondary_f_byte2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__secondary_f_byte3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_m_1p_rmce_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_m_1p_wmce_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_m_1p_wpulse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_mce_attr = "smmem_mce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_ra_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ssm_mmem_wa_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_actreden = "aibaux_actreden_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_asyn_rxen = "aibaux_asyn_rxen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_asyn_txen = "aibaux_asyn_txen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_cndn_cken = "aibaux_cndn_cken_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_cndn_rxen = "aibaux_cndn_rxen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_cnup_txen = "aibaux_cnup_txen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_dll_osc_cr_dftsel = "aibaux_dll_osc_cr_dftsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_dly_ovrd_cnocdn = "aibaux_dly_ovrd_cnocdn_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_dly_ovrd_cnocup = "aibaux_dly_ovrd_cnocup_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_dly_ovrden_cnocdn = "aibaux_dly_ovrden_cnocdn_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_dly_ovrden_cnocup = "aibaux_dly_ovrden_cnocup_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_iocsr_sel = "aibaux_iocsrsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_jtag_bypass = "aibaux_jtagbyp_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_ndrv = "aibaux_ndrv_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_atbmuxsel = "aibaux_osc_atbmuxsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_bypclken = "aibaux_osc_bypclken_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_dftcounter = "aibaux_osc_cr_dftcounter_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_ld_cntr = "aibaux_osc_cr_ld_cntr_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_pdb = "aibaux_osc_cr_pdb_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_spare = "aibaux_osc_cr_spare_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_trim = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_vccdreg_vsel = "aibaux_osc_cr_vccdreg_vsel_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_cr_vreg_rdy = "aibaux_osc_cr_vreg_rdy_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_monitoren = "aibaux_osc_monitoren_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_reserved = "aibaux_osc_reserved_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_osc_trim_overwrite = "aibaux_osc_ovrwrt_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_pdrv = "aibaux_pdrv_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_pred_rxen = "aibaux_pred_rxen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_pred_txen = "aibaux_pred_txen_setting1";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_spare0_bus0 = "aibaux_spare0_bus0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_spare0_bus1 = "aibaux_spare0_bus1_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_spare0_bus2 = "aibaux_spare0_bus2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_spare1_bus0 = "aibaux_spare1_bus0_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__aibaux_spare1_bus2 = "aibaux_spare1_bus2_setting0";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__op_mode = "aux_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__powermode_ac = "enable_pwr";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__u_aibaux__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ux0_ux1_ux0_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ux0_ux1_ux1_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ux2_ux3_ux2_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ctrl__ux2_ux3_ux3_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st0_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st1_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st2_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st3_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st4_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st5_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st6_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib1_tx_st7_adapt_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st0_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st1_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st2_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st3_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st4_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st5_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st6_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_rx_st7_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st0_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st1_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st2_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st3_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st4_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st5_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st6_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib2_tx_st7_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st0_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st1_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st2_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st3_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st4_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st5_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st6_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_rx_st7_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st0_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st1_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st2_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st3_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st4_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st5_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st6_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib3_tx_st7_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__aib_esys_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__block_enable = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_mac_mode = "e200g_100g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_mac_mode = "e200g_100g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_100g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_mac_mode = "e200g_150g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_mac_mode = "e200g_150g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_150g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_mac_mode = "e200g_200g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_200g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_mac_mode = "e200g_25g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_mac_mode = "e200g_25g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_mac_mode = "e200g_25g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_mac_mode = "e200g_25g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_mac_mode = "e200g_25g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_mac_mode = "e200g_25g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_mac_mode = "e200g_25g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_mac_mode = "e200g_25g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_25g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_mac_mode = "e200g_50g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_mac_mode = "e200g_50g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_mac_mode = "e200g_50g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_mac_mode = "e200g_50g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_50g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_duplex_mode = "e200g_stream0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_aib_if_fifo_mode = "e200g_stream0_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_excvr_if_fifo_mode = "e200g_stream0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_primary_use = "e200g_stream0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_rx_xcvr_width = "e200g_stream0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_sys_clk_src = "e200g_stream0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_aib_if_fifo_mode = "e200g_stream0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_excvr_if_fifo_mode = "e200g_stream0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_primary_use = "e200g_stream0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream0_tx_xcvr_width = "e200g_stream0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_duplex_mode = "e200g_stream1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_aib_if_fifo_mode = "e200g_stream1_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_excvr_if_fifo_mode = "e200g_stream1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_primary_use = "e200g_stream1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_rx_xcvr_width = "e200g_stream1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_sys_clk_src = "e200g_stream1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_aib_if_fifo_mode = "e200g_stream1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_excvr_if_fifo_mode = "e200g_stream1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_primary_use = "e200g_stream1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream1_tx_xcvr_width = "e200g_stream1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_duplex_mode = "e200g_stream2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_aib_if_fifo_mode = "e200g_stream2_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_excvr_if_fifo_mode = "e200g_stream2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_primary_use = "e200g_stream2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_rx_xcvr_width = "e200g_stream2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_sys_clk_src = "e200g_stream2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_aib_if_fifo_mode = "e200g_stream2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_excvr_if_fifo_mode = "e200g_stream2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_primary_use = "e200g_stream2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream2_tx_xcvr_width = "e200g_stream2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_duplex_mode = "e200g_stream3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_aib_if_fifo_mode = "e200g_stream3_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_excvr_if_fifo_mode = "e200g_stream3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_primary_use = "e200g_stream3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_rx_xcvr_width = "e200g_stream3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_sys_clk_src = "e200g_stream3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_aib_if_fifo_mode = "e200g_stream3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_excvr_if_fifo_mode = "e200g_stream3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_primary_use = "e200g_stream3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream3_tx_xcvr_width = "e200g_stream3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_duplex_mode = "e200g_stream4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_aib_if_fifo_mode = "e200g_stream4_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_excvr_if_fifo_mode = "e200g_stream4_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_primary_use = "e200g_stream4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_rx_xcvr_width = "e200g_stream4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_sys_clk_src = "e200g_stream4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_aib_if_fifo_mode = "e200g_stream4_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_excvr_if_fifo_mode = "e200g_stream4_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_primary_use = "e200g_stream4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream4_tx_xcvr_width = "e200g_stream4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_duplex_mode = "e200g_stream5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_aib_if_fifo_mode = "e200g_stream5_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_excvr_if_fifo_mode = "e200g_stream5_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_primary_use = "e200g_stream5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_rx_xcvr_width = "e200g_stream5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_sys_clk_src = "e200g_stream5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_aib_if_fifo_mode = "e200g_stream5_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_excvr_if_fifo_mode = "e200g_stream5_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_primary_use = "e200g_stream5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream5_tx_xcvr_width = "e200g_stream5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_duplex_mode = "e200g_stream6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_aib_if_fifo_mode = "e200g_stream6_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_excvr_if_fifo_mode = "e200g_stream6_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_primary_use = "e200g_stream6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_rx_xcvr_width = "e200g_stream6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_sys_clk_src = "e200g_stream6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_aib_if_fifo_mode = "e200g_stream6_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_excvr_if_fifo_mode = "e200g_stream6_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_primary_use = "e200g_stream6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream6_tx_xcvr_width = "e200g_stream6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_duplex_mode = "e200g_stream7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_aib_if_fifo_mode = "e200g_stream7_rx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_excvr_if_fifo_mode = "e200g_stream7_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_primary_use = "e200g_stream7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_rx_xcvr_width = "e200g_stream7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_sys_clk_src = "e200g_stream7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_aib_if_fifo_mode = "e200g_stream7_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_excvr_if_fifo_mode = "e200g_stream7_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_primary_use = "e200g_stream7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_stream7_tx_xcvr_width = "e200g_stream7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_rx_master_bond_chnl = "e200g_ux0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_tx_master_bond_chnl = "e200g_ux0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux0_txrx_channel_operation = "e200g_ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_rx_master_bond_chnl = "e200g_ux1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_tx_master_bond_chnl = "e200g_ux1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux1_txrx_channel_operation = "e200g_ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_rx_master_bond_chnl = "e200g_ux2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_tx_master_bond_chnl = "e200g_ux2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux2_txrx_channel_operation = "e200g_ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_rx_master_bond_chnl = "e200g_ux3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_tx_master_bond_chnl = "e200g_ux3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux3_txrx_channel_operation = "e200g_ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_rx_master_bond_chnl = "e200g_ux4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_tx_master_bond_chnl = "e200g_ux4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux4_txrx_channel_operation = "e200g_ux4_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_rx_master_bond_chnl = "e200g_ux5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_tx_master_bond_chnl = "e200g_ux5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux5_txrx_channel_operation = "e200g_ux5_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_rx_master_bond_chnl = "e200g_ux6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_tx_master_bond_chnl = "e200g_ux6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux6_txrx_channel_operation = "e200g_ux6_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_rx_master_bond_chnl = "e200g_ux7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_tx_master_bond_chnl = "e200g_ux7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_ux7_txrx_channel_operation = "e200g_ux7_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_25e2x7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__e200g_xcvr_speed_map_56e2x3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_aibif_data_valid = "e200g_100g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_duplex_mode = "e200g_100g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_fec_mode = "e200g_100g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_lpbk_mode = "e200g_100g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_pcs_ber_mon_mode = "e200g_100g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_fec_enable = "e200g_100g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_pcs_mode = "e200g_100g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_primary_use = "e200g_100g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_system_bonding = "e200g_100g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_sup_mode = "e200g_100g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_sys_clk_src = "e200g_100g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_aib_if_fifo_mode = "e200g_100g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_fec_enable = "e200g_100g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_pcs_mode = "e200g_100g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_primary_use = "e200g_100g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_system_bonding = "e200g_100g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_aibif_data_valid = "e200g_100g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_duplex_mode = "e200g_100g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_fec_mode = "e200g_100g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_lpbk_mode = "e200g_100g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_pcs_ber_mon_mode = "e200g_100g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_fec_enable = "e200g_100g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_pcs_mode = "e200g_100g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_primary_use = "e200g_100g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_system_bonding = "e200g_100g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_sup_mode = "e200g_100g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_sys_clk_src = "e200g_100g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_aib_if_fifo_mode = "e200g_100g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_fec_enable = "e200g_100g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_pcs_mode = "e200g_100g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_primary_use = "e200g_100g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_system_bonding = "e200g_100g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_100g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_aibif_data_valid = "e200g_150g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_duplex_mode = "e200g_150g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_fec_mode = "e200g_150g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_lpbk_mode = "e200g_150g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_pcs_ber_mon_mode = "e200g_150g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_fec_enable = "e200g_150g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_pcs_mode = "e200g_150g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_primary_use = "e200g_150g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_system_bonding = "e200g_150g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_sup_mode = "e200g_150g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_sys_clk_src = "e200g_150g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_aib_if_fifo_mode = "e200g_150g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_fec_enable = "e200g_150g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_pcs_mode = "e200g_150g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_primary_use = "e200g_150g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_system_bonding = "e200g_150g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_aibif_data_valid = "e200g_150g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_duplex_mode = "e200g_150g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_fec_mode = "e200g_150g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_lpbk_mode = "e200g_150g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_pcs_ber_mon_mode = "e200g_150g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_fec_enable = "e200g_150g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_pcs_mode = "e200g_150g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_primary_use = "e200g_150g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_system_bonding = "e200g_150g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_sup_mode = "e200g_150g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_sys_clk_src = "e200g_150g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_aib_if_fifo_mode = "e200g_150g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_fec_enable = "e200g_150g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_pcs_mode = "e200g_150g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_primary_use = "e200g_150g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_system_bonding = "e200g_150g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_150g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_aibif_data_valid = "e200g_200g_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_duplex_mode = "e200g_200g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_fec_mode = "e200g_200g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_lpbk_mode = "e200g_200g_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_pcs_ber_mon_mode = "e200g_200g_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_fec_enable = "e200g_200g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_pcs_mode = "e200g_200g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_primary_use = "e200g_200g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_system_bonding = "e200g_200g_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_sup_mode = "e200g_200g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_sys_clk_src = "e200g_200g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_aib_if_fifo_mode = "e200g_200g_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_fec_enable = "e200g_200g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_pcs_mode = "e200g_200g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_primary_use = "e200g_200g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_system_bonding = "e200g_200g_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_200g_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_aibif_data_valid = "e200g_25g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_duplex_mode = "e200g_25g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_fec_mode = "e200g_25g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_fec_spec = "e200g_25g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_lpbk_mode = "e200g_25g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_pcs_ber_mon_mode = "e200g_25g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_fec_enable = "e200g_25g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_pcs_mode = "e200g_25g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_primary_use = "e200g_25g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_system_bonding = "e200g_25g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_sup_mode = "e200g_25g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_sys_clk_src = "e200g_25g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_aib_if_fifo_mode = "e200g_25g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_fec_enable = "e200g_25g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_pcs_mode = "e200g_25g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_primary_use = "e200g_25g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_system_bonding = "e200g_25g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_aibif_data_valid = "e200g_25g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_duplex_mode = "e200g_25g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_fec_mode = "e200g_25g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_fec_spec = "e200g_25g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_lpbk_mode = "e200g_25g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_pcs_ber_mon_mode = "e200g_25g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_fec_enable = "e200g_25g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_pcs_mode = "e200g_25g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_primary_use = "e200g_25g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_system_bonding = "e200g_25g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_sup_mode = "e200g_25g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_sys_clk_src = "e200g_25g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_aib_if_fifo_mode = "e200g_25g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_fec_enable = "e200g_25g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_pcs_mode = "e200g_25g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_primary_use = "e200g_25g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_system_bonding = "e200g_25g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_aibif_data_valid = "e200g_25g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_duplex_mode = "e200g_25g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_fec_mode = "e200g_25g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_fec_spec = "e200g_25g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_lpbk_mode = "e200g_25g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_pcs_ber_mon_mode = "e200g_25g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_fec_enable = "e200g_25g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_pcs_mode = "e200g_25g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_primary_use = "e200g_25g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_system_bonding = "e200g_25g_2_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_sup_mode = "e200g_25g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_sys_clk_src = "e200g_25g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_aib_if_fifo_mode = "e200g_25g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_fec_enable = "e200g_25g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_pcs_mode = "e200g_25g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_primary_use = "e200g_25g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_system_bonding = "e200g_25g_2_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_aibif_data_valid = "e200g_25g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_duplex_mode = "e200g_25g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_fec_mode = "e200g_25g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_fec_spec = "e200g_25g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_lpbk_mode = "e200g_25g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_pcs_ber_mon_mode = "e200g_25g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_fec_enable = "e200g_25g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_pcs_mode = "e200g_25g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_primary_use = "e200g_25g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_system_bonding = "e200g_25g_3_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_sup_mode = "e200g_25g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_sys_clk_src = "e200g_25g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_aib_if_fifo_mode = "e200g_25g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_fec_enable = "e200g_25g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_pcs_mode = "e200g_25g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_primary_use = "e200g_25g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_system_bonding = "e200g_25g_3_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_aibif_data_valid = "e200g_25g_4_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_duplex_mode = "e200g_25g_4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_fec_mode = "e200g_25g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_fec_spec = "e200g_25g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_lpbk_mode = "e200g_25g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_pcs_ber_mon_mode = "e200g_25g_4_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_fec_enable = "e200g_25g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_pcs_mode = "e200g_25g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_primary_use = "e200g_25g_4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_system_bonding = "e200g_25g_4_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_sup_mode = "e200g_25g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_sys_clk_src = "e200g_25g_4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_aib_if_fifo_mode = "e200g_25g_4_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_fec_enable = "e200g_25g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_pcs_mode = "e200g_25g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_primary_use = "e200g_25g_4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_system_bonding = "e200g_25g_4_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_4_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_aibif_data_valid = "e200g_25g_5_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_duplex_mode = "e200g_25g_5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_fec_mode = "e200g_25g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_fec_spec = "e200g_25g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_lpbk_mode = "e200g_25g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_pcs_ber_mon_mode = "e200g_25g_5_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_fec_enable = "e200g_25g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_pcs_mode = "e200g_25g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_primary_use = "e200g_25g_5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_system_bonding = "e200g_25g_5_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_sup_mode = "e200g_25g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_sys_clk_src = "e200g_25g_5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_aib_if_fifo_mode = "e200g_25g_5_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_fec_enable = "e200g_25g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_pcs_mode = "e200g_25g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_primary_use = "e200g_25g_5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_system_bonding = "e200g_25g_5_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_5_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_aibif_data_valid = "e200g_25g_6_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_duplex_mode = "e200g_25g_6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_fec_mode = "e200g_25g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_fec_spec = "e200g_25g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_lpbk_mode = "e200g_25g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_pcs_ber_mon_mode = "e200g_25g_6_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_fec_enable = "e200g_25g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_pcs_mode = "e200g_25g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_primary_use = "e200g_25g_6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_system_bonding = "e200g_25g_6_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_sup_mode = "e200g_25g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_sys_clk_src = "e200g_25g_6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_aib_if_fifo_mode = "e200g_25g_6_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_fec_enable = "e200g_25g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_pcs_mode = "e200g_25g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_primary_use = "e200g_25g_6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_system_bonding = "e200g_25g_6_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_6_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_aibif_data_valid = "e200g_25g_7_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_duplex_mode = "e200g_25g_7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_fec_mode = "e200g_25g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_fec_spec = "e200g_25g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_lpbk_mode = "e200g_25g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_pcs_ber_mon_mode = "e200g_25g_7_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_fec_enable = "e200g_25g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_pcs_mode = "e200g_25g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_primary_use = "e200g_25g_7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_system_bonding = "e200g_25g_7_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_sup_mode = "e200g_25g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_sys_clk_src = "e200g_25g_7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_aib_if_fifo_mode = "e200g_25g_7_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_fec_enable = "e200g_25g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_pcs_mode = "e200g_25g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_primary_use = "e200g_25g_7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_system_bonding = "e200g_25g_7_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_25g_7_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_aibif_data_valid = "e200g_50g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_duplex_mode = "e200g_50g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_fec_mode = "e200g_50g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_lpbk_mode = "e200g_50g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_pcs_ber_mon_mode = "e200g_50g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_fec_enable = "e200g_50g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_pcs_mode = "e200g_50g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_primary_use = "e200g_50g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_system_bonding = "e200g_50g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_sup_mode = "e200g_50g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_sys_clk_src = "e200g_50g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_aib_if_fifo_mode = "e200g_50g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_fec_enable = "e200g_50g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_pcs_mode = "e200g_50g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_primary_use = "e200g_50g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_system_bonding = "e200g_50g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_aibif_data_valid = "e200g_50g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_duplex_mode = "e200g_50g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_fec_mode = "e200g_50g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_lpbk_mode = "e200g_50g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_pcs_ber_mon_mode = "e200g_50g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_fec_enable = "e200g_50g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_pcs_mode = "e200g_50g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_primary_use = "e200g_50g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_system_bonding = "e200g_50g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_sup_mode = "e200g_50g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_sys_clk_src = "e200g_50g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_aib_if_fifo_mode = "e200g_50g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_fec_enable = "e200g_50g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_pcs_mode = "e200g_50g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_primary_use = "e200g_50g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_system_bonding = "e200g_50g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_aibif_data_valid = "e200g_50g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_duplex_mode = "e200g_50g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_fec_mode = "e200g_50g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_lpbk_mode = "e200g_50g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_pcs_ber_mon_mode = "e200g_50g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_fec_enable = "e200g_50g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_pcs_mode = "e200g_50g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_primary_use = "e200g_50g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_system_bonding = "e200g_50g_2_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_sup_mode = "e200g_50g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_sys_clk_src = "e200g_50g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_aib_if_fifo_mode = "e200g_50g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_fec_enable = "e200g_50g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_pcs_mode = "e200g_50g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_primary_use = "e200g_50g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_system_bonding = "e200g_50g_2_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_aibif_data_valid = "e200g_50g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_duplex_mode = "e200g_50g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_fec_mode = "e200g_50g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_lpbk_mode = "e200g_50g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_pcs_ber_mon_mode = "e200g_50g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_fec_enable = "e200g_50g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_pcs_mode = "e200g_50g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_primary_use = "e200g_50g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_system_bonding = "e200g_50g_3_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_sup_mode = "e200g_50g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_sys_clk_src = "e200g_50g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_aib_if_fifo_mode = "e200g_50g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_fec_enable = "e200g_50g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_pcs_mode = "e200g_50g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_primary_use = "e200g_50g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_system_bonding = "e200g_50g_3_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_50g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_rx_primary_use = "e200g_stream0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_tx_aib_if_fifo_mode = "e200g_stream0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream0_tx_primary_use = "e200g_stream0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_rx_primary_use = "e200g_stream1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_tx_aib_if_fifo_mode = "e200g_stream1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream1_tx_primary_use = "e200g_stream1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_rx_primary_use = "e200g_stream2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_tx_aib_if_fifo_mode = "e200g_stream2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream2_tx_primary_use = "e200g_stream2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_rx_primary_use = "e200g_stream3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_tx_aib_if_fifo_mode = "e200g_stream3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream3_tx_primary_use = "e200g_stream3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_rx_primary_use = "e200g_stream4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_tx_aib_if_fifo_mode = "e200g_stream4_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream4_tx_primary_use = "e200g_stream4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_rx_primary_use = "e200g_stream5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_tx_aib_if_fifo_mode = "e200g_stream5_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream5_tx_primary_use = "e200g_stream5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_rx_primary_use = "e200g_stream6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_tx_aib_if_fifo_mode = "e200g_stream6_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream6_tx_primary_use = "e200g_stream6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_rx_primary_use = "e200g_stream7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_tx_aib_if_fifo_mode = "e200g_stream7_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__e200g_stream7_tx_primary_use = "e200g_stream7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_0_rx_aibif = "e200g_100g_0_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_0_rx_pcs = "e200g_100g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_0_tx_aibif = "e200g_100g_0_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_0_tx_pcs = "e200g_100g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_1_rx_aibif = "e200g_100g_1_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_1_rx_pcs = "e200g_100g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_1_tx_aibif = "e200g_100g_1_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_100g_1_tx_pcs = "e200g_100g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_200g_rx_aibif = "e200g_200g_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_200g_rx_pcs = "e200g_200g_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_200g_tx_aibif = "e200g_200g_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_200g_tx_pcs = "e200g_200g_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_0_rx_aibif = "e200g_25g_0_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_0_rx_pcs = "e200g_25g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_0_tx_aibif = "e200g_25g_0_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_0_tx_pcs = "e200g_25g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_1_rx_aibif = "e200g_25g_1_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_1_rx_pcs = "e200g_25g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_1_tx_aibif = "e200g_25g_1_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_1_tx_pcs = "e200g_25g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_2_rx_aibif = "e200g_25g_2_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_2_rx_pcs = "e200g_25g_2_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_2_tx_aibif = "e200g_25g_2_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_2_tx_pcs = "e200g_25g_2_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_3_rx_aibif = "e200g_25g_3_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_3_rx_pcs = "e200g_25g_3_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_3_tx_aibif = "e200g_25g_3_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_3_tx_pcs = "e200g_25g_3_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_4_rx_aibif = "e200g_25g_4_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_4_rx_pcs = "e200g_25g_4_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_4_tx_aibif = "e200g_25g_4_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_4_tx_pcs = "e200g_25g_4_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_5_rx_aibif = "e200g_25g_5_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_5_rx_pcs = "e200g_25g_5_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_5_tx_aibif = "e200g_25g_5_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_5_tx_pcs = "e200g_25g_5_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_6_rx_aibif = "e200g_25g_6_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_6_rx_pcs = "e200g_25g_6_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_6_tx_aibif = "e200g_25g_6_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_6_tx_pcs = "e200g_25g_6_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_7_rx_aibif = "e200g_25g_7_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_7_rx_pcs = "e200g_25g_7_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_7_tx_aibif = "e200g_25g_7_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_25g_7_tx_pcs = "e200g_25g_7_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_0_rx_aibif = "e200g_50g_0_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_0_rx_pcs = "e200g_50g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_0_tx_aibif = "e200g_50g_0_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_0_tx_pcs = "e200g_50g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_1_rx_aibif = "e200g_50g_1_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_1_rx_pcs = "e200g_50g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_1_tx_aibif = "e200g_50g_1_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_1_tx_pcs = "e200g_50g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_2_rx_aibif = "e200g_50g_2_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_2_rx_pcs = "e200g_50g_2_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_2_tx_aibif = "e200g_50g_2_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_2_tx_pcs = "e200g_50g_2_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_3_rx_aibif = "e200g_50g_3_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_3_rx_pcs = "e200g_50g_3_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_3_tx_aibif = "e200g_50g_3_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_e200g_50g_3_tx_pcs = "e200g_50g_3_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_ehip_cfg = "ehip_cfg_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_ac_ehip_misc = "ehip_misc_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_cfg_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch0_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch1_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch2_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch3_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch4_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch5_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch6_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__powermode_freq_hz_ehip_ch7_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__ehip_rate = "rate_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_100g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__ehip_rate = "rate_200g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_200g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch0_50g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch1_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch2_50g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch3_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__ehip_rate = "rate_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_100g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch4_50g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch5_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch6_50g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__phcomp_rd_del = "phcomp_rd_del1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__gdr_e2hip_top__u_gdr_e2hip_config_ch7_25g__gdr_e2hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk0_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk1_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk2_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk3_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk4_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk5_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk6_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__rx_transfer_clk7_adapt_rc_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sys_pll0_div1_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sys_pll0_div2_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sys_pll1_div1_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sys_pll1_div2_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sys_pll2_div1_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__sys_pll2_div2_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk0_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk1_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk2_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk3_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk4_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk5_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk6_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__transfer_clk7_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st0_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st1_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st2_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st3_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st4_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st5_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st6_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib1_tx_st7_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st4_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st5_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st6_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_rx_st7_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st4_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st5_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st6_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib2_tx_st7_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st4_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st5_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st6_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_rx_st7_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st4_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st5_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st6_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib3_tx_st7_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__aib_esys_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__block_enable = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_rx7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__bond_tx7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_aib2_rx_st_clk_en = "e200g_100g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_aib2_tx_st_clk_en = "e200g_100g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_aib3_rx_st_clk_en = "e200g_100g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_aib3_tx_st_clk_en = "e200g_100g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_duplex_mode = "e200g_100g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_fec_clk_src = "e200g_100g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_fec_error = "e200g_100g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_fec_mode = "e200g_100g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_fec_spec = "e200g_100g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_lpbk_mode = "e200g_100g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_mac_mode = "e200g_100g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_ptp_mode = "e200g_100g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_excvr_gb_ratio_mode = "e200g_100g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_excvr_if_fifo_mode = "e200g_100g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_fec_enable = "e200g_100g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_pcs_mode = "e200g_100g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_primary_use = "e200g_100g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_stream_bonding = "e200g_100g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_xcvr_bonded = "e200g_100g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_rx_xcvr_width = "e200g_100g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_speed_map = "e200g_100g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_sup_mode = "e200g_100g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_sys_clk_src = "e200g_100g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_excvr_gb_ratio_mode = "e200g_100g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_excvr_if_fifo_mode = "e200g_100g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_fec_enable = "e200g_100g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_pcs_mode = "e200g_100g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_primary_use = "e200g_100g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_stream_bonding = "e200g_100g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_xcvr_bonded = "e200g_100g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_tx_xcvr_width = "e200g_100g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_xcvr_type = "e200g_100g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_aib2_rx_st_clk_en = "e200g_100g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_aib2_tx_st_clk_en = "e200g_100g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_aib3_rx_st_clk_en = "e200g_100g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_aib3_tx_st_clk_en = "e200g_100g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_duplex_mode = "e200g_100g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_fec_clk_src = "e200g_100g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_fec_error = "e200g_100g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_fec_mode = "e200g_100g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_fec_spec = "e200g_100g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_lpbk_mode = "e200g_100g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_mac_mode = "e200g_100g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_ptp_mode = "e200g_100g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_excvr_gb_ratio_mode = "e200g_100g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_excvr_if_fifo_mode = "e200g_100g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_fec_enable = "e200g_100g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_pcs_mode = "e200g_100g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_primary_use = "e200g_100g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_stream_bonding = "e200g_100g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_xcvr_bonded = "e200g_100g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_rx_xcvr_width = "e200g_100g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_speed_map = "e200g_100g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_sup_mode = "e200g_100g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_sys_clk_src = "e200g_100g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_excvr_gb_ratio_mode = "e200g_100g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_excvr_if_fifo_mode = "e200g_100g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_fec_enable = "e200g_100g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_pcs_mode = "e200g_100g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_primary_use = "e200g_100g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_stream_bonding = "e200g_100g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_xcvr_bonded = "e200g_100g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_tx_xcvr_width = "e200g_100g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_xcvr_type = "e200g_100g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_100g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_aib2_rx_st_clk_en = "e200g_150g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_aib2_tx_st_clk_en = "e200g_150g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_aib3_rx_st_clk_en = "e200g_150g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_aib3_tx_st_clk_en = "e200g_150g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_duplex_mode = "e200g_150g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_fec_mode = "e200g_150g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_fec_spec = "e200g_150g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_lpbk_mode = "e200g_150g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_mac_mode = "e200g_150g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_ptp_mode = "e200g_150g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_excvr_gb_ratio_mode = "e200g_150g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_excvr_if_fifo_mode = "e200g_150g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_fec_enable = "e200g_150g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_pcs_mode = "e200g_150g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_primary_use = "e200g_150g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_stream_bonding = "e200g_150g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_xcvr_bonded = "e200g_150g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_rx_xcvr_width = "e200g_150g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_speed_map = "e200g_150g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_sup_mode = "e200g_150g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_sys_clk_src = "e200g_150g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_excvr_gb_ratio_mode = "e200g_150g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_excvr_if_fifo_mode = "e200g_150g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_fec_enable = "e200g_150g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_pcs_mode = "e200g_150g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_primary_use = "e200g_150g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_stream_bonding = "e200g_150g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_xcvr_bonded = "e200g_150g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_tx_xcvr_width = "e200g_150g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_xcvr_type = "e200g_150g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_aib2_rx_st_clk_en = "e200g_150g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_aib2_tx_st_clk_en = "e200g_150g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_aib3_rx_st_clk_en = "e200g_150g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_aib3_tx_st_clk_en = "e200g_150g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_duplex_mode = "e200g_150g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_fec_mode = "e200g_150g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_fec_spec = "e200g_150g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_lpbk_mode = "e200g_150g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_mac_mode = "e200g_150g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_ptp_mode = "e200g_150g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_excvr_gb_ratio_mode = "e200g_150g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_excvr_if_fifo_mode = "e200g_150g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_fec_enable = "e200g_150g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_pcs_mode = "e200g_150g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_primary_use = "e200g_150g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_stream_bonding = "e200g_150g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_xcvr_bonded = "e200g_150g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_rx_xcvr_width = "e200g_150g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_speed_map = "e200g_150g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_sup_mode = "e200g_150g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_sys_clk_src = "e200g_150g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_excvr_gb_ratio_mode = "e200g_150g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_excvr_if_fifo_mode = "e200g_150g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_fec_enable = "e200g_150g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_pcs_mode = "e200g_150g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_primary_use = "e200g_150g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_stream_bonding = "e200g_150g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_xcvr_bonded = "e200g_150g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_tx_xcvr_width = "e200g_150g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_xcvr_type = "e200g_150g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_150g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_aib2_rx_st_clk_en = "e200g_200g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_aib2_tx_st_clk_en = "e200g_200g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_aib3_rx_st_clk_en = "e200g_200g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_aib3_tx_st_clk_en = "e200g_200g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_duplex_mode = "e200g_200g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_fec_clk_src = "e200g_200g_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_fec_error = "e200g_200g_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_fec_mode = "e200g_200g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_fec_spec = "e200g_200g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_lpbk_mode = "e200g_200g_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_mac_mode = "e200g_200g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_ptp_mode = "e200g_200g_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_excvr_gb_ratio_mode = "e200g_200g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_excvr_if_fifo_mode = "e200g_200g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_fec_enable = "e200g_200g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_pcs_mode = "e200g_200g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_primary_use = "e200g_200g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_stream_bonding = "e200g_200g_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_xcvr_bonded = "e200g_200g_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_rx_xcvr_width = "e200g_200g_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_speed_map = "e200g_200g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_sup_mode = "e200g_200g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_sys_clk_src = "e200g_200g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_excvr_gb_ratio_mode = "e200g_200g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_excvr_if_fifo_mode = "e200g_200g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_fec_enable = "e200g_200g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_pcs_mode = "e200g_200g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_primary_use = "e200g_200g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_stream_bonding = "e200g_200g_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_xcvr_bonded = "e200g_200g_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_tx_xcvr_width = "e200g_200g_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_xcvr_type = "e200g_200g_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_200g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_aib2_rx_st_clk_en = "e200g_25g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_aib2_tx_st_clk_en = "e200g_25g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_aib3_rx_st_clk_en = "e200g_25g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_aib3_tx_st_clk_en = "e200g_25g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_duplex_mode = "e200g_25g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_fec_clk_src = "e200g_25g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_fec_error = "e200g_25g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_fec_mode = "e200g_25g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_fec_spec = "e200g_25g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_lpbk_mode = "e200g_25g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_mac_mode = "e200g_25g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_ptp_mode = "e200g_25g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_excvr_gb_ratio_mode = "e200g_25g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_excvr_if_fifo_mode = "e200g_25g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_fec_enable = "e200g_25g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_pcs_mode = "e200g_25g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_primary_use = "e200g_25g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_stream_bonding = "e200g_25g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_xcvr_bonded = "e200g_25g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_rx_xcvr_width = "e200g_25g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_speed_map = "e200g_25g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_sup_mode = "e200g_25g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_sys_clk_src = "e200g_25g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_excvr_gb_ratio_mode = "e200g_25g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_excvr_if_fifo_mode = "e200g_25g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_fec_enable = "e200g_25g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_pcs_mode = "e200g_25g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_primary_use = "e200g_25g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_stream_bonding = "e200g_25g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_xcvr_bonded = "e200g_25g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_tx_xcvr_width = "e200g_25g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_xcvr_type = "e200g_25g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_aib2_rx_st_clk_en = "e200g_25g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_aib2_tx_st_clk_en = "e200g_25g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_aib3_rx_st_clk_en = "e200g_25g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_aib3_tx_st_clk_en = "e200g_25g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_duplex_mode = "e200g_25g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_fec_clk_src = "e200g_25g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_fec_error = "e200g_25g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_fec_mode = "e200g_25g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_fec_spec = "e200g_25g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_lpbk_mode = "e200g_25g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_mac_mode = "e200g_25g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_ptp_mode = "e200g_25g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_excvr_gb_ratio_mode = "e200g_25g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_excvr_if_fifo_mode = "e200g_25g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_fec_enable = "e200g_25g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_pcs_mode = "e200g_25g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_primary_use = "e200g_25g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_stream_bonding = "e200g_25g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_xcvr_bonded = "e200g_25g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_rx_xcvr_width = "e200g_25g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_speed_map = "e200g_25g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_sup_mode = "e200g_25g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_sys_clk_src = "e200g_25g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_excvr_gb_ratio_mode = "e200g_25g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_excvr_if_fifo_mode = "e200g_25g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_fec_enable = "e200g_25g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_pcs_mode = "e200g_25g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_primary_use = "e200g_25g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_stream_bonding = "e200g_25g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_xcvr_bonded = "e200g_25g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_tx_xcvr_width = "e200g_25g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_xcvr_type = "e200g_25g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_aib2_rx_st_clk_en = "e200g_25g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_aib2_tx_st_clk_en = "e200g_25g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_aib3_rx_st_clk_en = "e200g_25g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_aib3_tx_st_clk_en = "e200g_25g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_duplex_mode = "e200g_25g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_fec_clk_src = "e200g_25g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_fec_error = "e200g_25g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_fec_mode = "e200g_25g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_fec_spec = "e200g_25g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_lpbk_mode = "e200g_25g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_mac_mode = "e200g_25g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_ptp_mode = "e200g_25g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_excvr_gb_ratio_mode = "e200g_25g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_excvr_if_fifo_mode = "e200g_25g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_fec_enable = "e200g_25g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_pcs_mode = "e200g_25g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_primary_use = "e200g_25g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_stream_bonding = "e200g_25g_2_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_xcvr_bonded = "e200g_25g_2_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_rx_xcvr_width = "e200g_25g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_speed_map = "e200g_25g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_sup_mode = "e200g_25g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_sys_clk_src = "e200g_25g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_excvr_gb_ratio_mode = "e200g_25g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_excvr_if_fifo_mode = "e200g_25g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_fec_enable = "e200g_25g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_pcs_mode = "e200g_25g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_primary_use = "e200g_25g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_stream_bonding = "e200g_25g_2_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_xcvr_bonded = "e200g_25g_2_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_tx_xcvr_width = "e200g_25g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_xcvr_type = "e200g_25g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_2_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_aib2_rx_st_clk_en = "e200g_25g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_aib2_tx_st_clk_en = "e200g_25g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_aib3_rx_st_clk_en = "e200g_25g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_aib3_tx_st_clk_en = "e200g_25g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_duplex_mode = "e200g_25g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_fec_clk_src = "e200g_25g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_fec_error = "e200g_25g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_fec_mode = "e200g_25g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_fec_spec = "e200g_25g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_lpbk_mode = "e200g_25g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_mac_mode = "e200g_25g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_ptp_mode = "e200g_25g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_excvr_gb_ratio_mode = "e200g_25g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_excvr_if_fifo_mode = "e200g_25g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_fec_enable = "e200g_25g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_pcs_mode = "e200g_25g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_primary_use = "e200g_25g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_stream_bonding = "e200g_25g_3_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_xcvr_bonded = "e200g_25g_3_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_rx_xcvr_width = "e200g_25g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_speed_map = "e200g_25g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_sup_mode = "e200g_25g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_sys_clk_src = "e200g_25g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_excvr_gb_ratio_mode = "e200g_25g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_excvr_if_fifo_mode = "e200g_25g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_fec_enable = "e200g_25g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_pcs_mode = "e200g_25g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_primary_use = "e200g_25g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_stream_bonding = "e200g_25g_3_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_xcvr_bonded = "e200g_25g_3_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_tx_xcvr_width = "e200g_25g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_xcvr_type = "e200g_25g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_3_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_aib2_rx_st_clk_en = "e200g_25g_4_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_aib2_tx_st_clk_en = "e200g_25g_4_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_aib3_rx_st_clk_en = "e200g_25g_4_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_aib3_tx_st_clk_en = "e200g_25g_4_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_duplex_mode = "e200g_25g_4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_fec_clk_src = "e200g_25g_4_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_fec_error = "e200g_25g_4_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_fec_mode = "e200g_25g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_fec_spec = "e200g_25g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_lpbk_mode = "e200g_25g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_mac_mode = "e200g_25g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_ptp_mode = "e200g_25g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_excvr_gb_ratio_mode = "e200g_25g_4_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_excvr_if_fifo_mode = "e200g_25g_4_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_fec_enable = "e200g_25g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_pcs_mode = "e200g_25g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_primary_use = "e200g_25g_4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_stream_bonding = "e200g_25g_4_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_xcvr_bonded = "e200g_25g_4_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_rx_xcvr_width = "e200g_25g_4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_speed_map = "e200g_25g_4_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_sup_mode = "e200g_25g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_sys_clk_src = "e200g_25g_4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_excvr_gb_ratio_mode = "e200g_25g_4_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_excvr_if_fifo_mode = "e200g_25g_4_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_fec_enable = "e200g_25g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_pcs_mode = "e200g_25g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_primary_use = "e200g_25g_4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_stream_bonding = "e200g_25g_4_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_xcvr_bonded = "e200g_25g_4_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_tx_xcvr_width = "e200g_25g_4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_xcvr_type = "e200g_25g_4_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_4_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_aib2_rx_st_clk_en = "e200g_25g_5_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_aib2_tx_st_clk_en = "e200g_25g_5_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_aib3_rx_st_clk_en = "e200g_25g_5_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_aib3_tx_st_clk_en = "e200g_25g_5_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_duplex_mode = "e200g_25g_5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_fec_clk_src = "e200g_25g_5_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_fec_error = "e200g_25g_5_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_fec_mode = "e200g_25g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_fec_spec = "e200g_25g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_lpbk_mode = "e200g_25g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_mac_mode = "e200g_25g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_ptp_mode = "e200g_25g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_excvr_gb_ratio_mode = "e200g_25g_5_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_excvr_if_fifo_mode = "e200g_25g_5_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_fec_enable = "e200g_25g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_pcs_mode = "e200g_25g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_primary_use = "e200g_25g_5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_stream_bonding = "e200g_25g_5_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_xcvr_bonded = "e200g_25g_5_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_rx_xcvr_width = "e200g_25g_5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_speed_map = "e200g_25g_5_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_sup_mode = "e200g_25g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_sys_clk_src = "e200g_25g_5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_excvr_gb_ratio_mode = "e200g_25g_5_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_excvr_if_fifo_mode = "e200g_25g_5_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_fec_enable = "e200g_25g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_pcs_mode = "e200g_25g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_primary_use = "e200g_25g_5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_stream_bonding = "e200g_25g_5_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_xcvr_bonded = "e200g_25g_5_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_tx_xcvr_width = "e200g_25g_5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_xcvr_type = "e200g_25g_5_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_5_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_aib2_rx_st_clk_en = "e200g_25g_6_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_aib2_tx_st_clk_en = "e200g_25g_6_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_aib3_rx_st_clk_en = "e200g_25g_6_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_aib3_tx_st_clk_en = "e200g_25g_6_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_duplex_mode = "e200g_25g_6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_fec_clk_src = "e200g_25g_6_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_fec_error = "e200g_25g_6_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_fec_mode = "e200g_25g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_fec_spec = "e200g_25g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_lpbk_mode = "e200g_25g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_mac_mode = "e200g_25g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_ptp_mode = "e200g_25g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_excvr_gb_ratio_mode = "e200g_25g_6_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_excvr_if_fifo_mode = "e200g_25g_6_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_fec_enable = "e200g_25g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_pcs_mode = "e200g_25g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_primary_use = "e200g_25g_6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_stream_bonding = "e200g_25g_6_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_xcvr_bonded = "e200g_25g_6_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_rx_xcvr_width = "e200g_25g_6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_speed_map = "e200g_25g_6_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_sup_mode = "e200g_25g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_sys_clk_src = "e200g_25g_6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_excvr_gb_ratio_mode = "e200g_25g_6_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_excvr_if_fifo_mode = "e200g_25g_6_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_fec_enable = "e200g_25g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_pcs_mode = "e200g_25g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_primary_use = "e200g_25g_6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_stream_bonding = "e200g_25g_6_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_xcvr_bonded = "e200g_25g_6_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_tx_xcvr_width = "e200g_25g_6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_xcvr_type = "e200g_25g_6_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_6_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_aib2_rx_st_clk_en = "e200g_25g_7_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_aib2_tx_st_clk_en = "e200g_25g_7_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_aib3_rx_st_clk_en = "e200g_25g_7_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_aib3_tx_st_clk_en = "e200g_25g_7_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_duplex_mode = "e200g_25g_7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_fec_clk_src = "e200g_25g_7_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_fec_error = "e200g_25g_7_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_fec_mode = "e200g_25g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_fec_spec = "e200g_25g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_lpbk_mode = "e200g_25g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_mac_mode = "e200g_25g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_ptp_mode = "e200g_25g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_excvr_gb_ratio_mode = "e200g_25g_7_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_excvr_if_fifo_mode = "e200g_25g_7_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_fec_enable = "e200g_25g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_pcs_mode = "e200g_25g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_primary_use = "e200g_25g_7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_stream_bonding = "e200g_25g_7_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_xcvr_bonded = "e200g_25g_7_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_rx_xcvr_width = "e200g_25g_7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_speed_map = "e200g_25g_7_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_sup_mode = "e200g_25g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_sys_clk_src = "e200g_25g_7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_excvr_gb_ratio_mode = "e200g_25g_7_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_excvr_if_fifo_mode = "e200g_25g_7_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_fec_enable = "e200g_25g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_pcs_mode = "e200g_25g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_primary_use = "e200g_25g_7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_stream_bonding = "e200g_25g_7_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_xcvr_bonded = "e200g_25g_7_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_tx_xcvr_width = "e200g_25g_7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_xcvr_type = "e200g_25g_7_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_25g_7_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_aib2_rx_st_clk_en = "e200g_50g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_aib2_tx_st_clk_en = "e200g_50g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_aib3_rx_st_clk_en = "e200g_50g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_aib3_tx_st_clk_en = "e200g_50g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_duplex_mode = "e200g_50g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_fec_clk_src = "e200g_50g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_fec_error = "e200g_50g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_fec_mode = "e200g_50g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_fec_spec = "e200g_50g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_lpbk_mode = "e200g_50g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_mac_mode = "e200g_50g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_ptp_mode = "e200g_50g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_excvr_gb_ratio_mode = "e200g_50g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_excvr_if_fifo_mode = "e200g_50g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_fec_enable = "e200g_50g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_pcs_mode = "e200g_50g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_primary_use = "e200g_50g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_stream_bonding = "e200g_50g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_xcvr_bonded = "e200g_50g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_rx_xcvr_width = "e200g_50g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_speed_map = "e200g_50g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_sup_mode = "e200g_50g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_sys_clk_src = "e200g_50g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_excvr_gb_ratio_mode = "e200g_50g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_excvr_if_fifo_mode = "e200g_50g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_fec_enable = "e200g_50g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_pcs_mode = "e200g_50g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_primary_use = "e200g_50g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_stream_bonding = "e200g_50g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_xcvr_bonded = "e200g_50g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_tx_xcvr_width = "e200g_50g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_xcvr_type = "e200g_50g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_aib2_rx_st_clk_en = "e200g_50g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_aib2_tx_st_clk_en = "e200g_50g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_aib3_rx_st_clk_en = "e200g_50g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_aib3_tx_st_clk_en = "e200g_50g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_duplex_mode = "e200g_50g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_fec_clk_src = "e200g_50g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_fec_error = "e200g_50g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_fec_mode = "e200g_50g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_fec_spec = "e200g_50g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_lpbk_mode = "e200g_50g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_mac_mode = "e200g_50g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_ptp_mode = "e200g_50g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_excvr_gb_ratio_mode = "e200g_50g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_excvr_if_fifo_mode = "e200g_50g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_fec_enable = "e200g_50g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_pcs_mode = "e200g_50g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_primary_use = "e200g_50g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_stream_bonding = "e200g_50g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_xcvr_bonded = "e200g_50g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_rx_xcvr_width = "e200g_50g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_speed_map = "e200g_50g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_sup_mode = "e200g_50g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_sys_clk_src = "e200g_50g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_excvr_gb_ratio_mode = "e200g_50g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_excvr_if_fifo_mode = "e200g_50g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_fec_enable = "e200g_50g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_pcs_mode = "e200g_50g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_primary_use = "e200g_50g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_stream_bonding = "e200g_50g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_xcvr_bonded = "e200g_50g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_tx_xcvr_width = "e200g_50g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_xcvr_type = "e200g_50g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_aib2_rx_st_clk_en = "e200g_50g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_aib2_tx_st_clk_en = "e200g_50g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_aib3_rx_st_clk_en = "e200g_50g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_aib3_tx_st_clk_en = "e200g_50g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_duplex_mode = "e200g_50g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_fec_clk_src = "e200g_50g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_fec_error = "e200g_50g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_fec_mode = "e200g_50g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_fec_spec = "e200g_50g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_lpbk_mode = "e200g_50g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_mac_mode = "e200g_50g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_ptp_mode = "e200g_50g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_excvr_gb_ratio_mode = "e200g_50g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_excvr_if_fifo_mode = "e200g_50g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_fec_enable = "e200g_50g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_pcs_mode = "e200g_50g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_primary_use = "e200g_50g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_stream_bonding = "e200g_50g_2_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_xcvr_bonded = "e200g_50g_2_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_rx_xcvr_width = "e200g_50g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_speed_map = "e200g_50g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_sup_mode = "e200g_50g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_sys_clk_src = "e200g_50g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_excvr_gb_ratio_mode = "e200g_50g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_excvr_if_fifo_mode = "e200g_50g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_fec_enable = "e200g_50g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_pcs_mode = "e200g_50g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_primary_use = "e200g_50g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_stream_bonding = "e200g_50g_2_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_xcvr_bonded = "e200g_50g_2_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_tx_xcvr_width = "e200g_50g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_xcvr_type = "e200g_50g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_2_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_aib2_rx_st_clk_en = "e200g_50g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_aib2_tx_st_clk_en = "e200g_50g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_aib3_rx_st_clk_en = "e200g_50g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_aib3_tx_st_clk_en = "e200g_50g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_duplex_mode = "e200g_50g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_fec_clk_src = "e200g_50g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_fec_error = "e200g_50g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_fec_mode = "e200g_50g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_fec_spec = "e200g_50g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_lpbk_mode = "e200g_50g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_mac_mode = "e200g_50g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_ptp_mode = "e200g_50g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_excvr_gb_ratio_mode = "e200g_50g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_excvr_if_fifo_mode = "e200g_50g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_fec_enable = "e200g_50g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_pcs_mode = "e200g_50g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_primary_use = "e200g_50g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_stream_bonding = "e200g_50g_3_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_xcvr_bonded = "e200g_50g_3_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_rx_xcvr_width = "e200g_50g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_speed_map = "e200g_50g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_sup_mode = "e200g_50g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_sys_clk_src = "e200g_50g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_excvr_gb_ratio_mode = "e200g_50g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_excvr_if_fifo_mode = "e200g_50g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_fec_enable = "e200g_50g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_pcs_mode = "e200g_50g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_primary_use = "e200g_50g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_stream_bonding = "e200g_50g_3_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_xcvr_bonded = "e200g_50g_3_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_tx_xcvr_width = "e200g_50g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_xcvr_type = "e200g_50g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_50g_3_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_ptp0_aib2_div2_clk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream0_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream0_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream1_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream1_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream2_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream2_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream3_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream3_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream4_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream4_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream5_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream5_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream6_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream6_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream7_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__e200g_stream7_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__func_mode = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_aib2_rx_st_clk_en = "e200g_100g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_aib2_tx_st_clk_en = "e200g_100g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_aib3_rx_st_clk_en = "e200g_100g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_aib3_tx_st_clk_en = "e200g_100g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_duplex_mode = "e200g_100g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_fec_mode = "e200g_100g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_fec_spec = "e200g_100g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_mac_mode = "e200g_100g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_excvr_gb_ratio_mode = "e200g_100g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_excvr_if_fifo_mode = "e200g_100g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_fec_enable = "e200g_100g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_pcs_mode = "e200g_100g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_rx_primary_use = "e200g_100g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_speed_map = "e200g_100g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_sup_mode = "e200g_100g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_sys_clk_src = "e200g_100g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_excvr_gb_ratio_mode = "e200g_100g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_excvr_if_fifo_mode = "e200g_100g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_fec_enable = "e200g_100g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_pcs_mode = "e200g_100g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_tx_primary_use = "e200g_100g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__e200g_100g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_aib2_rx_st_clk_en = "e200g_100g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_aib2_tx_st_clk_en = "e200g_100g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_aib3_rx_st_clk_en = "e200g_100g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_aib3_tx_st_clk_en = "e200g_100g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_duplex_mode = "e200g_100g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_fec_mode = "e200g_100g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_fec_spec = "e200g_100g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_mac_mode = "e200g_100g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_excvr_gb_ratio_mode = "e200g_100g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_excvr_if_fifo_mode = "e200g_100g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_fec_enable = "e200g_100g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_pcs_mode = "e200g_100g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_rx_primary_use = "e200g_100g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_speed_map = "e200g_100g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_sup_mode = "e200g_100g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_sys_clk_src = "e200g_100g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_excvr_gb_ratio_mode = "e200g_100g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_excvr_if_fifo_mode = "e200g_100g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_fec_enable = "e200g_100g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_pcs_mode = "e200g_100g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_tx_primary_use = "e200g_100g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__e200g_100g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e100g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_aib2_rx_st_clk_en = "e200g_200g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_aib2_tx_st_clk_en = "e200g_200g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_aib3_rx_st_clk_en = "e200g_200g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_aib3_tx_st_clk_en = "e200g_200g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_duplex_mode = "e200g_200g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_fec_mode = "e200g_200g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_fec_spec = "e200g_200g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_mac_mode = "e200g_200g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_excvr_gb_ratio_mode = "e200g_200g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_excvr_if_fifo_mode = "e200g_200g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_fec_enable = "e200g_200g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_pcs_mode = "e200g_200g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_rx_primary_use = "e200g_200g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_speed_map = "e200g_200g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_sup_mode = "e200g_200g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_sys_clk_src = "e200g_200g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_excvr_gb_ratio_mode = "e200g_200g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_excvr_if_fifo_mode = "e200g_200g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_fec_enable = "e200g_200g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_pcs_mode = "e200g_200g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_tx_primary_use = "e200g_200g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__e200g_200g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s4__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s5__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s6__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvr_sel = "ux_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e200g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s7__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch1__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch3__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch5__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_aib2_rx_st_clk_en = "e200g_25g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_aib2_tx_st_clk_en = "e200g_25g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_aib3_rx_st_clk_en = "e200g_25g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_aib3_tx_st_clk_en = "e200g_25g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_duplex_mode = "e200g_25g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_fec_mode = "e200g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_fec_spec = "e200g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_mac_mode = "e200g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_excvr_gb_ratio_mode = "e200g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_excvr_if_fifo_mode = "e200g_25g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_fec_enable = "e200g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_pcs_mode = "e200g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_rx_primary_use = "e200g_25g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_speed_map = "e200g_25g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_sup_mode = "e200g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_sys_clk_src = "e200g_25g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_excvr_gb_ratio_mode = "e200g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_excvr_if_fifo_mode = "e200g_25g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_fec_enable = "e200g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_pcs_mode = "e200g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_tx_primary_use = "e200g_25g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__e200g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e25g_reg_ch7__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_aib2_rx_st_clk_en = "e200g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_aib2_tx_st_clk_en = "e200g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_aib3_rx_st_clk_en = "e200g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_aib3_tx_st_clk_en = "e200g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_duplex_mode = "e200g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_fec_mode = "e200g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_fec_spec = "e200g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_mac_mode = "e200g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_excvr_gb_ratio_mode = "e200g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_excvr_if_fifo_mode = "e200g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_fec_enable = "e200g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_pcs_mode = "e200g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_rx_primary_use = "e200g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_speed_map = "e200g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_sup_mode = "e200g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_sys_clk_src = "e200g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_excvr_gb_ratio_mode = "e200g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_excvr_if_fifo_mode = "e200g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_fec_enable = "e200g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_pcs_mode = "e200g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_tx_primary_use = "e200g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__e200g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch0__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_aib2_rx_st_clk_en = "e200g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_aib2_tx_st_clk_en = "e200g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_aib3_rx_st_clk_en = "e200g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_aib3_tx_st_clk_en = "e200g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_duplex_mode = "e200g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_fec_mode = "e200g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_fec_spec = "e200g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_mac_mode = "e200g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_excvr_gb_ratio_mode = "e200g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_excvr_if_fifo_mode = "e200g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_fec_enable = "e200g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_pcs_mode = "e200g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_rx_primary_use = "e200g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_speed_map = "e200g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_sup_mode = "e200g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_sys_clk_src = "e200g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_excvr_gb_ratio_mode = "e200g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_excvr_if_fifo_mode = "e200g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_fec_enable = "e200g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_pcs_mode = "e200g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_tx_primary_use = "e200g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__e200g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch2__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_aib2_rx_st_clk_en = "e200g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_aib2_tx_st_clk_en = "e200g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_aib3_rx_st_clk_en = "e200g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_aib3_tx_st_clk_en = "e200g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_duplex_mode = "e200g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_fec_mode = "e200g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_fec_spec = "e200g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_mac_mode = "e200g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_excvr_gb_ratio_mode = "e200g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_excvr_if_fifo_mode = "e200g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_fec_enable = "e200g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_pcs_mode = "e200g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_rx_primary_use = "e200g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_speed_map = "e200g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_sup_mode = "e200g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_sys_clk_src = "e200g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_excvr_gb_ratio_mode = "e200g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_excvr_if_fifo_mode = "e200g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_fec_enable = "e200g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_pcs_mode = "e200g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_tx_primary_use = "e200g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__e200g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch4__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_aib2_rx_st_clk_en = "e200g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_aib2_tx_st_clk_en = "e200g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_aib3_rx_st_clk_en = "e200g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_aib3_tx_st_clk_en = "e200g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_duplex_mode = "e200g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_fec_mode = "e200g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_fec_spec = "e200g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_mac_mode = "e200g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_excvr_gb_ratio_mode = "e200g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_excvr_if_fifo_mode = "e200g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_fec_enable = "e200g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_pcs_mode = "e200g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_rx_primary_use = "e200g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_speed_map = "e200g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_sup_mode = "e200g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_sys_clk_src = "e200g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_excvr_gb_ratio_mode = "e200g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_excvr_if_fifo_mode = "e200g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_fec_enable = "e200g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_pcs_mode = "e200g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_tx_primary_use = "e200g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__e200g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_return_clk_gate_attr = "unused_bk_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__unused_bk_tx_rtrn_clk_sel = "bk3_unused";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_sys_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__gdr_e200g_lphy_e50g_reg_ch6__gdr_e200g_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x0 = "map_25e2x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x1 = "map_25e2x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x2 = "map_25e2x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x3 = "map_25e2x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x4 = "map_25e2x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x5 = "map_25e2x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x6 = "map_25e2x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_25e2x7 = "map_25e2x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_56e2x0 = "map_56e2x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_56e2x1 = "map_56e2x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_56e2x2 = "map_56e2x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_56e2x3 = "map_56e2x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux0 = "map_ux0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux1 = "map_ux1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux2 = "map_ux2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux3 = "map_ux3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux4 = "map_ux4_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux5 = "map_ux5_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux6 = "map_ux6_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__map_ux7 = "map_ux7_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_100g_0 = "off_100g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_100g_1 = "off_100g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_150g_0 = "off_150g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_150g_1 = "off_150g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_200g = "off_200g";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_0 = "off_25g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_1 = "off_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_2 = "off_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_3 = "off_25g_3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_4 = "off_25g_4";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_5 = "off_25g_5";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_6 = "off_25g_6";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_25g_7 = "off_25g_7";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_50g_0 = "off_50g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_50g_1 = "off_50g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_50g_2 = "off_50g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_50g_3 = "off_50g_3";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_core0_clk = "fec_core0_clk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_core1_clk = "fec_core1_clk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st0_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st1_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st2_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st3_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st4_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st5_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st6_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_rx_st7_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st0_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st1_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st2_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st3_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st4_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st5_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st6_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_eth_tx_st7_clk = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__speed_grade = "dash_1";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sys_pll0_div1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sys_pll0_div2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sys_pll1_div1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sys_pll1_div2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sys_pll2_div1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__sys_pll2_div2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk5_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk6_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__transfer_clk7_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux0_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux0_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux0_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux0_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux0_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux0_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux1_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux1_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux1_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux1_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux1_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux1_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux2_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux2_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux2_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux2_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux2_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux2_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux3_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux3_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux3_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux3_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux3_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux3_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux4_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux4_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux4_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux4_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux4_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux4_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux5_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux5_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux5_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux5_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux5_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux5_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux6_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux6_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux6_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux6_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux6_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux6_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux7_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux7_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux7_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux7_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux7_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__ux7_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st0_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st0_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st1_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st1_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st2_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st2_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st3_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_rx_user_st3_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x0 = "xcvr_select_25e2x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x1 = "xcvr_select_25e2x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x2 = "xcvr_select_25e2x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x3 = "xcvr_select_25e2x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x4 = "xcvr_select_25e2x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x5 = "xcvr_select_25e2x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x6 = "xcvr_select_25e2x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_25e2x7 = "xcvr_select_25e2x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_56e2x0 = "xcvr_select_56e2x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_56e2x1 = "xcvr_select_56e2x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_56e2x2 = "xcvr_select_56e2x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_select_56e2x3 = "xcvr_select_56e2x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st0_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st0_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st1_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st1_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st2_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st2_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st3_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__u_gdr_e200g_lphy__xcvr_tx_user_st3_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux0_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux0_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux0_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux0_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux0_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux0_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux1_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux1_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux1_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux1_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux1_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux1_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux2_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux2_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux2_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux2_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux2_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux2_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux3_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux3_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux3_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux3_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux3_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux3_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux4_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux4_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux4_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux4_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux4_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux4_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux5_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux5_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux5_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux5_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux5_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux5_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux6_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux6_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux6_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux6_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux6_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux6_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux7_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux7_rx_user_xcvr_rc_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux7_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux7_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux7_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__ux7_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x0 = "xcvr_select_25e2x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x1 = "xcvr_select_25e2x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x2 = "xcvr_select_25e2x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x3 = "xcvr_select_25e2x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x4 = "xcvr_select_25e2x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x5 = "xcvr_select_25e2x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x6 = "xcvr_select_25e2x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_25e2x7 = "xcvr_select_25e2x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_56e2x0 = "xcvr_select_56e2x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_56e2x1 = "xcvr_select_56e2x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_56e2x2 = "xcvr_select_56e2x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e200g_top__xcvr_select_56e2x3 = "xcvr_select_56e2x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st0_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st10_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st11_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st12_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st13_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st14_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st15_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st16_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st17_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st1_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st2_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st3_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st4_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st5_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st6_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st7_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st8_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib1_tx_st9_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st0_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st10_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st11_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st12_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st13_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st14_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st15_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st16_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st17_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st1_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st2_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st3_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st4_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st5_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st6_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st7_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st8_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_rx_st9_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st0_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st10_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st11_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st12_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st13_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st14_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st15_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st16_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st17_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st1_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st2_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st3_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st4_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st5_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st6_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st7_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st8_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib2_tx_st9_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st0_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st10_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st11_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st12_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st13_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st14_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st15_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st1_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st2_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st3_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st4_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st5_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st6_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st7_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st8_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_rx_st9_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st0_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st10_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st11_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st12_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st13_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st14_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st15_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st1_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st2_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st3_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st4_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st5_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st6_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st7_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st8_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib3_tx_st9_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib_esys_adapt_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib_transfer_ptp0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__aib_transfer_ptp1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_rx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_rx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_rxword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk0_txword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_rx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_rx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_rxword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk1_txword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_rx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_rx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_rxword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk2_txword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_return_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_rx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_rx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_rxword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__bk3_txword_xcvr_rc_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__block_enable = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_pcs_pcs_ber_mon_mode = "e400g_100g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_pcs_pcs_ber_mon_mode = "e400g_100g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_pcs_pcs_ber_mon_mode = "e400g_100g_2_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_pcs_pcs_ber_mon_mode = "e400g_100g_3_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_100g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_150g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_pcs_pcs_ber_mon_mode = "e400g_200g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_pcs_pcs_ber_mon_mode = "e400g_200g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_200g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_pcs_pcs_ber_mon_mode = "e400g_25g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_10_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_pcs_pcs_ber_mon_mode = "e400g_25g_11_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_11_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_pcs_pcs_ber_mon_mode = "e400g_25g_12_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_12_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_pcs_pcs_ber_mon_mode = "e400g_25g_13_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_13_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_pcs_pcs_ber_mon_mode = "e400g_25g_14_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_14_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_pcs_pcs_ber_mon_mode = "e400g_25g_15_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_15_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_pcs_pcs_ber_mon_mode = "e400g_25g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_pcs_pcs_ber_mon_mode = "e400g_25g_2_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_pcs_pcs_ber_mon_mode = "e400g_25g_3_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_pcs_pcs_ber_mon_mode = "e400g_25g_4_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_pcs_pcs_ber_mon_mode = "e400g_25g_5_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_pcs_pcs_ber_mon_mode = "e400g_25g_6_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_pcs_pcs_ber_mon_mode = "e400g_25g_7_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_pcs_pcs_ber_mon_mode = "e400g_25g_8_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_8_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_pcs_pcs_ber_mon_mode = "e400g_25g_9_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_25g_9_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_300g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_pcs_pcs_ber_mon_mode = "e400g_400g_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_400g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_pcs_pcs_ber_mon_mode = "e400g_50g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_pcs_pcs_ber_mon_mode = "e400g_50g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_pcs_pcs_ber_mon_mode = "e400g_50g_2_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_pcs_pcs_ber_mon_mode = "e400g_50g_3_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_pcs_pcs_ber_mon_mode = "e400g_50g_4_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_pcs_pcs_ber_mon_mode = "e400g_50g_5_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_pcs_pcs_ber_mon_mode = "e400g_50g_6_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_pcs_pcs_ber_mon_mode = "e400g_50g_7_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_50g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_rx_master_bond_chnl = "e400g_bk0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_speed_bucket = "e400g_bk0_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_tx_master_bond_chnl = "e400g_bk0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk0_xcvr_mode = "e400g_bk0_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_rx_master_bond_chnl = "e400g_bk1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_speed_bucket = "e400g_bk1_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_tx_master_bond_chnl = "e400g_bk1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk1_xcvr_mode = "e400g_bk1_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_rx_master_bond_chnl = "e400g_bk2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_speed_bucket = "e400g_bk2_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_tx_master_bond_chnl = "e400g_bk2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk2_xcvr_mode = "e400g_bk2_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_rx_master_bond_chnl = "e400g_bk3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_speed_bucket = "e400g_bk3_speed_bucket_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_tx_master_bond_chnl = "e400g_bk3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_bk3_xcvr_mode = "e400g_bk3_xcvr_mode_nrz";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_duplex_mode = "e400g_stream0_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_ptp_mode = "e400g_stream0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_aib_if_fifo_mode = "e400g_stream0_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_excvr_if_fifo_mode = "e400g_stream0_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_primary_use = "e400g_stream0_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_rx_xcvr_width = "e400g_stream0_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_sys_clk_src = "e400g_stream0_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_aib_if_fifo_mode = "e400g_stream0_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_excvr_if_fifo_mode = "e400g_stream0_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_primary_use = "e400g_stream0_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream0_tx_xcvr_width = "e400g_stream0_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_duplex_mode = "e400g_stream10_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_ptp_mode = "e400g_stream10_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_aib_if_fifo_mode = "e400g_stream10_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_excvr_if_fifo_mode = "e400g_stream10_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_primary_use = "e400g_stream10_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_rx_xcvr_width = "e400g_stream10_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_sys_clk_src = "e400g_stream10_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_aib_if_fifo_mode = "e400g_stream10_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_excvr_if_fifo_mode = "e400g_stream10_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_primary_use = "e400g_stream10_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream10_tx_xcvr_width = "e400g_stream10_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_duplex_mode = "e400g_stream11_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_ptp_mode = "e400g_stream11_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_aib_if_fifo_mode = "e400g_stream11_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_excvr_if_fifo_mode = "e400g_stream11_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_primary_use = "e400g_stream11_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_rx_xcvr_width = "e400g_stream11_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_sys_clk_src = "e400g_stream11_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_aib_if_fifo_mode = "e400g_stream11_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_excvr_if_fifo_mode = "e400g_stream11_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_primary_use = "e400g_stream11_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream11_tx_xcvr_width = "e400g_stream11_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_duplex_mode = "e400g_stream12_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_ptp_mode = "e400g_stream12_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_aib_if_fifo_mode = "e400g_stream12_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_excvr_if_fifo_mode = "e400g_stream12_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_primary_use = "e400g_stream12_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_rx_xcvr_width = "e400g_stream12_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_sys_clk_src = "e400g_stream12_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_aib_if_fifo_mode = "e400g_stream12_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_excvr_if_fifo_mode = "e400g_stream12_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_primary_use = "e400g_stream12_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream12_tx_xcvr_width = "e400g_stream12_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_duplex_mode = "e400g_stream13_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_ptp_mode = "e400g_stream13_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_aib_if_fifo_mode = "e400g_stream13_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_excvr_if_fifo_mode = "e400g_stream13_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_primary_use = "e400g_stream13_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_rx_xcvr_width = "e400g_stream13_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_sys_clk_src = "e400g_stream13_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_aib_if_fifo_mode = "e400g_stream13_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_excvr_if_fifo_mode = "e400g_stream13_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_primary_use = "e400g_stream13_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream13_tx_xcvr_width = "e400g_stream13_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_duplex_mode = "e400g_stream14_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_ptp_mode = "e400g_stream14_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_aib_if_fifo_mode = "e400g_stream14_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_excvr_if_fifo_mode = "e400g_stream14_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_primary_use = "e400g_stream14_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_rx_xcvr_width = "e400g_stream14_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_sys_clk_src = "e400g_stream14_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_aib_if_fifo_mode = "e400g_stream14_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_excvr_if_fifo_mode = "e400g_stream14_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_primary_use = "e400g_stream14_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream14_tx_xcvr_width = "e400g_stream14_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_duplex_mode = "e400g_stream15_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_ptp_mode = "e400g_stream15_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_aib_if_fifo_mode = "e400g_stream15_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_excvr_if_fifo_mode = "e400g_stream15_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_primary_use = "e400g_stream15_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_rx_xcvr_width = "e400g_stream15_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_sys_clk_src = "e400g_stream15_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_aib_if_fifo_mode = "e400g_stream15_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_excvr_if_fifo_mode = "e400g_stream15_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_primary_use = "e400g_stream15_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream15_tx_xcvr_width = "e400g_stream15_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream16_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream17_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_duplex_mode = "e400g_stream1_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_ptp_mode = "e400g_stream1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_aib_if_fifo_mode = "e400g_stream1_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_excvr_if_fifo_mode = "e400g_stream1_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_primary_use = "e400g_stream1_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_rx_xcvr_width = "e400g_stream1_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_sys_clk_src = "e400g_stream1_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_aib_if_fifo_mode = "e400g_stream1_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_excvr_if_fifo_mode = "e400g_stream1_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_primary_use = "e400g_stream1_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream1_tx_xcvr_width = "e400g_stream1_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_duplex_mode = "e400g_stream2_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_ptp_mode = "e400g_stream2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_aib_if_fifo_mode = "e400g_stream2_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_excvr_if_fifo_mode = "e400g_stream2_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_primary_use = "e400g_stream2_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_rx_xcvr_width = "e400g_stream2_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_sys_clk_src = "e400g_stream2_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_aib_if_fifo_mode = "e400g_stream2_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_excvr_if_fifo_mode = "e400g_stream2_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_primary_use = "e400g_stream2_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream2_tx_xcvr_width = "e400g_stream2_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_duplex_mode = "e400g_stream3_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_ptp_mode = "e400g_stream3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_aib_if_fifo_mode = "e400g_stream3_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_excvr_if_fifo_mode = "e400g_stream3_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_primary_use = "e400g_stream3_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_rx_xcvr_width = "e400g_stream3_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_sys_clk_src = "e400g_stream3_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_aib_if_fifo_mode = "e400g_stream3_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_excvr_if_fifo_mode = "e400g_stream3_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_primary_use = "e400g_stream3_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream3_tx_xcvr_width = "e400g_stream3_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_duplex_mode = "e400g_stream4_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_ptp_mode = "e400g_stream4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_aib_if_fifo_mode = "e400g_stream4_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_excvr_if_fifo_mode = "e400g_stream4_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_primary_use = "e400g_stream4_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_rx_xcvr_width = "e400g_stream4_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_sys_clk_src = "e400g_stream4_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_aib_if_fifo_mode = "e400g_stream4_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_excvr_if_fifo_mode = "e400g_stream4_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_primary_use = "e400g_stream4_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream4_tx_xcvr_width = "e400g_stream4_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_duplex_mode = "e400g_stream5_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_ptp_mode = "e400g_stream5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_aib_if_fifo_mode = "e400g_stream5_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_excvr_if_fifo_mode = "e400g_stream5_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_primary_use = "e400g_stream5_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_rx_xcvr_width = "e400g_stream5_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_sys_clk_src = "e400g_stream5_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_aib_if_fifo_mode = "e400g_stream5_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_excvr_if_fifo_mode = "e400g_stream5_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_primary_use = "e400g_stream5_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream5_tx_xcvr_width = "e400g_stream5_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_duplex_mode = "e400g_stream6_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_ptp_mode = "e400g_stream6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_aib_if_fifo_mode = "e400g_stream6_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_excvr_if_fifo_mode = "e400g_stream6_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_primary_use = "e400g_stream6_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_rx_xcvr_width = "e400g_stream6_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_sys_clk_src = "e400g_stream6_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_aib_if_fifo_mode = "e400g_stream6_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_excvr_if_fifo_mode = "e400g_stream6_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_primary_use = "e400g_stream6_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream6_tx_xcvr_width = "e400g_stream6_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_duplex_mode = "e400g_stream7_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_ptp_mode = "e400g_stream7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_aib_if_fifo_mode = "e400g_stream7_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_excvr_if_fifo_mode = "e400g_stream7_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_primary_use = "e400g_stream7_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_rx_xcvr_width = "e400g_stream7_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_sys_clk_src = "e400g_stream7_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_aib_if_fifo_mode = "e400g_stream7_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_excvr_if_fifo_mode = "e400g_stream7_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_primary_use = "e400g_stream7_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream7_tx_xcvr_width = "e400g_stream7_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_duplex_mode = "e400g_stream8_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_ptp_mode = "e400g_stream8_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_aib_if_fifo_mode = "e400g_stream8_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_excvr_if_fifo_mode = "e400g_stream8_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_primary_use = "e400g_stream8_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_rx_xcvr_width = "e400g_stream8_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_sys_clk_src = "e400g_stream8_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_aib_if_fifo_mode = "e400g_stream8_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_excvr_if_fifo_mode = "e400g_stream8_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_primary_use = "e400g_stream8_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream8_tx_xcvr_width = "e400g_stream8_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_duplex_mode = "e400g_stream9_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_ptp_mode = "e400g_stream9_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_aib_if_fifo_mode = "e400g_stream9_rx_aib_if_fifo_mode_register";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_excvr_if_fifo_mode = "e400g_stream9_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_primary_use = "e400g_stream9_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_rx_xcvr_width = "e400g_stream9_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_sys_clk_src = "e400g_stream9_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_aib_if_fifo_mode = "e400g_stream9_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_bond_size = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_excvr_if_fifo_mode = "e400g_stream9_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_primary_use = "e400g_stream9_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_stream9_tx_xcvr_width = "e400g_stream9_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_rx_master_bond_chnl = "e400g_ux0_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_tx_master_bond_chnl = "e400g_ux0_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux0_txrx_channel_operation = "e400g_ux0_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_rx_master_bond_chnl = "e400g_ux10_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_tx_master_bond_chnl = "e400g_ux10_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux10_txrx_channel_operation = "e400g_ux10_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_rx_master_bond_chnl = "e400g_ux11_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_tx_master_bond_chnl = "e400g_ux11_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux11_txrx_channel_operation = "e400g_ux11_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_rx_master_bond_chnl = "e400g_ux12_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_tx_master_bond_chnl = "e400g_ux12_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux12_txrx_channel_operation = "e400g_ux12_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_rx_master_bond_chnl = "e400g_ux13_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_tx_master_bond_chnl = "e400g_ux13_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux13_txrx_channel_operation = "e400g_ux13_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_rx_master_bond_chnl = "e400g_ux14_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_tx_master_bond_chnl = "e400g_ux14_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux14_txrx_channel_operation = "e400g_ux14_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_rx_master_bond_chnl = "e400g_ux15_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_tx_master_bond_chnl = "e400g_ux15_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux15_txrx_channel_operation = "e400g_ux15_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_rx_master_bond_chnl = "e400g_ux1_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_tx_master_bond_chnl = "e400g_ux1_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux1_txrx_channel_operation = "e400g_ux1_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_rx_master_bond_chnl = "e400g_ux2_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_tx_master_bond_chnl = "e400g_ux2_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux2_txrx_channel_operation = "e400g_ux2_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_rx_master_bond_chnl = "e400g_ux3_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_tx_master_bond_chnl = "e400g_ux3_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux3_txrx_channel_operation = "e400g_ux3_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_rx_master_bond_chnl = "e400g_ux4_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_tx_master_bond_chnl = "e400g_ux4_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux4_txrx_channel_operation = "e400g_ux4_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_rx_master_bond_chnl = "e400g_ux5_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_tx_master_bond_chnl = "e400g_ux5_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux5_txrx_channel_operation = "e400g_ux5_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_rx_master_bond_chnl = "e400g_ux6_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_tx_master_bond_chnl = "e400g_ux6_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux6_txrx_channel_operation = "e400g_ux6_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_rx_master_bond_chnl = "e400g_ux7_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_tx_master_bond_chnl = "e400g_ux7_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux7_txrx_channel_operation = "e400g_ux7_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_rx_master_bond_chnl = "e400g_ux8_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_tx_master_bond_chnl = "e400g_ux8_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux8_txrx_channel_operation = "e400g_ux8_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_rx_master_bond_chnl = "e400g_ux9_rx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_tx_master_bond_chnl = "e400g_ux9_tx_master_bond_chnl_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_ux9_txrx_channel_operation = "e400g_ux9_txrx_channel_operation_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_112e4x3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x10_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x11_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x12_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x13_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x14_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x15_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x8_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_25e4x9_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__e400g_xcvr_speed_map_56e4x7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ptp0_clk_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ptp1_clk_adapt_rc_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk0_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk10_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk11_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk12_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk13_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk14_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk15_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk1_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk2_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk3_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk4_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk5_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk6_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk7_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk8_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__rx_transfer_clk9_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sys_pll0_div1_adapt_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sys_pll0_div2_adapt_rc_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sys_pll1_div1_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sys_pll1_div2_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sys_pll2_div1_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__sys_pll2_div2_adapt_rc_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk0_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk10_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk11_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk12_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk13_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk14_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk15_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk1_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk2_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk3_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk4_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk5_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk6_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk7_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk8_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__transfer_clk9_adapt_rc_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_ptp_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib1_tx_st9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_ptp_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st0_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st10_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st11_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st12_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st13_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st14_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st15_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st1_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st3_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st4_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st5_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st6_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st7_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st8_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_rx_st9_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st0_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st10_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st11_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st12_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st13_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st14_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st15_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st1_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st3_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st4_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st5_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st6_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st7_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st8_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib2_tx_st9_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_rx_st9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib3_tx_st9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__aib_esys_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_rx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_rx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_rxword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk0_txword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_rx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_rx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_rxword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk1_txword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_rx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_rx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_rxword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk2_txword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_return_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_rx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_rx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_rxword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bk3_txword_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__block_enable = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_rx9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__bond_tx9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_aib2_rx_st_clk_en = "e400g_100g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_aib2_tx_st_clk_en = "e400g_100g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_aib3_rx_st_clk_en = "e400g_100g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_aib3_tx_st_clk_en = "e400g_100g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_duplex_mode = "e400g_100g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_fec_clk_src = "e400g_100g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_fec_error = "e400g_100g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_fec_mode = "e400g_100g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_fec_spec = "e400g_100g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_lpbk_mode = "e400g_100g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_mac_mode = "e400g_100g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_ptp_mode = "e400g_100g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_excvr_gb_ratio_mode = "e400g_100g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_excvr_if_fifo_mode = "e400g_100g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_fec_enable = "e400g_100g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_pcs_mode = "e400g_100g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_primary_use = "e400g_100g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_stream_bonding = "e400g_100g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_xcvr_bonded = "e400g_100g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_rx_xcvr_width = "e400g_100g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_speed_map = "e400g_100g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_sup_mode = "e400g_100g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_sys_clk_src = "e400g_100g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_excvr_gb_ratio_mode = "e400g_100g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_excvr_if_fifo_mode = "e400g_100g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_fec_enable = "e400g_100g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_pcs_mode = "e400g_100g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_primary_use = "e400g_100g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_stream_bonding = "e400g_100g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_xcvr_bonded = "e400g_100g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_tx_xcvr_width = "e400g_100g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_xcvr_type = "e400g_100g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_aib2_rx_st_clk_en = "e400g_100g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_aib2_tx_st_clk_en = "e400g_100g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_aib3_rx_st_clk_en = "e400g_100g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_aib3_tx_st_clk_en = "e400g_100g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_duplex_mode = "e400g_100g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_fec_clk_src = "e400g_100g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_fec_error = "e400g_100g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_fec_mode = "e400g_100g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_fec_spec = "e400g_100g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_lpbk_mode = "e400g_100g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_mac_mode = "e400g_100g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_ptp_mode = "e400g_100g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_excvr_gb_ratio_mode = "e400g_100g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_excvr_if_fifo_mode = "e400g_100g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_fec_enable = "e400g_100g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_pcs_mode = "e400g_100g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_primary_use = "e400g_100g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_stream_bonding = "e400g_100g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_xcvr_bonded = "e400g_100g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_rx_xcvr_width = "e400g_100g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_speed_map = "e400g_100g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_sup_mode = "e400g_100g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_sys_clk_src = "e400g_100g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_excvr_gb_ratio_mode = "e400g_100g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_excvr_if_fifo_mode = "e400g_100g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_fec_enable = "e400g_100g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_pcs_mode = "e400g_100g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_primary_use = "e400g_100g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_stream_bonding = "e400g_100g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_xcvr_bonded = "e400g_100g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_tx_xcvr_width = "e400g_100g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_xcvr_type = "e400g_100g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_aib2_rx_st_clk_en = "e400g_100g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_aib2_tx_st_clk_en = "e400g_100g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_aib3_rx_st_clk_en = "e400g_100g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_aib3_tx_st_clk_en = "e400g_100g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_duplex_mode = "e400g_100g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_fec_clk_src = "e400g_100g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_fec_error = "e400g_100g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_fec_mode = "e400g_100g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_fec_spec = "e400g_100g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_lpbk_mode = "e400g_100g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_mac_mode = "e400g_100g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_ptp_mode = "e400g_100g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_excvr_gb_ratio_mode = "e400g_100g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_excvr_if_fifo_mode = "e400g_100g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_fec_enable = "e400g_100g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_pcs_mode = "e400g_100g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_primary_use = "e400g_100g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_stream_bonding = "e400g_100g_2_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_xcvr_bonded = "e400g_100g_2_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_rx_xcvr_width = "e400g_100g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_speed_map = "e400g_100g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_sup_mode = "e400g_100g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_sys_clk_src = "e400g_100g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_excvr_gb_ratio_mode = "e400g_100g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_excvr_if_fifo_mode = "e400g_100g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_fec_enable = "e400g_100g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_pcs_mode = "e400g_100g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_primary_use = "e400g_100g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_stream_bonding = "e400g_100g_2_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_xcvr_bonded = "e400g_100g_2_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_tx_xcvr_width = "e400g_100g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_xcvr_type = "e400g_100g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_2_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_aib2_rx_st_clk_en = "e400g_100g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_aib2_tx_st_clk_en = "e400g_100g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_aib3_rx_st_clk_en = "e400g_100g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_aib3_tx_st_clk_en = "e400g_100g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_duplex_mode = "e400g_100g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_fec_clk_src = "e400g_100g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_fec_error = "e400g_100g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_fec_mode = "e400g_100g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_fec_spec = "e400g_100g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_lpbk_mode = "e400g_100g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_mac_mode = "e400g_100g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_ptp_mode = "e400g_100g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_excvr_gb_ratio_mode = "e400g_100g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_excvr_if_fifo_mode = "e400g_100g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_fec_enable = "e400g_100g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_pcs_mode = "e400g_100g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_primary_use = "e400g_100g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_stream_bonding = "e400g_100g_3_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_xcvr_bonded = "e400g_100g_3_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_rx_xcvr_width = "e400g_100g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_speed_map = "e400g_100g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_sup_mode = "e400g_100g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_sys_clk_src = "e400g_100g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_excvr_gb_ratio_mode = "e400g_100g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_excvr_if_fifo_mode = "e400g_100g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_fec_enable = "e400g_100g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_pcs_mode = "e400g_100g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_primary_use = "e400g_100g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_stream_bonding = "e400g_100g_3_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_xcvr_bonded = "e400g_100g_3_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_tx_xcvr_width = "e400g_100g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_xcvr_type = "e400g_100g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_100g_3_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_aib2_rx_st_clk_en = "e400g_150g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_aib2_tx_st_clk_en = "e400g_150g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_aib3_rx_st_clk_en = "e400g_150g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_aib3_tx_st_clk_en = "e400g_150g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_duplex_mode = "e400g_150g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_fec_mode = "e400g_150g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_fec_spec = "e400g_150g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_lpbk_mode = "e400g_150g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_mac_mode = "e400g_150g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_ptp_mode = "e400g_150g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_excvr_gb_ratio_mode = "e400g_150g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_excvr_if_fifo_mode = "e400g_150g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_fec_enable = "e400g_150g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_pcs_mode = "e400g_150g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_primary_use = "e400g_150g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_stream_bonding = "e400g_150g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_xcvr_bonded = "e400g_150g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_rx_xcvr_width = "e400g_150g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_speed_map = "e400g_150g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_sup_mode = "e400g_150g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_sys_clk_src = "e400g_150g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_excvr_gb_ratio_mode = "e400g_150g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_excvr_if_fifo_mode = "e400g_150g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_fec_enable = "e400g_150g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_pcs_mode = "e400g_150g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_primary_use = "e400g_150g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_stream_bonding = "e400g_150g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_xcvr_bonded = "e400g_150g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_tx_xcvr_width = "e400g_150g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_xcvr_type = "e400g_150g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_aib2_rx_st_clk_en = "e400g_150g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_aib2_tx_st_clk_en = "e400g_150g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_aib3_rx_st_clk_en = "e400g_150g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_aib3_tx_st_clk_en = "e400g_150g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_duplex_mode = "e400g_150g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_fec_mode = "e400g_150g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_fec_spec = "e400g_150g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_lpbk_mode = "e400g_150g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_mac_mode = "e400g_150g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_ptp_mode = "e400g_150g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_excvr_gb_ratio_mode = "e400g_150g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_excvr_if_fifo_mode = "e400g_150g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_fec_enable = "e400g_150g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_pcs_mode = "e400g_150g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_primary_use = "e400g_150g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_stream_bonding = "e400g_150g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_xcvr_bonded = "e400g_150g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_rx_xcvr_width = "e400g_150g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_speed_map = "e400g_150g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_sup_mode = "e400g_150g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_sys_clk_src = "e400g_150g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_excvr_gb_ratio_mode = "e400g_150g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_excvr_if_fifo_mode = "e400g_150g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_fec_enable = "e400g_150g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_pcs_mode = "e400g_150g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_primary_use = "e400g_150g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_stream_bonding = "e400g_150g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_xcvr_bonded = "e400g_150g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_tx_xcvr_width = "e400g_150g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_xcvr_type = "e400g_150g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_aib2_rx_st_clk_en = "e400g_150g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_aib2_tx_st_clk_en = "e400g_150g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_aib3_rx_st_clk_en = "e400g_150g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_aib3_tx_st_clk_en = "e400g_150g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_duplex_mode = "e400g_150g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_fec_mode = "e400g_150g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_fec_spec = "e400g_150g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_lpbk_mode = "e400g_150g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_mac_mode = "e400g_150g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_ptp_mode = "e400g_150g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_excvr_gb_ratio_mode = "e400g_150g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_excvr_if_fifo_mode = "e400g_150g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_fec_enable = "e400g_150g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_pcs_mode = "e400g_150g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_primary_use = "e400g_150g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_stream_bonding = "e400g_150g_2_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_xcvr_bonded = "e400g_150g_2_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_rx_xcvr_width = "e400g_150g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_speed_map = "e400g_150g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_sup_mode = "e400g_150g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_sys_clk_src = "e400g_150g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_excvr_gb_ratio_mode = "e400g_150g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_excvr_if_fifo_mode = "e400g_150g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_fec_enable = "e400g_150g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_pcs_mode = "e400g_150g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_primary_use = "e400g_150g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_stream_bonding = "e400g_150g_2_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_xcvr_bonded = "e400g_150g_2_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_tx_xcvr_width = "e400g_150g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_xcvr_type = "e400g_150g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_2_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_aib2_rx_st_clk_en = "e400g_150g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_aib2_tx_st_clk_en = "e400g_150g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_aib3_rx_st_clk_en = "e400g_150g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_aib3_tx_st_clk_en = "e400g_150g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_duplex_mode = "e400g_150g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_fec_mode = "e400g_150g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_fec_spec = "e400g_150g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_lpbk_mode = "e400g_150g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_mac_mode = "e400g_150g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_ptp_mode = "e400g_150g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_excvr_gb_ratio_mode = "e400g_150g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_excvr_if_fifo_mode = "e400g_150g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_fec_enable = "e400g_150g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_pcs_mode = "e400g_150g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_primary_use = "e400g_150g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_stream_bonding = "e400g_150g_3_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_xcvr_bonded = "e400g_150g_3_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_rx_xcvr_width = "e400g_150g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_speed_map = "e400g_150g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_sup_mode = "e400g_150g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_sys_clk_src = "e400g_150g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_excvr_gb_ratio_mode = "e400g_150g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_excvr_if_fifo_mode = "e400g_150g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_fec_enable = "e400g_150g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_pcs_mode = "e400g_150g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_primary_use = "e400g_150g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_stream_bonding = "e400g_150g_3_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_xcvr_bonded = "e400g_150g_3_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_tx_xcvr_width = "e400g_150g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_xcvr_type = "e400g_150g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_150g_3_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_aib2_rx_st_clk_en = "e400g_200g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_aib2_tx_st_clk_en = "e400g_200g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_aib3_rx_st_clk_en = "e400g_200g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_aib3_tx_st_clk_en = "e400g_200g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_duplex_mode = "e400g_200g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_fec_clk_src = "e400g_200g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_fec_error = "e400g_200g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_fec_mode = "e400g_200g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_fec_spec = "e400g_200g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_lpbk_mode = "e400g_200g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_mac_mode = "e400g_200g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_ptp_mode = "e400g_200g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_excvr_gb_ratio_mode = "e400g_200g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_excvr_if_fifo_mode = "e400g_200g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_fec_enable = "e400g_200g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_pcs_mode = "e400g_200g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_primary_use = "e400g_200g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_stream_bonding = "e400g_200g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_xcvr_bonded = "e400g_200g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_rx_xcvr_width = "e400g_200g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_speed_map = "e400g_200g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_sup_mode = "e400g_200g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_sys_clk_src = "e400g_200g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_excvr_gb_ratio_mode = "e400g_200g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_excvr_if_fifo_mode = "e400g_200g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_fec_enable = "e400g_200g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_pcs_mode = "e400g_200g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_primary_use = "e400g_200g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_stream_bonding = "e400g_200g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_xcvr_bonded = "e400g_200g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_tx_xcvr_width = "e400g_200g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_xcvr_type = "e400g_200g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_aib2_rx_st_clk_en = "e400g_200g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_aib2_tx_st_clk_en = "e400g_200g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_aib3_rx_st_clk_en = "e400g_200g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_aib3_tx_st_clk_en = "e400g_200g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_duplex_mode = "e400g_200g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_fec_clk_src = "e400g_200g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_fec_error = "e400g_200g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_fec_mode = "e400g_200g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_fec_spec = "e400g_200g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_lpbk_mode = "e400g_200g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_mac_mode = "e400g_200g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_ptp_mode = "e400g_200g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_excvr_gb_ratio_mode = "e400g_200g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_excvr_if_fifo_mode = "e400g_200g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_fec_enable = "e400g_200g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_pcs_mode = "e400g_200g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_primary_use = "e400g_200g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_stream_bonding = "e400g_200g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_xcvr_bonded = "e400g_200g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_rx_xcvr_width = "e400g_200g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_speed_map = "e400g_200g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_sup_mode = "e400g_200g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_sys_clk_src = "e400g_200g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_excvr_gb_ratio_mode = "e400g_200g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_excvr_if_fifo_mode = "e400g_200g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_fec_enable = "e400g_200g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_pcs_mode = "e400g_200g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_primary_use = "e400g_200g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_stream_bonding = "e400g_200g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_xcvr_bonded = "e400g_200g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_tx_xcvr_width = "e400g_200g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_xcvr_type = "e400g_200g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_200g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_aib2_rx_st_clk_en = "e400g_25g_0_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_aib2_tx_st_clk_en = "e400g_25g_0_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_aib3_rx_st_clk_en = "e400g_25g_0_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_aib3_tx_st_clk_en = "e400g_25g_0_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_duplex_mode = "e400g_25g_0_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_fec_clk_src = "e400g_25g_0_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_fec_error = "e400g_25g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_fec_mode = "e400g_25g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_fec_spec = "e400g_25g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_lpbk_mode = "e400g_25g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_mac_mode = "e400g_25g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_ptp_mode = "e400g_25g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_excvr_gb_ratio_mode = "e400g_25g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_excvr_if_fifo_mode = "e400g_25g_0_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_fec_enable = "e400g_25g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_pcs_mode = "e400g_25g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_primary_use = "e400g_25g_0_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_stream_bonding = "e400g_25g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_xcvr_bonded = "e400g_25g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_rx_xcvr_width = "e400g_25g_0_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_speed_map = "e400g_25g_0_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_sup_mode = "e400g_25g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_sys_clk_src = "e400g_25g_0_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_excvr_gb_ratio_mode = "e400g_25g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_excvr_if_fifo_mode = "e400g_25g_0_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_fec_enable = "e400g_25g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_pcs_mode = "e400g_25g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_primary_use = "e400g_25g_0_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_stream_bonding = "e400g_25g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_xcvr_bonded = "e400g_25g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_tx_xcvr_width = "e400g_25g_0_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_xcvr_type = "e400g_25g_0_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_aib2_rx_st_clk_en = "e400g_25g_10_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_aib2_tx_st_clk_en = "e400g_25g_10_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_aib3_rx_st_clk_en = "e400g_25g_10_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_aib3_tx_st_clk_en = "e400g_25g_10_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_duplex_mode = "e400g_25g_10_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_fec_clk_src = "e400g_25g_10_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_fec_error = "e400g_25g_10_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_fec_mode = "e400g_25g_10_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_fec_spec = "e400g_25g_10_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_lpbk_mode = "e400g_25g_10_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_mac_mode = "e400g_25g_10_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_ptp_mode = "e400g_25g_10_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_excvr_gb_ratio_mode = "e400g_25g_10_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_excvr_if_fifo_mode = "e400g_25g_10_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_fec_enable = "e400g_25g_10_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_pcs_mode = "e400g_25g_10_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_primary_use = "e400g_25g_10_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_stream_bonding = "e400g_25g_10_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_xcvr_bonded = "e400g_25g_10_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_rx_xcvr_width = "e400g_25g_10_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_speed_map = "e400g_25g_10_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_sup_mode = "e400g_25g_10_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_sys_clk_src = "e400g_25g_10_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_excvr_gb_ratio_mode = "e400g_25g_10_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_excvr_if_fifo_mode = "e400g_25g_10_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_fec_enable = "e400g_25g_10_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_pcs_mode = "e400g_25g_10_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_primary_use = "e400g_25g_10_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_stream_bonding = "e400g_25g_10_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_xcvr_bonded = "e400g_25g_10_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_tx_xcvr_width = "e400g_25g_10_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_xcvr_type = "e400g_25g_10_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_10_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_aib2_rx_st_clk_en = "e400g_25g_11_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_aib2_tx_st_clk_en = "e400g_25g_11_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_aib3_rx_st_clk_en = "e400g_25g_11_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_aib3_tx_st_clk_en = "e400g_25g_11_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_duplex_mode = "e400g_25g_11_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_fec_clk_src = "e400g_25g_11_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_fec_error = "e400g_25g_11_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_fec_mode = "e400g_25g_11_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_fec_spec = "e400g_25g_11_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_lpbk_mode = "e400g_25g_11_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_mac_mode = "e400g_25g_11_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_ptp_mode = "e400g_25g_11_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_excvr_gb_ratio_mode = "e400g_25g_11_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_excvr_if_fifo_mode = "e400g_25g_11_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_fec_enable = "e400g_25g_11_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_pcs_mode = "e400g_25g_11_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_primary_use = "e400g_25g_11_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_stream_bonding = "e400g_25g_11_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_xcvr_bonded = "e400g_25g_11_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_rx_xcvr_width = "e400g_25g_11_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_speed_map = "e400g_25g_11_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_sup_mode = "e400g_25g_11_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_sys_clk_src = "e400g_25g_11_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_excvr_gb_ratio_mode = "e400g_25g_11_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_excvr_if_fifo_mode = "e400g_25g_11_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_fec_enable = "e400g_25g_11_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_pcs_mode = "e400g_25g_11_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_primary_use = "e400g_25g_11_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_stream_bonding = "e400g_25g_11_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_xcvr_bonded = "e400g_25g_11_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_tx_xcvr_width = "e400g_25g_11_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_xcvr_type = "e400g_25g_11_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_11_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_aib2_rx_st_clk_en = "e400g_25g_12_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_aib2_tx_st_clk_en = "e400g_25g_12_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_aib3_rx_st_clk_en = "e400g_25g_12_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_aib3_tx_st_clk_en = "e400g_25g_12_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_duplex_mode = "e400g_25g_12_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_fec_clk_src = "e400g_25g_12_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_fec_error = "e400g_25g_12_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_fec_mode = "e400g_25g_12_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_fec_spec = "e400g_25g_12_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_lpbk_mode = "e400g_25g_12_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_mac_mode = "e400g_25g_12_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_ptp_mode = "e400g_25g_12_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_excvr_gb_ratio_mode = "e400g_25g_12_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_excvr_if_fifo_mode = "e400g_25g_12_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_fec_enable = "e400g_25g_12_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_pcs_mode = "e400g_25g_12_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_primary_use = "e400g_25g_12_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_stream_bonding = "e400g_25g_12_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_xcvr_bonded = "e400g_25g_12_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_rx_xcvr_width = "e400g_25g_12_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_speed_map = "e400g_25g_12_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_sup_mode = "e400g_25g_12_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_sys_clk_src = "e400g_25g_12_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_excvr_gb_ratio_mode = "e400g_25g_12_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_excvr_if_fifo_mode = "e400g_25g_12_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_fec_enable = "e400g_25g_12_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_pcs_mode = "e400g_25g_12_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_primary_use = "e400g_25g_12_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_stream_bonding = "e400g_25g_12_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_xcvr_bonded = "e400g_25g_12_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_tx_xcvr_width = "e400g_25g_12_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_xcvr_type = "e400g_25g_12_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_12_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_aib2_rx_st_clk_en = "e400g_25g_13_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_aib2_tx_st_clk_en = "e400g_25g_13_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_aib3_rx_st_clk_en = "e400g_25g_13_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_aib3_tx_st_clk_en = "e400g_25g_13_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_duplex_mode = "e400g_25g_13_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_fec_clk_src = "e400g_25g_13_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_fec_error = "e400g_25g_13_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_fec_mode = "e400g_25g_13_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_fec_spec = "e400g_25g_13_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_lpbk_mode = "e400g_25g_13_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_mac_mode = "e400g_25g_13_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_ptp_mode = "e400g_25g_13_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_excvr_gb_ratio_mode = "e400g_25g_13_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_excvr_if_fifo_mode = "e400g_25g_13_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_fec_enable = "e400g_25g_13_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_pcs_mode = "e400g_25g_13_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_primary_use = "e400g_25g_13_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_stream_bonding = "e400g_25g_13_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_xcvr_bonded = "e400g_25g_13_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_rx_xcvr_width = "e400g_25g_13_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_speed_map = "e400g_25g_13_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_sup_mode = "e400g_25g_13_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_sys_clk_src = "e400g_25g_13_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_excvr_gb_ratio_mode = "e400g_25g_13_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_excvr_if_fifo_mode = "e400g_25g_13_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_fec_enable = "e400g_25g_13_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_pcs_mode = "e400g_25g_13_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_primary_use = "e400g_25g_13_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_stream_bonding = "e400g_25g_13_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_xcvr_bonded = "e400g_25g_13_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_tx_xcvr_width = "e400g_25g_13_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_xcvr_type = "e400g_25g_13_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_13_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_aib2_rx_st_clk_en = "e400g_25g_14_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_aib2_tx_st_clk_en = "e400g_25g_14_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_aib3_rx_st_clk_en = "e400g_25g_14_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_aib3_tx_st_clk_en = "e400g_25g_14_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_duplex_mode = "e400g_25g_14_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_fec_clk_src = "e400g_25g_14_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_fec_error = "e400g_25g_14_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_fec_mode = "e400g_25g_14_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_fec_spec = "e400g_25g_14_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_lpbk_mode = "e400g_25g_14_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_mac_mode = "e400g_25g_14_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_ptp_mode = "e400g_25g_14_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_excvr_gb_ratio_mode = "e400g_25g_14_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_excvr_if_fifo_mode = "e400g_25g_14_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_fec_enable = "e400g_25g_14_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_pcs_mode = "e400g_25g_14_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_primary_use = "e400g_25g_14_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_stream_bonding = "e400g_25g_14_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_xcvr_bonded = "e400g_25g_14_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_rx_xcvr_width = "e400g_25g_14_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_speed_map = "e400g_25g_14_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_sup_mode = "e400g_25g_14_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_sys_clk_src = "e400g_25g_14_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_excvr_gb_ratio_mode = "e400g_25g_14_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_excvr_if_fifo_mode = "e400g_25g_14_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_fec_enable = "e400g_25g_14_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_pcs_mode = "e400g_25g_14_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_primary_use = "e400g_25g_14_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_stream_bonding = "e400g_25g_14_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_xcvr_bonded = "e400g_25g_14_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_tx_xcvr_width = "e400g_25g_14_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_xcvr_type = "e400g_25g_14_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_14_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_aib2_rx_st_clk_en = "e400g_25g_15_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_aib2_tx_st_clk_en = "e400g_25g_15_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_aib3_rx_st_clk_en = "e400g_25g_15_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_aib3_tx_st_clk_en = "e400g_25g_15_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_duplex_mode = "e400g_25g_15_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_fec_clk_src = "e400g_25g_15_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_fec_error = "e400g_25g_15_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_fec_mode = "e400g_25g_15_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_fec_spec = "e400g_25g_15_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_lpbk_mode = "e400g_25g_15_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_mac_mode = "e400g_25g_15_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_ptp_mode = "e400g_25g_15_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_excvr_gb_ratio_mode = "e400g_25g_15_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_excvr_if_fifo_mode = "e400g_25g_15_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_fec_enable = "e400g_25g_15_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_pcs_mode = "e400g_25g_15_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_primary_use = "e400g_25g_15_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_stream_bonding = "e400g_25g_15_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_xcvr_bonded = "e400g_25g_15_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_rx_xcvr_width = "e400g_25g_15_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_speed_map = "e400g_25g_15_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_sup_mode = "e400g_25g_15_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_sys_clk_src = "e400g_25g_15_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_excvr_gb_ratio_mode = "e400g_25g_15_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_excvr_if_fifo_mode = "e400g_25g_15_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_fec_enable = "e400g_25g_15_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_pcs_mode = "e400g_25g_15_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_primary_use = "e400g_25g_15_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_stream_bonding = "e400g_25g_15_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_xcvr_bonded = "e400g_25g_15_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_tx_xcvr_width = "e400g_25g_15_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_xcvr_type = "e400g_25g_15_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_15_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_aib2_rx_st_clk_en = "e400g_25g_1_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_aib2_tx_st_clk_en = "e400g_25g_1_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_aib3_rx_st_clk_en = "e400g_25g_1_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_aib3_tx_st_clk_en = "e400g_25g_1_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_duplex_mode = "e400g_25g_1_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_fec_clk_src = "e400g_25g_1_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_fec_error = "e400g_25g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_fec_mode = "e400g_25g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_fec_spec = "e400g_25g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_lpbk_mode = "e400g_25g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_mac_mode = "e400g_25g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_ptp_mode = "e400g_25g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_excvr_gb_ratio_mode = "e400g_25g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_excvr_if_fifo_mode = "e400g_25g_1_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_fec_enable = "e400g_25g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_pcs_mode = "e400g_25g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_primary_use = "e400g_25g_1_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_stream_bonding = "e400g_25g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_xcvr_bonded = "e400g_25g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_rx_xcvr_width = "e400g_25g_1_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_speed_map = "e400g_25g_1_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_sup_mode = "e400g_25g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_sys_clk_src = "e400g_25g_1_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_excvr_gb_ratio_mode = "e400g_25g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_excvr_if_fifo_mode = "e400g_25g_1_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_fec_enable = "e400g_25g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_pcs_mode = "e400g_25g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_primary_use = "e400g_25g_1_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_stream_bonding = "e400g_25g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_xcvr_bonded = "e400g_25g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_tx_xcvr_width = "e400g_25g_1_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_xcvr_type = "e400g_25g_1_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_aib2_rx_st_clk_en = "e400g_25g_2_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_aib2_tx_st_clk_en = "e400g_25g_2_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_aib3_rx_st_clk_en = "e400g_25g_2_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_aib3_tx_st_clk_en = "e400g_25g_2_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_duplex_mode = "e400g_25g_2_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_fec_clk_src = "e400g_25g_2_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_fec_error = "e400g_25g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_fec_mode = "e400g_25g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_fec_spec = "e400g_25g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_lpbk_mode = "e400g_25g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_mac_mode = "e400g_25g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_ptp_mode = "e400g_25g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_excvr_gb_ratio_mode = "e400g_25g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_excvr_if_fifo_mode = "e400g_25g_2_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_fec_enable = "e400g_25g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_pcs_mode = "e400g_25g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_primary_use = "e400g_25g_2_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_stream_bonding = "e400g_25g_2_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_xcvr_bonded = "e400g_25g_2_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_rx_xcvr_width = "e400g_25g_2_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_speed_map = "e400g_25g_2_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_sup_mode = "e400g_25g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_sys_clk_src = "e400g_25g_2_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_excvr_gb_ratio_mode = "e400g_25g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_excvr_if_fifo_mode = "e400g_25g_2_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_fec_enable = "e400g_25g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_pcs_mode = "e400g_25g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_primary_use = "e400g_25g_2_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_stream_bonding = "e400g_25g_2_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_xcvr_bonded = "e400g_25g_2_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_tx_xcvr_width = "e400g_25g_2_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_xcvr_type = "e400g_25g_2_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_2_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_aib2_rx_st_clk_en = "e400g_25g_3_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_aib2_tx_st_clk_en = "e400g_25g_3_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_aib3_rx_st_clk_en = "e400g_25g_3_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_aib3_tx_st_clk_en = "e400g_25g_3_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_duplex_mode = "e400g_25g_3_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_fec_clk_src = "e400g_25g_3_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_fec_error = "e400g_25g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_fec_mode = "e400g_25g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_fec_spec = "e400g_25g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_lpbk_mode = "e400g_25g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_mac_mode = "e400g_25g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_ptp_mode = "e400g_25g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_excvr_gb_ratio_mode = "e400g_25g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_excvr_if_fifo_mode = "e400g_25g_3_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_fec_enable = "e400g_25g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_pcs_mode = "e400g_25g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_primary_use = "e400g_25g_3_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_stream_bonding = "e400g_25g_3_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_xcvr_bonded = "e400g_25g_3_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_rx_xcvr_width = "e400g_25g_3_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_speed_map = "e400g_25g_3_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_sup_mode = "e400g_25g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_sys_clk_src = "e400g_25g_3_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_excvr_gb_ratio_mode = "e400g_25g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_excvr_if_fifo_mode = "e400g_25g_3_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_fec_enable = "e400g_25g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_pcs_mode = "e400g_25g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_primary_use = "e400g_25g_3_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_stream_bonding = "e400g_25g_3_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_xcvr_bonded = "e400g_25g_3_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_tx_xcvr_width = "e400g_25g_3_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_xcvr_type = "e400g_25g_3_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_3_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_aib2_rx_st_clk_en = "e400g_25g_4_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_aib2_tx_st_clk_en = "e400g_25g_4_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_aib3_rx_st_clk_en = "e400g_25g_4_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_aib3_tx_st_clk_en = "e400g_25g_4_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_duplex_mode = "e400g_25g_4_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_fec_clk_src = "e400g_25g_4_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_fec_error = "e400g_25g_4_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_fec_mode = "e400g_25g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_fec_spec = "e400g_25g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_lpbk_mode = "e400g_25g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_mac_mode = "e400g_25g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_ptp_mode = "e400g_25g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_excvr_gb_ratio_mode = "e400g_25g_4_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_excvr_if_fifo_mode = "e400g_25g_4_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_fec_enable = "e400g_25g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_pcs_mode = "e400g_25g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_primary_use = "e400g_25g_4_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_stream_bonding = "e400g_25g_4_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_xcvr_bonded = "e400g_25g_4_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_rx_xcvr_width = "e400g_25g_4_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_speed_map = "e400g_25g_4_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_sup_mode = "e400g_25g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_sys_clk_src = "e400g_25g_4_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_excvr_gb_ratio_mode = "e400g_25g_4_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_excvr_if_fifo_mode = "e400g_25g_4_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_fec_enable = "e400g_25g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_pcs_mode = "e400g_25g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_primary_use = "e400g_25g_4_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_stream_bonding = "e400g_25g_4_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_xcvr_bonded = "e400g_25g_4_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_tx_xcvr_width = "e400g_25g_4_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_xcvr_type = "e400g_25g_4_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_4_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_aib2_rx_st_clk_en = "e400g_25g_5_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_aib2_tx_st_clk_en = "e400g_25g_5_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_aib3_rx_st_clk_en = "e400g_25g_5_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_aib3_tx_st_clk_en = "e400g_25g_5_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_duplex_mode = "e400g_25g_5_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_fec_clk_src = "e400g_25g_5_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_fec_error = "e400g_25g_5_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_fec_mode = "e400g_25g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_fec_spec = "e400g_25g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_lpbk_mode = "e400g_25g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_mac_mode = "e400g_25g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_ptp_mode = "e400g_25g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_excvr_gb_ratio_mode = "e400g_25g_5_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_excvr_if_fifo_mode = "e400g_25g_5_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_fec_enable = "e400g_25g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_pcs_mode = "e400g_25g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_primary_use = "e400g_25g_5_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_stream_bonding = "e400g_25g_5_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_xcvr_bonded = "e400g_25g_5_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_rx_xcvr_width = "e400g_25g_5_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_speed_map = "e400g_25g_5_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_sup_mode = "e400g_25g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_sys_clk_src = "e400g_25g_5_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_excvr_gb_ratio_mode = "e400g_25g_5_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_excvr_if_fifo_mode = "e400g_25g_5_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_fec_enable = "e400g_25g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_pcs_mode = "e400g_25g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_primary_use = "e400g_25g_5_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_stream_bonding = "e400g_25g_5_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_xcvr_bonded = "e400g_25g_5_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_tx_xcvr_width = "e400g_25g_5_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_xcvr_type = "e400g_25g_5_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_5_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_aib2_rx_st_clk_en = "e400g_25g_6_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_aib2_tx_st_clk_en = "e400g_25g_6_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_aib3_rx_st_clk_en = "e400g_25g_6_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_aib3_tx_st_clk_en = "e400g_25g_6_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_duplex_mode = "e400g_25g_6_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_fec_clk_src = "e400g_25g_6_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_fec_error = "e400g_25g_6_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_fec_mode = "e400g_25g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_fec_spec = "e400g_25g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_lpbk_mode = "e400g_25g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_mac_mode = "e400g_25g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_ptp_mode = "e400g_25g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_excvr_gb_ratio_mode = "e400g_25g_6_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_excvr_if_fifo_mode = "e400g_25g_6_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_fec_enable = "e400g_25g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_pcs_mode = "e400g_25g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_primary_use = "e400g_25g_6_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_stream_bonding = "e400g_25g_6_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_xcvr_bonded = "e400g_25g_6_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_rx_xcvr_width = "e400g_25g_6_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_speed_map = "e400g_25g_6_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_sup_mode = "e400g_25g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_sys_clk_src = "e400g_25g_6_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_excvr_gb_ratio_mode = "e400g_25g_6_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_excvr_if_fifo_mode = "e400g_25g_6_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_fec_enable = "e400g_25g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_pcs_mode = "e400g_25g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_primary_use = "e400g_25g_6_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_stream_bonding = "e400g_25g_6_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_xcvr_bonded = "e400g_25g_6_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_tx_xcvr_width = "e400g_25g_6_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_xcvr_type = "e400g_25g_6_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_6_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_aib2_rx_st_clk_en = "e400g_25g_7_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_aib2_tx_st_clk_en = "e400g_25g_7_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_aib3_rx_st_clk_en = "e400g_25g_7_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_aib3_tx_st_clk_en = "e400g_25g_7_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_duplex_mode = "e400g_25g_7_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_fec_clk_src = "e400g_25g_7_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_fec_error = "e400g_25g_7_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_fec_mode = "e400g_25g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_fec_spec = "e400g_25g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_lpbk_mode = "e400g_25g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_mac_mode = "e400g_25g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_ptp_mode = "e400g_25g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_excvr_gb_ratio_mode = "e400g_25g_7_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_excvr_if_fifo_mode = "e400g_25g_7_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_fec_enable = "e400g_25g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_pcs_mode = "e400g_25g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_primary_use = "e400g_25g_7_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_stream_bonding = "e400g_25g_7_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_xcvr_bonded = "e400g_25g_7_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_rx_xcvr_width = "e400g_25g_7_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_speed_map = "e400g_25g_7_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_sup_mode = "e400g_25g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_sys_clk_src = "e400g_25g_7_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_excvr_gb_ratio_mode = "e400g_25g_7_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_excvr_if_fifo_mode = "e400g_25g_7_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_fec_enable = "e400g_25g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_pcs_mode = "e400g_25g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_primary_use = "e400g_25g_7_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_stream_bonding = "e400g_25g_7_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_xcvr_bonded = "e400g_25g_7_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_tx_xcvr_width = "e400g_25g_7_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_xcvr_type = "e400g_25g_7_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_7_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_aib2_rx_st_clk_en = "e400g_25g_8_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_aib2_tx_st_clk_en = "e400g_25g_8_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_aib3_rx_st_clk_en = "e400g_25g_8_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_aib3_tx_st_clk_en = "e400g_25g_8_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_duplex_mode = "e400g_25g_8_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_fec_clk_src = "e400g_25g_8_fec_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_fec_error = "e400g_25g_8_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_fec_mode = "e400g_25g_8_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_fec_spec = "e400g_25g_8_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_lpbk_mode = "e400g_25g_8_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_mac_mode = "e400g_25g_8_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_ptp_mode = "e400g_25g_8_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_excvr_gb_ratio_mode = "e400g_25g_8_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_excvr_if_fifo_mode = "e400g_25g_8_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_fec_enable = "e400g_25g_8_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_pcs_mode = "e400g_25g_8_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_primary_use = "e400g_25g_8_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_stream_bonding = "e400g_25g_8_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_xcvr_bonded = "e400g_25g_8_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_rx_xcvr_width = "e400g_25g_8_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_speed_map = "e400g_25g_8_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_sup_mode = "e400g_25g_8_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_sys_clk_src = "e400g_25g_8_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_excvr_gb_ratio_mode = "e400g_25g_8_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_excvr_if_fifo_mode = "e400g_25g_8_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_fec_enable = "e400g_25g_8_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_pcs_mode = "e400g_25g_8_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_primary_use = "e400g_25g_8_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_stream_bonding = "e400g_25g_8_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_xcvr_bonded = "e400g_25g_8_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_tx_xcvr_width = "e400g_25g_8_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_xcvr_type = "e400g_25g_8_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_8_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_aib2_rx_st_clk_en = "e400g_25g_9_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_aib2_tx_st_clk_en = "e400g_25g_9_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_aib3_rx_st_clk_en = "e400g_25g_9_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_aib3_tx_st_clk_en = "e400g_25g_9_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_duplex_mode = "e400g_25g_9_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_fec_clk_src = "e400g_25g_9_fec_clk_src_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_fec_error = "e400g_25g_9_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_fec_mode = "e400g_25g_9_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_fec_spec = "e400g_25g_9_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_lpbk_mode = "e400g_25g_9_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_mac_mode = "e400g_25g_9_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_ptp_mode = "e400g_25g_9_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_excvr_gb_ratio_mode = "e400g_25g_9_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_excvr_if_fifo_mode = "e400g_25g_9_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_fec_enable = "e400g_25g_9_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_pcs_mode = "e400g_25g_9_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_primary_use = "e400g_25g_9_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_stream_bonding = "e400g_25g_9_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_xcvr_bonded = "e400g_25g_9_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_rx_xcvr_width = "e400g_25g_9_rx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_speed_map = "e400g_25g_9_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_sup_mode = "e400g_25g_9_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_sys_clk_src = "e400g_25g_9_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_datarate = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_excvr_gb_ratio_mode = "e400g_25g_9_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_excvr_if_fifo_mode = "e400g_25g_9_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_fec_enable = "e400g_25g_9_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_pcs_mode = "e400g_25g_9_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_primary_use = "e400g_25g_9_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_stream_bonding = "e400g_25g_9_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_xcvr_bonded = "e400g_25g_9_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_tx_xcvr_width = "e400g_25g_9_tx_xcvr_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_xcvr_type = "e400g_25g_9_xcvr_type_ux";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_25g_9_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_aib2_rx_st_clk_en = "e400g_300g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_aib2_tx_st_clk_en = "e400g_300g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_aib3_rx_st_clk_en = "e400g_300g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_aib3_tx_st_clk_en = "e400g_300g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_duplex_mode = "e400g_300g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_fec_mode = "e400g_300g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_fec_spec = "e400g_300g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_lpbk_mode = "e400g_300g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_mac_mode = "e400g_300g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_ptp_mode = "e400g_300g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_excvr_gb_ratio_mode = "e400g_300g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_excvr_if_fifo_mode = "e400g_300g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_fec_enable = "e400g_300g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_pcs_mode = "e400g_300g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_primary_use = "e400g_300g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_stream_bonding = "e400g_300g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_xcvr_bonded = "e400g_300g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_rx_xcvr_width = "e400g_300g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_speed_map = "e400g_300g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_sup_mode = "e400g_300g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_sys_clk_src = "e400g_300g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_excvr_gb_ratio_mode = "e400g_300g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_excvr_if_fifo_mode = "e400g_300g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_fec_enable = "e400g_300g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_pcs_mode = "e400g_300g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_primary_use = "e400g_300g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_stream_bonding = "e400g_300g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_xcvr_bonded = "e400g_300g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_tx_xcvr_width = "e400g_300g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_xcvr_type = "e400g_300g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_aib2_rx_st_clk_en = "e400g_300g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_aib2_tx_st_clk_en = "e400g_300g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_aib3_rx_st_clk_en = "e400g_300g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_aib3_tx_st_clk_en = "e400g_300g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_duplex_mode = "e400g_300g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_fec_mode = "e400g_300g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_fec_spec = "e400g_300g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_lpbk_mode = "e400g_300g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_mac_mode = "e400g_300g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_ptp_mode = "e400g_300g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_excvr_gb_ratio_mode = "e400g_300g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_excvr_if_fifo_mode = "e400g_300g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_fec_enable = "e400g_300g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_pcs_mode = "e400g_300g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_primary_use = "e400g_300g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_stream_bonding = "e400g_300g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_xcvr_bonded = "e400g_300g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_rx_xcvr_width = "e400g_300g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_speed_map = "e400g_300g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_sup_mode = "e400g_300g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_sys_clk_src = "e400g_300g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_excvr_gb_ratio_mode = "e400g_300g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_excvr_if_fifo_mode = "e400g_300g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_fec_enable = "e400g_300g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_pcs_mode = "e400g_300g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_primary_use = "e400g_300g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_stream_bonding = "e400g_300g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_xcvr_bonded = "e400g_300g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_tx_xcvr_width = "e400g_300g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_xcvr_type = "e400g_300g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_300g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_aib2_rx_st_clk_en = "e400g_400g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_aib2_tx_st_clk_en = "e400g_400g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_aib3_rx_st_clk_en = "e400g_400g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_aib3_tx_st_clk_en = "e400g_400g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_duplex_mode = "e400g_400g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_fec_clk_src = "e400g_400g_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_fec_error = "e400g_400g_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_fec_mode = "e400g_400g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_fec_spec = "e400g_400g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_lpbk_mode = "e400g_400g_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_mac_mode = "e400g_400g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_ptp_mode = "e400g_400g_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_excvr_gb_ratio_mode = "e400g_400g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_excvr_if_fifo_mode = "e400g_400g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_fec_enable = "e400g_400g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_pcs_mode = "e400g_400g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_primary_use = "e400g_400g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_stream_bonding = "e400g_400g_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_xcvr_bonded = "e400g_400g_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_rx_xcvr_width = "e400g_400g_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_speed_map = "e400g_400g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_sup_mode = "e400g_400g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_sys_clk_src = "e400g_400g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_excvr_gb_ratio_mode = "e400g_400g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_excvr_if_fifo_mode = "e400g_400g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_fec_enable = "e400g_400g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_pcs_mode = "e400g_400g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_primary_use = "e400g_400g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_stream_bonding = "e400g_400g_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_xcvr_bonded = "e400g_400g_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_tx_xcvr_width = "e400g_400g_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_xcvr_type = "e400g_400g_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_400g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_aib2_rx_st_clk_en = "e400g_50g_0_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_aib2_tx_st_clk_en = "e400g_50g_0_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_aib3_rx_st_clk_en = "e400g_50g_0_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_aib3_tx_st_clk_en = "e400g_50g_0_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_duplex_mode = "e400g_50g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_fec_clk_src = "e400g_50g_0_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_fec_error = "e400g_50g_0_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_fec_mode = "e400g_50g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_fec_spec = "e400g_50g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_lpbk_mode = "e400g_50g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_mac_mode = "e400g_50g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_ptp_mode = "e400g_50g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_excvr_gb_ratio_mode = "e400g_50g_0_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_excvr_if_fifo_mode = "e400g_50g_0_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_fec_enable = "e400g_50g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_pcs_mode = "e400g_50g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_primary_use = "e400g_50g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_stream_bonding = "e400g_50g_0_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_xcvr_bonded = "e400g_50g_0_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_rx_xcvr_width = "e400g_50g_0_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_speed_map = "e400g_50g_0_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_sup_mode = "e400g_50g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_sys_clk_src = "e400g_50g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_excvr_gb_ratio_mode = "e400g_50g_0_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_excvr_if_fifo_mode = "e400g_50g_0_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_fec_enable = "e400g_50g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_pcs_mode = "e400g_50g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_primary_use = "e400g_50g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_stream_bonding = "e400g_50g_0_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_xcvr_bonded = "e400g_50g_0_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_tx_xcvr_width = "e400g_50g_0_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_xcvr_type = "e400g_50g_0_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_0_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_aib2_rx_st_clk_en = "e400g_50g_1_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_aib2_tx_st_clk_en = "e400g_50g_1_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_aib3_rx_st_clk_en = "e400g_50g_1_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_aib3_tx_st_clk_en = "e400g_50g_1_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_duplex_mode = "e400g_50g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_fec_clk_src = "e400g_50g_1_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_fec_error = "e400g_50g_1_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_fec_mode = "e400g_50g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_fec_spec = "e400g_50g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_lpbk_mode = "e400g_50g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_mac_mode = "e400g_50g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_ptp_mode = "e400g_50g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_excvr_gb_ratio_mode = "e400g_50g_1_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_excvr_if_fifo_mode = "e400g_50g_1_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_fec_enable = "e400g_50g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_pcs_mode = "e400g_50g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_primary_use = "e400g_50g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_stream_bonding = "e400g_50g_1_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_xcvr_bonded = "e400g_50g_1_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_rx_xcvr_width = "e400g_50g_1_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_speed_map = "e400g_50g_1_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_sup_mode = "e400g_50g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_sys_clk_src = "e400g_50g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_excvr_gb_ratio_mode = "e400g_50g_1_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_excvr_if_fifo_mode = "e400g_50g_1_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_fec_enable = "e400g_50g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_pcs_mode = "e400g_50g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_primary_use = "e400g_50g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_stream_bonding = "e400g_50g_1_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_xcvr_bonded = "e400g_50g_1_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_tx_xcvr_width = "e400g_50g_1_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_xcvr_type = "e400g_50g_1_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_1_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_aib2_rx_st_clk_en = "e400g_50g_2_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_aib2_tx_st_clk_en = "e400g_50g_2_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_aib3_rx_st_clk_en = "e400g_50g_2_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_aib3_tx_st_clk_en = "e400g_50g_2_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_duplex_mode = "e400g_50g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_fec_clk_src = "e400g_50g_2_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_fec_error = "e400g_50g_2_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_fec_mode = "e400g_50g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_fec_spec = "e400g_50g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_lpbk_mode = "e400g_50g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_mac_mode = "e400g_50g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_ptp_mode = "e400g_50g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_excvr_gb_ratio_mode = "e400g_50g_2_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_excvr_if_fifo_mode = "e400g_50g_2_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_fec_enable = "e400g_50g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_pcs_mode = "e400g_50g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_primary_use = "e400g_50g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_stream_bonding = "e400g_50g_2_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_xcvr_bonded = "e400g_50g_2_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_rx_xcvr_width = "e400g_50g_2_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_speed_map = "e400g_50g_2_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_sup_mode = "e400g_50g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_sys_clk_src = "e400g_50g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_excvr_gb_ratio_mode = "e400g_50g_2_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_excvr_if_fifo_mode = "e400g_50g_2_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_fec_enable = "e400g_50g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_pcs_mode = "e400g_50g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_primary_use = "e400g_50g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_stream_bonding = "e400g_50g_2_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_xcvr_bonded = "e400g_50g_2_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_tx_xcvr_width = "e400g_50g_2_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_xcvr_type = "e400g_50g_2_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_2_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_aib2_rx_st_clk_en = "e400g_50g_3_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_aib2_tx_st_clk_en = "e400g_50g_3_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_aib3_rx_st_clk_en = "e400g_50g_3_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_aib3_tx_st_clk_en = "e400g_50g_3_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_duplex_mode = "e400g_50g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_fec_clk_src = "e400g_50g_3_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_fec_error = "e400g_50g_3_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_fec_mode = "e400g_50g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_fec_spec = "e400g_50g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_lpbk_mode = "e400g_50g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_mac_mode = "e400g_50g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_ptp_mode = "e400g_50g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_excvr_gb_ratio_mode = "e400g_50g_3_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_excvr_if_fifo_mode = "e400g_50g_3_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_fec_enable = "e400g_50g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_pcs_mode = "e400g_50g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_primary_use = "e400g_50g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_stream_bonding = "e400g_50g_3_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_xcvr_bonded = "e400g_50g_3_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_rx_xcvr_width = "e400g_50g_3_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_speed_map = "e400g_50g_3_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_sup_mode = "e400g_50g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_sys_clk_src = "e400g_50g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_excvr_gb_ratio_mode = "e400g_50g_3_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_excvr_if_fifo_mode = "e400g_50g_3_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_fec_enable = "e400g_50g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_pcs_mode = "e400g_50g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_primary_use = "e400g_50g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_stream_bonding = "e400g_50g_3_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_xcvr_bonded = "e400g_50g_3_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_tx_xcvr_width = "e400g_50g_3_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_xcvr_type = "e400g_50g_3_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_3_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_aib2_rx_st_clk_en = "e400g_50g_4_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_aib2_tx_st_clk_en = "e400g_50g_4_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_aib3_rx_st_clk_en = "e400g_50g_4_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_aib3_tx_st_clk_en = "e400g_50g_4_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_duplex_mode = "e400g_50g_4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_fec_clk_src = "e400g_50g_4_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_fec_error = "e400g_50g_4_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_fec_mode = "e400g_50g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_fec_spec = "e400g_50g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_lpbk_mode = "e400g_50g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_mac_mode = "e400g_50g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_ptp_mode = "e400g_50g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_excvr_gb_ratio_mode = "e400g_50g_4_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_excvr_if_fifo_mode = "e400g_50g_4_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_fec_enable = "e400g_50g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_pcs_mode = "e400g_50g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_primary_use = "e400g_50g_4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_stream_bonding = "e400g_50g_4_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_xcvr_bonded = "e400g_50g_4_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_rx_xcvr_width = "e400g_50g_4_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_speed_map = "e400g_50g_4_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_sup_mode = "e400g_50g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_sys_clk_src = "e400g_50g_4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_excvr_gb_ratio_mode = "e400g_50g_4_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_excvr_if_fifo_mode = "e400g_50g_4_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_fec_enable = "e400g_50g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_pcs_mode = "e400g_50g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_primary_use = "e400g_50g_4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_stream_bonding = "e400g_50g_4_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_xcvr_bonded = "e400g_50g_4_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_tx_xcvr_width = "e400g_50g_4_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_xcvr_type = "e400g_50g_4_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_4_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_aib2_rx_st_clk_en = "e400g_50g_5_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_aib2_tx_st_clk_en = "e400g_50g_5_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_aib3_rx_st_clk_en = "e400g_50g_5_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_aib3_tx_st_clk_en = "e400g_50g_5_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_duplex_mode = "e400g_50g_5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_fec_clk_src = "e400g_50g_5_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_fec_error = "e400g_50g_5_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_fec_mode = "e400g_50g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_fec_spec = "e400g_50g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_lpbk_mode = "e400g_50g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_mac_mode = "e400g_50g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_ptp_mode = "e400g_50g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_excvr_gb_ratio_mode = "e400g_50g_5_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_excvr_if_fifo_mode = "e400g_50g_5_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_fec_enable = "e400g_50g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_pcs_mode = "e400g_50g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_primary_use = "e400g_50g_5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_stream_bonding = "e400g_50g_5_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_xcvr_bonded = "e400g_50g_5_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_rx_xcvr_width = "e400g_50g_5_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_speed_map = "e400g_50g_5_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_sup_mode = "e400g_50g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_sys_clk_src = "e400g_50g_5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_excvr_gb_ratio_mode = "e400g_50g_5_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_excvr_if_fifo_mode = "e400g_50g_5_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_fec_enable = "e400g_50g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_pcs_mode = "e400g_50g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_primary_use = "e400g_50g_5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_stream_bonding = "e400g_50g_5_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_xcvr_bonded = "e400g_50g_5_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_tx_xcvr_width = "e400g_50g_5_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_xcvr_type = "e400g_50g_5_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_5_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_aib2_rx_st_clk_en = "e400g_50g_6_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_aib2_tx_st_clk_en = "e400g_50g_6_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_aib3_rx_st_clk_en = "e400g_50g_6_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_aib3_tx_st_clk_en = "e400g_50g_6_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_duplex_mode = "e400g_50g_6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_fec_clk_src = "e400g_50g_6_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_fec_error = "e400g_50g_6_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_fec_mode = "e400g_50g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_fec_spec = "e400g_50g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_lpbk_mode = "e400g_50g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_mac_mode = "e400g_50g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_ptp_mode = "e400g_50g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_excvr_gb_ratio_mode = "e400g_50g_6_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_excvr_if_fifo_mode = "e400g_50g_6_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_fec_enable = "e400g_50g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_pcs_mode = "e400g_50g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_primary_use = "e400g_50g_6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_stream_bonding = "e400g_50g_6_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_xcvr_bonded = "e400g_50g_6_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_rx_xcvr_width = "e400g_50g_6_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_speed_map = "e400g_50g_6_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_sup_mode = "e400g_50g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_sys_clk_src = "e400g_50g_6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_excvr_gb_ratio_mode = "e400g_50g_6_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_excvr_if_fifo_mode = "e400g_50g_6_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_fec_enable = "e400g_50g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_pcs_mode = "e400g_50g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_primary_use = "e400g_50g_6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_stream_bonding = "e400g_50g_6_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_xcvr_bonded = "e400g_50g_6_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_tx_xcvr_width = "e400g_50g_6_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_xcvr_type = "e400g_50g_6_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_6_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_aib2_rx_st_clk_en = "e400g_50g_7_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_aib2_tx_st_clk_en = "e400g_50g_7_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_aib3_rx_st_clk_en = "e400g_50g_7_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_aib3_tx_st_clk_en = "e400g_50g_7_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_duplex_mode = "e400g_50g_7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_fec_clk_src = "e400g_50g_7_fec_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_fec_error = "e400g_50g_7_fec_error_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_fec_mode = "e400g_50g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_fec_spec = "e400g_50g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_is_fec_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_is_ptp_part_of_reconfig = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_lpbk_mode = "e400g_50g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_mac_mode = "e400g_50g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_ptp_mode = "e400g_50g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_excvr_gb_ratio_mode = "e400g_50g_7_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_excvr_if_fifo_mode = "e400g_50g_7_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_fec_enable = "e400g_50g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_pcs_mode = "e400g_50g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_primary_use = "e400g_50g_7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_stream_bonding = "e400g_50g_7_rx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_xcvr_bonded = "e400g_50g_7_rx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_rx_xcvr_width = "e400g_50g_7_rx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_speed_map = "e400g_50g_7_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_sup_mode = "e400g_50g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_sys_clk_src = "e400g_50g_7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_datarate = 1000000000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_excvr_gb_ratio_mode = "e400g_50g_7_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_excvr_if_fifo_mode = "e400g_50g_7_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_fec_enable = "e400g_50g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_pcs_mode = "e400g_50g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_primary_use = "e400g_50g_7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_stream_bonding = "e400g_50g_7_tx_stream_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_system_bonding = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_xcvr_bond_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_xcvr_bonded = "e400g_50g_7_tx_xcvr_bonded_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_tx_xcvr_width = "e400g_50g_7_tx_xcvr_width_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_xcvr_type = "e400g_50g_7_xcvr_type_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_50g_7_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_ptp0_aib2_div2_clk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_ptp1_aib2_div2_clk = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream0_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream0_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream0_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream0_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream10_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream10_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream10_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream10_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream11_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream11_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream11_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream11_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream12_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream12_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream12_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream12_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream13_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream13_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream13_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream13_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream14_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream14_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream14_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream14_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream15_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream15_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream15_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream15_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream1_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream1_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream1_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream1_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream2_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream2_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream2_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream2_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream3_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream3_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream3_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream3_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream4_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream4_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream4_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream4_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream5_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream5_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream5_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream5_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream6_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream6_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream6_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream6_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream7_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream7_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream7_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream7_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream8_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream8_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream8_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream8_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream9_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream9_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream9_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__e400g_stream9_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__func_mode = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_aib2_rx_st_clk_en = "e400g_100g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_aib2_tx_st_clk_en = "e400g_100g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_aib3_rx_st_clk_en = "e400g_100g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_aib3_tx_st_clk_en = "e400g_100g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_duplex_mode = "e400g_100g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_fec_mode = "e400g_100g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_fec_spec = "e400g_100g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_mac_mode = "e400g_100g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_excvr_gb_ratio_mode = "e400g_100g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_excvr_if_fifo_mode = "e400g_100g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_fec_enable = "e400g_100g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_pcs_mode = "e400g_100g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_rx_primary_use = "e400g_100g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_speed_map = "e400g_100g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_sup_mode = "e400g_100g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_sys_clk_src = "e400g_100g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_excvr_gb_ratio_mode = "e400g_100g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_excvr_if_fifo_mode = "e400g_100g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_fec_enable = "e400g_100g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_pcs_mode = "e400g_100g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_tx_primary_use = "e400g_100g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__e400g_100g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_aib2_rx_st_clk_en = "e400g_100g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_aib2_tx_st_clk_en = "e400g_100g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_aib3_rx_st_clk_en = "e400g_100g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_aib3_tx_st_clk_en = "e400g_100g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_duplex_mode = "e400g_100g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_fec_mode = "e400g_100g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_fec_spec = "e400g_100g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_mac_mode = "e400g_100g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_excvr_gb_ratio_mode = "e400g_100g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_excvr_if_fifo_mode = "e400g_100g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_fec_enable = "e400g_100g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_pcs_mode = "e400g_100g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_rx_primary_use = "e400g_100g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_speed_map = "e400g_100g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_sup_mode = "e400g_100g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_sys_clk_src = "e400g_100g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_excvr_gb_ratio_mode = "e400g_100g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_excvr_if_fifo_mode = "e400g_100g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_fec_enable = "e400g_100g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_pcs_mode = "e400g_100g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_tx_primary_use = "e400g_100g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__e400g_100g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch12__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_aib2_rx_st_clk_en = "e400g_100g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_aib2_tx_st_clk_en = "e400g_100g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_aib3_rx_st_clk_en = "e400g_100g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_aib3_tx_st_clk_en = "e400g_100g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_duplex_mode = "e400g_100g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_fec_mode = "e400g_100g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_fec_spec = "e400g_100g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_mac_mode = "e400g_100g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_excvr_gb_ratio_mode = "e400g_100g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_excvr_if_fifo_mode = "e400g_100g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_fec_enable = "e400g_100g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_pcs_mode = "e400g_100g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_rx_primary_use = "e400g_100g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_speed_map = "e400g_100g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_sup_mode = "e400g_100g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_sys_clk_src = "e400g_100g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_excvr_gb_ratio_mode = "e400g_100g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_excvr_if_fifo_mode = "e400g_100g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_fec_enable = "e400g_100g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_pcs_mode = "e400g_100g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_tx_primary_use = "e400g_100g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__e400g_100g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch4__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_aib2_rx_st_clk_en = "e400g_100g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_aib2_tx_st_clk_en = "e400g_100g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_aib3_rx_st_clk_en = "e400g_100g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_aib3_tx_st_clk_en = "e400g_100g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_duplex_mode = "e400g_100g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_fec_mode = "e400g_100g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_fec_spec = "e400g_100g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_mac_mode = "e400g_100g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_excvr_gb_ratio_mode = "e400g_100g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_excvr_if_fifo_mode = "e400g_100g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_fec_enable = "e400g_100g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_pcs_mode = "e400g_100g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_rx_primary_use = "e400g_100g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_speed_map = "e400g_100g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_sup_mode = "e400g_100g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_sys_clk_src = "e400g_100g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_excvr_gb_ratio_mode = "e400g_100g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_excvr_if_fifo_mode = "e400g_100g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_fec_enable = "e400g_100g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_pcs_mode = "e400g_100g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_tx_primary_use = "e400g_100g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__e400g_100g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e100g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_aib2_rx_st_clk_en = "e400g_200g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_aib2_tx_st_clk_en = "e400g_200g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_aib3_rx_st_clk_en = "e400g_200g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_aib3_tx_st_clk_en = "e400g_200g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_duplex_mode = "e400g_200g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_fec_mode = "e400g_200g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_fec_spec = "e400g_200g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_mac_mode = "e400g_200g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_excvr_gb_ratio_mode = "e400g_200g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_excvr_if_fifo_mode = "e400g_200g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_fec_enable = "e400g_200g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_pcs_mode = "e400g_200g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_rx_primary_use = "e400g_200g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_speed_map = "e400g_200g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_sup_mode = "e400g_200g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_sys_clk_src = "e400g_200g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_excvr_gb_ratio_mode = "e400g_200g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_excvr_if_fifo_mode = "e400g_200g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_fec_enable = "e400g_200g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_pcs_mode = "e400g_200g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_tx_primary_use = "e400g_200g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__e400g_200g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_aib2_rx_st_clk_en = "e400g_200g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_aib2_tx_st_clk_en = "e400g_200g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_aib3_rx_st_clk_en = "e400g_200g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_aib3_tx_st_clk_en = "e400g_200g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_duplex_mode = "e400g_200g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_fec_mode = "e400g_200g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_fec_spec = "e400g_200g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_mac_mode = "e400g_200g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_excvr_gb_ratio_mode = "e400g_200g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_excvr_if_fifo_mode = "e400g_200g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_fec_enable = "e400g_200g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_pcs_mode = "e400g_200g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_rx_primary_use = "e400g_200g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_speed_map = "e400g_200g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_sup_mode = "e400g_200g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_sys_clk_src = "e400g_200g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_excvr_gb_ratio_mode = "e400g_200g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_excvr_if_fifo_mode = "e400g_200g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_fec_enable = "e400g_200g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_pcs_mode = "e400g_200g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_tx_primary_use = "e400g_200g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__e400g_200g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cfg_frac = "frac_ln8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e200g_reg_ch8__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch11__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch13__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch15__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch1__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch3__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch5__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch7__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_aib2_rx_st_clk_en = "e400g_25g_aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_aib2_tx_st_clk_en = "e400g_25g_aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_aib3_rx_st_clk_en = "e400g_25g_aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_aib3_tx_st_clk_en = "e400g_25g_aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_duplex_mode = "e400g_25g_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_fec_mode = "e400g_25g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_fec_spec = "e400g_25g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_mac_mode = "e400g_25g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_excvr_gb_ratio_mode = "e400g_25g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_excvr_if_fifo_mode = "e400g_25g_rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_fec_enable = "e400g_25g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_pcs_mode = "e400g_25g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_rx_primary_use = "e400g_25g_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_speed_map = "e400g_25g_speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_sup_mode = "e400g_25g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_sys_clk_src = "e400g_25g_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_excvr_gb_ratio_mode = "e400g_25g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_excvr_if_fifo_mode = "e400g_25g_tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_fec_enable = "e400g_25g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_pcs_mode = "e400g_25g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_tx_primary_use = "e400g_25g_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__e400g_25g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_rx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_tx_word_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln1111";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_pll0_div2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_map_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_ux_intlv2_en = "rx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_intlv2_en = "tx_ux_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e25g_reg_ch9__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_aib2_rx_st_clk_en = "e400g_400g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_aib2_tx_st_clk_en = "e400g_400g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_aib3_rx_st_clk_en = "e400g_400g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_aib3_tx_st_clk_en = "e400g_400g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_duplex_mode = "e400g_400g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_fec_mode = "e400g_400g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_fec_spec = "e400g_400g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_mac_mode = "e400g_400g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_excvr_gb_ratio_mode = "e400g_400g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_excvr_if_fifo_mode = "e400g_400g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_fec_enable = "e400g_400g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_pcs_mode = "e400g_400g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_rx_primary_use = "e400g_400g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_speed_map = "e400g_400g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_sup_mode = "e400g_400g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_sys_clk_src = "e400g_400g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_excvr_gb_ratio_mode = "e400g_400g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_excvr_if_fifo_mode = "e400g_400g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_fec_enable = "e400g_400g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_pcs_mode = "e400g_400g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_tx_primary_use = "e400g_400g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__e400g_400g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s10__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s11__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s12__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s13__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s14__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s15__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s2__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s3__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s4__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s5__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s6__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s7__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s8__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cfg_frac = "frac_ln16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvr_sel = "bk_sel_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e400g_reg_ch0__gdr_lphy_e25g_reg_base_s9__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch0__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch10__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch12__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch14__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch2__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch4__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch6__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_aib2_rx_st_clk_en = "e400g_50g_aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_aib2_tx_st_clk_en = "e400g_50g_aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_aib3_rx_st_clk_en = "e400g_50g_aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_aib3_tx_st_clk_en = "e400g_50g_aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_duplex_mode = "e400g_50g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_fec_802p3ck = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_fec_mode = "e400g_50g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_fec_spec = "e400g_50g_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_mac_mode = "e400g_50g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_excvr_gb_ratio_mode = "e400g_50g_rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_excvr_if_fifo_mode = "e400g_50g_rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_fec_enable = "e400g_50g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_pcs_mode = "e400g_50g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_rx_primary_use = "e400g_50g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_speed_map = "e400g_50g_speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_sup_mode = "e400g_50g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_sys_clk_src = "e400g_50g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_excvr_gb_ratio_mode = "e400g_50g_tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_excvr_if_fifo_mode = "e400g_50g_tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_fec_enable = "e400g_50g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_pcs_mode = "e400g_50g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_tx_primary_use = "e400g_50g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_xcvrif_force_signal_ok = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__e400g_50g_xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s0__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib1_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib1_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_en = "aib2_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_en = "aib2_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib2_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_en = "aib3_rx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_en = "aib3_tx_st_clk_en_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__aib3_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_ld_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rd_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__am_sf_tx_rsr_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__bk_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__bk_tx_rtrn_clk_sel = "bk3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_fec_rx_rst = "unused_cfg_fec_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_fec_tx_rst = "unused_cfg_fec_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_frac = "frac_ln112";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_rx_rst = "unused_cfg_xcvrif_rx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cfg_xcvrif_tx_rst = "unused_cfg_xcvrif_tx_rst";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_1st = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_2nd = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__custom_log2mrk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cw_locking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__cw_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_activate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_deactivate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__degrade_ser_interval = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__disable_3_bad_fec = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__disable_scrambling = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dual_fec_am_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__dual_fec_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_2lane_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_enter_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_exit_align = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_intrlv = "intrlv_bit";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eng_test = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engam5baddis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engblkchkdis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engcons25g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__engswaps = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__err_inj_tx_pat = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__err_inj_tx_rate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eth_rx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__eth_tx_st_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_bypass_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_data_mux = "sel_aib";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_rx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_sel = "rs528";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fec_tx_core_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__fibre_channel = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__inv_uniq_am_pat = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__join_lanes = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_aib_esys_clk_sel = "txtrans_ptp0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_csr_ret_bond = "disable_bond";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_dfd_csr_ctrl = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_eth_ptp0_clk = "aib1_ptp_st0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_eth_triangle_en = "eth_triangle_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_last_reg_dummy = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_ptp_st0_clk_sel = "pll0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_clk_sel1 = "ux_rx_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel1 = "ux_rx_user_clk_sel1_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel2 = "rx_user_clk_sel2_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_rx_user_clk_sel3 = "rx_user_clk_sel3_rxword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel1 = "local_esys_clk_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel2 = "bond_tx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_clk_sel3 = "aib1_tx_xcvr";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_div2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel1 = "pll0_div1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel2 = "tx_user_clk_sel2_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__lphy_tx_user_clk_sel3 = "tx_user_clk_sel3_txword";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ptp_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_excvr_gb_ratio_mode = "rx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_excvr_if_fifo_mode = "rx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_hold = "unused_rx_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_empty_inten = "unused_rx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_hold = "unused_rx_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_full_inten = "unused_rx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_hold = "unused_rx_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_overflow_inten = "unused_rx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_hold = "unused_rx_fifo_pmepty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pempty_inten = "unused_rx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_hold = "unused_rx_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_pfull_inten = "unused_rx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_hold = "unused_rx_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_underrun_inten = "unused_rx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_hold = "unused_rx_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_reserved_inten = "unused_rx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_hold = "unused_rx_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_gb_restarted_inten = "unused_rx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sf_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__shadow_clear = "unused_shadow_clear";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__shadow_req = "unused_shadow_req";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__speed_map = "speed_map_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__stream_rx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__stream_tx_width_is_forty = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__trans_bypass = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_en_fec_latency = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_excvr_gb_ratio_mode = "tx_excvr_gb_ratio_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_excvr_if_fifo_mode = "tx_excvr_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_hold = "unused_tx_fifo_empty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_empty_inten = "unused_tx_inten_fifo_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_hold = "unused_tx_fifo_full_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_full_inten = "unused_tx_inten_fifo_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_hold = "unused_tx_fifo_overflow_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_overflow_inten = "unused_tx_inten_fifo_overflow";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_hold = "unused_tx_fifo_pmepty_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pempty_inten = "unused_tx_inten_fifo_pempty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_hold = "unused_tx_fifo_pfull_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_pfull_inten = "unused_tx_inten_fifo_pfull";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_rd_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_hold = "unused_tx_fifo_underrun_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_underrun_inten = "unused_tx_inten_fifo_underrun";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_fifo_wr_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_hold = "unused_tx_gb_reserved_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_reserved_inten = "unused_tx_inten_gb_reserved";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_hold = "unused_tx_gb_restarted_hold";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_gb_restarted_inten = "unused_tx_inten_gb_restarted";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate = "unused_rx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_gate_bit2 = "unused_rx_clk_gate_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_rx_clk_sel3 = "unused_rx_clk_sel3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__unused_lphy_tx_clk_gate = "unused_tx_clk_gate";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ux_return_clk_gate_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__ux_tx_rtrn_clk_sel = "ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_lpbk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rst_rxbit_cntr = "rst_rxbit_cntr_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv2_en = "rx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_intlv4_en = "rx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_bk_map = "rx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_en_deskew = "dis_rx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_fifo_mode = "rx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_idw = "rx_gb_idw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_gb_odw = "rx_gb_odw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_multi_ln_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_phcomp_rd_delay = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_tag_sel = "rx_tag_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rx_xcvr_bond = "bond_rx_e25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_cntr_pma = "rxbit_cntr_pma_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_rxbit_rollover = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_sel_rxbit_adder = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_40b_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv2_en = "tx_bk_intlv2_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_intlv4_en = "tx_bk_intlv4_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_bk_map = "tx_bk_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_en_deskew = "dis_tx_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_fifo_mode = "tx_fifo_elastic";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gating_sel = "gate_sel0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_bp = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_idw = "tx_gb_idw_33";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_gb_odw = "tx_gb_odw_32";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_multi_ln_sel = "tx_ml_sel_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_source_sel = "tx_adapter_source";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__gdr_lphy_e50g_reg_ch8__gdr_lphy_e25g_reg_base_s1__xcvrif_tx_ux_map = "tx_ux_main_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_112e4x0 = "map_112e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_112e4x1 = "map_112e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_112e4x2 = "map_112e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_112e4x3 = "map_112e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x0 = "map_25e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x1 = "map_25e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x10 = "map_25e4x10_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x11 = "map_25e4x11_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x12 = "map_25e4x12_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x13 = "map_25e4x13_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x14 = "map_25e4x14_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x15 = "map_25e4x15_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x2 = "map_25e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x3 = "map_25e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x4 = "map_25e4x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x5 = "map_25e4x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x6 = "map_25e4x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x7 = "map_25e4x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x8 = "map_25e4x8_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_25e4x9 = "map_25e4x9_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x0 = "map_56e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x1 = "map_56e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x2 = "map_56e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x3 = "map_56e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x4 = "map_56e4x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x5 = "map_56e4x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x6 = "map_56e4x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_56e4x7 = "map_56e4x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_bk0 = "map_bk0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_bk1 = "map_bk1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_bk2 = "map_bk2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_bk3 = "map_bk3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux0 = "map_ux0_enable_25e4x15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux1 = "map_ux1_enable_25e4x14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux10 = "map_ux10_enable_25e4x5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux11 = "map_ux11_enable_25e4x4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux12 = "map_ux12_enable_25e4x3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux13 = "map_ux13_enable_25e4x2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux14 = "map_ux14_enable_25e4x1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux15 = "map_ux15_enable_25e4x0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux2 = "map_ux2_enable_25e4x13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux3 = "map_ux3_enable_25e4x12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux4 = "map_ux4_enable_25e4x11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux5 = "map_ux5_enable_25e4x10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux6 = "map_ux6_enable_25e4x9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux7 = "map_ux7_enable_25e4x8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux8 = "map_ux8_enable_25e4x7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__map_ux9 = "map_ux9_enable_25e4x6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_100g_0 = "off_100g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_100g_1 = "off_100g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_100g_2 = "off_100g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_100g_3 = "off_100g_3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_150g_0 = "off_150g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_150g_1 = "off_150g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_150g_2 = "off_150g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_150g_3 = "off_150g_3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_200g_0 = "off_200g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_200g_1 = "off_200g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_0 = "duplex_25g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_1 = "duplex_25g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_10 = "duplex_25g_10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_11 = "duplex_25g_11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_12 = "duplex_25g_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_13 = "duplex_25g_13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_14 = "duplex_25g_14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_15 = "duplex_25g_15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_2 = "duplex_25g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_3 = "duplex_25g_3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_4 = "duplex_25g_4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_5 = "duplex_25g_5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_6 = "duplex_25g_6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_7 = "duplex_25g_7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_8 = "duplex_25g_8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_25g_9 = "duplex_25g_9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_300g_0 = "off_300g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_300g_1 = "off_300g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_400g = "off_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_0 = "off_50g_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_1 = "off_50g_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_2 = "off_50g_2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_3 = "off_50g_3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_4 = "off_50g_4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_5 = "off_50g_5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_6 = "off_50g_6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_50g_7 = "off_50g_7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_core0_clk = "fec_core0_clk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_core1_clk = "fec_core1_clk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_core2_clk = "fec_core2_clk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_core3_clk = "fec_core3_clk_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st0_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st10_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st11_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st12_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st13_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st14_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st15_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st1_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st2_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st3_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st4_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st5_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st6_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st7_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st8_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_rx_st9_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st0_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st10_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st11_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st12_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st13_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st14_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st15_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st1_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st2_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st3_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st4_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st5_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st6_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st7_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st8_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_eth_tx_st9_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__powermode_freq_hz_global_avmm_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__speed_grade = "dash_1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sys_pll0_div1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sys_pll0_div2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sys_pll1_div1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sys_pll1_div2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sys_pll2_div1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__sys_pll2_div2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk0_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk10_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk11_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk12_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk13_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk14_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk15_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk1_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk3_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk5_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk6_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk7_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk8_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__transfer_clk9_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux0_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux0_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux0_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux0_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux0_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux0_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux10_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux10_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux10_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux10_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux10_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux10_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux11_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux11_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux11_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux11_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux11_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux11_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux12_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux12_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux12_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux12_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux12_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux12_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux13_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux13_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux13_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux13_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux13_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux13_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux14_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux14_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux14_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux14_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux14_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux14_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux15_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux15_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux15_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux15_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux15_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux15_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux1_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux1_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux1_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux1_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux1_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux1_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux2_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux2_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux2_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux2_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux2_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux2_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux3_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux3_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux3_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux3_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux3_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux3_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux4_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux4_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux4_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux4_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux4_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux4_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux5_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux5_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux5_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux5_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux5_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux5_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux6_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux6_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux6_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux6_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux6_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux6_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux7_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux7_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux7_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux7_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux7_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux7_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux8_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux8_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux8_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux8_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux8_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux8_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux9_return_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux9_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux9_rxword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux9_tx_user_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux9_tx_user_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__ux9_txword_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_st9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st0_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st0_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st10_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st10_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st11_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st11_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st12_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st12_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st13_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st13_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st14_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st14_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st15_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st15_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st1_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st1_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st2_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st2_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st3_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st3_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st4_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st4_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st5_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st5_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st6_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st6_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st7_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st7_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st8_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st8_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st9_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_rx_user_st9_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_112e4x0 = "xcvr_select_112e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_112e4x1 = "xcvr_select_112e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_112e4x2 = "xcvr_select_112e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_112e4x3 = "xcvr_select_112e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x0 = "xcvr_select_25e4x0_e4ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x1 = "xcvr_select_25e4x1_e4ux14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x10 = "xcvr_select_25e4x10_e4ux5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x11 = "xcvr_select_25e4x11_e4ux4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x12 = "xcvr_select_25e4x12_e4ux3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x13 = "xcvr_select_25e4x13_e4ux2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x14 = "xcvr_select_25e4x14_e4ux1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x15 = "xcvr_select_25e4x15_e4ux0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x2 = "xcvr_select_25e4x2_e4ux13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x3 = "xcvr_select_25e4x3_e4ux12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x4 = "xcvr_select_25e4x4_e4ux11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x5 = "xcvr_select_25e4x5_e4ux10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x6 = "xcvr_select_25e4x6_e4ux9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x7 = "xcvr_select_25e4x7_e4ux8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x8 = "xcvr_select_25e4x8_e4ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_25e4x9 = "xcvr_select_25e4x9_e4ux6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x0 = "xcvr_select_56e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x1 = "xcvr_select_56e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x2 = "xcvr_select_56e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x3 = "xcvr_select_56e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x4 = "xcvr_select_56e4x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x5 = "xcvr_select_56e4x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x6 = "xcvr_select_56e4x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_select_56e4x7 = "xcvr_select_56e4x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st10_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st11_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st12_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st13_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st14_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st15_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st1_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st2_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st3_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st4_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st5_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st6_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st7_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st8_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_st9_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st0_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st0_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st10_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st10_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st11_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st11_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st12_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st12_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st13_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st13_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st14_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st14_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st15_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st15_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st1_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st1_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st2_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st2_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st3_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st3_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st4_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st4_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st5_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st5_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st6_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st6_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st7_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st7_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st8_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st8_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st9_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e400g_lphy__xcvr_tx_user_st9_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_aibif_data_valid = "e400g_100g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_duplex_mode = "e400g_100g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_fec_mode = "e400g_100g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_lpbk_mode = "e400g_100g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_flow_control = "e400g_100g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_flow_control_holdoff_mode = "e400g_100g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_link_fault_mode = "e400g_100g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_mode = "e400g_100g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_ptp_phy_lane_num = "e400g_100g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_ipg_size = "e400g_100g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_ptp_phy_lane_num = "e400g_100g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_pcs_ber_mon_mode = "e400g_100g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_pcs_pcs_ber_mon_mode = "e400g_100g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_ptp_mode = "e400g_100g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_fec_enable = "e400g_100g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_pcs_mode = "e400g_100g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_primary_use = "e400g_100g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_system_bonding = "e400g_100g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_sup_mode = "e400g_100g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_sys_clk_src = "e400g_100g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_aib_if_fifo_mode = "e400g_100g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_fec_enable = "e400g_100g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_pcs_mode = "e400g_100g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_primary_use = "e400g_100g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_system_bonding = "e400g_100g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_aibif_data_valid = "e400g_100g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_duplex_mode = "e400g_100g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_fec_mode = "e400g_100g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_lpbk_mode = "e400g_100g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_flow_control = "e400g_100g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_flow_control_holdoff_mode = "e400g_100g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_link_fault_mode = "e400g_100g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_mode = "e400g_100g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_ptp_phy_lane_num = "e400g_100g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_ipg_size = "e400g_100g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_ptp_phy_lane_num = "e400g_100g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_pcs_ber_mon_mode = "e400g_100g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_pcs_pcs_ber_mon_mode = "e400g_100g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_ptp_mode = "e400g_100g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_fec_enable = "e400g_100g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_pcs_mode = "e400g_100g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_primary_use = "e400g_100g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_system_bonding = "e400g_100g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_sup_mode = "e400g_100g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_sys_clk_src = "e400g_100g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_aib_if_fifo_mode = "e400g_100g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_fec_enable = "e400g_100g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_pcs_mode = "e400g_100g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_primary_use = "e400g_100g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_system_bonding = "e400g_100g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_aibif_data_valid = "e400g_100g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_duplex_mode = "e400g_100g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_fec_mode = "e400g_100g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_lpbk_mode = "e400g_100g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_flow_control = "e400g_100g_2_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_flow_control_holdoff_mode = "e400g_100g_2_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_link_fault_mode = "e400g_100g_2_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_mode = "e400g_100g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_ptp_phy_lane_num = "e400g_100g_2_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_ipg_size = "e400g_100g_2_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_ptp_phy_lane_num = "e400g_100g_2_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_pcs_ber_mon_mode = "e400g_100g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_pcs_pcs_ber_mon_mode = "e400g_100g_2_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_ptp_mode = "e400g_100g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_fec_enable = "e400g_100g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_pcs_mode = "e400g_100g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_primary_use = "e400g_100g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_system_bonding = "e400g_100g_2_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_sup_mode = "e400g_100g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_sys_clk_src = "e400g_100g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_aib_if_fifo_mode = "e400g_100g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_fec_enable = "e400g_100g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_pcs_mode = "e400g_100g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_primary_use = "e400g_100g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_system_bonding = "e400g_100g_2_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_aibif_data_valid = "e400g_100g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_duplex_mode = "e400g_100g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_fec_mode = "e400g_100g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_lpbk_mode = "e400g_100g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_flow_control = "e400g_100g_3_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_flow_control_holdoff_mode = "e400g_100g_3_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_link_fault_mode = "e400g_100g_3_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_mode = "e400g_100g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_ptp_phy_lane_num = "e400g_100g_3_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_ipg_size = "e400g_100g_3_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_ptp_phy_lane_num = "e400g_100g_3_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_pcs_ber_mon_mode = "e400g_100g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_pcs_pcs_ber_mon_mode = "e400g_100g_3_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_ptp_mode = "e400g_100g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_fec_enable = "e400g_100g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_pcs_mode = "e400g_100g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_primary_use = "e400g_100g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_system_bonding = "e400g_100g_3_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_sup_mode = "e400g_100g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_sys_clk_src = "e400g_100g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_aib_if_fifo_mode = "e400g_100g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_fec_enable = "e400g_100g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_pcs_mode = "e400g_100g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_primary_use = "e400g_100g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_system_bonding = "e400g_100g_3_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_100g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_aibif_data_valid = "e400g_150g_0_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_duplex_mode = "e400g_150g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_fec_mode = "e400g_150g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_lpbk_mode = "e400g_150g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_mac_mode = "e400g_150g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_pcs_ber_mon_mode = "e400g_150g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_ptp_mode = "e400g_150g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_fec_enable = "e400g_150g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_pcs_mode = "e400g_150g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_primary_use = "e400g_150g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_system_bonding = "e400g_150g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_sup_mode = "e400g_150g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_sys_clk_src = "e400g_150g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_aib_if_fifo_mode = "e400g_150g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_fec_enable = "e400g_150g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_pcs_mode = "e400g_150g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_primary_use = "e400g_150g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_system_bonding = "e400g_150g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_duplex_mode = "e400g_150g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_fec_mode = "e400g_150g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_lpbk_mode = "e400g_150g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_mac_mode = "e400g_150g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_pcs_ber_mon_mode = "e400g_150g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_ptp_mode = "e400g_150g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_fec_enable = "e400g_150g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_pcs_mode = "e400g_150g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_primary_use = "e400g_150g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_system_bonding = "e400g_150g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_sup_mode = "e400g_150g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_sys_clk_src = "e400g_150g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_aib_if_fifo_mode = "e400g_150g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_fec_enable = "e400g_150g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_pcs_mode = "e400g_150g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_primary_use = "e400g_150g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_system_bonding = "e400g_150g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_aibif_data_valid = "e400g_150g_2_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_duplex_mode = "e400g_150g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_fec_mode = "e400g_150g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_lpbk_mode = "e400g_150g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_mac_mode = "e400g_150g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_pcs_ber_mon_mode = "e400g_150g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_ptp_mode = "e400g_150g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_fec_enable = "e400g_150g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_pcs_mode = "e400g_150g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_primary_use = "e400g_150g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_system_bonding = "e400g_150g_2_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_sup_mode = "e400g_150g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_sys_clk_src = "e400g_150g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_aib_if_fifo_mode = "e400g_150g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_fec_enable = "e400g_150g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_pcs_mode = "e400g_150g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_primary_use = "e400g_150g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_system_bonding = "e400g_150g_2_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_aibif_data_valid = "e400g_150g_3_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_duplex_mode = "e400g_150g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_fec_mode = "e400g_150g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_lpbk_mode = "e400g_150g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_mac_mode = "e400g_150g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_pcs_ber_mon_mode = "e400g_150g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_ptp_mode = "e400g_150g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_fec_enable = "e400g_150g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_pcs_mode = "e400g_150g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_primary_use = "e400g_150g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_system_bonding = "e400g_150g_3_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_sup_mode = "e400g_150g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_sys_clk_src = "e400g_150g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_aib_if_fifo_mode = "e400g_150g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_fec_enable = "e400g_150g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_pcs_mode = "e400g_150g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_primary_use = "e400g_150g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_system_bonding = "e400g_150g_3_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_150g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_aibif_data_valid = "e400g_200g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_duplex_mode = "e400g_200g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_fec_mode = "e400g_200g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_lpbk_mode = "e400g_200g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_flow_control = "e400g_200g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_flow_control_holdoff_mode = "e400g_200g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_link_fault_mode = "e400g_200g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_mode = "e400g_200g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_ptp_phy_lane_num = "e400g_200g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_ipg_size = "e400g_200g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_ptp_phy_lane_num = "e400g_200g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_pcs_ber_mon_mode = "e400g_200g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_pcs_pcs_ber_mon_mode = "e400g_200g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_ptp_mode = "e400g_200g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_fec_enable = "e400g_200g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_pcs_mode = "e400g_200g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_primary_use = "e400g_200g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_system_bonding = "e400g_200g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_sup_mode = "e400g_200g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_sys_clk_src = "e400g_200g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_aib_if_fifo_mode = "e400g_200g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_fec_enable = "e400g_200g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_pcs_mode = "e400g_200g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_primary_use = "e400g_200g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_system_bonding = "e400g_200g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_aibif_data_valid = "e400g_200g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_duplex_mode = "e400g_200g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_fec_mode = "e400g_200g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_lpbk_mode = "e400g_200g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_flow_control = "e400g_200g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_flow_control_holdoff_mode = "e400g_200g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_link_fault_mode = "e400g_200g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_mode = "e400g_200g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_ptp_phy_lane_num = "e400g_200g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_ipg_size = "e400g_200g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_ptp_phy_lane_num = "e400g_200g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_pcs_ber_mon_mode = "e400g_200g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_pcs_pcs_ber_mon_mode = "e400g_200g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_ptp_mode = "e400g_200g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_fec_enable = "e400g_200g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_pcs_mode = "e400g_200g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_primary_use = "e400g_200g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_system_bonding = "e400g_200g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_sup_mode = "e400g_200g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_sys_clk_src = "e400g_200g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_aib_if_fifo_mode = "e400g_200g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_fec_enable = "e400g_200g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_pcs_mode = "e400g_200g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_primary_use = "e400g_200g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_system_bonding = "e400g_200g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_200g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_aibif_data_valid = "e400g_25g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_duplex_mode = "e400g_25g_0_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_fec_mode = "e400g_25g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_fec_spec = "e400g_25g_0_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_lpbk_mode = "e400g_25g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_flow_control = "e400g_25g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_flow_control_holdoff_mode = "e400g_25g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_link_fault_mode = "e400g_25g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_mode = "e400g_25g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_ptp_phy_lane_num = "e400g_25g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_ipg_size = "e400g_25g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_ptp_phy_lane_num = "e400g_25g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_pcs_ber_mon_mode = "e400g_25g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_pcs_pcs_ber_mon_mode = "e400g_25g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_ptp_mode = "e400g_25g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_fec_enable = "e400g_25g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_pcs_mode = "e400g_25g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_primary_use = "e400g_25g_0_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_system_bonding = "e400g_25g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_sup_mode = "e400g_25g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_sys_clk_src = "e400g_25g_0_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_aib_if_fifo_mode = "e400g_25g_0_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_fec_enable = "e400g_25g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_pcs_mode = "e400g_25g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_primary_use = "e400g_25g_0_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_system_bonding = "e400g_25g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_0_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_aibif_data_valid = "e400g_25g_10_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_duplex_mode = "e400g_25g_10_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_fec_mode = "e400g_25g_10_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_fec_spec = "e400g_25g_10_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_lpbk_mode = "e400g_25g_10_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_flow_control = "e400g_25g_10_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_flow_control_holdoff_mode = "e400g_25g_10_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_link_fault_mode = "e400g_25g_10_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_mode = "e400g_25g_10_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_ptp_phy_lane_num = "e400g_25g_10_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_ipg_size = "e400g_25g_10_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_ptp_phy_lane_num = "e400g_25g_10_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_pcs_ber_mon_mode = "e400g_25g_10_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_pcs_pcs_ber_mon_mode = "e400g_25g_10_pcs_pcs_ber_mon_mode_10g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_ptp_mode = "e400g_25g_10_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_fec_enable = "e400g_25g_10_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_pcs_mode = "e400g_25g_10_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_primary_use = "e400g_25g_10_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_system_bonding = "e400g_25g_10_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_sup_mode = "e400g_25g_10_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_sys_clk_src = "e400g_25g_10_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_aib_if_fifo_mode = "e400g_25g_10_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_fec_enable = "e400g_25g_10_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_pcs_mode = "e400g_25g_10_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_primary_use = "e400g_25g_10_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_system_bonding = "e400g_25g_10_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_10_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_aibif_data_valid = "e400g_25g_11_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_duplex_mode = "e400g_25g_11_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_fec_mode = "e400g_25g_11_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_fec_spec = "e400g_25g_11_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_lpbk_mode = "e400g_25g_11_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_flow_control = "e400g_25g_11_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_flow_control_holdoff_mode = "e400g_25g_11_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_link_fault_mode = "e400g_25g_11_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_mode = "e400g_25g_11_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_ptp_phy_lane_num = "e400g_25g_11_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_ipg_size = "e400g_25g_11_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_ptp_phy_lane_num = "e400g_25g_11_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_pcs_ber_mon_mode = "e400g_25g_11_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_pcs_pcs_ber_mon_mode = "e400g_25g_11_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_ptp_mode = "e400g_25g_11_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_fec_enable = "e400g_25g_11_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_pcs_mode = "e400g_25g_11_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_primary_use = "e400g_25g_11_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_system_bonding = "e400g_25g_11_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_sup_mode = "e400g_25g_11_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_sys_clk_src = "e400g_25g_11_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_aib_if_fifo_mode = "e400g_25g_11_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_fec_enable = "e400g_25g_11_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_pcs_mode = "e400g_25g_11_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_primary_use = "e400g_25g_11_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_system_bonding = "e400g_25g_11_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_11_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_aibif_data_valid = "e400g_25g_12_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_duplex_mode = "e400g_25g_12_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_fec_mode = "e400g_25g_12_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_fec_spec = "e400g_25g_12_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_lpbk_mode = "e400g_25g_12_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_flow_control = "e400g_25g_12_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_flow_control_holdoff_mode = "e400g_25g_12_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_link_fault_mode = "e400g_25g_12_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_mode = "e400g_25g_12_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_ptp_phy_lane_num = "e400g_25g_12_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_ipg_size = "e400g_25g_12_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_ptp_phy_lane_num = "e400g_25g_12_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_pcs_ber_mon_mode = "e400g_25g_12_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_pcs_pcs_ber_mon_mode = "e400g_25g_12_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_ptp_mode = "e400g_25g_12_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_fec_enable = "e400g_25g_12_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_pcs_mode = "e400g_25g_12_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_primary_use = "e400g_25g_12_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_system_bonding = "e400g_25g_12_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_sup_mode = "e400g_25g_12_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_sys_clk_src = "e400g_25g_12_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_aib_if_fifo_mode = "e400g_25g_12_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_fec_enable = "e400g_25g_12_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_pcs_mode = "e400g_25g_12_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_primary_use = "e400g_25g_12_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_system_bonding = "e400g_25g_12_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_12_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_aibif_data_valid = "e400g_25g_13_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_duplex_mode = "e400g_25g_13_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_fec_mode = "e400g_25g_13_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_fec_spec = "e400g_25g_13_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_lpbk_mode = "e400g_25g_13_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_flow_control = "e400g_25g_13_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_flow_control_holdoff_mode = "e400g_25g_13_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_link_fault_mode = "e400g_25g_13_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_mode = "e400g_25g_13_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_ptp_phy_lane_num = "e400g_25g_13_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_ipg_size = "e400g_25g_13_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_ptp_phy_lane_num = "e400g_25g_13_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_pcs_ber_mon_mode = "e400g_25g_13_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_pcs_pcs_ber_mon_mode = "e400g_25g_13_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_ptp_mode = "e400g_25g_13_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_fec_enable = "e400g_25g_13_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_pcs_mode = "e400g_25g_13_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_primary_use = "e400g_25g_13_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_system_bonding = "e400g_25g_13_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_sup_mode = "e400g_25g_13_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_sys_clk_src = "e400g_25g_13_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_aib_if_fifo_mode = "e400g_25g_13_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_fec_enable = "e400g_25g_13_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_pcs_mode = "e400g_25g_13_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_primary_use = "e400g_25g_13_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_system_bonding = "e400g_25g_13_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_13_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_aibif_data_valid = "e400g_25g_14_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_duplex_mode = "e400g_25g_14_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_fec_mode = "e400g_25g_14_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_fec_spec = "e400g_25g_14_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_lpbk_mode = "e400g_25g_14_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_flow_control = "e400g_25g_14_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_flow_control_holdoff_mode = "e400g_25g_14_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_link_fault_mode = "e400g_25g_14_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_mode = "e400g_25g_14_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_ptp_phy_lane_num = "e400g_25g_14_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_ipg_size = "e400g_25g_14_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_ptp_phy_lane_num = "e400g_25g_14_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_pcs_ber_mon_mode = "e400g_25g_14_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_pcs_pcs_ber_mon_mode = "e400g_25g_14_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_ptp_mode = "e400g_25g_14_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_fec_enable = "e400g_25g_14_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_pcs_mode = "e400g_25g_14_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_primary_use = "e400g_25g_14_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_system_bonding = "e400g_25g_14_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_sup_mode = "e400g_25g_14_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_sys_clk_src = "e400g_25g_14_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_aib_if_fifo_mode = "e400g_25g_14_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_fec_enable = "e400g_25g_14_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_pcs_mode = "e400g_25g_14_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_primary_use = "e400g_25g_14_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_system_bonding = "e400g_25g_14_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_14_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_aibif_data_valid = "e400g_25g_15_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_duplex_mode = "e400g_25g_15_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_fec_mode = "e400g_25g_15_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_fec_spec = "e400g_25g_15_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_lpbk_mode = "e400g_25g_15_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_flow_control = "e400g_25g_15_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_flow_control_holdoff_mode = "e400g_25g_15_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_link_fault_mode = "e400g_25g_15_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_mode = "e400g_25g_15_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_ptp_phy_lane_num = "e400g_25g_15_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_ipg_size = "e400g_25g_15_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_ptp_phy_lane_num = "e400g_25g_15_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_pcs_ber_mon_mode = "e400g_25g_15_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_pcs_pcs_ber_mon_mode = "e400g_25g_15_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_ptp_mode = "e400g_25g_15_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_fec_enable = "e400g_25g_15_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_pcs_mode = "e400g_25g_15_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_primary_use = "e400g_25g_15_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_system_bonding = "e400g_25g_15_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_sup_mode = "e400g_25g_15_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_sys_clk_src = "e400g_25g_15_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_aib_if_fifo_mode = "e400g_25g_15_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_fec_enable = "e400g_25g_15_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_pcs_mode = "e400g_25g_15_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_primary_use = "e400g_25g_15_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_system_bonding = "e400g_25g_15_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_15_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_aibif_data_valid = "e400g_25g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_duplex_mode = "e400g_25g_1_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_fec_mode = "e400g_25g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_fec_spec = "e400g_25g_1_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_lpbk_mode = "e400g_25g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_flow_control = "e400g_25g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_flow_control_holdoff_mode = "e400g_25g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_link_fault_mode = "e400g_25g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_mode = "e400g_25g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_ptp_phy_lane_num = "e400g_25g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_ipg_size = "e400g_25g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_ptp_phy_lane_num = "e400g_25g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_pcs_ber_mon_mode = "e400g_25g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_pcs_pcs_ber_mon_mode = "e400g_25g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_ptp_mode = "e400g_25g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_fec_enable = "e400g_25g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_pcs_mode = "e400g_25g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_primary_use = "e400g_25g_1_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_system_bonding = "e400g_25g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_sup_mode = "e400g_25g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_sys_clk_src = "e400g_25g_1_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_aib_if_fifo_mode = "e400g_25g_1_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_fec_enable = "e400g_25g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_pcs_mode = "e400g_25g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_primary_use = "e400g_25g_1_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_system_bonding = "e400g_25g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_1_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_aibif_data_valid = "e400g_25g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_duplex_mode = "e400g_25g_2_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_fec_mode = "e400g_25g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_fec_spec = "e400g_25g_2_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_lpbk_mode = "e400g_25g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_flow_control = "e400g_25g_2_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_flow_control_holdoff_mode = "e400g_25g_2_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_link_fault_mode = "e400g_25g_2_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_mode = "e400g_25g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_ptp_phy_lane_num = "e400g_25g_2_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_ipg_size = "e400g_25g_2_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_ptp_phy_lane_num = "e400g_25g_2_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_pcs_ber_mon_mode = "e400g_25g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_pcs_pcs_ber_mon_mode = "e400g_25g_2_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_ptp_mode = "e400g_25g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_fec_enable = "e400g_25g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_pcs_mode = "e400g_25g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_primary_use = "e400g_25g_2_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_system_bonding = "e400g_25g_2_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_sup_mode = "e400g_25g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_sys_clk_src = "e400g_25g_2_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_aib_if_fifo_mode = "e400g_25g_2_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_fec_enable = "e400g_25g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_pcs_mode = "e400g_25g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_primary_use = "e400g_25g_2_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_system_bonding = "e400g_25g_2_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_2_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_aibif_data_valid = "e400g_25g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_duplex_mode = "e400g_25g_3_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_fec_mode = "e400g_25g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_fec_spec = "e400g_25g_3_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_lpbk_mode = "e400g_25g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_flow_control = "e400g_25g_3_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_flow_control_holdoff_mode = "e400g_25g_3_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_link_fault_mode = "e400g_25g_3_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_mode = "e400g_25g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_ptp_phy_lane_num = "e400g_25g_3_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_ipg_size = "e400g_25g_3_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_ptp_phy_lane_num = "e400g_25g_3_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_pcs_ber_mon_mode = "e400g_25g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_pcs_pcs_ber_mon_mode = "e400g_25g_3_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_ptp_mode = "e400g_25g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_fec_enable = "e400g_25g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_pcs_mode = "e400g_25g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_primary_use = "e400g_25g_3_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_system_bonding = "e400g_25g_3_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_sup_mode = "e400g_25g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_sys_clk_src = "e400g_25g_3_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_aib_if_fifo_mode = "e400g_25g_3_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_fec_enable = "e400g_25g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_pcs_mode = "e400g_25g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_primary_use = "e400g_25g_3_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_system_bonding = "e400g_25g_3_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_3_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_aibif_data_valid = "e400g_25g_4_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_duplex_mode = "e400g_25g_4_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_fec_mode = "e400g_25g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_fec_spec = "e400g_25g_4_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_lpbk_mode = "e400g_25g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_flow_control = "e400g_25g_4_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_flow_control_holdoff_mode = "e400g_25g_4_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_link_fault_mode = "e400g_25g_4_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_mode = "e400g_25g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_ptp_phy_lane_num = "e400g_25g_4_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_ipg_size = "e400g_25g_4_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_ptp_phy_lane_num = "e400g_25g_4_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_pcs_ber_mon_mode = "e400g_25g_4_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_pcs_pcs_ber_mon_mode = "e400g_25g_4_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_ptp_mode = "e400g_25g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_fec_enable = "e400g_25g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_pcs_mode = "e400g_25g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_primary_use = "e400g_25g_4_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_system_bonding = "e400g_25g_4_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_sup_mode = "e400g_25g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_sys_clk_src = "e400g_25g_4_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_aib_if_fifo_mode = "e400g_25g_4_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_fec_enable = "e400g_25g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_pcs_mode = "e400g_25g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_primary_use = "e400g_25g_4_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_system_bonding = "e400g_25g_4_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_4_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_aibif_data_valid = "e400g_25g_5_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_duplex_mode = "e400g_25g_5_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_fec_mode = "e400g_25g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_fec_spec = "e400g_25g_5_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_lpbk_mode = "e400g_25g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_flow_control = "e400g_25g_5_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_flow_control_holdoff_mode = "e400g_25g_5_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_link_fault_mode = "e400g_25g_5_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_mode = "e400g_25g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_ptp_phy_lane_num = "e400g_25g_5_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_ipg_size = "e400g_25g_5_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_ptp_phy_lane_num = "e400g_25g_5_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_pcs_ber_mon_mode = "e400g_25g_5_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_pcs_pcs_ber_mon_mode = "e400g_25g_5_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_ptp_mode = "e400g_25g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_fec_enable = "e400g_25g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_pcs_mode = "e400g_25g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_primary_use = "e400g_25g_5_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_system_bonding = "e400g_25g_5_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_sup_mode = "e400g_25g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_sys_clk_src = "e400g_25g_5_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_aib_if_fifo_mode = "e400g_25g_5_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_fec_enable = "e400g_25g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_pcs_mode = "e400g_25g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_primary_use = "e400g_25g_5_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_system_bonding = "e400g_25g_5_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_5_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_aibif_data_valid = "e400g_25g_6_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_duplex_mode = "e400g_25g_6_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_fec_mode = "e400g_25g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_fec_spec = "e400g_25g_6_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_lpbk_mode = "e400g_25g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_flow_control = "e400g_25g_6_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_flow_control_holdoff_mode = "e400g_25g_6_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_link_fault_mode = "e400g_25g_6_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_mode = "e400g_25g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_ptp_phy_lane_num = "e400g_25g_6_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_ipg_size = "e400g_25g_6_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_ptp_phy_lane_num = "e400g_25g_6_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_pcs_ber_mon_mode = "e400g_25g_6_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_pcs_pcs_ber_mon_mode = "e400g_25g_6_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_ptp_mode = "e400g_25g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_fec_enable = "e400g_25g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_pcs_mode = "e400g_25g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_primary_use = "e400g_25g_6_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_system_bonding = "e400g_25g_6_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_sup_mode = "e400g_25g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_sys_clk_src = "e400g_25g_6_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_aib_if_fifo_mode = "e400g_25g_6_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_fec_enable = "e400g_25g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_pcs_mode = "e400g_25g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_primary_use = "e400g_25g_6_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_system_bonding = "e400g_25g_6_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_6_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_aibif_data_valid = "e400g_25g_7_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_duplex_mode = "e400g_25g_7_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_fec_mode = "e400g_25g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_fec_spec = "e400g_25g_7_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_lpbk_mode = "e400g_25g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_flow_control = "e400g_25g_7_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_flow_control_holdoff_mode = "e400g_25g_7_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_link_fault_mode = "e400g_25g_7_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_mode = "e400g_25g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_ptp_phy_lane_num = "e400g_25g_7_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_ipg_size = "e400g_25g_7_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_ptp_phy_lane_num = "e400g_25g_7_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_pcs_ber_mon_mode = "e400g_25g_7_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_pcs_pcs_ber_mon_mode = "e400g_25g_7_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_ptp_mode = "e400g_25g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_fec_enable = "e400g_25g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_pcs_mode = "e400g_25g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_primary_use = "e400g_25g_7_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_system_bonding = "e400g_25g_7_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_sup_mode = "e400g_25g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_sys_clk_src = "e400g_25g_7_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_aib_if_fifo_mode = "e400g_25g_7_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_fec_enable = "e400g_25g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_pcs_mode = "e400g_25g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_primary_use = "e400g_25g_7_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_system_bonding = "e400g_25g_7_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_7_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_aibif_data_valid = "e400g_25g_8_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_duplex_mode = "e400g_25g_8_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_fec_mode = "e400g_25g_8_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_fec_spec = "e400g_25g_8_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_lpbk_mode = "e400g_25g_8_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_flow_control = "e400g_25g_8_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_flow_control_holdoff_mode = "e400g_25g_8_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_link_fault_mode = "e400g_25g_8_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_mode = "e400g_25g_8_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_ptp_phy_lane_num = "e400g_25g_8_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_ipg_size = "e400g_25g_8_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_ptp_phy_lane_num = "e400g_25g_8_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_pcs_ber_mon_mode = "e400g_25g_8_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_pcs_pcs_ber_mon_mode = "e400g_25g_8_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_ptp_mode = "e400g_25g_8_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_fec_enable = "e400g_25g_8_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_pcs_mode = "e400g_25g_8_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_primary_use = "e400g_25g_8_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_system_bonding = "e400g_25g_8_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_sup_mode = "e400g_25g_8_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_sys_clk_src = "e400g_25g_8_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_aib_if_fifo_mode = "e400g_25g_8_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_fec_enable = "e400g_25g_8_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_pcs_mode = "e400g_25g_8_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_primary_use = "e400g_25g_8_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_system_bonding = "e400g_25g_8_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_8_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_aibif_data_valid = "e400g_25g_9_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_duplex_mode = "e400g_25g_9_duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_fec_mode = "e400g_25g_9_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_fec_spec = "e400g_25g_9_fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_lpbk_mode = "e400g_25g_9_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_flow_control = "e400g_25g_9_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_flow_control_holdoff_mode = "e400g_25g_9_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_link_fault_mode = "e400g_25g_9_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_mode = "e400g_25g_9_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_ptp_phy_lane_num = "e400g_25g_9_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_ipg_size = "e400g_25g_9_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_ptp_phy_lane_num = "e400g_25g_9_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_pcs_ber_mon_mode = "e400g_25g_9_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_pcs_pcs_ber_mon_mode = "e400g_25g_9_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_ptp_mode = "e400g_25g_9_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_fec_enable = "e400g_25g_9_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_pcs_mode = "e400g_25g_9_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_primary_use = "e400g_25g_9_rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_system_bonding = "e400g_25g_9_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_sup_mode = "e400g_25g_9_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_sys_clk_src = "e400g_25g_9_sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_aib_if_fifo_mode = "e400g_25g_9_tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_fec_enable = "e400g_25g_9_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_pcs_mode = "e400g_25g_9_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_primary_use = "e400g_25g_9_tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_system_bonding = "e400g_25g_9_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_25g_9_tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_aibif_data_valid = "e400g_300g_0_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_duplex_mode = "e400g_300g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_fec_mode = "e400g_300g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_lpbk_mode = "e400g_300g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_mac_mode = "e400g_300g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_pcs_ber_mon_mode = "e400g_300g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_ptp_mode = "e400g_300g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_fec_enable = "e400g_300g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_pcs_mode = "e400g_300g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_primary_use = "e400g_300g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_system_bonding = "e400g_300g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_sup_mode = "e400g_300g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_sys_clk_src = "e400g_300g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_aib_if_fifo_mode = "e400g_300g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_fec_enable = "e400g_300g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_pcs_mode = "e400g_300g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_primary_use = "e400g_300g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_system_bonding = "e400g_300g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_aibif_data_valid = "e400g_300g_1_aibif_data_valid_custom";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_duplex_mode = "e400g_300g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_fec_mode = "e400g_300g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_lpbk_mode = "e400g_300g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_mac_mode = "e400g_300g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_pcs_ber_mon_mode = "e400g_300g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_ptp_mode = "e400g_300g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_fec_enable = "e400g_300g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_pcs_mode = "e400g_300g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_primary_use = "e400g_300g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_system_bonding = "e400g_300g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_sup_mode = "e400g_300g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_sys_clk_src = "e400g_300g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_aib_if_fifo_mode = "e400g_300g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_fec_enable = "e400g_300g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_pcs_mode = "e400g_300g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_primary_use = "e400g_300g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_system_bonding = "e400g_300g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_300g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_aibif_data_valid = "e400g_400g_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_duplex_mode = "e400g_400g_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_fec_mode = "e400g_400g_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_lpbk_mode = "e400g_400g_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_flow_control = "e400g_400g_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_flow_control_holdoff_mode = "e400g_400g_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_link_fault_mode = "e400g_400g_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_mode = "e400g_400g_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_ptp_phy_lane_num = "e400g_400g_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_ipg_size = "e400g_400g_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_ptp_phy_lane_num = "e400g_400g_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_pcs_ber_mon_mode = "e400g_400g_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_pcs_pcs_ber_mon_mode = "e400g_400g_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_ptp_mode = "e400g_400g_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_fec_enable = "e400g_400g_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_pcs_mode = "e400g_400g_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_primary_use = "e400g_400g_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_system_bonding = "e400g_400g_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_sup_mode = "e400g_400g_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_sys_clk_src = "e400g_400g_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_aib_if_fifo_mode = "e400g_400g_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_fec_enable = "e400g_400g_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_pcs_mode = "e400g_400g_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_primary_use = "e400g_400g_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_system_bonding = "e400g_400g_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_400g_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_aibif_data_valid = "e400g_50g_0_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_duplex_mode = "e400g_50g_0_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_fec_mode = "e400g_50g_0_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_lpbk_mode = "e400g_50g_0_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_flow_control = "e400g_50g_0_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_flow_control_holdoff_mode = "e400g_50g_0_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_link_fault_mode = "e400g_50g_0_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_mode = "e400g_50g_0_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_ptp_phy_lane_num = "e400g_50g_0_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_ipg_size = "e400g_50g_0_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_ptp_phy_lane_num = "e400g_50g_0_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_pcs_ber_mon_mode = "e400g_50g_0_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_pcs_pcs_ber_mon_mode = "e400g_50g_0_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_ptp_mode = "e400g_50g_0_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_fec_enable = "e400g_50g_0_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_pcs_mode = "e400g_50g_0_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_primary_use = "e400g_50g_0_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_system_bonding = "e400g_50g_0_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_sup_mode = "e400g_50g_0_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_sys_clk_src = "e400g_50g_0_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_aib_if_fifo_mode = "e400g_50g_0_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_fec_enable = "e400g_50g_0_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_pcs_mode = "e400g_50g_0_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_primary_use = "e400g_50g_0_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_system_bonding = "e400g_50g_0_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_0_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_aibif_data_valid = "e400g_50g_1_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_duplex_mode = "e400g_50g_1_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_fec_mode = "e400g_50g_1_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_lpbk_mode = "e400g_50g_1_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_flow_control = "e400g_50g_1_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_flow_control_holdoff_mode = "e400g_50g_1_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_link_fault_mode = "e400g_50g_1_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_mode = "e400g_50g_1_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_ptp_phy_lane_num = "e400g_50g_1_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_ipg_size = "e400g_50g_1_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_ptp_phy_lane_num = "e400g_50g_1_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_pcs_ber_mon_mode = "e400g_50g_1_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_pcs_pcs_ber_mon_mode = "e400g_50g_1_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_ptp_mode = "e400g_50g_1_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_fec_enable = "e400g_50g_1_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_pcs_mode = "e400g_50g_1_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_primary_use = "e400g_50g_1_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_system_bonding = "e400g_50g_1_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_sup_mode = "e400g_50g_1_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_sys_clk_src = "e400g_50g_1_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_aib_if_fifo_mode = "e400g_50g_1_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_fec_enable = "e400g_50g_1_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_pcs_mode = "e400g_50g_1_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_primary_use = "e400g_50g_1_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_system_bonding = "e400g_50g_1_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_1_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_aibif_data_valid = "e400g_50g_2_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_duplex_mode = "e400g_50g_2_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_fec_mode = "e400g_50g_2_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_lpbk_mode = "e400g_50g_2_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_flow_control = "e400g_50g_2_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_flow_control_holdoff_mode = "e400g_50g_2_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_link_fault_mode = "e400g_50g_2_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_mode = "e400g_50g_2_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_ptp_phy_lane_num = "e400g_50g_2_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_ipg_size = "e400g_50g_2_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_ptp_phy_lane_num = "e400g_50g_2_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_pcs_ber_mon_mode = "e400g_50g_2_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_pcs_pcs_ber_mon_mode = "e400g_50g_2_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_ptp_mode = "e400g_50g_2_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_fec_enable = "e400g_50g_2_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_pcs_mode = "e400g_50g_2_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_primary_use = "e400g_50g_2_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_system_bonding = "e400g_50g_2_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_sup_mode = "e400g_50g_2_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_sys_clk_src = "e400g_50g_2_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_aib_if_fifo_mode = "e400g_50g_2_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_fec_enable = "e400g_50g_2_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_pcs_mode = "e400g_50g_2_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_primary_use = "e400g_50g_2_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_system_bonding = "e400g_50g_2_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_2_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_aibif_data_valid = "e400g_50g_3_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_duplex_mode = "e400g_50g_3_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_fec_mode = "e400g_50g_3_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_lpbk_mode = "e400g_50g_3_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_flow_control = "e400g_50g_3_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_flow_control_holdoff_mode = "e400g_50g_3_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_link_fault_mode = "e400g_50g_3_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_mode = "e400g_50g_3_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_ptp_phy_lane_num = "e400g_50g_3_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_ipg_size = "e400g_50g_3_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_ptp_phy_lane_num = "e400g_50g_3_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_pcs_ber_mon_mode = "e400g_50g_3_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_pcs_pcs_ber_mon_mode = "e400g_50g_3_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_ptp_mode = "e400g_50g_3_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_fec_enable = "e400g_50g_3_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_pcs_mode = "e400g_50g_3_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_primary_use = "e400g_50g_3_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_system_bonding = "e400g_50g_3_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_sup_mode = "e400g_50g_3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_sys_clk_src = "e400g_50g_3_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_aib_if_fifo_mode = "e400g_50g_3_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_fec_enable = "e400g_50g_3_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_pcs_mode = "e400g_50g_3_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_primary_use = "e400g_50g_3_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_system_bonding = "e400g_50g_3_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_3_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_aibif_data_valid = "e400g_50g_4_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_duplex_mode = "e400g_50g_4_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_fec_mode = "e400g_50g_4_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_lpbk_mode = "e400g_50g_4_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_flow_control = "e400g_50g_4_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_flow_control_holdoff_mode = "e400g_50g_4_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_link_fault_mode = "e400g_50g_4_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_mode = "e400g_50g_4_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_ptp_phy_lane_num = "e400g_50g_4_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_ipg_size = "e400g_50g_4_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_ptp_phy_lane_num = "e400g_50g_4_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_pcs_ber_mon_mode = "e400g_50g_4_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_pcs_pcs_ber_mon_mode = "e400g_50g_4_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_ptp_mode = "e400g_50g_4_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_fec_enable = "e400g_50g_4_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_pcs_mode = "e400g_50g_4_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_primary_use = "e400g_50g_4_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_system_bonding = "e400g_50g_4_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_sup_mode = "e400g_50g_4_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_sys_clk_src = "e400g_50g_4_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_aib_if_fifo_mode = "e400g_50g_4_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_fec_enable = "e400g_50g_4_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_pcs_mode = "e400g_50g_4_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_primary_use = "e400g_50g_4_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_system_bonding = "e400g_50g_4_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_4_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_aibif_data_valid = "e400g_50g_5_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_duplex_mode = "e400g_50g_5_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_fec_mode = "e400g_50g_5_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_lpbk_mode = "e400g_50g_5_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_flow_control = "e400g_50g_5_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_flow_control_holdoff_mode = "e400g_50g_5_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_link_fault_mode = "e400g_50g_5_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_mode = "e400g_50g_5_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_ptp_phy_lane_num = "e400g_50g_5_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_ipg_size = "e400g_50g_5_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_ptp_phy_lane_num = "e400g_50g_5_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_pcs_ber_mon_mode = "e400g_50g_5_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_pcs_pcs_ber_mon_mode = "e400g_50g_5_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_ptp_mode = "e400g_50g_5_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_fec_enable = "e400g_50g_5_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_pcs_mode = "e400g_50g_5_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_primary_use = "e400g_50g_5_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_system_bonding = "e400g_50g_5_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_sup_mode = "e400g_50g_5_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_sys_clk_src = "e400g_50g_5_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_aib_if_fifo_mode = "e400g_50g_5_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_fec_enable = "e400g_50g_5_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_pcs_mode = "e400g_50g_5_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_primary_use = "e400g_50g_5_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_system_bonding = "e400g_50g_5_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_5_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_aibif_data_valid = "e400g_50g_6_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_duplex_mode = "e400g_50g_6_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_fec_mode = "e400g_50g_6_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_lpbk_mode = "e400g_50g_6_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_flow_control = "e400g_50g_6_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_flow_control_holdoff_mode = "e400g_50g_6_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_link_fault_mode = "e400g_50g_6_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_mode = "e400g_50g_6_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_ptp_phy_lane_num = "e400g_50g_6_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_ipg_size = "e400g_50g_6_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_ptp_phy_lane_num = "e400g_50g_6_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_pcs_ber_mon_mode = "e400g_50g_6_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_pcs_pcs_ber_mon_mode = "e400g_50g_6_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_ptp_mode = "e400g_50g_6_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_fec_enable = "e400g_50g_6_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_pcs_mode = "e400g_50g_6_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_primary_use = "e400g_50g_6_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_system_bonding = "e400g_50g_6_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_sup_mode = "e400g_50g_6_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_sys_clk_src = "e400g_50g_6_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_aib_if_fifo_mode = "e400g_50g_6_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_fec_enable = "e400g_50g_6_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_pcs_mode = "e400g_50g_6_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_primary_use = "e400g_50g_6_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_system_bonding = "e400g_50g_6_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_6_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_aibif_data_valid = "e400g_50g_7_aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_duplex_mode = "e400g_50g_7_duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_fec_mode = "e400g_50g_7_fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_lpbk_mode = "e400g_50g_7_lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_flow_control = "e400g_50g_7_mac_none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_flow_control_holdoff_mode = "e400g_50g_7_mac_per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_link_fault_mode = "e400g_50g_7_mac_lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_mode = "e400g_50g_7_mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_ptp_dbg_master_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_ptp_phy_lane_num = "e400g_50g_7_mac_e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_ipg_size = "e400g_50g_7_mac_ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_ptp_phy_lane_num = "e400g_50g_7_mac_e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_mac_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_pcs_ber_mon_mode = "e400g_50g_7_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_pcs_pcs_ber_mon_mode = "e400g_50g_7_pcs_pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_ptp_mode = "e400g_50g_7_ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_fec_enable = "e400g_50g_7_rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_pcs_mode = "e400g_50g_7_rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_primary_use = "e400g_50g_7_rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_system_bonding = "e400g_50g_7_rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_sup_mode = "e400g_50g_7_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_sys_clk_src = "e400g_50g_7_sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_aib_if_fifo_mode = "e400g_50g_7_tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_fec_enable = "e400g_50g_7_tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_pcs_mode = "e400g_50g_7_tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_primary_use = "e400g_50g_7_tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_system_bonding = "e400g_50g_7_tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_50g_7_tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream0_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream0_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream10_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream10_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream11_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream11_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream12_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream12_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream13_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream13_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream14_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream14_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream15_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream15_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream1_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream1_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream2_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream2_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream3_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream3_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream4_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream4_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream5_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream5_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream6_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream6_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream7_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream7_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream8_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream8_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream9_rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__e400g_stream9_tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_0_mac = "e400g_100g_0_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_0_rx_aibif = "e400g_100g_0_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_0_rx_pcs = "e400g_100g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_0_tx_aibif = "e400g_100g_0_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_0_tx_pcs = "e400g_100g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_1_mac = "e400g_100g_1_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_1_rx_aibif = "e400g_100g_1_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_1_rx_pcs = "e400g_100g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_1_tx_aibif = "e400g_100g_1_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_1_tx_pcs = "e400g_100g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_2_mac = "e400g_100g_2_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_2_rx_aibif = "e400g_100g_2_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_2_rx_pcs = "e400g_100g_2_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_2_tx_aibif = "e400g_100g_2_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_2_tx_pcs = "e400g_100g_2_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_3_mac = "e400g_100g_3_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_3_rx_aibif = "e400g_100g_3_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_3_rx_pcs = "e400g_100g_3_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_3_tx_aibif = "e400g_100g_3_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_100g_3_tx_pcs = "e400g_100g_3_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_0_mac = "e400g_200g_0_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_0_rx_aibif = "e400g_200g_0_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_0_rx_pcs = "e400g_200g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_0_tx_aibif = "e400g_200g_0_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_0_tx_pcs = "e400g_200g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_1_mac = "e400g_200g_1_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_1_rx_aibif = "e400g_200g_1_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_1_rx_pcs = "e400g_200g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_1_tx_aibif = "e400g_200g_1_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_200g_1_tx_pcs = "e400g_200g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_0_mac = "e400g_25g_0_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_0_rx_aibif = "e400g_25g_0_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_0_rx_pcs = "e400g_25g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_0_tx_aibif = "e400g_25g_0_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_0_tx_pcs = "e400g_25g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_10_mac = "e400g_25g_10_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_10_rx_aibif = "e400g_25g_10_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_10_rx_pcs = "e400g_25g_10_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_10_tx_aibif = "e400g_25g_10_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_10_tx_pcs = "e400g_25g_10_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_11_mac = "e400g_25g_11_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_11_rx_aibif = "e400g_25g_11_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_11_rx_pcs = "e400g_25g_11_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_11_tx_aibif = "e400g_25g_11_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_11_tx_pcs = "e400g_25g_11_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_12_mac = "e400g_25g_12_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_12_rx_aibif = "e400g_25g_12_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_12_rx_pcs = "e400g_25g_12_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_12_tx_aibif = "e400g_25g_12_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_12_tx_pcs = "e400g_25g_12_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_13_mac = "e400g_25g_13_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_13_rx_aibif = "e400g_25g_13_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_13_rx_pcs = "e400g_25g_13_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_13_tx_aibif = "e400g_25g_13_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_13_tx_pcs = "e400g_25g_13_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_14_mac = "e400g_25g_14_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_14_rx_aibif = "e400g_25g_14_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_14_rx_pcs = "e400g_25g_14_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_14_tx_aibif = "e400g_25g_14_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_14_tx_pcs = "e400g_25g_14_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_15_mac = "e400g_25g_15_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_15_rx_aibif = "e400g_25g_15_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_15_rx_pcs = "e400g_25g_15_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_15_tx_aibif = "e400g_25g_15_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_15_tx_pcs = "e400g_25g_15_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_1_mac = "e400g_25g_1_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_1_rx_aibif = "e400g_25g_1_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_1_rx_pcs = "e400g_25g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_1_tx_aibif = "e400g_25g_1_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_1_tx_pcs = "e400g_25g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_2_mac = "e400g_25g_2_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_2_rx_aibif = "e400g_25g_2_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_2_rx_pcs = "e400g_25g_2_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_2_tx_aibif = "e400g_25g_2_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_2_tx_pcs = "e400g_25g_2_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_3_mac = "e400g_25g_3_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_3_rx_aibif = "e400g_25g_3_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_3_rx_pcs = "e400g_25g_3_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_3_tx_aibif = "e400g_25g_3_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_3_tx_pcs = "e400g_25g_3_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_4_mac = "e400g_25g_4_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_4_rx_aibif = "e400g_25g_4_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_4_rx_pcs = "e400g_25g_4_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_4_tx_aibif = "e400g_25g_4_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_4_tx_pcs = "e400g_25g_4_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_5_mac = "e400g_25g_5_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_5_rx_aibif = "e400g_25g_5_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_5_rx_pcs = "e400g_25g_5_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_5_tx_aibif = "e400g_25g_5_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_5_tx_pcs = "e400g_25g_5_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_6_mac = "e400g_25g_6_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_6_rx_aibif = "e400g_25g_6_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_6_rx_pcs = "e400g_25g_6_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_6_tx_aibif = "e400g_25g_6_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_6_tx_pcs = "e400g_25g_6_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_7_mac = "e400g_25g_7_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_7_rx_aibif = "e400g_25g_7_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_7_rx_pcs = "e400g_25g_7_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_7_tx_aibif = "e400g_25g_7_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_7_tx_pcs = "e400g_25g_7_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_8_mac = "e400g_25g_8_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_8_rx_aibif = "e400g_25g_8_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_8_rx_pcs = "e400g_25g_8_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_8_tx_aibif = "e400g_25g_8_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_8_tx_pcs = "e400g_25g_8_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_9_mac = "e400g_25g_9_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_9_rx_aibif = "e400g_25g_9_rx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_9_rx_pcs = "e400g_25g_9_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_9_tx_aibif = "e400g_25g_9_tx_aibif_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_25g_9_tx_pcs = "e400g_25g_9_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_400g_mac = "e400g_400g_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_400g_rx_aibif = "e400g_400g_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_400g_rx_pcs = "e400g_400g_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_400g_tx_aibif = "e400g_400g_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_400g_tx_pcs = "e400g_400g_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_0_mac = "e400g_50g_0_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_0_rx_aibif = "e400g_50g_0_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_0_rx_pcs = "e400g_50g_0_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_0_tx_aibif = "e400g_50g_0_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_0_tx_pcs = "e400g_50g_0_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_1_mac = "e400g_50g_1_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_1_rx_aibif = "e400g_50g_1_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_1_rx_pcs = "e400g_50g_1_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_1_tx_aibif = "e400g_50g_1_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_1_tx_pcs = "e400g_50g_1_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_2_mac = "e400g_50g_2_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_2_rx_aibif = "e400g_50g_2_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_2_rx_pcs = "e400g_50g_2_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_2_tx_aibif = "e400g_50g_2_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_2_tx_pcs = "e400g_50g_2_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_3_mac = "e400g_50g_3_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_3_rx_aibif = "e400g_50g_3_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_3_rx_pcs = "e400g_50g_3_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_3_tx_aibif = "e400g_50g_3_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_3_tx_pcs = "e400g_50g_3_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_4_mac = "e400g_50g_4_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_4_rx_aibif = "e400g_50g_4_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_4_rx_pcs = "e400g_50g_4_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_4_tx_aibif = "e400g_50g_4_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_4_tx_pcs = "e400g_50g_4_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_5_mac = "e400g_50g_5_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_5_rx_aibif = "e400g_50g_5_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_5_rx_pcs = "e400g_50g_5_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_5_tx_aibif = "e400g_50g_5_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_5_tx_pcs = "e400g_50g_5_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_6_mac = "e400g_50g_6_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_6_rx_aibif = "e400g_50g_6_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_6_rx_pcs = "e400g_50g_6_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_6_tx_aibif = "e400g_50g_6_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_6_tx_pcs = "e400g_50g_6_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_7_mac = "e400g_50g_7_mac_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_7_rx_aibif = "e400g_50g_7_rx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_7_rx_pcs = "e400g_50g_7_rx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_7_tx_aibif = "e400g_50g_7_tx_aibif_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_e400g_50g_7_tx_pcs = "e400g_50g_7_tx_pcs_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_ehip_cfg = "ehip_cfg_on";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_ac_ehip_misc = "ehip_misc_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_cfg_clk = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch0_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch10_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch11_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch12_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch13_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch14_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch15_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch1_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch2_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch3_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch4_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch5_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch6_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch7_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch8_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__powermode_freq_hz_ehip_ch9_clk = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_asm__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__ehip_rate = "rate_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_100g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__ehip_rate = "rate_200g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_200g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__ehip_rate = "rate_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_400g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch0_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch10_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch11_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__ehip_rate = "rate_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_100g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch12_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch13_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch14_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch15_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch1_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch2_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch3_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__ehip_rate = "rate_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_100g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch4_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch5_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch6_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch7_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__ehip_rate = "rate_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_100g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__ehip_rate = "rate_200g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_200g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__fifo_stop_wr = "n_wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__rx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__tx_total_xcvr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_aibif__word_align = "wa_dis";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__aib_word_align_dis = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__ehip_rate = "rate_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__hi_ber_monitor = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_ehip_mode = "use_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch8_50g__gdr_e4hip_pcs__xus_timer_window = 201415;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__aibif_data_valid = "aibif_data_valid_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__aibif_tx_bundle_enable = "aibif_bundle_tx_enable_not_bundled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__aibif_tx_bundle_size = "aibif_bundle_tx_size_bundle_size_0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__dfd_mux_reserved = "dfd_res_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__ehip_mode_rx = "ehip_rx_pmadir";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__enable_rx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__enable_tx_stats_snapshot = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__flowreg_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__force_hip_ready = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__force_tx_pld_deskew_valid = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__lb_txmac_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__lb_txpcs_rxaib = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__mac_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__mac_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__overclk_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__pcs_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__pcs_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__ptp_clock_en_rx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__ptp_clock_en_tx = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_system_bonding = "rx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__rx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_deskew_clear = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_deskew_en = "disable_deskew";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_mac_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_pcs_in_rst = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_pld_fifo_afull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_pmadirect_single_width = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_ro_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_system_bonding = "tx_system_bonding_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__tx_total_xcvr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__txfifo_empty = "empty_default";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__txfifo_full = "full_sw";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__txfifo_pempty = 2;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__txfifo_pfull = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_aibif__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__aib_word_align_dis = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__aib_word_align_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__aib_word_align_override_init_on_am_value = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__aib_word_align_override_init_value = "zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__ber_invalid_count = 97;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__check_random_idles = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__dis_descram_am_filter = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__duplex_mode = "duplex_mode_full_duplex";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__ehip_rate = "rate_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__ena_100g_blkalign_timeout_dis_elane_wa_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__ena_400g_hiber_to_mii_decoder_dis_elane_blksync_srst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__fec_spec = "fec_spec_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__hi_ber_monitor = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__otn_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__pcs_ber_mon_mode = "pcs_ber_mon_mode_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__pcs_ctrl_reserved = "pcs_reserved_zero";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__return_to_neutral = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_aib_word_align_lfb_ena = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_am_interval = "no_rx_am_interval";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_am_interval_msb = "no_rx_am_interval_msb";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_ehip_mode = "force_pcs_status";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_fec_enable = "rx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_pcs_max_skew = 47;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_pcs_mode = "rx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_primary_use = "rx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_use_aligner = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rx_use_dsc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__rxpcsmux_sel = "rx_lphy";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__select_rx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__select_tx_am = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__sup_mode = "sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__sys_clk_src = "sys_clk_src_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_am_encoding_0 = 9467463;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_am_encoding_1 = 15779046;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_am_encoding_2 = 12936603;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_am_encoding_3 = 10647869;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_ehip_mode = "dis_ptp_eco";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_fec_enable = "tx_fec_enable_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_pcs_mode = "tx_pcs_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_primary_use = "tx_primary_use_direct_bundle";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_use_enc = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_use_scr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__tx_use_striper = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__txpcsmux_sel = "tx_mac";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__use_rx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__use_tx_50g = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_ch9_25g__gdr_e4hip_pcs__xus_timer_window = 806451;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__fifo_rd_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__fifo_stop_rd = "rd_empty";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__fifo_stop_wr = "wr_full";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__fifo_wr_clk_scg_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__phcomp_rd_del = "phcomp_rd_del3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__tx_aib_if_fifo_mode = "tx_aib_if_fifo_mode_phasecomp";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__tx_fifo_power_mode = "full_width_half_depth";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_config_p2p__word_align = "wa_en";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__mac_rate = "standard_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rate_mode = "e400g_100g_0_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_100g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__mac_rate = "standard_200g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rate_mode = "e400g_200g_0_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_200g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rate_mode = "e400g_25g_0_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__mac_rate = "standard_400g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rate_mode = "e400g_400g_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_400g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rate_mode = "e400g_50g_0_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch0_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rate_mode = "e400g_25g_10_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rate_mode = "e400g_50g_5_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch10_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rate_mode = "e400g_25g_11_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch11_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__mac_rate = "standard_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rate_mode = "e400g_100g_3_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_100g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rate_mode = "e400g_25g_12_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rate_mode = "e400g_50g_6_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch12_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rate_mode = "e400g_25g_13_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch13_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rate_mode = "e400g_25g_14_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rate_mode = "e400g_50g_7_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch14_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rate_mode = "e400g_25g_15_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch15_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rate_mode = "e400g_25g_1_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch1_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rate_mode = "e400g_25g_2_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rate_mode = "e400g_50g_1_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch2_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rate_mode = "e400g_25g_3_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch3_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__mac_rate = "standard_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rate_mode = "e400g_100g_1_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_100g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rate_mode = "e400g_25g_4_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rate_mode = "e400g_50g_2_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch4_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rate_mode = "e400g_25g_5_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch5_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rate_mode = "e400g_25g_6_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rate_mode = "e400g_50g_3_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch6_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rate_mode = "e400g_25g_7_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch7_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__mac_rate = "standard_100g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rate_mode = "e400g_100g_2_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_100g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__mac_rate = "standard_200g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rate_mode = "e400g_200g_1_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_200g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rate_mode = "e400g_25g_8_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__mac_rate = "standard_50g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rate_mode = "e400g_50g_4_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch8_50g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__avmm_timeout = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__custom_cadence = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__dbg_bus_sel_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__dbg_bus_sel_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__dbg_bus_sel_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__dbg_bus_sel_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__dbg_bus_sel_dbg = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__disable_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__enforce_max_frame_size = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__fec_mode = "fec_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__flow_control = "none";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__flow_control_holdoff_mode = "per_queue";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__flowreg_rate = "flowreg_standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__force_link_fault_rf = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__forward_rx_pause_requests = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__ipg_removed_per_am_period = 20;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__keep_rx_crc = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__link_fault_mode = "lf_off";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__lpbk_mode = "lpbk_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__mac_lb_mode = "no_loopback";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__mac_mode = "mac_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__mac_rate = "standard_25g";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pause_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_holdoff_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_0 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_1 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_2 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_3 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_4 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_5 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_6 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__pfc_pause_quanta_7 = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__ptp_mode = "ptp_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rate_mode = "e400g_25g_9_mac_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__remove_pads = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__request_tx_pause = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rst_rx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rst_tx_stats = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_ap_filter = "no_filtering";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_dbg_pkt_n_ts_ctr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_fec_mode = "rx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_phy_lane_num = "e25g_x1_rx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_ui = "e25g_x1_rx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_offset_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_ptp_vl_to_pl_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__rxcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__source_address_insertion = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__strict_preamble_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__strict_sfd_checking = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ipg_size = "ipg_12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_length_checking = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_mac_data_flow = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_max_frame_size = 1518;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_pause_daddr = 41'h180C2000001;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_pause_saddr = 48'hE100CBFC5ADD;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_preamble_passthrough = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_extra_latency = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_fec_mode = "tx_no_fec";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_phy_lane_num = "e25g_x1_tx_ln";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_ui = "e25g_x1_tx_ui";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_0 = "e10g_25g_vl0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_1 = "e10g_25g_vl1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_10 = "e10g_25g_vl10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_11 = "e10g_25g_vl11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_12 = "e10g_25g_vl12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_13 = "e10g_25g_vl13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_14 = "e10g_25g_vl14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_15 = "e10g_25g_vl15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_16 = "e10g_25g_vl16";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_17 = "e10g_25g_vl17";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_18 = "e10g_25g_vl18";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_19 = "e10g_25g_vl19";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_2 = "e10g_25g_vl2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_3 = "e10g_25g_vl3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_4 = "e10g_25g_vl4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_5 = "e10g_25g_vl5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_6 = "e10g_25g_vl6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_7 = "e10g_25g_vl7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_8 = "e10g_25g_vl8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_ptp_vl_offset_9 = "e10g_25g_vl9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__tx_vlan_detection = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__txcrc_covers_preamble = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__txmac_saddr = 37'h1122334455;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__uniform_holdoff_quanta = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__u_gdr_e4hip_top__u_maccfg_ch9_25g__use_am_insert = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux0_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux0_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux0_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux0_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux0_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux0_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux10_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux10_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux10_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux10_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux10_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux10_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux11_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux11_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux11_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux11_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux11_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux11_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux12_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux12_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux12_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux12_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux12_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux12_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux13_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux13_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux13_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux13_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux13_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux13_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux14_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux14_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux14_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux14_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux14_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux14_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux15_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux15_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux15_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux15_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux15_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux15_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux1_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux1_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux1_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux1_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux1_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux1_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux2_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux2_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux2_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux2_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux2_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux2_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux3_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux3_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux3_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux3_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux3_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux3_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux4_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux4_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux4_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux4_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux4_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux4_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux5_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux5_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux5_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux5_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux5_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux5_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux6_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux6_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux6_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux6_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux6_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux6_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux7_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux7_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux7_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux7_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux7_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux7_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux8_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux8_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux8_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux8_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux8_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux8_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux9_return_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux9_rx_user_xcvr_rc_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux9_rxword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux9_tx_user_xcvr_rc_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux9_tx_user_xcvr_rc_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__ux9_txword_xcvr_rc_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_112e4x0 = "xcvr_select_112e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_112e4x1 = "xcvr_select_112e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_112e4x2 = "xcvr_select_112e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_112e4x3 = "xcvr_select_112e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x0 = "xcvr_select_25e4x0_e4ux15";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x1 = "xcvr_select_25e4x1_e4ux14";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x10 = "xcvr_select_25e4x10_e4ux5";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x11 = "xcvr_select_25e4x11_e4ux4";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x12 = "xcvr_select_25e4x12_e4ux3";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x13 = "xcvr_select_25e4x13_e4ux2";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x14 = "xcvr_select_25e4x14_e4ux1";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x15 = "xcvr_select_25e4x15_e4ux0";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x2 = "xcvr_select_25e4x2_e4ux13";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x3 = "xcvr_select_25e4x3_e4ux12";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x4 = "xcvr_select_25e4x4_e4ux11";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x5 = "xcvr_select_25e4x5_e4ux10";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x6 = "xcvr_select_25e4x6_e4ux9";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x7 = "xcvr_select_25e4x7_e4ux8";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x8 = "xcvr_select_25e4x8_e4ux7";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_25e4x9 = "xcvr_select_25e4x9_e4ux6";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x0 = "xcvr_select_56e4x0_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x1 = "xcvr_select_56e4x1_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x2 = "xcvr_select_56e4x2_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x3 = "xcvr_select_56e4x3_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x4 = "xcvr_select_56e4x4_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x5 = "xcvr_select_56e4x5_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x6 = "xcvr_select_56e4x6_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_e400g_top__xcvr_select_56e4x7 = "xcvr_select_56e4x7_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_0_sclk = "off_aib_clkrst_aibrc_ds_0_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_10_sclk = "off_aib_clkrst_aibrc_ds_10_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_11_sclk = "off_aib_clkrst_aibrc_ds_11_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_12_sclk = "off_aib_clkrst_aibrc_ds_12_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_13_sclk = "off_aib_clkrst_aibrc_ds_13_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_14_sclk = "off_aib_clkrst_aibrc_ds_14_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_15_sclk = "off_aib_clkrst_aibrc_ds_15_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_16_sclk = "off_aib_clkrst_aibrc_ds_16_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_17_sclk = "off_aib_clkrst_aibrc_ds_17_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_18_sclk = "off_aib_clkrst_aibrc_ds_18_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_19_sclk = "off_aib_clkrst_aibrc_ds_19_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_1_sclk = "off_aib_clkrst_aibrc_ds_1_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_20_sclk = "off_aib_clkrst_aibrc_ds_20_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_21_sclk = "off_aib_clkrst_aibrc_ds_21_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_22_sclk = "off_aib_clkrst_aibrc_ds_22_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_23_sclk = "off_aib_clkrst_aibrc_ds_23_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_2_sclk = "off_aib_clkrst_aibrc_ds_2_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_3_sclk = "off_aib_clkrst_aibrc_ds_3_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_4_sclk = "off_aib_clkrst_aibrc_ds_4_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_5_sclk = "off_aib_clkrst_aibrc_ds_5_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_6_sclk = "off_aib_clkrst_aibrc_ds_6_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_7_sclk = "off_aib_clkrst_aibrc_ds_7_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_8_sclk = "off_aib_clkrst_aibrc_ds_8_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_clkrst_aibrc_ds_9_sclk = "off_aib_clkrst_aibrc_ds_9_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_0_sclk = "off_aib_ie200g_ds_0_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_0_tx_clk = "off_aib_ie200g_ds_0_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_10_sclk = "off_aib_ie200g_ds_10_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_10_tx_clk = "off_aib_ie200g_ds_10_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_11_sclk = "off_aib_ie200g_ds_11_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_11_tx_clk = "off_aib_ie200g_ds_11_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_12_sclk = "off_aib_ie200g_ds_12_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_12_tx_clk = "off_aib_ie200g_ds_12_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_13_sclk = "off_aib_ie200g_ds_13_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_13_tx_clk = "off_aib_ie200g_ds_13_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_14_sclk = "off_aib_ie200g_ds_14_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_14_tx_clk = "off_aib_ie200g_ds_14_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_15_sclk = "off_aib_ie200g_ds_15_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_15_tx_clk = "off_aib_ie200g_ds_15_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_16_sclk = "off_aib_ie200g_ds_16_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_16_tx_clk = "off_aib_ie200g_ds_16_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_17_sclk = "off_aib_ie200g_ds_17_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_17_tx_clk = "off_aib_ie200g_ds_17_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_18_sclk = "off_aib_ie200g_ds_18_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_18_tx_clk = "off_aib_ie200g_ds_18_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_19_sclk = "off_aib_ie200g_ds_19_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_19_tx_clk = "off_aib_ie200g_ds_19_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_1_sclk = "off_aib_ie200g_ds_1_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_1_tx_clk = "off_aib_ie200g_ds_1_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_20_sclk = "off_aib_ie200g_ds_20_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_20_tx_clk = "off_aib_ie200g_ds_20_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_21_sclk = "off_aib_ie200g_ds_21_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_21_tx_clk = "off_aib_ie200g_ds_21_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_22_sclk = "off_aib_ie200g_ds_22_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_22_tx_clk = "off_aib_ie200g_ds_22_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_23_sclk = "off_aib_ie200g_ds_23_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_23_tx_clk = "off_aib_ie200g_ds_23_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_2_sclk = "off_aib_ie200g_ds_2_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_2_tx_clk = "off_aib_ie200g_ds_2_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_3_sclk = "off_aib_ie200g_ds_3_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_3_tx_clk = "off_aib_ie200g_ds_3_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_4_sclk = "off_aib_ie200g_ds_4_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_4_tx_clk = "off_aib_ie200g_ds_4_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_5_sclk = "off_aib_ie200g_ds_5_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_5_tx_clk = "off_aib_ie200g_ds_5_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_6_sclk = "off_aib_ie200g_ds_6_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_6_tx_clk = "off_aib_ie200g_ds_6_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_7_sclk = "off_aib_ie200g_ds_7_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_7_tx_clk = "off_aib_ie200g_ds_7_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_8_sclk = "off_aib_ie200g_ds_8_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_8_tx_clk = "off_aib_ie200g_ds_8_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_9_sclk = "off_aib_ie200g_ds_9_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie200g_ds_9_tx_clk = "off_aib_ie200g_ds_9_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_0_sclk = "off_aib_ie400g_ds_0_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_0_tx_clk = "pwr_aib_ie400g_ds_0_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_10_sclk = "off_aib_ie400g_ds_10_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_10_tx_clk = "pwr_aib_ie400g_ds_10_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_11_sclk = "off_aib_ie400g_ds_11_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_11_tx_clk = "pwr_aib_ie400g_ds_11_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_12_sclk = "off_aib_ie400g_ds_12_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_12_tx_clk = "pwr_aib_ie400g_ds_12_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_13_sclk = "off_aib_ie400g_ds_13_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_13_tx_clk = "pwr_aib_ie400g_ds_13_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_14_sclk = "off_aib_ie400g_ds_14_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_14_tx_clk = "pwr_aib_ie400g_ds_14_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_15_sclk = "off_aib_ie400g_ds_15_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_15_tx_clk = "pwr_aib_ie400g_ds_15_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_16_sclk = "off_aib_ie400g_ds_16_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_16_tx_clk = "pwr_aib_ie400g_ds_16_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_17_sclk = "off_aib_ie400g_ds_17_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_17_tx_clk = "pwr_aib_ie400g_ds_17_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_18_sclk = "off_aib_ie400g_ds_18_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_18_tx_clk = "off_aib_ie400g_ds_18_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_19_sclk = "off_aib_ie400g_ds_19_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_19_tx_clk = "off_aib_ie400g_ds_19_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_1_sclk = "off_aib_ie400g_ds_1_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_1_tx_clk = "pwr_aib_ie400g_ds_1_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_20_sclk = "off_aib_ie400g_ds_20_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_20_tx_clk = "off_aib_ie400g_ds_20_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_21_sclk = "off_aib_ie400g_ds_21_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_21_tx_clk = "off_aib_ie400g_ds_21_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_22_sclk = "off_aib_ie400g_ds_22_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_22_tx_clk = "off_aib_ie400g_ds_22_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_23_sclk = "off_aib_ie400g_ds_23_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_23_tx_clk = "off_aib_ie400g_ds_23_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_2_sclk = "off_aib_ie400g_ds_2_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_2_tx_clk = "pwr_aib_ie400g_ds_2_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_3_sclk = "off_aib_ie400g_ds_3_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_3_tx_clk = "pwr_aib_ie400g_ds_3_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_4_sclk = "off_aib_ie400g_ds_4_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_4_tx_clk = "pwr_aib_ie400g_ds_4_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_5_sclk = "off_aib_ie400g_ds_5_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_5_tx_clk = "pwr_aib_ie400g_ds_5_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_6_sclk = "off_aib_ie400g_ds_6_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_6_tx_clk = "pwr_aib_ie400g_ds_6_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_7_sclk = "off_aib_ie400g_ds_7_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_7_tx_clk = "pwr_aib_ie400g_ds_7_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_8_sclk = "off_aib_ie400g_ds_8_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_8_tx_clk = "pwr_aib_ie400g_ds_8_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_9_sclk = "off_aib_ie400g_ds_9_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aib_ie400g_ds_9_tx_clk = "pwr_aib_ie400g_ds_9_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_0_pma_internal_clk1 = "off_aibrc_clkrst_e200g_us_0_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_0_pma_internal_clk2 = "off_aibrc_clkrst_e200g_us_0_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_0_standalonecoreclk = "off_aibrc_clkrst_e200g_us_0_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_0_xcvr_quad_refclk1 = "off_aibrc_clkrst_e200g_us_0_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_0_xcvr_quad_refclk2 = "off_aibrc_clkrst_e200g_us_0_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_1_pma_internal_clk1 = "off_aibrc_clkrst_e200g_us_1_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_1_pma_internal_clk2 = "off_aibrc_clkrst_e200g_us_1_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_1_standalonecoreclk = "off_aibrc_clkrst_e200g_us_1_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_1_xcvr_quad_refclk1 = "off_aibrc_clkrst_e200g_us_1_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_1_xcvr_quad_refclk2 = "off_aibrc_clkrst_e200g_us_1_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_2_pma_internal_clk1 = "off_aibrc_clkrst_e200g_us_2_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_2_pma_internal_clk2 = "off_aibrc_clkrst_e200g_us_2_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_2_standalonecoreclk = "off_aibrc_clkrst_e200g_us_2_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_2_xcvr_quad_refclk1 = "off_aibrc_clkrst_e200g_us_2_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_2_xcvr_quad_refclk2 = "off_aibrc_clkrst_e200g_us_2_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_3_pma_internal_clk1 = "off_aibrc_clkrst_e200g_us_3_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_3_pma_internal_clk2 = "off_aibrc_clkrst_e200g_us_3_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_3_standalonecoreclk = "off_aibrc_clkrst_e200g_us_3_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_3_xcvr_quad_refclk1 = "off_aibrc_clkrst_e200g_us_3_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e200g_us_3_xcvr_quad_refclk2 = "off_aibrc_clkrst_e200g_us_3_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_0_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_0_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_0_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_0_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_0_standalonecoreclk = "off_aibrc_clkrst_e400g_us_0_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_0_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_0_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_0_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_0_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_10_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_10_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_10_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_10_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_10_standalonecoreclk = "off_aibrc_clkrst_e400g_us_10_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_10_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_10_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_10_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_10_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_11_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_11_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_11_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_11_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_11_standalonecoreclk = "off_aibrc_clkrst_e400g_us_11_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_11_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_11_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_11_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_11_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_1_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_1_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_1_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_1_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_1_standalonecoreclk = "off_aibrc_clkrst_e400g_us_1_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_1_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_1_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_1_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_1_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_2_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_2_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_2_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_2_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_2_standalonecoreclk = "off_aibrc_clkrst_e400g_us_2_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_2_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_2_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_2_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_2_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_3_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_3_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_3_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_3_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_3_standalonecoreclk = "off_aibrc_clkrst_e400g_us_3_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_3_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_3_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_3_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_3_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_4_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_4_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_4_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_4_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_4_standalonecoreclk = "off_aibrc_clkrst_e400g_us_4_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_4_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_4_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_4_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_4_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_5_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_5_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_5_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_5_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_5_standalonecoreclk = "off_aibrc_clkrst_e400g_us_5_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_5_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_5_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_5_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_5_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_6_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_6_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_6_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_6_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_6_standalonecoreclk = "off_aibrc_clkrst_e400g_us_6_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_6_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_6_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_6_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_6_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_7_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_7_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_7_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_7_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_7_standalonecoreclk = "off_aibrc_clkrst_e400g_us_7_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_7_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_7_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_7_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_7_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_8_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_8_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_8_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_8_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_8_standalonecoreclk = "off_aibrc_clkrst_e400g_us_8_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_8_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_8_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_8_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_8_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_9_pma_internal_clk1 = "off_aibrc_clkrst_e400g_us_9_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_9_pma_internal_clk2 = "off_aibrc_clkrst_e400g_us_9_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_9_standalonecoreclk = "off_aibrc_clkrst_e400g_us_9_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_9_xcvr_quad_refclk1 = "off_aibrc_clkrst_e400g_us_9_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_e400g_us_9_xcvr_quad_refclk2 = "off_aibrc_clkrst_e400g_us_9_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_0_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_0_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_0_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_0_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_0_standalonecoreclk = "off_aibrc_clkrst_pcie_us_0_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_0_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_0_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_0_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_0_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_1_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_1_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_1_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_1_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_1_standalonecoreclk = "off_aibrc_clkrst_pcie_us_1_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_1_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_1_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_1_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_1_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_2_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_2_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_2_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_2_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_2_standalonecoreclk = "off_aibrc_clkrst_pcie_us_2_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_2_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_2_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_2_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_2_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_3_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_3_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_3_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_3_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_3_standalonecoreclk = "off_aibrc_clkrst_pcie_us_3_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_3_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_3_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_3_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_3_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_4_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_4_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_4_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_4_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_4_standalonecoreclk = "off_aibrc_clkrst_pcie_us_4_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_4_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_4_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_4_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_4_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_5_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_5_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_5_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_5_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_5_standalonecoreclk = "off_aibrc_clkrst_pcie_us_5_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_5_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_5_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_5_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_5_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_6_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_6_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_6_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_6_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_6_standalonecoreclk = "off_aibrc_clkrst_pcie_us_6_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_6_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_6_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_6_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_6_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_7_pma_internal_clk1 = "off_aibrc_clkrst_pcie_us_7_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_7_pma_internal_clk2 = "off_aibrc_clkrst_pcie_us_7_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_7_standalonecoreclk = "off_aibrc_clkrst_pcie_us_7_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_7_xcvr_quad_refclk1 = "off_aibrc_clkrst_pcie_us_7_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_aibrc_clkrst_pcie_us_7_xcvr_quad_refclk2 = "off_aibrc_clkrst_pcie_us_7_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_dft_ie2hip_ip_dfx_clk = "off_ctrl_dft_ie2hip_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_dft_ie2lphy_ip_dfx_clk = "off_ctrl_dft_ie2lphy_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_dft_ie4hip_ip_dfx_clk = "off_ctrl_dft_ie4hip_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_dft_ie4lphy_ip_dfx_clk = "off_ctrl_dft_ie4lphy_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_dft_ipcie_ip_dfx_clk = "off_ctrl_dft_ipcie_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_dft_ipcie_pcs_ip_dfx_clk = "off_ctrl_dft_ipcie_pcs_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_lpct_aibrc_slv_lpct_clk = "off_ctrl_lpct_aibrc_slv_lpct_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_0_slice0_clk = "pwr_ctrl_pll_aibrc_ip_pll_0_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_0_slice1_clk = "pwr_ctrl_pll_aibrc_ip_pll_0_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_0_slice2_clk = "pwr_ctrl_pll_aibrc_ip_pll_0_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_0_slice3_clk = "off_ctrl_pll_aibrc_ip_pll_0_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_1_slice0_clk = "pwr_ctrl_pll_aibrc_ip_pll_1_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_1_slice1_clk = "pwr_ctrl_pll_aibrc_ip_pll_1_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_1_slice2_clk = "pwr_ctrl_pll_aibrc_ip_pll_1_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_1_slice3_clk = "pwr_ctrl_pll_aibrc_ip_pll_1_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_2_slice0_clk = "pwr_ctrl_pll_aibrc_ip_pll_2_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_2_slice1_clk = "pwr_ctrl_pll_aibrc_ip_pll_2_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_2_slice2_clk = "pwr_ctrl_pll_aibrc_ip_pll_2_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ctrl_pll_aibrc_ip_pll_2_slice3_clk = "pwr_ctrl_pll_aibrc_ip_pll_2_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_e400g_idvp1_aibrc_ip_idvfreqa_clk = "off_e400g_idvp1_aibrc_ip_idvfreqa_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_e400g_idvp1_aibrc_ip_idvfreqb_clk = "off_e400g_idvp1_aibrc_ip_idvfreqb_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_e400g_idvp1_aibrc_ip_idvtclk = "off_e400g_idvp1_aibrc_ip_idvtclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_global_avmm_ctrl_ie2hip_slv_clk = "off_global_avmm_ctrl_ie2hip_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_global_avmm_ctrl_ie2lphy_slv_clk = "off_global_avmm_ctrl_ie2lphy_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_global_avmm_ctrl_ie4hip_slv_clk = "off_global_avmm_ctrl_ie4hip_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_global_avmm_ctrl_ie4lphy_slv_clk = "off_global_avmm_ctrl_ie4lphy_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_global_avmm_ctrl_ipcie_slv_clk = "off_global_avmm_ctrl_ipcie_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_0_aib1_tx_st_clk = "pwr_iaib_e200g_us_0_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_0_aib2_rx_st_clk = "off_iaib_e200g_us_0_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_0_aib2_tx_st_clk = "off_iaib_e200g_us_0_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_0_aib3_rx_st_clk = "off_iaib_e200g_us_0_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_0_aib3_tx_st_clk = "off_iaib_e200g_us_0_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_0_rx_clk = "pwr_iaib_e200g_us_0_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_1_aib1_tx_st_clk = "pwr_iaib_e200g_us_1_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_1_aib2_rx_st_clk = "off_iaib_e200g_us_1_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_1_aib2_tx_st_clk = "off_iaib_e200g_us_1_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_1_aib3_rx_st_clk = "off_iaib_e200g_us_1_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_1_aib3_tx_st_clk = "off_iaib_e200g_us_1_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_1_rx_clk = "pwr_iaib_e200g_us_1_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_2_aib1_tx_st_clk = "pwr_iaib_e200g_us_2_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_2_aib2_rx_st_clk = "off_iaib_e200g_us_2_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_2_aib2_tx_st_clk = "off_iaib_e200g_us_2_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_2_aib3_rx_st_clk = "off_iaib_e200g_us_2_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_2_aib3_tx_st_clk = "off_iaib_e200g_us_2_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_2_rx_clk = "pwr_iaib_e200g_us_2_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_3_aib1_tx_st_clk = "pwr_iaib_e200g_us_3_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_3_aib2_rx_st_clk = "off_iaib_e200g_us_3_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_3_aib2_tx_st_clk = "off_iaib_e200g_us_3_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_3_aib3_rx_st_clk = "off_iaib_e200g_us_3_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_3_aib3_tx_st_clk = "off_iaib_e200g_us_3_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_3_rx_clk = "pwr_iaib_e200g_us_3_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_4_aib1_tx_st_clk = "pwr_iaib_e200g_us_4_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_4_aib2_rx_st_clk = "off_iaib_e200g_us_4_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_4_aib2_tx_st_clk = "off_iaib_e200g_us_4_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_4_aib3_rx_st_clk = "off_iaib_e200g_us_4_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_4_aib3_tx_st_clk = "off_iaib_e200g_us_4_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_4_rx_clk = "pwr_iaib_e200g_us_4_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_5_aib1_tx_st_clk = "pwr_iaib_e200g_us_5_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_5_aib2_rx_st_clk = "off_iaib_e200g_us_5_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_5_aib2_tx_st_clk = "off_iaib_e200g_us_5_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_5_aib3_rx_st_clk = "off_iaib_e200g_us_5_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_5_aib3_tx_st_clk = "off_iaib_e200g_us_5_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_5_rx_clk = "pwr_iaib_e200g_us_5_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_6_aib1_tx_st_clk = "pwr_iaib_e200g_us_6_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_6_aib2_rx_st_clk = "off_iaib_e200g_us_6_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_6_aib2_tx_st_clk = "off_iaib_e200g_us_6_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_6_aib3_rx_st_clk = "off_iaib_e200g_us_6_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_6_aib3_tx_st_clk = "off_iaib_e200g_us_6_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_6_rx_clk = "pwr_iaib_e200g_us_6_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_7_aib1_tx_st_clk = "pwr_iaib_e200g_us_7_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_7_aib2_rx_st_clk = "off_iaib_e200g_us_7_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_7_aib2_tx_st_clk = "off_iaib_e200g_us_7_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_7_aib3_rx_st_clk = "off_iaib_e200g_us_7_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_7_aib3_tx_st_clk = "off_iaib_e200g_us_7_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e200g_us_7_rx_clk = "pwr_iaib_e200g_us_7_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_test_us_0_test_clk = "off_iaib_e400g_test_us_0_test_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_test_us_1_test_clk = "off_iaib_e400g_test_us_1_test_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_test_us_2_test_clk = "off_iaib_e400g_test_us_2_test_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_test_us_3_test_clk = "off_iaib_e400g_test_us_3_test_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_test_us_4_test_clk = "off_iaib_e400g_test_us_4_test_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_test_us_5_test_clk = "off_iaib_e400g_test_us_5_test_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_0_aib1_tx_st_clk = "pwr_iaib_e400g_us_0_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_0_aib2_rx_st_clk = "pwr_iaib_e400g_us_0_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_0_aib2_tx_st_clk = "pwr_iaib_e400g_us_0_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_0_aib3_rx_st_clk = "pwr_iaib_e400g_us_0_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_0_aib3_tx_st_clk = "pwr_iaib_e400g_us_0_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_0_rx_clk = "pwr_iaib_e400g_us_0_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_10_aib1_tx_st_clk = "pwr_iaib_e400g_us_10_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_10_aib2_rx_st_clk = "pwr_iaib_e400g_us_10_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_10_aib2_tx_st_clk = "pwr_iaib_e400g_us_10_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_10_aib3_rx_st_clk = "pwr_iaib_e400g_us_10_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_10_aib3_tx_st_clk = "pwr_iaib_e400g_us_10_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_10_rx_clk = "pwr_iaib_e400g_us_10_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_11_aib1_tx_st_clk = "pwr_iaib_e400g_us_11_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_11_aib2_rx_st_clk = "pwr_iaib_e400g_us_11_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_11_aib2_tx_st_clk = "pwr_iaib_e400g_us_11_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_11_aib3_rx_st_clk = "pwr_iaib_e400g_us_11_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_11_aib3_tx_st_clk = "pwr_iaib_e400g_us_11_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_11_rx_clk = "pwr_iaib_e400g_us_11_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_12_aib1_tx_st_clk = "pwr_iaib_e400g_us_12_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_12_aib2_rx_st_clk = "pwr_iaib_e400g_us_12_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_12_aib2_tx_st_clk = "pwr_iaib_e400g_us_12_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_12_aib3_rx_st_clk = "pwr_iaib_e400g_us_12_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_12_aib3_tx_st_clk = "pwr_iaib_e400g_us_12_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_12_rx_clk = "pwr_iaib_e400g_us_12_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_13_aib1_tx_st_clk = "pwr_iaib_e400g_us_13_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_13_aib2_rx_st_clk = "pwr_iaib_e400g_us_13_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_13_aib2_tx_st_clk = "pwr_iaib_e400g_us_13_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_13_aib3_rx_st_clk = "pwr_iaib_e400g_us_13_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_13_aib3_tx_st_clk = "pwr_iaib_e400g_us_13_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_13_rx_clk = "pwr_iaib_e400g_us_13_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_14_aib1_tx_st_clk = "pwr_iaib_e400g_us_14_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_14_aib2_rx_st_clk = "pwr_iaib_e400g_us_14_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_14_aib2_tx_st_clk = "pwr_iaib_e400g_us_14_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_14_aib3_rx_st_clk = "pwr_iaib_e400g_us_14_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_14_aib3_tx_st_clk = "pwr_iaib_e400g_us_14_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_14_rx_clk = "pwr_iaib_e400g_us_14_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_15_aib1_tx_st_clk = "pwr_iaib_e400g_us_15_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_15_aib2_rx_st_clk = "pwr_iaib_e400g_us_15_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_15_aib2_tx_st_clk = "pwr_iaib_e400g_us_15_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_15_aib3_rx_st_clk = "pwr_iaib_e400g_us_15_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_15_aib3_tx_st_clk = "pwr_iaib_e400g_us_15_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_15_rx_clk = "pwr_iaib_e400g_us_15_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_16_aib1_tx_st_clk = "pwr_iaib_e400g_us_16_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_16_aib2_rx_st_clk = "pwr_iaib_e400g_us_16_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_16_aib2_tx_st_clk = "pwr_iaib_e400g_us_16_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_16_aib3_rx_st_clk = "pwr_iaib_e400g_us_16_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_16_aib3_tx_st_clk = "pwr_iaib_e400g_us_16_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_16_rx_clk = "pwr_iaib_e400g_us_16_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_17_aib1_tx_st_clk = "pwr_iaib_e400g_us_17_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_17_aib2_rx_st_clk = "pwr_iaib_e400g_us_17_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_17_aib2_tx_st_clk = "pwr_iaib_e400g_us_17_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_17_aib3_rx_st_clk = "pwr_iaib_e400g_us_17_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_17_aib3_tx_st_clk = "pwr_iaib_e400g_us_17_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_17_rx_clk = "pwr_iaib_e400g_us_17_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_1_aib1_tx_st_clk = "pwr_iaib_e400g_us_1_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_1_aib2_rx_st_clk = "pwr_iaib_e400g_us_1_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_1_aib2_tx_st_clk = "pwr_iaib_e400g_us_1_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_1_aib3_rx_st_clk = "pwr_iaib_e400g_us_1_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_1_aib3_tx_st_clk = "pwr_iaib_e400g_us_1_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_1_rx_clk = "pwr_iaib_e400g_us_1_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_2_aib1_tx_st_clk = "pwr_iaib_e400g_us_2_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_2_aib2_rx_st_clk = "pwr_iaib_e400g_us_2_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_2_aib2_tx_st_clk = "pwr_iaib_e400g_us_2_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_2_aib3_rx_st_clk = "pwr_iaib_e400g_us_2_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_2_aib3_tx_st_clk = "pwr_iaib_e400g_us_2_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_2_rx_clk = "pwr_iaib_e400g_us_2_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_3_aib1_tx_st_clk = "pwr_iaib_e400g_us_3_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_3_aib2_rx_st_clk = "pwr_iaib_e400g_us_3_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_3_aib2_tx_st_clk = "pwr_iaib_e400g_us_3_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_3_aib3_rx_st_clk = "pwr_iaib_e400g_us_3_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_3_aib3_tx_st_clk = "pwr_iaib_e400g_us_3_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_3_rx_clk = "pwr_iaib_e400g_us_3_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_4_aib1_tx_st_clk = "pwr_iaib_e400g_us_4_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_4_aib2_rx_st_clk = "pwr_iaib_e400g_us_4_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_4_aib2_tx_st_clk = "pwr_iaib_e400g_us_4_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_4_aib3_rx_st_clk = "pwr_iaib_e400g_us_4_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_4_aib3_tx_st_clk = "pwr_iaib_e400g_us_4_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_4_rx_clk = "pwr_iaib_e400g_us_4_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_5_aib1_tx_st_clk = "pwr_iaib_e400g_us_5_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_5_aib2_rx_st_clk = "pwr_iaib_e400g_us_5_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_5_aib2_tx_st_clk = "pwr_iaib_e400g_us_5_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_5_aib3_rx_st_clk = "pwr_iaib_e400g_us_5_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_5_aib3_tx_st_clk = "pwr_iaib_e400g_us_5_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_5_rx_clk = "pwr_iaib_e400g_us_5_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_6_aib1_tx_st_clk = "pwr_iaib_e400g_us_6_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_6_aib2_rx_st_clk = "pwr_iaib_e400g_us_6_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_6_aib2_tx_st_clk = "pwr_iaib_e400g_us_6_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_6_aib3_rx_st_clk = "pwr_iaib_e400g_us_6_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_6_aib3_tx_st_clk = "pwr_iaib_e400g_us_6_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_6_rx_clk = "pwr_iaib_e400g_us_6_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_7_aib1_tx_st_clk = "pwr_iaib_e400g_us_7_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_7_aib2_rx_st_clk = "pwr_iaib_e400g_us_7_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_7_aib2_tx_st_clk = "pwr_iaib_e400g_us_7_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_7_aib3_rx_st_clk = "pwr_iaib_e400g_us_7_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_7_aib3_tx_st_clk = "pwr_iaib_e400g_us_7_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_7_rx_clk = "pwr_iaib_e400g_us_7_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_8_aib1_tx_st_clk = "pwr_iaib_e400g_us_8_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_8_aib2_rx_st_clk = "pwr_iaib_e400g_us_8_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_8_aib2_tx_st_clk = "pwr_iaib_e400g_us_8_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_8_aib3_rx_st_clk = "pwr_iaib_e400g_us_8_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_8_aib3_tx_st_clk = "pwr_iaib_e400g_us_8_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_8_rx_clk = "pwr_iaib_e400g_us_8_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_9_aib1_tx_st_clk = "pwr_iaib_e400g_us_9_aib1_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_9_aib2_rx_st_clk = "pwr_iaib_e400g_us_9_aib2_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_9_aib2_tx_st_clk = "pwr_iaib_e400g_us_9_aib2_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_9_aib3_rx_st_clk = "pwr_iaib_e400g_us_9_aib3_rx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_9_aib3_tx_st_clk = "pwr_iaib_e400g_us_9_aib3_tx_st_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_e400g_us_9_rx_clk = "pwr_iaib_e400g_us_9_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_0_pld_clk = "pwr_iaib_pcie_aib_0_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_0_pld_clk_2x = "pwr_iaib_pcie_aib_0_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_10_pld_clk = "pwr_iaib_pcie_aib_10_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_10_pld_clk_2x = "pwr_iaib_pcie_aib_10_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_11_pld_clk = "pwr_iaib_pcie_aib_11_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_11_pld_clk_2x = "pwr_iaib_pcie_aib_11_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_12_pld_clk = "pwr_iaib_pcie_aib_12_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_12_pld_clk_2x = "pwr_iaib_pcie_aib_12_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_13_pld_clk = "pwr_iaib_pcie_aib_13_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_13_pld_clk_2x = "pwr_iaib_pcie_aib_13_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_14_pld_clk = "pwr_iaib_pcie_aib_14_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_14_pld_clk_2x = "pwr_iaib_pcie_aib_14_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_15_pld_clk = "pwr_iaib_pcie_aib_15_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_15_pld_clk_2x = "pwr_iaib_pcie_aib_15_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_16_pld_clk = "pwr_iaib_pcie_aib_16_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_16_pld_clk_2x = "pwr_iaib_pcie_aib_16_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_17_pld_clk = "pwr_iaib_pcie_aib_17_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_17_pld_clk_2x = "pwr_iaib_pcie_aib_17_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_18_pld_clk = "pwr_iaib_pcie_aib_18_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_18_pld_clk_2x = "pwr_iaib_pcie_aib_18_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_19_pld_clk = "pwr_iaib_pcie_aib_19_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_19_pld_clk_2x = "pwr_iaib_pcie_aib_19_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_1_pld_clk = "pwr_iaib_pcie_aib_1_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_1_pld_clk_2x = "pwr_iaib_pcie_aib_1_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_20_pld_clk = "pwr_iaib_pcie_aib_20_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_20_pld_clk_2x = "pwr_iaib_pcie_aib_20_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_21_pld_clk = "pwr_iaib_pcie_aib_21_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_21_pld_clk_2x = "pwr_iaib_pcie_aib_21_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_22_pld_clk = "pwr_iaib_pcie_aib_22_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_22_pld_clk_2x = "pwr_iaib_pcie_aib_22_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_23_pld_clk = "pwr_iaib_pcie_aib_23_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_23_pld_clk_2x = "pwr_iaib_pcie_aib_23_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_2_pld_clk = "pwr_iaib_pcie_aib_2_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_2_pld_clk_2x = "pwr_iaib_pcie_aib_2_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_3_pld_clk = "pwr_iaib_pcie_aib_3_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_3_pld_clk_2x = "pwr_iaib_pcie_aib_3_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_4_pld_clk = "pwr_iaib_pcie_aib_4_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_4_pld_clk_2x = "pwr_iaib_pcie_aib_4_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_5_pld_clk = "pwr_iaib_pcie_aib_5_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_5_pld_clk_2x = "pwr_iaib_pcie_aib_5_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_6_pld_clk = "pwr_iaib_pcie_aib_6_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_6_pld_clk_2x = "pwr_iaib_pcie_aib_6_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_7_pld_clk = "pwr_iaib_pcie_aib_7_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_7_pld_clk_2x = "pwr_iaib_pcie_aib_7_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_8_pld_clk = "pwr_iaib_pcie_aib_8_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_8_pld_clk_2x = "pwr_iaib_pcie_aib_8_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_9_pld_clk = "pwr_iaib_pcie_aib_9_pld_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_aib_9_pld_clk_2x = "pwr_iaib_pcie_aib_9_pld_clk_2x";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_0_tx_transfer_clk = "off_iaib_pcie_ip_0_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_0_tx_transfer_div2_clk = "off_iaib_pcie_ip_0_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_10_tx_transfer_clk = "off_iaib_pcie_ip_10_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_10_tx_transfer_div2_clk = "off_iaib_pcie_ip_10_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_11_tx_transfer_clk = "off_iaib_pcie_ip_11_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_11_tx_transfer_div2_clk = "off_iaib_pcie_ip_11_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_12_tx_transfer_clk = "off_iaib_pcie_ip_12_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_12_tx_transfer_div2_clk = "off_iaib_pcie_ip_12_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_13_tx_transfer_clk = "off_iaib_pcie_ip_13_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_13_tx_transfer_div2_clk = "off_iaib_pcie_ip_13_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_14_tx_transfer_clk = "off_iaib_pcie_ip_14_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_14_tx_transfer_div2_clk = "off_iaib_pcie_ip_14_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_15_tx_transfer_clk = "off_iaib_pcie_ip_15_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_15_tx_transfer_div2_clk = "off_iaib_pcie_ip_15_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_16_tx_transfer_clk = "off_iaib_pcie_ip_16_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_16_tx_transfer_div2_clk = "off_iaib_pcie_ip_16_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_17_tx_transfer_clk = "off_iaib_pcie_ip_17_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_17_tx_transfer_div2_clk = "off_iaib_pcie_ip_17_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_18_tx_transfer_clk = "off_iaib_pcie_ip_18_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_18_tx_transfer_div2_clk = "off_iaib_pcie_ip_18_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_19_tx_transfer_clk = "off_iaib_pcie_ip_19_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_19_tx_transfer_div2_clk = "off_iaib_pcie_ip_19_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_1_tx_transfer_clk = "off_iaib_pcie_ip_1_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_1_tx_transfer_div2_clk = "off_iaib_pcie_ip_1_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_20_tx_transfer_clk = "off_iaib_pcie_ip_20_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_20_tx_transfer_div2_clk = "off_iaib_pcie_ip_20_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_21_tx_transfer_clk = "off_iaib_pcie_ip_21_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_21_tx_transfer_div2_clk = "off_iaib_pcie_ip_21_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_22_tx_transfer_clk = "off_iaib_pcie_ip_22_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_22_tx_transfer_div2_clk = "off_iaib_pcie_ip_22_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_23_tx_transfer_clk = "off_iaib_pcie_ip_23_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_23_tx_transfer_div2_clk = "off_iaib_pcie_ip_23_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_2_tx_transfer_clk = "off_iaib_pcie_ip_2_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_2_tx_transfer_div2_clk = "off_iaib_pcie_ip_2_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_3_tx_transfer_clk = "off_iaib_pcie_ip_3_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_3_tx_transfer_div2_clk = "off_iaib_pcie_ip_3_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_4_tx_transfer_clk = "off_iaib_pcie_ip_4_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_4_tx_transfer_div2_clk = "off_iaib_pcie_ip_4_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_5_tx_transfer_clk = "off_iaib_pcie_ip_5_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_5_tx_transfer_div2_clk = "off_iaib_pcie_ip_5_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_6_tx_transfer_clk = "off_iaib_pcie_ip_6_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_6_tx_transfer_div2_clk = "off_iaib_pcie_ip_6_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_7_tx_transfer_clk = "off_iaib_pcie_ip_7_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_7_tx_transfer_div2_clk = "off_iaib_pcie_ip_7_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_8_tx_transfer_clk = "off_iaib_pcie_ip_8_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_8_tx_transfer_div2_clk = "off_iaib_pcie_ip_8_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_9_tx_transfer_clk = "off_iaib_pcie_ip_9_tx_transfer_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_iaib_pcie_ip_9_tx_transfer_div2_clk = "off_iaib_pcie_ip_9_tx_transfer_div2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e200_hub_0_clk = "off_ictrl_dfd_e200_hub_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e200_hub_1_clk = "off_ictrl_dfd_e200_hub_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e200_hub_2_clk = "off_ictrl_dfd_e200_hub_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e200_hub_3_clk = "off_ictrl_dfd_e200_hub_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e400_hub_0_clk = "off_ictrl_dfd_e400_hub_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e400_hub_1_clk = "off_ictrl_dfd_e400_hub_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e400_hub_2_clk = "off_ictrl_dfd_e400_hub_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_e400_hub_3_clk = "off_ictrl_dfd_e400_hub_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_pcie_hub_0_clk = "off_ictrl_dfd_pcie_hub_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_pcie_hub_1_clk = "off_ictrl_dfd_pcie_hub_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_pcie_hub_2_clk = "off_ictrl_dfd_pcie_hub_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ictrl_dfd_pcie_hub_3_clk = "off_ictrl_dfd_pcie_hub_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_ipcie_cvp_ep_avmm_clk_in = "off_ipcie_cvp_ep_avmm_clk_in";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_ac_pcie_cvp_issm_avmm_clk_out = "off_pcie_cvp_issm_avmm_clk_out";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_10_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_11_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_12_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_13_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_14_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_15_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_16_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_17_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_18_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_19_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_20_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_21_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_22_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_23_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_8_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_clkrst_aibrc_ds_9_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_0_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_10_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_10_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_11_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_11_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_12_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_12_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_13_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_13_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_14_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_14_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_15_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_15_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_16_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_16_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_17_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_17_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_18_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_18_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_19_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_19_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_1_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_20_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_20_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_21_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_21_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_22_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_22_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_23_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_23_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_2_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_3_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_4_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_5_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_6_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_7_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_8_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_8_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_9_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie200g_ds_9_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_0_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_10_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_10_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_11_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_11_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_12_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_12_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_13_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_13_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_14_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_14_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_15_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_15_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_16_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_16_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_17_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_17_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_18_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_18_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_19_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_19_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_1_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_20_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_20_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_21_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_21_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_22_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_22_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_23_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_23_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_2_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_3_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_4_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_5_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_6_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_7_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_8_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_8_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_9_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aib_ie400g_ds_9_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e200g_us_3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_10_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_10_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_10_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_10_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_10_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_11_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_11_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_11_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_11_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_11_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_4_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_4_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_4_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_4_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_4_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_5_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_5_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_5_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_5_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_5_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_6_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_6_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_6_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_6_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_6_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_7_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_7_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_7_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_7_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_7_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_8_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_8_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_8_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_8_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_8_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_9_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_9_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_9_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_9_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_e400g_us_9_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_4_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_4_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_4_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_4_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_4_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_5_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_5_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_5_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_5_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_5_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_6_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_6_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_6_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_6_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_6_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_7_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_7_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_7_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_7_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_aibrc_clkrst_pcie_us_7_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_dft_ie2hip_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_dft_ie2lphy_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_dft_ie4hip_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_dft_ie4lphy_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_dft_ipcie_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_dft_ipcie_pcs_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_lpct_aibrc_slv_lpct_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_0_slice0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_0_slice1_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_0_slice2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_0_slice3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_1_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_1_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_1_slice2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_1_slice3_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_2_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_2_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_2_slice2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ctrl_pll_aibrc_ip_pll_2_slice3_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_e400g_idvp1_aibrc_ip_idvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_e400g_idvp1_aibrc_ip_idvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_e400g_idvp1_aibrc_ip_idvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_global_avmm_ctrl_ie2hip_slv_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_global_avmm_ctrl_ie2lphy_slv_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_global_avmm_ctrl_ie4hip_slv_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_global_avmm_ctrl_ie4lphy_slv_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_global_avmm_ctrl_ipcie_slv_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_0_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_0_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_0_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_0_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_0_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_0_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_1_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_1_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_1_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_1_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_1_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_1_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_2_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_2_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_2_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_2_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_2_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_2_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_3_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_3_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_3_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_3_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_3_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_3_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_4_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_4_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_4_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_4_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_4_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_4_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_5_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_5_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_5_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_5_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_5_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_5_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_6_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_6_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_6_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_6_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_6_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_6_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_7_aib1_tx_st_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_7_aib2_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_7_aib2_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_7_aib3_rx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_7_aib3_tx_st_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e200g_us_7_rx_clk_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_test_us_0_test_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_test_us_1_test_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_test_us_2_test_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_test_us_3_test_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_test_us_4_test_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_test_us_5_test_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_0_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_0_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_0_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_0_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_0_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_0_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_10_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_10_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_10_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_10_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_10_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_10_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_11_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_11_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_11_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_11_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_11_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_11_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_12_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_12_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_12_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_12_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_12_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_12_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_13_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_13_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_13_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_13_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_13_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_13_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_14_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_14_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_14_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_14_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_14_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_14_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_15_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_15_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_15_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_15_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_15_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_15_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_16_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_16_aib2_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_16_aib2_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_16_aib3_rx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_16_aib3_tx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_16_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_17_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_17_aib2_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_17_aib2_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_17_aib3_rx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_17_aib3_tx_st_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_17_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_1_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_1_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_1_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_1_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_1_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_1_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_2_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_2_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_2_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_2_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_2_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_2_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_3_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_3_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_3_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_3_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_3_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_3_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_4_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_4_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_4_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_4_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_4_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_4_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_5_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_5_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_5_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_5_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_5_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_5_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_6_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_6_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_6_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_6_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_6_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_6_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_7_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_7_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_7_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_7_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_7_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_7_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_8_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_8_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_8_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_8_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_8_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_8_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_9_aib1_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_9_aib2_rx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_9_aib2_tx_st_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_9_aib3_rx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_9_aib3_tx_st_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_e400g_us_9_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_0_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_0_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_10_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_10_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_11_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_11_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_12_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_12_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_13_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_13_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_14_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_14_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_15_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_15_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_16_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_16_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_17_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_17_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_18_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_18_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_19_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_19_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_1_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_1_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_20_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_20_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_21_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_21_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_22_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_22_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_23_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_23_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_2_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_2_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_3_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_3_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_4_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_4_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_5_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_5_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_6_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_6_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_7_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_7_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_8_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_8_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_9_pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_aib_9_pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_0_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_0_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_10_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_10_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_11_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_11_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_12_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_12_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_13_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_13_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_14_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_14_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_15_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_15_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_16_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_16_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_17_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_17_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_18_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_18_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_19_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_19_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_1_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_1_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_20_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_20_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_21_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_21_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_22_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_22_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_23_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_23_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_2_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_2_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_3_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_3_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_4_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_4_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_5_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_5_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_6_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_6_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_7_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_7_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_8_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_8_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_9_tx_transfer_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_iaib_pcie_ip_9_tx_transfer_div2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e200_hub_0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e200_hub_1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e200_hub_2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e200_hub_3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e400_hub_0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e400_hub_1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e400_hub_2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_e400_hub_3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_pcie_hub_0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_pcie_hub_1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_pcie_hub_2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ictrl_dfd_pcie_hub_3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_ipcie_cvp_ep_avmm_clk_in_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__powermode_freq_hz_i_pcie_cvp_issm_avmm_clk_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_aib_rc__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_dfx_cfg_idrvctrl = "dfx_pad_cfg_drive_strength_16";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_dfx_cfg_ilowpowermode = "dfx_pad_cfg_normal_power_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_dfx_cfg_ioden = "dfx_pad_cfg_normal_drain_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_dfx_cfg_ipupdconfig = "dfx_pad_cfg_pupd_disabled_1_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_pinperst_cfg_idrvctrl = "pinperst_pad_cfg_drive_strength_16";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_pinperst_cfg_ilowpowermode = "pinperst_pad_cfg_normal_power_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_pinperst_cfg_ioden = "pinperst_pad_cfg_normal_drain_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_pinperst_cfg_ipupdconfig = "pinperst_pad_cfg_pupd_disabled_1_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_pinperst_cfg_irxen = "pinperst_pad_cfg_rx_enable_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_pinperst_cfg_itxen = "pinperst_pad_cfg_tx_enable_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_refclk_cfg_idrvctrl = "refclk_pad_cfg_drive_strength_16";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_refclk_cfg_ilowpowermode = "refclk_pad_cfg_normal_power_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_refclk_cfg_ioden = "refclk_pad_cfg_normal_drain_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_refclk_cfg_ipupdconfig = "refclk_pad_cfg_pupd_disabled_1_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_refclk_cfg_irxen = "refclk_pad_cfg_rx_enable_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__io_refclk_cfg_itxen = "refclk_pad_cfg_tx_enable_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dfd_barak_rc_hub_clk = "off_ctrl_dfd_barak_rc_hub_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dfd_ux_rc_hub_0_clk = "off_ctrl_dfd_ux_rc_hub_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dfd_ux_rc_hub_1_clk = "off_ctrl_dfd_ux_rc_hub_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dfd_ux_rc_hub_2_clk = "off_ctrl_dfd_ux_rc_hub_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dfd_ux_rc_hub_3_clk = "off_ctrl_dfd_ux_rc_hub_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_ibarak_ip_brk_aon_sys_clk = "off_ctrl_dft_ibarak_ip_brk_aon_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_ibarak_ip_brk_bti_clk = "off_ctrl_dft_ibarak_ip_brk_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_ibarak_ip_dfx_clk = "off_ctrl_dft_ibarak_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_iux_ip_0_dfx_clk = "off_ctrl_dft_iux_ip_0_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_iux_ip_1_dfx_clk = "off_ctrl_dft_iux_ip_1_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_iux_ip_2_dfx_clk = "off_ctrl_dft_iux_ip_2_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_dft_iux_ip_3_dfx_clk = "off_ctrl_dft_iux_ip_3_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_idvp_iopads_ip_idvfreqa_clk = "off_ctrl_idvp_iopads_ip_idvfreqa_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_idvp_iopads_ip_idvfreqb_clk = "off_ctrl_idvp_iopads_ip_idvfreqb_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_idvp_iopads_ip_idvtclk = "off_ctrl_idvp_iopads_ip_idvtclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_iopads_us_bs_clock_dr_clk = "off_ctrl_iopads_us_bs_clock_dr_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_iopads_us_bs_update_dr_clk = "off_ctrl_iopads_us_bs_update_dr_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_iopads_us_jtag_ctrl = "off_ctrl_iopads_us_jtag_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_0_slice0_clk = "pwr_ctrl_pll_iopads_ip_pll_0_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_0_slice1_clk = "pwr_ctrl_pll_iopads_ip_pll_0_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_0_slice2_clk = "pwr_ctrl_pll_iopads_ip_pll_0_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_0_slice3_clk = "off_ctrl_pll_iopads_ip_pll_0_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_1_slice0_clk = "pwr_ctrl_pll_iopads_ip_pll_1_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_1_slice1_clk = "pwr_ctrl_pll_iopads_ip_pll_1_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_1_slice2_clk = "pwr_ctrl_pll_iopads_ip_pll_1_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_1_slice3_clk = "pwr_ctrl_pll_iopads_ip_pll_1_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_2_slice0_clk = "pwr_ctrl_pll_iopads_ip_pll_2_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_2_slice1_clk = "pwr_ctrl_pll_iopads_ip_pll_2_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_2_slice2_clk = "pwr_ctrl_pll_iopads_ip_pll_2_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ctrl_pll_iopads_ip_pll_2_slice3_clk = "pwr_ctrl_pll_iopads_ip_pll_2_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_global_avmm_ctrl_ibarak_slv_clk = "pwr_global_avmm_ctrl_ibarak_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_global_avmm_ctrl_iux_slv_0_clk = "pwr_global_avmm_ctrl_iux_slv_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_global_avmm_ctrl_iux_slv_1_clk = "pwr_global_avmm_ctrl_iux_slv_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_global_avmm_ctrl_iux_slv_2_clk = "pwr_global_avmm_ctrl_iux_slv_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_global_avmm_ctrl_iux_slv_3_clk = "pwr_global_avmm_ctrl_iux_slv_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ictrl_dft_ux_tcb_0_ref_clk = "off_ictrl_dft_ux_tcb_0_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ictrl_dft_ux_tcb_1_ref_clk = "off_ictrl_dft_ux_tcb_1_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ictrl_dft_ux_tcb_2_ref_clk = "off_ictrl_dft_ux_tcb_2_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_ictrl_dft_ux_tcb_3_ref_clk = "off_ictrl_dft_ux_tcb_3_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_idvp2_iopads_ip_idvfreqa_clk = "off_xcvrrc_idvp2_iopads_ip_idvfreqa_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_idvp2_iopads_ip_idvfreqb_clk = "off_xcvrrc_idvp2_iopads_ip_idvfreqb_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_idvp2_iopads_ip_idvtclk = "off_xcvrrc_idvp2_iopads_ip_idvtclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_0_clk0 = "off_xcvrrc_uxpll_iopads_slv_0_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_0_clk1 = "off_xcvrrc_uxpll_iopads_slv_0_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_1_clk0 = "pwr_xcvrrc_uxpll_iopads_slv_1_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_1_clk1 = "off_xcvrrc_uxpll_iopads_slv_1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_2_clk0 = "off_xcvrrc_uxpll_iopads_slv_2_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_2_clk1 = "off_xcvrrc_uxpll_iopads_slv_2_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_3_clk0 = "off_xcvrrc_uxpll_iopads_slv_3_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_ac_xcvrrc_uxpll_iopads_slv_3_clk1 = "off_xcvrrc_uxpll_iopads_slv_3_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dfd_barak_rc_hub_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dfd_ux_rc_hub_0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dfd_ux_rc_hub_1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dfd_ux_rc_hub_2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dfd_ux_rc_hub_3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_ibarak_ip_brk_aon_sys_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_ibarak_ip_brk_bti_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_ibarak_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_iux_ip_0_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_iux_ip_1_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_iux_ip_2_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_dft_iux_ip_3_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_idvp_iopads_ip_idvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_idvp_iopads_ip_idvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_idvp_iopads_ip_idvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_iopads_us_bs_clock_dr_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_iopads_us_bs_update_dr_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_iopads_us_jtag_ctrl_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_0_slice0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_0_slice1_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_0_slice2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_0_slice3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_1_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_1_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_1_slice2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_1_slice3_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_2_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_2_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_2_slice2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ctrl_pll_iopads_ip_pll_2_slice3_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_global_avmm_ctrl_ibarak_slv_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_global_avmm_ctrl_iux_slv_0_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_global_avmm_ctrl_iux_slv_1_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_global_avmm_ctrl_iux_slv_2_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_global_avmm_ctrl_iux_slv_3_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ictrl_dft_ux_tcb_0_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ictrl_dft_ux_tcb_1_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ictrl_dft_ux_tcb_2_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_ictrl_dft_ux_tcb_3_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_idvp2_iopads_ip_idvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_idvp2_iopads_ip_idvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_idvp2_iopads_ip_idvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_0_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_0_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_1_clk0_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_1_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_2_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_2_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_3_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__powermode_freq_hz_i_xcvrrc_uxpll_iopads_slv_3_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_iopads__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_barak_idvp2_xcvrrc_ip_idvfreqa_clk = "off_barak_idvp2_xcvrrc_ip_idvfreqa_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_barak_idvp2_xcvrrc_ip_idvfreqb_clk = "off_barak_idvp2_xcvrrc_ip_idvfreqb_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_barak_idvp2_xcvrrc_ip_idvtclk = "off_barak_idvp2_xcvrrc_ip_idvtclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ctrl_dft_ux_rc_tcb_0_ref_clk = "off_ctrl_dft_ux_rc_tcb_0_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ctrl_dft_ux_rc_tcb_1_ref_clk = "off_ctrl_dft_ux_rc_tcb_1_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ctrl_dft_ux_rc_tcb_2_ref_clk = "off_ctrl_dft_ux_rc_tcb_2_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ctrl_dft_ux_rc_tcb_3_ref_clk = "off_ctrl_dft_ux_rc_tcb_3_ref_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e200g_clkrst_xcvrrc_ds_0_sclk = "off_e200g_clkrst_xcvrrc_ds_0_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e200g_clkrst_xcvrrc_ds_1_sclk = "off_e200g_clkrst_xcvrrc_ds_1_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e200g_clkrst_xcvrrc_ds_2_sclk = "off_e200g_clkrst_xcvrrc_ds_2_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e200g_clkrst_xcvrrc_ds_3_sclk = "off_e200g_clkrst_xcvrrc_ds_3_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_0_sclk = "off_e400g_clkrst_xcvrrc_ds_0_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_10_sclk = "off_e400g_clkrst_xcvrrc_ds_10_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_11_sclk = "off_e400g_clkrst_xcvrrc_ds_11_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_1_sclk = "off_e400g_clkrst_xcvrrc_ds_1_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_2_sclk = "off_e400g_clkrst_xcvrrc_ds_2_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_3_sclk = "off_e400g_clkrst_xcvrrc_ds_3_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_4_sclk = "off_e400g_clkrst_xcvrrc_ds_4_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_5_sclk = "off_e400g_clkrst_xcvrrc_ds_5_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_6_sclk = "off_e400g_clkrst_xcvrrc_ds_6_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_7_sclk = "off_e400g_clkrst_xcvrrc_ds_7_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_8_sclk = "off_e400g_clkrst_xcvrrc_ds_8_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_e400g_clkrst_xcvrrc_ds_9_sclk = "off_e400g_clkrst_xcvrrc_ds_9_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_0_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_0_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_1_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_1_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_2_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_2_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_3_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_3_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_4_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_4_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_5_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_5_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_6_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_6_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e200g_iux_ds_7_ux_tx_clk_ds = "off_gdr_e200g_iux_ds_7_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_ibarak_ds_0_brk_pcs_srds_tx_clki_lanex = "off_gdr_e400g_ibarak_ds_0_brk_pcs_srds_tx_clki_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_ibarak_ds_1_brk_pcs_srds_tx_clki_lanex = "off_gdr_e400g_ibarak_ds_1_brk_pcs_srds_tx_clki_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_ibarak_ds_2_brk_pcs_srds_tx_clki_lanex = "off_gdr_e400g_ibarak_ds_2_brk_pcs_srds_tx_clki_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_ibarak_ds_3_brk_pcs_srds_tx_clki_lanex = "off_gdr_e400g_ibarak_ds_3_brk_pcs_srds_tx_clki_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_0_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_0_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_10_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_10_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_11_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_11_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_12_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_12_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_13_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_13_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_14_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_14_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_15_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_15_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_1_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_1_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_2_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_2_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_3_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_3_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_4_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_4_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_5_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_5_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_6_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_6_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_7_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_7_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_8_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_8_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_e400g_iux_ds_9_ux_tx_clk_ds = "pwr_gdr_e400g_iux_ds_9_ux_tx_clk_ds";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_0_ux_clk = "off_gdr_ie200g_ux_us_0_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_0_ux_rx_clk = "pwr_gdr_ie200g_ux_us_0_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_0_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_0_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_0_ux_tx_clk = "pwr_gdr_ie200g_ux_us_0_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_0_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_0_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_0_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_0_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_10_ux_clk = "off_gdr_ie200g_ux_us_10_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_10_ux_rx_clk = "off_gdr_ie200g_ux_us_10_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_10_ux_rx_user_clk = "off_gdr_ie200g_ux_us_10_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_10_ux_tx_clk = "off_gdr_ie200g_ux_us_10_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_10_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_10_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_10_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_10_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_11_ux_clk = "off_gdr_ie200g_ux_us_11_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_11_ux_rx_clk = "off_gdr_ie200g_ux_us_11_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_11_ux_rx_user_clk = "off_gdr_ie200g_ux_us_11_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_11_ux_tx_clk = "off_gdr_ie200g_ux_us_11_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_11_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_11_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_11_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_11_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_12_ux_clk = "off_gdr_ie200g_ux_us_12_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_12_ux_rx_clk = "off_gdr_ie200g_ux_us_12_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_12_ux_rx_user_clk = "off_gdr_ie200g_ux_us_12_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_12_ux_tx_clk = "off_gdr_ie200g_ux_us_12_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_12_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_12_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_12_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_12_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_13_ux_clk = "off_gdr_ie200g_ux_us_13_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_13_ux_rx_clk = "off_gdr_ie200g_ux_us_13_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_13_ux_rx_user_clk = "off_gdr_ie200g_ux_us_13_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_13_ux_tx_clk = "off_gdr_ie200g_ux_us_13_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_13_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_13_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_13_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_13_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_14_ux_clk = "off_gdr_ie200g_ux_us_14_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_14_ux_rx_clk = "off_gdr_ie200g_ux_us_14_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_14_ux_rx_user_clk = "off_gdr_ie200g_ux_us_14_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_14_ux_tx_clk = "off_gdr_ie200g_ux_us_14_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_14_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_14_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_14_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_14_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_15_ux_clk = "off_gdr_ie200g_ux_us_15_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_15_ux_rx_clk = "off_gdr_ie200g_ux_us_15_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_15_ux_rx_user_clk = "off_gdr_ie200g_ux_us_15_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_15_ux_tx_clk = "off_gdr_ie200g_ux_us_15_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_15_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_15_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_15_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_15_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_1_ux_clk = "off_gdr_ie200g_ux_us_1_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_1_ux_rx_clk = "pwr_gdr_ie200g_ux_us_1_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_1_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_1_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_1_ux_tx_clk = "pwr_gdr_ie200g_ux_us_1_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_1_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_1_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_1_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_1_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_2_ux_clk = "off_gdr_ie200g_ux_us_2_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_2_ux_rx_clk = "pwr_gdr_ie200g_ux_us_2_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_2_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_2_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_2_ux_tx_clk = "pwr_gdr_ie200g_ux_us_2_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_2_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_2_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_2_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_2_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_3_ux_clk = "off_gdr_ie200g_ux_us_3_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_3_ux_rx_clk = "pwr_gdr_ie200g_ux_us_3_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_3_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_3_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_3_ux_tx_clk = "pwr_gdr_ie200g_ux_us_3_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_3_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_3_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_3_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_3_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_4_ux_clk = "off_gdr_ie200g_ux_us_4_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_4_ux_rx_clk = "pwr_gdr_ie200g_ux_us_4_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_4_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_4_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_4_ux_tx_clk = "pwr_gdr_ie200g_ux_us_4_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_4_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_4_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_4_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_4_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_5_ux_clk = "off_gdr_ie200g_ux_us_5_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_5_ux_rx_clk = "pwr_gdr_ie200g_ux_us_5_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_5_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_5_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_5_ux_tx_clk = "pwr_gdr_ie200g_ux_us_5_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_5_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_5_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_5_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_5_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_6_ux_clk = "off_gdr_ie200g_ux_us_6_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_6_ux_rx_clk = "pwr_gdr_ie200g_ux_us_6_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_6_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_6_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_6_ux_tx_clk = "pwr_gdr_ie200g_ux_us_6_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_6_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_6_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_6_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_6_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_7_ux_clk = "off_gdr_ie200g_ux_us_7_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_7_ux_rx_clk = "pwr_gdr_ie200g_ux_us_7_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_7_ux_rx_user_clk = "pwr_gdr_ie200g_ux_us_7_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_7_ux_tx_clk = "pwr_gdr_ie200g_ux_us_7_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_7_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_7_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_7_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_7_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_8_ux_clk = "off_gdr_ie200g_ux_us_8_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_8_ux_rx_clk = "off_gdr_ie200g_ux_us_8_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_8_ux_rx_user_clk = "off_gdr_ie200g_ux_us_8_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_8_ux_tx_clk = "off_gdr_ie200g_ux_us_8_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_8_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_8_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_8_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_8_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_9_ux_clk = "off_gdr_ie200g_ux_us_9_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_9_ux_rx_clk = "off_gdr_ie200g_ux_us_9_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_9_ux_rx_user_clk = "off_gdr_ie200g_ux_us_9_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_9_ux_tx_clk = "off_gdr_ie200g_ux_us_9_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_9_ux_tx_user_clk_1 = "off_gdr_ie200g_ux_us_9_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie200g_ux_us_9_ux_tx_user_clk_2 = "off_gdr_ie200g_ux_us_9_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_clk_lanex = "pwr_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_clk_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_clko_lanex = "pwr_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_clko_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_clk_lanex = "pwr_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_clk_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_clko_lanex = "pwr_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_clko_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_clk_lanex = "pwr_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_clk_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_clko_lanex = "pwr_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_clko_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_clk_lanex = "pwr_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_clk_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_clko_lanex = "pwr_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_clko_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_usr_clk1_lanex = "off_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_usr_clk1_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_usr_clk2_lanex = "off_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_usr_clk2_lanex";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_0_ux_clk = "off_gdr_ie400g_ux_us_0_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_0_ux_rx_clk = "pwr_gdr_ie400g_ux_us_0_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_0_ux_rx_user_clk = "off_gdr_ie400g_ux_us_0_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_0_ux_tx_clk = "pwr_gdr_ie400g_ux_us_0_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_0_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_0_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_0_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_0_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_10_ux_clk = "off_gdr_ie400g_ux_us_10_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_10_ux_rx_clk = "pwr_gdr_ie400g_ux_us_10_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_10_ux_rx_user_clk = "off_gdr_ie400g_ux_us_10_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_10_ux_tx_clk = "pwr_gdr_ie400g_ux_us_10_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_10_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_10_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_10_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_10_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_11_ux_clk = "off_gdr_ie400g_ux_us_11_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_11_ux_rx_clk = "pwr_gdr_ie400g_ux_us_11_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_11_ux_rx_user_clk = "off_gdr_ie400g_ux_us_11_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_11_ux_tx_clk = "pwr_gdr_ie400g_ux_us_11_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_11_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_11_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_11_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_11_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_12_ux_clk = "off_gdr_ie400g_ux_us_12_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_12_ux_rx_clk = "pwr_gdr_ie400g_ux_us_12_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_12_ux_rx_user_clk = "off_gdr_ie400g_ux_us_12_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_12_ux_tx_clk = "pwr_gdr_ie400g_ux_us_12_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_12_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_12_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_12_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_12_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_13_ux_clk = "off_gdr_ie400g_ux_us_13_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_13_ux_rx_clk = "pwr_gdr_ie400g_ux_us_13_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_13_ux_rx_user_clk = "off_gdr_ie400g_ux_us_13_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_13_ux_tx_clk = "pwr_gdr_ie400g_ux_us_13_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_13_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_13_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_13_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_13_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_14_ux_clk = "off_gdr_ie400g_ux_us_14_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_14_ux_rx_clk = "pwr_gdr_ie400g_ux_us_14_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_14_ux_rx_user_clk = "off_gdr_ie400g_ux_us_14_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_14_ux_tx_clk = "pwr_gdr_ie400g_ux_us_14_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_14_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_14_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_14_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_14_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_15_ux_clk = "off_gdr_ie400g_ux_us_15_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_15_ux_rx_clk = "pwr_gdr_ie400g_ux_us_15_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_15_ux_rx_user_clk = "off_gdr_ie400g_ux_us_15_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_15_ux_tx_clk = "pwr_gdr_ie400g_ux_us_15_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_15_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_15_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_15_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_15_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_1_ux_clk = "off_gdr_ie400g_ux_us_1_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_1_ux_rx_clk = "pwr_gdr_ie400g_ux_us_1_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_1_ux_rx_user_clk = "off_gdr_ie400g_ux_us_1_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_1_ux_tx_clk = "pwr_gdr_ie400g_ux_us_1_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_1_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_1_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_1_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_1_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_2_ux_clk = "off_gdr_ie400g_ux_us_2_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_2_ux_rx_clk = "pwr_gdr_ie400g_ux_us_2_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_2_ux_rx_user_clk = "off_gdr_ie400g_ux_us_2_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_2_ux_tx_clk = "pwr_gdr_ie400g_ux_us_2_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_2_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_2_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_2_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_2_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_3_ux_clk = "off_gdr_ie400g_ux_us_3_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_3_ux_rx_clk = "pwr_gdr_ie400g_ux_us_3_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_3_ux_rx_user_clk = "off_gdr_ie400g_ux_us_3_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_3_ux_tx_clk = "pwr_gdr_ie400g_ux_us_3_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_3_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_3_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_3_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_3_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_4_ux_clk = "off_gdr_ie400g_ux_us_4_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_4_ux_rx_clk = "pwr_gdr_ie400g_ux_us_4_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_4_ux_rx_user_clk = "off_gdr_ie400g_ux_us_4_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_4_ux_tx_clk = "pwr_gdr_ie400g_ux_us_4_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_4_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_4_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_4_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_4_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_5_ux_clk = "off_gdr_ie400g_ux_us_5_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_5_ux_rx_clk = "pwr_gdr_ie400g_ux_us_5_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_5_ux_rx_user_clk = "off_gdr_ie400g_ux_us_5_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_5_ux_tx_clk = "pwr_gdr_ie400g_ux_us_5_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_5_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_5_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_5_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_5_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_6_ux_clk = "off_gdr_ie400g_ux_us_6_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_6_ux_rx_clk = "pwr_gdr_ie400g_ux_us_6_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_6_ux_rx_user_clk = "off_gdr_ie400g_ux_us_6_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_6_ux_tx_clk = "pwr_gdr_ie400g_ux_us_6_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_6_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_6_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_6_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_6_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_7_ux_clk = "off_gdr_ie400g_ux_us_7_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_7_ux_rx_clk = "pwr_gdr_ie400g_ux_us_7_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_7_ux_rx_user_clk = "off_gdr_ie400g_ux_us_7_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_7_ux_tx_clk = "pwr_gdr_ie400g_ux_us_7_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_7_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_7_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_7_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_7_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_8_ux_clk = "off_gdr_ie400g_ux_us_8_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_8_ux_rx_clk = "pwr_gdr_ie400g_ux_us_8_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_8_ux_rx_user_clk = "off_gdr_ie400g_ux_us_8_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_8_ux_tx_clk = "pwr_gdr_ie400g_ux_us_8_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_8_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_8_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_8_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_8_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_9_ux_clk = "off_gdr_ie400g_ux_us_9_ux_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_9_ux_rx_clk = "pwr_gdr_ie400g_ux_us_9_ux_rx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_9_ux_rx_user_clk = "off_gdr_ie400g_ux_us_9_ux_rx_user_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_9_ux_tx_clk = "pwr_gdr_ie400g_ux_us_9_ux_tx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_9_ux_tx_user_clk_1 = "off_gdr_ie400g_ux_us_9_ux_tx_user_clk_1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_gdr_ie400g_ux_us_9_ux_tx_user_clk_2 = "off_gdr_ie400g_ux_us_9_ux_tx_user_clk_2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_global_avmm_ctrl_barak_rc_slv_clk = "pwr_global_avmm_ctrl_barak_rc_slv_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_global_avmm_ctrl_ux_rc_slv_0_clk = "pwr_global_avmm_ctrl_ux_rc_slv_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_global_avmm_ctrl_ux_rc_slv_1_clk = "pwr_global_avmm_ctrl_ux_rc_slv_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_global_avmm_ctrl_ux_rc_slv_2_clk = "pwr_global_avmm_ctrl_ux_rc_slv_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_global_avmm_ctrl_ux_rc_slv_3_clk = "pwr_global_avmm_ctrl_ux_rc_slv_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dfd_barak_hub_clk = "off_ictrl_dfd_barak_hub_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dfd_ux_hub_0_clk = "off_ictrl_dfd_ux_hub_0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dfd_ux_hub_1_clk = "off_ictrl_dfd_ux_hub_1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dfd_ux_hub_2_clk = "off_ictrl_dfd_ux_hub_2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dfd_ux_hub_3_clk = "off_ictrl_dfd_ux_hub_3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_barak_ip_brk_aon_sys_clk = "off_ictrl_dft_barak_ip_brk_aon_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_barak_ip_brk_bti_clk = "off_ictrl_dft_barak_ip_brk_bti_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_barak_ip_dfx_clk = "off_ictrl_dft_barak_ip_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_ux_ip_0_dfx_clk = "off_ictrl_dft_ux_ip_0_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_ux_ip_1_dfx_clk = "off_ictrl_dft_ux_ip_1_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_ux_ip_2_dfx_clk = "off_ictrl_dft_ux_ip_2_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ictrl_dft_ux_ip_3_dfx_clk = "off_ictrl_dft_ux_ip_3_dfx_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_idvp2_xcvrrc_ip_idvfreqa_clk = "off_iopads_idvp2_xcvrrc_ip_idvfreqa_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_idvp2_xcvrrc_ip_idvfreqb_clk = "off_iopads_idvp2_xcvrrc_ip_idvfreqb_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_idvp2_xcvrrc_ip_idvtclk = "off_iopads_idvp2_xcvrrc_ip_idvtclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_0_slice0_clk = "pwr_iopads_pll_xcvrrc_ip_pll_0_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_0_slice1_clk = "pwr_iopads_pll_xcvrrc_ip_pll_0_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_0_slice2_clk = "pwr_iopads_pll_xcvrrc_ip_pll_0_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_0_slice3_clk = "off_iopads_pll_xcvrrc_ip_pll_0_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_1_slice0_clk = "pwr_iopads_pll_xcvrrc_ip_pll_1_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_1_slice1_clk = "pwr_iopads_pll_xcvrrc_ip_pll_1_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_1_slice2_clk = "pwr_iopads_pll_xcvrrc_ip_pll_1_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_1_slice3_clk = "pwr_iopads_pll_xcvrrc_ip_pll_1_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_2_slice0_clk = "pwr_iopads_pll_xcvrrc_ip_pll_2_slice0_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_2_slice1_clk = "pwr_iopads_pll_xcvrrc_ip_pll_2_slice1_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_2_slice2_clk = "pwr_iopads_pll_xcvrrc_ip_pll_2_slice2_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_iopads_pll_xcvrrc_ip_pll_2_slice3_clk = "pwr_iopads_pll_xcvrrc_ip_pll_2_slice3_clk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_0_pma_pclk = "off_ipcie_ux_pcs_0_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_0_pma_ref = "off_ipcie_ux_pcs_0_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_0_pma_rxclk = "off_ipcie_ux_pcs_0_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_10_pma_pclk = "off_ipcie_ux_pcs_10_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_10_pma_ref = "off_ipcie_ux_pcs_10_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_10_pma_rxclk = "off_ipcie_ux_pcs_10_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_11_pma_pclk = "off_ipcie_ux_pcs_11_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_11_pma_ref = "off_ipcie_ux_pcs_11_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_11_pma_rxclk = "off_ipcie_ux_pcs_11_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_12_pma_pclk = "off_ipcie_ux_pcs_12_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_12_pma_ref = "off_ipcie_ux_pcs_12_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_12_pma_rxclk = "off_ipcie_ux_pcs_12_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_13_pma_pclk = "off_ipcie_ux_pcs_13_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_13_pma_ref = "off_ipcie_ux_pcs_13_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_13_pma_rxclk = "off_ipcie_ux_pcs_13_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_14_pma_pclk = "off_ipcie_ux_pcs_14_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_14_pma_ref = "off_ipcie_ux_pcs_14_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_14_pma_rxclk = "off_ipcie_ux_pcs_14_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_15_pma_pclk = "off_ipcie_ux_pcs_15_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_15_pma_ref = "off_ipcie_ux_pcs_15_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_15_pma_rxclk = "off_ipcie_ux_pcs_15_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_1_pma_pclk = "off_ipcie_ux_pcs_1_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_1_pma_ref = "off_ipcie_ux_pcs_1_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_1_pma_rxclk = "off_ipcie_ux_pcs_1_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_2_pma_pclk = "off_ipcie_ux_pcs_2_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_2_pma_ref = "off_ipcie_ux_pcs_2_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_2_pma_rxclk = "off_ipcie_ux_pcs_2_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_3_pma_pclk = "off_ipcie_ux_pcs_3_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_3_pma_ref = "off_ipcie_ux_pcs_3_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_3_pma_rxclk = "off_ipcie_ux_pcs_3_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_4_pma_pclk = "off_ipcie_ux_pcs_4_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_4_pma_ref = "off_ipcie_ux_pcs_4_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_4_pma_rxclk = "off_ipcie_ux_pcs_4_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_5_pma_pclk = "off_ipcie_ux_pcs_5_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_5_pma_ref = "off_ipcie_ux_pcs_5_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_5_pma_rxclk = "off_ipcie_ux_pcs_5_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_6_pma_pclk = "off_ipcie_ux_pcs_6_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_6_pma_ref = "off_ipcie_ux_pcs_6_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_6_pma_rxclk = "off_ipcie_ux_pcs_6_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_7_pma_pclk = "off_ipcie_ux_pcs_7_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_7_pma_ref = "off_ipcie_ux_pcs_7_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_7_pma_rxclk = "off_ipcie_ux_pcs_7_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_8_pma_pclk = "off_ipcie_ux_pcs_8_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_8_pma_ref = "off_ipcie_ux_pcs_8_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_8_pma_rxclk = "off_ipcie_ux_pcs_8_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_9_pma_pclk = "off_ipcie_ux_pcs_9_pma_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_9_pma_ref = "off_ipcie_ux_pcs_9_pma_ref";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ipcie_ux_pcs_9_pma_rxclk = "off_ipcie_ux_pcs_9_pma_rxclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_0_sclk = "off_pcie_clkrst_xcvrrc_ds_0_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_1_sclk = "off_pcie_clkrst_xcvrrc_ds_1_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_2_sclk = "off_pcie_clkrst_xcvrrc_ds_2_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_3_sclk = "off_pcie_clkrst_xcvrrc_ds_3_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_4_sclk = "off_pcie_clkrst_xcvrrc_ds_4_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_5_sclk = "off_pcie_clkrst_xcvrrc_ds_5_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_6_sclk = "off_pcie_clkrst_xcvrrc_ds_6_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_clkrst_xcvrrc_ds_7_sclk = "off_pcie_clkrst_xcvrrc_ds_7_sclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_0_pipe_pclk = "off_pcie_iux_pma_0_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_0_pma_cmn_ctrl = "pwr_pcie_iux_pma_0_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_0_pma_ctrl = "pwr_pcie_iux_pma_0_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_10_pipe_pclk = "off_pcie_iux_pma_10_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_10_pma_cmn_ctrl = "pwr_pcie_iux_pma_10_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_10_pma_ctrl = "pwr_pcie_iux_pma_10_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_11_pipe_pclk = "off_pcie_iux_pma_11_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_11_pma_cmn_ctrl = "pwr_pcie_iux_pma_11_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_11_pma_ctrl = "pwr_pcie_iux_pma_11_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_12_pipe_pclk = "off_pcie_iux_pma_12_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_12_pma_cmn_ctrl = "pwr_pcie_iux_pma_12_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_12_pma_ctrl = "pwr_pcie_iux_pma_12_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_13_pipe_pclk = "off_pcie_iux_pma_13_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_13_pma_cmn_ctrl = "pwr_pcie_iux_pma_13_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_13_pma_ctrl = "pwr_pcie_iux_pma_13_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_14_pipe_pclk = "off_pcie_iux_pma_14_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_14_pma_cmn_ctrl = "pwr_pcie_iux_pma_14_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_14_pma_ctrl = "pwr_pcie_iux_pma_14_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_15_pipe_pclk = "off_pcie_iux_pma_15_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_15_pma_cmn_ctrl = "pwr_pcie_iux_pma_15_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_15_pma_ctrl = "pwr_pcie_iux_pma_15_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_1_pipe_pclk = "off_pcie_iux_pma_1_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_1_pma_cmn_ctrl = "pwr_pcie_iux_pma_1_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_1_pma_ctrl = "pwr_pcie_iux_pma_1_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_2_pipe_pclk = "off_pcie_iux_pma_2_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_2_pma_cmn_ctrl = "pwr_pcie_iux_pma_2_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_2_pma_ctrl = "pwr_pcie_iux_pma_2_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_3_pipe_pclk = "off_pcie_iux_pma_3_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_3_pma_cmn_ctrl = "pwr_pcie_iux_pma_3_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_3_pma_ctrl = "pwr_pcie_iux_pma_3_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_4_pipe_pclk = "off_pcie_iux_pma_4_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_4_pma_cmn_ctrl = "pwr_pcie_iux_pma_4_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_4_pma_ctrl = "pwr_pcie_iux_pma_4_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_5_pipe_pclk = "off_pcie_iux_pma_5_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_5_pma_cmn_ctrl = "pwr_pcie_iux_pma_5_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_5_pma_ctrl = "pwr_pcie_iux_pma_5_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_6_pipe_pclk = "off_pcie_iux_pma_6_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_6_pma_cmn_ctrl = "pwr_pcie_iux_pma_6_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_6_pma_ctrl = "pwr_pcie_iux_pma_6_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_7_pipe_pclk = "off_pcie_iux_pma_7_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_7_pma_cmn_ctrl = "pwr_pcie_iux_pma_7_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_7_pma_ctrl = "pwr_pcie_iux_pma_7_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_8_pipe_pclk = "off_pcie_iux_pma_8_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_8_pma_cmn_ctrl = "pwr_pcie_iux_pma_8_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_8_pma_ctrl = "pwr_pcie_iux_pma_8_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_9_pipe_pclk = "off_pcie_iux_pma_9_pipe_pclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_9_pma_cmn_ctrl = "pwr_pcie_iux_pma_9_pma_cmn_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_pcie_iux_pma_9_pma_ctrl = "pwr_pcie_iux_pma_9_pma_ctrl";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_0_clk0 = "off_ux_pll_xvrrc_slv_0_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_0_clk1 = "off_ux_pll_xvrrc_slv_0_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_1_clk0 = "pwr_ux_pll_xvrrc_slv_1_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_1_clk1 = "off_ux_pll_xvrrc_slv_1_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_2_clk0 = "off_ux_pll_xvrrc_slv_2_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_2_clk1 = "off_ux_pll_xvrrc_slv_2_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_3_clk0 = "off_ux_pll_xvrrc_slv_3_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_ux_pll_xvrrc_slv_3_clk1 = "off_ux_pll_xvrrc_slv_3_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_0_pma_internal_clk1 = "off_xcvrrc_clkrst_barak_us_0_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_0_pma_internal_clk2 = "off_xcvrrc_clkrst_barak_us_0_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_0_standalonecoreclk = "off_xcvrrc_clkrst_barak_us_0_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_0_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_barak_us_0_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_0_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_barak_us_0_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_1_pma_internal_clk1 = "off_xcvrrc_clkrst_barak_us_1_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_1_pma_internal_clk2 = "off_xcvrrc_clkrst_barak_us_1_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_1_standalonecoreclk = "off_xcvrrc_clkrst_barak_us_1_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_1_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_barak_us_1_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_1_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_barak_us_1_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_2_pma_internal_clk1 = "off_xcvrrc_clkrst_barak_us_2_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_2_pma_internal_clk2 = "off_xcvrrc_clkrst_barak_us_2_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_2_standalonecoreclk = "off_xcvrrc_clkrst_barak_us_2_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_2_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_barak_us_2_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_2_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_barak_us_2_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_3_pma_internal_clk1 = "off_xcvrrc_clkrst_barak_us_3_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_3_pma_internal_clk2 = "off_xcvrrc_clkrst_barak_us_3_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_3_standalonecoreclk = "off_xcvrrc_clkrst_barak_us_3_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_3_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_barak_us_3_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_barak_us_3_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_barak_us_3_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_0_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_0_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_0_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_0_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_0_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_0_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_0_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_0_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_0_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_0_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_10_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_10_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_10_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_10_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_10_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_10_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_10_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_10_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_10_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_10_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_11_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_11_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_11_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_11_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_11_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_11_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_11_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_11_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_11_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_11_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_12_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_12_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_12_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_12_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_12_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_12_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_12_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_12_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_12_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_12_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_13_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_13_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_13_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_13_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_13_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_13_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_13_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_13_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_13_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_13_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_14_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_14_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_14_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_14_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_14_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_14_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_14_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_14_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_14_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_14_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_15_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_15_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_15_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_15_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_15_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_15_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_15_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_15_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_15_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_15_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_1_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_1_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_1_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_1_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_1_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_1_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_1_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_1_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_1_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_1_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_2_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_2_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_2_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_2_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_2_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_2_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_2_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_2_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_2_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_2_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_3_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_3_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_3_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_3_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_3_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_3_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_3_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_3_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_3_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_3_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_4_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_4_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_4_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_4_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_4_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_4_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_4_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_4_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_4_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_4_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_5_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_5_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_5_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_5_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_5_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_5_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_5_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_5_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_5_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_5_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_6_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_6_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_6_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_6_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_6_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_6_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_6_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_6_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_6_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_6_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_7_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_7_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_7_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_7_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_7_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_7_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_7_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_7_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_7_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_7_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_8_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_8_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_8_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_8_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_8_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_8_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_8_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_8_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_8_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_8_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_9_pma_internal_clk1 = "off_xcvrrc_clkrst_ux_us_9_pma_internal_clk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_9_pma_internal_clk2 = "off_xcvrrc_clkrst_ux_us_9_pma_internal_clk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_9_standalonecoreclk = "off_xcvrrc_clkrst_ux_us_9_standalonecoreclk";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_9_xcvr_quad_refclk1 = "off_xcvrrc_clkrst_ux_us_9_xcvr_quad_refclk1";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_ac_xcvrrc_clkrst_ux_us_9_xcvr_quad_refclk2 = "off_xcvrrc_clkrst_ux_us_9_xcvr_quad_refclk2";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_barak_idvp2_xcvrrc_ip_idvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_barak_idvp2_xcvrrc_ip_idvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_barak_idvp2_xcvrrc_ip_idvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ctrl_dft_ux_rc_tcb_0_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ctrl_dft_ux_rc_tcb_1_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ctrl_dft_ux_rc_tcb_2_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ctrl_dft_ux_rc_tcb_3_ref_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e200g_clkrst_xcvrrc_ds_0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e200g_clkrst_xcvrrc_ds_1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e200g_clkrst_xcvrrc_ds_2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e200g_clkrst_xcvrrc_ds_3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_10_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_11_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_8_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_e400g_clkrst_xcvrrc_ds_9_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_0_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_1_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_2_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_3_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_4_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_5_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_6_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e200g_iux_ds_7_ux_tx_clk_ds_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_ibarak_ds_0_brk_pcs_srds_tx_clki_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_ibarak_ds_1_brk_pcs_srds_tx_clki_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_ibarak_ds_2_brk_pcs_srds_tx_clki_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_ibarak_ds_3_brk_pcs_srds_tx_clki_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_0_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_10_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_11_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_12_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_13_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_14_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_15_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_1_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_2_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_3_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_4_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_5_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_6_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_7_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_8_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_e400g_iux_ds_9_ux_tx_clk_ds_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_0_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_0_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_0_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_0_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_0_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_0_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_10_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_10_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_10_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_10_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_10_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_10_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_11_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_11_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_11_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_11_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_11_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_11_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_12_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_12_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_12_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_12_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_12_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_12_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_13_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_13_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_13_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_13_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_13_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_13_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_14_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_14_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_14_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_14_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_14_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_14_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_15_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_15_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_15_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_15_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_15_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_15_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_1_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_1_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_1_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_1_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_1_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_1_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_2_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_2_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_2_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_2_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_2_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_2_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_3_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_3_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_3_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_3_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_3_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_3_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_4_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_4_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_4_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_4_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_4_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_4_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_5_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_5_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_5_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_5_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_5_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_5_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_6_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_6_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_6_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_6_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_6_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_6_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_7_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_7_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_7_ux_rx_user_clk_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_7_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_7_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_7_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_8_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_8_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_8_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_8_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_8_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_8_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_9_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_9_ux_rx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_9_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_9_ux_tx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_9_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie200g_ux_us_9_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_clk_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_0_brk_pcs_srds_rx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_clko_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_0_brk_pcs_srds_tx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_clk_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_1_brk_pcs_srds_rx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_clko_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_1_brk_pcs_srds_tx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_clk_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_2_brk_pcs_srds_rx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_clko_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_2_brk_pcs_srds_tx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_clk_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_3_brk_pcs_srds_rx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_clko_lanex_hz = 10000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_usr_clk1_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_barak_us_3_brk_pcs_srds_tx_usr_clk2_lanex_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_0_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_0_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_0_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_0_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_0_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_0_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_10_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_10_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_10_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_10_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_10_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_10_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_11_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_11_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_11_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_11_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_11_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_11_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_12_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_12_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_12_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_12_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_12_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_12_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_13_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_13_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_13_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_13_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_13_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_13_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_14_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_14_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_14_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_14_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_14_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_14_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_15_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_15_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_15_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_15_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_15_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_15_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_1_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_1_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_1_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_1_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_1_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_1_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_2_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_2_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_2_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_2_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_2_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_2_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_3_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_3_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_3_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_3_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_3_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_3_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_4_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_4_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_4_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_4_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_4_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_4_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_5_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_5_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_5_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_5_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_5_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_5_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_6_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_6_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_6_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_6_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_6_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_6_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_7_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_7_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_7_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_7_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_7_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_7_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_8_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_8_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_8_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_8_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_8_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_8_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_9_ux_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_9_ux_rx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_9_ux_rx_user_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_9_ux_tx_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_9_ux_tx_user_clk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_gdr_ie400g_ux_us_9_ux_tx_user_clk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_global_avmm_ctrl_barak_rc_slv_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_global_avmm_ctrl_ux_rc_slv_0_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_global_avmm_ctrl_ux_rc_slv_1_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_global_avmm_ctrl_ux_rc_slv_2_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_global_avmm_ctrl_ux_rc_slv_3_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dfd_barak_hub_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dfd_ux_hub_0_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dfd_ux_hub_1_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dfd_ux_hub_2_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dfd_ux_hub_3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_barak_ip_brk_aon_sys_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_barak_ip_brk_bti_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_barak_ip_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_ux_ip_0_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_ux_ip_1_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_ux_ip_2_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ictrl_dft_ux_ip_3_dfx_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_idvp2_xcvrrc_ip_idvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_idvp2_xcvrrc_ip_idvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_idvp2_xcvrrc_ip_idvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_0_slice0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_0_slice1_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_0_slice2_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_0_slice3_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_1_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_1_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_1_slice2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_1_slice3_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_2_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_2_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_2_slice2_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_iopads_pll_xcvrrc_ip_pll_2_slice3_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_0_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_0_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_0_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_10_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_10_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_10_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_11_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_11_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_11_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_12_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_12_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_12_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_13_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_13_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_13_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_14_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_14_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_14_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_15_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_15_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_15_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_1_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_1_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_1_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_2_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_2_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_2_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_3_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_3_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_3_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_4_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_4_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_4_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_5_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_5_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_5_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_6_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_6_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_6_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_7_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_7_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_7_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_8_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_8_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_8_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_9_pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_9_pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ipcie_ux_pcs_9_pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_clkrst_xcvrrc_ds_7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_0_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_0_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_0_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_10_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_10_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_10_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_11_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_11_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_11_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_12_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_12_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_12_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_13_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_13_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_13_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_14_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_14_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_14_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_15_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_15_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_15_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_1_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_1_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_1_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_2_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_2_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_2_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_3_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_3_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_3_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_4_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_4_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_4_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_5_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_5_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_5_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_6_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_6_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_6_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_7_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_7_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_7_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_8_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_8_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_8_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_9_pipe_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_9_pma_cmn_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_pcie_iux_pma_9_pma_ctrl_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_0_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_0_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_1_clk0_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_1_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_2_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_2_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_3_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_ux_pll_xvrrc_slv_3_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_barak_us_3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_10_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_10_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_10_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_10_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_10_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_11_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_11_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_11_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_11_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_11_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_12_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_12_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_12_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_12_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_12_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_13_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_13_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_13_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_13_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_13_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_14_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_14_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_14_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_14_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_14_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_15_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_15_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_15_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_15_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_15_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_4_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_4_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_4_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_4_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_4_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_5_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_5_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_5_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_5_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_5_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_6_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_6_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_6_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_6_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_6_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_7_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_7_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_7_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_7_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_7_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_8_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_8_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_8_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_8_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_8_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_9_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_9_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_9_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_9_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__powermode_freq_hz_i_xcvrrc_clkrst_ux_us_9_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_gdr_xcvr_rc__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib0_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib0_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib10_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib10_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib11_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib11_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib12_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib12_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib13_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib13_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib14_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib14_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib15_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib15_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib16_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib16_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib17_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib17_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib18_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib18_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib19_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib19_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib1_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib1_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib20_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib20_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib21_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib21_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib22_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib22_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib23_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib23_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib2_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib2_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib3_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib3_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib4_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib4_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib5_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib5_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib6_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib6_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib7_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib7_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib8_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib8_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib9_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aib9_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_0sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_1sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_2sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_3sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_4sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_5sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_6sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__aibrc_clkrst_pcie_ds_7sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__cfg_avmmclk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__cvp_enable = "cvp_is_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__cvpavmm_clk_in_hz = 250000000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__dwip_x16_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__dwip_x16_uses_pin_perstn = "perstn_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__dwip_x40_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__dwip_x41_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__dwip_x8_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__e200g_idvp1_pcie_ipidvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__e200g_idvp1_pcie_ipidvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__e200g_idvp1_pcie_ipidvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__ippwrmod_freq = "clk1g";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_0pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_0pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_0standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_0xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_0xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_1pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_1pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_1standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_1xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_1xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_2pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_2pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_2standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_2xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_2xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_3pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_3pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_3standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_3xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_3xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_4pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_4pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_4standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_4xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_4xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_5pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_5pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_5standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_5xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_5xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_6pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_6pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_6standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_6xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_6xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_7pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_7pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_7standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_7xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pcie_clkrst_xcvrrc_us_7xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pld_clk_2x_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pllpll_0_slice0_clk_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pllpll_0_slice1_clk_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pllpll_1_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pllpll_1_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pllpll_2_slice0_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__pllpll_2_slice1_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__powermode_ac = "pcie_pwr_g4_x16";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__sys_clk_select = "pll_2";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__tcbctldfx_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__tcbctldfx_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__tcbpcsdfx_clk0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__tcbpcsdfx_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib0_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib0_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib10_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib10_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib11_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib11_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib12_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib12_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib13_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib13_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib14_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib14_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib15_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib15_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib16_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib16_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib17_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib17_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib18_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib18_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib19_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib19_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib1_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib1_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib20_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib20_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib21_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib21_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib22_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib22_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib23_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib23_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib2_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib2_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib3_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib3_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib4_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib4_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib5_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib5_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib6_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib6_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib7_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib7_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib8_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib8_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib9_rx_transfer_clk_div2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aib9_rx_transfer_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_0sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_1sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_2sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_3sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_4sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_5sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_6sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__aibrc_clkrst_pcie_ds_7sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__cfg_avmmclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__cvpavmm_clk_in_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__dwip_x16_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__dwip_x40_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__dwip_x41_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__dwip_x8_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__e200g_idvp1_pcie_ipidvfreqa_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__e200g_idvp1_pcie_ipidvfreqb_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__e200g_idvp1_pcie_ipidvtclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__pld_clk_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_ac = "disabled_ac";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_freq_hz_o_dwip_x16_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_freq_hz_o_dwip_x40_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_freq_hz_o_dwip_x41_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_freq_hz_o_dwip_x8_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__powermode_freq_hz_pcie_ctrltop_global_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__topology = "disabled_system";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_func_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_hdr_log0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_hdr_log1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_hdr_log2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_hdr_log3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_info = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_prefix = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__app_err_valid = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_blk_crs_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf0_table_size = 339;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf1_start_addr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf1_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf2_start_addr = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf2_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf3_start_addr = 896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf3_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf4_start_addr = 1152;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf4_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf5_start_addr = 1408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf5_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf6_start_addr = 1664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf6_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf7_start_addr = 1920;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_dbi_pf7_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_ecrc_err_sts_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_ptm_local_clock_adj_lsb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_ptm_local_clock_adj_msb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_ram_ecc_chk_val = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cfg_ram_ecc_gen_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__crs_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__crs_override_value = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_blocking_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_hard_reset_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_hip_clk_sel_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_jtag1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_jtag2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_jtag3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_mode_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_mode_gating_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_update_no_reset = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_vsec_id = 4466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_vsec_rev = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_warm_rst_ready_force_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_warm_rst_ready_force_bit1 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_warm_rst_req_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__cvp_write_mask_ctl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__dbg_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__dbi_ro_wr_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__device_type = "dev_nep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__device_width = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__disable_ct_ur = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__disable_msg_ur = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__disable_ur_nf = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__dyngate_sriov_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__dyngate_vfspfnum_core_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__ecrc_strip = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__enable_poison_nf = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__ep_signal_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__err_tlp_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acs_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_acscap_enable_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_aricap_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_globalinvalidate_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_invalidateqdepth_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_ats_pagealignreq_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_atscap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msix_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_msixcap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_pciecap_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_revisionid_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_devspecificmode_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_exttphrequester_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_intvecmode_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tph_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_tphcap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__exvf_type0cap_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__func_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__gate_clk_in_reset_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__gate_radm_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__intel_marker = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__margining_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__margining_software_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ack_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8389386;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8389387;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8389388;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8388866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8388867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aer_cap_root_err_status_off_addr_byte0 = 304;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_cap_ari_base_addr_byte2 = 8388982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_cap_ari_base_addr_byte3 = 8388983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_cap_cap_reg_addr_byte0 = 8388984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_mfvc_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8389370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8389371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8389372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_auto_eq_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_auto_eq_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aux_clk_freq = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_aux_clk_freq_off_rsvdp_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar0_mem_io = "pf0_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar1_mem_io = "pf0_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar1_type = "pf0_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar2_mem_io = "pf0_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar3_type = "pf0_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar4_mem_io = "pf0_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar5_mem_io = "pf0_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_bar5_type = "pf0_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_common_clk_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_config_limit = 831;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_config_tx_comp_rx = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_cross_link_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_cross_link_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_d1_support = "pf0_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_d2_support = "pf0_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_direct_speed_change = "pf0_auto_speed_chg";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_disable_fc_wd_timer = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_disable_scrambler_gen_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_disable_scrambler_gen_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte2 = 8389742;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte3 = 8389743;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dlink_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dlink_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_dll_link_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eidle_timer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_eq_eieos_cnt_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_fast_training_seq = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen1_ei_inference = "pf0_use_rx_eidle";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen2_ctrl_off_rsvdp_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_dc_balance_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_dc_balance_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_dllp_xmt_delay_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_dllp_xmt_delay_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_control_off_rsvdp_27_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_control_off_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_control_off_rsvdp_7_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_fb_mode = "pf0_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_fb_mode_atg4 = "pf0_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_fom_inc_initial_eval = "pf0_ignore_init_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_fom_inc_initial_eval_atg4 = "pf0_ignore_init_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_invreq_eva_diff_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_invreq_eva_diff_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_pset_req_as_coef = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_eq_pset_req_as_coef_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_14_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_19_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_1_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_related_off_rsvdp_26_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_req_send_consec_eieos_for_pset_map = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_req_send_consec_eieos_for_pset_map_atg4 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_zrxdc_noncompl = "pf0_compliant";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_gen3_zrxdc_noncompl_atg4 = "pf0_compliant_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control01_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control01_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control01_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control01_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1011_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1011_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1011_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1011_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1213_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1213_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1213_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1213_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1415_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1415_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1415_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control1415_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control23_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control23_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control23_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control23_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control45_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control45_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control45_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control45_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control67_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control67_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control67_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control67_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control89_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control89_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control89_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_lane_equalization_control89_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_capable = "pf0_conn_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_link_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte2 = 8389414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte3 = 8389415;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ltr_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ltr_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte2 = 8389094;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte3 = 8389095;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_margin_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_margin_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_mask_radm_1 = 8200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_mask_radm_2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_max_func_num = "pf0_one_function";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_misc_control_1_rsvdp_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8388689;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8388690;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8388691;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_pba_offset_reg_addr_byte0 = 8388792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_pba_offset_reg_addr_byte1 = 8388793;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_pba_offset_reg_addr_byte2 = 8388794;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_pba_offset_reg_addr_byte3 = 8388795;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_table_offset_reg_addr_byte0 = 8388788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_table_offset_reg_addr_byte1 = 8388789;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_table_offset_reg_addr_byte2 = 8388790;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_msix_table_offset_reg_addr_byte3 = 8388791;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8388785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8388786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8388787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10485938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10485939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_num_of_lanes = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_p2p_err_rpt_ctrl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_p2p_track_cpl_to_reg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8389424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8389425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8389422;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8389423;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_active_state_link_pm_control = "pf0_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_active_state_link_pm_support = "pf0_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_clock_power_man = "pf0_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_device_capabilities_reg_addr_byte0 = 8388724;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_device_capabilities_reg_addr_byte1 = 8388725;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_device_capabilities_reg_addr_byte3 = 8388727;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_device_control_device_status_addr_byte1 = 8388729;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_en_clk_power_man = "pf0_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_ext_tag_supp = "pf0_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_capabilities_reg_addr_byte0 = 8388732;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_capabilities_reg_addr_byte1 = 8388733;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_capabilities_reg_addr_byte2 = 8388734;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_capabilities_reg_addr_byte3 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12583072;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_control_link_status_reg_addr_byte0 = 4194432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_control_link_status_reg_addr_byte1 = 12583041;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_control_link_status_reg_addr_byte3 = 4194435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_max_link_speed = "pf0_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_max_link_width = "pf0_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_max_payload_size = "pf0_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_next_ptr = 176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8388721;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8388723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_rcb = "pf0_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_root_control_root_capabilities_reg_addr_byte2 = 142;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_capabilities_reg_addr_byte0 = 132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_capabilities_reg_addr_byte1 = 133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_capabilities_reg_addr_byte2 = 134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_slot_capabilities_reg_addr_byte3 = 135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_target_link_speed = "pf0_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pipe_loopback_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte0 = 468;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte1 = 469;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte2 = 470;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte3 = 471;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte0 = 472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte1 = 473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte2 = 474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte3 = 475;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte0 = 476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte1 = 477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte2 = 478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte3 = 479;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte0 = 480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte1 = 481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte2 = 482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte3 = 483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte2 = 8389046;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte3 = 8389047;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pl16g_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8388673;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8388674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8388675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pm_cap_con_status_reg_addr_byte0 = 8388676;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_link_ctrl_off_rsvdp_4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte1 = 8390413;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte2 = 1806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_aux_clk_freq_off_addr_byte0 = 8391488;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_aux_clk_freq_off_addr_byte1 = 8391489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_filter_mask_2_off_addr_byte0 = 8390432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_filter_mask_2_off_addr_byte1 = 8390433;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_filter_mask_2_off_addr_byte2 = 8390434;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_filter_mask_2_off_addr_byte3 = 8390435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen2_ctrl_off_addr_byte0 = 8390668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen2_ctrl_off_addr_byte1 = 8390669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen2_ctrl_off_addr_byte2 = 4196366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_eq_local_fs_lf_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_atg4_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_atg4_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_atg4_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_gen3_related_off_atg4_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_misc_control_1_off_addr_byte1 = 2237;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_misc_control_1_off_addr_byte2 = 2238;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_pipe_loopback_control_off_addr_byte3 = 2235;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_port_force_off_addr_byte0 = 8390408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_port_link_ctrl_off_addr_byte0 = 1808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_port_link_ctrl_off_addr_byte2 = 8390418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_queue_status_off_addr_byte2 = 8390462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_queue_status_off_addr_byte3 = 8390463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_symbol_timer_filter_1_off_addr_byte0 = 8390428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_symbol_timer_filter_1_off_addr_byte1 = 8390429;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_symbol_timer_filter_1_off_addr_byte2 = 8390430;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_symbol_timer_filter_1_off_addr_byte3 = 8390431;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_timer_ctrl_max_func_num_off_addr_byte0 = 8390424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte0 = 8390480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte1 = 8390481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte2 = 8390482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte3 = 8390483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte0 = 8390476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte1 = 8390477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte2 = 8390478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte0 = 8390472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte1 = 8390473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte2 = 8390474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_pre_det_lane = "pf0_det_all_lanes";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8389398;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8389399;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8389404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8389405;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8389406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8389407;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_off_reserved3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_off_reserved3_dup = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_ptm_cap_off_addr_byte0 = 8389756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_ptm_cap_off_addr_byte0_dup = 8389756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_ptm_ext_cap_hdr_off_addr_byte2 = 8389754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_ptm_ext_cap_hdr_off_addr_byte3 = 8389755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capable_dup = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_cap_hdr_off_dbi_addr_byte2 = 8389766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_cap_hdr_off_dbi_addr_byte3 = 8389767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_control_off_dbi_addr_byte0 = 8389772;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_control_off_dbi_addr_byte1 = 8389773;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen1_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen2_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen3_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen4_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen1_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen1_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen2_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen2_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen3_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen3_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen4_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen4_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen1_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen1_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen2_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen2_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen3_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen3_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen4_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen4_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_control_off_ptm_req_auto_update_enabled = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_control_off_ptm_req_fast_timers = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_control_off_ptm_req_long_timer = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_control_off_ptm_req_start_update = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_control_off_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_ext_cap_next_offs = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_ext_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_gen1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_gen2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_gen3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_gen4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_off_gen1_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_off_gen2_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_off_gen3_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_latency_reg_sel_off_gen4_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_gen1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_gen2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_gen3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_gen4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_off_gen1_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_off_gen2_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_off_gen3_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_rx_latency_off_gen4_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_gen1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_gen2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_gen3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_gen4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_off_gen1_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_off_gen2_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_off_gen3_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_req_tx_latency_off_gen4_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_res_capable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_res_capable_dup = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_root_capable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ptm_root_capable_dup = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_queue_status_off_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 822;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 823;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rate_shadow_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rate_shadow_sel_atg4 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved250 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved8 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_reset_assert = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_root_control_root_capabilities_reg_rsvdp_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_root_err_status_off_rsvdp_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rp_exp_rom_bar_mask_reg_rp_rom_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_rxstatus_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_scramble_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_skp_int_val = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8388968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8388969;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8388970;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8388971;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8388972;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8388973;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8388974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8388975;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_sn_base_addr_byte2 = 8388966;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_sn_base_addr_byte3 = 8388967;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte0 = 400;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte1 = 8389009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte2 = 402;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte3 = 8389011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte0 = 420;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte1 = 8389029;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte2 = 422;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte3 = 8389031;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte0 = 424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte1 = 8389033;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte2 = 426;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte3 = 8389035;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte0 = 428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte1 = 8389037;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte2 = 430;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte3 = 8389039;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte0 = 408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte1 = 8389017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte2 = 410;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte3 = 8389019;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte0 = 412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte1 = 8389021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte2 = 414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte3 = 8389023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte0 = 416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte1 = 8389025;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte2 = 418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte3 = 8389027;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_spcie_cap_header_reg_addr_byte2 = 8388998;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_spcie_cap_header_reg_addr_byte3 = 8388999;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_spcie_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10486328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10486329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10486336;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10486337;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10486338;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10486339;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2097744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2097745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2097746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2097747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2097748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2097749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2097750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2097751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2097752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2097753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2097754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2097755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2097756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2097757;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2097758;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2097759;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2097760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2097761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2097762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2097763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2097764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2097765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2097766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2097767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2097748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2097756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2097764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_base_reg_addr_byte2 = 8389166;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_base_reg_addr_byte3 = 8389167;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_initial_vfs_addr_byte0 = 8389176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_initial_vfs_addr_byte1 = 8389177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8389184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8389185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8389186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8389187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8389192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8389193;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8389194;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8389195;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_bar0_reg_addr_byte0 = 592;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_bar1_reg_addr_byte0 = 596;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_bar2_reg_addr_byte0 = 600;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_bar3_reg_addr_byte0 = 604;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_bar4_reg_addr_byte0 = 608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_bar5_reg_addr_byte0 = 612;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_device_id_reg_addr_byte2 = 8389190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_cap_vf_device_id_reg_addr_byte3 = 8389191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar1_type = "pf0_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar3_type = "pf0_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_sriov_vf_bar5_type = "pf0_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_target_above_config_limit = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_timer_mod_flow_control = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_timer_mod_flow_control_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8389230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8389231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_addr_byte0 = 8389232;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_addr_byte1 = 8389233;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_addr_byte2 = 8389234;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_addr_byte3 = 8389235;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10486384;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10486385;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10486386;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10486387;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_st_table_loc_0 = "pf0_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar0_mask_reg_addr_byte0 = 2097168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar0_mask_reg_addr_byte1 = 2097169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar0_mask_reg_addr_byte2 = 2097170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar0_mask_reg_addr_byte3 = 2097171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar0_reg_addr_byte0 = 16;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar1_enable_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar1_mask_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar1_mask_reg_addr_byte1 = 2097173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar1_mask_reg_addr_byte2 = 2097174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar1_mask_reg_addr_byte3 = 2097175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar1_reg_addr_byte0 = 20;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar2_mask_reg_addr_byte0 = 2097176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar2_mask_reg_addr_byte1 = 2097177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar2_mask_reg_addr_byte2 = 2097178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar2_mask_reg_addr_byte3 = 2097179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar2_reg_addr_byte0 = 24;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar3_enable_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar3_mask_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar3_mask_reg_addr_byte1 = 2097181;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar3_mask_reg_addr_byte2 = 2097182;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar3_mask_reg_addr_byte3 = 2097183;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar3_reg_addr_byte0 = 28;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar4_mask_reg_addr_byte0 = 2097184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar4_mask_reg_addr_byte1 = 2097185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar4_mask_reg_addr_byte2 = 2097186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar4_mask_reg_addr_byte3 = 2097187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar4_reg_addr_byte0 = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar5_enable_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar5_mask_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar5_mask_reg_addr_byte1 = 2097189;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar5_mask_reg_addr_byte2 = 2097190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar5_mask_reg_addr_byte3 = 2097191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bar5_reg_addr_byte0 = 36;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8388622;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8388648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8388649;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8388650;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8388651;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_class_code_revision_id_addr_byte0 = 8388616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_class_code_revision_id_addr_byte1 = 8388617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_class_code_revision_id_addr_byte2 = 8388618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_class_code_revision_id_addr_byte3 = 8388619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8388608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8388609;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8388610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8388611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2097200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2097201;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2097202;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2097203;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 48;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8388669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8388660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte0 = 2097208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte1 = 2097209;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte2 = 2097210;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte3 = 2097211;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8388652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8388653;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8388654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8388655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_send_8gt_eq_ts2_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_usp_send_8gt_eq_ts2_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_cpl_data_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_cpl_data_scale = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_cpl_hdr_scale = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_cpl_header_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_cpl_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_np_data_credit = 392;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_np_header_credit = 49;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_np_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_p_data_credit = 1456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_p_header_credit = 49;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc0_p_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc_cap_vc_base_addr_byte2 = 8388938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc_cap_vc_base_addr_byte3 = 8388939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vc_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vendor_specific_dllp_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8389686;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8389687;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf0_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8393482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8393483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8393484;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 4877;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8392962;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8392963;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ari_cap_ari_base_addr_byte2 = 8393078;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ari_cap_ari_base_addr_byte3 = 8393079;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8393466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8393467;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8393468;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar0_mem_io = "pf1_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar1_mem_io = "pf1_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar1_type = "pf1_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar2_mem_io = "pf1_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar3_mem_io = "pf1_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar3_type = "pf1_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar4_mem_io = "pf1_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar5_mem_io = "pf1_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_bar5_type = "pf1_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_d1_support = "pf1_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_d2_support = "pf1_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8392785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8392786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8392787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_pba_offset_reg_addr_byte0 = 8392888;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_pba_offset_reg_addr_byte1 = 8392889;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_pba_offset_reg_addr_byte2 = 8392890;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_pba_offset_reg_addr_byte3 = 8392891;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_table_offset_reg_addr_byte0 = 8392884;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_table_offset_reg_addr_byte1 = 8392885;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_table_offset_reg_addr_byte2 = 8392886;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_msix_table_offset_reg_addr_byte3 = 8392887;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8392881;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8392882;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8392883;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10490034;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10490035;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8393520;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8393521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8393518;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8393519;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_active_state_link_pm_control = "pf1_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_active_state_link_pm_support = "pf1_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_clock_power_man = "pf1_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_device_capabilities_reg_addr_byte0 = 8392820;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_device_capabilities_reg_addr_byte1 = 8392821;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_device_capabilities_reg_addr_byte3 = 8392823;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_device_control_device_status_addr_byte1 = 8392825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_en_clk_power_man = "pf1_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_ext_tag_supp = "pf1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_capabilities_reg_addr_byte0 = 8392828;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_capabilities_reg_addr_byte1 = 8392829;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_capabilities_reg_addr_byte2 = 8392830;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_capabilities_reg_addr_byte3 = 4223;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12587168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_control_link_status_reg_addr_byte0 = 4198528;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_control_link_status_reg_addr_byte1 = 12587137;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_control_link_status_reg_addr_byte3 = 4198531;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_max_link_speed = "pf1_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_max_link_width = "pf1_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_max_payload_size = "pf1_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8392817;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8392819;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_rcb = "pf1_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_sel_deemphasis = "pf1_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_target_link_speed = "pf1_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pcie_slot_imp = "pf1_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8392769;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8392770;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8392771;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pm_cap_con_status_reg_addr_byte0 = 8392772;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8393494;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8393495;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8393500;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8393501;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8393502;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8393503;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 4918;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 4919;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8393064;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8393065;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8393066;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8393067;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8393068;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8393069;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8393070;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8393071;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_sn_base_addr_byte2 = 8393062;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_sn_base_addr_byte3 = 8393063;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10490424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10490425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10490432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10490433;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10490434;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10490435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2101840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2101841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2101842;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2101843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2101844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2101845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2101846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2101847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2101848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2101849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2101850;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2101851;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2101852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2101853;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2101854;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2101855;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2101856;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2101857;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2101858;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2101859;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2101860;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2101861;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2101862;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2101863;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2101844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2101852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2101860;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_base_reg_addr_byte2 = 8393262;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_base_reg_addr_byte3 = 8393263;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_initial_vfs_addr_byte0 = 8393272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_initial_vfs_addr_byte1 = 8393273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8393280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8393281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8393282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8393283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8393288;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8393289;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8393290;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8393291;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_bar0_reg_addr_byte0 = 4688;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_bar1_reg_addr_byte0 = 4692;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_bar2_reg_addr_byte0 = 4696;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_bar3_reg_addr_byte0 = 4700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_bar4_reg_addr_byte0 = 4704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_bar5_reg_addr_byte0 = 4708;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_device_id_reg_addr_byte2 = 8393286;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_cap_vf_device_id_reg_addr_byte3 = 8393287;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar1_type = "pf1_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar3_type = "pf1_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_sriov_vf_bar5_type = "pf1_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8393326;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8393327;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_addr_byte0 = 8393328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_addr_byte1 = 8393329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_addr_byte2 = 8393330;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_addr_byte3 = 8393331;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10490480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10490481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10490482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10490483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_st_table_loc_0 = "pf1_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar0_mask_reg_addr_byte0 = 2101264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar0_mask_reg_addr_byte1 = 2101265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar0_mask_reg_addr_byte2 = 2101266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar0_mask_reg_addr_byte3 = 2101267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar0_reg_addr_byte0 = 4112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar1_enable_reg_addr_byte0 = 2101268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar1_mask_reg_addr_byte0 = 2101268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar1_mask_reg_addr_byte1 = 2101269;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar1_mask_reg_addr_byte2 = 2101270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar1_mask_reg_addr_byte3 = 2101271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar1_reg_addr_byte0 = 4116;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar2_mask_reg_addr_byte0 = 2101272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar2_mask_reg_addr_byte1 = 2101273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar2_mask_reg_addr_byte2 = 2101274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar2_mask_reg_addr_byte3 = 2101275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar2_reg_addr_byte0 = 4120;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar3_enable_reg_addr_byte0 = 2101276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar3_mask_reg_addr_byte0 = 2101276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar3_mask_reg_addr_byte1 = 2101277;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar3_mask_reg_addr_byte2 = 2101278;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar3_mask_reg_addr_byte3 = 2101279;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar3_reg_addr_byte0 = 4124;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar4_mask_reg_addr_byte0 = 2101280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar4_mask_reg_addr_byte1 = 2101281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar4_mask_reg_addr_byte2 = 2101282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar4_mask_reg_addr_byte3 = 2101283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar4_reg_addr_byte0 = 4128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar5_enable_reg_addr_byte0 = 2101284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar5_mask_reg_addr_byte0 = 2101284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar5_mask_reg_addr_byte1 = 2101285;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar5_mask_reg_addr_byte2 = 2101286;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar5_mask_reg_addr_byte3 = 2101287;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bar5_reg_addr_byte0 = 4132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8392718;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8392744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8392745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8392746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8392747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_class_code_revision_id_addr_byte0 = 8392712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_class_code_revision_id_addr_byte1 = 8392713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_class_code_revision_id_addr_byte2 = 8392714;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_class_code_revision_id_addr_byte3 = 8392715;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8392704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8392705;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8392706;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8392707;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2101296;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2101297;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2101298;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2101299;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 4144;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8392765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8392756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8392748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8392749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8392750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8392751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8393782;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8393783;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf1_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8397578;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8397579;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8397580;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 8973;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8397058;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8397059;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ari_cap_ari_base_addr_byte2 = 8397174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ari_cap_ari_base_addr_byte3 = 8397175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8397562;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8397563;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8397564;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar0_mem_io = "pf2_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar1_mem_io = "pf2_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar1_type = "pf2_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar2_mem_io = "pf2_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar3_mem_io = "pf2_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar3_type = "pf2_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar4_mem_io = "pf2_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar5_mem_io = "pf2_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_bar5_type = "pf2_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_d1_support = "pf2_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_d2_support = "pf2_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8396881;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8396882;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8396883;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_pba_offset_reg_addr_byte0 = 8396984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_pba_offset_reg_addr_byte1 = 8396985;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_pba_offset_reg_addr_byte2 = 8396986;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_pba_offset_reg_addr_byte3 = 8396987;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_table_offset_reg_addr_byte0 = 8396980;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_table_offset_reg_addr_byte1 = 8396981;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_table_offset_reg_addr_byte2 = 8396982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_msix_table_offset_reg_addr_byte3 = 8396983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8396977;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8396978;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8396979;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10494130;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10494131;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8397616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8397617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8397614;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8397615;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_active_state_link_pm_control = "pf2_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_active_state_link_pm_support = "pf2_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_clock_power_man = "pf2_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_device_capabilities_reg_addr_byte0 = 8396916;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_device_capabilities_reg_addr_byte1 = 8396917;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_device_capabilities_reg_addr_byte3 = 8396919;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_device_control_device_status_addr_byte1 = 8396921;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_en_clk_power_man = "pf2_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_ext_tag_supp = "pf2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_capabilities_reg_addr_byte0 = 8396924;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_capabilities_reg_addr_byte1 = 8396925;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_capabilities_reg_addr_byte2 = 8396926;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_capabilities_reg_addr_byte3 = 8319;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12591264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_control_link_status_reg_addr_byte0 = 4202624;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_control_link_status_reg_addr_byte1 = 12591233;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_control_link_status_reg_addr_byte3 = 4202627;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_max_link_speed = "pf2_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_max_link_width = "pf2_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_max_payload_size = "pf2_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8396913;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8396915;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_rcb = "pf2_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_sel_deemphasis = "pf2_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_target_link_speed = "pf2_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pcie_slot_imp = "pf2_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8396865;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8396866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8396867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pm_cap_con_status_reg_addr_byte0 = 8396868;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8397596;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8397597;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8397598;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8397599;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8397622;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8397623;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8397160;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8397161;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8397162;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8397163;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8397164;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8397165;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8397166;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8397167;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_sn_base_addr_byte2 = 8397158;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_sn_base_addr_byte3 = 8397159;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10494520;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10494521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10494528;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10494529;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10494530;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10494531;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2105936;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2105937;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2105938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2105939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2105940;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2105941;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2105942;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2105943;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2105944;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2105945;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2105946;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2105947;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2105948;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2105949;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2105950;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2105951;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2105952;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2105953;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2105954;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2105955;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2105956;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2105957;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2105958;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2105959;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2105940;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2105948;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2105956;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_base_reg_addr_byte2 = 8397358;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_base_reg_addr_byte3 = 8397359;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_initial_vfs_addr_byte0 = 8397368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_initial_vfs_addr_byte1 = 8397369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8397376;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8397377;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8397378;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8397379;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8397384;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8397385;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8397386;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8397387;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_bar0_reg_addr_byte0 = 8784;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_bar1_reg_addr_byte0 = 8788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_bar2_reg_addr_byte0 = 8792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_bar3_reg_addr_byte0 = 8796;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_bar4_reg_addr_byte0 = 8800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_bar5_reg_addr_byte0 = 8804;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_device_id_reg_addr_byte2 = 8397382;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_cap_vf_device_id_reg_addr_byte3 = 8397383;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar1_type = "pf2_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar3_type = "pf2_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_sriov_vf_bar5_type = "pf2_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8397422;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8397423;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_addr_byte0 = 8397424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_addr_byte1 = 8397425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_addr_byte2 = 8397426;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_addr_byte3 = 8397427;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10494576;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10494577;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10494578;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10494579;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_st_table_loc_0 = "pf2_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar0_mask_reg_addr_byte0 = 2105360;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar0_mask_reg_addr_byte1 = 2105361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar0_mask_reg_addr_byte2 = 2105362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar0_mask_reg_addr_byte3 = 2105363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar0_reg_addr_byte0 = 8208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar1_enable_reg_addr_byte0 = 2105364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar1_mask_reg_addr_byte0 = 2105364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar1_mask_reg_addr_byte1 = 2105365;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar1_mask_reg_addr_byte2 = 2105366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar1_mask_reg_addr_byte3 = 2105367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar1_reg_addr_byte0 = 8212;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar2_mask_reg_addr_byte0 = 2105368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar2_mask_reg_addr_byte1 = 2105369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar2_mask_reg_addr_byte2 = 2105370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar2_mask_reg_addr_byte3 = 2105371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar2_reg_addr_byte0 = 8216;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar3_enable_reg_addr_byte0 = 2105372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar3_mask_reg_addr_byte0 = 2105372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar3_mask_reg_addr_byte1 = 2105373;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar3_mask_reg_addr_byte2 = 2105374;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar3_mask_reg_addr_byte3 = 2105375;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar3_reg_addr_byte0 = 8220;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar4_mask_reg_addr_byte0 = 2105376;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar4_mask_reg_addr_byte1 = 2105377;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar4_mask_reg_addr_byte2 = 2105378;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar4_mask_reg_addr_byte3 = 2105379;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar4_reg_addr_byte0 = 8224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar5_enable_reg_addr_byte0 = 2105380;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar5_mask_reg_addr_byte0 = 2105380;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar5_mask_reg_addr_byte1 = 2105381;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar5_mask_reg_addr_byte2 = 2105382;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar5_mask_reg_addr_byte3 = 2105383;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bar5_reg_addr_byte0 = 8228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8396814;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8396840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8396841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8396842;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8396843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_class_code_revision_id_addr_byte0 = 8396808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_class_code_revision_id_addr_byte1 = 8396809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_class_code_revision_id_addr_byte2 = 8396810;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_class_code_revision_id_addr_byte3 = 8396811;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8396800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8396801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8396802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8396803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2105392;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2105393;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2105394;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2105395;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 8240;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8253;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8396852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8396844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8396845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8396846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8396847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8397878;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8397879;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf2_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8401674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8401675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8401676;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 13069;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8401154;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8401155;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ari_cap_ari_base_addr_byte2 = 8401270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ari_cap_ari_base_addr_byte3 = 8401271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8401658;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8401659;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8401660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar0_mem_io = "pf3_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar1_mem_io = "pf3_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar1_type = "pf3_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar2_mem_io = "pf3_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar3_mem_io = "pf3_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar3_type = "pf3_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar4_mem_io = "pf3_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar5_mem_io = "pf3_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_bar5_type = "pf3_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_d1_support = "pf3_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_d2_support = "pf3_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8400977;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8400978;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8400979;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_pba_offset_reg_addr_byte0 = 8401080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_pba_offset_reg_addr_byte1 = 8401081;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_pba_offset_reg_addr_byte2 = 8401082;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_pba_offset_reg_addr_byte3 = 8401083;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_table_offset_reg_addr_byte0 = 8401076;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_table_offset_reg_addr_byte1 = 8401077;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_table_offset_reg_addr_byte2 = 8401078;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_msix_table_offset_reg_addr_byte3 = 8401079;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8401073;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8401074;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8401075;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10498226;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10498227;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8401712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8401713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8401710;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8401711;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_active_state_link_pm_control = "pf3_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_active_state_link_pm_support = "pf3_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_clock_power_man = "pf3_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_device_capabilities_reg_addr_byte0 = 8401012;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_device_capabilities_reg_addr_byte1 = 8401013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_device_capabilities_reg_addr_byte3 = 8401015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_device_control_device_status_addr_byte1 = 8401017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_en_clk_power_man = "pf3_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_ext_tag_supp = "pf3_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_capabilities_reg_addr_byte0 = 8401020;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_capabilities_reg_addr_byte1 = 8401021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_capabilities_reg_addr_byte2 = 8401022;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_capabilities_reg_addr_byte3 = 12415;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12595360;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_control_link_status_reg_addr_byte0 = 4206720;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_control_link_status_reg_addr_byte1 = 12595329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_control_link_status_reg_addr_byte3 = 4206723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_max_link_speed = "pf3_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_max_link_width = "pf3_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_max_payload_size = "pf3_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8401009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8401011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_rcb = "pf3_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_sel_deemphasis = "pf3_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_target_link_speed = "pf3_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pcie_slot_imp = "pf3_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8400961;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8400962;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8400963;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pm_cap_con_status_reg_addr_byte0 = 8400964;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8401686;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8401687;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8401692;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8401693;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8401694;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8401695;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8401718;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8401719;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8401256;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8401257;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8401258;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8401259;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8401260;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8401261;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8401262;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8401263;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_sn_base_addr_byte2 = 8401254;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_sn_base_addr_byte3 = 8401255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10498616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10498617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10498624;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10498625;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10498626;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10498627;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2110032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2110033;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2110034;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2110035;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2110036;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2110037;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2110038;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2110039;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2110040;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2110041;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2110042;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2110043;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2110044;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2110045;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2110046;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2110047;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2110048;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2110049;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2110050;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2110051;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2110052;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2110053;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2110054;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2110055;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2110036;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2110044;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2110052;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_base_reg_addr_byte2 = 8401454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_base_reg_addr_byte3 = 8401455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_initial_vfs_addr_byte0 = 8401464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_initial_vfs_addr_byte1 = 8401465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8401472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8401473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8401474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8401475;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8401480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8401481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8401482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8401483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_bar0_reg_addr_byte0 = 12880;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_bar1_reg_addr_byte0 = 12884;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_bar2_reg_addr_byte0 = 12888;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_bar3_reg_addr_byte0 = 12892;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_bar4_reg_addr_byte0 = 12896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_bar5_reg_addr_byte0 = 12900;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_device_id_reg_addr_byte2 = 8401478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_cap_vf_device_id_reg_addr_byte3 = 8401479;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar1_type = "pf3_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar3_type = "pf3_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_sriov_vf_bar5_type = "pf3_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8401518;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8401519;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_addr_byte0 = 8401520;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_addr_byte1 = 8401521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_addr_byte2 = 8401522;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_addr_byte3 = 8401523;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10498672;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10498673;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10498674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10498675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_st_table_loc_0 = "pf3_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar0_mask_reg_addr_byte0 = 2109456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar0_mask_reg_addr_byte1 = 2109457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar0_mask_reg_addr_byte2 = 2109458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar0_mask_reg_addr_byte3 = 2109459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar0_reg_addr_byte0 = 12304;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar1_enable_reg_addr_byte0 = 2109460;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar1_mask_reg_addr_byte0 = 2109460;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar1_mask_reg_addr_byte1 = 2109461;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar1_mask_reg_addr_byte2 = 2109462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar1_mask_reg_addr_byte3 = 2109463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar1_reg_addr_byte0 = 12308;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar2_mask_reg_addr_byte0 = 2109464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar2_mask_reg_addr_byte1 = 2109465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar2_mask_reg_addr_byte2 = 2109466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar2_mask_reg_addr_byte3 = 2109467;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar2_reg_addr_byte0 = 12312;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar3_enable_reg_addr_byte0 = 2109468;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar3_mask_reg_addr_byte0 = 2109468;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar3_mask_reg_addr_byte1 = 2109469;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar3_mask_reg_addr_byte2 = 2109470;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar3_mask_reg_addr_byte3 = 2109471;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar3_reg_addr_byte0 = 12316;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar4_mask_reg_addr_byte0 = 2109472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar4_mask_reg_addr_byte1 = 2109473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar4_mask_reg_addr_byte2 = 2109474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar4_mask_reg_addr_byte3 = 2109475;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar4_reg_addr_byte0 = 12320;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar5_enable_reg_addr_byte0 = 2109476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar5_mask_reg_addr_byte0 = 2109476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar5_mask_reg_addr_byte1 = 2109477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar5_mask_reg_addr_byte2 = 2109478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar5_mask_reg_addr_byte3 = 2109479;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bar5_reg_addr_byte0 = 12324;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8400910;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8400936;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8400937;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8400938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8400939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_class_code_revision_id_addr_byte0 = 8400904;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_class_code_revision_id_addr_byte1 = 8400905;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_class_code_revision_id_addr_byte2 = 8400906;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_class_code_revision_id_addr_byte3 = 8400907;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8400896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8400897;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8400898;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8400899;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2109488;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2109489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2109490;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2109491;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 12336;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8400957;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8400948;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8400940;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8400941;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8400942;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8400943;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8401974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8401975;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf3_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8405770;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8405771;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8405772;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 17165;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8405250;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8405251;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ari_cap_ari_base_addr_byte2 = 8405366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ari_cap_ari_base_addr_byte3 = 8405367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8405754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8405755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8405756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar0_mem_io = "pf4_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar1_mem_io = "pf4_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar1_type = "pf4_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar2_mem_io = "pf4_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar3_mem_io = "pf4_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar3_type = "pf4_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar4_mem_io = "pf4_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar5_mem_io = "pf4_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_bar5_type = "pf4_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_d1_support = "pf4_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_d2_support = "pf4_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8405073;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8405074;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8405075;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_pba_offset_reg_addr_byte0 = 8405176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_pba_offset_reg_addr_byte1 = 8405177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_pba_offset_reg_addr_byte2 = 8405178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_pba_offset_reg_addr_byte3 = 8405179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_table_offset_reg_addr_byte0 = 8405172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_table_offset_reg_addr_byte1 = 8405173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_table_offset_reg_addr_byte2 = 8405174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_msix_table_offset_reg_addr_byte3 = 8405175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8405169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8405170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8405171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10502322;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10502323;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8405808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8405809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8405806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8405807;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_active_state_link_pm_control = "pf4_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_active_state_link_pm_support = "pf4_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_clock_power_man = "pf4_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_device_capabilities_reg_addr_byte0 = 8405108;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_device_capabilities_reg_addr_byte1 = 8405109;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_device_capabilities_reg_addr_byte3 = 8405111;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_device_control_device_status_addr_byte1 = 8405113;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_en_clk_power_man = "pf4_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_ext_tag_supp = "pf4_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_capabilities_reg_addr_byte0 = 8405116;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_capabilities_reg_addr_byte1 = 8405117;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_capabilities_reg_addr_byte2 = 8405118;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_capabilities_reg_addr_byte3 = 16511;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12599456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_control_link_status_reg_addr_byte0 = 4210816;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_control_link_status_reg_addr_byte1 = 12599425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_control_link_status_reg_addr_byte3 = 4210819;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_max_link_speed = "pf4_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_max_link_width = "pf4_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_max_payload_size = "pf4_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8405105;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8405107;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_rcb = "pf4_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_sel_deemphasis = "pf4_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_target_link_speed = "pf4_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pcie_slot_imp = "pf4_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8405057;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8405058;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8405059;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pm_cap_con_status_reg_addr_byte0 = 8405060;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8405782;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8405783;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8405788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8405789;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8405790;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8405791;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8405814;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8405815;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8405352;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8405353;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8405354;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8405355;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8405356;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8405357;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8405358;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8405359;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_sn_base_addr_byte2 = 8405350;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_sn_base_addr_byte3 = 8405351;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10502712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10502713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10502720;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10502721;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10502722;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10502723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2114128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2114129;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2114130;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2114131;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2114132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2114133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2114134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2114135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2114136;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2114137;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2114138;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2114139;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2114140;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2114141;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2114142;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2114143;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2114144;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2114145;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2114146;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2114147;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2114148;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2114149;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2114150;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2114151;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2114132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2114140;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2114148;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_base_reg_addr_byte2 = 8405550;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_base_reg_addr_byte3 = 8405551;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_initial_vfs_addr_byte0 = 8405560;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_initial_vfs_addr_byte1 = 8405561;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8405568;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8405569;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8405570;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8405571;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8405576;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8405577;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8405578;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8405579;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_bar0_reg_addr_byte0 = 16976;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_bar1_reg_addr_byte0 = 16980;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_bar2_reg_addr_byte0 = 16984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_bar3_reg_addr_byte0 = 16988;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_bar4_reg_addr_byte0 = 16992;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_bar5_reg_addr_byte0 = 16996;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_device_id_reg_addr_byte2 = 8405574;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_cap_vf_device_id_reg_addr_byte3 = 8405575;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar1_type = "pf4_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar3_type = "pf4_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_sriov_vf_bar5_type = "pf4_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8405614;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8405615;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_addr_byte0 = 8405616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_addr_byte1 = 8405617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_addr_byte2 = 8405618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_addr_byte3 = 8405619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10502768;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10502769;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10502770;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10502771;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_st_table_loc_0 = "pf4_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar0_mask_reg_addr_byte0 = 2113552;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar0_mask_reg_addr_byte1 = 2113553;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar0_mask_reg_addr_byte2 = 2113554;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar0_mask_reg_addr_byte3 = 2113555;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar0_reg_addr_byte0 = 16400;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar1_enable_reg_addr_byte0 = 2113556;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar1_mask_reg_addr_byte0 = 2113556;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar1_mask_reg_addr_byte1 = 2113557;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar1_mask_reg_addr_byte2 = 2113558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar1_mask_reg_addr_byte3 = 2113559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar1_reg_addr_byte0 = 16404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar2_mask_reg_addr_byte0 = 2113560;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar2_mask_reg_addr_byte1 = 2113561;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar2_mask_reg_addr_byte2 = 2113562;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar2_mask_reg_addr_byte3 = 2113563;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar2_reg_addr_byte0 = 16408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar3_enable_reg_addr_byte0 = 2113564;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar3_mask_reg_addr_byte0 = 2113564;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar3_mask_reg_addr_byte1 = 2113565;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar3_mask_reg_addr_byte2 = 2113566;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar3_mask_reg_addr_byte3 = 2113567;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar3_reg_addr_byte0 = 16412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar4_mask_reg_addr_byte0 = 2113568;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar4_mask_reg_addr_byte1 = 2113569;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar4_mask_reg_addr_byte2 = 2113570;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar4_mask_reg_addr_byte3 = 2113571;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar4_reg_addr_byte0 = 16416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar5_enable_reg_addr_byte0 = 2113572;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar5_mask_reg_addr_byte0 = 2113572;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar5_mask_reg_addr_byte1 = 2113573;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar5_mask_reg_addr_byte2 = 2113574;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar5_mask_reg_addr_byte3 = 2113575;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bar5_reg_addr_byte0 = 16420;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8405006;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8405032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8405033;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8405034;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8405035;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_class_code_revision_id_addr_byte0 = 8405000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_class_code_revision_id_addr_byte1 = 8405001;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_class_code_revision_id_addr_byte2 = 8405002;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_class_code_revision_id_addr_byte3 = 8405003;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8404992;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8404993;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8404994;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8404995;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2113584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2113585;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2113586;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2113587;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 16432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8405053;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8405044;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8405036;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8405037;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8405038;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8405039;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8406070;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8406071;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf4_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8409866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8409867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8409868;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 21261;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8409346;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8409347;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ari_cap_ari_base_addr_byte2 = 8409462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ari_cap_ari_base_addr_byte3 = 8409463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8409850;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8409851;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8409852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar0_mem_io = "pf5_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar1_mem_io = "pf5_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar1_type = "pf5_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar2_mem_io = "pf5_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar3_mem_io = "pf5_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar3_type = "pf5_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar4_mem_io = "pf5_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar5_mem_io = "pf5_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_bar5_type = "pf5_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_d1_support = "pf5_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_d2_support = "pf5_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8409169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8409170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8409171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_pba_offset_reg_addr_byte0 = 8409272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_pba_offset_reg_addr_byte1 = 8409273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_pba_offset_reg_addr_byte2 = 8409274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_pba_offset_reg_addr_byte3 = 8409275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_table_offset_reg_addr_byte0 = 8409268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_table_offset_reg_addr_byte1 = 8409269;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_table_offset_reg_addr_byte2 = 8409270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_msix_table_offset_reg_addr_byte3 = 8409271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8409265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8409266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8409267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10506418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10506419;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8409904;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8409905;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8409902;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8409903;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_active_state_link_pm_control = "pf5_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_active_state_link_pm_support = "pf5_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_clock_power_man = "pf5_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_device_capabilities_reg_addr_byte0 = 8409204;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_device_capabilities_reg_addr_byte1 = 8409205;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_device_capabilities_reg_addr_byte3 = 8409207;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_device_control_device_status_addr_byte1 = 8409209;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_en_clk_power_man = "pf5_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_ext_tag_supp = "pf5_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_capabilities_reg_addr_byte0 = 8409212;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_capabilities_reg_addr_byte1 = 8409213;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_capabilities_reg_addr_byte2 = 8409214;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_capabilities_reg_addr_byte3 = 20607;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12603552;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_control_link_status_reg_addr_byte0 = 4214912;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_control_link_status_reg_addr_byte1 = 12603521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_control_link_status_reg_addr_byte3 = 4214915;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_max_link_speed = "pf5_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_max_link_width = "pf5_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_max_payload_size = "pf5_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8409201;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8409203;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_rcb = "pf5_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_sel_deemphasis = "pf5_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_target_link_speed = "pf5_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pcie_slot_imp = "pf5_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8409153;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8409154;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8409155;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pm_cap_con_status_reg_addr_byte0 = 8409156;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8409878;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8409879;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8409884;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8409885;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8409886;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8409887;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8409910;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8409911;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8409448;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8409449;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8409450;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8409451;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8409452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8409453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8409454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8409455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_sn_base_addr_byte2 = 8409446;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_sn_base_addr_byte3 = 8409447;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10506808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10506809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10506816;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10506817;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10506818;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10506819;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2118224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2118225;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2118226;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2118227;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2118228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2118229;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2118230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2118231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2118232;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2118233;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2118234;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2118235;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2118236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2118237;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2118238;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2118239;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2118240;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2118241;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2118242;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2118243;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2118244;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2118245;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2118246;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2118247;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2118228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2118236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2118244;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_base_reg_addr_byte2 = 8409646;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_base_reg_addr_byte3 = 8409647;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_initial_vfs_addr_byte0 = 8409656;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_initial_vfs_addr_byte1 = 8409657;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8409664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8409665;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8409666;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8409667;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8409672;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8409673;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8409674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8409675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_bar0_reg_addr_byte0 = 21072;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_bar1_reg_addr_byte0 = 21076;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_bar2_reg_addr_byte0 = 21080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_bar3_reg_addr_byte0 = 21084;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_bar4_reg_addr_byte0 = 21088;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_bar5_reg_addr_byte0 = 21092;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_device_id_reg_addr_byte2 = 8409670;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_cap_vf_device_id_reg_addr_byte3 = 8409671;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar1_type = "pf5_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar3_type = "pf5_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_sriov_vf_bar5_type = "pf5_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8409710;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8409711;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_addr_byte0 = 8409712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_addr_byte1 = 8409713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_addr_byte2 = 8409714;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_addr_byte3 = 8409715;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10506864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10506865;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10506866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10506867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_st_table_loc_0 = "pf5_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar0_mask_reg_addr_byte0 = 2117648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar0_mask_reg_addr_byte1 = 2117649;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar0_mask_reg_addr_byte2 = 2117650;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar0_mask_reg_addr_byte3 = 2117651;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar0_reg_addr_byte0 = 20496;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar1_enable_reg_addr_byte0 = 2117652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar1_mask_reg_addr_byte0 = 2117652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar1_mask_reg_addr_byte1 = 2117653;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar1_mask_reg_addr_byte2 = 2117654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar1_mask_reg_addr_byte3 = 2117655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar1_reg_addr_byte0 = 20500;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar2_mask_reg_addr_byte0 = 2117656;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar2_mask_reg_addr_byte1 = 2117657;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar2_mask_reg_addr_byte2 = 2117658;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar2_mask_reg_addr_byte3 = 2117659;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar2_reg_addr_byte0 = 20504;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar3_enable_reg_addr_byte0 = 2117660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar3_mask_reg_addr_byte0 = 2117660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar3_mask_reg_addr_byte1 = 2117661;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar3_mask_reg_addr_byte2 = 2117662;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar3_mask_reg_addr_byte3 = 2117663;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar3_reg_addr_byte0 = 20508;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar4_mask_reg_addr_byte0 = 2117664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar4_mask_reg_addr_byte1 = 2117665;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar4_mask_reg_addr_byte2 = 2117666;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar4_mask_reg_addr_byte3 = 2117667;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar4_reg_addr_byte0 = 20512;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar5_enable_reg_addr_byte0 = 2117668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar5_mask_reg_addr_byte0 = 2117668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar5_mask_reg_addr_byte1 = 2117669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar5_mask_reg_addr_byte2 = 2117670;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar5_mask_reg_addr_byte3 = 2117671;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bar5_reg_addr_byte0 = 20516;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8409102;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8409128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8409129;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8409130;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8409131;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_class_code_revision_id_addr_byte0 = 8409096;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_class_code_revision_id_addr_byte1 = 8409097;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_class_code_revision_id_addr_byte2 = 8409098;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_class_code_revision_id_addr_byte3 = 8409099;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8409088;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8409089;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8409090;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8409091;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2117680;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2117681;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2117682;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2117683;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 20528;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8409149;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8409140;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8409132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8409133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8409134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8409135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8410166;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8410167;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf5_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8413962;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8413963;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8413964;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 25357;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8413442;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8413443;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ari_cap_ari_base_addr_byte2 = 8413558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ari_cap_ari_base_addr_byte3 = 8413559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8413946;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8413947;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8413948;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar0_mem_io = "pf6_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar1_mem_io = "pf6_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar1_type = "pf6_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar2_mem_io = "pf6_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar3_mem_io = "pf6_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar3_type = "pf6_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar4_mem_io = "pf6_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar5_mem_io = "pf6_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_bar5_type = "pf6_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_d1_support = "pf6_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_d2_support = "pf6_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8413265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8413266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8413267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_pba_offset_reg_addr_byte0 = 8413368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_pba_offset_reg_addr_byte1 = 8413369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_pba_offset_reg_addr_byte2 = 8413370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_pba_offset_reg_addr_byte3 = 8413371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_table_offset_reg_addr_byte0 = 8413364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_table_offset_reg_addr_byte1 = 8413365;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_table_offset_reg_addr_byte2 = 8413366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_msix_table_offset_reg_addr_byte3 = 8413367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8413361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8413362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8413363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10510514;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10510515;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8414000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8414001;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8413998;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8413999;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_active_state_link_pm_control = "pf6_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_active_state_link_pm_support = "pf6_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_clock_power_man = "pf6_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_device_capabilities_reg_addr_byte0 = 8413300;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_device_capabilities_reg_addr_byte1 = 8413301;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_device_capabilities_reg_addr_byte3 = 24695;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_device_control_device_status_addr_byte1 = 8413305;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_en_clk_power_man = "pf6_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_ext_tag_supp = "pf6_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_capabilities_reg_addr_byte0 = 8413308;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_capabilities_reg_addr_byte1 = 8413309;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_capabilities_reg_addr_byte2 = 8413310;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_capabilities_reg_addr_byte3 = 24703;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12607648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_control_link_status_reg_addr_byte0 = 4219008;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_control_link_status_reg_addr_byte1 = 12607617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_control_link_status_reg_addr_byte3 = 4219011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_max_link_speed = "pf6_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_max_link_width = "pf6_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_max_payload_size = "pf6_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8413297;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8413299;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_rcb = "pf6_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_sel_deemphasis = "pf6_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_target_link_speed = "pf6_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pcie_slot_imp = "pf6_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8413249;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8413250;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8413251;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pm_cap_con_status_reg_addr_byte0 = 8413252;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8413974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8413975;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8413980;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8413981;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8413982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8413983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8414006;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8414007;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8413544;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8413545;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8413546;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8413547;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8413548;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8413549;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8413550;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8413551;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_sn_base_addr_byte2 = 8413542;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_sn_base_addr_byte3 = 8413543;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10510904;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10510905;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10510912;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10510913;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10510914;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10510915;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2122320;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2122321;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2122322;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2122323;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2122324;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2122325;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2122326;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2122327;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2122328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2122329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2122330;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2122331;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2122332;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2122333;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2122334;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2122335;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2122336;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2122337;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2122338;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2122339;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2122340;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2122341;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2122342;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2122343;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2122324;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2122332;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2122340;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_base_reg_addr_byte2 = 8413742;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_base_reg_addr_byte3 = 8413743;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_initial_vfs_addr_byte0 = 8413752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_initial_vfs_addr_byte1 = 8413753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8413760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8413761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8413762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8413763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8413768;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8413769;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8413770;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8413771;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_bar0_reg_addr_byte0 = 25168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_bar1_reg_addr_byte0 = 25172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_bar2_reg_addr_byte0 = 25176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_bar3_reg_addr_byte0 = 25180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_bar4_reg_addr_byte0 = 25184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_bar5_reg_addr_byte0 = 25188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_device_id_reg_addr_byte2 = 8413766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_cap_vf_device_id_reg_addr_byte3 = 8413767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar1_type = "pf6_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar3_type = "pf6_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_sriov_vf_bar5_type = "pf6_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8413806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8413807;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_addr_byte0 = 8413808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_addr_byte1 = 8413809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_addr_byte2 = 8413810;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_addr_byte3 = 8413811;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10510960;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10510961;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10510962;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10510963;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_st_table_loc_0 = "pf6_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar0_mask_reg_addr_byte0 = 2121744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar0_mask_reg_addr_byte1 = 2121745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar0_mask_reg_addr_byte2 = 2121746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar0_mask_reg_addr_byte3 = 2121747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar0_reg_addr_byte0 = 24592;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar1_enable_reg_addr_byte0 = 2121748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar1_mask_reg_addr_byte0 = 2121748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar1_mask_reg_addr_byte1 = 2121749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar1_mask_reg_addr_byte2 = 2121750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar1_mask_reg_addr_byte3 = 2121751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar1_reg_addr_byte0 = 24596;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar2_mask_reg_addr_byte0 = 2121752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar2_mask_reg_addr_byte1 = 2121753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar2_mask_reg_addr_byte2 = 2121754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar2_mask_reg_addr_byte3 = 2121755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar2_reg_addr_byte0 = 24600;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar3_enable_reg_addr_byte0 = 2121756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar3_mask_reg_addr_byte0 = 2121756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar3_mask_reg_addr_byte1 = 2121757;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar3_mask_reg_addr_byte2 = 2121758;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar3_mask_reg_addr_byte3 = 2121759;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar3_reg_addr_byte0 = 24604;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar4_mask_reg_addr_byte0 = 2121760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar4_mask_reg_addr_byte1 = 2121761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar4_mask_reg_addr_byte2 = 2121762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar4_mask_reg_addr_byte3 = 2121763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar4_reg_addr_byte0 = 24608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar5_enable_reg_addr_byte0 = 2121764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar5_mask_reg_addr_byte0 = 2121764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar5_mask_reg_addr_byte1 = 2121765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar5_mask_reg_addr_byte2 = 2121766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar5_mask_reg_addr_byte3 = 2121767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bar5_reg_addr_byte0 = 24612;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8413198;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8413224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8413225;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8413226;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8413227;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_class_code_revision_id_addr_byte0 = 8413192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_class_code_revision_id_addr_byte1 = 8413193;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_class_code_revision_id_addr_byte2 = 8413194;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_class_code_revision_id_addr_byte3 = 8413195;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8413184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8413185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8413186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8413187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2121776;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2121777;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2121778;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2121779;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 24624;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8413245;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8413236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8413228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8413229;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8413230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8413231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8414262;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8414263;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf6_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8418058;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8418059;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8418060;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 29453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8417538;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8417539;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ari_cap_ari_base_addr_byte2 = 8417654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ari_cap_ari_base_addr_byte3 = 8417655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8418042;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8418043;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8418044;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar0_mem_io = "pf7_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar1_mem_io = "pf7_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar1_type = "pf7_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar2_mem_io = "pf7_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar3_mem_io = "pf7_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar3_type = "pf7_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar4_mem_io = "pf7_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar5_mem_io = "pf7_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_bar5_type = "pf7_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_d1_support = "pf7_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_d2_support = "pf7_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8417361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8417362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8417363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_pba_offset_reg_addr_byte0 = 8417464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_pba_offset_reg_addr_byte1 = 8417465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_pba_offset_reg_addr_byte2 = 8417466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_pba_offset_reg_addr_byte3 = 8417467;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_table_offset_reg_addr_byte0 = 8417460;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_table_offset_reg_addr_byte1 = 8417461;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_table_offset_reg_addr_byte2 = 8417462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_msix_table_offset_reg_addr_byte3 = 8417463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8417457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8417458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8417459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10514610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10514611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8418096;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 29489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8418094;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8418095;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_active_state_link_pm_control = "pf7_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_active_state_link_pm_support = "pf7_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_clock_power_man = "pf7_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_device_capabilities_reg_addr_byte0 = 8417396;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_device_capabilities_reg_addr_byte1 = 8417397;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_device_capabilities_reg_addr_byte3 = 8417399;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_device_control_device_status_addr_byte1 = 8417401;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_en_clk_power_man = "pf7_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_ext_tag_supp = "pf7_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_capabilities_reg_addr_byte0 = 8417404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_capabilities_reg_addr_byte1 = 8417405;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_capabilities_reg_addr_byte2 = 8417406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_capabilities_reg_addr_byte3 = 28799;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12611744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_control_link_status_reg_addr_byte0 = 4223104;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_control_link_status_reg_addr_byte1 = 12611713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_control_link_status_reg_addr_byte3 = 4223107;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_max_link_speed = "pf7_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_max_link_width = "pf7_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_max_payload_size = "pf7_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8417393;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8417395;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_rcb = "pf7_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_sel_deemphasis = "pf7_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_target_link_speed = "pf7_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pcie_slot_imp = "pf7_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8417345;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8417346;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8417347;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pm_cap_con_status_reg_addr_byte0 = 8417348;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8418070;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8418071;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8418076;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8418077;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8418078;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8418079;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8418102;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8418103;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8417640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8417641;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8417642;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8417643;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8417644;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8417645;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8417646;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8417647;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_sn_base_addr_byte2 = 8417638;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_sn_base_addr_byte3 = 8417639;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10515000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10515001;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10515008;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10515009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10515010;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10515011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2126416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2126417;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2126418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2126419;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2126420;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2126421;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2126422;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2126423;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2126424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2126425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2126426;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2126427;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2126428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2126429;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2126430;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2126431;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2126432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2126433;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2126434;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2126435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2126436;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2126437;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2126438;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2126439;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2126420;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2126428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2126436;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_base_reg_addr_byte2 = 8417838;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_base_reg_addr_byte3 = 8417839;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_initial_vfs_addr_byte0 = 8417848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_initial_vfs_addr_byte1 = 8417849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8417856;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8417857;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8417858;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8417859;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8417864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8417865;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8417866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8417867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_bar0_reg_addr_byte0 = 29264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_bar1_reg_addr_byte0 = 29268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_bar2_reg_addr_byte0 = 29272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_bar3_reg_addr_byte0 = 29276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_bar4_reg_addr_byte0 = 29280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_bar5_reg_addr_byte0 = 29284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_device_id_reg_addr_byte2 = 8417862;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_cap_vf_device_id_reg_addr_byte3 = 8417863;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar1_type = "pf7_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar3_type = "pf7_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_sriov_vf_bar5_type = "pf7_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8417902;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8417903;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_addr_byte0 = 8417904;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_addr_byte1 = 8417905;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_addr_byte2 = 8417906;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_addr_byte3 = 8417907;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10515056;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10515057;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10515058;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10515059;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_st_table_loc_0 = "pf7_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar0_mask_reg_addr_byte0 = 2125840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar0_mask_reg_addr_byte1 = 2125841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar0_mask_reg_addr_byte2 = 2125842;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar0_mask_reg_addr_byte3 = 2125843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar0_reg_addr_byte0 = 28688;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar1_enable_reg_addr_byte0 = 2125844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar1_mask_reg_addr_byte0 = 2125844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar1_mask_reg_addr_byte1 = 2125845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar1_mask_reg_addr_byte2 = 2125846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar1_mask_reg_addr_byte3 = 2125847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar1_reg_addr_byte0 = 28692;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar2_mask_reg_addr_byte0 = 2125848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar2_mask_reg_addr_byte1 = 2125849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar2_mask_reg_addr_byte2 = 2125850;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar2_mask_reg_addr_byte3 = 2125851;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar2_reg_addr_byte0 = 28696;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar3_enable_reg_addr_byte0 = 2125852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar3_mask_reg_addr_byte0 = 2125852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar3_mask_reg_addr_byte1 = 2125853;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar3_mask_reg_addr_byte2 = 2125854;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar3_mask_reg_addr_byte3 = 2125855;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar3_reg_addr_byte0 = 28700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar4_mask_reg_addr_byte0 = 2125856;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar4_mask_reg_addr_byte1 = 2125857;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar4_mask_reg_addr_byte2 = 2125858;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar4_mask_reg_addr_byte3 = 2125859;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar4_reg_addr_byte0 = 28704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar5_enable_reg_addr_byte0 = 2125860;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar5_mask_reg_addr_byte0 = 2125860;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar5_mask_reg_addr_byte1 = 2125861;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar5_mask_reg_addr_byte2 = 2125862;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar5_mask_reg_addr_byte3 = 2125863;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bar5_reg_addr_byte0 = 28708;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8417294;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8417320;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8417321;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8417322;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8417323;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_class_code_revision_id_addr_byte0 = 8417288;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_class_code_revision_id_addr_byte1 = 8417289;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_class_code_revision_id_addr_byte2 = 8417290;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_class_code_revision_id_addr_byte3 = 8417291;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8417280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8417281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8417282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8417283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2125872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2125873;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2125874;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2125875;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 28720;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8417341;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8417332;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8417324;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8417325;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8417326;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8417327;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8418358;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8418359;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pf7_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pld_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pld_tx_fifo_dyn_empty_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__pldif_fifo_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__rstctl_timer_a = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__rstctl_timer_b = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__rxbuf_limit_init = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__rxbuf_pfull_th = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__sriov_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_cdts_rst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_fifo_empty_threshold_1 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_fifo_empty_threshold_2 = 12;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_fifo_empty_threshold_3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_fifo_empty_threshold_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__tx_fifo_full_threshold = 40;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__user_mode_del_count = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__vf = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_ip_port_num = "pcie_port0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_margin_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_pl16g_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf0_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf1_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf2_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf3_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf4_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf5_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf6_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_pf7_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_ptm_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__virtual_txeq_mode = "eq_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core16__wait_pld_warm_rst_rdy = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_blk_crs_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf0_table_size = 311;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf1_start_addr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf1_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf2_start_addr = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf2_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf3_start_addr = 896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf3_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf4_start_addr = 1152;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf4_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf5_start_addr = 1408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf5_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf6_start_addr = 1664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf6_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf7_start_addr = 1920;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_dbi_pf7_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_ram_ecc_chk_val = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cfg_ram_ecc_gen_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__crs_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__crs_override_value = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_blocking_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_hard_reset_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_hip_clk_sel_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_mode_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_mode_gating_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_update_no_reset = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_vsec_id = 4466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_vsec_rev = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_warm_rst_ready_force_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_warm_rst_ready_force_bit1 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_warm_rst_req_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__cvp_write_mask_ctl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__dbg_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__dbi_ro_wr_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__device_type = "dev_nep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__device_width = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__dyngate_sriov_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__dyngate_vfspfnum_core_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__ecrc_strip = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__ep_signal_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__err_tlp_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__func_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__gate_clk_in_reset_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__gate_radm_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__intel_marker = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__margining_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__margining_software_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ack_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8389246;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8389247;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8389248;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 641;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8388866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8388867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aer_cap_root_err_status_off_addr_byte0 = 304;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_cap_ari_base_addr_byte2 = 8388982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_cap_ari_base_addr_byte3 = 8388983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_cap_cap_reg_addr_byte0 = 8388984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_mfvc_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8389230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8389231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8389232;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_auto_eq_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_auto_eq_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aux_clk_freq = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_aux_clk_freq_off_rsvdp_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar0_mem_io = "pf0_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar1_mem_io = "pf0_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar1_type = "pf0_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar2_mem_io = "pf0_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar3_type = "pf0_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar4_mem_io = "pf0_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar5_mem_io = "pf0_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_bar5_type = "pf0_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_common_clk_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_config_limit = 831;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_config_tx_comp_rx = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_cross_link_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_cross_link_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_d1_support = "pf0_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_d2_support = "pf0_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_66 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_67 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_68 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_69 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_70 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_71 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_72 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_73 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_direct_speed_change = "pf0_auto_speed_chg";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_disable_fc_wd_timer = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_disable_scrambler_gen_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_disable_scrambler_gen_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte2 = 8389602;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte3 = 8389603;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dlink_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dlink_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_dll_link_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eidle_timer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_eq_eieos_cnt_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_fast_training_seq = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen1_ei_inference = "pf0_use_rx_eidle";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen2_ctrl_off_rsvdp_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_dc_balance_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_dc_balance_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_dllp_xmt_delay_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_dllp_xmt_delay_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_control_off_rsvdp_27_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_control_off_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_control_off_rsvdp_7_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_fb_mode = "pf0_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_fb_mode_atg4 = "pf0_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_fom_inc_initial_eval = "pf0_ignore_init_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_fom_inc_initial_eval_atg4 = "pf0_ignore_init_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_invreq_eva_diff_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_invreq_eva_diff_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_pset_req_as_coef = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_eq_pset_req_as_coef_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_14_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_19_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_1_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_related_off_rsvdp_26_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_req_send_consec_eieos_for_pset_map = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_req_send_consec_eieos_for_pset_map_atg4 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_zrxdc_noncompl = "pf0_compliant";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_gen3_zrxdc_noncompl_atg4 = "pf0_compliant_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control01_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control01_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control01_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control01_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1011_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1011_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1011_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1011_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1213_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1213_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1213_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1213_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1415_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1415_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1415_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control1415_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control23_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control23_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control23_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control23_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control45_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control45_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control45_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control45_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control67_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control67_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control67_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control67_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control89_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control89_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control89_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_lane_equalization_control89_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_capable = "pf0_conn_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_link_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte2 = 8389274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte3 = 8389275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ltr_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ltr_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte2 = 8389066;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte3 = 8389067;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_margin_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_margin_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_mask_radm_1 = 8200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_mask_radm_2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_max_func_num = "pf0_one_function";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_misc_control_1_rsvdp_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8388689;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8388690;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8388691;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_pba_offset_reg_addr_byte0 = 8388792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_pba_offset_reg_addr_byte1 = 8388793;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_pba_offset_reg_addr_byte2 = 8388794;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_pba_offset_reg_addr_byte3 = 8388795;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_table_offset_reg_addr_byte0 = 8388788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_table_offset_reg_addr_byte1 = 8388789;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_table_offset_reg_addr_byte2 = 8388790;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_msix_table_offset_reg_addr_byte3 = 8388791;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8388785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8388786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8388787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10485938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10485939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_num_of_lanes = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_p2p_err_rpt_ctrl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_p2p_track_cpl_to_reg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8389284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8389285;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8389282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8389283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_active_state_link_pm_control = "pf0_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_active_state_link_pm_support = "pf0_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_clock_power_man = "pf0_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_device_capabilities_reg_addr_byte0 = 8388724;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_device_capabilities_reg_addr_byte1 = 8388725;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_device_capabilities_reg_addr_byte3 = 8388727;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_device_control_device_status_addr_byte1 = 8388729;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_en_clk_power_man = "pf0_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_capabilities_reg_addr_byte0 = 8388732;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_capabilities_reg_addr_byte1 = 8388733;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_capabilities_reg_addr_byte2 = 8388734;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_capabilities_reg_addr_byte3 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12583072;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_control_link_status_reg_addr_byte0 = 4194432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_control_link_status_reg_addr_byte1 = 12583041;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_control_link_status_reg_addr_byte3 = 4194435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_max_link_speed = "pf0_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_max_link_width = "pf0_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_max_payload_size = "pf0_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_next_ptr = 176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8388721;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8388723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_rcb = "pf0_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_root_control_root_capabilities_reg_addr_byte2 = 8388750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_capabilities_reg_addr_byte0 = 132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_capabilities_reg_addr_byte1 = 133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_capabilities_reg_addr_byte2 = 134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_slot_capabilities_reg_addr_byte3 = 135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_target_link_speed = "pf0_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pipe_loopback_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte2 = 8389030;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte3 = 8389031;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pl16g_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8388673;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8388674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8388675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pm_cap_con_status_reg_addr_byte0 = 8388676;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_link_ctrl_off_rsvdp_4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte1 = 8390413;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte2 = 1806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_aux_clk_freq_off_addr_byte0 = 8391488;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_aux_clk_freq_off_addr_byte1 = 8391489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_filter_mask_2_off_addr_byte0 = 8390432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_filter_mask_2_off_addr_byte1 = 8390433;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_filter_mask_2_off_addr_byte2 = 8390434;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_filter_mask_2_off_addr_byte3 = 8390435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen2_ctrl_off_addr_byte0 = 8390668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen2_ctrl_off_addr_byte1 = 8390669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen2_ctrl_off_addr_byte2 = 12584974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_eq_local_fs_lf_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_atg4_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_atg4_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_atg4_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_gen3_related_off_atg4_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_misc_control_1_off_addr_byte1 = 2237;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_misc_control_1_off_addr_byte2 = 2238;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_pipe_loopback_control_off_addr_byte3 = 8390843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_port_force_off_addr_byte0 = 8390408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_port_link_ctrl_off_addr_byte0 = 8390416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_port_link_ctrl_off_addr_byte2 = 8390418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_queue_status_off_addr_byte2 = 8390462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_queue_status_off_addr_byte3 = 8390463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_symbol_timer_filter_1_off_addr_byte0 = 8390428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_symbol_timer_filter_1_off_addr_byte1 = 8390429;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_symbol_timer_filter_1_off_addr_byte2 = 8390430;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_symbol_timer_filter_1_off_addr_byte3 = 8390431;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_timer_ctrl_max_func_num_off_addr_byte0 = 8390424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte0 = 8390480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte1 = 8390481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte2 = 8390482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte3 = 8390483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte0 = 8390476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte1 = 8390477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte2 = 8390478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte0 = 8390472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte1 = 8390473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte2 = 8390474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_pre_det_lane = "pf0_det_all_lanes";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8389258;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8389259;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8389264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8389265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8389266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8389267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_queue_status_off_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8389290;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8389291;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rate_shadow_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rate_shadow_sel_atg4 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved250 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved8 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_66_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_67_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_68_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_69_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_70_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_71_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_72_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_73_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_reset_assert = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_root_control_root_capabilities_reg_rsvdp_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_root_err_status_off_rsvdp_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rp_exp_rom_bar_mask_reg_rp_rom_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_rxstatus_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_scramble_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_skp_int_val = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8388968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8388969;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8388970;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8388971;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8388972;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8388973;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8388974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8388975;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_sn_base_addr_byte2 = 8388966;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_sn_base_addr_byte3 = 8388967;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte0 = 400;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte1 = 8389009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte2 = 402;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte3 = 8389011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_spcie_cap_header_reg_addr_byte2 = 8388998;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_spcie_cap_header_reg_addr_byte3 = 8388999;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_spcie_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10486328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10486329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10486336;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10486337;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10486338;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10486339;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2097744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2097745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2097746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2097747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2097748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2097749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2097750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2097751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2097752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2097753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2097754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2097755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2097756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2097757;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2097758;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2097759;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2097760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2097761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2097762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2097763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2097764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2097765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2097766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2097767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2097748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2097756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2097764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_base_reg_addr_byte2 = 558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_base_reg_addr_byte3 = 559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_initial_vfs_addr_byte0 = 8389176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_initial_vfs_addr_byte1 = 8389177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8389184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8389185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8389186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8389187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8389192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8389193;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8389194;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8389195;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_bar0_reg_addr_byte0 = 592;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_bar1_reg_addr_byte0 = 596;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_bar2_reg_addr_byte0 = 600;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_bar3_reg_addr_byte0 = 604;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_bar4_reg_addr_byte0 = 608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_bar5_reg_addr_byte0 = 612;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_device_id_reg_addr_byte2 = 8389190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_cap_vf_device_id_reg_addr_byte3 = 8389191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar1_type = "pf0_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar3_type = "pf0_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_sriov_vf_bar5_type = "pf0_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_target_above_config_limit = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_timer_mod_flow_control = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_timer_mod_flow_control_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8389090;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8389091;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_addr_byte0 = 8389092;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_addr_byte1 = 8389093;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_addr_byte2 = 8389094;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_addr_byte3 = 8389095;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10486244;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10486245;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10486246;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10486247;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_st_table_loc_0 = "pf0_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar0_mask_reg_addr_byte0 = 2097168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar0_mask_reg_addr_byte1 = 2097169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar0_mask_reg_addr_byte2 = 2097170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar0_mask_reg_addr_byte3 = 2097171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar0_reg_addr_byte0 = 16;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar1_enable_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar1_mask_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar1_mask_reg_addr_byte1 = 2097173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar1_mask_reg_addr_byte2 = 2097174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar1_mask_reg_addr_byte3 = 2097175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar1_reg_addr_byte0 = 20;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar2_mask_reg_addr_byte0 = 2097176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar2_mask_reg_addr_byte1 = 2097177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar2_mask_reg_addr_byte2 = 2097178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar2_mask_reg_addr_byte3 = 2097179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar2_reg_addr_byte0 = 24;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar3_enable_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar3_mask_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar3_mask_reg_addr_byte1 = 2097181;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar3_mask_reg_addr_byte2 = 2097182;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar3_mask_reg_addr_byte3 = 2097183;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar3_reg_addr_byte0 = 28;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar4_mask_reg_addr_byte0 = 2097184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar4_mask_reg_addr_byte1 = 2097185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar4_mask_reg_addr_byte2 = 2097186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar4_mask_reg_addr_byte3 = 2097187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar4_reg_addr_byte0 = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar5_enable_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar5_mask_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar5_mask_reg_addr_byte1 = 2097189;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar5_mask_reg_addr_byte2 = 2097190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar5_mask_reg_addr_byte3 = 2097191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bar5_reg_addr_byte0 = 36;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8388622;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8388648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8388649;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8388650;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8388651;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_class_code_revision_id_addr_byte0 = 8388616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_class_code_revision_id_addr_byte1 = 8388617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_class_code_revision_id_addr_byte2 = 8388618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_class_code_revision_id_addr_byte3 = 8388619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8388608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8388609;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8388610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8388611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2097200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2097201;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2097202;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2097203;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 48;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8388669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8388660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte0 = 2097208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte1 = 2097209;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte2 = 2097210;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte3 = 2097211;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8388652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8388653;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8388654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8388655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_send_8gt_eq_ts2_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_usp_send_8gt_eq_ts2_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_cpl_data_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_cpl_data_scale = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_cpl_hdr_scale = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_cpl_header_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_cpl_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_np_data_credit = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_np_header_credit = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_np_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_p_data_credit = 444;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_p_header_credit = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc0_p_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc_cap_vc_base_addr_byte2 = 8388938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc_cap_vc_base_addr_byte3 = 8388939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vc_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vendor_specific_dllp_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8389546;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8389547;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pf0_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pld_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pld_tx_fifo_dyn_empty_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__pldif_fifo_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__rstctl_timer_a = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__rstctl_timer_b = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__rxbuf_limit_init = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__rxbuf_pfull_th = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__sriov_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_cdts_rst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_fifo_empty_threshold_1 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_fifo_empty_threshold_2 = 12;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_fifo_empty_threshold_3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_fifo_empty_threshold_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__tx_fifo_full_threshold = 40;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__user_mode_del_count = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__vf = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_ip_port_num = "pcie_port2";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_link_width = "x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_margin_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf0_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf1_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf2_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf3_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf4_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf5_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf6_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_pf7_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__virtual_txeq_mode = "eq_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_0__wait_pld_warm_rst_rdy = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_blk_crs_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf0_table_size = 311;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf1_start_addr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf1_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf2_start_addr = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf2_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf3_start_addr = 896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf3_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf4_start_addr = 1152;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf4_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf5_start_addr = 1408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf5_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf6_start_addr = 1664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf6_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf7_start_addr = 1920;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_dbi_pf7_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_ram_ecc_chk_val = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cfg_ram_ecc_gen_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__crs_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__crs_override_value = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_blocking_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_hard_reset_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_hip_clk_sel_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_mode_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_mode_gating_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_update_no_reset = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_vsec_id = 4466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_vsec_rev = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_warm_rst_ready_force_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_warm_rst_ready_force_bit1 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_warm_rst_req_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__cvp_write_mask_ctl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__dbg_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__dbi_ro_wr_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__device_type = "dev_nep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__device_width = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__dyngate_sriov_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__dyngate_vfspfnum_core_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__ecrc_strip = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__ep_signal_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__err_tlp_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__func_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__gate_clk_in_reset_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__gate_radm_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__intel_marker = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__margining_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__margining_software_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ack_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8389246;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8389247;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8389248;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 641;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8388866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8388867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aer_cap_root_err_status_off_addr_byte0 = 304;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_cap_ari_base_addr_byte2 = 8388982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_cap_ari_base_addr_byte3 = 8388983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_cap_cap_reg_addr_byte0 = 8388984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_mfvc_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8389230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8389231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8389232;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_auto_eq_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_auto_eq_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aux_clk_freq = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_aux_clk_freq_off_rsvdp_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar0_mem_io = "pf0_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar1_mem_io = "pf0_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar1_type = "pf0_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar2_mem_io = "pf0_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar3_type = "pf0_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar4_mem_io = "pf0_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar5_mem_io = "pf0_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_bar5_type = "pf0_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_common_clk_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_config_limit = 831;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_config_tx_comp_rx = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_cross_link_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_cross_link_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_d1_support = "pf0_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_d2_support = "pf0_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_66 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_67 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_68 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_69 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_70 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_71 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_72 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_73 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_direct_speed_change = "pf0_auto_speed_chg";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_disable_fc_wd_timer = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_disable_scrambler_gen_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_disable_scrambler_gen_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte2 = 8389602;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte3 = 8389603;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dlink_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dlink_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_dll_link_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eidle_timer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_eq_eieos_cnt_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_fast_training_seq = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen1_ei_inference = "pf0_use_rx_eidle";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen2_ctrl_off_rsvdp_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_dc_balance_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_dc_balance_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_dllp_xmt_delay_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_dllp_xmt_delay_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_control_off_rsvdp_27_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_control_off_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_control_off_rsvdp_7_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_fb_mode = "pf0_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_fb_mode_atg4 = "pf0_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_fom_inc_initial_eval = "pf0_ignore_init_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_fom_inc_initial_eval_atg4 = "pf0_ignore_init_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_invreq_eva_diff_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_invreq_eva_diff_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_pset_req_as_coef = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_eq_pset_req_as_coef_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_14_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_19_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_1_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_related_off_rsvdp_26_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_req_send_consec_eieos_for_pset_map = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_req_send_consec_eieos_for_pset_map_atg4 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_zrxdc_noncompl = "pf0_compliant";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_gen3_zrxdc_noncompl_atg4 = "pf0_compliant_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control01_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control01_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control01_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control01_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1011_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1011_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1011_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1011_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1213_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1213_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1213_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1213_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1415_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1415_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1415_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control1415_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control23_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control23_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control23_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control23_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control45_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control45_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control45_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control45_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control67_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control67_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control67_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control67_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control89_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control89_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control89_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_lane_equalization_control89_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_capable = "pf0_conn_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_link_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte2 = 8389274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte3 = 8389275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ltr_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ltr_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte2 = 8389066;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte3 = 8389067;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_margin_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_margin_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_mask_radm_1 = 8200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_mask_radm_2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_max_func_num = "pf0_one_function";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_misc_control_1_rsvdp_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8388689;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8388690;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8388691;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_pba_offset_reg_addr_byte0 = 8388792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_pba_offset_reg_addr_byte1 = 8388793;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_pba_offset_reg_addr_byte2 = 8388794;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_pba_offset_reg_addr_byte3 = 8388795;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_table_offset_reg_addr_byte0 = 8388788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_table_offset_reg_addr_byte1 = 8388789;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_table_offset_reg_addr_byte2 = 8388790;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_msix_table_offset_reg_addr_byte3 = 8388791;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8388785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8388786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8388787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10485938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10485939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_num_of_lanes = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_p2p_err_rpt_ctrl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_p2p_track_cpl_to_reg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8389284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8389285;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8389282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8389283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_active_state_link_pm_control = "pf0_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_active_state_link_pm_support = "pf0_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_clock_power_man = "pf0_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_device_capabilities_reg_addr_byte0 = 8388724;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_device_capabilities_reg_addr_byte1 = 8388725;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_device_capabilities_reg_addr_byte3 = 8388727;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_device_control_device_status_addr_byte1 = 8388729;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_en_clk_power_man = "pf0_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_capabilities_reg_addr_byte0 = 8388732;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_capabilities_reg_addr_byte1 = 8388733;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_capabilities_reg_addr_byte2 = 8388734;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_capabilities_reg_addr_byte3 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12583072;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_control_link_status_reg_addr_byte0 = 4194432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_control_link_status_reg_addr_byte1 = 12583041;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_control_link_status_reg_addr_byte3 = 4194435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_max_link_speed = "pf0_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_max_link_width = "pf0_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_max_payload_size = "pf0_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_next_ptr = 176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8388721;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8388723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_rcb = "pf0_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_root_control_root_capabilities_reg_addr_byte2 = 8388750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_capabilities_reg_addr_byte0 = 132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_capabilities_reg_addr_byte1 = 133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_capabilities_reg_addr_byte2 = 134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_slot_capabilities_reg_addr_byte3 = 135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_target_link_speed = "pf0_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pipe_loopback_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte2 = 8389030;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte3 = 8389031;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pl16g_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8388673;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8388674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8388675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pm_cap_con_status_reg_addr_byte0 = 8388676;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_link_ctrl_off_rsvdp_4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte1 = 8390413;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte2 = 1806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_aux_clk_freq_off_addr_byte0 = 8391488;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_aux_clk_freq_off_addr_byte1 = 8391489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_filter_mask_2_off_addr_byte0 = 8390432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_filter_mask_2_off_addr_byte1 = 8390433;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_filter_mask_2_off_addr_byte2 = 8390434;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_filter_mask_2_off_addr_byte3 = 8390435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen2_ctrl_off_addr_byte0 = 8390668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen2_ctrl_off_addr_byte1 = 8390669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen2_ctrl_off_addr_byte2 = 12584974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_eq_local_fs_lf_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_atg4_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_atg4_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_atg4_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_gen3_related_off_atg4_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_misc_control_1_off_addr_byte1 = 2237;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_misc_control_1_off_addr_byte2 = 2238;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_pipe_loopback_control_off_addr_byte3 = 8390843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_port_force_off_addr_byte0 = 8390408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_port_link_ctrl_off_addr_byte0 = 8390416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_port_link_ctrl_off_addr_byte2 = 8390418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_queue_status_off_addr_byte2 = 8390462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_queue_status_off_addr_byte3 = 8390463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_symbol_timer_filter_1_off_addr_byte0 = 8390428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_symbol_timer_filter_1_off_addr_byte1 = 8390429;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_symbol_timer_filter_1_off_addr_byte2 = 8390430;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_symbol_timer_filter_1_off_addr_byte3 = 8390431;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_timer_ctrl_max_func_num_off_addr_byte0 = 8390424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte0 = 8390480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte1 = 8390481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte2 = 8390482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte3 = 8390483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte0 = 8390476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte1 = 8390477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte2 = 8390478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte0 = 8390472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte1 = 8390473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte2 = 8390474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_pre_det_lane = "pf0_det_all_lanes";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8389258;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8389259;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8389264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8389265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8389266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8389267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_queue_status_off_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8389290;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8389291;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rate_shadow_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rate_shadow_sel_atg4 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved250 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved8 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_66_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_67_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_68_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_69_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_70_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_71_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_72_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_73_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_reset_assert = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_root_control_root_capabilities_reg_rsvdp_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_root_err_status_off_rsvdp_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rp_exp_rom_bar_mask_reg_rp_rom_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_rxstatus_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_scramble_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_skp_int_val = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8388968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8388969;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8388970;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8388971;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8388972;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8388973;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8388974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8388975;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_sn_base_addr_byte2 = 8388966;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_sn_base_addr_byte3 = 8388967;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte0 = 400;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte1 = 8389009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte2 = 402;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte3 = 8389011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_spcie_cap_header_reg_addr_byte2 = 8388998;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_spcie_cap_header_reg_addr_byte3 = 8388999;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_spcie_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10486328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10486329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10486336;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10486337;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10486338;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10486339;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2097744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2097745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2097746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2097747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2097748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2097749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2097750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2097751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2097752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2097753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2097754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2097755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2097756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2097757;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2097758;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2097759;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2097760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2097761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2097762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2097763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2097764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2097765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2097766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2097767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2097748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2097756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2097764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_base_reg_addr_byte2 = 558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_base_reg_addr_byte3 = 559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_initial_vfs_addr_byte0 = 8389176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_initial_vfs_addr_byte1 = 8389177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8389184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8389185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8389186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8389187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8389192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8389193;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8389194;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8389195;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_bar0_reg_addr_byte0 = 592;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_bar1_reg_addr_byte0 = 596;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_bar2_reg_addr_byte0 = 600;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_bar3_reg_addr_byte0 = 604;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_bar4_reg_addr_byte0 = 608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_bar5_reg_addr_byte0 = 612;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_device_id_reg_addr_byte2 = 8389190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_cap_vf_device_id_reg_addr_byte3 = 8389191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar1_type = "pf0_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar3_type = "pf0_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_sriov_vf_bar5_type = "pf0_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_target_above_config_limit = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_timer_mod_flow_control = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_timer_mod_flow_control_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8389090;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8389091;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_addr_byte0 = 8389092;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_addr_byte1 = 8389093;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_addr_byte2 = 8389094;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_addr_byte3 = 8389095;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10486244;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10486245;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10486246;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10486247;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_st_table_loc_0 = "pf0_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar0_mask_reg_addr_byte0 = 2097168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar0_mask_reg_addr_byte1 = 2097169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar0_mask_reg_addr_byte2 = 2097170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar0_mask_reg_addr_byte3 = 2097171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar0_reg_addr_byte0 = 16;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar1_enable_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar1_mask_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar1_mask_reg_addr_byte1 = 2097173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar1_mask_reg_addr_byte2 = 2097174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar1_mask_reg_addr_byte3 = 2097175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar1_reg_addr_byte0 = 20;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar2_mask_reg_addr_byte0 = 2097176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar2_mask_reg_addr_byte1 = 2097177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar2_mask_reg_addr_byte2 = 2097178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar2_mask_reg_addr_byte3 = 2097179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar2_reg_addr_byte0 = 24;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar3_enable_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar3_mask_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar3_mask_reg_addr_byte1 = 2097181;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar3_mask_reg_addr_byte2 = 2097182;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar3_mask_reg_addr_byte3 = 2097183;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar3_reg_addr_byte0 = 28;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar4_mask_reg_addr_byte0 = 2097184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar4_mask_reg_addr_byte1 = 2097185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar4_mask_reg_addr_byte2 = 2097186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar4_mask_reg_addr_byte3 = 2097187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar4_reg_addr_byte0 = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar5_enable_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar5_mask_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar5_mask_reg_addr_byte1 = 2097189;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar5_mask_reg_addr_byte2 = 2097190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar5_mask_reg_addr_byte3 = 2097191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bar5_reg_addr_byte0 = 36;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8388622;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8388648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8388649;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8388650;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8388651;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_class_code_revision_id_addr_byte0 = 8388616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_class_code_revision_id_addr_byte1 = 8388617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_class_code_revision_id_addr_byte2 = 8388618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_class_code_revision_id_addr_byte3 = 8388619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8388608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8388609;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8388610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8388611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2097200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2097201;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2097202;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2097203;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 48;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8388669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8388660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte0 = 2097208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte1 = 2097209;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte2 = 2097210;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte3 = 2097211;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8388652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8388653;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8388654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8388655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_send_8gt_eq_ts2_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_usp_send_8gt_eq_ts2_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_cpl_data_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_cpl_data_scale = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_cpl_hdr_scale = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_cpl_header_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_cpl_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_np_data_credit = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_np_header_credit = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_np_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_p_data_credit = 444;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_p_header_credit = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc0_p_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc_cap_vc_base_addr_byte2 = 8388938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc_cap_vc_base_addr_byte3 = 8388939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vc_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vendor_specific_dllp_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8389546;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8389547;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pf0_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pld_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pld_tx_fifo_dyn_empty_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__pldif_fifo_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__rstctl_timer_a = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__rstctl_timer_b = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__rxbuf_limit_init = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__rxbuf_pfull_th = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__sriov_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_cdts_rst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_fifo_empty_threshold_1 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_fifo_empty_threshold_2 = 12;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_fifo_empty_threshold_3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_fifo_empty_threshold_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__tx_fifo_full_threshold = 40;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__user_mode_del_count = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__vf = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_ip_port_num = "pcie_port3";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_link_width = "x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_margin_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf0_sriov_num_vf_non_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf1_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf2_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf3_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf4_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf5_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf6_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_pf7_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__virtual_txeq_mode = "eq_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core4_1__wait_pld_warm_rst_rdy = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_blk_crs_en = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf0_table_size = 339;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf1_start_addr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf1_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf2_start_addr = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf2_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf3_start_addr = 896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf3_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf4_start_addr = 1152;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf4_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf5_start_addr = 1408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf5_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf6_start_addr = 1664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf6_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf7_start_addr = 1920;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_dbi_pf7_table_size = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_ptm_local_clock_adj_lsb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_ptm_local_clock_adj_msb = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_ram_ecc_chk_val = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cfg_ram_ecc_gen_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__crs_override = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__crs_override_value = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_blocking_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_hard_reset_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_hip_clk_sel_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_mode_default = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_mode_gating_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_update_no_reset = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_vsec_id = 4466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_vsec_rev = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_warm_rst_ready_force_bit0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_warm_rst_ready_force_bit1 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_warm_rst_req_ena = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__cvp_write_mask_ctl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__dbg_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__dbi_ro_wr_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__device_type = "dev_nep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__device_width = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__disable_ct_ur = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__disable_msg_ur = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__disable_ur_nf = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__dyngate_sriov_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__dyngate_vfspfnum_core_clk_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__ecrc_strip = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__enable_poison_nf = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__ep_signal_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__err_tlp_bypass = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acs_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_acscap_enable_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_aricap_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_globalinvalidate_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_invalidateqdepth_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_ats_pagealignreq_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_atscap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msix_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_msixcap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_pciecap_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_revisionid_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_devspecificmode_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_exttphrequester_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf3 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf5 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_intvecmode_pf7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tph_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_tphcap_enable = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__exvf_type0cap_nxtptr_pf7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__func_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__gate_clk_in_reset_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__gate_radm_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__intel_marker = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__margining_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__margining_software_ready = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ack_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8389330;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8389331;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8389332;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 725;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8388866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8388867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aer_cap_root_err_status_off_addr_byte0 = 304;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_cap_ari_base_addr_byte2 = 8388982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_cap_ari_base_addr_byte3 = 8388983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_cap_cap_reg_addr_byte0 = 8388984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_mfvc_fun_grp_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8389314;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8389315;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8389316;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_auto_eq_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_auto_eq_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aux_clk_freq = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_aux_clk_freq_off_rsvdp_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar0_mem_io = "pf0_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar1_mem_io = "pf0_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar1_type = "pf0_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar2_mem_io = "pf0_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar3_type = "pf0_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar4_mem_io = "pf0_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar5_mem_io = "pf0_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_bar5_type = "pf0_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_common_clk_n_fts = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_config_limit = 831;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_config_tx_comp_rx = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_cross_link_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_cross_link_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_d1_support = "pf0_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_d2_support = "pf0_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_direct_speed_change = "pf0_auto_speed_chg";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_disable_fc_wd_timer = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_disable_scrambler_gen_3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_disable_scrambler_gen_3_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte2 = 8389686;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dlink_cap_dlink_fea_ext_hdr_off_addr_byte3 = 8389687;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dlink_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dlink_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_dll_link_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eidle_timer = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_eq_eieos_cnt_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_fast_training_seq = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen1_ei_inference = "pf0_use_rx_eidle";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen2_ctrl_off_rsvdp_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_dc_balance_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_dc_balance_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_dllp_xmt_delay_disable = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_dllp_xmt_delay_disable_atg4 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_control_off_rsvdp_27_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_control_off_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_control_off_rsvdp_7_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_fb_mode = "pf0_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_fb_mode_atg4 = "pf0_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_fom_inc_initial_eval = "pf0_ignore_init_fom";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_fom_inc_initial_eval_atg4 = "pf0_ignore_init_fom_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_invreq_eva_diff_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_invreq_eva_diff_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_pset_req_as_coef = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_eq_pset_req_as_coef_atg4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_14_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_19_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_1_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_related_off_rsvdp_26_atg4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_req_send_consec_eieos_for_pset_map = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_req_send_consec_eieos_for_pset_map_atg4 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_zrxdc_noncompl = "pf0_compliant";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_gen3_zrxdc_noncompl_atg4 = "pf0_compliant_atg4";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control01_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control01_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control01_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control01_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1011_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1011_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1011_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1011_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1213_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1213_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1213_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1213_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1415_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1415_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1415_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control1415_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control23_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control23_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control23_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control23_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control45_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control45_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control45_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control45_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control67_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control67_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control67_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control67_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control89_reg_rsvdp_15 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control89_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control89_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_lane_equalization_control89_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_capable = "pf0_conn_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_link_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte2 = 8389358;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ltr_cap_ltr_cap_hdr_reg_addr_byte3 = 8389359;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ltr_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ltr_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte2 = 8389070;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_margin_cap_margin_ext_cap_hdr_reg_addr_byte3 = 8389071;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_margin_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_margin_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_mask_radm_1 = 8200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_mask_radm_2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_max_func_num = "pf0_one_function";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_misc_control_1_rsvdp_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8388689;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8388690;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8388691;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_pba_offset_reg_addr_byte0 = 8388792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_pba_offset_reg_addr_byte1 = 8388793;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_pba_offset_reg_addr_byte2 = 8388794;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_pba_offset_reg_addr_byte3 = 8388795;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_table_offset_reg_addr_byte0 = 8388788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_table_offset_reg_addr_byte1 = 8388789;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_table_offset_reg_addr_byte2 = 8388790;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_msix_table_offset_reg_addr_byte3 = 8388791;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8388785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8388786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8388787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10485938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10485939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_num_of_lanes = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_p2p_err_rpt_ctrl = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_p2p_track_cpl_to_reg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8389368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8389369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8389366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8389367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_active_state_link_pm_control = "pf0_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_active_state_link_pm_support = "pf0_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_clock_power_man = "pf0_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_device_capabilities_reg_addr_byte0 = 8388724;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_device_capabilities_reg_addr_byte1 = 8388725;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_device_capabilities_reg_addr_byte3 = 8388727;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_device_control_device_status_addr_byte1 = 8388729;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_en_clk_power_man = "pf0_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_capabilities_reg_addr_byte0 = 8388732;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_capabilities_reg_addr_byte1 = 8388733;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_capabilities_reg_addr_byte2 = 8388734;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_capabilities_reg_addr_byte3 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12583072;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_control_link_status_reg_addr_byte0 = 4194432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_control_link_status_reg_addr_byte1 = 12583041;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_control_link_status_reg_addr_byte3 = 4194435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_max_link_speed = "pf0_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_max_link_width = "pf0_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_max_payload_size = "pf0_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_next_ptr = 176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8388721;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8388723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_rcb = "pf0_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_root_control_root_capabilities_reg_addr_byte2 = 142;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_capabilities_reg_addr_byte0 = 132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_capabilities_reg_addr_byte1 = 133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_capabilities_reg_addr_byte2 = 134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_slot_capabilities_reg_addr_byte3 = 135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_target_link_speed = "pf0_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pipe_loopback_control_off_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte0 = 452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte1 = 453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte2 = 454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_20h_reg_addr_byte3 = 455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte0 = 456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte1 = 457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte2 = 458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_24h_reg_addr_byte3 = 459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte0 = 456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte1 = 457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte2 = 458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_28h_reg_addr_byte3 = 459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte0 = 456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte1 = 457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte2 = 458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_cap_off_2ch_reg_addr_byte3 = 459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte2 = 8389030;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_pl16g_ext_cap_hdr_reg_addr_byte3 = 8389031;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pl16g_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8388673;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8388674;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8388675;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pm_cap_con_status_reg_addr_byte0 = 8388676;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_link_ctrl_off_rsvdp_4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte1 = 8390413;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_ack_f_aspm_ctrl_off_addr_byte2 = 1806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_aux_clk_freq_off_addr_byte0 = 8391488;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_aux_clk_freq_off_addr_byte1 = 8391489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_filter_mask_2_off_addr_byte0 = 8390432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_filter_mask_2_off_addr_byte1 = 8390433;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_filter_mask_2_off_addr_byte2 = 8390434;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_filter_mask_2_off_addr_byte3 = 8390435;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen2_ctrl_off_addr_byte0 = 8390668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen2_ctrl_off_addr_byte1 = 8390669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen2_ctrl_off_addr_byte2 = 12584974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte0 = 8390824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte1 = 8390825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte2 = 8390826;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_control_off_atg4_addr_byte3 = 8390827;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_eq_local_fs_lf_off_addr_byte1 = 2217;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_atg4_addr_byte0 = 8390800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_atg4_addr_byte1 = 8390801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_atg4_addr_byte2 = 8390802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_gen3_related_off_atg4_addr_byte3 = 8390803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_misc_control_1_off_addr_byte1 = 2237;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_misc_control_1_off_addr_byte2 = 2238;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_pipe_loopback_control_off_addr_byte3 = 8390843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_port_force_off_addr_byte0 = 8390408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_port_link_ctrl_off_addr_byte0 = 8390416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_port_link_ctrl_off_addr_byte2 = 8390418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_queue_status_off_addr_byte2 = 8390462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_queue_status_off_addr_byte3 = 8390463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_symbol_timer_filter_1_off_addr_byte0 = 8390428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_symbol_timer_filter_1_off_addr_byte1 = 8390429;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_symbol_timer_filter_1_off_addr_byte2 = 8390430;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_symbol_timer_filter_1_off_addr_byte3 = 8390431;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_timer_ctrl_max_func_num_off_addr_byte0 = 8390424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte0 = 8390480;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte1 = 8390481;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte2 = 8390482;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_cpl_rx_q_ctrl_off_addr_byte3 = 8390483;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte0 = 8390476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte1 = 8390477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_np_rx_q_ctrl_off_addr_byte2 = 8390478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte0 = 8390472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte1 = 8390473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_port_logic_vc0_p_rx_q_ctrl_off_addr_byte2 = 8390474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_pre_det_lane = "pf0_det_all_lanes";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8389342;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8389343;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8389348;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8389349;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8389350;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8389351;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_off_reserved3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_off_reserved3_dup = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_ptm_cap_off_addr_byte0 = 8389700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_ptm_cap_off_addr_byte0_dup = 8389700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_ptm_ext_cap_hdr_off_addr_byte2 = 8389698;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_ptm_ext_cap_hdr_off_addr_byte3 = 8389699;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capable_dup = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_cap_hdr_off_dbi_addr_byte2 = 8389710;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_cap_hdr_off_dbi_addr_byte3 = 8389711;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_control_off_dbi_addr_byte0 = 8389716;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_control_off_dbi_addr_byte1 = 8389717;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen1_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen2_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen3_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_latency_reg_sel_off_gen4_dbi_addr_byte0 = 8389864;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen1_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen1_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen2_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen2_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen3_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen3_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen4_dbi_addr_byte0 = 8389844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_rx_latency_off_gen4_dbi_addr_byte1 = 8389845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen1_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen1_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen2_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen2_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen3_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen3_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen4_dbi_addr_byte0 = 8389840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_capi_ptm_req_tx_latency_off_gen4_dbi_addr_byte1 = 8389841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_control_off_ptm_req_auto_update_enabled = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_control_off_ptm_req_fast_timers = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_control_off_ptm_req_long_timer = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_control_off_ptm_req_start_update = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_control_off_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_ext_cap_next_offs = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_ext_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_gen1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_gen2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_gen3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_gen4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_off_gen1_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_off_gen2_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_off_gen3_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_latency_reg_sel_off_gen4_reserved4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_gen1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_gen2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_gen3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_gen4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_off_gen1_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_off_gen2_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_off_gen3_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_rx_latency_off_gen4_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_gen1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_gen2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_gen3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_gen4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_off_gen1_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_off_gen2_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_off_gen3_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_req_tx_latency_off_gen4_reserved12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_res_capable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_res_capable_dup = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_root_capable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ptm_root_capable_dup = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_queue_status_off_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8389374;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8389375;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rate_shadow_sel = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rate_shadow_sel_atg4 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved250 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved4 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved8 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_reset_assert = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_root_control_root_capabilities_reg_rsvdp_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_root_err_status_off_rsvdp_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rp_exp_rom_bar_mask_reg_rp_rom_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_rxstatus_value = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_scramble_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_skp_int_val = 640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8388968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8388969;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8388970;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8388971;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8388972;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8388973;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8388974;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8388975;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_sn_base_addr_byte2 = 8388966;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_sn_base_addr_byte3 = 8388967;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte0 = 8389008;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte1 = 8389009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte2 = 8389010;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control01_reg_addr_byte3 = 8389011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte0 = 412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte1 = 8389021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte2 = 414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1011_reg_addr_byte3 = 8389023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte0 = 412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte1 = 8389021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte2 = 414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1213_reg_addr_byte3 = 8389023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte0 = 412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte1 = 8389021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte2 = 414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control1415_reg_addr_byte3 = 8389023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte0 = 404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte1 = 8389013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte2 = 406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control23_reg_addr_byte3 = 8389015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte0 = 408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte1 = 8389017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte2 = 410;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control45_reg_addr_byte3 = 8389019;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte0 = 412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte1 = 8389021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte2 = 414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control67_reg_addr_byte3 = 8389023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte0 = 412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte1 = 8389021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte2 = 414;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_lane_equalization_control89_reg_addr_byte3 = 8389023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_spcie_cap_header_reg_addr_byte2 = 8388998;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_spcie_cap_header_reg_addr_byte3 = 8388999;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_spcie_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10486272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10486273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10486280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10486281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10486282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10486283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2097688;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2097689;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2097690;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2097691;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2097692;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2097693;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2097694;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2097695;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2097696;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2097697;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2097698;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2097699;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2097700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2097701;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2097702;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2097703;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2097704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2097705;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2097706;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2097707;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2097708;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2097709;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2097710;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2097711;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2097692;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2097700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2097708;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_base_reg_addr_byte2 = 8389110;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_base_reg_addr_byte3 = 8389111;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_initial_vfs_addr_byte0 = 8389120;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_initial_vfs_addr_byte1 = 8389121;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8389128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8389129;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8389130;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8389131;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8389136;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8389137;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8389138;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8389139;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_bar0_reg_addr_byte0 = 536;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_bar1_reg_addr_byte0 = 540;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_bar2_reg_addr_byte0 = 544;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_bar3_reg_addr_byte0 = 548;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_bar4_reg_addr_byte0 = 552;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_bar5_reg_addr_byte0 = 556;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_device_id_reg_addr_byte2 = 8389134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_cap_vf_device_id_reg_addr_byte3 = 8389135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar1_type = "pf0_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar3_type = "pf0_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_sriov_vf_bar5_type = "pf0_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_target_above_config_limit = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_timer_mod_flow_control = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_timer_mod_flow_control_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8389174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8389175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_addr_byte0 = 8389176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_addr_byte1 = 8389177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_addr_byte2 = 8389178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_addr_byte3 = 8389179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10486328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10486329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10486330;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10486331;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_st_table_loc_0 = "pf0_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar0_mask_reg_addr_byte0 = 2097168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar0_mask_reg_addr_byte1 = 2097169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar0_mask_reg_addr_byte2 = 2097170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar0_mask_reg_addr_byte3 = 2097171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar0_reg_addr_byte0 = 16;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar1_enable_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar1_mask_reg_addr_byte0 = 2097172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar1_mask_reg_addr_byte1 = 2097173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar1_mask_reg_addr_byte2 = 2097174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar1_mask_reg_addr_byte3 = 2097175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar1_reg_addr_byte0 = 20;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar2_mask_reg_addr_byte0 = 2097176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar2_mask_reg_addr_byte1 = 2097177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar2_mask_reg_addr_byte2 = 2097178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar2_mask_reg_addr_byte3 = 2097179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar2_reg_addr_byte0 = 24;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar3_enable_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar3_mask_reg_addr_byte0 = 2097180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar3_mask_reg_addr_byte1 = 2097181;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar3_mask_reg_addr_byte2 = 2097182;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar3_mask_reg_addr_byte3 = 2097183;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar3_reg_addr_byte0 = 28;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar4_mask_reg_addr_byte0 = 2097184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar4_mask_reg_addr_byte1 = 2097185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar4_mask_reg_addr_byte2 = 2097186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar4_mask_reg_addr_byte3 = 2097187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar4_reg_addr_byte0 = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar5_enable_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar5_mask_reg_addr_byte0 = 2097188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar5_mask_reg_addr_byte1 = 2097189;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar5_mask_reg_addr_byte2 = 2097190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar5_mask_reg_addr_byte3 = 2097191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bar5_reg_addr_byte0 = 36;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8388622;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8388648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8388649;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8388650;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8388651;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_class_code_revision_id_addr_byte0 = 8388616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_class_code_revision_id_addr_byte1 = 8388617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_class_code_revision_id_addr_byte2 = 8388618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_class_code_revision_id_addr_byte3 = 8388619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8388608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8388609;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8388610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8388611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2097200;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2097201;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2097202;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2097203;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 48;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8388669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8388660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte0 = 2097208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte1 = 2097209;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte2 = 2097210;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_rp_exp_rom_bar_mask_reg_addr_byte3 = 2097211;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8388652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8388653;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8388654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8388655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_send_8gt_eq_ts2_disable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_usp_send_8gt_eq_ts2_disable_atg4 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_cpl_data_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_cpl_data_scale = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_cpl_hdr_scale = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_cpl_header_credit = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_cpl_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_np_data_credit = 196;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_np_header_credit = 98;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_np_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_p_data_credit = 760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_p_header_credit = 98;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc0_p_tlp_q_mode = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc_cap_vc_base_addr_byte2 = 8388938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc_cap_vc_base_addr_byte3 = 8388939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vc_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vendor_specific_dllp_req = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8389630;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8389631;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf0_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8393426;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8393427;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8393428;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 4821;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8392962;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8392963;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ari_cap_ari_base_addr_byte2 = 8393078;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ari_cap_ari_base_addr_byte3 = 8393079;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8393410;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8393411;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8393412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar0_mem_io = "pf1_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar1_mem_io = "pf1_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar1_type = "pf1_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar2_mem_io = "pf1_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar3_mem_io = "pf1_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar3_type = "pf1_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar4_mem_io = "pf1_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar5_mem_io = "pf1_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_bar5_type = "pf1_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_d1_support = "pf1_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_d2_support = "pf1_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8392785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8392786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8392787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_pba_offset_reg_addr_byte0 = 8392888;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_pba_offset_reg_addr_byte1 = 8392889;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_pba_offset_reg_addr_byte2 = 8392890;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_pba_offset_reg_addr_byte3 = 8392891;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_table_offset_reg_addr_byte0 = 8392884;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_table_offset_reg_addr_byte1 = 8392885;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_table_offset_reg_addr_byte2 = 8392886;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_msix_table_offset_reg_addr_byte3 = 8392887;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8392881;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8392882;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8392883;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10490034;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10490035;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8393464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8393465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8393462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8393463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_active_state_link_pm_control = "pf1_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_active_state_link_pm_support = "pf1_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_clock_power_man = "pf1_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_device_capabilities_reg_addr_byte0 = 8392820;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_device_capabilities_reg_addr_byte1 = 8392821;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_device_capabilities_reg_addr_byte3 = 8392823;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_device_control_device_status_addr_byte1 = 8392825;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_en_clk_power_man = "pf1_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_capabilities_reg_addr_byte0 = 8392828;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_capabilities_reg_addr_byte1 = 8392829;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_capabilities_reg_addr_byte2 = 8392830;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_capabilities_reg_addr_byte3 = 4223;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12587168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_control_link_status_reg_addr_byte0 = 4198528;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_control_link_status_reg_addr_byte1 = 12587137;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_control_link_status_reg_addr_byte3 = 4198531;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_max_link_speed = "pf1_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_max_link_width = "pf1_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_max_payload_size = "pf1_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8392817;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8392819;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_rcb = "pf1_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_sel_deemphasis = "pf1_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_target_link_speed = "pf1_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pcie_slot_imp = "pf1_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8392769;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8392770;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8392771;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pm_cap_con_status_reg_addr_byte0 = 8392772;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8393438;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8393439;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8393444;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8393445;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8393446;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8393447;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8393470;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8393471;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8393064;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8393065;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8393066;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8393067;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8393068;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8393069;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8393070;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8393071;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_sn_base_addr_byte2 = 8393062;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_sn_base_addr_byte3 = 8393063;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10490368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10490369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10490376;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10490377;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10490378;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10490379;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2101784;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2101785;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2101786;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2101787;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2101788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2101789;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2101790;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2101791;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2101792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2101793;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2101794;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2101795;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2101796;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2101797;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2101798;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2101799;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2101800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2101801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2101802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2101803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2101804;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2101805;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2101806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2101807;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2101788;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2101796;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2101804;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_base_reg_addr_byte2 = 8393206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_base_reg_addr_byte3 = 8393207;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_initial_vfs_addr_byte0 = 8393216;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_initial_vfs_addr_byte1 = 8393217;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8393224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8393225;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8393226;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8393227;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8393232;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8393233;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8393234;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8393235;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_bar0_reg_addr_byte0 = 4632;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_bar1_reg_addr_byte0 = 4636;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_bar2_reg_addr_byte0 = 4640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_bar3_reg_addr_byte0 = 4644;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_bar4_reg_addr_byte0 = 4648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_bar5_reg_addr_byte0 = 4652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_device_id_reg_addr_byte2 = 8393230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_cap_vf_device_id_reg_addr_byte3 = 8393231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar1_type = "pf1_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar3_type = "pf1_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_sriov_vf_bar5_type = "pf1_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8393270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8393271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_addr_byte0 = 8393272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_addr_byte1 = 8393273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_addr_byte2 = 8393274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_addr_byte3 = 8393275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10490424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10490425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10490426;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10490427;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_st_table_loc_0 = "pf1_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar0_mask_reg_addr_byte0 = 2101264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar0_mask_reg_addr_byte1 = 2101265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar0_mask_reg_addr_byte2 = 2101266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar0_mask_reg_addr_byte3 = 2101267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar0_reg_addr_byte0 = 4112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar1_enable_reg_addr_byte0 = 2101268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar1_mask_reg_addr_byte0 = 2101268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar1_mask_reg_addr_byte1 = 2101269;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar1_mask_reg_addr_byte2 = 2101270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar1_mask_reg_addr_byte3 = 2101271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar1_reg_addr_byte0 = 4116;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar2_mask_reg_addr_byte0 = 2101272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar2_mask_reg_addr_byte1 = 2101273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar2_mask_reg_addr_byte2 = 2101274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar2_mask_reg_addr_byte3 = 2101275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar2_reg_addr_byte0 = 4120;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar3_enable_reg_addr_byte0 = 2101276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar3_mask_reg_addr_byte0 = 2101276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar3_mask_reg_addr_byte1 = 2101277;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar3_mask_reg_addr_byte2 = 2101278;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar3_mask_reg_addr_byte3 = 2101279;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar3_reg_addr_byte0 = 4124;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar4_mask_reg_addr_byte0 = 2101280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar4_mask_reg_addr_byte1 = 2101281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar4_mask_reg_addr_byte2 = 2101282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar4_mask_reg_addr_byte3 = 2101283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar4_reg_addr_byte0 = 4128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar5_enable_reg_addr_byte0 = 2101284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar5_mask_reg_addr_byte0 = 2101284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar5_mask_reg_addr_byte1 = 2101285;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar5_mask_reg_addr_byte2 = 2101286;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar5_mask_reg_addr_byte3 = 2101287;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bar5_reg_addr_byte0 = 4132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8392718;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8392744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8392745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8392746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8392747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_class_code_revision_id_addr_byte0 = 8392712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_class_code_revision_id_addr_byte1 = 8392713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_class_code_revision_id_addr_byte2 = 8392714;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_class_code_revision_id_addr_byte3 = 8392715;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8392704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8392705;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8392706;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8392707;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2101296;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2101297;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2101298;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2101299;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 4144;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8392765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8392756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8392748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8392749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8392750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8392751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8393726;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8393727;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf1_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8397522;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8397523;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8397524;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 8917;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8397058;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8397059;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ari_cap_ari_base_addr_byte2 = 8397174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ari_cap_ari_base_addr_byte3 = 8397175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8397506;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8397507;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8397508;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar0_mem_io = "pf2_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar1_mem_io = "pf2_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar1_type = "pf2_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar2_mem_io = "pf2_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar3_mem_io = "pf2_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar3_type = "pf2_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar4_mem_io = "pf2_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar5_mem_io = "pf2_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_bar5_type = "pf2_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_d1_support = "pf2_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_d2_support = "pf2_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8396881;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8396882;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8396883;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_pba_offset_reg_addr_byte0 = 8396984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_pba_offset_reg_addr_byte1 = 8396985;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_pba_offset_reg_addr_byte2 = 8396986;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_pba_offset_reg_addr_byte3 = 8396987;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_table_offset_reg_addr_byte0 = 8396980;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_table_offset_reg_addr_byte1 = 8396981;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_table_offset_reg_addr_byte2 = 8396982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_msix_table_offset_reg_addr_byte3 = 8396983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8396977;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8396978;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8396979;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10494130;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10494131;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8397560;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8397561;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8397558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8397559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_active_state_link_pm_control = "pf2_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_active_state_link_pm_support = "pf2_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_clock_power_man = "pf2_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_device_capabilities_reg_addr_byte0 = 8396916;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_device_capabilities_reg_addr_byte1 = 8396917;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_device_capabilities_reg_addr_byte3 = 8396919;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_device_control_device_status_addr_byte1 = 8396921;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_en_clk_power_man = "pf2_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_capabilities_reg_addr_byte0 = 8396924;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_capabilities_reg_addr_byte1 = 8396925;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_capabilities_reg_addr_byte2 = 8396926;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_capabilities_reg_addr_byte3 = 8319;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12591264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_control_link_status_reg_addr_byte0 = 4202624;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_control_link_status_reg_addr_byte1 = 12591233;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_control_link_status_reg_addr_byte3 = 4202627;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_max_link_speed = "pf2_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_max_link_width = "pf2_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_max_payload_size = "pf2_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8396913;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8396915;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_rcb = "pf2_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_sel_deemphasis = "pf2_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_target_link_speed = "pf2_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pcie_slot_imp = "pf2_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8396865;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8396866;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8396867;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pm_cap_con_status_reg_addr_byte0 = 8396868;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8397534;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8397535;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8397540;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8397541;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8397542;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8397543;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8397566;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8397567;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8397160;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8397161;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8397162;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8397163;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8397164;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8397165;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8397166;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8397167;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_sn_base_addr_byte2 = 8397158;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_sn_base_addr_byte3 = 8397159;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10494464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10494465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10494472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10494473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10494474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10494475;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2105880;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2105881;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2105882;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2105883;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2105884;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2105885;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2105886;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2105887;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2105888;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2105889;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2105890;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2105891;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2105892;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2105893;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2105894;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2105895;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2105896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2105897;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2105898;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2105899;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2105900;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2105901;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2105902;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2105903;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2105884;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2105892;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2105900;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_base_reg_addr_byte2 = 8397302;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_base_reg_addr_byte3 = 8397303;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_initial_vfs_addr_byte0 = 8397312;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_initial_vfs_addr_byte1 = 8397313;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8397320;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8397321;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8397322;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8397323;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8397328;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8397329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8397330;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8397331;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_bar0_reg_addr_byte0 = 8728;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_bar1_reg_addr_byte0 = 8732;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_bar2_reg_addr_byte0 = 8736;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_bar3_reg_addr_byte0 = 8740;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_bar4_reg_addr_byte0 = 8744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_bar5_reg_addr_byte0 = 8748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_device_id_reg_addr_byte2 = 8397326;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_cap_vf_device_id_reg_addr_byte3 = 8397327;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar1_type = "pf2_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar3_type = "pf2_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_sriov_vf_bar5_type = "pf2_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8397366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8397367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_addr_byte0 = 8397368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_addr_byte1 = 8397369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_addr_byte2 = 8397370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_addr_byte3 = 8397371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10494520;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10494521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10494522;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10494523;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_st_table_loc_0 = "pf2_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar0_mask_reg_addr_byte0 = 2105360;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar0_mask_reg_addr_byte1 = 2105361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar0_mask_reg_addr_byte2 = 2105362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar0_mask_reg_addr_byte3 = 2105363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar0_reg_addr_byte0 = 8208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar1_enable_reg_addr_byte0 = 2105364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar1_mask_reg_addr_byte0 = 2105364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar1_mask_reg_addr_byte1 = 2105365;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar1_mask_reg_addr_byte2 = 2105366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar1_mask_reg_addr_byte3 = 2105367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar1_reg_addr_byte0 = 8212;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar2_mask_reg_addr_byte0 = 2105368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar2_mask_reg_addr_byte1 = 2105369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar2_mask_reg_addr_byte2 = 2105370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar2_mask_reg_addr_byte3 = 2105371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar2_reg_addr_byte0 = 8216;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar3_enable_reg_addr_byte0 = 2105372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar3_mask_reg_addr_byte0 = 2105372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar3_mask_reg_addr_byte1 = 2105373;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar3_mask_reg_addr_byte2 = 2105374;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar3_mask_reg_addr_byte3 = 2105375;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar3_reg_addr_byte0 = 8220;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar4_mask_reg_addr_byte0 = 2105376;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar4_mask_reg_addr_byte1 = 2105377;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar4_mask_reg_addr_byte2 = 2105378;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar4_mask_reg_addr_byte3 = 2105379;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar4_reg_addr_byte0 = 8224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar5_enable_reg_addr_byte0 = 2105380;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar5_mask_reg_addr_byte0 = 2105380;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar5_mask_reg_addr_byte1 = 2105381;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar5_mask_reg_addr_byte2 = 2105382;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar5_mask_reg_addr_byte3 = 2105383;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bar5_reg_addr_byte0 = 8228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8396814;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8396840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8396841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8396842;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8396843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_class_code_revision_id_addr_byte0 = 8396808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_class_code_revision_id_addr_byte1 = 8396809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_class_code_revision_id_addr_byte2 = 8396810;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_class_code_revision_id_addr_byte3 = 8396811;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8396800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8396801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8396802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8396803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2105392;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2105393;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2105394;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2105395;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 8240;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8396861;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8396852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8396844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8396845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8396846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8396847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8397822;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8397823;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf2_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8401618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8401619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8401620;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 13013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8401154;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8401155;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ari_cap_ari_base_addr_byte2 = 8401270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ari_cap_ari_base_addr_byte3 = 8401271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8401602;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8401603;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8401604;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar0_mem_io = "pf3_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar1_mem_io = "pf3_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar1_type = "pf3_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar2_mem_io = "pf3_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar3_mem_io = "pf3_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar3_type = "pf3_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar4_mem_io = "pf3_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar5_mem_io = "pf3_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_bar5_type = "pf3_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_d1_support = "pf3_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_d2_support = "pf3_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8400977;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8400978;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8400979;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_pba_offset_reg_addr_byte0 = 8401080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_pba_offset_reg_addr_byte1 = 8401081;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_pba_offset_reg_addr_byte2 = 8401082;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_pba_offset_reg_addr_byte3 = 8401083;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_table_offset_reg_addr_byte0 = 8401076;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_table_offset_reg_addr_byte1 = 8401077;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_table_offset_reg_addr_byte2 = 8401078;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_msix_table_offset_reg_addr_byte3 = 8401079;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8401073;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8401074;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8401075;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10498226;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10498227;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8401656;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8401657;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8401654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8401655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_active_state_link_pm_control = "pf3_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_active_state_link_pm_support = "pf3_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_clock_power_man = "pf3_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_device_capabilities_reg_addr_byte0 = 8401012;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_device_capabilities_reg_addr_byte1 = 8401013;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_device_capabilities_reg_addr_byte3 = 8401015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_device_control_device_status_addr_byte1 = 8401017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_en_clk_power_man = "pf3_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_capabilities_reg_addr_byte0 = 8401020;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_capabilities_reg_addr_byte1 = 8401021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_capabilities_reg_addr_byte2 = 8401022;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_capabilities_reg_addr_byte3 = 12415;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12595360;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_control_link_status_reg_addr_byte0 = 4206720;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_control_link_status_reg_addr_byte1 = 12595329;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_control_link_status_reg_addr_byte3 = 4206723;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_max_link_speed = "pf3_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_max_link_width = "pf3_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_max_payload_size = "pf3_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8401009;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8401011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_rcb = "pf3_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_sel_deemphasis = "pf3_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_target_link_speed = "pf3_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pcie_slot_imp = "pf3_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8400961;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8400962;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8400963;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pm_cap_con_status_reg_addr_byte0 = 8400964;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8401630;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8401631;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8401636;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8401637;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8401638;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8401639;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8401662;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8401663;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8401256;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8401257;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8401258;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8401259;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8401260;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8401261;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8401262;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8401263;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_sn_base_addr_byte2 = 8401254;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_sn_base_addr_byte3 = 8401255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10498560;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10498561;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10498568;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10498569;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10498570;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10498571;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2109976;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2109977;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2109978;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2109979;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2109980;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2109981;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2109982;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2109983;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2109984;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2109985;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2109986;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2109987;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2109988;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2109989;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2109990;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2109991;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2109992;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2109993;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2109994;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2109995;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2109996;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2109997;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2109998;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2109999;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2109980;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2109988;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2109996;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_base_reg_addr_byte2 = 8401398;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_base_reg_addr_byte3 = 8401399;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_initial_vfs_addr_byte0 = 8401408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_initial_vfs_addr_byte1 = 8401409;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8401416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8401417;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8401418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8401419;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8401424;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8401425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8401426;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8401427;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_bar0_reg_addr_byte0 = 12824;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_bar1_reg_addr_byte0 = 12828;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_bar2_reg_addr_byte0 = 12832;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_bar3_reg_addr_byte0 = 12836;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_bar4_reg_addr_byte0 = 12840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_bar5_reg_addr_byte0 = 12844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_device_id_reg_addr_byte2 = 8401422;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_cap_vf_device_id_reg_addr_byte3 = 8401423;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar1_type = "pf3_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar3_type = "pf3_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_sriov_vf_bar5_type = "pf3_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8401462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8401463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_addr_byte0 = 8401464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_addr_byte1 = 8401465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_addr_byte2 = 8401466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_addr_byte3 = 8401467;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10498616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10498617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10498618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10498619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_st_table_loc_0 = "pf3_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar0_mask_reg_addr_byte0 = 2109456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar0_mask_reg_addr_byte1 = 2109457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar0_mask_reg_addr_byte2 = 2109458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar0_mask_reg_addr_byte3 = 2109459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar0_reg_addr_byte0 = 12304;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar1_enable_reg_addr_byte0 = 2109460;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar1_mask_reg_addr_byte0 = 2109460;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar1_mask_reg_addr_byte1 = 2109461;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar1_mask_reg_addr_byte2 = 2109462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar1_mask_reg_addr_byte3 = 2109463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar1_reg_addr_byte0 = 12308;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar2_mask_reg_addr_byte0 = 2109464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar2_mask_reg_addr_byte1 = 2109465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar2_mask_reg_addr_byte2 = 2109466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar2_mask_reg_addr_byte3 = 2109467;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar2_reg_addr_byte0 = 12312;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar3_enable_reg_addr_byte0 = 2109468;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar3_mask_reg_addr_byte0 = 2109468;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar3_mask_reg_addr_byte1 = 2109469;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar3_mask_reg_addr_byte2 = 2109470;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar3_mask_reg_addr_byte3 = 2109471;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar3_reg_addr_byte0 = 12316;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar4_mask_reg_addr_byte0 = 2109472;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar4_mask_reg_addr_byte1 = 2109473;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar4_mask_reg_addr_byte2 = 2109474;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar4_mask_reg_addr_byte3 = 2109475;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar4_reg_addr_byte0 = 12320;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar5_enable_reg_addr_byte0 = 2109476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar5_mask_reg_addr_byte0 = 2109476;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar5_mask_reg_addr_byte1 = 2109477;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar5_mask_reg_addr_byte2 = 2109478;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar5_mask_reg_addr_byte3 = 2109479;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bar5_reg_addr_byte0 = 12324;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8400910;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8400936;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8400937;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8400938;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8400939;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_class_code_revision_id_addr_byte0 = 8400904;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_class_code_revision_id_addr_byte1 = 8400905;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_class_code_revision_id_addr_byte2 = 8400906;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_class_code_revision_id_addr_byte3 = 8400907;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8400896;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8400897;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8400898;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8400899;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2109488;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2109489;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2109490;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2109491;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 12336;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8400957;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8400948;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8400940;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8400941;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8400942;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8400943;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8401918;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8401919;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf3_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8405714;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8405715;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8405716;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 17109;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8405250;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8405251;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ari_cap_ari_base_addr_byte2 = 8405366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ari_cap_ari_base_addr_byte3 = 8405367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8405698;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8405699;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8405700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar0_mem_io = "pf4_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar1_mem_io = "pf4_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar1_type = "pf4_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar2_mem_io = "pf4_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar3_mem_io = "pf4_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar3_type = "pf4_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar4_mem_io = "pf4_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar5_mem_io = "pf4_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_bar5_type = "pf4_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_d1_support = "pf4_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_d2_support = "pf4_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8405073;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8405074;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8405075;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_pba_offset_reg_addr_byte0 = 8405176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_pba_offset_reg_addr_byte1 = 8405177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_pba_offset_reg_addr_byte2 = 8405178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_pba_offset_reg_addr_byte3 = 8405179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_table_offset_reg_addr_byte0 = 8405172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_table_offset_reg_addr_byte1 = 8405173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_table_offset_reg_addr_byte2 = 8405174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_msix_table_offset_reg_addr_byte3 = 8405175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8405169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8405170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8405171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10502322;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10502323;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8405752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8405753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8405750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8405751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_active_state_link_pm_control = "pf4_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_active_state_link_pm_support = "pf4_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_clock_power_man = "pf4_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_device_capabilities_reg_addr_byte0 = 8405108;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_device_capabilities_reg_addr_byte1 = 8405109;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_device_capabilities_reg_addr_byte3 = 8405111;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_device_control_device_status_addr_byte1 = 8405113;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_en_clk_power_man = "pf4_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_capabilities_reg_addr_byte0 = 8405116;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_capabilities_reg_addr_byte1 = 8405117;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_capabilities_reg_addr_byte2 = 8405118;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_capabilities_reg_addr_byte3 = 16511;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12599456;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_control_link_status_reg_addr_byte0 = 4210816;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_control_link_status_reg_addr_byte1 = 12599425;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_control_link_status_reg_addr_byte3 = 4210819;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_max_link_speed = "pf4_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_max_link_width = "pf4_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_max_payload_size = "pf4_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8405105;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8405107;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_rcb = "pf4_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_sel_deemphasis = "pf4_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_target_link_speed = "pf4_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pcie_slot_imp = "pf4_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8405057;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8405058;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8405059;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pm_cap_con_status_reg_addr_byte0 = 8405060;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8405726;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8405727;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8405732;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8405733;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8405734;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8405735;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8405758;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8405759;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8405352;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8405353;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8405354;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8405355;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8405356;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8405357;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8405358;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8405359;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_sn_base_addr_byte2 = 8405350;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_sn_base_addr_byte3 = 8405351;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10502656;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10502657;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10502664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10502665;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10502666;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10502667;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2114072;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2114073;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2114074;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2114075;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2114076;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2114077;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2114078;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2114079;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2114080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2114081;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2114082;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2114083;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2114084;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2114085;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2114086;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2114087;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2114088;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2114089;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2114090;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2114091;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2114092;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2114093;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2114094;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2114095;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2114076;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2114084;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2114092;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_base_reg_addr_byte2 = 8405494;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_base_reg_addr_byte3 = 8405495;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_initial_vfs_addr_byte0 = 8405504;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_initial_vfs_addr_byte1 = 8405505;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8405512;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8405513;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8405514;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8405515;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8405520;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8405521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8405522;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8405523;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_bar0_reg_addr_byte0 = 16920;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_bar1_reg_addr_byte0 = 16924;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_bar2_reg_addr_byte0 = 16928;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_bar3_reg_addr_byte0 = 16932;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_bar4_reg_addr_byte0 = 16936;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_bar5_reg_addr_byte0 = 16940;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_device_id_reg_addr_byte2 = 8405518;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_cap_vf_device_id_reg_addr_byte3 = 8405519;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar1_type = "pf4_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar3_type = "pf4_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_sriov_vf_bar5_type = "pf4_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8405558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8405559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_addr_byte0 = 8405560;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_addr_byte1 = 8405561;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_addr_byte2 = 8405562;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_addr_byte3 = 8405563;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10502712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10502713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10502714;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10502715;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_st_table_loc_0 = "pf4_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar0_mask_reg_addr_byte0 = 2113552;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar0_mask_reg_addr_byte1 = 2113553;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar0_mask_reg_addr_byte2 = 2113554;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar0_mask_reg_addr_byte3 = 2113555;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar0_reg_addr_byte0 = 16400;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar1_enable_reg_addr_byte0 = 2113556;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar1_mask_reg_addr_byte0 = 2113556;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar1_mask_reg_addr_byte1 = 2113557;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar1_mask_reg_addr_byte2 = 2113558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar1_mask_reg_addr_byte3 = 2113559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar1_reg_addr_byte0 = 16404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar2_mask_reg_addr_byte0 = 2113560;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar2_mask_reg_addr_byte1 = 2113561;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar2_mask_reg_addr_byte2 = 2113562;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar2_mask_reg_addr_byte3 = 2113563;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar2_reg_addr_byte0 = 16408;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar3_enable_reg_addr_byte0 = 2113564;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar3_mask_reg_addr_byte0 = 2113564;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar3_mask_reg_addr_byte1 = 2113565;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar3_mask_reg_addr_byte2 = 2113566;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar3_mask_reg_addr_byte3 = 2113567;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar3_reg_addr_byte0 = 16412;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar4_mask_reg_addr_byte0 = 2113568;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar4_mask_reg_addr_byte1 = 2113569;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar4_mask_reg_addr_byte2 = 2113570;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar4_mask_reg_addr_byte3 = 2113571;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar4_reg_addr_byte0 = 16416;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar5_enable_reg_addr_byte0 = 2113572;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar5_mask_reg_addr_byte0 = 2113572;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar5_mask_reg_addr_byte1 = 2113573;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar5_mask_reg_addr_byte2 = 2113574;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar5_mask_reg_addr_byte3 = 2113575;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bar5_reg_addr_byte0 = 16420;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8405006;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8405032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8405033;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8405034;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8405035;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_class_code_revision_id_addr_byte0 = 8405000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_class_code_revision_id_addr_byte1 = 8405001;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_class_code_revision_id_addr_byte2 = 8405002;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_class_code_revision_id_addr_byte3 = 8405003;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8404992;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8404993;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8404994;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8404995;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2113584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2113585;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2113586;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2113587;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 16432;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8405053;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8405044;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8405036;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8405037;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8405038;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8405039;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8406014;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8406015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf4_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8409810;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8409811;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8409812;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 21205;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8409346;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8409347;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ari_cap_ari_base_addr_byte2 = 8409462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ari_cap_ari_base_addr_byte3 = 8409463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8409794;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8409795;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8409796;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar0_mem_io = "pf5_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar1_mem_io = "pf5_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar1_type = "pf5_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar2_mem_io = "pf5_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar3_mem_io = "pf5_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar3_type = "pf5_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar4_mem_io = "pf5_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar5_mem_io = "pf5_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_bar5_type = "pf5_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_d1_support = "pf5_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_d2_support = "pf5_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8409169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8409170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8409171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_pba_offset_reg_addr_byte0 = 8409272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_pba_offset_reg_addr_byte1 = 8409273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_pba_offset_reg_addr_byte2 = 8409274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_pba_offset_reg_addr_byte3 = 8409275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_table_offset_reg_addr_byte0 = 8409268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_table_offset_reg_addr_byte1 = 8409269;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_table_offset_reg_addr_byte2 = 8409270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_msix_table_offset_reg_addr_byte3 = 8409271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8409265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8409266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8409267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10506418;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10506419;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8409848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8409849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8409846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8409847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_active_state_link_pm_control = "pf5_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_active_state_link_pm_support = "pf5_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_clock_power_man = "pf5_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_device_capabilities_reg_addr_byte0 = 8409204;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_device_capabilities_reg_addr_byte1 = 8409205;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_device_capabilities_reg_addr_byte3 = 8409207;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_device_control_device_status_addr_byte1 = 8409209;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_en_clk_power_man = "pf5_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_capabilities_reg_addr_byte0 = 8409212;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_capabilities_reg_addr_byte1 = 8409213;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_capabilities_reg_addr_byte2 = 8409214;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_capabilities_reg_addr_byte3 = 20607;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12603552;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_control_link_status_reg_addr_byte0 = 4214912;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_control_link_status_reg_addr_byte1 = 12603521;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_control_link_status_reg_addr_byte3 = 4214915;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_max_link_speed = "pf5_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_max_link_width = "pf5_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_max_payload_size = "pf5_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8409201;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8409203;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_rcb = "pf5_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_sel_deemphasis = "pf5_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_target_link_speed = "pf5_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pcie_slot_imp = "pf5_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8409153;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8409154;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8409155;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pm_cap_con_status_reg_addr_byte0 = 8409156;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8409822;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8409823;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8409828;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8409829;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8409830;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8409831;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8409854;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8409855;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8409448;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8409449;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8409450;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8409451;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8409452;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8409453;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8409454;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8409455;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_sn_base_addr_byte2 = 8409446;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_sn_base_addr_byte3 = 8409447;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10506752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10506753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10506760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10506761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10506762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10506763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2118168;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2118169;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2118170;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2118171;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2118172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2118173;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2118174;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2118175;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2118176;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2118177;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2118178;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2118179;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2118180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2118181;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2118182;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2118183;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2118184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2118185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2118186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2118187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2118188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2118189;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2118190;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2118191;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2118172;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2118180;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2118188;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_base_reg_addr_byte2 = 8409590;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_base_reg_addr_byte3 = 8409591;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_initial_vfs_addr_byte0 = 8409600;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_initial_vfs_addr_byte1 = 8409601;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8409608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8409609;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8409610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8409611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8409616;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8409617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8409618;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8409619;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_bar0_reg_addr_byte0 = 21016;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_bar1_reg_addr_byte0 = 21020;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_bar2_reg_addr_byte0 = 21024;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_bar3_reg_addr_byte0 = 21028;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_bar4_reg_addr_byte0 = 21032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_bar5_reg_addr_byte0 = 21036;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_device_id_reg_addr_byte2 = 8409614;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_cap_vf_device_id_reg_addr_byte3 = 8409615;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar1_type = "pf5_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar3_type = "pf5_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_sriov_vf_bar5_type = "pf5_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8409654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8409655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_addr_byte0 = 8409656;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_addr_byte1 = 8409657;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_addr_byte2 = 8409658;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_addr_byte3 = 8409659;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10506808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10506809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10506810;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10506811;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_st_table_loc_0 = "pf5_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar0_mask_reg_addr_byte0 = 2117648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar0_mask_reg_addr_byte1 = 2117649;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar0_mask_reg_addr_byte2 = 2117650;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar0_mask_reg_addr_byte3 = 2117651;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar0_reg_addr_byte0 = 20496;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar1_enable_reg_addr_byte0 = 2117652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar1_mask_reg_addr_byte0 = 2117652;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar1_mask_reg_addr_byte1 = 2117653;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar1_mask_reg_addr_byte2 = 2117654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar1_mask_reg_addr_byte3 = 2117655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar1_reg_addr_byte0 = 20500;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar2_mask_reg_addr_byte0 = 2117656;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar2_mask_reg_addr_byte1 = 2117657;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar2_mask_reg_addr_byte2 = 2117658;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar2_mask_reg_addr_byte3 = 2117659;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar2_reg_addr_byte0 = 20504;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar3_enable_reg_addr_byte0 = 2117660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar3_mask_reg_addr_byte0 = 2117660;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar3_mask_reg_addr_byte1 = 2117661;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar3_mask_reg_addr_byte2 = 2117662;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar3_mask_reg_addr_byte3 = 2117663;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar3_reg_addr_byte0 = 20508;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar4_mask_reg_addr_byte0 = 2117664;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar4_mask_reg_addr_byte1 = 2117665;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar4_mask_reg_addr_byte2 = 2117666;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar4_mask_reg_addr_byte3 = 2117667;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar4_reg_addr_byte0 = 20512;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar5_enable_reg_addr_byte0 = 2117668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar5_mask_reg_addr_byte0 = 2117668;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar5_mask_reg_addr_byte1 = 2117669;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar5_mask_reg_addr_byte2 = 2117670;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar5_mask_reg_addr_byte3 = 2117671;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bar5_reg_addr_byte0 = 20516;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8409102;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8409128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8409129;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8409130;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8409131;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_class_code_revision_id_addr_byte0 = 8409096;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_class_code_revision_id_addr_byte1 = 8409097;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_class_code_revision_id_addr_byte2 = 8409098;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_class_code_revision_id_addr_byte3 = 8409099;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8409088;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8409089;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8409090;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8409091;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2117680;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2117681;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2117682;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2117683;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 20528;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8409149;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8409140;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8409132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8409133;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8409134;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8409135;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8410110;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8410111;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf5_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8413906;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8413907;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8413908;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 25301;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8413442;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8413443;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ari_cap_ari_base_addr_byte2 = 8413558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ari_cap_ari_base_addr_byte3 = 8413559;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8413890;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8413891;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8413892;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar0_mem_io = "pf6_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar1_mem_io = "pf6_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar1_type = "pf6_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar2_mem_io = "pf6_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar3_mem_io = "pf6_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar3_type = "pf6_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar4_mem_io = "pf6_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar5_mem_io = "pf6_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_bar5_type = "pf6_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_d1_support = "pf6_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_d2_support = "pf6_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8413265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8413266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8413267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_pba_offset_reg_addr_byte0 = 8413368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_pba_offset_reg_addr_byte1 = 8413369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_pba_offset_reg_addr_byte2 = 8413370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_pba_offset_reg_addr_byte3 = 8413371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_table_offset_reg_addr_byte0 = 8413364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_table_offset_reg_addr_byte1 = 8413365;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_table_offset_reg_addr_byte2 = 8413366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_msix_table_offset_reg_addr_byte3 = 8413367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8413361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8413362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8413363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10510514;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10510515;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8413944;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8413945;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8413942;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8413943;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_active_state_link_pm_control = "pf6_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_active_state_link_pm_support = "pf6_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_clock_power_man = "pf6_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_device_capabilities_reg_addr_byte0 = 8413300;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_device_capabilities_reg_addr_byte1 = 8413301;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_device_capabilities_reg_addr_byte3 = 8413303;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_device_control_device_status_addr_byte1 = 8413305;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_en_clk_power_man = "pf6_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_capabilities_reg_addr_byte0 = 8413308;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_capabilities_reg_addr_byte1 = 8413309;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_capabilities_reg_addr_byte2 = 8413310;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_capabilities_reg_addr_byte3 = 24703;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12607648;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_control_link_status_reg_addr_byte0 = 4219008;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_control_link_status_reg_addr_byte1 = 12607617;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_control_link_status_reg_addr_byte3 = 4219011;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_max_link_speed = "pf6_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_max_link_width = "pf6_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_max_payload_size = "pf6_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8413297;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8413299;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_rcb = "pf6_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_sel_deemphasis = "pf6_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_target_link_speed = "pf6_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pcie_slot_imp = "pf6_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8413249;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8413250;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8413251;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pm_cap_con_status_reg_addr_byte0 = 8413252;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8413918;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8413919;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8413924;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8413925;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8413926;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8413927;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8413950;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8413951;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8413544;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8413545;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8413546;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8413547;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8413548;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8413549;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8413550;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8413551;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_sn_base_addr_byte2 = 8413542;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_sn_base_addr_byte3 = 8413543;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10510848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10510849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10510856;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10510857;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10510858;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10510859;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2122264;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2122265;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2122266;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2122267;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2122268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2122269;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2122270;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2122271;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2122272;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2122273;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2122274;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2122275;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2122276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2122277;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2122278;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2122279;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2122280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2122281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2122282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2122283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2122284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2122285;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2122286;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2122287;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2122268;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2122276;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2122284;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_base_reg_addr_byte2 = 8413686;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_base_reg_addr_byte3 = 8413687;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_initial_vfs_addr_byte0 = 8413696;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_initial_vfs_addr_byte1 = 8413697;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8413704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8413705;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8413706;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8413707;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8413712;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8413713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8413714;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8413715;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_bar0_reg_addr_byte0 = 25112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_bar1_reg_addr_byte0 = 25116;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_bar2_reg_addr_byte0 = 25120;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_bar3_reg_addr_byte0 = 25124;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_bar4_reg_addr_byte0 = 25128;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_bar5_reg_addr_byte0 = 25132;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_device_id_reg_addr_byte2 = 8413710;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_cap_vf_device_id_reg_addr_byte3 = 8413711;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar1_type = "pf6_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar3_type = "pf6_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_sriov_vf_bar5_type = "pf6_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8413750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8413751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_addr_byte0 = 8413752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_addr_byte1 = 8413753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_addr_byte2 = 8413754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_addr_byte3 = 8413755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10510904;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10510905;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10510906;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10510907;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_st_table_loc_0 = "pf6_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar0_mask_reg_addr_byte0 = 2121744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar0_mask_reg_addr_byte1 = 2121745;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar0_mask_reg_addr_byte2 = 2121746;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar0_mask_reg_addr_byte3 = 2121747;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar0_reg_addr_byte0 = 24592;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar1_enable_reg_addr_byte0 = 2121748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar1_mask_reg_addr_byte0 = 2121748;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar1_mask_reg_addr_byte1 = 2121749;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar1_mask_reg_addr_byte2 = 2121750;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar1_mask_reg_addr_byte3 = 2121751;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar1_reg_addr_byte0 = 24596;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar2_mask_reg_addr_byte0 = 2121752;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar2_mask_reg_addr_byte1 = 2121753;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar2_mask_reg_addr_byte2 = 2121754;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar2_mask_reg_addr_byte3 = 2121755;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar2_reg_addr_byte0 = 24600;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar3_enable_reg_addr_byte0 = 2121756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar3_mask_reg_addr_byte0 = 2121756;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar3_mask_reg_addr_byte1 = 2121757;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar3_mask_reg_addr_byte2 = 2121758;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar3_mask_reg_addr_byte3 = 2121759;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar3_reg_addr_byte0 = 24604;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar4_mask_reg_addr_byte0 = 2121760;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar4_mask_reg_addr_byte1 = 2121761;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar4_mask_reg_addr_byte2 = 2121762;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar4_mask_reg_addr_byte3 = 2121763;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar4_reg_addr_byte0 = 24608;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar5_enable_reg_addr_byte0 = 2121764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar5_mask_reg_addr_byte0 = 2121764;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar5_mask_reg_addr_byte1 = 2121765;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar5_mask_reg_addr_byte2 = 2121766;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar5_mask_reg_addr_byte3 = 2121767;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bar5_reg_addr_byte0 = 24612;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8413198;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8413224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8413225;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8413226;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8413227;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_class_code_revision_id_addr_byte0 = 8413192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_class_code_revision_id_addr_byte1 = 8413193;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_class_code_revision_id_addr_byte2 = 8413194;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_class_code_revision_id_addr_byte3 = 8413195;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8413184;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8413185;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8413186;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8413187;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2121776;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2121777;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2121778;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2121779;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 24624;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8413245;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8413236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8413228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8413229;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8413230;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8413231;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8414206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8414207;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf6_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_cap_hdr_reg_addr_byte2 = 8418002;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_cap_hdr_reg_addr_byte3 = 8418003;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_capalities_ctrl_reg_addr_byte0 = 8418004;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_acs_capalities_ctrl_reg_addr_byte1 = 29397;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_rsvdp_7 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_acs_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_aer_cap_aer_ext_cap_hdr_off_addr_byte2 = 8417538;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_aer_cap_aer_ext_cap_hdr_off_addr_byte3 = 8417539;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_aer_cap_version = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_aer_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ari_cap_ari_base_addr_byte2 = 8417654;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ari_cap_ari_base_addr_byte3 = 8417655;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ari_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ari_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ats_cap_ats_cap_hdr_reg_addr_byte2 = 8417986;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ats_cap_ats_cap_hdr_reg_addr_byte3 = 8417987;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ats_cap_ats_capabilities_ctrl_reg_addr_byte0 = 8417988;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ats_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ats_capabilities_ctrl_reg_rsvdp_7 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ats_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar0_mem_io = "pf7_bar0_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar1_mem_io = "pf7_bar1_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar1_type = "pf7_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar2_mem_io = "pf7_bar2_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar3_mem_io = "pf7_bar3_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar3_type = "pf7_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar4_mem_io = "pf7_bar4_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar5_mem_io = "pf7_bar5_mem";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_bar5_type = "pf7_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_cap_id_nxt_ptr_reg_rsvdp_20 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_cap_pointer = 64;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_con_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_con_status_reg_rsvdp_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_d1_support = "pf7_d1_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_d2_support = "pf7_d2_not_supported";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_17 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_18 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_19 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_20 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_21 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_22 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_23 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_25 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_26 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_28 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_30 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_31 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_32 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_33 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_34 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_35 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_36 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_37 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_38 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_39 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_40 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_41 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_42 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_43 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_44 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_45 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_46 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_47 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_48 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_49 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_50 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_51 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_52 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_53 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_54 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_55 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_56 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_57 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_58 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_59 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_60 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_61 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_62 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_63 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_64 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_65 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_dbi_reserved_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_device_capabilities_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_device_capabilities_reg_rsvdp_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_device_capabilities_reg_rsvdp_29 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_exp_rom_bar_mask_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_exp_rom_base_addr_reg_rsvdp_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_global_inval_spprtd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_header_type = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_link_capabilities_reg_rsvdp_23 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_link_control_link_status_reg_rsvdp_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_link_control_link_status_reg_rsvdp_2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_link_control_link_status_reg_rsvdp_26 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_link_control_link_status_reg_rsvdp_9 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte1 = 8417361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte2 = 8417362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_addr_byte3 = 8417363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msi_cap_pci_msi_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_pba_offset_reg_addr_byte0 = 8417464;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_pba_offset_reg_addr_byte1 = 8417465;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_pba_offset_reg_addr_byte2 = 8417466;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_pba_offset_reg_addr_byte3 = 8417467;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_table_offset_reg_addr_byte0 = 8417460;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_table_offset_reg_addr_byte1 = 8417461;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_table_offset_reg_addr_byte2 = 8417462;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_msix_table_offset_reg_addr_byte3 = 8417463;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte1 = 8417457;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte2 = 8417458;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_addr_byte3 = 8417459;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte2 = 10514610;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_msix_cap_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_addr_byte3 = 10514611;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_multi_func = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_pasid_cap_cntrl_reg_addr_byte0 = 8418040;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_pasid_cap_cntrl_reg_addr_byte1 = 8418041;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_pasid_ext_hdr_reg_addr_byte2 = 8418038;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_pasid_ext_hdr_reg_addr_byte3 = 8418039;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_rsvdp_0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_rsvpd_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pasid_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_cap_next_offset = 112;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msi_multiple_msg_en = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_cap_id_next_ctrl_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_cap_id_next_ctrl_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_cap_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_enable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_enable_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_function_mask = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_msix_function_mask_vfcomm_cs2 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_pvm_support = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar1_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar3_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pci_type0_bar5_enabled_or_mask64lsb = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_active_state_link_pm_control = "pf7_aspm_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_active_state_link_pm_support = "pf7_no_aspm";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_aspm_opt_compliance = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_aux_power_pm_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_clock_power_man = "pf7_refclk_remove_not_ok";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_common_clk_config = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_device_capabilities_reg_addr_byte0 = 8417396;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_device_capabilities_reg_addr_byte1 = 8417397;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_device_capabilities_reg_addr_byte3 = 8417399;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_device_control_device_status_addr_byte1 = 8417401;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_dll_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_dll_active_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_en_clk_power_man = "pf7_clkreq_dis";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_en_no_snoop = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_enter_compliance = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_extended_synch = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_hw_auto_speed_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvd = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_rsvdp_31 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_initiate_flr = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_auto_bw_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_auto_bw_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_bw_man_int_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_bw_man_status = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_bw_not_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_capabilities_reg_addr_byte0 = 8417404;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_capabilities_reg_addr_byte1 = 8417405;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_capabilities_reg_addr_byte2 = 8417406;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_capabilities_reg_addr_byte3 = 28799;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_control2_link_status2_reg_addr_byte0 = 12611744;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_control_link_status_reg_addr_byte0 = 4223104;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_control_link_status_reg_addr_byte1 = 12611713;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_control_link_status_reg_addr_byte3 = 4223107;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_disable = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_link_training = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_max_link_speed = "pf7_max_2p5gts";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_max_link_width = "pf7_x1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_max_payload_size = "pf7_payload_128";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_max_read_req_size = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_nego_link_width = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte1 = 8417393;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_pcie_cap_id_pcie_next_cap_ptr_pcie_cap_reg_addr_byte3 = 8417395;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_phantom_func_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_phantom_func_support = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_rcb = "pf7_rcb_64";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_retrain_link = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_role_based_err_report = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_sel_deemphasis = "pf7_minus_6db";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_surprise_down_err_rep_cap = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_target_link_speed = "pf7_trgt_gen1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_cap_tx_margin = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_int_msg_num = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pcie_slot_imp = "pf7_not_implemented";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_ari_device_number = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_dbi_ro_wr_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_default_target = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_disable_auto_ltr_clr_msg = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_mask_ur_ca_4_trgt1 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_misc_control_1_off_rsvdp_6 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_port_logic_misc_control_1_off_addr_byte0 = 2236;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_simplified_replay_timer = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pf0_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pm_cap_cap_id_nxt_ptr_reg_addr_byte1 = 8417345;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pm_cap_cap_id_nxt_ptr_reg_addr_byte2 = 8417346;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pm_cap_cap_id_nxt_ptr_reg_addr_byte3 = 8417347;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pm_cap_con_status_reg_addr_byte0 = 8417348;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pm_next_pointer = 80;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pm_spec_ver = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_pme_clk = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_power_state = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte2 = 8418014;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_prs_ext_cap_hdr_reg_addr_byte3 = 8418015;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte0 = 8418020;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte1 = 8418021;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte2 = 8418022;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_prs_req_capacity_reg_addr_byte3 = 8418023;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_ext_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_prs_outstanding_capacity = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ras_des_cap_ras_des_hdr_reg_addr_byte2 = 8418046;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ras_des_cap_ras_des_hdr_reg_addr_byte3 = 8418047;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ras_des_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_ras_des_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_0_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_10_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_11_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_12_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_13_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_14_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_15_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_16_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_17_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_18_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_19_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_1_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_20_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_21_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_22_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_23_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_24_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_25_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_26_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_27_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_28_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_29_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_2_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_30_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_31_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_32_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_33_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_34_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_35_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_36_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_37_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_38_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_39_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_3_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_40_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_41_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_42_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_43_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_44_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_45_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_46_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_47_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_48_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_49_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_4_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_50_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_51_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_52_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_53_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_54_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_55_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_56_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_57_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_58_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_59_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_5_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_60_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_61_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_62_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_63_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_64_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_65_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_6_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_7_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_8_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_reserved_9_addr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_1_addr_byte0 = 8417640;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_1_addr_byte1 = 8417641;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_1_addr_byte2 = 8417642;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_1_addr_byte3 = 8417643;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_2_addr_byte0 = 8417644;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_2_addr_byte1 = 8417645;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_2_addr_byte2 = 8417646;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_ser_num_reg_dw_2_addr_byte3 = 8417647;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_sn_base_addr_byte2 = 8417638;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_sn_base_addr_byte3 = 8417639;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sn_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_sriov_initial_vfs_addr_byte0 = 10514944;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_sriov_initial_vfs_addr_byte1 = 10514945;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte0 = 10514952;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte1 = 10514953;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte2 = 10514954;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_sriov_vf_offset_position_addr_byte3 = 10514955;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte0 = 2126360;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte1 = 2126361;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte2 = 2126362;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar0_reg_addr_byte3 = 2126363;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte0 = 2126364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte1 = 2126365;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte2 = 2126366;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar1_reg_addr_byte3 = 2126367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte0 = 2126368;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte1 = 2126369;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte2 = 2126370;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar2_reg_addr_byte3 = 2126371;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte0 = 2126372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte1 = 2126373;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte2 = 2126374;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar3_reg_addr_byte3 = 2126375;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte0 = 2126376;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte1 = 2126377;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte2 = 2126378;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar4_reg_addr_byte3 = 2126379;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte0 = 2126380;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte1 = 2126381;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte2 = 2126382;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_shadow_vf_bar5_reg_addr_byte3 = 2126383;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_bar1_enable_reg_addr_byte0 = 2126364;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_bar3_enable_reg_addr_byte0 = 2126372;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_bar5_enable_reg_addr_byte0 = 2126380;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_base_reg_addr_byte2 = 8417782;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_base_reg_addr_byte3 = 8417783;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_initial_vfs_addr_byte0 = 8417792;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_initial_vfs_addr_byte1 = 8417793;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_vf_offset_position_addr_byte0 = 8417800;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_vf_offset_position_addr_byte1 = 8417801;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_vf_offset_position_addr_byte2 = 8417802;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sriov_vf_offset_position_addr_byte3 = 8417803;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sup_page_sizes_reg_addr_byte0 = 8417808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sup_page_sizes_reg_addr_byte1 = 8417809;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sup_page_sizes_reg_addr_byte2 = 8417810;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_sup_page_sizes_reg_addr_byte3 = 8417811;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_bar0_reg_addr_byte0 = 29208;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_bar1_reg_addr_byte0 = 29212;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_bar2_reg_addr_byte0 = 29216;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_bar3_reg_addr_byte0 = 29220;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_bar4_reg_addr_byte0 = 29224;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_bar5_reg_addr_byte0 = 29228;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_device_id_reg_addr_byte2 = 8417806;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_cap_vf_device_id_reg_addr_byte3 = 8417807;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_initial_vfs_ari_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_initial_vfs_nonari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar0_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar1_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar1_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar1_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar1_type = "pf7_sriov_vf_bar1_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar2_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar3_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar3_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar3_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar3_type = "pf7_sriov_vf_bar3_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar4_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar5_dummy_mask_7_1 = 127;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar5_enabled = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar5_start = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_sriov_vf_bar5_type = "pf7_sriov_vf_bar5_mem32";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_ext_cap_hdr_reg_addr_byte2 = 8417846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_ext_cap_hdr_reg_addr_byte3 = 8417847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_addr_byte0 = 8417848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_addr_byte1 = 8417849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_addr_byte2 = 8417850;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_addr_byte3 = 8417851;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte0 = 10515000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte1 = 10515001;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte2 = 10515002;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_cap_tph_req_cap_reg_vfcomm_cs2_addr_byte3 = 10515003;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_reg_rsvdp_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_reg_rsvdp_27 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_reg_rsvdp_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_reg_vfcomm_cs2_rsvdp_11_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_reg_vfcomm_cs2_rsvdp_27_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_reg_vfcomm_cs2_rsvdp_3_vfcomm_cs2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_st_table_loc_0 = "pf7_not_in_tph_struct";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_cap_ver = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_extended_tph = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_extended_tph_vfcomm_cs2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_next_ptr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_no_st_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_tph_req_no_st_mode_vfcomm_cs2 = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar0_mask_reg_addr_byte0 = 2125840;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar0_mask_reg_addr_byte1 = 2125841;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar0_mask_reg_addr_byte2 = 2125842;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar0_mask_reg_addr_byte3 = 2125843;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar0_reg_addr_byte0 = 28688;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar1_enable_reg_addr_byte0 = 2125844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar1_mask_reg_addr_byte0 = 2125844;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar1_mask_reg_addr_byte1 = 2125845;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar1_mask_reg_addr_byte2 = 2125846;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar1_mask_reg_addr_byte3 = 2125847;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar1_reg_addr_byte0 = 28692;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar2_mask_reg_addr_byte0 = 2125848;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar2_mask_reg_addr_byte1 = 2125849;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar2_mask_reg_addr_byte2 = 2125850;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar2_mask_reg_addr_byte3 = 2125851;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar2_reg_addr_byte0 = 28696;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar3_enable_reg_addr_byte0 = 2125852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar3_mask_reg_addr_byte0 = 2125852;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar3_mask_reg_addr_byte1 = 2125853;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar3_mask_reg_addr_byte2 = 2125854;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar3_mask_reg_addr_byte3 = 2125855;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar3_reg_addr_byte0 = 28700;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar4_mask_reg_addr_byte0 = 2125856;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar4_mask_reg_addr_byte1 = 2125857;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar4_mask_reg_addr_byte2 = 2125858;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar4_mask_reg_addr_byte3 = 2125859;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar4_reg_addr_byte0 = 28704;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar5_enable_reg_addr_byte0 = 2125860;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar5_mask_reg_addr_byte0 = 2125860;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar5_mask_reg_addr_byte1 = 2125861;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar5_mask_reg_addr_byte2 = 2125862;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar5_mask_reg_addr_byte3 = 2125863;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bar5_reg_addr_byte0 = 28708;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_bist_header_type_latency_cache_line_size_reg_addr_byte2 = 8417294;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte0 = 8417320;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte1 = 8417321;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte2 = 8417322;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_cardbus_cis_ptr_reg_addr_byte3 = 8417323;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_class_code_revision_id_addr_byte0 = 8417288;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_class_code_revision_id_addr_byte1 = 8417289;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_class_code_revision_id_addr_byte2 = 8417290;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_class_code_revision_id_addr_byte3 = 8417291;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte0 = 8417280;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte1 = 8417281;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte2 = 8417282;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_device_id_vendor_id_reg_addr_byte3 = 8417283;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte0 = 2125872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte1 = 2125873;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte2 = 2125874;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_exp_rom_bar_mask_reg_addr_byte3 = 2125875;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_exp_rom_base_addr_reg_addr_byte0 = 28720;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_max_latency_min_grant_interrupt_pin_interrupt_line_reg_addr_byte1 = 8417341;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_pci_cap_ptr_reg_addr_byte0 = 8417332;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte0 = 8417324;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte1 = 8417325;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte2 = 8417326;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_type0_hdr_subsystem_id_subsystem_vendor_id_reg_addr_byte3 = 8417327;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vf_bar0_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vf_bar1_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vf_bar2_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vf_bar3_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vf_bar4_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vf_bar5_reg_rsvdp_0 = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vsecras_cap_rasdp_ext_hdr_off_addr_byte2 = 8418302;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vsecras_cap_rasdp_ext_hdr_off_addr_byte3 = 8418303;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vsecras_cap_version = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pf7_vsecras_next_offset = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pld_clk_dis = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pld_tx_fifo_dyn_empty_dis = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__pldif_fifo_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__rstctl_timer_a = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__rstctl_timer_b = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__rxbuf_limit_init = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__rxbuf_pfull_th = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__sriov_clk_en = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_cdts_rst = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_fifo_empty_threshold_1 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_fifo_empty_threshold_2 = 12;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_fifo_empty_threshold_3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_fifo_empty_threshold_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__tx_fifo_full_threshold = 40;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__user_mode_del_count = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__vf = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_ip_port_num = "pcie_port1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_margin_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_pl16g_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf0_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf1_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf2_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf3_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf4_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf5_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf6_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_exvf_aricap_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_pb_cap_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_pf7_sriov_num_vf_ari = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_ptm_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_tlp_bypass_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__virtual_txeq_mode = "eq_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_core8__wait_pld_warm_rst_rdy = "false";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_bitsync_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_clk_gate_en_attr = "dfd_ctrl_ctop_clk_gate_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_clock_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_data_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_rst_n_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_stream0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_stream1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_stream2_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_stream3_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_ctrl_ctop_trig_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__dfd_status_ctop_e_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__ecc_ctrl_ecc_spare_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__mailbox_in_msg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__mailbox_in_send_msg_attr = "mailbox_in_send_msg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__mailbox_out_msg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__mailbox_out_new_msg_attr = "mailbox_out_new_msg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_lane_x16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_lane_x4_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_lane_x4_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_lane_x8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_spare_x16_attr = "pctrl_spare_x16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_spare_x4_0_attr = "pctrl_spare_x4_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_spare_x4_1_attr = "pctrl_spare_x4_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__pctrl_spare_x8_attr = "pctrl_spare_x8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_arb_sel_k_hrc_arb_sel_ip4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_bypass_irq_status_attr = "r_hrc_bypass_irq_status_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_dfd_sel_k_hrc_dfd_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_irq_mask_k_hrc_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_perst_ctrl_k_hrc_perst_hi_filt_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_perst_ctrl_k_hrc_perst_lo_filt_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_pll_ctrl_k_hrc_cpll_lock_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_pll_ctrl_k_hrc_cpll_reset_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_pll_time_ctrl_k_hrc_cpll_post_rls_quiet_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_pll_time_ctrl_k_hrc_cpll_post_rst_quiet_time_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_cpll_ena_warm_reset_attr = "r_hrc_rst_ctrl_k_hrc_cpll_ena_warm_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_rst_ctrl_k_hrc_dis_chk_cpll_lock_attr = "r_hrc_rst_ctrl_k_hrc_dis_chk_cpll_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_byp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw16_perstn_disable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw40_perstn_disable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw41_perstn_disable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_dw8_perstn_disable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__r_hrc_top_ctrl_k_hrc_topology_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_clk_gate_en_attr = "sctrl_clk_gate_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_pll_mux_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_x16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_x4_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_x4_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sctrl_x8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__ub_ctrltop__topology = "disabled_system";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_dwip_x16_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_dwip_x4_0_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_dwip_x4_1_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_dwip_x8_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_port_type = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_sris_enable = "disable_sris";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_sup_mode = "user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ctop__virtual_tlp_bypass_en = "disable_tlpbp";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_d7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u4_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u4_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u4_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u4_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u4_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u5_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u5_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u5_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u5_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u5_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u6_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u6_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u6_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u6_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u6_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u7_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u7_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u7_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u7_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__i_ft_u7_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d0_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d0_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d0_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d0_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d0_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d1_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d1_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d1_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d1_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d1_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d2_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d2_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d2_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d2_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d2_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d3_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d3_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d3_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d3_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d3_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d4_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d4_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d4_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d4_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d4_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d5_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d5_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d5_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d5_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d5_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d6_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d6_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d6_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d6_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d6_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d7_pma_internal_clk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d7_pma_internal_clk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d7_standalonecoreclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d7_xcvr_quad_refclk1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_d7_xcvr_quad_refclk2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u0_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u1_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u2_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u3_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u4_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u5_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u6_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__o_ft_u7_sclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_cfg_clk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_core_x16_l0_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_core_x4_l12_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_core_x4_l4_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_core_x8_l8_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma0_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma0_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma0_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma0_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma0_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma10_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma10_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma10_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma10_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma10_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma11_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma11_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma11_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma11_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma11_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma12_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma12_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma12_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma12_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma12_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma13_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma13_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma13_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma13_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma13_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma14_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma14_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma14_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma14_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma14_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma15_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma15_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma15_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma15_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma15_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma1_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma1_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma1_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma1_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma1_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma2_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma2_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma2_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma2_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma2_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma3_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma3_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma3_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma3_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma3_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma4_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma4_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma4_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma4_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma4_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma5_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma5_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma5_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma5_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma5_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma6_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma6_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma6_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma6_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma6_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma7_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma7_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma7_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma7_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma7_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma8_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma8_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma8_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma8_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma8_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma9_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma9_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma9_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma9_syntha_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__pcie_ptop_pma9_synthb_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_ac = "pciemode_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_ac_global_avmm = "global_avmm_on";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_dc = "powerup_dc";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_global_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe0_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe10_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe11_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe12_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe13_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe14_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe15_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe1_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe2_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe3_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe4_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe5_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe6_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe7_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe8_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__powermode_freq_hz_pcie_ptop_pipe9_pclk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__topology = "disabled_system";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane0__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane10__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane11__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane12__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane13__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane14__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane15__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane1__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane2__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane3__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane4__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane5__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane6__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane7__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane8__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__dctrl_dfd_bsync_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__dctrl_dfd_datasel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__dctrl_dfd_power_off_attr = "dctrl_dfd_power_off_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__dctrl_dfd_primary_attr = "dctrl_dfd_primary_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__dctrl_dfd_secondary_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__lctrl_lane_mode_ctrl_attr = "lctrl_lane_mode_pcie_disable";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__lctrl_lane_mode_sel_attr = "lctrl_lane_mode_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_lowpin_nt_attr = "pctrl_lowpin_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_pclkchangeack_attr = "pctrl_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_phy_mode_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_rxelecidle_disable_a_attr = "pctrl_rxelecidle_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_rxeqclr_attr = "pctrl_rxeqclr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_rxeqtraining_attr = "pctrl_rxeqtraining_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_rxtermination_attr = "pctrl_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_txcmnmode_disable_a_attr = "pctrl_txcmnmode_disable_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_pcslane9__pctrl_txoneszeros_attr = "pctrl_txoneszeros_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane0__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane10__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane11__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane12__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane13__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane14__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane15__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane1__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane2__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane3__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane4__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane5__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane6__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane7__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane8__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie2_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_10_cfg_vpcsebuf_ptrdiff_half_pcie3_sris_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_half_usb2_attr = 17;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_11_cfg_vpcsebuf_ptrdiff_max_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_11_cfg_vpcsenc_force_neg_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_force_pos_disp_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsenc_tx_force_err_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsif_idle_cntr_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ignore_pclk_rate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsif_min_txidle_cntr_max_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr = "ux_pcs_lane_q0_reg_12_cfg_vpcsif_ovr_blockaligncontrol_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_min_reset_cntr_max_attr = 1000;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_chng_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_ebuf_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_encodedecodebypass_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_getlocalpresetcoefficients_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_localpresetindex_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_lowpin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_m2p_bus_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclk_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr = "ux_pcs_lane_q0_reg_13_cfg_vpcsif_ovr_pclkchangeack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_m2p_bus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_pclkchangeack_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_phy_mode_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_powerdown_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rate_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rst_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxelecidle_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxeqeval_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpolarity_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr = "ux_pcs_lane_q0_reg_14_cfg_vpcsif_ovr_rxpresethint_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxpresethint_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxstandby_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_rxtermination_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_srisenable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcmnmode_disable_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txcompliance_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr = "ux_pcs_lane_q0_reg_15_cfg_vpcsif_ovr_txdeemph_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txdtctrx_lb_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txelecidle_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txmargin_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txoneszeros_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_txswing_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_ovr_width_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subentry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p1subexit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2entry_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatus_p2exit_1cycle_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_phystatusgen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_pma_rx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxdetect_inpciep2_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxpstate_p0s_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr = "ux_pcs_lane_q0_reg_16_cfg_vpcsif_rxstandby0en_in_rxeq_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_rx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_17_cfg_vpcsif_pma_tx_pcie2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_pcie5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsif_pma_tx_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcslb_fe_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcslfps_ctrl_p3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_rd_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_c_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr = "ux_pcs_lane_q0_reg_18_cfg_vpcsmbusconv_illegal_wr_uc_addr_det_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_rd_compl_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_gen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timeout_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr = "ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_19_cfg_vpcsmbusconv_wr_ack_timer_max_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr = "ux_pcs_lane_q0_reg_1_cfg_vcpsckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcs_if_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcs_lfps_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_lock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcsalign10b_unlock_cnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcsalign128b_usb2_ctrl_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr = "ux_pcs_lane_q0_reg_1_cfg_vpcsbist_chk_hold_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_one_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_20_cfg_vpcsonezero_zero_cntr_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_22_cfg_vpcstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_22_cfg_vpcstx_gen4_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_22_cfg_vpcstxdrv_txdrvslew_gen1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_23_cfg_vpcstx_gen4_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localfs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_23_cfg_vpcstx_localg4fs_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txdeemph_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr = "ux_pcs_lane_q0_reg_23_cfg_vpcstxdrv_usb_gen1_txswing_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_24_cfg_vpcstx_gen4_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_24_cfg_vpcstx_localg4lf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_24_cfg_vpcstx_locallf_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_25_cfg_vpcstx_gen4_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_25_cfg_vpcstxdrv_levn_gen1_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_26_cfg_vpcstx_gen4_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_26_cfg_vpcstxdrv_levn_gen1_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_27_cfg_vpcstx_gen4_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_27_cfg_vpcstxdrv_levn_gen1_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_28_cfg_vpcstx_gen4_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_28_cfg_vpcstxdrv_levn_gen1_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_29_cfg_vpcstx_gen4_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_29_cfg_vpcstxdrv_levn_gen1_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_2_cfg_vpcs_misc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_30_cfg_vpcstx_gen4_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_30_cfg_vpcstxdrv_levn_gen1_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_31_cfg_vpcstx_gen4_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_31_cfg_vpcstxdrv_levn_gen1_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_32_cfg_vpcstx_gen4_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_32_cfg_vpcstxdrv_levn_gen1_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_33_cfg_vpcstx_preset0_attr = 60032;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_0_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_33_cfg_vpcstxdrv_levn_gen2_1_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_34_cfg_vpcstx_preset1_attr = 39872;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_10_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_34_cfg_vpcstxdrv_levn_gen2_11_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_35_cfg_vpcstx_preset10_attr = 80192;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_12_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_35_cfg_vpcstxdrv_levn_gen2_13_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_36_cfg_vpcstx_preset2_attr = 51968;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_14_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_36_cfg_vpcstxdrv_levn_gen2_15_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_37_cfg_vpcstx_preset3_attr = 31808;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_2_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_37_cfg_vpcstxdrv_levn_gen2_3_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_38_cfg_vpcstx_preset4_attr = 3584;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_38_cfg_vpcstxdrv_levn_gen2_5_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_39_cfg_vpcstx_preset5_attr = 3206;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_6_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_39_cfg_vpcstxdrv_levn_gen2_7_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_40_cfg_vpcstx_preset6_attr = 3080;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_8_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_40_cfg_vpcstxdrv_levn_gen2_9_attr = 47;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_41_cfg_vpcstx_preset7_attr = 47558;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_levnm1_gen1_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_41_cfg_vpcstxdrv_txdrvslew_gen2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_42_cfg_vpcstx_preset8_attr = 31367;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_levnm1_gen1_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_42_cfg_vpcstxdrv_txdrvslew_gen3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_43_cfg_vpcstx_preset9_attr = 3017;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_levnm1_gen1_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_43_cfg_vpcstxdrv_txdrvslew_gen4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_44_cfg_vpcstxdrv_levnm1_gen1_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen1_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_0_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_45_cfg_vpcstxdrv_levnm1_gen2_1_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_10_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_11_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_12_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_13_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_14_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_46_cfg_vpcstxdrv_levnm1_gen2_15_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_47_cfg_vpcstxdrv_levnm1_gen2_7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_8_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_48_cfg_vpcstxdrv_levnm1_gen2_9_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr = "ux_pcs_lane_q0_reg_4_cfg_vpcsalign128b_g3g4_skp_os_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_data_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_init_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_insert_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsbist_gen_skp_cnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_g3g4_err_dec_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcsebuf_reset_on_err_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr = "ux_pcs_lane_q0_reg_5_cfg_vpcseios_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_6_cfg_vpcsbist_gen_skp_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_6_cfg_vpcsebuf_ptradj_pcie2_sris_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_7_cfg_vpcsbist_udp_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_8_cfg_vpcsbist_udp_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_pcie3_sris_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptradj_usb2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_9_cfg_vpcsebuf_ptrctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__ub_uxlane9__ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr = "ux_pcs_lane_q0_reg_9_cfg_vpcsif_blockaligncontrolpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_dwip_x16_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_dwip_x4_0_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_dwip_x4_1_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_dwip_x8_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_port_type = "ep";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_sris_enable = "disable_sris";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__u_ptop__virtual_tlp_bypass_en = "disable_tlbp";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq0pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq0pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq0pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq0pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq0pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq0pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq10pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq10pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq10pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq10pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq10pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq10pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq11pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq11pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq11pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq11pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq11pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq11pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq12pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq12pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq12pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq12pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq12pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq12pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq13pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq13pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq13pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq13pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq13pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq13pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq14pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq14pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq14pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq14pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq14pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq14pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq15pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq15pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq15pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq15pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq15pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq15pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq1pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq1pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq1pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq1pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq1pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq1pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq2pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq2pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq2pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq2pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq2pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq2pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq3pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq3pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq3pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq3pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq3pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq3pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq4pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq4pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq4pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq4pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq4pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq4pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq5pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq5pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq5pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq5pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq5pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq5pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq6pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq6pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq6pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq6pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq6pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq6pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq7pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq7pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq7pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq7pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq7pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq7pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq8pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq8pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq8pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq8pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq8pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq8pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq9pma_cmn_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq9pma_ctrl_l_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq9pma_pclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq9pma_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq9pma_rxclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__uxq9pma_txclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_cfg_func_mode = "pcie_g4_x16";
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_dwip_x16_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_dwip_x4_0_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_dwip_x4_1_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_pcie_ss__virtual_dwip_x8_negociated_speed = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_fastest_reconfig_refclk_global_refclk_1_hz = 800000001;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__f_top_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__cdrdiv_offchip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__clkrx_bot_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__clkrx_top_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_ch1_ch0_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_ch3_ch2_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_fastest_reconfig_refclk_global_refclk_1_hz = 800000001;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_full_quad_master_pll_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_1_bot_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_1_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_2_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_3_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_1_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_regional_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_top_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__f_top_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_0_bot_control = "global_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_0_bot_power_mode = "global_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_0_top_control = "global_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_0_top_power_mode = "global_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_1_bot_control = "global_refclk_1_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_1_bot_power_mode = "global_refclk_1_bot_power_mode_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_1_top_control = "global_refclk_1_top_control_enable_l2r_r2t";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_1_top_power_mode = "global_refclk_1_top_power_mode_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_2_bot_control = "global_refclk_2_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_2_bot_power_mode = "global_refclk_2_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_2_top_control = "global_refclk_2_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_2_top_power_mode = "global_refclk_2_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_3_bot_control = "global_refclk_3_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_3_bot_power_mode = "global_refclk_3_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_3_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_3_top_control = "global_refclk_3_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__global_refclk_3_top_power_mode = "global_refclk_3_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__local_clock_line_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_global_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_global_refclk_1_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_global_refclk_2_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_global_refclk_3_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_regional_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__quad_regional_refclk_1_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_0_bot_control = "regional_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_0_bot_power_mode = "regional_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_0_top_control = "regional_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_0_top_power_mode = "regional_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_1_bot_control = "regional_refclk_1_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_1_bot_power_mode = "regional_refclk_1_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_1_top_control = "regional_refclk_1_top_control_enable_p2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__regional_refclk_1_top_power_mode = "regional_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_fw_loader_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_fw_loader_cfg_fw_loader_en_attr = "scmng_fw_loader_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_fw_loader_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_fw_loader_cfg_single_mode_en_attr = "scmng_fw_loader_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_ahb_non_posted_write_attr = "scmng_pm_cfg_ahb_non_posted_write_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_an_done_lane0_attr = "scmng_pm_cfg_an_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_an_done_lane1_attr = "scmng_pm_cfg_an_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_an_done_lane2_attr = "scmng_pm_cfg_an_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_an_done_lane3_attr = "scmng_pm_cfg_an_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_apb_broadcast_feature_en_attr = "scmng_pm_cfg_apb_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_apb_broadcast_type_attr = "scmng_pm_cfg_apb_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_apb_security_check_en_attr = "scmng_pm_cfg_apb_security_check_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cfg_top_head_visactl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cfg_top_head_visactl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cfg_top_head_visactl2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cfg_top_head_visactl3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cfg_top_head_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cpi_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cpi_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_cpi_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_ecc_double_attr = "scmng_pm_cfg_ecc_double_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_error_l0_attr = "scmng_pm_cfg_error_l0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_error_l1_attr = "scmng_pm_cfg_error_l1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_error_l2_attr = "scmng_pm_cfg_error_l2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_error_l3_attr = "scmng_pm_cfg_error_l3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_link_mng_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_link_mng_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_one_bit_error_corrected_attr = "scmng_pm_cfg_one_bit_error_corrected_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_phy_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_phy_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_phy_owner_cpi_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_rx_ready_lane0_attr = "scmng_pm_cfg_rx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_rx_ready_lane1_attr = "scmng_pm_cfg_rx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_rx_ready_lane2_attr = "scmng_pm_cfg_rx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_rx_ready_lane3_attr = "scmng_pm_cfg_rx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_sw_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_trn_done_lane0_attr = "scmng_pm_cfg_trn_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_trn_done_lane1_attr = "scmng_pm_cfg_trn_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_trn_done_lane2_attr = "scmng_pm_cfg_trn_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_trn_done_lane3_attr = "scmng_pm_cfg_trn_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_tx_ready_lane0_attr = "scmng_pm_cfg_tx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_tx_ready_lane1_attr = "scmng_pm_cfg_tx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_tx_ready_lane2_attr = "scmng_pm_cfg_tx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_tx_ready_lane3_attr = "scmng_pm_cfg_tx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_visa_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_visa_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__scmng_pm_cfg_visa_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_top_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_top_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_bti_div_rst_attr = "serdes_ip_cmn_l0_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_req_attr = "serdes_ip_cmn_l0_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l0_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_start_attr = "serdes_ip_cmn_l0_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l0_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_bti_div_rst_attr = "serdes_ip_cmn_l1_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_req_attr = "serdes_ip_cmn_l1_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l1_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_start_attr = "serdes_ip_cmn_l1_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l1_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_bti_div_rst_attr = "serdes_ip_cmn_l2_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_req_attr = "serdes_ip_cmn_l2_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l2_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_start_attr = "serdes_ip_cmn_l2_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l2_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_bti_div_rst_attr = "serdes_ip_cmn_l3_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_req_attr = "serdes_ip_cmn_l3_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l3_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_start_attr = "serdes_ip_cmn_l3_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l3_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_en_attr = "serdes_ip_lane_aon_l0_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_req_attr = "serdes_ip_lane_aon_l0_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_en_attr = "serdes_ip_lane_aon_l1_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_req_attr = "serdes_ip_lane_aon_l1_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_en_attr = "serdes_ip_lane_aon_l2_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_req_attr = "serdes_ip_lane_aon_l2_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_en_attr = "serdes_ip_lane_aon_l3_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_req_attr = "serdes_ip_lane_aon_l3_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_bshihyst_attr = "serdes_ip_lane_l0_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l0_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l0_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_continuous_attr = "serdes_ip_lane_l0_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_en_attr = "serdes_ip_lane_l0_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_start_attr = "serdes_ip_lane_l0_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l0_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_en_attr = "serdes_ip_lane_l0_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_locovren_attr = "serdes_ip_lane_l0_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l0_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lfps_locovren_attr = "serdes_ip_lane_l0_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_lfps_out_en_attr = "serdes_ip_lane_l0_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l0_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_pcstx_locovren_attr = "serdes_ip_lane_l0_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_polarity_rx_attr = "serdes_ip_lane_l0_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_polarity_tx_attr = "serdes_ip_lane_l0_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_pg_disable_attr = "serdes_ip_lane_l0_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxadc_req_attr = "serdes_ip_lane_l0_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbias_locovren_attr = "serdes_ip_lane_l0_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_err_en_attr = "serdes_ip_lane_l0_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxbshicm_attr = "serdes_ip_lane_l0_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxclk_locovren_attr = "serdes_ip_lane_l0_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdata_locovren_attr = "serdes_ip_lane_l0_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_en_attr = "serdes_ip_lane_l0_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_locovren_attr = "serdes_ip_lane_l0_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpam_locovren_attr = "serdes_ip_lane_l0_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxphd_locovren_attr = "serdes_ip_lane_l0_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_locovren_attr = "serdes_ip_lane_l0_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l0_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l0_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_locovren_attr = "serdes_ip_lane_l0_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_polarity_attr = "serdes_ip_lane_l0_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l0_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l0_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trancntout_locovren_attr = "serdes_ip_lane_l0_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_trandetout_locovren_attr = "serdes_ip_lane_l0_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l0_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_pg_disable_attr = "serdes_ip_lane_l0_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txadc_req_attr = "serdes_ip_lane_l0_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbeacon_sel_attr = "serdes_ip_lane_l0_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbias_locovren_attr = "serdes_ip_lane_l0_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l0_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_locovren_attr = "serdes_ip_lane_l0_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbti_data_replication_attr = "serdes_ip_lane_l0_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcal_locovren_attr = "serdes_ip_lane_l0_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txclk_locovren_attr = "serdes_ip_lane_l0_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_locovren_attr = "serdes_ip_lane_l0_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_refcken_attr = "serdes_ip_lane_l0_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrv_termref_attr = "serdes_ip_lane_l0_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l0_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_en_attr = "serdes_ip_lane_l0_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_locovren_attr = "serdes_ip_lane_l0_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpam_locovren_attr = "serdes_ip_lane_l0_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpcs_locovren_attr = "serdes_ip_lane_l0_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txresetdel_sel_attr = "serdes_ip_lane_l0_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_en_b_attr = "serdes_ip_lane_l0_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_en_attr = "serdes_ip_lane_l0_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l0_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_bshihyst_attr = "serdes_ip_lane_l1_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l1_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l1_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_continuous_attr = "serdes_ip_lane_l1_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_en_attr = "serdes_ip_lane_l1_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_start_attr = "serdes_ip_lane_l1_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l1_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_en_attr = "serdes_ip_lane_l1_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_locovren_attr = "serdes_ip_lane_l1_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l1_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lfps_locovren_attr = "serdes_ip_lane_l1_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_lfps_out_en_attr = "serdes_ip_lane_l1_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l1_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_pcstx_locovren_attr = "serdes_ip_lane_l1_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_polarity_rx_attr = "serdes_ip_lane_l1_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_polarity_tx_attr = "serdes_ip_lane_l1_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_pg_disable_attr = "serdes_ip_lane_l1_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxadc_req_attr = "serdes_ip_lane_l1_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbias_locovren_attr = "serdes_ip_lane_l1_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_err_en_attr = "serdes_ip_lane_l1_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxbshicm_attr = "serdes_ip_lane_l1_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxclk_locovren_attr = "serdes_ip_lane_l1_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdata_locovren_attr = "serdes_ip_lane_l1_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_en_attr = "serdes_ip_lane_l1_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_locovren_attr = "serdes_ip_lane_l1_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpam_locovren_attr = "serdes_ip_lane_l1_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxphd_locovren_attr = "serdes_ip_lane_l1_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_locovren_attr = "serdes_ip_lane_l1_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l1_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l1_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_locovren_attr = "serdes_ip_lane_l1_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_polarity_attr = "serdes_ip_lane_l1_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l1_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l1_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trancntout_locovren_attr = "serdes_ip_lane_l1_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_trandetout_locovren_attr = "serdes_ip_lane_l1_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l1_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_pg_disable_attr = "serdes_ip_lane_l1_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txadc_req_attr = "serdes_ip_lane_l1_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbeacon_sel_attr = "serdes_ip_lane_l1_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbias_locovren_attr = "serdes_ip_lane_l1_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l1_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_locovren_attr = "serdes_ip_lane_l1_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbti_data_replication_attr = "serdes_ip_lane_l1_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcal_locovren_attr = "serdes_ip_lane_l1_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txclk_locovren_attr = "serdes_ip_lane_l1_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_locovren_attr = "serdes_ip_lane_l1_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_refcken_attr = "serdes_ip_lane_l1_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrv_termref_attr = "serdes_ip_lane_l1_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l1_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_en_attr = "serdes_ip_lane_l1_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_locovren_attr = "serdes_ip_lane_l1_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpam_locovren_attr = "serdes_ip_lane_l1_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpcs_locovren_attr = "serdes_ip_lane_l1_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txresetdel_sel_attr = "serdes_ip_lane_l1_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_en_b_attr = "serdes_ip_lane_l1_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_en_attr = "serdes_ip_lane_l1_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l1_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_bshihyst_attr = "serdes_ip_lane_l2_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l2_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l2_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_continuous_attr = "serdes_ip_lane_l2_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_en_attr = "serdes_ip_lane_l2_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_start_attr = "serdes_ip_lane_l2_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l2_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_en_attr = "serdes_ip_lane_l2_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_locovren_attr = "serdes_ip_lane_l2_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l2_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lfps_locovren_attr = "serdes_ip_lane_l2_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_lfps_out_en_attr = "serdes_ip_lane_l2_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l2_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_pcstx_locovren_attr = "serdes_ip_lane_l2_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_polarity_rx_attr = "serdes_ip_lane_l2_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_polarity_tx_attr = "serdes_ip_lane_l2_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_pg_disable_attr = "serdes_ip_lane_l2_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxadc_req_attr = "serdes_ip_lane_l2_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbias_locovren_attr = "serdes_ip_lane_l2_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_err_en_attr = "serdes_ip_lane_l2_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxbshicm_attr = "serdes_ip_lane_l2_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxclk_locovren_attr = "serdes_ip_lane_l2_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdata_locovren_attr = "serdes_ip_lane_l2_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_en_attr = "serdes_ip_lane_l2_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_locovren_attr = "serdes_ip_lane_l2_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpam_locovren_attr = "serdes_ip_lane_l2_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxphd_locovren_attr = "serdes_ip_lane_l2_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_locovren_attr = "serdes_ip_lane_l2_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l2_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l2_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_locovren_attr = "serdes_ip_lane_l2_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_polarity_attr = "serdes_ip_lane_l2_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l2_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l2_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trancntout_locovren_attr = "serdes_ip_lane_l2_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_trandetout_locovren_attr = "serdes_ip_lane_l2_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l2_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_pg_disable_attr = "serdes_ip_lane_l2_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txadc_req_attr = "serdes_ip_lane_l2_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbeacon_sel_attr = "serdes_ip_lane_l2_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbias_locovren_attr = "serdes_ip_lane_l2_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l2_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_locovren_attr = "serdes_ip_lane_l2_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbti_data_replication_attr = "serdes_ip_lane_l2_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcal_locovren_attr = "serdes_ip_lane_l2_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txclk_locovren_attr = "serdes_ip_lane_l2_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_locovren_attr = "serdes_ip_lane_l2_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_refcken_attr = "serdes_ip_lane_l2_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrv_termref_attr = "serdes_ip_lane_l2_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l2_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_en_attr = "serdes_ip_lane_l2_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_locovren_attr = "serdes_ip_lane_l2_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpam_locovren_attr = "serdes_ip_lane_l2_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpcs_locovren_attr = "serdes_ip_lane_l2_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txresetdel_sel_attr = "serdes_ip_lane_l2_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_en_b_attr = "serdes_ip_lane_l2_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_en_attr = "serdes_ip_lane_l2_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l2_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_bshihyst_attr = "serdes_ip_lane_l3_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l3_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l3_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_continuous_attr = "serdes_ip_lane_l3_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_en_attr = "serdes_ip_lane_l3_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_start_attr = "serdes_ip_lane_l3_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l3_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_en_attr = "serdes_ip_lane_l3_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_locovren_attr = "serdes_ip_lane_l3_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l3_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lfps_locovren_attr = "serdes_ip_lane_l3_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_lfps_out_en_attr = "serdes_ip_lane_l3_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l3_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_pcstx_locovren_attr = "serdes_ip_lane_l3_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_polarity_rx_attr = "serdes_ip_lane_l3_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_polarity_tx_attr = "serdes_ip_lane_l3_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_pg_disable_attr = "serdes_ip_lane_l3_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxadc_req_attr = "serdes_ip_lane_l3_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbias_locovren_attr = "serdes_ip_lane_l3_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_err_en_attr = "serdes_ip_lane_l3_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxbshicm_attr = "serdes_ip_lane_l3_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxclk_locovren_attr = "serdes_ip_lane_l3_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdata_locovren_attr = "serdes_ip_lane_l3_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_en_attr = "serdes_ip_lane_l3_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_locovren_attr = "serdes_ip_lane_l3_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpam_locovren_attr = "serdes_ip_lane_l3_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxphd_locovren_attr = "serdes_ip_lane_l3_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_locovren_attr = "serdes_ip_lane_l3_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l3_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l3_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_locovren_attr = "serdes_ip_lane_l3_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_polarity_attr = "serdes_ip_lane_l3_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l3_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l3_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trancntout_locovren_attr = "serdes_ip_lane_l3_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_trandetout_locovren_attr = "serdes_ip_lane_l3_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l3_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_pg_disable_attr = "serdes_ip_lane_l3_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txadc_req_attr = "serdes_ip_lane_l3_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbeacon_sel_attr = "serdes_ip_lane_l3_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbias_locovren_attr = "serdes_ip_lane_l3_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l3_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_locovren_attr = "serdes_ip_lane_l3_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbti_data_replication_attr = "serdes_ip_lane_l3_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcal_locovren_attr = "serdes_ip_lane_l3_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txclk_locovren_attr = "serdes_ip_lane_l3_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_locovren_attr = "serdes_ip_lane_l3_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_refcken_attr = "serdes_ip_lane_l3_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrv_termref_attr = "serdes_ip_lane_l3_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l3_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_en_attr = "serdes_ip_lane_l3_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_locovren_attr = "serdes_ip_lane_l3_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpam_locovren_attr = "serdes_ip_lane_l3_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpcs_locovren_attr = "serdes_ip_lane_l3_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txresetdel_sel_attr = "serdes_ip_lane_l3_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_en_b_attr = "serdes_ip_lane_l3_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_en_attr = "serdes_ip_lane_l3_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_l3_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_dig_cdr_disable_attr = "serdes_shim_an_l0_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_direct_control_bus_en_attr = "serdes_shim_an_l0_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_edge_too_long_disable_attr = "serdes_shim_an_l0_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_edge_too_short_disable_attr = "serdes_shim_an_l0_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_page_max_timer_disable_attr = "serdes_shim_an_l0_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_page_min_timer_disable_attr = "serdes_shim_an_l0_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_pcs_lock_attr = "serdes_shim_an_l0_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_enable_m_attr = "serdes_shim_an_l0_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_lcw_re_attr = "serdes_shim_an_l0_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_pma_en_attr = "serdes_shim_an_l0_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_complete_ack_attr = "serdes_shim_an_l0_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_enable_m_attr = "serdes_shim_an_l0_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_lcw_we_attr = "serdes_shim_an_l0_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l0_cfg_tx_pma_en_attr = "serdes_shim_an_l0_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_dig_cdr_disable_attr = "serdes_shim_an_l1_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_direct_control_bus_en_attr = "serdes_shim_an_l1_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_edge_too_long_disable_attr = "serdes_shim_an_l1_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_edge_too_short_disable_attr = "serdes_shim_an_l1_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_page_max_timer_disable_attr = "serdes_shim_an_l1_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_page_min_timer_disable_attr = "serdes_shim_an_l1_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_pcs_lock_attr = "serdes_shim_an_l1_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_enable_m_attr = "serdes_shim_an_l1_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_lcw_re_attr = "serdes_shim_an_l1_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_pma_en_attr = "serdes_shim_an_l1_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_complete_ack_attr = "serdes_shim_an_l1_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_enable_m_attr = "serdes_shim_an_l1_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_lcw_we_attr = "serdes_shim_an_l1_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l1_cfg_tx_pma_en_attr = "serdes_shim_an_l1_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_dig_cdr_disable_attr = "serdes_shim_an_l2_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_direct_control_bus_en_attr = "serdes_shim_an_l2_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_edge_too_long_disable_attr = "serdes_shim_an_l2_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_edge_too_short_disable_attr = "serdes_shim_an_l2_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_page_max_timer_disable_attr = "serdes_shim_an_l2_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_page_min_timer_disable_attr = "serdes_shim_an_l2_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_pcs_lock_attr = "serdes_shim_an_l2_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_enable_m_attr = "serdes_shim_an_l2_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_lcw_re_attr = "serdes_shim_an_l2_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_pma_en_attr = "serdes_shim_an_l2_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_complete_ack_attr = "serdes_shim_an_l2_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_enable_m_attr = "serdes_shim_an_l2_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_lcw_we_attr = "serdes_shim_an_l2_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l2_cfg_tx_pma_en_attr = "serdes_shim_an_l2_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_dig_cdr_disable_attr = "serdes_shim_an_l3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_direct_control_bus_en_attr = "serdes_shim_an_l3_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_edge_too_long_disable_attr = "serdes_shim_an_l3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_edge_too_short_disable_attr = "serdes_shim_an_l3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_page_max_timer_disable_attr = "serdes_shim_an_l3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_page_min_timer_disable_attr = "serdes_shim_an_l3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_pcs_lock_attr = "serdes_shim_an_l3_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_enable_m_attr = "serdes_shim_an_l3_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_lcw_re_attr = "serdes_shim_an_l3_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_pma_en_attr = "serdes_shim_an_l3_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_complete_ack_attr = "serdes_shim_an_l3_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_enable_m_attr = "serdes_shim_an_l3_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_lcw_we_attr = "serdes_shim_an_l3_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_an_l3_cfg_tx_pma_en_attr = "serdes_shim_an_l3_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l0_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_en_attr = "serdes_shim_car_l0_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_val_attr = "serdes_shim_car_l0_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_timer_en_attr = "serdes_shim_car_l0_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l0_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l1_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_en_attr = "serdes_shim_car_l1_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_val_attr = "serdes_shim_car_l1_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_timer_en_attr = "serdes_shim_car_l1_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l1_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l2_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_en_attr = "serdes_shim_car_l2_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_val_attr = "serdes_shim_car_l2_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_timer_en_attr = "serdes_shim_car_l2_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l2_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l3_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_en_attr = "serdes_shim_car_l3_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_val_attr = "serdes_shim_car_l3_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_timer_en_attr = "serdes_shim_car_l3_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_car_l3_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_atresetn_attr = "serdes_shim_cpu_pm_cfg_cpu_atresetn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakin_attr = "serdes_shim_cpu_pm_cfg_cpu_breakin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr = "serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr = "serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr = "serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_prid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr = "serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr = "serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_dram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_trace_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_fifo_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram5_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram6_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_trace_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_trace_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fw_status_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_fw_version_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_iramh_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_iraml_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_nmi_icu_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tb_reg0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tb_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tb_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tb_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tb_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tie_queue_pwr_mgmt_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_cpu_pm_cfg_tram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_en_attr = "serdes_shim_dsp_l0_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l0_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_en_attr = "serdes_shim_dsp_l0_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_d_sign_attr = "serdes_shim_dsp_l0_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_en_attr = "serdes_shim_dsp_l0_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_event_sign_attr = "serdes_shim_dsp_l0_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_bb_stable_attr = "serdes_shim_dsp_l0_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_en_attr = "serdes_shim_dsp_l0_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l0_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_error_counter_clr_attr = "serdes_shim_dsp_l0_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_error_counter_enable_attr = "serdes_shim_dsp_l0_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l0_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_fine_attr = "serdes_shim_dsp_l0_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_en_attr = "serdes_shim_dsp_l0_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l0_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l0_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_en_attr = "serdes_shim_dsp_l0_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_pam_4_en_attr = "serdes_shim_dsp_l0_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_pol_invert_attr = "serdes_shim_dsp_l0_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_power_save_en_attr = "serdes_shim_dsp_l0_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_en_attr = "serdes_shim_dsp_l0_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_snr_meter_en_attr = "serdes_shim_dsp_l0_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_swap_bot_en_attr = "serdes_shim_dsp_l0_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_swap_top_en_attr = "serdes_shim_dsp_l0_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l0_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_en_attr = "serdes_shim_dsp_l0_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_en_attr = "serdes_shim_dsp_l0_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l0_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_x3_en_attr = "serdes_shim_dsp_l0_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l0_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_en_attr = "serdes_shim_dsp_l1_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l1_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_en_attr = "serdes_shim_dsp_l1_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_d_sign_attr = "serdes_shim_dsp_l1_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_en_attr = "serdes_shim_dsp_l1_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_event_sign_attr = "serdes_shim_dsp_l1_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_bb_stable_attr = "serdes_shim_dsp_l1_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_en_attr = "serdes_shim_dsp_l1_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l1_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_error_counter_clr_attr = "serdes_shim_dsp_l1_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_error_counter_enable_attr = "serdes_shim_dsp_l1_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l1_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_fine_attr = "serdes_shim_dsp_l1_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_en_attr = "serdes_shim_dsp_l1_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l1_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l1_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_en_attr = "serdes_shim_dsp_l1_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_pam_4_en_attr = "serdes_shim_dsp_l1_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_pol_invert_attr = "serdes_shim_dsp_l1_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_power_save_en_attr = "serdes_shim_dsp_l1_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_en_attr = "serdes_shim_dsp_l1_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_snr_meter_en_attr = "serdes_shim_dsp_l1_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_swap_bot_en_attr = "serdes_shim_dsp_l1_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_swap_top_en_attr = "serdes_shim_dsp_l1_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l1_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_en_attr = "serdes_shim_dsp_l1_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_en_attr = "serdes_shim_dsp_l1_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l1_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_x3_en_attr = "serdes_shim_dsp_l1_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l1_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_en_attr = "serdes_shim_dsp_l2_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l2_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_en_attr = "serdes_shim_dsp_l2_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_d_sign_attr = "serdes_shim_dsp_l2_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_en_attr = "serdes_shim_dsp_l2_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_event_sign_attr = "serdes_shim_dsp_l2_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_bb_stable_attr = "serdes_shim_dsp_l2_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_en_attr = "serdes_shim_dsp_l2_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l2_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_error_counter_clr_attr = "serdes_shim_dsp_l2_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_error_counter_enable_attr = "serdes_shim_dsp_l2_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l2_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_fine_attr = "serdes_shim_dsp_l2_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_en_attr = "serdes_shim_dsp_l2_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l2_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l2_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_en_attr = "serdes_shim_dsp_l2_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_pam_4_en_attr = "serdes_shim_dsp_l2_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_pol_invert_attr = "serdes_shim_dsp_l2_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_power_save_en_attr = "serdes_shim_dsp_l2_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_en_attr = "serdes_shim_dsp_l2_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_snr_meter_en_attr = "serdes_shim_dsp_l2_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_swap_bot_en_attr = "serdes_shim_dsp_l2_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_swap_top_en_attr = "serdes_shim_dsp_l2_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l2_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_en_attr = "serdes_shim_dsp_l2_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_en_attr = "serdes_shim_dsp_l2_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l2_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_x3_en_attr = "serdes_shim_dsp_l2_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l2_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_en_attr = "serdes_shim_dsp_l3_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l3_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_en_attr = "serdes_shim_dsp_l3_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_d_sign_attr = "serdes_shim_dsp_l3_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_en_attr = "serdes_shim_dsp_l3_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_event_sign_attr = "serdes_shim_dsp_l3_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_bb_stable_attr = "serdes_shim_dsp_l3_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_en_attr = "serdes_shim_dsp_l3_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l3_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_error_counter_clr_attr = "serdes_shim_dsp_l3_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_error_counter_enable_attr = "serdes_shim_dsp_l3_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l3_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_fine_attr = "serdes_shim_dsp_l3_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_en_attr = "serdes_shim_dsp_l3_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l3_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l3_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_en_attr = "serdes_shim_dsp_l3_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_pam_4_en_attr = "serdes_shim_dsp_l3_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_pol_invert_attr = "serdes_shim_dsp_l3_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_power_save_en_attr = "serdes_shim_dsp_l3_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_en_attr = "serdes_shim_dsp_l3_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_snr_meter_en_attr = "serdes_shim_dsp_l3_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_swap_bot_en_attr = "serdes_shim_dsp_l3_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_swap_top_en_attr = "serdes_shim_dsp_l3_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l3_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_en_attr = "serdes_shim_dsp_l3_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_en_attr = "serdes_shim_dsp_l3_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l3_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_x3_en_attr = "serdes_shim_dsp_l3_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_dsp_l3_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l0_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l0_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_send_data_attr = "serdes_shim_tfl_l0_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l0_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l1_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l1_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_send_data_attr = "serdes_shim_tfl_l1_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l1_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l2_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l2_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_send_data_attr = "serdes_shim_tfl_l2_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l2_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l3_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l3_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_send_data_attr = "serdes_shim_tfl_l3_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_tfl_l3_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_broadcast_feature_en_attr = "serdes_shim_top_cfg_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_broadcast_type_attr = "serdes_shim_top_cfg_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_datawidth_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_en_attr = "serdes_shim_top_cfg_fec_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_mask8_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_packet_sel_attr = "serdes_shim_top_cfg_fec_ber_packet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_poly_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_rs_type_sel_attr = "serdes_shim_top_cfg_fec_ber_rs_type_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_fec_ber_statistic_en_attr = "serdes_shim_top_cfg_fec_ber_statistic_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_wdt_clr_attr = "serdes_shim_top_cfg_wdt_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_wdt_en_attr = "serdes_shim_top_cfg_wdt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_wdt_pre_scale_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr = "serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_wdt_swrst_en_attr = "serdes_shim_top_cfg_wdt_swrst_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_top_cfg_wdt_time_val_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_clkrx_ref_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr = "serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_cpu_clk_sel_attr = "serdes_shim_wrap_car_cfg_cpu_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_cpu_clken_attr = "serdes_shim_wrap_car_cfg_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_cpu_runstall_attr = "serdes_shim_wrap_car_cfg_cpu_runstall_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr = "serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_val_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fast_clk_lane_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_clken_attr = "serdes_shim_wrap_car_cfg_fb_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fb_rx_clken_attr = "serdes_shim_wrap_car_cfg_fb_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_fec_ber_lane_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__top_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__top_refclk_reconfig_span = "top_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_0_rx_synth_select = "ux0_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_0_tx_synth_select = "ux0_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_1_rx_synth_select = "ux0_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_1_tx_synth_select = "ux0_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_2_rx_synth_select = "ux0_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_2_tx_synth_select = "ux0_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_3_rx_synth_select = "ux0_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_3_tx_synth_select = "ux0_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_4_rx_synth_select = "ux0_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_4_tx_synth_select = "ux0_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_refclk_type_select = "ux0_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_refclk_type_select = "ux0_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_refclk_type_select = "ux0_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_refclk_type_select = "ux0_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_refclk_type_select = "ux0_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_core_pll_bw_sel = "ux0_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dpma_n_counter_physical = "ux0_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rx_which_lane_to_copy = "ux0_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_select_lc_0_tx_path = "ux0_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_select_lc_1_tx_path = "ux0_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_select_lc_2_tx_path = "ux0_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_select_lc_3_tx_path = "ux0_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_select_lc_4_tx_path = "ux0_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_afc_range = "ux0_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_afc_range = "ux0_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_afc_range = "ux0_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_afc_range = "ux0_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_afc_range = "ux0_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_bw_sel = "ux0_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_refclk_mux_select = "ux0_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_refclk_type_select = "ux0_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_bw_sel = "ux0_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_refclk_mux_select = "ux0_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_refclk_type_select = "ux0_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_bw_sel = "ux0_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_refclk_mux_select = "ux0_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_refclk_type_select = "ux0_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_tx_which_lane_to_copy = "ux0_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux0_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_0_rx_synth_select = "ux1_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_0_tx_synth_select = "ux1_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_1_rx_synth_select = "ux1_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_1_tx_synth_select = "ux1_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_2_rx_synth_select = "ux1_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_2_tx_synth_select = "ux1_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_3_rx_synth_select = "ux1_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_3_tx_synth_select = "ux1_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_4_rx_synth_select = "ux1_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_4_tx_synth_select = "ux1_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_refclk_type_select = "ux1_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_refclk_type_select = "ux1_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_refclk_type_select = "ux1_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_refclk_type_select = "ux1_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_refclk_type_select = "ux1_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_core_pll_bw_sel = "ux1_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dpma_n_counter_physical = "ux1_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rx_which_lane_to_copy = "ux1_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_select_lc_0_tx_path = "ux1_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_select_lc_1_tx_path = "ux1_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_select_lc_2_tx_path = "ux1_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_select_lc_3_tx_path = "ux1_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_select_lc_4_tx_path = "ux1_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_afc_range = "ux1_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_afc_range = "ux1_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_afc_range = "ux1_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_afc_range = "ux1_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_afc_range = "ux1_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_bw_sel = "ux1_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_refclk_mux_select = "ux1_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_refclk_type_select = "ux1_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_bw_sel = "ux1_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_refclk_mux_select = "ux1_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_refclk_type_select = "ux1_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_bw_sel = "ux1_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_refclk_mux_select = "ux1_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_refclk_type_select = "ux1_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_tx_which_lane_to_copy = "ux1_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux1_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_0_rx_synth_select = "ux2_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_0_tx_synth_select = "ux2_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_1_rx_synth_select = "ux2_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_1_tx_synth_select = "ux2_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_2_rx_synth_select = "ux2_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_2_tx_synth_select = "ux2_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_3_rx_synth_select = "ux2_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_3_tx_synth_select = "ux2_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_4_rx_synth_select = "ux2_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_4_tx_synth_select = "ux2_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_refclk_type_select = "ux2_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_refclk_type_select = "ux2_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_refclk_type_select = "ux2_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_refclk_type_select = "ux2_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_refclk_type_select = "ux2_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_core_pll_bw_sel = "ux2_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dpma_n_counter_physical = "ux2_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rx_which_lane_to_copy = "ux2_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_select_lc_0_tx_path = "ux2_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_select_lc_1_tx_path = "ux2_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_select_lc_2_tx_path = "ux2_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_select_lc_3_tx_path = "ux2_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_select_lc_4_tx_path = "ux2_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_afc_range = "ux2_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_afc_range = "ux2_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_afc_range = "ux2_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_afc_range = "ux2_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_afc_range = "ux2_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_bw_sel = "ux2_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_refclk_mux_select = "ux2_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_refclk_type_select = "ux2_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_bw_sel = "ux2_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_refclk_mux_select = "ux2_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_refclk_type_select = "ux2_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_bw_sel = "ux2_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_refclk_mux_select = "ux2_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_refclk_type_select = "ux2_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_tx_which_lane_to_copy = "ux2_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux2_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_0_rx_synth_select = "ux3_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_0_tx_synth_select = "ux3_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_1_rx_synth_select = "ux3_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_1_tx_synth_select = "ux3_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_2_rx_synth_select = "ux3_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_2_tx_synth_select = "ux3_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_3_rx_synth_select = "ux3_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_3_tx_synth_select = "ux3_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_4_rx_synth_select = "ux3_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_4_tx_synth_select = "ux3_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_refclk_type_select = "ux3_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_refclk_type_select = "ux3_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_refclk_type_select = "ux3_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_refclk_type_select = "ux3_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_refclk_type_select = "ux3_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_core_pll_bw_sel = "ux3_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dpma_n_counter_physical = "ux3_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rx_which_lane_to_copy = "ux3_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_select_lc_0_tx_path = "ux3_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_select_lc_1_tx_path = "ux3_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_select_lc_2_tx_path = "ux3_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_select_lc_3_tx_path = "ux3_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_select_lc_4_tx_path = "ux3_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_afc_range = "ux3_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_afc_range = "ux3_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_afc_range = "ux3_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_afc_range = "ux3_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_afc_range = "ux3_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_bw_sel = "ux3_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_refclk_mux_select = "ux3_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_refclk_type_select = "ux3_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_bw_sel = "ux3_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_refclk_mux_select = "ux3_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_refclk_type_select = "ux3_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_bw_sel = "ux3_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_refclk_mux_select = "ux3_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_refclk_type_select = "ux3_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_tx_which_lane_to_copy = "ux3_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux3_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux_quad_instance = "ux_quad_instance_zero";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__flux_top__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_cpi_cmn2_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_cpi_lm_addr = 589884;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_cpi_phy_addr = 589888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_cpi_reserved = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_cpi_seq_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_cpi_timer_max = 500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_end_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_flux_cpu_freq = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l0_attr = "bonding_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l1_attr = "bonding_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l2_attr = "bonding_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l3_attr = "bonding_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_cpi_seq_ctrl_cfg_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l0_attr = "lb_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l1_attr = "lb_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l2_attr = "lb_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l3_attr = "lb_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_clk_en_dfd_clk_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_extrig_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_rsvd_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_data_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_inc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_rst_b_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_apb_rdata_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_rst_dfd_extrig_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l2_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l3_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_dpma_clk_mux_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l0_attr = "e200_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l1_attr = "e200_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l2_attr = "e200_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l3_attr = "e200_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l0_attr = "e200_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l1_attr = "e200_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l2_attr = "e200_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l3_attr = "e200_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l0_attr = "e400_ckmux_slow_med_l0_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l1_attr = "e400_ckmux_slow_med_l1_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l2_attr = "e400_ckmux_slow_med_l2_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l3_attr = "e400_ckmux_slow_med_l3_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l0_attr = "e400_ckmux_txuser0_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l1_attr = "e400_ckmux_txuser0_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l2_attr = "e400_ckmux_txuser0_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l3_attr = "e400_ckmux_txuser0_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l0_attr = "e400_ckmux_txuser1_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l1_attr = "e400_ckmux_txuser1_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l2_attr = "e400_ckmux_txuser1_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l3_attr = "e400_ckmux_txuser1_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l0_attr = "e400_ckmux_txuser2_l0_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l1_attr = "e400_ckmux_txuser2_l1_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l2_attr = "e400_ckmux_txuser2_l2_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l3_attr = "e400_ckmux_txuser2_l3_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l0_attr = "e400_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l1_attr = "e400_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l2_attr = "e400_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l3_attr = "e400_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l0_attr = "e400_rxusrclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l1_attr = "e400_rxusrclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l2_attr = "e400_rxusrclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l3_attr = "e400_rxusrclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l0_attr = "e400_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l1_attr = "e400_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l2_attr = "e400_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l3_attr = "e400_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l0_attr = "e400_usrclk0_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l1_attr = "e400_usrclk0_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l2_attr = "e400_usrclk0_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l3_attr = "e400_usrclk0_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l0_attr = "e400_usrclk1_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l1_attr = "e400_usrclk1_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l2_attr = "e400_usrclk1_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l3_attr = "e400_usrclk1_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l0_attr = "e400_usrclk2_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l1_attr = "e400_usrclk2_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l2_attr = "e400_usrclk2_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l3_attr = "e400_usrclk2_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l0_attr = "e_rx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l1_attr = "e_rx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l2_attr = "e_rx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l3_attr = "e_rx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l0_attr = "e_tx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l1_attr = "e_tx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l2_attr = "e_tx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l3_attr = "e_tx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l0_cfg_value_attr = 277792;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l1_cfg_value_attr = 310560;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l2_cfg_value_attr = 343328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l3_cfg_value_attr = 376096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_disable_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_mapped_base_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_unmapped_base_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l0_attr = "func_mode_e400_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l1_attr = "func_mode_e400_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l2_attr = "func_mode_e400_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l3_attr = "func_mode_e400_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l0_attr = "pcie_medclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l1_attr = "pcie_medclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l2_attr = "pcie_medclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l3_attr = "pcie_medclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l0_attr = "pcie_pclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l1_attr = "pcie_pclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l2_attr = "pcie_pclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l3_attr = "pcie_pclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l0_attr = "pcie_refclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l1_attr = "pcie_refclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l2_attr = "pcie_refclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l3_attr = "pcie_refclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l0_attr = "pcie_rxclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l1_attr = "pcie_rxclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l2_attr = "pcie_rxclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l3_attr = "pcie_rxclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l0_attr = "pcie_slowclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l1_attr = "pcie_slowclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l2_attr = "pcie_slowclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l3_attr = "pcie_slowclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_reserved0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_restart_seq_sm_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_skip_rd_seq_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_1_cfg_seqen_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_2_cfg_seqen_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_3_cfg_seq_rdwrb_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_4_cfg_seq_rdwrb_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_0_attr = 51224679;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_10_attr = 11641603;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_11_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_12_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_13_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_14_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_15_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_16_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_17_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_18_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_19_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_1_attr = 41138;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_20_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_21_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_22_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_2_attr = 134258864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_3_attr = 499727;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_4_attr = 11640835;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_5_attr = 499983;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_6_attr = 11641091;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_7_attr = 500239;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_8_attr = 11641347;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_9_attr = 500495;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_0_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_1_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_2_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_32_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_33_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_34_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_35_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_36_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_37_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_38_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_39_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_3_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_40_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_41_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_42_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_43_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_44_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_45_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_46_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_47_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_48_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_49_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_4_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_50_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_51_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_52_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_53_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_54_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_55_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_56_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_57_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_58_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_59_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_5_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_60_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_61_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_62_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_63_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_6_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_7_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_8_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_9_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_quad_instance = "ux_quad_instance_zero";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__gdr_ux_quad_avmm_cfgcsr__ux_rst_value_pre_user_mode_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_avmm = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_bot_clkrx_base = "powermode_ac_mode_bot_clkrx_base_non_pin_primary_driver_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_bot_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_flux = "powermode_ac_mode_flux_flux_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_0_bot = "powermode_ac_mode_global_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_0_top = "powermode_ac_mode_global_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_1_bot = "powermode_ac_mode_global_refclk_1_bot_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_1_top = "powermode_ac_mode_global_refclk_1_top_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_2_bot = "powermode_ac_mode_global_refclk_2_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_2_top = "powermode_ac_mode_global_refclk_2_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_3_bot = "powermode_ac_mode_global_refclk_3_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_global_refclk_3_top = "powermode_ac_mode_global_refclk_3_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_regional_refclk_0_bot = "powermode_ac_mode_regional_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_regional_refclk_0_top = "powermode_ac_mode_regional_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_regional_refclk_1_bot = "powermode_ac_mode_regional_refclk_1_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_regional_refclk_1_top = "powermode_ac_mode_regional_refclk_1_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_fast_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_fast_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_fast_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_fast_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_med_ux0 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_med_ux1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_med_ux2 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_med_ux3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_slow_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_slow_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_slow_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_synth_lc_slow_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_top_clkrx_base = "powermode_ac_mode_top_clkrx_base_pin_to_clkrx_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_ac_mode_top_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_bot_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_bot_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_flux = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_2_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_2_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_3_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_global_refclk_3_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_regional_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_regional_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_regional_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_regional_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_rx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_fast_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_fast_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_fast_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_fast_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_med_ux0 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_med_ux1 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_med_ux2 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_med_ux3 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_slow_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_slow_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_slow_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_synth_lc_slow_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_top_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_top_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__powermode_freq_hz_tx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_0__ux_quad_instance = "ux_quad_instance_zero";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_fastest_reconfig_refclk_global_refclk_1_hz = 800000001;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__f_top_syspll_refclk_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__cdrdiv_offchip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__clkrx_bot_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__clkrx_top_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_ch1_ch0_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_ch3_ch2_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_fastest_reconfig_refclk_global_refclk_1_hz = 800000001;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_full_quad_master_pll_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_1_bot_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_1_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_2_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_3_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_1_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_regional_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_top_refclk_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__f_top_syspll_refclk_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_0_bot_control = "global_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_0_bot_power_mode = "global_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_0_top_control = "global_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_0_top_power_mode = "global_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_1_bot_control = "global_refclk_1_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_1_bot_power_mode = "global_refclk_1_bot_power_mode_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_1_right_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_1_top_control = "global_refclk_1_top_control_enable_p2l_l2b_p2r_r2t";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_1_top_power_mode = "global_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_2_bot_control = "global_refclk_2_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_2_bot_power_mode = "global_refclk_2_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_2_top_control = "global_refclk_2_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_2_top_power_mode = "global_refclk_2_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_3_bot_control = "global_refclk_3_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_3_bot_power_mode = "global_refclk_3_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_3_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_3_top_control = "global_refclk_3_top_control_enable_l2r_r2t";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__global_refclk_3_top_power_mode = "global_refclk_3_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__local_clock_line_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_global_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_global_refclk_1_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_global_refclk_2_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_global_refclk_3_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_regional_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__quad_regional_refclk_1_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_0_bot_control = "regional_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_0_bot_power_mode = "regional_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_0_top_control = "regional_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_0_top_power_mode = "regional_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_1_bot_control = "regional_refclk_1_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_1_bot_power_mode = "regional_refclk_1_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_1_top_control = "regional_refclk_1_top_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__regional_refclk_1_top_power_mode = "regional_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_fw_loader_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_fw_loader_cfg_fw_loader_en_attr = "scmng_fw_loader_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_fw_loader_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_fw_loader_cfg_single_mode_en_attr = "scmng_fw_loader_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_ahb_non_posted_write_attr = "scmng_pm_cfg_ahb_non_posted_write_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_an_done_lane0_attr = "scmng_pm_cfg_an_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_an_done_lane1_attr = "scmng_pm_cfg_an_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_an_done_lane2_attr = "scmng_pm_cfg_an_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_an_done_lane3_attr = "scmng_pm_cfg_an_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_apb_broadcast_feature_en_attr = "scmng_pm_cfg_apb_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_apb_broadcast_type_attr = "scmng_pm_cfg_apb_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_apb_security_check_en_attr = "scmng_pm_cfg_apb_security_check_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cfg_top_head_visactl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cfg_top_head_visactl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cfg_top_head_visactl2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cfg_top_head_visactl3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cfg_top_head_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cpi_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cpi_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_cpi_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_ecc_double_attr = "scmng_pm_cfg_ecc_double_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_error_l0_attr = "scmng_pm_cfg_error_l0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_error_l1_attr = "scmng_pm_cfg_error_l1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_error_l2_attr = "scmng_pm_cfg_error_l2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_error_l3_attr = "scmng_pm_cfg_error_l3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_link_mng_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_link_mng_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_one_bit_error_corrected_attr = "scmng_pm_cfg_one_bit_error_corrected_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_phy_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_phy_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_phy_owner_cpi_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_rx_ready_lane0_attr = "scmng_pm_cfg_rx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_rx_ready_lane1_attr = "scmng_pm_cfg_rx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_rx_ready_lane2_attr = "scmng_pm_cfg_rx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_rx_ready_lane3_attr = "scmng_pm_cfg_rx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_sw_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_trn_done_lane0_attr = "scmng_pm_cfg_trn_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_trn_done_lane1_attr = "scmng_pm_cfg_trn_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_trn_done_lane2_attr = "scmng_pm_cfg_trn_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_trn_done_lane3_attr = "scmng_pm_cfg_trn_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_tx_ready_lane0_attr = "scmng_pm_cfg_tx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_tx_ready_lane1_attr = "scmng_pm_cfg_tx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_tx_ready_lane2_attr = "scmng_pm_cfg_tx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_tx_ready_lane3_attr = "scmng_pm_cfg_tx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_visa_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_visa_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__scmng_pm_cfg_visa_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_top_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_top_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_bti_div_rst_attr = "serdes_ip_cmn_l0_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_req_attr = "serdes_ip_cmn_l0_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l0_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_start_attr = "serdes_ip_cmn_l0_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l0_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_bti_div_rst_attr = "serdes_ip_cmn_l1_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_req_attr = "serdes_ip_cmn_l1_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l1_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_start_attr = "serdes_ip_cmn_l1_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l1_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_bti_div_rst_attr = "serdes_ip_cmn_l2_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_req_attr = "serdes_ip_cmn_l2_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l2_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_start_attr = "serdes_ip_cmn_l2_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l2_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_bti_div_rst_attr = "serdes_ip_cmn_l3_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_req_attr = "serdes_ip_cmn_l3_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l3_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_start_attr = "serdes_ip_cmn_l3_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l3_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_en_attr = "serdes_ip_lane_aon_l0_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_req_attr = "serdes_ip_lane_aon_l0_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_en_attr = "serdes_ip_lane_aon_l1_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_req_attr = "serdes_ip_lane_aon_l1_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_en_attr = "serdes_ip_lane_aon_l2_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_req_attr = "serdes_ip_lane_aon_l2_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_en_attr = "serdes_ip_lane_aon_l3_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_req_attr = "serdes_ip_lane_aon_l3_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_bshihyst_attr = "serdes_ip_lane_l0_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l0_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l0_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_continuous_attr = "serdes_ip_lane_l0_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_en_attr = "serdes_ip_lane_l0_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_start_attr = "serdes_ip_lane_l0_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l0_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_en_attr = "serdes_ip_lane_l0_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_locovren_attr = "serdes_ip_lane_l0_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l0_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lfps_locovren_attr = "serdes_ip_lane_l0_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_lfps_out_en_attr = "serdes_ip_lane_l0_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l0_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_pcstx_locovren_attr = "serdes_ip_lane_l0_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_polarity_rx_attr = "serdes_ip_lane_l0_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_polarity_tx_attr = "serdes_ip_lane_l0_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_pg_disable_attr = "serdes_ip_lane_l0_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxadc_req_attr = "serdes_ip_lane_l0_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbias_locovren_attr = "serdes_ip_lane_l0_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_err_en_attr = "serdes_ip_lane_l0_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxbshicm_attr = "serdes_ip_lane_l0_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxclk_locovren_attr = "serdes_ip_lane_l0_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdata_locovren_attr = "serdes_ip_lane_l0_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_en_attr = "serdes_ip_lane_l0_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_locovren_attr = "serdes_ip_lane_l0_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpam_locovren_attr = "serdes_ip_lane_l0_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxphd_locovren_attr = "serdes_ip_lane_l0_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_locovren_attr = "serdes_ip_lane_l0_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l0_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l0_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_locovren_attr = "serdes_ip_lane_l0_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_polarity_attr = "serdes_ip_lane_l0_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l0_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l0_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trancntout_locovren_attr = "serdes_ip_lane_l0_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_trandetout_locovren_attr = "serdes_ip_lane_l0_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l0_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_pg_disable_attr = "serdes_ip_lane_l0_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txadc_req_attr = "serdes_ip_lane_l0_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbeacon_sel_attr = "serdes_ip_lane_l0_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbias_locovren_attr = "serdes_ip_lane_l0_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l0_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_locovren_attr = "serdes_ip_lane_l0_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbti_data_replication_attr = "serdes_ip_lane_l0_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcal_locovren_attr = "serdes_ip_lane_l0_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txclk_locovren_attr = "serdes_ip_lane_l0_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_locovren_attr = "serdes_ip_lane_l0_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_refcken_attr = "serdes_ip_lane_l0_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrv_termref_attr = "serdes_ip_lane_l0_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l0_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_en_attr = "serdes_ip_lane_l0_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_locovren_attr = "serdes_ip_lane_l0_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpam_locovren_attr = "serdes_ip_lane_l0_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpcs_locovren_attr = "serdes_ip_lane_l0_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txresetdel_sel_attr = "serdes_ip_lane_l0_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_en_b_attr = "serdes_ip_lane_l0_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_en_attr = "serdes_ip_lane_l0_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l0_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_bshihyst_attr = "serdes_ip_lane_l1_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l1_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l1_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_continuous_attr = "serdes_ip_lane_l1_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_en_attr = "serdes_ip_lane_l1_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_start_attr = "serdes_ip_lane_l1_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l1_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_en_attr = "serdes_ip_lane_l1_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_locovren_attr = "serdes_ip_lane_l1_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l1_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lfps_locovren_attr = "serdes_ip_lane_l1_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_lfps_out_en_attr = "serdes_ip_lane_l1_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l1_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_pcstx_locovren_attr = "serdes_ip_lane_l1_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_polarity_rx_attr = "serdes_ip_lane_l1_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_polarity_tx_attr = "serdes_ip_lane_l1_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_pg_disable_attr = "serdes_ip_lane_l1_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxadc_req_attr = "serdes_ip_lane_l1_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbias_locovren_attr = "serdes_ip_lane_l1_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_err_en_attr = "serdes_ip_lane_l1_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxbshicm_attr = "serdes_ip_lane_l1_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxclk_locovren_attr = "serdes_ip_lane_l1_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdata_locovren_attr = "serdes_ip_lane_l1_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_en_attr = "serdes_ip_lane_l1_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_locovren_attr = "serdes_ip_lane_l1_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpam_locovren_attr = "serdes_ip_lane_l1_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxphd_locovren_attr = "serdes_ip_lane_l1_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_locovren_attr = "serdes_ip_lane_l1_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l1_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l1_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_locovren_attr = "serdes_ip_lane_l1_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_polarity_attr = "serdes_ip_lane_l1_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l1_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l1_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trancntout_locovren_attr = "serdes_ip_lane_l1_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_trandetout_locovren_attr = "serdes_ip_lane_l1_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l1_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_pg_disable_attr = "serdes_ip_lane_l1_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txadc_req_attr = "serdes_ip_lane_l1_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbeacon_sel_attr = "serdes_ip_lane_l1_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbias_locovren_attr = "serdes_ip_lane_l1_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l1_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_locovren_attr = "serdes_ip_lane_l1_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbti_data_replication_attr = "serdes_ip_lane_l1_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcal_locovren_attr = "serdes_ip_lane_l1_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txclk_locovren_attr = "serdes_ip_lane_l1_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_locovren_attr = "serdes_ip_lane_l1_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_refcken_attr = "serdes_ip_lane_l1_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrv_termref_attr = "serdes_ip_lane_l1_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l1_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_en_attr = "serdes_ip_lane_l1_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_locovren_attr = "serdes_ip_lane_l1_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpam_locovren_attr = "serdes_ip_lane_l1_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpcs_locovren_attr = "serdes_ip_lane_l1_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txresetdel_sel_attr = "serdes_ip_lane_l1_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_en_b_attr = "serdes_ip_lane_l1_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_en_attr = "serdes_ip_lane_l1_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l1_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_bshihyst_attr = "serdes_ip_lane_l2_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l2_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l2_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_continuous_attr = "serdes_ip_lane_l2_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_en_attr = "serdes_ip_lane_l2_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_start_attr = "serdes_ip_lane_l2_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l2_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_en_attr = "serdes_ip_lane_l2_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_locovren_attr = "serdes_ip_lane_l2_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l2_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lfps_locovren_attr = "serdes_ip_lane_l2_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_lfps_out_en_attr = "serdes_ip_lane_l2_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l2_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_pcstx_locovren_attr = "serdes_ip_lane_l2_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_polarity_rx_attr = "serdes_ip_lane_l2_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_polarity_tx_attr = "serdes_ip_lane_l2_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_pg_disable_attr = "serdes_ip_lane_l2_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxadc_req_attr = "serdes_ip_lane_l2_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbias_locovren_attr = "serdes_ip_lane_l2_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_err_en_attr = "serdes_ip_lane_l2_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxbshicm_attr = "serdes_ip_lane_l2_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxclk_locovren_attr = "serdes_ip_lane_l2_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdata_locovren_attr = "serdes_ip_lane_l2_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_en_attr = "serdes_ip_lane_l2_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_locovren_attr = "serdes_ip_lane_l2_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpam_locovren_attr = "serdes_ip_lane_l2_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxphd_locovren_attr = "serdes_ip_lane_l2_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_locovren_attr = "serdes_ip_lane_l2_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l2_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l2_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_locovren_attr = "serdes_ip_lane_l2_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_polarity_attr = "serdes_ip_lane_l2_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l2_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l2_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trancntout_locovren_attr = "serdes_ip_lane_l2_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_trandetout_locovren_attr = "serdes_ip_lane_l2_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l2_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_pg_disable_attr = "serdes_ip_lane_l2_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txadc_req_attr = "serdes_ip_lane_l2_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbeacon_sel_attr = "serdes_ip_lane_l2_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbias_locovren_attr = "serdes_ip_lane_l2_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l2_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_locovren_attr = "serdes_ip_lane_l2_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbti_data_replication_attr = "serdes_ip_lane_l2_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcal_locovren_attr = "serdes_ip_lane_l2_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txclk_locovren_attr = "serdes_ip_lane_l2_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_locovren_attr = "serdes_ip_lane_l2_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_refcken_attr = "serdes_ip_lane_l2_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrv_termref_attr = "serdes_ip_lane_l2_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l2_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_en_attr = "serdes_ip_lane_l2_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_locovren_attr = "serdes_ip_lane_l2_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpam_locovren_attr = "serdes_ip_lane_l2_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpcs_locovren_attr = "serdes_ip_lane_l2_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txresetdel_sel_attr = "serdes_ip_lane_l2_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_en_b_attr = "serdes_ip_lane_l2_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_en_attr = "serdes_ip_lane_l2_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l2_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_bshihyst_attr = "serdes_ip_lane_l3_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l3_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l3_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_continuous_attr = "serdes_ip_lane_l3_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_en_attr = "serdes_ip_lane_l3_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_start_attr = "serdes_ip_lane_l3_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l3_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_en_attr = "serdes_ip_lane_l3_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_locovren_attr = "serdes_ip_lane_l3_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l3_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lfps_locovren_attr = "serdes_ip_lane_l3_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_lfps_out_en_attr = "serdes_ip_lane_l3_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l3_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_pcstx_locovren_attr = "serdes_ip_lane_l3_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_polarity_rx_attr = "serdes_ip_lane_l3_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_polarity_tx_attr = "serdes_ip_lane_l3_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_pg_disable_attr = "serdes_ip_lane_l3_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxadc_req_attr = "serdes_ip_lane_l3_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbias_locovren_attr = "serdes_ip_lane_l3_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_err_en_attr = "serdes_ip_lane_l3_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxbshicm_attr = "serdes_ip_lane_l3_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxclk_locovren_attr = "serdes_ip_lane_l3_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdata_locovren_attr = "serdes_ip_lane_l3_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_en_attr = "serdes_ip_lane_l3_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_locovren_attr = "serdes_ip_lane_l3_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpam_locovren_attr = "serdes_ip_lane_l3_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxphd_locovren_attr = "serdes_ip_lane_l3_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_locovren_attr = "serdes_ip_lane_l3_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l3_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l3_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_locovren_attr = "serdes_ip_lane_l3_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_polarity_attr = "serdes_ip_lane_l3_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l3_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l3_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trancntout_locovren_attr = "serdes_ip_lane_l3_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_trandetout_locovren_attr = "serdes_ip_lane_l3_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l3_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_pg_disable_attr = "serdes_ip_lane_l3_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txadc_req_attr = "serdes_ip_lane_l3_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbeacon_sel_attr = "serdes_ip_lane_l3_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbias_locovren_attr = "serdes_ip_lane_l3_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l3_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_locovren_attr = "serdes_ip_lane_l3_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbti_data_replication_attr = "serdes_ip_lane_l3_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcal_locovren_attr = "serdes_ip_lane_l3_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txclk_locovren_attr = "serdes_ip_lane_l3_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_locovren_attr = "serdes_ip_lane_l3_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_refcken_attr = "serdes_ip_lane_l3_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrv_termref_attr = "serdes_ip_lane_l3_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l3_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_en_attr = "serdes_ip_lane_l3_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_locovren_attr = "serdes_ip_lane_l3_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpam_locovren_attr = "serdes_ip_lane_l3_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpcs_locovren_attr = "serdes_ip_lane_l3_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txresetdel_sel_attr = "serdes_ip_lane_l3_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_en_b_attr = "serdes_ip_lane_l3_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_en_attr = "serdes_ip_lane_l3_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_l3_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_dig_cdr_disable_attr = "serdes_shim_an_l0_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_direct_control_bus_en_attr = "serdes_shim_an_l0_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_edge_too_long_disable_attr = "serdes_shim_an_l0_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_edge_too_short_disable_attr = "serdes_shim_an_l0_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_page_max_timer_disable_attr = "serdes_shim_an_l0_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_page_min_timer_disable_attr = "serdes_shim_an_l0_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_pcs_lock_attr = "serdes_shim_an_l0_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_enable_m_attr = "serdes_shim_an_l0_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_lcw_re_attr = "serdes_shim_an_l0_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_pma_en_attr = "serdes_shim_an_l0_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_complete_ack_attr = "serdes_shim_an_l0_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_enable_m_attr = "serdes_shim_an_l0_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_lcw_we_attr = "serdes_shim_an_l0_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l0_cfg_tx_pma_en_attr = "serdes_shim_an_l0_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_dig_cdr_disable_attr = "serdes_shim_an_l1_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_direct_control_bus_en_attr = "serdes_shim_an_l1_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_edge_too_long_disable_attr = "serdes_shim_an_l1_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_edge_too_short_disable_attr = "serdes_shim_an_l1_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_page_max_timer_disable_attr = "serdes_shim_an_l1_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_page_min_timer_disable_attr = "serdes_shim_an_l1_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_pcs_lock_attr = "serdes_shim_an_l1_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_enable_m_attr = "serdes_shim_an_l1_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_lcw_re_attr = "serdes_shim_an_l1_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_pma_en_attr = "serdes_shim_an_l1_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_complete_ack_attr = "serdes_shim_an_l1_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_enable_m_attr = "serdes_shim_an_l1_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_lcw_we_attr = "serdes_shim_an_l1_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l1_cfg_tx_pma_en_attr = "serdes_shim_an_l1_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_dig_cdr_disable_attr = "serdes_shim_an_l2_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_direct_control_bus_en_attr = "serdes_shim_an_l2_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_edge_too_long_disable_attr = "serdes_shim_an_l2_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_edge_too_short_disable_attr = "serdes_shim_an_l2_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_page_max_timer_disable_attr = "serdes_shim_an_l2_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_page_min_timer_disable_attr = "serdes_shim_an_l2_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_pcs_lock_attr = "serdes_shim_an_l2_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_enable_m_attr = "serdes_shim_an_l2_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_lcw_re_attr = "serdes_shim_an_l2_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_pma_en_attr = "serdes_shim_an_l2_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_complete_ack_attr = "serdes_shim_an_l2_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_enable_m_attr = "serdes_shim_an_l2_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_lcw_we_attr = "serdes_shim_an_l2_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l2_cfg_tx_pma_en_attr = "serdes_shim_an_l2_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_dig_cdr_disable_attr = "serdes_shim_an_l3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_direct_control_bus_en_attr = "serdes_shim_an_l3_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_edge_too_long_disable_attr = "serdes_shim_an_l3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_edge_too_short_disable_attr = "serdes_shim_an_l3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_page_max_timer_disable_attr = "serdes_shim_an_l3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_page_min_timer_disable_attr = "serdes_shim_an_l3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_pcs_lock_attr = "serdes_shim_an_l3_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_enable_m_attr = "serdes_shim_an_l3_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_lcw_re_attr = "serdes_shim_an_l3_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_pma_en_attr = "serdes_shim_an_l3_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_complete_ack_attr = "serdes_shim_an_l3_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_enable_m_attr = "serdes_shim_an_l3_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_lcw_we_attr = "serdes_shim_an_l3_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_an_l3_cfg_tx_pma_en_attr = "serdes_shim_an_l3_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l0_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_en_attr = "serdes_shim_car_l0_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_val_attr = "serdes_shim_car_l0_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_timer_en_attr = "serdes_shim_car_l0_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l0_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l1_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_en_attr = "serdes_shim_car_l1_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_val_attr = "serdes_shim_car_l1_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_timer_en_attr = "serdes_shim_car_l1_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l1_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l2_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_en_attr = "serdes_shim_car_l2_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_val_attr = "serdes_shim_car_l2_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_timer_en_attr = "serdes_shim_car_l2_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l2_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l3_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_en_attr = "serdes_shim_car_l3_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_val_attr = "serdes_shim_car_l3_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_timer_en_attr = "serdes_shim_car_l3_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_car_l3_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_atresetn_attr = "serdes_shim_cpu_pm_cfg_cpu_atresetn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakin_attr = "serdes_shim_cpu_pm_cfg_cpu_breakin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr = "serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr = "serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr = "serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_prid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr = "serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr = "serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_dram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_trace_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_fifo_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram5_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram6_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_trace_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_trace_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fw_status_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_fw_version_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_iramh_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_iraml_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_nmi_icu_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tb_reg0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tb_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tb_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tb_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tb_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tie_queue_pwr_mgmt_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_cpu_pm_cfg_tram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_en_attr = "serdes_shim_dsp_l0_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l0_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_en_attr = "serdes_shim_dsp_l0_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_d_sign_attr = "serdes_shim_dsp_l0_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_en_attr = "serdes_shim_dsp_l0_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_event_sign_attr = "serdes_shim_dsp_l0_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_bb_stable_attr = "serdes_shim_dsp_l0_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_en_attr = "serdes_shim_dsp_l0_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l0_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_error_counter_clr_attr = "serdes_shim_dsp_l0_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_error_counter_enable_attr = "serdes_shim_dsp_l0_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l0_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_fine_attr = "serdes_shim_dsp_l0_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_en_attr = "serdes_shim_dsp_l0_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l0_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l0_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_en_attr = "serdes_shim_dsp_l0_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_pam_4_en_attr = "serdes_shim_dsp_l0_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_pol_invert_attr = "serdes_shim_dsp_l0_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_power_save_en_attr = "serdes_shim_dsp_l0_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_en_attr = "serdes_shim_dsp_l0_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_snr_meter_en_attr = "serdes_shim_dsp_l0_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_swap_bot_en_attr = "serdes_shim_dsp_l0_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_swap_top_en_attr = "serdes_shim_dsp_l0_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l0_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_en_attr = "serdes_shim_dsp_l0_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_en_attr = "serdes_shim_dsp_l0_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l0_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_x3_en_attr = "serdes_shim_dsp_l0_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l0_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_en_attr = "serdes_shim_dsp_l1_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l1_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_en_attr = "serdes_shim_dsp_l1_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_d_sign_attr = "serdes_shim_dsp_l1_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_en_attr = "serdes_shim_dsp_l1_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_event_sign_attr = "serdes_shim_dsp_l1_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_bb_stable_attr = "serdes_shim_dsp_l1_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_en_attr = "serdes_shim_dsp_l1_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l1_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_error_counter_clr_attr = "serdes_shim_dsp_l1_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_error_counter_enable_attr = "serdes_shim_dsp_l1_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l1_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_fine_attr = "serdes_shim_dsp_l1_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_en_attr = "serdes_shim_dsp_l1_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l1_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l1_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_en_attr = "serdes_shim_dsp_l1_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_pam_4_en_attr = "serdes_shim_dsp_l1_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_pol_invert_attr = "serdes_shim_dsp_l1_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_power_save_en_attr = "serdes_shim_dsp_l1_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_en_attr = "serdes_shim_dsp_l1_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_snr_meter_en_attr = "serdes_shim_dsp_l1_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_swap_bot_en_attr = "serdes_shim_dsp_l1_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_swap_top_en_attr = "serdes_shim_dsp_l1_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l1_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_en_attr = "serdes_shim_dsp_l1_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_en_attr = "serdes_shim_dsp_l1_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l1_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_x3_en_attr = "serdes_shim_dsp_l1_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l1_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_en_attr = "serdes_shim_dsp_l2_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l2_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_en_attr = "serdes_shim_dsp_l2_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_d_sign_attr = "serdes_shim_dsp_l2_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_en_attr = "serdes_shim_dsp_l2_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_event_sign_attr = "serdes_shim_dsp_l2_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_bb_stable_attr = "serdes_shim_dsp_l2_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_en_attr = "serdes_shim_dsp_l2_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l2_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_error_counter_clr_attr = "serdes_shim_dsp_l2_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_error_counter_enable_attr = "serdes_shim_dsp_l2_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l2_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_fine_attr = "serdes_shim_dsp_l2_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_en_attr = "serdes_shim_dsp_l2_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l2_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l2_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_en_attr = "serdes_shim_dsp_l2_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_pam_4_en_attr = "serdes_shim_dsp_l2_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_pol_invert_attr = "serdes_shim_dsp_l2_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_power_save_en_attr = "serdes_shim_dsp_l2_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_en_attr = "serdes_shim_dsp_l2_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_snr_meter_en_attr = "serdes_shim_dsp_l2_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_swap_bot_en_attr = "serdes_shim_dsp_l2_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_swap_top_en_attr = "serdes_shim_dsp_l2_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l2_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_en_attr = "serdes_shim_dsp_l2_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_en_attr = "serdes_shim_dsp_l2_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l2_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_x3_en_attr = "serdes_shim_dsp_l2_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l2_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_en_attr = "serdes_shim_dsp_l3_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l3_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_en_attr = "serdes_shim_dsp_l3_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_d_sign_attr = "serdes_shim_dsp_l3_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_en_attr = "serdes_shim_dsp_l3_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_event_sign_attr = "serdes_shim_dsp_l3_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_bb_stable_attr = "serdes_shim_dsp_l3_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_en_attr = "serdes_shim_dsp_l3_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l3_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_error_counter_clr_attr = "serdes_shim_dsp_l3_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_error_counter_enable_attr = "serdes_shim_dsp_l3_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l3_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_fine_attr = "serdes_shim_dsp_l3_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_en_attr = "serdes_shim_dsp_l3_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l3_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l3_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_en_attr = "serdes_shim_dsp_l3_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_pam_4_en_attr = "serdes_shim_dsp_l3_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_pol_invert_attr = "serdes_shim_dsp_l3_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_power_save_en_attr = "serdes_shim_dsp_l3_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_en_attr = "serdes_shim_dsp_l3_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_snr_meter_en_attr = "serdes_shim_dsp_l3_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_swap_bot_en_attr = "serdes_shim_dsp_l3_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_swap_top_en_attr = "serdes_shim_dsp_l3_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l3_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_en_attr = "serdes_shim_dsp_l3_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_en_attr = "serdes_shim_dsp_l3_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l3_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_x3_en_attr = "serdes_shim_dsp_l3_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_dsp_l3_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l0_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l0_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_send_data_attr = "serdes_shim_tfl_l0_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l0_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l1_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l1_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_send_data_attr = "serdes_shim_tfl_l1_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l1_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l2_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l2_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_send_data_attr = "serdes_shim_tfl_l2_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l2_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l3_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l3_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_send_data_attr = "serdes_shim_tfl_l3_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_tfl_l3_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_broadcast_feature_en_attr = "serdes_shim_top_cfg_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_broadcast_type_attr = "serdes_shim_top_cfg_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_datawidth_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_en_attr = "serdes_shim_top_cfg_fec_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_mask8_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_packet_sel_attr = "serdes_shim_top_cfg_fec_ber_packet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_poly_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_rs_type_sel_attr = "serdes_shim_top_cfg_fec_ber_rs_type_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_fec_ber_statistic_en_attr = "serdes_shim_top_cfg_fec_ber_statistic_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_wdt_clr_attr = "serdes_shim_top_cfg_wdt_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_wdt_en_attr = "serdes_shim_top_cfg_wdt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_wdt_pre_scale_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr = "serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_wdt_swrst_en_attr = "serdes_shim_top_cfg_wdt_swrst_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_top_cfg_wdt_time_val_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_clkrx_ref_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr = "serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_cpu_clk_sel_attr = "serdes_shim_wrap_car_cfg_cpu_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_cpu_clken_attr = "serdes_shim_wrap_car_cfg_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_cpu_runstall_attr = "serdes_shim_wrap_car_cfg_cpu_runstall_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr = "serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_val_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fast_clk_lane_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_clken_attr = "serdes_shim_wrap_car_cfg_fb_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fb_rx_clken_attr = "serdes_shim_wrap_car_cfg_fb_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_fec_ber_lane_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__top_f_fastest_reconfig_refclk_hz = 800000001;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__top_refclk_reconfig_span = "top_refclk_reconfig_span_one_right";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_0_rx_synth_select = "ux0_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_0_tx_synth_select = "ux0_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_1_rx_synth_select = "ux0_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_1_tx_synth_select = "ux0_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_2_rx_synth_select = "ux0_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_2_tx_synth_select = "ux0_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_3_rx_synth_select = "ux0_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_3_tx_synth_select = "ux0_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_4_rx_synth_select = "ux0_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_4_tx_synth_select = "ux0_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_refclk_type_select = "ux0_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_refclk_type_select = "ux0_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_refclk_type_select = "ux0_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_refclk_type_select = "ux0_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_refclk_type_select = "ux0_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_core_pll_bw_sel = "ux0_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dpma_n_counter_physical = "ux0_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rx_which_lane_to_copy = "ux0_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_select_lc_0_tx_path = "ux0_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_select_lc_1_tx_path = "ux0_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_select_lc_2_tx_path = "ux0_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_select_lc_3_tx_path = "ux0_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_select_lc_4_tx_path = "ux0_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_afc_range = "ux0_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_afc_range = "ux0_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_afc_range = "ux0_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_afc_range = "ux0_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_afc_range = "ux0_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_bw_sel = "ux0_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_refclk_mux_select = "ux0_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_refclk_type_select = "ux0_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_bw_sel = "ux0_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_refclk_mux_select = "ux0_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_refclk_type_select = "ux0_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_bw_sel = "ux0_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_refclk_mux_select = "ux0_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_refclk_type_select = "ux0_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_tx_which_lane_to_copy = "ux0_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux0_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_0_rx_synth_select = "ux1_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_0_tx_synth_select = "ux1_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_1_rx_synth_select = "ux1_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_1_tx_synth_select = "ux1_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_2_rx_synth_select = "ux1_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_2_tx_synth_select = "ux1_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_3_rx_synth_select = "ux1_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_3_tx_synth_select = "ux1_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_4_rx_synth_select = "ux1_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_4_tx_synth_select = "ux1_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_refclk_type_select = "ux1_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_refclk_type_select = "ux1_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_refclk_type_select = "ux1_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_refclk_type_select = "ux1_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_refclk_type_select = "ux1_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_core_pll_bw_sel = "ux1_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dpma_n_counter_physical = "ux1_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rx_which_lane_to_copy = "ux1_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_select_lc_0_tx_path = "ux1_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_select_lc_1_tx_path = "ux1_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_select_lc_2_tx_path = "ux1_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_select_lc_3_tx_path = "ux1_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_select_lc_4_tx_path = "ux1_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_afc_range = "ux1_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_afc_range = "ux1_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_afc_range = "ux1_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_afc_range = "ux1_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_afc_range = "ux1_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_bw_sel = "ux1_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_refclk_mux_select = "ux1_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_refclk_type_select = "ux1_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_bw_sel = "ux1_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_refclk_mux_select = "ux1_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_refclk_type_select = "ux1_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_bw_sel = "ux1_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_refclk_mux_select = "ux1_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_refclk_type_select = "ux1_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_tx_which_lane_to_copy = "ux1_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux1_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_0_rx_synth_select = "ux2_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_0_tx_synth_select = "ux2_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_1_rx_synth_select = "ux2_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_1_tx_synth_select = "ux2_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_2_rx_synth_select = "ux2_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_2_tx_synth_select = "ux2_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_3_rx_synth_select = "ux2_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_3_tx_synth_select = "ux2_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_4_rx_synth_select = "ux2_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_4_tx_synth_select = "ux2_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_refclk_type_select = "ux2_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_refclk_type_select = "ux2_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_refclk_type_select = "ux2_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_refclk_type_select = "ux2_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_refclk_type_select = "ux2_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_core_pll_bw_sel = "ux2_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dpma_n_counter_physical = "ux2_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rx_which_lane_to_copy = "ux2_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_select_lc_0_tx_path = "ux2_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_select_lc_1_tx_path = "ux2_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_select_lc_2_tx_path = "ux2_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_select_lc_3_tx_path = "ux2_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_select_lc_4_tx_path = "ux2_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_afc_range = "ux2_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_afc_range = "ux2_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_afc_range = "ux2_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_afc_range = "ux2_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_afc_range = "ux2_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_bw_sel = "ux2_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_refclk_mux_select = "ux2_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_refclk_type_select = "ux2_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_bw_sel = "ux2_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_refclk_mux_select = "ux2_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_refclk_type_select = "ux2_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_bw_sel = "ux2_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_refclk_mux_select = "ux2_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_refclk_type_select = "ux2_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_tx_which_lane_to_copy = "ux2_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux2_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_0_rx_synth_select = "ux3_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_0_tx_synth_select = "ux3_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_1_rx_synth_select = "ux3_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_1_tx_synth_select = "ux3_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_2_rx_synth_select = "ux3_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_2_tx_synth_select = "ux3_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_3_rx_synth_select = "ux3_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_3_tx_synth_select = "ux3_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_4_rx_synth_select = "ux3_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_4_tx_synth_select = "ux3_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_refclk_type_select = "ux3_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_refclk_type_select = "ux3_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_refclk_type_select = "ux3_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_refclk_type_select = "ux3_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_refclk_type_select = "ux3_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_core_pll_bw_sel = "ux3_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dpma_n_counter_physical = "ux3_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rx_which_lane_to_copy = "ux3_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_select_lc_0_tx_path = "ux3_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_select_lc_1_tx_path = "ux3_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_select_lc_2_tx_path = "ux3_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_select_lc_3_tx_path = "ux3_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_select_lc_4_tx_path = "ux3_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_afc_range = "ux3_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_afc_range = "ux3_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_afc_range = "ux3_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_afc_range = "ux3_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_afc_range = "ux3_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_bw_sel = "ux3_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_refclk_mux_select = "ux3_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_refclk_type_select = "ux3_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_bw_sel = "ux3_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_refclk_mux_select = "ux3_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_refclk_type_select = "ux3_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_bw_sel = "ux3_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_refclk_mux_select = "ux3_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_refclk_type_select = "ux3_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_tx_which_lane_to_copy = "ux3_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux3_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux_quad_instance = "ux_quad_instance_one";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__flux_top__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_cpi_cmn2_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_cpi_lm_addr = 589884;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_cpi_phy_addr = 589888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_cpi_reserved = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_cpi_seq_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_cpi_timer_max = 500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_end_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_flux_cpu_freq = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l0_attr = "bonding_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l1_attr = "bonding_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l2_attr = "bonding_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l3_attr = "bonding_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_cpi_seq_ctrl_cfg_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l0_attr = "lb_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l1_attr = "lb_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l2_attr = "lb_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l3_attr = "lb_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_clk_en_dfd_clk_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_extrig_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_rsvd_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_data_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_inc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_rst_b_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_apb_rdata_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_rst_dfd_extrig_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l2_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l3_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_dpma_clk_mux_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l0_attr = "e200_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l1_attr = "e200_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l2_attr = "e200_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l3_attr = "e200_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l0_attr = "e200_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l1_attr = "e200_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l2_attr = "e200_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l3_attr = "e200_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l0_attr = "e400_ckmux_slow_med_l0_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l1_attr = "e400_ckmux_slow_med_l1_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l2_attr = "e400_ckmux_slow_med_l2_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l3_attr = "e400_ckmux_slow_med_l3_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l0_attr = "e400_ckmux_txuser0_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l1_attr = "e400_ckmux_txuser0_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l2_attr = "e400_ckmux_txuser0_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l3_attr = "e400_ckmux_txuser0_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l0_attr = "e400_ckmux_txuser1_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l1_attr = "e400_ckmux_txuser1_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l2_attr = "e400_ckmux_txuser1_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l3_attr = "e400_ckmux_txuser1_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l0_attr = "e400_ckmux_txuser2_l0_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l1_attr = "e400_ckmux_txuser2_l1_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l2_attr = "e400_ckmux_txuser2_l2_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l3_attr = "e400_ckmux_txuser2_l3_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l0_attr = "e400_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l1_attr = "e400_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l2_attr = "e400_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l3_attr = "e400_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l0_attr = "e400_rxusrclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l1_attr = "e400_rxusrclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l2_attr = "e400_rxusrclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l3_attr = "e400_rxusrclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l0_attr = "e400_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l1_attr = "e400_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l2_attr = "e400_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l3_attr = "e400_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l0_attr = "e400_usrclk0_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l1_attr = "e400_usrclk0_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l2_attr = "e400_usrclk0_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l3_attr = "e400_usrclk0_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l0_attr = "e400_usrclk1_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l1_attr = "e400_usrclk1_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l2_attr = "e400_usrclk1_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l3_attr = "e400_usrclk1_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l0_attr = "e400_usrclk2_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l1_attr = "e400_usrclk2_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l2_attr = "e400_usrclk2_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l3_attr = "e400_usrclk2_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l0_attr = "e_rx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l1_attr = "e_rx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l2_attr = "e_rx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l3_attr = "e_rx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l0_attr = "e_tx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l1_attr = "e_tx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l2_attr = "e_tx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l3_attr = "e_tx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l0_cfg_value_attr = 277792;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l1_cfg_value_attr = 310560;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l2_cfg_value_attr = 343328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l3_cfg_value_attr = 376096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_disable_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_mapped_base_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_unmapped_base_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l0_attr = "func_mode_e400_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l1_attr = "func_mode_e400_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l2_attr = "func_mode_e400_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l3_attr = "func_mode_e400_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l0_attr = "pcie_medclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l1_attr = "pcie_medclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l2_attr = "pcie_medclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l3_attr = "pcie_medclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l0_attr = "pcie_pclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l1_attr = "pcie_pclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l2_attr = "pcie_pclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l3_attr = "pcie_pclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l0_attr = "pcie_refclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l1_attr = "pcie_refclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l2_attr = "pcie_refclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l3_attr = "pcie_refclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l0_attr = "pcie_rxclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l1_attr = "pcie_rxclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l2_attr = "pcie_rxclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l3_attr = "pcie_rxclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l0_attr = "pcie_slowclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l1_attr = "pcie_slowclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l2_attr = "pcie_slowclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l3_attr = "pcie_slowclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_reserved0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_restart_seq_sm_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_skip_rd_seq_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_1_cfg_seqen_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_2_cfg_seqen_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_3_cfg_seq_rdwrb_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_4_cfg_seq_rdwrb_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_0_attr = 51224679;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_10_attr = 11641603;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_11_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_12_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_13_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_14_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_15_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_16_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_17_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_18_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_19_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_1_attr = 41138;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_20_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_21_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_22_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_2_attr = 134258864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_3_attr = 499727;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_4_attr = 11640835;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_5_attr = 499983;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_6_attr = 11641091;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_7_attr = 500239;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_8_attr = 11641347;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_9_attr = 500495;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_0_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_1_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_2_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_32_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_33_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_34_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_35_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_36_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_37_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_38_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_39_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_3_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_40_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_41_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_42_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_43_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_44_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_45_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_46_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_47_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_48_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_49_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_4_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_50_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_51_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_52_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_53_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_54_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_55_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_56_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_57_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_58_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_59_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_5_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_60_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_61_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_62_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_63_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_6_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_7_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_8_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_9_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_quad_instance = "ux_quad_instance_one";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__gdr_ux_quad_avmm_cfgcsr__ux_rst_value_pre_user_mode_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_avmm = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_bot_clkrx_base = "powermode_ac_mode_bot_clkrx_base_non_pin_primary_driver_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_bot_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_flux = "powermode_ac_mode_flux_flux_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_0_bot = "powermode_ac_mode_global_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_0_top = "powermode_ac_mode_global_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_1_bot = "powermode_ac_mode_global_refclk_1_bot_high_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_1_top = "powermode_ac_mode_global_refclk_1_top_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_2_bot = "powermode_ac_mode_global_refclk_2_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_2_top = "powermode_ac_mode_global_refclk_2_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_3_bot = "powermode_ac_mode_global_refclk_3_bot_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_global_refclk_3_top = "powermode_ac_mode_global_refclk_3_top_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_regional_refclk_0_bot = "powermode_ac_mode_regional_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_regional_refclk_0_top = "powermode_ac_mode_regional_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_regional_refclk_1_bot = "powermode_ac_mode_regional_refclk_1_bot_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_regional_refclk_1_top = "powermode_ac_mode_regional_refclk_1_top_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_fast_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_fast_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_fast_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_fast_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_med_ux0 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_med_ux1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_med_ux2 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_med_ux3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_slow_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_slow_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_slow_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_synth_lc_slow_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_top_clkrx_base = "powermode_ac_mode_top_clkrx_base_pin_to_clkrx_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_ac_mode_top_cmos_driver = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_bot_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_bot_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_flux = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_2_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_2_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_3_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_global_refclk_3_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_regional_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_regional_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_regional_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_regional_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_rx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_fast_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_fast_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_fast_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_fast_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_med_ux0 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_med_ux1 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_med_ux2 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_med_ux3 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_slow_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_slow_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_slow_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_synth_lc_slow_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_top_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_top_cmos_driver = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__powermode_freq_hz_tx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_o_usr_clk_e2_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_1__ux_quad_instance = "ux_quad_instance_one";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_fastest_reconfig_refclk_global_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__f_top_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__cdrdiv_offchip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__clkrx_bot_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__clkrx_top_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_ch1_ch0_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_ch3_ch2_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_fastest_reconfig_refclk_global_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_full_quad_master_pll_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_1_bot_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_1_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_2_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_3_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_1_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_regional_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_top_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__f_top_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_0_bot_control = "global_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_0_bot_power_mode = "global_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_0_top_control = "global_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_0_top_power_mode = "global_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_1_bot_control = "global_refclk_1_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_1_bot_power_mode = "global_refclk_1_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_1_left_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_1_top_control = "global_refclk_1_top_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_1_top_power_mode = "global_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_2_bot_control = "global_refclk_2_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_2_bot_power_mode = "global_refclk_2_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_2_top_control = "global_refclk_2_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_2_top_power_mode = "global_refclk_2_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_3_bot_control = "global_refclk_3_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_3_bot_power_mode = "global_refclk_3_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_3_right_adjacent_active = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_3_top_control = "global_refclk_3_top_control_enable_p2l_l2b_p2r_r2t";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__global_refclk_3_top_power_mode = "global_refclk_3_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__local_clock_line_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_global_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_global_refclk_1_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_global_refclk_2_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_global_refclk_3_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_regional_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__quad_regional_refclk_1_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_0_bot_control = "regional_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_0_bot_power_mode = "regional_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_0_top_control = "regional_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_0_top_power_mode = "regional_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_1_bot_control = "regional_refclk_1_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_1_bot_power_mode = "regional_refclk_1_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_1_top_control = "regional_refclk_1_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__regional_refclk_1_top_power_mode = "regional_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_fw_loader_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_fw_loader_cfg_fw_loader_en_attr = "scmng_fw_loader_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_fw_loader_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_fw_loader_cfg_single_mode_en_attr = "scmng_fw_loader_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_ahb_non_posted_write_attr = "scmng_pm_cfg_ahb_non_posted_write_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_an_done_lane0_attr = "scmng_pm_cfg_an_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_an_done_lane1_attr = "scmng_pm_cfg_an_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_an_done_lane2_attr = "scmng_pm_cfg_an_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_an_done_lane3_attr = "scmng_pm_cfg_an_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_apb_broadcast_feature_en_attr = "scmng_pm_cfg_apb_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_apb_broadcast_type_attr = "scmng_pm_cfg_apb_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_apb_security_check_en_attr = "scmng_pm_cfg_apb_security_check_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cfg_top_head_visactl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cfg_top_head_visactl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cfg_top_head_visactl2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cfg_top_head_visactl3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cfg_top_head_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cpi_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cpi_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_cpi_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_ecc_double_attr = "scmng_pm_cfg_ecc_double_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_error_l0_attr = "scmng_pm_cfg_error_l0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_error_l1_attr = "scmng_pm_cfg_error_l1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_error_l2_attr = "scmng_pm_cfg_error_l2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_error_l3_attr = "scmng_pm_cfg_error_l3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_link_mng_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_link_mng_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_one_bit_error_corrected_attr = "scmng_pm_cfg_one_bit_error_corrected_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_phy_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_phy_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_phy_owner_cpi_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_rx_ready_lane0_attr = "scmng_pm_cfg_rx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_rx_ready_lane1_attr = "scmng_pm_cfg_rx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_rx_ready_lane2_attr = "scmng_pm_cfg_rx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_rx_ready_lane3_attr = "scmng_pm_cfg_rx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_sw_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_trn_done_lane0_attr = "scmng_pm_cfg_trn_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_trn_done_lane1_attr = "scmng_pm_cfg_trn_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_trn_done_lane2_attr = "scmng_pm_cfg_trn_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_trn_done_lane3_attr = "scmng_pm_cfg_trn_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_tx_ready_lane0_attr = "scmng_pm_cfg_tx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_tx_ready_lane1_attr = "scmng_pm_cfg_tx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_tx_ready_lane2_attr = "scmng_pm_cfg_tx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_tx_ready_lane3_attr = "scmng_pm_cfg_tx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_visa_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_visa_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__scmng_pm_cfg_visa_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_top_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_top_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_bti_div_rst_attr = "serdes_ip_cmn_l0_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_req_attr = "serdes_ip_cmn_l0_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l0_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_start_attr = "serdes_ip_cmn_l0_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l0_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_bti_div_rst_attr = "serdes_ip_cmn_l1_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_req_attr = "serdes_ip_cmn_l1_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l1_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_start_attr = "serdes_ip_cmn_l1_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l1_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_bti_div_rst_attr = "serdes_ip_cmn_l2_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_req_attr = "serdes_ip_cmn_l2_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l2_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_start_attr = "serdes_ip_cmn_l2_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l2_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_bti_div_rst_attr = "serdes_ip_cmn_l3_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_req_attr = "serdes_ip_cmn_l3_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l3_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_start_attr = "serdes_ip_cmn_l3_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l3_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_en_attr = "serdes_ip_lane_aon_l0_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_req_attr = "serdes_ip_lane_aon_l0_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_en_attr = "serdes_ip_lane_aon_l1_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_req_attr = "serdes_ip_lane_aon_l1_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_en_attr = "serdes_ip_lane_aon_l2_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_req_attr = "serdes_ip_lane_aon_l2_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_en_attr = "serdes_ip_lane_aon_l3_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_req_attr = "serdes_ip_lane_aon_l3_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_bshihyst_attr = "serdes_ip_lane_l0_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l0_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l0_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_continuous_attr = "serdes_ip_lane_l0_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_en_attr = "serdes_ip_lane_l0_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_start_attr = "serdes_ip_lane_l0_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l0_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_en_attr = "serdes_ip_lane_l0_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_locovren_attr = "serdes_ip_lane_l0_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l0_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lfps_locovren_attr = "serdes_ip_lane_l0_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_lfps_out_en_attr = "serdes_ip_lane_l0_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l0_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_pcstx_locovren_attr = "serdes_ip_lane_l0_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_polarity_rx_attr = "serdes_ip_lane_l0_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_polarity_tx_attr = "serdes_ip_lane_l0_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_pg_disable_attr = "serdes_ip_lane_l0_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxadc_req_attr = "serdes_ip_lane_l0_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbias_locovren_attr = "serdes_ip_lane_l0_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_err_en_attr = "serdes_ip_lane_l0_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxbshicm_attr = "serdes_ip_lane_l0_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxclk_locovren_attr = "serdes_ip_lane_l0_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdata_locovren_attr = "serdes_ip_lane_l0_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_en_attr = "serdes_ip_lane_l0_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_locovren_attr = "serdes_ip_lane_l0_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpam_locovren_attr = "serdes_ip_lane_l0_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxphd_locovren_attr = "serdes_ip_lane_l0_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_locovren_attr = "serdes_ip_lane_l0_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l0_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l0_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_locovren_attr = "serdes_ip_lane_l0_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_polarity_attr = "serdes_ip_lane_l0_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l0_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l0_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trancntout_locovren_attr = "serdes_ip_lane_l0_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_trandetout_locovren_attr = "serdes_ip_lane_l0_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l0_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_pg_disable_attr = "serdes_ip_lane_l0_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txadc_req_attr = "serdes_ip_lane_l0_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbeacon_sel_attr = "serdes_ip_lane_l0_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbias_locovren_attr = "serdes_ip_lane_l0_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l0_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_locovren_attr = "serdes_ip_lane_l0_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbti_data_replication_attr = "serdes_ip_lane_l0_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcal_locovren_attr = "serdes_ip_lane_l0_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txclk_locovren_attr = "serdes_ip_lane_l0_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_locovren_attr = "serdes_ip_lane_l0_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_refcken_attr = "serdes_ip_lane_l0_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrv_termref_attr = "serdes_ip_lane_l0_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l0_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_en_attr = "serdes_ip_lane_l0_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_locovren_attr = "serdes_ip_lane_l0_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpam_locovren_attr = "serdes_ip_lane_l0_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpcs_locovren_attr = "serdes_ip_lane_l0_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txresetdel_sel_attr = "serdes_ip_lane_l0_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_en_b_attr = "serdes_ip_lane_l0_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_en_attr = "serdes_ip_lane_l0_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l0_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_bshihyst_attr = "serdes_ip_lane_l1_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l1_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l1_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_continuous_attr = "serdes_ip_lane_l1_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_en_attr = "serdes_ip_lane_l1_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_start_attr = "serdes_ip_lane_l1_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l1_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_en_attr = "serdes_ip_lane_l1_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_locovren_attr = "serdes_ip_lane_l1_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l1_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lfps_locovren_attr = "serdes_ip_lane_l1_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_lfps_out_en_attr = "serdes_ip_lane_l1_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l1_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_pcstx_locovren_attr = "serdes_ip_lane_l1_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_polarity_rx_attr = "serdes_ip_lane_l1_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_polarity_tx_attr = "serdes_ip_lane_l1_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_pg_disable_attr = "serdes_ip_lane_l1_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxadc_req_attr = "serdes_ip_lane_l1_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbias_locovren_attr = "serdes_ip_lane_l1_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_err_en_attr = "serdes_ip_lane_l1_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxbshicm_attr = "serdes_ip_lane_l1_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxclk_locovren_attr = "serdes_ip_lane_l1_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdata_locovren_attr = "serdes_ip_lane_l1_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_en_attr = "serdes_ip_lane_l1_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_locovren_attr = "serdes_ip_lane_l1_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpam_locovren_attr = "serdes_ip_lane_l1_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxphd_locovren_attr = "serdes_ip_lane_l1_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_locovren_attr = "serdes_ip_lane_l1_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l1_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l1_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_locovren_attr = "serdes_ip_lane_l1_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_polarity_attr = "serdes_ip_lane_l1_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l1_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l1_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trancntout_locovren_attr = "serdes_ip_lane_l1_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_trandetout_locovren_attr = "serdes_ip_lane_l1_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l1_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_pg_disable_attr = "serdes_ip_lane_l1_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txadc_req_attr = "serdes_ip_lane_l1_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbeacon_sel_attr = "serdes_ip_lane_l1_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbias_locovren_attr = "serdes_ip_lane_l1_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l1_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_locovren_attr = "serdes_ip_lane_l1_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbti_data_replication_attr = "serdes_ip_lane_l1_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcal_locovren_attr = "serdes_ip_lane_l1_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txclk_locovren_attr = "serdes_ip_lane_l1_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_locovren_attr = "serdes_ip_lane_l1_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_refcken_attr = "serdes_ip_lane_l1_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrv_termref_attr = "serdes_ip_lane_l1_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l1_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_en_attr = "serdes_ip_lane_l1_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_locovren_attr = "serdes_ip_lane_l1_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpam_locovren_attr = "serdes_ip_lane_l1_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpcs_locovren_attr = "serdes_ip_lane_l1_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txresetdel_sel_attr = "serdes_ip_lane_l1_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_en_b_attr = "serdes_ip_lane_l1_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_en_attr = "serdes_ip_lane_l1_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l1_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_bshihyst_attr = "serdes_ip_lane_l2_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l2_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l2_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_continuous_attr = "serdes_ip_lane_l2_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_en_attr = "serdes_ip_lane_l2_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_start_attr = "serdes_ip_lane_l2_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l2_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_en_attr = "serdes_ip_lane_l2_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_locovren_attr = "serdes_ip_lane_l2_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l2_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lfps_locovren_attr = "serdes_ip_lane_l2_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_lfps_out_en_attr = "serdes_ip_lane_l2_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l2_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_pcstx_locovren_attr = "serdes_ip_lane_l2_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_polarity_rx_attr = "serdes_ip_lane_l2_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_polarity_tx_attr = "serdes_ip_lane_l2_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_pg_disable_attr = "serdes_ip_lane_l2_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxadc_req_attr = "serdes_ip_lane_l2_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbias_locovren_attr = "serdes_ip_lane_l2_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_err_en_attr = "serdes_ip_lane_l2_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxbshicm_attr = "serdes_ip_lane_l2_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxclk_locovren_attr = "serdes_ip_lane_l2_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdata_locovren_attr = "serdes_ip_lane_l2_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_en_attr = "serdes_ip_lane_l2_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_locovren_attr = "serdes_ip_lane_l2_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpam_locovren_attr = "serdes_ip_lane_l2_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxphd_locovren_attr = "serdes_ip_lane_l2_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_locovren_attr = "serdes_ip_lane_l2_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l2_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l2_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_locovren_attr = "serdes_ip_lane_l2_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_polarity_attr = "serdes_ip_lane_l2_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l2_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l2_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trancntout_locovren_attr = "serdes_ip_lane_l2_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_trandetout_locovren_attr = "serdes_ip_lane_l2_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l2_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_pg_disable_attr = "serdes_ip_lane_l2_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txadc_req_attr = "serdes_ip_lane_l2_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbeacon_sel_attr = "serdes_ip_lane_l2_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbias_locovren_attr = "serdes_ip_lane_l2_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l2_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_locovren_attr = "serdes_ip_lane_l2_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbti_data_replication_attr = "serdes_ip_lane_l2_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcal_locovren_attr = "serdes_ip_lane_l2_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txclk_locovren_attr = "serdes_ip_lane_l2_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_locovren_attr = "serdes_ip_lane_l2_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_refcken_attr = "serdes_ip_lane_l2_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrv_termref_attr = "serdes_ip_lane_l2_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l2_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_en_attr = "serdes_ip_lane_l2_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_locovren_attr = "serdes_ip_lane_l2_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpam_locovren_attr = "serdes_ip_lane_l2_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpcs_locovren_attr = "serdes_ip_lane_l2_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txresetdel_sel_attr = "serdes_ip_lane_l2_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_en_b_attr = "serdes_ip_lane_l2_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_en_attr = "serdes_ip_lane_l2_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l2_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_bshihyst_attr = "serdes_ip_lane_l3_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l3_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l3_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_continuous_attr = "serdes_ip_lane_l3_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_en_attr = "serdes_ip_lane_l3_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_start_attr = "serdes_ip_lane_l3_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l3_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_en_attr = "serdes_ip_lane_l3_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_locovren_attr = "serdes_ip_lane_l3_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l3_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lfps_locovren_attr = "serdes_ip_lane_l3_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_lfps_out_en_attr = "serdes_ip_lane_l3_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l3_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_pcstx_locovren_attr = "serdes_ip_lane_l3_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_polarity_rx_attr = "serdes_ip_lane_l3_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_polarity_tx_attr = "serdes_ip_lane_l3_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_pg_disable_attr = "serdes_ip_lane_l3_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxadc_req_attr = "serdes_ip_lane_l3_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbias_locovren_attr = "serdes_ip_lane_l3_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_err_en_attr = "serdes_ip_lane_l3_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxbshicm_attr = "serdes_ip_lane_l3_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxclk_locovren_attr = "serdes_ip_lane_l3_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdata_locovren_attr = "serdes_ip_lane_l3_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_en_attr = "serdes_ip_lane_l3_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_locovren_attr = "serdes_ip_lane_l3_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpam_locovren_attr = "serdes_ip_lane_l3_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxphd_locovren_attr = "serdes_ip_lane_l3_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_locovren_attr = "serdes_ip_lane_l3_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l3_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l3_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_locovren_attr = "serdes_ip_lane_l3_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_polarity_attr = "serdes_ip_lane_l3_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l3_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l3_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trancntout_locovren_attr = "serdes_ip_lane_l3_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_trandetout_locovren_attr = "serdes_ip_lane_l3_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l3_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_pg_disable_attr = "serdes_ip_lane_l3_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txadc_req_attr = "serdes_ip_lane_l3_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbeacon_sel_attr = "serdes_ip_lane_l3_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbias_locovren_attr = "serdes_ip_lane_l3_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l3_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_locovren_attr = "serdes_ip_lane_l3_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbti_data_replication_attr = "serdes_ip_lane_l3_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcal_locovren_attr = "serdes_ip_lane_l3_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txclk_locovren_attr = "serdes_ip_lane_l3_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_locovren_attr = "serdes_ip_lane_l3_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_refcken_attr = "serdes_ip_lane_l3_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrv_termref_attr = "serdes_ip_lane_l3_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l3_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_en_attr = "serdes_ip_lane_l3_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_locovren_attr = "serdes_ip_lane_l3_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpam_locovren_attr = "serdes_ip_lane_l3_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpcs_locovren_attr = "serdes_ip_lane_l3_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txresetdel_sel_attr = "serdes_ip_lane_l3_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_en_b_attr = "serdes_ip_lane_l3_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_en_attr = "serdes_ip_lane_l3_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_l3_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_dig_cdr_disable_attr = "serdes_shim_an_l0_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_direct_control_bus_en_attr = "serdes_shim_an_l0_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_edge_too_long_disable_attr = "serdes_shim_an_l0_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_edge_too_short_disable_attr = "serdes_shim_an_l0_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_page_max_timer_disable_attr = "serdes_shim_an_l0_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_page_min_timer_disable_attr = "serdes_shim_an_l0_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_pcs_lock_attr = "serdes_shim_an_l0_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_enable_m_attr = "serdes_shim_an_l0_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_lcw_re_attr = "serdes_shim_an_l0_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_pma_en_attr = "serdes_shim_an_l0_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_complete_ack_attr = "serdes_shim_an_l0_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_enable_m_attr = "serdes_shim_an_l0_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_lcw_we_attr = "serdes_shim_an_l0_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l0_cfg_tx_pma_en_attr = "serdes_shim_an_l0_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_dig_cdr_disable_attr = "serdes_shim_an_l1_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_direct_control_bus_en_attr = "serdes_shim_an_l1_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_edge_too_long_disable_attr = "serdes_shim_an_l1_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_edge_too_short_disable_attr = "serdes_shim_an_l1_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_page_max_timer_disable_attr = "serdes_shim_an_l1_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_page_min_timer_disable_attr = "serdes_shim_an_l1_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_pcs_lock_attr = "serdes_shim_an_l1_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_enable_m_attr = "serdes_shim_an_l1_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_lcw_re_attr = "serdes_shim_an_l1_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_pma_en_attr = "serdes_shim_an_l1_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_complete_ack_attr = "serdes_shim_an_l1_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_enable_m_attr = "serdes_shim_an_l1_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_lcw_we_attr = "serdes_shim_an_l1_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l1_cfg_tx_pma_en_attr = "serdes_shim_an_l1_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_dig_cdr_disable_attr = "serdes_shim_an_l2_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_direct_control_bus_en_attr = "serdes_shim_an_l2_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_edge_too_long_disable_attr = "serdes_shim_an_l2_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_edge_too_short_disable_attr = "serdes_shim_an_l2_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_page_max_timer_disable_attr = "serdes_shim_an_l2_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_page_min_timer_disable_attr = "serdes_shim_an_l2_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_pcs_lock_attr = "serdes_shim_an_l2_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_enable_m_attr = "serdes_shim_an_l2_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_lcw_re_attr = "serdes_shim_an_l2_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_pma_en_attr = "serdes_shim_an_l2_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_complete_ack_attr = "serdes_shim_an_l2_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_enable_m_attr = "serdes_shim_an_l2_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_lcw_we_attr = "serdes_shim_an_l2_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l2_cfg_tx_pma_en_attr = "serdes_shim_an_l2_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_dig_cdr_disable_attr = "serdes_shim_an_l3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_direct_control_bus_en_attr = "serdes_shim_an_l3_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_edge_too_long_disable_attr = "serdes_shim_an_l3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_edge_too_short_disable_attr = "serdes_shim_an_l3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_page_max_timer_disable_attr = "serdes_shim_an_l3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_page_min_timer_disable_attr = "serdes_shim_an_l3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_pcs_lock_attr = "serdes_shim_an_l3_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_enable_m_attr = "serdes_shim_an_l3_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_lcw_re_attr = "serdes_shim_an_l3_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_pma_en_attr = "serdes_shim_an_l3_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_complete_ack_attr = "serdes_shim_an_l3_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_enable_m_attr = "serdes_shim_an_l3_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_lcw_we_attr = "serdes_shim_an_l3_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_an_l3_cfg_tx_pma_en_attr = "serdes_shim_an_l3_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l0_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_en_attr = "serdes_shim_car_l0_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_val_attr = "serdes_shim_car_l0_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_timer_en_attr = "serdes_shim_car_l0_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l0_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l1_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_en_attr = "serdes_shim_car_l1_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_val_attr = "serdes_shim_car_l1_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_timer_en_attr = "serdes_shim_car_l1_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l1_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l2_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_en_attr = "serdes_shim_car_l2_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_val_attr = "serdes_shim_car_l2_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_timer_en_attr = "serdes_shim_car_l2_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l2_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l3_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_en_attr = "serdes_shim_car_l3_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_val_attr = "serdes_shim_car_l3_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_timer_en_attr = "serdes_shim_car_l3_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_car_l3_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_atresetn_attr = "serdes_shim_cpu_pm_cfg_cpu_atresetn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakin_attr = "serdes_shim_cpu_pm_cfg_cpu_breakin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr = "serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr = "serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr = "serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_prid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr = "serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr = "serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_dram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_trace_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_fifo_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram5_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram6_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_trace_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_trace_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fw_status_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_fw_version_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_iramh_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_iraml_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_nmi_icu_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tb_reg0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tb_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tb_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tb_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tb_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tie_queue_pwr_mgmt_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_cpu_pm_cfg_tram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_en_attr = "serdes_shim_dsp_l0_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l0_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_en_attr = "serdes_shim_dsp_l0_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_d_sign_attr = "serdes_shim_dsp_l0_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_en_attr = "serdes_shim_dsp_l0_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_event_sign_attr = "serdes_shim_dsp_l0_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_bb_stable_attr = "serdes_shim_dsp_l0_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_en_attr = "serdes_shim_dsp_l0_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l0_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_error_counter_clr_attr = "serdes_shim_dsp_l0_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_error_counter_enable_attr = "serdes_shim_dsp_l0_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l0_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_fine_attr = "serdes_shim_dsp_l0_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_en_attr = "serdes_shim_dsp_l0_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l0_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l0_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_en_attr = "serdes_shim_dsp_l0_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_pam_4_en_attr = "serdes_shim_dsp_l0_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_pol_invert_attr = "serdes_shim_dsp_l0_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_power_save_en_attr = "serdes_shim_dsp_l0_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_en_attr = "serdes_shim_dsp_l0_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_snr_meter_en_attr = "serdes_shim_dsp_l0_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_swap_bot_en_attr = "serdes_shim_dsp_l0_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_swap_top_en_attr = "serdes_shim_dsp_l0_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l0_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_en_attr = "serdes_shim_dsp_l0_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_en_attr = "serdes_shim_dsp_l0_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l0_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_x3_en_attr = "serdes_shim_dsp_l0_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l0_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_en_attr = "serdes_shim_dsp_l1_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l1_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_en_attr = "serdes_shim_dsp_l1_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_d_sign_attr = "serdes_shim_dsp_l1_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_en_attr = "serdes_shim_dsp_l1_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_event_sign_attr = "serdes_shim_dsp_l1_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_bb_stable_attr = "serdes_shim_dsp_l1_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_en_attr = "serdes_shim_dsp_l1_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l1_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_error_counter_clr_attr = "serdes_shim_dsp_l1_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_error_counter_enable_attr = "serdes_shim_dsp_l1_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l1_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_fine_attr = "serdes_shim_dsp_l1_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_en_attr = "serdes_shim_dsp_l1_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l1_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l1_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_en_attr = "serdes_shim_dsp_l1_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_pam_4_en_attr = "serdes_shim_dsp_l1_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_pol_invert_attr = "serdes_shim_dsp_l1_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_power_save_en_attr = "serdes_shim_dsp_l1_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_en_attr = "serdes_shim_dsp_l1_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_snr_meter_en_attr = "serdes_shim_dsp_l1_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_swap_bot_en_attr = "serdes_shim_dsp_l1_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_swap_top_en_attr = "serdes_shim_dsp_l1_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l1_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_en_attr = "serdes_shim_dsp_l1_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_en_attr = "serdes_shim_dsp_l1_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l1_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_x3_en_attr = "serdes_shim_dsp_l1_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l1_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_en_attr = "serdes_shim_dsp_l2_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l2_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_en_attr = "serdes_shim_dsp_l2_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_d_sign_attr = "serdes_shim_dsp_l2_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_en_attr = "serdes_shim_dsp_l2_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_event_sign_attr = "serdes_shim_dsp_l2_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_bb_stable_attr = "serdes_shim_dsp_l2_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_en_attr = "serdes_shim_dsp_l2_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l2_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_error_counter_clr_attr = "serdes_shim_dsp_l2_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_error_counter_enable_attr = "serdes_shim_dsp_l2_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l2_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_fine_attr = "serdes_shim_dsp_l2_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_en_attr = "serdes_shim_dsp_l2_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l2_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l2_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_en_attr = "serdes_shim_dsp_l2_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_pam_4_en_attr = "serdes_shim_dsp_l2_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_pol_invert_attr = "serdes_shim_dsp_l2_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_power_save_en_attr = "serdes_shim_dsp_l2_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_en_attr = "serdes_shim_dsp_l2_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_snr_meter_en_attr = "serdes_shim_dsp_l2_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_swap_bot_en_attr = "serdes_shim_dsp_l2_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_swap_top_en_attr = "serdes_shim_dsp_l2_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l2_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_en_attr = "serdes_shim_dsp_l2_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_en_attr = "serdes_shim_dsp_l2_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l2_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_x3_en_attr = "serdes_shim_dsp_l2_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l2_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_en_attr = "serdes_shim_dsp_l3_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l3_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_en_attr = "serdes_shim_dsp_l3_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_d_sign_attr = "serdes_shim_dsp_l3_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_en_attr = "serdes_shim_dsp_l3_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_event_sign_attr = "serdes_shim_dsp_l3_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_bb_stable_attr = "serdes_shim_dsp_l3_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_en_attr = "serdes_shim_dsp_l3_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l3_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_error_counter_clr_attr = "serdes_shim_dsp_l3_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_error_counter_enable_attr = "serdes_shim_dsp_l3_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l3_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_fine_attr = "serdes_shim_dsp_l3_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_en_attr = "serdes_shim_dsp_l3_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l3_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l3_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_en_attr = "serdes_shim_dsp_l3_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_pam_4_en_attr = "serdes_shim_dsp_l3_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_pol_invert_attr = "serdes_shim_dsp_l3_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_power_save_en_attr = "serdes_shim_dsp_l3_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_en_attr = "serdes_shim_dsp_l3_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_snr_meter_en_attr = "serdes_shim_dsp_l3_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_swap_bot_en_attr = "serdes_shim_dsp_l3_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_swap_top_en_attr = "serdes_shim_dsp_l3_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l3_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_en_attr = "serdes_shim_dsp_l3_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_en_attr = "serdes_shim_dsp_l3_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l3_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_x3_en_attr = "serdes_shim_dsp_l3_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_dsp_l3_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l0_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l0_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_send_data_attr = "serdes_shim_tfl_l0_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l0_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l1_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l1_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_send_data_attr = "serdes_shim_tfl_l1_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l1_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l2_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l2_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_send_data_attr = "serdes_shim_tfl_l2_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l2_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l3_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l3_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_send_data_attr = "serdes_shim_tfl_l3_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_tfl_l3_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_broadcast_feature_en_attr = "serdes_shim_top_cfg_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_broadcast_type_attr = "serdes_shim_top_cfg_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_datawidth_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_en_attr = "serdes_shim_top_cfg_fec_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_mask8_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_packet_sel_attr = "serdes_shim_top_cfg_fec_ber_packet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_poly_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_rs_type_sel_attr = "serdes_shim_top_cfg_fec_ber_rs_type_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_fec_ber_statistic_en_attr = "serdes_shim_top_cfg_fec_ber_statistic_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_wdt_clr_attr = "serdes_shim_top_cfg_wdt_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_wdt_en_attr = "serdes_shim_top_cfg_wdt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_wdt_pre_scale_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr = "serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_wdt_swrst_en_attr = "serdes_shim_top_cfg_wdt_swrst_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_top_cfg_wdt_time_val_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_clkrx_ref_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr = "serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_cpu_clk_sel_attr = "serdes_shim_wrap_car_cfg_cpu_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_cpu_clken_attr = "serdes_shim_wrap_car_cfg_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_cpu_runstall_attr = "serdes_shim_wrap_car_cfg_cpu_runstall_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr = "serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_val_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fast_clk_lane_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_clken_attr = "serdes_shim_wrap_car_cfg_fb_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fb_rx_clken_attr = "serdes_shim_wrap_car_cfg_fb_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_fec_ber_lane_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__top_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__top_refclk_reconfig_span = "top_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_0_rx_synth_select = "ux0_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_0_tx_synth_select = "ux0_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_1_rx_synth_select = "ux0_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_1_tx_synth_select = "ux0_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_2_rx_synth_select = "ux0_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_2_tx_synth_select = "ux0_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_3_rx_synth_select = "ux0_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_3_tx_synth_select = "ux0_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_4_rx_synth_select = "ux0_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_4_tx_synth_select = "ux0_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_refclk_type_select = "ux0_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_refclk_type_select = "ux0_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_refclk_type_select = "ux0_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_refclk_type_select = "ux0_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_refclk_type_select = "ux0_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_core_pll_bw_sel = "ux0_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dpma_n_counter_physical = "ux0_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rx_which_lane_to_copy = "ux0_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_select_lc_0_tx_path = "ux0_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_select_lc_1_tx_path = "ux0_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_select_lc_2_tx_path = "ux0_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_select_lc_3_tx_path = "ux0_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_select_lc_4_tx_path = "ux0_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_afc_range = "ux0_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_afc_range = "ux0_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_afc_range = "ux0_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_afc_range = "ux0_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_afc_range = "ux0_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_bw_sel = "ux0_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_refclk_mux_select = "ux0_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_refclk_type_select = "ux0_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_bw_sel = "ux0_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_refclk_mux_select = "ux0_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_refclk_type_select = "ux0_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_bw_sel = "ux0_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_refclk_mux_select = "ux0_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_refclk_type_select = "ux0_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_tx_which_lane_to_copy = "ux0_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux0_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_0_rx_synth_select = "ux1_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_0_tx_synth_select = "ux1_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_1_rx_synth_select = "ux1_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_1_tx_synth_select = "ux1_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_2_rx_synth_select = "ux1_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_2_tx_synth_select = "ux1_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_3_rx_synth_select = "ux1_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_3_tx_synth_select = "ux1_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_4_rx_synth_select = "ux1_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_4_tx_synth_select = "ux1_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_refclk_type_select = "ux1_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_refclk_type_select = "ux1_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_refclk_type_select = "ux1_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_refclk_type_select = "ux1_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_refclk_type_select = "ux1_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_core_pll_bw_sel = "ux1_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dpma_n_counter_physical = "ux1_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rx_which_lane_to_copy = "ux1_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_select_lc_0_tx_path = "ux1_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_select_lc_1_tx_path = "ux1_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_select_lc_2_tx_path = "ux1_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_select_lc_3_tx_path = "ux1_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_select_lc_4_tx_path = "ux1_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_afc_range = "ux1_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_afc_range = "ux1_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_afc_range = "ux1_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_afc_range = "ux1_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_afc_range = "ux1_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_bw_sel = "ux1_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_refclk_mux_select = "ux1_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_refclk_type_select = "ux1_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_bw_sel = "ux1_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_refclk_mux_select = "ux1_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_refclk_type_select = "ux1_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_bw_sel = "ux1_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_refclk_mux_select = "ux1_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_refclk_type_select = "ux1_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_tx_which_lane_to_copy = "ux1_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux1_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_0_rx_synth_select = "ux2_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_0_tx_synth_select = "ux2_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_1_rx_synth_select = "ux2_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_1_tx_synth_select = "ux2_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_2_rx_synth_select = "ux2_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_2_tx_synth_select = "ux2_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_3_rx_synth_select = "ux2_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_3_tx_synth_select = "ux2_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_4_rx_synth_select = "ux2_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_4_tx_synth_select = "ux2_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_refclk_type_select = "ux2_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_refclk_type_select = "ux2_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_refclk_type_select = "ux2_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_refclk_type_select = "ux2_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_refclk_type_select = "ux2_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_core_pll_bw_sel = "ux2_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dpma_n_counter_physical = "ux2_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rx_which_lane_to_copy = "ux2_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_select_lc_0_tx_path = "ux2_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_select_lc_1_tx_path = "ux2_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_select_lc_2_tx_path = "ux2_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_select_lc_3_tx_path = "ux2_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_select_lc_4_tx_path = "ux2_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_afc_range = "ux2_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_afc_range = "ux2_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_afc_range = "ux2_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_afc_range = "ux2_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_afc_range = "ux2_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_bw_sel = "ux2_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_refclk_mux_select = "ux2_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_refclk_type_select = "ux2_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_bw_sel = "ux2_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_refclk_mux_select = "ux2_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_refclk_type_select = "ux2_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_bw_sel = "ux2_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_refclk_mux_select = "ux2_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_refclk_type_select = "ux2_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_tx_which_lane_to_copy = "ux2_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux2_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_0_rx_synth_select = "ux3_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_0_tx_synth_select = "ux3_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_1_rx_synth_select = "ux3_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_1_tx_synth_select = "ux3_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_2_rx_synth_select = "ux3_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_2_tx_synth_select = "ux3_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_3_rx_synth_select = "ux3_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_3_tx_synth_select = "ux3_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_4_rx_synth_select = "ux3_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_4_tx_synth_select = "ux3_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_refclk_type_select = "ux3_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_refclk_type_select = "ux3_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_refclk_type_select = "ux3_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_refclk_type_select = "ux3_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_refclk_type_select = "ux3_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_core_pll_bw_sel = "ux3_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dpma_n_counter_physical = "ux3_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rx_which_lane_to_copy = "ux3_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_select_lc_0_tx_path = "ux3_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_select_lc_1_tx_path = "ux3_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_select_lc_2_tx_path = "ux3_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_select_lc_3_tx_path = "ux3_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_select_lc_4_tx_path = "ux3_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_afc_range = "ux3_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_afc_range = "ux3_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_afc_range = "ux3_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_afc_range = "ux3_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_afc_range = "ux3_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_bw_sel = "ux3_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_refclk_mux_select = "ux3_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_refclk_type_select = "ux3_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_bw_sel = "ux3_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_refclk_mux_select = "ux3_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_refclk_type_select = "ux3_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_bw_sel = "ux3_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_refclk_mux_select = "ux3_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_refclk_type_select = "ux3_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_tx_which_lane_to_copy = "ux3_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux3_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux_quad_instance = "ux_quad_instance_two";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__flux_top__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_cpi_cmn2_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_cpi_lm_addr = 589884;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_cpi_phy_addr = 589888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_cpi_reserved = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_cpi_seq_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_cpi_timer_max = 500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_end_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_flux_cpu_freq = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l0_attr = "bonding_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l1_attr = "bonding_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l2_attr = "bonding_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l3_attr = "bonding_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_cpi_seq_ctrl_cfg_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l0_attr = "lb_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l1_attr = "lb_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l2_attr = "lb_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l3_attr = "lb_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_clk_en_dfd_clk_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_extrig_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_rsvd_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_data_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_inc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_rst_b_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_apb_rdata_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_rst_dfd_extrig_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l2_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l3_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_dpma_clk_mux_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l0_attr = "e200_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l1_attr = "e200_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l2_attr = "e200_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l3_attr = "e200_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l0_attr = "e200_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l1_attr = "e200_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l2_attr = "e200_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l3_attr = "e200_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l0_attr = "e400_ckmux_slow_med_l0_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l1_attr = "e400_ckmux_slow_med_l1_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l2_attr = "e400_ckmux_slow_med_l2_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l3_attr = "e400_ckmux_slow_med_l3_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l0_attr = "e400_ckmux_txuser0_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l1_attr = "e400_ckmux_txuser0_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l2_attr = "e400_ckmux_txuser0_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l3_attr = "e400_ckmux_txuser0_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l0_attr = "e400_ckmux_txuser1_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l1_attr = "e400_ckmux_txuser1_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l2_attr = "e400_ckmux_txuser1_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l3_attr = "e400_ckmux_txuser1_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l0_attr = "e400_ckmux_txuser2_l0_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l1_attr = "e400_ckmux_txuser2_l1_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l2_attr = "e400_ckmux_txuser2_l2_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l3_attr = "e400_ckmux_txuser2_l3_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l0_attr = "e400_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l1_attr = "e400_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l2_attr = "e400_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l3_attr = "e400_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l0_attr = "e400_rxusrclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l1_attr = "e400_rxusrclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l2_attr = "e400_rxusrclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l3_attr = "e400_rxusrclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l0_attr = "e400_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l1_attr = "e400_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l2_attr = "e400_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l3_attr = "e400_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l0_attr = "e400_usrclk0_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l1_attr = "e400_usrclk0_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l2_attr = "e400_usrclk0_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l3_attr = "e400_usrclk0_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l0_attr = "e400_usrclk1_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l1_attr = "e400_usrclk1_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l2_attr = "e400_usrclk1_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l3_attr = "e400_usrclk1_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l0_attr = "e400_usrclk2_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l1_attr = "e400_usrclk2_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l2_attr = "e400_usrclk2_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l3_attr = "e400_usrclk2_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l0_attr = "e_rx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l1_attr = "e_rx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l2_attr = "e_rx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l3_attr = "e_rx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l0_attr = "e_tx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l1_attr = "e_tx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l2_attr = "e_tx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l3_attr = "e_tx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l0_cfg_value_attr = 277792;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l1_cfg_value_attr = 310560;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l2_cfg_value_attr = 343328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l3_cfg_value_attr = 376096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_disable_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_mapped_base_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_unmapped_base_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l0_attr = "func_mode_e400_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l1_attr = "func_mode_e400_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l2_attr = "func_mode_e400_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l3_attr = "func_mode_e400_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l0_attr = "pcie_medclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l1_attr = "pcie_medclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l2_attr = "pcie_medclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l3_attr = "pcie_medclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l0_attr = "pcie_pclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l1_attr = "pcie_pclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l2_attr = "pcie_pclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l3_attr = "pcie_pclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l0_attr = "pcie_refclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l1_attr = "pcie_refclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l2_attr = "pcie_refclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l3_attr = "pcie_refclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l0_attr = "pcie_rxclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l1_attr = "pcie_rxclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l2_attr = "pcie_rxclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l3_attr = "pcie_rxclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l0_attr = "pcie_slowclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l1_attr = "pcie_slowclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l2_attr = "pcie_slowclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l3_attr = "pcie_slowclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_reserved0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_restart_seq_sm_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_skip_rd_seq_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_1_cfg_seqen_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_2_cfg_seqen_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_3_cfg_seq_rdwrb_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_4_cfg_seq_rdwrb_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_0_attr = 51224679;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_10_attr = 11641603;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_11_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_12_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_13_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_14_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_15_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_16_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_17_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_18_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_19_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_1_attr = 41138;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_20_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_21_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_22_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_2_attr = 134258864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_3_attr = 499727;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_4_attr = 11640835;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_5_attr = 499983;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_6_attr = 11641091;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_7_attr = 500239;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_8_attr = 11641347;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_9_attr = 500495;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_0_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_1_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_2_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_32_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_33_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_34_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_35_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_36_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_37_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_38_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_39_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_3_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_40_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_41_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_42_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_43_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_44_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_45_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_46_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_47_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_48_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_49_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_4_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_50_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_51_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_52_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_53_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_54_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_55_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_56_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_57_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_58_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_59_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_5_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_60_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_61_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_62_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_63_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_6_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_7_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_8_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_9_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_quad_instance = "ux_quad_instance_two";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__gdr_ux_quad_avmm_cfgcsr__ux_rst_value_pre_user_mode_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_avmm = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_bot_clkrx_base = "powermode_ac_mode_bot_clkrx_base_non_pin_primary_driver_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_bot_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_flux = "powermode_ac_mode_flux_flux_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_0_bot = "powermode_ac_mode_global_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_0_top = "powermode_ac_mode_global_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_1_bot = "powermode_ac_mode_global_refclk_1_bot_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_1_top = "powermode_ac_mode_global_refclk_1_top_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_2_bot = "powermode_ac_mode_global_refclk_2_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_2_top = "powermode_ac_mode_global_refclk_2_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_3_bot = "powermode_ac_mode_global_refclk_3_bot_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_global_refclk_3_top = "powermode_ac_mode_global_refclk_3_top_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_regional_refclk_0_bot = "powermode_ac_mode_regional_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_regional_refclk_0_top = "powermode_ac_mode_regional_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_regional_refclk_1_bot = "powermode_ac_mode_regional_refclk_1_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_regional_refclk_1_top = "powermode_ac_mode_regional_refclk_1_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_fast_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_fast_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_fast_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_fast_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_med_ux0 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_med_ux1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_med_ux2 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_med_ux3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_slow_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_slow_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_slow_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_synth_lc_slow_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_top_clkrx_base = "powermode_ac_mode_top_clkrx_base_pin_to_clkrx_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_ac_mode_top_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_bot_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_bot_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_flux = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_2_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_2_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_3_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_global_refclk_3_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_regional_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_regional_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_regional_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_regional_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_rx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_fast_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_fast_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_fast_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_fast_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_med_ux0 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_med_ux1 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_med_ux2 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_med_ux3 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_slow_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_slow_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_slow_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_synth_lc_slow_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_top_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_top_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__powermode_freq_hz_tx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_2__ux_quad_instance = "ux_quad_instance_two";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_avmm_clk_hz = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_fastest_reconfig_refclk_global_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__f_top_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__bot_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__bot_refclk_reconfig_span = "bot_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__cdrdiv_offchip_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ch1_ch0_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ch3_ch2_master_pll_pair_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__clkrx_bot_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__clkrx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__clkrx_top_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__dynamic_pcie_speed_choice = "dynamic_pcie_speed_choice_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__enable_static_refclk_network = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_bot_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_bot_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_ch1_ch0_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_ch3_ch2_master_pll_pair_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_fastest_reconfig_refclk_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_fastest_reconfig_refclk_global_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_fastest_reconfig_refclk_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_fastest_reconfig_refclk_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_fastest_reconfig_refclk_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_fastest_reconfig_refclk_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_full_quad_master_pll_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_1_bot_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_1_bot_right_top_left_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_1_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_1_top_right_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_2_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_2_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_2_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_3_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_3_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_global_refclk_3_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_local_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_0_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_0_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_0_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_0_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_1_bot_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_1_bot_right_top_left_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_1_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_1_top_right_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_regional_refclk_3_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_top_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__f_top_syspll_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__force_refclk_power_to_specific_value = "force_refclk_power_to_specific_value_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__full_quad_master_pll_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_0_bot_control = "global_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_0_bot_power_mode = "global_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_0_top_control = "global_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_0_top_power_mode = "global_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_1_bot_control = "global_refclk_1_bot_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_1_bot_power_mode = "global_refclk_1_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_1_top_control = "global_refclk_1_top_control_enable_r2l_l2b";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_1_top_power_mode = "global_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_2_bot_control = "global_refclk_2_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_2_bot_power_mode = "global_refclk_2_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_2_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_2_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_2_top_control = "global_refclk_2_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_2_top_power_mode = "global_refclk_2_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_3_bot_control = "global_refclk_3_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_3_bot_power_mode = "global_refclk_3_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_3_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_3_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_3_top_control = "global_refclk_3_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__global_refclk_3_top_power_mode = "global_refclk_3_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__local_clock_line_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_global_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_global_refclk_1_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_global_refclk_2_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_global_refclk_3_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_regional_refclk_0_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__quad_regional_refclk_1_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_0_bot_control = "regional_refclk_0_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_0_bot_power_mode = "regional_refclk_0_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_0_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_0_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_0_top_control = "regional_refclk_0_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_0_top_power_mode = "regional_refclk_0_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_1_bot_control = "regional_refclk_1_bot_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_1_bot_power_mode = "regional_refclk_1_bot_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_1_left_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_1_right_adjacent_active = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_1_top_control = "regional_refclk_1_top_control_enable_t2r_b2l_no_pass_thru";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__regional_refclk_1_top_power_mode = "regional_refclk_1_top_power_mode_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_fw_loader_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_fw_loader_cfg_fw_loader_en_attr = "scmng_fw_loader_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_fw_loader_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_fw_loader_cfg_single_mode_en_attr = "scmng_fw_loader_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_ahb_non_posted_write_attr = "scmng_pm_cfg_ahb_non_posted_write_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_an_done_lane0_attr = "scmng_pm_cfg_an_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_an_done_lane1_attr = "scmng_pm_cfg_an_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_an_done_lane2_attr = "scmng_pm_cfg_an_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_an_done_lane3_attr = "scmng_pm_cfg_an_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_apb_broadcast_feature_en_attr = "scmng_pm_cfg_apb_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_apb_broadcast_type_attr = "scmng_pm_cfg_apb_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_apb_security_check_en_attr = "scmng_pm_cfg_apb_security_check_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cfg_top_head_visactl0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cfg_top_head_visactl1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cfg_top_head_visactl2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cfg_top_head_visactl3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cfg_top_head_visaenable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cpi_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cpi_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_cpi_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_ecc_double_attr = "scmng_pm_cfg_ecc_double_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_error_l0_attr = "scmng_pm_cfg_error_l0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_error_l1_attr = "scmng_pm_cfg_error_l1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_error_l2_attr = "scmng_pm_cfg_error_l2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_error_l3_attr = "scmng_pm_cfg_error_l3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_link_mng_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_link_mng_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_one_bit_error_corrected_attr = "scmng_pm_cfg_one_bit_error_corrected_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_phy_cpi_cmd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_phy_cpi_data_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_phy_owner_cpi_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_probe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_rx_ready_lane0_attr = "scmng_pm_cfg_rx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_rx_ready_lane1_attr = "scmng_pm_cfg_rx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_rx_ready_lane2_attr = "scmng_pm_cfg_rx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_rx_ready_lane3_attr = "scmng_pm_cfg_rx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_sw_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_trn_done_lane0_attr = "scmng_pm_cfg_trn_done_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_trn_done_lane1_attr = "scmng_pm_cfg_trn_done_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_trn_done_lane2_attr = "scmng_pm_cfg_trn_done_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_trn_done_lane3_attr = "scmng_pm_cfg_trn_done_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_tx_ready_lane0_attr = "scmng_pm_cfg_tx_ready_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_tx_ready_lane1_attr = "scmng_pm_cfg_tx_ready_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_tx_ready_lane2_attr = "scmng_pm_cfg_tx_ready_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_tx_ready_lane3_attr = "scmng_pm_cfg_tx_ready_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_visa_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_visa_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__scmng_pm_cfg_visa_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_bot_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_bot_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_bot_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_bot_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_bot_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_bot_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_bot_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_bot_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_bot_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr = "serdes_ip_clkrx_top_aon_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr = "serdes_ip_clkrx_top_aon_cfg_cmn_powerup_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_aon_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr = "serdes_ip_clkrx_top_aon_cfg_synth_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_aprobe_left_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_left_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_aprobe_right_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_right_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_aprobe_top_en_attr = "serdes_ip_clkrx_top_cfg_aprobe_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmn_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr = "serdes_ip_clkrx_top_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmn_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnaprobeclkrx_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnbs_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnbshihyst_attr = "serdes_ip_clkrx_top_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_refckregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_pstate_swfabricregopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_refckregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalptr_quad_swfabricregopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalrefckregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr = "serdes_ip_clkrx_top_cfg_cmncalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr = "serdes_ip_clkrx_top_cfg_cmncalswfabricregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr = "serdes_ip_clkrx_top_cfg_cmnclkrx_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxcdrdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_buf2dpma_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_cml_ena_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_core_cmos_ena_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbuf_termhiz_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_hs_ls_b_path_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxrefckbufsel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxspare_attr = 61440;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_bot_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_input_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnclkrxsynthdiv_top_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmndprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refck_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refck_smpltime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_cdrdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_hsrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_lcrefsel_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_ana_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_pad2cmos_dig_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel0_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel1_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel2_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel3_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel4_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_refsel5_powersave_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_synthdivsel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnref_termhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_auto_powerdown_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_cml_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnrefckctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrefckreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q3_attr = 250;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_delay_s2q7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr = "serdes_ip_clkrx_top_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_refckregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpuetr_swfabricregpwrupacc_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckbuf_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_refckreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabric_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpupd_swfabricreg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_refckregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrpurst_swfabricregreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_refckregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_aetrcmn_swfabricregpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_refckreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabric_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdcmn_swfabricreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_apdrefck_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_refckregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr = "serdes_ip_clkrx_top_cfg_cmnrstpdovr_arstcmn_swfabricregreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref0_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref1_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref2_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref3_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref4_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref5_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref6_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_left_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_powersave_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr = "serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_right_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabric_ref7_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_cfg_cmnswfabricreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_en_attr = "serdes_ip_clkrx_top_if_cfg_egress_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_egress_override_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_burnin_mode_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cdrdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_cmnclkrxrefckbufsel_hs_ls_b_path_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_hsrefsel_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_jtagslvid_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_ana_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_pad2cmos_dig_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_powerup_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel0_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel1_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel2_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel3_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel4_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_refsel5_powersave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_synthdivsel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_termhiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_ref_vdd_ehv_sel_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_ictl_spare_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_n_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_idat_txbscan_p_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_por_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr = "serdes_ip_clkrx_top_if_cfg_irst_ref_tstbus_b_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l0_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l0_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l0_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l0_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l1_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l1_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l1_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l1_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l2_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l2_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l2_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l2_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr = "serdes_ip_cmn_aon_l3_cfg_ckgate_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmn_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr = "serdes_ip_cmn_aon_l3_cfg_cmnclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnclkdiv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_cmnfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_cmntstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfast_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcfastfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmed_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcmedfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_default_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_force_pup_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_ignore_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslow_rst_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr = "serdes_ip_cmn_aon_l3_cfg_synthlcslowfsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr = "serdes_ip_cmn_aon_l3_cfg_tstbus_rst_bypass_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_bti_div_rst_attr = "serdes_ip_cmn_l0_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l0_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnadc_req_attr = "serdes_ip_cmn_l0_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l0_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l0_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l0_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l0_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_en_attr = "serdes_ip_cmn_l0_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l0_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_start_attr = "serdes_ip_cmn_l0_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l0_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l0_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l0_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l0_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l0_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l0_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l0_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l0_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l0_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l0_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l0_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l0_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l0_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_bti_div_rst_attr = "serdes_ip_cmn_l1_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l1_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnadc_req_attr = "serdes_ip_cmn_l1_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l1_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l1_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l1_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l1_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_en_attr = "serdes_ip_cmn_l1_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l1_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_start_attr = "serdes_ip_cmn_l1_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l1_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l1_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l1_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l1_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l1_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_cdrdiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l1_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l1_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l1_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l1_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l1_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l1_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l1_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l1_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_bti_div_rst_attr = "serdes_ip_cmn_l2_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l2_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnadc_req_attr = "serdes_ip_cmn_l2_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l2_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l2_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l2_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l2_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_en_attr = "serdes_ip_cmn_l2_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l2_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_start_attr = "serdes_ip_cmn_l2_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l2_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l2_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l2_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnrefckbuf_termhiz_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l2_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l2_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l2_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l2_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l2_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l2_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l2_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l2_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l2_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l2_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_bti_div_attr = 54;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_bti_div_rst_attr = "serdes_ip_cmn_l3_cfg_bti_div_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_bti_en_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_bti_static_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr = "serdes_ip_cmn_l3_cfg_cmn_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnadc_req_attr = "serdes_ip_cmn_l3_cfg_cmnadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_acc_ctrl_field_mask_write_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr = "serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_force_state_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_aftr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_stbl_time_bfr_strb_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapb2strbbridgecfg_strb_pulse_width_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnapbmaster_timeout_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr = "serdes_ip_cmn_l3_cfg_cmnaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr = "serdes_ip_cmn_l3_cfg_cmnaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_block_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr = "serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_mask_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_rotate_left_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnaprobedacctrl_tstbus_clkdiv_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnbshihyst_attr = "serdes_ip_cmn_l3_cfg_cmnbshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_restore_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldac_synthdutyoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacfsm_synthdutyoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncaldacsynthdutyoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_pstate_synthdutyoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_rcomp_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalptr_quad_synthdutyoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_biastrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_cap_tune_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_mode_select_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_ref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_rx_term_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tfr_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pd_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcomp_tx_term_pu_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcomp_txterm_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_code_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_init_cal_value_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_max_value_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_tfr_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpd_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf00_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rcomp_txpu_valid_code_lut_vf01_attr = 32'hFD221084;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_init_cal_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_rx_termcode_delta_lut_attr = 24084352;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_initval_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tfr_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_comp_config_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_lpfsetup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_mode_setup_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_reset_release_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_time_sample_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pd_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_capcode_value_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_init_cal_value_attr = 49;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_max_value_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_tx_pu_min_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_comp_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpd_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_comp_inv_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_initval_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_step_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txpu_termcode_delta_lut_attr = 2147483647;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompfsm_txterm_pmos_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_rx_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_tfr_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpd_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_txpu_locovr_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalrcompmaster_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalrcompmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr = "serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmncalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr = "serdes_ip_cmn_l3_cfg_cmnckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_en_attr = "serdes_ip_cmn_l3_cfg_cmnckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr = "serdes_ip_cmn_l3_cfg_cmnckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_start_attr = "serdes_ip_cmn_l3_cfg_cmnckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmndmondac_en_attr = "serdes_ip_cmn_l3_cfg_cmndmondac_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe1_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_aprobe2_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr = "serdes_ip_cmn_l3_cfg_cmnntl_cmn_ntl_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_cmn_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnntl_refckp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpcs_ref_sel_tx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr = "serdes_ip_cmn_l3_cfg_cmnperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_init_termcal_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefckbufprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_delta_attr = 4672;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_init_termcal_rx_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprefcktxdrvprelut_termcal_rx_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_delta_attr = 32767;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_init_termcal_tfr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrcomprxdfeprelut_termcal_tfr_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_cml_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ls_b_path_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_hs_ref_to_cdrdiv_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_ls_cmos_ena_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_powersave_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnrefckbuf_termhiz_b_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefckdrv_powersave_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrefcktxdrv_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr = "serdes_ip_cmn_l3_cfg_cmnrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_entry3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evdn_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry4_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry5_attr = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry6_attr = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s1q7_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpu_evup_delay_lut_sel_s2q0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_dacsynthdutyoffsetfsm_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_devicetrim_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_cal_term_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpuetr_reg_pwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_bias_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_refckbuf_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_rxref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthdutycomp_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_synthlcslowref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpupd_txref_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrpurst_regreset_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_aetrcmn_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_refckbuf_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_rxref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_synthlcslowref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_apdcmn_txref_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_adc_ovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_aprobedac_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_refcktxdrv_hiz_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_arstcmn_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr = "serdes_ip_cmn_l3_cfg_cmnrstpdovr_synthdutycomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_dpma_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnrxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnrxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnspare0_attr = 163;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_cdrdiv_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdiv_slowmed_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutyoffsetcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthdutysel_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthdutysel_mux_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_currentdacdcdmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_synthdutyoffsetmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldac_tx_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_calsynthdutyerr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlccaldacerr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnsynthlcslowref_sel_en_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr = "serdes_ip_cmn_l3_cfg_cmntxref_dpma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr = "serdes_ip_cmn_l3_cfg_cmntxref_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmntxref_sel_en_locovr_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr = "serdes_ip_cmn_l3_cfg_cmnynthdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr = "serdes_ip_cmn_l3_cfg_lbcmn_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr = "serdes_ip_cmn_l3_cfg_lbcmn_synthlcslowmedpostdivclk2cdrrefclken_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompmaster_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr = "serdes_ip_cmn_l3_cfg_rcompslave_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr = "serdes_ip_cmn_l3_cfg_rcompslave_valid_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_rx_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_tfr_termcode_base_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpd_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_rcompterm_txpu_termcode_base_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmed_txbitclkselect_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdiv2clk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedpcs_postdivclk0en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_lev_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr = "serdes_ip_cmn_l3_cfg_synthlcslowmedreg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l0_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l0_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l1_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l1_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l2_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l2_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_max_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_clock_ratio_cnt_min_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_enable_flex_override_value_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_flex_gpi_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_lvl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_gp_pls_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_lms_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_local_tp_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_periodical_rst_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_spa_sat_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr = "serdes_ip_flex_fw_loader_l3_cfg_cfg_vg_inv_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_data_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_fw_loader_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_offset_addr_for_fw_load_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr = "serdes_ip_flex_fw_loader_l3_cfg_single_mode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l0_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l0_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l0_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l0_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l1_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l1_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l1_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l1_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l2_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l2_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l2_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l2_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_cpi_port_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_dfx_secure_visa_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_p_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_ehv_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pa_vdd_pwrgood_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_andme_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bist_modesel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_capturedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_clamp_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit1dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_exit2dr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extest_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extestpulse_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_extesttrain_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_highz_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_mode_en_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_preload_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_runtestidle_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_shiftdr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_txinvert_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_bs_updatedr_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_cmn_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_disconnect_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_isolate_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_jtagslvid_nt_int_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_cdrclk2txen_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_parrx2txtimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lb_tx2rxbuftimeden_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_lfps_en_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_mode_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d1_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_pcie_l1d2_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rcomp_slave_valid_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_rx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_sel_tx_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_ref_term_hiz_en_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxbitslip_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeiosdetectstat_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_clr_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_precal_code_sel_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeq_static_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxeyediag_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_direction_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_mode_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_change_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_offset_l0_nt_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxmargin_start_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxterm_hiz_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_rxwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_spare_nt_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcfast_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcmed_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_divrate_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_synthlcslow_force_pup_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbeacon_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txbist_en_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txclkdivrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdetectrx_req_l0_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levn_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnm2_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_levnp1_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_slew_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txdrv_spare_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txenable_l0_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_gray_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txpam_precode_en_a_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txrate_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_pcs_txwidth_l0_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr = "serdes_ip_if_l3_cfg_ictl_visa_unit_id_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_idat_dfx_obs_dig_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_idat_visa_serial_cfg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr = "serdes_ip_if_l3_cfg_irst_apb_mem_b_reg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_rx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tstbus_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr = "serdes_ip_if_l3_cfg_irst_pcs_tx_l0_b_a_reg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr = "serdes_ip_if_l3_cfg_irst_visa_reset_b_a_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l0_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l0_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l0_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l0_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l0_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l0_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_en_attr = "serdes_ip_lane_aon_l0_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_req_attr = "serdes_ip_lane_aon_l0_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l0_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l0_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l1_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l1_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l1_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l1_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l1_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l1_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_en_attr = "serdes_ip_lane_aon_l1_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_req_attr = "serdes_ip_lane_aon_l1_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l1_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l1_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l2_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l2_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l2_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l2_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l2_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l2_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_en_attr = "serdes_ip_lane_aon_l2_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_req_attr = "serdes_ip_lane_aon_l2_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l2_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l2_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr = "serdes_ip_lane_aon_l3_cfg_laneclk_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr = "serdes_ip_lane_aon_l3_cfg_lanefsm_pmu_req_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_lanetstbus_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_en_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_req_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_rxmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr = "serdes_ip_lane_aon_l3_cfg_rxrstpdovr_apdrx_sqlch_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr = "serdes_ip_lane_aon_l3_cfg_rxsussigdetout_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr = "serdes_ip_lane_aon_l3_cfg_rxsussqlch_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_clr_attr = "serdes_ip_lane_aon_l3_cfg_txmem_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_en_attr = "serdes_ip_lane_aon_l3_cfg_txmem_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_pstate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_req_attr = "serdes_ip_lane_aon_l3_cfg_txmem_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr = "serdes_ip_lane_aon_l3_cfg_txmem_rst_b_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txmem_width_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d1_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txpcs_pciel1d2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr = "serdes_ip_lane_aon_l3_cfg_txrstpdovr_apdtx_drv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_bshihyst_attr = "serdes_ip_lane_l0_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l0_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l0_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l0_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l0_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l0_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_continuous_attr = "serdes_ip_lane_l0_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_en_attr = "serdes_ip_lane_l0_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l0_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_start_attr = "serdes_ip_lane_l0_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l0_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l0_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_en_attr = "serdes_ip_lane_l0_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l0_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l0_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l0_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l0_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_locovren_attr = "serdes_ip_lane_l0_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l0_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l0_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l0_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l0_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l0_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lfps_locovren_attr = "serdes_ip_lane_l0_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_lfps_out_en_attr = "serdes_ip_lane_l0_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l0_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l0_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l0_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l0_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_pcstx_locovren_attr = "serdes_ip_lane_l0_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_polarity_rx_attr = "serdes_ip_lane_l0_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_polarity_tx_attr = "serdes_ip_lane_l0_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_pg_disable_attr = "serdes_ip_lane_l0_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxadc_req_attr = "serdes_ip_lane_l0_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l0_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbias_locovren_attr = "serdes_ip_lane_l0_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l0_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_err_en_attr = "serdes_ip_lane_l0_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_errtype_attr = "serdes_ip_lane_l0_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l0_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l0_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxbshicm_attr = "serdes_ip_lane_l0_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l0_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l0_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l0_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l0_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxclk_locovren_attr = "serdes_ip_lane_l0_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdata_locovren_attr = "serdes_ip_lane_l0_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l0_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l0_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l0_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l0_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l0_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l0_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l0_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l0_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l0_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l0_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l0_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l0_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l0_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l0_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l0_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_en_attr = "serdes_ip_lane_l0_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_locovren_attr = "serdes_ip_lane_l0_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l0_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpam_locovren_attr = "serdes_ip_lane_l0_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l0_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l0_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxphd_locovren_attr = "serdes_ip_lane_l0_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l0_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l0_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l0_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_locovren_attr = "serdes_ip_lane_l0_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l0_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l0_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l0_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l0_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l0_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l0_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l0_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l0_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l0_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l0_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l0_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l0_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxterm_locovren_attr = "serdes_ip_lane_l0_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l0_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l0_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l0_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l0_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l0_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_locovren_attr = "serdes_ip_lane_l0_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_polarity_attr = "serdes_ip_lane_l0_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l0_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l0_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l0_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l0_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trancntout_locovren_attr = "serdes_ip_lane_l0_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l0_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_trandetout_locovren_attr = "serdes_ip_lane_l0_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l0_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l0_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_pg_disable_attr = "serdes_ip_lane_l0_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txadc_req_attr = "serdes_ip_lane_l0_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l0_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l0_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l0_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbeacon_sel_attr = "serdes_ip_lane_l0_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbias_locovren_attr = "serdes_ip_lane_l0_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l0_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_locovren_attr = "serdes_ip_lane_l0_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l0_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbti_data_replication_attr = "serdes_ip_lane_l0_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcal_locovren_attr = "serdes_ip_lane_l0_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l0_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l0_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l0_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l0_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l0_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txclk_locovren_attr = "serdes_ip_lane_l0_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l0_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l0_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l0_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_locovren_attr = "serdes_ip_lane_l0_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_refcken_attr = "serdes_ip_lane_l0_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrv_termref_attr = "serdes_ip_lane_l0_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l0_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l0_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l0_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l0_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l0_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l0_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l0_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l0_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l0_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l0_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l0_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_en_attr = "serdes_ip_lane_l0_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_locovren_attr = "serdes_ip_lane_l0_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l0_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l0_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpam_locovren_attr = "serdes_ip_lane_l0_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpcs_locovren_attr = "serdes_ip_lane_l0_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l0_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l0_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l0_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l0_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l0_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txresetdel_sel_attr = "serdes_ip_lane_l0_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_en_b_attr = "serdes_ip_lane_l0_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l0_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l0_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_en_attr = "serdes_ip_lane_l0_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l0_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l0_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_bshihyst_attr = "serdes_ip_lane_l1_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l1_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l1_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l1_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l1_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l1_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_continuous_attr = "serdes_ip_lane_l1_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_en_attr = "serdes_ip_lane_l1_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l1_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_start_attr = "serdes_ip_lane_l1_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l1_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l1_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_en_attr = "serdes_ip_lane_l1_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l1_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l1_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l1_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l1_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_locovren_attr = "serdes_ip_lane_l1_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l1_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l1_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l1_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l1_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l1_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lfps_locovren_attr = "serdes_ip_lane_l1_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_lfps_out_en_attr = "serdes_ip_lane_l1_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l1_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l1_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l1_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l1_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_pcstx_locovren_attr = "serdes_ip_lane_l1_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_polarity_rx_attr = "serdes_ip_lane_l1_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_polarity_tx_attr = "serdes_ip_lane_l1_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_pg_disable_attr = "serdes_ip_lane_l1_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxadc_req_attr = "serdes_ip_lane_l1_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l1_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbias_locovren_attr = "serdes_ip_lane_l1_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l1_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_err_en_attr = "serdes_ip_lane_l1_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_errtype_attr = "serdes_ip_lane_l1_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l1_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l1_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxbshicm_attr = "serdes_ip_lane_l1_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l1_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l1_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l1_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l1_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxclk_locovren_attr = "serdes_ip_lane_l1_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdata_locovren_attr = "serdes_ip_lane_l1_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l1_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l1_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l1_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l1_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l1_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l1_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l1_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l1_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l1_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l1_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l1_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l1_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l1_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l1_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l1_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_en_attr = "serdes_ip_lane_l1_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_locovren_attr = "serdes_ip_lane_l1_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l1_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpam_locovren_attr = "serdes_ip_lane_l1_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l1_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l1_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxphd_locovren_attr = "serdes_ip_lane_l1_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l1_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l1_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l1_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_locovren_attr = "serdes_ip_lane_l1_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l1_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l1_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l1_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l1_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l1_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l1_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l1_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l1_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l1_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l1_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l1_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l1_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxterm_locovren_attr = "serdes_ip_lane_l1_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l1_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l1_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l1_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l1_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l1_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_locovren_attr = "serdes_ip_lane_l1_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_polarity_attr = "serdes_ip_lane_l1_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l1_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l1_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l1_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l1_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trancntout_locovren_attr = "serdes_ip_lane_l1_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l1_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_trandetout_locovren_attr = "serdes_ip_lane_l1_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l1_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l1_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_pg_disable_attr = "serdes_ip_lane_l1_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txadc_req_attr = "serdes_ip_lane_l1_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l1_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l1_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l1_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbeacon_sel_attr = "serdes_ip_lane_l1_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbias_locovren_attr = "serdes_ip_lane_l1_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l1_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_locovren_attr = "serdes_ip_lane_l1_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l1_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbti_data_replication_attr = "serdes_ip_lane_l1_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcal_locovren_attr = "serdes_ip_lane_l1_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l1_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l1_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l1_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l1_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l1_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txclk_locovren_attr = "serdes_ip_lane_l1_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l1_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l1_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l1_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_locovren_attr = "serdes_ip_lane_l1_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_refcken_attr = "serdes_ip_lane_l1_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrv_termref_attr = "serdes_ip_lane_l1_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l1_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l1_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l1_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l1_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l1_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l1_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l1_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l1_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l1_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l1_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l1_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_en_attr = "serdes_ip_lane_l1_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_locovren_attr = "serdes_ip_lane_l1_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l1_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l1_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpam_locovren_attr = "serdes_ip_lane_l1_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpcs_locovren_attr = "serdes_ip_lane_l1_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l1_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l1_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l1_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l1_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l1_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txresetdel_sel_attr = "serdes_ip_lane_l1_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_en_b_attr = "serdes_ip_lane_l1_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l1_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l1_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_en_attr = "serdes_ip_lane_l1_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l1_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l1_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_bshihyst_attr = "serdes_ip_lane_l2_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l2_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l2_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l2_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l2_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l2_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_continuous_attr = "serdes_ip_lane_l2_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_en_attr = "serdes_ip_lane_l2_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l2_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_start_attr = "serdes_ip_lane_l2_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l2_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l2_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_en_attr = "serdes_ip_lane_l2_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l2_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l2_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l2_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l2_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_locovren_attr = "serdes_ip_lane_l2_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l2_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l2_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l2_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l2_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l2_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lfps_locovren_attr = "serdes_ip_lane_l2_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_lfps_out_en_attr = "serdes_ip_lane_l2_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l2_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l2_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l2_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l2_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_pcstx_locovren_attr = "serdes_ip_lane_l2_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_polarity_rx_attr = "serdes_ip_lane_l2_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_polarity_tx_attr = "serdes_ip_lane_l2_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_pg_disable_attr = "serdes_ip_lane_l2_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxadc_req_attr = "serdes_ip_lane_l2_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l2_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbias_locovren_attr = "serdes_ip_lane_l2_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l2_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_err_en_attr = "serdes_ip_lane_l2_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_errtype_attr = "serdes_ip_lane_l2_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l2_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l2_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxbshicm_attr = "serdes_ip_lane_l2_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l2_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l2_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l2_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l2_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxclk_locovren_attr = "serdes_ip_lane_l2_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdata_locovren_attr = "serdes_ip_lane_l2_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l2_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l2_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l2_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l2_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l2_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l2_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l2_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l2_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l2_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l2_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l2_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l2_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l2_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l2_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l2_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_en_attr = "serdes_ip_lane_l2_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_locovren_attr = "serdes_ip_lane_l2_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l2_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpam_locovren_attr = "serdes_ip_lane_l2_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l2_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l2_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxphd_locovren_attr = "serdes_ip_lane_l2_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l2_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l2_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l2_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_locovren_attr = "serdes_ip_lane_l2_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l2_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l2_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l2_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l2_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l2_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l2_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l2_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l2_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l2_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l2_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l2_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l2_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxterm_locovren_attr = "serdes_ip_lane_l2_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l2_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l2_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l2_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l2_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l2_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_locovren_attr = "serdes_ip_lane_l2_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_polarity_attr = "serdes_ip_lane_l2_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l2_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l2_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l2_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l2_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trancntout_locovren_attr = "serdes_ip_lane_l2_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l2_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_trandetout_locovren_attr = "serdes_ip_lane_l2_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l2_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l2_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_pg_disable_attr = "serdes_ip_lane_l2_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txadc_req_attr = "serdes_ip_lane_l2_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l2_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l2_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l2_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbeacon_sel_attr = "serdes_ip_lane_l2_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbias_locovren_attr = "serdes_ip_lane_l2_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l2_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_locovren_attr = "serdes_ip_lane_l2_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l2_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbti_data_replication_attr = "serdes_ip_lane_l2_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcal_locovren_attr = "serdes_ip_lane_l2_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l2_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l2_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l2_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l2_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l2_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txclk_locovren_attr = "serdes_ip_lane_l2_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l2_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l2_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l2_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_locovren_attr = "serdes_ip_lane_l2_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_refcken_attr = "serdes_ip_lane_l2_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrv_termref_attr = "serdes_ip_lane_l2_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l2_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l2_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l2_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l2_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l2_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l2_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l2_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l2_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l2_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l2_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l2_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_en_attr = "serdes_ip_lane_l2_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_locovren_attr = "serdes_ip_lane_l2_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l2_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l2_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpam_locovren_attr = "serdes_ip_lane_l2_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpcs_locovren_attr = "serdes_ip_lane_l2_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l2_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l2_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l2_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l2_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l2_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txresetdel_sel_attr = "serdes_ip_lane_l2_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_en_b_attr = "serdes_ip_lane_l2_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l2_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l2_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_en_attr = "serdes_ip_lane_l2_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l2_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l2_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_bshihyst_attr = "serdes_ip_lane_l3_cfg_bshihyst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levn_attr = 53;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_bstxdrv_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr = "serdes_ip_lane_l3_cfg_calsqlchosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_calsqlchosc_trimcode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr = "serdes_ip_lane_l3_cfg_cdrclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr = "serdes_ip_lane_l3_cfg_etrregrxcdrclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_avg_en_attr = "serdes_ip_lane_l3_cfg_laneckm_avg_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_clk_en_attr = "serdes_ip_lane_l3_cfg_laneckm_clk_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_continuous_attr = "serdes_ip_lane_l3_cfg_laneckm_continuous_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_dig_meas_err_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_en_attr = "serdes_ip_lane_l3_cfg_laneckm_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_max_thr_attr = 33554431;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_meas_ck_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_ref_ck_div_ratio_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_result_clr_attr = "serdes_ip_lane_l3_cfg_laneckm_result_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_start_attr = "serdes_ip_lane_l3_cfg_laneckm_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_wdt_interval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneckm_win_thr_ref_attr = 16777215;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepcs_locovren_attr = "serdes_ip_lane_l3_cfg_lanepcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr = "serdes_ip_lane_l3_cfg_lanepcs_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_start_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_compare_val_stop_attr = 255;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_en_attr = "serdes_ip_lane_l3_cfg_laneperfmon_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_laneperfmon_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lanepmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr = "serdes_ip_lane_l3_cfg_lb_cdrclk2txen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr = "serdes_ip_lane_l3_cfg_lb_cdrclkdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2exten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr = "serdes_ip_lane_l3_cfg_lb_cdrdivclk2txen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr = "serdes_ip_lane_l3_cfg_lb_hsclk2cdrdiven_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_locovren_attr = "serdes_ip_lane_l3_cfg_lb_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr = "serdes_ip_lane_l3_cfg_lb_parrx2txtimeden_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_pllfbclk2cdrrefclken_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr = "serdes_ip_lane_l3_cfg_lb_rx2txuntimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr = "serdes_ip_lane_l3_cfg_lb_rxwordck2pcstxwordcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_lsb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxbuftimeden_msb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr = "serdes_ip_lane_l3_cfg_lb_tx2rxiotimeden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lfps_det_locovr_attr = "serdes_ip_lane_l3_cfg_lfps_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lfps_locovren_attr = "serdes_ip_lane_l3_cfg_lfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_lfps_out_en_attr = "serdes_ip_lane_l3_cfg_lfps_out_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcslfps_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcslfps_locovren_attr = "serdes_ip_lane_l3_cfg_pcslfps_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr = "serdes_ip_lane_l3_cfg_pcsrx_dme_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcsrx_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr = "serdes_ip_lane_l3_cfg_pcsrxbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcsrxbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr = "serdes_ip_lane_l3_cfg_pcstx_beaconen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_pcstx_locovren_attr = "serdes_ip_lane_l3_cfg_pcstx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_polarity_rx_attr = "serdes_ip_lane_l3_cfg_polarity_rx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_polarity_tx_attr = "serdes_ip_lane_l3_cfg_polarity_tx_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_rx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_frac_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_pg_disable_attr = "serdes_ip_lane_l3_cfg_rx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_amode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_bmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_dmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rx_synth_sel_emode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxadc_req_attr = "serdes_ip_lane_l3_cfg_rxadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr = "serdes_ip_lane_l3_cfg_rxagc_dccoupleen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_rxaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_rxaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbias_iccadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbias_icvadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbias_locovren_attr = "serdes_ip_lane_l3_cfg_rxbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbias_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_four_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_one_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_three_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_burst_two_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr = "serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_cdrlock2data_postamble_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr = "serdes_ip_lane_l3_cfg_rxbist_clear_errcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_err_en_attr = "serdes_ip_lane_l3_cfg_rxbist_err_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_errmask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_errtype_attr = "serdes_ip_lane_l3_cfg_rxbist_errtype_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_firsterr_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_lockchk_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_maxbitcnt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr = "serdes_ip_lane_l3_cfg_rxbist_mostrecent_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_relock_itercount_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr = "serdes_ip_lane_l3_cfg_rxbitslip_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbscan_vref_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxbshicm_attr = "serdes_ip_lane_l3_cfg_rxbshicm_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_iclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_qclk_gray_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalduty_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_i_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div1_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div2_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div4_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyctrl_q_div8_bin_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_comp_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_i_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeas_q_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_comp_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_i_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutymeasout_q_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_centerfreq_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_end_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd0_attr = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd1_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd2_attr = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd3_attr = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_hscount_muxd4_attr = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_centerfreq_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_initval_fosc_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfosc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfosc_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreq_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_centerfreqoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_fosc_finishside_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_foscoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfosccoarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_calfoscfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpfax_centerfreqfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsm_vcorepen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_count_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_dlycount_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalfoscmeasout_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_int_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalfoscval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_init_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr = "serdes_ip_lane_l3_cfg_rxcaloffsetfsmout_input_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_i_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_duty_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_dutycomp_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_foscfsm_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_offsetfsm_init_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_regopampoffset_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlch_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_pstate_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_i_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_duty_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_foscfsm_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_offsetfsm_init_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_rxppm_lockstatus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlch_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_sqlchosc_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalptr_quad_synthppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_clear_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_caldone_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_ref_cnt_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_settle_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalsqlchoscmeas_smpl_cnt_attr = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvbiascap_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcoopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_initval_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_runcount_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetfsmout_runcount_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_rxcalvcorepoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_rxcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdiv_moddiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd0_attr = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd1_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd2_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd3_attr = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrfbdivslip_mdiv_muxd4_attr = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr = "serdes_ip_lane_l3_cfg_rxcdrpfd_propgain_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrpfd_pulsewidth_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_bitshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forcedn_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr = "serdes_ip_lane_l3_cfg_rxcdrphd_forceup_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_doublerate2s2p_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrphdrate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrrefck_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastop_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_biastopbypass_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_high_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_datapropgain_low_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_flickerdegen_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_gmfoscshort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intf_fil_short_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_intrj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr = "serdes_ip_lane_l3_cfg_rxcdrvco_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxcdrvco_refpropgain_nom_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_cdrfb_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_rxclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxclk_locovren_attr = "serdes_ip_lane_l3_cfg_rxclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdat_nrz_64b80b_bcword_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxdata_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdata_locovren_attr = "serdes_ip_lane_l3_cfg_rxdata_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr = "serdes_ip_lane_l3_cfg_rxdatapath_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_on_state_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr = "serdes_ip_lane_l3_cfg_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfe_datatap_vcasc_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfe_dfebiasadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr = "serdes_ip_lane_l3_cfg_rxdfe_nbiasctle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfe_vcasc_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxdfeterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfeterm_termcal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datamid_edge_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr = "serdes_ip_lane_l3_cfg_rxdfeyadjdac_datatopbot_aux_coarse_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasscdrpdetupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenfosc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr = "serdes_ip_lane_l3_cfg_rxdpif_bypassenupdnsmpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypassfosc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_bypasspllpfdupdnsmpl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_data2pll_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr = "serdes_ip_lane_l3_cfg_rxdpif_deltasigmode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr = "serdes_ip_lane_l3_cfg_rxdpif_fastref_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr = "serdes_ip_lane_l3_cfg_rxdpif_fosc_sample_pedge_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_init_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gaindelaycount_pow2_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_10b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_16b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_20b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_32b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_40b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_64b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_80b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2dat_8b_pow2_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainlocked2ref_pow2_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_gainunlocked_pow2_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initintegrator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr = "serdes_ip_lane_l3_cfg_rxdpif_initmodulator_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_length_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr = "serdes_ip_lane_l3_cfg_rxdpif_jit_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr = "serdes_ip_lane_l3_cfg_rxdpif_modck_ctrl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_pll2data_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_restore_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_store_cntr_attr = 258;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpif_trnsfrdelay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_inten_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr = "serdes_ip_lane_l3_cfg_rxdpiffreeze_moden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr = "serdes_ip_lane_l3_cfg_rxdutyselpolarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr = "serdes_ip_lane_l3_cfg_rxflxgate_force_rxeq_gate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr = "serdes_ip_lane_l3_cfg_rxflxgate_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxfoscstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_rxfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_rxlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_attr = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxlock2datatmr_short_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_en_attr = "serdes_ip_lane_l3_cfg_rxntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_locovren_attr = "serdes_ip_lane_l3_cfg_rxntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_rxntl_rxp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_acc_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2data_gater_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_cdrlock2datatmr_optcl_sel_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_enter_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_exit_lock2data_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2data_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_force_lock2ref_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_hold_timer_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_intf_ovrd_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_mod_freeze_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ovrd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_ppm_detect_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_prop_freeze_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_rxdata_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr = "serdes_ip_lane_l3_cfg_rxoptclfastlock_skip_init_lock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpam_locovren_attr = "serdes_ip_lane_l3_cfg_rxpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdiv_p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr = "serdes_ip_lane_l3_cfg_rxpcs_postdivclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_rxpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_hold_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr = "serdes_ip_lane_l3_cfg_rxphd_gain_zero_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxphd_locovren_attr = "serdes_ip_lane_l3_cfg_rxphd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxphd_nrz8b10b_pam16b20b_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxphd_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr = "serdes_ip_lane_l3_cfg_rxphd_sign_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr = "serdes_ip_lane_l3_cfg_rxpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_h_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_max_offset_l_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_freq_ref_cnt_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcfast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcmed_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr = "serdes_ip_lane_l3_cfg_rxppm_lockstatus_synthlcslow_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_locovren_attr = "serdes_ip_lane_l3_cfg_rxppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftcount_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_ppmdriftmax_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr = "serdes_ip_lane_l3_cfg_rxppm_unlock_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd1_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd2_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd3_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_fast_muxd4_attr = 666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd0_attr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd1_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd2_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd3_attr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppm_watchdogtmr_muxd4_attr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmlockstat_sticky_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr = "serdes_ip_lane_l3_cfg_rxppmtmr_watchdogtmr_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_rxratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_clk_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_rxratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxreg_lev_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr = "serdes_ip_lane_l3_cfg_rxreg_vreg_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_en_b_attr = "serdes_ip_lane_l3_cfg_rxrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry4_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry5_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry6_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q5_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_fosc_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cal_sqlch_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_cdrfb_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrfbdivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_cdrmoddivcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpuetr_termhiz_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_auxcomp_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_datfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_dfe_yadj_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_hifreqagc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_sqlch_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpupd_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_cdrfbdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_dpif_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pdet_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_pfd_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_ppm_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pa_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_s2pb_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr0_s_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrpurst_vco_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrfbdivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_cdrmoddivcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrrx_termhiz_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_aetrsynth_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_auxcomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_bias_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ctlecomp_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_datfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_bias_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_dfe_yadj_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_hifreqagc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_apdrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_cdrfbdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pdet_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_pfd_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pa_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_s2pb_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstrx_vco_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_arstsynth_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_dpif_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr = "serdes_ip_lane_l3_cfg_rxrstpdovr_drstrx_ppm_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdet_cdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_diglfpsdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrancnten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_digtrandeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_eiosdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_enable_attr = "serdes_ip_lane_l3_cfg_rxsigdet_enable_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_fastlock_winsize_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_leveldeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_lfpsexit_delay_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdet_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_ppmdeten_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeq_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxeqen_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_dncount_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_rxleveldet_debounce_upcount_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr = "serdes_ip_lane_l3_cfg_rxsigdet_sigdet_debounce_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr = "serdes_ip_lane_l3_cfg_rxsigdet_tmr_clksel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr = "serdes_ip_lane_l3_cfg_rxsigdet_toggle_count_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdet_toggle_monitor_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_eiosdetectstat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrcdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetin_ovrencdrlock2data_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_lock2data_noforce_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr = "serdes_ip_lane_l3_cfg_rxsigdetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxspare0_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxspare1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxspare_attr = 30752;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_one_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_consec_zero_thresh_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_cycle_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_dat_bitorder_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr = "serdes_ip_lane_l3_cfg_rxsqlchlfps_debounce_type_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_thresh_attr = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_one_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_thresh_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsqlchlfps_zero_run_length_timeout_attr = 103;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr = "serdes_ip_lane_l3_cfg_rxsynthdiv_slowmed_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxterm_cal_locovr_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxterm_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxterm_locovren_attr = "serdes_ip_lane_l3_cfg_rxterm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxterm_modeselect_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr = "serdes_ip_lane_l3_cfg_rxtermhiz_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqgain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_acqtime_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_quiet_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_cal_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_calctrl_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_calen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_caltimer_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr = "serdes_ip_lane_l3_cfg_sqlch_clkgate_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr = "serdes_ip_lane_l3_cfg_sqlch_cmshiften_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_gain_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_acq_pct_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_cal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_clr_errlog_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_controller_mode_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr = "serdes_ip_lane_l3_cfg_sqlch_cont_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_pause_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_postcal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_precal_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_cont_quiet_time_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr = "serdes_ip_lane_l3_cfg_sqlch_lfps_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_locovren_attr = "serdes_ip_lane_l3_cfg_sqlch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_ovrd_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_pkdet_freqsel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_polarity_attr = "serdes_ip_lane_l3_cfg_sqlch_polarity_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_rdacen_attr = "serdes_ip_lane_l3_cfg_sqlch_rdacen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_thresh_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_time_out_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr = "serdes_ip_lane_l3_cfg_sqlch_vrefsel_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_deb_status_cnt_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_en_attr = "serdes_ip_lane_l3_cfg_sqlchdeb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_ign_cnt_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_sigdet_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdeb_thresh_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_debounced_status_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_exit_good_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr = "serdes_ip_lane_l3_cfg_sqlchdebout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trancnt_off_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trancnt_on_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trancntout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trancntout_locovren_attr = "serdes_ip_lane_l3_cfg_trancntout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandet_ax_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandet_ay_attr = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandet_off_h_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandet_off_l_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandet_on_h_attr = 39;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandet_on_l_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr = "serdes_ip_lane_l3_cfg_trandetout_det_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_trandetout_locovren_attr = "serdes_ip_lane_l3_cfg_trandetout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_en_attr = "serdes_ip_lane_l3_cfg_tx2rxlb_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx2rxlb_init_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_cmn_on_state_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr = "serdes_ip_lane_l3_cfg_tx_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_pg_disable_attr = "serdes_ip_lane_l3_cfg_tx_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_synth_on_state_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_amode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_bmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_cmode_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_dmode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_synth_sel_emode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_tx_txdetrx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txadc_count_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txadc_req_attr = "serdes_ip_lane_l3_cfg_txadc_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txaprobe_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr = "serdes_ip_lane_l3_cfg_txaprobe_lastmux_isolate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_current_direction_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr = "serdes_ip_lane_l3_cfg_txaprobeadc_resistor_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txaprobeadc_vcm_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr = "serdes_ip_lane_l3_cfg_txbdvdr_pma2pcstxworden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbeacon_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbeacon_sel_attr = "serdes_ip_lane_l3_cfg_txbeacon_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbias_icc20uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbias_icc80uadj_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbias_locovren_attr = "serdes_ip_lane_l3_cfg_txbias_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbias_termcal_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_biterror_en_attr = "serdes_ip_lane_l3_cfg_txbist_biterror_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_locovren_attr = "serdes_ip_lane_l3_cfg_txbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_modesel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_oobmode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtburst_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomrstinit_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomsas_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_oobtcomwake_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_seed_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_size_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf00_attr = 1985229328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf01_attr = 32'hFEDCBA98;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbist_udp_vf09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr = "serdes_ip_lane_l3_cfg_txbit_select_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbti_data_replication_attr = "serdes_ip_lane_l3_cfg_txbti_data_replication_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txbti_tx_idle_data_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcal_locovren_attr = "serdes_ip_lane_l3_cfg_txcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcal_tclkduty_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalduty_bin_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalduty_locovren_attr = "serdes_ip_lane_l3_cfg_txcalduty_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalduty_sel_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutybg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycomp_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycomp_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_initval_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_precalfsmstart_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_dlycount_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutycompmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcaldutyfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_dlycount_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_pow2count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_erravg_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutymeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr = "serdes_ip_lane_l3_cfg_txcaldutystat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_duty_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_dutycomp_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_duty_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_dutycomp_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_maxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr = "serdes_ip_lane_l3_cfg_txcaltclkdutyforce_div1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr = "serdes_ip_lane_l3_cfg_txcdrdiv_local_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr = "serdes_ip_lane_l3_cfg_txclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txclk_locovren_attr = "serdes_ip_lane_l3_cfg_txclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr = "serdes_ip_lane_l3_cfg_txclkgenmuxsel_txinternal_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrx_thr_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_count_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeas_validdlycount_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeaspcs_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr = "serdes_ip_lane_l3_cfg_txdetectrxmeasval_stat_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levn_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnm1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdetrx_levnp2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr = "serdes_ip_lane_l3_cfg_txdrv_hizen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_levn_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnm1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_levnp2_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_locovren_attr = "serdes_ip_lane_l3_cfg_txdrv_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_refcken_attr = "serdes_ip_lane_l3_cfg_txdrv_refcken_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrv_termref_attr = "serdes_ip_lane_l3_cfg_txdrv_termref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr = "serdes_ip_lane_l3_cfg_txdrvmute_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr = "serdes_ip_lane_l3_cfg_txduty_ctrl_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr = "serdes_ip_lane_l3_cfg_txduty_pad_sense_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div1_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div2_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr = "serdes_ip_lane_l3_cfg_txdutycal_div8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr = "serdes_ip_lane_l3_cfg_txfifo_elecidle_deskew_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr = "serdes_ip_lane_l3_cfg_txfifo_force_txidlebit1_zero_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_10b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_16b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_20b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_32b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_40b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_64b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_80b_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_dly_8b_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfifo_kill_en_attr = "serdes_ip_lane_l3_cfg_txfifo_kill_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr = "serdes_ip_lane_l3_cfg_txfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txfsm_main_on_state_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr = "serdes_ip_lane_l3_cfg_txlanepam_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txlanepam_locovren_attr = "serdes_ip_lane_l3_cfg_txlanepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr = "serdes_ip_lane_l3_cfg_txmeaslatovrhd_meas_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txmute_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_changeref_val_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_chrgtime_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_en_attr = "serdes_ip_lane_l3_cfg_txntl_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_fsmclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_locovren_attr = "serdes_ip_lane_l3_cfg_txntl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_pdmtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_pdn_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_pumtchval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_pup_vrefcode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_smpltime_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txm_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_charge_up_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_pull_dn_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr = "serdes_ip_lane_l3_cfg_txntl_txp_sense_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr = "serdes_ip_lane_l3_cfg_txp2s_txwordsyncbypen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpam_bitorder_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_gray_en_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpam_locovren_attr = "serdes_ip_lane_l3_cfg_txpam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpam_precode_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpcs_locovren_attr = "serdes_ip_lane_l3_cfg_txpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr = "serdes_ip_lane_l3_cfg_txpcs_txenable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr = "serdes_ip_lane_l3_cfg_txpcsbist_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr = "serdes_ip_lane_l3_cfg_txpcsbist_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr = "serdes_ip_lane_l3_cfg_txratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_locovren_attr = "serdes_ip_lane_l3_cfg_txratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txresetdel_sel_attr = "serdes_ip_lane_l3_cfg_txresetdel_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_en_b_attr = "serdes_ip_lane_l3_cfg_txrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s4q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evdn_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s2q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s3q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s4q1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpu_evup_delay_lut_sel_s5q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_duty_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_bitckdvdrcken_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_bias_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr0_s_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_drvdoze_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_p2s_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr0_s_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_pma2pcstxword_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_regreset_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrpurst_txdetectrx_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_bitckdvdrcken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_aetrtx_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_b_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_drvdoze_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_duty_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_ntl_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_p2s_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_apdtx_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_adc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_pma2pcstxword_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_regreset_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr = "serdes_ip_lane_l3_cfg_txrstpdovr_arsttx_txdetectrx_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txspare0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txspare_attr = 384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txterm_coarse_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr = "serdes_ip_lane_l3_cfg_txtermtrim_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_nmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txtermtrim_pmos_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_en_attr = "serdes_ip_lane_l3_cfg_txwclk_div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr = "serdes_ip_lane_l3_cfg_txwclk_div_smpl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_l3_cfg_txwptr_init_rx2txparlb_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l0_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l0_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l0_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l1_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l1_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l1_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l2_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l2_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l2_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_cdrlock2data_loc_ov_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_div_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr = "serdes_ip_lane_rxeq_l3_cfg_dfeyadj_aging_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_ctlecomp_filterbypass_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_calfsmmeas_dlycount_attr = 392;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_coarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxbgcalorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_calbiasboost_use_lut_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_callbbiasboost_use_lut_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_smplrcal_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlecomp_filterbypass_tfrcal_stg3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_smplrcal_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctleinput_probe_mux_tfrcal_stg3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_probe_mux_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_smplrcal_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_state_en_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg1_use_stg2code_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg2_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_probe_mux_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_smplrcal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_ctlestg3_state_en_tfrcal_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_inputcmadjust_stg3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcal_sdimode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_smplroffset_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcal_tfrtrim_outen_tfrcal_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_iqclk_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalalign_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_abort_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_cal_type_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_input_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg1_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg2_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_probemuxen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecalctrl_stg3_stateen_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalctlecompoffsetfsmout_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaldutybkgnd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_biasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf1resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2cap_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf2reszero_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3deq_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf3resdcgain_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_hf4deq_gray_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaleq_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg1_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg2_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_ctlecmnmode_stg3_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsm_smplroffset_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg1_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg2_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_ctlecmnmode_stg3_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalfsmmeas_smplroffset_invert_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_ctlecmnmode_stg3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_aux1_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d0_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_bot_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_mid_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_d1_top_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e0_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalinit_smplroffset_e1_lo_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_pow2count_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasin_req_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_ack_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp0_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp1_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_avg_grp2_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalmeasout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_auxdatacomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_boost_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_edgecomp_offset_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcaloffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_clear_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_cal_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_cal_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_comp_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcalsummerfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxcdrphd_override_ignore_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_caloffset_range_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg1offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg2offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_calstg3offset_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_dccouple_sigpath_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_lbbiasboost_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg1tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg2tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_stg3tfrtrim_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outmem_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctle_tfrtrim_outpen_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_dccouple_tgate_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxctledc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfe_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfe_tapgain_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_enable_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdfepam_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_enb_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxdpifjit_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqadj_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_amux_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_dmux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqauxxor_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_pstate_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcal2flx_rate_mask_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_16e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_1e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_2e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_4e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8a_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8b_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8c_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8d_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalhfagcbiasadj_lut_8e_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcallofreqagcgain_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_16e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_1e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_2e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_4e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8a_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8b_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8c_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8d_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcalmidbandzero_lut_8e_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcals_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_datasummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer0_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcals_offset_edgesummer1_preenc_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqcdr_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctl_fg_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqagcres_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctlelut_hifreqvgagain_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_oddeven_tapgain_sel_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqctls_static_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_aux_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdat_edge_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_auxswap_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatactl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdatarate_rx_rate_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqdfeyadj_agingl2r_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge0lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqedgeadj_yadjust_edge1lo_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_err_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_ehm_fom_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_data_extshift_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_50p_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_distance_th_rate_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_err_mask_vf01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf00_attr = 67108864;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_event_rate_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf00_attr = 5505024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_general_in_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_50p_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_lms_th_rate_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_mask_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_50p_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_no_change_th_rate_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_50p_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_reflections_num_rate_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehm_slicer_swap_cb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_sym_dly_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_aux_slicer_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehm_test_hits_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_ehm_yadjust_aux1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_ehm_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_aux_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_ehm_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_ehm_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_data_yadj_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqehmyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ehm_ehm_run_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_coarse_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_ctrl_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_dfecore_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_freeze_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_incr_decr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_mu_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2lms_rst_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx2ofc_ofc_en_ovrden_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_clr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflx_pcs_rxeq_static_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie1_map_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie2_map_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie3_map_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflx_rxrate2pcie4_map_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_ehm_data_slc_sel_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxehmdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_generalpurpose_reg_in_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxfsm_pause_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_force_ltr_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxltr_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxpcsrxeyediag_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqflxsigdet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqfsm2ofc_ofc_cal_req_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_16e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_1e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_2e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_4e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8a_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8b_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8c_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8d_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqhf2cap_lut_8e_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_done_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmax_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_satmin_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_auxvref_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_calalign_iqclk_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfedatatapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_caldfeedgetapgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqagcres_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_hifreqvgagain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlms2flx_stable_lofreqagcgain_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_ack_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_chng_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsupd_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_lms_vref1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjaux_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_lms_aux_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_lms_aux_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjauxltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d0_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_bot_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_mid_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_lms_yadjust_d1_top_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdata_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_lms_data_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_lms_data_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjdataltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge0_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_lms_yadjust_edge1_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedge_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_lms_edge_yadjust_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeen_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_lms_edge_latch_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqlmsyadjedgeltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_aux_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_dfe_data_yadj_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltch_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_auxswap_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqltchc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofc2flx_ofc_cal_done_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxinpprobemuxen_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg1probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_h_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_adapt_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_ctle_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxinpprobemuxen_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1_stateen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg1probemuxen_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg2probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3_stateen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_summer_rxstg3probemuxen_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_cal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_ctle_st3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_idle_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_d1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_compsel_sa_e1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_invert_comp_fb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_h_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_lpexitcal_time_l_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_adapt_thr_sel_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_cal_thr_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_data_disp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_leak_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_disparity_thr_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpexitcal_en_attr = 253;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_ofc_lpf_bypass_en_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_pre_timer_setting_pow2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxinpprobemuxen_idle_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg1probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg2probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3_stateen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqofccfg_rxstg3probemuxen_idle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqout_init_restore_avail_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_code_sel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqprecal_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf1deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf2reszero_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_hf3deq_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf00_attr = 599186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf1deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf00_attr = 1198372;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf00_attr = 32'hFFC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf2reszero_vf01_attr = 2097151;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf00_attr = 2396744;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_idx_hf3deq_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf1deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf2reszero_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_boostlut_init_hf3deq_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqagcres_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_hifreqvgagain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_cal_yadjust_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_biasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf1resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_hf3resdcgain_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_biasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf00_attr = 32'hAAAAAAAA;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf01_attr = 715827882;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf1resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf00_attr = 1431655764;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf01_attr = 1431655765;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_hf3resdcgain_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_idx_lbbiasboost_vf02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_biasboost_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf1resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_hf3resdcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_init_lbbiasboost_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_gainlut_lbbiasboost_dir_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_latch_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref0_initval_attr = 61;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref1_initval_attr = 191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref2_initval_attr = 321;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref3_initval_attr = 451;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pam4adj_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_pol_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_hi_attr = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_auxvref_targ_0_lo_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_auxvref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_dfe_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edge_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_edgevref_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_iqalign_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_level_vga_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_block_vote_vga_vf01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_blockcount_fast_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_coarse_detect_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_continuous_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_incr_decr_swizzle_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_datastats_thres_attr = 1023;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe1_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe2_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe3_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe4p_accum_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_core_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_inner_lvl_filter_en_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap2_attr = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap3_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_dfe_targtap4_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_incr_decr_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_pol_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edge_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_initval_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_edgevref_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_fast_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_auxvref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edge_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_edgevref_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_filter_mode_vga_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_auxvrefupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_dfeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgeupd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_edgevrefupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_forcebg_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_hifreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_iqalignupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_lofreqagcupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_freeze_vgaupd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_gated_update_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_n5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_hifreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_init_adapt_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_iqalign_targ_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_itercount_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_delay_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_latch_prepost_delay_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_level_en_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_pol_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_lofreqagc_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_auxvref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_dfe_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edge_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_edgevref_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_hifreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_iqalign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_lofreqagc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_logain_vga_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_auxvref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe23_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_dfe4p_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edge4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_edgevref_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_hifreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_iqalign_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_lofreqagc_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_mu_vga_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_nrz_to_pam4_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_slow_blockcnt_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_start_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_tsettle_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_count_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_accum_level_en_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_decr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_reset_type_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_frac_rst_prd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_incr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_periodic_frac_reset_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_single_step_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_distance_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_nochange_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reflect_th_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_vga_stable_reset_mask_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lms_yadjdata_mid_clamp_zero_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_lofreqagcgain_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal0_lofreqagcgain_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap1gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal1_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap1gain_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal2_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap1gain_attr = 24;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal3_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal4_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal5_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal6_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap1gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap2gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap3gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfedatatap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap2gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap3gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_caldfeedgetap4gain_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_precal7_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_auxshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_capture_trigger_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_dat_bitsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_datashft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_edgeshft_nrz8b10b_pam16b20b_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqset_shift_polarity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap10gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap11gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap12gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap13gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap14gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap15gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap16gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap1gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap2gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap5gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap6gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap7gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap8gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfedatatap9gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap2gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap3gain_attr = 64;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_caldfeedgetap4gain_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_iqalign_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_static_lofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref0_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref1_attr = 223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref2_attr = 339;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_auxvref3_attr = 456;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfedatatap1gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_caldfeedgetap2gain_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_calhifreqagcres_attr = 52;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_callofreqagcgain_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_edgevref_attr = 511;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_hifreqvgagain_attr = 77;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmax_iqalign_attr = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref0_attr = 56;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref1_attr = 173;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref2_attr = 289;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_auxvref3_attr = 356;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfedatatap1gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_caldfeedgetap2gain_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_calhifreqagcres_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_callofreqagcgain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_edgevref_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_hifreqvgagain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqset_swpmin_iqalign_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsetnrztopam4_switch_locovr_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsigdet_pause_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqspare1_attr = 15871;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqsync2flx_rxdatapath_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap13to16_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap1to4_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap5to8_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_data_tap9to12_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_edge_tap_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap1to4gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqtapctrl_tap5to16gain_dbl_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_hifreqagcbiasadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalc_midbandzero_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvalcl_lofreqagcgain_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap01gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap05gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap06gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap07gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap08gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap09gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap10gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap11gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap12gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap13gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap14gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap15gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_caldfedatatap16gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvald_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap02gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap03gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_caldfeedgetap04gain_graysm_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxeqvale_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1cal_clear_mask_attr = 8184;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_aux1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d0_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_bot_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_mid_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_d1_top_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e0_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg1calorder_smplroffset_e1_lo_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2cal_clear_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_ctlecmnmode_stg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_aux1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d0_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_bot_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_mid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_d1_top_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e0_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfg2calorder_smplroffset_e1_lo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_calfsmmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_fsmmaxiter_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_coarse_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxfgcal_lpfax_fine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_inputcmadjust_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxhifreqagc_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcal_clear_mask_attr = 8191;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_ctlecmnmode_stg3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_aux1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d0_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_bot_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_mid_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_d1_top_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e0_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxinitcalorder_smplroffset_e1_lo_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_flx_jit_offset_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_disable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_enable_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_offset_shift_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_jit_setup_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_comp_mask_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_forcel2d_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmargin_volt_offset_shift_d1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_direction_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_flx_jit_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_mode_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_change_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_offset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr = "serdes_ip_lane_rxeq_l3_cfg_rxmarginin_start_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_cm_vref_attr = 50;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr = "serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_lane_rxeq_l3_cfg_rxsum_summer_cmfb_ibias_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l0_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l1_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l2_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd0_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd1_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd2_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd3_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_apb_dwmask_muxd4_attr = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_a2f_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_anamonmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_dtr_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boost_fine_const_zeta_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd0_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd1_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd2_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd3_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_boostgain_maxcnt_muxd4_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_cb56_lane32div_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_cb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_clkouten_lane_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_cnt_max_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_max_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd0_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd1_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd2_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd3_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_coarse_loop_gscale_min_muxd4_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcocoarse_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dcosettle_time_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_cnt_restart_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dft_freq_meas_enable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_disable_dft_timer_ovrd_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrd_offset_ovr_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrddir_ovr_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_feedfwrdphase_ovr_val_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_dir_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_enable_ovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_toggle_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dfx_ramp_val_ovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_bypass_mode_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd0_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd1_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd2_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd3_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dpso_marker_muxd4_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_earlylock_timer_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_final_code_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_boost_val_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd1_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd3_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_int_coeff_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrd_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_ovrden_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_boost_val_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_dtr_prop_coeff_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_earlylock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_en_peak_sense_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_clkgate_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fbdiv_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_dtr_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_filter_boostfade_fine_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine2dtr_ratio_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_first_boost_repeat_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd0_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd1_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd2_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_high_limit_muxd4_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_step_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_boost_val_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_int_coeff_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd0_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd1_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd2_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd3_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_low_limit_muxd4_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_modulation_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_step_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_boost_val_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fine_prop_coeff_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_kvcc_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_tdcdone_at_afcdone_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_force_vreglpfbyp_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fracn_sd_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_full_range_afc_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_force_vreg_cal_done_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd0_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd1_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd2_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd3_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_fw_vreg_accum_val_muxd4_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_gaincal_update_rate_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vpeak_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_inv_vreg_comb_fb_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_bin_code_limit_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd0_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd1_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd2_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd3_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_code_val_muxd4_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_measure_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_settle_maxcnt_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_ovrd_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcc_vreg_offset_en_val_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_kvcccalib_vreg_offset_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd0_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd1_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd2_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_lock_thresh_muxd4_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd0_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd1_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd2_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd3_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_locktimer_maxcnt_muxd4_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_modulation_toggle_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchn_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_notchp_offset_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux0_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_del_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_obsmux1_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334_divsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs3334div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pcs40div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_bypass_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_pll_refclkreg_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_plllock_state_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_prediv_ratio_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_ctr_delay_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ramp_step_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_rat0p5_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd0_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd1_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd2_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd3_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ref156div_ratio_muxd4_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk100div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk156div_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cnt_limit_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd0_attr = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd1_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd2_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd3_attr = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_refclk_cycles_per_1us_maxcnt_muxd4_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddiv_ratio_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sddtr_clk_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_sigma_delta2_sel_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_skip_second_afc_calib_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd0_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd1_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd2_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd3_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_spare_dig2ana_muxd4_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ss_comp_out_sel_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_ctr_delay_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_ramp_step_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_ssc_track_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_fll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_stay_pll_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd0_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd1_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd2_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd3_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_cnt_limit_muxd4_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcbbpd_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcpe_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd0_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd3_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_tdcrefclkcnt_muxd4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_temp_track_en_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_visa8to1_2obs_sel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_dac_modulation_en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd0_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd1_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd2_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd3_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_final_gain_maxcnt_muxd4_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd0_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd1_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd2_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd3_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_gain_maxcnt_muxd4_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_init_gain_muxd4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd0_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd2_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd3_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_loopen_maxcnt_muxd4_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd0_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd2_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd3_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vreg_swing_peak_ref_ctl_bin_muxd4_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_average_cnt_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_cfg_vregcomp_cmnsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bb_gain_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbinlock_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_bbthresh_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrlhext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_cloadctrllext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcocoarse_ovrd_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcoditheren_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofine_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dcofinedftsel_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dfx_tdc_disable_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_dither_value_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd0_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd1_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd2_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd3_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_earlylock_criteria_muxd4_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_frac_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd0_attr = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd1_attr = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd2_attr = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd3_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_intgr_muxd4_attr = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fbdiv_strobe_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdcal_pause_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd1_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd2_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd3_attr = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_feedfwrdgain_muxd4_attr = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_fracnen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd0_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd1_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd2_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_lock_criteria_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_mode_ctrl_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_pll_reg_resetb_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_en_mode_ctrl_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllc_regen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_plllock_sel_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdc_fine_res_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdccalexten_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcdc_en_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcovccorr_en_h_muxd4_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr = "serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcroen_h_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd0_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdcsel_muxd4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd0_attr = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd1_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd2_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd3_attr = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tdctargetcnt_muxd4_attr = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_pll_cfg_loader_l3_cfg_pllloader_synthlc_o_tribufctrlext_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l0_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l1_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l2_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr = "serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcfast_l3_cfg_plllcfast_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l0_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l1_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l2_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr = "serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcmed_l3_cfg_plllcmed_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l0_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l1_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l2_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_a2f_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_anamonmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_dtr_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boost_fine_const_zeta_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_boostgain_maxcnt_attr = 512;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_cb56_lane32div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_cb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_clkouten_lane_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_cnt_max_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_max_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_coarse_loop_gscale_min_attr = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcocoarse_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dcosettle_time_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_cnt_restart_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dft_freq_meas_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_disable_dft_timer_ovrd_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrd_offset_ovr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrddir_ovr_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_feedfwrdphase_ovr_val_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_dir_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_enable_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_toggle_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dfx_ramp_val_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_bypass_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dpso_marker_attr = 43690;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_earlylock_timer_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_final_code_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_int_coeff_boost_val_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_ovrden_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_dtr_prop_coeff_boost_val_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_earlylock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_en_peak_sense_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_clkgate_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fbdiv_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_dtr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_filter_boostfade_fine_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine2dtr_ratio_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_first_boost_repeat_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_high_limit_attr = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_step_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_int_coeff_boost_val_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_low_limit_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_modulation_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_step_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fine_prop_coeff_boost_val_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_kvcc_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_tdcdone_at_afcdone_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_force_vreglpfbyp_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fracn_sd_step_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_full_range_afc_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_force_vreg_cal_done_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_fw_vreg_accum_val_attr = 128;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_gaincal_update_rate_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vpeak_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_inv_vreg_comb_fb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_bin_code_limit_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_code_val_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_measure_maxcnt_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_settle_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_ovrd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcc_vreg_offset_en_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_kvcccalib_vreg_offset_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_lock_thresh_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_locktimer_maxcnt_attr = 3968;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_modulation_toggle_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchn_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_notchp_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_del_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_obsmux1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334_divsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs3334div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pcs40div_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_bypass_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_pll_refclkreg_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_plllock_state_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_prediv_ratio_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_ctr_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ramp_step_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_rat0p5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ref156div_ratio_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk100div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk156div_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cnt_limit_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_refclk_cycles_per_1us_maxcnt_attr = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddiv_ratio_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sddtr_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_sigma_delta2_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_skip_second_afc_calib_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_spare_dig2ana_attr = 4096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ss_comp_out_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_ctr_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_ramp_step_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_ssc_track_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_fll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_stay_pll_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_cnt_limit_attr = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcbbpd_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcpe_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_tdcrefclkcnt_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_temp_track_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa8to1_2obs_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane0_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_visa_lane1_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_dac_modulation_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_final_gain_maxcnt_attr = 20;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_gain_maxcnt_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_init_gain_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_loopen_maxcnt_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vreg_swing_peak_ref_ctl_bin_attr = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_average_cnt_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_cfg_vregcomp_cmnsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bb_gain_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbinlock_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_bbthresh_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrlhext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_cloadctrllext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcocoarse_ovrd_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcoditheren_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofine_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dcofinedftsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_dfx_tdc_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_dither_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_earlylock_criteria_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_frac_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_intgr_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fbdiv_strobe_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdcal_pause_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_feedfwrdgain_attr = 40;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_fracnen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_lock_criteria_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_pll_reg_resetb_mode_ctrl_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_en_mode_ctrl_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllc_regen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_plllock_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdc_fine_res_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdccalexten_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcdc_en_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcovccorr_en_h_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr = "serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcroen_h_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdcsel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tdctargetcnt_attr = 58;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_plllcslow_l3_cfg_plllcslow_o_tribufctrlext_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l0_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l0_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l0_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l0_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l0_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l0_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l0_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l0_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l1_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l1_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l1_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l1_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l1_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l1_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l1_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l1_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l2_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l2_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l2_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l2_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l2_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l2_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l2_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l2_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_flavor_table_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr = "serdes_ip_rx_flex_l3_cfg_flx_force_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr = "serdes_ip_rx_flex_l3_cfg_flx_freeze_in_state_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_01_attr = 65537;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_02_attr = 32'h80008000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_03_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_08_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_09_attr = 131072;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_10_attr = 32'h90020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_11_attr = 33554432;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_12_attr = 1075838976;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_13_attr = 301989888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_15_attr = 32'h82020000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_18_attr = 302006272;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_30_attr = 33587200;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_mask_31_attr = 1107329024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_02_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_03_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_10_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_12_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_13_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_15_attr = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_18_attr = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_ir_state_31_attr = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_03_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_11_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_12_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_13_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_15_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_18_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_30_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_next_lpcnt_state_31_attr = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr = "serdes_ip_rx_flex_l3_cfg_flx_one_state_inc_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_00_attr = 1056783;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_01_attr = 9510943;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_02_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_03_attr = 9437199;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_04_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_05_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_06_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_07_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_08_attr = 14680079;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_09_attr = 26017807;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_10_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_11_attr = 9502735;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_12_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_13_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_14_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_15_attr = 25493519;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_16_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_17_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_18_attr = 14942223;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_19_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_20_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_21_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_22_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_23_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_24_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_25_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_26_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_27_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_28_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_29_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_30_attr = 1376271;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl1_31_attr = 8716303;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_00_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_01_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_02_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_03_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_04_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_05_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_06_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_07_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_08_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_09_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_out_ctrl_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr = "serdes_ip_rx_flex_l3_cfg_flx_state_force_value_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr = "serdes_ip_rx_flex_l3_cfg_flx_stop_tmr_in_handshake_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_00_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_03_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_10_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_15_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr = "serdes_ip_rx_flex_l3_cfg_max_timer_en_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_00_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_02_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_03_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_10_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_max_timer_value_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_00_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_01_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_02_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_03_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_04_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_05_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_06_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_07_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_08_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_09_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_19_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_20_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_21_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_22_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_23_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_24_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_25_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_26_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_27_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_28_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_29_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_30_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr = "serdes_ip_rx_flex_l3_cfg_min_timer_start_event_31_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_00_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_01_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_02_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_03_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_04_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_05_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_06_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_07_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_08_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_09_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_13_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_rx_flex_l3_cfg_min_timer_value_31_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l0_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l0_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l0_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l1_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l1_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l1_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l2_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l2_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l2_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr = "serdes_ip_synth_fast_l3_cfg_etrregsynthlcfastclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_lb_synthlcfastpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refdiv_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfast_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfastrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfastspare1_attr = 769;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_fast_l3_cfg_synthlcfaststartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_fast_l3_cfg_synthlcfasttimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l0_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l0_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l0_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l0_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l0_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l1_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l1_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l1_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l1_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l1_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l2_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l2_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l2_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l2_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l2_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr = "serdes_ip_synth_med_l3_cfg_etrregsynthlcmedclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_med_l3_cfg_lb_synthlcmedpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd0_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refdiv_muxd4_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr = "serdes_ip_synth_med_l3_cfg_synthlcmed_used_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmeddccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_locovren_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd0_attr = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_locovr_muxd4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_clk_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_med_l3_cfg_synthlcmedstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_med_l3_cfg_synthlcmedtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l0_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l0_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l0_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l1_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l1_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l1_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l2_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l2_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l2_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr = "serdes_ip_synth_slow_l3_cfg_etrregsynthlcslowclk_ready_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_lb_synthlcslowpostdivclk2cdrrefclken_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_fastregpwrup_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_on_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_pg_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_ready_state_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refdiv_muxd4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_refinctl_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_static_divrate_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_txbitclkselect_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslow_used_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowbias_icc400uadj_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcd_gray_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_intvl_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_bg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_inc_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_fg_one_step_cal_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_initval_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxcoarse_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpfaxfine_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_count_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_restore_delay_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdfsm_signmagen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_currentdacdcdmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldac_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_abort_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacbg_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsm_recal_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldaccurrentdacdcdfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_currentdacdcd_bin_locovr_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacencoderin_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_currentdacdcdfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcaldacfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_currentdacdcdfsm_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_plllc_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_regopampoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_startup_plllc_en_h_sus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_pstate_synthlcppm_lockstatus_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_currentdacdcdfsm_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_plllc_lockstatus_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_regopampoffset_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_rxppm_lockstatus_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_startup_plllc_en_h_sus_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalptr_quad_synthlcppm_lockstatus_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffset_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_clear_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_codeoffset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_finish_side_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_init_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_initval_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxcoarse_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpfaxfine_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_count_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_lpflockdet_tolerance_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_maxiter_attr = 4095;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_precalfsmstart_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_recal_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_restore_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_round_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_runcount_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsm_signmagen_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_en_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetfsmout_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_clrcount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_dlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_pow2count_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_req_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowcalregopampoffsetmeas_validdlycount_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_keepalive_en_b_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclk_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowclkstat_ready_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowdccrst_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowearlylock_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_calabort_pulse_width_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowfsm_cken_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv2clk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_locovr_muxd4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdiv_p5_locovr_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpcs_postdivclk0en_muxd4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_disable_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_hardreset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_refclksel_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpll_sel_cb0_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_shutdown_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_spare_dout_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t0_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpll_strbreg_reset_t1_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_load_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_mode_ovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllcfgloader_pll_off_req_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrdn_refclksel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllregpwrup_refclksel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_lock_dig_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpllstatus_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_h8_rst_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_iso_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_iso_on_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_restore_off_delay_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpmu_rst_off_delay_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowpostdiv_wait_for_lock_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_lockstatus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowppm_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_cal_clear_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_chk_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_clk_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_etr_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_mode_locovr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_pd_on_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_ratewidth_delay_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_a_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b0_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b1_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowratewidth_rst_b2_off_delay_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrecal_on_pd_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_lr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrefck_refinctl_slv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowreg_lev_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_en_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry1_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry2_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_entry3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q2_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evdn_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry2_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry3_attr = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry4_attr = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry5_attr = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_entry7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q3_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s0q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q1_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q2_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q3_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q4_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q5_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q6_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s1q7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpu_evup_delay_lut_sel_s2q0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_clear_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_currentdacdcd_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr0_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_cal_regopamp_init_up_ptr1_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_q_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuctl_keepalive_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdiv2clksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_pcspostdivclksel_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_regpwrupacc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpuetr_startup_plllc_sus_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_q_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_biasicc_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_q_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_pll_en_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpupd_reg_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_dccrst_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv2_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_postdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_q_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr0_s_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_refdiv_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_q_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_dn_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_q_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr0_s_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_q_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrpurst_synthregreset_b_up_ptr1_s_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdiv2clksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_pcspostdivclksel_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_aetrsynthlc_regpwrupacc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_biasicc_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_apdsynthlc_reg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_dcc_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv2_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_postdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_refdiv_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_strbreg_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_startup_plllc_sus_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovr_b_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_arstsynthlc_synthregreset_b_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowrstpdovr_synthlcstartup_plllc_en_ovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowspare1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_locovren_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr = "serdes_ip_synth_slow_l3_cfg_synthlcslowstartup_plllc_en_h_sus_locovr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_dccrst2lockmask_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_ip_synth_slow_l3_cfg_synthlcslowtimer_rawlock2dccrst_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l0_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_dig_cdr_disable_attr = "serdes_shim_an_l0_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_direct_control_bus_en_attr = "serdes_shim_an_l0_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_edge_too_long_disable_attr = "serdes_shim_an_l0_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_edge_too_short_disable_attr = "serdes_shim_an_l0_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_page_max_timer_disable_attr = "serdes_shim_an_l0_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_page_min_timer_disable_attr = "serdes_shim_an_l0_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_pcs_lock_attr = "serdes_shim_an_l0_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l0_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_enable_m_attr = "serdes_shim_an_l0_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_lcw_re_attr = "serdes_shim_an_l0_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_pma_en_attr = "serdes_shim_an_l0_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l0_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l0_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_complete_ack_attr = "serdes_shim_an_l0_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_enable_m_attr = "serdes_shim_an_l0_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_lcw_we_attr = "serdes_shim_an_l0_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l0_cfg_tx_pma_en_attr = "serdes_shim_an_l0_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l1_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_dig_cdr_disable_attr = "serdes_shim_an_l1_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_direct_control_bus_en_attr = "serdes_shim_an_l1_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_edge_too_long_disable_attr = "serdes_shim_an_l1_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_edge_too_short_disable_attr = "serdes_shim_an_l1_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_page_max_timer_disable_attr = "serdes_shim_an_l1_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_page_min_timer_disable_attr = "serdes_shim_an_l1_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_pcs_lock_attr = "serdes_shim_an_l1_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l1_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_enable_m_attr = "serdes_shim_an_l1_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_lcw_re_attr = "serdes_shim_an_l1_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_pma_en_attr = "serdes_shim_an_l1_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l1_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l1_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_complete_ack_attr = "serdes_shim_an_l1_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_enable_m_attr = "serdes_shim_an_l1_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_lcw_we_attr = "serdes_shim_an_l1_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l1_cfg_tx_pma_en_attr = "serdes_shim_an_l1_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l2_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_dig_cdr_disable_attr = "serdes_shim_an_l2_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_direct_control_bus_en_attr = "serdes_shim_an_l2_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_edge_too_long_disable_attr = "serdes_shim_an_l2_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_edge_too_short_disable_attr = "serdes_shim_an_l2_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_page_max_timer_disable_attr = "serdes_shim_an_l2_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_page_min_timer_disable_attr = "serdes_shim_an_l2_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_pcs_lock_attr = "serdes_shim_an_l2_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l2_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_enable_m_attr = "serdes_shim_an_l2_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_lcw_re_attr = "serdes_shim_an_l2_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_pma_en_attr = "serdes_shim_an_l2_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l2_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l2_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_complete_ack_attr = "serdes_shim_an_l2_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_enable_m_attr = "serdes_shim_an_l2_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_lcw_we_attr = "serdes_shim_an_l2_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l2_cfg_tx_pma_en_attr = "serdes_shim_an_l2_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr = "serdes_shim_an_l3_cfg_an_idle_stiky_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_an_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_debug_fw_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_dig_cdr_disable_attr = "serdes_shim_an_l3_cfg_dig_cdr_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_direct_control_bus_en_attr = "serdes_shim_an_l3_cfg_direct_control_bus_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_edge_too_long_disable_attr = "serdes_shim_an_l3_cfg_edge_too_long_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_edge_too_short_disable_attr = "serdes_shim_an_l3_cfg_edge_too_short_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_page_max_timer_disable_attr = "serdes_shim_an_l3_cfg_page_max_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_page_min_timer_disable_attr = "serdes_shim_an_l3_cfg_page_min_timer_disable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_pcs_lock_attr = "serdes_shim_an_l3_cfg_pcs_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr = "serdes_shim_an_l3_cfg_pcs_tx_bypass_sample_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_enable_m_attr = "serdes_shim_an_l3_cfg_rx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_lcw_re_attr = "serdes_shim_an_l3_cfg_rx_lcw_re_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_pma_en_attr = "serdes_shim_an_l3_cfg_rx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_ctrl_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_gray_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_bitorder_swz_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_pam_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr = "serdes_shim_an_l3_cfg_rx_unencoder_polarity_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr = "serdes_shim_an_l3_cfg_rx_unencoder_precode_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_rx_unencoder_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_serdes_irq_bus_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_transmit_mode_scan_mode_dbg_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_complete_ack_attr = "serdes_shim_an_l3_cfg_tx_complete_ack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_enable_m_attr = "serdes_shim_an_l3_cfg_tx_enable_m_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_lcw_high_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_lcw_low_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_lcw_reserv_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_lcw_we_attr = "serdes_shim_an_l3_cfg_tx_lcw_we_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_an_l3_cfg_tx_pma_en_attr = "serdes_shim_an_l3_cfg_tx_pma_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l0_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l0_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l0_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l0_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l0_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_en_attr = "serdes_shim_car_l0_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_eee_alert_force_val_attr = "serdes_shim_car_l0_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l0_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l0_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l0_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l0_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_timer_en_attr = "serdes_shim_car_l0_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l0_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l1_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l1_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l1_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l1_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l1_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_en_attr = "serdes_shim_car_l1_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_eee_alert_force_val_attr = "serdes_shim_car_l1_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l1_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l1_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l1_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l1_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_timer_en_attr = "serdes_shim_car_l1_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l1_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l2_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l2_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l2_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l2_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l2_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_en_attr = "serdes_shim_car_l2_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_eee_alert_force_val_attr = "serdes_shim_car_l2_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l2_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l2_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l2_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l2_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_timer_en_attr = "serdes_shim_car_l2_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l2_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr = "serdes_shim_car_l3_cfg_apb_dsp_clk_sel_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr = "serdes_shim_car_l3_cfg_apb_dsp_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_apb_dsp_divn_value_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_apb_dsp_pclken_attr = "serdes_shim_car_l3_cfg_apb_dsp_pclken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr = "serdes_shim_car_l3_cfg_apb_dsp_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_rx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr = "serdes_shim_car_l3_cfg_dp_tx_80b_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_en_attr = "serdes_shim_car_l3_cfg_eee_alert_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_eee_alert_force_val_attr = "serdes_shim_car_l3_cfg_eee_alert_force_val_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_flux_srds_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr = "serdes_shim_car_l3_cfg_iflux_tx_or_apb_clk_for_ux_ctrl_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr = "serdes_shim_car_l3_cfg_oflux_srds_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_cmn_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr = "serdes_shim_car_l3_cfg_pcs_ick_ctrl_l0_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2data_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr = "serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_rxovrcdrlock2dataen_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_rxpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_rxpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_an_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_an_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ctrl_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dfx_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_isi_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_dsp_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_eee_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_pcs_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_divn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_trn_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_cmn_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr = "serdes_shim_car_l3_cfg_srds_ux_tx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_timer_en_attr = "serdes_shim_car_l3_cfg_timer_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_timer_value_attr = 25;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_transmit_mode_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_tx_postdiv_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_txelecidle_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_txelecidle_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_txpstate_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_car_l3_cfg_txpstate_src_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_atresetn_attr = "serdes_shim_cpu_pm_cfg_cpu_atresetn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakin_attr = "serdes_shim_cpu_pm_cfg_cpu_breakin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr = "serdes_shim_cpu_pm_cfg_cpu_breakoutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggerin_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr = "serdes_shim_cpu_pm_cfg_cpu_crosstriggeroutack_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr = "serdes_shim_cpu_pm_cfg_cpu_ocdhaltonreset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr = "serdes_shim_cpu_pm_cfg_cpu_pdebugenable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_prid_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr = "serdes_shim_cpu_pm_cfg_cpu_statvectorsel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr = "serdes_shim_cpu_pm_cfg_cpu_tmodeclkgateoverride_reserved_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_dram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_clkbyp_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_dram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_fifo_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_iram7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr = "serdes_shim_cpu_pm_cfg_fuse_mce_trace_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_dram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram0_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram3_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram4_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram5_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram6_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_iram7_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_ra_trace_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_rmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_dram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_fifo_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram0_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram1_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram2_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram3_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram4_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram5_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram6_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_iram7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wa_trace_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_dram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_iram7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wmce_trace_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_dram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_fifo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram0_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram1_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram3_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram4_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram6_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_iram7_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fuse_wpulse_trace_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fw_status_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_fw_version_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_iramh_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_iraml_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_nmi_icu_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tb_reg0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tb_reg1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tb_reg2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tb_reg3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tb_reg4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tie_queue_pwr_mgmt_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_cpu_pm_cfg_tram_pwr_mgmt_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_en_attr = "serdes_shim_dsp_l0_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l0_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_en_attr = "serdes_shim_dsp_l0_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l0_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_d_sign_attr = "serdes_shim_dsp_l0_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_en_attr = "serdes_shim_dsp_l0_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_event_sign_attr = "serdes_shim_dsp_l0_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_bb_stable_attr = "serdes_shim_dsp_l0_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l0_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l0_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l0_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l0_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l0_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l0_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_en_attr = "serdes_shim_dsp_l0_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l0_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l0_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l0_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l0_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_error_counter_clr_attr = "serdes_shim_dsp_l0_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_error_counter_enable_attr = "serdes_shim_dsp_l0_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l0_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l0_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_fine_attr = "serdes_shim_dsp_l0_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_en_attr = "serdes_shim_dsp_l0_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l0_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l0_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l0_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l0_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l0_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_en_attr = "serdes_shim_dsp_l0_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l0_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l0_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l0_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_pam_4_en_attr = "serdes_shim_dsp_l0_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_pol_invert_attr = "serdes_shim_dsp_l0_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_power_save_en_attr = "serdes_shim_dsp_l0_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_regs2visa_en_attr = "serdes_shim_dsp_l0_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l0_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_snr_meter_en_attr = "serdes_shim_dsp_l0_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l0_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_swap_bot_en_attr = "serdes_shim_dsp_l0_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_swap_top_en_attr = "serdes_shim_dsp_l0_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l0_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_en_attr = "serdes_shim_dsp_l0_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_en_attr = "serdes_shim_dsp_l0_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l0_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_x3_en_attr = "serdes_shim_dsp_l0_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l0_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l0_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_en_attr = "serdes_shim_dsp_l1_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l1_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_en_attr = "serdes_shim_dsp_l1_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l1_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_d_sign_attr = "serdes_shim_dsp_l1_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_en_attr = "serdes_shim_dsp_l1_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_event_sign_attr = "serdes_shim_dsp_l1_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_bb_stable_attr = "serdes_shim_dsp_l1_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l1_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l1_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l1_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l1_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l1_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l1_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_en_attr = "serdes_shim_dsp_l1_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l1_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l1_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l1_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l1_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_error_counter_clr_attr = "serdes_shim_dsp_l1_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_error_counter_enable_attr = "serdes_shim_dsp_l1_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l1_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l1_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_fine_attr = "serdes_shim_dsp_l1_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_en_attr = "serdes_shim_dsp_l1_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l1_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l1_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l1_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l1_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l1_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_en_attr = "serdes_shim_dsp_l1_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l1_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l1_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l1_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_pam_4_en_attr = "serdes_shim_dsp_l1_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_pol_invert_attr = "serdes_shim_dsp_l1_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_power_save_en_attr = "serdes_shim_dsp_l1_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_regs2visa_en_attr = "serdes_shim_dsp_l1_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l1_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_snr_meter_en_attr = "serdes_shim_dsp_l1_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l1_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_swap_bot_en_attr = "serdes_shim_dsp_l1_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_swap_top_en_attr = "serdes_shim_dsp_l1_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l1_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_en_attr = "serdes_shim_dsp_l1_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_en_attr = "serdes_shim_dsp_l1_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l1_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_x3_en_attr = "serdes_shim_dsp_l1_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l1_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l1_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_en_attr = "serdes_shim_dsp_l2_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l2_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_en_attr = "serdes_shim_dsp_l2_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l2_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_d_sign_attr = "serdes_shim_dsp_l2_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_en_attr = "serdes_shim_dsp_l2_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_event_sign_attr = "serdes_shim_dsp_l2_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_bb_stable_attr = "serdes_shim_dsp_l2_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l2_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l2_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l2_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l2_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l2_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l2_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_en_attr = "serdes_shim_dsp_l2_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l2_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l2_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l2_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l2_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_error_counter_clr_attr = "serdes_shim_dsp_l2_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_error_counter_enable_attr = "serdes_shim_dsp_l2_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l2_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l2_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_fine_attr = "serdes_shim_dsp_l2_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_en_attr = "serdes_shim_dsp_l2_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l2_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l2_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l2_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l2_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l2_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_en_attr = "serdes_shim_dsp_l2_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l2_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l2_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l2_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_pam_4_en_attr = "serdes_shim_dsp_l2_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_pol_invert_attr = "serdes_shim_dsp_l2_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_power_save_en_attr = "serdes_shim_dsp_l2_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_regs2visa_en_attr = "serdes_shim_dsp_l2_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l2_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_snr_meter_en_attr = "serdes_shim_dsp_l2_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l2_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_swap_bot_en_attr = "serdes_shim_dsp_l2_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_swap_top_en_attr = "serdes_shim_dsp_l2_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l2_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_en_attr = "serdes_shim_dsp_l2_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_en_attr = "serdes_shim_dsp_l2_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l2_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_x3_en_attr = "serdes_shim_dsp_l2_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l2_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l2_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_en_attr = "serdes_shim_dsp_l3_cfg_acc_clr_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_acc_clr_rst_attr = "serdes_shim_dsp_l3_cfg_acc_clr_rst_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_agc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_en_attr = "serdes_shim_dsp_l3_cfg_agc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr = "serdes_shim_dsp_l3_cfg_agc_coarse_det_pol_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_d_sign_attr = "serdes_shim_dsp_l3_cfg_agc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_en_attr = "serdes_shim_dsp_l3_cfg_agc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_event_sign_attr = "serdes_shim_dsp_l3_cfg_agc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_agc_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_bb_stable_attr = "serdes_shim_dsp_l3_cfg_bb_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr = "serdes_shim_dsp_l3_cfg_ctle_hf_stable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_d_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_data_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_data_width_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe10_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe11_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe12_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe13_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe14_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe15_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe16_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe1_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe1_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe1_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe1_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr = "serdes_shim_dsp_l3_cfg_dfe2_16_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe2_16_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe2_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe4_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe5_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe6_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe7_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe8_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe9_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr = "serdes_shim_dsp_l3_cfg_dfe_acc_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_all_taps_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr = "serdes_shim_dsp_l3_cfg_dfe_adapt_en_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr = "serdes_shim_dsp_l3_cfg_dfe_common_th_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_d_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_event_sign_attr = "serdes_shim_dsp_l3_cfg_dfe_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap10_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap11_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap12_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap13_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap14_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap15_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap16_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap1_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dfe_tap9_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_bit_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_en_attr = "serdes_shim_dsp_l3_cfg_dsp_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_d_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_inner_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr = "serdes_shim_dsp_l3_cfg_dsp_latch_dis_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_m_swz_attr = "serdes_shim_dsp_l3_cfg_dsp_m_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_dsp_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_e_dly_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ehm_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_lsb_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_rate_msb_attr = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_event_sign_attr = "serdes_shim_dsp_l3_cfg_ehm_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym1_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_sym_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_tap_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ehm_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr = "serdes_shim_dsp_l3_cfg_en_duration_cnt_trig_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_en_duration_val_attr = 625;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_err_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_err_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_error_counter_clr_attr = "serdes_shim_dsp_l3_cfg_error_counter_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_error_counter_enable_attr = "serdes_shim_dsp_l3_cfg_error_counter_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr = "serdes_shim_dsp_l3_cfg_error_counter_even_odd_select_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_error_counter_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_error_counter_resetb_attr = "serdes_shim_dsp_l3_cfg_error_counter_resetb_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_error_sel_mux_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_fine_attr = "serdes_shim_dsp_l3_cfg_fine_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_en_attr = "serdes_shim_dsp_l3_cfg_gain_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_gain_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gain_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap32_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr = "serdes_shim_dsp_l3_cfg_gps_tap64_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr = "serdes_shim_dsp_l3_cfg_ingress_dsp_disable_chkn_bit_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_io_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_joint_dfe_en_attr = "serdes_shim_dsp_l3_cfg_joint_dfe_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr = "serdes_shim_dsp_l3_cfg_ofc_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_en_attr = "serdes_shim_dsp_l3_cfg_ofc_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_cnt_offset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_d_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_d_sign_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_en_attr = "serdes_shim_dsp_l3_cfg_ofc_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_rate_attr = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_event_sign_attr = "serdes_shim_dsp_l3_cfg_ofc_event_sign_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_lsb_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_lsb_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask0_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask1_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_mask2_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_acc_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_en_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_lsb_inv_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_lsb_sel_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num2_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num3_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num4_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num5_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num6_attr = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num7_attr = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_num8_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr = "serdes_shim_dsp_l3_cfg_ofc_sar_sticky_clr8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_sar_th_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_ofc_th_attr = 2048;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_pam4_bit_flip_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr = "serdes_shim_dsp_l3_cfg_pam4_gray_enable_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_pam_4_en_attr = "serdes_shim_dsp_l3_cfg_pam_4_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_phase_cnt_th_attr = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_phase_mask0_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_phase_mask1_attr = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_phase_mask2_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_phase_mask3_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_phase_num_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_pol_invert_attr = "serdes_shim_dsp_l3_cfg_pol_invert_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_power_save_en_attr = "serdes_shim_dsp_l3_cfg_power_save_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_addr_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_regs2visa_en_attr = "serdes_shim_dsp_l3_cfg_regs2visa_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr = "serdes_shim_dsp_l3_cfg_res_isi_mes_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_snr_div_facror_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_lsb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_snr_mask_msb_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_snr_meter_en_attr = "serdes_shim_dsp_l3_cfg_snr_meter_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_snr_smooth_bw_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_0_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_10_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_10_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_11_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_11_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_12_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_12_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_13_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_13_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_14_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_14_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_15_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_15_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_16_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_16_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_17_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_17_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_18_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_18_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_1_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_2_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_3_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_4_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_4_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_5_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_5_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_6_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_6_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_7_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_7_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_8_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_8_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_sticky_clr_9_attr = "serdes_shim_dsp_l3_cfg_sticky_clr_9_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_swap_bot_en_attr = "serdes_shim_dsp_l3_cfg_swap_bot_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_swap_top_en_attr = "serdes_shim_dsp_l3_cfg_swap_top_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_timeout_counter_value_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_acc_clr_attr = "serdes_shim_dsp_l3_cfg_vga_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_en_attr = "serdes_shim_dsp_l3_cfg_vga_clr_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_clr_sel_attr = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_en_attr = "serdes_shim_dsp_l3_cfg_vga_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_h_attr = 126;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_comp_const_l_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_range_detect_sub_const_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_shift_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_vga_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vga_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_vref_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_x3_acc_clr_attr = "serdes_shim_dsp_l3_cfg_x3_acc_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_x3_en_attr = "serdes_shim_dsp_l3_cfg_x3_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr = "serdes_shim_dsp_l3_cfg_x3_sticky_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_dsp_l3_cfg_x3_th_attr = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l0_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l0_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l0_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l0_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l0_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l0_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l0_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l0_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l0_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l0_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l0_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_send_data_attr = "serdes_shim_tfl_l0_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l0_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l0_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l0_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l0_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l1_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l1_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l1_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l1_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l1_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l1_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l1_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l1_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l1_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l1_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l1_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_send_data_attr = "serdes_shim_tfl_l1_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l1_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l1_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l1_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l1_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l2_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l2_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l2_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l2_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l2_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l2_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l2_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l2_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l2_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l2_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l2_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_send_data_attr = "serdes_shim_tfl_l2_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l2_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l2_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l2_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l2_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_2_attr = 7571;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cfg_prbs13_seed_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr = "serdes_shim_tfl_l3_cfg_cfg_tfl_prbs11_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_11_10_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_13_12_init_cond_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_1_0_coeff_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_4_2_coeff_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_7_5_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_ctrl_field_9_8_mod_precode_req_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr = "serdes_shim_tfl_l3_cfg_cl136_prbs_encoder_select_even_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr = "serdes_shim_tfl_l3_cfg_cl136_precoder_out_swz_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_precoder_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_11_10_mod_precode_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_14_12_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_15_rx_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_2_0_coeff_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_5_3_coeff_sel_echo_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_6_rsvd_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_7_parity_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_8_init_cond_stts_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr = "serdes_shim_tfl_l3_cfg_cl136_stts_field_9_rx_frame_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_11_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_12_initialize_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr = "serdes_shim_tfl_l3_cfg_cl72_ctrl_field_13_preset_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_15_14_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_1_0_coef_m1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_3_2_coef_0_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_ctrl_field_5_4_coef_p1_update_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_frame_cycle_to_lock_attr = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_14_6_rsvd_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr = "serdes_shim_tfl_l3_cfg_cl72_stts_field_15_rcv_ready_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_1_0_coef_m1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_3_2_coef_0_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_cl72_stts_field_5_4_coef_p1_stts_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_frame_boundary_early_attr = "serdes_shim_tfl_l3_cfg_frame_boundary_early_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_gb_128_80_en_attr = "serdes_shim_tfl_l3_cfg_gb_128_80_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr = "serdes_shim_tfl_l3_cfg_ignore_tfl_en_to_avoid_cut_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_2_attr = 977;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_prbs11_seed_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_pam4_modulation_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_seed_force_val_attr = 6816;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl136_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_count_snap_lock_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_ber_counter_clear_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_clear_one_marker_seen_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_control_reg_ff_disable_sc_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_data_align_fast_mode_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_bad_markers_to_shift_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_extra_good_markers_to_lock_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_frame_marker_th_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_marker_valid_before_dme_check_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_polynomial_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_good_frames_th_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_ignored_last_dwords_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_lock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr = "serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_seed_force_val_attr = 1013;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_cl72_prbs_unlock_th_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr = "serdes_shim_tfl_l3_cfg_rx_sync_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr = "serdes_shim_tfl_l3_cfg_scrambler_force_init_at_each_frame_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_send_data_attr = "serdes_shim_tfl_l3_cfg_send_data_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr = "serdes_shim_tfl_l3_cfg_sync_ctrl_stts_word_pulse_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr = "serdes_shim_tfl_l3_cfg_tfl_prbs13_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr = "serdes_shim_tfl_l3_cfg_tfl_pulse_sync_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_rx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_tfl_training_enable_tx_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_tfl_l3_cfg_tx_gb_mode_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_broadcast_feature_en_attr = "serdes_shim_top_cfg_broadcast_feature_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_broadcast_type_attr = "serdes_shim_top_cfg_broadcast_type_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fabric_wd_counter_max_attr = 127;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_datawidth_sel_attr = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_en_attr = "serdes_shim_top_cfg_fec_ber_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_mask8_attr = 85;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_packet_sel_attr = "serdes_shim_top_cfg_fec_ber_packet_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_poly_sel_attr = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_rs_type_sel_attr = "serdes_shim_top_cfg_fec_ber_rs_type_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_fec_ber_statistic_en_attr = "serdes_shim_top_cfg_fec_ber_statistic_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_serdes_irq_enable_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_serdes_irq_mask_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_serdes_irq_reset_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_wdt_clr_attr = "serdes_shim_top_cfg_wdt_clr_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_wdt_en_attr = "serdes_shim_top_cfg_wdt_en_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_wdt_pre_scale_attr = 256;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr = "serdes_shim_top_cfg_wdt_rst_after_irq_mode_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_wdt_swrst_en_attr = "serdes_shim_top_cfg_wdt_swrst_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_top_cfg_wdt_time_val_attr = 65535;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_lgc_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_mem_rstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_bot_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_clkrx_top_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_scmng_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ctrl_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane0_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane1_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane2_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr = "serdes_shim_wrap_car_cfg_apb_pclk_srds_ux_lane3_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_apb_presetn_srds_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane0_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane1_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane2_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr = "serdes_shim_wrap_car_cfg_car_ux_lane_rst_src_sel_lane3_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_clkrx_ref_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr = "serdes_shim_wrap_car_cfg_cpu_apb_clocks_ratio_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_cpu_clk_sel_attr = "serdes_shim_wrap_car_cfg_cpu_clk_sel_attr_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_cpu_clken_attr = "serdes_shim_wrap_car_cfg_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_cpu_runstall_attr = "serdes_shim_wrap_car_cfg_cpu_runstall_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr = "serdes_shim_wrap_car_cfg_fast_clk_divn_en_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fast_clk_divn_val_attr = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fast_clk_lane_sel_attr = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_clken_attr = "serdes_shim_wrap_car_cfg_fb_cpu_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_cpu_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fb_rx_clken_attr = "serdes_shim_wrap_car_cfg_fb_rx_clken_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr = "serdes_shim_wrap_car_cfg_fb_rx_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_fec_ber_lane_select_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_bot_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_clkrx_top_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_scmng_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ctrl_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane0_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane1_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane2_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr = "serdes_shim_wrap_car_cfg_hwrstn_serdes_ux_lane3_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane0_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane1_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane2_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr = "serdes_shim_wrap_car_cfg_lane_car_apb_cfg_presetn_swrstn_lane3_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr = "serdes_shim_wrap_car_cfg_wrap_car_apb_cfg_presetn_swrstn_attr_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__top_f_fastest_reconfig_refclk_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__top_refclk_reconfig_span = "top_refclk_reconfig_span_none";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_0_rx_synth_select = "ux0_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_0_tx_synth_select = "ux0_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_1_rx_synth_select = "ux0_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_1_tx_synth_select = "ux0_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_2_rx_synth_select = "ux0_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_2_tx_synth_select = "ux0_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_3_rx_synth_select = "ux0_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_3_tx_synth_select = "ux0_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_4_rx_synth_select = "ux0_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_4_tx_synth_select = "ux0_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_refclk_type_select = "ux0_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_refclk_type_select = "ux0_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_refclk_type_select = "ux0_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_refclk_type_select = "ux0_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_refclk_type_select = "ux0_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_bw_sel = "ux0_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_refclk_mux_select = "ux0_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_core_pll_bw_sel = "ux0_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_core_pll_refclk_select = "ux0_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dpma_n_counter_physical = "ux0_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_primary_use = "ux0_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_protocol = "ux0_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rx_which_lane_to_copy = "ux0_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_select_lc_0_tx_path = "ux0_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_select_lc_1_tx_path = "ux0_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_select_lc_2_tx_path = "ux0_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_select_lc_3_tx_path = "ux0_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_select_lc_4_tx_path = "ux0_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_afc_range = "ux0_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_afc_range = "ux0_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_afc_range = "ux0_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_afc_range = "ux0_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_afc_range = "ux0_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_bw_sel = "ux0_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_primary_use = "ux0_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_refclk_mux_select = "ux0_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_refclk_type_select = "ux0_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_bw_sel = "ux0_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_primary_use = "ux0_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_refclk_mux_select = "ux0_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_refclk_type_select = "ux0_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_bw_sel = "ux0_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_primary_use = "ux0_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_refclk_mux_select = "ux0_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_refclk_type_select = "ux0_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_protocol = "ux0_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_user_clk1_mux = "ux0_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_user_clk2_mux = "ux0_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_tx_which_lane_to_copy = "ux0_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux0_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_0_rx_synth_select = "ux1_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_0_tx_synth_select = "ux1_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_1_rx_synth_select = "ux1_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_1_tx_synth_select = "ux1_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_2_rx_synth_select = "ux1_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_2_tx_synth_select = "ux1_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_3_rx_synth_select = "ux1_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_3_tx_synth_select = "ux1_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_4_rx_synth_select = "ux1_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_4_tx_synth_select = "ux1_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_refclk_type_select = "ux1_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_refclk_type_select = "ux1_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_refclk_type_select = "ux1_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_refclk_type_select = "ux1_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_refclk_type_select = "ux1_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_bw_sel = "ux1_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_refclk_mux_select = "ux1_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_core_pll_bw_sel = "ux1_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_core_pll_refclk_select = "ux1_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dpma_n_counter_physical = "ux1_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_primary_use = "ux1_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_protocol = "ux1_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rx_which_lane_to_copy = "ux1_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_select_lc_0_tx_path = "ux1_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_select_lc_1_tx_path = "ux1_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_select_lc_2_tx_path = "ux1_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_select_lc_3_tx_path = "ux1_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_select_lc_4_tx_path = "ux1_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_afc_range = "ux1_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_afc_range = "ux1_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_afc_range = "ux1_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_afc_range = "ux1_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_afc_range = "ux1_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_bw_sel = "ux1_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_primary_use = "ux1_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_refclk_mux_select = "ux1_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_refclk_type_select = "ux1_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_bw_sel = "ux1_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_primary_use = "ux1_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_refclk_mux_select = "ux1_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_refclk_type_select = "ux1_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_bw_sel = "ux1_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_primary_use = "ux1_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_refclk_mux_select = "ux1_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_refclk_type_select = "ux1_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_protocol = "ux1_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_user_clk1_mux = "ux1_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_user_clk2_mux = "ux1_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_tx_which_lane_to_copy = "ux1_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux1_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_0_rx_synth_select = "ux2_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_0_tx_synth_select = "ux2_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_1_rx_synth_select = "ux2_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_1_tx_synth_select = "ux2_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_2_rx_synth_select = "ux2_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_2_tx_synth_select = "ux2_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_3_rx_synth_select = "ux2_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_3_tx_synth_select = "ux2_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_4_rx_synth_select = "ux2_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_4_tx_synth_select = "ux2_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_refclk_type_select = "ux2_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_refclk_type_select = "ux2_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_refclk_type_select = "ux2_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_refclk_type_select = "ux2_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_refclk_type_select = "ux2_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_bw_sel = "ux2_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_refclk_mux_select = "ux2_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_core_pll_bw_sel = "ux2_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_core_pll_refclk_select = "ux2_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dpma_n_counter_physical = "ux2_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_flux_mode = "ux2_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_primary_use = "ux2_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_protocol = "ux2_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rx_which_lane_to_copy = "ux2_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_select_lc_0_tx_path = "ux2_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_select_lc_1_tx_path = "ux2_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_select_lc_2_tx_path = "ux2_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_select_lc_3_tx_path = "ux2_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_select_lc_4_tx_path = "ux2_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_afc_range = "ux2_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_afc_range = "ux2_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_afc_range = "ux2_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_afc_range = "ux2_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_afc_range = "ux2_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_bw_sel = "ux2_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_primary_use = "ux2_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_refclk_mux_select = "ux2_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_refclk_type_select = "ux2_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_bw_sel = "ux2_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_primary_use = "ux2_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_refclk_mux_select = "ux2_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_refclk_type_select = "ux2_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_bw_sel = "ux2_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_primary_use = "ux2_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_refclk_mux_select = "ux2_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_refclk_type_select = "ux2_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_protocol = "ux2_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_user_clk1_mux = "ux2_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_user_clk2_mux = "ux2_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_tx_which_lane_to_copy = "ux2_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux2_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_0_rx_synth_select = "ux3_0_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_0_tx_synth_select = "ux3_0_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_1_rx_synth_select = "ux3_1_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_1_tx_synth_select = "ux3_1_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_2_rx_synth_select = "ux3_2_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_2_tx_synth_select = "ux3_2_tx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_3_rx_synth_select = "ux3_3_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_3_tx_synth_select = "ux3_3_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_4_rx_synth_select = "ux3_4_rx_synth_select_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_4_tx_synth_select = "ux3_4_tx_synth_select_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_hscount = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_m_counter_physical = 234;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_refclk_type_select = "ux3_cdr_0_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_0_watchdogtmr = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_m_counter_physical = 84;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_meascount = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_mod_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_refclk_type_select = "ux3_cdr_1_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_1_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_hscount = 180;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_m_counter_physical = 48;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_meascount = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_refclk_type_select = "ux3_cdr_2_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_2_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_hscount = 171;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_m_counter_physical = 66;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_mod_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_refclk_type_select = "ux3_cdr_3_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_3_watchdogtmr = 1500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_fastref_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_hscount = 206;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_m_counter_physical = 210;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_meascount = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_mod_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_refclk_type_select = "ux3_cdr_4_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_4_watchdogtmr = 600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_bw_sel = "ux3_cdr_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_f_pfd_hz = 26041666;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_f_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_hscount_scratch = 186;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_is_cascaded = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_is_fractional = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_m_counter = 240;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_meascount_scratch = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_mod_counter_scratch = 13;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_n_counter = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_ppm_driftcount = 1024;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_ppm_driftmax = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_ppm_driftmax_scratch = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_ppm_driftmax_scratch_denominator = 40'hEC62140100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_ppm_driftmax_scratch_numerator = 45'h1C4FECC00000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_ppm_tolerance = 7600;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_refclk_mux_select = "ux3_cdr_refclk_mux_select_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_squelch_sample_count = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_squelch_sample_scratch = 144;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cdr_watchdogtmr_scratch = 520;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evdn_delay_lut_entry3 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry2 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry3 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry4 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry5 = 62;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry6 = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_cmnrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_core_pll_bw_sel = "ux3_core_pll_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_core_pll_refclk_select = "ux3_core_pll_refclk_select_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dpma_f_out_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dpma_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dpma_n_counter_physical = "ux3_dpma_n_counter_physical_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dpma_n_counter_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_dts_ssdiv_scratch = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_med_lc_0_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_med_lc_1_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_med_lc_2_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_med_lc_3_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_med_lc_4_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_port_control_of_cdr_ltr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_slow_lc_0_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_slow_lc_1_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_slow_lc_2_path = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_slow_lc_3_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_enable_slow_lc_4_path = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_external_dpma_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_f_cascade_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_feed_forward_gain_scratch = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_feed_forward_temp_one = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_feed_forward_temp_two = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_force_cdr_ltd = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_force_cdr_ltr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_kvcc_settle_maxcnt_scratch = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_master_sup_mode = "ux3_master_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_oversampling_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_prbs_mon_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_prbs_pattern = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_primary_use = "ux3_primary_use_standard";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_refclk_in_1us_scratch = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_ac_couple_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_onchip_termination = "ux3_rx_onchip_termination_r_4";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_protocol = "ux3_rx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rx_which_lane_to_copy = "ux3_rx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_bias_adj = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_biasboost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_lf_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_midband_zero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_1_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_1_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_2_cap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_2_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_2_reszero = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_3_dcgain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_ctle_stage_3_deq = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_10 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_11 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_12 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_13 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_14 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_16 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_5 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_data_tap_9 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_edge_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_edge_tap_3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_dfe_edge_tap_4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_hf_boost = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_iq_clk = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_targ_0_hi = 149;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_targ_0_lo = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxeq_vga_gain = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry4 = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry5 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry6 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_rxrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_select_lc_0_tx_path = "ux3_select_lc_0_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_select_lc_1_tx_path = "ux3_select_lc_1_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_select_lc_2_tx_path = "ux3_select_lc_2_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_select_lc_3_tx_path = "ux3_select_lc_3_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_select_lc_4_tx_path = "ux3_select_lc_4_tx_path_slow";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_sup_mode = "ux3_sup_mode_user_mode";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_afc_range = "ux3_synth_lc_0_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_afc_refclk_count = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_dtr_prop_coeff = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_f_max_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_f_min_vco_hz = 34'h271D94900;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_f_pfd_hz = 78125000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter = 14;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_feed_forward_gain = 32;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fine_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fine_int_coeff_tmp = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fine_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fine_prop_coeff_tmp = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_kvcc_settle_maxcnt = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_tx_postdiv_counter_physical = 88;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_tx_postdiv_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_refclk_in_1us = 78;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_tdc_fine_res_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_tdc_refclk_count = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_tdc_target_count = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_0_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_afc_range = "ux3_synth_lc_1_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_feed_forward_gain = 18;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_m_counter = 45;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_1_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_afc_range = "ux3_synth_lc_2_afc_range_full";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_dtr_int_coeff = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_feed_forward_gain = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_m_counter = 27;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_2_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_afc_range = "ux3_synth_lc_3_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_afc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_dtr_int_coeff = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_feed_forward_gain = 23;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fine_int_coeff = 9;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_kvcc_settle_maxcnt = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_m_counter = 36;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_refclk_in_1us = 150;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_tdc_refclk_count = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_tdc_target_count = 60;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_3_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_afc_range = "ux3_synth_lc_4_afc_range_restricted";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_afc_refclk_count = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_div2_to_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_dtr_int_coeff = 8;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_dtr_prop_coeff = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_dts_ssdiv = 4;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_f_max_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_f_min_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_feed_forward_gain = 19;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fine_int_coeff = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fine_prop_coeff = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_kvcc_settle_maxcnt = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_m_counter = 216;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_n_counter = 5;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_tx_postdiv_counter_physical = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_refclk_in_1us = 30;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_n_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_rx_cdr_cascade_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_rx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_rx_postdiv_to_cdr_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_tx_postdiv_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_tx_postdiv_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_slowmed_path_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_tdc_fine_res_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_tdc_refclk_count = 6;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_tdc_target_count = 120;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_vreg_avg_count = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_4_vreg_loopen_maxcnt = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_bw_sel = "ux3_synth_lc_fast_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_primary_use = "ux3_synth_lc_fast_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_refclk_mux_select = "ux3_synth_lc_fast_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_refclk_type_select = "ux3_synth_lc_fast_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_fast_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_l_counter_physical = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_bw_sel = "ux3_synth_lc_med_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_f_out_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_f_ref_hz = 156250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_f_tx_postdiv_hz = 125000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_f_vco_hz = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_l_counter = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_m_counter = 80;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_primary_use = "ux3_synth_lc_med_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_refclk_mux_select = "ux3_synth_lc_med_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_refclk_type_select = "ux3_synth_lc_med_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_rx_postdiv_counter = 12;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_tx_postdiv_counter = 100;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_med_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_bw_sel = "ux3_synth_lc_slow_bw_sel_low";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_f_out_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_f_pfd_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_f_ref_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_f_rx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_f_tx_postdiv_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_f_vco_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_k_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_l_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_m_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_n_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_powerdown_mode = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_primary_use = "ux3_synth_lc_slow_primary_use_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_refclk_mux_select = "ux3_synth_lc_slow_refclk_mux_select_ref_clk0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_refclk_type_select = "ux3_synth_lc_slow_refclk_type_select_from_refclks_mux";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_rx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_tx_postdiv_counter = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_tx_postdiv_fractional_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synth_lc_slow_used = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_0_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_0_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_0_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_0_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_1_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_1_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_1_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_1_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_2_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_2_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_2_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_2_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_3_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_3_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_3_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_3_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_4_apb_dwmask = 32'hA9FC010F;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_4_clkout_cb_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_4_refclk100div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_4_refclk156div_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlc_dcdmeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastratewidth_pd_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcfastrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcmedrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_synthlcslowrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tdc_refclk_count_divisor = 850000000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tdc_refclk_count_scratch = 11;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tdc_target_count_scratch = 119;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_cal_dutymeas_delay_count = 156;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_line_rate_bps = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_pll_is_downstream_pll = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_tx_which_lane_to_copy = "ux3_tx_which_lane_to_copy_self";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txeq_main_tap = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txeq_post_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txeq_pre_tap_1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txeq_pre_tap_2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txratewidth_rst_b0_off_delay_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evdn_delay_lut_entry1 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evdn_delay_lut_entry2 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evdn_delay_lut_entry3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry1 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry2 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry2_scratch = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry3 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry4 = 125;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry5 = 781;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_txrpu_evup_delay_lut_entry7 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux3_vreg_loopen_maxcnt_scratch = 16;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux_quad_instance = "ux_quad_instance_three";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__flux_top__ux_speed_grade = "ux_speed_grade_dash1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__hard_all_ux_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__quad_pcie_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__sim_mode = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_external_dpma_refclk_source = "ux0_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_external_dpma_refclk_source = "ux1_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_external_dpma_refclk_source = "ux2_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_01_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_10_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_bonding_size_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_dl_enable = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ethernet_source = "ux3_ethernet_source_e400g";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_external_dpma_refclk_source = "ux3_external_dpma_refclk_source_global_refclk_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_fec_used = "true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_flux_mode = "ux3_flux_mode_cpri";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_loopback_mode = "ux3_loopback_mode_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_latpls_bw_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rst_rxbit_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rx_lat_bit_for_async_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_cntr_pma_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_rxbit_rollover_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_q_dl_cfg_sel_rxbit_adder_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_rx_adapt_mode = "ux3_rx_adapt_mode_flux_rx_adapt";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_rx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_rx_tuning_hint = "ux3_rx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_rx_user_clk_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sr_custom = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_standalone_core_clk_mux = "ux3_standalone_core_clk_mux_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_bond_size = "ux3_tx_bond_size_1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_master_bond_chnl = "ux3_tx_master_bond_chnl_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_protocol = "ux3_tx_protocol_pma_direct_sys_clk";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_rst_value_pre_user_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_tuning_hint = "ux3_tx_tuning_hint_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk1_mux = "ux3_tx_user_clk1_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_en = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk2_mux = "ux3_tx_user_clk2_mux_slow_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_tx_width = "ux3_tx_width_32";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_23 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_0_31 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_1_1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_16to15 = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_andme_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_lfps_en_lx_nt = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d1_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcie_l1d2_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_pcs_lock = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeiosdetectstat_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_clr_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeq_static_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxeyediag_start_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxovrcdrlock2dataen_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxterm_hiz_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_tx_lx_b_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbeacon_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txbist_en_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdetectrx_req_lx_a = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_23 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_0_31 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_1_1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_13to8 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_16to15 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_2_29to24 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_andme_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_lfps_en_lx_nt = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d1_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcie_l1d2_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_pcs_lock = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeiosdetectstat_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_clr_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeq_static_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxeyediag_start_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxovrcdrlock2dataen_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxterm_hiz_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_tx_lx_b_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbeacon_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txbist_en_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdetectrx_req_lx_a = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_cpi_cmn2_st_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_cpi_lm_addr = 589884;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_cpi_phy_addr = 589888;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_cpi_reserved = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_cpi_seq_en = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_cpi_timer_max = 500;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_end_pt = 22;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_flux_cpu_freq = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_attr = "ckmux0_10_to_1_cmosclk0_0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_0_en_attr = "ckmux0_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_attr = "ckmux1_10_to_1_cmosclk0_3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_10_to_1_ckmux_1_en_attr = "ckmux1_10_to_1_en";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_ctrl_l3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l0_attr = "bonding_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l1_attr = "bonding_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l2_attr = "bonding_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_bonding_ctrl_cfg_bonding_enable_l3_attr = "bonding_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_cpi_seq_ctrl_cfg_ctrl_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l0_attr = "lb_l0_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l1_attr = "lb_l1_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l2_attr = "lb_l2_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_datapath_loopback_en_cfg_datapath_loopback_en_l3_attr = "lb_l3_disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_clk_en_dfd_clk_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_clk_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_extrig_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_mux_sel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_dfd_rsvd_muxsel_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_data_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_inc_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_a_cfg_pattern_cntr_rst_b_attr = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_apb_rdata_sel_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dfd_ctrl_b_cfg_rst_dfd_extrig_cntr_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l2_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dl_ctrl_a_l3_cfg_ctrl_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_dpma_clk_mux_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l0_attr = "e200_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l1_attr = "e200_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l2_attr = "e200_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_rxclk_en_l3_attr = "e200_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l0_attr = "e200_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l1_attr = "e200_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l2_attr = "e200_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e200_txclk_en_l3_attr = "e200_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l0_attr = "e400_ckmux_slow_med_l0_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l1_attr = "e400_ckmux_slow_med_l1_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l2_attr = "e400_ckmux_slow_med_l2_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_slow_med_l3_attr = "e400_ckmux_slow_med_l3_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l0_attr = "e400_ckmux_txuser0_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l1_attr = "e400_ckmux_txuser0_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l2_attr = "e400_ckmux_txuser0_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser0_l3_attr = "e400_ckmux_txuser0_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l0_attr = "e400_ckmux_txuser1_l0_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l1_attr = "e400_ckmux_txuser1_l1_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l2_attr = "e400_ckmux_txuser1_l2_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser1_l3_attr = "e400_ckmux_txuser1_l3_non_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l0_attr = "e400_ckmux_txuser2_l0_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l1_attr = "e400_ckmux_txuser2_l1_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l2_attr = "e400_ckmux_txuser2_l2_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_ckmux_txuser2_l3_attr = "e400_ckmux_txuser2_l3_fast";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l0_attr = "e400_rxclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l1_attr = "e400_rxclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l2_attr = "e400_rxclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxclk_en_l3_attr = "e400_rxclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l0_attr = "e400_rxusrclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l1_attr = "e400_rxusrclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l2_attr = "e400_rxusrclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_rxusrclk_en_l3_attr = "e400_rxusrclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l0_attr = "e400_txclk_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l1_attr = "e400_txclk_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l2_attr = "e400_txclk_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_txclk_en_l3_attr = "e400_txclk_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l0_attr = "e400_usrclk0_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l1_attr = "e400_usrclk0_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l2_attr = "e400_usrclk0_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk0_en_l3_attr = "e400_usrclk0_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l0_attr = "e400_usrclk1_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l1_attr = "e400_usrclk1_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l2_attr = "e400_usrclk1_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk1_en_l3_attr = "e400_usrclk1_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l0_attr = "e400_usrclk2_en_l0_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l1_attr = "e400_usrclk2_en_l1_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l2_attr = "e400_usrclk2_en_l2_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e400_usrclk2_en_l3_attr = "e400_usrclk2_en_l3_true";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l0_attr = "e_rx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l1_attr = "e_rx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l2_attr = "e_rx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_rx_dp_pipe_l3_attr = "e_rx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l0_attr = "e_tx_dp_pipe_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l1_attr = "e_tx_dp_pipe_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l2_attr = "e_tx_dp_pipe_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_e_tx_dp_pipe_l3_attr = "e_tx_dp_pipe_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l0_cfg_value_attr = 277792;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l1_cfg_value_attr = 310560;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l2_cfg_value_attr = 343328;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_fw_load_base_l3_cfg_value_attr = 376096;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_disable_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_fw_load_mode_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_mapped_base_attr = 10;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_indirect_access_ctrl_cfg_unmapped_base_attr = 16384;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l0_attr = "func_mode_e400_l0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l1_attr = "func_mode_e400_l1";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l2_attr = "func_mode_e400_l2";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_mode_ctrl_cfg_func_mode_l3_attr = "func_mode_e400_l3";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l0_attr = "pcie_medclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l1_attr = "pcie_medclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l2_attr = "pcie_medclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_medclk_en_l3_attr = "pcie_medclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l0_attr = "pcie_pclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l1_attr = "pcie_pclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l2_attr = "pcie_pclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_pclk_en_l3_attr = "pcie_pclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l0_attr = "pcie_refclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l1_attr = "pcie_refclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l2_attr = "pcie_refclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_refclk_en_l3_attr = "pcie_refclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l0_attr = "pcie_rxclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l1_attr = "pcie_rxclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l2_attr = "pcie_rxclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_rxclk_en_l3_attr = "pcie_rxclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l0_attr = "pcie_slowclk_en_l0_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l1_attr = "pcie_slowclk_en_l1_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l2_attr = "pcie_slowclk_en_l2_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_pcie_slowclk_en_l3_attr = "pcie_slowclk_en_l3_false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_reserved0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_0_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_10_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_11_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_12_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_13_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_14_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_15_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_16_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_17_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_18_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_19_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_1_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_20_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_21_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_22_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_2_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_3_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_4_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_5_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_6_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_7_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_8_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_addr_9_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_restart_seq_sm_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_0_cfg_skip_rd_seq_attr = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_1_cfg_seqen_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_2_cfg_seqen_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_3_cfg_seq_rdwrb_0to31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_ctrl_4_cfg_seq_rdwrb_32to63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_0_attr = 51224679;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_10_attr = 11641603;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_11_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_12_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_13_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_14_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_15_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_16_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_17_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_18_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_19_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_1_attr = 41138;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_20_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_21_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_22_attr = 41056;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_23_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_24_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_25_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_26_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_27_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_28_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_29_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_2_attr = 41136;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_30_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_31_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_32_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_33_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_34_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_35_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_36_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_37_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_38_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_39_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_3_attr = 499727;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_40_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_41_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_42_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_43_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_44_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_45_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_46_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_47_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_48_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_49_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_4_attr = 11640835;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_50_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_51_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_52_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_53_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_54_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_55_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_56_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_57_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_58_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_59_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_5_attr = 499983;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_60_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_61_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_62_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_63_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_6_attr = 11641091;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_7_attr = 500239;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_8_attr = 11641347;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_data_9_attr = 500495;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_0_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_10_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_11_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_12_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_13_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_14_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_15_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_16_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_17_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_18_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_19_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_1_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_20_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_21_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_22_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_23_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_24_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_25_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_26_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_27_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_28_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_29_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_2_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_30_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_31_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_32_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_33_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_34_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_35_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_36_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_37_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_38_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_39_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_3_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_40_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_41_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_42_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_43_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_44_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_45_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_46_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_47_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_48_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_49_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_4_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_50_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_51_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_52_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_53_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_54_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_55_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_56_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_57_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_58_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_59_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_5_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_60_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_61_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_62_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_63_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_6_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_7_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_8_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_q_seq_rdata_unmask_9_attr = 32'hFFFFFFFF;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_quad_instance = "ux_quad_instance_three";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__gdr_ux_quad_avmm_cfgcsr__ux_rst_value_pre_user_mode_reserved_attr = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powerdown_mode = "false";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_avmm = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_bot_clkrx_base = "powermode_ac_mode_bot_clkrx_base_non_pin_primary_driver_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_bot_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_flux = "powermode_ac_mode_flux_flux_enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_0_bot = "powermode_ac_mode_global_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_0_top = "powermode_ac_mode_global_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_1_bot = "powermode_ac_mode_global_refclk_1_bot_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_1_top = "powermode_ac_mode_global_refclk_1_top_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_2_bot = "powermode_ac_mode_global_refclk_2_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_2_top = "powermode_ac_mode_global_refclk_2_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_3_bot = "powermode_ac_mode_global_refclk_3_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_global_refclk_3_top = "powermode_ac_mode_global_refclk_3_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_regional_refclk_0_bot = "powermode_ac_mode_regional_refclk_0_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_regional_refclk_0_top = "powermode_ac_mode_regional_refclk_0_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_regional_refclk_1_bot = "powermode_ac_mode_regional_refclk_1_bot_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_regional_refclk_1_top = "powermode_ac_mode_regional_refclk_1_top_disabled";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_fast_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_fast_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_fast_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_fast_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_med_ux0 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_med_ux1 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_med_ux2 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_med_ux3 = "enable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_slow_ux0 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_slow_ux1 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_slow_ux2 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_synth_lc_slow_ux3 = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_top_clkrx_base = "powermode_ac_mode_top_clkrx_base_non_pin_primary_driver_low_power";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_ac_mode_top_cmos_driver = "disable";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_dc = "powerup";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_avmm = 62500000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_bot_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_bot_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_flux = 390;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_2_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_2_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_3_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_global_refclk_3_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_regional_refclk_0_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_regional_refclk_0_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_regional_refclk_1_bot = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_regional_refclk_1_top = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_rx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_fast_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_fast_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_fast_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_fast_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_med_ux0 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_med_ux1 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_med_ux2 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_med_ux3 = 34'h2E90EDD00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_slow_ux0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_slow_ux1 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_slow_ux2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_synth_lc_slow_ux3 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_top_clkrx_base = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_top_cmos_driver = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_parallel_ux0 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_parallel_ux1 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_parallel_ux2 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_parallel_ux3 = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_ux0 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_ux1 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_ux2 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__powermode_freq_hz_tx_ux3 = 35'h5D21DBA00;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_tx_user_clk_slow_med_mux = "ux0_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux0_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_tx_user_clk_slow_med_mux = "ux1_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux1_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_tx_user_clk_slow_med_mux = "ux2_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux2_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cdr_f_mod_hz = 961538461;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_cmn_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_duplex_datarate = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_lane_ctrl_i_clk_p_hz = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ref_clk_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_o_clk_e2_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_o_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_o_usr_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_rx_o_usr_clk_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_sv_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_synth_lc_0_n_counter = 2;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_datarate = 1;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_i_clk_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_i_clk_e4_hz = 781250000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_i_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_clk_p_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_usr_clk_1_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_usr_clk_1_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_usr_clk_2_e2_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_o_usr_clk_2_e4_hz = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_tx_user_clk_slow_med_mux = "ux3_tx_user_clk_slow_med_mux_med";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxeq_precal_code_sel_lx_nt_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_rxwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txclkdivrate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_levn_lx_5to0 = 63;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_levnm1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_levnp1_lx_4to0 = 31;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_levnp2_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_spare_l0_1to0 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_spare_l0_3to2 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_spare_l0_5to4 = 3;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txdrv_spare_l0_9to6 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txelecidle_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txpstate_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txrate_lx_3to0 = 15;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_en_txwidth_lx_2to0 = 7;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxeq_precal_code_sel_lx_nt_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_rxwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txclkdivrate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_levn_lx_5to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_levnm1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_levnp1_lx_4to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_levnp2_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_spare_l0_1to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_spare_l0_3to2 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_spare_l0_5to4 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txdrv_spare_l0_9to6 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txelecidle_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txpstate_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txrate_lx_3to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux3_ur_ovr_txwidth_lx_2to0 = 0;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_ckmux_cpu_attr = "ckmux_cpu_pll0";
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_i_pll0_hz = 390625000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_i_pll1_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_q_i_pll2_hz = 2831000;
defparam z1577a_x0_y166_n0.z1577a_u_ux_quad_3__ux_quad_instance = "ux_quad_instance_three";
`endif
defparam z1577a_x0_y166_n0.z1577a_bcm_settings_file_pathname = "bts_xcvr__tiles.bcm.txt";
defparam z1577a_x0_y166_n0.z1577a_bcm_settings_prefix = "bts_xcvr__tiles.z1577a_x0_y166_n0.gdr.z1577a";
`endif
endmodule
